#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 5991
#define LARGE_STATE_COUNT 2172
#define SYMBOL_COUNT 349
#define ALIAS_COUNT 4
#define TOKEN_COUNT 159
#define EXTERNAL_TOKEN_COUNT 30
#define FIELD_COUNT 32
#define MAX_ALIAS_SEQUENCE_LENGTH 8
#define PRODUCTION_ID_COUNT 127

enum ts_symbol_identifiers {
  sym_identifier = 1,
  aux_sym_program_token1 = 2,
  anon_sym___END__ = 3,
  anon_sym_ = 4,
  sym_uninterpreted = 5,
  anon_sym_BEGIN = 6,
  anon_sym_LBRACE = 7,
  anon_sym_RBRACE = 8,
  anon_sym_END = 9,
  anon_sym_def = 10,
  anon_sym_LPAREN = 11,
  anon_sym_RPAREN = 12,
  anon_sym_DOT = 13,
  anon_sym_COLON_COLON = 14,
  anon_sym_end = 15,
  anon_sym_rescue = 16,
  anon_sym_EQ = 17,
  anon_sym_COMMA = 18,
  anon_sym_PIPE = 19,
  anon_sym_SEMI = 20,
  anon_sym_DOT_DOT_DOT = 21,
  anon_sym_STAR = 22,
  anon_sym_STAR_STAR = 23,
  anon_sym_nil = 24,
  anon_sym_AMP = 25,
  anon_sym_COLON = 26,
  anon_sym_class = 27,
  anon_sym_LT = 28,
  anon_sym_module = 29,
  anon_sym_return = 30,
  anon_sym_yield = 31,
  anon_sym_break = 32,
  anon_sym_next = 33,
  anon_sym_redo = 34,
  anon_sym_retry = 35,
  anon_sym_if = 36,
  anon_sym_unless = 37,
  anon_sym_while = 38,
  anon_sym_until = 39,
  anon_sym_for = 40,
  anon_sym_in = 41,
  anon_sym_do = 42,
  anon_sym_case = 43,
  anon_sym_when = 44,
  anon_sym_EQ_GT = 45,
  anon_sym_LBRACK = 46,
  anon_sym_RBRACK = 47,
  anon_sym_LBRACK2 = 48,
  anon_sym_LPAREN2 = 49,
  anon_sym_DOT_DOT = 50,
  sym_line = 51,
  sym_file = 52,
  sym_encoding = 53,
  anon_sym_CARET = 54,
  anon_sym_elsif = 55,
  anon_sym_else = 56,
  anon_sym_then = 57,
  anon_sym_begin = 58,
  anon_sym_ensure = 59,
  anon_sym_COLON_COLON2 = 60,
  anon_sym_AMP_DOT = 61,
  anon_sym_PLUS_EQ = 62,
  anon_sym_DASH_EQ = 63,
  anon_sym_STAR_EQ = 64,
  anon_sym_STAR_STAR_EQ = 65,
  anon_sym_SLASH_EQ = 66,
  anon_sym_PIPE_PIPE_EQ = 67,
  anon_sym_PIPE_EQ = 68,
  anon_sym_AMP_AMP_EQ = 69,
  anon_sym_AMP_EQ = 70,
  anon_sym_PERCENT_EQ = 71,
  anon_sym_GT_GT_EQ = 72,
  anon_sym_LT_LT_EQ = 73,
  anon_sym_CARET_EQ = 74,
  anon_sym_QMARK = 75,
  anon_sym_COLON2 = 76,
  anon_sym_and = 77,
  anon_sym_or = 78,
  anon_sym_PIPE_PIPE = 79,
  anon_sym_AMP_AMP = 80,
  anon_sym_LT_LT = 81,
  anon_sym_GT_GT = 82,
  anon_sym_LT_EQ = 83,
  anon_sym_GT = 84,
  anon_sym_GT_EQ = 85,
  anon_sym_PLUS = 86,
  anon_sym_SLASH = 87,
  anon_sym_PERCENT = 88,
  anon_sym_EQ_EQ = 89,
  anon_sym_BANG_EQ = 90,
  anon_sym_EQ_EQ_EQ = 91,
  anon_sym_LT_EQ_GT = 92,
  anon_sym_EQ_TILDE = 93,
  anon_sym_BANG_TILDE = 94,
  anon_sym_defined_QMARK = 95,
  anon_sym_not = 96,
  anon_sym_BANG = 97,
  anon_sym_TILDE = 98,
  anon_sym_DASH = 99,
  anon_sym_PLUS_AT = 100,
  anon_sym_DASH_AT = 101,
  anon_sym_TILDE_AT = 102,
  anon_sym_LBRACK_RBRACK = 103,
  anon_sym_LBRACK_RBRACK_EQ = 104,
  anon_sym_BQUOTE = 105,
  anon_sym_EQ2 = 106,
  anon_sym_undef = 107,
  anon_sym_alias = 108,
  sym_comment = 109,
  sym_integer = 110,
  sym_float = 111,
  anon_sym_i = 112,
  anon_sym_ri = 113,
  anon_sym_r = 114,
  sym_super = 115,
  sym_self = 116,
  sym_true = 117,
  sym_false = 118,
  sym_constant = 119,
  aux_sym_constant_suffix_token1 = 120,
  aux_sym_identifier_suffix_token1 = 121,
  sym_instance_variable = 122,
  sym_class_variable = 123,
  sym_global_variable = 124,
  sym_character = 125,
  anon_sym_POUND_LBRACE = 126,
  aux_sym_string_array_token1 = 127,
  sym_escape_sequence = 128,
  anon_sym_DASH_GT = 129,
  sym__line_break = 130,
  sym__no_line_break = 131,
  sym_simple_symbol = 132,
  sym__string_start = 133,
  sym__symbol_start = 134,
  sym__subshell_start = 135,
  sym__regex_start = 136,
  sym__string_array_start = 137,
  sym__symbol_array_start = 138,
  sym__heredoc_body_start = 139,
  sym_string_content = 140,
  sym_heredoc_content = 141,
  sym__string_end = 142,
  sym_heredoc_end = 143,
  sym_heredoc_beginning = 144,
  sym__block_ampersand = 145,
  sym__splat_star = 146,
  sym__unary_minus = 147,
  sym__unary_minus_num = 148,
  sym__binary_minus = 149,
  sym__binary_star = 150,
  sym__singleton_class_left_angle_left_langle = 151,
  sym_hash_key_symbol = 152,
  sym__identifier_suffix = 153,
  sym__constant_suffix = 154,
  sym__hash_splat_star_star = 155,
  sym__binary_star_star = 156,
  sym__element_reference_bracket = 157,
  sym__short_interpolation = 158,
  sym_program = 159,
  sym_block_body = 160,
  sym__statements = 161,
  sym_begin_block = 162,
  sym_end_block = 163,
  sym__statement = 164,
  sym_method = 165,
  sym_singleton_method = 166,
  sym__method_rest = 167,
  sym_rescue_modifier_arg = 168,
  sym_rescue_modifier_expression = 169,
  sym__body_expr = 170,
  sym_parameters = 171,
  sym_bare_parameters = 172,
  sym_block_parameters = 173,
  sym__formal_parameter = 174,
  sym__simple_formal_parameter = 175,
  sym_forward_parameter = 176,
  sym_splat_parameter = 177,
  sym_hash_splat_parameter = 178,
  sym_hash_splat_nil = 179,
  sym_block_parameter = 180,
  sym_keyword_parameter = 181,
  sym_optional_parameter = 182,
  sym_class = 183,
  sym_superclass = 184,
  sym_singleton_class = 185,
  sym_module = 186,
  sym_return_command = 187,
  sym_yield_command = 188,
  sym_break_command = 189,
  sym_next_command = 190,
  sym_return = 191,
  sym_yield = 192,
  sym_break = 193,
  sym_next = 194,
  sym_redo = 195,
  sym_retry = 196,
  sym_if_modifier = 197,
  sym_unless_modifier = 198,
  sym_while_modifier = 199,
  sym_until_modifier = 200,
  sym_rescue_modifier = 201,
  sym_while = 202,
  sym_until = 203,
  sym_for = 204,
  sym_in = 205,
  sym_do = 206,
  sym_case = 207,
  sym_case_match = 208,
  sym_when = 209,
  sym_in_clause = 210,
  sym_pattern = 211,
  sym__guard = 212,
  sym_if_guard = 213,
  sym_unless_guard = 214,
  sym__pattern_top_expr_body = 215,
  sym__array_pattern_n = 216,
  sym__pattern_expr = 217,
  sym_as_pattern = 218,
  sym__pattern_expr_alt = 219,
  sym_alternative_pattern = 220,
  sym__array_pattern_body = 221,
  sym_array_pattern = 222,
  sym__find_pattern_body = 223,
  sym_find_pattern = 224,
  sym__hash_pattern_body = 225,
  sym_keyword_pattern = 226,
  sym__hash_pattern_any_rest = 227,
  sym_hash_pattern = 228,
  sym__pattern_expr_basic = 229,
  sym_parenthesized_pattern = 230,
  sym__pattern_value = 231,
  sym__pattern_range = 232,
  sym__pattern_primitive = 233,
  sym__pattern_lambda = 234,
  sym__pattern_literal = 235,
  sym__keyword_variable = 236,
  sym_variable_reference_pattern = 237,
  sym_expression_reference_pattern = 238,
  sym__pattern_constant = 239,
  sym__pattern_constant_resolution = 240,
  sym_if = 241,
  sym_unless = 242,
  sym_elsif = 243,
  sym_else = 244,
  sym_then = 245,
  sym_begin = 246,
  sym_ensure = 247,
  sym_rescue = 248,
  sym_exceptions = 249,
  sym_exception_variable = 250,
  sym_body_statement = 251,
  sym__body_statement = 252,
  sym__expression = 253,
  sym_match_pattern = 254,
  sym_test_pattern = 255,
  sym__arg = 256,
  sym__unary_minus_pow = 257,
  sym__pow = 258,
  sym__primary = 259,
  sym_parenthesized_statements = 260,
  sym_element_reference = 261,
  sym_scope_resolution = 262,
  sym__call = 263,
  sym_command_call = 264,
  sym_command_call_with_block = 265,
  sym__chained_command_call = 266,
  sym_call = 267,
  sym_command_argument_list = 268,
  sym_argument_list = 269,
  sym__argument_list_with_trailing_comma = 270,
  sym__argument = 271,
  sym_forward_argument = 272,
  sym_splat_argument = 273,
  sym_hash_splat_argument = 274,
  sym_block_argument = 275,
  sym_do_block = 276,
  sym_block = 277,
  sym_assignment = 278,
  sym_command_assignment = 279,
  sym_operator_assignment = 280,
  sym_command_operator_assignment = 281,
  sym_conditional = 282,
  sym_range = 283,
  sym_binary = 284,
  sym_command_binary = 285,
  sym_unary = 286,
  sym_command_unary = 287,
  sym_parenthesized_unary = 288,
  sym_unary_literal = 289,
  sym__literal = 290,
  sym__numeric = 291,
  sym__simple_numeric = 292,
  sym_right_assignment_list = 293,
  sym_left_assignment_list = 294,
  sym__mlhs = 295,
  sym_destructured_left_assignment = 296,
  sym_rest_assignment = 297,
  sym__function_identifier = 298,
  sym__function_identifier_call = 299,
  sym__lhs = 300,
  sym__variable = 301,
  sym_operator = 302,
  sym__method_name = 303,
  sym__nonlocal_variable = 304,
  sym_setter = 305,
  sym_undef = 306,
  sym_alias = 307,
  sym__int_or_float = 308,
  sym_complex = 309,
  sym_rational = 310,
  sym_nil = 311,
  sym_constant_suffix = 312,
  sym_identifier_suffix = 313,
  sym_chained_string = 314,
  sym_interpolation = 315,
  sym_string = 316,
  sym_subshell = 317,
  sym_string_array = 318,
  sym_symbol_array = 319,
  sym_delimited_symbol = 320,
  sym_regex = 321,
  sym_heredoc_body = 322,
  aux_sym__literal_contents = 323,
  sym_array = 324,
  sym_hash = 325,
  sym_pair = 326,
  sym_lambda = 327,
  sym_empty_statement = 328,
  sym__terminator = 329,
  aux_sym__statements_repeat1 = 330,
  aux_sym_parameters_repeat1 = 331,
  aux_sym_block_parameters_repeat1 = 332,
  aux_sym_case_repeat1 = 333,
  aux_sym_case_match_repeat1 = 334,
  aux_sym_when_repeat1 = 335,
  aux_sym__array_pattern_n_repeat1 = 336,
  aux_sym_alternative_pattern_repeat1 = 337,
  aux_sym__hash_pattern_body_repeat1 = 338,
  aux_sym_exceptions_repeat1 = 339,
  aux_sym__body_statement_repeat1 = 340,
  aux_sym_command_argument_list_repeat1 = 341,
  aux_sym__mlhs_repeat1 = 342,
  aux_sym_undef_repeat1 = 343,
  aux_sym_chained_string_repeat1 = 344,
  aux_sym_string_array_repeat1 = 345,
  aux_sym_symbol_array_repeat1 = 346,
  aux_sym_heredoc_body_repeat1 = 347,
  aux_sym_hash_repeat1 = 348,
  alias_sym_bare_string = 349,
  alias_sym_bare_symbol = 350,
  alias_sym_destructured_parameter = 351,
  alias_sym_lambda_parameters = 352,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_program_token1] = "program_token1",
  [anon_sym___END__] = "__END__",
  [anon_sym_] = "uninterpreted",
  [sym_uninterpreted] = "uninterpreted",
  [anon_sym_BEGIN] = "BEGIN",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_END] = "END",
  [anon_sym_def] = "def",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_end] = "end",
  [anon_sym_rescue] = "rescue",
  [anon_sym_EQ] = "=",
  [anon_sym_COMMA] = ",",
  [anon_sym_PIPE] = "|",
  [anon_sym_SEMI] = ";",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_STAR] = "*",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_nil] = "nil",
  [anon_sym_AMP] = "&",
  [anon_sym_COLON] = ":",
  [anon_sym_class] = "class",
  [anon_sym_LT] = "<",
  [anon_sym_module] = "module",
  [anon_sym_return] = "return",
  [anon_sym_yield] = "yield",
  [anon_sym_break] = "break",
  [anon_sym_next] = "next",
  [anon_sym_redo] = "redo",
  [anon_sym_retry] = "retry",
  [anon_sym_if] = "if",
  [anon_sym_unless] = "unless",
  [anon_sym_while] = "while",
  [anon_sym_until] = "until",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_do] = "do",
  [anon_sym_case] = "case",
  [anon_sym_when] = "when",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK2] = "[",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_DOT_DOT] = "..",
  [sym_line] = "line",
  [sym_file] = "file",
  [sym_encoding] = "encoding",
  [anon_sym_CARET] = "^",
  [anon_sym_elsif] = "elsif",
  [anon_sym_else] = "else",
  [anon_sym_then] = "then",
  [anon_sym_begin] = "begin",
  [anon_sym_ensure] = "ensure",
  [anon_sym_COLON_COLON2] = "::",
  [anon_sym_AMP_DOT] = "&.",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_QMARK] = "\?",
  [anon_sym_COLON2] = ":",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PLUS] = "+",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_BANG_TILDE] = "!~",
  [anon_sym_defined_QMARK] = "defined\?",
  [anon_sym_not] = "not",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS_AT] = "+@",
  [anon_sym_DASH_AT] = "-@",
  [anon_sym_TILDE_AT] = "~@",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_LBRACK_RBRACK_EQ] = "[]=",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_EQ2] = "=",
  [anon_sym_undef] = "undef",
  [anon_sym_alias] = "alias",
  [sym_comment] = "comment",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [anon_sym_i] = "i",
  [anon_sym_ri] = "ri",
  [anon_sym_r] = "r",
  [sym_super] = "super",
  [sym_self] = "self",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_constant] = "constant",
  [aux_sym_constant_suffix_token1] = "constant_suffix_token1",
  [aux_sym_identifier_suffix_token1] = "identifier_suffix_token1",
  [sym_instance_variable] = "instance_variable",
  [sym_class_variable] = "class_variable",
  [sym_global_variable] = "global_variable",
  [sym_character] = "character",
  [anon_sym_POUND_LBRACE] = "#{",
  [aux_sym_string_array_token1] = "string_array_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_DASH_GT] = "->",
  [sym__line_break] = "_line_break",
  [sym__no_line_break] = "_no_line_break",
  [sym_simple_symbol] = "simple_symbol",
  [sym__string_start] = "\"",
  [sym__symbol_start] = ":\"",
  [sym__subshell_start] = "`",
  [sym__regex_start] = "/",
  [sym__string_array_start] = "%w(",
  [sym__symbol_array_start] = "%i(",
  [sym__heredoc_body_start] = "_heredoc_body_start",
  [sym_string_content] = "string_content",
  [sym_heredoc_content] = "heredoc_content",
  [sym__string_end] = ")",
  [sym_heredoc_end] = "heredoc_end",
  [sym_heredoc_beginning] = "heredoc_beginning",
  [sym__block_ampersand] = "&",
  [sym__splat_star] = "*",
  [sym__unary_minus] = "-",
  [sym__unary_minus_num] = "-",
  [sym__binary_minus] = "-",
  [sym__binary_star] = "*",
  [sym__singleton_class_left_angle_left_langle] = "<<",
  [sym_hash_key_symbol] = "hash_key_symbol",
  [sym__identifier_suffix] = "_identifier_suffix",
  [sym__constant_suffix] = "_constant_suffix",
  [sym__hash_splat_star_star] = "**",
  [sym__binary_star_star] = "**",
  [sym__element_reference_bracket] = "[",
  [sym__short_interpolation] = "_short_interpolation",
  [sym_program] = "program",
  [sym_block_body] = "block_body",
  [sym__statements] = "_statements",
  [sym_begin_block] = "begin_block",
  [sym_end_block] = "end_block",
  [sym__statement] = "_statement",
  [sym_method] = "method",
  [sym_singleton_method] = "singleton_method",
  [sym__method_rest] = "_method_rest",
  [sym_rescue_modifier_arg] = "rescue_modifier",
  [sym_rescue_modifier_expression] = "rescue_modifier",
  [sym__body_expr] = "_body_expr",
  [sym_parameters] = "method_parameters",
  [sym_bare_parameters] = "method_parameters",
  [sym_block_parameters] = "block_parameters",
  [sym__formal_parameter] = "_formal_parameter",
  [sym__simple_formal_parameter] = "_simple_formal_parameter",
  [sym_forward_parameter] = "forward_parameter",
  [sym_splat_parameter] = "splat_parameter",
  [sym_hash_splat_parameter] = "hash_splat_parameter",
  [sym_hash_splat_nil] = "hash_splat_nil",
  [sym_block_parameter] = "block_parameter",
  [sym_keyword_parameter] = "keyword_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym_class] = "class",
  [sym_superclass] = "superclass",
  [sym_singleton_class] = "singleton_class",
  [sym_module] = "module",
  [sym_return_command] = "return",
  [sym_yield_command] = "yield",
  [sym_break_command] = "break",
  [sym_next_command] = "next",
  [sym_return] = "return",
  [sym_yield] = "yield",
  [sym_break] = "break",
  [sym_next] = "next",
  [sym_redo] = "redo",
  [sym_retry] = "retry",
  [sym_if_modifier] = "if_modifier",
  [sym_unless_modifier] = "unless_modifier",
  [sym_while_modifier] = "while_modifier",
  [sym_until_modifier] = "until_modifier",
  [sym_rescue_modifier] = "rescue_modifier",
  [sym_while] = "while",
  [sym_until] = "until",
  [sym_for] = "for",
  [sym_in] = "in",
  [sym_do] = "do",
  [sym_case] = "case",
  [sym_case_match] = "case_match",
  [sym_when] = "when",
  [sym_in_clause] = "in_clause",
  [sym_pattern] = "pattern",
  [sym__guard] = "_guard",
  [sym_if_guard] = "if_guard",
  [sym_unless_guard] = "unless_guard",
  [sym__pattern_top_expr_body] = "_pattern_top_expr_body",
  [sym__array_pattern_n] = "_array_pattern_n",
  [sym__pattern_expr] = "_pattern_expr",
  [sym_as_pattern] = "as_pattern",
  [sym__pattern_expr_alt] = "_pattern_expr_alt",
  [sym_alternative_pattern] = "alternative_pattern",
  [sym__array_pattern_body] = "_array_pattern_body",
  [sym_array_pattern] = "array_pattern",
  [sym__find_pattern_body] = "_find_pattern_body",
  [sym_find_pattern] = "find_pattern",
  [sym__hash_pattern_body] = "_hash_pattern_body",
  [sym_keyword_pattern] = "keyword_pattern",
  [sym__hash_pattern_any_rest] = "_hash_pattern_any_rest",
  [sym_hash_pattern] = "hash_pattern",
  [sym__pattern_expr_basic] = "_pattern_expr_basic",
  [sym_parenthesized_pattern] = "parenthesized_pattern",
  [sym__pattern_value] = "_pattern_value",
  [sym__pattern_range] = "range",
  [sym__pattern_primitive] = "_pattern_primitive",
  [sym__pattern_lambda] = "_pattern_lambda",
  [sym__pattern_literal] = "_pattern_literal",
  [sym__keyword_variable] = "_keyword_variable",
  [sym_variable_reference_pattern] = "variable_reference_pattern",
  [sym_expression_reference_pattern] = "expression_reference_pattern",
  [sym__pattern_constant] = "_pattern_constant",
  [sym__pattern_constant_resolution] = "scope_resolution",
  [sym_if] = "if",
  [sym_unless] = "unless",
  [sym_elsif] = "elsif",
  [sym_else] = "else",
  [sym_then] = "then",
  [sym_begin] = "begin",
  [sym_ensure] = "ensure",
  [sym_rescue] = "rescue",
  [sym_exceptions] = "exceptions",
  [sym_exception_variable] = "exception_variable",
  [sym_body_statement] = "body_statement",
  [sym__body_statement] = "_body_statement",
  [sym__expression] = "_expression",
  [sym_match_pattern] = "match_pattern",
  [sym_test_pattern] = "test_pattern",
  [sym__arg] = "_arg",
  [sym__unary_minus_pow] = "unary",
  [sym__pow] = "binary",
  [sym__primary] = "_primary",
  [sym_parenthesized_statements] = "parenthesized_statements",
  [sym_element_reference] = "element_reference",
  [sym_scope_resolution] = "scope_resolution",
  [sym__call] = "_call",
  [sym_command_call] = "call",
  [sym_command_call_with_block] = "call",
  [sym__chained_command_call] = "_chained_command_call",
  [sym_call] = "call",
  [sym_command_argument_list] = "argument_list",
  [sym_argument_list] = "argument_list",
  [sym__argument_list_with_trailing_comma] = "_argument_list_with_trailing_comma",
  [sym__argument] = "_argument",
  [sym_forward_argument] = "forward_argument",
  [sym_splat_argument] = "splat_argument",
  [sym_hash_splat_argument] = "hash_splat_argument",
  [sym_block_argument] = "block_argument",
  [sym_do_block] = "do_block",
  [sym_block] = "block",
  [sym_assignment] = "assignment",
  [sym_command_assignment] = "assignment",
  [sym_operator_assignment] = "operator_assignment",
  [sym_command_operator_assignment] = "operator_assignment",
  [sym_conditional] = "conditional",
  [sym_range] = "range",
  [sym_binary] = "binary",
  [sym_command_binary] = "binary",
  [sym_unary] = "unary",
  [sym_command_unary] = "unary",
  [sym_parenthesized_unary] = "unary",
  [sym_unary_literal] = "unary",
  [sym__literal] = "_literal",
  [sym__numeric] = "_numeric",
  [sym__simple_numeric] = "_simple_numeric",
  [sym_right_assignment_list] = "right_assignment_list",
  [sym_left_assignment_list] = "left_assignment_list",
  [sym__mlhs] = "_mlhs",
  [sym_destructured_left_assignment] = "destructured_left_assignment",
  [sym_rest_assignment] = "rest_assignment",
  [sym__function_identifier] = "_function_identifier",
  [sym__function_identifier_call] = "call",
  [sym__lhs] = "_lhs",
  [sym__variable] = "_variable",
  [sym_operator] = "operator",
  [sym__method_name] = "_method_name",
  [sym__nonlocal_variable] = "_nonlocal_variable",
  [sym_setter] = "setter",
  [sym_undef] = "undef",
  [sym_alias] = "alias",
  [sym__int_or_float] = "_int_or_float",
  [sym_complex] = "complex",
  [sym_rational] = "rational",
  [sym_nil] = "nil",
  [sym_constant_suffix] = "hash_key_symbol",
  [sym_identifier_suffix] = "hash_key_symbol",
  [sym_chained_string] = "chained_string",
  [sym_interpolation] = "interpolation",
  [sym_string] = "string",
  [sym_subshell] = "subshell",
  [sym_string_array] = "string_array",
  [sym_symbol_array] = "symbol_array",
  [sym_delimited_symbol] = "delimited_symbol",
  [sym_regex] = "regex",
  [sym_heredoc_body] = "heredoc_body",
  [aux_sym__literal_contents] = "_literal_contents",
  [sym_array] = "array",
  [sym_hash] = "hash",
  [sym_pair] = "pair",
  [sym_lambda] = "lambda",
  [sym_empty_statement] = "empty_statement",
  [sym__terminator] = "_terminator",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_block_parameters_repeat1] = "block_parameters_repeat1",
  [aux_sym_case_repeat1] = "case_repeat1",
  [aux_sym_case_match_repeat1] = "case_match_repeat1",
  [aux_sym_when_repeat1] = "when_repeat1",
  [aux_sym__array_pattern_n_repeat1] = "_array_pattern_n_repeat1",
  [aux_sym_alternative_pattern_repeat1] = "alternative_pattern_repeat1",
  [aux_sym__hash_pattern_body_repeat1] = "_hash_pattern_body_repeat1",
  [aux_sym_exceptions_repeat1] = "exceptions_repeat1",
  [aux_sym__body_statement_repeat1] = "_body_statement_repeat1",
  [aux_sym_command_argument_list_repeat1] = "command_argument_list_repeat1",
  [aux_sym__mlhs_repeat1] = "_mlhs_repeat1",
  [aux_sym_undef_repeat1] = "undef_repeat1",
  [aux_sym_chained_string_repeat1] = "chained_string_repeat1",
  [aux_sym_string_array_repeat1] = "string_array_repeat1",
  [aux_sym_symbol_array_repeat1] = "symbol_array_repeat1",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym_hash_repeat1] = "hash_repeat1",
  [alias_sym_bare_string] = "bare_string",
  [alias_sym_bare_symbol] = "bare_symbol",
  [alias_sym_destructured_parameter] = "destructured_parameter",
  [alias_sym_lambda_parameters] = "lambda_parameters",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_program_token1] = aux_sym_program_token1,
  [anon_sym___END__] = anon_sym___END__,
  [anon_sym_] = sym_uninterpreted,
  [sym_uninterpreted] = sym_uninterpreted,
  [anon_sym_BEGIN] = anon_sym_BEGIN,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_END] = anon_sym_END,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_rescue] = anon_sym_rescue,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_nil] = anon_sym_nil,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_next] = anon_sym_next,
  [anon_sym_redo] = anon_sym_redo,
  [anon_sym_retry] = anon_sym_retry,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_unless] = anon_sym_unless,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_until] = anon_sym_until,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACK2] = anon_sym_LBRACK,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [sym_line] = sym_line,
  [sym_file] = sym_file,
  [sym_encoding] = sym_encoding,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_elsif] = anon_sym_elsif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_begin] = anon_sym_begin,
  [anon_sym_ensure] = anon_sym_ensure,
  [anon_sym_COLON_COLON2] = anon_sym_COLON_COLON,
  [anon_sym_AMP_DOT] = anon_sym_AMP_DOT,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON2] = anon_sym_COLON,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_EQ_TILDE] = anon_sym_EQ_TILDE,
  [anon_sym_BANG_TILDE] = anon_sym_BANG_TILDE,
  [anon_sym_defined_QMARK] = anon_sym_defined_QMARK,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS_AT] = anon_sym_PLUS_AT,
  [anon_sym_DASH_AT] = anon_sym_DASH_AT,
  [anon_sym_TILDE_AT] = anon_sym_TILDE_AT,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_LBRACK_RBRACK_EQ] = anon_sym_LBRACK_RBRACK_EQ,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_EQ2] = anon_sym_EQ,
  [anon_sym_undef] = anon_sym_undef,
  [anon_sym_alias] = anon_sym_alias,
  [sym_comment] = sym_comment,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [anon_sym_i] = anon_sym_i,
  [anon_sym_ri] = anon_sym_ri,
  [anon_sym_r] = anon_sym_r,
  [sym_super] = sym_super,
  [sym_self] = sym_self,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_constant] = sym_constant,
  [aux_sym_constant_suffix_token1] = aux_sym_constant_suffix_token1,
  [aux_sym_identifier_suffix_token1] = aux_sym_identifier_suffix_token1,
  [sym_instance_variable] = sym_instance_variable,
  [sym_class_variable] = sym_class_variable,
  [sym_global_variable] = sym_global_variable,
  [sym_character] = sym_character,
  [anon_sym_POUND_LBRACE] = anon_sym_POUND_LBRACE,
  [aux_sym_string_array_token1] = aux_sym_string_array_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym__line_break] = sym__line_break,
  [sym__no_line_break] = sym__no_line_break,
  [sym_simple_symbol] = sym_simple_symbol,
  [sym__string_start] = sym__string_start,
  [sym__symbol_start] = sym__symbol_start,
  [sym__subshell_start] = anon_sym_BQUOTE,
  [sym__regex_start] = anon_sym_SLASH,
  [sym__string_array_start] = sym__string_array_start,
  [sym__symbol_array_start] = sym__symbol_array_start,
  [sym__heredoc_body_start] = sym__heredoc_body_start,
  [sym_string_content] = sym_string_content,
  [sym_heredoc_content] = sym_heredoc_content,
  [sym__string_end] = anon_sym_RPAREN,
  [sym_heredoc_end] = sym_heredoc_end,
  [sym_heredoc_beginning] = sym_heredoc_beginning,
  [sym__block_ampersand] = anon_sym_AMP,
  [sym__splat_star] = anon_sym_STAR,
  [sym__unary_minus] = anon_sym_DASH,
  [sym__unary_minus_num] = anon_sym_DASH,
  [sym__binary_minus] = anon_sym_DASH,
  [sym__binary_star] = anon_sym_STAR,
  [sym__singleton_class_left_angle_left_langle] = anon_sym_LT_LT,
  [sym_hash_key_symbol] = sym_hash_key_symbol,
  [sym__identifier_suffix] = sym__identifier_suffix,
  [sym__constant_suffix] = sym__constant_suffix,
  [sym__hash_splat_star_star] = anon_sym_STAR_STAR,
  [sym__binary_star_star] = anon_sym_STAR_STAR,
  [sym__element_reference_bracket] = anon_sym_LBRACK,
  [sym__short_interpolation] = sym__short_interpolation,
  [sym_program] = sym_program,
  [sym_block_body] = sym_block_body,
  [sym__statements] = sym__statements,
  [sym_begin_block] = sym_begin_block,
  [sym_end_block] = sym_end_block,
  [sym__statement] = sym__statement,
  [sym_method] = sym_method,
  [sym_singleton_method] = sym_singleton_method,
  [sym__method_rest] = sym__method_rest,
  [sym_rescue_modifier_arg] = sym_rescue_modifier,
  [sym_rescue_modifier_expression] = sym_rescue_modifier,
  [sym__body_expr] = sym__body_expr,
  [sym_parameters] = sym_parameters,
  [sym_bare_parameters] = sym_parameters,
  [sym_block_parameters] = sym_block_parameters,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym__simple_formal_parameter] = sym__simple_formal_parameter,
  [sym_forward_parameter] = sym_forward_parameter,
  [sym_splat_parameter] = sym_splat_parameter,
  [sym_hash_splat_parameter] = sym_hash_splat_parameter,
  [sym_hash_splat_nil] = sym_hash_splat_nil,
  [sym_block_parameter] = sym_block_parameter,
  [sym_keyword_parameter] = sym_keyword_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym_class] = sym_class,
  [sym_superclass] = sym_superclass,
  [sym_singleton_class] = sym_singleton_class,
  [sym_module] = sym_module,
  [sym_return_command] = sym_return,
  [sym_yield_command] = sym_yield,
  [sym_break_command] = sym_break,
  [sym_next_command] = sym_next,
  [sym_return] = sym_return,
  [sym_yield] = sym_yield,
  [sym_break] = sym_break,
  [sym_next] = sym_next,
  [sym_redo] = sym_redo,
  [sym_retry] = sym_retry,
  [sym_if_modifier] = sym_if_modifier,
  [sym_unless_modifier] = sym_unless_modifier,
  [sym_while_modifier] = sym_while_modifier,
  [sym_until_modifier] = sym_until_modifier,
  [sym_rescue_modifier] = sym_rescue_modifier,
  [sym_while] = sym_while,
  [sym_until] = sym_until,
  [sym_for] = sym_for,
  [sym_in] = sym_in,
  [sym_do] = sym_do,
  [sym_case] = sym_case,
  [sym_case_match] = sym_case_match,
  [sym_when] = sym_when,
  [sym_in_clause] = sym_in_clause,
  [sym_pattern] = sym_pattern,
  [sym__guard] = sym__guard,
  [sym_if_guard] = sym_if_guard,
  [sym_unless_guard] = sym_unless_guard,
  [sym__pattern_top_expr_body] = sym__pattern_top_expr_body,
  [sym__array_pattern_n] = sym__array_pattern_n,
  [sym__pattern_expr] = sym__pattern_expr,
  [sym_as_pattern] = sym_as_pattern,
  [sym__pattern_expr_alt] = sym__pattern_expr_alt,
  [sym_alternative_pattern] = sym_alternative_pattern,
  [sym__array_pattern_body] = sym__array_pattern_body,
  [sym_array_pattern] = sym_array_pattern,
  [sym__find_pattern_body] = sym__find_pattern_body,
  [sym_find_pattern] = sym_find_pattern,
  [sym__hash_pattern_body] = sym__hash_pattern_body,
  [sym_keyword_pattern] = sym_keyword_pattern,
  [sym__hash_pattern_any_rest] = sym__hash_pattern_any_rest,
  [sym_hash_pattern] = sym_hash_pattern,
  [sym__pattern_expr_basic] = sym__pattern_expr_basic,
  [sym_parenthesized_pattern] = sym_parenthesized_pattern,
  [sym__pattern_value] = sym__pattern_value,
  [sym__pattern_range] = sym_range,
  [sym__pattern_primitive] = sym__pattern_primitive,
  [sym__pattern_lambda] = sym__pattern_lambda,
  [sym__pattern_literal] = sym__pattern_literal,
  [sym__keyword_variable] = sym__keyword_variable,
  [sym_variable_reference_pattern] = sym_variable_reference_pattern,
  [sym_expression_reference_pattern] = sym_expression_reference_pattern,
  [sym__pattern_constant] = sym__pattern_constant,
  [sym__pattern_constant_resolution] = sym_scope_resolution,
  [sym_if] = sym_if,
  [sym_unless] = sym_unless,
  [sym_elsif] = sym_elsif,
  [sym_else] = sym_else,
  [sym_then] = sym_then,
  [sym_begin] = sym_begin,
  [sym_ensure] = sym_ensure,
  [sym_rescue] = sym_rescue,
  [sym_exceptions] = sym_exceptions,
  [sym_exception_variable] = sym_exception_variable,
  [sym_body_statement] = sym_body_statement,
  [sym__body_statement] = sym__body_statement,
  [sym__expression] = sym__expression,
  [sym_match_pattern] = sym_match_pattern,
  [sym_test_pattern] = sym_test_pattern,
  [sym__arg] = sym__arg,
  [sym__unary_minus_pow] = sym_unary,
  [sym__pow] = sym_binary,
  [sym__primary] = sym__primary,
  [sym_parenthesized_statements] = sym_parenthesized_statements,
  [sym_element_reference] = sym_element_reference,
  [sym_scope_resolution] = sym_scope_resolution,
  [sym__call] = sym__call,
  [sym_command_call] = sym_call,
  [sym_command_call_with_block] = sym_call,
  [sym__chained_command_call] = sym__chained_command_call,
  [sym_call] = sym_call,
  [sym_command_argument_list] = sym_argument_list,
  [sym_argument_list] = sym_argument_list,
  [sym__argument_list_with_trailing_comma] = sym__argument_list_with_trailing_comma,
  [sym__argument] = sym__argument,
  [sym_forward_argument] = sym_forward_argument,
  [sym_splat_argument] = sym_splat_argument,
  [sym_hash_splat_argument] = sym_hash_splat_argument,
  [sym_block_argument] = sym_block_argument,
  [sym_do_block] = sym_do_block,
  [sym_block] = sym_block,
  [sym_assignment] = sym_assignment,
  [sym_command_assignment] = sym_assignment,
  [sym_operator_assignment] = sym_operator_assignment,
  [sym_command_operator_assignment] = sym_operator_assignment,
  [sym_conditional] = sym_conditional,
  [sym_range] = sym_range,
  [sym_binary] = sym_binary,
  [sym_command_binary] = sym_binary,
  [sym_unary] = sym_unary,
  [sym_command_unary] = sym_unary,
  [sym_parenthesized_unary] = sym_unary,
  [sym_unary_literal] = sym_unary,
  [sym__literal] = sym__literal,
  [sym__numeric] = sym__numeric,
  [sym__simple_numeric] = sym__simple_numeric,
  [sym_right_assignment_list] = sym_right_assignment_list,
  [sym_left_assignment_list] = sym_left_assignment_list,
  [sym__mlhs] = sym__mlhs,
  [sym_destructured_left_assignment] = sym_destructured_left_assignment,
  [sym_rest_assignment] = sym_rest_assignment,
  [sym__function_identifier] = sym__function_identifier,
  [sym__function_identifier_call] = sym_call,
  [sym__lhs] = sym__lhs,
  [sym__variable] = sym__variable,
  [sym_operator] = sym_operator,
  [sym__method_name] = sym__method_name,
  [sym__nonlocal_variable] = sym__nonlocal_variable,
  [sym_setter] = sym_setter,
  [sym_undef] = sym_undef,
  [sym_alias] = sym_alias,
  [sym__int_or_float] = sym__int_or_float,
  [sym_complex] = sym_complex,
  [sym_rational] = sym_rational,
  [sym_nil] = sym_nil,
  [sym_constant_suffix] = sym_hash_key_symbol,
  [sym_identifier_suffix] = sym_hash_key_symbol,
  [sym_chained_string] = sym_chained_string,
  [sym_interpolation] = sym_interpolation,
  [sym_string] = sym_string,
  [sym_subshell] = sym_subshell,
  [sym_string_array] = sym_string_array,
  [sym_symbol_array] = sym_symbol_array,
  [sym_delimited_symbol] = sym_delimited_symbol,
  [sym_regex] = sym_regex,
  [sym_heredoc_body] = sym_heredoc_body,
  [aux_sym__literal_contents] = aux_sym__literal_contents,
  [sym_array] = sym_array,
  [sym_hash] = sym_hash,
  [sym_pair] = sym_pair,
  [sym_lambda] = sym_lambda,
  [sym_empty_statement] = sym_empty_statement,
  [sym__terminator] = sym__terminator,
  [aux_sym__statements_repeat1] = aux_sym__statements_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_block_parameters_repeat1] = aux_sym_block_parameters_repeat1,
  [aux_sym_case_repeat1] = aux_sym_case_repeat1,
  [aux_sym_case_match_repeat1] = aux_sym_case_match_repeat1,
  [aux_sym_when_repeat1] = aux_sym_when_repeat1,
  [aux_sym__array_pattern_n_repeat1] = aux_sym__array_pattern_n_repeat1,
  [aux_sym_alternative_pattern_repeat1] = aux_sym_alternative_pattern_repeat1,
  [aux_sym__hash_pattern_body_repeat1] = aux_sym__hash_pattern_body_repeat1,
  [aux_sym_exceptions_repeat1] = aux_sym_exceptions_repeat1,
  [aux_sym__body_statement_repeat1] = aux_sym__body_statement_repeat1,
  [aux_sym_command_argument_list_repeat1] = aux_sym_command_argument_list_repeat1,
  [aux_sym__mlhs_repeat1] = aux_sym__mlhs_repeat1,
  [aux_sym_undef_repeat1] = aux_sym_undef_repeat1,
  [aux_sym_chained_string_repeat1] = aux_sym_chained_string_repeat1,
  [aux_sym_string_array_repeat1] = aux_sym_string_array_repeat1,
  [aux_sym_symbol_array_repeat1] = aux_sym_symbol_array_repeat1,
  [aux_sym_heredoc_body_repeat1] = aux_sym_heredoc_body_repeat1,
  [aux_sym_hash_repeat1] = aux_sym_hash_repeat1,
  [alias_sym_bare_string] = alias_sym_bare_string,
  [alias_sym_bare_symbol] = alias_sym_bare_symbol,
  [alias_sym_destructured_parameter] = alias_sym_destructured_parameter,
  [alias_sym_lambda_parameters] = alias_sym_lambda_parameters,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym___END__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_] = {
    .visible = true,
    .named = true,
  },
  [sym_uninterpreted] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BEGIN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_END] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rescue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nil] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_next] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_redo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_retry] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unless] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_line] = {
    .visible = true,
    .named = true,
  },
  [sym_file] = {
    .visible = true,
    .named = true,
  },
  [sym_encoding] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elsif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ensure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ri] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r] = {
    .visible = true,
    .named = false,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_constant] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_constant_suffix_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_identifier_suffix_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_instance_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_class_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_global_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_array_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym__line_break] = {
    .visible = false,
    .named = true,
  },
  [sym__no_line_break] = {
    .visible = false,
    .named = true,
  },
  [sym_simple_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_start] = {
    .visible = true,
    .named = false,
  },
  [sym__subshell_start] = {
    .visible = true,
    .named = false,
  },
  [sym__regex_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__heredoc_body_start] = {
    .visible = false,
    .named = true,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_content] = {
    .visible = true,
    .named = true,
  },
  [sym__string_end] = {
    .visible = true,
    .named = false,
  },
  [sym_heredoc_end] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_beginning] = {
    .visible = true,
    .named = true,
  },
  [sym__block_ampersand] = {
    .visible = true,
    .named = false,
  },
  [sym__splat_star] = {
    .visible = true,
    .named = false,
  },
  [sym__unary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__unary_minus_num] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_star] = {
    .visible = true,
    .named = false,
  },
  [sym__singleton_class_left_angle_left_langle] = {
    .visible = true,
    .named = false,
  },
  [sym_hash_key_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_suffix] = {
    .visible = false,
    .named = true,
  },
  [sym__constant_suffix] = {
    .visible = false,
    .named = true,
  },
  [sym__hash_splat_star_star] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_star_star] = {
    .visible = true,
    .named = false,
  },
  [sym__element_reference_bracket] = {
    .visible = true,
    .named = false,
  },
  [sym__short_interpolation] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_block_body] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym_begin_block] = {
    .visible = true,
    .named = true,
  },
  [sym_end_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_method] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_method] = {
    .visible = true,
    .named = true,
  },
  [sym__method_rest] = {
    .visible = false,
    .named = true,
  },
  [sym_rescue_modifier_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue_modifier_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__body_expr] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_bare_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_forward_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_superclass] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_class] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_return_command] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_command] = {
    .visible = true,
    .named = true,
  },
  [sym_break_command] = {
    .visible = true,
    .named = true,
  },
  [sym_next_command] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_next] = {
    .visible = true,
    .named = true,
  },
  [sym_redo] = {
    .visible = true,
    .named = true,
  },
  [sym_retry] = {
    .visible = true,
    .named = true,
  },
  [sym_if_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_unless_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_until_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_until] = {
    .visible = true,
    .named = true,
  },
  [sym_for] = {
    .visible = true,
    .named = true,
  },
  [sym_in] = {
    .visible = true,
    .named = true,
  },
  [sym_do] = {
    .visible = true,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_case_match] = {
    .visible = true,
    .named = true,
  },
  [sym_when] = {
    .visible = true,
    .named = true,
  },
  [sym_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__guard] = {
    .visible = false,
    .named = true,
  },
  [sym_if_guard] = {
    .visible = true,
    .named = true,
  },
  [sym_unless_guard] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_top_expr_body] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__array_pattern_n] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_expr] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_expr_alt] = {
    .visible = false,
    .named = true,
  },
  [sym_alternative_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__array_pattern_body] = {
    .visible = false,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__find_pattern_body] = {
    .visible = false,
    .named = true,
  },
  [sym_find_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__hash_pattern_body] = {
    .visible = false,
    .named = true,
  },
  [sym_keyword_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__hash_pattern_any_rest] = {
    .visible = false,
    .named = true,
  },
  [sym_hash_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_expr_basic] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_value] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_range] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_primitive] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__pattern_lambda] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__keyword_variable] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_reference_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_reference_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_constant] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__pattern_constant_resolution] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_unless] = {
    .visible = true,
    .named = true,
  },
  [sym_elsif] = {
    .visible = true,
    .named = true,
  },
  [sym_else] = {
    .visible = true,
    .named = true,
  },
  [sym_then] = {
    .visible = true,
    .named = true,
  },
  [sym_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_ensure] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue] = {
    .visible = true,
    .named = true,
  },
  [sym_exceptions] = {
    .visible = true,
    .named = true,
  },
  [sym_exception_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_body_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__body_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_match_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_test_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__arg] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__unary_minus_pow] = {
    .visible = true,
    .named = true,
  },
  [sym__pow] = {
    .visible = true,
    .named = true,
  },
  [sym__primary] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_statements] = {
    .visible = true,
    .named = true,
  },
  [sym_element_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_scope_resolution] = {
    .visible = true,
    .named = true,
  },
  [sym__call] = {
    .visible = false,
    .named = true,
  },
  [sym_command_call] = {
    .visible = true,
    .named = true,
  },
  [sym_command_call_with_block] = {
    .visible = true,
    .named = true,
  },
  [sym__chained_command_call] = {
    .visible = false,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_command_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_list_with_trailing_comma] = {
    .visible = false,
    .named = true,
  },
  [sym__argument] = {
    .visible = false,
    .named = true,
  },
  [sym_forward_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_block_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_do_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_command_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_command_operator_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_command_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_command_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym__numeric] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_numeric] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_right_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym_left_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym__mlhs] = {
    .visible = false,
    .named = true,
  },
  [sym_destructured_left_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__function_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__function_identifier_call] = {
    .visible = true,
    .named = true,
  },
  [sym__lhs] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__variable] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__method_name] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__nonlocal_variable] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_setter] = {
    .visible = true,
    .named = true,
  },
  [sym_undef] = {
    .visible = true,
    .named = true,
  },
  [sym_alias] = {
    .visible = true,
    .named = true,
  },
  [sym__int_or_float] = {
    .visible = false,
    .named = true,
  },
  [sym_complex] = {
    .visible = true,
    .named = true,
  },
  [sym_rational] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_suffix] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_suffix] = {
    .visible = true,
    .named = true,
  },
  [sym_chained_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_string_array] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol_array] = {
    .visible = true,
    .named = true,
  },
  [sym_delimited_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__literal_contents] = {
    .visible = false,
    .named = false,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_hash] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__terminator] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_match_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_when_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__array_pattern_n_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alternative_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__hash_pattern_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exceptions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__body_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__mlhs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_undef_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_chained_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_symbol_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_hash_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_bare_string] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_bare_symbol] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_destructured_parameter] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_alternatives = 3,
  field_arguments = 4,
  field_begin = 5,
  field_block = 6,
  field_body = 7,
  field_class = 8,
  field_clauses = 9,
  field_condition = 10,
  field_consequence = 11,
  field_else = 12,
  field_end = 13,
  field_exceptions = 14,
  field_guard = 15,
  field_handler = 16,
  field_key = 17,
  field_left = 18,
  field_locals = 19,
  field_method = 20,
  field_name = 21,
  field_object = 22,
  field_operand = 23,
  field_operator = 24,
  field_parameters = 25,
  field_pattern = 26,
  field_receiver = 27,
  field_right = 28,
  field_scope = 29,
  field_superclass = 30,
  field_value = 31,
  field_variable = 32,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_alternatives] = "alternatives",
  [field_arguments] = "arguments",
  [field_begin] = "begin",
  [field_block] = "block",
  [field_body] = "body",
  [field_class] = "class",
  [field_clauses] = "clauses",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_else] = "else",
  [field_end] = "end",
  [field_exceptions] = "exceptions",
  [field_guard] = "guard",
  [field_handler] = "handler",
  [field_key] = "key",
  [field_left] = "left",
  [field_locals] = "locals",
  [field_method] = "method",
  [field_name] = "name",
  [field_object] = "object",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_receiver] = "receiver",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_superclass] = "superclass",
  [field_value] = "value",
  [field_variable] = "variable",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 3},
  [4] = {.index = 5, .length = 1},
  [5] = {.index = 6, .length = 1},
  [11] = {.index = 7, .length = 2},
  [12] = {.index = 9, .length = 5},
  [13] = {.index = 14, .length = 3},
  [14] = {.index = 17, .length = 1},
  [15] = {.index = 18, .length = 2},
  [16] = {.index = 20, .length = 1},
  [17] = {.index = 21, .length = 2},
  [18] = {.index = 23, .length = 4},
  [19] = {.index = 27, .length = 4},
  [20] = {.index = 31, .length = 2},
  [21] = {.index = 33, .length = 2},
  [28] = {.index = 35, .length = 1},
  [29] = {.index = 35, .length = 1},
  [30] = {.index = 36, .length = 1},
  [31] = {.index = 37, .length = 2},
  [32] = {.index = 39, .length = 2},
  [33] = {.index = 41, .length = 1},
  [34] = {.index = 42, .length = 1},
  [35] = {.index = 43, .length = 2},
  [37] = {.index = 45, .length = 2},
  [38] = {.index = 47, .length = 2},
  [39] = {.index = 49, .length = 2},
  [40] = {.index = 51, .length = 3},
  [41] = {.index = 54, .length = 3},
  [42] = {.index = 57, .length = 2},
  [46] = {.index = 59, .length = 3},
  [47] = {.index = 62, .length = 2},
  [48] = {.index = 64, .length = 1},
  [49] = {.index = 65, .length = 3},
  [50] = {.index = 68, .length = 3},
  [51] = {.index = 71, .length = 2},
  [52] = {.index = 73, .length = 5},
  [53] = {.index = 78, .length = 2},
  [54] = {.index = 80, .length = 3},
  [57] = {.index = 83, .length = 2},
  [58] = {.index = 83, .length = 2},
  [59] = {.index = 85, .length = 4},
  [60] = {.index = 89, .length = 2},
  [61] = {.index = 91, .length = 3},
  [62] = {.index = 94, .length = 2},
  [63] = {.index = 96, .length = 2},
  [64] = {.index = 98, .length = 1},
  [65] = {.index = 99, .length = 3},
  [66] = {.index = 102, .length = 1},
  [67] = {.index = 103, .length = 2},
  [68] = {.index = 105, .length = 1},
  [69] = {.index = 106, .length = 2},
  [70] = {.index = 108, .length = 2},
  [71] = {.index = 110, .length = 2},
  [72] = {.index = 112, .length = 1},
  [73] = {.index = 113, .length = 2},
  [74] = {.index = 115, .length = 1},
  [75] = {.index = 116, .length = 1},
  [76] = {.index = 117, .length = 2},
  [78] = {.index = 119, .length = 2},
  [79] = {.index = 121, .length = 2},
  [80] = {.index = 123, .length = 4},
  [81] = {.index = 127, .length = 3},
  [82] = {.index = 130, .length = 2},
  [83] = {.index = 132, .length = 2},
  [84] = {.index = 134, .length = 2},
  [85] = {.index = 136, .length = 3},
  [86] = {.index = 139, .length = 2},
  [87] = {.index = 141, .length = 2},
  [88] = {.index = 143, .length = 3},
  [89] = {.index = 146, .length = 2},
  [90] = {.index = 148, .length = 2},
  [91] = {.index = 150, .length = 2},
  [92] = {.index = 152, .length = 3},
  [93] = {.index = 155, .length = 3},
  [94] = {.index = 158, .length = 2},
  [95] = {.index = 45, .length = 2},
  [96] = {.index = 160, .length = 1},
  [97] = {.index = 161, .length = 1},
  [98] = {.index = 162, .length = 2},
  [99] = {.index = 164, .length = 1},
  [100] = {.index = 165, .length = 2},
  [101] = {.index = 167, .length = 1},
  [102] = {.index = 168, .length = 3},
  [103] = {.index = 171, .length = 2},
  [104] = {.index = 173, .length = 4},
  [105] = {.index = 177, .length = 3},
  [106] = {.index = 180, .length = 2},
  [107] = {.index = 182, .length = 3},
  [108] = {.index = 185, .length = 2},
  [109] = {.index = 187, .length = 3},
  [110] = {.index = 190, .length = 3},
  [111] = {.index = 193, .length = 2},
  [112] = {.index = 195, .length = 3},
  [113] = {.index = 198, .length = 1},
  [114] = {.index = 199, .length = 2},
  [115] = {.index = 201, .length = 2},
  [116] = {.index = 203, .length = 3},
  [117] = {.index = 206, .length = 1},
  [118] = {.index = 207, .length = 1},
  [119] = {.index = 208, .length = 2},
  [120] = {.index = 210, .length = 2},
  [121] = {.index = 212, .length = 2},
  [122] = {.index = 214, .length = 2},
  [123] = {.index = 216, .length = 1},
  [124] = {.index = 217, .length = 2},
  [125] = {.index = 219, .length = 1},
  [126] = {.index = 220, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_operand, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [2] =
    {field_method, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_receiver, 0, .inherited = true},
  [5] =
    {field_method, 0},
  [6] =
    {field_method, 0, .inherited = true},
  [7] =
    {field_operand, 1},
    {field_operator, 0},
  [9] =
    {field_left, 1, .inherited = true},
    {field_operand, 1},
    {field_operator, 0},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [14] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
  [17] =
    {field_name, 1},
  [18] =
    {field_end, 1},
    {field_operator, 0},
  [20] =
    {field_body, 1},
  [21] =
    {field_begin, 0},
    {field_operator, 1},
  [23] =
    {field_arguments, 1},
    {field_method, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_receiver, 0, .inherited = true},
  [27] =
    {field_block, 1},
    {field_method, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_receiver, 0, .inherited = true},
  [31] =
    {field_arguments, 1},
    {field_method, 0},
  [33] =
    {field_block, 1},
    {field_method, 0},
  [35] =
    {field_key, 0},
  [36] =
    {field_name, 0},
  [37] =
    {field_body, 1, .inherited = true},
    {field_name, 0},
  [39] =
    {field_body, 2},
    {field_condition, 1},
  [41] =
    {field_value, 1},
  [42] =
    {field_clauses, 0},
  [43] =
    {field_alias, 2},
    {field_name, 1},
  [45] =
    {field_body, 2},
    {field_parameters, 1},
  [47] =
    {field_body, 0},
    {field_handler, 2},
  [49] =
    {field_body, 0},
    {field_condition, 2},
  [51] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [54] =
    {field_begin, 0},
    {field_end, 2},
    {field_operator, 1},
  [57] =
    {field_pattern, 2},
    {field_value, 0},
  [59] =
    {field_begin, 0, .inherited = true},
    {field_end, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [62] =
    {field_name, 0, .inherited = true},
    {field_scope, 0, .inherited = true},
  [64] =
    {field_object, 0},
  [65] =
    {field_method, 2},
    {field_operator, 1},
    {field_receiver, 0},
  [68] =
    {field_arguments, 2},
    {field_operator, 1},
    {field_receiver, 0},
  [71] =
    {field_name, 2},
    {field_scope, 0},
  [73] =
    {field_arguments, 1},
    {field_block, 2},
    {field_method, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_receiver, 0, .inherited = true},
  [78] =
    {field_left, 0},
    {field_right, 2},
  [80] =
    {field_arguments, 1},
    {field_block, 2},
    {field_method, 0},
  [83] =
    {field_key, 0},
    {field_value, 2},
  [85] =
    {field_body, 3, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_object, 1},
    {field_parameters, 3, .inherited = true},
  [89] =
    {field_name, 0},
    {field_parameters, 1},
  [91] =
    {field_body, 2, .inherited = true},
    {field_name, 0},
    {field_parameters, 1},
  [94] =
    {field_body, 2},
    {field_name, 1},
  [96] =
    {field_condition, 1},
    {field_consequence, 2},
  [98] =
    {field_condition, 1},
  [99] =
    {field_body, 3},
    {field_pattern, 1},
    {field_value, 2},
  [102] =
    {field_value, 2},
  [103] =
    {field_body, 2},
    {field_pattern, 1},
  [105] =
    {field_pattern, 1},
  [106] =
    {field_clauses, 2, .inherited = true},
    {field_value, 1},
  [108] =
    {field_clauses, 0, .inherited = true},
    {field_clauses, 1, .inherited = true},
  [110] =
    {field_body, 2},
    {field_exceptions, 1},
  [112] =
    {field_exceptions, 1},
  [113] =
    {field_body, 2},
    {field_variable, 1},
  [115] =
    {field_variable, 1},
  [116] =
    {field_parameters, 1},
  [117] =
    {field_name, 0},
    {field_value, 2},
  [119] =
    {field_alternatives, 0},
    {field_alternatives, 1, .inherited = true},
  [121] =
    {field_block, 3},
    {field_object, 0},
  [123] =
    {field_arguments, 2},
    {field_block, 3},
    {field_operator, 1},
    {field_receiver, 0},
  [127] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1},
  [130] =
    {field_body, 2},
    {field_name, 0},
  [132] =
    {field_name, 1},
    {field_superclass, 2},
  [134] =
    {field_body, 3},
    {field_name, 1},
  [136] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [139] =
    {field_alternative, 3},
    {field_condition, 1},
  [141] =
    {field_clauses, 3, .inherited = true},
    {field_value, 2},
  [143] =
    {field_body, 3},
    {field_pattern, 1},
    {field_pattern, 2, .inherited = true},
  [146] =
    {field_pattern, 1},
    {field_pattern, 2, .inherited = true},
  [148] =
    {field_pattern, 0, .inherited = true},
    {field_pattern, 1, .inherited = true},
  [150] =
    {field_clauses, 3, .inherited = true},
    {field_value, 1},
  [152] =
    {field_clauses, 2, .inherited = true},
    {field_else, 3},
    {field_value, 1},
  [155] =
    {field_body, 3},
    {field_exceptions, 1},
    {field_variable, 2},
  [158] =
    {field_exceptions, 1},
    {field_variable, 2},
  [160] =
    {field_parameters, 2},
  [161] =
    {field_body, 2},
  [162] =
    {field_name, 2},
    {field_value, 0},
  [164] =
    {field_alternatives, 1},
  [165] =
    {field_alternatives, 0, .inherited = true},
    {field_alternatives, 1, .inherited = true},
  [167] =
    {field_class, 0},
  [168] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [171] =
    {field_block, 4},
    {field_object, 0},
  [173] =
    {field_body, 5, .inherited = true},
    {field_name, 5, .inherited = true},
    {field_object, 2},
    {field_parameters, 5, .inherited = true},
  [177] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 1},
  [180] =
    {field_body, 4},
    {field_value, 2},
  [182] =
    {field_body, 4},
    {field_name, 1},
    {field_superclass, 2},
  [185] =
    {field_clauses, 4, .inherited = true},
    {field_value, 2},
  [187] =
    {field_clauses, 3, .inherited = true},
    {field_else, 4},
    {field_value, 2},
  [190] =
    {field_body, 3},
    {field_guard, 2},
    {field_pattern, 1},
  [193] =
    {field_guard, 2},
    {field_pattern, 1},
  [195] =
    {field_clauses, 3, .inherited = true},
    {field_else, 4},
    {field_value, 1},
  [198] =
    {field_locals, 2},
  [199] =
    {field_body, 3},
    {field_parameters, 1},
  [201] =
    {field_body, 3},
    {field_parameters, 2},
  [203] =
    {field_clauses, 4, .inherited = true},
    {field_else, 5},
    {field_value, 2},
  [206] =
    {field_locals, 3},
  [207] =
    {field_locals, 1},
  [208] =
    {field_locals, 2},
    {field_locals, 3, .inherited = true},
  [210] =
    {field_locals, 0, .inherited = true},
    {field_locals, 1, .inherited = true},
  [212] =
    {field_body, 4},
    {field_parameters, 2},
  [214] =
    {field_locals, 3},
    {field_locals, 4, .inherited = true},
  [216] =
    {field_locals, 4},
  [217] =
    {field_locals, 4},
    {field_locals, 5, .inherited = true},
  [219] =
    {field_locals, 5},
  [220] =
    {field_locals, 5},
    {field_locals, 6, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [2] = {
    [0] = sym_call,
  },
  [3] = {
    [0] = sym_call,
  },
  [6] = {
    [0] = sym_constant,
  },
  [7] = {
    [0] = sym_identifier,
  },
  [8] = {
    [1] = sym__string_start,
  },
  [9] = {
    [1] = anon_sym_BQUOTE,
  },
  [10] = {
    [1] = anon_sym_SLASH,
  },
  [22] = {
    [0] = sym_rational,
  },
  [23] = {
    [2] = sym__string_start,
  },
  [24] = {
    [2] = anon_sym_BQUOTE,
  },
  [25] = {
    [2] = anon_sym_SLASH,
  },
  [26] = {
    [1] = alias_sym_bare_string,
  },
  [27] = {
    [1] = alias_sym_bare_symbol,
  },
  [29] = {
    [0] = sym_hash_key_symbol,
  },
  [36] = {
    [0] = alias_sym_destructured_parameter,
  },
  [37] = {
    [1] = alias_sym_lambda_parameters,
  },
  [43] = {
    [0] = sym_array_pattern,
  },
  [44] = {
    [0] = sym_find_pattern,
  },
  [45] = {
    [0] = sym_hash_pattern,
  },
  [55] = {
    [2] = alias_sym_bare_string,
  },
  [56] = {
    [2] = alias_sym_bare_symbol,
  },
  [58] = {
    [0] = sym_hash_key_symbol,
  },
  [77] = {
    [1] = sym_splat_parameter,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_parameters, 3,
    sym_parameters,
    alias_sym_destructured_parameter,
    alias_sym_lambda_parameters,
  sym_bare_parameters, 2,
    sym_parameters,
    alias_sym_lambda_parameters,
  sym__array_pattern_n, 2,
    sym__array_pattern_n,
    sym_array_pattern,
  sym__find_pattern_body, 2,
    sym__find_pattern_body,
    sym_find_pattern,
  sym__hash_pattern_body, 2,
    sym__hash_pattern_body,
    sym_hash_pattern,
  sym__call, 2,
    sym__call,
    sym_call,
  sym__chained_command_call, 2,
    sym__chained_command_call,
    sym_call,
  sym__int_or_float, 2,
    sym__int_or_float,
    sym_rational,
  sym_constant_suffix, 2,
    sym_hash_key_symbol,
    sym_constant,
  sym_identifier_suffix, 2,
    sym_hash_key_symbol,
    sym_identifier,
  aux_sym__literal_contents, 3,
    aux_sym__literal_contents,
    alias_sym_bare_string,
    alias_sym_bare_symbol,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 4,
  [6] = 4,
  [7] = 2,
  [8] = 4,
  [9] = 4,
  [10] = 2,
  [11] = 4,
  [12] = 2,
  [13] = 2,
  [14] = 2,
  [15] = 2,
  [16] = 4,
  [17] = 4,
  [18] = 4,
  [19] = 2,
  [20] = 4,
  [21] = 2,
  [22] = 2,
  [23] = 4,
  [24] = 4,
  [25] = 2,
  [26] = 2,
  [27] = 2,
  [28] = 4,
  [29] = 2,
  [30] = 2,
  [31] = 4,
  [32] = 4,
  [33] = 4,
  [34] = 4,
  [35] = 2,
  [36] = 4,
  [37] = 2,
  [38] = 2,
  [39] = 4,
  [40] = 2,
  [41] = 4,
  [42] = 42,
  [43] = 42,
  [44] = 42,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 48,
  [50] = 45,
  [51] = 46,
  [52] = 47,
  [53] = 42,
  [54] = 42,
  [55] = 42,
  [56] = 42,
  [57] = 46,
  [58] = 42,
  [59] = 48,
  [60] = 47,
  [61] = 45,
  [62] = 42,
  [63] = 42,
  [64] = 42,
  [65] = 46,
  [66] = 42,
  [67] = 48,
  [68] = 47,
  [69] = 42,
  [70] = 45,
  [71] = 42,
  [72] = 42,
  [73] = 46,
  [74] = 42,
  [75] = 48,
  [76] = 42,
  [77] = 47,
  [78] = 42,
  [79] = 45,
  [80] = 45,
  [81] = 48,
  [82] = 46,
  [83] = 45,
  [84] = 46,
  [85] = 45,
  [86] = 47,
  [87] = 48,
  [88] = 47,
  [89] = 47,
  [90] = 47,
  [91] = 45,
  [92] = 46,
  [93] = 46,
  [94] = 48,
  [95] = 48,
  [96] = 42,
  [97] = 46,
  [98] = 48,
  [99] = 46,
  [100] = 45,
  [101] = 47,
  [102] = 48,
  [103] = 45,
  [104] = 47,
  [105] = 48,
  [106] = 46,
  [107] = 45,
  [108] = 47,
  [109] = 42,
  [110] = 45,
  [111] = 48,
  [112] = 46,
  [113] = 47,
  [114] = 114,
  [115] = 114,
  [116] = 114,
  [117] = 114,
  [118] = 118,
  [119] = 118,
  [120] = 118,
  [121] = 118,
  [122] = 118,
  [123] = 123,
  [124] = 123,
  [125] = 123,
  [126] = 126,
  [127] = 127,
  [128] = 126,
  [129] = 127,
  [130] = 127,
  [131] = 126,
  [132] = 132,
  [133] = 132,
  [134] = 132,
  [135] = 135,
  [136] = 135,
  [137] = 135,
  [138] = 138,
  [139] = 135,
  [140] = 135,
  [141] = 135,
  [142] = 135,
  [143] = 135,
  [144] = 138,
  [145] = 135,
  [146] = 138,
  [147] = 135,
  [148] = 135,
  [149] = 135,
  [150] = 138,
  [151] = 138,
  [152] = 135,
  [153] = 138,
  [154] = 135,
  [155] = 135,
  [156] = 135,
  [157] = 138,
  [158] = 135,
  [159] = 138,
  [160] = 135,
  [161] = 135,
  [162] = 138,
  [163] = 135,
  [164] = 135,
  [165] = 135,
  [166] = 135,
  [167] = 138,
  [168] = 135,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 169,
  [173] = 169,
  [174] = 169,
  [175] = 171,
  [176] = 170,
  [177] = 170,
  [178] = 171,
  [179] = 169,
  [180] = 170,
  [181] = 171,
  [182] = 170,
  [183] = 170,
  [184] = 171,
  [185] = 171,
  [186] = 170,
  [187] = 169,
  [188] = 171,
  [189] = 170,
  [190] = 170,
  [191] = 171,
  [192] = 170,
  [193] = 169,
  [194] = 169,
  [195] = 169,
  [196] = 171,
  [197] = 169,
  [198] = 171,
  [199] = 199,
  [200] = 199,
  [201] = 199,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 205,
  [209] = 205,
  [210] = 210,
  [211] = 207,
  [212] = 212,
  [213] = 205,
  [214] = 214,
  [215] = 206,
  [216] = 204,
  [217] = 217,
  [218] = 206,
  [219] = 204,
  [220] = 205,
  [221] = 207,
  [222] = 207,
  [223] = 217,
  [224] = 207,
  [225] = 205,
  [226] = 202,
  [227] = 205,
  [228] = 210,
  [229] = 212,
  [230] = 205,
  [231] = 217,
  [232] = 207,
  [233] = 203,
  [234] = 214,
  [235] = 207,
  [236] = 214,
  [237] = 207,
  [238] = 212,
  [239] = 207,
  [240] = 210,
  [241] = 205,
  [242] = 207,
  [243] = 205,
  [244] = 244,
  [245] = 244,
  [246] = 203,
  [247] = 244,
  [248] = 248,
  [249] = 248,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 252,
  [254] = 252,
  [255] = 252,
  [256] = 252,
  [257] = 252,
  [258] = 252,
  [259] = 252,
  [260] = 203,
  [261] = 261,
  [262] = 202,
  [263] = 263,
  [264] = 202,
  [265] = 203,
  [266] = 266,
  [267] = 267,
  [268] = 202,
  [269] = 269,
  [270] = 269,
  [271] = 267,
  [272] = 203,
  [273] = 269,
  [274] = 274,
  [275] = 267,
  [276] = 203,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 203,
  [281] = 281,
  [282] = 282,
  [283] = 202,
  [284] = 277,
  [285] = 277,
  [286] = 203,
  [287] = 287,
  [288] = 287,
  [289] = 289,
  [290] = 290,
  [291] = 287,
  [292] = 287,
  [293] = 203,
  [294] = 294,
  [295] = 287,
  [296] = 296,
  [297] = 287,
  [298] = 287,
  [299] = 299,
  [300] = 287,
  [301] = 287,
  [302] = 202,
  [303] = 287,
  [304] = 304,
  [305] = 202,
  [306] = 202,
  [307] = 203,
  [308] = 203,
  [309] = 202,
  [310] = 248,
  [311] = 203,
  [312] = 202,
  [313] = 203,
  [314] = 250,
  [315] = 202,
  [316] = 316,
  [317] = 316,
  [318] = 316,
  [319] = 316,
  [320] = 316,
  [321] = 316,
  [322] = 203,
  [323] = 316,
  [324] = 203,
  [325] = 251,
  [326] = 202,
  [327] = 316,
  [328] = 248,
  [329] = 203,
  [330] = 316,
  [331] = 316,
  [332] = 203,
  [333] = 202,
  [334] = 334,
  [335] = 335,
  [336] = 335,
  [337] = 335,
  [338] = 335,
  [339] = 203,
  [340] = 335,
  [341] = 341,
  [342] = 335,
  [343] = 343,
  [344] = 248,
  [345] = 335,
  [346] = 335,
  [347] = 347,
  [348] = 348,
  [349] = 343,
  [350] = 335,
  [351] = 203,
  [352] = 341,
  [353] = 334,
  [354] = 343,
  [355] = 334,
  [356] = 335,
  [357] = 341,
  [358] = 358,
  [359] = 335,
  [360] = 202,
  [361] = 335,
  [362] = 335,
  [363] = 203,
  [364] = 248,
  [365] = 203,
  [366] = 203,
  [367] = 202,
  [368] = 203,
  [369] = 248,
  [370] = 202,
  [371] = 248,
  [372] = 248,
  [373] = 373,
  [374] = 203,
  [375] = 248,
  [376] = 373,
  [377] = 202,
  [378] = 248,
  [379] = 202,
  [380] = 203,
  [381] = 202,
  [382] = 203,
  [383] = 248,
  [384] = 202,
  [385] = 203,
  [386] = 203,
  [387] = 202,
  [388] = 203,
  [389] = 373,
  [390] = 203,
  [391] = 203,
  [392] = 203,
  [393] = 202,
  [394] = 202,
  [395] = 248,
  [396] = 203,
  [397] = 203,
  [398] = 203,
  [399] = 202,
  [400] = 203,
  [401] = 203,
  [402] = 402,
  [403] = 403,
  [404] = 203,
  [405] = 405,
  [406] = 402,
  [407] = 402,
  [408] = 405,
  [409] = 405,
  [410] = 410,
  [411] = 410,
  [412] = 410,
  [413] = 403,
  [414] = 403,
  [415] = 202,
  [416] = 203,
  [417] = 417,
  [418] = 202,
  [419] = 203,
  [420] = 203,
  [421] = 203,
  [422] = 422,
  [423] = 423,
  [424] = 203,
  [425] = 425,
  [426] = 422,
  [427] = 425,
  [428] = 428,
  [429] = 422,
  [430] = 430,
  [431] = 422,
  [432] = 422,
  [433] = 202,
  [434] = 422,
  [435] = 435,
  [436] = 423,
  [437] = 422,
  [438] = 423,
  [439] = 203,
  [440] = 425,
  [441] = 203,
  [442] = 442,
  [443] = 443,
  [444] = 443,
  [445] = 443,
  [446] = 443,
  [447] = 443,
  [448] = 443,
  [449] = 443,
  [450] = 443,
  [451] = 443,
  [452] = 443,
  [453] = 443,
  [454] = 443,
  [455] = 443,
  [456] = 443,
  [457] = 457,
  [458] = 457,
  [459] = 457,
  [460] = 457,
  [461] = 457,
  [462] = 457,
  [463] = 457,
  [464] = 457,
  [465] = 457,
  [466] = 457,
  [467] = 457,
  [468] = 457,
  [469] = 457,
  [470] = 457,
  [471] = 457,
  [472] = 457,
  [473] = 457,
  [474] = 457,
  [475] = 457,
  [476] = 457,
  [477] = 457,
  [478] = 457,
  [479] = 457,
  [480] = 457,
  [481] = 457,
  [482] = 482,
  [483] = 483,
  [484] = 482,
  [485] = 485,
  [486] = 485,
  [487] = 487,
  [488] = 485,
  [489] = 485,
  [490] = 483,
  [491] = 485,
  [492] = 485,
  [493] = 485,
  [494] = 485,
  [495] = 485,
  [496] = 485,
  [497] = 485,
  [498] = 498,
  [499] = 485,
  [500] = 485,
  [501] = 485,
  [502] = 485,
  [503] = 485,
  [504] = 485,
  [505] = 485,
  [506] = 202,
  [507] = 485,
  [508] = 485,
  [509] = 485,
  [510] = 485,
  [511] = 485,
  [512] = 485,
  [513] = 485,
  [514] = 514,
  [515] = 498,
  [516] = 514,
  [517] = 202,
  [518] = 487,
  [519] = 519,
  [520] = 520,
  [521] = 520,
  [522] = 522,
  [523] = 519,
  [524] = 524,
  [525] = 525,
  [526] = 524,
  [527] = 519,
  [528] = 522,
  [529] = 520,
  [530] = 522,
  [531] = 520,
  [532] = 519,
  [533] = 524,
  [534] = 525,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 520,
  [540] = 540,
  [541] = 525,
  [542] = 525,
  [543] = 524,
  [544] = 519,
  [545] = 522,
  [546] = 522,
  [547] = 520,
  [548] = 524,
  [549] = 519,
  [550] = 537,
  [551] = 536,
  [552] = 519,
  [553] = 524,
  [554] = 522,
  [555] = 520,
  [556] = 556,
  [557] = 524,
  [558] = 519,
  [559] = 522,
  [560] = 520,
  [561] = 520,
  [562] = 535,
  [563] = 525,
  [564] = 540,
  [565] = 524,
  [566] = 540,
  [567] = 520,
  [568] = 522,
  [569] = 519,
  [570] = 524,
  [571] = 519,
  [572] = 524,
  [573] = 522,
  [574] = 519,
  [575] = 522,
  [576] = 520,
  [577] = 520,
  [578] = 525,
  [579] = 522,
  [580] = 556,
  [581] = 538,
  [582] = 524,
  [583] = 519,
  [584] = 540,
  [585] = 538,
  [586] = 537,
  [587] = 536,
  [588] = 535,
  [589] = 556,
  [590] = 522,
  [591] = 525,
  [592] = 525,
  [593] = 525,
  [594] = 525,
  [595] = 519,
  [596] = 519,
  [597] = 525,
  [598] = 524,
  [599] = 525,
  [600] = 524,
  [601] = 520,
  [602] = 520,
  [603] = 522,
  [604] = 519,
  [605] = 524,
  [606] = 524,
  [607] = 519,
  [608] = 522,
  [609] = 522,
  [610] = 525,
  [611] = 520,
  [612] = 520,
  [613] = 520,
  [614] = 522,
  [615] = 615,
  [616] = 616,
  [617] = 519,
  [618] = 525,
  [619] = 619,
  [620] = 520,
  [621] = 524,
  [622] = 522,
  [623] = 522,
  [624] = 519,
  [625] = 540,
  [626] = 525,
  [627] = 522,
  [628] = 520,
  [629] = 519,
  [630] = 525,
  [631] = 524,
  [632] = 519,
  [633] = 522,
  [634] = 520,
  [635] = 524,
  [636] = 520,
  [637] = 619,
  [638] = 524,
  [639] = 525,
  [640] = 540,
  [641] = 520,
  [642] = 525,
  [643] = 522,
  [644] = 519,
  [645] = 525,
  [646] = 524,
  [647] = 524,
  [648] = 519,
  [649] = 522,
  [650] = 522,
  [651] = 520,
  [652] = 525,
  [653] = 525,
  [654] = 525,
  [655] = 522,
  [656] = 520,
  [657] = 524,
  [658] = 525,
  [659] = 524,
  [660] = 519,
  [661] = 520,
  [662] = 522,
  [663] = 519,
  [664] = 524,
  [665] = 524,
  [666] = 666,
  [667] = 525,
  [668] = 519,
  [669] = 525,
  [670] = 670,
  [671] = 482,
  [672] = 670,
  [673] = 670,
  [674] = 670,
  [675] = 483,
  [676] = 670,
  [677] = 677,
  [678] = 514,
  [679] = 483,
  [680] = 487,
  [681] = 202,
  [682] = 498,
  [683] = 482,
  [684] = 514,
  [685] = 202,
  [686] = 487,
  [687] = 498,
  [688] = 688,
  [689] = 483,
  [690] = 482,
  [691] = 483,
  [692] = 482,
  [693] = 483,
  [694] = 482,
  [695] = 487,
  [696] = 696,
  [697] = 696,
  [698] = 696,
  [699] = 482,
  [700] = 514,
  [701] = 498,
  [702] = 483,
  [703] = 696,
  [704] = 482,
  [705] = 483,
  [706] = 498,
  [707] = 696,
  [708] = 498,
  [709] = 483,
  [710] = 696,
  [711] = 482,
  [712] = 514,
  [713] = 696,
  [714] = 202,
  [715] = 696,
  [716] = 514,
  [717] = 202,
  [718] = 487,
  [719] = 487,
  [720] = 696,
  [721] = 696,
  [722] = 696,
  [723] = 696,
  [724] = 202,
  [725] = 696,
  [726] = 696,
  [727] = 514,
  [728] = 498,
  [729] = 202,
  [730] = 514,
  [731] = 514,
  [732] = 487,
  [733] = 202,
  [734] = 202,
  [735] = 482,
  [736] = 498,
  [737] = 498,
  [738] = 487,
  [739] = 487,
  [740] = 483,
  [741] = 741,
  [742] = 498,
  [743] = 202,
  [744] = 744,
  [745] = 202,
  [746] = 741,
  [747] = 487,
  [748] = 744,
  [749] = 741,
  [750] = 482,
  [751] = 483,
  [752] = 744,
  [753] = 753,
  [754] = 514,
  [755] = 753,
  [756] = 753,
  [757] = 757,
  [758] = 757,
  [759] = 757,
  [760] = 757,
  [761] = 757,
  [762] = 757,
  [763] = 757,
  [764] = 757,
  [765] = 757,
  [766] = 757,
  [767] = 757,
  [768] = 757,
  [769] = 757,
  [770] = 757,
  [771] = 757,
  [772] = 757,
  [773] = 757,
  [774] = 757,
  [775] = 757,
  [776] = 498,
  [777] = 777,
  [778] = 757,
  [779] = 757,
  [780] = 757,
  [781] = 757,
  [782] = 757,
  [783] = 757,
  [784] = 757,
  [785] = 757,
  [786] = 757,
  [787] = 757,
  [788] = 757,
  [789] = 757,
  [790] = 757,
  [791] = 757,
  [792] = 757,
  [793] = 757,
  [794] = 757,
  [795] = 757,
  [796] = 757,
  [797] = 757,
  [798] = 757,
  [799] = 757,
  [800] = 757,
  [801] = 757,
  [802] = 757,
  [803] = 757,
  [804] = 757,
  [805] = 805,
  [806] = 514,
  [807] = 202,
  [808] = 808,
  [809] = 809,
  [810] = 805,
  [811] = 811,
  [812] = 811,
  [813] = 811,
  [814] = 811,
  [815] = 811,
  [816] = 811,
  [817] = 811,
  [818] = 811,
  [819] = 811,
  [820] = 811,
  [821] = 811,
  [822] = 811,
  [823] = 805,
  [824] = 811,
  [825] = 811,
  [826] = 811,
  [827] = 811,
  [828] = 811,
  [829] = 811,
  [830] = 811,
  [831] = 811,
  [832] = 811,
  [833] = 811,
  [834] = 811,
  [835] = 811,
  [836] = 805,
  [837] = 811,
  [838] = 811,
  [839] = 811,
  [840] = 811,
  [841] = 811,
  [842] = 842,
  [843] = 842,
  [844] = 844,
  [845] = 844,
  [846] = 842,
  [847] = 844,
  [848] = 842,
  [849] = 842,
  [850] = 842,
  [851] = 842,
  [852] = 844,
  [853] = 842,
  [854] = 842,
  [855] = 842,
  [856] = 844,
  [857] = 844,
  [858] = 842,
  [859] = 844,
  [860] = 842,
  [861] = 844,
  [862] = 842,
  [863] = 842,
  [864] = 842,
  [865] = 844,
  [866] = 842,
  [867] = 844,
  [868] = 842,
  [869] = 844,
  [870] = 842,
  [871] = 844,
  [872] = 842,
  [873] = 842,
  [874] = 842,
  [875] = 842,
  [876] = 842,
  [877] = 844,
  [878] = 842,
  [879] = 844,
  [880] = 842,
  [881] = 844,
  [882] = 844,
  [883] = 842,
  [884] = 844,
  [885] = 842,
  [886] = 842,
  [887] = 844,
  [888] = 842,
  [889] = 842,
  [890] = 844,
  [891] = 842,
  [892] = 842,
  [893] = 842,
  [894] = 844,
  [895] = 844,
  [896] = 842,
  [897] = 842,
  [898] = 842,
  [899] = 844,
  [900] = 844,
  [901] = 842,
  [902] = 842,
  [903] = 842,
  [904] = 842,
  [905] = 842,
  [906] = 842,
  [907] = 842,
  [908] = 842,
  [909] = 842,
  [910] = 844,
  [911] = 842,
  [912] = 912,
  [913] = 913,
  [914] = 914,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 912,
  [919] = 919,
  [920] = 914,
  [921] = 914,
  [922] = 914,
  [923] = 914,
  [924] = 914,
  [925] = 913,
  [926] = 914,
  [927] = 914,
  [928] = 914,
  [929] = 914,
  [930] = 914,
  [931] = 914,
  [932] = 914,
  [933] = 914,
  [934] = 914,
  [935] = 914,
  [936] = 914,
  [937] = 914,
  [938] = 914,
  [939] = 914,
  [940] = 914,
  [941] = 915,
  [942] = 942,
  [943] = 943,
  [944] = 944,
  [945] = 945,
  [946] = 914,
  [947] = 947,
  [948] = 947,
  [949] = 947,
  [950] = 947,
  [951] = 947,
  [952] = 947,
  [953] = 947,
  [954] = 947,
  [955] = 947,
  [956] = 947,
  [957] = 947,
  [958] = 947,
  [959] = 947,
  [960] = 947,
  [961] = 961,
  [962] = 962,
  [963] = 963,
  [964] = 917,
  [965] = 945,
  [966] = 962,
  [967] = 963,
  [968] = 968,
  [969] = 968,
  [970] = 970,
  [971] = 971,
  [972] = 970,
  [973] = 971,
  [974] = 974,
  [975] = 975,
  [976] = 976,
  [977] = 977,
  [978] = 978,
  [979] = 947,
  [980] = 947,
  [981] = 975,
  [982] = 976,
  [983] = 917,
  [984] = 915,
  [985] = 977,
  [986] = 916,
  [987] = 915,
  [988] = 978,
  [989] = 913,
  [990] = 916,
  [991] = 991,
  [992] = 992,
  [993] = 916,
  [994] = 915,
  [995] = 942,
  [996] = 919,
  [997] = 944,
  [998] = 991,
  [999] = 978,
  [1000] = 977,
  [1001] = 976,
  [1002] = 975,
  [1003] = 971,
  [1004] = 970,
  [1005] = 968,
  [1006] = 963,
  [1007] = 991,
  [1008] = 962,
  [1009] = 945,
  [1010] = 913,
  [1011] = 912,
  [1012] = 919,
  [1013] = 912,
  [1014] = 916,
  [1015] = 1015,
  [1016] = 992,
  [1017] = 944,
  [1018] = 943,
  [1019] = 915,
  [1020] = 942,
  [1021] = 942,
  [1022] = 944,
  [1023] = 991,
  [1024] = 978,
  [1025] = 977,
  [1026] = 976,
  [1027] = 975,
  [1028] = 971,
  [1029] = 970,
  [1030] = 968,
  [1031] = 963,
  [1032] = 962,
  [1033] = 945,
  [1034] = 913,
  [1035] = 919,
  [1036] = 912,
  [1037] = 917,
  [1038] = 942,
  [1039] = 915,
  [1040] = 913,
  [1041] = 916,
  [1042] = 919,
  [1043] = 912,
  [1044] = 943,
  [1045] = 944,
  [1046] = 991,
  [1047] = 978,
  [1048] = 977,
  [1049] = 1015,
  [1050] = 976,
  [1051] = 975,
  [1052] = 971,
  [1053] = 970,
  [1054] = 968,
  [1055] = 963,
  [1056] = 962,
  [1057] = 945,
  [1058] = 917,
  [1059] = 942,
  [1060] = 917,
  [1061] = 916,
  [1062] = 912,
  [1063] = 919,
  [1064] = 913,
  [1065] = 944,
  [1066] = 991,
  [1067] = 978,
  [1068] = 977,
  [1069] = 976,
  [1070] = 975,
  [1071] = 971,
  [1072] = 970,
  [1073] = 968,
  [1074] = 963,
  [1075] = 962,
  [1076] = 945,
  [1077] = 913,
  [1078] = 919,
  [1079] = 912,
  [1080] = 917,
  [1081] = 992,
  [1082] = 945,
  [1083] = 962,
  [1084] = 963,
  [1085] = 968,
  [1086] = 970,
  [1087] = 971,
  [1088] = 974,
  [1089] = 975,
  [1090] = 976,
  [1091] = 947,
  [1092] = 961,
  [1093] = 977,
  [1094] = 947,
  [1095] = 947,
  [1096] = 947,
  [1097] = 947,
  [1098] = 947,
  [1099] = 978,
  [1100] = 991,
  [1101] = 947,
  [1102] = 992,
  [1103] = 947,
  [1104] = 947,
  [1105] = 947,
  [1106] = 947,
  [1107] = 947,
  [1108] = 944,
  [1109] = 947,
  [1110] = 947,
  [1111] = 947,
  [1112] = 947,
  [1113] = 947,
  [1114] = 947,
  [1115] = 947,
  [1116] = 947,
  [1117] = 947,
  [1118] = 943,
  [1119] = 947,
  [1120] = 942,
  [1121] = 947,
  [1122] = 917,
  [1123] = 912,
  [1124] = 947,
  [1125] = 919,
  [1126] = 913,
  [1127] = 947,
  [1128] = 945,
  [1129] = 947,
  [1130] = 962,
  [1131] = 963,
  [1132] = 968,
  [1133] = 947,
  [1134] = 970,
  [1135] = 971,
  [1136] = 974,
  [1137] = 947,
  [1138] = 975,
  [1139] = 976,
  [1140] = 917,
  [1141] = 917,
  [1142] = 917,
  [1143] = 915,
  [1144] = 915,
  [1145] = 977,
  [1146] = 978,
  [1147] = 991,
  [1148] = 992,
  [1149] = 944,
  [1150] = 917,
  [1151] = 912,
  [1152] = 943,
  [1153] = 919,
  [1154] = 942,
  [1155] = 917,
  [1156] = 913,
  [1157] = 912,
  [1158] = 919,
  [1159] = 913,
  [1160] = 1160,
  [1161] = 945,
  [1162] = 962,
  [1163] = 963,
  [1164] = 968,
  [1165] = 947,
  [1166] = 970,
  [1167] = 917,
  [1168] = 971,
  [1169] = 975,
  [1170] = 916,
  [1171] = 915,
  [1172] = 976,
  [1173] = 916,
  [1174] = 914,
  [1175] = 916,
  [1176] = 977,
  [1177] = 915,
  [1178] = 916,
  [1179] = 978,
  [1180] = 916,
  [1181] = 915,
  [1182] = 916,
  [1183] = 915,
  [1184] = 916,
  [1185] = 915,
  [1186] = 916,
  [1187] = 915,
  [1188] = 916,
  [1189] = 915,
  [1190] = 916,
  [1191] = 915,
  [1192] = 961,
  [1193] = 991,
  [1194] = 944,
  [1195] = 916,
  [1196] = 943,
  [1197] = 915,
  [1198] = 916,
  [1199] = 942,
  [1200] = 915,
  [1201] = 916,
  [1202] = 917,
  [1203] = 944,
  [1204] = 912,
  [1205] = 919,
  [1206] = 915,
  [1207] = 916,
  [1208] = 943,
  [1209] = 942,
  [1210] = 915,
  [1211] = 916,
  [1212] = 915,
  [1213] = 942,
  [1214] = 944,
  [1215] = 991,
  [1216] = 978,
  [1217] = 977,
  [1218] = 976,
  [1219] = 975,
  [1220] = 971,
  [1221] = 970,
  [1222] = 968,
  [1223] = 963,
  [1224] = 962,
  [1225] = 945,
  [1226] = 913,
  [1227] = 945,
  [1228] = 913,
  [1229] = 919,
  [1230] = 912,
  [1231] = 916,
  [1232] = 915,
  [1233] = 916,
  [1234] = 915,
  [1235] = 942,
  [1236] = 944,
  [1237] = 991,
  [1238] = 978,
  [1239] = 977,
  [1240] = 976,
  [1241] = 975,
  [1242] = 971,
  [1243] = 970,
  [1244] = 962,
  [1245] = 968,
  [1246] = 963,
  [1247] = 963,
  [1248] = 962,
  [1249] = 945,
  [1250] = 913,
  [1251] = 919,
  [1252] = 912,
  [1253] = 916,
  [1254] = 915,
  [1255] = 916,
  [1256] = 915,
  [1257] = 968,
  [1258] = 942,
  [1259] = 944,
  [1260] = 970,
  [1261] = 991,
  [1262] = 978,
  [1263] = 977,
  [1264] = 976,
  [1265] = 975,
  [1266] = 971,
  [1267] = 970,
  [1268] = 968,
  [1269] = 963,
  [1270] = 962,
  [1271] = 945,
  [1272] = 913,
  [1273] = 919,
  [1274] = 971,
  [1275] = 912,
  [1276] = 916,
  [1277] = 915,
  [1278] = 942,
  [1279] = 916,
  [1280] = 915,
  [1281] = 942,
  [1282] = 944,
  [1283] = 991,
  [1284] = 978,
  [1285] = 977,
  [1286] = 976,
  [1287] = 975,
  [1288] = 975,
  [1289] = 976,
  [1290] = 971,
  [1291] = 970,
  [1292] = 968,
  [1293] = 963,
  [1294] = 962,
  [1295] = 945,
  [1296] = 913,
  [1297] = 919,
  [1298] = 912,
  [1299] = 916,
  [1300] = 915,
  [1301] = 942,
  [1302] = 977,
  [1303] = 978,
  [1304] = 991,
  [1305] = 944,
  [1306] = 944,
  [1307] = 942,
  [1308] = 915,
  [1309] = 916,
  [1310] = 917,
  [1311] = 991,
  [1312] = 978,
  [1313] = 977,
  [1314] = 976,
  [1315] = 975,
  [1316] = 971,
  [1317] = 970,
  [1318] = 968,
  [1319] = 963,
  [1320] = 962,
  [1321] = 945,
  [1322] = 913,
  [1323] = 912,
  [1324] = 919,
  [1325] = 919,
  [1326] = 912,
  [1327] = 913,
  [1328] = 917,
  [1329] = 945,
  [1330] = 916,
  [1331] = 962,
  [1332] = 915,
  [1333] = 942,
  [1334] = 944,
  [1335] = 963,
  [1336] = 968,
  [1337] = 991,
  [1338] = 978,
  [1339] = 977,
  [1340] = 976,
  [1341] = 975,
  [1342] = 971,
  [1343] = 970,
  [1344] = 968,
  [1345] = 963,
  [1346] = 962,
  [1347] = 945,
  [1348] = 913,
  [1349] = 919,
  [1350] = 912,
  [1351] = 917,
  [1352] = 916,
  [1353] = 915,
  [1354] = 917,
  [1355] = 912,
  [1356] = 919,
  [1357] = 913,
  [1358] = 942,
  [1359] = 944,
  [1360] = 991,
  [1361] = 978,
  [1362] = 977,
  [1363] = 976,
  [1364] = 975,
  [1365] = 970,
  [1366] = 971,
  [1367] = 975,
  [1368] = 971,
  [1369] = 970,
  [1370] = 968,
  [1371] = 963,
  [1372] = 962,
  [1373] = 945,
  [1374] = 913,
  [1375] = 919,
  [1376] = 912,
  [1377] = 917,
  [1378] = 916,
  [1379] = 915,
  [1380] = 942,
  [1381] = 944,
  [1382] = 991,
  [1383] = 978,
  [1384] = 977,
  [1385] = 976,
  [1386] = 976,
  [1387] = 975,
  [1388] = 971,
  [1389] = 970,
  [1390] = 968,
  [1391] = 963,
  [1392] = 962,
  [1393] = 945,
  [1394] = 945,
  [1395] = 962,
  [1396] = 963,
  [1397] = 968,
  [1398] = 913,
  [1399] = 970,
  [1400] = 971,
  [1401] = 974,
  [1402] = 975,
  [1403] = 976,
  [1404] = 977,
  [1405] = 978,
  [1406] = 919,
  [1407] = 917,
  [1408] = 916,
  [1409] = 915,
  [1410] = 942,
  [1411] = 944,
  [1412] = 991,
  [1413] = 978,
  [1414] = 977,
  [1415] = 976,
  [1416] = 975,
  [1417] = 971,
  [1418] = 970,
  [1419] = 968,
  [1420] = 963,
  [1421] = 962,
  [1422] = 945,
  [1423] = 913,
  [1424] = 919,
  [1425] = 912,
  [1426] = 917,
  [1427] = 942,
  [1428] = 944,
  [1429] = 977,
  [1430] = 991,
  [1431] = 945,
  [1432] = 962,
  [1433] = 991,
  [1434] = 978,
  [1435] = 978,
  [1436] = 991,
  [1437] = 992,
  [1438] = 977,
  [1439] = 976,
  [1440] = 975,
  [1441] = 971,
  [1442] = 970,
  [1443] = 968,
  [1444] = 963,
  [1445] = 962,
  [1446] = 945,
  [1447] = 913,
  [1448] = 992,
  [1449] = 919,
  [1450] = 912,
  [1451] = 917,
  [1452] = 916,
  [1453] = 915,
  [1454] = 963,
  [1455] = 942,
  [1456] = 944,
  [1457] = 968,
  [1458] = 970,
  [1459] = 971,
  [1460] = 1015,
  [1461] = 944,
  [1462] = 947,
  [1463] = 976,
  [1464] = 977,
  [1465] = 991,
  [1466] = 978,
  [1467] = 978,
  [1468] = 977,
  [1469] = 976,
  [1470] = 975,
  [1471] = 971,
  [1472] = 970,
  [1473] = 968,
  [1474] = 943,
  [1475] = 963,
  [1476] = 942,
  [1477] = 962,
  [1478] = 945,
  [1479] = 913,
  [1480] = 915,
  [1481] = 919,
  [1482] = 912,
  [1483] = 917,
  [1484] = 916,
  [1485] = 915,
  [1486] = 942,
  [1487] = 944,
  [1488] = 991,
  [1489] = 916,
  [1490] = 978,
  [1491] = 977,
  [1492] = 976,
  [1493] = 975,
  [1494] = 971,
  [1495] = 970,
  [1496] = 968,
  [1497] = 963,
  [1498] = 962,
  [1499] = 945,
  [1500] = 913,
  [1501] = 919,
  [1502] = 912,
  [1503] = 917,
  [1504] = 942,
  [1505] = 944,
  [1506] = 975,
  [1507] = 917,
  [1508] = 991,
  [1509] = 978,
  [1510] = 977,
  [1511] = 976,
  [1512] = 975,
  [1513] = 971,
  [1514] = 912,
  [1515] = 919,
  [1516] = 913,
  [1517] = 945,
  [1518] = 962,
  [1519] = 963,
  [1520] = 970,
  [1521] = 968,
  [1522] = 963,
  [1523] = 962,
  [1524] = 945,
  [1525] = 913,
  [1526] = 919,
  [1527] = 912,
  [1528] = 917,
  [1529] = 916,
  [1530] = 915,
  [1531] = 942,
  [1532] = 943,
  [1533] = 944,
  [1534] = 968,
  [1535] = 970,
  [1536] = 971,
  [1537] = 991,
  [1538] = 978,
  [1539] = 977,
  [1540] = 976,
  [1541] = 975,
  [1542] = 971,
  [1543] = 974,
  [1544] = 975,
  [1545] = 970,
  [1546] = 976,
  [1547] = 944,
  [1548] = 968,
  [1549] = 963,
  [1550] = 962,
  [1551] = 945,
  [1552] = 943,
  [1553] = 942,
  [1554] = 913,
  [1555] = 919,
  [1556] = 912,
  [1557] = 917,
  [1558] = 916,
  [1559] = 915,
  [1560] = 917,
  [1561] = 942,
  [1562] = 944,
  [1563] = 991,
  [1564] = 978,
  [1565] = 977,
  [1566] = 976,
  [1567] = 975,
  [1568] = 971,
  [1569] = 977,
  [1570] = 970,
  [1571] = 968,
  [1572] = 963,
  [1573] = 962,
  [1574] = 945,
  [1575] = 913,
  [1576] = 919,
  [1577] = 912,
  [1578] = 917,
  [1579] = 978,
  [1580] = 942,
  [1581] = 944,
  [1582] = 991,
  [1583] = 978,
  [1584] = 977,
  [1585] = 976,
  [1586] = 975,
  [1587] = 971,
  [1588] = 970,
  [1589] = 968,
  [1590] = 963,
  [1591] = 962,
  [1592] = 945,
  [1593] = 914,
  [1594] = 919,
  [1595] = 912,
  [1596] = 917,
  [1597] = 942,
  [1598] = 944,
  [1599] = 991,
  [1600] = 978,
  [1601] = 977,
  [1602] = 976,
  [1603] = 975,
  [1604] = 974,
  [1605] = 971,
  [1606] = 970,
  [1607] = 968,
  [1608] = 963,
  [1609] = 962,
  [1610] = 945,
  [1611] = 913,
  [1612] = 919,
  [1613] = 912,
  [1614] = 917,
  [1615] = 916,
  [1616] = 915,
  [1617] = 942,
  [1618] = 943,
  [1619] = 916,
  [1620] = 991,
  [1621] = 992,
  [1622] = 944,
  [1623] = 915,
  [1624] = 944,
  [1625] = 991,
  [1626] = 991,
  [1627] = 978,
  [1628] = 977,
  [1629] = 976,
  [1630] = 975,
  [1631] = 943,
  [1632] = 971,
  [1633] = 970,
  [1634] = 968,
  [1635] = 942,
  [1636] = 917,
  [1637] = 912,
  [1638] = 963,
  [1639] = 919,
  [1640] = 913,
  [1641] = 962,
  [1642] = 945,
  [1643] = 992,
  [1644] = 913,
  [1645] = 919,
  [1646] = 912,
  [1647] = 917,
  [1648] = 917,
  [1649] = 912,
  [1650] = 919,
  [1651] = 913,
  [1652] = 916,
  [1653] = 945,
  [1654] = 962,
  [1655] = 963,
  [1656] = 968,
  [1657] = 915,
  [1658] = 1160,
  [1659] = 970,
  [1660] = 971,
  [1661] = 974,
  [1662] = 975,
  [1663] = 942,
  [1664] = 944,
  [1665] = 976,
  [1666] = 977,
  [1667] = 991,
  [1668] = 945,
  [1669] = 962,
  [1670] = 963,
  [1671] = 968,
  [1672] = 978,
  [1673] = 970,
  [1674] = 971,
  [1675] = 975,
  [1676] = 976,
  [1677] = 977,
  [1678] = 978,
  [1679] = 977,
  [1680] = 978,
  [1681] = 976,
  [1682] = 975,
  [1683] = 991,
  [1684] = 944,
  [1685] = 971,
  [1686] = 970,
  [1687] = 968,
  [1688] = 963,
  [1689] = 962,
  [1690] = 945,
  [1691] = 913,
  [1692] = 919,
  [1693] = 912,
  [1694] = 917,
  [1695] = 942,
  [1696] = 991,
  [1697] = 944,
  [1698] = 991,
  [1699] = 978,
  [1700] = 977,
  [1701] = 976,
  [1702] = 975,
  [1703] = 971,
  [1704] = 970,
  [1705] = 943,
  [1706] = 968,
  [1707] = 963,
  [1708] = 962,
  [1709] = 945,
  [1710] = 942,
  [1711] = 917,
  [1712] = 912,
  [1713] = 913,
  [1714] = 919,
  [1715] = 912,
  [1716] = 917,
  [1717] = 942,
  [1718] = 944,
  [1719] = 991,
  [1720] = 978,
  [1721] = 977,
  [1722] = 976,
  [1723] = 919,
  [1724] = 913,
  [1725] = 945,
  [1726] = 962,
  [1727] = 975,
  [1728] = 971,
  [1729] = 970,
  [1730] = 968,
  [1731] = 963,
  [1732] = 962,
  [1733] = 945,
  [1734] = 913,
  [1735] = 919,
  [1736] = 912,
  [1737] = 917,
  [1738] = 916,
  [1739] = 915,
  [1740] = 942,
  [1741] = 943,
  [1742] = 944,
  [1743] = 992,
  [1744] = 991,
  [1745] = 963,
  [1746] = 968,
  [1747] = 978,
  [1748] = 977,
  [1749] = 976,
  [1750] = 970,
  [1751] = 975,
  [1752] = 971,
  [1753] = 970,
  [1754] = 968,
  [1755] = 963,
  [1756] = 944,
  [1757] = 962,
  [1758] = 971,
  [1759] = 943,
  [1760] = 942,
  [1761] = 945,
  [1762] = 1762,
  [1763] = 913,
  [1764] = 919,
  [1765] = 912,
  [1766] = 917,
  [1767] = 916,
  [1768] = 915,
  [1769] = 942,
  [1770] = 944,
  [1771] = 974,
  [1772] = 991,
  [1773] = 978,
  [1774] = 977,
  [1775] = 976,
  [1776] = 975,
  [1777] = 971,
  [1778] = 970,
  [1779] = 968,
  [1780] = 963,
  [1781] = 962,
  [1782] = 945,
  [1783] = 913,
  [1784] = 919,
  [1785] = 912,
  [1786] = 917,
  [1787] = 942,
  [1788] = 944,
  [1789] = 975,
  [1790] = 976,
  [1791] = 991,
  [1792] = 978,
  [1793] = 977,
  [1794] = 976,
  [1795] = 975,
  [1796] = 971,
  [1797] = 970,
  [1798] = 968,
  [1799] = 963,
  [1800] = 962,
  [1801] = 977,
  [1802] = 978,
  [1803] = 945,
  [1804] = 913,
  [1805] = 919,
  [1806] = 912,
  [1807] = 991,
  [1808] = 917,
  [1809] = 942,
  [1810] = 944,
  [1811] = 991,
  [1812] = 978,
  [1813] = 977,
  [1814] = 976,
  [1815] = 975,
  [1816] = 971,
  [1817] = 970,
  [1818] = 917,
  [1819] = 912,
  [1820] = 919,
  [1821] = 913,
  [1822] = 968,
  [1823] = 944,
  [1824] = 963,
  [1825] = 942,
  [1826] = 944,
  [1827] = 943,
  [1828] = 942,
  [1829] = 917,
  [1830] = 962,
  [1831] = 945,
  [1832] = 912,
  [1833] = 919,
  [1834] = 913,
  [1835] = 913,
  [1836] = 945,
  [1837] = 962,
  [1838] = 963,
  [1839] = 968,
  [1840] = 919,
  [1841] = 970,
  [1842] = 971,
  [1843] = 975,
  [1844] = 976,
  [1845] = 977,
  [1846] = 978,
  [1847] = 912,
  [1848] = 917,
  [1849] = 942,
  [1850] = 944,
  [1851] = 992,
  [1852] = 991,
  [1853] = 945,
  [1854] = 978,
  [1855] = 977,
  [1856] = 976,
  [1857] = 975,
  [1858] = 974,
  [1859] = 971,
  [1860] = 970,
  [1861] = 968,
  [1862] = 991,
  [1863] = 963,
  [1864] = 962,
  [1865] = 945,
  [1866] = 913,
  [1867] = 919,
  [1868] = 912,
  [1869] = 917,
  [1870] = 916,
  [1871] = 915,
  [1872] = 942,
  [1873] = 943,
  [1874] = 944,
  [1875] = 992,
  [1876] = 991,
  [1877] = 978,
  [1878] = 977,
  [1879] = 976,
  [1880] = 975,
  [1881] = 971,
  [1882] = 970,
  [1883] = 968,
  [1884] = 963,
  [1885] = 962,
  [1886] = 962,
  [1887] = 945,
  [1888] = 1015,
  [1889] = 913,
  [1890] = 919,
  [1891] = 912,
  [1892] = 917,
  [1893] = 916,
  [1894] = 915,
  [1895] = 942,
  [1896] = 944,
  [1897] = 991,
  [1898] = 978,
  [1899] = 977,
  [1900] = 976,
  [1901] = 975,
  [1902] = 971,
  [1903] = 970,
  [1904] = 968,
  [1905] = 963,
  [1906] = 1906,
  [1907] = 1907,
  [1908] = 1908,
  [1909] = 1909,
  [1910] = 1910,
  [1911] = 1910,
  [1912] = 1912,
  [1913] = 1913,
  [1914] = 1914,
  [1915] = 1915,
  [1916] = 1916,
  [1917] = 1160,
  [1918] = 1160,
  [1919] = 1907,
  [1920] = 1914,
  [1921] = 1906,
  [1922] = 1908,
  [1923] = 1910,
  [1924] = 1909,
  [1925] = 1915,
  [1926] = 1912,
  [1927] = 1910,
  [1928] = 1913,
  [1929] = 1160,
  [1930] = 1930,
  [1931] = 1931,
  [1932] = 1916,
  [1933] = 1160,
  [1934] = 1160,
  [1935] = 1910,
  [1936] = 1160,
  [1937] = 1160,
  [1938] = 1910,
  [1939] = 1939,
  [1940] = 1160,
  [1941] = 1160,
  [1942] = 1913,
  [1943] = 1915,
  [1944] = 1910,
  [1945] = 1945,
  [1946] = 1906,
  [1947] = 1907,
  [1948] = 1912,
  [1949] = 1908,
  [1950] = 1910,
  [1951] = 1909,
  [1952] = 1910,
  [1953] = 1914,
  [1954] = 1160,
  [1955] = 1160,
  [1956] = 1956,
  [1957] = 1931,
  [1958] = 1916,
  [1959] = 1959,
  [1960] = 1960,
  [1961] = 1961,
  [1962] = 1962,
  [1963] = 1963,
  [1964] = 1963,
  [1965] = 1963,
  [1966] = 1962,
  [1967] = 1961,
  [1968] = 1906,
  [1969] = 1915,
  [1970] = 1908,
  [1971] = 1909,
  [1972] = 1972,
  [1973] = 1973,
  [1974] = 1974,
  [1975] = 1974,
  [1976] = 1974,
  [1977] = 1977,
  [1978] = 1978,
  [1979] = 1961,
  [1980] = 1962,
  [1981] = 1962,
  [1982] = 1906,
  [1983] = 1978,
  [1984] = 1915,
  [1985] = 1978,
  [1986] = 1961,
  [1987] = 1909,
  [1988] = 1908,
  [1989] = 1962,
  [1990] = 1962,
  [1991] = 1962,
  [1992] = 1961,
  [1993] = 1962,
  [1994] = 1961,
  [1995] = 1962,
  [1996] = 1906,
  [1997] = 1961,
  [1998] = 1915,
  [1999] = 1962,
  [2000] = 1961,
  [2001] = 1961,
  [2002] = 1961,
  [2003] = 1961,
  [2004] = 1962,
  [2005] = 1908,
  [2006] = 1962,
  [2007] = 1962,
  [2008] = 1961,
  [2009] = 1961,
  [2010] = 1909,
  [2011] = 2011,
  [2012] = 2012,
  [2013] = 2013,
  [2014] = 2014,
  [2015] = 2015,
  [2016] = 2014,
  [2017] = 2015,
  [2018] = 2018,
  [2019] = 2019,
  [2020] = 2019,
  [2021] = 2019,
  [2022] = 2018,
  [2023] = 2018,
  [2024] = 2024,
  [2025] = 2019,
  [2026] = 2011,
  [2027] = 2018,
  [2028] = 2018,
  [2029] = 2019,
  [2030] = 1915,
  [2031] = 2012,
  [2032] = 1908,
  [2033] = 1906,
  [2034] = 2034,
  [2035] = 1907,
  [2036] = 1909,
  [2037] = 2013,
  [2038] = 2011,
  [2039] = 1910,
  [2040] = 2040,
  [2041] = 2041,
  [2042] = 2040,
  [2043] = 2043,
  [2044] = 2043,
  [2045] = 2011,
  [2046] = 2011,
  [2047] = 2013,
  [2048] = 2012,
  [2049] = 2049,
  [2050] = 2050,
  [2051] = 1915,
  [2052] = 1906,
  [2053] = 2053,
  [2054] = 2054,
  [2055] = 2055,
  [2056] = 1907,
  [2057] = 2057,
  [2058] = 1909,
  [2059] = 2053,
  [2060] = 2055,
  [2061] = 2034,
  [2062] = 2062,
  [2063] = 1908,
  [2064] = 2013,
  [2065] = 1910,
  [2066] = 2013,
  [2067] = 2012,
  [2068] = 1907,
  [2069] = 1913,
  [2070] = 1914,
  [2071] = 2071,
  [2072] = 1915,
  [2073] = 1931,
  [2074] = 1906,
  [2075] = 1910,
  [2076] = 1908,
  [2077] = 1909,
  [2078] = 1912,
  [2079] = 2012,
  [2080] = 2080,
  [2081] = 2081,
  [2082] = 2082,
  [2083] = 2083,
  [2084] = 2049,
  [2085] = 2085,
  [2086] = 2086,
  [2087] = 2087,
  [2088] = 2088,
  [2089] = 2089,
  [2090] = 2090,
  [2091] = 2091,
  [2092] = 2092,
  [2093] = 2093,
  [2094] = 2093,
  [2095] = 2095,
  [2096] = 2096,
  [2097] = 2097,
  [2098] = 2098,
  [2099] = 2099,
  [2100] = 2100,
  [2101] = 2101,
  [2102] = 2102,
  [2103] = 2103,
  [2104] = 2104,
  [2105] = 1906,
  [2106] = 1915,
  [2107] = 1908,
  [2108] = 2108,
  [2109] = 1909,
  [2110] = 2110,
  [2111] = 2111,
  [2112] = 2034,
  [2113] = 1907,
  [2114] = 2114,
  [2115] = 2115,
  [2116] = 2116,
  [2117] = 2117,
  [2118] = 2118,
  [2119] = 2119,
  [2120] = 2120,
  [2121] = 2121,
  [2122] = 2122,
  [2123] = 2123,
  [2124] = 2124,
  [2125] = 2125,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 2119,
  [2129] = 2129,
  [2130] = 2041,
  [2131] = 2119,
  [2132] = 2132,
  [2133] = 2057,
  [2134] = 2119,
  [2135] = 2132,
  [2136] = 2132,
  [2137] = 2132,
  [2138] = 2132,
  [2139] = 2118,
  [2140] = 2062,
  [2141] = 2119,
  [2142] = 2118,
  [2143] = 2054,
  [2144] = 2119,
  [2145] = 2118,
  [2146] = 2071,
  [2147] = 2123,
  [2148] = 2116,
  [2149] = 2149,
  [2150] = 2117,
  [2151] = 2122,
  [2152] = 2125,
  [2153] = 2149,
  [2154] = 2149,
  [2155] = 2155,
  [2156] = 2124,
  [2157] = 2129,
  [2158] = 2126,
  [2159] = 2127,
  [2160] = 2114,
  [2161] = 2155,
  [2162] = 2149,
  [2163] = 2121,
  [2164] = 2120,
  [2165] = 2149,
  [2166] = 2119,
  [2167] = 2119,
  [2168] = 2118,
  [2169] = 2169,
  [2170] = 2071,
  [2171] = 2108,
  [2172] = 2043,
  [2173] = 2040,
  [2174] = 1931,
  [2175] = 2118,
  [2176] = 2108,
  [2177] = 2119,
  [2178] = 2118,
  [2179] = 2118,
  [2180] = 2055,
  [2181] = 2119,
  [2182] = 2053,
  [2183] = 2119,
  [2184] = 2119,
  [2185] = 2050,
  [2186] = 2186,
  [2187] = 2187,
  [2188] = 2186,
  [2189] = 2186,
  [2190] = 2050,
  [2191] = 2187,
  [2192] = 1910,
  [2193] = 2055,
  [2194] = 1931,
  [2195] = 2186,
  [2196] = 2186,
  [2197] = 2053,
  [2198] = 2118,
  [2199] = 2043,
  [2200] = 1910,
  [2201] = 2201,
  [2202] = 2202,
  [2203] = 1912,
  [2204] = 1907,
  [2205] = 2205,
  [2206] = 2119,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 1906,
  [2210] = 2119,
  [2211] = 1915,
  [2212] = 2119,
  [2213] = 2119,
  [2214] = 2118,
  [2215] = 2118,
  [2216] = 1908,
  [2217] = 1909,
  [2218] = 1913,
  [2219] = 2040,
  [2220] = 1914,
  [2221] = 2221,
  [2222] = 2102,
  [2223] = 2071,
  [2224] = 2086,
  [2225] = 2225,
  [2226] = 2101,
  [2227] = 2092,
  [2228] = 2081,
  [2229] = 2090,
  [2230] = 2088,
  [2231] = 2231,
  [2232] = 2095,
  [2233] = 2233,
  [2234] = 2091,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 1915,
  [2238] = 2089,
  [2239] = 1906,
  [2240] = 2087,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2049,
  [2244] = 2071,
  [2245] = 2050,
  [2246] = 2246,
  [2247] = 2080,
  [2248] = 2103,
  [2249] = 2249,
  [2250] = 2100,
  [2251] = 2099,
  [2252] = 2098,
  [2253] = 2097,
  [2254] = 2096,
  [2255] = 2235,
  [2256] = 2246,
  [2257] = 2257,
  [2258] = 2241,
  [2259] = 2082,
  [2260] = 2083,
  [2261] = 2085,
  [2262] = 2262,
  [2263] = 2055,
  [2264] = 1908,
  [2265] = 2053,
  [2266] = 1909,
  [2267] = 2118,
  [2268] = 2169,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2071,
  [2272] = 2087,
  [2273] = 2273,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2276,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 2279,
  [2280] = 2118,
  [2281] = 2275,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 2284,
  [2285] = 2285,
  [2286] = 2119,
  [2287] = 2287,
  [2288] = 2288,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2119,
  [2297] = 2297,
  [2298] = 2095,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 2088,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2307,
  [2308] = 2103,
  [2309] = 2108,
  [2310] = 2310,
  [2311] = 2101,
  [2312] = 2312,
  [2313] = 2119,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2099,
  [2327] = 2100,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2083,
  [2332] = 2332,
  [2333] = 2333,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2341,
  [2342] = 2098,
  [2343] = 2343,
  [2344] = 2344,
  [2345] = 2345,
  [2346] = 2346,
  [2347] = 2347,
  [2348] = 2348,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 2351,
  [2352] = 2352,
  [2353] = 2353,
  [2354] = 2354,
  [2355] = 2082,
  [2356] = 2356,
  [2357] = 2357,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 2362,
  [2363] = 2363,
  [2364] = 2364,
  [2365] = 2365,
  [2366] = 2366,
  [2367] = 2367,
  [2368] = 2368,
  [2369] = 2092,
  [2370] = 2370,
  [2371] = 2119,
  [2372] = 2081,
  [2373] = 2275,
  [2374] = 2374,
  [2375] = 2375,
  [2376] = 2119,
  [2377] = 2377,
  [2378] = 2378,
  [2379] = 2379,
  [2380] = 2380,
  [2381] = 2381,
  [2382] = 2119,
  [2383] = 2383,
  [2384] = 2384,
  [2385] = 2385,
  [2386] = 2386,
  [2387] = 2387,
  [2388] = 2388,
  [2389] = 2080,
  [2390] = 2390,
  [2391] = 2090,
  [2392] = 2392,
  [2393] = 2393,
  [2394] = 2097,
  [2395] = 2395,
  [2396] = 2096,
  [2397] = 2397,
  [2398] = 2398,
  [2399] = 2399,
  [2400] = 2400,
  [2401] = 2401,
  [2402] = 2402,
  [2403] = 2403,
  [2404] = 2404,
  [2405] = 1931,
  [2406] = 2406,
  [2407] = 2407,
  [2408] = 1910,
  [2409] = 2409,
  [2410] = 2410,
  [2411] = 2411,
  [2412] = 2412,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 2415,
  [2416] = 2416,
  [2417] = 2417,
  [2418] = 2418,
  [2419] = 2108,
  [2420] = 2420,
  [2421] = 2421,
  [2422] = 2102,
  [2423] = 2423,
  [2424] = 2424,
  [2425] = 2425,
  [2426] = 2426,
  [2427] = 2427,
  [2428] = 2428,
  [2429] = 2429,
  [2430] = 2430,
  [2431] = 2431,
  [2432] = 2432,
  [2433] = 2433,
  [2434] = 2118,
  [2435] = 2435,
  [2436] = 2436,
  [2437] = 2437,
  [2438] = 2108,
  [2439] = 2119,
  [2440] = 2119,
  [2441] = 1930,
  [2442] = 2087,
  [2443] = 2262,
  [2444] = 2118,
  [2445] = 2118,
  [2446] = 2118,
  [2447] = 2119,
  [2448] = 2118,
  [2449] = 2119,
  [2450] = 2450,
  [2451] = 2118,
  [2452] = 2118,
  [2453] = 2450,
  [2454] = 2450,
  [2455] = 2450,
  [2456] = 2450,
  [2457] = 2118,
  [2458] = 2050,
  [2459] = 2459,
  [2460] = 2450,
  [2461] = 1931,
  [2462] = 2450,
  [2463] = 2450,
  [2464] = 2464,
  [2465] = 2344,
  [2466] = 2119,
  [2467] = 2450,
  [2468] = 2450,
  [2469] = 2450,
  [2470] = 2450,
  [2471] = 2450,
  [2472] = 2450,
  [2473] = 2473,
  [2474] = 2450,
  [2475] = 2119,
  [2476] = 2450,
  [2477] = 2477,
  [2478] = 2450,
  [2479] = 2450,
  [2480] = 2480,
  [2481] = 2119,
  [2482] = 2450,
  [2483] = 2450,
  [2484] = 2450,
  [2485] = 2119,
  [2486] = 2486,
  [2487] = 2450,
  [2488] = 2450,
  [2489] = 2450,
  [2490] = 2490,
  [2491] = 2491,
  [2492] = 2492,
  [2493] = 2493,
  [2494] = 2494,
  [2495] = 2495,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2119,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 2118,
  [2504] = 2504,
  [2505] = 2118,
  [2506] = 2506,
  [2507] = 2507,
  [2508] = 2508,
  [2509] = 2498,
  [2510] = 1160,
  [2511] = 2511,
  [2512] = 2119,
  [2513] = 2513,
  [2514] = 2514,
  [2515] = 2515,
  [2516] = 2118,
  [2517] = 2517,
  [2518] = 2518,
  [2519] = 2519,
  [2520] = 1939,
  [2521] = 2521,
  [2522] = 2522,
  [2523] = 2344,
  [2524] = 2486,
  [2525] = 2119,
  [2526] = 2118,
  [2527] = 2119,
  [2528] = 2347,
  [2529] = 2337,
  [2530] = 2341,
  [2531] = 2119,
  [2532] = 2119,
  [2533] = 2304,
  [2534] = 2480,
  [2535] = 2119,
  [2536] = 2169,
  [2537] = 2416,
  [2538] = 2119,
  [2539] = 2429,
  [2540] = 2464,
  [2541] = 2332,
  [2542] = 2464,
  [2543] = 2473,
  [2544] = 2262,
  [2545] = 2486,
  [2546] = 2522,
  [2547] = 2521,
  [2548] = 2492,
  [2549] = 2498,
  [2550] = 2119,
  [2551] = 2499,
  [2552] = 2269,
  [2553] = 2502,
  [2554] = 2496,
  [2555] = 2501,
  [2556] = 2119,
  [2557] = 2506,
  [2558] = 2518,
  [2559] = 2507,
  [2560] = 2508,
  [2561] = 2344,
  [2562] = 2514,
  [2563] = 2497,
  [2564] = 2495,
  [2565] = 2494,
  [2566] = 2493,
  [2567] = 2490,
  [2568] = 2504,
  [2569] = 2511,
  [2570] = 2491,
  [2571] = 2087,
  [2572] = 2498,
  [2573] = 2519,
  [2574] = 2119,
  [2575] = 2119,
  [2576] = 2513,
  [2577] = 2515,
  [2578] = 2578,
  [2579] = 2480,
  [2580] = 2521,
  [2581] = 2578,
  [2582] = 2582,
  [2583] = 2582,
  [2584] = 2582,
  [2585] = 2582,
  [2586] = 2578,
  [2587] = 2169,
  [2588] = 2578,
  [2589] = 2578,
  [2590] = 2582,
  [2591] = 2582,
  [2592] = 2578,
  [2593] = 2578,
  [2594] = 2496,
  [2595] = 2508,
  [2596] = 2582,
  [2597] = 2515,
  [2598] = 2582,
  [2599] = 2513,
  [2600] = 2582,
  [2601] = 2601,
  [2602] = 2578,
  [2603] = 2582,
  [2604] = 2578,
  [2605] = 2495,
  [2606] = 2578,
  [2607] = 2518,
  [2608] = 2494,
  [2609] = 2493,
  [2610] = 2490,
  [2611] = 2582,
  [2612] = 2582,
  [2613] = 2578,
  [2614] = 2504,
  [2615] = 2511,
  [2616] = 2582,
  [2617] = 2582,
  [2618] = 2578,
  [2619] = 2497,
  [2620] = 2578,
  [2621] = 2491,
  [2622] = 2582,
  [2623] = 2578,
  [2624] = 2578,
  [2625] = 2578,
  [2626] = 2578,
  [2627] = 2582,
  [2628] = 2501,
  [2629] = 2582,
  [2630] = 2578,
  [2631] = 2578,
  [2632] = 2582,
  [2633] = 2514,
  [2634] = 2492,
  [2635] = 2582,
  [2636] = 2578,
  [2637] = 2119,
  [2638] = 2169,
  [2639] = 2119,
  [2640] = 2578,
  [2641] = 2522,
  [2642] = 2498,
  [2643] = 2119,
  [2644] = 2578,
  [2645] = 2582,
  [2646] = 2464,
  [2647] = 2578,
  [2648] = 2473,
  [2649] = 2519,
  [2650] = 2119,
  [2651] = 2582,
  [2652] = 2582,
  [2653] = 2498,
  [2654] = 2506,
  [2655] = 2262,
  [2656] = 2486,
  [2657] = 2507,
  [2658] = 2582,
  [2659] = 2578,
  [2660] = 2582,
  [2661] = 2502,
  [2662] = 2497,
  [2663] = 2480,
  [2664] = 2464,
  [2665] = 2665,
  [2666] = 2666,
  [2667] = 2667,
  [2668] = 2668,
  [2669] = 2515,
  [2670] = 2670,
  [2671] = 2671,
  [2672] = 2672,
  [2673] = 2513,
  [2674] = 2473,
  [2675] = 2675,
  [2676] = 2668,
  [2677] = 2677,
  [2678] = 2514,
  [2679] = 2666,
  [2680] = 2508,
  [2681] = 2518,
  [2682] = 2677,
  [2683] = 2499,
  [2684] = 2507,
  [2685] = 2506,
  [2686] = 2501,
  [2687] = 2687,
  [2688] = 2496,
  [2689] = 2689,
  [2690] = 2519,
  [2691] = 2521,
  [2692] = 2486,
  [2693] = 2522,
  [2694] = 2491,
  [2695] = 2675,
  [2696] = 2511,
  [2697] = 2504,
  [2698] = 2490,
  [2699] = 2493,
  [2700] = 2494,
  [2701] = 2495,
  [2702] = 2504,
  [2703] = 2514,
  [2704] = 2187,
  [2705] = 2486,
  [2706] = 2477,
  [2707] = 2492,
  [2708] = 2493,
  [2709] = 2511,
  [2710] = 2491,
  [2711] = 2522,
  [2712] = 2521,
  [2713] = 2519,
  [2714] = 2494,
  [2715] = 2495,
  [2716] = 2515,
  [2717] = 2464,
  [2718] = 2497,
  [2719] = 2498,
  [2720] = 2473,
  [2721] = 2502,
  [2722] = 2722,
  [2723] = 2490,
  [2724] = 2344,
  [2725] = 2725,
  [2726] = 2726,
  [2727] = 2499,
  [2728] = 2480,
  [2729] = 2729,
  [2730] = 2262,
  [2731] = 2731,
  [2732] = 2601,
  [2733] = 2486,
  [2734] = 2498,
  [2735] = 2464,
  [2736] = 2601,
  [2737] = 2459,
  [2738] = 2518,
  [2739] = 2508,
  [2740] = 2507,
  [2741] = 2506,
  [2742] = 2501,
  [2743] = 2496,
  [2744] = 2513,
  [2745] = 2670,
  [2746] = 2504,
  [2747] = 2672,
  [2748] = 2513,
  [2749] = 2490,
  [2750] = 2493,
  [2751] = 2494,
  [2752] = 2519,
  [2753] = 2495,
  [2754] = 2497,
  [2755] = 2464,
  [2756] = 2486,
  [2757] = 2671,
  [2758] = 2521,
  [2759] = 2522,
  [2760] = 2687,
  [2761] = 2491,
  [2762] = 2508,
  [2763] = 2518,
  [2764] = 2507,
  [2765] = 2511,
  [2766] = 2486,
  [2767] = 2506,
  [2768] = 2515,
  [2769] = 2501,
  [2770] = 2496,
  [2771] = 2514,
  [2772] = 2464,
  [2773] = 2201,
  [2774] = 2262,
  [2775] = 2665,
  [2776] = 2269,
  [2777] = 2499,
  [2778] = 2502,
  [2779] = 2473,
  [2780] = 2689,
  [2781] = 2480,
  [2782] = 2672,
  [2783] = 2519,
  [2784] = 2508,
  [2785] = 2518,
  [2786] = 2515,
  [2787] = 2726,
  [2788] = 2722,
  [2789] = 2241,
  [2790] = 2205,
  [2791] = 2725,
  [2792] = 2497,
  [2793] = 2519,
  [2794] = 2521,
  [2795] = 2515,
  [2796] = 2522,
  [2797] = 2491,
  [2798] = 2670,
  [2799] = 2511,
  [2800] = 2504,
  [2801] = 2344,
  [2802] = 2490,
  [2803] = 2493,
  [2804] = 2498,
  [2805] = 2494,
  [2806] = 2495,
  [2807] = 2492,
  [2808] = 2507,
  [2809] = 2665,
  [2810] = 2506,
  [2811] = 2497,
  [2812] = 2208,
  [2813] = 2495,
  [2814] = 2514,
  [2815] = 2494,
  [2816] = 2208,
  [2817] = 2498,
  [2818] = 2493,
  [2819] = 2490,
  [2820] = 2201,
  [2821] = 2729,
  [2822] = 2689,
  [2823] = 2242,
  [2824] = 2513,
  [2825] = 2731,
  [2826] = 2502,
  [2827] = 2504,
  [2828] = 2511,
  [2829] = 2491,
  [2830] = 2513,
  [2831] = 2499,
  [2832] = 2522,
  [2833] = 2521,
  [2834] = 2246,
  [2835] = 2508,
  [2836] = 2501,
  [2837] = 2496,
  [2838] = 2207,
  [2839] = 2225,
  [2840] = 2518,
  [2841] = 2233,
  [2842] = 2514,
  [2843] = 2507,
  [2844] = 2506,
  [2845] = 2501,
  [2846] = 2496,
  [2847] = 2221,
  [2848] = 2235,
  [2849] = 2671,
  [2850] = 2249,
  [2851] = 2236,
  [2852] = 2202,
  [2853] = 2522,
  [2854] = 2508,
  [2855] = 2491,
  [2856] = 2515,
  [2857] = 2492,
  [2858] = 2511,
  [2859] = 2519,
  [2860] = 2513,
  [2861] = 2504,
  [2862] = 1909,
  [2863] = 2464,
  [2864] = 2262,
  [2865] = 2490,
  [2866] = 2498,
  [2867] = 2473,
  [2868] = 2473,
  [2869] = 1908,
  [2870] = 2493,
  [2871] = 2494,
  [2872] = 2495,
  [2873] = 2486,
  [2874] = 2187,
  [2875] = 2601,
  [2876] = 2257,
  [2877] = 2480,
  [2878] = 1915,
  [2879] = 1906,
  [2880] = 2486,
  [2881] = 2722,
  [2882] = 2521,
  [2883] = 2497,
  [2884] = 2518,
  [2885] = 2262,
  [2886] = 2496,
  [2887] = 2501,
  [2888] = 2231,
  [2889] = 2498,
  [2890] = 2486,
  [2891] = 2275,
  [2892] = 2464,
  [2893] = 2480,
  [2894] = 2275,
  [2895] = 2507,
  [2896] = 2270,
  [2897] = 2464,
  [2898] = 2506,
  [2899] = 2514,
  [2900] = 2501,
  [2901] = 2508,
  [2902] = 2292,
  [2903] = 2375,
  [2904] = 2366,
  [2905] = 2354,
  [2906] = 2334,
  [2907] = 2299,
  [2908] = 2287,
  [2909] = 2499,
  [2910] = 2082,
  [2911] = 2393,
  [2912] = 2307,
  [2913] = 2282,
  [2914] = 2208,
  [2915] = 2501,
  [2916] = 2496,
  [2917] = 2687,
  [2918] = 2506,
  [2919] = 2437,
  [2920] = 2507,
  [2921] = 2290,
  [2922] = 2370,
  [2923] = 2297,
  [2924] = 2665,
  [2925] = 2322,
  [2926] = 2328,
  [2927] = 2417,
  [2928] = 2340,
  [2929] = 2388,
  [2930] = 2518,
  [2931] = 2353,
  [2932] = 2521,
  [2933] = 2522,
  [2934] = 2491,
  [2935] = 2400,
  [2936] = 2284,
  [2937] = 2349,
  [2938] = 2436,
  [2939] = 2499,
  [2940] = 2502,
  [2941] = 2511,
  [2942] = 2401,
  [2943] = 2504,
  [2944] = 2490,
  [2945] = 2330,
  [2946] = 2269,
  [2947] = 2348,
  [2948] = 2493,
  [2949] = 2494,
  [2950] = 2096,
  [2951] = 2495,
  [2952] = 2314,
  [2953] = 2305,
  [2954] = 2352,
  [2955] = 2399,
  [2956] = 2497,
  [2957] = 2492,
  [2958] = 2097,
  [2959] = 2362,
  [2960] = 2420,
  [2961] = 2098,
  [2962] = 2099,
  [2963] = 2671,
  [2964] = 2344,
  [2965] = 2384,
  [2966] = 2670,
  [2967] = 2300,
  [2968] = 2515,
  [2969] = 2513,
  [2970] = 2100,
  [2971] = 2385,
  [2972] = 2359,
  [2973] = 2386,
  [2974] = 2358,
  [2975] = 2667,
  [2976] = 2380,
  [2977] = 2346,
  [2978] = 2498,
  [2979] = 2672,
  [2980] = 2431,
  [2981] = 2515,
  [2982] = 2519,
  [2983] = 2332,
  [2984] = 2398,
  [2985] = 2273,
  [2986] = 2521,
  [2987] = 2522,
  [2988] = 2491,
  [2989] = 2511,
  [2990] = 2508,
  [2991] = 2504,
  [2992] = 2490,
  [2993] = 2493,
  [2994] = 2494,
  [2995] = 2495,
  [2996] = 2513,
  [2997] = 2519,
  [2998] = 2341,
  [2999] = 2497,
  [3000] = 2101,
  [3001] = 2507,
  [3002] = 2506,
  [3003] = 2320,
  [3004] = 2336,
  [3005] = 2279,
  [3006] = 2514,
  [3007] = 2295,
  [3008] = 2350,
  [3009] = 2514,
  [3010] = 2277,
  [3011] = 2518,
  [3012] = 2403,
  [3013] = 2289,
  [3014] = 2283,
  [3015] = 2410,
  [3016] = 2407,
  [3017] = 2413,
  [3018] = 2496,
  [3019] = 2498,
  [3020] = 2416,
  [3021] = 2435,
  [3022] = 2424,
  [3023] = 2333,
  [3024] = 2411,
  [3025] = 2415,
  [3026] = 2262,
  [3027] = 2338,
  [3028] = 2418,
  [3029] = 2425,
  [3030] = 2310,
  [3031] = 2293,
  [3032] = 2285,
  [3033] = 2432,
  [3034] = 2304,
  [3035] = 2294,
  [3036] = 2427,
  [3037] = 2337,
  [3038] = 2324,
  [3039] = 2428,
  [3040] = 2303,
  [3041] = 2347,
  [3042] = 2357,
  [3043] = 2414,
  [3044] = 2378,
  [3045] = 2406,
  [3046] = 2404,
  [3047] = 2423,
  [3048] = 2302,
  [3049] = 2351,
  [3050] = 2278,
  [3051] = 2083,
  [3052] = 2201,
  [3053] = 2412,
  [3054] = 2088,
  [3055] = 2363,
  [3056] = 2325,
  [3057] = 2430,
  [3058] = 2433,
  [3059] = 2080,
  [3060] = 2276,
  [3061] = 2502,
  [3062] = 2090,
  [3063] = 2081,
  [3064] = 2381,
  [3065] = 2092,
  [3066] = 2397,
  [3067] = 2361,
  [3068] = 2395,
  [3069] = 2344,
  [3070] = 2390,
  [3071] = 2360,
  [3072] = 2335,
  [3073] = 2315,
  [3074] = 2323,
  [3075] = 2402,
  [3076] = 2321,
  [3077] = 2274,
  [3078] = 2383,
  [3079] = 2319,
  [3080] = 2379,
  [3081] = 2318,
  [3082] = 2368,
  [3083] = 2367,
  [3084] = 2365,
  [3085] = 2409,
  [3086] = 2269,
  [3087] = 2364,
  [3088] = 2329,
  [3089] = 2288,
  [3090] = 2339,
  [3091] = 2317,
  [3092] = 2316,
  [3093] = 2312,
  [3094] = 2689,
  [3095] = 2374,
  [3096] = 2377,
  [3097] = 2306,
  [3098] = 2387,
  [3099] = 2392,
  [3100] = 2426,
  [3101] = 2103,
  [3102] = 2095,
  [3103] = 2291,
  [3104] = 2102,
  [3105] = 2429,
  [3106] = 2246,
  [3107] = 2473,
  [3108] = 2345,
  [3109] = 2514,
  [3110] = 2356,
  [3111] = 2515,
  [3112] = 2519,
  [3113] = 2521,
  [3114] = 2343,
  [3115] = 2522,
  [3116] = 2491,
  [3117] = 2486,
  [3118] = 2601,
  [3119] = 2421,
  [3120] = 2513,
  [3121] = 2464,
  [3122] = 2511,
  [3123] = 2518,
  [3124] = 2356,
  [3125] = 2504,
  [3126] = 2508,
  [3127] = 2262,
  [3128] = 2507,
  [3129] = 2506,
  [3130] = 2501,
  [3131] = 2496,
  [3132] = 2490,
  [3133] = 2464,
  [3134] = 2493,
  [3135] = 2494,
  [3136] = 2480,
  [3137] = 2345,
  [3138] = 2241,
  [3139] = 2495,
  [3140] = 2498,
  [3141] = 2497,
  [3142] = 2492,
  [3143] = 2464,
  [3144] = 2601,
  [3145] = 2486,
  [3146] = 2262,
  [3147] = 2498,
  [3148] = 2498,
  [3149] = 2421,
  [3150] = 2235,
  [3151] = 2269,
  [3152] = 2343,
  [3153] = 3153,
  [3154] = 2689,
  [3155] = 3155,
  [3156] = 2496,
  [3157] = 2501,
  [3158] = 2515,
  [3159] = 2731,
  [3160] = 3155,
  [3161] = 2486,
  [3162] = 2492,
  [3163] = 3155,
  [3164] = 3155,
  [3165] = 2687,
  [3166] = 3155,
  [3167] = 3153,
  [3168] = 2344,
  [3169] = 2473,
  [3170] = 2344,
  [3171] = 2670,
  [3172] = 2722,
  [3173] = 3153,
  [3174] = 3155,
  [3175] = 2521,
  [3176] = 2506,
  [3177] = 2486,
  [3178] = 2473,
  [3179] = 2464,
  [3180] = 3155,
  [3181] = 2507,
  [3182] = 2665,
  [3183] = 2486,
  [3184] = 2262,
  [3185] = 3155,
  [3186] = 3153,
  [3187] = 3153,
  [3188] = 2508,
  [3189] = 2518,
  [3190] = 2518,
  [3191] = 2514,
  [3192] = 2497,
  [3193] = 3153,
  [3194] = 3153,
  [3195] = 3155,
  [3196] = 3155,
  [3197] = 3197,
  [3198] = 3153,
  [3199] = 3155,
  [3200] = 2495,
  [3201] = 3155,
  [3202] = 2464,
  [3203] = 2494,
  [3204] = 3155,
  [3205] = 2493,
  [3206] = 2490,
  [3207] = 3153,
  [3208] = 2473,
  [3209] = 2262,
  [3210] = 2504,
  [3211] = 2725,
  [3212] = 2511,
  [3213] = 3153,
  [3214] = 3153,
  [3215] = 3155,
  [3216] = 2491,
  [3217] = 2522,
  [3218] = 2513,
  [3219] = 3155,
  [3220] = 2672,
  [3221] = 3155,
  [3222] = 2480,
  [3223] = 2671,
  [3224] = 2464,
  [3225] = 3153,
  [3226] = 3155,
  [3227] = 2502,
  [3228] = 2729,
  [3229] = 2480,
  [3230] = 2726,
  [3231] = 2464,
  [3232] = 2499,
  [3233] = 2480,
  [3234] = 2519,
  [3235] = 2501,
  [3236] = 2519,
  [3237] = 2494,
  [3238] = 2495,
  [3239] = 2495,
  [3240] = 2494,
  [3241] = 2497,
  [3242] = 2493,
  [3243] = 1908,
  [3244] = 2490,
  [3245] = 1909,
  [3246] = 2507,
  [3247] = 2490,
  [3248] = 2504,
  [3249] = 2511,
  [3250] = 2491,
  [3251] = 2275,
  [3252] = 2508,
  [3253] = 2522,
  [3254] = 2521,
  [3255] = 2519,
  [3256] = 2496,
  [3257] = 2501,
  [3258] = 2506,
  [3259] = 2507,
  [3260] = 2508,
  [3261] = 2514,
  [3262] = 3262,
  [3263] = 2513,
  [3264] = 2515,
  [3265] = 2498,
  [3266] = 2344,
  [3267] = 2480,
  [3268] = 2498,
  [3269] = 2275,
  [3270] = 2513,
  [3271] = 2343,
  [3272] = 2496,
  [3273] = 2501,
  [3274] = 2492,
  [3275] = 2506,
  [3276] = 2493,
  [3277] = 2507,
  [3278] = 2508,
  [3279] = 2473,
  [3280] = 2518,
  [3281] = 2518,
  [3282] = 2670,
  [3283] = 2497,
  [3284] = 2497,
  [3285] = 2495,
  [3286] = 2494,
  [3287] = 2515,
  [3288] = 2486,
  [3289] = 2493,
  [3290] = 2514,
  [3291] = 2490,
  [3292] = 2504,
  [3293] = 2501,
  [3294] = 2496,
  [3295] = 2511,
  [3296] = 2514,
  [3297] = 2491,
  [3298] = 2518,
  [3299] = 2522,
  [3300] = 2521,
  [3301] = 2519,
  [3302] = 2356,
  [3303] = 2508,
  [3304] = 2345,
  [3305] = 2507,
  [3306] = 2506,
  [3307] = 2498,
  [3308] = 2496,
  [3309] = 2601,
  [3310] = 2513,
  [3311] = 2515,
  [3312] = 2492,
  [3313] = 2492,
  [3314] = 2344,
  [3315] = 2477,
  [3316] = 2459,
  [3317] = 2480,
  [3318] = 2477,
  [3319] = 2486,
  [3320] = 2514,
  [3321] = 2689,
  [3322] = 2459,
  [3323] = 2498,
  [3324] = 2486,
  [3325] = 2464,
  [3326] = 2519,
  [3327] = 2464,
  [3328] = 2502,
  [3329] = 1906,
  [3330] = 2521,
  [3331] = 1915,
  [3332] = 2522,
  [3333] = 2491,
  [3334] = 2473,
  [3335] = 2518,
  [3336] = 2601,
  [3337] = 2506,
  [3338] = 2421,
  [3339] = 2511,
  [3340] = 2504,
  [3341] = 2464,
  [3342] = 2515,
  [3343] = 2502,
  [3344] = 2513,
  [3345] = 2499,
  [3346] = 2473,
  [3347] = 2665,
  [3348] = 2464,
  [3349] = 2672,
  [3350] = 2499,
  [3351] = 2492,
  [3352] = 2499,
  [3353] = 2498,
  [3354] = 2502,
  [3355] = 3355,
  [3356] = 2486,
  [3357] = 2671,
  [3358] = 2480,
  [3359] = 2518,
  [3360] = 2404,
  [3361] = 3361,
  [3362] = 1907,
  [3363] = 1914,
  [3364] = 2497,
  [3365] = 2495,
  [3366] = 2494,
  [3367] = 2493,
  [3368] = 2490,
  [3369] = 2498,
  [3370] = 2504,
  [3371] = 2511,
  [3372] = 2401,
  [3373] = 2491,
  [3374] = 2522,
  [3375] = 2521,
  [3376] = 2493,
  [3377] = 2502,
  [3378] = 2513,
  [3379] = 2341,
  [3380] = 2208,
  [3381] = 2672,
  [3382] = 2729,
  [3383] = 2514,
  [3384] = 2671,
  [3385] = 2498,
  [3386] = 2726,
  [3387] = 2496,
  [3388] = 2514,
  [3389] = 3389,
  [3390] = 2486,
  [3391] = 2347,
  [3392] = 2459,
  [3393] = 2497,
  [3394] = 3394,
  [3395] = 2495,
  [3396] = 2494,
  [3397] = 2689,
  [3398] = 2490,
  [3399] = 2670,
  [3400] = 2515,
  [3401] = 2504,
  [3402] = 2501,
  [3403] = 2519,
  [3404] = 2511,
  [3405] = 2486,
  [3406] = 2491,
  [3407] = 2337,
  [3408] = 2506,
  [3409] = 2522,
  [3410] = 2521,
  [3411] = 3389,
  [3412] = 2519,
  [3413] = 2508,
  [3414] = 3394,
  [3415] = 2507,
  [3416] = 2506,
  [3417] = 2501,
  [3418] = 2496,
  [3419] = 2665,
  [3420] = 3394,
  [3421] = 3394,
  [3422] = 2502,
  [3423] = 2473,
  [3424] = 2513,
  [3425] = 2515,
  [3426] = 2519,
  [3427] = 2521,
  [3428] = 2522,
  [3429] = 2491,
  [3430] = 2511,
  [3431] = 2507,
  [3432] = 2504,
  [3433] = 2490,
  [3434] = 2493,
  [3435] = 2494,
  [3436] = 2477,
  [3437] = 2498,
  [3438] = 2495,
  [3439] = 2497,
  [3440] = 3394,
  [3441] = 2514,
  [3442] = 2502,
  [3443] = 2499,
  [3444] = 2513,
  [3445] = 2518,
  [3446] = 2515,
  [3447] = 2687,
  [3448] = 2522,
  [3449] = 2521,
  [3450] = 2344,
  [3451] = 2429,
  [3452] = 2499,
  [3453] = 2491,
  [3454] = 2498,
  [3455] = 2498,
  [3456] = 2511,
  [3457] = 2504,
  [3458] = 2490,
  [3459] = 2493,
  [3460] = 2494,
  [3461] = 2508,
  [3462] = 2275,
  [3463] = 2332,
  [3464] = 2495,
  [3465] = 2497,
  [3466] = 2518,
  [3467] = 2304,
  [3468] = 2722,
  [3469] = 2480,
  [3470] = 2492,
  [3471] = 2731,
  [3472] = 2416,
  [3473] = 2496,
  [3474] = 2501,
  [3475] = 2499,
  [3476] = 2506,
  [3477] = 2725,
  [3478] = 2508,
  [3479] = 2507,
  [3480] = 3389,
  [3481] = 2496,
  [3482] = 2207,
  [3483] = 2477,
  [3484] = 2601,
  [3485] = 2671,
  [3486] = 2496,
  [3487] = 2459,
  [3488] = 2672,
  [3489] = 2486,
  [3490] = 2205,
  [3491] = 2464,
  [3492] = 2514,
  [3493] = 2492,
  [3494] = 2502,
  [3495] = 2499,
  [3496] = 2665,
  [3497] = 2464,
  [3498] = 2519,
  [3499] = 2687,
  [3500] = 2689,
  [3501] = 2202,
  [3502] = 2464,
  [3503] = 2518,
  [3504] = 2521,
  [3505] = 2522,
  [3506] = 2501,
  [3507] = 2464,
  [3508] = 2514,
  [3509] = 2670,
  [3510] = 2497,
  [3511] = 2515,
  [3512] = 2508,
  [3513] = 2495,
  [3514] = 2513,
  [3515] = 2722,
  [3516] = 2501,
  [3517] = 2344,
  [3518] = 2497,
  [3519] = 2515,
  [3520] = 2506,
  [3521] = 1906,
  [3522] = 1915,
  [3523] = 2513,
  [3524] = 2507,
  [3525] = 2495,
  [3526] = 2494,
  [3527] = 2493,
  [3528] = 2506,
  [3529] = 2518,
  [3530] = 2490,
  [3531] = 2507,
  [3532] = 2494,
  [3533] = 2498,
  [3534] = 2504,
  [3535] = 2491,
  [3536] = 2511,
  [3537] = 2491,
  [3538] = 2493,
  [3539] = 2522,
  [3540] = 2490,
  [3541] = 2521,
  [3542] = 2498,
  [3543] = 2519,
  [3544] = 2511,
  [3545] = 2508,
  [3546] = 2504,
  [3547] = 2464,
  [3548] = 2498,
  [3549] = 1961,
  [3550] = 2464,
  [3551] = 2464,
  [3552] = 2665,
  [3553] = 2514,
  [3554] = 2492,
  [3555] = 1962,
  [3556] = 2497,
  [3557] = 2486,
  [3558] = 2495,
  [3559] = 2486,
  [3560] = 2473,
  [3561] = 2486,
  [3562] = 2473,
  [3563] = 2518,
  [3564] = 2494,
  [3565] = 2493,
  [3566] = 2490,
  [3567] = 2504,
  [3568] = 2511,
  [3569] = 2513,
  [3570] = 2731,
  [3571] = 2729,
  [3572] = 2601,
  [3573] = 2501,
  [3574] = 2491,
  [3575] = 2486,
  [3576] = 2518,
  [3577] = 2522,
  [3578] = 3578,
  [3579] = 2486,
  [3580] = 2725,
  [3581] = 2515,
  [3582] = 2480,
  [3583] = 2726,
  [3584] = 2498,
  [3585] = 2601,
  [3586] = 2508,
  [3587] = 2480,
  [3588] = 2464,
  [3589] = 2480,
  [3590] = 2473,
  [3591] = 2473,
  [3592] = 2496,
  [3593] = 2507,
  [3594] = 2480,
  [3595] = 2486,
  [3596] = 2722,
  [3597] = 2519,
  [3598] = 2464,
  [3599] = 3599,
  [3600] = 3600,
  [3601] = 2506,
  [3602] = 2521,
  [3603] = 2464,
  [3604] = 2515,
  [3605] = 2518,
  [3606] = 2515,
  [3607] = 2513,
  [3608] = 2514,
  [3609] = 2491,
  [3610] = 2480,
  [3611] = 2518,
  [3612] = 2497,
  [3613] = 2508,
  [3614] = 2486,
  [3615] = 2515,
  [3616] = 2480,
  [3617] = 2518,
  [3618] = 2519,
  [3619] = 2667,
  [3620] = 2521,
  [3621] = 2513,
  [3622] = 2492,
  [3623] = 2504,
  [3624] = 2464,
  [3625] = 2502,
  [3626] = 2518,
  [3627] = 2518,
  [3628] = 3628,
  [3629] = 2473,
  [3630] = 2670,
  [3631] = 2513,
  [3632] = 2497,
  [3633] = 2495,
  [3634] = 2671,
  [3635] = 2672,
  [3636] = 2519,
  [3637] = 2521,
  [3638] = 2522,
  [3639] = 2491,
  [3640] = 2511,
  [3641] = 2490,
  [3642] = 2499,
  [3643] = 2495,
  [3644] = 2493,
  [3645] = 2494,
  [3646] = 2687,
  [3647] = 2494,
  [3648] = 2495,
  [3649] = 2665,
  [3650] = 2493,
  [3651] = 2486,
  [3652] = 2490,
  [3653] = 2504,
  [3654] = 2497,
  [3655] = 2486,
  [3656] = 2507,
  [3657] = 2519,
  [3658] = 2502,
  [3659] = 2506,
  [3660] = 2671,
  [3661] = 3661,
  [3662] = 2508,
  [3663] = 2499,
  [3664] = 2672,
  [3665] = 2491,
  [3666] = 2507,
  [3667] = 2506,
  [3668] = 2501,
  [3669] = 2511,
  [3670] = 2496,
  [3671] = 2421,
  [3672] = 2521,
  [3673] = 2464,
  [3674] = 2343,
  [3675] = 2473,
  [3676] = 2498,
  [3677] = 2504,
  [3678] = 2464,
  [3679] = 2501,
  [3680] = 2665,
  [3681] = 2687,
  [3682] = 2514,
  [3683] = 2356,
  [3684] = 2670,
  [3685] = 2513,
  [3686] = 2507,
  [3687] = 2667,
  [3688] = 2515,
  [3689] = 2601,
  [3690] = 2689,
  [3691] = 2522,
  [3692] = 2492,
  [3693] = 2689,
  [3694] = 2490,
  [3695] = 2518,
  [3696] = 2497,
  [3697] = 2495,
  [3698] = 2494,
  [3699] = 2506,
  [3700] = 2345,
  [3701] = 2493,
  [3702] = 2493,
  [3703] = 2490,
  [3704] = 2504,
  [3705] = 2511,
  [3706] = 2514,
  [3707] = 2498,
  [3708] = 2491,
  [3709] = 2473,
  [3710] = 2514,
  [3711] = 2522,
  [3712] = 2499,
  [3713] = 2496,
  [3714] = 2521,
  [3715] = 2519,
  [3716] = 2480,
  [3717] = 2508,
  [3718] = 2464,
  [3719] = 2496,
  [3720] = 2507,
  [3721] = 2506,
  [3722] = 2501,
  [3723] = 2501,
  [3724] = 2496,
  [3725] = 2464,
  [3726] = 2514,
  [3727] = 2506,
  [3728] = 2507,
  [3729] = 2502,
  [3730] = 2601,
  [3731] = 2722,
  [3732] = 2498,
  [3733] = 2497,
  [3734] = 2495,
  [3735] = 2494,
  [3736] = 2493,
  [3737] = 2490,
  [3738] = 2508,
  [3739] = 2504,
  [3740] = 2511,
  [3741] = 2498,
  [3742] = 2491,
  [3743] = 2522,
  [3744] = 2521,
  [3745] = 2519,
  [3746] = 2515,
  [3747] = 2513,
  [3748] = 2257,
  [3749] = 2501,
  [3750] = 2496,
  [3751] = 2231,
  [3752] = 2518,
  [3753] = 2508,
  [3754] = 2492,
  [3755] = 2499,
  [3756] = 2502,
  [3757] = 2522,
  [3758] = 2486,
  [3759] = 2494,
  [3760] = 2511,
  [3761] = 2521,
  [3762] = 2522,
  [3763] = 2522,
  [3764] = 2491,
  [3765] = 2514,
  [3766] = 2496,
  [3767] = 2501,
  [3768] = 2504,
  [3769] = 2508,
  [3770] = 2511,
  [3771] = 2508,
  [3772] = 2671,
  [3773] = 2511,
  [3774] = 2502,
  [3775] = 2507,
  [3776] = 2506,
  [3777] = 2515,
  [3778] = 2498,
  [3779] = 2601,
  [3780] = 2513,
  [3781] = 2687,
  [3782] = 2502,
  [3783] = 2672,
  [3784] = 2498,
  [3785] = 2518,
  [3786] = 2504,
  [3787] = 2513,
  [3788] = 2502,
  [3789] = 2513,
  [3790] = 2490,
  [3791] = 2501,
  [3792] = 2665,
  [3793] = 2514,
  [3794] = 2493,
  [3795] = 2499,
  [3796] = 2494,
  [3797] = 2480,
  [3798] = 2518,
  [3799] = 2495,
  [3800] = 2497,
  [3801] = 2507,
  [3802] = 2519,
  [3803] = 2508,
  [3804] = 2490,
  [3805] = 2493,
  [3806] = 2496,
  [3807] = 2494,
  [3808] = 2506,
  [3809] = 2513,
  [3810] = 2498,
  [3811] = 2492,
  [3812] = 2515,
  [3813] = 2515,
  [3814] = 2473,
  [3815] = 2514,
  [3816] = 2496,
  [3817] = 2515,
  [3818] = 2501,
  [3819] = 2670,
  [3820] = 2689,
  [3821] = 2495,
  [3822] = 2498,
  [3823] = 2498,
  [3824] = 2519,
  [3825] = 2499,
  [3826] = 2501,
  [3827] = 2521,
  [3828] = 2496,
  [3829] = 2521,
  [3830] = 2491,
  [3831] = 2497,
  [3832] = 2486,
  [3833] = 2518,
  [3834] = 2498,
  [3835] = 2480,
  [3836] = 2508,
  [3837] = 2519,
  [3838] = 2601,
  [3839] = 2522,
  [3840] = 2491,
  [3841] = 2507,
  [3842] = 2522,
  [3843] = 2521,
  [3844] = 2511,
  [3845] = 2504,
  [3846] = 2492,
  [3847] = 2506,
  [3848] = 2490,
  [3849] = 2522,
  [3850] = 2514,
  [3851] = 2493,
  [3852] = 2491,
  [3853] = 2494,
  [3854] = 2495,
  [3855] = 2501,
  [3856] = 2506,
  [3857] = 2496,
  [3858] = 2497,
  [3859] = 2667,
  [3860] = 2519,
  [3861] = 2497,
  [3862] = 2511,
  [3863] = 2504,
  [3864] = 2499,
  [3865] = 2507,
  [3866] = 2490,
  [3867] = 2495,
  [3868] = 2493,
  [3869] = 2494,
  [3870] = 2495,
  [3871] = 2494,
  [3872] = 2493,
  [3873] = 2486,
  [3874] = 2497,
  [3875] = 2490,
  [3876] = 2519,
  [3877] = 2521,
  [3878] = 2507,
  [3879] = 2513,
  [3880] = 2486,
  [3881] = 2508,
  [3882] = 2515,
  [3883] = 2504,
  [3884] = 2511,
  [3885] = 2473,
  [3886] = 2486,
  [3887] = 2514,
  [3888] = 2506,
  [3889] = 2491,
  [3890] = 2514,
  [3891] = 2501,
  [3892] = 2498,
  [3893] = 2515,
  [3894] = 2499,
  [3895] = 2508,
  [3896] = 2501,
  [3897] = 2498,
  [3898] = 2502,
  [3899] = 2687,
  [3900] = 2726,
  [3901] = 2687,
  [3902] = 2519,
  [3903] = 2521,
  [3904] = 2522,
  [3905] = 2672,
  [3906] = 2506,
  [3907] = 2725,
  [3908] = 2671,
  [3909] = 2499,
  [3910] = 2502,
  [3911] = 2514,
  [3912] = 2491,
  [3913] = 2494,
  [3914] = 2665,
  [3915] = 2492,
  [3916] = 2511,
  [3917] = 2493,
  [3918] = 2513,
  [3919] = 2490,
  [3920] = 2504,
  [3921] = 2464,
  [3922] = 2504,
  [3923] = 2507,
  [3924] = 2486,
  [3925] = 2490,
  [3926] = 2729,
  [3927] = 2515,
  [3928] = 2689,
  [3929] = 2493,
  [3930] = 2511,
  [3931] = 2491,
  [3932] = 2522,
  [3933] = 2494,
  [3934] = 2498,
  [3935] = 2689,
  [3936] = 2521,
  [3937] = 2507,
  [3938] = 2731,
  [3939] = 2506,
  [3940] = 2495,
  [3941] = 2506,
  [3942] = 2497,
  [3943] = 2496,
  [3944] = 2464,
  [3945] = 2492,
  [3946] = 2519,
  [3947] = 2514,
  [3948] = 2722,
  [3949] = 2519,
  [3950] = 2731,
  [3951] = 2670,
  [3952] = 2513,
  [3953] = 2496,
  [3954] = 2501,
  [3955] = 2497,
  [3956] = 2518,
  [3957] = 2670,
  [3958] = 2671,
  [3959] = 2722,
  [3960] = 2518,
  [3961] = 2508,
  [3962] = 2496,
  [3963] = 2507,
  [3964] = 2495,
  [3965] = 2497,
  [3966] = 3966,
  [3967] = 2672,
  [3968] = 2495,
  [3969] = 2494,
  [3970] = 2493,
  [3971] = 2498,
  [3972] = 2725,
  [3973] = 2464,
  [3974] = 2490,
  [3975] = 2504,
  [3976] = 2511,
  [3977] = 2508,
  [3978] = 2491,
  [3979] = 2522,
  [3980] = 2521,
  [3981] = 2665,
  [3982] = 2513,
  [3983] = 2601,
  [3984] = 2729,
  [3985] = 2665,
  [3986] = 2515,
  [3987] = 2464,
  [3988] = 2518,
  [3989] = 2726,
  [3990] = 2601,
  [3991] = 2671,
  [3992] = 2689,
  [3993] = 2501,
  [3994] = 2670,
  [3995] = 2498,
  [3996] = 2687,
  [3997] = 2515,
  [3998] = 2507,
  [3999] = 2731,
  [4000] = 2513,
  [4001] = 2506,
  [4002] = 2514,
  [4003] = 2508,
  [4004] = 2496,
  [4005] = 2672,
  [4006] = 2486,
  [4007] = 2486,
  [4008] = 2502,
  [4009] = 2504,
  [4010] = 2497,
  [4011] = 2670,
  [4012] = 2518,
  [4013] = 2496,
  [4014] = 2501,
  [4015] = 2515,
  [4016] = 2514,
  [4017] = 2473,
  [4018] = 2513,
  [4019] = 2495,
  [4020] = 2494,
  [4021] = 2493,
  [4022] = 2498,
  [4023] = 2490,
  [4024] = 2519,
  [4025] = 2521,
  [4026] = 2492,
  [4027] = 2722,
  [4028] = 2672,
  [4029] = 2689,
  [4030] = 2522,
  [4031] = 2729,
  [4032] = 2687,
  [4033] = 2508,
  [4034] = 2671,
  [4035] = 2491,
  [4036] = 2480,
  [4037] = 2511,
  [4038] = 2504,
  [4039] = 2490,
  [4040] = 2486,
  [4041] = 2493,
  [4042] = 2494,
  [4043] = 2495,
  [4044] = 2497,
  [4045] = 2507,
  [4046] = 2725,
  [4047] = 2506,
  [4048] = 2519,
  [4049] = 2521,
  [4050] = 2522,
  [4051] = 2726,
  [4052] = 2491,
  [4053] = 2499,
  [4054] = 2511,
  [4055] = 2731,
  [4056] = 2506,
  [4057] = 2731,
  [4058] = 2672,
  [4059] = 2473,
  [4060] = 2726,
  [4061] = 2665,
  [4062] = 2502,
  [4063] = 2729,
  [4064] = 2731,
  [4065] = 2725,
  [4066] = 2508,
  [4067] = 2725,
  [4068] = 2480,
  [4069] = 2464,
  [4070] = 2515,
  [4071] = 2513,
  [4072] = 2521,
  [4073] = 2514,
  [4074] = 2519,
  [4075] = 2522,
  [4076] = 2491,
  [4077] = 2486,
  [4078] = 2497,
  [4079] = 2464,
  [4080] = 2494,
  [4081] = 2518,
  [4082] = 2671,
  [4083] = 2495,
  [4084] = 2494,
  [4085] = 2511,
  [4086] = 2493,
  [4087] = 2490,
  [4088] = 2504,
  [4089] = 2495,
  [4090] = 2511,
  [4091] = 2491,
  [4092] = 2486,
  [4093] = 2496,
  [4094] = 2504,
  [4095] = 2522,
  [4096] = 2521,
  [4097] = 2519,
  [4098] = 2670,
  [4099] = 2689,
  [4100] = 2722,
  [4101] = 2515,
  [4102] = 2490,
  [4103] = 2722,
  [4104] = 2729,
  [4105] = 4105,
  [4106] = 2496,
  [4107] = 2501,
  [4108] = 2506,
  [4109] = 2507,
  [4110] = 2464,
  [4111] = 2501,
  [4112] = 2514,
  [4113] = 2514,
  [4114] = 2518,
  [4115] = 2726,
  [4116] = 2464,
  [4117] = 2518,
  [4118] = 2513,
  [4119] = 2497,
  [4120] = 2508,
  [4121] = 2507,
  [4122] = 2499,
  [4123] = 2726,
  [4124] = 2493,
  [4125] = 1914,
  [4126] = 2665,
  [4127] = 2725,
  [4128] = 2506,
  [4129] = 2518,
  [4130] = 4130,
  [4131] = 2514,
  [4132] = 2508,
  [4133] = 2497,
  [4134] = 4130,
  [4135] = 2518,
  [4136] = 2506,
  [4137] = 2480,
  [4138] = 2499,
  [4139] = 2515,
  [4140] = 2522,
  [4141] = 2521,
  [4142] = 2508,
  [4143] = 2689,
  [4144] = 2486,
  [4145] = 2521,
  [4146] = 2670,
  [4147] = 2519,
  [4148] = 2404,
  [4149] = 4149,
  [4150] = 2729,
  [4151] = 2499,
  [4152] = 2508,
  [4153] = 4149,
  [4154] = 2519,
  [4155] = 2513,
  [4156] = 2497,
  [4157] = 2496,
  [4158] = 4158,
  [4159] = 2513,
  [4160] = 4160,
  [4161] = 2507,
  [4162] = 2495,
  [4163] = 2491,
  [4164] = 2514,
  [4165] = 2473,
  [4166] = 2511,
  [4167] = 2494,
  [4168] = 2493,
  [4169] = 2486,
  [4170] = 2672,
  [4171] = 2522,
  [4172] = 2671,
  [4173] = 2490,
  [4174] = 2504,
  [4175] = 2511,
  [4176] = 2491,
  [4177] = 2504,
  [4178] = 2507,
  [4179] = 2729,
  [4180] = 2731,
  [4181] = 2722,
  [4182] = 2490,
  [4183] = 2515,
  [4184] = 2504,
  [4185] = 2522,
  [4186] = 2521,
  [4187] = 2519,
  [4188] = 2501,
  [4189] = 2490,
  [4190] = 2722,
  [4191] = 2496,
  [4192] = 2515,
  [4193] = 2506,
  [4194] = 2501,
  [4195] = 2201,
  [4196] = 2514,
  [4197] = 2507,
  [4198] = 2493,
  [4199] = 4158,
  [4200] = 2494,
  [4201] = 2491,
  [4202] = 2726,
  [4203] = 2493,
  [4204] = 2495,
  [4205] = 2511,
  [4206] = 2501,
  [4207] = 2401,
  [4208] = 2494,
  [4209] = 2496,
  [4210] = 4130,
  [4211] = 2513,
  [4212] = 2502,
  [4213] = 2497,
  [4214] = 2725,
  [4215] = 2495,
  [4216] = 2514,
  [4217] = 2494,
  [4218] = 2499,
  [4219] = 2518,
  [4220] = 2515,
  [4221] = 2513,
  [4222] = 2515,
  [4223] = 2513,
  [4224] = 2507,
  [4225] = 2511,
  [4226] = 2491,
  [4227] = 2504,
  [4228] = 2506,
  [4229] = 2506,
  [4230] = 2491,
  [4231] = 2501,
  [4232] = 3628,
  [4233] = 2496,
  [4234] = 2522,
  [4235] = 4158,
  [4236] = 4149,
  [4237] = 2521,
  [4238] = 2519,
  [4239] = 2518,
  [4240] = 2502,
  [4241] = 2508,
  [4242] = 2521,
  [4243] = 2511,
  [4244] = 2507,
  [4245] = 4149,
  [4246] = 2519,
  [4247] = 4158,
  [4248] = 3661,
  [4249] = 2514,
  [4250] = 2501,
  [4251] = 2496,
  [4252] = 2508,
  [4253] = 4253,
  [4254] = 2722,
  [4255] = 2495,
  [4256] = 2497,
  [4257] = 2495,
  [4258] = 2522,
  [4259] = 2494,
  [4260] = 2493,
  [4261] = 2490,
  [4262] = 2504,
  [4263] = 2493,
  [4264] = 2497,
  [4265] = 2490,
  [4266] = 2100,
  [4267] = 4267,
  [4268] = 4268,
  [4269] = 4268,
  [4270] = 4268,
  [4271] = 4268,
  [4272] = 2519,
  [4273] = 4268,
  [4274] = 4268,
  [4275] = 4268,
  [4276] = 4276,
  [4277] = 4268,
  [4278] = 2521,
  [4279] = 2522,
  [4280] = 4268,
  [4281] = 2491,
  [4282] = 2506,
  [4283] = 4268,
  [4284] = 2511,
  [4285] = 2504,
  [4286] = 2507,
  [4287] = 2490,
  [4288] = 2493,
  [4289] = 2494,
  [4290] = 2495,
  [4291] = 2497,
  [4292] = 4268,
  [4293] = 4268,
  [4294] = 4268,
  [4295] = 4268,
  [4296] = 2496,
  [4297] = 2501,
  [4298] = 4276,
  [4299] = 2508,
  [4300] = 4268,
  [4301] = 4276,
  [4302] = 4276,
  [4303] = 2514,
  [4304] = 4276,
  [4305] = 4305,
  [4306] = 4306,
  [4307] = 4276,
  [4308] = 4276,
  [4309] = 4276,
  [4310] = 4268,
  [4311] = 4276,
  [4312] = 4276,
  [4313] = 4268,
  [4314] = 4268,
  [4315] = 2257,
  [4316] = 4268,
  [4317] = 4268,
  [4318] = 4276,
  [4319] = 4276,
  [4320] = 4268,
  [4321] = 4268,
  [4322] = 4276,
  [4323] = 4268,
  [4324] = 4268,
  [4325] = 4268,
  [4326] = 4268,
  [4327] = 4268,
  [4328] = 4276,
  [4329] = 4268,
  [4330] = 4268,
  [4331] = 2088,
  [4332] = 4276,
  [4333] = 4268,
  [4334] = 2090,
  [4335] = 2081,
  [4336] = 2092,
  [4337] = 2095,
  [4338] = 2101,
  [4339] = 4268,
  [4340] = 2231,
  [4341] = 4276,
  [4342] = 2102,
  [4343] = 2080,
  [4344] = 2103,
  [4345] = 4268,
  [4346] = 4276,
  [4347] = 4276,
  [4348] = 4268,
  [4349] = 4276,
  [4350] = 4268,
  [4351] = 4268,
  [4352] = 4276,
  [4353] = 2083,
  [4354] = 2082,
  [4355] = 4276,
  [4356] = 4276,
  [4357] = 4268,
  [4358] = 4268,
  [4359] = 4276,
  [4360] = 4268,
  [4361] = 4268,
  [4362] = 4362,
  [4363] = 2722,
  [4364] = 4364,
  [4365] = 2099,
  [4366] = 2098,
  [4367] = 2097,
  [4368] = 2096,
  [4369] = 4268,
  [4370] = 4268,
  [4371] = 4371,
  [4372] = 2513,
  [4373] = 4276,
  [4374] = 4268,
  [4375] = 4268,
  [4376] = 4268,
  [4377] = 4268,
  [4378] = 4268,
  [4379] = 2515,
  [4380] = 2095,
  [4381] = 2407,
  [4382] = 4382,
  [4383] = 2358,
  [4384] = 2082,
  [4385] = 2092,
  [4386] = 2083,
  [4387] = 2101,
  [4388] = 2354,
  [4389] = 2329,
  [4390] = 2288,
  [4391] = 2089,
  [4392] = 2097,
  [4393] = 2103,
  [4394] = 2098,
  [4395] = 2102,
  [4396] = 4396,
  [4397] = 2431,
  [4398] = 2099,
  [4399] = 2363,
  [4400] = 2413,
  [4401] = 2412,
  [4402] = 2096,
  [4403] = 2398,
  [4404] = 2274,
  [4405] = 2409,
  [4406] = 2402,
  [4407] = 4407,
  [4408] = 2302,
  [4409] = 2357,
  [4410] = 2415,
  [4411] = 2403,
  [4412] = 2437,
  [4413] = 2285,
  [4414] = 2423,
  [4415] = 2384,
  [4416] = 2420,
  [4417] = 2081,
  [4418] = 2100,
  [4419] = 2090,
  [4420] = 2080,
  [4421] = 2088,
  [4422] = 4422,
  [4423] = 2399,
  [4424] = 2305,
  [4425] = 2291,
  [4426] = 2314,
  [4427] = 2330,
  [4428] = 2375,
  [4429] = 2366,
  [4430] = 4430,
  [4431] = 2425,
  [4432] = 4432,
  [4433] = 4433,
  [4434] = 4434,
  [4435] = 4435,
  [4436] = 4436,
  [4437] = 4437,
  [4438] = 4438,
  [4439] = 4439,
  [4440] = 4440,
  [4441] = 4441,
  [4442] = 4442,
  [4443] = 4443,
  [4444] = 4444,
  [4445] = 4445,
  [4446] = 4446,
  [4447] = 4447,
  [4448] = 4448,
  [4449] = 4442,
  [4450] = 4450,
  [4451] = 4451,
  [4452] = 4452,
  [4453] = 4453,
  [4454] = 4454,
  [4455] = 4455,
  [4456] = 4456,
  [4457] = 4439,
  [4458] = 4458,
  [4459] = 4459,
  [4460] = 4460,
  [4461] = 1908,
  [4462] = 3361,
  [4463] = 4463,
  [4464] = 4464,
  [4465] = 4465,
  [4466] = 1906,
  [4467] = 3628,
  [4468] = 1915,
  [4469] = 4469,
  [4470] = 1907,
  [4471] = 4471,
  [4472] = 4472,
  [4473] = 1909,
  [4474] = 3355,
  [4475] = 3661,
  [4476] = 4476,
  [4477] = 4477,
  [4478] = 4478,
  [4479] = 4479,
  [4480] = 4480,
  [4481] = 4481,
  [4482] = 4482,
  [4483] = 4483,
  [4484] = 4484,
  [4485] = 4485,
  [4486] = 4486,
  [4487] = 4487,
  [4488] = 4488,
  [4489] = 4489,
  [4490] = 4490,
  [4491] = 4491,
  [4492] = 4492,
  [4493] = 4493,
  [4494] = 4494,
  [4495] = 4495,
  [4496] = 4496,
  [4497] = 4497,
  [4498] = 4498,
  [4499] = 4499,
  [4500] = 4500,
  [4501] = 4501,
  [4502] = 4502,
  [4503] = 4503,
  [4504] = 4504,
  [4505] = 4505,
  [4506] = 4506,
  [4507] = 4507,
  [4508] = 4508,
  [4509] = 4509,
  [4510] = 4510,
  [4511] = 4511,
  [4512] = 4512,
  [4513] = 4513,
  [4514] = 4514,
  [4515] = 3661,
  [4516] = 4516,
  [4517] = 3661,
  [4518] = 3628,
  [4519] = 3628,
  [4520] = 4520,
  [4521] = 4521,
  [4522] = 4522,
  [4523] = 4523,
  [4524] = 4524,
  [4525] = 4525,
  [4526] = 4526,
  [4527] = 4527,
  [4528] = 4528,
  [4529] = 4529,
  [4530] = 4530,
  [4531] = 4531,
  [4532] = 4532,
  [4533] = 4533,
  [4534] = 4534,
  [4535] = 4535,
  [4536] = 4535,
  [4537] = 4535,
  [4538] = 4535,
  [4539] = 4535,
  [4540] = 4535,
  [4541] = 4535,
  [4542] = 4535,
  [4543] = 4535,
  [4544] = 4535,
  [4545] = 4535,
  [4546] = 4535,
  [4547] = 4547,
  [4548] = 4535,
  [4549] = 4535,
  [4550] = 4535,
  [4551] = 4535,
  [4552] = 4535,
  [4553] = 4553,
  [4554] = 4535,
  [4555] = 4432,
  [4556] = 4535,
  [4557] = 4535,
  [4558] = 4535,
  [4559] = 4535,
  [4560] = 4535,
  [4561] = 4535,
  [4562] = 4562,
  [4563] = 4437,
  [4564] = 4564,
  [4565] = 4562,
  [4566] = 4562,
  [4567] = 4562,
  [4568] = 4562,
  [4569] = 4562,
  [4570] = 4570,
  [4571] = 4571,
  [4572] = 4572,
  [4573] = 4573,
  [4574] = 4523,
  [4575] = 4524,
  [4576] = 4562,
  [4577] = 4577,
  [4578] = 4529,
  [4579] = 4579,
  [4580] = 4580,
  [4581] = 4581,
  [4582] = 4579,
  [4583] = 4547,
  [4584] = 4534,
  [4585] = 4471,
  [4586] = 2404,
  [4587] = 4587,
  [4588] = 3197,
  [4589] = 2401,
  [4590] = 4505,
  [4591] = 4591,
  [4592] = 4592,
  [4593] = 4494,
  [4594] = 4594,
  [4595] = 4595,
  [4596] = 4480,
  [4597] = 4592,
  [4598] = 4598,
  [4599] = 4502,
  [4600] = 4591,
  [4601] = 4601,
  [4602] = 4602,
  [4603] = 4603,
  [4604] = 4500,
  [4605] = 4547,
  [4606] = 4534,
  [4607] = 1914,
  [4608] = 4608,
  [4609] = 4609,
  [4610] = 4610,
  [4611] = 4611,
  [4612] = 4516,
  [4613] = 4611,
  [4614] = 4609,
  [4615] = 4609,
  [4616] = 4611,
  [4617] = 4610,
  [4618] = 2201,
  [4619] = 4610,
  [4620] = 4608,
  [4621] = 4621,
  [4622] = 4622,
  [4623] = 4533,
  [4624] = 4531,
  [4625] = 4432,
  [4626] = 4532,
  [4627] = 4621,
  [4628] = 4521,
  [4629] = 4524,
  [4630] = 4530,
  [4631] = 4621,
  [4632] = 4527,
  [4633] = 4523,
  [4634] = 4529,
  [4635] = 4635,
  [4636] = 4522,
  [4637] = 4528,
  [4638] = 4621,
  [4639] = 4526,
  [4640] = 4525,
  [4641] = 4520,
  [4642] = 4437,
  [4643] = 4547,
  [4644] = 4534,
  [4645] = 2201,
  [4646] = 2201,
  [4647] = 2102,
  [4648] = 2090,
  [4649] = 2101,
  [4650] = 2092,
  [4651] = 4253,
  [4652] = 2231,
  [4653] = 2098,
  [4654] = 2080,
  [4655] = 2103,
  [4656] = 2097,
  [4657] = 2096,
  [4658] = 4432,
  [4659] = 2081,
  [4660] = 2088,
  [4661] = 2095,
  [4662] = 4524,
  [4663] = 4364,
  [4664] = 4529,
  [4665] = 2040,
  [4666] = 4267,
  [4667] = 4523,
  [4668] = 2043,
  [4669] = 2099,
  [4670] = 2257,
  [4671] = 2083,
  [4672] = 2100,
  [4673] = 2082,
  [4674] = 4371,
  [4675] = 4471,
  [4676] = 4305,
  [4677] = 4362,
  [4678] = 2358,
  [4679] = 4432,
  [4680] = 2285,
  [4681] = 2302,
  [4682] = 2043,
  [4683] = 2404,
  [4684] = 2040,
  [4685] = 2103,
  [4686] = 2437,
  [4687] = 2431,
  [4688] = 2080,
  [4689] = 2102,
  [4690] = 2291,
  [4691] = 2089,
  [4692] = 2101,
  [4693] = 4534,
  [4694] = 2090,
  [4695] = 2413,
  [4696] = 2401,
  [4697] = 2366,
  [4698] = 4505,
  [4699] = 2375,
  [4700] = 4437,
  [4701] = 4502,
  [4702] = 4430,
  [4703] = 2330,
  [4704] = 2314,
  [4705] = 2100,
  [4706] = 2423,
  [4707] = 2425,
  [4708] = 2095,
  [4709] = 2096,
  [4710] = 4396,
  [4711] = 4547,
  [4712] = 4422,
  [4713] = 2092,
  [4714] = 2081,
  [4715] = 2403,
  [4716] = 2088,
  [4717] = 2274,
  [4718] = 2412,
  [4719] = 4382,
  [4720] = 2363,
  [4721] = 2083,
  [4722] = 2082,
  [4723] = 4494,
  [4724] = 2398,
  [4725] = 2305,
  [4726] = 2099,
  [4727] = 4516,
  [4728] = 2098,
  [4729] = 2402,
  [4730] = 2399,
  [4731] = 2288,
  [4732] = 2407,
  [4733] = 2357,
  [4734] = 2415,
  [4735] = 2420,
  [4736] = 2384,
  [4737] = 2354,
  [4738] = 2329,
  [4739] = 2409,
  [4740] = 2097,
  [4741] = 4407,
  [4742] = 4500,
  [4743] = 4743,
  [4744] = 4534,
  [4745] = 4580,
  [4746] = 2055,
  [4747] = 4602,
  [4748] = 4529,
  [4749] = 2053,
  [4750] = 4603,
  [4751] = 4587,
  [4752] = 4547,
  [4753] = 4581,
  [4754] = 4471,
  [4755] = 4524,
  [4756] = 3197,
  [4757] = 4594,
  [4758] = 4595,
  [4759] = 4598,
  [4760] = 4601,
  [4761] = 4437,
  [4762] = 4523,
  [4763] = 4471,
  [4764] = 4440,
  [4765] = 4531,
  [4766] = 4494,
  [4767] = 4528,
  [4768] = 4525,
  [4769] = 4434,
  [4770] = 4435,
  [4771] = 4771,
  [4772] = 1907,
  [4773] = 4500,
  [4774] = 4622,
  [4775] = 4635,
  [4776] = 4532,
  [4777] = 4502,
  [4778] = 1906,
  [4779] = 1910,
  [4780] = 1915,
  [4781] = 4453,
  [4782] = 4500,
  [4783] = 4455,
  [4784] = 4521,
  [4785] = 1913,
  [4786] = 4445,
  [4787] = 1914,
  [4788] = 1912,
  [4789] = 4526,
  [4790] = 4459,
  [4791] = 1909,
  [4792] = 4447,
  [4793] = 4444,
  [4794] = 3361,
  [4795] = 1914,
  [4796] = 1915,
  [4797] = 1907,
  [4798] = 4443,
  [4799] = 1906,
  [4800] = 4489,
  [4801] = 4771,
  [4802] = 4771,
  [4803] = 4451,
  [4804] = 4456,
  [4805] = 4454,
  [4806] = 2055,
  [4807] = 4527,
  [4808] = 4522,
  [4809] = 4441,
  [4810] = 4520,
  [4811] = 4505,
  [4812] = 1908,
  [4813] = 4484,
  [4814] = 4452,
  [4815] = 1909,
  [4816] = 1908,
  [4817] = 4448,
  [4818] = 2053,
  [4819] = 4450,
  [4820] = 4502,
  [4821] = 4458,
  [4822] = 4771,
  [4823] = 4533,
  [4824] = 4505,
  [4825] = 4771,
  [4826] = 4826,
  [4827] = 4446,
  [4828] = 4438,
  [4829] = 3355,
  [4830] = 4480,
  [4831] = 4534,
  [4832] = 4530,
  [4833] = 4433,
  [4834] = 4547,
  [4835] = 4436,
  [4836] = 4547,
  [4837] = 4837,
  [4838] = 4598,
  [4839] = 4839,
  [4840] = 4839,
  [4841] = 4469,
  [4842] = 1910,
  [4843] = 4601,
  [4844] = 4464,
  [4845] = 4439,
  [4846] = 4595,
  [4847] = 4847,
  [4848] = 4848,
  [4849] = 4482,
  [4850] = 4850,
  [4851] = 4463,
  [4852] = 2187,
  [4853] = 4529,
  [4854] = 4523,
  [4855] = 4602,
  [4856] = 4856,
  [4857] = 4534,
  [4858] = 4856,
  [4859] = 4837,
  [4860] = 1914,
  [4861] = 4472,
  [4862] = 1909,
  [4863] = 4460,
  [4864] = 1908,
  [4865] = 4442,
  [4866] = 4848,
  [4867] = 4494,
  [4868] = 4848,
  [4869] = 4839,
  [4870] = 4524,
  [4871] = 1913,
  [4872] = 1906,
  [4873] = 1907,
  [4874] = 1915,
  [4875] = 4439,
  [4876] = 4442,
  [4877] = 4837,
  [4878] = 4603,
  [4879] = 3197,
  [4880] = 4856,
  [4881] = 4594,
  [4882] = 1912,
  [4883] = 4883,
  [4884] = 4490,
  [4885] = 4885,
  [4886] = 4886,
  [4887] = 4887,
  [4888] = 4886,
  [4889] = 4523,
  [4890] = 4890,
  [4891] = 4887,
  [4892] = 4883,
  [4893] = 4885,
  [4894] = 4547,
  [4895] = 4895,
  [4896] = 4533,
  [4897] = 4529,
  [4898] = 4524,
  [4899] = 4531,
  [4900] = 4522,
  [4901] = 4532,
  [4902] = 4534,
  [4903] = 4886,
  [4904] = 4491,
  [4905] = 4887,
  [4906] = 4883,
  [4907] = 4883,
  [4908] = 4529,
  [4909] = 4890,
  [4910] = 4890,
  [4911] = 4498,
  [4912] = 4886,
  [4913] = 4890,
  [4914] = 4507,
  [4915] = 4890,
  [4916] = 4883,
  [4917] = 4504,
  [4918] = 4523,
  [4919] = 4527,
  [4920] = 4514,
  [4921] = 4887,
  [4922] = 4524,
  [4923] = 4887,
  [4924] = 4886,
  [4925] = 4525,
  [4926] = 4530,
  [4927] = 4521,
  [4928] = 4895,
  [4929] = 4527,
  [4930] = 4496,
  [4931] = 4525,
  [4932] = 4895,
  [4933] = 4465,
  [4934] = 4521,
  [4935] = 4885,
  [4936] = 4520,
  [4937] = 4526,
  [4938] = 4938,
  [4939] = 4511,
  [4940] = 4940,
  [4941] = 4530,
  [4942] = 2102,
  [4943] = 4503,
  [4944] = 2080,
  [4945] = 4510,
  [4946] = 2103,
  [4947] = 4512,
  [4948] = 4479,
  [4949] = 4501,
  [4950] = 4499,
  [4951] = 4547,
  [4952] = 4483,
  [4953] = 4534,
  [4954] = 4533,
  [4955] = 4531,
  [4956] = 4492,
  [4957] = 4938,
  [4958] = 2095,
  [4959] = 4959,
  [4960] = 4959,
  [4961] = 4938,
  [4962] = 4962,
  [4963] = 4532,
  [4964] = 2085,
  [4965] = 4523,
  [4966] = 4547,
  [4967] = 4534,
  [4968] = 2092,
  [4969] = 4522,
  [4970] = 2081,
  [4971] = 2096,
  [4972] = 2086,
  [4973] = 2100,
  [4974] = 4974,
  [4975] = 2099,
  [4976] = 2098,
  [4977] = 4476,
  [4978] = 2097,
  [4979] = 4486,
  [4980] = 2089,
  [4981] = 2090,
  [4982] = 4982,
  [4983] = 4526,
  [4984] = 4509,
  [4985] = 4508,
  [4986] = 2091,
  [4987] = 2101,
  [4988] = 4938,
  [4989] = 4520,
  [4990] = 4990,
  [4991] = 4990,
  [4992] = 4959,
  [4993] = 4993,
  [4994] = 4938,
  [4995] = 4513,
  [4996] = 4990,
  [4997] = 4997,
  [4998] = 4998,
  [4999] = 4999,
  [5000] = 5000,
  [5001] = 4959,
  [5002] = 4485,
  [5003] = 4982,
  [5004] = 4990,
  [5005] = 4982,
  [5006] = 4488,
  [5007] = 4529,
  [5008] = 4523,
  [5009] = 4478,
  [5010] = 2088,
  [5011] = 5011,
  [5012] = 4524,
  [5013] = 4962,
  [5014] = 5014,
  [5015] = 2241,
  [5016] = 4477,
  [5017] = 2049,
  [5018] = 4493,
  [5019] = 4481,
  [5020] = 4529,
  [5021] = 4497,
  [5022] = 2082,
  [5023] = 2083,
  [5024] = 4962,
  [5025] = 4982,
  [5026] = 4524,
  [5027] = 4990,
  [5028] = 4495,
  [5029] = 4959,
  [5030] = 4997,
  [5031] = 4982,
  [5032] = 4487,
  [5033] = 4506,
  [5034] = 5034,
  [5035] = 2246,
  [5036] = 2235,
  [5037] = 5037,
  [5038] = 5038,
  [5039] = 2098,
  [5040] = 2099,
  [5041] = 5041,
  [5042] = 2086,
  [5043] = 2085,
  [5044] = 5044,
  [5045] = 5045,
  [5046] = 5044,
  [5047] = 5047,
  [5048] = 2100,
  [5049] = 5049,
  [5050] = 5038,
  [5051] = 5051,
  [5052] = 5052,
  [5053] = 5053,
  [5054] = 5044,
  [5055] = 5055,
  [5056] = 5056,
  [5057] = 5057,
  [5058] = 5058,
  [5059] = 5059,
  [5060] = 2205,
  [5061] = 5057,
  [5062] = 5037,
  [5063] = 2082,
  [5064] = 2103,
  [5065] = 5052,
  [5066] = 2080,
  [5067] = 2102,
  [5068] = 5044,
  [5069] = 5044,
  [5070] = 5053,
  [5071] = 5071,
  [5072] = 5072,
  [5073] = 5055,
  [5074] = 5056,
  [5075] = 2101,
  [5076] = 5044,
  [5077] = 2095,
  [5078] = 5044,
  [5079] = 2049,
  [5080] = 5080,
  [5081] = 5081,
  [5082] = 5049,
  [5083] = 5044,
  [5084] = 5071,
  [5085] = 5072,
  [5086] = 5044,
  [5087] = 5045,
  [5088] = 5088,
  [5089] = 5044,
  [5090] = 5090,
  [5091] = 5049,
  [5092] = 2092,
  [5093] = 5072,
  [5094] = 4523,
  [5095] = 5044,
  [5096] = 5071,
  [5097] = 5044,
  [5098] = 5098,
  [5099] = 5038,
  [5100] = 5044,
  [5101] = 5044,
  [5102] = 5102,
  [5103] = 5044,
  [5104] = 5044,
  [5105] = 2207,
  [5106] = 5056,
  [5107] = 5055,
  [5108] = 2081,
  [5109] = 5053,
  [5110] = 5052,
  [5111] = 5044,
  [5112] = 5044,
  [5113] = 4523,
  [5114] = 5056,
  [5115] = 5047,
  [5116] = 5055,
  [5117] = 5053,
  [5118] = 5044,
  [5119] = 5052,
  [5120] = 5038,
  [5121] = 5044,
  [5122] = 5044,
  [5123] = 5044,
  [5124] = 5047,
  [5125] = 5044,
  [5126] = 5045,
  [5127] = 5044,
  [5128] = 5051,
  [5129] = 5129,
  [5130] = 5057,
  [5131] = 5129,
  [5132] = 5044,
  [5133] = 5058,
  [5134] = 5057,
  [5135] = 5058,
  [5136] = 5059,
  [5137] = 5037,
  [5138] = 5044,
  [5139] = 5044,
  [5140] = 5044,
  [5141] = 5037,
  [5142] = 5059,
  [5143] = 5058,
  [5144] = 5044,
  [5145] = 2201,
  [5146] = 2202,
  [5147] = 4524,
  [5148] = 5049,
  [5149] = 5044,
  [5150] = 5044,
  [5151] = 5057,
  [5152] = 5044,
  [5153] = 5059,
  [5154] = 5045,
  [5155] = 2091,
  [5156] = 5044,
  [5157] = 2090,
  [5158] = 5044,
  [5159] = 2088,
  [5160] = 5037,
  [5161] = 5059,
  [5162] = 5058,
  [5163] = 5071,
  [5164] = 5164,
  [5165] = 4529,
  [5166] = 5044,
  [5167] = 5045,
  [5168] = 5168,
  [5169] = 5072,
  [5170] = 5057,
  [5171] = 5044,
  [5172] = 5044,
  [5173] = 5049,
  [5174] = 5044,
  [5175] = 5044,
  [5176] = 2083,
  [5177] = 5129,
  [5178] = 5129,
  [5179] = 5058,
  [5180] = 5058,
  [5181] = 5051,
  [5182] = 5038,
  [5183] = 5044,
  [5184] = 5044,
  [5185] = 5047,
  [5186] = 5044,
  [5187] = 2089,
  [5188] = 5038,
  [5189] = 5034,
  [5190] = 4529,
  [5191] = 5047,
  [5192] = 5051,
  [5193] = 5038,
  [5194] = 4547,
  [5195] = 4534,
  [5196] = 5052,
  [5197] = 5053,
  [5198] = 5055,
  [5199] = 5056,
  [5200] = 2097,
  [5201] = 5047,
  [5202] = 5071,
  [5203] = 5044,
  [5204] = 5072,
  [5205] = 2096,
  [5206] = 5044,
  [5207] = 5044,
  [5208] = 5208,
  [5209] = 5044,
  [5210] = 5129,
  [5211] = 5044,
  [5212] = 4524,
  [5213] = 5051,
  [5214] = 2236,
  [5215] = 5215,
  [5216] = 5216,
  [5217] = 5217,
  [5218] = 5218,
  [5219] = 5219,
  [5220] = 5217,
  [5221] = 5221,
  [5222] = 5215,
  [5223] = 5223,
  [5224] = 4534,
  [5225] = 5225,
  [5226] = 5226,
  [5227] = 5227,
  [5228] = 5228,
  [5229] = 4547,
  [5230] = 5226,
  [5231] = 5226,
  [5232] = 4547,
  [5233] = 5227,
  [5234] = 4534,
  [5235] = 1914,
  [5236] = 5236,
  [5237] = 5237,
  [5238] = 5221,
  [5239] = 5218,
  [5240] = 5240,
  [5241] = 5223,
  [5242] = 5242,
  [5243] = 5225,
  [5244] = 4529,
  [5245] = 5245,
  [5246] = 5246,
  [5247] = 5247,
  [5248] = 5216,
  [5249] = 5249,
  [5250] = 5217,
  [5251] = 5219,
  [5252] = 5215,
  [5253] = 5253,
  [5254] = 5217,
  [5255] = 5217,
  [5256] = 5253,
  [5257] = 5249,
  [5258] = 5219,
  [5259] = 2249,
  [5260] = 2221,
  [5261] = 5261,
  [5262] = 5262,
  [5263] = 5263,
  [5264] = 5245,
  [5265] = 2110,
  [5266] = 2333,
  [5267] = 2411,
  [5268] = 2104,
  [5269] = 5218,
  [5270] = 4524,
  [5271] = 5221,
  [5272] = 2242,
  [5273] = 2111,
  [5274] = 2233,
  [5275] = 4547,
  [5276] = 5276,
  [5277] = 2225,
  [5278] = 5249,
  [5279] = 4534,
  [5280] = 5280,
  [5281] = 5281,
  [5282] = 5216,
  [5283] = 5223,
  [5284] = 4523,
  [5285] = 2473,
  [5286] = 5225,
  [5287] = 5253,
  [5288] = 5245,
  [5289] = 5227,
  [5290] = 5290,
  [5291] = 5291,
  [5292] = 5292,
  [5293] = 5293,
  [5294] = 2429,
  [5295] = 2257,
  [5296] = 5296,
  [5297] = 5276,
  [5298] = 5298,
  [5299] = 5299,
  [5300] = 4481,
  [5301] = 5242,
  [5302] = 1914,
  [5303] = 5242,
  [5304] = 5304,
  [5305] = 5305,
  [5306] = 5298,
  [5307] = 2231,
  [5308] = 5308,
  [5309] = 2270,
  [5310] = 5310,
  [5311] = 5311,
  [5312] = 5308,
  [5313] = 5310,
  [5314] = 5314,
  [5315] = 5315,
  [5316] = 5316,
  [5317] = 5317,
  [5318] = 5318,
  [5319] = 5276,
  [5320] = 5263,
  [5321] = 5311,
  [5322] = 5310,
  [5323] = 5298,
  [5324] = 5311,
  [5325] = 1914,
  [5326] = 5308,
  [5327] = 2346,
  [5328] = 2279,
  [5329] = 2350,
  [5330] = 2348,
  [5331] = 5331,
  [5332] = 2339,
  [5333] = 2325,
  [5334] = 2324,
  [5335] = 2310,
  [5336] = 2283,
  [5337] = 2276,
  [5338] = 2300,
  [5339] = 2336,
  [5340] = 4529,
  [5341] = 5341,
  [5342] = 2426,
  [5343] = 2393,
  [5344] = 2307,
  [5345] = 2282,
  [5346] = 5346,
  [5347] = 5347,
  [5348] = 5348,
  [5349] = 5349,
  [5350] = 2290,
  [5351] = 2370,
  [5352] = 2284,
  [5353] = 5353,
  [5354] = 5354,
  [5355] = 2388,
  [5356] = 2400,
  [5357] = 2293,
  [5358] = 2277,
  [5359] = 2436,
  [5360] = 2431,
  [5361] = 2380,
  [5362] = 5331,
  [5363] = 5363,
  [5364] = 4534,
  [5365] = 2413,
  [5366] = 4547,
  [5367] = 2412,
  [5368] = 5368,
  [5369] = 5369,
  [5370] = 5298,
  [5371] = 5371,
  [5372] = 5372,
  [5373] = 2274,
  [5374] = 2409,
  [5375] = 2402,
  [5376] = 2352,
  [5377] = 2041,
  [5378] = 5378,
  [5379] = 5341,
  [5380] = 5380,
  [5381] = 5341,
  [5382] = 4422,
  [5383] = 2353,
  [5384] = 2292,
  [5385] = 5331,
  [5386] = 2287,
  [5387] = 2417,
  [5388] = 2437,
  [5389] = 2358,
  [5390] = 2398,
  [5391] = 5391,
  [5392] = 2403,
  [5393] = 2407,
  [5394] = 5394,
  [5395] = 2415,
  [5396] = 5353,
  [5397] = 2401,
  [5398] = 5398,
  [5399] = 5353,
  [5400] = 2278,
  [5401] = 2359,
  [5402] = 2351,
  [5403] = 5041,
  [5404] = 2418,
  [5405] = 2302,
  [5406] = 2289,
  [5407] = 2329,
  [5408] = 2432,
  [5409] = 2428,
  [5410] = 2399,
  [5411] = 2414,
  [5412] = 5412,
  [5413] = 2303,
  [5414] = 5414,
  [5415] = 2427,
  [5416] = 2423,
  [5417] = 5341,
  [5418] = 5418,
  [5419] = 2406,
  [5420] = 2404,
  [5421] = 5354,
  [5422] = 2381,
  [5423] = 2425,
  [5424] = 5341,
  [5425] = 5425,
  [5426] = 2294,
  [5427] = 2291,
  [5428] = 2363,
  [5429] = 2361,
  [5430] = 2360,
  [5431] = 2323,
  [5432] = 2321,
  [5433] = 2322,
  [5434] = 2297,
  [5435] = 2319,
  [5436] = 2328,
  [5437] = 2318,
  [5438] = 2340,
  [5439] = 2349,
  [5440] = 5341,
  [5441] = 5441,
  [5442] = 2338,
  [5443] = 5441,
  [5444] = 2362,
  [5445] = 2385,
  [5446] = 2435,
  [5447] = 2410,
  [5448] = 2305,
  [5449] = 5394,
  [5450] = 2320,
  [5451] = 2430,
  [5452] = 5354,
  [5453] = 2433,
  [5454] = 2384,
  [5455] = 5418,
  [5456] = 2420,
  [5457] = 2397,
  [5458] = 2395,
  [5459] = 2317,
  [5460] = 5460,
  [5461] = 2390,
  [5462] = 2383,
  [5463] = 2379,
  [5464] = 2316,
  [5465] = 2312,
  [5466] = 2367,
  [5467] = 2365,
  [5468] = 2386,
  [5469] = 2273,
  [5470] = 2285,
  [5471] = 2424,
  [5472] = 2368,
  [5473] = 2378,
  [5474] = 2335,
  [5475] = 2357,
  [5476] = 2364,
  [5477] = 2314,
  [5478] = 5341,
  [5479] = 2374,
  [5480] = 5425,
  [5481] = 2295,
  [5482] = 2377,
  [5483] = 2288,
  [5484] = 2387,
  [5485] = 2330,
  [5486] = 2375,
  [5487] = 2299,
  [5488] = 2334,
  [5489] = 4534,
  [5490] = 4547,
  [5491] = 2366,
  [5492] = 5492,
  [5493] = 2392,
  [5494] = 2354,
  [5495] = 5495,
  [5496] = 5496,
  [5497] = 5497,
  [5498] = 5495,
  [5499] = 5499,
  [5500] = 5495,
  [5501] = 5501,
  [5502] = 2111,
  [5503] = 5503,
  [5504] = 5499,
  [5505] = 5505,
  [5506] = 5506,
  [5507] = 5507,
  [5508] = 5495,
  [5509] = 5509,
  [5510] = 5510,
  [5511] = 5511,
  [5512] = 5512,
  [5513] = 5513,
  [5514] = 5514,
  [5515] = 5354,
  [5516] = 5516,
  [5517] = 5517,
  [5518] = 5516,
  [5519] = 5511,
  [5520] = 5240,
  [5521] = 5501,
  [5522] = 5522,
  [5523] = 5513,
  [5524] = 5524,
  [5525] = 5525,
  [5526] = 5526,
  [5527] = 5526,
  [5528] = 5517,
  [5529] = 5517,
  [5530] = 5499,
  [5531] = 5510,
  [5532] = 5236,
  [5533] = 5507,
  [5534] = 5495,
  [5535] = 5511,
  [5536] = 5536,
  [5537] = 5537,
  [5538] = 2104,
  [5539] = 5539,
  [5540] = 5540,
  [5541] = 5514,
  [5542] = 5542,
  [5543] = 5524,
  [5544] = 5262,
  [5545] = 5545,
  [5546] = 5546,
  [5547] = 5547,
  [5548] = 5513,
  [5549] = 5549,
  [5550] = 5546,
  [5551] = 5503,
  [5552] = 5261,
  [5553] = 5507,
  [5554] = 5496,
  [5555] = 5542,
  [5556] = 5511,
  [5557] = 5557,
  [5558] = 5540,
  [5559] = 5496,
  [5560] = 5549,
  [5561] = 5246,
  [5562] = 5517,
  [5563] = 5501,
  [5564] = 5547,
  [5565] = 5513,
  [5566] = 5503,
  [5567] = 5516,
  [5568] = 5499,
  [5569] = 5513,
  [5570] = 5499,
  [5571] = 5237,
  [5572] = 2110,
  [5573] = 5573,
  [5574] = 5511,
  [5575] = 5510,
  [5576] = 5545,
  [5577] = 5517,
  [5578] = 5578,
  [5579] = 5579,
  [5580] = 5579,
  [5581] = 5581,
  [5582] = 5579,
  [5583] = 5583,
  [5584] = 5579,
  [5585] = 5585,
  [5586] = 5581,
  [5587] = 5579,
  [5588] = 5581,
  [5589] = 5579,
  [5590] = 5581,
  [5591] = 5579,
  [5592] = 1913,
  [5593] = 5579,
  [5594] = 5594,
  [5595] = 5581,
  [5596] = 5579,
  [5597] = 5581,
  [5598] = 5579,
  [5599] = 5585,
  [5600] = 5581,
  [5601] = 5579,
  [5602] = 5579,
  [5603] = 5581,
  [5604] = 5604,
  [5605] = 5581,
  [5606] = 5606,
  [5607] = 5581,
  [5608] = 5581,
  [5609] = 5581,
  [5610] = 5585,
  [5611] = 5579,
  [5612] = 5612,
  [5613] = 5579,
  [5614] = 5581,
  [5615] = 5579,
  [5616] = 5581,
  [5617] = 5579,
  [5618] = 5581,
  [5619] = 5579,
  [5620] = 5581,
  [5621] = 5579,
  [5622] = 5581,
  [5623] = 5579,
  [5624] = 5604,
  [5625] = 5581,
  [5626] = 5581,
  [5627] = 5579,
  [5628] = 5628,
  [5629] = 5579,
  [5630] = 5578,
  [5631] = 5579,
  [5632] = 5581,
  [5633] = 5579,
  [5634] = 5581,
  [5635] = 5581,
  [5636] = 5581,
  [5637] = 5581,
  [5638] = 5638,
  [5639] = 5579,
  [5640] = 5640,
  [5641] = 5641,
  [5642] = 5642,
  [5643] = 5643,
  [5644] = 5644,
  [5645] = 5645,
  [5646] = 5646,
  [5647] = 5647,
  [5648] = 5648,
  [5649] = 5649,
  [5650] = 5650,
  [5651] = 5641,
  [5652] = 5652,
  [5653] = 5653,
  [5654] = 5654,
  [5655] = 5655,
  [5656] = 5656,
  [5657] = 5657,
  [5658] = 5658,
  [5659] = 5659,
  [5660] = 5660,
  [5661] = 5661,
  [5662] = 5662,
  [5663] = 5663,
  [5664] = 5664,
  [5665] = 5658,
  [5666] = 5666,
  [5667] = 5655,
  [5668] = 5668,
  [5669] = 5655,
  [5670] = 5670,
  [5671] = 5671,
  [5672] = 5672,
  [5673] = 5673,
  [5674] = 5674,
  [5675] = 5675,
  [5676] = 5676,
  [5677] = 5641,
  [5678] = 5641,
  [5679] = 5641,
  [5680] = 5658,
  [5681] = 5681,
  [5682] = 5682,
  [5683] = 5683,
  [5684] = 5658,
  [5685] = 5685,
  [5686] = 5642,
  [5687] = 5644,
  [5688] = 5688,
  [5689] = 5655,
  [5690] = 5658,
  [5691] = 5647,
  [5692] = 5648,
  [5693] = 5643,
  [5694] = 5694,
  [5695] = 5695,
  [5696] = 5696,
  [5697] = 5652,
  [5698] = 5698,
  [5699] = 5641,
  [5700] = 5644,
  [5701] = 5701,
  [5702] = 5645,
  [5703] = 5658,
  [5704] = 5704,
  [5705] = 5646,
  [5706] = 5706,
  [5707] = 5707,
  [5708] = 5708,
  [5709] = 5709,
  [5710] = 5641,
  [5711] = 5649,
  [5712] = 5658,
  [5713] = 5713,
  [5714] = 5681,
  [5715] = 5647,
  [5716] = 5658,
  [5717] = 5642,
  [5718] = 5658,
  [5719] = 5658,
  [5720] = 5658,
  [5721] = 5646,
  [5722] = 5658,
  [5723] = 5681,
  [5724] = 5724,
  [5725] = 5725,
  [5726] = 5659,
  [5727] = 5660,
  [5728] = 5661,
  [5729] = 5729,
  [5730] = 5663,
  [5731] = 5664,
  [5732] = 5658,
  [5733] = 5643,
  [5734] = 5645,
  [5735] = 5735,
  [5736] = 5658,
  [5737] = 5658,
  [5738] = 5671,
  [5739] = 5739,
  [5740] = 5735,
  [5741] = 5741,
  [5742] = 5657,
  [5743] = 5658,
  [5744] = 5744,
  [5745] = 5745,
  [5746] = 5662,
  [5747] = 5747,
  [5748] = 5748,
  [5749] = 5666,
  [5750] = 5668,
  [5751] = 5751,
  [5752] = 5752,
  [5753] = 5753,
  [5754] = 5754,
  [5755] = 5685,
  [5756] = 5640,
  [5757] = 5757,
  [5758] = 5758,
  [5759] = 5759,
  [5760] = 5652,
  [5761] = 5641,
  [5762] = 5762,
  [5763] = 5648,
  [5764] = 5674,
  [5765] = 5658,
  [5766] = 5647,
  [5767] = 5675,
  [5768] = 5676,
  [5769] = 5648,
  [5770] = 5653,
  [5771] = 5704,
  [5772] = 5682,
  [5773] = 5701,
  [5774] = 5649,
  [5775] = 5688,
  [5776] = 5698,
  [5777] = 5658,
  [5778] = 5698,
  [5779] = 5701,
  [5780] = 5688,
  [5781] = 5682,
  [5782] = 5676,
  [5783] = 5675,
  [5784] = 5674,
  [5785] = 5673,
  [5786] = 5645,
  [5787] = 5644,
  [5788] = 5668,
  [5789] = 5652,
  [5790] = 5666,
  [5791] = 5662,
  [5792] = 5657,
  [5793] = 5704,
  [5794] = 5671,
  [5795] = 5647,
  [5796] = 5648,
  [5797] = 5652,
  [5798] = 5658,
  [5799] = 5748,
  [5800] = 5747,
  [5801] = 5745,
  [5802] = 5641,
  [5803] = 5744,
  [5804] = 5658,
  [5805] = 5643,
  [5806] = 5681,
  [5807] = 5741,
  [5808] = 5808,
  [5809] = 5758,
  [5810] = 5642,
  [5811] = 5640,
  [5812] = 5673,
  [5813] = 5649,
  [5814] = 5708,
  [5815] = 5654,
  [5816] = 5707,
  [5817] = 5739,
  [5818] = 5658,
  [5819] = 5644,
  [5820] = 5706,
  [5821] = 5645,
  [5822] = 5725,
  [5823] = 5724,
  [5824] = 5646,
  [5825] = 5649,
  [5826] = 5696,
  [5827] = 5729,
  [5828] = 5695,
  [5829] = 5808,
  [5830] = 5694,
  [5831] = 5754,
  [5832] = 5753,
  [5833] = 5725,
  [5834] = 5642,
  [5835] = 5648,
  [5836] = 5752,
  [5837] = 5837,
  [5838] = 5647,
  [5839] = 5648,
  [5840] = 5652,
  [5841] = 5724,
  [5842] = 5646,
  [5843] = 5658,
  [5844] = 5654,
  [5845] = 5683,
  [5846] = 5645,
  [5847] = 5644,
  [5848] = 5848,
  [5849] = 5644,
  [5850] = 5658,
  [5851] = 5645,
  [5852] = 5646,
  [5853] = 5652,
  [5854] = 5751,
  [5855] = 5672,
  [5856] = 5658,
  [5857] = 5658,
  [5858] = 5658,
  [5859] = 5670,
  [5860] = 5685,
  [5861] = 5653,
  [5862] = 5641,
  [5863] = 5863,
  [5864] = 5748,
  [5865] = 5643,
  [5866] = 5762,
  [5867] = 5647,
  [5868] = 5643,
  [5869] = 5656,
  [5870] = 5642,
  [5871] = 5683,
  [5872] = 5655,
  [5873] = 5655,
  [5874] = 5641,
  [5875] = 5658,
  [5876] = 5658,
  [5877] = 5649,
  [5878] = 5658,
  [5879] = 5655,
  [5880] = 5880,
  [5881] = 5642,
  [5882] = 5654,
  [5883] = 5685,
  [5884] = 5649,
  [5885] = 5672,
  [5886] = 5642,
  [5887] = 5655,
  [5888] = 5658,
  [5889] = 5658,
  [5890] = 5641,
  [5891] = 5648,
  [5892] = 5652,
  [5893] = 5893,
  [5894] = 5649,
  [5895] = 5649,
  [5896] = 5642,
  [5897] = 5644,
  [5898] = 5681,
  [5899] = 5645,
  [5900] = 5646,
  [5901] = 5643,
  [5902] = 5902,
  [5903] = 5903,
  [5904] = 5904,
  [5905] = 5668,
  [5906] = 5654,
  [5907] = 5670,
  [5908] = 5641,
  [5909] = 5647,
  [5910] = 5648,
  [5911] = 5641,
  [5912] = 5708,
  [5913] = 5658,
  [5914] = 5647,
  [5915] = 5652,
  [5916] = 5640,
  [5917] = 5653,
  [5918] = 5644,
  [5919] = 5762,
  [5920] = 5645,
  [5921] = 5646,
  [5922] = 5646,
  [5923] = 5645,
  [5924] = 5641,
  [5925] = 5644,
  [5926] = 5658,
  [5927] = 5652,
  [5928] = 5648,
  [5929] = 5641,
  [5930] = 5658,
  [5931] = 5641,
  [5932] = 5658,
  [5933] = 5641,
  [5934] = 1906,
  [5935] = 5747,
  [5936] = 1915,
  [5937] = 5647,
  [5938] = 5745,
  [5939] = 5707,
  [5940] = 5658,
  [5941] = 5941,
  [5942] = 5942,
  [5943] = 5655,
  [5944] = 5739,
  [5945] = 5735,
  [5946] = 5641,
  [5947] = 5658,
  [5948] = 5641,
  [5949] = 5658,
  [5950] = 5658,
  [5951] = 5658,
  [5952] = 5641,
  [5953] = 5658,
  [5954] = 5954,
  [5955] = 5646,
  [5956] = 5655,
  [5957] = 5694,
  [5958] = 5668,
  [5959] = 5959,
  [5960] = 5903,
  [5961] = 5706,
  [5962] = 5962,
  [5963] = 5741,
  [5964] = 5954,
  [5965] = 5653,
  [5966] = 5848,
  [5967] = 5656,
  [5968] = 5641,
  [5969] = 5744,
  [5970] = 5658,
  [5971] = 5640,
  [5972] = 5641,
  [5973] = 5658,
  [5974] = 5658,
  [5975] = 5713,
  [5976] = 5655,
  [5977] = 5977,
  [5978] = 5641,
  [5979] = 5658,
  [5980] = 5658,
  [5981] = 5685,
  [5982] = 5696,
  [5983] = 5641,
  [5984] = 5984,
  [5985] = 5649,
  [5986] = 5695,
  [5987] = 5655,
  [5988] = 5642,
  [5989] = 5989,
  [5990] = 5990,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 279,
        '+', 335,
        ',', 271,
        '-', 353,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 361,
        '>', 330,
        '?', 317,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(172);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == 'd') ADVANCE(404);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`') ADVANCE(409);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(133);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead != 0) ADVANCE(1);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(79);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(79);
      if (lookahead == '\r') SKIP(2);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(78);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(78);
      if (lookahead == '\r') SKIP(4);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(80);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(80);
      if (lookahead == '\r') SKIP(6);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(81);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(81);
      if (lookahead == '\r') SKIP(8);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(102);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(102);
      if (lookahead == '\r') SKIP(10);
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(101);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(101);
      if (lookahead == '\r') SKIP(12);
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(115);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(115);
      if (lookahead == '\r') SKIP(14);
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(85);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(85);
      if (lookahead == '\r') SKIP(16);
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(87);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(87);
      if (lookahead == '\r') SKIP(18);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(91);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(91);
      if (lookahead == '\r') SKIP(20);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(94);
      END_STATE();
    case 23:
      if (lookahead == '\n') SKIP(94);
      if (lookahead == '\r') SKIP(22);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(92);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(92);
      if (lookahead == '\r') SKIP(24);
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(98);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(98);
      if (lookahead == '\r') SKIP(26);
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(107);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(107);
      if (lookahead == '\r') SKIP(28);
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(106);
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(106);
      if (lookahead == '\r') SKIP(30);
      END_STATE();
    case 32:
      if (lookahead == '\n') SKIP(116);
      END_STATE();
    case 33:
      if (lookahead == '\n') SKIP(116);
      if (lookahead == '\r') SKIP(32);
      END_STATE();
    case 34:
      if (lookahead == '\n') SKIP(105);
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(105);
      if (lookahead == '\r') SKIP(34);
      END_STATE();
    case 36:
      if (lookahead == '\n') SKIP(112);
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(112);
      if (lookahead == '\r') SKIP(36);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(113);
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(113);
      if (lookahead == '\r') SKIP(38);
      END_STATE();
    case 40:
      if (lookahead == '\n') ADVANCE(425);
      if (lookahead == '\r') ADVANCE(424);
      if (lookahead == 'u') ADVANCE(150);
      if (lookahead == 'x') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(428);
      if (lookahead != 0) ADVANCE(424);
      END_STATE();
    case 41:
      if (lookahead == '\n') ADVANCE(426);
      if (lookahead == '\r') ADVANCE(424);
      if (lookahead == 'u') ADVANCE(150);
      if (lookahead == 'x') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(428);
      if (lookahead != 0) ADVANCE(424);
      END_STATE();
    case 42:
      if (lookahead == '\n') SKIP(119);
      END_STATE();
    case 43:
      if (lookahead == '\n') SKIP(119);
      if (lookahead == '\r') SKIP(42);
      END_STATE();
    case 44:
      if (lookahead == '\n') SKIP(68);
      END_STATE();
    case 45:
      if (lookahead == '\n') SKIP(68);
      if (lookahead == '\r') SKIP(44);
      END_STATE();
    case 46:
      if (lookahead == '\n') SKIP(76);
      END_STATE();
    case 47:
      if (lookahead == '\n') SKIP(76);
      if (lookahead == '\r') SKIP(46);
      END_STATE();
    case 48:
      if (lookahead == '\n') SKIP(69);
      END_STATE();
    case 49:
      if (lookahead == '\n') SKIP(69);
      if (lookahead == '\r') SKIP(48);
      END_STATE();
    case 50:
      if (lookahead == '\n') SKIP(86);
      END_STATE();
    case 51:
      if (lookahead == '\n') SKIP(86);
      if (lookahead == '\r') SKIP(50);
      END_STATE();
    case 52:
      if (lookahead == '\n') SKIP(90);
      END_STATE();
    case 53:
      if (lookahead == '\n') SKIP(90);
      if (lookahead == '\r') SKIP(52);
      END_STATE();
    case 54:
      if (lookahead == '\n') SKIP(96);
      END_STATE();
    case 55:
      if (lookahead == '\n') SKIP(96);
      if (lookahead == '\r') SKIP(54);
      END_STATE();
    case 56:
      if (lookahead == '\n') SKIP(117);
      END_STATE();
    case 57:
      if (lookahead == '\n') SKIP(117);
      if (lookahead == '\r') SKIP(56);
      END_STATE();
    case 58:
      if (lookahead == '\n') SKIP(108);
      END_STATE();
    case 59:
      if (lookahead == '\n') SKIP(108);
      if (lookahead == '\r') SKIP(58);
      END_STATE();
    case 60:
      if (lookahead == '\n') SKIP(72);
      END_STATE();
    case 61:
      if (lookahead == '\n') SKIP(72);
      if (lookahead == '\r') SKIP(60);
      END_STATE();
    case 62:
      if (lookahead == '\n') SKIP(71);
      END_STATE();
    case 63:
      if (lookahead == '\n') SKIP(71);
      if (lookahead == '\r') SKIP(62);
      END_STATE();
    case 64:
      if (lookahead == '\n') SKIP(74);
      END_STATE();
    case 65:
      if (lookahead == '\n') SKIP(74);
      if (lookahead == '\r') SKIP(64);
      END_STATE();
    case 66:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(49);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 67:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(45);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 68:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 261,
        ')', 262,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 129,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(45);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 69:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 261,
        ')', 262,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 129,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(49);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 70:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 296,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 365,
        ':', 287,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(61);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(72);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 71:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 365,
        ':', 320,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(63);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(71);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 72:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 365,
        ':', 129,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(61);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(72);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 73:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 365,
        ':', 319,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(63);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(71);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 74:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 284,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '/', 337,
        '0', 365,
        ':', 320,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(65);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(74);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 75:
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '&', 124,
        '(', 296,
        '*', 277,
        '+', 333,
        '-', 137,
        '.', 264,
        '0', 365,
        ':', 128,
        ';', 275,
        '<', 289,
        '=', 142,
        '?', 140,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(47);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(76);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 76:
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '&', 124,
        '(', 261,
        '*', 277,
        '+', 333,
        '-', 137,
        '.', 264,
        '0', 365,
        ':', 129,
        ';', 275,
        '<', 289,
        '=', 142,
        '?', 140,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(47);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(76);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 77:
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '&', 124,
        '(', 261,
        '*', 277,
        '+', 333,
        '-', 137,
        '.', 264,
        '0', 365,
        ':', 128,
        ';', 275,
        '<', 289,
        '=', 142,
        '?', 140,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(47);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(76);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 78:
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 138,
        '?', 140,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(5);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(78);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 79:
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 142,
        '?', 140,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(3);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(79);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 80:
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 267,
        '?', 140,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(7);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(80);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 81:
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '(', 261,
        '*', 278,
        '+', 333,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        '=', 142,
        '?', 140,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(9);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(81);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 82:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(17);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(85);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 83:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(19);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(87);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 84:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 319,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(51);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(86);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 85:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 129,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(17);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(85);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 86:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 318,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(51);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(86);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 87:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(19);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(87);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 88:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 285,
        '(', 296,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ':', 287,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(21);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(91);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 89:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 285,
        '(', 296,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ':', 319,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(53);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(90);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 90:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 285,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ':', 318,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(53);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(90);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 91:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 285,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(21);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(91);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 92:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 284,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 125,
        '/', 337,
        ':', 318,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(25);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(92);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 93:
      ADVANCE_MAP(
        '!', 350,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 282,
        '(', 261,
        '*', 278,
        '+', 336,
        '-', 353,
        '.', 127,
        '/', 337,
        ':', 286,
        '<', 291,
        '=', 132,
        '>', 331,
        '@', 139,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(23);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(94);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 94:
      ADVANCE_MAP(
        '!', 350,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 282,
        '(', 261,
        '*', 278,
        '+', 336,
        '-', 353,
        '.', 127,
        '/', 337,
        '<', 291,
        '=', 132,
        '>', 331,
        '@', 139,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(23);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(94);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 95:
      ADVANCE_MAP(
        '!', 350,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 282,
        '*', 278,
        '+', 336,
        '-', 353,
        '.', 127,
        '/', 337,
        '<', 291,
        '=', 361,
        '>', 331,
        '@', 139,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(55);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(96);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 96:
      ADVANCE_MAP(
        '!', 350,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 282,
        '*', 278,
        '+', 336,
        '-', 353,
        '.', 127,
        '/', 337,
        '<', 291,
        '=', 132,
        '>', 331,
        '@', 139,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(55);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(96);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 97:
      ADVANCE_MAP(
        '!', 350,
        '#', 363,
        '%', 339,
        '&', 282,
        '(', 296,
        '*', 278,
        '+', 336,
        '-', 353,
        '.', 127,
        '/', 337,
        '<', 291,
        '=', 132,
        '>', 331,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(27);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(98);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 98:
      ADVANCE_MAP(
        '!', 350,
        '#', 363,
        '%', 339,
        '&', 282,
        '*', 278,
        '+', 336,
        '-', 353,
        '.', 127,
        '/', 337,
        '<', 291,
        '=', 132,
        '>', 331,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(27);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(98);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 99:
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') ADVANCE(40);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(422);
      END_STATE();
    case 100:
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') ADVANCE(41);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(100);
      END_STATE();
    case 101:
      ADVANCE_MAP(
        '#', 363,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 138,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(13);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(101);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(380);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 102:
      ADVANCE_MAP(
        '#', 363,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 267,
        '?', 140,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(11);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(102);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 103:
      ADVANCE_MAP(
        '#', 363,
        '&', 282,
        '(', 261,
        ')', 262,
        '*', 278,
        ',', 271,
        '.', 125,
        ':', 286,
        ';', 275,
        '=', 138,
      );
      if (lookahead == '\\') SKIP(35);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(105);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 104:
      ADVANCE_MAP(
        '#', 363,
        '&', 282,
        '(', 261,
        ')', 262,
        '*', 278,
        ',', 271,
        '.', 125,
        ':', 286,
        ';', 275,
        '=', 270,
      );
      if (lookahead == '\\') SKIP(31);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(106);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 105:
      ADVANCE_MAP(
        '#', 363,
        '&', 282,
        '(', 261,
        ')', 262,
        '*', 278,
        ',', 271,
        '.', 125,
        ';', 275,
        '=', 138,
      );
      if (lookahead == '\\') SKIP(35);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(105);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 106:
      ADVANCE_MAP(
        '#', 363,
        '&', 282,
        '(', 261,
        ')', 262,
        '*', 278,
        ',', 271,
        '.', 125,
        ';', 275,
        '=', 270,
      );
      if (lookahead == '\\') SKIP(31);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(106);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 107:
      ADVANCE_MAP(
        '#', 363,
        '&', 282,
        '(', 261,
        ')', 262,
        '*', 278,
        ',', 271,
        '.', 265,
        ':', 129,
        ';', 275,
        '=', 270,
      );
      if (lookahead == '\\') SKIP(29);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(107);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 108:
      ADVANCE_MAP(
        '#', 363,
        '&', 282,
        '(', 261,
        '*', 278,
        '.', 265,
        ':', 129,
        ';', 275,
        '=', 267,
      );
      if (lookahead == '\\') SKIP(59);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(108);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 109:
      ADVANCE_MAP(
        '#', 363,
        '&', 282,
        '(', 261,
        '*', 278,
        '.', 265,
        ':', 129,
        ';', 275,
        '=', 360,
      );
      if (lookahead == '\\') SKIP(59);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(108);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 110:
      ADVANCE_MAP(
        '#', 363,
        '&', 124,
        '(', 296,
        ')', 262,
        ',', 271,
        '.', 263,
        ':', 128,
        ';', 275,
        '=', 138,
      );
      if (lookahead == '\\') SKIP(37);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(112);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 111:
      ADVANCE_MAP(
        '#', 363,
        '&', 124,
        '(', 296,
        ')', 262,
        ',', 271,
        '.', 263,
        ':', 128,
        '=', 267,
      );
      if (lookahead == '\\') SKIP(39);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(113);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 112:
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(37);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(112);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 113:
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == '=') ADVANCE(267);
      if (lookahead == '\\') SKIP(39);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(113);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 114:
      ADVANCE_MAP(
        '#', 363,
        '(', 296,
        ')', 262,
        ',', 271,
        ':', 288,
        ';', 275,
        '=', 138,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(33);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(116);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 115:
      ADVANCE_MAP(
        '#', 363,
        '(', 261,
        ')', 262,
        '*', 278,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 142,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(15);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(115);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 116:
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == ':') ADVANCE(129);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(33);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(116);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 117:
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') SKIP(57);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(117);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 118:
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(360);
      if (lookahead == '\\') SKIP(57);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(117);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 119:
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') SKIP(43);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(423);
      END_STATE();
    case 120:
      if (lookahead == '*') ADVANCE(281);
      END_STATE();
    case 121:
      if (lookahead == '*') ADVANCE(136);
      if (lookahead == '=') ADVANCE(305);
      END_STATE();
    case 122:
      if (lookahead == '-') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(414);
      if (lookahead == '!' ||
          lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '&' ||
          lookahead == '\'' ||
          ('*' <= lookahead && lookahead <= '@') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '~') ADVANCE(413);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(415);
      END_STATE();
    case 123:
      if (lookahead == '-') ADVANCE(169);
      END_STATE();
    case 124:
      if (lookahead == '.') ADVANCE(302);
      END_STATE();
    case 125:
      if (lookahead == '.') ADVANCE(298);
      END_STATE();
    case 126:
      if (lookahead == '.') ADVANCE(276);
      END_STATE();
    case 127:
      if (lookahead == '.') ADVANCE(297);
      END_STATE();
    case 128:
      if (lookahead == ':') ADVANCE(301);
      END_STATE();
    case 129:
      if (lookahead == ':') ADVANCE(266);
      END_STATE();
    case 130:
      if (lookahead == '=') ADVANCE(342);
      if (lookahead == '~') ADVANCE(346);
      END_STATE();
    case 131:
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == '>') ADVANCE(292);
      if (lookahead == 'b') ADVANCE(144);
      if (lookahead == '~') ADVANCE(345);
      END_STATE();
    case 132:
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == 'b') ADVANCE(144);
      if (lookahead == '~') ADVANCE(345);
      END_STATE();
    case 133:
      if (lookahead == '=') ADVANCE(145);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '*') ADVANCE(133);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 134:
      if (lookahead == '=') ADVANCE(304);
      END_STATE();
    case 135:
      if (lookahead == '=') ADVANCE(304);
      if (lookahead == '>') ADVANCE(430);
      END_STATE();
    case 136:
      if (lookahead == '=') ADVANCE(306);
      END_STATE();
    case 137:
      if (lookahead == '>') ADVANCE(430);
      END_STATE();
    case 138:
      if (lookahead == '>') ADVANCE(292);
      if (lookahead == 'b') ADVANCE(144);
      END_STATE();
    case 139:
      if (lookahead == '@') ADVANCE(168);
      if (lookahead > '@' &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(411);
      END_STATE();
    case 140:
      if (lookahead == '\\') ADVANCE(420);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(416);
      END_STATE();
    case 141:
      if (lookahead == ']') ADVANCE(357);
      END_STATE();
    case 142:
      if (lookahead == 'b') ADVANCE(144);
      END_STATE();
    case 143:
      if (lookahead == 'd') ADVANCE(363);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(146);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(149);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 146:
      if (lookahead == 'g') ADVANCE(147);
      END_STATE();
    case 147:
      if (lookahead == 'i') ADVANCE(148);
      END_STATE();
    case 148:
      if (lookahead == 'n') ADVANCE(1);
      END_STATE();
    case 149:
      if (lookahead == 'n') ADVANCE(143);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 150:
      if (lookahead == '{') ADVANCE(166);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(165);
      END_STATE();
    case 151:
      if (lookahead == '}') ADVANCE(416);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(151);
      END_STATE();
    case 152:
      if (lookahead == '}') ADVANCE(424);
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(152);
      END_STATE();
    case 153:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(372);
      END_STATE();
    case 154:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(367);
      END_STATE();
    case 155:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(366);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(364);
      END_STATE();
    case 156:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(368);
      END_STATE();
    case 157:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(366);
      END_STATE();
    case 158:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(371);
      END_STATE();
    case 159:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(370);
      END_STATE();
    case 160:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(372);
      END_STATE();
    case 161:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(369);
      END_STATE();
    case 162:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(424);
      END_STATE();
    case 163:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(429);
      END_STATE();
    case 164:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(162);
      END_STATE();
    case 165:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(164);
      END_STATE();
    case 166:
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(152);
      END_STATE();
    case 167:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(413);
      END_STATE();
    case 168:
      if (lookahead > '@' &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(412);
      END_STATE();
    case 169:
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(416);
      END_STATE();
    case 170:
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(418);
      END_STATE();
    case 171:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(207);
      END_STATE();
    case 172:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(207);
      if (lookahead == '\r') SKIP(171);
      END_STATE();
    case 173:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(214);
      END_STATE();
    case 174:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(214);
      if (lookahead == '\r') SKIP(173);
      END_STATE();
    case 175:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(215);
      END_STATE();
    case 176:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(215);
      if (lookahead == '\r') SKIP(175);
      END_STATE();
    case 177:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(223);
      END_STATE();
    case 178:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(223);
      if (lookahead == '\r') SKIP(177);
      END_STATE();
    case 179:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(231);
      END_STATE();
    case 180:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(231);
      if (lookahead == '\r') SKIP(179);
      END_STATE();
    case 181:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(218);
      END_STATE();
    case 182:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(218);
      if (lookahead == '\r') SKIP(181);
      END_STATE();
    case 183:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(219);
      END_STATE();
    case 184:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(219);
      if (lookahead == '\r') SKIP(183);
      END_STATE();
    case 185:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(221);
      END_STATE();
    case 186:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(221);
      if (lookahead == '\r') SKIP(185);
      END_STATE();
    case 187:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(229);
      END_STATE();
    case 188:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(229);
      if (lookahead == '\r') SKIP(187);
      END_STATE();
    case 189:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(228);
      END_STATE();
    case 190:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(228);
      if (lookahead == '\r') SKIP(189);
      END_STATE();
    case 191:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(227);
      END_STATE();
    case 192:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(227);
      if (lookahead == '\r') SKIP(191);
      END_STATE();
    case 193:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(234);
      END_STATE();
    case 194:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(234);
      if (lookahead == '\r') SKIP(193);
      END_STATE();
    case 195:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(233);
      END_STATE();
    case 196:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(233);
      if (lookahead == '\r') SKIP(195);
      END_STATE();
    case 197:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(209);
      END_STATE();
    case 198:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(209);
      if (lookahead == '\r') SKIP(197);
      END_STATE();
    case 199:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(222);
      END_STATE();
    case 200:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(222);
      if (lookahead == '\r') SKIP(199);
      END_STATE();
    case 201:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(235);
      END_STATE();
    case 202:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(235);
      if (lookahead == '\r') SKIP(201);
      END_STATE();
    case 203:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(211);
      END_STATE();
    case 204:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(211);
      if (lookahead == '\r') SKIP(203);
      END_STATE();
    case 205:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(213);
      END_STATE();
    case 206:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(213);
      if (lookahead == '\r') SKIP(205);
      END_STATE();
    case 207:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 261,
        ')', 262,
        '*', 279,
        '+', 335,
        ',', 271,
        '-', 353,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 320,
        ';', 275,
        '<', 290,
        '=', 269,
        '>', 330,
        '?', 317,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(172);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == 'd') ADVANCE(404);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`') ADVANCE(409);
      END_STATE();
    case 208:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 296,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(198);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 209:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 261,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 129,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(198);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 210:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 296,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 365,
        ':', 287,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(204);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(211);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 211:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 261,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 365,
        ':', 129,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(204);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(211);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 212:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 261,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 365,
        ':', 128,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(204);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(211);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 213:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 284,
        '(', 261,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '/', 337,
        '0', 365,
        ':', 129,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(206);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(213);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 214:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 138,
        '?', 140,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(174);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(214);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`') ADVANCE(396);
      END_STATE();
    case 215:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '(', 261,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 142,
        '?', 140,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(176);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(215);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 216:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(182);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(218);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 217:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        '(', 296,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(184);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 218:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 129,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(182);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(218);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 219:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(184);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 220:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 285,
        '(', 296,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ':', 287,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(186);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 221:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 285,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(186);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 222:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 284,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 125,
        '/', 337,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(200);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(222);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 223:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 363,
        '$', 122,
        '(', 261,
        '+', 333,
        ',', 271,
        '-', 137,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 267,
        '?', 140,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(178);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(223);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 224:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 363,
        '&', 124,
        '(', 296,
        ')', 262,
        ',', 271,
        '.', 263,
        ':', 128,
        ';', 275,
        '=', 267,
      );
      if (lookahead == '\\') SKIP(190);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(228);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 225:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 363,
        '&', 124,
        '(', 296,
        '*', 120,
        ',', 271,
        '.', 263,
        ':', 128,
        ';', 275,
        '=', 142,
      );
      if (lookahead == '\\') SKIP(188);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == '{') ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(229);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 226:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 363,
        '&', 124,
        ')', 262,
        ',', 271,
        '.', 263,
        ':', 128,
        ';', 275,
        '=', 138,
      );
      if (lookahead == '\\') SKIP(192);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(227);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 227:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(192);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(227);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 228:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(267);
      if (lookahead == '\\') SKIP(190);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(228);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 229:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '*') ADVANCE(120);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') SKIP(188);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == '{') ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(229);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 230:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 363,
        '(', 296,
        ')', 262,
        ',', 271,
        '.', 263,
        ':', 288,
        ';', 275,
        '=', 138,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(194);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 231:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 363,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 138,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(180);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(231);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(380);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 232:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == ':') ADVANCE(286);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(196);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(233);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 233:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(196);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(233);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 234:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == ':') ADVANCE(129);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(194);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 235:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') SKIP(202);
      if (lookahead == '_') ADVANCE(400);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(235);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 236:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(360);
      if (lookahead == '\\') SKIP(202);
      if (lookahead == '_') ADVANCE(400);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(235);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(aux_sym_program_token1);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym___END__);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(238);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym___END__);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(238);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(246);
      if (lookahead == '\r') ADVANCE(243);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(246);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(256);
      if (lookahead != 0) ADVANCE(244);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(247);
      if (lookahead == '\r') ADVANCE(245);
      if (lookahead != 0) ADVANCE(245);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '#') ADVANCE(244);
      if (lookahead == '=') ADVANCE(248);
      if (lookahead == '\\') ADVANCE(242);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(246);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '=') ADVANCE(251);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '*') ADVANCE(247);
      if (lookahead != 0) ADVANCE(247);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'b') ADVANCE(250);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'd') ADVANCE(244);
      if (lookahead != 0) ADVANCE(247);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'e') ADVANCE(252);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'e') ADVANCE(254);
      if (lookahead != 0) ADVANCE(247);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'g') ADVANCE(253);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'i') ADVANCE(255);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'n') ADVANCE(249);
      if (lookahead != 0) ADVANCE(247);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'n') ADVANCE(245);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_BEGIN);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_END);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(298);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(126);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == '>') ADVANCE(292);
      if (lookahead == '~') ADVANCE(345);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == '~') ADVANCE(345);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(292);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(309);
      if (lookahead == '|') ADVANCE(322);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(321);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(281);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(281);
      if (lookahead == '=') ADVANCE(305);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(136);
      if (lookahead == '=') ADVANCE(305);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(324);
      if (lookahead == '.') ADVANCE(302);
      if (lookahead == '=') ADVANCE(311);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(323);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(323);
      if (lookahead == '.') ADVANCE(302);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(301);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(266);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(326);
      if (lookahead == '=') ADVANCE(329);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(325);
      if (lookahead == '=') ADVANCE(329);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(276);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(315);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_COLON_COLON2);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_AMP_DOT);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\') ADVANCE(420);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(416);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_COLON2);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':') ADVANCE(301);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':') ADVANCE(266);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(308);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(310);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(314);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(313);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(344);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(332);
      if (lookahead == '>') ADVANCE(328);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(332);
      if (lookahead == '>') ADVANCE(327);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(303);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '@') ADVANCE(354);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '@') ADVANCE(354);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=') ADVANCE(307);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(312);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(343);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_BANG_TILDE);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_defined_QMARK);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(342);
      if (lookahead == '~') ADVANCE(346);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '~') ADVANCE(346);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '@') ADVANCE(356);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '@') ADVANCE(355);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(anon_sym_PLUS_AT);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_DASH_AT);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_TILDE_AT);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      if (lookahead == '=') ADVANCE(358);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK_EQ);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_EQ2);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_EQ2);
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == '~') ADVANCE(345);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '{') ADVANCE(421);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(363);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(363);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(158);
      if (lookahead == '_') ADVANCE(155);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(153);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(366);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(364);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym_integer);
      ADVANCE_MAP(
        '.', 158,
        '_', 157,
        'B', 154,
        'b', 154,
        'D', 159,
        'd', 159,
        'E', 153,
        'e', 153,
        'O', 156,
        'o', 156,
        'X', 161,
        'x', 161,
        '8', 366,
        '9', 366,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(364);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(158);
      if (lookahead == '_') ADVANCE(157);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(366);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(154);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(367);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(368);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(369);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(159);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(370);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(158);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(371);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(372);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead == 'D') ADVANCE(260);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead == 'E') ADVANCE(375);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead == 'G') ADVANCE(376);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead == 'I') ADVANCE(378);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead == 'N') ADVANCE(373);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead == 'N') ADVANCE(257);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(380);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(aux_sym_constant_suffix_token1);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(347);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(347);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'D') ADVANCE(389);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'E') ADVANCE(386);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'N') ADVANCE(384);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == '_') ADVANCE(385);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == '_') ADVANCE(239);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == '_') ADVANCE(388);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'd') ADVANCE(383);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'e') ADVANCE(393);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'e') ADVANCE(390);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'f') ADVANCE(394);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'i') ADVANCE(395);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'n') ADVANCE(392);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'D') ADVANCE(402);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(399);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'N') ADVANCE(397);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(398);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(240);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(401);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(382);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(406);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(403);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(407);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(408);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(405);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(aux_sym_identifier_suffix_token1);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(sym_instance_variable);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(411);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(sym_class_variable);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(412);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(sym_global_variable);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(414);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(415);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(sym_character);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == '-') ADVANCE(170);
      if (lookahead == '{') ADVANCE(151);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(419);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == 'C' ||
          lookahead == 'M') ADVANCE(123);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(sym_character);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(419);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(sym_character);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(417);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACE);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(aux_sym_string_array_token1);
      if (lookahead == '\\') ADVANCE(40);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(422);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(aux_sym_string_array_token1);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(423);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(40);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(422);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(41);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(424);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(427);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(424);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '\\') SKIP(1);
      if (lookahead == '_') ADVANCE(2);
      if (lookahead == 'a') ADVANCE(3);
      if (lookahead == 'b') ADVANCE(4);
      if (lookahead == 'c') ADVANCE(5);
      if (lookahead == 'd') ADVANCE(6);
      if (lookahead == 'e') ADVANCE(7);
      if (lookahead == 'f') ADVANCE(8);
      if (lookahead == 'i') ADVANCE(9);
      if (lookahead == 'm') ADVANCE(10);
      if (lookahead == 'n') ADVANCE(11);
      if (lookahead == 'o') ADVANCE(12);
      if (lookahead == 'r') ADVANCE(13);
      if (lookahead == 's') ADVANCE(14);
      if (lookahead == 't') ADVANCE(15);
      if (lookahead == 'u') ADVANCE(16);
      if (lookahead == 'w') ADVANCE(17);
      if (lookahead == 'y') ADVANCE(18);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(19);
      if (lookahead == '\r') SKIP(20);
      END_STATE();
    case 2:
      if (lookahead == '_') ADVANCE(21);
      END_STATE();
    case 3:
      if (lookahead == 'l') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(24);
      if (lookahead == 'r') ADVANCE(25);
      END_STATE();
    case 5:
      if (lookahead == 'a') ADVANCE(26);
      if (lookahead == 'l') ADVANCE(27);
      END_STATE();
    case 6:
      if (lookahead == 'e') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 7:
      if (lookahead == 'l') ADVANCE(30);
      if (lookahead == 'n') ADVANCE(31);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(32);
      if (lookahead == 'o') ADVANCE(33);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_i);
      if (lookahead == 'f') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      END_STATE();
    case 10:
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(37);
      if (lookahead == 'i') ADVANCE(38);
      if (lookahead == 'o') ADVANCE(39);
      END_STATE();
    case 12:
      if (lookahead == 'r') ADVANCE(40);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_r);
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'i') ADVANCE(42);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 'u') ADVANCE(44);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(45);
      if (lookahead == 'r') ADVANCE(46);
      END_STATE();
    case 16:
      if (lookahead == 'n') ADVANCE(47);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(48);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(49);
      END_STATE();
    case 19:
      if (lookahead == '\\') SKIP(1);
      if (lookahead == '_') ADVANCE(2);
      if (lookahead == 'a') ADVANCE(3);
      if (lookahead == 'b') ADVANCE(4);
      if (lookahead == 'c') ADVANCE(5);
      if (lookahead == 'd') ADVANCE(6);
      if (lookahead == 'e') ADVANCE(7);
      if (lookahead == 'f') ADVANCE(8);
      if (lookahead == 'i') ADVANCE(50);
      if (lookahead == 'm') ADVANCE(10);
      if (lookahead == 'n') ADVANCE(11);
      if (lookahead == 'o') ADVANCE(12);
      if (lookahead == 'r') ADVANCE(51);
      if (lookahead == 's') ADVANCE(14);
      if (lookahead == 't') ADVANCE(15);
      if (lookahead == 'u') ADVANCE(16);
      if (lookahead == 'w') ADVANCE(17);
      if (lookahead == 'y') ADVANCE(18);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(19);
      END_STATE();
    case 21:
      if (lookahead == 'E') ADVANCE(52);
      if (lookahead == 'F') ADVANCE(53);
      if (lookahead == 'L') ADVANCE(54);
      END_STATE();
    case 22:
      if (lookahead == 'i') ADVANCE(55);
      END_STATE();
    case 23:
      if (lookahead == 'd') ADVANCE(56);
      END_STATE();
    case 24:
      if (lookahead == 'g') ADVANCE(57);
      END_STATE();
    case 25:
      if (lookahead == 'e') ADVANCE(58);
      END_STATE();
    case 26:
      if (lookahead == 's') ADVANCE(59);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(60);
      END_STATE();
    case 28:
      if (lookahead == 'f') ADVANCE(61);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 30:
      if (lookahead == 's') ADVANCE(62);
      END_STATE();
    case 31:
      if (lookahead == 'd') ADVANCE(63);
      if (lookahead == 's') ADVANCE(64);
      END_STATE();
    case 32:
      if (lookahead == 'l') ADVANCE(65);
      END_STATE();
    case 33:
      if (lookahead == 'r') ADVANCE(66);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 36:
      if (lookahead == 'd') ADVANCE(67);
      END_STATE();
    case 37:
      if (lookahead == 'x') ADVANCE(68);
      END_STATE();
    case 38:
      if (lookahead == 'l') ADVANCE(69);
      END_STATE();
    case 39:
      if (lookahead == 't') ADVANCE(70);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 41:
      if (lookahead == 'd') ADVANCE(71);
      if (lookahead == 's') ADVANCE(72);
      if (lookahead == 't') ADVANCE(73);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_ri);
      END_STATE();
    case 43:
      if (lookahead == 'l') ADVANCE(74);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(75);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(76);
      END_STATE();
    case 46:
      if (lookahead == 'u') ADVANCE(77);
      END_STATE();
    case 47:
      if (lookahead == 'd') ADVANCE(78);
      if (lookahead == 'l') ADVANCE(79);
      if (lookahead == 't') ADVANCE(80);
      END_STATE();
    case 48:
      if (lookahead == 'e') ADVANCE(81);
      if (lookahead == 'i') ADVANCE(82);
      END_STATE();
    case 49:
      if (lookahead == 'e') ADVANCE(83);
      END_STATE();
    case 50:
      if (lookahead == 'f') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(41);
      END_STATE();
    case 52:
      if (lookahead == 'N') ADVANCE(84);
      END_STATE();
    case 53:
      if (lookahead == 'I') ADVANCE(85);
      END_STATE();
    case 54:
      if (lookahead == 'I') ADVANCE(86);
      END_STATE();
    case 55:
      if (lookahead == 'a') ADVANCE(87);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 57:
      if (lookahead == 'i') ADVANCE(88);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(89);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 60:
      if (lookahead == 's') ADVANCE(91);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(92);
      if (lookahead == 'i') ADVANCE(93);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(94);
      END_STATE();
    case 65:
      if (lookahead == 's') ADVANCE(95);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 67:
      if (lookahead == 'u') ADVANCE(96);
      END_STATE();
    case 68:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_nil);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 71:
      if (lookahead == 'o') ADVANCE(98);
      END_STATE();
    case 72:
      if (lookahead == 'c') ADVANCE(99);
      END_STATE();
    case 73:
      if (lookahead == 'r') ADVANCE(100);
      if (lookahead == 'u') ADVANCE(101);
      END_STATE();
    case 74:
      if (lookahead == 'f') ADVANCE(102);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(103);
      END_STATE();
    case 76:
      if (lookahead == 'n') ADVANCE(104);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(105);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(106);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 80:
      if (lookahead == 'i') ADVANCE(108);
      END_STATE();
    case 81:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(110);
      END_STATE();
    case 83:
      if (lookahead == 'l') ADVANCE(111);
      END_STATE();
    case 84:
      if (lookahead == 'C') ADVANCE(112);
      END_STATE();
    case 85:
      if (lookahead == 'L') ADVANCE(113);
      END_STATE();
    case 86:
      if (lookahead == 'N') ADVANCE(114);
      END_STATE();
    case 87:
      if (lookahead == 's') ADVANCE(115);
      END_STATE();
    case 88:
      if (lookahead == 'n') ADVANCE(116);
      END_STATE();
    case 89:
      if (lookahead == 'k') ADVANCE(117);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 91:
      if (lookahead == 's') ADVANCE(118);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 93:
      if (lookahead == 'f') ADVANCE(119);
      END_STATE();
    case 94:
      if (lookahead == 'r') ADVANCE(120);
      END_STATE();
    case 95:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 96:
      if (lookahead == 'l') ADVANCE(122);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_next);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_redo);
      END_STATE();
    case 99:
      if (lookahead == 'u') ADVANCE(123);
      END_STATE();
    case 100:
      if (lookahead == 'y') ADVANCE(124);
      END_STATE();
    case 101:
      if (lookahead == 'r') ADVANCE(125);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 103:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 106:
      if (lookahead == 'f') ADVANCE(127);
      END_STATE();
    case 107:
      if (lookahead == 's') ADVANCE(128);
      END_STATE();
    case 108:
      if (lookahead == 'l') ADVANCE(129);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 111:
      if (lookahead == 'd') ADVANCE(131);
      END_STATE();
    case 112:
      if (lookahead == 'O') ADVANCE(132);
      END_STATE();
    case 113:
      if (lookahead == 'E') ADVANCE(133);
      END_STATE();
    case 114:
      if (lookahead == 'E') ADVANCE(134);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_elsif);
      END_STATE();
    case 120:
      if (lookahead == 'e') ADVANCE(135);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(137);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_retry);
      END_STATE();
    case 125:
      if (lookahead == 'n') ADVANCE(138);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_undef);
      END_STATE();
    case 128:
      if (lookahead == 's') ADVANCE(139);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 132:
      if (lookahead == 'D') ADVANCE(140);
      END_STATE();
    case 133:
      if (lookahead == '_') ADVANCE(141);
      END_STATE();
    case 134:
      if (lookahead == '_') ADVANCE(142);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_ensure);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_rescue);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_unless);
      END_STATE();
    case 140:
      if (lookahead == 'I') ADVANCE(143);
      END_STATE();
    case 141:
      if (lookahead == '_') ADVANCE(144);
      END_STATE();
    case 142:
      if (lookahead == '_') ADVANCE(145);
      END_STATE();
    case 143:
      if (lookahead == 'N') ADVANCE(146);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_file);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_line);
      END_STATE();
    case 146:
      if (lookahead == 'G') ADVANCE(147);
      END_STATE();
    case 147:
      if (lookahead == '_') ADVANCE(148);
      END_STATE();
    case 148:
      if (lookahead == '_') ADVANCE(149);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_encoding);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 214, .external_lex_state = 2},
  [2] = {.lex_state = 67, .external_lex_state = 3},
  [3] = {.lex_state = 67, .external_lex_state = 3},
  [4] = {.lex_state = 67, .external_lex_state = 3},
  [5] = {.lex_state = 67, .external_lex_state = 3},
  [6] = {.lex_state = 67, .external_lex_state = 3},
  [7] = {.lex_state = 67, .external_lex_state = 3},
  [8] = {.lex_state = 208, .external_lex_state = 3},
  [9] = {.lex_state = 208, .external_lex_state = 3},
  [10] = {.lex_state = 208, .external_lex_state = 3},
  [11] = {.lex_state = 208, .external_lex_state = 3},
  [12] = {.lex_state = 208, .external_lex_state = 3},
  [13] = {.lex_state = 208, .external_lex_state = 3},
  [14] = {.lex_state = 67, .external_lex_state = 3},
  [15] = {.lex_state = 67, .external_lex_state = 3},
  [16] = {.lex_state = 67, .external_lex_state = 3},
  [17] = {.lex_state = 67, .external_lex_state = 3},
  [18] = {.lex_state = 67, .external_lex_state = 3},
  [19] = {.lex_state = 67, .external_lex_state = 3},
  [20] = {.lex_state = 67, .external_lex_state = 3},
  [21] = {.lex_state = 67, .external_lex_state = 3},
  [22] = {.lex_state = 67, .external_lex_state = 4},
  [23] = {.lex_state = 67, .external_lex_state = 4},
  [24] = {.lex_state = 67, .external_lex_state = 3},
  [25] = {.lex_state = 67, .external_lex_state = 4},
  [26] = {.lex_state = 67, .external_lex_state = 3},
  [27] = {.lex_state = 67, .external_lex_state = 3},
  [28] = {.lex_state = 67, .external_lex_state = 4},
  [29] = {.lex_state = 67, .external_lex_state = 3},
  [30] = {.lex_state = 67, .external_lex_state = 3},
  [31] = {.lex_state = 67, .external_lex_state = 3},
  [32] = {.lex_state = 67, .external_lex_state = 3},
  [33] = {.lex_state = 67, .external_lex_state = 3},
  [34] = {.lex_state = 67, .external_lex_state = 4},
  [35] = {.lex_state = 67, .external_lex_state = 4},
  [36] = {.lex_state = 67, .external_lex_state = 4},
  [37] = {.lex_state = 67, .external_lex_state = 4},
  [38] = {.lex_state = 67, .external_lex_state = 4},
  [39] = {.lex_state = 67, .external_lex_state = 4},
  [40] = {.lex_state = 67, .external_lex_state = 4},
  [41] = {.lex_state = 67, .external_lex_state = 4},
  [42] = {.lex_state = 70, .external_lex_state = 3},
  [43] = {.lex_state = 70, .external_lex_state = 3},
  [44] = {.lex_state = 70, .external_lex_state = 3},
  [45] = {.lex_state = 70, .external_lex_state = 3},
  [46] = {.lex_state = 70, .external_lex_state = 3},
  [47] = {.lex_state = 70, .external_lex_state = 3},
  [48] = {.lex_state = 70, .external_lex_state = 3},
  [49] = {.lex_state = 70, .external_lex_state = 3},
  [50] = {.lex_state = 70, .external_lex_state = 3},
  [51] = {.lex_state = 70, .external_lex_state = 3},
  [52] = {.lex_state = 70, .external_lex_state = 3},
  [53] = {.lex_state = 210, .external_lex_state = 3},
  [54] = {.lex_state = 210, .external_lex_state = 3},
  [55] = {.lex_state = 210, .external_lex_state = 3},
  [56] = {.lex_state = 70, .external_lex_state = 3},
  [57] = {.lex_state = 210, .external_lex_state = 3},
  [58] = {.lex_state = 70, .external_lex_state = 3},
  [59] = {.lex_state = 210, .external_lex_state = 3},
  [60] = {.lex_state = 210, .external_lex_state = 3},
  [61] = {.lex_state = 210, .external_lex_state = 3},
  [62] = {.lex_state = 70, .external_lex_state = 3},
  [63] = {.lex_state = 70, .external_lex_state = 3},
  [64] = {.lex_state = 70, .external_lex_state = 4},
  [65] = {.lex_state = 210, .external_lex_state = 3},
  [66] = {.lex_state = 70, .external_lex_state = 3},
  [67] = {.lex_state = 210, .external_lex_state = 3},
  [68] = {.lex_state = 210, .external_lex_state = 3},
  [69] = {.lex_state = 70, .external_lex_state = 3},
  [70] = {.lex_state = 210, .external_lex_state = 3},
  [71] = {.lex_state = 70, .external_lex_state = 4},
  [72] = {.lex_state = 70, .external_lex_state = 3},
  [73] = {.lex_state = 70, .external_lex_state = 3},
  [74] = {.lex_state = 70, .external_lex_state = 3},
  [75] = {.lex_state = 70, .external_lex_state = 3},
  [76] = {.lex_state = 70, .external_lex_state = 4},
  [77] = {.lex_state = 70, .external_lex_state = 3},
  [78] = {.lex_state = 70, .external_lex_state = 4},
  [79] = {.lex_state = 70, .external_lex_state = 3},
  [80] = {.lex_state = 70, .external_lex_state = 4},
  [81] = {.lex_state = 70, .external_lex_state = 4},
  [82] = {.lex_state = 70, .external_lex_state = 3},
  [83] = {.lex_state = 70, .external_lex_state = 3},
  [84] = {.lex_state = 70, .external_lex_state = 3},
  [85] = {.lex_state = 70, .external_lex_state = 3},
  [86] = {.lex_state = 70, .external_lex_state = 3},
  [87] = {.lex_state = 70, .external_lex_state = 3},
  [88] = {.lex_state = 70, .external_lex_state = 3},
  [89] = {.lex_state = 70, .external_lex_state = 3},
  [90] = {.lex_state = 70, .external_lex_state = 4},
  [91] = {.lex_state = 70, .external_lex_state = 3},
  [92] = {.lex_state = 70, .external_lex_state = 4},
  [93] = {.lex_state = 70, .external_lex_state = 3},
  [94] = {.lex_state = 70, .external_lex_state = 3},
  [95] = {.lex_state = 70, .external_lex_state = 3},
  [96] = {.lex_state = 70, .external_lex_state = 4},
  [97] = {.lex_state = 70, .external_lex_state = 3},
  [98] = {.lex_state = 70, .external_lex_state = 4},
  [99] = {.lex_state = 70, .external_lex_state = 4},
  [100] = {.lex_state = 70, .external_lex_state = 4},
  [101] = {.lex_state = 70, .external_lex_state = 4},
  [102] = {.lex_state = 70, .external_lex_state = 4},
  [103] = {.lex_state = 70, .external_lex_state = 3},
  [104] = {.lex_state = 70, .external_lex_state = 3},
  [105] = {.lex_state = 70, .external_lex_state = 3},
  [106] = {.lex_state = 70, .external_lex_state = 4},
  [107] = {.lex_state = 70, .external_lex_state = 4},
  [108] = {.lex_state = 70, .external_lex_state = 4},
  [109] = {.lex_state = 70, .external_lex_state = 4},
  [110] = {.lex_state = 70, .external_lex_state = 4},
  [111] = {.lex_state = 70, .external_lex_state = 4},
  [112] = {.lex_state = 70, .external_lex_state = 4},
  [113] = {.lex_state = 70, .external_lex_state = 4},
  [114] = {.lex_state = 79, .external_lex_state = 2},
  [115] = {.lex_state = 79, .external_lex_state = 2},
  [116] = {.lex_state = 79, .external_lex_state = 2},
  [117] = {.lex_state = 79, .external_lex_state = 2},
  [118] = {.lex_state = 78, .external_lex_state = 5},
  [119] = {.lex_state = 78, .external_lex_state = 5},
  [120] = {.lex_state = 78, .external_lex_state = 5},
  [121] = {.lex_state = 78, .external_lex_state = 5},
  [122] = {.lex_state = 78, .external_lex_state = 5},
  [123] = {.lex_state = 75, .external_lex_state = 6},
  [124] = {.lex_state = 75, .external_lex_state = 6},
  [125] = {.lex_state = 75, .external_lex_state = 6},
  [126] = {.lex_state = 77, .external_lex_state = 6},
  [127] = {.lex_state = 75, .external_lex_state = 6},
  [128] = {.lex_state = 77, .external_lex_state = 6},
  [129] = {.lex_state = 75, .external_lex_state = 6},
  [130] = {.lex_state = 75, .external_lex_state = 6},
  [131] = {.lex_state = 77, .external_lex_state = 6},
  [132] = {.lex_state = 77, .external_lex_state = 6},
  [133] = {.lex_state = 77, .external_lex_state = 6},
  [134] = {.lex_state = 77, .external_lex_state = 6},
  [135] = {.lex_state = 80, .external_lex_state = 7},
  [136] = {.lex_state = 80, .external_lex_state = 7},
  [137] = {.lex_state = 80, .external_lex_state = 7},
  [138] = {.lex_state = 79, .external_lex_state = 7},
  [139] = {.lex_state = 80, .external_lex_state = 7},
  [140] = {.lex_state = 80, .external_lex_state = 7},
  [141] = {.lex_state = 80, .external_lex_state = 7},
  [142] = {.lex_state = 80, .external_lex_state = 7},
  [143] = {.lex_state = 80, .external_lex_state = 7},
  [144] = {.lex_state = 79, .external_lex_state = 7},
  [145] = {.lex_state = 80, .external_lex_state = 7},
  [146] = {.lex_state = 79, .external_lex_state = 7},
  [147] = {.lex_state = 80, .external_lex_state = 7},
  [148] = {.lex_state = 80, .external_lex_state = 7},
  [149] = {.lex_state = 80, .external_lex_state = 7},
  [150] = {.lex_state = 79, .external_lex_state = 7},
  [151] = {.lex_state = 79, .external_lex_state = 7},
  [152] = {.lex_state = 80, .external_lex_state = 7},
  [153] = {.lex_state = 79, .external_lex_state = 7},
  [154] = {.lex_state = 80, .external_lex_state = 7},
  [155] = {.lex_state = 80, .external_lex_state = 7},
  [156] = {.lex_state = 80, .external_lex_state = 7},
  [157] = {.lex_state = 79, .external_lex_state = 7},
  [158] = {.lex_state = 80, .external_lex_state = 7},
  [159] = {.lex_state = 79, .external_lex_state = 7},
  [160] = {.lex_state = 80, .external_lex_state = 7},
  [161] = {.lex_state = 80, .external_lex_state = 7},
  [162] = {.lex_state = 79, .external_lex_state = 7},
  [163] = {.lex_state = 80, .external_lex_state = 7},
  [164] = {.lex_state = 80, .external_lex_state = 7},
  [165] = {.lex_state = 80, .external_lex_state = 7},
  [166] = {.lex_state = 80, .external_lex_state = 7},
  [167] = {.lex_state = 79, .external_lex_state = 7},
  [168] = {.lex_state = 80, .external_lex_state = 7},
  [169] = {.lex_state = 79, .external_lex_state = 7},
  [170] = {.lex_state = 79, .external_lex_state = 7},
  [171] = {.lex_state = 79, .external_lex_state = 2},
  [172] = {.lex_state = 79, .external_lex_state = 7},
  [173] = {.lex_state = 79, .external_lex_state = 7},
  [174] = {.lex_state = 79, .external_lex_state = 7},
  [175] = {.lex_state = 79, .external_lex_state = 2},
  [176] = {.lex_state = 79, .external_lex_state = 7},
  [177] = {.lex_state = 79, .external_lex_state = 7},
  [178] = {.lex_state = 79, .external_lex_state = 2},
  [179] = {.lex_state = 79, .external_lex_state = 7},
  [180] = {.lex_state = 79, .external_lex_state = 7},
  [181] = {.lex_state = 79, .external_lex_state = 2},
  [182] = {.lex_state = 79, .external_lex_state = 7},
  [183] = {.lex_state = 79, .external_lex_state = 7},
  [184] = {.lex_state = 79, .external_lex_state = 2},
  [185] = {.lex_state = 79, .external_lex_state = 2},
  [186] = {.lex_state = 79, .external_lex_state = 7},
  [187] = {.lex_state = 79, .external_lex_state = 7},
  [188] = {.lex_state = 79, .external_lex_state = 2},
  [189] = {.lex_state = 79, .external_lex_state = 7},
  [190] = {.lex_state = 79, .external_lex_state = 7},
  [191] = {.lex_state = 79, .external_lex_state = 2},
  [192] = {.lex_state = 79, .external_lex_state = 7},
  [193] = {.lex_state = 79, .external_lex_state = 7},
  [194] = {.lex_state = 79, .external_lex_state = 7},
  [195] = {.lex_state = 79, .external_lex_state = 7},
  [196] = {.lex_state = 79, .external_lex_state = 2},
  [197] = {.lex_state = 79, .external_lex_state = 7},
  [198] = {.lex_state = 79, .external_lex_state = 2},
  [199] = {.lex_state = 79, .external_lex_state = 7},
  [200] = {.lex_state = 79, .external_lex_state = 7},
  [201] = {.lex_state = 79, .external_lex_state = 7},
  [202] = {.lex_state = 73, .external_lex_state = 8},
  [203] = {.lex_state = 73, .external_lex_state = 8},
  [204] = {.lex_state = 79, .external_lex_state = 2},
  [205] = {.lex_state = 79, .external_lex_state = 2},
  [206] = {.lex_state = 79, .external_lex_state = 2},
  [207] = {.lex_state = 79, .external_lex_state = 2},
  [208] = {.lex_state = 79, .external_lex_state = 2},
  [209] = {.lex_state = 79, .external_lex_state = 2},
  [210] = {.lex_state = 79, .external_lex_state = 2},
  [211] = {.lex_state = 79, .external_lex_state = 2},
  [212] = {.lex_state = 79, .external_lex_state = 2},
  [213] = {.lex_state = 79, .external_lex_state = 2},
  [214] = {.lex_state = 79, .external_lex_state = 2},
  [215] = {.lex_state = 79, .external_lex_state = 2},
  [216] = {.lex_state = 79, .external_lex_state = 2},
  [217] = {.lex_state = 79, .external_lex_state = 2},
  [218] = {.lex_state = 79, .external_lex_state = 2},
  [219] = {.lex_state = 79, .external_lex_state = 2},
  [220] = {.lex_state = 79, .external_lex_state = 2},
  [221] = {.lex_state = 79, .external_lex_state = 2},
  [222] = {.lex_state = 79, .external_lex_state = 2},
  [223] = {.lex_state = 79, .external_lex_state = 2},
  [224] = {.lex_state = 79, .external_lex_state = 2},
  [225] = {.lex_state = 79, .external_lex_state = 2},
  [226] = {.lex_state = 73, .external_lex_state = 8},
  [227] = {.lex_state = 79, .external_lex_state = 2},
  [228] = {.lex_state = 79, .external_lex_state = 2},
  [229] = {.lex_state = 79, .external_lex_state = 2},
  [230] = {.lex_state = 79, .external_lex_state = 2},
  [231] = {.lex_state = 79, .external_lex_state = 2},
  [232] = {.lex_state = 79, .external_lex_state = 2},
  [233] = {.lex_state = 73, .external_lex_state = 8},
  [234] = {.lex_state = 79, .external_lex_state = 2},
  [235] = {.lex_state = 79, .external_lex_state = 2},
  [236] = {.lex_state = 79, .external_lex_state = 2},
  [237] = {.lex_state = 79, .external_lex_state = 2},
  [238] = {.lex_state = 79, .external_lex_state = 2},
  [239] = {.lex_state = 79, .external_lex_state = 2},
  [240] = {.lex_state = 79, .external_lex_state = 2},
  [241] = {.lex_state = 79, .external_lex_state = 2},
  [242] = {.lex_state = 79, .external_lex_state = 2},
  [243] = {.lex_state = 79, .external_lex_state = 2},
  [244] = {.lex_state = 79, .external_lex_state = 2},
  [245] = {.lex_state = 79, .external_lex_state = 2},
  [246] = {.lex_state = 73, .external_lex_state = 8},
  [247] = {.lex_state = 79, .external_lex_state = 2},
  [248] = {.lex_state = 78, .external_lex_state = 9},
  [249] = {.lex_state = 78, .external_lex_state = 9},
  [250] = {.lex_state = 79, .external_lex_state = 2},
  [251] = {.lex_state = 79, .external_lex_state = 2},
  [252] = {.lex_state = 79, .external_lex_state = 10},
  [253] = {.lex_state = 79, .external_lex_state = 10},
  [254] = {.lex_state = 79, .external_lex_state = 10},
  [255] = {.lex_state = 79, .external_lex_state = 10},
  [256] = {.lex_state = 79, .external_lex_state = 10},
  [257] = {.lex_state = 79, .external_lex_state = 10},
  [258] = {.lex_state = 79, .external_lex_state = 10},
  [259] = {.lex_state = 79, .external_lex_state = 10},
  [260] = {.lex_state = 74, .external_lex_state = 11},
  [261] = {.lex_state = 79, .external_lex_state = 2},
  [262] = {.lex_state = 74, .external_lex_state = 11},
  [263] = {.lex_state = 79, .external_lex_state = 2},
  [264] = {.lex_state = 74, .external_lex_state = 11},
  [265] = {.lex_state = 74, .external_lex_state = 11},
  [266] = {.lex_state = 79, .external_lex_state = 7},
  [267] = {.lex_state = 79, .external_lex_state = 2},
  [268] = {.lex_state = 212, .external_lex_state = 8},
  [269] = {.lex_state = 79, .external_lex_state = 2},
  [270] = {.lex_state = 79, .external_lex_state = 2},
  [271] = {.lex_state = 79, .external_lex_state = 2},
  [272] = {.lex_state = 212, .external_lex_state = 8},
  [273] = {.lex_state = 79, .external_lex_state = 2},
  [274] = {.lex_state = 79, .external_lex_state = 2},
  [275] = {.lex_state = 79, .external_lex_state = 2},
  [276] = {.lex_state = 74, .external_lex_state = 11},
  [277] = {.lex_state = 79, .external_lex_state = 7},
  [278] = {.lex_state = 79, .external_lex_state = 2},
  [279] = {.lex_state = 79, .external_lex_state = 2},
  [280] = {.lex_state = 212, .external_lex_state = 8},
  [281] = {.lex_state = 79, .external_lex_state = 2},
  [282] = {.lex_state = 79, .external_lex_state = 2},
  [283] = {.lex_state = 212, .external_lex_state = 8},
  [284] = {.lex_state = 79, .external_lex_state = 7},
  [285] = {.lex_state = 79, .external_lex_state = 7},
  [286] = {.lex_state = 212, .external_lex_state = 8},
  [287] = {.lex_state = 79, .external_lex_state = 2},
  [288] = {.lex_state = 79, .external_lex_state = 2},
  [289] = {.lex_state = 79, .external_lex_state = 2},
  [290] = {.lex_state = 79, .external_lex_state = 2},
  [291] = {.lex_state = 79, .external_lex_state = 2},
  [292] = {.lex_state = 79, .external_lex_state = 2},
  [293] = {.lex_state = 73, .external_lex_state = 12},
  [294] = {.lex_state = 79, .external_lex_state = 2},
  [295] = {.lex_state = 79, .external_lex_state = 2},
  [296] = {.lex_state = 79, .external_lex_state = 2},
  [297] = {.lex_state = 79, .external_lex_state = 2},
  [298] = {.lex_state = 79, .external_lex_state = 2},
  [299] = {.lex_state = 79, .external_lex_state = 2},
  [300] = {.lex_state = 79, .external_lex_state = 2},
  [301] = {.lex_state = 79, .external_lex_state = 2},
  [302] = {.lex_state = 73, .external_lex_state = 12},
  [303] = {.lex_state = 79, .external_lex_state = 2},
  [304] = {.lex_state = 79, .external_lex_state = 2},
  [305] = {.lex_state = 73, .external_lex_state = 12},
  [306] = {.lex_state = 73, .external_lex_state = 8},
  [307] = {.lex_state = 73, .external_lex_state = 8},
  [308] = {.lex_state = 73, .external_lex_state = 12},
  [309] = {.lex_state = 73, .external_lex_state = 8},
  [310] = {.lex_state = 215, .external_lex_state = 9},
  [311] = {.lex_state = 73, .external_lex_state = 8},
  [312] = {.lex_state = 73, .external_lex_state = 12},
  [313] = {.lex_state = 73, .external_lex_state = 12},
  [314] = {.lex_state = 214, .external_lex_state = 2},
  [315] = {.lex_state = 73, .external_lex_state = 12},
  [316] = {.lex_state = 79, .external_lex_state = 2},
  [317] = {.lex_state = 79, .external_lex_state = 2},
  [318] = {.lex_state = 79, .external_lex_state = 2},
  [319] = {.lex_state = 79, .external_lex_state = 2},
  [320] = {.lex_state = 79, .external_lex_state = 2},
  [321] = {.lex_state = 79, .external_lex_state = 2},
  [322] = {.lex_state = 73, .external_lex_state = 8},
  [323] = {.lex_state = 79, .external_lex_state = 2},
  [324] = {.lex_state = 73, .external_lex_state = 8},
  [325] = {.lex_state = 214, .external_lex_state = 2},
  [326] = {.lex_state = 73, .external_lex_state = 8},
  [327] = {.lex_state = 79, .external_lex_state = 2},
  [328] = {.lex_state = 215, .external_lex_state = 9},
  [329] = {.lex_state = 73, .external_lex_state = 12},
  [330] = {.lex_state = 79, .external_lex_state = 2},
  [331] = {.lex_state = 79, .external_lex_state = 2},
  [332] = {.lex_state = 213, .external_lex_state = 11},
  [333] = {.lex_state = 213, .external_lex_state = 11},
  [334] = {.lex_state = 79, .external_lex_state = 2},
  [335] = {.lex_state = 81, .external_lex_state = 2},
  [336] = {.lex_state = 81, .external_lex_state = 2},
  [337] = {.lex_state = 81, .external_lex_state = 2},
  [338] = {.lex_state = 81, .external_lex_state = 2},
  [339] = {.lex_state = 213, .external_lex_state = 11},
  [340] = {.lex_state = 81, .external_lex_state = 2},
  [341] = {.lex_state = 79, .external_lex_state = 2},
  [342] = {.lex_state = 81, .external_lex_state = 2},
  [343] = {.lex_state = 79, .external_lex_state = 2},
  [344] = {.lex_state = 78, .external_lex_state = 9},
  [345] = {.lex_state = 81, .external_lex_state = 2},
  [346] = {.lex_state = 81, .external_lex_state = 2},
  [347] = {.lex_state = 79, .external_lex_state = 2},
  [348] = {.lex_state = 79, .external_lex_state = 2},
  [349] = {.lex_state = 79, .external_lex_state = 2},
  [350] = {.lex_state = 81, .external_lex_state = 2},
  [351] = {.lex_state = 73, .external_lex_state = 8},
  [352] = {.lex_state = 79, .external_lex_state = 2},
  [353] = {.lex_state = 79, .external_lex_state = 2},
  [354] = {.lex_state = 79, .external_lex_state = 2},
  [355] = {.lex_state = 79, .external_lex_state = 2},
  [356] = {.lex_state = 81, .external_lex_state = 2},
  [357] = {.lex_state = 79, .external_lex_state = 2},
  [358] = {.lex_state = 79, .external_lex_state = 2},
  [359] = {.lex_state = 81, .external_lex_state = 2},
  [360] = {.lex_state = 213, .external_lex_state = 11},
  [361] = {.lex_state = 81, .external_lex_state = 2},
  [362] = {.lex_state = 81, .external_lex_state = 2},
  [363] = {.lex_state = 73, .external_lex_state = 12},
  [364] = {.lex_state = 78, .external_lex_state = 9},
  [365] = {.lex_state = 74, .external_lex_state = 13},
  [366] = {.lex_state = 213, .external_lex_state = 11},
  [367] = {.lex_state = 73, .external_lex_state = 8},
  [368] = {.lex_state = 73, .external_lex_state = 8},
  [369] = {.lex_state = 78, .external_lex_state = 9},
  [370] = {.lex_state = 74, .external_lex_state = 13},
  [371] = {.lex_state = 78, .external_lex_state = 5},
  [372] = {.lex_state = 78, .external_lex_state = 9},
  [373] = {.lex_state = 79, .external_lex_state = 2},
  [374] = {.lex_state = 73, .external_lex_state = 12},
  [375] = {.lex_state = 78, .external_lex_state = 5},
  [376] = {.lex_state = 79, .external_lex_state = 2},
  [377] = {.lex_state = 74, .external_lex_state = 13},
  [378] = {.lex_state = 78, .external_lex_state = 9},
  [379] = {.lex_state = 74, .external_lex_state = 13},
  [380] = {.lex_state = 73, .external_lex_state = 12},
  [381] = {.lex_state = 73, .external_lex_state = 12},
  [382] = {.lex_state = 74, .external_lex_state = 11},
  [383] = {.lex_state = 78, .external_lex_state = 5},
  [384] = {.lex_state = 74, .external_lex_state = 11},
  [385] = {.lex_state = 74, .external_lex_state = 13},
  [386] = {.lex_state = 74, .external_lex_state = 11},
  [387] = {.lex_state = 74, .external_lex_state = 11},
  [388] = {.lex_state = 73, .external_lex_state = 8},
  [389] = {.lex_state = 79, .external_lex_state = 2},
  [390] = {.lex_state = 74, .external_lex_state = 13},
  [391] = {.lex_state = 74, .external_lex_state = 11},
  [392] = {.lex_state = 73, .external_lex_state = 12},
  [393] = {.lex_state = 73, .external_lex_state = 12},
  [394] = {.lex_state = 74, .external_lex_state = 11},
  [395] = {.lex_state = 78, .external_lex_state = 5},
  [396] = {.lex_state = 74, .external_lex_state = 13},
  [397] = {.lex_state = 73, .external_lex_state = 12},
  [398] = {.lex_state = 74, .external_lex_state = 11},
  [399] = {.lex_state = 74, .external_lex_state = 13},
  [400] = {.lex_state = 73, .external_lex_state = 12},
  [401] = {.lex_state = 74, .external_lex_state = 11},
  [402] = {.lex_state = 79, .external_lex_state = 2},
  [403] = {.lex_state = 79, .external_lex_state = 2},
  [404] = {.lex_state = 74, .external_lex_state = 13},
  [405] = {.lex_state = 79, .external_lex_state = 2},
  [406] = {.lex_state = 79, .external_lex_state = 2},
  [407] = {.lex_state = 79, .external_lex_state = 2},
  [408] = {.lex_state = 79, .external_lex_state = 2},
  [409] = {.lex_state = 79, .external_lex_state = 2},
  [410] = {.lex_state = 79, .external_lex_state = 2},
  [411] = {.lex_state = 79, .external_lex_state = 2},
  [412] = {.lex_state = 79, .external_lex_state = 2},
  [413] = {.lex_state = 79, .external_lex_state = 2},
  [414] = {.lex_state = 79, .external_lex_state = 2},
  [415] = {.lex_state = 74, .external_lex_state = 11},
  [416] = {.lex_state = 74, .external_lex_state = 11},
  [417] = {.lex_state = 79, .external_lex_state = 2},
  [418] = {.lex_state = 74, .external_lex_state = 13},
  [419] = {.lex_state = 74, .external_lex_state = 13},
  [420] = {.lex_state = 74, .external_lex_state = 11},
  [421] = {.lex_state = 74, .external_lex_state = 13},
  [422] = {.lex_state = 78, .external_lex_state = 5},
  [423] = {.lex_state = 78, .external_lex_state = 5},
  [424] = {.lex_state = 74, .external_lex_state = 13},
  [425] = {.lex_state = 78, .external_lex_state = 5},
  [426] = {.lex_state = 78, .external_lex_state = 5},
  [427] = {.lex_state = 78, .external_lex_state = 5},
  [428] = {.lex_state = 78, .external_lex_state = 5},
  [429] = {.lex_state = 78, .external_lex_state = 5},
  [430] = {.lex_state = 78, .external_lex_state = 5},
  [431] = {.lex_state = 78, .external_lex_state = 5},
  [432] = {.lex_state = 78, .external_lex_state = 5},
  [433] = {.lex_state = 74, .external_lex_state = 13},
  [434] = {.lex_state = 78, .external_lex_state = 5},
  [435] = {.lex_state = 78, .external_lex_state = 14},
  [436] = {.lex_state = 78, .external_lex_state = 5},
  [437] = {.lex_state = 78, .external_lex_state = 5},
  [438] = {.lex_state = 78, .external_lex_state = 5},
  [439] = {.lex_state = 74, .external_lex_state = 13},
  [440] = {.lex_state = 78, .external_lex_state = 5},
  [441] = {.lex_state = 74, .external_lex_state = 13},
  [442] = {.lex_state = 78, .external_lex_state = 2},
  [443] = {.lex_state = 78, .external_lex_state = 5},
  [444] = {.lex_state = 78, .external_lex_state = 5},
  [445] = {.lex_state = 78, .external_lex_state = 5},
  [446] = {.lex_state = 78, .external_lex_state = 5},
  [447] = {.lex_state = 78, .external_lex_state = 5},
  [448] = {.lex_state = 78, .external_lex_state = 5},
  [449] = {.lex_state = 78, .external_lex_state = 5},
  [450] = {.lex_state = 78, .external_lex_state = 5},
  [451] = {.lex_state = 78, .external_lex_state = 5},
  [452] = {.lex_state = 78, .external_lex_state = 5},
  [453] = {.lex_state = 78, .external_lex_state = 5},
  [454] = {.lex_state = 78, .external_lex_state = 5},
  [455] = {.lex_state = 78, .external_lex_state = 5},
  [456] = {.lex_state = 78, .external_lex_state = 5},
  [457] = {.lex_state = 78, .external_lex_state = 15},
  [458] = {.lex_state = 78, .external_lex_state = 15},
  [459] = {.lex_state = 78, .external_lex_state = 15},
  [460] = {.lex_state = 78, .external_lex_state = 15},
  [461] = {.lex_state = 78, .external_lex_state = 15},
  [462] = {.lex_state = 78, .external_lex_state = 15},
  [463] = {.lex_state = 78, .external_lex_state = 15},
  [464] = {.lex_state = 78, .external_lex_state = 15},
  [465] = {.lex_state = 78, .external_lex_state = 15},
  [466] = {.lex_state = 78, .external_lex_state = 15},
  [467] = {.lex_state = 78, .external_lex_state = 15},
  [468] = {.lex_state = 78, .external_lex_state = 15},
  [469] = {.lex_state = 78, .external_lex_state = 15},
  [470] = {.lex_state = 78, .external_lex_state = 15},
  [471] = {.lex_state = 78, .external_lex_state = 15},
  [472] = {.lex_state = 78, .external_lex_state = 15},
  [473] = {.lex_state = 78, .external_lex_state = 15},
  [474] = {.lex_state = 78, .external_lex_state = 15},
  [475] = {.lex_state = 78, .external_lex_state = 15},
  [476] = {.lex_state = 78, .external_lex_state = 15},
  [477] = {.lex_state = 78, .external_lex_state = 15},
  [478] = {.lex_state = 78, .external_lex_state = 15},
  [479] = {.lex_state = 78, .external_lex_state = 15},
  [480] = {.lex_state = 78, .external_lex_state = 15},
  [481] = {.lex_state = 78, .external_lex_state = 15},
  [482] = {.lex_state = 78, .external_lex_state = 16},
  [483] = {.lex_state = 78, .external_lex_state = 16},
  [484] = {.lex_state = 78, .external_lex_state = 16},
  [485] = {.lex_state = 78, .external_lex_state = 2},
  [486] = {.lex_state = 78, .external_lex_state = 2},
  [487] = {.lex_state = 78, .external_lex_state = 7},
  [488] = {.lex_state = 78, .external_lex_state = 2},
  [489] = {.lex_state = 78, .external_lex_state = 2},
  [490] = {.lex_state = 78, .external_lex_state = 16},
  [491] = {.lex_state = 78, .external_lex_state = 2},
  [492] = {.lex_state = 78, .external_lex_state = 2},
  [493] = {.lex_state = 78, .external_lex_state = 2},
  [494] = {.lex_state = 78, .external_lex_state = 2},
  [495] = {.lex_state = 78, .external_lex_state = 2},
  [496] = {.lex_state = 78, .external_lex_state = 2},
  [497] = {.lex_state = 78, .external_lex_state = 2},
  [498] = {.lex_state = 78, .external_lex_state = 7},
  [499] = {.lex_state = 78, .external_lex_state = 2},
  [500] = {.lex_state = 78, .external_lex_state = 2},
  [501] = {.lex_state = 78, .external_lex_state = 2},
  [502] = {.lex_state = 78, .external_lex_state = 2},
  [503] = {.lex_state = 78, .external_lex_state = 2},
  [504] = {.lex_state = 78, .external_lex_state = 2},
  [505] = {.lex_state = 78, .external_lex_state = 2},
  [506] = {.lex_state = 78, .external_lex_state = 7},
  [507] = {.lex_state = 78, .external_lex_state = 2},
  [508] = {.lex_state = 78, .external_lex_state = 2},
  [509] = {.lex_state = 78, .external_lex_state = 2},
  [510] = {.lex_state = 78, .external_lex_state = 2},
  [511] = {.lex_state = 78, .external_lex_state = 2},
  [512] = {.lex_state = 78, .external_lex_state = 2},
  [513] = {.lex_state = 78, .external_lex_state = 2},
  [514] = {.lex_state = 78, .external_lex_state = 7},
  [515] = {.lex_state = 78, .external_lex_state = 7},
  [516] = {.lex_state = 78, .external_lex_state = 7},
  [517] = {.lex_state = 78, .external_lex_state = 7},
  [518] = {.lex_state = 78, .external_lex_state = 7},
  [519] = {.lex_state = 78, .external_lex_state = 2},
  [520] = {.lex_state = 78, .external_lex_state = 2},
  [521] = {.lex_state = 78, .external_lex_state = 2},
  [522] = {.lex_state = 78, .external_lex_state = 2},
  [523] = {.lex_state = 78, .external_lex_state = 2},
  [524] = {.lex_state = 78, .external_lex_state = 2},
  [525] = {.lex_state = 78, .external_lex_state = 2},
  [526] = {.lex_state = 78, .external_lex_state = 2},
  [527] = {.lex_state = 78, .external_lex_state = 2},
  [528] = {.lex_state = 78, .external_lex_state = 2},
  [529] = {.lex_state = 78, .external_lex_state = 2},
  [530] = {.lex_state = 78, .external_lex_state = 2},
  [531] = {.lex_state = 78, .external_lex_state = 2},
  [532] = {.lex_state = 78, .external_lex_state = 2},
  [533] = {.lex_state = 78, .external_lex_state = 2},
  [534] = {.lex_state = 78, .external_lex_state = 2},
  [535] = {.lex_state = 78, .external_lex_state = 2},
  [536] = {.lex_state = 78, .external_lex_state = 2},
  [537] = {.lex_state = 78, .external_lex_state = 2},
  [538] = {.lex_state = 78, .external_lex_state = 2},
  [539] = {.lex_state = 78, .external_lex_state = 2},
  [540] = {.lex_state = 78, .external_lex_state = 2},
  [541] = {.lex_state = 78, .external_lex_state = 2},
  [542] = {.lex_state = 78, .external_lex_state = 2},
  [543] = {.lex_state = 78, .external_lex_state = 2},
  [544] = {.lex_state = 78, .external_lex_state = 2},
  [545] = {.lex_state = 78, .external_lex_state = 2},
  [546] = {.lex_state = 78, .external_lex_state = 2},
  [547] = {.lex_state = 78, .external_lex_state = 2},
  [548] = {.lex_state = 78, .external_lex_state = 2},
  [549] = {.lex_state = 78, .external_lex_state = 2},
  [550] = {.lex_state = 78, .external_lex_state = 2},
  [551] = {.lex_state = 78, .external_lex_state = 2},
  [552] = {.lex_state = 78, .external_lex_state = 2},
  [553] = {.lex_state = 78, .external_lex_state = 2},
  [554] = {.lex_state = 78, .external_lex_state = 2},
  [555] = {.lex_state = 78, .external_lex_state = 2},
  [556] = {.lex_state = 78, .external_lex_state = 2},
  [557] = {.lex_state = 78, .external_lex_state = 2},
  [558] = {.lex_state = 78, .external_lex_state = 2},
  [559] = {.lex_state = 78, .external_lex_state = 2},
  [560] = {.lex_state = 78, .external_lex_state = 2},
  [561] = {.lex_state = 78, .external_lex_state = 2},
  [562] = {.lex_state = 78, .external_lex_state = 2},
  [563] = {.lex_state = 78, .external_lex_state = 2},
  [564] = {.lex_state = 78, .external_lex_state = 2},
  [565] = {.lex_state = 78, .external_lex_state = 2},
  [566] = {.lex_state = 78, .external_lex_state = 2},
  [567] = {.lex_state = 78, .external_lex_state = 2},
  [568] = {.lex_state = 78, .external_lex_state = 2},
  [569] = {.lex_state = 78, .external_lex_state = 2},
  [570] = {.lex_state = 78, .external_lex_state = 2},
  [571] = {.lex_state = 78, .external_lex_state = 2},
  [572] = {.lex_state = 78, .external_lex_state = 2},
  [573] = {.lex_state = 78, .external_lex_state = 2},
  [574] = {.lex_state = 78, .external_lex_state = 2},
  [575] = {.lex_state = 78, .external_lex_state = 2},
  [576] = {.lex_state = 78, .external_lex_state = 2},
  [577] = {.lex_state = 78, .external_lex_state = 2},
  [578] = {.lex_state = 78, .external_lex_state = 2},
  [579] = {.lex_state = 78, .external_lex_state = 2},
  [580] = {.lex_state = 78, .external_lex_state = 2},
  [581] = {.lex_state = 78, .external_lex_state = 2},
  [582] = {.lex_state = 78, .external_lex_state = 2},
  [583] = {.lex_state = 78, .external_lex_state = 2},
  [584] = {.lex_state = 78, .external_lex_state = 2},
  [585] = {.lex_state = 78, .external_lex_state = 2},
  [586] = {.lex_state = 78, .external_lex_state = 2},
  [587] = {.lex_state = 78, .external_lex_state = 2},
  [588] = {.lex_state = 78, .external_lex_state = 2},
  [589] = {.lex_state = 78, .external_lex_state = 2},
  [590] = {.lex_state = 78, .external_lex_state = 2},
  [591] = {.lex_state = 78, .external_lex_state = 2},
  [592] = {.lex_state = 78, .external_lex_state = 2},
  [593] = {.lex_state = 78, .external_lex_state = 2},
  [594] = {.lex_state = 78, .external_lex_state = 2},
  [595] = {.lex_state = 78, .external_lex_state = 2},
  [596] = {.lex_state = 78, .external_lex_state = 2},
  [597] = {.lex_state = 78, .external_lex_state = 2},
  [598] = {.lex_state = 78, .external_lex_state = 2},
  [599] = {.lex_state = 78, .external_lex_state = 2},
  [600] = {.lex_state = 78, .external_lex_state = 2},
  [601] = {.lex_state = 78, .external_lex_state = 2},
  [602] = {.lex_state = 78, .external_lex_state = 2},
  [603] = {.lex_state = 78, .external_lex_state = 2},
  [604] = {.lex_state = 78, .external_lex_state = 2},
  [605] = {.lex_state = 78, .external_lex_state = 2},
  [606] = {.lex_state = 78, .external_lex_state = 2},
  [607] = {.lex_state = 78, .external_lex_state = 2},
  [608] = {.lex_state = 78, .external_lex_state = 2},
  [609] = {.lex_state = 78, .external_lex_state = 2},
  [610] = {.lex_state = 78, .external_lex_state = 2},
  [611] = {.lex_state = 78, .external_lex_state = 2},
  [612] = {.lex_state = 78, .external_lex_state = 2},
  [613] = {.lex_state = 78, .external_lex_state = 2},
  [614] = {.lex_state = 78, .external_lex_state = 2},
  [615] = {.lex_state = 78, .external_lex_state = 2},
  [616] = {.lex_state = 78, .external_lex_state = 2},
  [617] = {.lex_state = 78, .external_lex_state = 2},
  [618] = {.lex_state = 78, .external_lex_state = 2},
  [619] = {.lex_state = 78, .external_lex_state = 2},
  [620] = {.lex_state = 78, .external_lex_state = 2},
  [621] = {.lex_state = 78, .external_lex_state = 2},
  [622] = {.lex_state = 78, .external_lex_state = 2},
  [623] = {.lex_state = 78, .external_lex_state = 2},
  [624] = {.lex_state = 78, .external_lex_state = 2},
  [625] = {.lex_state = 78, .external_lex_state = 2},
  [626] = {.lex_state = 78, .external_lex_state = 2},
  [627] = {.lex_state = 78, .external_lex_state = 2},
  [628] = {.lex_state = 78, .external_lex_state = 2},
  [629] = {.lex_state = 78, .external_lex_state = 2},
  [630] = {.lex_state = 78, .external_lex_state = 2},
  [631] = {.lex_state = 78, .external_lex_state = 2},
  [632] = {.lex_state = 78, .external_lex_state = 2},
  [633] = {.lex_state = 78, .external_lex_state = 2},
  [634] = {.lex_state = 78, .external_lex_state = 2},
  [635] = {.lex_state = 78, .external_lex_state = 2},
  [636] = {.lex_state = 78, .external_lex_state = 2},
  [637] = {.lex_state = 78, .external_lex_state = 2},
  [638] = {.lex_state = 78, .external_lex_state = 2},
  [639] = {.lex_state = 78, .external_lex_state = 2},
  [640] = {.lex_state = 78, .external_lex_state = 2},
  [641] = {.lex_state = 78, .external_lex_state = 2},
  [642] = {.lex_state = 78, .external_lex_state = 2},
  [643] = {.lex_state = 78, .external_lex_state = 2},
  [644] = {.lex_state = 78, .external_lex_state = 2},
  [645] = {.lex_state = 78, .external_lex_state = 2},
  [646] = {.lex_state = 78, .external_lex_state = 2},
  [647] = {.lex_state = 78, .external_lex_state = 2},
  [648] = {.lex_state = 78, .external_lex_state = 2},
  [649] = {.lex_state = 78, .external_lex_state = 2},
  [650] = {.lex_state = 78, .external_lex_state = 2},
  [651] = {.lex_state = 78, .external_lex_state = 2},
  [652] = {.lex_state = 78, .external_lex_state = 2},
  [653] = {.lex_state = 78, .external_lex_state = 2},
  [654] = {.lex_state = 78, .external_lex_state = 2},
  [655] = {.lex_state = 78, .external_lex_state = 2},
  [656] = {.lex_state = 78, .external_lex_state = 2},
  [657] = {.lex_state = 78, .external_lex_state = 2},
  [658] = {.lex_state = 78, .external_lex_state = 2},
  [659] = {.lex_state = 78, .external_lex_state = 2},
  [660] = {.lex_state = 78, .external_lex_state = 2},
  [661] = {.lex_state = 78, .external_lex_state = 2},
  [662] = {.lex_state = 78, .external_lex_state = 2},
  [663] = {.lex_state = 78, .external_lex_state = 2},
  [664] = {.lex_state = 78, .external_lex_state = 2},
  [665] = {.lex_state = 78, .external_lex_state = 2},
  [666] = {.lex_state = 78, .external_lex_state = 2},
  [667] = {.lex_state = 78, .external_lex_state = 2},
  [668] = {.lex_state = 78, .external_lex_state = 2},
  [669] = {.lex_state = 78, .external_lex_state = 2},
  [670] = {.lex_state = 81, .external_lex_state = 10},
  [671] = {.lex_state = 215, .external_lex_state = 16},
  [672] = {.lex_state = 81, .external_lex_state = 10},
  [673] = {.lex_state = 81, .external_lex_state = 10},
  [674] = {.lex_state = 81, .external_lex_state = 10},
  [675] = {.lex_state = 215, .external_lex_state = 16},
  [676] = {.lex_state = 81, .external_lex_state = 10},
  [677] = {.lex_state = 78, .external_lex_state = 17},
  [678] = {.lex_state = 215, .external_lex_state = 7},
  [679] = {.lex_state = 215, .external_lex_state = 16},
  [680] = {.lex_state = 215, .external_lex_state = 7},
  [681] = {.lex_state = 215, .external_lex_state = 7},
  [682] = {.lex_state = 215, .external_lex_state = 7},
  [683] = {.lex_state = 215, .external_lex_state = 16},
  [684] = {.lex_state = 215, .external_lex_state = 7},
  [685] = {.lex_state = 215, .external_lex_state = 7},
  [686] = {.lex_state = 215, .external_lex_state = 7},
  [687] = {.lex_state = 215, .external_lex_state = 7},
  [688] = {.lex_state = 78, .external_lex_state = 2},
  [689] = {.lex_state = 78, .external_lex_state = 16},
  [690] = {.lex_state = 78, .external_lex_state = 14},
  [691] = {.lex_state = 78, .external_lex_state = 14},
  [692] = {.lex_state = 78, .external_lex_state = 16},
  [693] = {.lex_state = 78, .external_lex_state = 16},
  [694] = {.lex_state = 78, .external_lex_state = 16},
  [695] = {.lex_state = 78, .external_lex_state = 7},
  [696] = {.lex_state = 78, .external_lex_state = 2},
  [697] = {.lex_state = 78, .external_lex_state = 2},
  [698] = {.lex_state = 78, .external_lex_state = 2},
  [699] = {.lex_state = 78, .external_lex_state = 16},
  [700] = {.lex_state = 78, .external_lex_state = 7},
  [701] = {.lex_state = 78, .external_lex_state = 7},
  [702] = {.lex_state = 78, .external_lex_state = 14},
  [703] = {.lex_state = 78, .external_lex_state = 2},
  [704] = {.lex_state = 78, .external_lex_state = 14},
  [705] = {.lex_state = 78, .external_lex_state = 16},
  [706] = {.lex_state = 78, .external_lex_state = 2},
  [707] = {.lex_state = 78, .external_lex_state = 2},
  [708] = {.lex_state = 78, .external_lex_state = 7},
  [709] = {.lex_state = 78, .external_lex_state = 14},
  [710] = {.lex_state = 78, .external_lex_state = 2},
  [711] = {.lex_state = 78, .external_lex_state = 14},
  [712] = {.lex_state = 78, .external_lex_state = 7},
  [713] = {.lex_state = 78, .external_lex_state = 2},
  [714] = {.lex_state = 78, .external_lex_state = 7},
  [715] = {.lex_state = 78, .external_lex_state = 2},
  [716] = {.lex_state = 78, .external_lex_state = 2},
  [717] = {.lex_state = 78, .external_lex_state = 2},
  [718] = {.lex_state = 78, .external_lex_state = 7},
  [719] = {.lex_state = 78, .external_lex_state = 2},
  [720] = {.lex_state = 78, .external_lex_state = 2},
  [721] = {.lex_state = 78, .external_lex_state = 2},
  [722] = {.lex_state = 78, .external_lex_state = 2},
  [723] = {.lex_state = 78, .external_lex_state = 2},
  [724] = {.lex_state = 78, .external_lex_state = 7},
  [725] = {.lex_state = 78, .external_lex_state = 2},
  [726] = {.lex_state = 78, .external_lex_state = 2},
  [727] = {.lex_state = 78, .external_lex_state = 7},
  [728] = {.lex_state = 78, .external_lex_state = 2},
  [729] = {.lex_state = 78, .external_lex_state = 2},
  [730] = {.lex_state = 78, .external_lex_state = 2},
  [731] = {.lex_state = 78, .external_lex_state = 2},
  [732] = {.lex_state = 78, .external_lex_state = 2},
  [733] = {.lex_state = 78, .external_lex_state = 7},
  [734] = {.lex_state = 78, .external_lex_state = 2},
  [735] = {.lex_state = 78, .external_lex_state = 14},
  [736] = {.lex_state = 78, .external_lex_state = 2},
  [737] = {.lex_state = 78, .external_lex_state = 7},
  [738] = {.lex_state = 78, .external_lex_state = 7},
  [739] = {.lex_state = 78, .external_lex_state = 2},
  [740] = {.lex_state = 78, .external_lex_state = 14},
  [741] = {.lex_state = 78, .external_lex_state = 10},
  [742] = {.lex_state = 78, .external_lex_state = 2},
  [743] = {.lex_state = 78, .external_lex_state = 7},
  [744] = {.lex_state = 78, .external_lex_state = 10},
  [745] = {.lex_state = 78, .external_lex_state = 2},
  [746] = {.lex_state = 78, .external_lex_state = 10},
  [747] = {.lex_state = 78, .external_lex_state = 2},
  [748] = {.lex_state = 78, .external_lex_state = 10},
  [749] = {.lex_state = 78, .external_lex_state = 10},
  [750] = {.lex_state = 78, .external_lex_state = 14},
  [751] = {.lex_state = 78, .external_lex_state = 14},
  [752] = {.lex_state = 78, .external_lex_state = 10},
  [753] = {.lex_state = 78, .external_lex_state = 10},
  [754] = {.lex_state = 78, .external_lex_state = 2},
  [755] = {.lex_state = 78, .external_lex_state = 10},
  [756] = {.lex_state = 78, .external_lex_state = 10},
  [757] = {.lex_state = 78, .external_lex_state = 15},
  [758] = {.lex_state = 78, .external_lex_state = 15},
  [759] = {.lex_state = 78, .external_lex_state = 15},
  [760] = {.lex_state = 78, .external_lex_state = 15},
  [761] = {.lex_state = 78, .external_lex_state = 15},
  [762] = {.lex_state = 78, .external_lex_state = 15},
  [763] = {.lex_state = 78, .external_lex_state = 15},
  [764] = {.lex_state = 78, .external_lex_state = 15},
  [765] = {.lex_state = 78, .external_lex_state = 15},
  [766] = {.lex_state = 78, .external_lex_state = 15},
  [767] = {.lex_state = 78, .external_lex_state = 15},
  [768] = {.lex_state = 78, .external_lex_state = 15},
  [769] = {.lex_state = 78, .external_lex_state = 15},
  [770] = {.lex_state = 78, .external_lex_state = 15},
  [771] = {.lex_state = 78, .external_lex_state = 15},
  [772] = {.lex_state = 78, .external_lex_state = 15},
  [773] = {.lex_state = 78, .external_lex_state = 15},
  [774] = {.lex_state = 78, .external_lex_state = 15},
  [775] = {.lex_state = 78, .external_lex_state = 15},
  [776] = {.lex_state = 78, .external_lex_state = 2},
  [777] = {.lex_state = 78, .external_lex_state = 10},
  [778] = {.lex_state = 78, .external_lex_state = 15},
  [779] = {.lex_state = 78, .external_lex_state = 15},
  [780] = {.lex_state = 78, .external_lex_state = 15},
  [781] = {.lex_state = 78, .external_lex_state = 15},
  [782] = {.lex_state = 78, .external_lex_state = 15},
  [783] = {.lex_state = 78, .external_lex_state = 15},
  [784] = {.lex_state = 78, .external_lex_state = 15},
  [785] = {.lex_state = 78, .external_lex_state = 15},
  [786] = {.lex_state = 78, .external_lex_state = 15},
  [787] = {.lex_state = 78, .external_lex_state = 15},
  [788] = {.lex_state = 78, .external_lex_state = 15},
  [789] = {.lex_state = 78, .external_lex_state = 15},
  [790] = {.lex_state = 78, .external_lex_state = 15},
  [791] = {.lex_state = 78, .external_lex_state = 15},
  [792] = {.lex_state = 78, .external_lex_state = 15},
  [793] = {.lex_state = 78, .external_lex_state = 15},
  [794] = {.lex_state = 78, .external_lex_state = 15},
  [795] = {.lex_state = 78, .external_lex_state = 15},
  [796] = {.lex_state = 78, .external_lex_state = 15},
  [797] = {.lex_state = 78, .external_lex_state = 15},
  [798] = {.lex_state = 78, .external_lex_state = 15},
  [799] = {.lex_state = 78, .external_lex_state = 15},
  [800] = {.lex_state = 78, .external_lex_state = 15},
  [801] = {.lex_state = 78, .external_lex_state = 15},
  [802] = {.lex_state = 78, .external_lex_state = 15},
  [803] = {.lex_state = 78, .external_lex_state = 15},
  [804] = {.lex_state = 78, .external_lex_state = 15},
  [805] = {.lex_state = 78, .external_lex_state = 7},
  [806] = {.lex_state = 78, .external_lex_state = 2},
  [807] = {.lex_state = 78, .external_lex_state = 2},
  [808] = {.lex_state = 78, .external_lex_state = 15},
  [809] = {.lex_state = 78, .external_lex_state = 15},
  [810] = {.lex_state = 78, .external_lex_state = 2},
  [811] = {.lex_state = 78, .external_lex_state = 15},
  [812] = {.lex_state = 78, .external_lex_state = 15},
  [813] = {.lex_state = 78, .external_lex_state = 15},
  [814] = {.lex_state = 78, .external_lex_state = 15},
  [815] = {.lex_state = 78, .external_lex_state = 15},
  [816] = {.lex_state = 78, .external_lex_state = 15},
  [817] = {.lex_state = 78, .external_lex_state = 15},
  [818] = {.lex_state = 78, .external_lex_state = 15},
  [819] = {.lex_state = 78, .external_lex_state = 15},
  [820] = {.lex_state = 78, .external_lex_state = 15},
  [821] = {.lex_state = 78, .external_lex_state = 15},
  [822] = {.lex_state = 78, .external_lex_state = 15},
  [823] = {.lex_state = 78, .external_lex_state = 2},
  [824] = {.lex_state = 78, .external_lex_state = 15},
  [825] = {.lex_state = 78, .external_lex_state = 15},
  [826] = {.lex_state = 78, .external_lex_state = 15},
  [827] = {.lex_state = 78, .external_lex_state = 15},
  [828] = {.lex_state = 78, .external_lex_state = 15},
  [829] = {.lex_state = 78, .external_lex_state = 15},
  [830] = {.lex_state = 78, .external_lex_state = 15},
  [831] = {.lex_state = 78, .external_lex_state = 15},
  [832] = {.lex_state = 78, .external_lex_state = 15},
  [833] = {.lex_state = 78, .external_lex_state = 15},
  [834] = {.lex_state = 78, .external_lex_state = 15},
  [835] = {.lex_state = 78, .external_lex_state = 15},
  [836] = {.lex_state = 78, .external_lex_state = 2},
  [837] = {.lex_state = 78, .external_lex_state = 15},
  [838] = {.lex_state = 78, .external_lex_state = 15},
  [839] = {.lex_state = 78, .external_lex_state = 15},
  [840] = {.lex_state = 78, .external_lex_state = 15},
  [841] = {.lex_state = 78, .external_lex_state = 15},
  [842] = {.lex_state = 78, .external_lex_state = 2},
  [843] = {.lex_state = 78, .external_lex_state = 2},
  [844] = {.lex_state = 78, .external_lex_state = 2},
  [845] = {.lex_state = 78, .external_lex_state = 2},
  [846] = {.lex_state = 78, .external_lex_state = 2},
  [847] = {.lex_state = 78, .external_lex_state = 2},
  [848] = {.lex_state = 78, .external_lex_state = 2},
  [849] = {.lex_state = 78, .external_lex_state = 2},
  [850] = {.lex_state = 78, .external_lex_state = 2},
  [851] = {.lex_state = 78, .external_lex_state = 2},
  [852] = {.lex_state = 78, .external_lex_state = 2},
  [853] = {.lex_state = 78, .external_lex_state = 2},
  [854] = {.lex_state = 78, .external_lex_state = 2},
  [855] = {.lex_state = 78, .external_lex_state = 2},
  [856] = {.lex_state = 78, .external_lex_state = 2},
  [857] = {.lex_state = 78, .external_lex_state = 2},
  [858] = {.lex_state = 78, .external_lex_state = 2},
  [859] = {.lex_state = 78, .external_lex_state = 2},
  [860] = {.lex_state = 78, .external_lex_state = 2},
  [861] = {.lex_state = 78, .external_lex_state = 2},
  [862] = {.lex_state = 78, .external_lex_state = 2},
  [863] = {.lex_state = 78, .external_lex_state = 2},
  [864] = {.lex_state = 78, .external_lex_state = 2},
  [865] = {.lex_state = 78, .external_lex_state = 2},
  [866] = {.lex_state = 78, .external_lex_state = 2},
  [867] = {.lex_state = 78, .external_lex_state = 2},
  [868] = {.lex_state = 78, .external_lex_state = 2},
  [869] = {.lex_state = 78, .external_lex_state = 2},
  [870] = {.lex_state = 78, .external_lex_state = 2},
  [871] = {.lex_state = 78, .external_lex_state = 2},
  [872] = {.lex_state = 78, .external_lex_state = 2},
  [873] = {.lex_state = 78, .external_lex_state = 2},
  [874] = {.lex_state = 78, .external_lex_state = 2},
  [875] = {.lex_state = 78, .external_lex_state = 2},
  [876] = {.lex_state = 78, .external_lex_state = 2},
  [877] = {.lex_state = 78, .external_lex_state = 2},
  [878] = {.lex_state = 78, .external_lex_state = 2},
  [879] = {.lex_state = 78, .external_lex_state = 2},
  [880] = {.lex_state = 78, .external_lex_state = 2},
  [881] = {.lex_state = 78, .external_lex_state = 2},
  [882] = {.lex_state = 78, .external_lex_state = 2},
  [883] = {.lex_state = 78, .external_lex_state = 2},
  [884] = {.lex_state = 78, .external_lex_state = 2},
  [885] = {.lex_state = 78, .external_lex_state = 2},
  [886] = {.lex_state = 78, .external_lex_state = 2},
  [887] = {.lex_state = 78, .external_lex_state = 2},
  [888] = {.lex_state = 78, .external_lex_state = 2},
  [889] = {.lex_state = 78, .external_lex_state = 2},
  [890] = {.lex_state = 78, .external_lex_state = 2},
  [891] = {.lex_state = 78, .external_lex_state = 2},
  [892] = {.lex_state = 78, .external_lex_state = 2},
  [893] = {.lex_state = 78, .external_lex_state = 2},
  [894] = {.lex_state = 78, .external_lex_state = 2},
  [895] = {.lex_state = 78, .external_lex_state = 2},
  [896] = {.lex_state = 78, .external_lex_state = 2},
  [897] = {.lex_state = 78, .external_lex_state = 2},
  [898] = {.lex_state = 78, .external_lex_state = 2},
  [899] = {.lex_state = 78, .external_lex_state = 2},
  [900] = {.lex_state = 78, .external_lex_state = 2},
  [901] = {.lex_state = 78, .external_lex_state = 2},
  [902] = {.lex_state = 78, .external_lex_state = 2},
  [903] = {.lex_state = 78, .external_lex_state = 2},
  [904] = {.lex_state = 78, .external_lex_state = 2},
  [905] = {.lex_state = 78, .external_lex_state = 2},
  [906] = {.lex_state = 78, .external_lex_state = 2},
  [907] = {.lex_state = 78, .external_lex_state = 2},
  [908] = {.lex_state = 78, .external_lex_state = 2},
  [909] = {.lex_state = 78, .external_lex_state = 2},
  [910] = {.lex_state = 78, .external_lex_state = 2},
  [911] = {.lex_state = 78, .external_lex_state = 2},
  [912] = {.lex_state = 78, .external_lex_state = 2},
  [913] = {.lex_state = 78, .external_lex_state = 2},
  [914] = {.lex_state = 78, .external_lex_state = 2},
  [915] = {.lex_state = 78, .external_lex_state = 2},
  [916] = {.lex_state = 78, .external_lex_state = 2},
  [917] = {.lex_state = 78, .external_lex_state = 2},
  [918] = {.lex_state = 78, .external_lex_state = 2},
  [919] = {.lex_state = 78, .external_lex_state = 2},
  [920] = {.lex_state = 78, .external_lex_state = 2},
  [921] = {.lex_state = 78, .external_lex_state = 2},
  [922] = {.lex_state = 78, .external_lex_state = 2},
  [923] = {.lex_state = 78, .external_lex_state = 2},
  [924] = {.lex_state = 78, .external_lex_state = 2},
  [925] = {.lex_state = 78, .external_lex_state = 2},
  [926] = {.lex_state = 78, .external_lex_state = 2},
  [927] = {.lex_state = 78, .external_lex_state = 2},
  [928] = {.lex_state = 78, .external_lex_state = 2},
  [929] = {.lex_state = 78, .external_lex_state = 2},
  [930] = {.lex_state = 78, .external_lex_state = 2},
  [931] = {.lex_state = 78, .external_lex_state = 2},
  [932] = {.lex_state = 78, .external_lex_state = 2},
  [933] = {.lex_state = 78, .external_lex_state = 2},
  [934] = {.lex_state = 78, .external_lex_state = 2},
  [935] = {.lex_state = 78, .external_lex_state = 2},
  [936] = {.lex_state = 78, .external_lex_state = 2},
  [937] = {.lex_state = 78, .external_lex_state = 2},
  [938] = {.lex_state = 78, .external_lex_state = 2},
  [939] = {.lex_state = 78, .external_lex_state = 2},
  [940] = {.lex_state = 78, .external_lex_state = 2},
  [941] = {.lex_state = 78, .external_lex_state = 2},
  [942] = {.lex_state = 78, .external_lex_state = 2},
  [943] = {.lex_state = 78, .external_lex_state = 2},
  [944] = {.lex_state = 78, .external_lex_state = 2},
  [945] = {.lex_state = 78, .external_lex_state = 2},
  [946] = {.lex_state = 78, .external_lex_state = 2},
  [947] = {.lex_state = 78, .external_lex_state = 2},
  [948] = {.lex_state = 78, .external_lex_state = 2},
  [949] = {.lex_state = 78, .external_lex_state = 2},
  [950] = {.lex_state = 78, .external_lex_state = 2},
  [951] = {.lex_state = 78, .external_lex_state = 2},
  [952] = {.lex_state = 78, .external_lex_state = 2},
  [953] = {.lex_state = 78, .external_lex_state = 2},
  [954] = {.lex_state = 78, .external_lex_state = 2},
  [955] = {.lex_state = 78, .external_lex_state = 2},
  [956] = {.lex_state = 78, .external_lex_state = 2},
  [957] = {.lex_state = 78, .external_lex_state = 2},
  [958] = {.lex_state = 78, .external_lex_state = 2},
  [959] = {.lex_state = 78, .external_lex_state = 2},
  [960] = {.lex_state = 78, .external_lex_state = 2},
  [961] = {.lex_state = 78, .external_lex_state = 2},
  [962] = {.lex_state = 78, .external_lex_state = 2},
  [963] = {.lex_state = 78, .external_lex_state = 2},
  [964] = {.lex_state = 78, .external_lex_state = 2},
  [965] = {.lex_state = 78, .external_lex_state = 2},
  [966] = {.lex_state = 78, .external_lex_state = 2},
  [967] = {.lex_state = 78, .external_lex_state = 2},
  [968] = {.lex_state = 78, .external_lex_state = 2},
  [969] = {.lex_state = 78, .external_lex_state = 2},
  [970] = {.lex_state = 78, .external_lex_state = 2},
  [971] = {.lex_state = 78, .external_lex_state = 2},
  [972] = {.lex_state = 78, .external_lex_state = 2},
  [973] = {.lex_state = 78, .external_lex_state = 2},
  [974] = {.lex_state = 78, .external_lex_state = 2},
  [975] = {.lex_state = 78, .external_lex_state = 2},
  [976] = {.lex_state = 78, .external_lex_state = 2},
  [977] = {.lex_state = 78, .external_lex_state = 2},
  [978] = {.lex_state = 78, .external_lex_state = 2},
  [979] = {.lex_state = 78, .external_lex_state = 2},
  [980] = {.lex_state = 78, .external_lex_state = 2},
  [981] = {.lex_state = 78, .external_lex_state = 2},
  [982] = {.lex_state = 78, .external_lex_state = 2},
  [983] = {.lex_state = 78, .external_lex_state = 2},
  [984] = {.lex_state = 78, .external_lex_state = 2},
  [985] = {.lex_state = 78, .external_lex_state = 2},
  [986] = {.lex_state = 78, .external_lex_state = 2},
  [987] = {.lex_state = 78, .external_lex_state = 2},
  [988] = {.lex_state = 78, .external_lex_state = 2},
  [989] = {.lex_state = 78, .external_lex_state = 2},
  [990] = {.lex_state = 78, .external_lex_state = 2},
  [991] = {.lex_state = 78, .external_lex_state = 2},
  [992] = {.lex_state = 78, .external_lex_state = 2},
  [993] = {.lex_state = 78, .external_lex_state = 2},
  [994] = {.lex_state = 78, .external_lex_state = 2},
  [995] = {.lex_state = 78, .external_lex_state = 2},
  [996] = {.lex_state = 78, .external_lex_state = 2},
  [997] = {.lex_state = 78, .external_lex_state = 2},
  [998] = {.lex_state = 78, .external_lex_state = 2},
  [999] = {.lex_state = 78, .external_lex_state = 2},
  [1000] = {.lex_state = 78, .external_lex_state = 2},
  [1001] = {.lex_state = 78, .external_lex_state = 2},
  [1002] = {.lex_state = 78, .external_lex_state = 2},
  [1003] = {.lex_state = 78, .external_lex_state = 2},
  [1004] = {.lex_state = 78, .external_lex_state = 2},
  [1005] = {.lex_state = 78, .external_lex_state = 2},
  [1006] = {.lex_state = 78, .external_lex_state = 2},
  [1007] = {.lex_state = 78, .external_lex_state = 2},
  [1008] = {.lex_state = 78, .external_lex_state = 2},
  [1009] = {.lex_state = 78, .external_lex_state = 2},
  [1010] = {.lex_state = 78, .external_lex_state = 2},
  [1011] = {.lex_state = 78, .external_lex_state = 2},
  [1012] = {.lex_state = 78, .external_lex_state = 2},
  [1013] = {.lex_state = 78, .external_lex_state = 2},
  [1014] = {.lex_state = 78, .external_lex_state = 2},
  [1015] = {.lex_state = 78, .external_lex_state = 2},
  [1016] = {.lex_state = 78, .external_lex_state = 2},
  [1017] = {.lex_state = 78, .external_lex_state = 2},
  [1018] = {.lex_state = 78, .external_lex_state = 2},
  [1019] = {.lex_state = 78, .external_lex_state = 2},
  [1020] = {.lex_state = 78, .external_lex_state = 2},
  [1021] = {.lex_state = 78, .external_lex_state = 2},
  [1022] = {.lex_state = 78, .external_lex_state = 2},
  [1023] = {.lex_state = 78, .external_lex_state = 2},
  [1024] = {.lex_state = 78, .external_lex_state = 2},
  [1025] = {.lex_state = 78, .external_lex_state = 2},
  [1026] = {.lex_state = 78, .external_lex_state = 2},
  [1027] = {.lex_state = 78, .external_lex_state = 2},
  [1028] = {.lex_state = 78, .external_lex_state = 2},
  [1029] = {.lex_state = 78, .external_lex_state = 2},
  [1030] = {.lex_state = 78, .external_lex_state = 2},
  [1031] = {.lex_state = 78, .external_lex_state = 2},
  [1032] = {.lex_state = 78, .external_lex_state = 2},
  [1033] = {.lex_state = 78, .external_lex_state = 2},
  [1034] = {.lex_state = 78, .external_lex_state = 2},
  [1035] = {.lex_state = 78, .external_lex_state = 2},
  [1036] = {.lex_state = 78, .external_lex_state = 2},
  [1037] = {.lex_state = 78, .external_lex_state = 2},
  [1038] = {.lex_state = 78, .external_lex_state = 2},
  [1039] = {.lex_state = 78, .external_lex_state = 2},
  [1040] = {.lex_state = 78, .external_lex_state = 2},
  [1041] = {.lex_state = 78, .external_lex_state = 2},
  [1042] = {.lex_state = 78, .external_lex_state = 2},
  [1043] = {.lex_state = 78, .external_lex_state = 2},
  [1044] = {.lex_state = 78, .external_lex_state = 2},
  [1045] = {.lex_state = 78, .external_lex_state = 2},
  [1046] = {.lex_state = 78, .external_lex_state = 2},
  [1047] = {.lex_state = 78, .external_lex_state = 2},
  [1048] = {.lex_state = 78, .external_lex_state = 2},
  [1049] = {.lex_state = 78, .external_lex_state = 2},
  [1050] = {.lex_state = 78, .external_lex_state = 2},
  [1051] = {.lex_state = 78, .external_lex_state = 2},
  [1052] = {.lex_state = 78, .external_lex_state = 2},
  [1053] = {.lex_state = 78, .external_lex_state = 2},
  [1054] = {.lex_state = 78, .external_lex_state = 2},
  [1055] = {.lex_state = 78, .external_lex_state = 2},
  [1056] = {.lex_state = 78, .external_lex_state = 2},
  [1057] = {.lex_state = 78, .external_lex_state = 2},
  [1058] = {.lex_state = 78, .external_lex_state = 2},
  [1059] = {.lex_state = 78, .external_lex_state = 2},
  [1060] = {.lex_state = 78, .external_lex_state = 2},
  [1061] = {.lex_state = 78, .external_lex_state = 2},
  [1062] = {.lex_state = 78, .external_lex_state = 2},
  [1063] = {.lex_state = 78, .external_lex_state = 2},
  [1064] = {.lex_state = 78, .external_lex_state = 2},
  [1065] = {.lex_state = 78, .external_lex_state = 2},
  [1066] = {.lex_state = 78, .external_lex_state = 2},
  [1067] = {.lex_state = 78, .external_lex_state = 2},
  [1068] = {.lex_state = 78, .external_lex_state = 2},
  [1069] = {.lex_state = 78, .external_lex_state = 2},
  [1070] = {.lex_state = 78, .external_lex_state = 2},
  [1071] = {.lex_state = 78, .external_lex_state = 2},
  [1072] = {.lex_state = 78, .external_lex_state = 2},
  [1073] = {.lex_state = 78, .external_lex_state = 2},
  [1074] = {.lex_state = 78, .external_lex_state = 2},
  [1075] = {.lex_state = 78, .external_lex_state = 2},
  [1076] = {.lex_state = 78, .external_lex_state = 2},
  [1077] = {.lex_state = 78, .external_lex_state = 2},
  [1078] = {.lex_state = 78, .external_lex_state = 2},
  [1079] = {.lex_state = 78, .external_lex_state = 2},
  [1080] = {.lex_state = 78, .external_lex_state = 2},
  [1081] = {.lex_state = 78, .external_lex_state = 2},
  [1082] = {.lex_state = 78, .external_lex_state = 2},
  [1083] = {.lex_state = 78, .external_lex_state = 2},
  [1084] = {.lex_state = 78, .external_lex_state = 2},
  [1085] = {.lex_state = 78, .external_lex_state = 2},
  [1086] = {.lex_state = 78, .external_lex_state = 2},
  [1087] = {.lex_state = 78, .external_lex_state = 2},
  [1088] = {.lex_state = 78, .external_lex_state = 2},
  [1089] = {.lex_state = 78, .external_lex_state = 2},
  [1090] = {.lex_state = 78, .external_lex_state = 2},
  [1091] = {.lex_state = 78, .external_lex_state = 2},
  [1092] = {.lex_state = 78, .external_lex_state = 2},
  [1093] = {.lex_state = 78, .external_lex_state = 2},
  [1094] = {.lex_state = 78, .external_lex_state = 2},
  [1095] = {.lex_state = 78, .external_lex_state = 2},
  [1096] = {.lex_state = 78, .external_lex_state = 2},
  [1097] = {.lex_state = 78, .external_lex_state = 2},
  [1098] = {.lex_state = 78, .external_lex_state = 2},
  [1099] = {.lex_state = 78, .external_lex_state = 2},
  [1100] = {.lex_state = 78, .external_lex_state = 2},
  [1101] = {.lex_state = 78, .external_lex_state = 2},
  [1102] = {.lex_state = 78, .external_lex_state = 2},
  [1103] = {.lex_state = 78, .external_lex_state = 2},
  [1104] = {.lex_state = 78, .external_lex_state = 2},
  [1105] = {.lex_state = 78, .external_lex_state = 2},
  [1106] = {.lex_state = 78, .external_lex_state = 2},
  [1107] = {.lex_state = 78, .external_lex_state = 2},
  [1108] = {.lex_state = 78, .external_lex_state = 2},
  [1109] = {.lex_state = 78, .external_lex_state = 2},
  [1110] = {.lex_state = 78, .external_lex_state = 2},
  [1111] = {.lex_state = 78, .external_lex_state = 2},
  [1112] = {.lex_state = 78, .external_lex_state = 2},
  [1113] = {.lex_state = 78, .external_lex_state = 2},
  [1114] = {.lex_state = 78, .external_lex_state = 2},
  [1115] = {.lex_state = 78, .external_lex_state = 2},
  [1116] = {.lex_state = 78, .external_lex_state = 2},
  [1117] = {.lex_state = 78, .external_lex_state = 2},
  [1118] = {.lex_state = 78, .external_lex_state = 2},
  [1119] = {.lex_state = 78, .external_lex_state = 2},
  [1120] = {.lex_state = 78, .external_lex_state = 2},
  [1121] = {.lex_state = 78, .external_lex_state = 2},
  [1122] = {.lex_state = 78, .external_lex_state = 2},
  [1123] = {.lex_state = 78, .external_lex_state = 2},
  [1124] = {.lex_state = 78, .external_lex_state = 2},
  [1125] = {.lex_state = 78, .external_lex_state = 2},
  [1126] = {.lex_state = 78, .external_lex_state = 2},
  [1127] = {.lex_state = 78, .external_lex_state = 2},
  [1128] = {.lex_state = 78, .external_lex_state = 2},
  [1129] = {.lex_state = 78, .external_lex_state = 2},
  [1130] = {.lex_state = 78, .external_lex_state = 2},
  [1131] = {.lex_state = 78, .external_lex_state = 2},
  [1132] = {.lex_state = 78, .external_lex_state = 2},
  [1133] = {.lex_state = 78, .external_lex_state = 2},
  [1134] = {.lex_state = 78, .external_lex_state = 2},
  [1135] = {.lex_state = 78, .external_lex_state = 2},
  [1136] = {.lex_state = 78, .external_lex_state = 2},
  [1137] = {.lex_state = 78, .external_lex_state = 2},
  [1138] = {.lex_state = 78, .external_lex_state = 2},
  [1139] = {.lex_state = 78, .external_lex_state = 2},
  [1140] = {.lex_state = 78, .external_lex_state = 2},
  [1141] = {.lex_state = 78, .external_lex_state = 2},
  [1142] = {.lex_state = 78, .external_lex_state = 2},
  [1143] = {.lex_state = 78, .external_lex_state = 2},
  [1144] = {.lex_state = 78, .external_lex_state = 2},
  [1145] = {.lex_state = 78, .external_lex_state = 2},
  [1146] = {.lex_state = 78, .external_lex_state = 2},
  [1147] = {.lex_state = 78, .external_lex_state = 2},
  [1148] = {.lex_state = 78, .external_lex_state = 2},
  [1149] = {.lex_state = 78, .external_lex_state = 2},
  [1150] = {.lex_state = 78, .external_lex_state = 2},
  [1151] = {.lex_state = 78, .external_lex_state = 2},
  [1152] = {.lex_state = 78, .external_lex_state = 2},
  [1153] = {.lex_state = 78, .external_lex_state = 2},
  [1154] = {.lex_state = 78, .external_lex_state = 2},
  [1155] = {.lex_state = 78, .external_lex_state = 2},
  [1156] = {.lex_state = 78, .external_lex_state = 2},
  [1157] = {.lex_state = 78, .external_lex_state = 2},
  [1158] = {.lex_state = 78, .external_lex_state = 2},
  [1159] = {.lex_state = 78, .external_lex_state = 2},
  [1160] = {.lex_state = 67, .external_lex_state = 3},
  [1161] = {.lex_state = 78, .external_lex_state = 2},
  [1162] = {.lex_state = 78, .external_lex_state = 2},
  [1163] = {.lex_state = 78, .external_lex_state = 2},
  [1164] = {.lex_state = 78, .external_lex_state = 2},
  [1165] = {.lex_state = 78, .external_lex_state = 2},
  [1166] = {.lex_state = 78, .external_lex_state = 2},
  [1167] = {.lex_state = 78, .external_lex_state = 2},
  [1168] = {.lex_state = 78, .external_lex_state = 2},
  [1169] = {.lex_state = 78, .external_lex_state = 2},
  [1170] = {.lex_state = 78, .external_lex_state = 2},
  [1171] = {.lex_state = 78, .external_lex_state = 2},
  [1172] = {.lex_state = 78, .external_lex_state = 2},
  [1173] = {.lex_state = 78, .external_lex_state = 2},
  [1174] = {.lex_state = 78, .external_lex_state = 2},
  [1175] = {.lex_state = 78, .external_lex_state = 2},
  [1176] = {.lex_state = 78, .external_lex_state = 2},
  [1177] = {.lex_state = 78, .external_lex_state = 2},
  [1178] = {.lex_state = 78, .external_lex_state = 2},
  [1179] = {.lex_state = 78, .external_lex_state = 2},
  [1180] = {.lex_state = 78, .external_lex_state = 2},
  [1181] = {.lex_state = 78, .external_lex_state = 2},
  [1182] = {.lex_state = 78, .external_lex_state = 2},
  [1183] = {.lex_state = 78, .external_lex_state = 2},
  [1184] = {.lex_state = 78, .external_lex_state = 2},
  [1185] = {.lex_state = 78, .external_lex_state = 2},
  [1186] = {.lex_state = 78, .external_lex_state = 2},
  [1187] = {.lex_state = 78, .external_lex_state = 2},
  [1188] = {.lex_state = 78, .external_lex_state = 2},
  [1189] = {.lex_state = 78, .external_lex_state = 2},
  [1190] = {.lex_state = 78, .external_lex_state = 2},
  [1191] = {.lex_state = 78, .external_lex_state = 2},
  [1192] = {.lex_state = 78, .external_lex_state = 2},
  [1193] = {.lex_state = 78, .external_lex_state = 2},
  [1194] = {.lex_state = 78, .external_lex_state = 2},
  [1195] = {.lex_state = 78, .external_lex_state = 2},
  [1196] = {.lex_state = 78, .external_lex_state = 2},
  [1197] = {.lex_state = 78, .external_lex_state = 2},
  [1198] = {.lex_state = 78, .external_lex_state = 2},
  [1199] = {.lex_state = 78, .external_lex_state = 2},
  [1200] = {.lex_state = 78, .external_lex_state = 2},
  [1201] = {.lex_state = 78, .external_lex_state = 2},
  [1202] = {.lex_state = 78, .external_lex_state = 2},
  [1203] = {.lex_state = 78, .external_lex_state = 2},
  [1204] = {.lex_state = 78, .external_lex_state = 2},
  [1205] = {.lex_state = 78, .external_lex_state = 2},
  [1206] = {.lex_state = 78, .external_lex_state = 2},
  [1207] = {.lex_state = 78, .external_lex_state = 2},
  [1208] = {.lex_state = 78, .external_lex_state = 2},
  [1209] = {.lex_state = 78, .external_lex_state = 2},
  [1210] = {.lex_state = 78, .external_lex_state = 2},
  [1211] = {.lex_state = 78, .external_lex_state = 2},
  [1212] = {.lex_state = 78, .external_lex_state = 2},
  [1213] = {.lex_state = 78, .external_lex_state = 2},
  [1214] = {.lex_state = 78, .external_lex_state = 2},
  [1215] = {.lex_state = 78, .external_lex_state = 2},
  [1216] = {.lex_state = 78, .external_lex_state = 2},
  [1217] = {.lex_state = 78, .external_lex_state = 2},
  [1218] = {.lex_state = 78, .external_lex_state = 2},
  [1219] = {.lex_state = 78, .external_lex_state = 2},
  [1220] = {.lex_state = 78, .external_lex_state = 2},
  [1221] = {.lex_state = 78, .external_lex_state = 2},
  [1222] = {.lex_state = 78, .external_lex_state = 2},
  [1223] = {.lex_state = 78, .external_lex_state = 2},
  [1224] = {.lex_state = 78, .external_lex_state = 2},
  [1225] = {.lex_state = 78, .external_lex_state = 2},
  [1226] = {.lex_state = 78, .external_lex_state = 2},
  [1227] = {.lex_state = 78, .external_lex_state = 2},
  [1228] = {.lex_state = 78, .external_lex_state = 2},
  [1229] = {.lex_state = 78, .external_lex_state = 2},
  [1230] = {.lex_state = 78, .external_lex_state = 2},
  [1231] = {.lex_state = 78, .external_lex_state = 2},
  [1232] = {.lex_state = 78, .external_lex_state = 2},
  [1233] = {.lex_state = 78, .external_lex_state = 2},
  [1234] = {.lex_state = 78, .external_lex_state = 2},
  [1235] = {.lex_state = 78, .external_lex_state = 2},
  [1236] = {.lex_state = 78, .external_lex_state = 2},
  [1237] = {.lex_state = 78, .external_lex_state = 2},
  [1238] = {.lex_state = 78, .external_lex_state = 2},
  [1239] = {.lex_state = 78, .external_lex_state = 2},
  [1240] = {.lex_state = 78, .external_lex_state = 2},
  [1241] = {.lex_state = 78, .external_lex_state = 2},
  [1242] = {.lex_state = 78, .external_lex_state = 2},
  [1243] = {.lex_state = 78, .external_lex_state = 2},
  [1244] = {.lex_state = 78, .external_lex_state = 2},
  [1245] = {.lex_state = 78, .external_lex_state = 2},
  [1246] = {.lex_state = 78, .external_lex_state = 2},
  [1247] = {.lex_state = 78, .external_lex_state = 2},
  [1248] = {.lex_state = 78, .external_lex_state = 2},
  [1249] = {.lex_state = 78, .external_lex_state = 2},
  [1250] = {.lex_state = 78, .external_lex_state = 2},
  [1251] = {.lex_state = 78, .external_lex_state = 2},
  [1252] = {.lex_state = 78, .external_lex_state = 2},
  [1253] = {.lex_state = 78, .external_lex_state = 2},
  [1254] = {.lex_state = 78, .external_lex_state = 2},
  [1255] = {.lex_state = 78, .external_lex_state = 2},
  [1256] = {.lex_state = 78, .external_lex_state = 2},
  [1257] = {.lex_state = 78, .external_lex_state = 2},
  [1258] = {.lex_state = 78, .external_lex_state = 2},
  [1259] = {.lex_state = 78, .external_lex_state = 2},
  [1260] = {.lex_state = 78, .external_lex_state = 2},
  [1261] = {.lex_state = 78, .external_lex_state = 2},
  [1262] = {.lex_state = 78, .external_lex_state = 2},
  [1263] = {.lex_state = 78, .external_lex_state = 2},
  [1264] = {.lex_state = 78, .external_lex_state = 2},
  [1265] = {.lex_state = 78, .external_lex_state = 2},
  [1266] = {.lex_state = 78, .external_lex_state = 2},
  [1267] = {.lex_state = 78, .external_lex_state = 2},
  [1268] = {.lex_state = 78, .external_lex_state = 2},
  [1269] = {.lex_state = 78, .external_lex_state = 2},
  [1270] = {.lex_state = 78, .external_lex_state = 2},
  [1271] = {.lex_state = 78, .external_lex_state = 2},
  [1272] = {.lex_state = 78, .external_lex_state = 2},
  [1273] = {.lex_state = 78, .external_lex_state = 2},
  [1274] = {.lex_state = 78, .external_lex_state = 2},
  [1275] = {.lex_state = 78, .external_lex_state = 2},
  [1276] = {.lex_state = 78, .external_lex_state = 2},
  [1277] = {.lex_state = 78, .external_lex_state = 2},
  [1278] = {.lex_state = 78, .external_lex_state = 2},
  [1279] = {.lex_state = 78, .external_lex_state = 2},
  [1280] = {.lex_state = 78, .external_lex_state = 2},
  [1281] = {.lex_state = 78, .external_lex_state = 2},
  [1282] = {.lex_state = 78, .external_lex_state = 2},
  [1283] = {.lex_state = 78, .external_lex_state = 2},
  [1284] = {.lex_state = 78, .external_lex_state = 2},
  [1285] = {.lex_state = 78, .external_lex_state = 2},
  [1286] = {.lex_state = 78, .external_lex_state = 2},
  [1287] = {.lex_state = 78, .external_lex_state = 2},
  [1288] = {.lex_state = 78, .external_lex_state = 2},
  [1289] = {.lex_state = 78, .external_lex_state = 2},
  [1290] = {.lex_state = 78, .external_lex_state = 2},
  [1291] = {.lex_state = 78, .external_lex_state = 2},
  [1292] = {.lex_state = 78, .external_lex_state = 2},
  [1293] = {.lex_state = 78, .external_lex_state = 2},
  [1294] = {.lex_state = 78, .external_lex_state = 2},
  [1295] = {.lex_state = 78, .external_lex_state = 2},
  [1296] = {.lex_state = 78, .external_lex_state = 2},
  [1297] = {.lex_state = 78, .external_lex_state = 2},
  [1298] = {.lex_state = 78, .external_lex_state = 2},
  [1299] = {.lex_state = 78, .external_lex_state = 2},
  [1300] = {.lex_state = 78, .external_lex_state = 2},
  [1301] = {.lex_state = 78, .external_lex_state = 2},
  [1302] = {.lex_state = 78, .external_lex_state = 2},
  [1303] = {.lex_state = 78, .external_lex_state = 2},
  [1304] = {.lex_state = 78, .external_lex_state = 2},
  [1305] = {.lex_state = 78, .external_lex_state = 2},
  [1306] = {.lex_state = 78, .external_lex_state = 2},
  [1307] = {.lex_state = 78, .external_lex_state = 2},
  [1308] = {.lex_state = 78, .external_lex_state = 2},
  [1309] = {.lex_state = 78, .external_lex_state = 2},
  [1310] = {.lex_state = 78, .external_lex_state = 2},
  [1311] = {.lex_state = 78, .external_lex_state = 2},
  [1312] = {.lex_state = 78, .external_lex_state = 2},
  [1313] = {.lex_state = 78, .external_lex_state = 2},
  [1314] = {.lex_state = 78, .external_lex_state = 2},
  [1315] = {.lex_state = 78, .external_lex_state = 2},
  [1316] = {.lex_state = 78, .external_lex_state = 2},
  [1317] = {.lex_state = 78, .external_lex_state = 2},
  [1318] = {.lex_state = 78, .external_lex_state = 2},
  [1319] = {.lex_state = 78, .external_lex_state = 2},
  [1320] = {.lex_state = 78, .external_lex_state = 2},
  [1321] = {.lex_state = 78, .external_lex_state = 2},
  [1322] = {.lex_state = 78, .external_lex_state = 2},
  [1323] = {.lex_state = 78, .external_lex_state = 2},
  [1324] = {.lex_state = 78, .external_lex_state = 2},
  [1325] = {.lex_state = 78, .external_lex_state = 2},
  [1326] = {.lex_state = 78, .external_lex_state = 2},
  [1327] = {.lex_state = 78, .external_lex_state = 2},
  [1328] = {.lex_state = 78, .external_lex_state = 2},
  [1329] = {.lex_state = 78, .external_lex_state = 2},
  [1330] = {.lex_state = 78, .external_lex_state = 2},
  [1331] = {.lex_state = 78, .external_lex_state = 2},
  [1332] = {.lex_state = 78, .external_lex_state = 2},
  [1333] = {.lex_state = 78, .external_lex_state = 2},
  [1334] = {.lex_state = 78, .external_lex_state = 2},
  [1335] = {.lex_state = 78, .external_lex_state = 2},
  [1336] = {.lex_state = 78, .external_lex_state = 2},
  [1337] = {.lex_state = 78, .external_lex_state = 2},
  [1338] = {.lex_state = 78, .external_lex_state = 2},
  [1339] = {.lex_state = 78, .external_lex_state = 2},
  [1340] = {.lex_state = 78, .external_lex_state = 2},
  [1341] = {.lex_state = 78, .external_lex_state = 2},
  [1342] = {.lex_state = 78, .external_lex_state = 2},
  [1343] = {.lex_state = 78, .external_lex_state = 2},
  [1344] = {.lex_state = 78, .external_lex_state = 2},
  [1345] = {.lex_state = 78, .external_lex_state = 2},
  [1346] = {.lex_state = 78, .external_lex_state = 2},
  [1347] = {.lex_state = 78, .external_lex_state = 2},
  [1348] = {.lex_state = 78, .external_lex_state = 2},
  [1349] = {.lex_state = 78, .external_lex_state = 2},
  [1350] = {.lex_state = 78, .external_lex_state = 2},
  [1351] = {.lex_state = 78, .external_lex_state = 2},
  [1352] = {.lex_state = 78, .external_lex_state = 2},
  [1353] = {.lex_state = 78, .external_lex_state = 2},
  [1354] = {.lex_state = 78, .external_lex_state = 2},
  [1355] = {.lex_state = 78, .external_lex_state = 2},
  [1356] = {.lex_state = 78, .external_lex_state = 2},
  [1357] = {.lex_state = 78, .external_lex_state = 2},
  [1358] = {.lex_state = 78, .external_lex_state = 2},
  [1359] = {.lex_state = 78, .external_lex_state = 2},
  [1360] = {.lex_state = 78, .external_lex_state = 2},
  [1361] = {.lex_state = 78, .external_lex_state = 2},
  [1362] = {.lex_state = 78, .external_lex_state = 2},
  [1363] = {.lex_state = 78, .external_lex_state = 2},
  [1364] = {.lex_state = 78, .external_lex_state = 2},
  [1365] = {.lex_state = 78, .external_lex_state = 2},
  [1366] = {.lex_state = 78, .external_lex_state = 2},
  [1367] = {.lex_state = 78, .external_lex_state = 2},
  [1368] = {.lex_state = 78, .external_lex_state = 2},
  [1369] = {.lex_state = 78, .external_lex_state = 2},
  [1370] = {.lex_state = 78, .external_lex_state = 2},
  [1371] = {.lex_state = 78, .external_lex_state = 2},
  [1372] = {.lex_state = 78, .external_lex_state = 2},
  [1373] = {.lex_state = 78, .external_lex_state = 2},
  [1374] = {.lex_state = 78, .external_lex_state = 2},
  [1375] = {.lex_state = 78, .external_lex_state = 2},
  [1376] = {.lex_state = 78, .external_lex_state = 2},
  [1377] = {.lex_state = 78, .external_lex_state = 2},
  [1378] = {.lex_state = 78, .external_lex_state = 2},
  [1379] = {.lex_state = 78, .external_lex_state = 2},
  [1380] = {.lex_state = 78, .external_lex_state = 2},
  [1381] = {.lex_state = 78, .external_lex_state = 2},
  [1382] = {.lex_state = 78, .external_lex_state = 2},
  [1383] = {.lex_state = 78, .external_lex_state = 2},
  [1384] = {.lex_state = 78, .external_lex_state = 2},
  [1385] = {.lex_state = 78, .external_lex_state = 2},
  [1386] = {.lex_state = 78, .external_lex_state = 2},
  [1387] = {.lex_state = 78, .external_lex_state = 2},
  [1388] = {.lex_state = 78, .external_lex_state = 2},
  [1389] = {.lex_state = 78, .external_lex_state = 2},
  [1390] = {.lex_state = 78, .external_lex_state = 2},
  [1391] = {.lex_state = 78, .external_lex_state = 2},
  [1392] = {.lex_state = 78, .external_lex_state = 2},
  [1393] = {.lex_state = 78, .external_lex_state = 2},
  [1394] = {.lex_state = 78, .external_lex_state = 2},
  [1395] = {.lex_state = 78, .external_lex_state = 2},
  [1396] = {.lex_state = 78, .external_lex_state = 2},
  [1397] = {.lex_state = 78, .external_lex_state = 2},
  [1398] = {.lex_state = 78, .external_lex_state = 2},
  [1399] = {.lex_state = 78, .external_lex_state = 2},
  [1400] = {.lex_state = 78, .external_lex_state = 2},
  [1401] = {.lex_state = 78, .external_lex_state = 2},
  [1402] = {.lex_state = 78, .external_lex_state = 2},
  [1403] = {.lex_state = 78, .external_lex_state = 2},
  [1404] = {.lex_state = 78, .external_lex_state = 2},
  [1405] = {.lex_state = 78, .external_lex_state = 2},
  [1406] = {.lex_state = 78, .external_lex_state = 2},
  [1407] = {.lex_state = 78, .external_lex_state = 2},
  [1408] = {.lex_state = 78, .external_lex_state = 2},
  [1409] = {.lex_state = 78, .external_lex_state = 2},
  [1410] = {.lex_state = 78, .external_lex_state = 2},
  [1411] = {.lex_state = 78, .external_lex_state = 2},
  [1412] = {.lex_state = 78, .external_lex_state = 2},
  [1413] = {.lex_state = 78, .external_lex_state = 2},
  [1414] = {.lex_state = 78, .external_lex_state = 2},
  [1415] = {.lex_state = 78, .external_lex_state = 2},
  [1416] = {.lex_state = 78, .external_lex_state = 2},
  [1417] = {.lex_state = 78, .external_lex_state = 2},
  [1418] = {.lex_state = 78, .external_lex_state = 2},
  [1419] = {.lex_state = 78, .external_lex_state = 2},
  [1420] = {.lex_state = 78, .external_lex_state = 2},
  [1421] = {.lex_state = 78, .external_lex_state = 2},
  [1422] = {.lex_state = 78, .external_lex_state = 2},
  [1423] = {.lex_state = 78, .external_lex_state = 2},
  [1424] = {.lex_state = 78, .external_lex_state = 2},
  [1425] = {.lex_state = 78, .external_lex_state = 2},
  [1426] = {.lex_state = 78, .external_lex_state = 2},
  [1427] = {.lex_state = 78, .external_lex_state = 2},
  [1428] = {.lex_state = 78, .external_lex_state = 2},
  [1429] = {.lex_state = 78, .external_lex_state = 2},
  [1430] = {.lex_state = 78, .external_lex_state = 2},
  [1431] = {.lex_state = 78, .external_lex_state = 2},
  [1432] = {.lex_state = 78, .external_lex_state = 2},
  [1433] = {.lex_state = 78, .external_lex_state = 2},
  [1434] = {.lex_state = 78, .external_lex_state = 2},
  [1435] = {.lex_state = 78, .external_lex_state = 2},
  [1436] = {.lex_state = 78, .external_lex_state = 2},
  [1437] = {.lex_state = 78, .external_lex_state = 2},
  [1438] = {.lex_state = 78, .external_lex_state = 2},
  [1439] = {.lex_state = 78, .external_lex_state = 2},
  [1440] = {.lex_state = 78, .external_lex_state = 2},
  [1441] = {.lex_state = 78, .external_lex_state = 2},
  [1442] = {.lex_state = 78, .external_lex_state = 2},
  [1443] = {.lex_state = 78, .external_lex_state = 2},
  [1444] = {.lex_state = 78, .external_lex_state = 2},
  [1445] = {.lex_state = 78, .external_lex_state = 2},
  [1446] = {.lex_state = 78, .external_lex_state = 2},
  [1447] = {.lex_state = 78, .external_lex_state = 2},
  [1448] = {.lex_state = 78, .external_lex_state = 2},
  [1449] = {.lex_state = 78, .external_lex_state = 2},
  [1450] = {.lex_state = 78, .external_lex_state = 2},
  [1451] = {.lex_state = 78, .external_lex_state = 2},
  [1452] = {.lex_state = 78, .external_lex_state = 2},
  [1453] = {.lex_state = 78, .external_lex_state = 2},
  [1454] = {.lex_state = 78, .external_lex_state = 2},
  [1455] = {.lex_state = 78, .external_lex_state = 2},
  [1456] = {.lex_state = 78, .external_lex_state = 2},
  [1457] = {.lex_state = 78, .external_lex_state = 2},
  [1458] = {.lex_state = 78, .external_lex_state = 2},
  [1459] = {.lex_state = 78, .external_lex_state = 2},
  [1460] = {.lex_state = 78, .external_lex_state = 2},
  [1461] = {.lex_state = 78, .external_lex_state = 2},
  [1462] = {.lex_state = 78, .external_lex_state = 2},
  [1463] = {.lex_state = 78, .external_lex_state = 2},
  [1464] = {.lex_state = 78, .external_lex_state = 2},
  [1465] = {.lex_state = 78, .external_lex_state = 2},
  [1466] = {.lex_state = 78, .external_lex_state = 2},
  [1467] = {.lex_state = 78, .external_lex_state = 2},
  [1468] = {.lex_state = 78, .external_lex_state = 2},
  [1469] = {.lex_state = 78, .external_lex_state = 2},
  [1470] = {.lex_state = 78, .external_lex_state = 2},
  [1471] = {.lex_state = 78, .external_lex_state = 2},
  [1472] = {.lex_state = 78, .external_lex_state = 2},
  [1473] = {.lex_state = 78, .external_lex_state = 2},
  [1474] = {.lex_state = 78, .external_lex_state = 2},
  [1475] = {.lex_state = 78, .external_lex_state = 2},
  [1476] = {.lex_state = 78, .external_lex_state = 2},
  [1477] = {.lex_state = 78, .external_lex_state = 2},
  [1478] = {.lex_state = 78, .external_lex_state = 2},
  [1479] = {.lex_state = 78, .external_lex_state = 2},
  [1480] = {.lex_state = 78, .external_lex_state = 2},
  [1481] = {.lex_state = 78, .external_lex_state = 2},
  [1482] = {.lex_state = 78, .external_lex_state = 2},
  [1483] = {.lex_state = 78, .external_lex_state = 2},
  [1484] = {.lex_state = 78, .external_lex_state = 2},
  [1485] = {.lex_state = 78, .external_lex_state = 2},
  [1486] = {.lex_state = 78, .external_lex_state = 2},
  [1487] = {.lex_state = 78, .external_lex_state = 2},
  [1488] = {.lex_state = 78, .external_lex_state = 2},
  [1489] = {.lex_state = 78, .external_lex_state = 2},
  [1490] = {.lex_state = 78, .external_lex_state = 2},
  [1491] = {.lex_state = 78, .external_lex_state = 2},
  [1492] = {.lex_state = 78, .external_lex_state = 2},
  [1493] = {.lex_state = 78, .external_lex_state = 2},
  [1494] = {.lex_state = 78, .external_lex_state = 2},
  [1495] = {.lex_state = 78, .external_lex_state = 2},
  [1496] = {.lex_state = 78, .external_lex_state = 2},
  [1497] = {.lex_state = 78, .external_lex_state = 2},
  [1498] = {.lex_state = 78, .external_lex_state = 2},
  [1499] = {.lex_state = 78, .external_lex_state = 2},
  [1500] = {.lex_state = 78, .external_lex_state = 2},
  [1501] = {.lex_state = 78, .external_lex_state = 2},
  [1502] = {.lex_state = 78, .external_lex_state = 2},
  [1503] = {.lex_state = 78, .external_lex_state = 2},
  [1504] = {.lex_state = 78, .external_lex_state = 2},
  [1505] = {.lex_state = 78, .external_lex_state = 2},
  [1506] = {.lex_state = 78, .external_lex_state = 2},
  [1507] = {.lex_state = 78, .external_lex_state = 2},
  [1508] = {.lex_state = 78, .external_lex_state = 2},
  [1509] = {.lex_state = 78, .external_lex_state = 2},
  [1510] = {.lex_state = 78, .external_lex_state = 2},
  [1511] = {.lex_state = 78, .external_lex_state = 2},
  [1512] = {.lex_state = 78, .external_lex_state = 2},
  [1513] = {.lex_state = 78, .external_lex_state = 2},
  [1514] = {.lex_state = 78, .external_lex_state = 2},
  [1515] = {.lex_state = 78, .external_lex_state = 2},
  [1516] = {.lex_state = 78, .external_lex_state = 2},
  [1517] = {.lex_state = 78, .external_lex_state = 2},
  [1518] = {.lex_state = 78, .external_lex_state = 2},
  [1519] = {.lex_state = 78, .external_lex_state = 2},
  [1520] = {.lex_state = 78, .external_lex_state = 2},
  [1521] = {.lex_state = 78, .external_lex_state = 2},
  [1522] = {.lex_state = 78, .external_lex_state = 2},
  [1523] = {.lex_state = 78, .external_lex_state = 2},
  [1524] = {.lex_state = 78, .external_lex_state = 2},
  [1525] = {.lex_state = 78, .external_lex_state = 2},
  [1526] = {.lex_state = 78, .external_lex_state = 2},
  [1527] = {.lex_state = 78, .external_lex_state = 2},
  [1528] = {.lex_state = 78, .external_lex_state = 2},
  [1529] = {.lex_state = 78, .external_lex_state = 2},
  [1530] = {.lex_state = 78, .external_lex_state = 2},
  [1531] = {.lex_state = 78, .external_lex_state = 2},
  [1532] = {.lex_state = 78, .external_lex_state = 2},
  [1533] = {.lex_state = 78, .external_lex_state = 2},
  [1534] = {.lex_state = 78, .external_lex_state = 2},
  [1535] = {.lex_state = 78, .external_lex_state = 2},
  [1536] = {.lex_state = 78, .external_lex_state = 2},
  [1537] = {.lex_state = 78, .external_lex_state = 2},
  [1538] = {.lex_state = 78, .external_lex_state = 2},
  [1539] = {.lex_state = 78, .external_lex_state = 2},
  [1540] = {.lex_state = 78, .external_lex_state = 2},
  [1541] = {.lex_state = 78, .external_lex_state = 2},
  [1542] = {.lex_state = 78, .external_lex_state = 2},
  [1543] = {.lex_state = 78, .external_lex_state = 2},
  [1544] = {.lex_state = 78, .external_lex_state = 2},
  [1545] = {.lex_state = 78, .external_lex_state = 2},
  [1546] = {.lex_state = 78, .external_lex_state = 2},
  [1547] = {.lex_state = 78, .external_lex_state = 2},
  [1548] = {.lex_state = 78, .external_lex_state = 2},
  [1549] = {.lex_state = 78, .external_lex_state = 2},
  [1550] = {.lex_state = 78, .external_lex_state = 2},
  [1551] = {.lex_state = 78, .external_lex_state = 2},
  [1552] = {.lex_state = 78, .external_lex_state = 2},
  [1553] = {.lex_state = 78, .external_lex_state = 2},
  [1554] = {.lex_state = 78, .external_lex_state = 2},
  [1555] = {.lex_state = 78, .external_lex_state = 2},
  [1556] = {.lex_state = 78, .external_lex_state = 2},
  [1557] = {.lex_state = 78, .external_lex_state = 2},
  [1558] = {.lex_state = 78, .external_lex_state = 2},
  [1559] = {.lex_state = 78, .external_lex_state = 2},
  [1560] = {.lex_state = 78, .external_lex_state = 2},
  [1561] = {.lex_state = 78, .external_lex_state = 2},
  [1562] = {.lex_state = 78, .external_lex_state = 2},
  [1563] = {.lex_state = 78, .external_lex_state = 2},
  [1564] = {.lex_state = 78, .external_lex_state = 2},
  [1565] = {.lex_state = 78, .external_lex_state = 2},
  [1566] = {.lex_state = 78, .external_lex_state = 2},
  [1567] = {.lex_state = 78, .external_lex_state = 2},
  [1568] = {.lex_state = 78, .external_lex_state = 2},
  [1569] = {.lex_state = 78, .external_lex_state = 2},
  [1570] = {.lex_state = 78, .external_lex_state = 2},
  [1571] = {.lex_state = 78, .external_lex_state = 2},
  [1572] = {.lex_state = 78, .external_lex_state = 2},
  [1573] = {.lex_state = 78, .external_lex_state = 2},
  [1574] = {.lex_state = 78, .external_lex_state = 2},
  [1575] = {.lex_state = 78, .external_lex_state = 2},
  [1576] = {.lex_state = 78, .external_lex_state = 2},
  [1577] = {.lex_state = 78, .external_lex_state = 2},
  [1578] = {.lex_state = 78, .external_lex_state = 2},
  [1579] = {.lex_state = 78, .external_lex_state = 2},
  [1580] = {.lex_state = 78, .external_lex_state = 2},
  [1581] = {.lex_state = 78, .external_lex_state = 2},
  [1582] = {.lex_state = 78, .external_lex_state = 2},
  [1583] = {.lex_state = 78, .external_lex_state = 2},
  [1584] = {.lex_state = 78, .external_lex_state = 2},
  [1585] = {.lex_state = 78, .external_lex_state = 2},
  [1586] = {.lex_state = 78, .external_lex_state = 2},
  [1587] = {.lex_state = 78, .external_lex_state = 2},
  [1588] = {.lex_state = 78, .external_lex_state = 2},
  [1589] = {.lex_state = 78, .external_lex_state = 2},
  [1590] = {.lex_state = 78, .external_lex_state = 2},
  [1591] = {.lex_state = 78, .external_lex_state = 2},
  [1592] = {.lex_state = 78, .external_lex_state = 2},
  [1593] = {.lex_state = 78, .external_lex_state = 2},
  [1594] = {.lex_state = 78, .external_lex_state = 2},
  [1595] = {.lex_state = 78, .external_lex_state = 2},
  [1596] = {.lex_state = 78, .external_lex_state = 2},
  [1597] = {.lex_state = 78, .external_lex_state = 2},
  [1598] = {.lex_state = 78, .external_lex_state = 2},
  [1599] = {.lex_state = 78, .external_lex_state = 2},
  [1600] = {.lex_state = 78, .external_lex_state = 2},
  [1601] = {.lex_state = 78, .external_lex_state = 2},
  [1602] = {.lex_state = 78, .external_lex_state = 2},
  [1603] = {.lex_state = 78, .external_lex_state = 2},
  [1604] = {.lex_state = 78, .external_lex_state = 2},
  [1605] = {.lex_state = 78, .external_lex_state = 2},
  [1606] = {.lex_state = 78, .external_lex_state = 2},
  [1607] = {.lex_state = 78, .external_lex_state = 2},
  [1608] = {.lex_state = 78, .external_lex_state = 2},
  [1609] = {.lex_state = 78, .external_lex_state = 2},
  [1610] = {.lex_state = 78, .external_lex_state = 2},
  [1611] = {.lex_state = 78, .external_lex_state = 2},
  [1612] = {.lex_state = 78, .external_lex_state = 2},
  [1613] = {.lex_state = 78, .external_lex_state = 2},
  [1614] = {.lex_state = 78, .external_lex_state = 2},
  [1615] = {.lex_state = 78, .external_lex_state = 2},
  [1616] = {.lex_state = 78, .external_lex_state = 2},
  [1617] = {.lex_state = 78, .external_lex_state = 2},
  [1618] = {.lex_state = 78, .external_lex_state = 2},
  [1619] = {.lex_state = 78, .external_lex_state = 2},
  [1620] = {.lex_state = 78, .external_lex_state = 2},
  [1621] = {.lex_state = 78, .external_lex_state = 2},
  [1622] = {.lex_state = 78, .external_lex_state = 2},
  [1623] = {.lex_state = 78, .external_lex_state = 2},
  [1624] = {.lex_state = 78, .external_lex_state = 2},
  [1625] = {.lex_state = 78, .external_lex_state = 2},
  [1626] = {.lex_state = 78, .external_lex_state = 2},
  [1627] = {.lex_state = 78, .external_lex_state = 2},
  [1628] = {.lex_state = 78, .external_lex_state = 2},
  [1629] = {.lex_state = 78, .external_lex_state = 2},
  [1630] = {.lex_state = 78, .external_lex_state = 2},
  [1631] = {.lex_state = 78, .external_lex_state = 2},
  [1632] = {.lex_state = 78, .external_lex_state = 2},
  [1633] = {.lex_state = 78, .external_lex_state = 2},
  [1634] = {.lex_state = 78, .external_lex_state = 2},
  [1635] = {.lex_state = 78, .external_lex_state = 2},
  [1636] = {.lex_state = 78, .external_lex_state = 2},
  [1637] = {.lex_state = 78, .external_lex_state = 2},
  [1638] = {.lex_state = 78, .external_lex_state = 2},
  [1639] = {.lex_state = 78, .external_lex_state = 2},
  [1640] = {.lex_state = 78, .external_lex_state = 2},
  [1641] = {.lex_state = 78, .external_lex_state = 2},
  [1642] = {.lex_state = 78, .external_lex_state = 2},
  [1643] = {.lex_state = 78, .external_lex_state = 2},
  [1644] = {.lex_state = 78, .external_lex_state = 2},
  [1645] = {.lex_state = 78, .external_lex_state = 2},
  [1646] = {.lex_state = 78, .external_lex_state = 2},
  [1647] = {.lex_state = 78, .external_lex_state = 2},
  [1648] = {.lex_state = 78, .external_lex_state = 2},
  [1649] = {.lex_state = 78, .external_lex_state = 2},
  [1650] = {.lex_state = 78, .external_lex_state = 2},
  [1651] = {.lex_state = 78, .external_lex_state = 2},
  [1652] = {.lex_state = 78, .external_lex_state = 2},
  [1653] = {.lex_state = 78, .external_lex_state = 2},
  [1654] = {.lex_state = 78, .external_lex_state = 2},
  [1655] = {.lex_state = 78, .external_lex_state = 2},
  [1656] = {.lex_state = 78, .external_lex_state = 2},
  [1657] = {.lex_state = 78, .external_lex_state = 2},
  [1658] = {.lex_state = 67, .external_lex_state = 3},
  [1659] = {.lex_state = 78, .external_lex_state = 2},
  [1660] = {.lex_state = 78, .external_lex_state = 2},
  [1661] = {.lex_state = 78, .external_lex_state = 2},
  [1662] = {.lex_state = 78, .external_lex_state = 2},
  [1663] = {.lex_state = 78, .external_lex_state = 2},
  [1664] = {.lex_state = 78, .external_lex_state = 2},
  [1665] = {.lex_state = 78, .external_lex_state = 2},
  [1666] = {.lex_state = 78, .external_lex_state = 2},
  [1667] = {.lex_state = 78, .external_lex_state = 2},
  [1668] = {.lex_state = 78, .external_lex_state = 2},
  [1669] = {.lex_state = 78, .external_lex_state = 2},
  [1670] = {.lex_state = 78, .external_lex_state = 2},
  [1671] = {.lex_state = 78, .external_lex_state = 2},
  [1672] = {.lex_state = 78, .external_lex_state = 2},
  [1673] = {.lex_state = 78, .external_lex_state = 2},
  [1674] = {.lex_state = 78, .external_lex_state = 2},
  [1675] = {.lex_state = 78, .external_lex_state = 2},
  [1676] = {.lex_state = 78, .external_lex_state = 2},
  [1677] = {.lex_state = 78, .external_lex_state = 2},
  [1678] = {.lex_state = 78, .external_lex_state = 2},
  [1679] = {.lex_state = 78, .external_lex_state = 2},
  [1680] = {.lex_state = 78, .external_lex_state = 2},
  [1681] = {.lex_state = 78, .external_lex_state = 2},
  [1682] = {.lex_state = 78, .external_lex_state = 2},
  [1683] = {.lex_state = 78, .external_lex_state = 2},
  [1684] = {.lex_state = 78, .external_lex_state = 2},
  [1685] = {.lex_state = 78, .external_lex_state = 2},
  [1686] = {.lex_state = 78, .external_lex_state = 2},
  [1687] = {.lex_state = 78, .external_lex_state = 2},
  [1688] = {.lex_state = 78, .external_lex_state = 2},
  [1689] = {.lex_state = 78, .external_lex_state = 2},
  [1690] = {.lex_state = 78, .external_lex_state = 2},
  [1691] = {.lex_state = 78, .external_lex_state = 2},
  [1692] = {.lex_state = 78, .external_lex_state = 2},
  [1693] = {.lex_state = 78, .external_lex_state = 2},
  [1694] = {.lex_state = 78, .external_lex_state = 2},
  [1695] = {.lex_state = 78, .external_lex_state = 2},
  [1696] = {.lex_state = 78, .external_lex_state = 2},
  [1697] = {.lex_state = 78, .external_lex_state = 2},
  [1698] = {.lex_state = 78, .external_lex_state = 2},
  [1699] = {.lex_state = 78, .external_lex_state = 2},
  [1700] = {.lex_state = 78, .external_lex_state = 2},
  [1701] = {.lex_state = 78, .external_lex_state = 2},
  [1702] = {.lex_state = 78, .external_lex_state = 2},
  [1703] = {.lex_state = 78, .external_lex_state = 2},
  [1704] = {.lex_state = 78, .external_lex_state = 2},
  [1705] = {.lex_state = 78, .external_lex_state = 2},
  [1706] = {.lex_state = 78, .external_lex_state = 2},
  [1707] = {.lex_state = 78, .external_lex_state = 2},
  [1708] = {.lex_state = 78, .external_lex_state = 2},
  [1709] = {.lex_state = 78, .external_lex_state = 2},
  [1710] = {.lex_state = 78, .external_lex_state = 2},
  [1711] = {.lex_state = 78, .external_lex_state = 2},
  [1712] = {.lex_state = 78, .external_lex_state = 2},
  [1713] = {.lex_state = 78, .external_lex_state = 2},
  [1714] = {.lex_state = 78, .external_lex_state = 2},
  [1715] = {.lex_state = 78, .external_lex_state = 2},
  [1716] = {.lex_state = 78, .external_lex_state = 2},
  [1717] = {.lex_state = 78, .external_lex_state = 2},
  [1718] = {.lex_state = 78, .external_lex_state = 2},
  [1719] = {.lex_state = 78, .external_lex_state = 2},
  [1720] = {.lex_state = 78, .external_lex_state = 2},
  [1721] = {.lex_state = 78, .external_lex_state = 2},
  [1722] = {.lex_state = 78, .external_lex_state = 2},
  [1723] = {.lex_state = 78, .external_lex_state = 2},
  [1724] = {.lex_state = 78, .external_lex_state = 2},
  [1725] = {.lex_state = 78, .external_lex_state = 2},
  [1726] = {.lex_state = 78, .external_lex_state = 2},
  [1727] = {.lex_state = 78, .external_lex_state = 2},
  [1728] = {.lex_state = 78, .external_lex_state = 2},
  [1729] = {.lex_state = 78, .external_lex_state = 2},
  [1730] = {.lex_state = 78, .external_lex_state = 2},
  [1731] = {.lex_state = 78, .external_lex_state = 2},
  [1732] = {.lex_state = 78, .external_lex_state = 2},
  [1733] = {.lex_state = 78, .external_lex_state = 2},
  [1734] = {.lex_state = 78, .external_lex_state = 2},
  [1735] = {.lex_state = 78, .external_lex_state = 2},
  [1736] = {.lex_state = 78, .external_lex_state = 2},
  [1737] = {.lex_state = 78, .external_lex_state = 2},
  [1738] = {.lex_state = 78, .external_lex_state = 2},
  [1739] = {.lex_state = 78, .external_lex_state = 2},
  [1740] = {.lex_state = 78, .external_lex_state = 2},
  [1741] = {.lex_state = 78, .external_lex_state = 2},
  [1742] = {.lex_state = 78, .external_lex_state = 2},
  [1743] = {.lex_state = 78, .external_lex_state = 2},
  [1744] = {.lex_state = 78, .external_lex_state = 2},
  [1745] = {.lex_state = 78, .external_lex_state = 2},
  [1746] = {.lex_state = 78, .external_lex_state = 2},
  [1747] = {.lex_state = 78, .external_lex_state = 2},
  [1748] = {.lex_state = 78, .external_lex_state = 2},
  [1749] = {.lex_state = 78, .external_lex_state = 2},
  [1750] = {.lex_state = 78, .external_lex_state = 2},
  [1751] = {.lex_state = 78, .external_lex_state = 2},
  [1752] = {.lex_state = 78, .external_lex_state = 2},
  [1753] = {.lex_state = 78, .external_lex_state = 2},
  [1754] = {.lex_state = 78, .external_lex_state = 2},
  [1755] = {.lex_state = 78, .external_lex_state = 2},
  [1756] = {.lex_state = 78, .external_lex_state = 2},
  [1757] = {.lex_state = 78, .external_lex_state = 2},
  [1758] = {.lex_state = 78, .external_lex_state = 2},
  [1759] = {.lex_state = 78, .external_lex_state = 2},
  [1760] = {.lex_state = 78, .external_lex_state = 2},
  [1761] = {.lex_state = 78, .external_lex_state = 2},
  [1762] = {.lex_state = 78, .external_lex_state = 2},
  [1763] = {.lex_state = 78, .external_lex_state = 2},
  [1764] = {.lex_state = 78, .external_lex_state = 2},
  [1765] = {.lex_state = 78, .external_lex_state = 2},
  [1766] = {.lex_state = 78, .external_lex_state = 2},
  [1767] = {.lex_state = 78, .external_lex_state = 2},
  [1768] = {.lex_state = 78, .external_lex_state = 2},
  [1769] = {.lex_state = 78, .external_lex_state = 2},
  [1770] = {.lex_state = 78, .external_lex_state = 2},
  [1771] = {.lex_state = 78, .external_lex_state = 2},
  [1772] = {.lex_state = 78, .external_lex_state = 2},
  [1773] = {.lex_state = 78, .external_lex_state = 2},
  [1774] = {.lex_state = 78, .external_lex_state = 2},
  [1775] = {.lex_state = 78, .external_lex_state = 2},
  [1776] = {.lex_state = 78, .external_lex_state = 2},
  [1777] = {.lex_state = 78, .external_lex_state = 2},
  [1778] = {.lex_state = 78, .external_lex_state = 2},
  [1779] = {.lex_state = 78, .external_lex_state = 2},
  [1780] = {.lex_state = 78, .external_lex_state = 2},
  [1781] = {.lex_state = 78, .external_lex_state = 2},
  [1782] = {.lex_state = 78, .external_lex_state = 2},
  [1783] = {.lex_state = 78, .external_lex_state = 2},
  [1784] = {.lex_state = 78, .external_lex_state = 2},
  [1785] = {.lex_state = 78, .external_lex_state = 2},
  [1786] = {.lex_state = 78, .external_lex_state = 2},
  [1787] = {.lex_state = 78, .external_lex_state = 2},
  [1788] = {.lex_state = 78, .external_lex_state = 2},
  [1789] = {.lex_state = 78, .external_lex_state = 2},
  [1790] = {.lex_state = 78, .external_lex_state = 2},
  [1791] = {.lex_state = 78, .external_lex_state = 2},
  [1792] = {.lex_state = 78, .external_lex_state = 2},
  [1793] = {.lex_state = 78, .external_lex_state = 2},
  [1794] = {.lex_state = 78, .external_lex_state = 2},
  [1795] = {.lex_state = 78, .external_lex_state = 2},
  [1796] = {.lex_state = 78, .external_lex_state = 2},
  [1797] = {.lex_state = 78, .external_lex_state = 2},
  [1798] = {.lex_state = 78, .external_lex_state = 2},
  [1799] = {.lex_state = 78, .external_lex_state = 2},
  [1800] = {.lex_state = 78, .external_lex_state = 2},
  [1801] = {.lex_state = 78, .external_lex_state = 2},
  [1802] = {.lex_state = 78, .external_lex_state = 2},
  [1803] = {.lex_state = 78, .external_lex_state = 2},
  [1804] = {.lex_state = 78, .external_lex_state = 2},
  [1805] = {.lex_state = 78, .external_lex_state = 2},
  [1806] = {.lex_state = 78, .external_lex_state = 2},
  [1807] = {.lex_state = 78, .external_lex_state = 2},
  [1808] = {.lex_state = 78, .external_lex_state = 2},
  [1809] = {.lex_state = 78, .external_lex_state = 2},
  [1810] = {.lex_state = 78, .external_lex_state = 2},
  [1811] = {.lex_state = 78, .external_lex_state = 2},
  [1812] = {.lex_state = 78, .external_lex_state = 2},
  [1813] = {.lex_state = 78, .external_lex_state = 2},
  [1814] = {.lex_state = 78, .external_lex_state = 2},
  [1815] = {.lex_state = 78, .external_lex_state = 2},
  [1816] = {.lex_state = 78, .external_lex_state = 2},
  [1817] = {.lex_state = 78, .external_lex_state = 2},
  [1818] = {.lex_state = 78, .external_lex_state = 2},
  [1819] = {.lex_state = 78, .external_lex_state = 2},
  [1820] = {.lex_state = 78, .external_lex_state = 2},
  [1821] = {.lex_state = 78, .external_lex_state = 2},
  [1822] = {.lex_state = 78, .external_lex_state = 2},
  [1823] = {.lex_state = 78, .external_lex_state = 2},
  [1824] = {.lex_state = 78, .external_lex_state = 2},
  [1825] = {.lex_state = 78, .external_lex_state = 2},
  [1826] = {.lex_state = 78, .external_lex_state = 2},
  [1827] = {.lex_state = 78, .external_lex_state = 2},
  [1828] = {.lex_state = 78, .external_lex_state = 2},
  [1829] = {.lex_state = 78, .external_lex_state = 2},
  [1830] = {.lex_state = 78, .external_lex_state = 2},
  [1831] = {.lex_state = 78, .external_lex_state = 2},
  [1832] = {.lex_state = 78, .external_lex_state = 2},
  [1833] = {.lex_state = 78, .external_lex_state = 2},
  [1834] = {.lex_state = 78, .external_lex_state = 2},
  [1835] = {.lex_state = 78, .external_lex_state = 2},
  [1836] = {.lex_state = 78, .external_lex_state = 2},
  [1837] = {.lex_state = 78, .external_lex_state = 2},
  [1838] = {.lex_state = 78, .external_lex_state = 2},
  [1839] = {.lex_state = 78, .external_lex_state = 2},
  [1840] = {.lex_state = 78, .external_lex_state = 2},
  [1841] = {.lex_state = 78, .external_lex_state = 2},
  [1842] = {.lex_state = 78, .external_lex_state = 2},
  [1843] = {.lex_state = 78, .external_lex_state = 2},
  [1844] = {.lex_state = 78, .external_lex_state = 2},
  [1845] = {.lex_state = 78, .external_lex_state = 2},
  [1846] = {.lex_state = 78, .external_lex_state = 2},
  [1847] = {.lex_state = 78, .external_lex_state = 2},
  [1848] = {.lex_state = 78, .external_lex_state = 2},
  [1849] = {.lex_state = 78, .external_lex_state = 2},
  [1850] = {.lex_state = 78, .external_lex_state = 2},
  [1851] = {.lex_state = 78, .external_lex_state = 2},
  [1852] = {.lex_state = 78, .external_lex_state = 2},
  [1853] = {.lex_state = 78, .external_lex_state = 2},
  [1854] = {.lex_state = 78, .external_lex_state = 2},
  [1855] = {.lex_state = 78, .external_lex_state = 2},
  [1856] = {.lex_state = 78, .external_lex_state = 2},
  [1857] = {.lex_state = 78, .external_lex_state = 2},
  [1858] = {.lex_state = 78, .external_lex_state = 2},
  [1859] = {.lex_state = 78, .external_lex_state = 2},
  [1860] = {.lex_state = 78, .external_lex_state = 2},
  [1861] = {.lex_state = 78, .external_lex_state = 2},
  [1862] = {.lex_state = 78, .external_lex_state = 2},
  [1863] = {.lex_state = 78, .external_lex_state = 2},
  [1864] = {.lex_state = 78, .external_lex_state = 2},
  [1865] = {.lex_state = 78, .external_lex_state = 2},
  [1866] = {.lex_state = 78, .external_lex_state = 2},
  [1867] = {.lex_state = 78, .external_lex_state = 2},
  [1868] = {.lex_state = 78, .external_lex_state = 2},
  [1869] = {.lex_state = 78, .external_lex_state = 2},
  [1870] = {.lex_state = 78, .external_lex_state = 2},
  [1871] = {.lex_state = 78, .external_lex_state = 2},
  [1872] = {.lex_state = 78, .external_lex_state = 2},
  [1873] = {.lex_state = 78, .external_lex_state = 2},
  [1874] = {.lex_state = 78, .external_lex_state = 2},
  [1875] = {.lex_state = 78, .external_lex_state = 2},
  [1876] = {.lex_state = 78, .external_lex_state = 2},
  [1877] = {.lex_state = 78, .external_lex_state = 2},
  [1878] = {.lex_state = 78, .external_lex_state = 2},
  [1879] = {.lex_state = 78, .external_lex_state = 2},
  [1880] = {.lex_state = 78, .external_lex_state = 2},
  [1881] = {.lex_state = 78, .external_lex_state = 2},
  [1882] = {.lex_state = 78, .external_lex_state = 2},
  [1883] = {.lex_state = 78, .external_lex_state = 2},
  [1884] = {.lex_state = 78, .external_lex_state = 2},
  [1885] = {.lex_state = 78, .external_lex_state = 2},
  [1886] = {.lex_state = 78, .external_lex_state = 2},
  [1887] = {.lex_state = 78, .external_lex_state = 2},
  [1888] = {.lex_state = 78, .external_lex_state = 2},
  [1889] = {.lex_state = 78, .external_lex_state = 2},
  [1890] = {.lex_state = 78, .external_lex_state = 2},
  [1891] = {.lex_state = 78, .external_lex_state = 2},
  [1892] = {.lex_state = 78, .external_lex_state = 2},
  [1893] = {.lex_state = 78, .external_lex_state = 2},
  [1894] = {.lex_state = 78, .external_lex_state = 2},
  [1895] = {.lex_state = 78, .external_lex_state = 2},
  [1896] = {.lex_state = 78, .external_lex_state = 2},
  [1897] = {.lex_state = 78, .external_lex_state = 2},
  [1898] = {.lex_state = 78, .external_lex_state = 2},
  [1899] = {.lex_state = 78, .external_lex_state = 2},
  [1900] = {.lex_state = 78, .external_lex_state = 2},
  [1901] = {.lex_state = 78, .external_lex_state = 2},
  [1902] = {.lex_state = 78, .external_lex_state = 2},
  [1903] = {.lex_state = 78, .external_lex_state = 2},
  [1904] = {.lex_state = 78, .external_lex_state = 2},
  [1905] = {.lex_state = 78, .external_lex_state = 2},
  [1906] = {.lex_state = 67, .external_lex_state = 3},
  [1907] = {.lex_state = 67, .external_lex_state = 3},
  [1908] = {.lex_state = 67, .external_lex_state = 3},
  [1909] = {.lex_state = 67, .external_lex_state = 3},
  [1910] = {.lex_state = 67, .external_lex_state = 3},
  [1911] = {.lex_state = 67, .external_lex_state = 3},
  [1912] = {.lex_state = 67, .external_lex_state = 3},
  [1913] = {.lex_state = 67, .external_lex_state = 3},
  [1914] = {.lex_state = 67, .external_lex_state = 3},
  [1915] = {.lex_state = 67, .external_lex_state = 3},
  [1916] = {.lex_state = 102, .external_lex_state = 18},
  [1917] = {.lex_state = 208, .external_lex_state = 3},
  [1918] = {.lex_state = 208, .external_lex_state = 3},
  [1919] = {.lex_state = 208, .external_lex_state = 3},
  [1920] = {.lex_state = 208, .external_lex_state = 3},
  [1921] = {.lex_state = 208, .external_lex_state = 3},
  [1922] = {.lex_state = 208, .external_lex_state = 3},
  [1923] = {.lex_state = 208, .external_lex_state = 3},
  [1924] = {.lex_state = 208, .external_lex_state = 3},
  [1925] = {.lex_state = 208, .external_lex_state = 3},
  [1926] = {.lex_state = 208, .external_lex_state = 3},
  [1927] = {.lex_state = 208, .external_lex_state = 3},
  [1928] = {.lex_state = 208, .external_lex_state = 3},
  [1929] = {.lex_state = 67, .external_lex_state = 3},
  [1930] = {.lex_state = 66, .external_lex_state = 3},
  [1931] = {.lex_state = 67, .external_lex_state = 3},
  [1932] = {.lex_state = 223, .external_lex_state = 18},
  [1933] = {.lex_state = 67, .external_lex_state = 4},
  [1934] = {.lex_state = 67, .external_lex_state = 3},
  [1935] = {.lex_state = 67, .external_lex_state = 3},
  [1936] = {.lex_state = 67, .external_lex_state = 3},
  [1937] = {.lex_state = 67, .external_lex_state = 3},
  [1938] = {.lex_state = 67, .external_lex_state = 3},
  [1939] = {.lex_state = 67, .external_lex_state = 3},
  [1940] = {.lex_state = 67, .external_lex_state = 4},
  [1941] = {.lex_state = 67, .external_lex_state = 4},
  [1942] = {.lex_state = 67, .external_lex_state = 4},
  [1943] = {.lex_state = 67, .external_lex_state = 4},
  [1944] = {.lex_state = 67, .external_lex_state = 3},
  [1945] = {.lex_state = 66, .external_lex_state = 4},
  [1946] = {.lex_state = 67, .external_lex_state = 4},
  [1947] = {.lex_state = 67, .external_lex_state = 4},
  [1948] = {.lex_state = 67, .external_lex_state = 4},
  [1949] = {.lex_state = 67, .external_lex_state = 4},
  [1950] = {.lex_state = 67, .external_lex_state = 4},
  [1951] = {.lex_state = 67, .external_lex_state = 4},
  [1952] = {.lex_state = 67, .external_lex_state = 4},
  [1953] = {.lex_state = 67, .external_lex_state = 4},
  [1954] = {.lex_state = 67, .external_lex_state = 4},
  [1955] = {.lex_state = 67, .external_lex_state = 4},
  [1956] = {.lex_state = 67, .external_lex_state = 4},
  [1957] = {.lex_state = 67, .external_lex_state = 4},
  [1958] = {.lex_state = 102, .external_lex_state = 19},
  [1959] = {.lex_state = 102, .external_lex_state = 19},
  [1960] = {.lex_state = 102, .external_lex_state = 19},
  [1961] = {.lex_state = 70, .external_lex_state = 3},
  [1962] = {.lex_state = 70, .external_lex_state = 3},
  [1963] = {.lex_state = 78, .external_lex_state = 19},
  [1964] = {.lex_state = 78, .external_lex_state = 19},
  [1965] = {.lex_state = 78, .external_lex_state = 19},
  [1966] = {.lex_state = 70, .external_lex_state = 3},
  [1967] = {.lex_state = 70, .external_lex_state = 3},
  [1968] = {.lex_state = 70, .external_lex_state = 3},
  [1969] = {.lex_state = 70, .external_lex_state = 3},
  [1970] = {.lex_state = 70, .external_lex_state = 3},
  [1971] = {.lex_state = 70, .external_lex_state = 3},
  [1972] = {.lex_state = 102, .external_lex_state = 19},
  [1973] = {.lex_state = 78, .external_lex_state = 19},
  [1974] = {.lex_state = 78, .external_lex_state = 20},
  [1975] = {.lex_state = 78, .external_lex_state = 20},
  [1976] = {.lex_state = 78, .external_lex_state = 20},
  [1977] = {.lex_state = 78, .external_lex_state = 19},
  [1978] = {.lex_state = 78, .external_lex_state = 19},
  [1979] = {.lex_state = 210, .external_lex_state = 3},
  [1980] = {.lex_state = 210, .external_lex_state = 3},
  [1981] = {.lex_state = 210, .external_lex_state = 3},
  [1982] = {.lex_state = 210, .external_lex_state = 3},
  [1983] = {.lex_state = 78, .external_lex_state = 19},
  [1984] = {.lex_state = 210, .external_lex_state = 3},
  [1985] = {.lex_state = 78, .external_lex_state = 19},
  [1986] = {.lex_state = 210, .external_lex_state = 3},
  [1987] = {.lex_state = 210, .external_lex_state = 3},
  [1988] = {.lex_state = 210, .external_lex_state = 3},
  [1989] = {.lex_state = 70, .external_lex_state = 3},
  [1990] = {.lex_state = 70, .external_lex_state = 3},
  [1991] = {.lex_state = 70, .external_lex_state = 3},
  [1992] = {.lex_state = 70, .external_lex_state = 3},
  [1993] = {.lex_state = 70, .external_lex_state = 4},
  [1994] = {.lex_state = 70, .external_lex_state = 3},
  [1995] = {.lex_state = 70, .external_lex_state = 3},
  [1996] = {.lex_state = 70, .external_lex_state = 4},
  [1997] = {.lex_state = 70, .external_lex_state = 3},
  [1998] = {.lex_state = 70, .external_lex_state = 4},
  [1999] = {.lex_state = 70, .external_lex_state = 4},
  [2000] = {.lex_state = 70, .external_lex_state = 3},
  [2001] = {.lex_state = 70, .external_lex_state = 4},
  [2002] = {.lex_state = 70, .external_lex_state = 4},
  [2003] = {.lex_state = 70, .external_lex_state = 4},
  [2004] = {.lex_state = 70, .external_lex_state = 4},
  [2005] = {.lex_state = 70, .external_lex_state = 4},
  [2006] = {.lex_state = 70, .external_lex_state = 4},
  [2007] = {.lex_state = 70, .external_lex_state = 4},
  [2008] = {.lex_state = 70, .external_lex_state = 4},
  [2009] = {.lex_state = 70, .external_lex_state = 4},
  [2010] = {.lex_state = 70, .external_lex_state = 4},
  [2011] = {.lex_state = 101, .external_lex_state = 21},
  [2012] = {.lex_state = 101, .external_lex_state = 21},
  [2013] = {.lex_state = 101, .external_lex_state = 21},
  [2014] = {.lex_state = 115, .external_lex_state = 19},
  [2015] = {.lex_state = 115, .external_lex_state = 19},
  [2016] = {.lex_state = 115, .external_lex_state = 19},
  [2017] = {.lex_state = 115, .external_lex_state = 19},
  [2018] = {.lex_state = 115, .external_lex_state = 19},
  [2019] = {.lex_state = 115, .external_lex_state = 19},
  [2020] = {.lex_state = 115, .external_lex_state = 19},
  [2021] = {.lex_state = 115, .external_lex_state = 19},
  [2022] = {.lex_state = 115, .external_lex_state = 19},
  [2023] = {.lex_state = 115, .external_lex_state = 19},
  [2024] = {.lex_state = 115, .external_lex_state = 19},
  [2025] = {.lex_state = 115, .external_lex_state = 19},
  [2026] = {.lex_state = 231, .external_lex_state = 21},
  [2027] = {.lex_state = 115, .external_lex_state = 19},
  [2028] = {.lex_state = 115, .external_lex_state = 19},
  [2029] = {.lex_state = 115, .external_lex_state = 19},
  [2030] = {.lex_state = 78, .external_lex_state = 9},
  [2031] = {.lex_state = 231, .external_lex_state = 21},
  [2032] = {.lex_state = 78, .external_lex_state = 9},
  [2033] = {.lex_state = 78, .external_lex_state = 9},
  [2034] = {.lex_state = 78, .external_lex_state = 9},
  [2035] = {.lex_state = 78, .external_lex_state = 9},
  [2036] = {.lex_state = 78, .external_lex_state = 9},
  [2037] = {.lex_state = 231, .external_lex_state = 21},
  [2038] = {.lex_state = 101, .external_lex_state = 21},
  [2039] = {.lex_state = 75, .external_lex_state = 6},
  [2040] = {.lex_state = 216, .external_lex_state = 22},
  [2041] = {.lex_state = 79, .external_lex_state = 2},
  [2042] = {.lex_state = 216, .external_lex_state = 22},
  [2043] = {.lex_state = 216, .external_lex_state = 22},
  [2044] = {.lex_state = 216, .external_lex_state = 22},
  [2045] = {.lex_state = 101, .external_lex_state = 23},
  [2046] = {.lex_state = 101, .external_lex_state = 23},
  [2047] = {.lex_state = 101, .external_lex_state = 21},
  [2048] = {.lex_state = 101, .external_lex_state = 21},
  [2049] = {.lex_state = 77, .external_lex_state = 6},
  [2050] = {.lex_state = 216, .external_lex_state = 22},
  [2051] = {.lex_state = 215, .external_lex_state = 9},
  [2052] = {.lex_state = 215, .external_lex_state = 9},
  [2053] = {.lex_state = 216, .external_lex_state = 22},
  [2054] = {.lex_state = 79, .external_lex_state = 2},
  [2055] = {.lex_state = 216, .external_lex_state = 22},
  [2056] = {.lex_state = 215, .external_lex_state = 9},
  [2057] = {.lex_state = 79, .external_lex_state = 2},
  [2058] = {.lex_state = 215, .external_lex_state = 9},
  [2059] = {.lex_state = 216, .external_lex_state = 22},
  [2060] = {.lex_state = 216, .external_lex_state = 22},
  [2061] = {.lex_state = 215, .external_lex_state = 9},
  [2062] = {.lex_state = 79, .external_lex_state = 2},
  [2063] = {.lex_state = 215, .external_lex_state = 9},
  [2064] = {.lex_state = 101, .external_lex_state = 23},
  [2065] = {.lex_state = 216, .external_lex_state = 22},
  [2066] = {.lex_state = 101, .external_lex_state = 23},
  [2067] = {.lex_state = 101, .external_lex_state = 23},
  [2068] = {.lex_state = 216, .external_lex_state = 22},
  [2069] = {.lex_state = 216, .external_lex_state = 22},
  [2070] = {.lex_state = 216, .external_lex_state = 22},
  [2071] = {.lex_state = 82, .external_lex_state = 22},
  [2072] = {.lex_state = 216, .external_lex_state = 22},
  [2073] = {.lex_state = 216, .external_lex_state = 22},
  [2074] = {.lex_state = 216, .external_lex_state = 22},
  [2075] = {.lex_state = 216, .external_lex_state = 22},
  [2076] = {.lex_state = 216, .external_lex_state = 22},
  [2077] = {.lex_state = 216, .external_lex_state = 22},
  [2078] = {.lex_state = 216, .external_lex_state = 22},
  [2079] = {.lex_state = 101, .external_lex_state = 23},
  [2080] = {.lex_state = 216, .external_lex_state = 22},
  [2081] = {.lex_state = 216, .external_lex_state = 22},
  [2082] = {.lex_state = 216, .external_lex_state = 22},
  [2083] = {.lex_state = 216, .external_lex_state = 22},
  [2084] = {.lex_state = 216, .external_lex_state = 22},
  [2085] = {.lex_state = 216, .external_lex_state = 22},
  [2086] = {.lex_state = 216, .external_lex_state = 22},
  [2087] = {.lex_state = 216, .external_lex_state = 22},
  [2088] = {.lex_state = 216, .external_lex_state = 22},
  [2089] = {.lex_state = 216, .external_lex_state = 22},
  [2090] = {.lex_state = 216, .external_lex_state = 22},
  [2091] = {.lex_state = 216, .external_lex_state = 22},
  [2092] = {.lex_state = 216, .external_lex_state = 22},
  [2093] = {.lex_state = 101, .external_lex_state = 23},
  [2094] = {.lex_state = 101, .external_lex_state = 23},
  [2095] = {.lex_state = 216, .external_lex_state = 22},
  [2096] = {.lex_state = 216, .external_lex_state = 22},
  [2097] = {.lex_state = 216, .external_lex_state = 22},
  [2098] = {.lex_state = 216, .external_lex_state = 22},
  [2099] = {.lex_state = 216, .external_lex_state = 22},
  [2100] = {.lex_state = 216, .external_lex_state = 22},
  [2101] = {.lex_state = 216, .external_lex_state = 22},
  [2102] = {.lex_state = 216, .external_lex_state = 22},
  [2103] = {.lex_state = 216, .external_lex_state = 22},
  [2104] = {.lex_state = 80, .external_lex_state = 7},
  [2105] = {.lex_state = 78, .external_lex_state = 5},
  [2106] = {.lex_state = 78, .external_lex_state = 5},
  [2107] = {.lex_state = 78, .external_lex_state = 5},
  [2108] = {.lex_state = 83, .external_lex_state = 22},
  [2109] = {.lex_state = 78, .external_lex_state = 5},
  [2110] = {.lex_state = 80, .external_lex_state = 7},
  [2111] = {.lex_state = 80, .external_lex_state = 7},
  [2112] = {.lex_state = 78, .external_lex_state = 5},
  [2113] = {.lex_state = 78, .external_lex_state = 5},
  [2114] = {.lex_state = 79, .external_lex_state = 7},
  [2115] = {.lex_state = 79, .external_lex_state = 2},
  [2116] = {.lex_state = 79, .external_lex_state = 7},
  [2117] = {.lex_state = 79, .external_lex_state = 7},
  [2118] = {.lex_state = 82, .external_lex_state = 22},
  [2119] = {.lex_state = 82, .external_lex_state = 22},
  [2120] = {.lex_state = 79, .external_lex_state = 7},
  [2121] = {.lex_state = 79, .external_lex_state = 7},
  [2122] = {.lex_state = 79, .external_lex_state = 7},
  [2123] = {.lex_state = 79, .external_lex_state = 7},
  [2124] = {.lex_state = 79, .external_lex_state = 7},
  [2125] = {.lex_state = 79, .external_lex_state = 7},
  [2126] = {.lex_state = 79, .external_lex_state = 7},
  [2127] = {.lex_state = 79, .external_lex_state = 7},
  [2128] = {.lex_state = 82, .external_lex_state = 22},
  [2129] = {.lex_state = 79, .external_lex_state = 7},
  [2130] = {.lex_state = 214, .external_lex_state = 2},
  [2131] = {.lex_state = 82, .external_lex_state = 22},
  [2132] = {.lex_state = 101, .external_lex_state = 23},
  [2133] = {.lex_state = 214, .external_lex_state = 2},
  [2134] = {.lex_state = 82, .external_lex_state = 22},
  [2135] = {.lex_state = 101, .external_lex_state = 23},
  [2136] = {.lex_state = 101, .external_lex_state = 23},
  [2137] = {.lex_state = 101, .external_lex_state = 23},
  [2138] = {.lex_state = 101, .external_lex_state = 23},
  [2139] = {.lex_state = 82, .external_lex_state = 22},
  [2140] = {.lex_state = 214, .external_lex_state = 2},
  [2141] = {.lex_state = 82, .external_lex_state = 22},
  [2142] = {.lex_state = 82, .external_lex_state = 22},
  [2143] = {.lex_state = 214, .external_lex_state = 2},
  [2144] = {.lex_state = 82, .external_lex_state = 22},
  [2145] = {.lex_state = 82, .external_lex_state = 22},
  [2146] = {.lex_state = 216, .external_lex_state = 22},
  [2147] = {.lex_state = 79, .external_lex_state = 2},
  [2148] = {.lex_state = 79, .external_lex_state = 2},
  [2149] = {.lex_state = 101, .external_lex_state = 23},
  [2150] = {.lex_state = 79, .external_lex_state = 2},
  [2151] = {.lex_state = 79, .external_lex_state = 2},
  [2152] = {.lex_state = 79, .external_lex_state = 2},
  [2153] = {.lex_state = 101, .external_lex_state = 23},
  [2154] = {.lex_state = 101, .external_lex_state = 23},
  [2155] = {.lex_state = 101, .external_lex_state = 23},
  [2156] = {.lex_state = 79, .external_lex_state = 2},
  [2157] = {.lex_state = 79, .external_lex_state = 2},
  [2158] = {.lex_state = 79, .external_lex_state = 2},
  [2159] = {.lex_state = 79, .external_lex_state = 2},
  [2160] = {.lex_state = 79, .external_lex_state = 2},
  [2161] = {.lex_state = 101, .external_lex_state = 23},
  [2162] = {.lex_state = 101, .external_lex_state = 23},
  [2163] = {.lex_state = 79, .external_lex_state = 2},
  [2164] = {.lex_state = 79, .external_lex_state = 2},
  [2165] = {.lex_state = 101, .external_lex_state = 23},
  [2166] = {.lex_state = 216, .external_lex_state = 22},
  [2167] = {.lex_state = 216, .external_lex_state = 22},
  [2168] = {.lex_state = 216, .external_lex_state = 22},
  [2169] = {.lex_state = 101, .external_lex_state = 21},
  [2170] = {.lex_state = 82, .external_lex_state = 22},
  [2171] = {.lex_state = 217, .external_lex_state = 22},
  [2172] = {.lex_state = 84, .external_lex_state = 24},
  [2173] = {.lex_state = 84, .external_lex_state = 24},
  [2174] = {.lex_state = 82, .external_lex_state = 22},
  [2175] = {.lex_state = 216, .external_lex_state = 22},
  [2176] = {.lex_state = 83, .external_lex_state = 22},
  [2177] = {.lex_state = 216, .external_lex_state = 22},
  [2178] = {.lex_state = 216, .external_lex_state = 22},
  [2179] = {.lex_state = 216, .external_lex_state = 22},
  [2180] = {.lex_state = 82, .external_lex_state = 22},
  [2181] = {.lex_state = 216, .external_lex_state = 22},
  [2182] = {.lex_state = 82, .external_lex_state = 22},
  [2183] = {.lex_state = 216, .external_lex_state = 22},
  [2184] = {.lex_state = 216, .external_lex_state = 22},
  [2185] = {.lex_state = 82, .external_lex_state = 22},
  [2186] = {.lex_state = 101, .external_lex_state = 23},
  [2187] = {.lex_state = 220, .external_lex_state = 22},
  [2188] = {.lex_state = 101, .external_lex_state = 23},
  [2189] = {.lex_state = 101, .external_lex_state = 23},
  [2190] = {.lex_state = 82, .external_lex_state = 22},
  [2191] = {.lex_state = 220, .external_lex_state = 22},
  [2192] = {.lex_state = 82, .external_lex_state = 22},
  [2193] = {.lex_state = 84, .external_lex_state = 24},
  [2194] = {.lex_state = 82, .external_lex_state = 22},
  [2195] = {.lex_state = 101, .external_lex_state = 23},
  [2196] = {.lex_state = 101, .external_lex_state = 23},
  [2197] = {.lex_state = 84, .external_lex_state = 24},
  [2198] = {.lex_state = 82, .external_lex_state = 22},
  [2199] = {.lex_state = 82, .external_lex_state = 24},
  [2200] = {.lex_state = 84, .external_lex_state = 24},
  [2201] = {.lex_state = 220, .external_lex_state = 22},
  [2202] = {.lex_state = 220, .external_lex_state = 25},
  [2203] = {.lex_state = 84, .external_lex_state = 24},
  [2204] = {.lex_state = 84, .external_lex_state = 24},
  [2205] = {.lex_state = 220, .external_lex_state = 25},
  [2206] = {.lex_state = 82, .external_lex_state = 22},
  [2207] = {.lex_state = 220, .external_lex_state = 25},
  [2208] = {.lex_state = 220, .external_lex_state = 25},
  [2209] = {.lex_state = 84, .external_lex_state = 24},
  [2210] = {.lex_state = 82, .external_lex_state = 22},
  [2211] = {.lex_state = 84, .external_lex_state = 24},
  [2212] = {.lex_state = 82, .external_lex_state = 22},
  [2213] = {.lex_state = 82, .external_lex_state = 22},
  [2214] = {.lex_state = 82, .external_lex_state = 22},
  [2215] = {.lex_state = 82, .external_lex_state = 22},
  [2216] = {.lex_state = 84, .external_lex_state = 24},
  [2217] = {.lex_state = 84, .external_lex_state = 24},
  [2218] = {.lex_state = 84, .external_lex_state = 24},
  [2219] = {.lex_state = 82, .external_lex_state = 24},
  [2220] = {.lex_state = 84, .external_lex_state = 24},
  [2221] = {.lex_state = 220, .external_lex_state = 22},
  [2222] = {.lex_state = 84, .external_lex_state = 24},
  [2223] = {.lex_state = 82, .external_lex_state = 24},
  [2224] = {.lex_state = 84, .external_lex_state = 24},
  [2225] = {.lex_state = 220, .external_lex_state = 22},
  [2226] = {.lex_state = 84, .external_lex_state = 24},
  [2227] = {.lex_state = 84, .external_lex_state = 24},
  [2228] = {.lex_state = 84, .external_lex_state = 24},
  [2229] = {.lex_state = 84, .external_lex_state = 24},
  [2230] = {.lex_state = 84, .external_lex_state = 24},
  [2231] = {.lex_state = 220, .external_lex_state = 25},
  [2232] = {.lex_state = 84, .external_lex_state = 24},
  [2233] = {.lex_state = 220, .external_lex_state = 22},
  [2234] = {.lex_state = 84, .external_lex_state = 24},
  [2235] = {.lex_state = 220, .external_lex_state = 22},
  [2236] = {.lex_state = 220, .external_lex_state = 22},
  [2237] = {.lex_state = 220, .external_lex_state = 22},
  [2238] = {.lex_state = 84, .external_lex_state = 24},
  [2239] = {.lex_state = 220, .external_lex_state = 22},
  [2240] = {.lex_state = 82, .external_lex_state = 22},
  [2241] = {.lex_state = 220, .external_lex_state = 22},
  [2242] = {.lex_state = 220, .external_lex_state = 22},
  [2243] = {.lex_state = 84, .external_lex_state = 24},
  [2244] = {.lex_state = 82, .external_lex_state = 22},
  [2245] = {.lex_state = 82, .external_lex_state = 24},
  [2246] = {.lex_state = 220, .external_lex_state = 22},
  [2247] = {.lex_state = 84, .external_lex_state = 24},
  [2248] = {.lex_state = 84, .external_lex_state = 24},
  [2249] = {.lex_state = 220, .external_lex_state = 22},
  [2250] = {.lex_state = 84, .external_lex_state = 24},
  [2251] = {.lex_state = 84, .external_lex_state = 24},
  [2252] = {.lex_state = 84, .external_lex_state = 24},
  [2253] = {.lex_state = 84, .external_lex_state = 24},
  [2254] = {.lex_state = 84, .external_lex_state = 24},
  [2255] = {.lex_state = 220, .external_lex_state = 22},
  [2256] = {.lex_state = 220, .external_lex_state = 22},
  [2257] = {.lex_state = 220, .external_lex_state = 25},
  [2258] = {.lex_state = 220, .external_lex_state = 22},
  [2259] = {.lex_state = 84, .external_lex_state = 24},
  [2260] = {.lex_state = 84, .external_lex_state = 24},
  [2261] = {.lex_state = 84, .external_lex_state = 24},
  [2262] = {.lex_state = 88, .external_lex_state = 25},
  [2263] = {.lex_state = 82, .external_lex_state = 24},
  [2264] = {.lex_state = 220, .external_lex_state = 22},
  [2265] = {.lex_state = 82, .external_lex_state = 24},
  [2266] = {.lex_state = 220, .external_lex_state = 22},
  [2267] = {.lex_state = 82, .external_lex_state = 22},
  [2268] = {.lex_state = 231, .external_lex_state = 21},
  [2269] = {.lex_state = 88, .external_lex_state = 25},
  [2270] = {.lex_state = 220, .external_lex_state = 25},
  [2271] = {.lex_state = 82, .external_lex_state = 24},
  [2272] = {.lex_state = 82, .external_lex_state = 22},
  [2273] = {.lex_state = 220, .external_lex_state = 22},
  [2274] = {.lex_state = 220, .external_lex_state = 22},
  [2275] = {.lex_state = 220, .external_lex_state = 22},
  [2276] = {.lex_state = 220, .external_lex_state = 22},
  [2277] = {.lex_state = 220, .external_lex_state = 22},
  [2278] = {.lex_state = 220, .external_lex_state = 22},
  [2279] = {.lex_state = 220, .external_lex_state = 22},
  [2280] = {.lex_state = 82, .external_lex_state = 24},
  [2281] = {.lex_state = 220, .external_lex_state = 22},
  [2282] = {.lex_state = 220, .external_lex_state = 22},
  [2283] = {.lex_state = 220, .external_lex_state = 22},
  [2284] = {.lex_state = 220, .external_lex_state = 22},
  [2285] = {.lex_state = 220, .external_lex_state = 22},
  [2286] = {.lex_state = 82, .external_lex_state = 24},
  [2287] = {.lex_state = 220, .external_lex_state = 22},
  [2288] = {.lex_state = 220, .external_lex_state = 22},
  [2289] = {.lex_state = 220, .external_lex_state = 22},
  [2290] = {.lex_state = 220, .external_lex_state = 22},
  [2291] = {.lex_state = 220, .external_lex_state = 22},
  [2292] = {.lex_state = 220, .external_lex_state = 22},
  [2293] = {.lex_state = 220, .external_lex_state = 22},
  [2294] = {.lex_state = 220, .external_lex_state = 22},
  [2295] = {.lex_state = 220, .external_lex_state = 22},
  [2296] = {.lex_state = 82, .external_lex_state = 22},
  [2297] = {.lex_state = 220, .external_lex_state = 22},
  [2298] = {.lex_state = 220, .external_lex_state = 22},
  [2299] = {.lex_state = 220, .external_lex_state = 22},
  [2300] = {.lex_state = 220, .external_lex_state = 22},
  [2301] = {.lex_state = 220, .external_lex_state = 22},
  [2302] = {.lex_state = 220, .external_lex_state = 22},
  [2303] = {.lex_state = 220, .external_lex_state = 22},
  [2304] = {.lex_state = 220, .external_lex_state = 22},
  [2305] = {.lex_state = 220, .external_lex_state = 22},
  [2306] = {.lex_state = 220, .external_lex_state = 22},
  [2307] = {.lex_state = 220, .external_lex_state = 22},
  [2308] = {.lex_state = 220, .external_lex_state = 22},
  [2309] = {.lex_state = 83, .external_lex_state = 22},
  [2310] = {.lex_state = 220, .external_lex_state = 22},
  [2311] = {.lex_state = 220, .external_lex_state = 22},
  [2312] = {.lex_state = 220, .external_lex_state = 22},
  [2313] = {.lex_state = 82, .external_lex_state = 22},
  [2314] = {.lex_state = 220, .external_lex_state = 22},
  [2315] = {.lex_state = 220, .external_lex_state = 22},
  [2316] = {.lex_state = 220, .external_lex_state = 22},
  [2317] = {.lex_state = 220, .external_lex_state = 22},
  [2318] = {.lex_state = 220, .external_lex_state = 22},
  [2319] = {.lex_state = 220, .external_lex_state = 22},
  [2320] = {.lex_state = 220, .external_lex_state = 22},
  [2321] = {.lex_state = 220, .external_lex_state = 22},
  [2322] = {.lex_state = 220, .external_lex_state = 22},
  [2323] = {.lex_state = 220, .external_lex_state = 22},
  [2324] = {.lex_state = 220, .external_lex_state = 22},
  [2325] = {.lex_state = 220, .external_lex_state = 22},
  [2326] = {.lex_state = 220, .external_lex_state = 22},
  [2327] = {.lex_state = 220, .external_lex_state = 22},
  [2328] = {.lex_state = 220, .external_lex_state = 22},
  [2329] = {.lex_state = 220, .external_lex_state = 22},
  [2330] = {.lex_state = 220, .external_lex_state = 22},
  [2331] = {.lex_state = 220, .external_lex_state = 22},
  [2332] = {.lex_state = 220, .external_lex_state = 22},
  [2333] = {.lex_state = 220, .external_lex_state = 22},
  [2334] = {.lex_state = 220, .external_lex_state = 22},
  [2335] = {.lex_state = 220, .external_lex_state = 22},
  [2336] = {.lex_state = 220, .external_lex_state = 22},
  [2337] = {.lex_state = 220, .external_lex_state = 22},
  [2338] = {.lex_state = 220, .external_lex_state = 22},
  [2339] = {.lex_state = 220, .external_lex_state = 22},
  [2340] = {.lex_state = 220, .external_lex_state = 22},
  [2341] = {.lex_state = 220, .external_lex_state = 22},
  [2342] = {.lex_state = 220, .external_lex_state = 22},
  [2343] = {.lex_state = 220, .external_lex_state = 22},
  [2344] = {.lex_state = 220, .external_lex_state = 22},
  [2345] = {.lex_state = 220, .external_lex_state = 22},
  [2346] = {.lex_state = 220, .external_lex_state = 22},
  [2347] = {.lex_state = 220, .external_lex_state = 22},
  [2348] = {.lex_state = 220, .external_lex_state = 22},
  [2349] = {.lex_state = 220, .external_lex_state = 22},
  [2350] = {.lex_state = 220, .external_lex_state = 22},
  [2351] = {.lex_state = 220, .external_lex_state = 22},
  [2352] = {.lex_state = 220, .external_lex_state = 22},
  [2353] = {.lex_state = 220, .external_lex_state = 22},
  [2354] = {.lex_state = 220, .external_lex_state = 22},
  [2355] = {.lex_state = 220, .external_lex_state = 22},
  [2356] = {.lex_state = 220, .external_lex_state = 22},
  [2357] = {.lex_state = 220, .external_lex_state = 22},
  [2358] = {.lex_state = 220, .external_lex_state = 22},
  [2359] = {.lex_state = 220, .external_lex_state = 22},
  [2360] = {.lex_state = 220, .external_lex_state = 22},
  [2361] = {.lex_state = 220, .external_lex_state = 22},
  [2362] = {.lex_state = 220, .external_lex_state = 22},
  [2363] = {.lex_state = 220, .external_lex_state = 22},
  [2364] = {.lex_state = 220, .external_lex_state = 22},
  [2365] = {.lex_state = 220, .external_lex_state = 22},
  [2366] = {.lex_state = 220, .external_lex_state = 22},
  [2367] = {.lex_state = 220, .external_lex_state = 22},
  [2368] = {.lex_state = 220, .external_lex_state = 22},
  [2369] = {.lex_state = 220, .external_lex_state = 22},
  [2370] = {.lex_state = 220, .external_lex_state = 22},
  [2371] = {.lex_state = 82, .external_lex_state = 24},
  [2372] = {.lex_state = 220, .external_lex_state = 22},
  [2373] = {.lex_state = 220, .external_lex_state = 22},
  [2374] = {.lex_state = 220, .external_lex_state = 22},
  [2375] = {.lex_state = 220, .external_lex_state = 22},
  [2376] = {.lex_state = 82, .external_lex_state = 24},
  [2377] = {.lex_state = 220, .external_lex_state = 22},
  [2378] = {.lex_state = 220, .external_lex_state = 22},
  [2379] = {.lex_state = 220, .external_lex_state = 22},
  [2380] = {.lex_state = 220, .external_lex_state = 22},
  [2381] = {.lex_state = 220, .external_lex_state = 22},
  [2382] = {.lex_state = 82, .external_lex_state = 24},
  [2383] = {.lex_state = 220, .external_lex_state = 22},
  [2384] = {.lex_state = 220, .external_lex_state = 22},
  [2385] = {.lex_state = 220, .external_lex_state = 22},
  [2386] = {.lex_state = 220, .external_lex_state = 22},
  [2387] = {.lex_state = 220, .external_lex_state = 22},
  [2388] = {.lex_state = 220, .external_lex_state = 22},
  [2389] = {.lex_state = 220, .external_lex_state = 22},
  [2390] = {.lex_state = 220, .external_lex_state = 22},
  [2391] = {.lex_state = 220, .external_lex_state = 22},
  [2392] = {.lex_state = 220, .external_lex_state = 22},
  [2393] = {.lex_state = 220, .external_lex_state = 22},
  [2394] = {.lex_state = 220, .external_lex_state = 22},
  [2395] = {.lex_state = 220, .external_lex_state = 22},
  [2396] = {.lex_state = 220, .external_lex_state = 22},
  [2397] = {.lex_state = 220, .external_lex_state = 22},
  [2398] = {.lex_state = 220, .external_lex_state = 22},
  [2399] = {.lex_state = 220, .external_lex_state = 22},
  [2400] = {.lex_state = 220, .external_lex_state = 22},
  [2401] = {.lex_state = 220, .external_lex_state = 22},
  [2402] = {.lex_state = 220, .external_lex_state = 22},
  [2403] = {.lex_state = 220, .external_lex_state = 22},
  [2404] = {.lex_state = 220, .external_lex_state = 22},
  [2405] = {.lex_state = 82, .external_lex_state = 24},
  [2406] = {.lex_state = 220, .external_lex_state = 22},
  [2407] = {.lex_state = 220, .external_lex_state = 22},
  [2408] = {.lex_state = 82, .external_lex_state = 24},
  [2409] = {.lex_state = 220, .external_lex_state = 22},
  [2410] = {.lex_state = 220, .external_lex_state = 22},
  [2411] = {.lex_state = 220, .external_lex_state = 22},
  [2412] = {.lex_state = 220, .external_lex_state = 22},
  [2413] = {.lex_state = 220, .external_lex_state = 22},
  [2414] = {.lex_state = 220, .external_lex_state = 22},
  [2415] = {.lex_state = 220, .external_lex_state = 22},
  [2416] = {.lex_state = 220, .external_lex_state = 22},
  [2417] = {.lex_state = 220, .external_lex_state = 22},
  [2418] = {.lex_state = 220, .external_lex_state = 22},
  [2419] = {.lex_state = 83, .external_lex_state = 24},
  [2420] = {.lex_state = 220, .external_lex_state = 22},
  [2421] = {.lex_state = 220, .external_lex_state = 22},
  [2422] = {.lex_state = 220, .external_lex_state = 22},
  [2423] = {.lex_state = 220, .external_lex_state = 22},
  [2424] = {.lex_state = 220, .external_lex_state = 22},
  [2425] = {.lex_state = 220, .external_lex_state = 22},
  [2426] = {.lex_state = 220, .external_lex_state = 22},
  [2427] = {.lex_state = 220, .external_lex_state = 22},
  [2428] = {.lex_state = 220, .external_lex_state = 22},
  [2429] = {.lex_state = 220, .external_lex_state = 22},
  [2430] = {.lex_state = 220, .external_lex_state = 22},
  [2431] = {.lex_state = 220, .external_lex_state = 22},
  [2432] = {.lex_state = 220, .external_lex_state = 22},
  [2433] = {.lex_state = 220, .external_lex_state = 22},
  [2434] = {.lex_state = 82, .external_lex_state = 22},
  [2435] = {.lex_state = 220, .external_lex_state = 22},
  [2436] = {.lex_state = 220, .external_lex_state = 22},
  [2437] = {.lex_state = 220, .external_lex_state = 22},
  [2438] = {.lex_state = 83, .external_lex_state = 24},
  [2439] = {.lex_state = 82, .external_lex_state = 24},
  [2440] = {.lex_state = 82, .external_lex_state = 24},
  [2441] = {.lex_state = 82, .external_lex_state = 24},
  [2442] = {.lex_state = 82, .external_lex_state = 24},
  [2443] = {.lex_state = 88, .external_lex_state = 25},
  [2444] = {.lex_state = 82, .external_lex_state = 22},
  [2445] = {.lex_state = 82, .external_lex_state = 24},
  [2446] = {.lex_state = 82, .external_lex_state = 22},
  [2447] = {.lex_state = 82, .external_lex_state = 24},
  [2448] = {.lex_state = 82, .external_lex_state = 22},
  [2449] = {.lex_state = 82, .external_lex_state = 24},
  [2450] = {.lex_state = 93, .external_lex_state = 26},
  [2451] = {.lex_state = 82, .external_lex_state = 22},
  [2452] = {.lex_state = 82, .external_lex_state = 24},
  [2453] = {.lex_state = 93, .external_lex_state = 26},
  [2454] = {.lex_state = 93, .external_lex_state = 26},
  [2455] = {.lex_state = 93, .external_lex_state = 26},
  [2456] = {.lex_state = 93, .external_lex_state = 26},
  [2457] = {.lex_state = 82, .external_lex_state = 22},
  [2458] = {.lex_state = 82, .external_lex_state = 24},
  [2459] = {.lex_state = 88, .external_lex_state = 22},
  [2460] = {.lex_state = 93, .external_lex_state = 26},
  [2461] = {.lex_state = 82, .external_lex_state = 24},
  [2462] = {.lex_state = 93, .external_lex_state = 26},
  [2463] = {.lex_state = 93, .external_lex_state = 26},
  [2464] = {.lex_state = 88, .external_lex_state = 22},
  [2465] = {.lex_state = 220, .external_lex_state = 22},
  [2466] = {.lex_state = 82, .external_lex_state = 22},
  [2467] = {.lex_state = 93, .external_lex_state = 26},
  [2468] = {.lex_state = 93, .external_lex_state = 26},
  [2469] = {.lex_state = 93, .external_lex_state = 26},
  [2470] = {.lex_state = 93, .external_lex_state = 26},
  [2471] = {.lex_state = 93, .external_lex_state = 26},
  [2472] = {.lex_state = 93, .external_lex_state = 26},
  [2473] = {.lex_state = 88, .external_lex_state = 22},
  [2474] = {.lex_state = 93, .external_lex_state = 26},
  [2475] = {.lex_state = 82, .external_lex_state = 22},
  [2476] = {.lex_state = 93, .external_lex_state = 26},
  [2477] = {.lex_state = 88, .external_lex_state = 22},
  [2478] = {.lex_state = 93, .external_lex_state = 26},
  [2479] = {.lex_state = 93, .external_lex_state = 26},
  [2480] = {.lex_state = 88, .external_lex_state = 22},
  [2481] = {.lex_state = 82, .external_lex_state = 22},
  [2482] = {.lex_state = 93, .external_lex_state = 26},
  [2483] = {.lex_state = 93, .external_lex_state = 26},
  [2484] = {.lex_state = 93, .external_lex_state = 26},
  [2485] = {.lex_state = 82, .external_lex_state = 22},
  [2486] = {.lex_state = 88, .external_lex_state = 22},
  [2487] = {.lex_state = 93, .external_lex_state = 26},
  [2488] = {.lex_state = 93, .external_lex_state = 26},
  [2489] = {.lex_state = 93, .external_lex_state = 26},
  [2490] = {.lex_state = 88, .external_lex_state = 22},
  [2491] = {.lex_state = 88, .external_lex_state = 22},
  [2492] = {.lex_state = 88, .external_lex_state = 22},
  [2493] = {.lex_state = 88, .external_lex_state = 22},
  [2494] = {.lex_state = 88, .external_lex_state = 22},
  [2495] = {.lex_state = 88, .external_lex_state = 22},
  [2496] = {.lex_state = 88, .external_lex_state = 22},
  [2497] = {.lex_state = 88, .external_lex_state = 22},
  [2498] = {.lex_state = 88, .external_lex_state = 22},
  [2499] = {.lex_state = 88, .external_lex_state = 22},
  [2500] = {.lex_state = 82, .external_lex_state = 24},
  [2501] = {.lex_state = 88, .external_lex_state = 22},
  [2502] = {.lex_state = 88, .external_lex_state = 22},
  [2503] = {.lex_state = 82, .external_lex_state = 24},
  [2504] = {.lex_state = 88, .external_lex_state = 22},
  [2505] = {.lex_state = 82, .external_lex_state = 24},
  [2506] = {.lex_state = 88, .external_lex_state = 22},
  [2507] = {.lex_state = 88, .external_lex_state = 22},
  [2508] = {.lex_state = 88, .external_lex_state = 22},
  [2509] = {.lex_state = 88, .external_lex_state = 22},
  [2510] = {.lex_state = 83, .external_lex_state = 24},
  [2511] = {.lex_state = 88, .external_lex_state = 22},
  [2512] = {.lex_state = 82, .external_lex_state = 24},
  [2513] = {.lex_state = 88, .external_lex_state = 22},
  [2514] = {.lex_state = 88, .external_lex_state = 22},
  [2515] = {.lex_state = 88, .external_lex_state = 22},
  [2516] = {.lex_state = 82, .external_lex_state = 24},
  [2517] = {.lex_state = 83, .external_lex_state = 24},
  [2518] = {.lex_state = 88, .external_lex_state = 22},
  [2519] = {.lex_state = 88, .external_lex_state = 22},
  [2520] = {.lex_state = 82, .external_lex_state = 24},
  [2521] = {.lex_state = 88, .external_lex_state = 22},
  [2522] = {.lex_state = 88, .external_lex_state = 22},
  [2523] = {.lex_state = 88, .external_lex_state = 22},
  [2524] = {.lex_state = 88, .external_lex_state = 22},
  [2525] = {.lex_state = 82, .external_lex_state = 22},
  [2526] = {.lex_state = 82, .external_lex_state = 24},
  [2527] = {.lex_state = 82, .external_lex_state = 22},
  [2528] = {.lex_state = 222, .external_lex_state = 27},
  [2529] = {.lex_state = 222, .external_lex_state = 27},
  [2530] = {.lex_state = 222, .external_lex_state = 27},
  [2531] = {.lex_state = 82, .external_lex_state = 22},
  [2532] = {.lex_state = 82, .external_lex_state = 24},
  [2533] = {.lex_state = 222, .external_lex_state = 27},
  [2534] = {.lex_state = 88, .external_lex_state = 22},
  [2535] = {.lex_state = 82, .external_lex_state = 22},
  [2536] = {.lex_state = 101, .external_lex_state = 21},
  [2537] = {.lex_state = 222, .external_lex_state = 27},
  [2538] = {.lex_state = 82, .external_lex_state = 24},
  [2539] = {.lex_state = 222, .external_lex_state = 27},
  [2540] = {.lex_state = 88, .external_lex_state = 22},
  [2541] = {.lex_state = 222, .external_lex_state = 27},
  [2542] = {.lex_state = 88, .external_lex_state = 22},
  [2543] = {.lex_state = 88, .external_lex_state = 22},
  [2544] = {.lex_state = 220, .external_lex_state = 25},
  [2545] = {.lex_state = 88, .external_lex_state = 22},
  [2546] = {.lex_state = 88, .external_lex_state = 22},
  [2547] = {.lex_state = 88, .external_lex_state = 22},
  [2548] = {.lex_state = 88, .external_lex_state = 22},
  [2549] = {.lex_state = 88, .external_lex_state = 22},
  [2550] = {.lex_state = 84, .external_lex_state = 24},
  [2551] = {.lex_state = 88, .external_lex_state = 22},
  [2552] = {.lex_state = 220, .external_lex_state = 25},
  [2553] = {.lex_state = 88, .external_lex_state = 22},
  [2554] = {.lex_state = 88, .external_lex_state = 22},
  [2555] = {.lex_state = 88, .external_lex_state = 22},
  [2556] = {.lex_state = 84, .external_lex_state = 24},
  [2557] = {.lex_state = 88, .external_lex_state = 22},
  [2558] = {.lex_state = 88, .external_lex_state = 22},
  [2559] = {.lex_state = 88, .external_lex_state = 22},
  [2560] = {.lex_state = 88, .external_lex_state = 22},
  [2561] = {.lex_state = 88, .external_lex_state = 22},
  [2562] = {.lex_state = 88, .external_lex_state = 22},
  [2563] = {.lex_state = 88, .external_lex_state = 22},
  [2564] = {.lex_state = 88, .external_lex_state = 22},
  [2565] = {.lex_state = 88, .external_lex_state = 22},
  [2566] = {.lex_state = 88, .external_lex_state = 22},
  [2567] = {.lex_state = 88, .external_lex_state = 22},
  [2568] = {.lex_state = 88, .external_lex_state = 22},
  [2569] = {.lex_state = 88, .external_lex_state = 22},
  [2570] = {.lex_state = 88, .external_lex_state = 22},
  [2571] = {.lex_state = 82, .external_lex_state = 24},
  [2572] = {.lex_state = 88, .external_lex_state = 22},
  [2573] = {.lex_state = 88, .external_lex_state = 22},
  [2574] = {.lex_state = 84, .external_lex_state = 24},
  [2575] = {.lex_state = 84, .external_lex_state = 24},
  [2576] = {.lex_state = 88, .external_lex_state = 22},
  [2577] = {.lex_state = 88, .external_lex_state = 22},
  [2578] = {.lex_state = 93, .external_lex_state = 26},
  [2579] = {.lex_state = 92, .external_lex_state = 27},
  [2580] = {.lex_state = 88, .external_lex_state = 22},
  [2581] = {.lex_state = 93, .external_lex_state = 26},
  [2582] = {.lex_state = 93, .external_lex_state = 26},
  [2583] = {.lex_state = 93, .external_lex_state = 26},
  [2584] = {.lex_state = 93, .external_lex_state = 26},
  [2585] = {.lex_state = 93, .external_lex_state = 26},
  [2586] = {.lex_state = 93, .external_lex_state = 26},
  [2587] = {.lex_state = 101, .external_lex_state = 23},
  [2588] = {.lex_state = 93, .external_lex_state = 26},
  [2589] = {.lex_state = 93, .external_lex_state = 26},
  [2590] = {.lex_state = 93, .external_lex_state = 26},
  [2591] = {.lex_state = 93, .external_lex_state = 26},
  [2592] = {.lex_state = 93, .external_lex_state = 26},
  [2593] = {.lex_state = 93, .external_lex_state = 26},
  [2594] = {.lex_state = 88, .external_lex_state = 22},
  [2595] = {.lex_state = 88, .external_lex_state = 22},
  [2596] = {.lex_state = 93, .external_lex_state = 26},
  [2597] = {.lex_state = 88, .external_lex_state = 22},
  [2598] = {.lex_state = 93, .external_lex_state = 26},
  [2599] = {.lex_state = 88, .external_lex_state = 22},
  [2600] = {.lex_state = 93, .external_lex_state = 26},
  [2601] = {.lex_state = 92, .external_lex_state = 27},
  [2602] = {.lex_state = 93, .external_lex_state = 26},
  [2603] = {.lex_state = 93, .external_lex_state = 26},
  [2604] = {.lex_state = 93, .external_lex_state = 26},
  [2605] = {.lex_state = 88, .external_lex_state = 22},
  [2606] = {.lex_state = 93, .external_lex_state = 26},
  [2607] = {.lex_state = 88, .external_lex_state = 22},
  [2608] = {.lex_state = 88, .external_lex_state = 22},
  [2609] = {.lex_state = 88, .external_lex_state = 22},
  [2610] = {.lex_state = 88, .external_lex_state = 22},
  [2611] = {.lex_state = 93, .external_lex_state = 26},
  [2612] = {.lex_state = 93, .external_lex_state = 26},
  [2613] = {.lex_state = 93, .external_lex_state = 26},
  [2614] = {.lex_state = 88, .external_lex_state = 22},
  [2615] = {.lex_state = 88, .external_lex_state = 22},
  [2616] = {.lex_state = 93, .external_lex_state = 26},
  [2617] = {.lex_state = 93, .external_lex_state = 26},
  [2618] = {.lex_state = 93, .external_lex_state = 26},
  [2619] = {.lex_state = 88, .external_lex_state = 22},
  [2620] = {.lex_state = 93, .external_lex_state = 26},
  [2621] = {.lex_state = 88, .external_lex_state = 22},
  [2622] = {.lex_state = 93, .external_lex_state = 26},
  [2623] = {.lex_state = 93, .external_lex_state = 26},
  [2624] = {.lex_state = 93, .external_lex_state = 26},
  [2625] = {.lex_state = 93, .external_lex_state = 26},
  [2626] = {.lex_state = 93, .external_lex_state = 26},
  [2627] = {.lex_state = 93, .external_lex_state = 26},
  [2628] = {.lex_state = 88, .external_lex_state = 22},
  [2629] = {.lex_state = 93, .external_lex_state = 26},
  [2630] = {.lex_state = 93, .external_lex_state = 26},
  [2631] = {.lex_state = 93, .external_lex_state = 26},
  [2632] = {.lex_state = 93, .external_lex_state = 26},
  [2633] = {.lex_state = 88, .external_lex_state = 22},
  [2634] = {.lex_state = 88, .external_lex_state = 22},
  [2635] = {.lex_state = 93, .external_lex_state = 26},
  [2636] = {.lex_state = 93, .external_lex_state = 26},
  [2637] = {.lex_state = 84, .external_lex_state = 24},
  [2638] = {.lex_state = 101, .external_lex_state = 23},
  [2639] = {.lex_state = 84, .external_lex_state = 24},
  [2640] = {.lex_state = 93, .external_lex_state = 26},
  [2641] = {.lex_state = 88, .external_lex_state = 22},
  [2642] = {.lex_state = 88, .external_lex_state = 22},
  [2643] = {.lex_state = 84, .external_lex_state = 24},
  [2644] = {.lex_state = 93, .external_lex_state = 26},
  [2645] = {.lex_state = 93, .external_lex_state = 26},
  [2646] = {.lex_state = 92, .external_lex_state = 27},
  [2647] = {.lex_state = 93, .external_lex_state = 26},
  [2648] = {.lex_state = 92, .external_lex_state = 27},
  [2649] = {.lex_state = 88, .external_lex_state = 22},
  [2650] = {.lex_state = 84, .external_lex_state = 24},
  [2651] = {.lex_state = 93, .external_lex_state = 26},
  [2652] = {.lex_state = 93, .external_lex_state = 26},
  [2653] = {.lex_state = 88, .external_lex_state = 22},
  [2654] = {.lex_state = 88, .external_lex_state = 22},
  [2655] = {.lex_state = 220, .external_lex_state = 25},
  [2656] = {.lex_state = 92, .external_lex_state = 27},
  [2657] = {.lex_state = 88, .external_lex_state = 22},
  [2658] = {.lex_state = 93, .external_lex_state = 26},
  [2659] = {.lex_state = 93, .external_lex_state = 26},
  [2660] = {.lex_state = 93, .external_lex_state = 26},
  [2661] = {.lex_state = 92, .external_lex_state = 27},
  [2662] = {.lex_state = 92, .external_lex_state = 27},
  [2663] = {.lex_state = 220, .external_lex_state = 22},
  [2664] = {.lex_state = 220, .external_lex_state = 22},
  [2665] = {.lex_state = 92, .external_lex_state = 27},
  [2666] = {.lex_state = 93, .external_lex_state = 26},
  [2667] = {.lex_state = 92, .external_lex_state = 27},
  [2668] = {.lex_state = 93, .external_lex_state = 26},
  [2669] = {.lex_state = 92, .external_lex_state = 27},
  [2670] = {.lex_state = 92, .external_lex_state = 27},
  [2671] = {.lex_state = 92, .external_lex_state = 27},
  [2672] = {.lex_state = 92, .external_lex_state = 27},
  [2673] = {.lex_state = 92, .external_lex_state = 27},
  [2674] = {.lex_state = 220, .external_lex_state = 22},
  [2675] = {.lex_state = 93, .external_lex_state = 26},
  [2676] = {.lex_state = 93, .external_lex_state = 26},
  [2677] = {.lex_state = 93, .external_lex_state = 26},
  [2678] = {.lex_state = 92, .external_lex_state = 27},
  [2679] = {.lex_state = 93, .external_lex_state = 26},
  [2680] = {.lex_state = 92, .external_lex_state = 27},
  [2681] = {.lex_state = 92, .external_lex_state = 27},
  [2682] = {.lex_state = 93, .external_lex_state = 26},
  [2683] = {.lex_state = 92, .external_lex_state = 27},
  [2684] = {.lex_state = 92, .external_lex_state = 27},
  [2685] = {.lex_state = 92, .external_lex_state = 27},
  [2686] = {.lex_state = 92, .external_lex_state = 27},
  [2687] = {.lex_state = 92, .external_lex_state = 27},
  [2688] = {.lex_state = 92, .external_lex_state = 27},
  [2689] = {.lex_state = 92, .external_lex_state = 27},
  [2690] = {.lex_state = 92, .external_lex_state = 27},
  [2691] = {.lex_state = 92, .external_lex_state = 27},
  [2692] = {.lex_state = 220, .external_lex_state = 22},
  [2693] = {.lex_state = 92, .external_lex_state = 27},
  [2694] = {.lex_state = 92, .external_lex_state = 27},
  [2695] = {.lex_state = 93, .external_lex_state = 26},
  [2696] = {.lex_state = 92, .external_lex_state = 27},
  [2697] = {.lex_state = 92, .external_lex_state = 27},
  [2698] = {.lex_state = 92, .external_lex_state = 27},
  [2699] = {.lex_state = 92, .external_lex_state = 27},
  [2700] = {.lex_state = 92, .external_lex_state = 27},
  [2701] = {.lex_state = 92, .external_lex_state = 27},
  [2702] = {.lex_state = 220, .external_lex_state = 22},
  [2703] = {.lex_state = 220, .external_lex_state = 22},
  [2704] = {.lex_state = 89, .external_lex_state = 24},
  [2705] = {.lex_state = 92, .external_lex_state = 27},
  [2706] = {.lex_state = 220, .external_lex_state = 22},
  [2707] = {.lex_state = 220, .external_lex_state = 22},
  [2708] = {.lex_state = 220, .external_lex_state = 22},
  [2709] = {.lex_state = 220, .external_lex_state = 22},
  [2710] = {.lex_state = 220, .external_lex_state = 22},
  [2711] = {.lex_state = 220, .external_lex_state = 22},
  [2712] = {.lex_state = 220, .external_lex_state = 22},
  [2713] = {.lex_state = 220, .external_lex_state = 22},
  [2714] = {.lex_state = 220, .external_lex_state = 22},
  [2715] = {.lex_state = 220, .external_lex_state = 22},
  [2716] = {.lex_state = 220, .external_lex_state = 22},
  [2717] = {.lex_state = 92, .external_lex_state = 27},
  [2718] = {.lex_state = 220, .external_lex_state = 22},
  [2719] = {.lex_state = 220, .external_lex_state = 22},
  [2720] = {.lex_state = 92, .external_lex_state = 27},
  [2721] = {.lex_state = 220, .external_lex_state = 22},
  [2722] = {.lex_state = 92, .external_lex_state = 27},
  [2723] = {.lex_state = 220, .external_lex_state = 22},
  [2724] = {.lex_state = 220, .external_lex_state = 22},
  [2725] = {.lex_state = 92, .external_lex_state = 27},
  [2726] = {.lex_state = 92, .external_lex_state = 27},
  [2727] = {.lex_state = 220, .external_lex_state = 22},
  [2728] = {.lex_state = 92, .external_lex_state = 27},
  [2729] = {.lex_state = 92, .external_lex_state = 27},
  [2730] = {.lex_state = 88, .external_lex_state = 25},
  [2731] = {.lex_state = 92, .external_lex_state = 27},
  [2732] = {.lex_state = 92, .external_lex_state = 27},
  [2733] = {.lex_state = 92, .external_lex_state = 27},
  [2734] = {.lex_state = 220, .external_lex_state = 22},
  [2735] = {.lex_state = 92, .external_lex_state = 27},
  [2736] = {.lex_state = 92, .external_lex_state = 27},
  [2737] = {.lex_state = 220, .external_lex_state = 22},
  [2738] = {.lex_state = 220, .external_lex_state = 22},
  [2739] = {.lex_state = 220, .external_lex_state = 22},
  [2740] = {.lex_state = 220, .external_lex_state = 22},
  [2741] = {.lex_state = 220, .external_lex_state = 22},
  [2742] = {.lex_state = 220, .external_lex_state = 22},
  [2743] = {.lex_state = 220, .external_lex_state = 22},
  [2744] = {.lex_state = 220, .external_lex_state = 22},
  [2745] = {.lex_state = 92, .external_lex_state = 27},
  [2746] = {.lex_state = 92, .external_lex_state = 27},
  [2747] = {.lex_state = 92, .external_lex_state = 27},
  [2748] = {.lex_state = 92, .external_lex_state = 27},
  [2749] = {.lex_state = 92, .external_lex_state = 27},
  [2750] = {.lex_state = 92, .external_lex_state = 27},
  [2751] = {.lex_state = 92, .external_lex_state = 27},
  [2752] = {.lex_state = 92, .external_lex_state = 27},
  [2753] = {.lex_state = 92, .external_lex_state = 27},
  [2754] = {.lex_state = 92, .external_lex_state = 27},
  [2755] = {.lex_state = 220, .external_lex_state = 22},
  [2756] = {.lex_state = 220, .external_lex_state = 22},
  [2757] = {.lex_state = 92, .external_lex_state = 27},
  [2758] = {.lex_state = 92, .external_lex_state = 27},
  [2759] = {.lex_state = 92, .external_lex_state = 27},
  [2760] = {.lex_state = 92, .external_lex_state = 27},
  [2761] = {.lex_state = 92, .external_lex_state = 27},
  [2762] = {.lex_state = 92, .external_lex_state = 27},
  [2763] = {.lex_state = 92, .external_lex_state = 27},
  [2764] = {.lex_state = 92, .external_lex_state = 27},
  [2765] = {.lex_state = 92, .external_lex_state = 27},
  [2766] = {.lex_state = 220, .external_lex_state = 22},
  [2767] = {.lex_state = 92, .external_lex_state = 27},
  [2768] = {.lex_state = 92, .external_lex_state = 27},
  [2769] = {.lex_state = 92, .external_lex_state = 27},
  [2770] = {.lex_state = 92, .external_lex_state = 27},
  [2771] = {.lex_state = 92, .external_lex_state = 27},
  [2772] = {.lex_state = 220, .external_lex_state = 22},
  [2773] = {.lex_state = 89, .external_lex_state = 24},
  [2774] = {.lex_state = 88, .external_lex_state = 25},
  [2775] = {.lex_state = 92, .external_lex_state = 27},
  [2776] = {.lex_state = 88, .external_lex_state = 25},
  [2777] = {.lex_state = 92, .external_lex_state = 27},
  [2778] = {.lex_state = 92, .external_lex_state = 27},
  [2779] = {.lex_state = 220, .external_lex_state = 22},
  [2780] = {.lex_state = 92, .external_lex_state = 27},
  [2781] = {.lex_state = 220, .external_lex_state = 22},
  [2782] = {.lex_state = 92, .external_lex_state = 27},
  [2783] = {.lex_state = 92, .external_lex_state = 27},
  [2784] = {.lex_state = 92, .external_lex_state = 27},
  [2785] = {.lex_state = 92, .external_lex_state = 27},
  [2786] = {.lex_state = 220, .external_lex_state = 22},
  [2787] = {.lex_state = 92, .external_lex_state = 27},
  [2788] = {.lex_state = 92, .external_lex_state = 27},
  [2789] = {.lex_state = 89, .external_lex_state = 24},
  [2790] = {.lex_state = 88, .external_lex_state = 28},
  [2791] = {.lex_state = 92, .external_lex_state = 27},
  [2792] = {.lex_state = 92, .external_lex_state = 27},
  [2793] = {.lex_state = 220, .external_lex_state = 22},
  [2794] = {.lex_state = 220, .external_lex_state = 22},
  [2795] = {.lex_state = 92, .external_lex_state = 27},
  [2796] = {.lex_state = 220, .external_lex_state = 22},
  [2797] = {.lex_state = 220, .external_lex_state = 22},
  [2798] = {.lex_state = 92, .external_lex_state = 27},
  [2799] = {.lex_state = 220, .external_lex_state = 22},
  [2800] = {.lex_state = 220, .external_lex_state = 22},
  [2801] = {.lex_state = 220, .external_lex_state = 22},
  [2802] = {.lex_state = 220, .external_lex_state = 22},
  [2803] = {.lex_state = 220, .external_lex_state = 22},
  [2804] = {.lex_state = 220, .external_lex_state = 22},
  [2805] = {.lex_state = 220, .external_lex_state = 22},
  [2806] = {.lex_state = 220, .external_lex_state = 22},
  [2807] = {.lex_state = 220, .external_lex_state = 22},
  [2808] = {.lex_state = 92, .external_lex_state = 27},
  [2809] = {.lex_state = 92, .external_lex_state = 27},
  [2810] = {.lex_state = 92, .external_lex_state = 27},
  [2811] = {.lex_state = 220, .external_lex_state = 22},
  [2812] = {.lex_state = 88, .external_lex_state = 25},
  [2813] = {.lex_state = 92, .external_lex_state = 27},
  [2814] = {.lex_state = 92, .external_lex_state = 27},
  [2815] = {.lex_state = 92, .external_lex_state = 27},
  [2816] = {.lex_state = 88, .external_lex_state = 25},
  [2817] = {.lex_state = 220, .external_lex_state = 22},
  [2818] = {.lex_state = 92, .external_lex_state = 27},
  [2819] = {.lex_state = 92, .external_lex_state = 27},
  [2820] = {.lex_state = 89, .external_lex_state = 24},
  [2821] = {.lex_state = 92, .external_lex_state = 27},
  [2822] = {.lex_state = 92, .external_lex_state = 27},
  [2823] = {.lex_state = 89, .external_lex_state = 24},
  [2824] = {.lex_state = 220, .external_lex_state = 22},
  [2825] = {.lex_state = 92, .external_lex_state = 27},
  [2826] = {.lex_state = 220, .external_lex_state = 22},
  [2827] = {.lex_state = 92, .external_lex_state = 27},
  [2828] = {.lex_state = 92, .external_lex_state = 27},
  [2829] = {.lex_state = 92, .external_lex_state = 27},
  [2830] = {.lex_state = 92, .external_lex_state = 27},
  [2831] = {.lex_state = 220, .external_lex_state = 22},
  [2832] = {.lex_state = 92, .external_lex_state = 27},
  [2833] = {.lex_state = 92, .external_lex_state = 27},
  [2834] = {.lex_state = 89, .external_lex_state = 24},
  [2835] = {.lex_state = 220, .external_lex_state = 22},
  [2836] = {.lex_state = 92, .external_lex_state = 27},
  [2837] = {.lex_state = 92, .external_lex_state = 27},
  [2838] = {.lex_state = 88, .external_lex_state = 28},
  [2839] = {.lex_state = 89, .external_lex_state = 24},
  [2840] = {.lex_state = 220, .external_lex_state = 22},
  [2841] = {.lex_state = 89, .external_lex_state = 24},
  [2842] = {.lex_state = 220, .external_lex_state = 22},
  [2843] = {.lex_state = 220, .external_lex_state = 22},
  [2844] = {.lex_state = 220, .external_lex_state = 22},
  [2845] = {.lex_state = 220, .external_lex_state = 22},
  [2846] = {.lex_state = 220, .external_lex_state = 22},
  [2847] = {.lex_state = 89, .external_lex_state = 24},
  [2848] = {.lex_state = 89, .external_lex_state = 24},
  [2849] = {.lex_state = 92, .external_lex_state = 27},
  [2850] = {.lex_state = 89, .external_lex_state = 24},
  [2851] = {.lex_state = 89, .external_lex_state = 24},
  [2852] = {.lex_state = 88, .external_lex_state = 28},
  [2853] = {.lex_state = 220, .external_lex_state = 22},
  [2854] = {.lex_state = 220, .external_lex_state = 22},
  [2855] = {.lex_state = 220, .external_lex_state = 22},
  [2856] = {.lex_state = 220, .external_lex_state = 22},
  [2857] = {.lex_state = 220, .external_lex_state = 22},
  [2858] = {.lex_state = 220, .external_lex_state = 22},
  [2859] = {.lex_state = 220, .external_lex_state = 22},
  [2860] = {.lex_state = 220, .external_lex_state = 22},
  [2861] = {.lex_state = 220, .external_lex_state = 22},
  [2862] = {.lex_state = 89, .external_lex_state = 24},
  [2863] = {.lex_state = 222, .external_lex_state = 27},
  [2864] = {.lex_state = 88, .external_lex_state = 28},
  [2865] = {.lex_state = 220, .external_lex_state = 22},
  [2866] = {.lex_state = 220, .external_lex_state = 22},
  [2867] = {.lex_state = 222, .external_lex_state = 27},
  [2868] = {.lex_state = 88, .external_lex_state = 22},
  [2869] = {.lex_state = 89, .external_lex_state = 24},
  [2870] = {.lex_state = 220, .external_lex_state = 22},
  [2871] = {.lex_state = 220, .external_lex_state = 22},
  [2872] = {.lex_state = 220, .external_lex_state = 22},
  [2873] = {.lex_state = 222, .external_lex_state = 27},
  [2874] = {.lex_state = 88, .external_lex_state = 24},
  [2875] = {.lex_state = 222, .external_lex_state = 27},
  [2876] = {.lex_state = 88, .external_lex_state = 28},
  [2877] = {.lex_state = 222, .external_lex_state = 27},
  [2878] = {.lex_state = 88, .external_lex_state = 24},
  [2879] = {.lex_state = 88, .external_lex_state = 24},
  [2880] = {.lex_state = 88, .external_lex_state = 22},
  [2881] = {.lex_state = 92, .external_lex_state = 27},
  [2882] = {.lex_state = 220, .external_lex_state = 22},
  [2883] = {.lex_state = 220, .external_lex_state = 22},
  [2884] = {.lex_state = 220, .external_lex_state = 22},
  [2885] = {.lex_state = 88, .external_lex_state = 25},
  [2886] = {.lex_state = 220, .external_lex_state = 22},
  [2887] = {.lex_state = 220, .external_lex_state = 22},
  [2888] = {.lex_state = 88, .external_lex_state = 28},
  [2889] = {.lex_state = 220, .external_lex_state = 22},
  [2890] = {.lex_state = 88, .external_lex_state = 22},
  [2891] = {.lex_state = 88, .external_lex_state = 22},
  [2892] = {.lex_state = 88, .external_lex_state = 22},
  [2893] = {.lex_state = 88, .external_lex_state = 22},
  [2894] = {.lex_state = 88, .external_lex_state = 22},
  [2895] = {.lex_state = 220, .external_lex_state = 22},
  [2896] = {.lex_state = 89, .external_lex_state = 28},
  [2897] = {.lex_state = 88, .external_lex_state = 22},
  [2898] = {.lex_state = 220, .external_lex_state = 22},
  [2899] = {.lex_state = 220, .external_lex_state = 22},
  [2900] = {.lex_state = 88, .external_lex_state = 22},
  [2901] = {.lex_state = 222, .external_lex_state = 27},
  [2902] = {.lex_state = 89, .external_lex_state = 24},
  [2903] = {.lex_state = 89, .external_lex_state = 24},
  [2904] = {.lex_state = 89, .external_lex_state = 24},
  [2905] = {.lex_state = 89, .external_lex_state = 24},
  [2906] = {.lex_state = 89, .external_lex_state = 24},
  [2907] = {.lex_state = 89, .external_lex_state = 24},
  [2908] = {.lex_state = 89, .external_lex_state = 24},
  [2909] = {.lex_state = 222, .external_lex_state = 27},
  [2910] = {.lex_state = 89, .external_lex_state = 24},
  [2911] = {.lex_state = 89, .external_lex_state = 24},
  [2912] = {.lex_state = 89, .external_lex_state = 24},
  [2913] = {.lex_state = 89, .external_lex_state = 24},
  [2914] = {.lex_state = 88, .external_lex_state = 28},
  [2915] = {.lex_state = 222, .external_lex_state = 27},
  [2916] = {.lex_state = 222, .external_lex_state = 27},
  [2917] = {.lex_state = 222, .external_lex_state = 27},
  [2918] = {.lex_state = 222, .external_lex_state = 27},
  [2919] = {.lex_state = 89, .external_lex_state = 24},
  [2920] = {.lex_state = 222, .external_lex_state = 27},
  [2921] = {.lex_state = 89, .external_lex_state = 24},
  [2922] = {.lex_state = 89, .external_lex_state = 24},
  [2923] = {.lex_state = 89, .external_lex_state = 24},
  [2924] = {.lex_state = 222, .external_lex_state = 27},
  [2925] = {.lex_state = 89, .external_lex_state = 24},
  [2926] = {.lex_state = 89, .external_lex_state = 24},
  [2927] = {.lex_state = 89, .external_lex_state = 24},
  [2928] = {.lex_state = 89, .external_lex_state = 24},
  [2929] = {.lex_state = 89, .external_lex_state = 24},
  [2930] = {.lex_state = 222, .external_lex_state = 27},
  [2931] = {.lex_state = 89, .external_lex_state = 24},
  [2932] = {.lex_state = 222, .external_lex_state = 27},
  [2933] = {.lex_state = 222, .external_lex_state = 27},
  [2934] = {.lex_state = 222, .external_lex_state = 27},
  [2935] = {.lex_state = 89, .external_lex_state = 24},
  [2936] = {.lex_state = 89, .external_lex_state = 24},
  [2937] = {.lex_state = 89, .external_lex_state = 24},
  [2938] = {.lex_state = 89, .external_lex_state = 24},
  [2939] = {.lex_state = 88, .external_lex_state = 22},
  [2940] = {.lex_state = 88, .external_lex_state = 22},
  [2941] = {.lex_state = 222, .external_lex_state = 27},
  [2942] = {.lex_state = 89, .external_lex_state = 24},
  [2943] = {.lex_state = 222, .external_lex_state = 27},
  [2944] = {.lex_state = 222, .external_lex_state = 27},
  [2945] = {.lex_state = 89, .external_lex_state = 24},
  [2946] = {.lex_state = 88, .external_lex_state = 25},
  [2947] = {.lex_state = 89, .external_lex_state = 24},
  [2948] = {.lex_state = 222, .external_lex_state = 27},
  [2949] = {.lex_state = 222, .external_lex_state = 27},
  [2950] = {.lex_state = 89, .external_lex_state = 24},
  [2951] = {.lex_state = 222, .external_lex_state = 27},
  [2952] = {.lex_state = 89, .external_lex_state = 24},
  [2953] = {.lex_state = 89, .external_lex_state = 24},
  [2954] = {.lex_state = 89, .external_lex_state = 24},
  [2955] = {.lex_state = 89, .external_lex_state = 24},
  [2956] = {.lex_state = 222, .external_lex_state = 27},
  [2957] = {.lex_state = 88, .external_lex_state = 22},
  [2958] = {.lex_state = 89, .external_lex_state = 24},
  [2959] = {.lex_state = 89, .external_lex_state = 24},
  [2960] = {.lex_state = 89, .external_lex_state = 24},
  [2961] = {.lex_state = 89, .external_lex_state = 24},
  [2962] = {.lex_state = 89, .external_lex_state = 24},
  [2963] = {.lex_state = 222, .external_lex_state = 27},
  [2964] = {.lex_state = 88, .external_lex_state = 22},
  [2965] = {.lex_state = 89, .external_lex_state = 24},
  [2966] = {.lex_state = 222, .external_lex_state = 27},
  [2967] = {.lex_state = 89, .external_lex_state = 24},
  [2968] = {.lex_state = 222, .external_lex_state = 27},
  [2969] = {.lex_state = 88, .external_lex_state = 22},
  [2970] = {.lex_state = 89, .external_lex_state = 24},
  [2971] = {.lex_state = 89, .external_lex_state = 24},
  [2972] = {.lex_state = 89, .external_lex_state = 24},
  [2973] = {.lex_state = 89, .external_lex_state = 24},
  [2974] = {.lex_state = 89, .external_lex_state = 24},
  [2975] = {.lex_state = 222, .external_lex_state = 27},
  [2976] = {.lex_state = 89, .external_lex_state = 24},
  [2977] = {.lex_state = 89, .external_lex_state = 24},
  [2978] = {.lex_state = 88, .external_lex_state = 22},
  [2979] = {.lex_state = 222, .external_lex_state = 27},
  [2980] = {.lex_state = 89, .external_lex_state = 24},
  [2981] = {.lex_state = 88, .external_lex_state = 22},
  [2982] = {.lex_state = 88, .external_lex_state = 22},
  [2983] = {.lex_state = 89, .external_lex_state = 24},
  [2984] = {.lex_state = 89, .external_lex_state = 24},
  [2985] = {.lex_state = 89, .external_lex_state = 24},
  [2986] = {.lex_state = 88, .external_lex_state = 22},
  [2987] = {.lex_state = 88, .external_lex_state = 22},
  [2988] = {.lex_state = 88, .external_lex_state = 22},
  [2989] = {.lex_state = 88, .external_lex_state = 22},
  [2990] = {.lex_state = 88, .external_lex_state = 22},
  [2991] = {.lex_state = 88, .external_lex_state = 22},
  [2992] = {.lex_state = 88, .external_lex_state = 22},
  [2993] = {.lex_state = 88, .external_lex_state = 22},
  [2994] = {.lex_state = 88, .external_lex_state = 22},
  [2995] = {.lex_state = 88, .external_lex_state = 22},
  [2996] = {.lex_state = 222, .external_lex_state = 27},
  [2997] = {.lex_state = 222, .external_lex_state = 27},
  [2998] = {.lex_state = 89, .external_lex_state = 24},
  [2999] = {.lex_state = 88, .external_lex_state = 22},
  [3000] = {.lex_state = 89, .external_lex_state = 24},
  [3001] = {.lex_state = 88, .external_lex_state = 22},
  [3002] = {.lex_state = 88, .external_lex_state = 22},
  [3003] = {.lex_state = 89, .external_lex_state = 24},
  [3004] = {.lex_state = 89, .external_lex_state = 24},
  [3005] = {.lex_state = 89, .external_lex_state = 24},
  [3006] = {.lex_state = 88, .external_lex_state = 22},
  [3007] = {.lex_state = 89, .external_lex_state = 24},
  [3008] = {.lex_state = 89, .external_lex_state = 24},
  [3009] = {.lex_state = 222, .external_lex_state = 27},
  [3010] = {.lex_state = 89, .external_lex_state = 24},
  [3011] = {.lex_state = 88, .external_lex_state = 22},
  [3012] = {.lex_state = 89, .external_lex_state = 24},
  [3013] = {.lex_state = 89, .external_lex_state = 24},
  [3014] = {.lex_state = 89, .external_lex_state = 24},
  [3015] = {.lex_state = 89, .external_lex_state = 24},
  [3016] = {.lex_state = 89, .external_lex_state = 24},
  [3017] = {.lex_state = 89, .external_lex_state = 24},
  [3018] = {.lex_state = 88, .external_lex_state = 22},
  [3019] = {.lex_state = 88, .external_lex_state = 22},
  [3020] = {.lex_state = 89, .external_lex_state = 24},
  [3021] = {.lex_state = 89, .external_lex_state = 24},
  [3022] = {.lex_state = 89, .external_lex_state = 24},
  [3023] = {.lex_state = 89, .external_lex_state = 24},
  [3024] = {.lex_state = 89, .external_lex_state = 24},
  [3025] = {.lex_state = 89, .external_lex_state = 24},
  [3026] = {.lex_state = 88, .external_lex_state = 28},
  [3027] = {.lex_state = 89, .external_lex_state = 24},
  [3028] = {.lex_state = 89, .external_lex_state = 24},
  [3029] = {.lex_state = 89, .external_lex_state = 24},
  [3030] = {.lex_state = 89, .external_lex_state = 24},
  [3031] = {.lex_state = 89, .external_lex_state = 24},
  [3032] = {.lex_state = 89, .external_lex_state = 24},
  [3033] = {.lex_state = 89, .external_lex_state = 24},
  [3034] = {.lex_state = 89, .external_lex_state = 24},
  [3035] = {.lex_state = 89, .external_lex_state = 24},
  [3036] = {.lex_state = 89, .external_lex_state = 24},
  [3037] = {.lex_state = 89, .external_lex_state = 24},
  [3038] = {.lex_state = 89, .external_lex_state = 24},
  [3039] = {.lex_state = 89, .external_lex_state = 24},
  [3040] = {.lex_state = 89, .external_lex_state = 24},
  [3041] = {.lex_state = 89, .external_lex_state = 24},
  [3042] = {.lex_state = 89, .external_lex_state = 24},
  [3043] = {.lex_state = 89, .external_lex_state = 24},
  [3044] = {.lex_state = 89, .external_lex_state = 24},
  [3045] = {.lex_state = 89, .external_lex_state = 24},
  [3046] = {.lex_state = 89, .external_lex_state = 24},
  [3047] = {.lex_state = 89, .external_lex_state = 24},
  [3048] = {.lex_state = 89, .external_lex_state = 24},
  [3049] = {.lex_state = 89, .external_lex_state = 24},
  [3050] = {.lex_state = 89, .external_lex_state = 24},
  [3051] = {.lex_state = 89, .external_lex_state = 24},
  [3052] = {.lex_state = 88, .external_lex_state = 22},
  [3053] = {.lex_state = 89, .external_lex_state = 24},
  [3054] = {.lex_state = 89, .external_lex_state = 24},
  [3055] = {.lex_state = 89, .external_lex_state = 24},
  [3056] = {.lex_state = 89, .external_lex_state = 24},
  [3057] = {.lex_state = 89, .external_lex_state = 24},
  [3058] = {.lex_state = 89, .external_lex_state = 24},
  [3059] = {.lex_state = 89, .external_lex_state = 24},
  [3060] = {.lex_state = 89, .external_lex_state = 24},
  [3061] = {.lex_state = 222, .external_lex_state = 27},
  [3062] = {.lex_state = 89, .external_lex_state = 24},
  [3063] = {.lex_state = 89, .external_lex_state = 24},
  [3064] = {.lex_state = 89, .external_lex_state = 24},
  [3065] = {.lex_state = 89, .external_lex_state = 24},
  [3066] = {.lex_state = 89, .external_lex_state = 24},
  [3067] = {.lex_state = 89, .external_lex_state = 24},
  [3068] = {.lex_state = 89, .external_lex_state = 24},
  [3069] = {.lex_state = 88, .external_lex_state = 22},
  [3070] = {.lex_state = 89, .external_lex_state = 24},
  [3071] = {.lex_state = 89, .external_lex_state = 24},
  [3072] = {.lex_state = 89, .external_lex_state = 24},
  [3073] = {.lex_state = 89, .external_lex_state = 24},
  [3074] = {.lex_state = 89, .external_lex_state = 24},
  [3075] = {.lex_state = 89, .external_lex_state = 24},
  [3076] = {.lex_state = 89, .external_lex_state = 24},
  [3077] = {.lex_state = 89, .external_lex_state = 24},
  [3078] = {.lex_state = 89, .external_lex_state = 24},
  [3079] = {.lex_state = 89, .external_lex_state = 24},
  [3080] = {.lex_state = 89, .external_lex_state = 24},
  [3081] = {.lex_state = 89, .external_lex_state = 24},
  [3082] = {.lex_state = 89, .external_lex_state = 24},
  [3083] = {.lex_state = 89, .external_lex_state = 24},
  [3084] = {.lex_state = 89, .external_lex_state = 24},
  [3085] = {.lex_state = 89, .external_lex_state = 24},
  [3086] = {.lex_state = 88, .external_lex_state = 28},
  [3087] = {.lex_state = 89, .external_lex_state = 24},
  [3088] = {.lex_state = 89, .external_lex_state = 24},
  [3089] = {.lex_state = 89, .external_lex_state = 24},
  [3090] = {.lex_state = 89, .external_lex_state = 24},
  [3091] = {.lex_state = 89, .external_lex_state = 24},
  [3092] = {.lex_state = 89, .external_lex_state = 24},
  [3093] = {.lex_state = 89, .external_lex_state = 24},
  [3094] = {.lex_state = 222, .external_lex_state = 27},
  [3095] = {.lex_state = 89, .external_lex_state = 24},
  [3096] = {.lex_state = 89, .external_lex_state = 24},
  [3097] = {.lex_state = 89, .external_lex_state = 24},
  [3098] = {.lex_state = 89, .external_lex_state = 24},
  [3099] = {.lex_state = 89, .external_lex_state = 24},
  [3100] = {.lex_state = 89, .external_lex_state = 24},
  [3101] = {.lex_state = 89, .external_lex_state = 24},
  [3102] = {.lex_state = 89, .external_lex_state = 24},
  [3103] = {.lex_state = 89, .external_lex_state = 24},
  [3104] = {.lex_state = 89, .external_lex_state = 24},
  [3105] = {.lex_state = 89, .external_lex_state = 24},
  [3106] = {.lex_state = 88, .external_lex_state = 24},
  [3107] = {.lex_state = 222, .external_lex_state = 27},
  [3108] = {.lex_state = 88, .external_lex_state = 22},
  [3109] = {.lex_state = 88, .external_lex_state = 22},
  [3110] = {.lex_state = 88, .external_lex_state = 22},
  [3111] = {.lex_state = 88, .external_lex_state = 22},
  [3112] = {.lex_state = 88, .external_lex_state = 22},
  [3113] = {.lex_state = 88, .external_lex_state = 22},
  [3114] = {.lex_state = 88, .external_lex_state = 22},
  [3115] = {.lex_state = 88, .external_lex_state = 22},
  [3116] = {.lex_state = 88, .external_lex_state = 22},
  [3117] = {.lex_state = 222, .external_lex_state = 27},
  [3118] = {.lex_state = 222, .external_lex_state = 27},
  [3119] = {.lex_state = 88, .external_lex_state = 22},
  [3120] = {.lex_state = 88, .external_lex_state = 22},
  [3121] = {.lex_state = 222, .external_lex_state = 27},
  [3122] = {.lex_state = 88, .external_lex_state = 22},
  [3123] = {.lex_state = 88, .external_lex_state = 22},
  [3124] = {.lex_state = 88, .external_lex_state = 22},
  [3125] = {.lex_state = 88, .external_lex_state = 22},
  [3126] = {.lex_state = 88, .external_lex_state = 22},
  [3127] = {.lex_state = 88, .external_lex_state = 25},
  [3128] = {.lex_state = 88, .external_lex_state = 22},
  [3129] = {.lex_state = 88, .external_lex_state = 22},
  [3130] = {.lex_state = 88, .external_lex_state = 22},
  [3131] = {.lex_state = 88, .external_lex_state = 22},
  [3132] = {.lex_state = 88, .external_lex_state = 22},
  [3133] = {.lex_state = 222, .external_lex_state = 27},
  [3134] = {.lex_state = 88, .external_lex_state = 22},
  [3135] = {.lex_state = 88, .external_lex_state = 22},
  [3136] = {.lex_state = 222, .external_lex_state = 27},
  [3137] = {.lex_state = 88, .external_lex_state = 22},
  [3138] = {.lex_state = 88, .external_lex_state = 24},
  [3139] = {.lex_state = 88, .external_lex_state = 22},
  [3140] = {.lex_state = 88, .external_lex_state = 22},
  [3141] = {.lex_state = 88, .external_lex_state = 22},
  [3142] = {.lex_state = 88, .external_lex_state = 22},
  [3143] = {.lex_state = 88, .external_lex_state = 22},
  [3144] = {.lex_state = 222, .external_lex_state = 27},
  [3145] = {.lex_state = 222, .external_lex_state = 27},
  [3146] = {.lex_state = 88, .external_lex_state = 28},
  [3147] = {.lex_state = 88, .external_lex_state = 22},
  [3148] = {.lex_state = 88, .external_lex_state = 22},
  [3149] = {.lex_state = 88, .external_lex_state = 22},
  [3150] = {.lex_state = 88, .external_lex_state = 24},
  [3151] = {.lex_state = 88, .external_lex_state = 28},
  [3152] = {.lex_state = 88, .external_lex_state = 22},
  [3153] = {.lex_state = 97, .external_lex_state = 29},
  [3154] = {.lex_state = 222, .external_lex_state = 27},
  [3155] = {.lex_state = 97, .external_lex_state = 29},
  [3156] = {.lex_state = 222, .external_lex_state = 27},
  [3157] = {.lex_state = 222, .external_lex_state = 27},
  [3158] = {.lex_state = 222, .external_lex_state = 27},
  [3159] = {.lex_state = 222, .external_lex_state = 27},
  [3160] = {.lex_state = 97, .external_lex_state = 29},
  [3161] = {.lex_state = 88, .external_lex_state = 22},
  [3162] = {.lex_state = 88, .external_lex_state = 22},
  [3163] = {.lex_state = 97, .external_lex_state = 29},
  [3164] = {.lex_state = 97, .external_lex_state = 29},
  [3165] = {.lex_state = 222, .external_lex_state = 27},
  [3166] = {.lex_state = 97, .external_lex_state = 29},
  [3167] = {.lex_state = 97, .external_lex_state = 29},
  [3168] = {.lex_state = 89, .external_lex_state = 24},
  [3169] = {.lex_state = 88, .external_lex_state = 24},
  [3170] = {.lex_state = 88, .external_lex_state = 22},
  [3171] = {.lex_state = 222, .external_lex_state = 27},
  [3172] = {.lex_state = 222, .external_lex_state = 27},
  [3173] = {.lex_state = 97, .external_lex_state = 29},
  [3174] = {.lex_state = 97, .external_lex_state = 29},
  [3175] = {.lex_state = 222, .external_lex_state = 27},
  [3176] = {.lex_state = 222, .external_lex_state = 27},
  [3177] = {.lex_state = 88, .external_lex_state = 24},
  [3178] = {.lex_state = 88, .external_lex_state = 24},
  [3179] = {.lex_state = 88, .external_lex_state = 24},
  [3180] = {.lex_state = 97, .external_lex_state = 29},
  [3181] = {.lex_state = 222, .external_lex_state = 27},
  [3182] = {.lex_state = 222, .external_lex_state = 27},
  [3183] = {.lex_state = 88, .external_lex_state = 24},
  [3184] = {.lex_state = 88, .external_lex_state = 28},
  [3185] = {.lex_state = 97, .external_lex_state = 29},
  [3186] = {.lex_state = 97, .external_lex_state = 29},
  [3187] = {.lex_state = 97, .external_lex_state = 29},
  [3188] = {.lex_state = 222, .external_lex_state = 27},
  [3189] = {.lex_state = 88, .external_lex_state = 22},
  [3190] = {.lex_state = 222, .external_lex_state = 27},
  [3191] = {.lex_state = 222, .external_lex_state = 27},
  [3192] = {.lex_state = 222, .external_lex_state = 27},
  [3193] = {.lex_state = 97, .external_lex_state = 29},
  [3194] = {.lex_state = 97, .external_lex_state = 29},
  [3195] = {.lex_state = 97, .external_lex_state = 29},
  [3196] = {.lex_state = 97, .external_lex_state = 29},
  [3197] = {.lex_state = 95, .external_lex_state = 26},
  [3198] = {.lex_state = 97, .external_lex_state = 29},
  [3199] = {.lex_state = 97, .external_lex_state = 29},
  [3200] = {.lex_state = 222, .external_lex_state = 27},
  [3201] = {.lex_state = 97, .external_lex_state = 29},
  [3202] = {.lex_state = 88, .external_lex_state = 24},
  [3203] = {.lex_state = 222, .external_lex_state = 27},
  [3204] = {.lex_state = 97, .external_lex_state = 29},
  [3205] = {.lex_state = 222, .external_lex_state = 27},
  [3206] = {.lex_state = 222, .external_lex_state = 27},
  [3207] = {.lex_state = 97, .external_lex_state = 29},
  [3208] = {.lex_state = 88, .external_lex_state = 22},
  [3209] = {.lex_state = 88, .external_lex_state = 28},
  [3210] = {.lex_state = 222, .external_lex_state = 27},
  [3211] = {.lex_state = 222, .external_lex_state = 27},
  [3212] = {.lex_state = 222, .external_lex_state = 27},
  [3213] = {.lex_state = 97, .external_lex_state = 29},
  [3214] = {.lex_state = 97, .external_lex_state = 29},
  [3215] = {.lex_state = 97, .external_lex_state = 29},
  [3216] = {.lex_state = 222, .external_lex_state = 27},
  [3217] = {.lex_state = 222, .external_lex_state = 27},
  [3218] = {.lex_state = 222, .external_lex_state = 27},
  [3219] = {.lex_state = 97, .external_lex_state = 29},
  [3220] = {.lex_state = 222, .external_lex_state = 27},
  [3221] = {.lex_state = 97, .external_lex_state = 29},
  [3222] = {.lex_state = 88, .external_lex_state = 22},
  [3223] = {.lex_state = 222, .external_lex_state = 27},
  [3224] = {.lex_state = 88, .external_lex_state = 24},
  [3225] = {.lex_state = 97, .external_lex_state = 29},
  [3226] = {.lex_state = 97, .external_lex_state = 29},
  [3227] = {.lex_state = 222, .external_lex_state = 27},
  [3228] = {.lex_state = 222, .external_lex_state = 27},
  [3229] = {.lex_state = 88, .external_lex_state = 24},
  [3230] = {.lex_state = 222, .external_lex_state = 27},
  [3231] = {.lex_state = 88, .external_lex_state = 24},
  [3232] = {.lex_state = 222, .external_lex_state = 27},
  [3233] = {.lex_state = 88, .external_lex_state = 24},
  [3234] = {.lex_state = 222, .external_lex_state = 27},
  [3235] = {.lex_state = 88, .external_lex_state = 24},
  [3236] = {.lex_state = 88, .external_lex_state = 24},
  [3237] = {.lex_state = 88, .external_lex_state = 22},
  [3238] = {.lex_state = 88, .external_lex_state = 22},
  [3239] = {.lex_state = 222, .external_lex_state = 27},
  [3240] = {.lex_state = 222, .external_lex_state = 27},
  [3241] = {.lex_state = 88, .external_lex_state = 22},
  [3242] = {.lex_state = 222, .external_lex_state = 27},
  [3243] = {.lex_state = 93, .external_lex_state = 26},
  [3244] = {.lex_state = 222, .external_lex_state = 27},
  [3245] = {.lex_state = 93, .external_lex_state = 26},
  [3246] = {.lex_state = 222, .external_lex_state = 27},
  [3247] = {.lex_state = 88, .external_lex_state = 22},
  [3248] = {.lex_state = 88, .external_lex_state = 22},
  [3249] = {.lex_state = 88, .external_lex_state = 22},
  [3250] = {.lex_state = 88, .external_lex_state = 22},
  [3251] = {.lex_state = 88, .external_lex_state = 24},
  [3252] = {.lex_state = 222, .external_lex_state = 27},
  [3253] = {.lex_state = 88, .external_lex_state = 22},
  [3254] = {.lex_state = 88, .external_lex_state = 22},
  [3255] = {.lex_state = 88, .external_lex_state = 22},
  [3256] = {.lex_state = 88, .external_lex_state = 22},
  [3257] = {.lex_state = 88, .external_lex_state = 22},
  [3258] = {.lex_state = 88, .external_lex_state = 22},
  [3259] = {.lex_state = 88, .external_lex_state = 22},
  [3260] = {.lex_state = 88, .external_lex_state = 22},
  [3261] = {.lex_state = 88, .external_lex_state = 22},
  [3262] = {.lex_state = 88, .external_lex_state = 28},
  [3263] = {.lex_state = 88, .external_lex_state = 22},
  [3264] = {.lex_state = 88, .external_lex_state = 22},
  [3265] = {.lex_state = 88, .external_lex_state = 22},
  [3266] = {.lex_state = 88, .external_lex_state = 24},
  [3267] = {.lex_state = 88, .external_lex_state = 24},
  [3268] = {.lex_state = 88, .external_lex_state = 24},
  [3269] = {.lex_state = 88, .external_lex_state = 24},
  [3270] = {.lex_state = 222, .external_lex_state = 27},
  [3271] = {.lex_state = 88, .external_lex_state = 24},
  [3272] = {.lex_state = 88, .external_lex_state = 24},
  [3273] = {.lex_state = 88, .external_lex_state = 24},
  [3274] = {.lex_state = 88, .external_lex_state = 24},
  [3275] = {.lex_state = 88, .external_lex_state = 24},
  [3276] = {.lex_state = 88, .external_lex_state = 22},
  [3277] = {.lex_state = 88, .external_lex_state = 24},
  [3278] = {.lex_state = 88, .external_lex_state = 24},
  [3279] = {.lex_state = 88, .external_lex_state = 24},
  [3280] = {.lex_state = 88, .external_lex_state = 24},
  [3281] = {.lex_state = 222, .external_lex_state = 27},
  [3282] = {.lex_state = 222, .external_lex_state = 27},
  [3283] = {.lex_state = 222, .external_lex_state = 27},
  [3284] = {.lex_state = 88, .external_lex_state = 24},
  [3285] = {.lex_state = 88, .external_lex_state = 24},
  [3286] = {.lex_state = 88, .external_lex_state = 24},
  [3287] = {.lex_state = 222, .external_lex_state = 27},
  [3288] = {.lex_state = 88, .external_lex_state = 24},
  [3289] = {.lex_state = 88, .external_lex_state = 24},
  [3290] = {.lex_state = 222, .external_lex_state = 27},
  [3291] = {.lex_state = 88, .external_lex_state = 24},
  [3292] = {.lex_state = 88, .external_lex_state = 24},
  [3293] = {.lex_state = 222, .external_lex_state = 27},
  [3294] = {.lex_state = 222, .external_lex_state = 27},
  [3295] = {.lex_state = 88, .external_lex_state = 24},
  [3296] = {.lex_state = 88, .external_lex_state = 24},
  [3297] = {.lex_state = 88, .external_lex_state = 24},
  [3298] = {.lex_state = 88, .external_lex_state = 24},
  [3299] = {.lex_state = 88, .external_lex_state = 24},
  [3300] = {.lex_state = 88, .external_lex_state = 24},
  [3301] = {.lex_state = 88, .external_lex_state = 24},
  [3302] = {.lex_state = 88, .external_lex_state = 24},
  [3303] = {.lex_state = 88, .external_lex_state = 24},
  [3304] = {.lex_state = 88, .external_lex_state = 24},
  [3305] = {.lex_state = 88, .external_lex_state = 24},
  [3306] = {.lex_state = 88, .external_lex_state = 24},
  [3307] = {.lex_state = 88, .external_lex_state = 24},
  [3308] = {.lex_state = 88, .external_lex_state = 24},
  [3309] = {.lex_state = 92, .external_lex_state = 27},
  [3310] = {.lex_state = 88, .external_lex_state = 24},
  [3311] = {.lex_state = 88, .external_lex_state = 24},
  [3312] = {.lex_state = 88, .external_lex_state = 24},
  [3313] = {.lex_state = 88, .external_lex_state = 24},
  [3314] = {.lex_state = 88, .external_lex_state = 24},
  [3315] = {.lex_state = 88, .external_lex_state = 22},
  [3316] = {.lex_state = 88, .external_lex_state = 22},
  [3317] = {.lex_state = 92, .external_lex_state = 27},
  [3318] = {.lex_state = 88, .external_lex_state = 24},
  [3319] = {.lex_state = 92, .external_lex_state = 27},
  [3320] = {.lex_state = 88, .external_lex_state = 24},
  [3321] = {.lex_state = 222, .external_lex_state = 27},
  [3322] = {.lex_state = 88, .external_lex_state = 24},
  [3323] = {.lex_state = 88, .external_lex_state = 24},
  [3324] = {.lex_state = 88, .external_lex_state = 24},
  [3325] = {.lex_state = 88, .external_lex_state = 22},
  [3326] = {.lex_state = 222, .external_lex_state = 27},
  [3327] = {.lex_state = 88, .external_lex_state = 22},
  [3328] = {.lex_state = 88, .external_lex_state = 24},
  [3329] = {.lex_state = 93, .external_lex_state = 26},
  [3330] = {.lex_state = 222, .external_lex_state = 27},
  [3331] = {.lex_state = 93, .external_lex_state = 26},
  [3332] = {.lex_state = 222, .external_lex_state = 27},
  [3333] = {.lex_state = 222, .external_lex_state = 27},
  [3334] = {.lex_state = 88, .external_lex_state = 24},
  [3335] = {.lex_state = 88, .external_lex_state = 24},
  [3336] = {.lex_state = 92, .external_lex_state = 27},
  [3337] = {.lex_state = 222, .external_lex_state = 27},
  [3338] = {.lex_state = 88, .external_lex_state = 24},
  [3339] = {.lex_state = 222, .external_lex_state = 27},
  [3340] = {.lex_state = 222, .external_lex_state = 27},
  [3341] = {.lex_state = 92, .external_lex_state = 27},
  [3342] = {.lex_state = 88, .external_lex_state = 24},
  [3343] = {.lex_state = 88, .external_lex_state = 22},
  [3344] = {.lex_state = 88, .external_lex_state = 24},
  [3345] = {.lex_state = 88, .external_lex_state = 22},
  [3346] = {.lex_state = 92, .external_lex_state = 27},
  [3347] = {.lex_state = 222, .external_lex_state = 27},
  [3348] = {.lex_state = 92, .external_lex_state = 27},
  [3349] = {.lex_state = 222, .external_lex_state = 27},
  [3350] = {.lex_state = 88, .external_lex_state = 24},
  [3351] = {.lex_state = 88, .external_lex_state = 24},
  [3352] = {.lex_state = 88, .external_lex_state = 24},
  [3353] = {.lex_state = 88, .external_lex_state = 22},
  [3354] = {.lex_state = 88, .external_lex_state = 24},
  [3355] = {.lex_state = 93, .external_lex_state = 26},
  [3356] = {.lex_state = 92, .external_lex_state = 27},
  [3357] = {.lex_state = 222, .external_lex_state = 27},
  [3358] = {.lex_state = 88, .external_lex_state = 24},
  [3359] = {.lex_state = 88, .external_lex_state = 24},
  [3360] = {.lex_state = 93, .external_lex_state = 26},
  [3361] = {.lex_state = 93, .external_lex_state = 26},
  [3362] = {.lex_state = 93, .external_lex_state = 26},
  [3363] = {.lex_state = 93, .external_lex_state = 26},
  [3364] = {.lex_state = 88, .external_lex_state = 24},
  [3365] = {.lex_state = 88, .external_lex_state = 24},
  [3366] = {.lex_state = 88, .external_lex_state = 24},
  [3367] = {.lex_state = 88, .external_lex_state = 24},
  [3368] = {.lex_state = 88, .external_lex_state = 24},
  [3369] = {.lex_state = 88, .external_lex_state = 24},
  [3370] = {.lex_state = 88, .external_lex_state = 24},
  [3371] = {.lex_state = 88, .external_lex_state = 24},
  [3372] = {.lex_state = 93, .external_lex_state = 26},
  [3373] = {.lex_state = 88, .external_lex_state = 24},
  [3374] = {.lex_state = 88, .external_lex_state = 24},
  [3375] = {.lex_state = 88, .external_lex_state = 24},
  [3376] = {.lex_state = 88, .external_lex_state = 24},
  [3377] = {.lex_state = 88, .external_lex_state = 24},
  [3378] = {.lex_state = 92, .external_lex_state = 27},
  [3379] = {.lex_state = 92, .external_lex_state = 30},
  [3380] = {.lex_state = 88, .external_lex_state = 28},
  [3381] = {.lex_state = 92, .external_lex_state = 27},
  [3382] = {.lex_state = 222, .external_lex_state = 27},
  [3383] = {.lex_state = 88, .external_lex_state = 24},
  [3384] = {.lex_state = 92, .external_lex_state = 27},
  [3385] = {.lex_state = 88, .external_lex_state = 24},
  [3386] = {.lex_state = 222, .external_lex_state = 27},
  [3387] = {.lex_state = 92, .external_lex_state = 27},
  [3388] = {.lex_state = 92, .external_lex_state = 27},
  [3389] = {.lex_state = 93, .external_lex_state = 29},
  [3390] = {.lex_state = 88, .external_lex_state = 22},
  [3391] = {.lex_state = 92, .external_lex_state = 30},
  [3392] = {.lex_state = 88, .external_lex_state = 24},
  [3393] = {.lex_state = 88, .external_lex_state = 24},
  [3394] = {.lex_state = 101, .external_lex_state = 23},
  [3395] = {.lex_state = 88, .external_lex_state = 24},
  [3396] = {.lex_state = 88, .external_lex_state = 24},
  [3397] = {.lex_state = 92, .external_lex_state = 27},
  [3398] = {.lex_state = 88, .external_lex_state = 24},
  [3399] = {.lex_state = 92, .external_lex_state = 27},
  [3400] = {.lex_state = 92, .external_lex_state = 27},
  [3401] = {.lex_state = 88, .external_lex_state = 24},
  [3402] = {.lex_state = 92, .external_lex_state = 27},
  [3403] = {.lex_state = 92, .external_lex_state = 27},
  [3404] = {.lex_state = 88, .external_lex_state = 24},
  [3405] = {.lex_state = 88, .external_lex_state = 22},
  [3406] = {.lex_state = 88, .external_lex_state = 24},
  [3407] = {.lex_state = 92, .external_lex_state = 30},
  [3408] = {.lex_state = 92, .external_lex_state = 27},
  [3409] = {.lex_state = 88, .external_lex_state = 24},
  [3410] = {.lex_state = 88, .external_lex_state = 24},
  [3411] = {.lex_state = 93, .external_lex_state = 29},
  [3412] = {.lex_state = 88, .external_lex_state = 24},
  [3413] = {.lex_state = 88, .external_lex_state = 24},
  [3414] = {.lex_state = 101, .external_lex_state = 23},
  [3415] = {.lex_state = 88, .external_lex_state = 24},
  [3416] = {.lex_state = 88, .external_lex_state = 24},
  [3417] = {.lex_state = 88, .external_lex_state = 24},
  [3418] = {.lex_state = 88, .external_lex_state = 24},
  [3419] = {.lex_state = 92, .external_lex_state = 27},
  [3420] = {.lex_state = 101, .external_lex_state = 23},
  [3421] = {.lex_state = 101, .external_lex_state = 23},
  [3422] = {.lex_state = 88, .external_lex_state = 24},
  [3423] = {.lex_state = 88, .external_lex_state = 22},
  [3424] = {.lex_state = 88, .external_lex_state = 24},
  [3425] = {.lex_state = 88, .external_lex_state = 24},
  [3426] = {.lex_state = 88, .external_lex_state = 24},
  [3427] = {.lex_state = 88, .external_lex_state = 24},
  [3428] = {.lex_state = 88, .external_lex_state = 24},
  [3429] = {.lex_state = 88, .external_lex_state = 24},
  [3430] = {.lex_state = 88, .external_lex_state = 24},
  [3431] = {.lex_state = 92, .external_lex_state = 27},
  [3432] = {.lex_state = 88, .external_lex_state = 24},
  [3433] = {.lex_state = 88, .external_lex_state = 24},
  [3434] = {.lex_state = 88, .external_lex_state = 24},
  [3435] = {.lex_state = 88, .external_lex_state = 24},
  [3436] = {.lex_state = 88, .external_lex_state = 24},
  [3437] = {.lex_state = 88, .external_lex_state = 24},
  [3438] = {.lex_state = 88, .external_lex_state = 24},
  [3439] = {.lex_state = 88, .external_lex_state = 24},
  [3440] = {.lex_state = 101, .external_lex_state = 23},
  [3441] = {.lex_state = 88, .external_lex_state = 24},
  [3442] = {.lex_state = 92, .external_lex_state = 27},
  [3443] = {.lex_state = 88, .external_lex_state = 24},
  [3444] = {.lex_state = 88, .external_lex_state = 24},
  [3445] = {.lex_state = 88, .external_lex_state = 22},
  [3446] = {.lex_state = 88, .external_lex_state = 24},
  [3447] = {.lex_state = 92, .external_lex_state = 27},
  [3448] = {.lex_state = 92, .external_lex_state = 27},
  [3449] = {.lex_state = 92, .external_lex_state = 27},
  [3450] = {.lex_state = 88, .external_lex_state = 22},
  [3451] = {.lex_state = 92, .external_lex_state = 30},
  [3452] = {.lex_state = 92, .external_lex_state = 27},
  [3453] = {.lex_state = 92, .external_lex_state = 27},
  [3454] = {.lex_state = 88, .external_lex_state = 24},
  [3455] = {.lex_state = 88, .external_lex_state = 24},
  [3456] = {.lex_state = 92, .external_lex_state = 27},
  [3457] = {.lex_state = 92, .external_lex_state = 27},
  [3458] = {.lex_state = 92, .external_lex_state = 27},
  [3459] = {.lex_state = 92, .external_lex_state = 27},
  [3460] = {.lex_state = 92, .external_lex_state = 27},
  [3461] = {.lex_state = 92, .external_lex_state = 27},
  [3462] = {.lex_state = 88, .external_lex_state = 24},
  [3463] = {.lex_state = 92, .external_lex_state = 30},
  [3464] = {.lex_state = 92, .external_lex_state = 27},
  [3465] = {.lex_state = 92, .external_lex_state = 27},
  [3466] = {.lex_state = 92, .external_lex_state = 27},
  [3467] = {.lex_state = 92, .external_lex_state = 30},
  [3468] = {.lex_state = 222, .external_lex_state = 27},
  [3469] = {.lex_state = 88, .external_lex_state = 22},
  [3470] = {.lex_state = 88, .external_lex_state = 22},
  [3471] = {.lex_state = 222, .external_lex_state = 27},
  [3472] = {.lex_state = 92, .external_lex_state = 30},
  [3473] = {.lex_state = 88, .external_lex_state = 24},
  [3474] = {.lex_state = 88, .external_lex_state = 24},
  [3475] = {.lex_state = 88, .external_lex_state = 24},
  [3476] = {.lex_state = 88, .external_lex_state = 24},
  [3477] = {.lex_state = 222, .external_lex_state = 27},
  [3478] = {.lex_state = 88, .external_lex_state = 24},
  [3479] = {.lex_state = 88, .external_lex_state = 24},
  [3480] = {.lex_state = 93, .external_lex_state = 29},
  [3481] = {.lex_state = 92, .external_lex_state = 27},
  [3482] = {.lex_state = 89, .external_lex_state = 28},
  [3483] = {.lex_state = 88, .external_lex_state = 24},
  [3484] = {.lex_state = 92, .external_lex_state = 27},
  [3485] = {.lex_state = 92, .external_lex_state = 27},
  [3486] = {.lex_state = 88, .external_lex_state = 22},
  [3487] = {.lex_state = 88, .external_lex_state = 24},
  [3488] = {.lex_state = 92, .external_lex_state = 27},
  [3489] = {.lex_state = 88, .external_lex_state = 24},
  [3490] = {.lex_state = 89, .external_lex_state = 28},
  [3491] = {.lex_state = 92, .external_lex_state = 27},
  [3492] = {.lex_state = 88, .external_lex_state = 22},
  [3493] = {.lex_state = 88, .external_lex_state = 22},
  [3494] = {.lex_state = 88, .external_lex_state = 22},
  [3495] = {.lex_state = 88, .external_lex_state = 22},
  [3496] = {.lex_state = 92, .external_lex_state = 27},
  [3497] = {.lex_state = 88, .external_lex_state = 22},
  [3498] = {.lex_state = 88, .external_lex_state = 22},
  [3499] = {.lex_state = 92, .external_lex_state = 27},
  [3500] = {.lex_state = 92, .external_lex_state = 27},
  [3501] = {.lex_state = 89, .external_lex_state = 28},
  [3502] = {.lex_state = 88, .external_lex_state = 22},
  [3503] = {.lex_state = 88, .external_lex_state = 22},
  [3504] = {.lex_state = 88, .external_lex_state = 22},
  [3505] = {.lex_state = 88, .external_lex_state = 22},
  [3506] = {.lex_state = 88, .external_lex_state = 22},
  [3507] = {.lex_state = 88, .external_lex_state = 24},
  [3508] = {.lex_state = 92, .external_lex_state = 27},
  [3509] = {.lex_state = 92, .external_lex_state = 27},
  [3510] = {.lex_state = 88, .external_lex_state = 22},
  [3511] = {.lex_state = 92, .external_lex_state = 27},
  [3512] = {.lex_state = 88, .external_lex_state = 22},
  [3513] = {.lex_state = 88, .external_lex_state = 22},
  [3514] = {.lex_state = 88, .external_lex_state = 22},
  [3515] = {.lex_state = 222, .external_lex_state = 27},
  [3516] = {.lex_state = 92, .external_lex_state = 27},
  [3517] = {.lex_state = 88, .external_lex_state = 24},
  [3518] = {.lex_state = 92, .external_lex_state = 27},
  [3519] = {.lex_state = 88, .external_lex_state = 22},
  [3520] = {.lex_state = 92, .external_lex_state = 27},
  [3521] = {.lex_state = 89, .external_lex_state = 24},
  [3522] = {.lex_state = 89, .external_lex_state = 24},
  [3523] = {.lex_state = 92, .external_lex_state = 27},
  [3524] = {.lex_state = 92, .external_lex_state = 27},
  [3525] = {.lex_state = 92, .external_lex_state = 27},
  [3526] = {.lex_state = 92, .external_lex_state = 27},
  [3527] = {.lex_state = 92, .external_lex_state = 27},
  [3528] = {.lex_state = 88, .external_lex_state = 22},
  [3529] = {.lex_state = 92, .external_lex_state = 27},
  [3530] = {.lex_state = 92, .external_lex_state = 27},
  [3531] = {.lex_state = 88, .external_lex_state = 22},
  [3532] = {.lex_state = 88, .external_lex_state = 22},
  [3533] = {.lex_state = 88, .external_lex_state = 22},
  [3534] = {.lex_state = 92, .external_lex_state = 27},
  [3535] = {.lex_state = 88, .external_lex_state = 22},
  [3536] = {.lex_state = 92, .external_lex_state = 27},
  [3537] = {.lex_state = 92, .external_lex_state = 27},
  [3538] = {.lex_state = 88, .external_lex_state = 22},
  [3539] = {.lex_state = 92, .external_lex_state = 27},
  [3540] = {.lex_state = 88, .external_lex_state = 22},
  [3541] = {.lex_state = 92, .external_lex_state = 27},
  [3542] = {.lex_state = 88, .external_lex_state = 22},
  [3543] = {.lex_state = 92, .external_lex_state = 27},
  [3544] = {.lex_state = 88, .external_lex_state = 22},
  [3545] = {.lex_state = 92, .external_lex_state = 27},
  [3546] = {.lex_state = 88, .external_lex_state = 22},
  [3547] = {.lex_state = 88, .external_lex_state = 24},
  [3548] = {.lex_state = 88, .external_lex_state = 22},
  [3549] = {.lex_state = 88, .external_lex_state = 24},
  [3550] = {.lex_state = 92, .external_lex_state = 30},
  [3551] = {.lex_state = 92, .external_lex_state = 30},
  [3552] = {.lex_state = 92, .external_lex_state = 27},
  [3553] = {.lex_state = 88, .external_lex_state = 22},
  [3554] = {.lex_state = 88, .external_lex_state = 22},
  [3555] = {.lex_state = 88, .external_lex_state = 24},
  [3556] = {.lex_state = 88, .external_lex_state = 22},
  [3557] = {.lex_state = 88, .external_lex_state = 24},
  [3558] = {.lex_state = 88, .external_lex_state = 22},
  [3559] = {.lex_state = 92, .external_lex_state = 30},
  [3560] = {.lex_state = 92, .external_lex_state = 30},
  [3561] = {.lex_state = 92, .external_lex_state = 27},
  [3562] = {.lex_state = 92, .external_lex_state = 30},
  [3563] = {.lex_state = 92, .external_lex_state = 27},
  [3564] = {.lex_state = 88, .external_lex_state = 22},
  [3565] = {.lex_state = 88, .external_lex_state = 22},
  [3566] = {.lex_state = 88, .external_lex_state = 22},
  [3567] = {.lex_state = 88, .external_lex_state = 22},
  [3568] = {.lex_state = 88, .external_lex_state = 22},
  [3569] = {.lex_state = 88, .external_lex_state = 22},
  [3570] = {.lex_state = 92, .external_lex_state = 27},
  [3571] = {.lex_state = 92, .external_lex_state = 27},
  [3572] = {.lex_state = 92, .external_lex_state = 30},
  [3573] = {.lex_state = 88, .external_lex_state = 22},
  [3574] = {.lex_state = 88, .external_lex_state = 22},
  [3575] = {.lex_state = 88, .external_lex_state = 22},
  [3576] = {.lex_state = 88, .external_lex_state = 22},
  [3577] = {.lex_state = 88, .external_lex_state = 22},
  [3578] = {.lex_state = 88, .external_lex_state = 24},
  [3579] = {.lex_state = 92, .external_lex_state = 30},
  [3580] = {.lex_state = 92, .external_lex_state = 27},
  [3581] = {.lex_state = 88, .external_lex_state = 22},
  [3582] = {.lex_state = 92, .external_lex_state = 30},
  [3583] = {.lex_state = 92, .external_lex_state = 27},
  [3584] = {.lex_state = 88, .external_lex_state = 22},
  [3585] = {.lex_state = 92, .external_lex_state = 30},
  [3586] = {.lex_state = 88, .external_lex_state = 22},
  [3587] = {.lex_state = 92, .external_lex_state = 27},
  [3588] = {.lex_state = 92, .external_lex_state = 30},
  [3589] = {.lex_state = 88, .external_lex_state = 22},
  [3590] = {.lex_state = 88, .external_lex_state = 22},
  [3591] = {.lex_state = 92, .external_lex_state = 27},
  [3592] = {.lex_state = 88, .external_lex_state = 22},
  [3593] = {.lex_state = 88, .external_lex_state = 22},
  [3594] = {.lex_state = 92, .external_lex_state = 30},
  [3595] = {.lex_state = 88, .external_lex_state = 22},
  [3596] = {.lex_state = 92, .external_lex_state = 27},
  [3597] = {.lex_state = 88, .external_lex_state = 22},
  [3598] = {.lex_state = 92, .external_lex_state = 30},
  [3599] = {.lex_state = 88, .external_lex_state = 24},
  [3600] = {.lex_state = 88, .external_lex_state = 28},
  [3601] = {.lex_state = 88, .external_lex_state = 22},
  [3602] = {.lex_state = 88, .external_lex_state = 22},
  [3603] = {.lex_state = 92, .external_lex_state = 27},
  [3604] = {.lex_state = 92, .external_lex_state = 27},
  [3605] = {.lex_state = 88, .external_lex_state = 22},
  [3606] = {.lex_state = 88, .external_lex_state = 22},
  [3607] = {.lex_state = 88, .external_lex_state = 22},
  [3608] = {.lex_state = 88, .external_lex_state = 22},
  [3609] = {.lex_state = 88, .external_lex_state = 24},
  [3610] = {.lex_state = 92, .external_lex_state = 30},
  [3611] = {.lex_state = 88, .external_lex_state = 24},
  [3612] = {.lex_state = 88, .external_lex_state = 24},
  [3613] = {.lex_state = 92, .external_lex_state = 30},
  [3614] = {.lex_state = 89, .external_lex_state = 24},
  [3615] = {.lex_state = 88, .external_lex_state = 24},
  [3616] = {.lex_state = 89, .external_lex_state = 24},
  [3617] = {.lex_state = 92, .external_lex_state = 30},
  [3618] = {.lex_state = 88, .external_lex_state = 22},
  [3619] = {.lex_state = 92, .external_lex_state = 30},
  [3620] = {.lex_state = 88, .external_lex_state = 22},
  [3621] = {.lex_state = 88, .external_lex_state = 24},
  [3622] = {.lex_state = 88, .external_lex_state = 22},
  [3623] = {.lex_state = 88, .external_lex_state = 22},
  [3624] = {.lex_state = 89, .external_lex_state = 24},
  [3625] = {.lex_state = 92, .external_lex_state = 30},
  [3626] = {.lex_state = 92, .external_lex_state = 30},
  [3627] = {.lex_state = 92, .external_lex_state = 30},
  [3628] = {.lex_state = 115, .external_lex_state = 31},
  [3629] = {.lex_state = 92, .external_lex_state = 30},
  [3630] = {.lex_state = 92, .external_lex_state = 27},
  [3631] = {.lex_state = 92, .external_lex_state = 27},
  [3632] = {.lex_state = 88, .external_lex_state = 22},
  [3633] = {.lex_state = 88, .external_lex_state = 22},
  [3634] = {.lex_state = 92, .external_lex_state = 30},
  [3635] = {.lex_state = 92, .external_lex_state = 30},
  [3636] = {.lex_state = 92, .external_lex_state = 30},
  [3637] = {.lex_state = 92, .external_lex_state = 30},
  [3638] = {.lex_state = 92, .external_lex_state = 30},
  [3639] = {.lex_state = 92, .external_lex_state = 30},
  [3640] = {.lex_state = 92, .external_lex_state = 30},
  [3641] = {.lex_state = 92, .external_lex_state = 30},
  [3642] = {.lex_state = 92, .external_lex_state = 30},
  [3643] = {.lex_state = 88, .external_lex_state = 24},
  [3644] = {.lex_state = 92, .external_lex_state = 30},
  [3645] = {.lex_state = 88, .external_lex_state = 22},
  [3646] = {.lex_state = 92, .external_lex_state = 30},
  [3647] = {.lex_state = 92, .external_lex_state = 30},
  [3648] = {.lex_state = 92, .external_lex_state = 30},
  [3649] = {.lex_state = 92, .external_lex_state = 30},
  [3650] = {.lex_state = 88, .external_lex_state = 22},
  [3651] = {.lex_state = 92, .external_lex_state = 30},
  [3652] = {.lex_state = 88, .external_lex_state = 22},
  [3653] = {.lex_state = 88, .external_lex_state = 24},
  [3654] = {.lex_state = 92, .external_lex_state = 30},
  [3655] = {.lex_state = 92, .external_lex_state = 30},
  [3656] = {.lex_state = 92, .external_lex_state = 30},
  [3657] = {.lex_state = 88, .external_lex_state = 24},
  [3658] = {.lex_state = 92, .external_lex_state = 30},
  [3659] = {.lex_state = 92, .external_lex_state = 30},
  [3660] = {.lex_state = 92, .external_lex_state = 27},
  [3661] = {.lex_state = 115, .external_lex_state = 31},
  [3662] = {.lex_state = 88, .external_lex_state = 24},
  [3663] = {.lex_state = 92, .external_lex_state = 27},
  [3664] = {.lex_state = 92, .external_lex_state = 27},
  [3665] = {.lex_state = 88, .external_lex_state = 22},
  [3666] = {.lex_state = 92, .external_lex_state = 30},
  [3667] = {.lex_state = 92, .external_lex_state = 30},
  [3668] = {.lex_state = 92, .external_lex_state = 30},
  [3669] = {.lex_state = 88, .external_lex_state = 22},
  [3670] = {.lex_state = 92, .external_lex_state = 30},
  [3671] = {.lex_state = 88, .external_lex_state = 24},
  [3672] = {.lex_state = 88, .external_lex_state = 24},
  [3673] = {.lex_state = 92, .external_lex_state = 27},
  [3674] = {.lex_state = 88, .external_lex_state = 24},
  [3675] = {.lex_state = 92, .external_lex_state = 30},
  [3676] = {.lex_state = 88, .external_lex_state = 24},
  [3677] = {.lex_state = 92, .external_lex_state = 30},
  [3678] = {.lex_state = 89, .external_lex_state = 24},
  [3679] = {.lex_state = 88, .external_lex_state = 24},
  [3680] = {.lex_state = 92, .external_lex_state = 30},
  [3681] = {.lex_state = 92, .external_lex_state = 27},
  [3682] = {.lex_state = 92, .external_lex_state = 30},
  [3683] = {.lex_state = 88, .external_lex_state = 24},
  [3684] = {.lex_state = 92, .external_lex_state = 30},
  [3685] = {.lex_state = 92, .external_lex_state = 30},
  [3686] = {.lex_state = 88, .external_lex_state = 24},
  [3687] = {.lex_state = 92, .external_lex_state = 27},
  [3688] = {.lex_state = 92, .external_lex_state = 30},
  [3689] = {.lex_state = 92, .external_lex_state = 27},
  [3690] = {.lex_state = 92, .external_lex_state = 27},
  [3691] = {.lex_state = 88, .external_lex_state = 24},
  [3692] = {.lex_state = 88, .external_lex_state = 24},
  [3693] = {.lex_state = 92, .external_lex_state = 30},
  [3694] = {.lex_state = 88, .external_lex_state = 24},
  [3695] = {.lex_state = 88, .external_lex_state = 24},
  [3696] = {.lex_state = 92, .external_lex_state = 30},
  [3697] = {.lex_state = 92, .external_lex_state = 30},
  [3698] = {.lex_state = 92, .external_lex_state = 30},
  [3699] = {.lex_state = 88, .external_lex_state = 24},
  [3700] = {.lex_state = 88, .external_lex_state = 24},
  [3701] = {.lex_state = 88, .external_lex_state = 24},
  [3702] = {.lex_state = 92, .external_lex_state = 30},
  [3703] = {.lex_state = 92, .external_lex_state = 30},
  [3704] = {.lex_state = 92, .external_lex_state = 30},
  [3705] = {.lex_state = 92, .external_lex_state = 30},
  [3706] = {.lex_state = 88, .external_lex_state = 24},
  [3707] = {.lex_state = 88, .external_lex_state = 22},
  [3708] = {.lex_state = 92, .external_lex_state = 30},
  [3709] = {.lex_state = 89, .external_lex_state = 24},
  [3710] = {.lex_state = 92, .external_lex_state = 27},
  [3711] = {.lex_state = 92, .external_lex_state = 30},
  [3712] = {.lex_state = 92, .external_lex_state = 30},
  [3713] = {.lex_state = 88, .external_lex_state = 24},
  [3714] = {.lex_state = 92, .external_lex_state = 30},
  [3715] = {.lex_state = 92, .external_lex_state = 30},
  [3716] = {.lex_state = 92, .external_lex_state = 30},
  [3717] = {.lex_state = 92, .external_lex_state = 27},
  [3718] = {.lex_state = 89, .external_lex_state = 24},
  [3719] = {.lex_state = 88, .external_lex_state = 22},
  [3720] = {.lex_state = 92, .external_lex_state = 27},
  [3721] = {.lex_state = 92, .external_lex_state = 27},
  [3722] = {.lex_state = 88, .external_lex_state = 22},
  [3723] = {.lex_state = 92, .external_lex_state = 27},
  [3724] = {.lex_state = 92, .external_lex_state = 27},
  [3725] = {.lex_state = 89, .external_lex_state = 24},
  [3726] = {.lex_state = 92, .external_lex_state = 30},
  [3727] = {.lex_state = 88, .external_lex_state = 22},
  [3728] = {.lex_state = 88, .external_lex_state = 22},
  [3729] = {.lex_state = 92, .external_lex_state = 27},
  [3730] = {.lex_state = 92, .external_lex_state = 27},
  [3731] = {.lex_state = 92, .external_lex_state = 27},
  [3732] = {.lex_state = 88, .external_lex_state = 22},
  [3733] = {.lex_state = 92, .external_lex_state = 27},
  [3734] = {.lex_state = 92, .external_lex_state = 27},
  [3735] = {.lex_state = 92, .external_lex_state = 27},
  [3736] = {.lex_state = 92, .external_lex_state = 27},
  [3737] = {.lex_state = 92, .external_lex_state = 27},
  [3738] = {.lex_state = 88, .external_lex_state = 22},
  [3739] = {.lex_state = 92, .external_lex_state = 27},
  [3740] = {.lex_state = 92, .external_lex_state = 27},
  [3741] = {.lex_state = 88, .external_lex_state = 24},
  [3742] = {.lex_state = 92, .external_lex_state = 27},
  [3743] = {.lex_state = 92, .external_lex_state = 27},
  [3744] = {.lex_state = 92, .external_lex_state = 27},
  [3745] = {.lex_state = 92, .external_lex_state = 27},
  [3746] = {.lex_state = 92, .external_lex_state = 30},
  [3747] = {.lex_state = 92, .external_lex_state = 30},
  [3748] = {.lex_state = 89, .external_lex_state = 28},
  [3749] = {.lex_state = 92, .external_lex_state = 30},
  [3750] = {.lex_state = 92, .external_lex_state = 30},
  [3751] = {.lex_state = 89, .external_lex_state = 28},
  [3752] = {.lex_state = 92, .external_lex_state = 30},
  [3753] = {.lex_state = 92, .external_lex_state = 30},
  [3754] = {.lex_state = 88, .external_lex_state = 24},
  [3755] = {.lex_state = 88, .external_lex_state = 22},
  [3756] = {.lex_state = 88, .external_lex_state = 22},
  [3757] = {.lex_state = 88, .external_lex_state = 22},
  [3758] = {.lex_state = 89, .external_lex_state = 24},
  [3759] = {.lex_state = 88, .external_lex_state = 24},
  [3760] = {.lex_state = 88, .external_lex_state = 24},
  [3761] = {.lex_state = 89, .external_lex_state = 24},
  [3762] = {.lex_state = 92, .external_lex_state = 30},
  [3763] = {.lex_state = 88, .external_lex_state = 22},
  [3764] = {.lex_state = 88, .external_lex_state = 22},
  [3765] = {.lex_state = 92, .external_lex_state = 30},
  [3766] = {.lex_state = 92, .external_lex_state = 30},
  [3767] = {.lex_state = 92, .external_lex_state = 30},
  [3768] = {.lex_state = 88, .external_lex_state = 24},
  [3769] = {.lex_state = 89, .external_lex_state = 24},
  [3770] = {.lex_state = 88, .external_lex_state = 24},
  [3771] = {.lex_state = 88, .external_lex_state = 24},
  [3772] = {.lex_state = 92, .external_lex_state = 30},
  [3773] = {.lex_state = 88, .external_lex_state = 22},
  [3774] = {.lex_state = 89, .external_lex_state = 24},
  [3775] = {.lex_state = 89, .external_lex_state = 24},
  [3776] = {.lex_state = 89, .external_lex_state = 24},
  [3777] = {.lex_state = 92, .external_lex_state = 30},
  [3778] = {.lex_state = 88, .external_lex_state = 24},
  [3779] = {.lex_state = 92, .external_lex_state = 30},
  [3780] = {.lex_state = 92, .external_lex_state = 30},
  [3781] = {.lex_state = 92, .external_lex_state = 30},
  [3782] = {.lex_state = 92, .external_lex_state = 30},
  [3783] = {.lex_state = 92, .external_lex_state = 30},
  [3784] = {.lex_state = 88, .external_lex_state = 22},
  [3785] = {.lex_state = 92, .external_lex_state = 27},
  [3786] = {.lex_state = 88, .external_lex_state = 22},
  [3787] = {.lex_state = 89, .external_lex_state = 24},
  [3788] = {.lex_state = 92, .external_lex_state = 30},
  [3789] = {.lex_state = 92, .external_lex_state = 30},
  [3790] = {.lex_state = 88, .external_lex_state = 22},
  [3791] = {.lex_state = 89, .external_lex_state = 24},
  [3792] = {.lex_state = 92, .external_lex_state = 27},
  [3793] = {.lex_state = 88, .external_lex_state = 24},
  [3794] = {.lex_state = 88, .external_lex_state = 22},
  [3795] = {.lex_state = 92, .external_lex_state = 30},
  [3796] = {.lex_state = 88, .external_lex_state = 22},
  [3797] = {.lex_state = 89, .external_lex_state = 24},
  [3798] = {.lex_state = 89, .external_lex_state = 24},
  [3799] = {.lex_state = 88, .external_lex_state = 22},
  [3800] = {.lex_state = 88, .external_lex_state = 22},
  [3801] = {.lex_state = 88, .external_lex_state = 24},
  [3802] = {.lex_state = 88, .external_lex_state = 22},
  [3803] = {.lex_state = 92, .external_lex_state = 30},
  [3804] = {.lex_state = 88, .external_lex_state = 24},
  [3805] = {.lex_state = 88, .external_lex_state = 24},
  [3806] = {.lex_state = 89, .external_lex_state = 24},
  [3807] = {.lex_state = 88, .external_lex_state = 24},
  [3808] = {.lex_state = 88, .external_lex_state = 24},
  [3809] = {.lex_state = 88, .external_lex_state = 24},
  [3810] = {.lex_state = 89, .external_lex_state = 24},
  [3811] = {.lex_state = 89, .external_lex_state = 24},
  [3812] = {.lex_state = 92, .external_lex_state = 30},
  [3813] = {.lex_state = 88, .external_lex_state = 24},
  [3814] = {.lex_state = 89, .external_lex_state = 24},
  [3815] = {.lex_state = 88, .external_lex_state = 22},
  [3816] = {.lex_state = 92, .external_lex_state = 30},
  [3817] = {.lex_state = 89, .external_lex_state = 24},
  [3818] = {.lex_state = 92, .external_lex_state = 30},
  [3819] = {.lex_state = 92, .external_lex_state = 30},
  [3820] = {.lex_state = 92, .external_lex_state = 30},
  [3821] = {.lex_state = 88, .external_lex_state = 24},
  [3822] = {.lex_state = 89, .external_lex_state = 24},
  [3823] = {.lex_state = 88, .external_lex_state = 22},
  [3824] = {.lex_state = 92, .external_lex_state = 30},
  [3825] = {.lex_state = 92, .external_lex_state = 30},
  [3826] = {.lex_state = 88, .external_lex_state = 24},
  [3827] = {.lex_state = 92, .external_lex_state = 30},
  [3828] = {.lex_state = 88, .external_lex_state = 24},
  [3829] = {.lex_state = 88, .external_lex_state = 22},
  [3830] = {.lex_state = 88, .external_lex_state = 24},
  [3831] = {.lex_state = 88, .external_lex_state = 24},
  [3832] = {.lex_state = 92, .external_lex_state = 27},
  [3833] = {.lex_state = 89, .external_lex_state = 24},
  [3834] = {.lex_state = 88, .external_lex_state = 24},
  [3835] = {.lex_state = 92, .external_lex_state = 27},
  [3836] = {.lex_state = 88, .external_lex_state = 22},
  [3837] = {.lex_state = 89, .external_lex_state = 24},
  [3838] = {.lex_state = 92, .external_lex_state = 30},
  [3839] = {.lex_state = 89, .external_lex_state = 24},
  [3840] = {.lex_state = 89, .external_lex_state = 24},
  [3841] = {.lex_state = 88, .external_lex_state = 22},
  [3842] = {.lex_state = 88, .external_lex_state = 24},
  [3843] = {.lex_state = 88, .external_lex_state = 24},
  [3844] = {.lex_state = 89, .external_lex_state = 24},
  [3845] = {.lex_state = 89, .external_lex_state = 24},
  [3846] = {.lex_state = 89, .external_lex_state = 24},
  [3847] = {.lex_state = 88, .external_lex_state = 22},
  [3848] = {.lex_state = 89, .external_lex_state = 24},
  [3849] = {.lex_state = 92, .external_lex_state = 30},
  [3850] = {.lex_state = 89, .external_lex_state = 24},
  [3851] = {.lex_state = 89, .external_lex_state = 24},
  [3852] = {.lex_state = 92, .external_lex_state = 30},
  [3853] = {.lex_state = 89, .external_lex_state = 24},
  [3854] = {.lex_state = 89, .external_lex_state = 24},
  [3855] = {.lex_state = 88, .external_lex_state = 22},
  [3856] = {.lex_state = 92, .external_lex_state = 30},
  [3857] = {.lex_state = 88, .external_lex_state = 22},
  [3858] = {.lex_state = 89, .external_lex_state = 24},
  [3859] = {.lex_state = 92, .external_lex_state = 30},
  [3860] = {.lex_state = 88, .external_lex_state = 24},
  [3861] = {.lex_state = 92, .external_lex_state = 30},
  [3862] = {.lex_state = 92, .external_lex_state = 30},
  [3863] = {.lex_state = 92, .external_lex_state = 30},
  [3864] = {.lex_state = 89, .external_lex_state = 24},
  [3865] = {.lex_state = 92, .external_lex_state = 30},
  [3866] = {.lex_state = 92, .external_lex_state = 30},
  [3867] = {.lex_state = 92, .external_lex_state = 30},
  [3868] = {.lex_state = 92, .external_lex_state = 30},
  [3869] = {.lex_state = 92, .external_lex_state = 30},
  [3870] = {.lex_state = 92, .external_lex_state = 30},
  [3871] = {.lex_state = 92, .external_lex_state = 30},
  [3872] = {.lex_state = 92, .external_lex_state = 30},
  [3873] = {.lex_state = 89, .external_lex_state = 24},
  [3874] = {.lex_state = 92, .external_lex_state = 30},
  [3875] = {.lex_state = 92, .external_lex_state = 30},
  [3876] = {.lex_state = 92, .external_lex_state = 30},
  [3877] = {.lex_state = 92, .external_lex_state = 30},
  [3878] = {.lex_state = 92, .external_lex_state = 30},
  [3879] = {.lex_state = 88, .external_lex_state = 22},
  [3880] = {.lex_state = 92, .external_lex_state = 27},
  [3881] = {.lex_state = 92, .external_lex_state = 30},
  [3882] = {.lex_state = 88, .external_lex_state = 22},
  [3883] = {.lex_state = 92, .external_lex_state = 30},
  [3884] = {.lex_state = 92, .external_lex_state = 30},
  [3885] = {.lex_state = 92, .external_lex_state = 27},
  [3886] = {.lex_state = 89, .external_lex_state = 24},
  [3887] = {.lex_state = 92, .external_lex_state = 30},
  [3888] = {.lex_state = 92, .external_lex_state = 30},
  [3889] = {.lex_state = 92, .external_lex_state = 30},
  [3890] = {.lex_state = 92, .external_lex_state = 27},
  [3891] = {.lex_state = 89, .external_lex_state = 24},
  [3892] = {.lex_state = 89, .external_lex_state = 24},
  [3893] = {.lex_state = 92, .external_lex_state = 27},
  [3894] = {.lex_state = 92, .external_lex_state = 27},
  [3895] = {.lex_state = 89, .external_lex_state = 24},
  [3896] = {.lex_state = 89, .external_lex_state = 24},
  [3897] = {.lex_state = 89, .external_lex_state = 24},
  [3898] = {.lex_state = 92, .external_lex_state = 27},
  [3899] = {.lex_state = 92, .external_lex_state = 30},
  [3900] = {.lex_state = 92, .external_lex_state = 27},
  [3901] = {.lex_state = 92, .external_lex_state = 27},
  [3902] = {.lex_state = 89, .external_lex_state = 24},
  [3903] = {.lex_state = 89, .external_lex_state = 24},
  [3904] = {.lex_state = 89, .external_lex_state = 24},
  [3905] = {.lex_state = 92, .external_lex_state = 30},
  [3906] = {.lex_state = 89, .external_lex_state = 24},
  [3907] = {.lex_state = 92, .external_lex_state = 27},
  [3908] = {.lex_state = 92, .external_lex_state = 30},
  [3909] = {.lex_state = 89, .external_lex_state = 24},
  [3910] = {.lex_state = 89, .external_lex_state = 24},
  [3911] = {.lex_state = 89, .external_lex_state = 24},
  [3912] = {.lex_state = 89, .external_lex_state = 24},
  [3913] = {.lex_state = 89, .external_lex_state = 24},
  [3914] = {.lex_state = 92, .external_lex_state = 27},
  [3915] = {.lex_state = 89, .external_lex_state = 24},
  [3916] = {.lex_state = 89, .external_lex_state = 24},
  [3917] = {.lex_state = 89, .external_lex_state = 24},
  [3918] = {.lex_state = 89, .external_lex_state = 24},
  [3919] = {.lex_state = 89, .external_lex_state = 24},
  [3920] = {.lex_state = 89, .external_lex_state = 24},
  [3921] = {.lex_state = 92, .external_lex_state = 30},
  [3922] = {.lex_state = 89, .external_lex_state = 24},
  [3923] = {.lex_state = 89, .external_lex_state = 24},
  [3924] = {.lex_state = 92, .external_lex_state = 30},
  [3925] = {.lex_state = 89, .external_lex_state = 24},
  [3926] = {.lex_state = 92, .external_lex_state = 27},
  [3927] = {.lex_state = 89, .external_lex_state = 24},
  [3928] = {.lex_state = 92, .external_lex_state = 27},
  [3929] = {.lex_state = 89, .external_lex_state = 24},
  [3930] = {.lex_state = 89, .external_lex_state = 24},
  [3931] = {.lex_state = 89, .external_lex_state = 24},
  [3932] = {.lex_state = 89, .external_lex_state = 24},
  [3933] = {.lex_state = 89, .external_lex_state = 24},
  [3934] = {.lex_state = 89, .external_lex_state = 24},
  [3935] = {.lex_state = 92, .external_lex_state = 30},
  [3936] = {.lex_state = 89, .external_lex_state = 24},
  [3937] = {.lex_state = 89, .external_lex_state = 24},
  [3938] = {.lex_state = 92, .external_lex_state = 30},
  [3939] = {.lex_state = 89, .external_lex_state = 24},
  [3940] = {.lex_state = 89, .external_lex_state = 24},
  [3941] = {.lex_state = 92, .external_lex_state = 27},
  [3942] = {.lex_state = 89, .external_lex_state = 24},
  [3943] = {.lex_state = 89, .external_lex_state = 24},
  [3944] = {.lex_state = 92, .external_lex_state = 27},
  [3945] = {.lex_state = 89, .external_lex_state = 24},
  [3946] = {.lex_state = 89, .external_lex_state = 24},
  [3947] = {.lex_state = 89, .external_lex_state = 24},
  [3948] = {.lex_state = 92, .external_lex_state = 30},
  [3949] = {.lex_state = 92, .external_lex_state = 27},
  [3950] = {.lex_state = 92, .external_lex_state = 27},
  [3951] = {.lex_state = 92, .external_lex_state = 30},
  [3952] = {.lex_state = 89, .external_lex_state = 24},
  [3953] = {.lex_state = 92, .external_lex_state = 27},
  [3954] = {.lex_state = 92, .external_lex_state = 27},
  [3955] = {.lex_state = 89, .external_lex_state = 24},
  [3956] = {.lex_state = 92, .external_lex_state = 27},
  [3957] = {.lex_state = 92, .external_lex_state = 27},
  [3958] = {.lex_state = 92, .external_lex_state = 27},
  [3959] = {.lex_state = 92, .external_lex_state = 27},
  [3960] = {.lex_state = 89, .external_lex_state = 24},
  [3961] = {.lex_state = 89, .external_lex_state = 24},
  [3962] = {.lex_state = 89, .external_lex_state = 24},
  [3963] = {.lex_state = 92, .external_lex_state = 27},
  [3964] = {.lex_state = 89, .external_lex_state = 24},
  [3965] = {.lex_state = 92, .external_lex_state = 27},
  [3966] = {.lex_state = 92, .external_lex_state = 27},
  [3967] = {.lex_state = 92, .external_lex_state = 27},
  [3968] = {.lex_state = 92, .external_lex_state = 27},
  [3969] = {.lex_state = 92, .external_lex_state = 27},
  [3970] = {.lex_state = 92, .external_lex_state = 27},
  [3971] = {.lex_state = 89, .external_lex_state = 24},
  [3972] = {.lex_state = 92, .external_lex_state = 30},
  [3973] = {.lex_state = 92, .external_lex_state = 27},
  [3974] = {.lex_state = 92, .external_lex_state = 27},
  [3975] = {.lex_state = 92, .external_lex_state = 27},
  [3976] = {.lex_state = 92, .external_lex_state = 27},
  [3977] = {.lex_state = 92, .external_lex_state = 27},
  [3978] = {.lex_state = 92, .external_lex_state = 27},
  [3979] = {.lex_state = 92, .external_lex_state = 27},
  [3980] = {.lex_state = 92, .external_lex_state = 27},
  [3981] = {.lex_state = 92, .external_lex_state = 30},
  [3982] = {.lex_state = 92, .external_lex_state = 27},
  [3983] = {.lex_state = 92, .external_lex_state = 30},
  [3984] = {.lex_state = 92, .external_lex_state = 30},
  [3985] = {.lex_state = 92, .external_lex_state = 30},
  [3986] = {.lex_state = 89, .external_lex_state = 24},
  [3987] = {.lex_state = 92, .external_lex_state = 30},
  [3988] = {.lex_state = 89, .external_lex_state = 24},
  [3989] = {.lex_state = 92, .external_lex_state = 30},
  [3990] = {.lex_state = 92, .external_lex_state = 30},
  [3991] = {.lex_state = 92, .external_lex_state = 27},
  [3992] = {.lex_state = 92, .external_lex_state = 27},
  [3993] = {.lex_state = 89, .external_lex_state = 24},
  [3994] = {.lex_state = 92, .external_lex_state = 30},
  [3995] = {.lex_state = 89, .external_lex_state = 24},
  [3996] = {.lex_state = 92, .external_lex_state = 30},
  [3997] = {.lex_state = 92, .external_lex_state = 27},
  [3998] = {.lex_state = 89, .external_lex_state = 24},
  [3999] = {.lex_state = 92, .external_lex_state = 30},
  [4000] = {.lex_state = 92, .external_lex_state = 27},
  [4001] = {.lex_state = 89, .external_lex_state = 24},
  [4002] = {.lex_state = 92, .external_lex_state = 27},
  [4003] = {.lex_state = 89, .external_lex_state = 24},
  [4004] = {.lex_state = 89, .external_lex_state = 24},
  [4005] = {.lex_state = 92, .external_lex_state = 27},
  [4006] = {.lex_state = 92, .external_lex_state = 27},
  [4007] = {.lex_state = 92, .external_lex_state = 27},
  [4008] = {.lex_state = 92, .external_lex_state = 27},
  [4009] = {.lex_state = 92, .external_lex_state = 27},
  [4010] = {.lex_state = 92, .external_lex_state = 27},
  [4011] = {.lex_state = 92, .external_lex_state = 27},
  [4012] = {.lex_state = 92, .external_lex_state = 27},
  [4013] = {.lex_state = 92, .external_lex_state = 27},
  [4014] = {.lex_state = 92, .external_lex_state = 27},
  [4015] = {.lex_state = 89, .external_lex_state = 24},
  [4016] = {.lex_state = 89, .external_lex_state = 24},
  [4017] = {.lex_state = 92, .external_lex_state = 27},
  [4018] = {.lex_state = 89, .external_lex_state = 24},
  [4019] = {.lex_state = 92, .external_lex_state = 27},
  [4020] = {.lex_state = 92, .external_lex_state = 27},
  [4021] = {.lex_state = 92, .external_lex_state = 27},
  [4022] = {.lex_state = 89, .external_lex_state = 24},
  [4023] = {.lex_state = 92, .external_lex_state = 27},
  [4024] = {.lex_state = 89, .external_lex_state = 24},
  [4025] = {.lex_state = 89, .external_lex_state = 24},
  [4026] = {.lex_state = 88, .external_lex_state = 24},
  [4027] = {.lex_state = 92, .external_lex_state = 30},
  [4028] = {.lex_state = 92, .external_lex_state = 30},
  [4029] = {.lex_state = 92, .external_lex_state = 30},
  [4030] = {.lex_state = 89, .external_lex_state = 24},
  [4031] = {.lex_state = 92, .external_lex_state = 30},
  [4032] = {.lex_state = 92, .external_lex_state = 30},
  [4033] = {.lex_state = 92, .external_lex_state = 27},
  [4034] = {.lex_state = 92, .external_lex_state = 30},
  [4035] = {.lex_state = 89, .external_lex_state = 24},
  [4036] = {.lex_state = 92, .external_lex_state = 27},
  [4037] = {.lex_state = 89, .external_lex_state = 24},
  [4038] = {.lex_state = 89, .external_lex_state = 24},
  [4039] = {.lex_state = 89, .external_lex_state = 24},
  [4040] = {.lex_state = 92, .external_lex_state = 30},
  [4041] = {.lex_state = 89, .external_lex_state = 24},
  [4042] = {.lex_state = 89, .external_lex_state = 24},
  [4043] = {.lex_state = 89, .external_lex_state = 24},
  [4044] = {.lex_state = 89, .external_lex_state = 24},
  [4045] = {.lex_state = 92, .external_lex_state = 27},
  [4046] = {.lex_state = 92, .external_lex_state = 30},
  [4047] = {.lex_state = 92, .external_lex_state = 27},
  [4048] = {.lex_state = 92, .external_lex_state = 27},
  [4049] = {.lex_state = 92, .external_lex_state = 27},
  [4050] = {.lex_state = 92, .external_lex_state = 27},
  [4051] = {.lex_state = 92, .external_lex_state = 30},
  [4052] = {.lex_state = 92, .external_lex_state = 27},
  [4053] = {.lex_state = 92, .external_lex_state = 27},
  [4054] = {.lex_state = 92, .external_lex_state = 27},
  [4055] = {.lex_state = 92, .external_lex_state = 30},
  [4056] = {.lex_state = 92, .external_lex_state = 27},
  [4057] = {.lex_state = 92, .external_lex_state = 27},
  [4058] = {.lex_state = 92, .external_lex_state = 30},
  [4059] = {.lex_state = 92, .external_lex_state = 30},
  [4060] = {.lex_state = 92, .external_lex_state = 27},
  [4061] = {.lex_state = 92, .external_lex_state = 30},
  [4062] = {.lex_state = 92, .external_lex_state = 27},
  [4063] = {.lex_state = 92, .external_lex_state = 30},
  [4064] = {.lex_state = 92, .external_lex_state = 30},
  [4065] = {.lex_state = 92, .external_lex_state = 30},
  [4066] = {.lex_state = 92, .external_lex_state = 27},
  [4067] = {.lex_state = 92, .external_lex_state = 27},
  [4068] = {.lex_state = 92, .external_lex_state = 30},
  [4069] = {.lex_state = 92, .external_lex_state = 30},
  [4070] = {.lex_state = 92, .external_lex_state = 30},
  [4071] = {.lex_state = 92, .external_lex_state = 30},
  [4072] = {.lex_state = 92, .external_lex_state = 27},
  [4073] = {.lex_state = 92, .external_lex_state = 27},
  [4074] = {.lex_state = 92, .external_lex_state = 27},
  [4075] = {.lex_state = 92, .external_lex_state = 27},
  [4076] = {.lex_state = 92, .external_lex_state = 27},
  [4077] = {.lex_state = 92, .external_lex_state = 30},
  [4078] = {.lex_state = 92, .external_lex_state = 30},
  [4079] = {.lex_state = 92, .external_lex_state = 30},
  [4080] = {.lex_state = 92, .external_lex_state = 27},
  [4081] = {.lex_state = 92, .external_lex_state = 30},
  [4082] = {.lex_state = 92, .external_lex_state = 30},
  [4083] = {.lex_state = 92, .external_lex_state = 30},
  [4084] = {.lex_state = 92, .external_lex_state = 30},
  [4085] = {.lex_state = 92, .external_lex_state = 27},
  [4086] = {.lex_state = 92, .external_lex_state = 30},
  [4087] = {.lex_state = 92, .external_lex_state = 30},
  [4088] = {.lex_state = 92, .external_lex_state = 30},
  [4089] = {.lex_state = 92, .external_lex_state = 27},
  [4090] = {.lex_state = 92, .external_lex_state = 30},
  [4091] = {.lex_state = 92, .external_lex_state = 30},
  [4092] = {.lex_state = 92, .external_lex_state = 30},
  [4093] = {.lex_state = 92, .external_lex_state = 27},
  [4094] = {.lex_state = 92, .external_lex_state = 27},
  [4095] = {.lex_state = 92, .external_lex_state = 30},
  [4096] = {.lex_state = 92, .external_lex_state = 30},
  [4097] = {.lex_state = 92, .external_lex_state = 30},
  [4098] = {.lex_state = 92, .external_lex_state = 30},
  [4099] = {.lex_state = 92, .external_lex_state = 30},
  [4100] = {.lex_state = 92, .external_lex_state = 27},
  [4101] = {.lex_state = 92, .external_lex_state = 27},
  [4102] = {.lex_state = 92, .external_lex_state = 27},
  [4103] = {.lex_state = 92, .external_lex_state = 30},
  [4104] = {.lex_state = 92, .external_lex_state = 27},
  [4105] = {.lex_state = 92, .external_lex_state = 27},
  [4106] = {.lex_state = 92, .external_lex_state = 30},
  [4107] = {.lex_state = 92, .external_lex_state = 30},
  [4108] = {.lex_state = 92, .external_lex_state = 30},
  [4109] = {.lex_state = 92, .external_lex_state = 30},
  [4110] = {.lex_state = 92, .external_lex_state = 30},
  [4111] = {.lex_state = 92, .external_lex_state = 27},
  [4112] = {.lex_state = 92, .external_lex_state = 30},
  [4113] = {.lex_state = 88, .external_lex_state = 24},
  [4114] = {.lex_state = 92, .external_lex_state = 30},
  [4115] = {.lex_state = 92, .external_lex_state = 30},
  [4116] = {.lex_state = 92, .external_lex_state = 30},
  [4117] = {.lex_state = 92, .external_lex_state = 27},
  [4118] = {.lex_state = 92, .external_lex_state = 27},
  [4119] = {.lex_state = 92, .external_lex_state = 27},
  [4120] = {.lex_state = 92, .external_lex_state = 30},
  [4121] = {.lex_state = 92, .external_lex_state = 27},
  [4122] = {.lex_state = 92, .external_lex_state = 27},
  [4123] = {.lex_state = 92, .external_lex_state = 30},
  [4124] = {.lex_state = 92, .external_lex_state = 27},
  [4125] = {.lex_state = 107, .external_lex_state = 32},
  [4126] = {.lex_state = 92, .external_lex_state = 30},
  [4127] = {.lex_state = 92, .external_lex_state = 30},
  [4128] = {.lex_state = 92, .external_lex_state = 27},
  [4129] = {.lex_state = 92, .external_lex_state = 30},
  [4130] = {.lex_state = 92, .external_lex_state = 27},
  [4131] = {.lex_state = 92, .external_lex_state = 30},
  [4132] = {.lex_state = 92, .external_lex_state = 30},
  [4133] = {.lex_state = 92, .external_lex_state = 30},
  [4134] = {.lex_state = 92, .external_lex_state = 27},
  [4135] = {.lex_state = 92, .external_lex_state = 30},
  [4136] = {.lex_state = 92, .external_lex_state = 30},
  [4137] = {.lex_state = 92, .external_lex_state = 30},
  [4138] = {.lex_state = 92, .external_lex_state = 30},
  [4139] = {.lex_state = 92, .external_lex_state = 30},
  [4140] = {.lex_state = 92, .external_lex_state = 27},
  [4141] = {.lex_state = 92, .external_lex_state = 30},
  [4142] = {.lex_state = 92, .external_lex_state = 30},
  [4143] = {.lex_state = 92, .external_lex_state = 30},
  [4144] = {.lex_state = 92, .external_lex_state = 30},
  [4145] = {.lex_state = 92, .external_lex_state = 27},
  [4146] = {.lex_state = 92, .external_lex_state = 30},
  [4147] = {.lex_state = 92, .external_lex_state = 27},
  [4148] = {.lex_state = 104, .external_lex_state = 32},
  [4149] = {.lex_state = 92, .external_lex_state = 30},
  [4150] = {.lex_state = 92, .external_lex_state = 30},
  [4151] = {.lex_state = 92, .external_lex_state = 30},
  [4152] = {.lex_state = 92, .external_lex_state = 27},
  [4153] = {.lex_state = 92, .external_lex_state = 27},
  [4154] = {.lex_state = 92, .external_lex_state = 30},
  [4155] = {.lex_state = 92, .external_lex_state = 30},
  [4156] = {.lex_state = 92, .external_lex_state = 30},
  [4157] = {.lex_state = 92, .external_lex_state = 30},
  [4158] = {.lex_state = 92, .external_lex_state = 30},
  [4159] = {.lex_state = 92, .external_lex_state = 27},
  [4160] = {.lex_state = 92, .external_lex_state = 27},
  [4161] = {.lex_state = 92, .external_lex_state = 30},
  [4162] = {.lex_state = 92, .external_lex_state = 30},
  [4163] = {.lex_state = 92, .external_lex_state = 27},
  [4164] = {.lex_state = 92, .external_lex_state = 30},
  [4165] = {.lex_state = 92, .external_lex_state = 30},
  [4166] = {.lex_state = 92, .external_lex_state = 27},
  [4167] = {.lex_state = 92, .external_lex_state = 30},
  [4168] = {.lex_state = 92, .external_lex_state = 30},
  [4169] = {.lex_state = 92, .external_lex_state = 30},
  [4170] = {.lex_state = 92, .external_lex_state = 30},
  [4171] = {.lex_state = 92, .external_lex_state = 30},
  [4172] = {.lex_state = 92, .external_lex_state = 30},
  [4173] = {.lex_state = 92, .external_lex_state = 30},
  [4174] = {.lex_state = 92, .external_lex_state = 30},
  [4175] = {.lex_state = 92, .external_lex_state = 30},
  [4176] = {.lex_state = 92, .external_lex_state = 30},
  [4177] = {.lex_state = 92, .external_lex_state = 30},
  [4178] = {.lex_state = 92, .external_lex_state = 30},
  [4179] = {.lex_state = 92, .external_lex_state = 30},
  [4180] = {.lex_state = 92, .external_lex_state = 30},
  [4181] = {.lex_state = 92, .external_lex_state = 30},
  [4182] = {.lex_state = 92, .external_lex_state = 30},
  [4183] = {.lex_state = 92, .external_lex_state = 27},
  [4184] = {.lex_state = 92, .external_lex_state = 27},
  [4185] = {.lex_state = 92, .external_lex_state = 30},
  [4186] = {.lex_state = 92, .external_lex_state = 30},
  [4187] = {.lex_state = 92, .external_lex_state = 30},
  [4188] = {.lex_state = 92, .external_lex_state = 27},
  [4189] = {.lex_state = 92, .external_lex_state = 27},
  [4190] = {.lex_state = 92, .external_lex_state = 27},
  [4191] = {.lex_state = 92, .external_lex_state = 27},
  [4192] = {.lex_state = 92, .external_lex_state = 30},
  [4193] = {.lex_state = 92, .external_lex_state = 30},
  [4194] = {.lex_state = 92, .external_lex_state = 30},
  [4195] = {.lex_state = 231, .external_lex_state = 32},
  [4196] = {.lex_state = 92, .external_lex_state = 27},
  [4197] = {.lex_state = 92, .external_lex_state = 27},
  [4198] = {.lex_state = 92, .external_lex_state = 27},
  [4199] = {.lex_state = 92, .external_lex_state = 27},
  [4200] = {.lex_state = 92, .external_lex_state = 27},
  [4201] = {.lex_state = 92, .external_lex_state = 30},
  [4202] = {.lex_state = 92, .external_lex_state = 30},
  [4203] = {.lex_state = 92, .external_lex_state = 30},
  [4204] = {.lex_state = 92, .external_lex_state = 27},
  [4205] = {.lex_state = 92, .external_lex_state = 30},
  [4206] = {.lex_state = 92, .external_lex_state = 30},
  [4207] = {.lex_state = 104, .external_lex_state = 32},
  [4208] = {.lex_state = 92, .external_lex_state = 30},
  [4209] = {.lex_state = 92, .external_lex_state = 30},
  [4210] = {.lex_state = 92, .external_lex_state = 27},
  [4211] = {.lex_state = 92, .external_lex_state = 30},
  [4212] = {.lex_state = 92, .external_lex_state = 30},
  [4213] = {.lex_state = 92, .external_lex_state = 27},
  [4214] = {.lex_state = 92, .external_lex_state = 30},
  [4215] = {.lex_state = 92, .external_lex_state = 30},
  [4216] = {.lex_state = 92, .external_lex_state = 30},
  [4217] = {.lex_state = 92, .external_lex_state = 30},
  [4218] = {.lex_state = 92, .external_lex_state = 30},
  [4219] = {.lex_state = 92, .external_lex_state = 30},
  [4220] = {.lex_state = 92, .external_lex_state = 30},
  [4221] = {.lex_state = 92, .external_lex_state = 30},
  [4222] = {.lex_state = 92, .external_lex_state = 30},
  [4223] = {.lex_state = 92, .external_lex_state = 30},
  [4224] = {.lex_state = 92, .external_lex_state = 30},
  [4225] = {.lex_state = 92, .external_lex_state = 30},
  [4226] = {.lex_state = 92, .external_lex_state = 30},
  [4227] = {.lex_state = 92, .external_lex_state = 30},
  [4228] = {.lex_state = 92, .external_lex_state = 30},
  [4229] = {.lex_state = 92, .external_lex_state = 30},
  [4230] = {.lex_state = 92, .external_lex_state = 30},
  [4231] = {.lex_state = 92, .external_lex_state = 30},
  [4232] = {.lex_state = 225, .external_lex_state = 31},
  [4233] = {.lex_state = 92, .external_lex_state = 30},
  [4234] = {.lex_state = 92, .external_lex_state = 30},
  [4235] = {.lex_state = 92, .external_lex_state = 30},
  [4236] = {.lex_state = 92, .external_lex_state = 30},
  [4237] = {.lex_state = 92, .external_lex_state = 30},
  [4238] = {.lex_state = 92, .external_lex_state = 30},
  [4239] = {.lex_state = 92, .external_lex_state = 30},
  [4240] = {.lex_state = 92, .external_lex_state = 30},
  [4241] = {.lex_state = 92, .external_lex_state = 30},
  [4242] = {.lex_state = 92, .external_lex_state = 30},
  [4243] = {.lex_state = 92, .external_lex_state = 30},
  [4244] = {.lex_state = 92, .external_lex_state = 30},
  [4245] = {.lex_state = 92, .external_lex_state = 30},
  [4246] = {.lex_state = 92, .external_lex_state = 30},
  [4247] = {.lex_state = 92, .external_lex_state = 30},
  [4248] = {.lex_state = 225, .external_lex_state = 31},
  [4249] = {.lex_state = 92, .external_lex_state = 30},
  [4250] = {.lex_state = 92, .external_lex_state = 30},
  [4251] = {.lex_state = 92, .external_lex_state = 30},
  [4252] = {.lex_state = 92, .external_lex_state = 30},
  [4253] = {.lex_state = 224, .external_lex_state = 33},
  [4254] = {.lex_state = 92, .external_lex_state = 30},
  [4255] = {.lex_state = 92, .external_lex_state = 30},
  [4256] = {.lex_state = 92, .external_lex_state = 30},
  [4257] = {.lex_state = 92, .external_lex_state = 30},
  [4258] = {.lex_state = 92, .external_lex_state = 30},
  [4259] = {.lex_state = 92, .external_lex_state = 30},
  [4260] = {.lex_state = 92, .external_lex_state = 30},
  [4261] = {.lex_state = 92, .external_lex_state = 30},
  [4262] = {.lex_state = 92, .external_lex_state = 30},
  [4263] = {.lex_state = 92, .external_lex_state = 30},
  [4264] = {.lex_state = 92, .external_lex_state = 30},
  [4265] = {.lex_state = 92, .external_lex_state = 30},
  [4266] = {.lex_state = 226, .external_lex_state = 32},
  [4267] = {.lex_state = 230, .external_lex_state = 32},
  [4268] = {.lex_state = 92, .external_lex_state = 30},
  [4269] = {.lex_state = 92, .external_lex_state = 30},
  [4270] = {.lex_state = 92, .external_lex_state = 30},
  [4271] = {.lex_state = 92, .external_lex_state = 30},
  [4272] = {.lex_state = 92, .external_lex_state = 30},
  [4273] = {.lex_state = 92, .external_lex_state = 30},
  [4274] = {.lex_state = 92, .external_lex_state = 30},
  [4275] = {.lex_state = 92, .external_lex_state = 30},
  [4276] = {.lex_state = 92, .external_lex_state = 30},
  [4277] = {.lex_state = 92, .external_lex_state = 30},
  [4278] = {.lex_state = 92, .external_lex_state = 30},
  [4279] = {.lex_state = 92, .external_lex_state = 30},
  [4280] = {.lex_state = 92, .external_lex_state = 30},
  [4281] = {.lex_state = 92, .external_lex_state = 30},
  [4282] = {.lex_state = 92, .external_lex_state = 30},
  [4283] = {.lex_state = 92, .external_lex_state = 30},
  [4284] = {.lex_state = 92, .external_lex_state = 30},
  [4285] = {.lex_state = 92, .external_lex_state = 30},
  [4286] = {.lex_state = 92, .external_lex_state = 30},
  [4287] = {.lex_state = 92, .external_lex_state = 30},
  [4288] = {.lex_state = 92, .external_lex_state = 30},
  [4289] = {.lex_state = 92, .external_lex_state = 30},
  [4290] = {.lex_state = 92, .external_lex_state = 30},
  [4291] = {.lex_state = 92, .external_lex_state = 30},
  [4292] = {.lex_state = 92, .external_lex_state = 30},
  [4293] = {.lex_state = 92, .external_lex_state = 30},
  [4294] = {.lex_state = 92, .external_lex_state = 30},
  [4295] = {.lex_state = 92, .external_lex_state = 30},
  [4296] = {.lex_state = 92, .external_lex_state = 30},
  [4297] = {.lex_state = 92, .external_lex_state = 30},
  [4298] = {.lex_state = 92, .external_lex_state = 30},
  [4299] = {.lex_state = 92, .external_lex_state = 30},
  [4300] = {.lex_state = 92, .external_lex_state = 30},
  [4301] = {.lex_state = 92, .external_lex_state = 30},
  [4302] = {.lex_state = 92, .external_lex_state = 30},
  [4303] = {.lex_state = 92, .external_lex_state = 30},
  [4304] = {.lex_state = 92, .external_lex_state = 30},
  [4305] = {.lex_state = 230, .external_lex_state = 32},
  [4306] = {.lex_state = 92, .external_lex_state = 30},
  [4307] = {.lex_state = 92, .external_lex_state = 30},
  [4308] = {.lex_state = 92, .external_lex_state = 30},
  [4309] = {.lex_state = 92, .external_lex_state = 30},
  [4310] = {.lex_state = 92, .external_lex_state = 30},
  [4311] = {.lex_state = 92, .external_lex_state = 30},
  [4312] = {.lex_state = 92, .external_lex_state = 30},
  [4313] = {.lex_state = 92, .external_lex_state = 30},
  [4314] = {.lex_state = 92, .external_lex_state = 30},
  [4315] = {.lex_state = 232, .external_lex_state = 32},
  [4316] = {.lex_state = 92, .external_lex_state = 30},
  [4317] = {.lex_state = 92, .external_lex_state = 30},
  [4318] = {.lex_state = 92, .external_lex_state = 30},
  [4319] = {.lex_state = 92, .external_lex_state = 30},
  [4320] = {.lex_state = 92, .external_lex_state = 30},
  [4321] = {.lex_state = 92, .external_lex_state = 30},
  [4322] = {.lex_state = 92, .external_lex_state = 30},
  [4323] = {.lex_state = 92, .external_lex_state = 30},
  [4324] = {.lex_state = 92, .external_lex_state = 30},
  [4325] = {.lex_state = 92, .external_lex_state = 30},
  [4326] = {.lex_state = 92, .external_lex_state = 30},
  [4327] = {.lex_state = 92, .external_lex_state = 30},
  [4328] = {.lex_state = 92, .external_lex_state = 30},
  [4329] = {.lex_state = 92, .external_lex_state = 30},
  [4330] = {.lex_state = 92, .external_lex_state = 30},
  [4331] = {.lex_state = 226, .external_lex_state = 32},
  [4332] = {.lex_state = 92, .external_lex_state = 30},
  [4333] = {.lex_state = 92, .external_lex_state = 30},
  [4334] = {.lex_state = 226, .external_lex_state = 32},
  [4335] = {.lex_state = 226, .external_lex_state = 32},
  [4336] = {.lex_state = 226, .external_lex_state = 32},
  [4337] = {.lex_state = 226, .external_lex_state = 32},
  [4338] = {.lex_state = 226, .external_lex_state = 32},
  [4339] = {.lex_state = 92, .external_lex_state = 30},
  [4340] = {.lex_state = 232, .external_lex_state = 32},
  [4341] = {.lex_state = 92, .external_lex_state = 30},
  [4342] = {.lex_state = 226, .external_lex_state = 32},
  [4343] = {.lex_state = 226, .external_lex_state = 32},
  [4344] = {.lex_state = 226, .external_lex_state = 32},
  [4345] = {.lex_state = 92, .external_lex_state = 30},
  [4346] = {.lex_state = 92, .external_lex_state = 30},
  [4347] = {.lex_state = 92, .external_lex_state = 30},
  [4348] = {.lex_state = 92, .external_lex_state = 30},
  [4349] = {.lex_state = 92, .external_lex_state = 30},
  [4350] = {.lex_state = 92, .external_lex_state = 30},
  [4351] = {.lex_state = 92, .external_lex_state = 30},
  [4352] = {.lex_state = 92, .external_lex_state = 30},
  [4353] = {.lex_state = 226, .external_lex_state = 32},
  [4354] = {.lex_state = 226, .external_lex_state = 32},
  [4355] = {.lex_state = 92, .external_lex_state = 30},
  [4356] = {.lex_state = 92, .external_lex_state = 30},
  [4357] = {.lex_state = 92, .external_lex_state = 30},
  [4358] = {.lex_state = 92, .external_lex_state = 30},
  [4359] = {.lex_state = 92, .external_lex_state = 30},
  [4360] = {.lex_state = 92, .external_lex_state = 30},
  [4361] = {.lex_state = 92, .external_lex_state = 30},
  [4362] = {.lex_state = 230, .external_lex_state = 32},
  [4363] = {.lex_state = 92, .external_lex_state = 30},
  [4364] = {.lex_state = 230, .external_lex_state = 32},
  [4365] = {.lex_state = 226, .external_lex_state = 32},
  [4366] = {.lex_state = 226, .external_lex_state = 32},
  [4367] = {.lex_state = 226, .external_lex_state = 32},
  [4368] = {.lex_state = 226, .external_lex_state = 32},
  [4369] = {.lex_state = 92, .external_lex_state = 30},
  [4370] = {.lex_state = 92, .external_lex_state = 30},
  [4371] = {.lex_state = 230, .external_lex_state = 32},
  [4372] = {.lex_state = 92, .external_lex_state = 30},
  [4373] = {.lex_state = 92, .external_lex_state = 30},
  [4374] = {.lex_state = 92, .external_lex_state = 30},
  [4375] = {.lex_state = 92, .external_lex_state = 30},
  [4376] = {.lex_state = 92, .external_lex_state = 30},
  [4377] = {.lex_state = 92, .external_lex_state = 30},
  [4378] = {.lex_state = 92, .external_lex_state = 30},
  [4379] = {.lex_state = 92, .external_lex_state = 30},
  [4380] = {.lex_state = 231, .external_lex_state = 32},
  [4381] = {.lex_state = 231, .external_lex_state = 32},
  [4382] = {.lex_state = 231, .external_lex_state = 32},
  [4383] = {.lex_state = 231, .external_lex_state = 32},
  [4384] = {.lex_state = 231, .external_lex_state = 32},
  [4385] = {.lex_state = 231, .external_lex_state = 32},
  [4386] = {.lex_state = 231, .external_lex_state = 32},
  [4387] = {.lex_state = 231, .external_lex_state = 32},
  [4388] = {.lex_state = 231, .external_lex_state = 32},
  [4389] = {.lex_state = 231, .external_lex_state = 32},
  [4390] = {.lex_state = 231, .external_lex_state = 32},
  [4391] = {.lex_state = 231, .external_lex_state = 32},
  [4392] = {.lex_state = 231, .external_lex_state = 32},
  [4393] = {.lex_state = 231, .external_lex_state = 32},
  [4394] = {.lex_state = 231, .external_lex_state = 32},
  [4395] = {.lex_state = 231, .external_lex_state = 32},
  [4396] = {.lex_state = 231, .external_lex_state = 32},
  [4397] = {.lex_state = 231, .external_lex_state = 32},
  [4398] = {.lex_state = 231, .external_lex_state = 32},
  [4399] = {.lex_state = 231, .external_lex_state = 32},
  [4400] = {.lex_state = 231, .external_lex_state = 32},
  [4401] = {.lex_state = 231, .external_lex_state = 32},
  [4402] = {.lex_state = 231, .external_lex_state = 32},
  [4403] = {.lex_state = 231, .external_lex_state = 32},
  [4404] = {.lex_state = 231, .external_lex_state = 32},
  [4405] = {.lex_state = 231, .external_lex_state = 32},
  [4406] = {.lex_state = 231, .external_lex_state = 32},
  [4407] = {.lex_state = 231, .external_lex_state = 32},
  [4408] = {.lex_state = 231, .external_lex_state = 32},
  [4409] = {.lex_state = 231, .external_lex_state = 32},
  [4410] = {.lex_state = 231, .external_lex_state = 32},
  [4411] = {.lex_state = 231, .external_lex_state = 32},
  [4412] = {.lex_state = 231, .external_lex_state = 32},
  [4413] = {.lex_state = 231, .external_lex_state = 32},
  [4414] = {.lex_state = 231, .external_lex_state = 32},
  [4415] = {.lex_state = 231, .external_lex_state = 32},
  [4416] = {.lex_state = 231, .external_lex_state = 32},
  [4417] = {.lex_state = 231, .external_lex_state = 32},
  [4418] = {.lex_state = 231, .external_lex_state = 32},
  [4419] = {.lex_state = 231, .external_lex_state = 32},
  [4420] = {.lex_state = 231, .external_lex_state = 32},
  [4421] = {.lex_state = 231, .external_lex_state = 32},
  [4422] = {.lex_state = 231, .external_lex_state = 32},
  [4423] = {.lex_state = 231, .external_lex_state = 32},
  [4424] = {.lex_state = 231, .external_lex_state = 32},
  [4425] = {.lex_state = 231, .external_lex_state = 32},
  [4426] = {.lex_state = 231, .external_lex_state = 32},
  [4427] = {.lex_state = 231, .external_lex_state = 32},
  [4428] = {.lex_state = 231, .external_lex_state = 32},
  [4429] = {.lex_state = 231, .external_lex_state = 32},
  [4430] = {.lex_state = 231, .external_lex_state = 32},
  [4431] = {.lex_state = 231, .external_lex_state = 32},
  [4432] = {.lex_state = 114, .external_lex_state = 32},
  [4433] = {.lex_state = 226, .external_lex_state = 32},
  [4434] = {.lex_state = 226, .external_lex_state = 32},
  [4435] = {.lex_state = 226, .external_lex_state = 32},
  [4436] = {.lex_state = 226, .external_lex_state = 32},
  [4437] = {.lex_state = 103, .external_lex_state = 32},
  [4438] = {.lex_state = 231, .external_lex_state = 32},
  [4439] = {.lex_state = 231, .external_lex_state = 32},
  [4440] = {.lex_state = 231, .external_lex_state = 32},
  [4441] = {.lex_state = 231, .external_lex_state = 32},
  [4442] = {.lex_state = 231, .external_lex_state = 32},
  [4443] = {.lex_state = 231, .external_lex_state = 32},
  [4444] = {.lex_state = 231, .external_lex_state = 32},
  [4445] = {.lex_state = 231, .external_lex_state = 32},
  [4446] = {.lex_state = 231, .external_lex_state = 32},
  [4447] = {.lex_state = 231, .external_lex_state = 32},
  [4448] = {.lex_state = 231, .external_lex_state = 32},
  [4449] = {.lex_state = 231, .external_lex_state = 32},
  [4450] = {.lex_state = 231, .external_lex_state = 32},
  [4451] = {.lex_state = 231, .external_lex_state = 32},
  [4452] = {.lex_state = 231, .external_lex_state = 32},
  [4453] = {.lex_state = 231, .external_lex_state = 32},
  [4454] = {.lex_state = 231, .external_lex_state = 32},
  [4455] = {.lex_state = 231, .external_lex_state = 32},
  [4456] = {.lex_state = 231, .external_lex_state = 32},
  [4457] = {.lex_state = 231, .external_lex_state = 32},
  [4458] = {.lex_state = 231, .external_lex_state = 32},
  [4459] = {.lex_state = 231, .external_lex_state = 32},
  [4460] = {.lex_state = 231, .external_lex_state = 32},
  [4461] = {.lex_state = 107, .external_lex_state = 32},
  [4462] = {.lex_state = 107, .external_lex_state = 32},
  [4463] = {.lex_state = 231, .external_lex_state = 32},
  [4464] = {.lex_state = 231, .external_lex_state = 32},
  [4465] = {.lex_state = 231, .external_lex_state = 32},
  [4466] = {.lex_state = 107, .external_lex_state = 32},
  [4467] = {.lex_state = 115, .external_lex_state = 31},
  [4468] = {.lex_state = 107, .external_lex_state = 32},
  [4469] = {.lex_state = 231, .external_lex_state = 32},
  [4470] = {.lex_state = 107, .external_lex_state = 32},
  [4471] = {.lex_state = 101, .external_lex_state = 32},
  [4472] = {.lex_state = 231, .external_lex_state = 32},
  [4473] = {.lex_state = 107, .external_lex_state = 32},
  [4474] = {.lex_state = 107, .external_lex_state = 32},
  [4475] = {.lex_state = 115, .external_lex_state = 31},
  [4476] = {.lex_state = 231, .external_lex_state = 32},
  [4477] = {.lex_state = 231, .external_lex_state = 32},
  [4478] = {.lex_state = 231, .external_lex_state = 32},
  [4479] = {.lex_state = 231, .external_lex_state = 32},
  [4480] = {.lex_state = 110, .external_lex_state = 32},
  [4481] = {.lex_state = 231, .external_lex_state = 32},
  [4482] = {.lex_state = 231, .external_lex_state = 32},
  [4483] = {.lex_state = 231, .external_lex_state = 32},
  [4484] = {.lex_state = 231, .external_lex_state = 32},
  [4485] = {.lex_state = 231, .external_lex_state = 32},
  [4486] = {.lex_state = 231, .external_lex_state = 32},
  [4487] = {.lex_state = 231, .external_lex_state = 32},
  [4488] = {.lex_state = 231, .external_lex_state = 32},
  [4489] = {.lex_state = 231, .external_lex_state = 32},
  [4490] = {.lex_state = 231, .external_lex_state = 32},
  [4491] = {.lex_state = 231, .external_lex_state = 32},
  [4492] = {.lex_state = 231, .external_lex_state = 32},
  [4493] = {.lex_state = 231, .external_lex_state = 32},
  [4494] = {.lex_state = 103, .external_lex_state = 32},
  [4495] = {.lex_state = 231, .external_lex_state = 32},
  [4496] = {.lex_state = 231, .external_lex_state = 32},
  [4497] = {.lex_state = 231, .external_lex_state = 32},
  [4498] = {.lex_state = 231, .external_lex_state = 32},
  [4499] = {.lex_state = 231, .external_lex_state = 32},
  [4500] = {.lex_state = 101, .external_lex_state = 32},
  [4501] = {.lex_state = 231, .external_lex_state = 32},
  [4502] = {.lex_state = 101, .external_lex_state = 32},
  [4503] = {.lex_state = 231, .external_lex_state = 32},
  [4504] = {.lex_state = 231, .external_lex_state = 32},
  [4505] = {.lex_state = 101, .external_lex_state = 32},
  [4506] = {.lex_state = 231, .external_lex_state = 32},
  [4507] = {.lex_state = 231, .external_lex_state = 32},
  [4508] = {.lex_state = 231, .external_lex_state = 32},
  [4509] = {.lex_state = 231, .external_lex_state = 32},
  [4510] = {.lex_state = 231, .external_lex_state = 32},
  [4511] = {.lex_state = 231, .external_lex_state = 32},
  [4512] = {.lex_state = 231, .external_lex_state = 32},
  [4513] = {.lex_state = 231, .external_lex_state = 32},
  [4514] = {.lex_state = 231, .external_lex_state = 32},
  [4515] = {.lex_state = 115, .external_lex_state = 34},
  [4516] = {.lex_state = 101, .external_lex_state = 32},
  [4517] = {.lex_state = 115, .external_lex_state = 34},
  [4518] = {.lex_state = 115, .external_lex_state = 34},
  [4519] = {.lex_state = 115, .external_lex_state = 34},
  [4520] = {.lex_state = 101, .external_lex_state = 32},
  [4521] = {.lex_state = 101, .external_lex_state = 32},
  [4522] = {.lex_state = 101, .external_lex_state = 32},
  [4523] = {.lex_state = 101, .external_lex_state = 32},
  [4524] = {.lex_state = 101, .external_lex_state = 32},
  [4525] = {.lex_state = 101, .external_lex_state = 32},
  [4526] = {.lex_state = 101, .external_lex_state = 32},
  [4527] = {.lex_state = 101, .external_lex_state = 32},
  [4528] = {.lex_state = 101, .external_lex_state = 32},
  [4529] = {.lex_state = 101, .external_lex_state = 32},
  [4530] = {.lex_state = 101, .external_lex_state = 32},
  [4531] = {.lex_state = 101, .external_lex_state = 32},
  [4532] = {.lex_state = 101, .external_lex_state = 32},
  [4533] = {.lex_state = 101, .external_lex_state = 32},
  [4534] = {.lex_state = 101, .external_lex_state = 32},
  [4535] = {.lex_state = 107, .external_lex_state = 32},
  [4536] = {.lex_state = 107, .external_lex_state = 32},
  [4537] = {.lex_state = 107, .external_lex_state = 32},
  [4538] = {.lex_state = 107, .external_lex_state = 32},
  [4539] = {.lex_state = 107, .external_lex_state = 32},
  [4540] = {.lex_state = 107, .external_lex_state = 32},
  [4541] = {.lex_state = 107, .external_lex_state = 32},
  [4542] = {.lex_state = 107, .external_lex_state = 32},
  [4543] = {.lex_state = 107, .external_lex_state = 32},
  [4544] = {.lex_state = 107, .external_lex_state = 32},
  [4545] = {.lex_state = 107, .external_lex_state = 32},
  [4546] = {.lex_state = 107, .external_lex_state = 32},
  [4547] = {.lex_state = 101, .external_lex_state = 32},
  [4548] = {.lex_state = 107, .external_lex_state = 32},
  [4549] = {.lex_state = 107, .external_lex_state = 32},
  [4550] = {.lex_state = 107, .external_lex_state = 32},
  [4551] = {.lex_state = 107, .external_lex_state = 32},
  [4552] = {.lex_state = 107, .external_lex_state = 32},
  [4553] = {.lex_state = 231, .external_lex_state = 32},
  [4554] = {.lex_state = 107, .external_lex_state = 32},
  [4555] = {.lex_state = 230, .external_lex_state = 32},
  [4556] = {.lex_state = 107, .external_lex_state = 32},
  [4557] = {.lex_state = 107, .external_lex_state = 32},
  [4558] = {.lex_state = 107, .external_lex_state = 32},
  [4559] = {.lex_state = 107, .external_lex_state = 32},
  [4560] = {.lex_state = 107, .external_lex_state = 32},
  [4561] = {.lex_state = 107, .external_lex_state = 32},
  [4562] = {.lex_state = 103, .external_lex_state = 35},
  [4563] = {.lex_state = 232, .external_lex_state = 32},
  [4564] = {.lex_state = 231, .external_lex_state = 32},
  [4565] = {.lex_state = 103, .external_lex_state = 35},
  [4566] = {.lex_state = 103, .external_lex_state = 35},
  [4567] = {.lex_state = 103, .external_lex_state = 35},
  [4568] = {.lex_state = 103, .external_lex_state = 35},
  [4569] = {.lex_state = 103, .external_lex_state = 35},
  [4570] = {.lex_state = 231, .external_lex_state = 32},
  [4571] = {.lex_state = 231, .external_lex_state = 32},
  [4572] = {.lex_state = 231, .external_lex_state = 32},
  [4573] = {.lex_state = 231, .external_lex_state = 32},
  [4574] = {.lex_state = 101, .external_lex_state = 32},
  [4575] = {.lex_state = 101, .external_lex_state = 32},
  [4576] = {.lex_state = 103, .external_lex_state = 35},
  [4577] = {.lex_state = 231, .external_lex_state = 32},
  [4578] = {.lex_state = 101, .external_lex_state = 32},
  [4579] = {.lex_state = 103, .external_lex_state = 35},
  [4580] = {.lex_state = 101, .external_lex_state = 32},
  [4581] = {.lex_state = 101, .external_lex_state = 32},
  [4582] = {.lex_state = 103, .external_lex_state = 35},
  [4583] = {.lex_state = 101, .external_lex_state = 32},
  [4584] = {.lex_state = 101, .external_lex_state = 32},
  [4585] = {.lex_state = 231, .external_lex_state = 32},
  [4586] = {.lex_state = 231, .external_lex_state = 32},
  [4587] = {.lex_state = 101, .external_lex_state = 32},
  [4588] = {.lex_state = 118, .external_lex_state = 32},
  [4589] = {.lex_state = 231, .external_lex_state = 32},
  [4590] = {.lex_state = 231, .external_lex_state = 32},
  [4591] = {.lex_state = 103, .external_lex_state = 35},
  [4592] = {.lex_state = 103, .external_lex_state = 35},
  [4593] = {.lex_state = 232, .external_lex_state = 32},
  [4594] = {.lex_state = 101, .external_lex_state = 32},
  [4595] = {.lex_state = 101, .external_lex_state = 32},
  [4596] = {.lex_state = 226, .external_lex_state = 32},
  [4597] = {.lex_state = 103, .external_lex_state = 35},
  [4598] = {.lex_state = 101, .external_lex_state = 32},
  [4599] = {.lex_state = 231, .external_lex_state = 32},
  [4600] = {.lex_state = 103, .external_lex_state = 35},
  [4601] = {.lex_state = 101, .external_lex_state = 32},
  [4602] = {.lex_state = 101, .external_lex_state = 32},
  [4603] = {.lex_state = 101, .external_lex_state = 32},
  [4604] = {.lex_state = 231, .external_lex_state = 32},
  [4605] = {.lex_state = 101, .external_lex_state = 32},
  [4606] = {.lex_state = 101, .external_lex_state = 32},
  [4607] = {.lex_state = 231, .external_lex_state = 32},
  [4608] = {.lex_state = 115, .external_lex_state = 34},
  [4609] = {.lex_state = 103, .external_lex_state = 35},
  [4610] = {.lex_state = 101, .external_lex_state = 32},
  [4611] = {.lex_state = 101, .external_lex_state = 32},
  [4612] = {.lex_state = 231, .external_lex_state = 32},
  [4613] = {.lex_state = 101, .external_lex_state = 32},
  [4614] = {.lex_state = 103, .external_lex_state = 35},
  [4615] = {.lex_state = 103, .external_lex_state = 35},
  [4616] = {.lex_state = 101, .external_lex_state = 32},
  [4617] = {.lex_state = 101, .external_lex_state = 32},
  [4618] = {.lex_state = 101, .external_lex_state = 32},
  [4619] = {.lex_state = 101, .external_lex_state = 32},
  [4620] = {.lex_state = 115, .external_lex_state = 34},
  [4621] = {.lex_state = 103, .external_lex_state = 35},
  [4622] = {.lex_state = 101, .external_lex_state = 32},
  [4623] = {.lex_state = 231, .external_lex_state = 32},
  [4624] = {.lex_state = 231, .external_lex_state = 32},
  [4625] = {.lex_state = 114, .external_lex_state = 32},
  [4626] = {.lex_state = 231, .external_lex_state = 32},
  [4627] = {.lex_state = 103, .external_lex_state = 35},
  [4628] = {.lex_state = 231, .external_lex_state = 32},
  [4629] = {.lex_state = 231, .external_lex_state = 32},
  [4630] = {.lex_state = 231, .external_lex_state = 32},
  [4631] = {.lex_state = 103, .external_lex_state = 35},
  [4632] = {.lex_state = 231, .external_lex_state = 32},
  [4633] = {.lex_state = 231, .external_lex_state = 32},
  [4634] = {.lex_state = 231, .external_lex_state = 32},
  [4635] = {.lex_state = 101, .external_lex_state = 32},
  [4636] = {.lex_state = 231, .external_lex_state = 32},
  [4637] = {.lex_state = 231, .external_lex_state = 32},
  [4638] = {.lex_state = 103, .external_lex_state = 35},
  [4639] = {.lex_state = 231, .external_lex_state = 32},
  [4640] = {.lex_state = 231, .external_lex_state = 32},
  [4641] = {.lex_state = 231, .external_lex_state = 32},
  [4642] = {.lex_state = 103, .external_lex_state = 32},
  [4643] = {.lex_state = 231, .external_lex_state = 32},
  [4644] = {.lex_state = 231, .external_lex_state = 32},
  [4645] = {.lex_state = 101, .external_lex_state = 35},
  [4646] = {.lex_state = 101, .external_lex_state = 35},
  [4647] = {.lex_state = 110, .external_lex_state = 35},
  [4648] = {.lex_state = 110, .external_lex_state = 35},
  [4649] = {.lex_state = 110, .external_lex_state = 35},
  [4650] = {.lex_state = 110, .external_lex_state = 35},
  [4651] = {.lex_state = 111, .external_lex_state = 36},
  [4652] = {.lex_state = 103, .external_lex_state = 35},
  [4653] = {.lex_state = 110, .external_lex_state = 35},
  [4654] = {.lex_state = 110, .external_lex_state = 35},
  [4655] = {.lex_state = 110, .external_lex_state = 35},
  [4656] = {.lex_state = 110, .external_lex_state = 35},
  [4657] = {.lex_state = 110, .external_lex_state = 35},
  [4658] = {.lex_state = 114, .external_lex_state = 35},
  [4659] = {.lex_state = 110, .external_lex_state = 35},
  [4660] = {.lex_state = 110, .external_lex_state = 35},
  [4661] = {.lex_state = 110, .external_lex_state = 35},
  [4662] = {.lex_state = 231, .external_lex_state = 32},
  [4663] = {.lex_state = 114, .external_lex_state = 35},
  [4664] = {.lex_state = 231, .external_lex_state = 32},
  [4665] = {.lex_state = 111, .external_lex_state = 36},
  [4666] = {.lex_state = 114, .external_lex_state = 35},
  [4667] = {.lex_state = 231, .external_lex_state = 32},
  [4668] = {.lex_state = 111, .external_lex_state = 36},
  [4669] = {.lex_state = 110, .external_lex_state = 35},
  [4670] = {.lex_state = 103, .external_lex_state = 35},
  [4671] = {.lex_state = 110, .external_lex_state = 35},
  [4672] = {.lex_state = 110, .external_lex_state = 35},
  [4673] = {.lex_state = 110, .external_lex_state = 35},
  [4674] = {.lex_state = 114, .external_lex_state = 35},
  [4675] = {.lex_state = 101, .external_lex_state = 32},
  [4676] = {.lex_state = 114, .external_lex_state = 35},
  [4677] = {.lex_state = 114, .external_lex_state = 35},
  [4678] = {.lex_state = 101, .external_lex_state = 35},
  [4679] = {.lex_state = 114, .external_lex_state = 35},
  [4680] = {.lex_state = 101, .external_lex_state = 35},
  [4681] = {.lex_state = 101, .external_lex_state = 35},
  [4682] = {.lex_state = 110, .external_lex_state = 33},
  [4683] = {.lex_state = 101, .external_lex_state = 35},
  [4684] = {.lex_state = 110, .external_lex_state = 33},
  [4685] = {.lex_state = 101, .external_lex_state = 35},
  [4686] = {.lex_state = 101, .external_lex_state = 35},
  [4687] = {.lex_state = 101, .external_lex_state = 35},
  [4688] = {.lex_state = 101, .external_lex_state = 35},
  [4689] = {.lex_state = 101, .external_lex_state = 35},
  [4690] = {.lex_state = 101, .external_lex_state = 35},
  [4691] = {.lex_state = 101, .external_lex_state = 35},
  [4692] = {.lex_state = 101, .external_lex_state = 35},
  [4693] = {.lex_state = 231, .external_lex_state = 32},
  [4694] = {.lex_state = 101, .external_lex_state = 35},
  [4695] = {.lex_state = 101, .external_lex_state = 35},
  [4696] = {.lex_state = 101, .external_lex_state = 35},
  [4697] = {.lex_state = 101, .external_lex_state = 35},
  [4698] = {.lex_state = 101, .external_lex_state = 32},
  [4699] = {.lex_state = 101, .external_lex_state = 35},
  [4700] = {.lex_state = 103, .external_lex_state = 35},
  [4701] = {.lex_state = 101, .external_lex_state = 32},
  [4702] = {.lex_state = 101, .external_lex_state = 35},
  [4703] = {.lex_state = 101, .external_lex_state = 35},
  [4704] = {.lex_state = 101, .external_lex_state = 35},
  [4705] = {.lex_state = 101, .external_lex_state = 35},
  [4706] = {.lex_state = 101, .external_lex_state = 35},
  [4707] = {.lex_state = 101, .external_lex_state = 35},
  [4708] = {.lex_state = 101, .external_lex_state = 35},
  [4709] = {.lex_state = 101, .external_lex_state = 35},
  [4710] = {.lex_state = 101, .external_lex_state = 35},
  [4711] = {.lex_state = 231, .external_lex_state = 32},
  [4712] = {.lex_state = 101, .external_lex_state = 35},
  [4713] = {.lex_state = 101, .external_lex_state = 35},
  [4714] = {.lex_state = 101, .external_lex_state = 35},
  [4715] = {.lex_state = 101, .external_lex_state = 35},
  [4716] = {.lex_state = 101, .external_lex_state = 35},
  [4717] = {.lex_state = 101, .external_lex_state = 35},
  [4718] = {.lex_state = 101, .external_lex_state = 35},
  [4719] = {.lex_state = 101, .external_lex_state = 35},
  [4720] = {.lex_state = 101, .external_lex_state = 35},
  [4721] = {.lex_state = 101, .external_lex_state = 35},
  [4722] = {.lex_state = 101, .external_lex_state = 35},
  [4723] = {.lex_state = 103, .external_lex_state = 32},
  [4724] = {.lex_state = 101, .external_lex_state = 35},
  [4725] = {.lex_state = 101, .external_lex_state = 35},
  [4726] = {.lex_state = 101, .external_lex_state = 35},
  [4727] = {.lex_state = 101, .external_lex_state = 35},
  [4728] = {.lex_state = 101, .external_lex_state = 35},
  [4729] = {.lex_state = 101, .external_lex_state = 35},
  [4730] = {.lex_state = 101, .external_lex_state = 35},
  [4731] = {.lex_state = 101, .external_lex_state = 35},
  [4732] = {.lex_state = 101, .external_lex_state = 35},
  [4733] = {.lex_state = 101, .external_lex_state = 35},
  [4734] = {.lex_state = 101, .external_lex_state = 35},
  [4735] = {.lex_state = 101, .external_lex_state = 35},
  [4736] = {.lex_state = 101, .external_lex_state = 35},
  [4737] = {.lex_state = 101, .external_lex_state = 35},
  [4738] = {.lex_state = 101, .external_lex_state = 35},
  [4739] = {.lex_state = 101, .external_lex_state = 35},
  [4740] = {.lex_state = 101, .external_lex_state = 35},
  [4741] = {.lex_state = 101, .external_lex_state = 35},
  [4742] = {.lex_state = 101, .external_lex_state = 32},
  [4743] = {.lex_state = 109, .external_lex_state = 32},
  [4744] = {.lex_state = 231, .external_lex_state = 32},
  [4745] = {.lex_state = 231, .external_lex_state = 32},
  [4746] = {.lex_state = 111, .external_lex_state = 36},
  [4747] = {.lex_state = 231, .external_lex_state = 32},
  [4748] = {.lex_state = 101, .external_lex_state = 32},
  [4749] = {.lex_state = 111, .external_lex_state = 36},
  [4750] = {.lex_state = 231, .external_lex_state = 32},
  [4751] = {.lex_state = 231, .external_lex_state = 32},
  [4752] = {.lex_state = 231, .external_lex_state = 32},
  [4753] = {.lex_state = 231, .external_lex_state = 32},
  [4754] = {.lex_state = 101, .external_lex_state = 35},
  [4755] = {.lex_state = 101, .external_lex_state = 32},
  [4756] = {.lex_state = 236, .external_lex_state = 32},
  [4757] = {.lex_state = 231, .external_lex_state = 32},
  [4758] = {.lex_state = 231, .external_lex_state = 32},
  [4759] = {.lex_state = 231, .external_lex_state = 32},
  [4760] = {.lex_state = 231, .external_lex_state = 32},
  [4761] = {.lex_state = 103, .external_lex_state = 35},
  [4762] = {.lex_state = 101, .external_lex_state = 32},
  [4763] = {.lex_state = 101, .external_lex_state = 35},
  [4764] = {.lex_state = 101, .external_lex_state = 35},
  [4765] = {.lex_state = 101, .external_lex_state = 32},
  [4766] = {.lex_state = 103, .external_lex_state = 35},
  [4767] = {.lex_state = 101, .external_lex_state = 35},
  [4768] = {.lex_state = 101, .external_lex_state = 32},
  [4769] = {.lex_state = 110, .external_lex_state = 35},
  [4770] = {.lex_state = 110, .external_lex_state = 35},
  [4771] = {.lex_state = 115, .external_lex_state = 34},
  [4772] = {.lex_state = 111, .external_lex_state = 36},
  [4773] = {.lex_state = 101, .external_lex_state = 35},
  [4774] = {.lex_state = 231, .external_lex_state = 32},
  [4775] = {.lex_state = 231, .external_lex_state = 32},
  [4776] = {.lex_state = 101, .external_lex_state = 32},
  [4777] = {.lex_state = 101, .external_lex_state = 35},
  [4778] = {.lex_state = 111, .external_lex_state = 36},
  [4779] = {.lex_state = 111, .external_lex_state = 36},
  [4780] = {.lex_state = 111, .external_lex_state = 36},
  [4781] = {.lex_state = 101, .external_lex_state = 35},
  [4782] = {.lex_state = 101, .external_lex_state = 35},
  [4783] = {.lex_state = 101, .external_lex_state = 35},
  [4784] = {.lex_state = 101, .external_lex_state = 32},
  [4785] = {.lex_state = 111, .external_lex_state = 36},
  [4786] = {.lex_state = 101, .external_lex_state = 35},
  [4787] = {.lex_state = 111, .external_lex_state = 36},
  [4788] = {.lex_state = 111, .external_lex_state = 36},
  [4789] = {.lex_state = 101, .external_lex_state = 32},
  [4790] = {.lex_state = 101, .external_lex_state = 35},
  [4791] = {.lex_state = 111, .external_lex_state = 36},
  [4792] = {.lex_state = 101, .external_lex_state = 35},
  [4793] = {.lex_state = 101, .external_lex_state = 35},
  [4794] = {.lex_state = 231, .external_lex_state = 32},
  [4795] = {.lex_state = 101, .external_lex_state = 35},
  [4796] = {.lex_state = 231, .external_lex_state = 32},
  [4797] = {.lex_state = 231, .external_lex_state = 32},
  [4798] = {.lex_state = 101, .external_lex_state = 35},
  [4799] = {.lex_state = 231, .external_lex_state = 32},
  [4800] = {.lex_state = 101, .external_lex_state = 35},
  [4801] = {.lex_state = 115, .external_lex_state = 34},
  [4802] = {.lex_state = 115, .external_lex_state = 34},
  [4803] = {.lex_state = 101, .external_lex_state = 35},
  [4804] = {.lex_state = 101, .external_lex_state = 35},
  [4805] = {.lex_state = 101, .external_lex_state = 35},
  [4806] = {.lex_state = 110, .external_lex_state = 33},
  [4807] = {.lex_state = 101, .external_lex_state = 32},
  [4808] = {.lex_state = 101, .external_lex_state = 32},
  [4809] = {.lex_state = 101, .external_lex_state = 35},
  [4810] = {.lex_state = 101, .external_lex_state = 32},
  [4811] = {.lex_state = 101, .external_lex_state = 35},
  [4812] = {.lex_state = 111, .external_lex_state = 36},
  [4813] = {.lex_state = 101, .external_lex_state = 35},
  [4814] = {.lex_state = 101, .external_lex_state = 35},
  [4815] = {.lex_state = 231, .external_lex_state = 32},
  [4816] = {.lex_state = 231, .external_lex_state = 32},
  [4817] = {.lex_state = 101, .external_lex_state = 35},
  [4818] = {.lex_state = 110, .external_lex_state = 33},
  [4819] = {.lex_state = 101, .external_lex_state = 35},
  [4820] = {.lex_state = 101, .external_lex_state = 35},
  [4821] = {.lex_state = 101, .external_lex_state = 35},
  [4822] = {.lex_state = 115, .external_lex_state = 34},
  [4823] = {.lex_state = 101, .external_lex_state = 32},
  [4824] = {.lex_state = 101, .external_lex_state = 35},
  [4825] = {.lex_state = 115, .external_lex_state = 34},
  [4826] = {.lex_state = 107, .external_lex_state = 32},
  [4827] = {.lex_state = 101, .external_lex_state = 35},
  [4828] = {.lex_state = 101, .external_lex_state = 35},
  [4829] = {.lex_state = 231, .external_lex_state = 32},
  [4830] = {.lex_state = 110, .external_lex_state = 35},
  [4831] = {.lex_state = 101, .external_lex_state = 32},
  [4832] = {.lex_state = 101, .external_lex_state = 32},
  [4833] = {.lex_state = 110, .external_lex_state = 35},
  [4834] = {.lex_state = 101, .external_lex_state = 32},
  [4835] = {.lex_state = 110, .external_lex_state = 35},
  [4836] = {.lex_state = 101, .external_lex_state = 32},
  [4837] = {.lex_state = 101, .external_lex_state = 32},
  [4838] = {.lex_state = 101, .external_lex_state = 32},
  [4839] = {.lex_state = 101, .external_lex_state = 32},
  [4840] = {.lex_state = 101, .external_lex_state = 32},
  [4841] = {.lex_state = 101, .external_lex_state = 35},
  [4842] = {.lex_state = 110, .external_lex_state = 33},
  [4843] = {.lex_state = 101, .external_lex_state = 32},
  [4844] = {.lex_state = 101, .external_lex_state = 35},
  [4845] = {.lex_state = 101, .external_lex_state = 35},
  [4846] = {.lex_state = 101, .external_lex_state = 32},
  [4847] = {.lex_state = 101, .external_lex_state = 32},
  [4848] = {.lex_state = 101, .external_lex_state = 32},
  [4849] = {.lex_state = 101, .external_lex_state = 35},
  [4850] = {.lex_state = 101, .external_lex_state = 32},
  [4851] = {.lex_state = 101, .external_lex_state = 35},
  [4852] = {.lex_state = 110, .external_lex_state = 36},
  [4853] = {.lex_state = 101, .external_lex_state = 32},
  [4854] = {.lex_state = 101, .external_lex_state = 32},
  [4855] = {.lex_state = 101, .external_lex_state = 32},
  [4856] = {.lex_state = 101, .external_lex_state = 32},
  [4857] = {.lex_state = 101, .external_lex_state = 32},
  [4858] = {.lex_state = 101, .external_lex_state = 32},
  [4859] = {.lex_state = 101, .external_lex_state = 32},
  [4860] = {.lex_state = 110, .external_lex_state = 33},
  [4861] = {.lex_state = 101, .external_lex_state = 35},
  [4862] = {.lex_state = 110, .external_lex_state = 33},
  [4863] = {.lex_state = 101, .external_lex_state = 35},
  [4864] = {.lex_state = 110, .external_lex_state = 33},
  [4865] = {.lex_state = 101, .external_lex_state = 35},
  [4866] = {.lex_state = 101, .external_lex_state = 32},
  [4867] = {.lex_state = 103, .external_lex_state = 35},
  [4868] = {.lex_state = 101, .external_lex_state = 32},
  [4869] = {.lex_state = 101, .external_lex_state = 32},
  [4870] = {.lex_state = 101, .external_lex_state = 32},
  [4871] = {.lex_state = 110, .external_lex_state = 33},
  [4872] = {.lex_state = 110, .external_lex_state = 33},
  [4873] = {.lex_state = 110, .external_lex_state = 33},
  [4874] = {.lex_state = 110, .external_lex_state = 33},
  [4875] = {.lex_state = 101, .external_lex_state = 35},
  [4876] = {.lex_state = 101, .external_lex_state = 35},
  [4877] = {.lex_state = 101, .external_lex_state = 32},
  [4878] = {.lex_state = 101, .external_lex_state = 32},
  [4879] = {.lex_state = 109, .external_lex_state = 32},
  [4880] = {.lex_state = 101, .external_lex_state = 32},
  [4881] = {.lex_state = 101, .external_lex_state = 32},
  [4882] = {.lex_state = 110, .external_lex_state = 33},
  [4883] = {.lex_state = 99, .external_lex_state = 37},
  [4884] = {.lex_state = 101, .external_lex_state = 35},
  [4885] = {.lex_state = 101, .external_lex_state = 35},
  [4886] = {.lex_state = 99, .external_lex_state = 37},
  [4887] = {.lex_state = 99, .external_lex_state = 37},
  [4888] = {.lex_state = 99, .external_lex_state = 37},
  [4889] = {.lex_state = 101, .external_lex_state = 32},
  [4890] = {.lex_state = 99, .external_lex_state = 37},
  [4891] = {.lex_state = 99, .external_lex_state = 37},
  [4892] = {.lex_state = 99, .external_lex_state = 37},
  [4893] = {.lex_state = 101, .external_lex_state = 35},
  [4894] = {.lex_state = 101, .external_lex_state = 32},
  [4895] = {.lex_state = 101, .external_lex_state = 35},
  [4896] = {.lex_state = 101, .external_lex_state = 35},
  [4897] = {.lex_state = 101, .external_lex_state = 35},
  [4898] = {.lex_state = 101, .external_lex_state = 35},
  [4899] = {.lex_state = 101, .external_lex_state = 35},
  [4900] = {.lex_state = 101, .external_lex_state = 35},
  [4901] = {.lex_state = 101, .external_lex_state = 35},
  [4902] = {.lex_state = 101, .external_lex_state = 32},
  [4903] = {.lex_state = 99, .external_lex_state = 37},
  [4904] = {.lex_state = 101, .external_lex_state = 35},
  [4905] = {.lex_state = 99, .external_lex_state = 37},
  [4906] = {.lex_state = 99, .external_lex_state = 37},
  [4907] = {.lex_state = 99, .external_lex_state = 37},
  [4908] = {.lex_state = 101, .external_lex_state = 32},
  [4909] = {.lex_state = 99, .external_lex_state = 37},
  [4910] = {.lex_state = 99, .external_lex_state = 37},
  [4911] = {.lex_state = 101, .external_lex_state = 35},
  [4912] = {.lex_state = 99, .external_lex_state = 37},
  [4913] = {.lex_state = 99, .external_lex_state = 37},
  [4914] = {.lex_state = 101, .external_lex_state = 35},
  [4915] = {.lex_state = 99, .external_lex_state = 37},
  [4916] = {.lex_state = 99, .external_lex_state = 37},
  [4917] = {.lex_state = 101, .external_lex_state = 35},
  [4918] = {.lex_state = 101, .external_lex_state = 35},
  [4919] = {.lex_state = 101, .external_lex_state = 35},
  [4920] = {.lex_state = 101, .external_lex_state = 35},
  [4921] = {.lex_state = 99, .external_lex_state = 37},
  [4922] = {.lex_state = 101, .external_lex_state = 32},
  [4923] = {.lex_state = 99, .external_lex_state = 37},
  [4924] = {.lex_state = 99, .external_lex_state = 37},
  [4925] = {.lex_state = 101, .external_lex_state = 35},
  [4926] = {.lex_state = 101, .external_lex_state = 35},
  [4927] = {.lex_state = 101, .external_lex_state = 35},
  [4928] = {.lex_state = 101, .external_lex_state = 35},
  [4929] = {.lex_state = 101, .external_lex_state = 35},
  [4930] = {.lex_state = 101, .external_lex_state = 35},
  [4931] = {.lex_state = 101, .external_lex_state = 35},
  [4932] = {.lex_state = 101, .external_lex_state = 35},
  [4933] = {.lex_state = 101, .external_lex_state = 35},
  [4934] = {.lex_state = 101, .external_lex_state = 35},
  [4935] = {.lex_state = 101, .external_lex_state = 35},
  [4936] = {.lex_state = 101, .external_lex_state = 35},
  [4937] = {.lex_state = 101, .external_lex_state = 35},
  [4938] = {.lex_state = 99, .external_lex_state = 37},
  [4939] = {.lex_state = 101, .external_lex_state = 35},
  [4940] = {.lex_state = 111, .external_lex_state = 36},
  [4941] = {.lex_state = 101, .external_lex_state = 35},
  [4942] = {.lex_state = 111, .external_lex_state = 36},
  [4943] = {.lex_state = 101, .external_lex_state = 35},
  [4944] = {.lex_state = 111, .external_lex_state = 36},
  [4945] = {.lex_state = 101, .external_lex_state = 35},
  [4946] = {.lex_state = 111, .external_lex_state = 36},
  [4947] = {.lex_state = 101, .external_lex_state = 35},
  [4948] = {.lex_state = 101, .external_lex_state = 35},
  [4949] = {.lex_state = 101, .external_lex_state = 35},
  [4950] = {.lex_state = 101, .external_lex_state = 35},
  [4951] = {.lex_state = 101, .external_lex_state = 35},
  [4952] = {.lex_state = 101, .external_lex_state = 35},
  [4953] = {.lex_state = 101, .external_lex_state = 35},
  [4954] = {.lex_state = 101, .external_lex_state = 35},
  [4955] = {.lex_state = 101, .external_lex_state = 35},
  [4956] = {.lex_state = 101, .external_lex_state = 35},
  [4957] = {.lex_state = 99, .external_lex_state = 37},
  [4958] = {.lex_state = 111, .external_lex_state = 36},
  [4959] = {.lex_state = 99, .external_lex_state = 37},
  [4960] = {.lex_state = 99, .external_lex_state = 37},
  [4961] = {.lex_state = 99, .external_lex_state = 37},
  [4962] = {.lex_state = 110, .external_lex_state = 36},
  [4963] = {.lex_state = 101, .external_lex_state = 35},
  [4964] = {.lex_state = 111, .external_lex_state = 36},
  [4965] = {.lex_state = 101, .external_lex_state = 35},
  [4966] = {.lex_state = 101, .external_lex_state = 35},
  [4967] = {.lex_state = 101, .external_lex_state = 35},
  [4968] = {.lex_state = 111, .external_lex_state = 36},
  [4969] = {.lex_state = 101, .external_lex_state = 35},
  [4970] = {.lex_state = 111, .external_lex_state = 36},
  [4971] = {.lex_state = 111, .external_lex_state = 36},
  [4972] = {.lex_state = 111, .external_lex_state = 36},
  [4973] = {.lex_state = 111, .external_lex_state = 36},
  [4974] = {.lex_state = 111, .external_lex_state = 36},
  [4975] = {.lex_state = 111, .external_lex_state = 36},
  [4976] = {.lex_state = 111, .external_lex_state = 36},
  [4977] = {.lex_state = 101, .external_lex_state = 35},
  [4978] = {.lex_state = 111, .external_lex_state = 36},
  [4979] = {.lex_state = 101, .external_lex_state = 35},
  [4980] = {.lex_state = 111, .external_lex_state = 36},
  [4981] = {.lex_state = 111, .external_lex_state = 36},
  [4982] = {.lex_state = 99, .external_lex_state = 37},
  [4983] = {.lex_state = 101, .external_lex_state = 35},
  [4984] = {.lex_state = 101, .external_lex_state = 35},
  [4985] = {.lex_state = 101, .external_lex_state = 35},
  [4986] = {.lex_state = 111, .external_lex_state = 36},
  [4987] = {.lex_state = 111, .external_lex_state = 36},
  [4988] = {.lex_state = 99, .external_lex_state = 37},
  [4989] = {.lex_state = 101, .external_lex_state = 35},
  [4990] = {.lex_state = 99, .external_lex_state = 37},
  [4991] = {.lex_state = 99, .external_lex_state = 37},
  [4992] = {.lex_state = 99, .external_lex_state = 37},
  [4993] = {.lex_state = 101, .external_lex_state = 35},
  [4994] = {.lex_state = 99, .external_lex_state = 37},
  [4995] = {.lex_state = 101, .external_lex_state = 35},
  [4996] = {.lex_state = 99, .external_lex_state = 37},
  [4997] = {.lex_state = 101, .external_lex_state = 32},
  [4998] = {.lex_state = 99, .external_lex_state = 37},
  [4999] = {.lex_state = 101, .external_lex_state = 35},
  [5000] = {.lex_state = 99, .external_lex_state = 37},
  [5001] = {.lex_state = 99, .external_lex_state = 37},
  [5002] = {.lex_state = 101, .external_lex_state = 35},
  [5003] = {.lex_state = 99, .external_lex_state = 37},
  [5004] = {.lex_state = 99, .external_lex_state = 37},
  [5005] = {.lex_state = 99, .external_lex_state = 37},
  [5006] = {.lex_state = 101, .external_lex_state = 35},
  [5007] = {.lex_state = 101, .external_lex_state = 32},
  [5008] = {.lex_state = 101, .external_lex_state = 32},
  [5009] = {.lex_state = 101, .external_lex_state = 35},
  [5010] = {.lex_state = 111, .external_lex_state = 36},
  [5011] = {.lex_state = 101, .external_lex_state = 35},
  [5012] = {.lex_state = 101, .external_lex_state = 32},
  [5013] = {.lex_state = 110, .external_lex_state = 36},
  [5014] = {.lex_state = 101, .external_lex_state = 35},
  [5015] = {.lex_state = 110, .external_lex_state = 36},
  [5016] = {.lex_state = 101, .external_lex_state = 35},
  [5017] = {.lex_state = 111, .external_lex_state = 36},
  [5018] = {.lex_state = 101, .external_lex_state = 35},
  [5019] = {.lex_state = 101, .external_lex_state = 35},
  [5020] = {.lex_state = 101, .external_lex_state = 35},
  [5021] = {.lex_state = 101, .external_lex_state = 35},
  [5022] = {.lex_state = 111, .external_lex_state = 36},
  [5023] = {.lex_state = 111, .external_lex_state = 36},
  [5024] = {.lex_state = 110, .external_lex_state = 36},
  [5025] = {.lex_state = 99, .external_lex_state = 37},
  [5026] = {.lex_state = 101, .external_lex_state = 35},
  [5027] = {.lex_state = 99, .external_lex_state = 37},
  [5028] = {.lex_state = 101, .external_lex_state = 35},
  [5029] = {.lex_state = 99, .external_lex_state = 37},
  [5030] = {.lex_state = 101, .external_lex_state = 32},
  [5031] = {.lex_state = 99, .external_lex_state = 37},
  [5032] = {.lex_state = 101, .external_lex_state = 35},
  [5033] = {.lex_state = 101, .external_lex_state = 35},
  [5034] = {.lex_state = 99, .external_lex_state = 37},
  [5035] = {.lex_state = 110, .external_lex_state = 36},
  [5036] = {.lex_state = 110, .external_lex_state = 36},
  [5037] = {.lex_state = 100, .external_lex_state = 37},
  [5038] = {.lex_state = 100, .external_lex_state = 37},
  [5039] = {.lex_state = 110, .external_lex_state = 33},
  [5040] = {.lex_state = 110, .external_lex_state = 33},
  [5041] = {.lex_state = 101, .external_lex_state = 35},
  [5042] = {.lex_state = 110, .external_lex_state = 33},
  [5043] = {.lex_state = 110, .external_lex_state = 33},
  [5044] = {.lex_state = 214, .external_lex_state = 35},
  [5045] = {.lex_state = 100, .external_lex_state = 37},
  [5046] = {.lex_state = 214, .external_lex_state = 35},
  [5047] = {.lex_state = 100, .external_lex_state = 37},
  [5048] = {.lex_state = 110, .external_lex_state = 33},
  [5049] = {.lex_state = 100, .external_lex_state = 37},
  [5050] = {.lex_state = 100, .external_lex_state = 37},
  [5051] = {.lex_state = 100, .external_lex_state = 37},
  [5052] = {.lex_state = 100, .external_lex_state = 37},
  [5053] = {.lex_state = 100, .external_lex_state = 37},
  [5054] = {.lex_state = 214, .external_lex_state = 35},
  [5055] = {.lex_state = 100, .external_lex_state = 37},
  [5056] = {.lex_state = 100, .external_lex_state = 37},
  [5057] = {.lex_state = 100, .external_lex_state = 37},
  [5058] = {.lex_state = 100, .external_lex_state = 37},
  [5059] = {.lex_state = 100, .external_lex_state = 37},
  [5060] = {.lex_state = 225, .external_lex_state = 38},
  [5061] = {.lex_state = 100, .external_lex_state = 37},
  [5062] = {.lex_state = 100, .external_lex_state = 37},
  [5063] = {.lex_state = 110, .external_lex_state = 33},
  [5064] = {.lex_state = 110, .external_lex_state = 33},
  [5065] = {.lex_state = 100, .external_lex_state = 37},
  [5066] = {.lex_state = 110, .external_lex_state = 33},
  [5067] = {.lex_state = 110, .external_lex_state = 33},
  [5068] = {.lex_state = 214, .external_lex_state = 35},
  [5069] = {.lex_state = 214, .external_lex_state = 35},
  [5070] = {.lex_state = 100, .external_lex_state = 37},
  [5071] = {.lex_state = 100, .external_lex_state = 37},
  [5072] = {.lex_state = 100, .external_lex_state = 37},
  [5073] = {.lex_state = 100, .external_lex_state = 37},
  [5074] = {.lex_state = 100, .external_lex_state = 37},
  [5075] = {.lex_state = 110, .external_lex_state = 33},
  [5076] = {.lex_state = 214, .external_lex_state = 35},
  [5077] = {.lex_state = 110, .external_lex_state = 33},
  [5078] = {.lex_state = 214, .external_lex_state = 35},
  [5079] = {.lex_state = 110, .external_lex_state = 33},
  [5080] = {.lex_state = 101, .external_lex_state = 32},
  [5081] = {.lex_state = 110, .external_lex_state = 33},
  [5082] = {.lex_state = 100, .external_lex_state = 37},
  [5083] = {.lex_state = 214, .external_lex_state = 35},
  [5084] = {.lex_state = 100, .external_lex_state = 37},
  [5085] = {.lex_state = 100, .external_lex_state = 37},
  [5086] = {.lex_state = 214, .external_lex_state = 35},
  [5087] = {.lex_state = 100, .external_lex_state = 37},
  [5088] = {.lex_state = 101, .external_lex_state = 32},
  [5089] = {.lex_state = 214, .external_lex_state = 35},
  [5090] = {.lex_state = 101, .external_lex_state = 32},
  [5091] = {.lex_state = 100, .external_lex_state = 37},
  [5092] = {.lex_state = 110, .external_lex_state = 33},
  [5093] = {.lex_state = 100, .external_lex_state = 37},
  [5094] = {.lex_state = 101, .external_lex_state = 35},
  [5095] = {.lex_state = 214, .external_lex_state = 35},
  [5096] = {.lex_state = 100, .external_lex_state = 37},
  [5097] = {.lex_state = 214, .external_lex_state = 35},
  [5098] = {.lex_state = 100, .external_lex_state = 39},
  [5099] = {.lex_state = 100, .external_lex_state = 37},
  [5100] = {.lex_state = 214, .external_lex_state = 35},
  [5101] = {.lex_state = 214, .external_lex_state = 35},
  [5102] = {.lex_state = 101, .external_lex_state = 35},
  [5103] = {.lex_state = 214, .external_lex_state = 35},
  [5104] = {.lex_state = 214, .external_lex_state = 35},
  [5105] = {.lex_state = 225, .external_lex_state = 38},
  [5106] = {.lex_state = 100, .external_lex_state = 37},
  [5107] = {.lex_state = 100, .external_lex_state = 37},
  [5108] = {.lex_state = 110, .external_lex_state = 33},
  [5109] = {.lex_state = 100, .external_lex_state = 37},
  [5110] = {.lex_state = 100, .external_lex_state = 37},
  [5111] = {.lex_state = 214, .external_lex_state = 35},
  [5112] = {.lex_state = 214, .external_lex_state = 35},
  [5113] = {.lex_state = 101, .external_lex_state = 32},
  [5114] = {.lex_state = 100, .external_lex_state = 37},
  [5115] = {.lex_state = 100, .external_lex_state = 37},
  [5116] = {.lex_state = 100, .external_lex_state = 37},
  [5117] = {.lex_state = 100, .external_lex_state = 37},
  [5118] = {.lex_state = 214, .external_lex_state = 35},
  [5119] = {.lex_state = 100, .external_lex_state = 37},
  [5120] = {.lex_state = 100, .external_lex_state = 37},
  [5121] = {.lex_state = 214, .external_lex_state = 35},
  [5122] = {.lex_state = 214, .external_lex_state = 35},
  [5123] = {.lex_state = 214, .external_lex_state = 35},
  [5124] = {.lex_state = 100, .external_lex_state = 37},
  [5125] = {.lex_state = 214, .external_lex_state = 35},
  [5126] = {.lex_state = 100, .external_lex_state = 37},
  [5127] = {.lex_state = 214, .external_lex_state = 35},
  [5128] = {.lex_state = 100, .external_lex_state = 37},
  [5129] = {.lex_state = 100, .external_lex_state = 37},
  [5130] = {.lex_state = 100, .external_lex_state = 37},
  [5131] = {.lex_state = 100, .external_lex_state = 37},
  [5132] = {.lex_state = 214, .external_lex_state = 35},
  [5133] = {.lex_state = 100, .external_lex_state = 37},
  [5134] = {.lex_state = 100, .external_lex_state = 37},
  [5135] = {.lex_state = 100, .external_lex_state = 37},
  [5136] = {.lex_state = 100, .external_lex_state = 37},
  [5137] = {.lex_state = 100, .external_lex_state = 37},
  [5138] = {.lex_state = 214, .external_lex_state = 35},
  [5139] = {.lex_state = 214, .external_lex_state = 35},
  [5140] = {.lex_state = 214, .external_lex_state = 35},
  [5141] = {.lex_state = 100, .external_lex_state = 37},
  [5142] = {.lex_state = 100, .external_lex_state = 37},
  [5143] = {.lex_state = 100, .external_lex_state = 37},
  [5144] = {.lex_state = 214, .external_lex_state = 35},
  [5145] = {.lex_state = 110, .external_lex_state = 36},
  [5146] = {.lex_state = 225, .external_lex_state = 38},
  [5147] = {.lex_state = 101, .external_lex_state = 32},
  [5148] = {.lex_state = 100, .external_lex_state = 37},
  [5149] = {.lex_state = 214, .external_lex_state = 35},
  [5150] = {.lex_state = 214, .external_lex_state = 35},
  [5151] = {.lex_state = 100, .external_lex_state = 37},
  [5152] = {.lex_state = 214, .external_lex_state = 35},
  [5153] = {.lex_state = 100, .external_lex_state = 37},
  [5154] = {.lex_state = 100, .external_lex_state = 37},
  [5155] = {.lex_state = 110, .external_lex_state = 33},
  [5156] = {.lex_state = 214, .external_lex_state = 35},
  [5157] = {.lex_state = 110, .external_lex_state = 33},
  [5158] = {.lex_state = 214, .external_lex_state = 35},
  [5159] = {.lex_state = 110, .external_lex_state = 33},
  [5160] = {.lex_state = 100, .external_lex_state = 37},
  [5161] = {.lex_state = 100, .external_lex_state = 37},
  [5162] = {.lex_state = 100, .external_lex_state = 37},
  [5163] = {.lex_state = 100, .external_lex_state = 37},
  [5164] = {.lex_state = 101, .external_lex_state = 35},
  [5165] = {.lex_state = 101, .external_lex_state = 32},
  [5166] = {.lex_state = 214, .external_lex_state = 35},
  [5167] = {.lex_state = 100, .external_lex_state = 37},
  [5168] = {.lex_state = 100, .external_lex_state = 39},
  [5169] = {.lex_state = 100, .external_lex_state = 37},
  [5170] = {.lex_state = 100, .external_lex_state = 37},
  [5171] = {.lex_state = 214, .external_lex_state = 35},
  [5172] = {.lex_state = 214, .external_lex_state = 35},
  [5173] = {.lex_state = 100, .external_lex_state = 37},
  [5174] = {.lex_state = 214, .external_lex_state = 35},
  [5175] = {.lex_state = 214, .external_lex_state = 35},
  [5176] = {.lex_state = 110, .external_lex_state = 33},
  [5177] = {.lex_state = 100, .external_lex_state = 37},
  [5178] = {.lex_state = 100, .external_lex_state = 37},
  [5179] = {.lex_state = 100, .external_lex_state = 37},
  [5180] = {.lex_state = 100, .external_lex_state = 37},
  [5181] = {.lex_state = 100, .external_lex_state = 37},
  [5182] = {.lex_state = 100, .external_lex_state = 37},
  [5183] = {.lex_state = 214, .external_lex_state = 35},
  [5184] = {.lex_state = 214, .external_lex_state = 35},
  [5185] = {.lex_state = 100, .external_lex_state = 37},
  [5186] = {.lex_state = 214, .external_lex_state = 35},
  [5187] = {.lex_state = 110, .external_lex_state = 33},
  [5188] = {.lex_state = 100, .external_lex_state = 37},
  [5189] = {.lex_state = 100, .external_lex_state = 37},
  [5190] = {.lex_state = 101, .external_lex_state = 35},
  [5191] = {.lex_state = 100, .external_lex_state = 37},
  [5192] = {.lex_state = 100, .external_lex_state = 37},
  [5193] = {.lex_state = 100, .external_lex_state = 37},
  [5194] = {.lex_state = 101, .external_lex_state = 32},
  [5195] = {.lex_state = 101, .external_lex_state = 32},
  [5196] = {.lex_state = 100, .external_lex_state = 37},
  [5197] = {.lex_state = 100, .external_lex_state = 37},
  [5198] = {.lex_state = 100, .external_lex_state = 37},
  [5199] = {.lex_state = 100, .external_lex_state = 37},
  [5200] = {.lex_state = 110, .external_lex_state = 33},
  [5201] = {.lex_state = 100, .external_lex_state = 37},
  [5202] = {.lex_state = 100, .external_lex_state = 37},
  [5203] = {.lex_state = 214, .external_lex_state = 35},
  [5204] = {.lex_state = 100, .external_lex_state = 37},
  [5205] = {.lex_state = 110, .external_lex_state = 33},
  [5206] = {.lex_state = 214, .external_lex_state = 35},
  [5207] = {.lex_state = 214, .external_lex_state = 35},
  [5208] = {.lex_state = 100, .external_lex_state = 39},
  [5209] = {.lex_state = 214, .external_lex_state = 35},
  [5210] = {.lex_state = 100, .external_lex_state = 37},
  [5211] = {.lex_state = 214, .external_lex_state = 35},
  [5212] = {.lex_state = 101, .external_lex_state = 35},
  [5213] = {.lex_state = 100, .external_lex_state = 37},
  [5214] = {.lex_state = 225, .external_lex_state = 36},
  [5215] = {.lex_state = 101, .external_lex_state = 35},
  [5216] = {.lex_state = 101, .external_lex_state = 35},
  [5217] = {.lex_state = 214, .external_lex_state = 35},
  [5218] = {.lex_state = 101, .external_lex_state = 35},
  [5219] = {.lex_state = 101, .external_lex_state = 35},
  [5220] = {.lex_state = 214, .external_lex_state = 35},
  [5221] = {.lex_state = 101, .external_lex_state = 35},
  [5222] = {.lex_state = 101, .external_lex_state = 35},
  [5223] = {.lex_state = 101, .external_lex_state = 35},
  [5224] = {.lex_state = 101, .external_lex_state = 35},
  [5225] = {.lex_state = 101, .external_lex_state = 35},
  [5226] = {.lex_state = 101, .external_lex_state = 35},
  [5227] = {.lex_state = 101, .external_lex_state = 35},
  [5228] = {.lex_state = 100, .external_lex_state = 40},
  [5229] = {.lex_state = 101, .external_lex_state = 35},
  [5230] = {.lex_state = 101, .external_lex_state = 35},
  [5231] = {.lex_state = 101, .external_lex_state = 35},
  [5232] = {.lex_state = 101, .external_lex_state = 32},
  [5233] = {.lex_state = 101, .external_lex_state = 35},
  [5234] = {.lex_state = 101, .external_lex_state = 32},
  [5235] = {.lex_state = 99, .external_lex_state = 37},
  [5236] = {.lex_state = 101, .external_lex_state = 35},
  [5237] = {.lex_state = 101, .external_lex_state = 35},
  [5238] = {.lex_state = 101, .external_lex_state = 35},
  [5239] = {.lex_state = 101, .external_lex_state = 35},
  [5240] = {.lex_state = 101, .external_lex_state = 35},
  [5241] = {.lex_state = 101, .external_lex_state = 35},
  [5242] = {.lex_state = 99, .external_lex_state = 37},
  [5243] = {.lex_state = 101, .external_lex_state = 35},
  [5244] = {.lex_state = 101, .external_lex_state = 35},
  [5245] = {.lex_state = 101, .external_lex_state = 35},
  [5246] = {.lex_state = 101, .external_lex_state = 35},
  [5247] = {.lex_state = 100, .external_lex_state = 40},
  [5248] = {.lex_state = 101, .external_lex_state = 35},
  [5249] = {.lex_state = 101, .external_lex_state = 35},
  [5250] = {.lex_state = 214, .external_lex_state = 35},
  [5251] = {.lex_state = 101, .external_lex_state = 35},
  [5252] = {.lex_state = 101, .external_lex_state = 35},
  [5253] = {.lex_state = 101, .external_lex_state = 35},
  [5254] = {.lex_state = 214, .external_lex_state = 35},
  [5255] = {.lex_state = 214, .external_lex_state = 35},
  [5256] = {.lex_state = 101, .external_lex_state = 35},
  [5257] = {.lex_state = 101, .external_lex_state = 35},
  [5258] = {.lex_state = 101, .external_lex_state = 35},
  [5259] = {.lex_state = 225, .external_lex_state = 36},
  [5260] = {.lex_state = 225, .external_lex_state = 36},
  [5261] = {.lex_state = 101, .external_lex_state = 35},
  [5262] = {.lex_state = 101, .external_lex_state = 35},
  [5263] = {.lex_state = 99, .external_lex_state = 37},
  [5264] = {.lex_state = 101, .external_lex_state = 35},
  [5265] = {.lex_state = 101, .external_lex_state = 35},
  [5266] = {.lex_state = 110, .external_lex_state = 36},
  [5267] = {.lex_state = 110, .external_lex_state = 36},
  [5268] = {.lex_state = 101, .external_lex_state = 35},
  [5269] = {.lex_state = 101, .external_lex_state = 35},
  [5270] = {.lex_state = 101, .external_lex_state = 35},
  [5271] = {.lex_state = 101, .external_lex_state = 35},
  [5272] = {.lex_state = 225, .external_lex_state = 36},
  [5273] = {.lex_state = 101, .external_lex_state = 35},
  [5274] = {.lex_state = 225, .external_lex_state = 36},
  [5275] = {.lex_state = 101, .external_lex_state = 35},
  [5276] = {.lex_state = 99, .external_lex_state = 37},
  [5277] = {.lex_state = 225, .external_lex_state = 36},
  [5278] = {.lex_state = 101, .external_lex_state = 35},
  [5279] = {.lex_state = 101, .external_lex_state = 35},
  [5280] = {.lex_state = 101, .external_lex_state = 32},
  [5281] = {.lex_state = 101, .external_lex_state = 32},
  [5282] = {.lex_state = 101, .external_lex_state = 35},
  [5283] = {.lex_state = 101, .external_lex_state = 35},
  [5284] = {.lex_state = 101, .external_lex_state = 35},
  [5285] = {.lex_state = 101, .external_lex_state = 32},
  [5286] = {.lex_state = 101, .external_lex_state = 35},
  [5287] = {.lex_state = 101, .external_lex_state = 35},
  [5288] = {.lex_state = 101, .external_lex_state = 35},
  [5289] = {.lex_state = 101, .external_lex_state = 35},
  [5290] = {.lex_state = 101, .external_lex_state = 35},
  [5291] = {.lex_state = 101, .external_lex_state = 32},
  [5292] = {.lex_state = 101, .external_lex_state = 35},
  [5293] = {.lex_state = 101, .external_lex_state = 32},
  [5294] = {.lex_state = 101, .external_lex_state = 32},
  [5295] = {.lex_state = 225, .external_lex_state = 38},
  [5296] = {.lex_state = 107, .external_lex_state = 35},
  [5297] = {.lex_state = 100, .external_lex_state = 39},
  [5298] = {.lex_state = 104, .external_lex_state = 32},
  [5299] = {.lex_state = 107, .external_lex_state = 35},
  [5300] = {.lex_state = 101, .external_lex_state = 35},
  [5301] = {.lex_state = 100, .external_lex_state = 39},
  [5302] = {.lex_state = 100, .external_lex_state = 37},
  [5303] = {.lex_state = 100, .external_lex_state = 37},
  [5304] = {.lex_state = 107, .external_lex_state = 35},
  [5305] = {.lex_state = 100, .external_lex_state = 39},
  [5306] = {.lex_state = 104, .external_lex_state = 35},
  [5307] = {.lex_state = 225, .external_lex_state = 38},
  [5308] = {.lex_state = 101, .external_lex_state = 35},
  [5309] = {.lex_state = 225, .external_lex_state = 38},
  [5310] = {.lex_state = 101, .external_lex_state = 35},
  [5311] = {.lex_state = 101, .external_lex_state = 32},
  [5312] = {.lex_state = 101, .external_lex_state = 35},
  [5313] = {.lex_state = 101, .external_lex_state = 35},
  [5314] = {.lex_state = 101, .external_lex_state = 32},
  [5315] = {.lex_state = 101, .external_lex_state = 32},
  [5316] = {.lex_state = 101, .external_lex_state = 32},
  [5317] = {.lex_state = 101, .external_lex_state = 32},
  [5318] = {.lex_state = 101, .external_lex_state = 35},
  [5319] = {.lex_state = 100, .external_lex_state = 37},
  [5320] = {.lex_state = 100, .external_lex_state = 37},
  [5321] = {.lex_state = 101, .external_lex_state = 32},
  [5322] = {.lex_state = 101, .external_lex_state = 35},
  [5323] = {.lex_state = 104, .external_lex_state = 35},
  [5324] = {.lex_state = 101, .external_lex_state = 32},
  [5325] = {.lex_state = 100, .external_lex_state = 39},
  [5326] = {.lex_state = 101, .external_lex_state = 35},
  [5327] = {.lex_state = 225, .external_lex_state = 36},
  [5328] = {.lex_state = 225, .external_lex_state = 36},
  [5329] = {.lex_state = 225, .external_lex_state = 36},
  [5330] = {.lex_state = 225, .external_lex_state = 36},
  [5331] = {.lex_state = 225, .external_lex_state = 36},
  [5332] = {.lex_state = 225, .external_lex_state = 36},
  [5333] = {.lex_state = 225, .external_lex_state = 36},
  [5334] = {.lex_state = 225, .external_lex_state = 36},
  [5335] = {.lex_state = 225, .external_lex_state = 36},
  [5336] = {.lex_state = 225, .external_lex_state = 36},
  [5337] = {.lex_state = 225, .external_lex_state = 36},
  [5338] = {.lex_state = 225, .external_lex_state = 36},
  [5339] = {.lex_state = 225, .external_lex_state = 36},
  [5340] = {.lex_state = 214, .external_lex_state = 35},
  [5341] = {.lex_state = 101, .external_lex_state = 35},
  [5342] = {.lex_state = 225, .external_lex_state = 36},
  [5343] = {.lex_state = 225, .external_lex_state = 36},
  [5344] = {.lex_state = 225, .external_lex_state = 36},
  [5345] = {.lex_state = 225, .external_lex_state = 36},
  [5346] = {.lex_state = 101, .external_lex_state = 32},
  [5347] = {.lex_state = 107, .external_lex_state = 35},
  [5348] = {.lex_state = 101, .external_lex_state = 32},
  [5349] = {.lex_state = 101, .external_lex_state = 35},
  [5350] = {.lex_state = 225, .external_lex_state = 36},
  [5351] = {.lex_state = 225, .external_lex_state = 36},
  [5352] = {.lex_state = 225, .external_lex_state = 36},
  [5353] = {.lex_state = 214, .external_lex_state = 35},
  [5354] = {.lex_state = 214, .external_lex_state = 32},
  [5355] = {.lex_state = 225, .external_lex_state = 36},
  [5356] = {.lex_state = 225, .external_lex_state = 36},
  [5357] = {.lex_state = 225, .external_lex_state = 36},
  [5358] = {.lex_state = 225, .external_lex_state = 36},
  [5359] = {.lex_state = 225, .external_lex_state = 36},
  [5360] = {.lex_state = 225, .external_lex_state = 36},
  [5361] = {.lex_state = 225, .external_lex_state = 36},
  [5362] = {.lex_state = 225, .external_lex_state = 36},
  [5363] = {.lex_state = 101, .external_lex_state = 35},
  [5364] = {.lex_state = 101, .external_lex_state = 35},
  [5365] = {.lex_state = 225, .external_lex_state = 36},
  [5366] = {.lex_state = 101, .external_lex_state = 35},
  [5367] = {.lex_state = 225, .external_lex_state = 36},
  [5368] = {.lex_state = 107, .external_lex_state = 35},
  [5369] = {.lex_state = 101, .external_lex_state = 32},
  [5370] = {.lex_state = 104, .external_lex_state = 35},
  [5371] = {.lex_state = 214, .external_lex_state = 35},
  [5372] = {.lex_state = 101, .external_lex_state = 35},
  [5373] = {.lex_state = 225, .external_lex_state = 36},
  [5374] = {.lex_state = 225, .external_lex_state = 36},
  [5375] = {.lex_state = 225, .external_lex_state = 36},
  [5376] = {.lex_state = 225, .external_lex_state = 36},
  [5377] = {.lex_state = 101, .external_lex_state = 35},
  [5378] = {.lex_state = 225, .external_lex_state = 36},
  [5379] = {.lex_state = 101, .external_lex_state = 35},
  [5380] = {.lex_state = 101, .external_lex_state = 35},
  [5381] = {.lex_state = 101, .external_lex_state = 35},
  [5382] = {.lex_state = 225, .external_lex_state = 36},
  [5383] = {.lex_state = 225, .external_lex_state = 36},
  [5384] = {.lex_state = 225, .external_lex_state = 36},
  [5385] = {.lex_state = 225, .external_lex_state = 36},
  [5386] = {.lex_state = 225, .external_lex_state = 36},
  [5387] = {.lex_state = 225, .external_lex_state = 36},
  [5388] = {.lex_state = 225, .external_lex_state = 36},
  [5389] = {.lex_state = 225, .external_lex_state = 36},
  [5390] = {.lex_state = 225, .external_lex_state = 36},
  [5391] = {.lex_state = 214, .external_lex_state = 35},
  [5392] = {.lex_state = 225, .external_lex_state = 36},
  [5393] = {.lex_state = 225, .external_lex_state = 36},
  [5394] = {.lex_state = 214, .external_lex_state = 32},
  [5395] = {.lex_state = 225, .external_lex_state = 36},
  [5396] = {.lex_state = 214, .external_lex_state = 35},
  [5397] = {.lex_state = 225, .external_lex_state = 36},
  [5398] = {.lex_state = 101, .external_lex_state = 35},
  [5399] = {.lex_state = 214, .external_lex_state = 35},
  [5400] = {.lex_state = 225, .external_lex_state = 36},
  [5401] = {.lex_state = 225, .external_lex_state = 36},
  [5402] = {.lex_state = 225, .external_lex_state = 36},
  [5403] = {.lex_state = 101, .external_lex_state = 32},
  [5404] = {.lex_state = 225, .external_lex_state = 36},
  [5405] = {.lex_state = 225, .external_lex_state = 36},
  [5406] = {.lex_state = 225, .external_lex_state = 36},
  [5407] = {.lex_state = 225, .external_lex_state = 36},
  [5408] = {.lex_state = 225, .external_lex_state = 36},
  [5409] = {.lex_state = 225, .external_lex_state = 36},
  [5410] = {.lex_state = 225, .external_lex_state = 36},
  [5411] = {.lex_state = 225, .external_lex_state = 36},
  [5412] = {.lex_state = 101, .external_lex_state = 35},
  [5413] = {.lex_state = 225, .external_lex_state = 36},
  [5414] = {.lex_state = 101, .external_lex_state = 35},
  [5415] = {.lex_state = 225, .external_lex_state = 36},
  [5416] = {.lex_state = 225, .external_lex_state = 36},
  [5417] = {.lex_state = 101, .external_lex_state = 35},
  [5418] = {.lex_state = 214, .external_lex_state = 35},
  [5419] = {.lex_state = 225, .external_lex_state = 36},
  [5420] = {.lex_state = 225, .external_lex_state = 36},
  [5421] = {.lex_state = 214, .external_lex_state = 35},
  [5422] = {.lex_state = 225, .external_lex_state = 36},
  [5423] = {.lex_state = 225, .external_lex_state = 36},
  [5424] = {.lex_state = 101, .external_lex_state = 35},
  [5425] = {.lex_state = 214, .external_lex_state = 32},
  [5426] = {.lex_state = 225, .external_lex_state = 36},
  [5427] = {.lex_state = 225, .external_lex_state = 36},
  [5428] = {.lex_state = 225, .external_lex_state = 36},
  [5429] = {.lex_state = 225, .external_lex_state = 36},
  [5430] = {.lex_state = 225, .external_lex_state = 36},
  [5431] = {.lex_state = 225, .external_lex_state = 36},
  [5432] = {.lex_state = 225, .external_lex_state = 36},
  [5433] = {.lex_state = 225, .external_lex_state = 36},
  [5434] = {.lex_state = 225, .external_lex_state = 36},
  [5435] = {.lex_state = 225, .external_lex_state = 36},
  [5436] = {.lex_state = 225, .external_lex_state = 36},
  [5437] = {.lex_state = 225, .external_lex_state = 36},
  [5438] = {.lex_state = 225, .external_lex_state = 36},
  [5439] = {.lex_state = 225, .external_lex_state = 36},
  [5440] = {.lex_state = 101, .external_lex_state = 35},
  [5441] = {.lex_state = 214, .external_lex_state = 35},
  [5442] = {.lex_state = 225, .external_lex_state = 36},
  [5443] = {.lex_state = 214, .external_lex_state = 35},
  [5444] = {.lex_state = 225, .external_lex_state = 36},
  [5445] = {.lex_state = 225, .external_lex_state = 36},
  [5446] = {.lex_state = 225, .external_lex_state = 36},
  [5447] = {.lex_state = 225, .external_lex_state = 36},
  [5448] = {.lex_state = 225, .external_lex_state = 36},
  [5449] = {.lex_state = 101, .external_lex_state = 35},
  [5450] = {.lex_state = 225, .external_lex_state = 36},
  [5451] = {.lex_state = 225, .external_lex_state = 36},
  [5452] = {.lex_state = 101, .external_lex_state = 35},
  [5453] = {.lex_state = 225, .external_lex_state = 36},
  [5454] = {.lex_state = 225, .external_lex_state = 36},
  [5455] = {.lex_state = 214, .external_lex_state = 35},
  [5456] = {.lex_state = 225, .external_lex_state = 36},
  [5457] = {.lex_state = 225, .external_lex_state = 36},
  [5458] = {.lex_state = 225, .external_lex_state = 36},
  [5459] = {.lex_state = 225, .external_lex_state = 36},
  [5460] = {.lex_state = 214, .external_lex_state = 35},
  [5461] = {.lex_state = 225, .external_lex_state = 36},
  [5462] = {.lex_state = 225, .external_lex_state = 36},
  [5463] = {.lex_state = 225, .external_lex_state = 36},
  [5464] = {.lex_state = 225, .external_lex_state = 36},
  [5465] = {.lex_state = 225, .external_lex_state = 36},
  [5466] = {.lex_state = 225, .external_lex_state = 36},
  [5467] = {.lex_state = 225, .external_lex_state = 36},
  [5468] = {.lex_state = 225, .external_lex_state = 36},
  [5469] = {.lex_state = 225, .external_lex_state = 36},
  [5470] = {.lex_state = 225, .external_lex_state = 36},
  [5471] = {.lex_state = 225, .external_lex_state = 36},
  [5472] = {.lex_state = 225, .external_lex_state = 36},
  [5473] = {.lex_state = 225, .external_lex_state = 36},
  [5474] = {.lex_state = 225, .external_lex_state = 36},
  [5475] = {.lex_state = 225, .external_lex_state = 36},
  [5476] = {.lex_state = 225, .external_lex_state = 36},
  [5477] = {.lex_state = 225, .external_lex_state = 36},
  [5478] = {.lex_state = 101, .external_lex_state = 35},
  [5479] = {.lex_state = 225, .external_lex_state = 36},
  [5480] = {.lex_state = 101, .external_lex_state = 35},
  [5481] = {.lex_state = 225, .external_lex_state = 36},
  [5482] = {.lex_state = 225, .external_lex_state = 36},
  [5483] = {.lex_state = 225, .external_lex_state = 36},
  [5484] = {.lex_state = 225, .external_lex_state = 36},
  [5485] = {.lex_state = 225, .external_lex_state = 36},
  [5486] = {.lex_state = 225, .external_lex_state = 36},
  [5487] = {.lex_state = 225, .external_lex_state = 36},
  [5488] = {.lex_state = 225, .external_lex_state = 36},
  [5489] = {.lex_state = 101, .external_lex_state = 35},
  [5490] = {.lex_state = 101, .external_lex_state = 35},
  [5491] = {.lex_state = 225, .external_lex_state = 36},
  [5492] = {.lex_state = 101, .external_lex_state = 35},
  [5493] = {.lex_state = 225, .external_lex_state = 36},
  [5494] = {.lex_state = 225, .external_lex_state = 36},
  [5495] = {.lex_state = 119, .external_lex_state = 41},
  [5496] = {.lex_state = 214, .external_lex_state = 35},
  [5497] = {.lex_state = 214, .external_lex_state = 35},
  [5498] = {.lex_state = 119, .external_lex_state = 41},
  [5499] = {.lex_state = 119, .external_lex_state = 41},
  [5500] = {.lex_state = 119, .external_lex_state = 41},
  [5501] = {.lex_state = 214, .external_lex_state = 32},
  [5502] = {.lex_state = 214, .external_lex_state = 32},
  [5503] = {.lex_state = 214, .external_lex_state = 32},
  [5504] = {.lex_state = 119, .external_lex_state = 41},
  [5505] = {.lex_state = 119, .external_lex_state = 41},
  [5506] = {.lex_state = 214, .external_lex_state = 35},
  [5507] = {.lex_state = 214, .external_lex_state = 35},
  [5508] = {.lex_state = 119, .external_lex_state = 41},
  [5509] = {.lex_state = 214, .external_lex_state = 35},
  [5510] = {.lex_state = 214, .external_lex_state = 35},
  [5511] = {.lex_state = 119, .external_lex_state = 41},
  [5512] = {.lex_state = 101, .external_lex_state = 35},
  [5513] = {.lex_state = 119, .external_lex_state = 41},
  [5514] = {.lex_state = 214, .external_lex_state = 35},
  [5515] = {.lex_state = 214, .external_lex_state = 35},
  [5516] = {.lex_state = 214, .external_lex_state = 35},
  [5517] = {.lex_state = 101, .external_lex_state = 35},
  [5518] = {.lex_state = 214, .external_lex_state = 35},
  [5519] = {.lex_state = 119, .external_lex_state = 41},
  [5520] = {.lex_state = 214, .external_lex_state = 32},
  [5521] = {.lex_state = 214, .external_lex_state = 32},
  [5522] = {.lex_state = 101, .external_lex_state = 35},
  [5523] = {.lex_state = 119, .external_lex_state = 41},
  [5524] = {.lex_state = 214, .external_lex_state = 35},
  [5525] = {.lex_state = 101, .external_lex_state = 35},
  [5526] = {.lex_state = 214, .external_lex_state = 35},
  [5527] = {.lex_state = 214, .external_lex_state = 35},
  [5528] = {.lex_state = 101, .external_lex_state = 35},
  [5529] = {.lex_state = 101, .external_lex_state = 35},
  [5530] = {.lex_state = 119, .external_lex_state = 41},
  [5531] = {.lex_state = 214, .external_lex_state = 35},
  [5532] = {.lex_state = 214, .external_lex_state = 32},
  [5533] = {.lex_state = 214, .external_lex_state = 35},
  [5534] = {.lex_state = 119, .external_lex_state = 41},
  [5535] = {.lex_state = 119, .external_lex_state = 41},
  [5536] = {.lex_state = 101, .external_lex_state = 32},
  [5537] = {.lex_state = 119, .external_lex_state = 41},
  [5538] = {.lex_state = 214, .external_lex_state = 32},
  [5539] = {.lex_state = 101, .external_lex_state = 35},
  [5540] = {.lex_state = 101, .external_lex_state = 35},
  [5541] = {.lex_state = 214, .external_lex_state = 35},
  [5542] = {.lex_state = 214, .external_lex_state = 35},
  [5543] = {.lex_state = 214, .external_lex_state = 35},
  [5544] = {.lex_state = 214, .external_lex_state = 32},
  [5545] = {.lex_state = 214, .external_lex_state = 35},
  [5546] = {.lex_state = 214, .external_lex_state = 35},
  [5547] = {.lex_state = 214, .external_lex_state = 35},
  [5548] = {.lex_state = 119, .external_lex_state = 41},
  [5549] = {.lex_state = 214, .external_lex_state = 35},
  [5550] = {.lex_state = 214, .external_lex_state = 35},
  [5551] = {.lex_state = 214, .external_lex_state = 32},
  [5552] = {.lex_state = 214, .external_lex_state = 32},
  [5553] = {.lex_state = 214, .external_lex_state = 35},
  [5554] = {.lex_state = 214, .external_lex_state = 35},
  [5555] = {.lex_state = 214, .external_lex_state = 35},
  [5556] = {.lex_state = 119, .external_lex_state = 41},
  [5557] = {.lex_state = 101, .external_lex_state = 35},
  [5558] = {.lex_state = 101, .external_lex_state = 35},
  [5559] = {.lex_state = 214, .external_lex_state = 35},
  [5560] = {.lex_state = 214, .external_lex_state = 35},
  [5561] = {.lex_state = 214, .external_lex_state = 32},
  [5562] = {.lex_state = 101, .external_lex_state = 35},
  [5563] = {.lex_state = 214, .external_lex_state = 32},
  [5564] = {.lex_state = 214, .external_lex_state = 35},
  [5565] = {.lex_state = 119, .external_lex_state = 41},
  [5566] = {.lex_state = 214, .external_lex_state = 32},
  [5567] = {.lex_state = 214, .external_lex_state = 35},
  [5568] = {.lex_state = 119, .external_lex_state = 41},
  [5569] = {.lex_state = 119, .external_lex_state = 41},
  [5570] = {.lex_state = 119, .external_lex_state = 41},
  [5571] = {.lex_state = 214, .external_lex_state = 32},
  [5572] = {.lex_state = 214, .external_lex_state = 32},
  [5573] = {.lex_state = 101, .external_lex_state = 35},
  [5574] = {.lex_state = 119, .external_lex_state = 41},
  [5575] = {.lex_state = 214, .external_lex_state = 35},
  [5576] = {.lex_state = 214, .external_lex_state = 35},
  [5577] = {.lex_state = 101, .external_lex_state = 35},
  [5578] = {.lex_state = 214, .external_lex_state = 35},
  [5579] = {.lex_state = 230, .external_lex_state = 35},
  [5580] = {.lex_state = 230, .external_lex_state = 35},
  [5581] = {.lex_state = 230, .external_lex_state = 35},
  [5582] = {.lex_state = 230, .external_lex_state = 35},
  [5583] = {.lex_state = 214, .external_lex_state = 35},
  [5584] = {.lex_state = 230, .external_lex_state = 35},
  [5585] = {.lex_state = 101, .external_lex_state = 35},
  [5586] = {.lex_state = 230, .external_lex_state = 35},
  [5587] = {.lex_state = 230, .external_lex_state = 35},
  [5588] = {.lex_state = 230, .external_lex_state = 35},
  [5589] = {.lex_state = 230, .external_lex_state = 35},
  [5590] = {.lex_state = 230, .external_lex_state = 35},
  [5591] = {.lex_state = 230, .external_lex_state = 35},
  [5592] = {.lex_state = 230, .external_lex_state = 35},
  [5593] = {.lex_state = 230, .external_lex_state = 35},
  [5594] = {.lex_state = 107, .external_lex_state = 35},
  [5595] = {.lex_state = 230, .external_lex_state = 35},
  [5596] = {.lex_state = 230, .external_lex_state = 35},
  [5597] = {.lex_state = 230, .external_lex_state = 35},
  [5598] = {.lex_state = 230, .external_lex_state = 35},
  [5599] = {.lex_state = 101, .external_lex_state = 35},
  [5600] = {.lex_state = 230, .external_lex_state = 35},
  [5601] = {.lex_state = 230, .external_lex_state = 35},
  [5602] = {.lex_state = 230, .external_lex_state = 35},
  [5603] = {.lex_state = 230, .external_lex_state = 35},
  [5604] = {.lex_state = 214, .external_lex_state = 35},
  [5605] = {.lex_state = 230, .external_lex_state = 35},
  [5606] = {.lex_state = 214, .external_lex_state = 35},
  [5607] = {.lex_state = 230, .external_lex_state = 35},
  [5608] = {.lex_state = 230, .external_lex_state = 35},
  [5609] = {.lex_state = 230, .external_lex_state = 35},
  [5610] = {.lex_state = 101, .external_lex_state = 35},
  [5611] = {.lex_state = 230, .external_lex_state = 35},
  [5612] = {.lex_state = 80, .external_lex_state = 35},
  [5613] = {.lex_state = 230, .external_lex_state = 35},
  [5614] = {.lex_state = 230, .external_lex_state = 35},
  [5615] = {.lex_state = 230, .external_lex_state = 35},
  [5616] = {.lex_state = 230, .external_lex_state = 35},
  [5617] = {.lex_state = 230, .external_lex_state = 35},
  [5618] = {.lex_state = 230, .external_lex_state = 35},
  [5619] = {.lex_state = 230, .external_lex_state = 35},
  [5620] = {.lex_state = 230, .external_lex_state = 35},
  [5621] = {.lex_state = 230, .external_lex_state = 35},
  [5622] = {.lex_state = 230, .external_lex_state = 35},
  [5623] = {.lex_state = 230, .external_lex_state = 35},
  [5624] = {.lex_state = 214, .external_lex_state = 35},
  [5625] = {.lex_state = 230, .external_lex_state = 35},
  [5626] = {.lex_state = 230, .external_lex_state = 35},
  [5627] = {.lex_state = 230, .external_lex_state = 35},
  [5628] = {.lex_state = 214, .external_lex_state = 35},
  [5629] = {.lex_state = 230, .external_lex_state = 35},
  [5630] = {.lex_state = 214, .external_lex_state = 35},
  [5631] = {.lex_state = 230, .external_lex_state = 35},
  [5632] = {.lex_state = 230, .external_lex_state = 35},
  [5633] = {.lex_state = 230, .external_lex_state = 35},
  [5634] = {.lex_state = 230, .external_lex_state = 35},
  [5635] = {.lex_state = 230, .external_lex_state = 35},
  [5636] = {.lex_state = 230, .external_lex_state = 35},
  [5637] = {.lex_state = 230, .external_lex_state = 35},
  [5638] = {.lex_state = 214, .external_lex_state = 35},
  [5639] = {.lex_state = 230, .external_lex_state = 35},
  [5640] = {.lex_state = 93, .external_lex_state = 35},
  [5641] = {.lex_state = 80, .external_lex_state = 35},
  [5642] = {.lex_state = 101, .external_lex_state = 35},
  [5643] = {.lex_state = 214, .external_lex_state = 35},
  [5644] = {.lex_state = 101, .external_lex_state = 35},
  [5645] = {.lex_state = 101, .external_lex_state = 35},
  [5646] = {.lex_state = 101, .external_lex_state = 35},
  [5647] = {.lex_state = 214, .external_lex_state = 35},
  [5648] = {.lex_state = 101, .external_lex_state = 35},
  [5649] = {.lex_state = 214, .external_lex_state = 35},
  [5650] = {.lex_state = 214, .external_lex_state = 35},
  [5651] = {.lex_state = 80, .external_lex_state = 35},
  [5652] = {.lex_state = 101, .external_lex_state = 35},
  [5653] = {.lex_state = 101, .external_lex_state = 35},
  [5654] = {.lex_state = 214, .external_lex_state = 41},
  [5655] = {.lex_state = 93, .external_lex_state = 35},
  [5656] = {.lex_state = 214, .external_lex_state = 35},
  [5657] = {.lex_state = 101, .external_lex_state = 35},
  [5658] = {.lex_state = 80, .external_lex_state = 35},
  [5659] = {.lex_state = 214, .external_lex_state = 35},
  [5660] = {.lex_state = 214, .external_lex_state = 35},
  [5661] = {.lex_state = 214, .external_lex_state = 35},
  [5662] = {.lex_state = 101, .external_lex_state = 35},
  [5663] = {.lex_state = 214, .external_lex_state = 35},
  [5664] = {.lex_state = 214, .external_lex_state = 35},
  [5665] = {.lex_state = 80, .external_lex_state = 35},
  [5666] = {.lex_state = 101, .external_lex_state = 35},
  [5667] = {.lex_state = 93, .external_lex_state = 35},
  [5668] = {.lex_state = 101, .external_lex_state = 35},
  [5669] = {.lex_state = 93, .external_lex_state = 35},
  [5670] = {.lex_state = 214, .external_lex_state = 35},
  [5671] = {.lex_state = 101, .external_lex_state = 35},
  [5672] = {.lex_state = 101, .external_lex_state = 35},
  [5673] = {.lex_state = 101, .external_lex_state = 35},
  [5674] = {.lex_state = 101, .external_lex_state = 35},
  [5675] = {.lex_state = 101, .external_lex_state = 35},
  [5676] = {.lex_state = 101, .external_lex_state = 35},
  [5677] = {.lex_state = 80, .external_lex_state = 35},
  [5678] = {.lex_state = 80, .external_lex_state = 35},
  [5679] = {.lex_state = 80, .external_lex_state = 35},
  [5680] = {.lex_state = 80, .external_lex_state = 35},
  [5681] = {.lex_state = 93, .external_lex_state = 35},
  [5682] = {.lex_state = 101, .external_lex_state = 35},
  [5683] = {.lex_state = 214, .external_lex_state = 35},
  [5684] = {.lex_state = 80, .external_lex_state = 35},
  [5685] = {.lex_state = 214, .external_lex_state = 41},
  [5686] = {.lex_state = 101, .external_lex_state = 35},
  [5687] = {.lex_state = 101, .external_lex_state = 35},
  [5688] = {.lex_state = 101, .external_lex_state = 35},
  [5689] = {.lex_state = 93, .external_lex_state = 35},
  [5690] = {.lex_state = 80, .external_lex_state = 35},
  [5691] = {.lex_state = 214, .external_lex_state = 35},
  [5692] = {.lex_state = 101, .external_lex_state = 35},
  [5693] = {.lex_state = 214, .external_lex_state = 35},
  [5694] = {.lex_state = 101, .external_lex_state = 35},
  [5695] = {.lex_state = 101, .external_lex_state = 35},
  [5696] = {.lex_state = 214, .external_lex_state = 35},
  [5697] = {.lex_state = 101, .external_lex_state = 35},
  [5698] = {.lex_state = 101, .external_lex_state = 35},
  [5699] = {.lex_state = 80, .external_lex_state = 35},
  [5700] = {.lex_state = 101, .external_lex_state = 35},
  [5701] = {.lex_state = 101, .external_lex_state = 35},
  [5702] = {.lex_state = 101, .external_lex_state = 35},
  [5703] = {.lex_state = 80, .external_lex_state = 35},
  [5704] = {.lex_state = 101, .external_lex_state = 35},
  [5705] = {.lex_state = 101, .external_lex_state = 35},
  [5706] = {.lex_state = 101, .external_lex_state = 35},
  [5707] = {.lex_state = 101, .external_lex_state = 35},
  [5708] = {.lex_state = 101, .external_lex_state = 35},
  [5709] = {.lex_state = 214, .external_lex_state = 35},
  [5710] = {.lex_state = 80, .external_lex_state = 35},
  [5711] = {.lex_state = 214, .external_lex_state = 35},
  [5712] = {.lex_state = 80, .external_lex_state = 35},
  [5713] = {.lex_state = 101, .external_lex_state = 35},
  [5714] = {.lex_state = 93, .external_lex_state = 35},
  [5715] = {.lex_state = 214, .external_lex_state = 35},
  [5716] = {.lex_state = 80, .external_lex_state = 35},
  [5717] = {.lex_state = 101, .external_lex_state = 35},
  [5718] = {.lex_state = 80, .external_lex_state = 35},
  [5719] = {.lex_state = 80, .external_lex_state = 35},
  [5720] = {.lex_state = 80, .external_lex_state = 35},
  [5721] = {.lex_state = 101, .external_lex_state = 35},
  [5722] = {.lex_state = 80, .external_lex_state = 35},
  [5723] = {.lex_state = 93, .external_lex_state = 35},
  [5724] = {.lex_state = 101, .external_lex_state = 35},
  [5725] = {.lex_state = 101, .external_lex_state = 35},
  [5726] = {.lex_state = 214, .external_lex_state = 35},
  [5727] = {.lex_state = 214, .external_lex_state = 35},
  [5728] = {.lex_state = 214, .external_lex_state = 35},
  [5729] = {.lex_state = 214, .external_lex_state = 35},
  [5730] = {.lex_state = 214, .external_lex_state = 35},
  [5731] = {.lex_state = 214, .external_lex_state = 35},
  [5732] = {.lex_state = 80, .external_lex_state = 35},
  [5733] = {.lex_state = 214, .external_lex_state = 35},
  [5734] = {.lex_state = 101, .external_lex_state = 35},
  [5735] = {.lex_state = 101, .external_lex_state = 35},
  [5736] = {.lex_state = 80, .external_lex_state = 35},
  [5737] = {.lex_state = 80, .external_lex_state = 35},
  [5738] = {.lex_state = 101, .external_lex_state = 35},
  [5739] = {.lex_state = 101, .external_lex_state = 35},
  [5740] = {.lex_state = 101, .external_lex_state = 35},
  [5741] = {.lex_state = 101, .external_lex_state = 35},
  [5742] = {.lex_state = 101, .external_lex_state = 35},
  [5743] = {.lex_state = 80, .external_lex_state = 35},
  [5744] = {.lex_state = 101, .external_lex_state = 35},
  [5745] = {.lex_state = 101, .external_lex_state = 35},
  [5746] = {.lex_state = 101, .external_lex_state = 35},
  [5747] = {.lex_state = 101, .external_lex_state = 35},
  [5748] = {.lex_state = 101, .external_lex_state = 35},
  [5749] = {.lex_state = 101, .external_lex_state = 35},
  [5750] = {.lex_state = 101, .external_lex_state = 35},
  [5751] = {.lex_state = 101, .external_lex_state = 35},
  [5752] = {.lex_state = 101, .external_lex_state = 35},
  [5753] = {.lex_state = 214, .external_lex_state = 35},
  [5754] = {.lex_state = 214, .external_lex_state = 35},
  [5755] = {.lex_state = 214, .external_lex_state = 41},
  [5756] = {.lex_state = 93, .external_lex_state = 35},
  [5757] = {.lex_state = 241, .external_lex_state = 35},
  [5758] = {.lex_state = 214, .external_lex_state = 35},
  [5759] = {.lex_state = 246, .external_lex_state = 35},
  [5760] = {.lex_state = 101, .external_lex_state = 35},
  [5761] = {.lex_state = 80, .external_lex_state = 35},
  [5762] = {.lex_state = 101, .external_lex_state = 35},
  [5763] = {.lex_state = 101, .external_lex_state = 35},
  [5764] = {.lex_state = 101, .external_lex_state = 35},
  [5765] = {.lex_state = 80, .external_lex_state = 35},
  [5766] = {.lex_state = 214, .external_lex_state = 35},
  [5767] = {.lex_state = 101, .external_lex_state = 35},
  [5768] = {.lex_state = 101, .external_lex_state = 35},
  [5769] = {.lex_state = 101, .external_lex_state = 35},
  [5770] = {.lex_state = 101, .external_lex_state = 35},
  [5771] = {.lex_state = 101, .external_lex_state = 35},
  [5772] = {.lex_state = 101, .external_lex_state = 35},
  [5773] = {.lex_state = 101, .external_lex_state = 35},
  [5774] = {.lex_state = 214, .external_lex_state = 35},
  [5775] = {.lex_state = 101, .external_lex_state = 35},
  [5776] = {.lex_state = 101, .external_lex_state = 35},
  [5777] = {.lex_state = 80, .external_lex_state = 35},
  [5778] = {.lex_state = 101, .external_lex_state = 35},
  [5779] = {.lex_state = 101, .external_lex_state = 35},
  [5780] = {.lex_state = 101, .external_lex_state = 35},
  [5781] = {.lex_state = 101, .external_lex_state = 35},
  [5782] = {.lex_state = 101, .external_lex_state = 35},
  [5783] = {.lex_state = 101, .external_lex_state = 35},
  [5784] = {.lex_state = 101, .external_lex_state = 35},
  [5785] = {.lex_state = 101, .external_lex_state = 35},
  [5786] = {.lex_state = 101, .external_lex_state = 35},
  [5787] = {.lex_state = 101, .external_lex_state = 35},
  [5788] = {.lex_state = 101, .external_lex_state = 35},
  [5789] = {.lex_state = 101, .external_lex_state = 35},
  [5790] = {.lex_state = 101, .external_lex_state = 35},
  [5791] = {.lex_state = 101, .external_lex_state = 35},
  [5792] = {.lex_state = 101, .external_lex_state = 35},
  [5793] = {.lex_state = 101, .external_lex_state = 35},
  [5794] = {.lex_state = 101, .external_lex_state = 35},
  [5795] = {.lex_state = 214, .external_lex_state = 35},
  [5796] = {.lex_state = 101, .external_lex_state = 35},
  [5797] = {.lex_state = 101, .external_lex_state = 35},
  [5798] = {.lex_state = 80, .external_lex_state = 35},
  [5799] = {.lex_state = 101, .external_lex_state = 35},
  [5800] = {.lex_state = 101, .external_lex_state = 35},
  [5801] = {.lex_state = 101, .external_lex_state = 35},
  [5802] = {.lex_state = 80, .external_lex_state = 35},
  [5803] = {.lex_state = 101, .external_lex_state = 35},
  [5804] = {.lex_state = 80, .external_lex_state = 35},
  [5805] = {.lex_state = 214, .external_lex_state = 35},
  [5806] = {.lex_state = 93, .external_lex_state = 35},
  [5807] = {.lex_state = 101, .external_lex_state = 35},
  [5808] = {.lex_state = 101, .external_lex_state = 35},
  [5809] = {.lex_state = 214, .external_lex_state = 35},
  [5810] = {.lex_state = 101, .external_lex_state = 35},
  [5811] = {.lex_state = 93, .external_lex_state = 35},
  [5812] = {.lex_state = 101, .external_lex_state = 35},
  [5813] = {.lex_state = 214, .external_lex_state = 35},
  [5814] = {.lex_state = 101, .external_lex_state = 35},
  [5815] = {.lex_state = 214, .external_lex_state = 41},
  [5816] = {.lex_state = 101, .external_lex_state = 35},
  [5817] = {.lex_state = 101, .external_lex_state = 35},
  [5818] = {.lex_state = 80, .external_lex_state = 35},
  [5819] = {.lex_state = 101, .external_lex_state = 35},
  [5820] = {.lex_state = 101, .external_lex_state = 35},
  [5821] = {.lex_state = 101, .external_lex_state = 35},
  [5822] = {.lex_state = 101, .external_lex_state = 35},
  [5823] = {.lex_state = 101, .external_lex_state = 35},
  [5824] = {.lex_state = 101, .external_lex_state = 35},
  [5825] = {.lex_state = 214, .external_lex_state = 35},
  [5826] = {.lex_state = 214, .external_lex_state = 35},
  [5827] = {.lex_state = 214, .external_lex_state = 35},
  [5828] = {.lex_state = 101, .external_lex_state = 35},
  [5829] = {.lex_state = 101, .external_lex_state = 35},
  [5830] = {.lex_state = 101, .external_lex_state = 35},
  [5831] = {.lex_state = 214, .external_lex_state = 35},
  [5832] = {.lex_state = 214, .external_lex_state = 35},
  [5833] = {.lex_state = 101, .external_lex_state = 35},
  [5834] = {.lex_state = 101, .external_lex_state = 35},
  [5835] = {.lex_state = 101, .external_lex_state = 35},
  [5836] = {.lex_state = 101, .external_lex_state = 35},
  [5837] = {.lex_state = 101, .external_lex_state = 35},
  [5838] = {.lex_state = 214, .external_lex_state = 35},
  [5839] = {.lex_state = 101, .external_lex_state = 35},
  [5840] = {.lex_state = 101, .external_lex_state = 35},
  [5841] = {.lex_state = 101, .external_lex_state = 35},
  [5842] = {.lex_state = 101, .external_lex_state = 35},
  [5843] = {.lex_state = 80, .external_lex_state = 35},
  [5844] = {.lex_state = 214, .external_lex_state = 41},
  [5845] = {.lex_state = 214, .external_lex_state = 35},
  [5846] = {.lex_state = 101, .external_lex_state = 35},
  [5847] = {.lex_state = 101, .external_lex_state = 35},
  [5848] = {.lex_state = 101, .external_lex_state = 35},
  [5849] = {.lex_state = 101, .external_lex_state = 35},
  [5850] = {.lex_state = 80, .external_lex_state = 35},
  [5851] = {.lex_state = 101, .external_lex_state = 35},
  [5852] = {.lex_state = 101, .external_lex_state = 35},
  [5853] = {.lex_state = 101, .external_lex_state = 35},
  [5854] = {.lex_state = 101, .external_lex_state = 35},
  [5855] = {.lex_state = 101, .external_lex_state = 35},
  [5856] = {.lex_state = 80, .external_lex_state = 35},
  [5857] = {.lex_state = 80, .external_lex_state = 35},
  [5858] = {.lex_state = 80, .external_lex_state = 35},
  [5859] = {.lex_state = 214, .external_lex_state = 35},
  [5860] = {.lex_state = 214, .external_lex_state = 41},
  [5861] = {.lex_state = 101, .external_lex_state = 35},
  [5862] = {.lex_state = 80, .external_lex_state = 35},
  [5863] = {.lex_state = 214, .external_lex_state = 35},
  [5864] = {.lex_state = 101, .external_lex_state = 35},
  [5865] = {.lex_state = 214, .external_lex_state = 35},
  [5866] = {.lex_state = 101, .external_lex_state = 35},
  [5867] = {.lex_state = 214, .external_lex_state = 35},
  [5868] = {.lex_state = 214, .external_lex_state = 35},
  [5869] = {.lex_state = 214, .external_lex_state = 35},
  [5870] = {.lex_state = 101, .external_lex_state = 35},
  [5871] = {.lex_state = 214, .external_lex_state = 35},
  [5872] = {.lex_state = 93, .external_lex_state = 35},
  [5873] = {.lex_state = 93, .external_lex_state = 35},
  [5874] = {.lex_state = 80, .external_lex_state = 35},
  [5875] = {.lex_state = 80, .external_lex_state = 35},
  [5876] = {.lex_state = 80, .external_lex_state = 35},
  [5877] = {.lex_state = 214, .external_lex_state = 35},
  [5878] = {.lex_state = 80, .external_lex_state = 35},
  [5879] = {.lex_state = 93, .external_lex_state = 35},
  [5880] = {.lex_state = 214, .external_lex_state = 35},
  [5881] = {.lex_state = 101, .external_lex_state = 35},
  [5882] = {.lex_state = 214, .external_lex_state = 41},
  [5883] = {.lex_state = 214, .external_lex_state = 41},
  [5884] = {.lex_state = 214, .external_lex_state = 35},
  [5885] = {.lex_state = 101, .external_lex_state = 35},
  [5886] = {.lex_state = 101, .external_lex_state = 35},
  [5887] = {.lex_state = 93, .external_lex_state = 35},
  [5888] = {.lex_state = 80, .external_lex_state = 35},
  [5889] = {.lex_state = 80, .external_lex_state = 35},
  [5890] = {.lex_state = 80, .external_lex_state = 35},
  [5891] = {.lex_state = 101, .external_lex_state = 35},
  [5892] = {.lex_state = 101, .external_lex_state = 35},
  [5893] = {.lex_state = 214, .external_lex_state = 35},
  [5894] = {.lex_state = 214, .external_lex_state = 35},
  [5895] = {.lex_state = 214, .external_lex_state = 35},
  [5896] = {.lex_state = 101, .external_lex_state = 35},
  [5897] = {.lex_state = 101, .external_lex_state = 35},
  [5898] = {.lex_state = 93, .external_lex_state = 35},
  [5899] = {.lex_state = 101, .external_lex_state = 35},
  [5900] = {.lex_state = 101, .external_lex_state = 35},
  [5901] = {.lex_state = 214, .external_lex_state = 35},
  [5902] = {.lex_state = 214, .external_lex_state = 35},
  [5903] = {.lex_state = 101, .external_lex_state = 35},
  [5904] = {.lex_state = 214, .external_lex_state = 35},
  [5905] = {.lex_state = 101, .external_lex_state = 35},
  [5906] = {.lex_state = 214, .external_lex_state = 41},
  [5907] = {.lex_state = 214, .external_lex_state = 35},
  [5908] = {.lex_state = 80, .external_lex_state = 35},
  [5909] = {.lex_state = 214, .external_lex_state = 35},
  [5910] = {.lex_state = 101, .external_lex_state = 35},
  [5911] = {.lex_state = 80, .external_lex_state = 35},
  [5912] = {.lex_state = 101, .external_lex_state = 35},
  [5913] = {.lex_state = 80, .external_lex_state = 35},
  [5914] = {.lex_state = 214, .external_lex_state = 35},
  [5915] = {.lex_state = 101, .external_lex_state = 35},
  [5916] = {.lex_state = 93, .external_lex_state = 35},
  [5917] = {.lex_state = 101, .external_lex_state = 35},
  [5918] = {.lex_state = 101, .external_lex_state = 35},
  [5919] = {.lex_state = 101, .external_lex_state = 35},
  [5920] = {.lex_state = 101, .external_lex_state = 35},
  [5921] = {.lex_state = 101, .external_lex_state = 35},
  [5922] = {.lex_state = 101, .external_lex_state = 35},
  [5923] = {.lex_state = 101, .external_lex_state = 35},
  [5924] = {.lex_state = 80, .external_lex_state = 35},
  [5925] = {.lex_state = 101, .external_lex_state = 35},
  [5926] = {.lex_state = 80, .external_lex_state = 35},
  [5927] = {.lex_state = 101, .external_lex_state = 35},
  [5928] = {.lex_state = 101, .external_lex_state = 35},
  [5929] = {.lex_state = 80, .external_lex_state = 35},
  [5930] = {.lex_state = 80, .external_lex_state = 35},
  [5931] = {.lex_state = 80, .external_lex_state = 35},
  [5932] = {.lex_state = 80, .external_lex_state = 35},
  [5933] = {.lex_state = 80, .external_lex_state = 35},
  [5934] = {.lex_state = 93, .external_lex_state = 35},
  [5935] = {.lex_state = 101, .external_lex_state = 35},
  [5936] = {.lex_state = 93, .external_lex_state = 35},
  [5937] = {.lex_state = 214, .external_lex_state = 35},
  [5938] = {.lex_state = 101, .external_lex_state = 35},
  [5939] = {.lex_state = 101, .external_lex_state = 35},
  [5940] = {.lex_state = 80, .external_lex_state = 35},
  [5941] = {.lex_state = 241, .external_lex_state = 35},
  [5942] = {.lex_state = 246, .external_lex_state = 35},
  [5943] = {.lex_state = 93, .external_lex_state = 35},
  [5944] = {.lex_state = 101, .external_lex_state = 35},
  [5945] = {.lex_state = 101, .external_lex_state = 35},
  [5946] = {.lex_state = 80, .external_lex_state = 35},
  [5947] = {.lex_state = 80, .external_lex_state = 35},
  [5948] = {.lex_state = 80, .external_lex_state = 35},
  [5949] = {.lex_state = 80, .external_lex_state = 35},
  [5950] = {.lex_state = 80, .external_lex_state = 35},
  [5951] = {.lex_state = 80, .external_lex_state = 35},
  [5952] = {.lex_state = 80, .external_lex_state = 35},
  [5953] = {.lex_state = 80, .external_lex_state = 35},
  [5954] = {.lex_state = 101, .external_lex_state = 35},
  [5955] = {.lex_state = 101, .external_lex_state = 35},
  [5956] = {.lex_state = 93, .external_lex_state = 35},
  [5957] = {.lex_state = 101, .external_lex_state = 35},
  [5958] = {.lex_state = 101, .external_lex_state = 35},
  [5959] = {.lex_state = 101, .external_lex_state = 35},
  [5960] = {.lex_state = 101, .external_lex_state = 35},
  [5961] = {.lex_state = 101, .external_lex_state = 35},
  [5962] = {.lex_state = 101, .external_lex_state = 35},
  [5963] = {.lex_state = 101, .external_lex_state = 35},
  [5964] = {.lex_state = 101, .external_lex_state = 35},
  [5965] = {.lex_state = 101, .external_lex_state = 35},
  [5966] = {.lex_state = 101, .external_lex_state = 35},
  [5967] = {.lex_state = 214, .external_lex_state = 35},
  [5968] = {.lex_state = 80, .external_lex_state = 35},
  [5969] = {.lex_state = 101, .external_lex_state = 35},
  [5970] = {.lex_state = 80, .external_lex_state = 35},
  [5971] = {.lex_state = 93, .external_lex_state = 35},
  [5972] = {.lex_state = 80, .external_lex_state = 35},
  [5973] = {.lex_state = 80, .external_lex_state = 35},
  [5974] = {.lex_state = 80, .external_lex_state = 35},
  [5975] = {.lex_state = 101, .external_lex_state = 35},
  [5976] = {.lex_state = 93, .external_lex_state = 35},
  [5977] = {.lex_state = 101, .external_lex_state = 35},
  [5978] = {.lex_state = 80, .external_lex_state = 35},
  [5979] = {.lex_state = 80, .external_lex_state = 35},
  [5980] = {.lex_state = 80, .external_lex_state = 35},
  [5981] = {.lex_state = 214, .external_lex_state = 41},
  [5982] = {.lex_state = 214, .external_lex_state = 35},
  [5983] = {.lex_state = 80, .external_lex_state = 35},
  [5984] = {.lex_state = 214, .external_lex_state = 35},
  [5985] = {.lex_state = 214, .external_lex_state = 35},
  [5986] = {.lex_state = 101, .external_lex_state = 35},
  [5987] = {.lex_state = 93, .external_lex_state = 35},
  [5988] = {.lex_state = 101, .external_lex_state = 35},
  [5989] = {(TSStateId)(-1)},
  [5990] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_heredoc_body] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_program_token1] = ACTIONS(1),
    [anon_sym___END__] = ACTIONS(1),
    [anon_sym_BEGIN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_END] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_rescue] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_nil] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_next] = ACTIONS(1),
    [anon_sym_redo] = ACTIONS(1),
    [anon_sym_retry] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_unless] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACK2] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [sym_line] = ACTIONS(1),
    [sym_file] = ACTIONS(1),
    [sym_encoding] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_elsif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_begin] = ACTIONS(1),
    [anon_sym_ensure] = ACTIONS(1),
    [anon_sym_COLON_COLON2] = ACTIONS(1),
    [anon_sym_AMP_DOT] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON2] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_BANG_TILDE] = ACTIONS(1),
    [anon_sym_defined_QMARK] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS_AT] = ACTIONS(1),
    [anon_sym_DASH_AT] = ACTIONS(1),
    [anon_sym_TILDE_AT] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_EQ2] = ACTIONS(1),
    [anon_sym_undef] = ACTIONS(1),
    [anon_sym_alias] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_i] = ACTIONS(1),
    [anon_sym_ri] = ACTIONS(1),
    [anon_sym_r] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_self] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_constant] = ACTIONS(1),
    [aux_sym_constant_suffix_token1] = ACTIONS(1),
    [sym_instance_variable] = ACTIONS(1),
    [sym_class_variable] = ACTIONS(1),
    [sym_global_variable] = ACTIONS(1),
    [sym_character] = ACTIONS(1),
    [anon_sym_POUND_LBRACE] = ACTIONS(1),
    [sym__line_break] = ACTIONS(1),
    [sym__no_line_break] = ACTIONS(1),
    [sym_simple_symbol] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__symbol_start] = ACTIONS(1),
    [sym__subshell_start] = ACTIONS(1),
    [sym__regex_start] = ACTIONS(1),
    [sym__string_array_start] = ACTIONS(1),
    [sym__symbol_array_start] = ACTIONS(1),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_string_content] = ACTIONS(1),
    [sym_heredoc_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
    [sym_heredoc_end] = ACTIONS(1),
    [sym_heredoc_beginning] = ACTIONS(1),
    [sym__block_ampersand] = ACTIONS(1),
    [sym__splat_star] = ACTIONS(1),
    [sym__unary_minus] = ACTIONS(1),
    [sym__unary_minus_num] = ACTIONS(1),
    [sym__binary_minus] = ACTIONS(1),
    [sym__binary_star] = ACTIONS(1),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1),
    [sym_hash_key_symbol] = ACTIONS(1),
    [sym__identifier_suffix] = ACTIONS(1),
    [sym__constant_suffix] = ACTIONS(1),
    [sym__hash_splat_star_star] = ACTIONS(1),
    [sym__binary_star_star] = ACTIONS(1),
    [sym__element_reference_bracket] = ACTIONS(1),
    [sym__short_interpolation] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(5650),
    [sym__statements] = STATE(5506),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4775),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4750),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3321),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1928),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2140),
    [aux_sym__statements_repeat1] = STATE(314),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [aux_sym_program_token1] = ACTIONS(11),
    [anon_sym___END__] = ACTIONS(13),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_undef] = ACTIONS(77),
    [anon_sym_alias] = ACTIONS(79),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [2] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(2),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(129),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(129),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(129),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [3] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(3),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(129),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(129),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(129),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [4] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2235),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(4),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_RBRACE] = ACTIONS(179),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(181),
    [anon_sym_rescue] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_unless] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_until] = ACTIONS(181),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_elsif] = ACTIONS(181),
    [anon_sym_else] = ACTIONS(181),
    [anon_sym_then] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(181),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(179),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [5] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2235),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(5),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_RBRACE] = ACTIONS(179),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(181),
    [anon_sym_rescue] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_unless] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_until] = ACTIONS(181),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_elsif] = ACTIONS(181),
    [anon_sym_else] = ACTIONS(181),
    [anon_sym_then] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(181),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(179),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [6] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4449),
    [sym_argument_list] = STATE(2255),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(6),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(179),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(181),
    [anon_sym_rescue] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_unless] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_until] = ACTIONS(181),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_elsif] = ACTIONS(181),
    [anon_sym_else] = ACTIONS(181),
    [anon_sym_then] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(181),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(179),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [7] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4457),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(7),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(129),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(129),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(129),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [8] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2235),
    [sym__argument] = STATE(4629),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1986),
    [sym_identifier_suffix] = STATE(1981),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2544),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(8),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(179),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(179),
    [anon_sym___END__] = ACTIONS(181),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_unless] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_until] = ACTIONS(181),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(179),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [9] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4449),
    [sym_argument_list] = STATE(2255),
    [sym__argument] = STATE(4629),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1986),
    [sym_identifier_suffix] = STATE(1981),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2544),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(9),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(179),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(179),
    [anon_sym___END__] = ACTIONS(181),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_unless] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_until] = ACTIONS(181),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(179),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [10] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4629),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1986),
    [sym_identifier_suffix] = STATE(1981),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2544),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(10),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(123),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [11] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2235),
    [sym__argument] = STATE(4629),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1986),
    [sym_identifier_suffix] = STATE(1981),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2544),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(11),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(179),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(179),
    [anon_sym___END__] = ACTIONS(181),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_unless] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_until] = ACTIONS(181),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(179),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [12] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4629),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1986),
    [sym_identifier_suffix] = STATE(1981),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2544),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(12),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(123),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [13] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4457),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4629),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1986),
    [sym_identifier_suffix] = STATE(1981),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2544),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(13),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(123),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [14] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4457),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4870),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(14),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [15] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4870),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(15),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [16] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2235),
    [sym__argument] = STATE(4870),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(16),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_then] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(179),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [17] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2235),
    [sym__argument] = STATE(4870),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(17),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_then] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(179),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [18] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4449),
    [sym_argument_list] = STATE(2255),
    [sym__argument] = STATE(4870),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(18),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_then] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(179),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [19] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4870),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(19),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [20] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4449),
    [sym_argument_list] = STATE(2255),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(20),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_unless] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_until] = ACTIONS(181),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(179),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [21] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4457),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4922),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(21),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(259),
    [sym__splat_star] = ACTIONS(261),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(267),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(269),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [22] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4875),
    [sym_argument_list] = STATE(3106),
    [sym__argument] = STATE(4898),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(2907),
    [sym_block] = STATE(2906),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2002),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2864),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(22),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(273),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(271),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(355),
    [sym__splat_star] = ACTIONS(357),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(363),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(367),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [23] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4865),
    [sym_argument_list] = STATE(2848),
    [sym__argument] = STATE(4898),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(3007),
    [sym_block] = STATE(3005),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2002),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2864),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(23),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(369),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(371),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(271),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(355),
    [sym__splat_star] = ACTIONS(357),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(363),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(367),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [24] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4449),
    [sym_argument_list] = STATE(2255),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(24),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(373),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_unless] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_until] = ACTIONS(181),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(179),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [25] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4845),
    [sym_argument_list] = STATE(2834),
    [sym__argument] = STATE(4898),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(2907),
    [sym_block] = STATE(2906),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2002),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2864),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(25),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(369),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(371),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(271),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(355),
    [sym__splat_star] = ACTIONS(357),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(363),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(367),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [26] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4922),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(26),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(259),
    [sym__splat_star] = ACTIONS(261),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(267),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(269),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [27] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4922),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(27),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(259),
    [sym__splat_star] = ACTIONS(261),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(267),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(269),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [28] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4876),
    [sym_argument_list] = STATE(3150),
    [sym__argument] = STATE(4898),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(3007),
    [sym_block] = STATE(3005),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2002),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2864),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(28),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(273),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(271),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(355),
    [sym__splat_star] = ACTIONS(357),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(363),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(367),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [29] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4457),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(29),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [30] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4457),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(30),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(373),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [31] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2235),
    [sym__argument] = STATE(4922),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(31),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_then] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(179),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(259),
    [sym__splat_star] = ACTIONS(261),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(267),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(269),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [32] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4449),
    [sym_argument_list] = STATE(2255),
    [sym__argument] = STATE(4922),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(32),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_then] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(179),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(259),
    [sym__splat_star] = ACTIONS(261),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(267),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(269),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [33] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2235),
    [sym__argument] = STATE(4922),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(33),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_then] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(179),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(259),
    [sym__splat_star] = ACTIONS(261),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(267),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(269),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [34] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4865),
    [sym_argument_list] = STATE(2848),
    [sym__argument] = STATE(4898),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(3007),
    [sym_block] = STATE(3005),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2002),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2864),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(34),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(371),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(271),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(355),
    [sym__splat_star] = ACTIONS(357),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(363),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(367),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [35] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4875),
    [sym_argument_list] = STATE(3106),
    [sym__argument] = STATE(5026),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(2907),
    [sym_block] = STATE(2906),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2004),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3026),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(35),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(273),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(377),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(399),
    [sym__splat_star] = ACTIONS(401),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(407),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(409),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [36] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4865),
    [sym_argument_list] = STATE(2848),
    [sym__argument] = STATE(5026),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(3007),
    [sym_block] = STATE(3005),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2004),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3026),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(36),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(369),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(371),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(377),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(399),
    [sym__splat_star] = ACTIONS(401),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(407),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(409),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [37] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4845),
    [sym_argument_list] = STATE(2834),
    [sym__argument] = STATE(4898),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(2907),
    [sym_block] = STATE(2906),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2002),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2864),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(37),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(371),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(271),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(355),
    [sym__splat_star] = ACTIONS(357),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(363),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(367),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [38] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4845),
    [sym_argument_list] = STATE(2834),
    [sym__argument] = STATE(5026),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(2907),
    [sym_block] = STATE(2906),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2004),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3026),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(38),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(369),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(371),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(377),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(399),
    [sym__splat_star] = ACTIONS(401),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(407),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(409),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [39] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4876),
    [sym_argument_list] = STATE(3150),
    [sym__argument] = STATE(5026),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(3007),
    [sym_block] = STATE(3005),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2004),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3026),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(39),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(273),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(377),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(399),
    [sym__splat_star] = ACTIONS(401),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(407),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(409),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [40] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4845),
    [sym_argument_list] = STATE(2834),
    [sym__argument] = STATE(5026),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(2907),
    [sym_block] = STATE(2906),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2004),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3026),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(40),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(371),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(377),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(399),
    [sym__splat_star] = ACTIONS(401),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(407),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(409),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [41] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4865),
    [sym_argument_list] = STATE(2848),
    [sym__argument] = STATE(5026),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(3007),
    [sym_block] = STATE(3005),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2004),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3026),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(41),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(371),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(377),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(399),
    [sym__splat_star] = ACTIONS(401),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym_hash_key_symbol] = ACTIONS(407),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(409),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [42] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(42),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_RBRACE] = ACTIONS(411),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(413),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(413),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_elsif] = ACTIONS(413),
    [anon_sym_else] = ACTIONS(413),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(413),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [43] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4457),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(43),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(411),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(413),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(413),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_elsif] = ACTIONS(413),
    [anon_sym_else] = ACTIONS(413),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(413),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [44] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(44),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_RBRACE] = ACTIONS(411),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(413),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(413),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_elsif] = ACTIONS(413),
    [anon_sym_else] = ACTIONS(413),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(413),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [45] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4488),
    [sym_argument_list] = STATE(2349),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(45),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [46] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4497),
    [sym_argument_list] = STATE(2340),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(46),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [47] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4485),
    [sym_argument_list] = STATE(2362),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(47),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [48] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4511),
    [sym_argument_list] = STATE(2385),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(48),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_RBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(429),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_unless] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_until] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(429),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_elsif] = ACTIONS(429),
    [anon_sym_else] = ACTIONS(429),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(429),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [49] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2760),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4511),
    [sym_argument_list] = STATE(2385),
    [sym__argument] = STATE(4575),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5890),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2145),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1961),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2443),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(49),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(429),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_unless] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_until] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(429),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_elsif] = ACTIONS(429),
    [anon_sym_else] = ACTIONS(429),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(429),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [50] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2760),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4488),
    [sym_argument_list] = STATE(2349),
    [sym__argument] = STATE(4575),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5890),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2145),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1961),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2443),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(50),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [51] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2760),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4497),
    [sym_argument_list] = STATE(2340),
    [sym__argument] = STATE(4575),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5890),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2145),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1961),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2443),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(51),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [52] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2760),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4485),
    [sym_argument_list] = STATE(2362),
    [sym__argument] = STATE(4575),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5890),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2145),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1961),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2443),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(52),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [53] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4457),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4629),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1986),
    [sym_identifier_suffix] = STATE(1981),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2544),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(53),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(411),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(411),
    [anon_sym___END__] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [54] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4629),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1986),
    [sym_identifier_suffix] = STATE(1981),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2544),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(54),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(411),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(411),
    [anon_sym___END__] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [55] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4629),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1986),
    [sym_identifier_suffix] = STATE(1981),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2544),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(55),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(411),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(411),
    [anon_sym___END__] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [56] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4457),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4870),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(56),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [57] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4497),
    [sym_argument_list] = STATE(2340),
    [sym__argument] = STATE(4629),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1986),
    [sym_identifier_suffix] = STATE(1981),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2544),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(57),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(419),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [58] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4870),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(58),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [59] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4511),
    [sym_argument_list] = STATE(2385),
    [sym__argument] = STATE(4629),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1986),
    [sym_identifier_suffix] = STATE(1981),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2544),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(59),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(427),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(427),
    [anon_sym___END__] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_unless] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_until] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [60] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4485),
    [sym_argument_list] = STATE(2362),
    [sym__argument] = STATE(4629),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1986),
    [sym_identifier_suffix] = STATE(1981),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2544),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(60),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(423),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [61] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4488),
    [sym_argument_list] = STATE(2349),
    [sym__argument] = STATE(4629),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1986),
    [sym_identifier_suffix] = STATE(1981),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2544),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(61),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(415),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [62] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4457),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(62),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(373),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [63] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4457),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4922),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(63),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(259),
    [sym__splat_star] = ACTIONS(261),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(267),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(269),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [64] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4875),
    [sym_argument_list] = STATE(3106),
    [sym__argument] = STATE(4898),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(2907),
    [sym_block] = STATE(2906),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2002),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2864),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(64),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(273),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(411),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(271),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(355),
    [sym__splat_star] = ACTIONS(357),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(363),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(367),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [65] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3165),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4497),
    [sym_argument_list] = STATE(2340),
    [sym__argument] = STATE(4662),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5983),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2655),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(65),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(419),
    [sym_identifier] = ACTIONS(463),
    [aux_sym_program_token1] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [66] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4922),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(66),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(259),
    [sym__splat_star] = ACTIONS(261),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(267),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(269),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [67] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3165),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4511),
    [sym_argument_list] = STATE(2385),
    [sym__argument] = STATE(4662),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5983),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2655),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(67),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(427),
    [sym_identifier] = ACTIONS(463),
    [aux_sym_program_token1] = ACTIONS(427),
    [anon_sym___END__] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_unless] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_until] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [68] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3165),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4485),
    [sym_argument_list] = STATE(2362),
    [sym__argument] = STATE(4662),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5983),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2655),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(68),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(423),
    [sym_identifier] = ACTIONS(463),
    [aux_sym_program_token1] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [69] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4870),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(69),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [70] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3165),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4488),
    [sym_argument_list] = STATE(2349),
    [sym__argument] = STATE(4662),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5983),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2655),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(70),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(415),
    [sym_identifier] = ACTIONS(463),
    [aux_sym_program_token1] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [71] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4845),
    [sym_argument_list] = STATE(2834),
    [sym__argument] = STATE(4898),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(2907),
    [sym_block] = STATE(2906),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2002),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2864),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(71),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(369),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(371),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(411),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(271),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(355),
    [sym__splat_star] = ACTIONS(357),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(363),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(367),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [72] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4439),
    [sym_argument_list] = STATE(2246),
    [sym__argument] = STATE(4922),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(72),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(259),
    [sym__splat_star] = ACTIONS(261),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(267),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(269),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [73] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4497),
    [sym_argument_list] = STATE(2340),
    [sym__argument] = STATE(4870),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(73),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [74] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4457),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(74),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [75] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4511),
    [sym_argument_list] = STATE(2385),
    [sym__argument] = STATE(4870),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(75),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [76] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4875),
    [sym_argument_list] = STATE(3106),
    [sym__argument] = STATE(5026),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(2907),
    [sym_block] = STATE(2906),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2004),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3026),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(76),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(273),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(411),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(377),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(399),
    [sym__splat_star] = ACTIONS(401),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(407),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(409),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [77] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4485),
    [sym_argument_list] = STATE(2362),
    [sym__argument] = STATE(4870),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(77),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [78] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4845),
    [sym_argument_list] = STATE(2834),
    [sym__argument] = STATE(5026),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(2907),
    [sym_block] = STATE(2906),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2004),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3026),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(78),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(369),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(371),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(411),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(377),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(399),
    [sym__splat_star] = ACTIONS(401),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(407),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(409),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [79] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4488),
    [sym_argument_list] = STATE(2349),
    [sym__argument] = STATE(4870),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(79),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [80] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5006),
    [sym_argument_list] = STATE(2937),
    [sym__argument] = STATE(4898),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2002),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2864),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(80),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(271),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(355),
    [sym__splat_star] = ACTIONS(357),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(363),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(367),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [81] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4939),
    [sym_argument_list] = STATE(2971),
    [sym__argument] = STATE(4898),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2002),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2864),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(81),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(427),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(271),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(355),
    [sym__splat_star] = ACTIONS(357),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(363),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(367),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [82] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3447),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4497),
    [sym_argument_list] = STATE(2340),
    [sym__argument] = STATE(4755),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1994),
    [sym_identifier_suffix] = STATE(1995),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2730),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(82),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(487),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(507),
    [sym__splat_star] = ACTIONS(509),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(515),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(517),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [83] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3447),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4488),
    [sym_argument_list] = STATE(2349),
    [sym__argument] = STATE(4755),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1994),
    [sym_identifier_suffix] = STATE(1995),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2730),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(83),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(487),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(507),
    [sym__splat_star] = ACTIONS(509),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(515),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(517),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [84] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2760),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4497),
    [sym_argument_list] = STATE(2340),
    [sym__argument] = STATE(5012),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5761),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1961),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2443),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(84),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(531),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [85] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2760),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4488),
    [sym_argument_list] = STATE(2349),
    [sym__argument] = STATE(5012),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5761),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1961),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2443),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(85),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(531),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [86] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2760),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4485),
    [sym_argument_list] = STATE(2362),
    [sym__argument] = STATE(5012),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5761),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1961),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2443),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(86),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(531),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [87] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2760),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4511),
    [sym_argument_list] = STATE(2385),
    [sym__argument] = STATE(5012),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5761),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1961),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2443),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(87),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(531),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [88] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3447),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4485),
    [sym_argument_list] = STATE(2362),
    [sym__argument] = STATE(4755),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1994),
    [sym_identifier_suffix] = STATE(1995),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2730),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(88),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(487),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(507),
    [sym__splat_star] = ACTIONS(509),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(515),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(517),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [89] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4485),
    [sym_argument_list] = STATE(2362),
    [sym__argument] = STATE(4922),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(89),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(259),
    [sym__splat_star] = ACTIONS(261),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(267),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(269),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [90] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5002),
    [sym_argument_list] = STATE(2959),
    [sym__argument] = STATE(4898),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2002),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2864),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(90),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(271),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(355),
    [sym__splat_star] = ACTIONS(357),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(363),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(367),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [91] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4488),
    [sym_argument_list] = STATE(2349),
    [sym__argument] = STATE(4922),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(91),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(259),
    [sym__splat_star] = ACTIONS(261),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(267),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(269),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [92] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5021),
    [sym_argument_list] = STATE(2928),
    [sym__argument] = STATE(4898),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2002),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2864),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(92),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(271),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(355),
    [sym__splat_star] = ACTIONS(357),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(363),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(367),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [93] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4497),
    [sym_argument_list] = STATE(2340),
    [sym__argument] = STATE(4922),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(93),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(259),
    [sym__splat_star] = ACTIONS(261),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(267),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(269),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [94] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3447),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4511),
    [sym_argument_list] = STATE(2385),
    [sym__argument] = STATE(4755),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1994),
    [sym_identifier_suffix] = STATE(1995),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2730),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(94),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_unless] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_until] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(487),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(507),
    [sym__splat_star] = ACTIONS(509),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(515),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(517),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [95] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4511),
    [sym_argument_list] = STATE(2385),
    [sym__argument] = STATE(4922),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(95),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(259),
    [sym__splat_star] = ACTIONS(261),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(267),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(269),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [96] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4845),
    [sym_argument_list] = STATE(2834),
    [sym__argument] = STATE(4898),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(2907),
    [sym_block] = STATE(2906),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2002),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2864),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(96),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(371),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(271),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(355),
    [sym__splat_star] = ACTIONS(357),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(363),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(367),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [97] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3901),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4497),
    [sym_argument_list] = STATE(2340),
    [sym__argument] = STATE(5147),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5924),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(66),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2457),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1990),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(3127),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(97),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(557),
    [sym__splat_star] = ACTIONS(559),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(565),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(567),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [98] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3899),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4939),
    [sym_argument_list] = STATE(2971),
    [sym__argument] = STATE(5212),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5911),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2452),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(1993),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3146),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(98),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(427),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(569),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(601),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [99] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5021),
    [sym_argument_list] = STATE(2928),
    [sym__argument] = STATE(5026),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2004),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3026),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(99),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(377),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(399),
    [sym__splat_star] = ACTIONS(401),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(407),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(409),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [100] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5006),
    [sym_argument_list] = STATE(2937),
    [sym__argument] = STATE(5026),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2004),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3026),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(100),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(377),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(399),
    [sym__splat_star] = ACTIONS(401),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(407),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(409),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [101] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5002),
    [sym_argument_list] = STATE(2959),
    [sym__argument] = STATE(5026),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2004),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3026),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(101),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(377),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(399),
    [sym__splat_star] = ACTIONS(401),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(407),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(409),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [102] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4939),
    [sym_argument_list] = STATE(2971),
    [sym__argument] = STATE(5026),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2004),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3026),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(102),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(427),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(377),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(399),
    [sym__splat_star] = ACTIONS(401),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(407),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(409),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [103] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3901),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4488),
    [sym_argument_list] = STATE(2349),
    [sym__argument] = STATE(5147),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5924),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(66),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2457),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1990),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(3127),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(103),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(557),
    [sym__splat_star] = ACTIONS(559),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(565),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(567),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [104] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3901),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4485),
    [sym_argument_list] = STATE(2362),
    [sym__argument] = STATE(5147),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5924),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(66),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2457),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1990),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(3127),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(104),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(557),
    [sym__splat_star] = ACTIONS(559),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(565),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(567),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [105] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3901),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4511),
    [sym_argument_list] = STATE(2385),
    [sym__argument] = STATE(5147),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5924),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(66),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2457),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1990),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(3127),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(105),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(557),
    [sym__splat_star] = ACTIONS(559),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(565),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(567),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [106] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3899),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5021),
    [sym_argument_list] = STATE(2928),
    [sym__argument] = STATE(5212),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5911),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2452),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(1993),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3146),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(106),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(569),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(601),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [107] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3899),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5006),
    [sym_argument_list] = STATE(2937),
    [sym__argument] = STATE(5212),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5911),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2452),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(1993),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3146),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(107),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(569),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(601),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [108] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3899),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5002),
    [sym_argument_list] = STATE(2959),
    [sym__argument] = STATE(5212),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5911),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2452),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(1993),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3146),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(108),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(569),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(601),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [109] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4845),
    [sym_argument_list] = STATE(2834),
    [sym__argument] = STATE(5026),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_do_block] = STATE(2907),
    [sym_block] = STATE(2906),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2004),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3026),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(109),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(371),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(377),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(399),
    [sym__splat_star] = ACTIONS(401),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(407),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(409),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [110] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4032),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5006),
    [sym_argument_list] = STATE(2937),
    [sym__argument] = STATE(5270),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2003),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3209),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(110),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(633),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [111] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4032),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(4939),
    [sym_argument_list] = STATE(2971),
    [sym__argument] = STATE(5270),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2003),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3209),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(111),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(427),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(633),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [112] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4032),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5021),
    [sym_argument_list] = STATE(2928),
    [sym__argument] = STATE(5270),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2003),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3209),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(112),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(633),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [113] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4032),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5002),
    [sym_argument_list] = STATE(2959),
    [sym__argument] = STATE(5270),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2003),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3209),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(113),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(633),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [114] = {
    [sym__statements] = STATE(5967),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_expr] = STATE(5578),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(3149),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5612),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2240),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2812),
    [sym_subshell] = STATE(3149),
    [sym_string_array] = STATE(3149),
    [sym_symbol_array] = STATE(3149),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(3149),
    [sym_heredoc_body] = STATE(114),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(3152),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(637),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_COLON_COLON] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_DOT_DOT] = ACTIONS(653),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(671),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_constant] = ACTIONS(675),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(677),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [115] = {
    [sym__statements] = STATE(5967),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_expr] = STATE(5630),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(3149),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5612),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2240),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2812),
    [sym_subshell] = STATE(3149),
    [sym_string_array] = STATE(3149),
    [sym_symbol_array] = STATE(3149),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(3149),
    [sym_heredoc_body] = STATE(115),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(3152),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(637),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_COLON_COLON] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_DOT_DOT] = ACTIONS(653),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(671),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_constant] = ACTIONS(675),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(677),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [116] = {
    [sym__statements] = STATE(5869),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_expr] = STATE(5630),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(3149),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5612),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2240),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2812),
    [sym_subshell] = STATE(3149),
    [sym_string_array] = STATE(3149),
    [sym_symbol_array] = STATE(3149),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(3149),
    [sym_heredoc_body] = STATE(116),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(3152),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(637),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_COLON_COLON] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_DOT_DOT] = ACTIONS(653),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(671),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_constant] = ACTIONS(675),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(677),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [117] = {
    [sym__statements] = STATE(5869),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_expr] = STATE(5578),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(3149),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5612),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2240),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2812),
    [sym_subshell] = STATE(3149),
    [sym_string_array] = STATE(3149),
    [sym_symbol_array] = STATE(3149),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(3149),
    [sym_heredoc_body] = STATE(117),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(3152),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(637),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_COLON_COLON] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_DOT_DOT] = ACTIONS(653),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(671),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_constant] = ACTIONS(675),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(677),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [118] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_splat_parameter] = STATE(4989),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5460),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym__array_pattern_body] = STATE(5754),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(5753),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5859),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3671),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2571),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3262),
    [sym_subshell] = STATE(3671),
    [sym_string_array] = STATE(3671),
    [sym_symbol_array] = STATE(3671),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3671),
    [sym_heredoc_body] = STATE(118),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(3674),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(703),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(707),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(711),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [119] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_splat_parameter] = STATE(4989),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5460),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym__array_pattern_body] = STATE(5754),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(5753),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5859),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3671),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2571),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3262),
    [sym_subshell] = STATE(3671),
    [sym_string_array] = STATE(3671),
    [sym_symbol_array] = STATE(3671),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3671),
    [sym_heredoc_body] = STATE(119),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(3674),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(703),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(707),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(711),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [120] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_splat_parameter] = STATE(4989),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5460),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym__array_pattern_body] = STATE(5831),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(5832),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5859),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3671),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2571),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3262),
    [sym_subshell] = STATE(3671),
    [sym_string_array] = STATE(3671),
    [sym_symbol_array] = STATE(3671),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3671),
    [sym_heredoc_body] = STATE(120),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(3674),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(727),
    [anon_sym_DOT_DOT] = ACTIONS(703),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(707),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(711),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [121] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_splat_parameter] = STATE(4989),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5460),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym__array_pattern_body] = STATE(5754),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(5753),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5907),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3671),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2571),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3262),
    [sym_subshell] = STATE(3671),
    [sym_string_array] = STATE(3671),
    [sym_symbol_array] = STATE(3671),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3671),
    [sym_heredoc_body] = STATE(121),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(3674),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(729),
    [anon_sym_DOT_DOT] = ACTIONS(703),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(707),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(711),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [122] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_splat_parameter] = STATE(4989),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5460),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym__array_pattern_body] = STATE(5831),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(5832),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5907),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3671),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2571),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3262),
    [sym_subshell] = STATE(3671),
    [sym_string_array] = STATE(3671),
    [sym_symbol_array] = STATE(3671),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3671),
    [sym_heredoc_body] = STATE(122),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(3674),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(703),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(707),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(711),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [123] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_superclass] = STATE(5551),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5957),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(123),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(219),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(735),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [124] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_superclass] = STATE(5566),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5694),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(124),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(204),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(755),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [125] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_superclass] = STATE(5503),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5830),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(125),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(216),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(757),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [126] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_superclass] = STATE(5566),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5694),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(126),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(204),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(755),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [127] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5695),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(127),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(206),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(759),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [128] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_superclass] = STATE(5551),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5957),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(128),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(219),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(735),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [129] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5986),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(129),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(218),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(761),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [130] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5828),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(130),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(215),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(763),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [131] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_superclass] = STATE(5503),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5830),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(131),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(216),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(757),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [132] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5695),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(132),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(206),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(759),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [133] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5828),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(133),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(215),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(763),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [134] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5986),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(134),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(218),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(761),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [135] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(2324),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5671),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(135),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(234),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [136] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(3038),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5794),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(136),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [137] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(2324),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5671),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(137),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(234),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [138] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(170),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5686),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(138),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(171),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [139] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(3038),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5794),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(139),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(779),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [140] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(2324),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5671),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(140),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(234),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(781),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [141] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(3038),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5794),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(141),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [142] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(3038),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5794),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(142),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [143] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(3038),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5794),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(143),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(787),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [144] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(182),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5834),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(144),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(191),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(789),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [145] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(2324),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5671),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(145),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(234),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [146] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(189),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5717),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(146),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(188),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(793),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [147] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(2324),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5671),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(147),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(234),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(795),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [148] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(3038),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5794),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(148),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [149] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(5334),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5738),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(149),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(236),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(799),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(801),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [150] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(190),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5810),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(150),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(196),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(803),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [151] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(180),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5881),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(151),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(181),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(805),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [152] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(3038),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5794),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(152),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [153] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(192),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5886),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(153),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(198),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(809),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [154] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(2324),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5671),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(154),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(234),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [155] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(2324),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5671),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(155),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(234),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [156] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(2324),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5671),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(156),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(234),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [157] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(183),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5642),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(157),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(184),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(817),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [158] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(3038),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5794),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(158),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(819),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [159] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(176),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5896),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(159),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(175),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(821),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [160] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(2324),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5671),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(160),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(234),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(823),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [161] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(2324),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5671),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(161),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(234),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [162] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(177),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5870),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(162),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(178),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(827),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [163] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(3038),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5794),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(163),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [164] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(2324),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5671),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(164),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(234),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(831),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [165] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(3038),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5794),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(165),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [166] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(2324),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5671),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(166),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(234),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(835),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [167] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(186),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5988),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(167),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(185),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(837),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [168] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym__body_expr] = STATE(2324),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5671),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(168),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(234),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [169] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5645),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(169),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(237),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(841),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [170] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5692),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(170),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(243),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(843),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [171] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(193),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5697),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(171),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(845),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [172] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5923),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(172),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(221),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(847),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [173] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5920),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(173),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(849),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [174] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5734),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(174),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(207),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(851),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [175] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(173),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5915),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(175),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(853),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [176] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5910),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(176),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(227),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(855),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [177] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5835),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(177),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(230),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(857),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [178] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(179),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5853),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(178),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(859),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [179] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5846),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(179),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(232),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(861),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [180] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5769),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(180),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(209),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(863),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [181] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(197),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5789),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(181),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(865),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [182] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5839),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(182),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(225),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(867),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [183] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5648),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(183),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(241),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(869),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [184] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(169),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5652),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(184),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(871),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [185] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(172),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5927),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(185),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(873),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [186] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5928),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(186),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(220),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(875),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [187] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5821),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(187),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(235),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [188] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(187),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5797),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(188),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(879),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [189] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5796),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(189),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(205),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(881),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [190] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5763),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(190),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(208),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(883),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [191] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(195),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5840),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(191),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(885),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [192] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5891),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(192),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(213),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [193] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5702),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(193),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(242),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(889),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [194] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5899),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(194),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(891),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [195] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5851),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(195),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(224),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [196] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(174),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5760),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(196),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(895),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [197] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5786),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(197),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(239),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(897),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [198] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(194),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5892),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(198),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [199] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym__body_statement] = STATE(5885),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(199),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(245),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(901),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [200] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym__body_statement] = STATE(5672),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(200),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(244),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(903),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [201] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym__body_statement] = STATE(5855),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(201),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(247),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [202] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2499),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(202),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(911),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(911),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_elsif] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(911),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [203] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2506),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(203),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(949),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(949),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_elsif] = ACTIONS(949),
    [anon_sym_else] = ACTIONS(949),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(949),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [204] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5746),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(204),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(951),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [205] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5819),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(205),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(953),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [206] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5749),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(206),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(955),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [207] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5721),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(207),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(957),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [208] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5687),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(208),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(959),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [209] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5787),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(209),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(961),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [210] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5745),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(210),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(963),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [211] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5900),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(211),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(965),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [212] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5747),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(212),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(967),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [213] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5897),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(213),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(969),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [214] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5748),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(214),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(971),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [215] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5790),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(215),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(973),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [216] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5791),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(216),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(975),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [217] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5792),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(217),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(977),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [218] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5666),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(218),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(979),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [219] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5662),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(219),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(981),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [220] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5925),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(220),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(983),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [221] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5922),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(221),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(985),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [222] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5921),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(222),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(987),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [223] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5657),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(223),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(989),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [224] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5852),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(224),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(991),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [225] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5849),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(225),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [226] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2551),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(226),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(911),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(911),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_elsif] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(911),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [227] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5918),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(227),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1013),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [228] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5938),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(228),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1015),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [229] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5935),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(229),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1017),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [230] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5847),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(230),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1019),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [231] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5742),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(231),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1021),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [232] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5842),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(232),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1023),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [233] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2557),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(233),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(949),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(949),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_elsif] = ACTIONS(949),
    [anon_sym_else] = ACTIONS(949),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(949),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [234] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5864),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(234),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1025),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [235] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5824),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(235),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1027),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [236] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5799),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(236),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1029),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [237] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5646),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(237),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1031),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [238] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5800),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(238),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1033),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [239] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5955),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(239),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1035),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [240] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5801),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(240),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1037),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [241] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5644),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(241),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1039),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [242] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5705),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(242),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1041),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [243] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym_body_statement] = STATE(5700),
    [sym__body_statement] = STATE(5959),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(243),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1043),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [244] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym__body_statement] = STATE(5708),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(244),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1045),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [245] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym__body_statement] = STATE(5912),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(245),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1047),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [246] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2654),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(246),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(949),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(949),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_elsif] = ACTIONS(949),
    [anon_sym_else] = ACTIONS(949),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(949),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [247] = {
    [sym__statements] = STATE(4993),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5412),
    [sym_begin] = STATE(2359),
    [sym_ensure] = STATE(5412),
    [sym_rescue] = STATE(5412),
    [sym__body_statement] = STATE(5814),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(247),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [aux_sym__body_statement_repeat1] = STATE(4999),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1067),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [248] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4487),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(248),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1071),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(1071),
    [anon_sym_unless] = ACTIONS(1071),
    [anon_sym_while] = ACTIONS(1071),
    [anon_sym_until] = ACTIONS(1071),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_elsif] = ACTIONS(1071),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_then] = ACTIONS(1071),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1071),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
  },
  [249] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2760),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4487),
    [sym__argument] = STATE(4575),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5890),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2145),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1961),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2443),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(249),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1071),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(1071),
    [anon_sym_unless] = ACTIONS(1071),
    [anon_sym_while] = ACTIONS(1071),
    [anon_sym_until] = ACTIONS(1071),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_elsif] = ACTIONS(1071),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_then] = ACTIONS(1071),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1071),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
  },
  [250] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4622),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(250),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(251),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [251] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(5030),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(251),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(251),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_BEGIN] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_RBRACE] = ACTIONS(1102),
    [anon_sym_END] = ACTIONS(1104),
    [anon_sym_def] = ACTIONS(1107),
    [anon_sym_LPAREN] = ACTIONS(1110),
    [anon_sym_RPAREN] = ACTIONS(1102),
    [anon_sym_COLON_COLON] = ACTIONS(1113),
    [anon_sym_end] = ACTIONS(1116),
    [anon_sym_rescue] = ACTIONS(1116),
    [anon_sym_SEMI] = ACTIONS(1118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1121),
    [anon_sym_STAR] = ACTIONS(1124),
    [anon_sym_nil] = ACTIONS(1127),
    [anon_sym_class] = ACTIONS(1130),
    [anon_sym_module] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1136),
    [anon_sym_yield] = ACTIONS(1139),
    [anon_sym_break] = ACTIONS(1142),
    [anon_sym_next] = ACTIONS(1145),
    [anon_sym_redo] = ACTIONS(1148),
    [anon_sym_retry] = ACTIONS(1151),
    [anon_sym_if] = ACTIONS(1154),
    [anon_sym_unless] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1160),
    [anon_sym_until] = ACTIONS(1163),
    [anon_sym_for] = ACTIONS(1166),
    [anon_sym_in] = ACTIONS(1116),
    [anon_sym_case] = ACTIONS(1169),
    [anon_sym_when] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1172),
    [anon_sym_DOT_DOT] = ACTIONS(1175),
    [anon_sym_elsif] = ACTIONS(1116),
    [anon_sym_else] = ACTIONS(1116),
    [anon_sym_begin] = ACTIONS(1178),
    [anon_sym_ensure] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_defined_QMARK] = ACTIONS(1184),
    [anon_sym_not] = ACTIONS(1187),
    [anon_sym_BANG] = ACTIONS(1190),
    [anon_sym_TILDE] = ACTIONS(1190),
    [anon_sym_undef] = ACTIONS(1193),
    [anon_sym_alias] = ACTIONS(1196),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(1199),
    [sym_float] = ACTIONS(1199),
    [sym_super] = ACTIONS(1093),
    [sym_self] = ACTIONS(1093),
    [sym_true] = ACTIONS(1202),
    [sym_false] = ACTIONS(1202),
    [sym_constant] = ACTIONS(1093),
    [aux_sym_constant_suffix_token1] = ACTIONS(1205),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1208),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_character] = ACTIONS(1214),
    [anon_sym_DASH_GT] = ACTIONS(1217),
    [sym_simple_symbol] = ACTIONS(1220),
    [sym__string_start] = ACTIONS(1223),
    [sym__symbol_start] = ACTIONS(1226),
    [sym__subshell_start] = ACTIONS(1229),
    [sym__regex_start] = ACTIONS(1232),
    [sym__string_array_start] = ACTIONS(1235),
    [sym__symbol_array_start] = ACTIONS(1238),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1214),
    [sym__unary_minus] = ACTIONS(1241),
    [sym__unary_minus_num] = ACTIONS(1244),
    [sym__binary_minus] = ACTIONS(1247),
    [sym__identifier_suffix] = ACTIONS(1250),
    [sym__constant_suffix] = ACTIONS(1205),
  },
  [252] = {
    [sym_block_body] = STATE(5813),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(320),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3499),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_hash_splat_argument] = STATE(5533),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2000),
    [sym_identifier_suffix] = STATE(1991),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2774),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(252),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(5533),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1255),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1253),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [253] = {
    [sym_block_body] = STATE(5895),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(327),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3499),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_hash_splat_argument] = STATE(5507),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2000),
    [sym_identifier_suffix] = STATE(1991),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2774),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(253),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(5507),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1259),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1253),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [254] = {
    [sym_block_body] = STATE(5813),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(320),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3499),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_hash_splat_argument] = STATE(5533),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2000),
    [sym_identifier_suffix] = STATE(1991),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2774),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(254),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(5533),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1253),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [255] = {
    [sym_block_body] = STATE(5895),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(327),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3499),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_hash_splat_argument] = STATE(5507),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2000),
    [sym_identifier_suffix] = STATE(1991),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2774),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(255),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(5507),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1253),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [256] = {
    [sym_block_body] = STATE(5813),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(320),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3499),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_hash_splat_argument] = STATE(5533),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2000),
    [sym_identifier_suffix] = STATE(1991),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2774),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(256),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(5533),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1253),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [257] = {
    [sym_block_body] = STATE(5895),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(327),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3499),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_hash_splat_argument] = STATE(5507),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2000),
    [sym_identifier_suffix] = STATE(1991),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2774),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(257),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(5507),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1253),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [258] = {
    [sym_block_body] = STATE(5895),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(327),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3499),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_hash_splat_argument] = STATE(5507),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2000),
    [sym_identifier_suffix] = STATE(1991),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2774),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(258),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(5507),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1269),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1253),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [259] = {
    [sym_block_body] = STATE(5895),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(327),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3499),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_hash_splat_argument] = STATE(5507),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2000),
    [sym_identifier_suffix] = STATE(1991),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2774),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(259),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(5507),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1271),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1253),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [260] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2685),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(260),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(949),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(949),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_elsif] = ACTIONS(949),
    [anon_sym_else] = ACTIONS(949),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(949),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1281),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [261] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(261),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1285),
    [anon_sym_rescue] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1285),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1285),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1285),
    [anon_sym_else] = ACTIONS(1285),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [262] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2683),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(262),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(911),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(911),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_elsif] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(911),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1281),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [263] = {
    [sym__statements] = STATE(5164),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(263),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1287),
    [anon_sym_rescue] = ACTIONS(1287),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1287),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1287),
    [anon_sym_else] = ACTIONS(1287),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1287),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [264] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2777),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(264),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(911),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(911),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_elsif] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(911),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1297),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [265] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2767),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(265),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(949),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(949),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_elsif] = ACTIONS(949),
    [anon_sym_else] = ACTIONS(949),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(949),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1297),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [266] = {
    [sym__statements] = STATE(5349),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(266),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [sym__terminator] = STATE(299),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1301),
    [anon_sym_rescue] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1301),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [267] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_elsif] = STATE(5768),
    [sym_else] = STATE(5768),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(267),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1303),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1305),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1307),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [268] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2727),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(268),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [269] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_elsif] = STATE(5784),
    [sym_else] = STATE(5784),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(269),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1305),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1307),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [270] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_elsif] = STATE(5674),
    [sym_else] = STATE(5674),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(270),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1329),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1305),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1307),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [271] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_elsif] = STATE(5782),
    [sym_else] = STATE(5782),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(271),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1331),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1305),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1307),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [272] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2741),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(272),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(947),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(947),
    [anon_sym___END__] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [273] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_elsif] = STATE(5764),
    [sym_else] = STATE(5764),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(273),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1333),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1305),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1307),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [274] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_elsif] = STATE(5962),
    [sym_else] = STATE(5962),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(274),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1335),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1305),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1307),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [275] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_elsif] = STATE(5676),
    [sym_else] = STATE(5676),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(275),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1337),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1305),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1307),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [276] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2810),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(276),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(949),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(949),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_elsif] = ACTIONS(949),
    [anon_sym_else] = ACTIONS(949),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(949),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [277] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4611),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_when] = STATE(5557),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5762),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(277),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym__terminator] = STATE(5253),
    [aux_sym_case_repeat1] = STATE(5249),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1353),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1355),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [278] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(278),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1357),
    [anon_sym_rescue] = ACTIONS(1357),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1357),
    [anon_sym_then] = ACTIONS(1307),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [279] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(279),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1359),
    [anon_sym_rescue] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1359),
    [anon_sym_then] = ACTIONS(1307),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [280] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2844),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(280),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(947),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(947),
    [anon_sym___END__] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1371),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [281] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(281),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1379),
    [anon_sym_rescue] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1379),
    [anon_sym_then] = ACTIONS(1307),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [282] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(282),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1381),
    [anon_sym_rescue] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_then] = ACTIONS(1307),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [283] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2831),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(283),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1371),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [284] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4613),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_when] = STATE(5557),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5919),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(284),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym__terminator] = STATE(5256),
    [aux_sym_case_repeat1] = STATE(5257),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1383),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1353),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1385),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [285] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4616),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_when] = STATE(5557),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_else] = STATE(5866),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(285),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym__terminator] = STATE(5287),
    [aux_sym_case_repeat1] = STATE(5278),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1387),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1353),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1389),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [286] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2898),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(286),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(947),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(947),
    [anon_sym___END__] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [287] = {
    [sym_block_body] = STATE(5884),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(317),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(287),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [288] = {
    [sym_block_body] = STATE(5711),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(321),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(288),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1411),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [289] = {
    [sym__statements] = STATE(5380),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(289),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1413),
    [anon_sym_rescue] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [290] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(290),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1415),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1415),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1415),
    [anon_sym_then] = ACTIONS(1307),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [291] = {
    [sym_block_body] = STATE(5813),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(320),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(291),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1417),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [292] = {
    [sym_block_body] = STATE(5649),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(323),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(292),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1419),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [293] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3275),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(293),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [294] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(294),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1459),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1459),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1459),
    [anon_sym_then] = ACTIONS(1307),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [295] = {
    [sym_block_body] = STATE(5825),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(318),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(295),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [296] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(296),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1463),
    [anon_sym_then] = ACTIONS(1307),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [297] = {
    [sym_block_body] = STATE(5774),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(319),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(297),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1465),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [298] = {
    [sym_block_body] = STATE(5985),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(331),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(298),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1467),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [299] = {
    [sym__statements] = STATE(5398),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(299),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1469),
    [anon_sym_rescue] = ACTIONS(1469),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1469),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1469),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [300] = {
    [sym_block_body] = STATE(5894),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(316),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(300),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1471),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [301] = {
    [sym_block_body] = STATE(5895),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(327),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(301),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1473),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [302] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3350),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(302),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [303] = {
    [sym_block_body] = STATE(5877),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_block_parameters] = STATE(330),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(303),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [304] = {
    [sym__statements] = STATE(5102),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(304),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1477),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1477),
    [anon_sym_then] = ACTIONS(1307),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [305] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3352),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(305),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [306] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2939),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(306),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [307] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3258),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(307),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [308] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3476),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(308),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [309] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3345),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(309),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [310] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4487),
    [sym__argument] = STATE(4629),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1986),
    [sym_identifier_suffix] = STATE(1981),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2544),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(310),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(1069),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(1069),
    [anon_sym___END__] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1551),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(1071),
    [anon_sym_unless] = ACTIONS(1071),
    [anon_sym_while] = ACTIONS(1071),
    [anon_sym_until] = ACTIONS(1071),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
  },
  [311] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3002),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(311),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [312] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3443),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(312),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [313] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3306),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(313),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [314] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4774),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4750),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3321),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1928),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(314),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2140),
    [aux_sym__statements_repeat1] = STATE(325),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [sym_identifier] = ACTIONS(9),
    [aux_sym_program_token1] = ACTIONS(1089),
    [anon_sym___END__] = ACTIONS(1091),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_undef] = ACTIONS(77),
    [anon_sym_alias] = ACTIONS(79),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [315] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3475),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(315),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [316] = {
    [sym_block_body] = STATE(5909),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(316),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1577),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [317] = {
    [sym_block_body] = STATE(5914),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(317),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1579),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [318] = {
    [sym_block_body] = STATE(5838),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(318),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1581),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [319] = {
    [sym_block_body] = STATE(5691),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(319),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1583),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [320] = {
    [sym_block_body] = STATE(5766),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(320),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1585),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [321] = {
    [sym_block_body] = STATE(5795),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(321),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1587),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [322] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3528),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(322),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [323] = {
    [sym_block_body] = STATE(5647),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(323),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1607),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [324] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3129),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(324),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [325] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4997),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(325),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2140),
    [aux_sym__statements_repeat1] = STATE(325),
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1093),
    [aux_sym_program_token1] = ACTIONS(1102),
    [anon_sym___END__] = ACTIONS(1116),
    [anon_sym_BEGIN] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_END] = ACTIONS(1104),
    [anon_sym_def] = ACTIONS(1107),
    [anon_sym_LPAREN] = ACTIONS(1110),
    [anon_sym_COLON_COLON] = ACTIONS(1113),
    [anon_sym_SEMI] = ACTIONS(1629),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1121),
    [anon_sym_STAR] = ACTIONS(1124),
    [anon_sym_nil] = ACTIONS(1127),
    [anon_sym_class] = ACTIONS(1130),
    [anon_sym_module] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1136),
    [anon_sym_yield] = ACTIONS(1139),
    [anon_sym_break] = ACTIONS(1142),
    [anon_sym_next] = ACTIONS(1145),
    [anon_sym_redo] = ACTIONS(1148),
    [anon_sym_retry] = ACTIONS(1151),
    [anon_sym_if] = ACTIONS(1154),
    [anon_sym_unless] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1160),
    [anon_sym_until] = ACTIONS(1163),
    [anon_sym_for] = ACTIONS(1166),
    [anon_sym_case] = ACTIONS(1169),
    [anon_sym_LBRACK] = ACTIONS(1172),
    [anon_sym_DOT_DOT] = ACTIONS(1175),
    [anon_sym_begin] = ACTIONS(1178),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_defined_QMARK] = ACTIONS(1184),
    [anon_sym_not] = ACTIONS(1187),
    [anon_sym_BANG] = ACTIONS(1190),
    [anon_sym_TILDE] = ACTIONS(1190),
    [anon_sym_undef] = ACTIONS(1193),
    [anon_sym_alias] = ACTIONS(1196),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(1199),
    [sym_float] = ACTIONS(1199),
    [sym_super] = ACTIONS(1093),
    [sym_self] = ACTIONS(1093),
    [sym_true] = ACTIONS(1202),
    [sym_false] = ACTIONS(1202),
    [sym_constant] = ACTIONS(1093),
    [aux_sym_constant_suffix_token1] = ACTIONS(1205),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1208),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_character] = ACTIONS(1214),
    [anon_sym_DASH_GT] = ACTIONS(1217),
    [sym_simple_symbol] = ACTIONS(1220),
    [sym__string_start] = ACTIONS(1223),
    [sym__symbol_start] = ACTIONS(1226),
    [sym__subshell_start] = ACTIONS(1229),
    [sym__regex_start] = ACTIONS(1232),
    [sym__string_array_start] = ACTIONS(1235),
    [sym__symbol_array_start] = ACTIONS(1238),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1214),
    [sym__unary_minus] = ACTIONS(1241),
    [sym__unary_minus_num] = ACTIONS(1244),
    [sym__binary_minus] = ACTIONS(1247),
    [sym__identifier_suffix] = ACTIONS(1250),
    [sym__constant_suffix] = ACTIONS(1205),
  },
  [326] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3495),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(326),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [327] = {
    [sym_block_body] = STATE(5715),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(327),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1632),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [328] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3165),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4487),
    [sym__argument] = STATE(4662),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5983),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2655),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(328),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(1069),
    [sym_identifier] = ACTIONS(463),
    [aux_sym_program_token1] = ACTIONS(1069),
    [anon_sym___END__] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(1071),
    [anon_sym_unless] = ACTIONS(1071),
    [anon_sym_while] = ACTIONS(1071),
    [anon_sym_until] = ACTIONS(1071),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
  },
  [329] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3416),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(329),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [330] = {
    [sym_block_body] = STATE(5867),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(330),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [331] = {
    [sym_block_body] = STATE(5937),
    [sym__statements] = STATE(5893),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(331),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1644),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [332] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2918),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(332),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(947),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(947),
    [anon_sym___END__] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1654),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [333] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2909),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(333),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1654),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [334] = {
    [sym__statements] = STATE(5845),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(334),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1658),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [335] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_splat_parameter] = STATE(4520),
    [sym_hash_splat_parameter] = STATE(4507),
    [sym_hash_splat_nil] = STATE(4507),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__pattern_top_expr_body] = STATE(4483),
    [sym__array_pattern_n] = STATE(4509),
    [sym__pattern_expr] = STATE(4526),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym__find_pattern_body] = STATE(4486),
    [sym_find_pattern] = STATE(4459),
    [sym__hash_pattern_body] = STATE(4476),
    [sym_keyword_pattern] = STATE(4525),
    [sym__hash_pattern_any_rest] = STATE(4514),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4505),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4471),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4115),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(3119),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2272),
    [sym_constant_suffix] = STATE(3483),
    [sym_identifier_suffix] = STATE(3487),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2776),
    [sym_subshell] = STATE(3119),
    [sym_string_array] = STATE(3119),
    [sym_symbol_array] = STATE(3119),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(3119),
    [sym_heredoc_body] = STATE(335),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(3114),
    [sym_identifier] = ACTIONS(1660),
    [anon_sym_LBRACE] = ACTIONS(1662),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_COLON_COLON] = ACTIONS(1666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1668),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_STAR_STAR] = ACTIONS(1672),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1674),
    [anon_sym_DOT_DOT] = ACTIONS(1676),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1682),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1690),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(1694),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1696),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(1698),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [336] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_splat_parameter] = STATE(4641),
    [sym_hash_splat_parameter] = STATE(4507),
    [sym_hash_splat_nil] = STATE(4507),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_top_expr_body] = STATE(4483),
    [sym__array_pattern_n] = STATE(4509),
    [sym__pattern_expr] = STATE(4639),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym__find_pattern_body] = STATE(4486),
    [sym_find_pattern] = STATE(4459),
    [sym__hash_pattern_body] = STATE(4476),
    [sym_keyword_pattern] = STATE(4640),
    [sym__hash_pattern_any_rest] = STATE(4514),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4590),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4585),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3386),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2421),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2087),
    [sym_constant_suffix] = STATE(2706),
    [sym_identifier_suffix] = STATE(2737),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2552),
    [sym_subshell] = STATE(2421),
    [sym_string_array] = STATE(2421),
    [sym_symbol_array] = STATE(2421),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2421),
    [sym_heredoc_body] = STATE(336),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2343),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_LBRACE] = ACTIONS(1702),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(1704),
    [anon_sym_COLON_COLON] = ACTIONS(1706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1708),
    [anon_sym_STAR] = ACTIONS(1710),
    [anon_sym_STAR_STAR] = ACTIONS(1712),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_DOT_DOT] = ACTIONS(1716),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1718),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_constant] = ACTIONS(1732),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1734),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [337] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_splat_parameter] = STATE(4936),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__pattern_top_expr_body] = STATE(4952),
    [sym__array_pattern_n] = STATE(4984),
    [sym__pattern_expr] = STATE(4937),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(4979),
    [sym_find_pattern] = STATE(4790),
    [sym__hash_pattern_body] = STATE(4977),
    [sym_keyword_pattern] = STATE(4931),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4811),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4754),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3989),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3338),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2442),
    [sym_constant_suffix] = STATE(3318),
    [sym_identifier_suffix] = STATE(3322),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3086),
    [sym_subshell] = STATE(3338),
    [sym_string_array] = STATE(3338),
    [sym_symbol_array] = STATE(3338),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3338),
    [sym_heredoc_body] = STATE(337),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(3271),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1742),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1748),
    [anon_sym_DOT_DOT] = ACTIONS(1750),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1760),
    [sym_true] = ACTIONS(1762),
    [sym_false] = ACTIONS(1762),
    [sym_constant] = ACTIONS(1764),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1766),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [338] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_splat_parameter] = STATE(4810),
    [sym_hash_splat_parameter] = STATE(4507),
    [sym_hash_splat_nil] = STATE(4507),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_top_expr_body] = STATE(4483),
    [sym__array_pattern_n] = STATE(4509),
    [sym__pattern_expr] = STATE(4789),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym__find_pattern_body] = STATE(4486),
    [sym_find_pattern] = STATE(4459),
    [sym__hash_pattern_body] = STATE(4476),
    [sym_keyword_pattern] = STATE(4768),
    [sym__hash_pattern_any_rest] = STATE(4514),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4698),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4675),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4060),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2421),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2087),
    [sym_constant_suffix] = STATE(3315),
    [sym_identifier_suffix] = STATE(3316),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(2421),
    [sym_string_array] = STATE(2421),
    [sym_symbol_array] = STATE(2421),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2421),
    [sym_heredoc_body] = STATE(338),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2343),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_LBRACE] = ACTIONS(1702),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(1704),
    [anon_sym_COLON_COLON] = ACTIONS(1706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1772),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_STAR_STAR] = ACTIONS(1672),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_DOT_DOT] = ACTIONS(1774),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_constant] = ACTIONS(1784),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1734),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [339] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3176),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(339),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(947),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(947),
    [anon_sym___END__] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1790),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [340] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_splat_parameter] = STATE(4520),
    [sym_hash_splat_parameter] = STATE(4507),
    [sym_hash_splat_nil] = STATE(4507),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_top_expr_body] = STATE(4483),
    [sym__array_pattern_n] = STATE(4509),
    [sym__pattern_expr] = STATE(4526),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym__find_pattern_body] = STATE(4486),
    [sym_find_pattern] = STATE(4459),
    [sym__hash_pattern_body] = STATE(4476),
    [sym_keyword_pattern] = STATE(4525),
    [sym__hash_pattern_any_rest] = STATE(4514),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4505),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4471),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2726),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2421),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2087),
    [sym_constant_suffix] = STATE(2477),
    [sym_identifier_suffix] = STATE(2459),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2269),
    [sym_subshell] = STATE(2421),
    [sym_string_array] = STATE(2421),
    [sym_symbol_array] = STATE(2421),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2421),
    [sym_heredoc_body] = STATE(340),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2343),
    [sym_identifier] = ACTIONS(1792),
    [anon_sym_LBRACE] = ACTIONS(1702),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(1704),
    [anon_sym_COLON_COLON] = ACTIONS(1706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1794),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_STAR_STAR] = ACTIONS(1672),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_DOT_DOT] = ACTIONS(1796),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_constant] = ACTIONS(1798),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1734),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [341] = {
    [sym__statements] = STATE(5869),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5612),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(341),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [342] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_splat_parameter] = STATE(4520),
    [sym_hash_splat_parameter] = STATE(4507),
    [sym_hash_splat_nil] = STATE(4507),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_top_expr_body] = STATE(4483),
    [sym__array_pattern_n] = STATE(4509),
    [sym__pattern_expr] = STATE(4526),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym__find_pattern_body] = STATE(4486),
    [sym_find_pattern] = STATE(4459),
    [sym__hash_pattern_body] = STATE(4476),
    [sym_keyword_pattern] = STATE(4525),
    [sym__hash_pattern_any_rest] = STATE(4514),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4505),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4471),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3583),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2421),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2087),
    [sym_constant_suffix] = STATE(2477),
    [sym_identifier_suffix] = STATE(2459),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2269),
    [sym_subshell] = STATE(2421),
    [sym_string_array] = STATE(2421),
    [sym_symbol_array] = STATE(2421),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2421),
    [sym_heredoc_body] = STATE(342),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2343),
    [sym_identifier] = ACTIONS(1792),
    [anon_sym_LBRACE] = ACTIONS(1702),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(1704),
    [anon_sym_COLON_COLON] = ACTIONS(1706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1800),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_STAR_STAR] = ACTIONS(1672),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_DOT_DOT] = ACTIONS(1802),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_constant] = ACTIONS(1798),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1734),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [343] = {
    [sym__statements] = STATE(5682),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(343),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1814),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [344] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4487),
    [sym__argument] = STATE(4870),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(344),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_then] = ACTIONS(1071),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
  },
  [345] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_splat_parameter] = STATE(4989),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__pattern_top_expr_body] = STATE(4952),
    [sym__array_pattern_n] = STATE(4984),
    [sym__pattern_expr] = STATE(4983),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(4979),
    [sym_find_pattern] = STATE(4790),
    [sym__hash_pattern_body] = STATE(4977),
    [sym_keyword_pattern] = STATE(4925),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4202),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3338),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2442),
    [sym_constant_suffix] = STATE(3436),
    [sym_identifier_suffix] = STATE(3392),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3151),
    [sym_subshell] = STATE(3338),
    [sym_string_array] = STATE(3338),
    [sym_symbol_array] = STATE(3338),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3338),
    [sym_heredoc_body] = STATE(345),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(3271),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1820),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1748),
    [anon_sym_DOT_DOT] = ACTIONS(1822),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1760),
    [sym_true] = ACTIONS(1762),
    [sym_false] = ACTIONS(1762),
    [sym_constant] = ACTIONS(1826),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1766),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [346] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_splat_parameter] = STATE(4989),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__pattern_top_expr_body] = STATE(4952),
    [sym__array_pattern_n] = STATE(4984),
    [sym__pattern_expr] = STATE(4983),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(4979),
    [sym_find_pattern] = STATE(4790),
    [sym__hash_pattern_body] = STATE(4977),
    [sym_keyword_pattern] = STATE(4925),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4051),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3338),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2442),
    [sym_constant_suffix] = STATE(3436),
    [sym_identifier_suffix] = STATE(3392),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3151),
    [sym_subshell] = STATE(3338),
    [sym_string_array] = STATE(3338),
    [sym_symbol_array] = STATE(3338),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3338),
    [sym_heredoc_body] = STATE(346),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(3271),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1828),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1748),
    [anon_sym_DOT_DOT] = ACTIONS(1830),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1760),
    [sym_true] = ACTIONS(1762),
    [sym_false] = ACTIONS(1762),
    [sym_constant] = ACTIONS(1826),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1766),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [347] = {
    [sym__statements] = STATE(5656),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(347),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(1842),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [348] = {
    [sym__statements] = STATE(5904),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(348),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1844),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [349] = {
    [sym__statements] = STATE(5772),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(349),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1846),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [350] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_splat_parameter] = STATE(4641),
    [sym_hash_splat_parameter] = STATE(4507),
    [sym_hash_splat_nil] = STATE(4507),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_top_expr_body] = STATE(4483),
    [sym__array_pattern_n] = STATE(4509),
    [sym__pattern_expr] = STATE(4639),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym__find_pattern_body] = STATE(4486),
    [sym_find_pattern] = STATE(4459),
    [sym__hash_pattern_body] = STATE(4476),
    [sym_keyword_pattern] = STATE(4640),
    [sym__hash_pattern_any_rest] = STATE(4514),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4590),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4585),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3230),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2421),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2087),
    [sym_constant_suffix] = STATE(2706),
    [sym_identifier_suffix] = STATE(2737),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2552),
    [sym_subshell] = STATE(2421),
    [sym_string_array] = STATE(2421),
    [sym_symbol_array] = STATE(2421),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2421),
    [sym_heredoc_body] = STATE(350),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2343),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_LBRACE] = ACTIONS(1702),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(1704),
    [anon_sym_COLON_COLON] = ACTIONS(1706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1710),
    [anon_sym_STAR_STAR] = ACTIONS(1712),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_DOT_DOT] = ACTIONS(1850),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1718),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_constant] = ACTIONS(1732),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1734),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [351] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3601),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(351),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1864),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [352] = {
    [sym__statements] = STATE(5656),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5612),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(352),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(1842),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [353] = {
    [sym__statements] = STATE(5683),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(353),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1872),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [354] = {
    [sym__statements] = STATE(5781),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(354),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1874),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [355] = {
    [sym__statements] = STATE(5871),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(355),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1876),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [356] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_splat_parameter] = STATE(4810),
    [sym_hash_splat_parameter] = STATE(4507),
    [sym_hash_splat_nil] = STATE(4507),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_top_expr_body] = STATE(4483),
    [sym__array_pattern_n] = STATE(4509),
    [sym__pattern_expr] = STATE(4789),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym__find_pattern_body] = STATE(4486),
    [sym_find_pattern] = STATE(4459),
    [sym__hash_pattern_body] = STATE(4476),
    [sym_keyword_pattern] = STATE(4768),
    [sym__hash_pattern_any_rest] = STATE(4514),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4698),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4675),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3900),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2421),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2087),
    [sym_constant_suffix] = STATE(3315),
    [sym_identifier_suffix] = STATE(3316),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(2421),
    [sym_string_array] = STATE(2421),
    [sym_symbol_array] = STATE(2421),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2421),
    [sym_heredoc_body] = STATE(356),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2343),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_LBRACE] = ACTIONS(1702),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1704),
    [anon_sym_COLON_COLON] = ACTIONS(1706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1878),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_STAR_STAR] = ACTIONS(1672),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_DOT_DOT] = ACTIONS(1880),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_constant] = ACTIONS(1784),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1734),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [357] = {
    [sym__statements] = STATE(5967),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5612),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(357),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [358] = {
    [sym__statements] = STATE(5880),
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4635),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(358),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_empty_statement] = STATE(2062),
    [aux_sym__statements_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1892),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [359] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_splat_parameter] = STATE(4936),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__pattern_top_expr_body] = STATE(4952),
    [sym__array_pattern_n] = STATE(4984),
    [sym__pattern_expr] = STATE(4937),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(4979),
    [sym_find_pattern] = STATE(4790),
    [sym__hash_pattern_body] = STATE(4977),
    [sym_keyword_pattern] = STATE(4931),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4811),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4754),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4123),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3338),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2442),
    [sym_constant_suffix] = STATE(3318),
    [sym_identifier_suffix] = STATE(3322),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3086),
    [sym_subshell] = STATE(3338),
    [sym_string_array] = STATE(3338),
    [sym_symbol_array] = STATE(3338),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3338),
    [sym_heredoc_body] = STATE(359),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(3271),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1894),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1748),
    [anon_sym_DOT_DOT] = ACTIONS(1896),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1760),
    [sym_true] = ACTIONS(1762),
    [sym_false] = ACTIONS(1762),
    [sym_constant] = ACTIONS(1764),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1766),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [360] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3232),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(360),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1790),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [361] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_splat_parameter] = STATE(4520),
    [sym_hash_splat_parameter] = STATE(4507),
    [sym_hash_splat_nil] = STATE(4507),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_top_expr_body] = STATE(4483),
    [sym__array_pattern_n] = STATE(4509),
    [sym__pattern_expr] = STATE(4526),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym__find_pattern_body] = STATE(4486),
    [sym_find_pattern] = STATE(4459),
    [sym__hash_pattern_body] = STATE(4476),
    [sym_keyword_pattern] = STATE(4525),
    [sym__hash_pattern_any_rest] = STATE(4514),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4505),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4471),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2787),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2421),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2087),
    [sym_constant_suffix] = STATE(2477),
    [sym_identifier_suffix] = STATE(2459),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2269),
    [sym_subshell] = STATE(2421),
    [sym_string_array] = STATE(2421),
    [sym_symbol_array] = STATE(2421),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2421),
    [sym_heredoc_body] = STATE(361),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2343),
    [sym_identifier] = ACTIONS(1792),
    [anon_sym_LBRACE] = ACTIONS(1702),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(1704),
    [anon_sym_COLON_COLON] = ACTIONS(1706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1908),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_STAR_STAR] = ACTIONS(1672),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_DOT_DOT] = ACTIONS(1910),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_constant] = ACTIONS(1798),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1734),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [362] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_splat_parameter] = STATE(4989),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__pattern_top_expr_body] = STATE(4952),
    [sym__array_pattern_n] = STATE(4984),
    [sym__pattern_expr] = STATE(4983),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(4979),
    [sym_find_pattern] = STATE(4790),
    [sym__hash_pattern_body] = STATE(4977),
    [sym_keyword_pattern] = STATE(4925),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4115),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3338),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2442),
    [sym_constant_suffix] = STATE(3436),
    [sym_identifier_suffix] = STATE(3392),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3151),
    [sym_subshell] = STATE(3338),
    [sym_string_array] = STATE(3338),
    [sym_symbol_array] = STATE(3338),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3338),
    [sym_heredoc_body] = STATE(362),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(3271),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1820),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1748),
    [anon_sym_DOT_DOT] = ACTIONS(1822),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1760),
    [sym_true] = ACTIONS(1762),
    [sym_false] = ACTIONS(1762),
    [sym_constant] = ACTIONS(1826),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1766),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [363] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3699),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(363),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1924),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [364] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2760),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4487),
    [sym__argument] = STATE(5012),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5761),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1961),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2443),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(364),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_then] = ACTIONS(1071),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
  },
  [365] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3659),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(365),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1940),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [366] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3337),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(366),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(947),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(947),
    [anon_sym___END__] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [367] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3755),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(367),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1964),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [368] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3727),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(368),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1964),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [369] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4487),
    [sym__argument] = STATE(4922),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(369),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_then] = ACTIONS(1071),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1976),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(255),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(259),
    [sym__splat_star] = ACTIONS(261),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym_hash_key_symbol] = ACTIONS(267),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(269),
  },
  [370] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3712),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(370),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1940),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [371] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5032),
    [sym__argument] = STATE(4898),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2002),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2864),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(371),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(1069),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(323),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(271),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(355),
    [sym__splat_star] = ACTIONS(357),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym_hash_key_symbol] = ACTIONS(363),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(367),
  },
  [372] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3447),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4487),
    [sym__argument] = STATE(4755),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1994),
    [sym_identifier_suffix] = STATE(1995),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2730),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(372),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(1071),
    [anon_sym_unless] = ACTIONS(1071),
    [anon_sym_while] = ACTIONS(1071),
    [anon_sym_until] = ACTIONS(1071),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(487),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(507),
    [sym__splat_star] = ACTIONS(509),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym_hash_key_symbol] = ACTIONS(515),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(517),
  },
  [373] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4619),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(373),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1990),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1990),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [374] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3808),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(374),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2004),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [375] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5032),
    [sym__argument] = STATE(5026),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2004),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3026),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(375),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(1069),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(2016),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(377),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(399),
    [sym__splat_star] = ACTIONS(401),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym_hash_key_symbol] = ACTIONS(407),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(409),
  },
  [376] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4610),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(376),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1990),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1990),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [377] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3825),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(377),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(2022),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [378] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3901),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_command_argument_list] = STATE(4487),
    [sym__argument] = STATE(5147),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5924),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(66),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2457),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1990),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(3127),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(378),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2024),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_then] = ACTIONS(1071),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(2028),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(557),
    [sym__splat_star] = ACTIONS(559),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym_hash_key_symbol] = ACTIONS(565),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(567),
  },
  [379] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3642),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(379),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [380] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3776),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(380),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [381] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3864),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(381),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_COLON2] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [382] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3408),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(382),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [383] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3899),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5032),
    [sym__argument] = STATE(5212),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5911),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2452),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(1993),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3146),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(383),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2066),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(1069),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(569),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(601),
  },
  [384] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3452),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(384),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [385] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3888),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(385),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(2022),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [386] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3721),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(386),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(2072),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [387] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3663),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(387),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(2072),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [388] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3847),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(388),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2086),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [389] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4617),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(389),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1990),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1990),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [390] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3667),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(390),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [391] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3941),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(391),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(2096),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [392] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3906),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(392),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2110),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [393] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3909),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(393),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_COLON2] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2130),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [394] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3894),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(394),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(2096),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [395] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4032),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_command_argument_list] = STATE(5032),
    [sym__argument] = STATE(5270),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2003),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3209),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(395),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(1069),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(633),
  },
  [396] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3856),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(396),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [397] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3939),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(397),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2130),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [398] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3520),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(398),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [399] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3795),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(399),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [400] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4001),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(400),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(279),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [401] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4047),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(401),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [402] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4859),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4878),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3500),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(402),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [403] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4839),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(403),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [404] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4108),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(404),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2220),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [405] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4858),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4878),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3500),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(405),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [406] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4837),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4878),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3500),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(406),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [407] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4877),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4878),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3500),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(407),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [408] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4856),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4878),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3500),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(408),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [409] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4880),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4878),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3500),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(409),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [410] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4868),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(410),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [411] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4848),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(411),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [412] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4866),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(412),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [413] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4869),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(413),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [414] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4840),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(414),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [415] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4122),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(415),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [416] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4056),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(416),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [417] = {
    [sym_begin_block] = STATE(4570),
    [sym_end_block] = STATE(4570),
    [sym__statement] = STATE(4847),
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_if_modifier] = STATE(4570),
    [sym_unless_modifier] = STATE(4570),
    [sym_while_modifier] = STATE(4570),
    [sym_until_modifier] = STATE(4570),
    [sym_rescue_modifier] = STATE(4570),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4603),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym_undef] = STATE(4570),
    [sym_alias] = STATE(4570),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(417),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [418] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4138),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(418),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_COLON2] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [419] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4136),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(419),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [420] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4128),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(420),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [421] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4193),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(421),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [422] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5693),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(422),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2302),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [423] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5907),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(423),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2304),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [424] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4229),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(424),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [425] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5826),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(425),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2324),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [426] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5643),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(426),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2326),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [427] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5982),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(427),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2328),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [428] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument] = STATE(4995),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(428),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2330),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2330),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [429] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5868),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(429),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2332),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [430] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument] = STATE(4995),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(430),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2334),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [431] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5901),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(431),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2336),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [432] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5733),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(432),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2338),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [433] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4218),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(433),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_COLON2] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [434] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5805),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(434),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2358),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [435] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__pattern_expr] = STATE(4844),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4065),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3338),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2442),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(3338),
    [sym_string_array] = STATE(3338),
    [sym_symbol_array] = STATE(3338),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3338),
    [sym_heredoc_body] = STATE(435),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(3271),
    [sym_identifier] = ACTIONS(2360),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1740),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1820),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1748),
    [anon_sym_DOT_DOT] = ACTIONS(1822),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1760),
    [sym_true] = ACTIONS(1762),
    [sym_false] = ACTIONS(1762),
    [sym_constant] = ACTIONS(2364),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym__no_line_break] = ACTIONS(2366),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1766),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [436] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5859),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(436),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2368),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [437] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5865),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(437),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2370),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [438] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5670),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(438),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2372),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [439] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4228),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(439),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [440] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument_list_with_trailing_comma] = STATE(5696),
    [sym__argument] = STATE(5391),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(440),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2374),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [441] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(441),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [442] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__pattern_expr] = STATE(4851),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4115),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3338),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2442),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(3338),
    [sym_string_array] = STATE(3338),
    [sym_symbol_array] = STATE(3338),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3338),
    [sym_heredoc_body] = STATE(442),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(3271),
    [sym_identifier] = ACTIONS(2360),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1740),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1820),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1748),
    [anon_sym_DOT_DOT] = ACTIONS(1822),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1760),
    [sym_true] = ACTIONS(1762),
    [sym_false] = ACTIONS(1762),
    [sym_constant] = ACTIONS(2364),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1766),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [443] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5300),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument] = STATE(4995),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2008),
    [sym_identifier_suffix] = STATE(2007),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(443),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [444] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3899),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym__argument] = STATE(4995),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5911),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2452),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(1993),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3146),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(444),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2066),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(569),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(601),
  },
  [445] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3165),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym__argument] = STATE(4513),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5983),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2655),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(445),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
  },
  [446] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4032),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym__argument] = STATE(4995),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2003),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3209),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(446),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(633),
  },
  [447] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym__argument] = STATE(4995),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2004),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3026),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(447),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2016),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(377),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(399),
    [sym__splat_star] = ACTIONS(401),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym_hash_key_symbol] = ACTIONS(407),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(409),
  },
  [448] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym__argument] = STATE(4513),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(448),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
  },
  [449] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5019),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym__argument] = STATE(4995),
    [sym_forward_argument] = STATE(5009),
    [sym_splat_argument] = STATE(5009),
    [sym_hash_splat_argument] = STATE(5009),
    [sym_block_argument] = STATE(5009),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2002),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2864),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(449),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5009),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(323),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(271),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__block_ampersand] = ACTIONS(355),
    [sym__splat_star] = ACTIONS(357),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym_hash_key_symbol] = ACTIONS(363),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
    [sym__hash_splat_star_star] = ACTIONS(367),
  },
  [450] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym__argument] = STATE(4513),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(450),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
  },
  [451] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym__argument] = STATE(4513),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(451),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1976),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(255),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(259),
    [sym__splat_star] = ACTIONS(261),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym_hash_key_symbol] = ACTIONS(267),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(269),
  },
  [452] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3901),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym__argument] = STATE(4513),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5924),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(66),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2457),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1990),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(3127),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(452),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2024),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2028),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(557),
    [sym__splat_star] = ACTIONS(559),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym_hash_key_symbol] = ACTIONS(565),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(567),
  },
  [453] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2760),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym__argument] = STATE(4513),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5761),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1961),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2443),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(453),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
  },
  [454] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2760),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym__argument] = STATE(4513),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5890),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2145),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1961),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2443),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(454),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
  },
  [455] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3447),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym__argument] = STATE(4513),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1994),
    [sym_identifier_suffix] = STATE(1995),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2730),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(455),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(487),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(507),
    [sym__splat_star] = ACTIONS(509),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym_hash_key_symbol] = ACTIONS(515),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(517),
  },
  [456] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4481),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym__argument] = STATE(4513),
    [sym_forward_argument] = STATE(4478),
    [sym_splat_argument] = STATE(4478),
    [sym_hash_splat_argument] = STATE(4478),
    [sym_block_argument] = STATE(4478),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1986),
    [sym_identifier_suffix] = STATE(1981),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2544),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(456),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_pair] = STATE(4478),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(185),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1551),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
  },
  [457] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_rescue_modifier_expression] = STATE(4950),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4951),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3585),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3655),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(457),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(323),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2396),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [458] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4643),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2875),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2873),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(458),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2398),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [459] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4547),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2601),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2656),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(459),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2400),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [460] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4894),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3484),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3561),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(460),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2402),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [461] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4836),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3309),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3319),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5710),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(461),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_defined_QMARK] = ACTIONS(2406),
    [anon_sym_not] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_TILDE] = ACTIONS(2410),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2412),
    [sym__unary_minus] = ACTIONS(2414),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [462] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_rescue_modifier_expression] = STATE(4950),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5366),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3990),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3924),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5968),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(462),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_defined_QMARK] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2422),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2424),
    [sym__unary_minus] = ACTIONS(2426),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [463] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4752),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3144),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3145),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5641),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(463),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_defined_QMARK] = ACTIONS(2430),
    [anon_sym_not] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_TILDE] = ACTIONS(2434),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2436),
    [sym__unary_minus] = ACTIONS(2438),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [464] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(5232),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3730),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3880),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(464),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_defined_QMARK] = ACTIONS(2442),
    [anon_sym_not] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_TILDE] = ACTIONS(2446),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2448),
    [sym__unary_minus] = ACTIONS(2450),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [465] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_rescue_modifier_expression] = STATE(4950),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5275),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3838),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3579),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5911),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2452),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(465),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2424),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [466] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4711),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3118),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3117),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5983),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(466),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2436),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [467] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(5194),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3689),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3832),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5761),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(467),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2448),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [468] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_rescue_modifier_expression] = STATE(4950),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5490),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3983),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(4040),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5968),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(468),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_defined_QMARK] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2422),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2452),
    [sym__unary_minus] = ACTIONS(2426),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [469] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4583),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2732),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2705),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5761),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(469),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2454),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [470] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4752),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3118),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3117),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5641),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(470),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_defined_QMARK] = ACTIONS(2430),
    [anon_sym_not] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_TILDE] = ACTIONS(2434),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2436),
    [sym__unary_minus] = ACTIONS(2438),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [471] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4834),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3336),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3356),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(471),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2412),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [472] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4836),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3336),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3356),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5710),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(472),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_defined_QMARK] = ACTIONS(2406),
    [anon_sym_not] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_TILDE] = ACTIONS(2410),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2412),
    [sym__unary_minus] = ACTIONS(2414),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [473] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_rescue_modifier_expression] = STATE(4950),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5229),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3779),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3651),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5911),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2452),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(473),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2452),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [474] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4547),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2601),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2656),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(474),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2400),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [475] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4605),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2736),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2733),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2139),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(475),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2454),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [476] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_rescue_modifier_expression] = STATE(4950),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5366),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3838),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3579),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5968),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(476),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_defined_QMARK] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2422),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2424),
    [sym__unary_minus] = ACTIONS(2426),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [477] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_rescue_modifier_expression] = STATE(4950),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4966),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3572),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3559),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(477),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(323),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2466),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [478] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4605),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2732),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2705),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2139),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(478),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2454),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [479] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4583),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2732),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2705),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5890),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2145),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(479),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2454),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [480] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4605),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2736),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2733),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(480),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_defined_QMARK] = ACTIONS(2442),
    [anon_sym_not] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_TILDE] = ACTIONS(2446),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2454),
    [sym__unary_minus] = ACTIONS(2450),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [481] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_rescue_modifier_expression] = STATE(4499),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4605),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2732),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2705),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(481),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_defined_QMARK] = ACTIONS(2442),
    [anon_sym_not] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_TILDE] = ACTIONS(2446),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2454),
    [sym__unary_minus] = ACTIONS(2450),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [482] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2725),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(482),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2468),
    [anon_sym_rescue] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2468),
    [anon_sym_do] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2468),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_elsif] = ACTIONS(2468),
    [anon_sym_else] = ACTIONS(2468),
    [anon_sym_then] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2468),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2362),
    [sym__no_line_break] = ACTIONS(2470),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [483] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2726),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(483),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2474),
    [anon_sym_rescue] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_elsif] = ACTIONS(2474),
    [anon_sym_else] = ACTIONS(2474),
    [anon_sym_then] = ACTIONS(2474),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2474),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2472),
    [sym__no_line_break] = ACTIONS(2476),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [484] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2791),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(484),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2468),
    [anon_sym_rescue] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2468),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_elsif] = ACTIONS(2468),
    [anon_sym_else] = ACTIONS(2468),
    [anon_sym_then] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2468),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2362),
    [sym__no_line_break] = ACTIONS(2470),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [485] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4606),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2809),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(485),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [486] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4693),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3182),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5983),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(486),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [487] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2673),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(487),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2478),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2480),
    [anon_sym_rescue] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_elsif] = ACTIONS(2480),
    [anon_sym_else] = ACTIONS(2480),
    [anon_sym_then] = ACTIONS(2480),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2480),
    [anon_sym_and] = ACTIONS(2480),
    [anon_sym_or] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2478),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [488] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4606),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2775),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(488),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_defined_QMARK] = ACTIONS(2442),
    [anon_sym_not] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_TILDE] = ACTIONS(2446),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2450),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [489] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4534),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2665),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(489),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [490] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2787),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(490),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2474),
    [anon_sym_rescue] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_elsif] = ACTIONS(2474),
    [anon_sym_else] = ACTIONS(2474),
    [anon_sym_then] = ACTIONS(2474),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2474),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2472),
    [sym__no_line_break] = ACTIONS(2476),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [491] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_rescue_modifier_expression] = STATE(4947),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5489),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4126),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5978),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(96),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2503),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(491),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_defined_QMARK] = ACTIONS(2484),
    [anon_sym_not] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_TILDE] = ACTIONS(2488),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2490),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [492] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4584),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2775),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5890),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2145),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(492),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [493] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_rescue_modifier_expression] = STATE(4947),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5224),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3981),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5911),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2452),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(493),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [494] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_rescue_modifier_expression] = STATE(4947),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4967),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3680),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(494),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(323),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [495] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4606),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2809),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5948),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(69),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(495),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_defined_QMARK] = ACTIONS(2494),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2500),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [496] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4606),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2775),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2139),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(496),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [497] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_rescue_modifier_expression] = STATE(4947),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5364),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3985),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5968),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(497),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_defined_QMARK] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2422),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2426),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [498] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2731),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(498),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2504),
    [anon_sym_rescue] = ACTIONS(2504),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2504),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_elsif] = ACTIONS(2504),
    [anon_sym_else] = ACTIONS(2504),
    [anon_sym_then] = ACTIONS(2504),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2504),
    [anon_sym_and] = ACTIONS(2504),
    [anon_sym_or] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2502),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [499] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4902),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3552),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(499),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [500] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_rescue_modifier_expression] = STATE(4947),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5364),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4061),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5978),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(96),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2503),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(500),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_defined_QMARK] = ACTIONS(2484),
    [anon_sym_not] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_TILDE] = ACTIONS(2488),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2490),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [501] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4744),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3182),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5641),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(501),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_defined_QMARK] = ACTIONS(2430),
    [anon_sym_not] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_TILDE] = ACTIONS(2434),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2438),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [502] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(5234),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3914),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5948),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(69),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(502),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_defined_QMARK] = ACTIONS(2494),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2500),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [503] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4831),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3419),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(503),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [504] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4534),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2665),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(504),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [505] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4857),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3496),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(505),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [506] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2683),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(506),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(911),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_elsif] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [507] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4857),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3419),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5710),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(507),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_defined_QMARK] = ACTIONS(2406),
    [anon_sym_not] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_TILDE] = ACTIONS(2410),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2414),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [508] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(5195),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3792),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5761),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(508),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [509] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4644),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2924),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(509),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [510] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4584),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2775),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5761),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(510),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [511] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_rescue_modifier_expression] = STATE(4512),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4744),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3347),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(511),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [512] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_rescue_modifier_expression] = STATE(4947),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5279),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3985),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5911),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2452),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(512),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [513] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_rescue_modifier_expression] = STATE(4947),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4953),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3649),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(513),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(323),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [514] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2729),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(514),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2508),
    [anon_sym_rescue] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2508),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_elsif] = ACTIONS(2508),
    [anon_sym_else] = ACTIONS(2508),
    [anon_sym_then] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2506),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [515] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2825),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(515),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2504),
    [anon_sym_rescue] = ACTIONS(2504),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_elsif] = ACTIONS(2504),
    [anon_sym_else] = ACTIONS(2504),
    [anon_sym_then] = ACTIONS(2504),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2504),
    [anon_sym_and] = ACTIONS(2504),
    [anon_sym_or] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2502),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [516] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2821),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(516),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2508),
    [anon_sym_rescue] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_elsif] = ACTIONS(2508),
    [anon_sym_else] = ACTIONS(2508),
    [anon_sym_then] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2506),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [517] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2777),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(517),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(911),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_elsif] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [518] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2748),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(518),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2478),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2480),
    [anon_sym_rescue] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_elsif] = ACTIONS(2480),
    [anon_sym_else] = ACTIONS(2480),
    [anon_sym_then] = ACTIONS(2480),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2480),
    [anon_sym_and] = ACTIONS(2480),
    [anon_sym_or] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2478),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [519] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4943),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3635),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(519),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(323),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [520] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(520),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1976),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(255),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [521] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4948),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3619),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5978),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(96),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2503),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(521),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_defined_QMARK] = ACTIONS(2484),
    [anon_sym_not] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_TILDE] = ACTIONS(2488),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2490),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [522] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4945),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4082),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5978),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(96),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2503),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(522),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_defined_QMARK] = ACTIONS(2484),
    [anon_sym_not] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_TILDE] = ACTIONS(2488),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2490),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [523] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4943),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4058),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5978),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(96),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2503),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(523),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_defined_QMARK] = ACTIONS(2484),
    [anon_sym_not] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_TILDE] = ACTIONS(2488),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2490),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [524] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5028),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4098),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5978),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(96),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2503),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(524),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_defined_QMARK] = ACTIONS(2484),
    [anon_sym_not] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_TILDE] = ACTIONS(2488),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2490),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [525] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2745),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5761),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(525),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [526] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2670),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(526),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [527] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2672),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(527),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [528] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2671),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(528),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [529] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5924),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(66),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2457),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(529),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2028),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [530] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3958),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5924),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(66),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2457),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(530),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2028),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [531] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2667),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(531),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [532] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3967),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5924),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(66),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2457),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(532),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2028),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [533] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3957),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5924),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(66),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2457),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(533),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2028),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [534] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2745),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2139),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(534),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [535] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4760),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3321),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(535),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [536] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4759),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3321),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(536),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [537] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4758),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3321),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(537),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [538] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4757),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3321),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(538),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [539] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2667),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5710),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(539),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_defined_QMARK] = ACTIONS(2406),
    [anon_sym_not] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_TILDE] = ACTIONS(2410),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2414),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [540] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4477),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3321),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(540),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [541] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3509),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(541),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [542] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3399),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(542),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [543] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5028),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3819),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(543),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2016),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [544] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4943),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3783),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(544),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2016),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [545] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4945),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3772),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(545),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2016),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [546] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3384),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5710),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(546),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_defined_QMARK] = ACTIONS(2406),
    [anon_sym_not] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_TILDE] = ACTIONS(2410),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2414),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [547] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4948),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3859),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(547),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2016),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [548] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3282),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(548),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [549] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3349),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(549),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [550] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4595),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(550),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [551] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4598),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(551),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [552] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3381),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5710),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(552),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_defined_QMARK] = ACTIONS(2406),
    [anon_sym_not] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_TILDE] = ACTIONS(2410),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2414),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [553] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3399),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5710),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(553),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_defined_QMARK] = ACTIONS(2406),
    [anon_sym_not] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_TILDE] = ACTIONS(2410),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2414),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [554] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3357),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(554),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [555] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2975),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(555),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [556] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4747),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3321),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(556),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [557] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(4011),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(557),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [558] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(4005),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(558),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [559] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3991),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(559),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [560] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2667),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2139),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(560),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [561] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3687),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(561),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [562] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4601),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(562),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [563] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3399),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5710),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(563),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_defined_QMARK] = ACTIONS(2406),
    [anon_sym_not] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_TILDE] = ACTIONS(2410),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2414),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [564] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5016),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4143),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5933),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2526),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(564),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [565] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5028),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3994),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(565),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [566] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4477),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3992),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(566),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [567] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4948),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3859),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5933),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2526),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(567),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [568] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4945),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4172),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5933),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2526),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(568),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [569] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4943),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4170),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5933),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2526),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(569),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [570] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5028),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4146),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5933),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2526),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(570),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [571] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4943),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4028),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(571),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [572] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5028),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3951),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5911),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2452),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(572),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [573] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4945),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(573),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [574] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4943),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3905),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5911),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2452),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(574),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [575] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4945),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3908),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5911),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2452),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(575),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [576] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4948),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3859),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(576),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [577] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4948),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3619),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5911),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2452),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(577),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [578] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2670),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2523),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(6),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5699),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(578),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [579] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2757),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2139),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(579),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [580] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(580),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [581] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4594),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(581),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [582] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3630),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(582),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1976),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(255),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [583] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3664),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(583),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1976),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(255),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [584] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4477),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3500),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(584),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [585] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4881),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3500),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(585),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [586] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4846),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3500),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(586),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [587] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4838),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3500),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(587),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [588] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4843),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3500),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(588),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [589] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4855),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3500),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(589),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [590] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3660),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(590),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1976),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(255),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [591] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3171),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5641),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(591),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_defined_QMARK] = ACTIONS(2430),
    [anon_sym_not] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_TILDE] = ACTIONS(2434),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2438),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [592] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5028),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4098),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5978),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(96),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2503),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(592),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_defined_QMARK] = ACTIONS(2484),
    [anon_sym_not] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_TILDE] = ACTIONS(2488),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2490),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [593] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2745),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(593),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_defined_QMARK] = ACTIONS(2442),
    [anon_sym_not] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_TILDE] = ACTIONS(2446),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2450),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [594] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(4011),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(594),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [595] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2747),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2139),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(595),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [596] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4943),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3905),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5968),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(596),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_defined_QMARK] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2422),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2426),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [597] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3282),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(597),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [598] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5028),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3684),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(598),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(323),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [599] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5028),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3684),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(599),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(323),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [600] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2745),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2139),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(600),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [601] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2667),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5761),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(601),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [602] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2667),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(602),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [603] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3485),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(603),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [604] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3488),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(604),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [605] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3509),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5651),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2214),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(605),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_defined_QMARK] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2208),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [606] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3399),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(606),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [607] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3381),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(607),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [608] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4945),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3634),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(608),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(323),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [609] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3384),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(609),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [610] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5028),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3819),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(39),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(375),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5802),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(610),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2016),
    [anon_sym_defined_QMARK] = ACTIONS(389),
    [anon_sym_not] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(395),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(403),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [611] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2667),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2964),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(24),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(611),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [612] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2975),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(612),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [613] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4948),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3619),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3314),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(371),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5931),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2280),
    [sym__variable] = STATE(22),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(613),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_break] = ACTIONS(291),
    [anon_sym_next] = ACTIONS(293),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_defined_QMARK] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(323),
    [anon_sym_TILDE] = ACTIONS(323),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(359),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [614] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2963),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(614),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [615] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(5316),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3992),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(615),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [616] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(5317),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3992),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(616),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [617] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2979),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(617),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [618] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5028),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3994),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(618),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [619] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5540),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4143),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5933),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2526),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(619),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [620] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2975),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5641),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(620),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_defined_QMARK] = ACTIONS(2430),
    [anon_sym_not] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_TILDE] = ACTIONS(2434),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2438),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [621] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2798),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5948),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(69),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(621),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_defined_QMARK] = ACTIONS(2494),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2500),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [622] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2757),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5761),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(622),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [623] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3223),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5641),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(623),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_defined_QMARK] = ACTIONS(2430),
    [anon_sym_not] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_TILDE] = ACTIONS(2434),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2438),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [624] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2782),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5948),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(69),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(624),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_defined_QMARK] = ACTIONS(2494),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2500),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [625] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5016),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4029),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2505),
    [sym__variable] = STATE(38),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(625),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [626] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3957),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5924),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(66),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2457),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(626),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2028),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [627] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2849),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5948),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(69),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(627),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_defined_QMARK] = ACTIONS(2494),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2500),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [628] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2667),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5948),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(69),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(628),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_defined_QMARK] = ACTIONS(2494),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2500),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [629] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3220),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5641),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(629),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_defined_QMARK] = ACTIONS(2430),
    [anon_sym_not] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_TILDE] = ACTIONS(2434),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2438),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [630] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3630),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2434),
    [sym__variable] = STATE(21),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(630),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_next] = ACTIONS(247),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1976),
    [anon_sym_defined_QMARK] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(255),
    [anon_sym_TILDE] = ACTIONS(255),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(263),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [631] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2745),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(631),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_defined_QMARK] = ACTIONS(2442),
    [anon_sym_not] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_TILDE] = ACTIONS(2446),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2450),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [632] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2747),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(632),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_defined_QMARK] = ACTIONS(2442),
    [anon_sym_not] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_TILDE] = ACTIONS(2446),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2450),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [633] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2757),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(633),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_defined_QMARK] = ACTIONS(2442),
    [anon_sym_not] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_TILDE] = ACTIONS(2446),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2450),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [634] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2667),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(634),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_defined_QMARK] = ACTIONS(2442),
    [anon_sym_not] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_TILDE] = ACTIONS(2446),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2450),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [635] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5028),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3951),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5968),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(635),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_defined_QMARK] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2422),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2426),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [636] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2667),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5890),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2145),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(636),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [637] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5558),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4143),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5933),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2526),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(637),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [638] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3171),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5641),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(638),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_defined_QMARK] = ACTIONS(2430),
    [anon_sym_not] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_TILDE] = ACTIONS(2434),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2438),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [639] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2745),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5890),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2145),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(639),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [640] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4477),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(640),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [641] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2667),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(641),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [642] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5028),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3951),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5911),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2452),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(642),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [643] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2757),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5890),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2145),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(643),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [644] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2747),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5890),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2145),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(644),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [645] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2966),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(645),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [646] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2966),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2724),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(310),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5972),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2168),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(646),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [647] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2670),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(647),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [648] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2672),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(648),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [649] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2849),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(649),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [650] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2671),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(650),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [651] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2667),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(651),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [652] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2798),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5948),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(69),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(652),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_defined_QMARK] = ACTIONS(2494),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2500),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [653] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5028),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3951),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5968),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(653),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_defined_QMARK] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2422),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2426),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [654] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(5028),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(4146),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(395),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5933),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2526),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(654),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [655] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4945),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3908),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5968),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(655),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_defined_QMARK] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2422),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2426),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [656] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return_command] = STATE(5033),
    [sym_yield_command] = STATE(5033),
    [sym_break_command] = STATE(5033),
    [sym_next_command] = STATE(5033),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__expression] = STATE(4948),
    [sym_match_pattern] = STATE(5033),
    [sym_test_pattern] = STATE(5033),
    [sym__arg] = STATE(3619),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3517),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(5018),
    [sym_command_call_with_block] = STATE(4830),
    [sym__chained_command_call] = STATE(383),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_command_assignment] = STATE(5033),
    [sym_operator_assignment] = STATE(3407),
    [sym_command_operator_assignment] = STATE(5033),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_command_binary] = STATE(5033),
    [sym_unary] = STATE(3407),
    [sym_command_unary] = STATE(5033),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5968),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1942),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2010),
    [sym_identifier_suffix] = STATE(2005),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(656),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_defined_QMARK] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2422),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(327),
    [sym_self] = ACTIONS(327),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(327),
    [aux_sym_constant_suffix_token1] = ACTIONS(331),
    [aux_sym_identifier_suffix_token1] = ACTIONS(333),
    [sym_instance_variable] = ACTIONS(335),
    [sym_class_variable] = ACTIONS(335),
    [sym_global_variable] = ACTIONS(335),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2426),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(365),
    [sym__constant_suffix] = ACTIONS(331),
  },
  [657] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2745),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5890),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2145),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(657),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [658] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3171),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5983),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(658),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [659] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2745),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5761),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(659),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [660] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2782),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(660),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [661] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2975),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5983),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(661),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [662] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4510),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3223),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5983),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(662),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [663] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3220),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5983),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(663),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [664] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3171),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2801),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(11),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4596),
    [sym__chained_command_call] = STATE(328),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5983),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1987),
    [sym_identifier_suffix] = STATE(1988),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(664),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [665] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2798),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(665),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [666] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(5369),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(3992),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(378),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(666),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [667] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2670),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3170),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(344),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5952),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(56),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2267),
    [sym__variable] = STATE(14),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(667),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [668] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4503),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2747),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3450),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(17),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(364),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5761),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(668),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [669] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return_command] = STATE(4506),
    [sym_yield_command] = STATE(4506),
    [sym_break_command] = STATE(4506),
    [sym_next_command] = STATE(4506),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__expression] = STATE(4495),
    [sym_match_pattern] = STATE(4506),
    [sym_test_pattern] = STATE(4506),
    [sym__arg] = STATE(2798),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2561),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4493),
    [sym_command_call_with_block] = STATE(4480),
    [sym__chained_command_call] = STATE(249),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_command_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(2529),
    [sym_command_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_command_binary] = STATE(4506),
    [sym_unary] = STATE(2529),
    [sym_command_unary] = STATE(4506),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2142),
    [sym__variable] = STATE(3),
    [sym__nonlocal_variable] = STATE(1913),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(669),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [670] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__hash_pattern_body] = STATE(5758),
    [sym_keyword_pattern] = STATE(4925),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4306),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_hash_splat_argument] = STATE(5533),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(3578),
    [sym_identifier_suffix] = STATE(3599),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3600),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(670),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5533),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2530),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [671] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3211),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(671),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2362),
    [anon_sym___END__] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2362),
    [sym__no_line_break] = ACTIONS(2470),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [672] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__hash_pattern_body] = STATE(5809),
    [sym_keyword_pattern] = STATE(4925),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4306),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_hash_splat_argument] = STATE(5533),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(3578),
    [sym_identifier_suffix] = STATE(3599),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3600),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(672),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5533),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2530),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [673] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__hash_pattern_body] = STATE(5809),
    [sym_keyword_pattern] = STATE(4925),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4306),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_hash_splat_argument] = STATE(5507),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(3578),
    [sym_identifier_suffix] = STATE(3599),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3600),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(673),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5507),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2536),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2530),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [674] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__hash_pattern_body] = STATE(5758),
    [sym_keyword_pattern] = STATE(4925),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4306),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_hash_splat_argument] = STATE(5507),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(3578),
    [sym_identifier_suffix] = STATE(3599),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3600),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(674),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5507),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2538),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2530),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [675] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3230),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(675),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(2472),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2472),
    [anon_sym___END__] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2472),
    [sym__no_line_break] = ACTIONS(2476),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [676] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__hash_pattern_body] = STATE(5758),
    [sym_keyword_pattern] = STATE(4925),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4306),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_hash_splat_argument] = STATE(5533),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(3578),
    [sym_identifier_suffix] = STATE(3599),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3600),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(676),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5533),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2540),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2530),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [677] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_then] = STATE(5372),
    [sym_begin] = STATE(2359),
    [sym_exceptions] = STATE(5090),
    [sym_exception_variable] = STATE(5291),
    [sym__arg] = STATE(3966),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(5281),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(677),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym__terminator] = STATE(281),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(2542),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_then] = ACTIONS(2544),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2546),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [678] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3228),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(678),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(2506),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2506),
    [anon_sym___END__] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2506),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [679] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3386),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(679),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(2472),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2472),
    [anon_sym___END__] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2472),
    [sym__no_line_break] = ACTIONS(2476),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [680] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2996),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(680),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(2478),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2478),
    [anon_sym___END__] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2480),
    [anon_sym_or] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2478),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [681] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2909),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(681),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [682] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3159),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(682),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2502),
    [anon_sym___END__] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2504),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2504),
    [anon_sym_or] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2502),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [683] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3477),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(683),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2362),
    [anon_sym___END__] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2362),
    [sym__no_line_break] = ACTIONS(2470),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [684] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3382),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(684),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(2506),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2506),
    [anon_sym___END__] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2506),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [685] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3232),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(685),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [686] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3218),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(686),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(2478),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2478),
    [anon_sym___END__] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2480),
    [anon_sym_or] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2478),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [687] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3471),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(687),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [ts_builtin_sym_end] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2502),
    [anon_sym___END__] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2504),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2504),
    [anon_sym_or] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2502),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [688] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__pattern_primitive] = STATE(4798),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3789),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3671),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2571),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3380),
    [sym_subshell] = STATE(3671),
    [sym_string_array] = STATE(3671),
    [sym_symbol_array] = STATE(3671),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3671),
    [sym_heredoc_body] = STATE(688),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(3674),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2478),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(2548),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [689] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3583),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(689),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2472),
    [sym__no_line_break] = ACTIONS(2476),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [690] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3972),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(690),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_do] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2362),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym__no_line_break] = ACTIONS(2366),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [691] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3989),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(691),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym__no_line_break] = ACTIONS(2550),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [692] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3907),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(692),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_then] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2362),
    [sym__no_line_break] = ACTIONS(2470),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [693] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3900),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(693),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_then] = ACTIONS(2474),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2472),
    [sym__no_line_break] = ACTIONS(2476),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [694] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3580),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(694),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2362),
    [sym__no_line_break] = ACTIONS(2470),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [695] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3631),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(695),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_then] = ACTIONS(2480),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2480),
    [anon_sym_or] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2478),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [696] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_primitive] = STATE(4443),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2996),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2421),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2087),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2208),
    [sym_subshell] = STATE(2421),
    [sym_string_array] = STATE(2421),
    [sym_symbol_array] = STATE(2421),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2421),
    [sym_heredoc_body] = STATE(696),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2343),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1734),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [697] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__pattern_primitive] = STATE(4798),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3789),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3671),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2571),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3380),
    [sym_subshell] = STATE(3671),
    [sym_string_array] = STATE(3671),
    [sym_symbol_array] = STATE(3671),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3671),
    [sym_heredoc_body] = STATE(697),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(3674),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(2548),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [698] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_primitive] = STATE(4443),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3218),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2421),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2087),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2208),
    [sym_subshell] = STATE(2421),
    [sym_string_array] = STATE(2421),
    [sym_symbol_array] = STATE(2421),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2421),
    [sym_heredoc_body] = STATE(698),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2343),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1734),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [699] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4067),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(699),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_then] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2362),
    [sym__no_line_break] = ACTIONS(2470),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [700] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3926),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(700),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_then] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2506),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [701] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3950),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(701),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_then] = ACTIONS(2504),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2504),
    [anon_sym_or] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2502),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [702] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4123),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(702),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym__no_line_break] = ACTIONS(2550),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [703] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__pattern_primitive] = STATE(4798),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3747),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3338),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2442),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(3338),
    [sym_string_array] = STATE(3338),
    [sym_symbol_array] = STATE(3338),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3338),
    [sym_heredoc_body] = STATE(703),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(3271),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1760),
    [sym_true] = ACTIONS(1762),
    [sym_false] = ACTIONS(1762),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1766),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [704] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4127),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(704),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2362),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym__no_line_break] = ACTIONS(2366),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [705] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4060),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(705),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_then] = ACTIONS(2474),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2472),
    [sym__no_line_break] = ACTIONS(2476),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [706] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3938),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(706),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(2504),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2502),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2504),
    [anon_sym_or] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [707] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__pattern_primitive] = STATE(4798),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3685),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3338),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2442),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(3338),
    [sym_string_array] = STATE(3338),
    [sym_symbol_array] = STATE(3338),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3338),
    [sym_heredoc_body] = STATE(707),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(3271),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1760),
    [sym_true] = ACTIONS(1762),
    [sym_false] = ACTIONS(1762),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1766),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [708] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3570),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(708),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2504),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2504),
    [anon_sym_or] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2502),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [709] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4051),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(709),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym__no_line_break] = ACTIONS(2550),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [710] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_primitive] = STATE(4443),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3982),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2421),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2087),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2208),
    [sym_subshell] = STATE(2421),
    [sym_string_array] = STATE(2421),
    [sym_symbol_array] = STATE(2421),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2421),
    [sym_heredoc_body] = STATE(710),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2343),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1734),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [711] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4046),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(711),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_do] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2362),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym__no_line_break] = ACTIONS(2366),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [712] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3571),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(712),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2506),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [713] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_primitive] = STATE(4443),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2748),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2421),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2087),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2208),
    [sym_subshell] = STATE(2421),
    [sym_string_array] = STATE(2421),
    [sym_symbol_array] = STATE(2421),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2421),
    [sym_heredoc_body] = STATE(713),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2343),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1734),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [714] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3452),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(714),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [715] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__pattern_primitive] = STATE(4798),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3780),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3338),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2442),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(3338),
    [sym_string_array] = STATE(3338),
    [sym_symbol_array] = STATE(3338),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3338),
    [sym_heredoc_body] = STATE(715),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(3271),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1760),
    [sym_true] = ACTIONS(1762),
    [sym_false] = ACTIONS(1762),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1766),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [716] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3984),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(716),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2506),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [717] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3642),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(717),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [718] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3378),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(718),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2480),
    [anon_sym_or] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2478),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [719] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3747),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(719),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2478),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2478),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2480),
    [anon_sym_or] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [720] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__pattern_primitive] = STATE(4443),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3789),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(3119),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2272),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2816),
    [sym_subshell] = STATE(3119),
    [sym_string_array] = STATE(3119),
    [sym_symbol_array] = STATE(3119),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(3119),
    [sym_heredoc_body] = STATE(720),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(3114),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1682),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1690),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1696),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(1698),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [721] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_primitive] = STATE(4443),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3378),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2421),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2087),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2208),
    [sym_subshell] = STATE(2421),
    [sym_string_array] = STATE(2421),
    [sym_symbol_array] = STATE(2421),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2421),
    [sym_heredoc_body] = STATE(721),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2343),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1734),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [722] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym__pattern_primitive] = STATE(4798),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3789),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(3338),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2442),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(3338),
    [sym_string_array] = STATE(3338),
    [sym_symbol_array] = STATE(3338),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(3338),
    [sym_heredoc_body] = STATE(722),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(3271),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1760),
    [sym_true] = ACTIONS(1762),
    [sym_false] = ACTIONS(1762),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1766),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [723] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_primitive] = STATE(4443),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2673),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2421),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2087),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2208),
    [sym_subshell] = STATE(2421),
    [sym_string_array] = STATE(2421),
    [sym_symbol_array] = STATE(2421),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2421),
    [sym_heredoc_body] = STATE(723),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2343),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1734),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [724] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3663),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(724),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [725] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_primitive] = STATE(4443),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3631),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2421),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2087),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2208),
    [sym_subshell] = STATE(2421),
    [sym_string_array] = STATE(2421),
    [sym_symbol_array] = STATE(2421),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2421),
    [sym_heredoc_body] = STATE(725),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2343),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1734),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [726] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym__pattern_primitive] = STATE(4798),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2830),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(3149),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2240),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2812),
    [sym_subshell] = STATE(3149),
    [sym_string_array] = STATE(3149),
    [sym_symbol_array] = STATE(3149),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(3149),
    [sym_heredoc_body] = STATE(726),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(3152),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(2552),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(677),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [727] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4104),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(727),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_then] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2506),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [728] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4064),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(728),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(2504),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2502),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2504),
    [anon_sym_or] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [729] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3795),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(729),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [730] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4031),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(730),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2506),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [731] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4063),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(731),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2506),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [732] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3685),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(732),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2478),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2478),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2480),
    [anon_sym_or] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [733] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3894),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(733),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [734] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3712),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(734),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [735] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4214),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(735),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2362),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym__no_line_break] = ACTIONS(2366),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [736] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3999),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(736),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2502),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2504),
    [anon_sym_or] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [737] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4057),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(737),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_then] = ACTIONS(2504),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2504),
    [anon_sym_or] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2502),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [738] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3982),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(738),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_then] = ACTIONS(2480),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2480),
    [anon_sym_or] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2478),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [739] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3780),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(739),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2478),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2478),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2480),
    [anon_sym_or] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [740] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4202),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(740),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym__no_line_break] = ACTIONS(2550),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [741] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4306),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_hash_splat_argument] = STATE(5638),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(3549),
    [sym_identifier_suffix] = STATE(3555),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(741),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5638),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2556),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [742] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4180),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(742),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2502),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2504),
    [anon_sym_or] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [743] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4053),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(743),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [744] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4306),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_hash_splat_argument] = STATE(5533),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(3549),
    [sym_identifier_suffix] = STATE(3555),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(744),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5533),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2558),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [745] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3825),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(745),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [746] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4306),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_hash_splat_argument] = STATE(5638),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(3549),
    [sym_identifier_suffix] = STATE(3555),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(746),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5638),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2560),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [747] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3789),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(747),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2478),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2478),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2480),
    [anon_sym_or] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [748] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4306),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_hash_splat_argument] = STATE(5507),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(3549),
    [sym_identifier_suffix] = STATE(3555),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(748),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5507),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2562),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [749] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4306),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_hash_splat_argument] = STATE(5638),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(3549),
    [sym_identifier_suffix] = STATE(3555),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(749),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5638),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [750] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4065),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(750),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2362),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym__no_line_break] = ACTIONS(2366),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [751] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4115),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(751),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym__no_line_break] = ACTIONS(2550),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [752] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4306),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_hash_splat_argument] = STATE(5553),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(3549),
    [sym_identifier_suffix] = STATE(3555),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(752),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5553),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2566),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [753] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4306),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_hash_splat_argument] = STATE(5638),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(3549),
    [sym_identifier_suffix] = STATE(3555),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(753),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5638),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2568),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [754] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4179),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(754),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2506),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [755] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4306),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_hash_splat_argument] = STATE(5638),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(3549),
    [sym_identifier_suffix] = STATE(3555),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(755),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5638),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2570),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [756] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4306),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_hash_splat_argument] = STATE(5638),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(3549),
    [sym_identifier_suffix] = STATE(3555),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(756),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5638),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2572),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [757] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4110),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(4169),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(757),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2574),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [758] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2717),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2733),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(758),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2454),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [759] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3673),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3832),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(759),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2448),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [760] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2863),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2873),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(760),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2398),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [761] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3133),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3145),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(761),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2436),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [762] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3987),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(4040),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(762),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2452),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [763] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2341),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2542),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2545),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2341),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(763),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2576),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [764] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3598),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3559),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(764),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2466),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [765] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2998),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3678),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3758),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(2998),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(765),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2578),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [766] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2341),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3325),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3390),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2341),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(766),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [767] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2341),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2892),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2880),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2341),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(767),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2582),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [768] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3341),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3356),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(768),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2412),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [769] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2341),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2664),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2692),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2341),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(769),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [770] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2646),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2656),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(770),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2400),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [771] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4116),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(4144),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(771),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2574),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [772] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2998),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3547),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3557),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(2998),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(772),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2586),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [773] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2341),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3502),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3595),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2341),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(773),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2588),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [774] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2998),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3624),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3886),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(2998),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(774),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2590),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [775] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2998),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3231),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3324),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(2998),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(775),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2592),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [776] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4055),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(776),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2502),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [777] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4306),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_hash_splat_argument] = STATE(5638),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(3549),
    [sym_identifier_suffix] = STATE(3555),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3184),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(777),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_pair] = STATE(5638),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [778] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2341),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3143),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3161),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2341),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(778),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2594),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [779] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3944),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(4006),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(779),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2596),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [780] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3491),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3561),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(780),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2402),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [781] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3603),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3880),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(781),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2448),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [782] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2998),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3507),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3489),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(2998),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(782),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2598),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [783] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3588),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3651),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(783),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2452),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [784] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3550),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3579),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(784),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2424),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [785] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3121),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3117),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(785),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2436),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [786] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2998),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3179),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3177),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(2998),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(786),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2600),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [787] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2341),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2897),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2890),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2341),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(787),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2582),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [788] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3348),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3319),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(788),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2412),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [789] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2341),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2464),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2486),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2341),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(789),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2602),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [790] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2998),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3202),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3288),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(2998),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(790),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2586),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [791] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2735),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2705),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(791),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2454),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [792] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2341),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3497),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3575),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2341),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(792),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2588),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [793] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2341),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2755),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2756),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2341),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(793),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2604),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [794] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2998),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3718),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3873),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(2998),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(794),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2590),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [795] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2998),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3224),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3183),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(2998),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(795),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2598),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [796] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2341),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2772),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2766),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2341),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(796),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2604),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [797] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2530),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3973),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(4007),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2530),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(797),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2596),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [798] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2341),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3327),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(3405),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2341),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(798),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [799] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3551),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3655),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(799),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2396),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [800] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2341),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2540),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2524),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_right_assignment_list] = STATE(2341),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(800),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2576),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [801] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2998),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3725),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3614),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(2998),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(801),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2578),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [802] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3921),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3924),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(802),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2424),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [803] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4079),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(4077),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(803),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2606),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [804] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3379),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4069),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(4092),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_right_assignment_list] = STATE(3379),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(804),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2606),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [805] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4199),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(805),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2608),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [806] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4150),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(806),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(2506),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [807] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4151),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(807),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [808] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_pattern] = STATE(5346),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4105),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(5348),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(808),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2546),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [809] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_pattern] = STATE(5080),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4105),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(5348),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(809),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2546),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [810] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4235),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(810),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2608),
    [anon_sym_PIPE] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [811] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2826),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2429),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(811),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2604),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [812] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3910),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3105),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(812),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2590),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [813] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3422),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3105),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(813),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2586),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [814] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4062),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2539),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(814),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2596),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [815] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3442),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2539),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(815),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2412),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [816] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3774),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3105),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(816),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2578),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [817] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3625),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3451),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(817),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2424),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [818] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2940),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2429),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(818),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2582),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [819] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3328),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3105),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(819),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2598),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [820] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3658),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3451),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(820),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2466),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [821] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2502),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2429),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(821),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2602),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [822] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4240),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3451),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(822),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2574),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [823] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4158),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(823),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_do] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [824] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4212),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3451),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(824),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2606),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [825] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3227),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2539),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(825),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2436),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [826] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3788),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3451),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(826),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2396),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [827] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3343),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2429),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(827),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2594),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [828] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2778),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2539),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(828),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2454),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [829] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3494),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2429),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(829),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [830] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2721),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2429),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(830),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [831] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4008),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(5294),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(831),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2546),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [832] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2553),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2429),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(832),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2576),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [833] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2661),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2539),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(833),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2400),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [834] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3729),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2539),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(834),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2402),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [835] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3898),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2539),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(835),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2448),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [836] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4247),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(836),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(2608),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(2608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [837] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3061),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2539),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(837),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2398),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [838] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3377),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3105),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(838),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2592),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [839] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3354),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3105),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(839),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2600),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [840] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3756),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_splat_argument] = STATE(2429),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(840),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2588),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [841] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3782),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_splat_argument] = STATE(3451),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(841),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__splat_star] = ACTIONS(2452),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [842] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3281),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(842),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [843] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2983),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3960),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(843),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [844] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2339),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3493),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(844),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [845] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3090),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3945),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(845),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [846] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2332),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3576),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(846),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [847] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2339),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2857),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(847),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [848] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2332),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3605),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(848),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [849] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2763),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(849),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [850] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3627),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(850),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [851] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2332),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2840),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(851),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [852] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2339),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2492),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(852),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [853] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4129),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(853),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [854] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4219),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(854),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [855] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2332),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2738),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(855),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [856] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2339),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3622),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(856),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [857] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2339),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2548),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(857),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [858] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3529),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(858),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [859] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3090),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3915),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(859),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [860] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2785),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(860),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [861] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2339),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2807),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(861),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [862] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2332),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2607),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(862),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [863] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4012),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(863),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [864] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2983),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3611),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(864),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [865] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3090),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3754),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(865),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [866] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4081),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(866),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [867] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3090),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3351),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(867),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [868] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2983),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3695),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(868),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [869] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3090),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3312),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(869),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [870] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3617),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(870),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [871] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2339),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2634),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(871),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [872] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2332),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3011),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(872),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [873] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2332),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3189),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(873),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [874] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2983),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3280),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(874),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [875] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2681),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(875),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [876] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2930),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(876),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [877] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2339),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3142),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(877),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [878] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3626),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(878),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [879] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(5332),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4026),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(879),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [880] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2983),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3335),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(880),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [881] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2339),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3470),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(881),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [882] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2339),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2707),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(882),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [883] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4117),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(883),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [884] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2339),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2957),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(884),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [885] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3190),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(885),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [886] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2332),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3445),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(886),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [887] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3090),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3811),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(887),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [888] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2983),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3359),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(888),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [889] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3785),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(889),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [890] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3090),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3274),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(890),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [891] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3466),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(891),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [892] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3752),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(892),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [893] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2332),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3123),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(893),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [894] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3090),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3692),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(894),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [895] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2339),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3162),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(895),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [896] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2983),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3833),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(896),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [897] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4114),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(897),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [898] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4135),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(898),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [899] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3090),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3846),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(899),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [900] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3090),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3313),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(900),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [901] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4239),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(901),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [902] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2332),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3503),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(902),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [903] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2983),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3798),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(903),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [904] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2332),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2558),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(904),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [905] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2332),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2884),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(905),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [906] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3563),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(906),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [907] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2983),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3988),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(907),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [908] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2332),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2518),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(908),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [909] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_rescue_modifier_arg] = STATE(2983),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3298),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(909),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [910] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2339),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3554),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(910),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [911] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_rescue_modifier_arg] = STATE(2541),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3956),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(911),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [912] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2594),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(912),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [913] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2416),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(913),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [914] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4307),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(914),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [915] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3158),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(915),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [916] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3218),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(916),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [917] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3158),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(917),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [918] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2837),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(918),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [919] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2836),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(919),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [920] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4312),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(920),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [921] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4328),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(921),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [922] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4346),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(922),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [923] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4347),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(923),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [924] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4355),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(924),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [925] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2537),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(925),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [926] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4356),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(926),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [927] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4359),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(927),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [928] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4332),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(928),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [929] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4322),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(929),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [930] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4276),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(930),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [931] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4373),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(931),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [932] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4298),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(932),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [933] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4301),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(933),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [934] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4302),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(934),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [935] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4308),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(935),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [936] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4309),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(936),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [937] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4311),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(937),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [938] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4318),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(938),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [939] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4319),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(939),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [940] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4341),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(940),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [941] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3287),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(941),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [942] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3290),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(942),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [943] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3515),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(943),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [944] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3252),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(944),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [945] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2783),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(945),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [946] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4349),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(946),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [947] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4370),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(947),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [948] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4326),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(948),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [949] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4270),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(949),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [950] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4295),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(950),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [951] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4273),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(951),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [952] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4277),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(952),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [953] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4310),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(953),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [954] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4324),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(954),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [955] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4292),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(955),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [956] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4283),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(956),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [957] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4375),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(957),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [958] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4294),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(958),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [959] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4378),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(959),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [960] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4269),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(960),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [961] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4130),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(961),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [962] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2833),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(962),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [963] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2832),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(963),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [964] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4192),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(964),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [965] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4154),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(965),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [966] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4141),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(966),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [967] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4171),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(967),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [968] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4201),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(968),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [969] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2829),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(969),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [970] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4205),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(970),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [971] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4177),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(971),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [972] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2828),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(972),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [973] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2827),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(973),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [974] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4178),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(974),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [975] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4182),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(975),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [976] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4203),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(976),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [977] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4208),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(977),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [978] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4215),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(978),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [979] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4358),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(979),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [980] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4333),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(980),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [981] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2819),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(981),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [982] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2818),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(982),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [983] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2981),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(983),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [984] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3400),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(984),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [985] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2815),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(985),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [986] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3607),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(986),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [987] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(987),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [988] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2813),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(988),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [989] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3472),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(989),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [990] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3270),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(990),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [991] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2792),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(991),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [992] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4202),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(992),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [993] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2969),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(993),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [994] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2981),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(994),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [995] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3006),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(995),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [996] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4206),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(996),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [997] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2990),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(997),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [998] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2999),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(998),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [999] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2995),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(999),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1000] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2994),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1000),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1001] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2993),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1001),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1002] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2992),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1002),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1003] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2991),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1003),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1004] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2989),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1004),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1005] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2988),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1005),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1006] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2987),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1006),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1007] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4133),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1007),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1008] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2986),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1008),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1009] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2982),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1009),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1010] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2416),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1010),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1011] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4209),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1011),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1012] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2900),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1012),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1013] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3018),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1013),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1014] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4118),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1014),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1015] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4245),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1015),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1016] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3386),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1016),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1017] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2784),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1017),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1018] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2881),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1018),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1019] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4101),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1019),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1020] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3388),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1020),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1021] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3608),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1021),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1022] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3738),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1022),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1023] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3632),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1023),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1024] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3633),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1024),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1025] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3645),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1025),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1026] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1026),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1027] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3652),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1027),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1028] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3623),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1028),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1029] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3669),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1029),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1030] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3665),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1030),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1031] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3757),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1031),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1032] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3620),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1032),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1033] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3618),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1033),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1034] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2416),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1034),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1035] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3722),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1035),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1036] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3719),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1036),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1037] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5858),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1037),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_defined_QMARK] = ACTIONS(1960),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1968),
    [sym__unary_minus_num] = ACTIONS(1970),
    [sym__binary_minus] = ACTIONS(1968),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1038] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2899),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1038),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1039] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3812),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1039),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1040] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2537),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1040),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1041] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3789),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1041),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1042] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3402),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1042),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1043] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3387),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1043),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1044] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3596),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1044),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1045] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3461),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1045),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1046] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3465),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1046),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1047] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3464),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1047),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1048] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3460),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1048),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1049] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4153),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1049),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1050] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3459),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1050),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1051] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3458),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1051),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1052] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3457),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1052),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1053] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3456),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1053),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1054] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3453),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1054),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1055] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3448),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1055),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1056] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3449),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1056),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1057] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3403),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1057),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1058] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3400),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1058),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1059] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4073),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1059),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1060] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3812),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1060),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1061] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3378),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1061),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1062] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3816),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1062),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1063] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3818),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1063),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1064] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3472),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1064),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1065] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4066),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1065),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1066] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4119),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1066),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1067] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4089),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1067),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1068] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4080),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1068),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1069] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4124),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1069),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1070] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4102),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1070),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1071] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4094),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1071),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1072] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4085),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1072),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1073] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4076),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1073),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1074] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4075),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1074),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1075] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4072),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1075),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1076] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4074),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1076),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1077] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2537),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1077),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1078] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4111),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1078),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1079] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4093),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1079),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1080] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4101),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2527),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1080),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1081] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3583),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1081),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_defined_QMARK] = ACTIONS(1806),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1812),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1812),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1082] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3876),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1082),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1083] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3877),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1083),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1084] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3762),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1084),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1085] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3889),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1085),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1086] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3884),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1086),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1087] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3883),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1087),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1088] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3878),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1088),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1089] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3875),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1089),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1090] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3872),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1090),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1091] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4345),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1091),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1092] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4134),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1092),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1093] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3871),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1093),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1094] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4313),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1094),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1095] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4314),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1095),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1096] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4316),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1096),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1097] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4320),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1097),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1098] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4321),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1098),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1099] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1099),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1100] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3861),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1100),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1101] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4323),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1101),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1102] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3230),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1102),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1103] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4325),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1103),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1104] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4327),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1104),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1105] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4330),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1105),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1106] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4348),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1106),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1107] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4360),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1107),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1108] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3803),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1108),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1109] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4374),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1109),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1110] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4377),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1110),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1111] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4361),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1111),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1112] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4350),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1112),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1113] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4300),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1113),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1114] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4275),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1114),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1115] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4271),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1115),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1116] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4280),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1116),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1117] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4369),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1117),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1118] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4027),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1118),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1119] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4274),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1119),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1120] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3765),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1120),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1121] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4339),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1121),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1122] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3893),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1122),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1123] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3953),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1123),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1124] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4317),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1124),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1125] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3954),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1125),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1126] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2537),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1126),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1127] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4293),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1127),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1128] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3949),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1128),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1129] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4376),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1129),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1130] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3980),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1130),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1131] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3979),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1131),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1132] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3978),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1132),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1133] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4351),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1133),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1134] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3976),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1134),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1135] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3975),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1135),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1136] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3963),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1136),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1137] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4357),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1137),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1138] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3974),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1138),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1139] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3970),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1139),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1140] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2515),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1140),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1141] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2577),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1141),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1142] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1142),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1143] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2669),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1143),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1144] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2768),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1144),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1145] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3969),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1145),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1146] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3968),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1146),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1147] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3965),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1147),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1148] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3900),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1148),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1149] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3977),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1149),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1150] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3287),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1150),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1151] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3294),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1151),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1152] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4100),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1152),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1153] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3293),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1153),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1154] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3890),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1154),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1155] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4070),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1155),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1156] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2537),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1156),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1157] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4106),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1157),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1158] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4107),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1158),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1159] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3472),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1159),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1160] = {
    [sym_heredoc_body] = STATE(1160),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2612),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_when] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_ensure] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1161] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4097),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1161),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1162] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4096),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1162),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1163] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4095),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1163),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1164] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4091),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1164),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1165] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4329),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1165),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1166] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4090),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1166),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1167] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2795),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1167),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1168] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4088),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1168),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1169] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4087),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1169),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1170] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2830),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1170),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1171] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2795),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1171),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1172] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4086),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1172),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1173] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3263),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1173),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1174] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4352),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1174),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1175] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3952),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1175),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1176] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4084),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1176),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1177] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3986),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1177),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1178] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3879),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1178),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1179] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4083),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1179),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1180] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3787),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1180),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1181] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3817),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1181),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1182] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3514),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1182),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1183] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3264),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1183),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1184] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4018),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1184),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1185] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4015),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1185),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1186] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3569),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1186),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1187] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3882),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1187),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1188] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3444),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1188),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1189] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3446),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1189),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1190] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2513),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1190),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1191] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3519),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1191),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1192] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4210),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1192),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1193] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4078),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1193),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1194] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4120),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1194),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1195] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3424),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1195),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1196] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3948),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1196),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1197] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3425),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1197),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1198] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2576),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1198),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1199] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4112),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1199),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1200] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3581),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1200),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1201] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3809),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1201),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1202] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4222),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1202),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1203] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4132),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1203),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1204] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4233),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1204),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1205] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4231),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1205),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1206] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3813),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1206),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1207] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1207),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1208] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4181),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1208),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1209] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4131),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1209),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1210] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2515),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1210),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1211] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4223),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1211),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1212] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4220),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1212),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1213] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2514),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1213),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1214] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2508),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1214),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1215] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2497),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1215),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1216] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2495),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1216),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1217] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2494),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1217),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1218] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2493),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1218),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1219] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2490),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1219),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1220] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2504),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1220),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1221] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2511),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1221),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1222] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2491),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1222),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1223] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2522),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1223),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1224] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2521),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1224),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1225] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2519),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1225),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1226] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3472),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1226),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1227] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4246),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1227),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1228] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2416),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1228),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1229] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2501),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1229),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1230] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2496),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5722),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2128),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1230),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1231] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3120),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1231),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1232] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2577),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1232),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1233] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3918),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1233),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1234] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3927),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1234),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1235] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2562),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1235),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1236] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2560),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1236),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1237] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2563),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1237),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1238] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2564),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1238),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1239] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2565),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1239),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1240] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2566),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1240),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1241] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2567),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1241),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1242] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2568),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1242),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1243] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2569),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1243),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1244] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4242),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1244),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1245] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2570),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1245),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1246] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4258),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1246),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1247] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2546),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1247),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1248] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2547),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1248),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1249] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2573),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1249),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1250] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2416),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1250),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1251] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2555),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1251),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1252] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2554),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1252),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__unary_minus_num] = ACTIONS(1011),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1253] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2824),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1253),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1254] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2716),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1254),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1255] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3310),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1255),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1256] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3311),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1256),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1257] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4226),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1257),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1258] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2703),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1258),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1259] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2739),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1259),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1260] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4243),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1260),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1261] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2718),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1261),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1262] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2715),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1262),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1263] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2714),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1263),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1264] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2708),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1264),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1265] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2723),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1265),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1266] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2702),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1266),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1267] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2709),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1267),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1268] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2710),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1268),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1269] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2711),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1269),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1270] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2712),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1270),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1271] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2713),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1271),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1272] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2416),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1272),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1273] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2742),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1273),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1274] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4262),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1274),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1275] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2743),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1275),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1276] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3631),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1276),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1277] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3111),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1277),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1278] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3911),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1278),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1279] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4221),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1279),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1280] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4222),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1280),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1281] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3109),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1281),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1282] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3126),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1282),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1283] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3141),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1283),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1284] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3139),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1284),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1285] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3135),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1285),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1286] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3134),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1286),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1287] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3132),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1287),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1288] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4261),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1288),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1289] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4260),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1289),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1290] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3125),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1290),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1291] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3122),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1291),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1292] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3116),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1292),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1293] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3115),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1293),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1294] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3113),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1294),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1295] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3112),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1295),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1296] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2416),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1296),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1297] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3130),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1297),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1298] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3131),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1298),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1299] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2599),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1299),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1300] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2786),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1300),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1301] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4249),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1301),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1302] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4217),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1302),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1303] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4255),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1303),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1304] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4264),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1304),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1305] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3895),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1305),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1306] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4241),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1306),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1307] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4216),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5913),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2575),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1307),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_defined_QMARK] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2320),
    [sym__unary_minus_num] = ACTIONS(2322),
    [sym__binary_minus] = ACTIONS(2320),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1308] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3511),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1308),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1309] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3523),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1309),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1310] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3511),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1310),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1311] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3942),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1311),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1312] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3940),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1312),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1313] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3933),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1313),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1314] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3929),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1314),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1315] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3925),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1315),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1316] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3922),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1316),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1317] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3916),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1317),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1318] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3912),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1318),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1319] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3904),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1319),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1320] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3903),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1320),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1321] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3902),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1321),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1322] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3020),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1322),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1323] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3156),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1323),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1324] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3891),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1324),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1325] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3157),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1325),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1326] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1326),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1327] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2537),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1327),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1328] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3986),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5980),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2650),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1328),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_defined_QMARK] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2134),
    [sym__unary_minus_num] = ACTIONS(2136),
    [sym__binary_minus] = ACTIONS(2134),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1329] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3234),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1329),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1330] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4155),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1330),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1331] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3175),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1331),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1332] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4139),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1332),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1333] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2842),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1333),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1334] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2835),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1334),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1335] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3217),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1335),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1336] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3216),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1336),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1337] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2811),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1337),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1338] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2806),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1338),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1339] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2805),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1339),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1340] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2803),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1340),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1341] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2802),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1341),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1342] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2800),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1342),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1343] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2799),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1343),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1344] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2797),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1344),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1345] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2796),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1345),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1346] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2794),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1346),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1347] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2793),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1347),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1348] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2416),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1348),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1349] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2845),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1349),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1350] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2846),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1350),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1351] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2716),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1351),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1323),
    [sym__unary_minus_num] = ACTIONS(1325),
    [sym__binary_minus] = ACTIONS(1323),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1352] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4159),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1352),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1353] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3604),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1353),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1354] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3997),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1354),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1355] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4013),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1355),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1356] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4014),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1356),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1357] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2537),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1357),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1358] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4016),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1358),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1359] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4003),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1359),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1360] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4044),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1360),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1361] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4043),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1361),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1362] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4042),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1362),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1363] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4041),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1363),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1364] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4039),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1364),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1365] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3212),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1365),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1366] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3210),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1366),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1367] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3206),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1367),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1368] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4038),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1368),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1369] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4037),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1369),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1370] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4035),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1370),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1371] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4030),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1371),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1372] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4025),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1372),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1373] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4024),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1373),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1374] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3020),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1374),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1375] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3993),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1375),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1376] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4004),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1376),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1377] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4015),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5973),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2637),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1377),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1378] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3747),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1378),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1379] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3746),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1379),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1380] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2678),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1380),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1381] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2595),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1381),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1382] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2619),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1382),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1383] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2605),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1383),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1384] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2608),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1384),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1385] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2609),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1385),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1386] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3205),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1386),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1387] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2610),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1387),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1388] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2614),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1388),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1389] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2615),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1389),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1390] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2621),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1390),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1391] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2641),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1391),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1392] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2580),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1392),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1393] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2649),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1393),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1394] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4048),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1394),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1395] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4049),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1395),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1396] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4050),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1396),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1397] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4052),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1397),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1398] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2416),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1398),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1399] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4054),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1399),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1400] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4009),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1400),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1401] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4045),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1401),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1402] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4023),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1402),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1403] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4021),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1403),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1404] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4020),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1404),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1405] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4019),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1405),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1406] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2628),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1406),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1407] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3111),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5736),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2206),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1407),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_defined_QMARK] = ACTIONS(1617),
    [anon_sym_not] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1625),
    [sym__unary_minus_num] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1625),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1408] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2860),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1408),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1409] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1409),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1410] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3261),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1410),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1411] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3260),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1411),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1412] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3241),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1412),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1413] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3238),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1413),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1414] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3237),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1414),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1415] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3276),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1415),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1416] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3247),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1416),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1417] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3248),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1417),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1418] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3249),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1418),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1419] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3250),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1419),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1420] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3253),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1420),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1421] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3254),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1421),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1422] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3255),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1422),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1423] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2416),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1423),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1424] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3257),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1424),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1425] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3256),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1425),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1426] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3264),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5712),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2296),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1426),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1427] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3441),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1427),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1428] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3413),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1428),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1429] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3203),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1429),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1430] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4010),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1430),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1431] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3326),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1431),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1432] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3330),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1432),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1433] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3393),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1433),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1434] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3200),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1434),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1435] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3395),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1435),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1436] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3192),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1436),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1437] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4060),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1437),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1438] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3396),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1438),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1439] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3376),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1439),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1440] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3398),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1440),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1441] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3401),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1441),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1442] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3404),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1442),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1443] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3406),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1443),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1444] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3409),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1444),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1445] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3410),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1445),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1446] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3412),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1446),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1447] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3020),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1447),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1448] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4051),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1448),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1449] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3417),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1449),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1450] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3418),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1450),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1451] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3446),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5953),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2440),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1451),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_defined_QMARK] = ACTIONS(1565),
    [anon_sym_not] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1573),
    [sym__unary_minus_num] = ACTIONS(1575),
    [sym__binary_minus] = ACTIONS(1573),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1452] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3344),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1452),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1453] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3342),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1453),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1454] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3332),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1454),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1455] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2771),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1455),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1456] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2854),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1456),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1457] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3333),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1457),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1458] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3339),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1458),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1459] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3340),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1459),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1460] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4236),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1460),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1461] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3188),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1461),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1462] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4268),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1462),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1463] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3242),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1463),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1464] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3240),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1464),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1465] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2883),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1465),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1466] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3239),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1466),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1467] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2872),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1467),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1468] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2871),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1468),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1469] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2870),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1469),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1470] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2865),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1470),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1471] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2861),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1471),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1472] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2858),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1472),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1473] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2855),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1473),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1474] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3468),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1474),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1475] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2853),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1475),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1476] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2814),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2134),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1476),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1477] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2882),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1477),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1478] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2859),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1478),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1479] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2537),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1479),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1480] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3777),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1480),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1481] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2686),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1481),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1482] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2688),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1482),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1483] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2786),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2177),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1483),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1363),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_defined_QMARK] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1375),
    [sym__unary_minus_num] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(1375),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1484] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3982),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1484),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1485] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4183),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1485),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1486] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3815),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1486),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1487] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3836),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1487),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1488] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3800),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1488),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1489] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3780),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1489),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1490] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3799),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1490),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1491] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3796),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1491),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1492] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3794),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1492),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1493] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3790),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1493),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1494] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1494),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1495] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3773),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1495),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1496] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3764),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1496),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1497] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3763),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1497),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1498] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3829),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1498),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1499] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3802),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1499),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1500] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2416),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1500),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1501] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3855),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1501),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1502] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3857),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1502),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1503] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3882),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1503),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_defined_QMARK] = ACTIONS(2082),
    [anon_sym_not] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2090),
    [sym__unary_minus_num] = ACTIONS(2092),
    [sym__binary_minus] = ACTIONS(2090),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1504] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4303),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1504),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1505] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3478),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1505),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1506] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3244),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1506),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1507] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4379),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1507),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1508] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3439),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1508),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1509] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3438),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1509),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1510] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3435),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1510),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1511] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3434),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1511),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1512] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3433),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1512),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1513] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3432),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1513),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1514] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4296),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1514),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1515] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4297),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1515),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1516] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3472),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1516),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1517] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3824),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1517),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1518] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3827),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1518),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1519] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3849),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1519),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1520] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3430),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1520),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1521] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3429),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1521),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1522] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3428),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1522),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1523] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3427),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1523),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1524] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3426),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1524),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1525] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3020),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1525),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1526] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3474),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1526),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1527] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3473),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1527),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1528] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3425),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1528),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1529] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3621),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1529),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1530] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3615),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1530),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1531] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2633),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2141),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1531),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1051),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_defined_QMARK] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1063),
    [sym__unary_minus_num] = ACTIONS(1065),
    [sym__binary_minus] = ACTIONS(1063),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1532] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2722),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1532),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1533] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2680),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1533),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1534] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3852),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1534),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1535] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3862),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1535),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1536] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3863),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1536),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1537] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2662),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1537),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1538] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2701),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1538),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1539] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2700),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1539),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1540] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2699),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1540),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1541] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2698),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1541),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1542] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2697),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1542),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1543] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3865),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1543),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1544] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3866),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1544),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1545] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2696),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1545),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1546] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3868),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1546),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1547] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4033),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1547),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1548] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2694),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1548),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1549] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2693),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1549),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1550] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2691),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1550),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1551] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2690),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1551),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1552] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4190),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1552),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1553] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4002),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1553),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1554] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2537),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1554),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1555] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2769),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1555),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1556] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2770),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1556),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1557] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2669),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1557),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1558] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4000),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1558),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1559] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2856),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1559),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1560] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3812),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1560),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1561] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3296),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1561),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1562] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3303),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1562),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1563] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3284),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1563),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1564] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3285),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1564),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1565] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3286),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1565),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1566] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3289),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1566),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1567] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3291),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1567),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1568] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3292),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1568),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1569] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3869),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1569),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1570] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3295),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1570),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1571] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3297),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1571),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1572] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3299),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1572),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1573] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3300),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1573),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1574] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3301),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1574),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1575] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3020),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1575),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1576] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3235),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1576),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1577] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3308),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1577),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1578] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3311),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5930),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2382),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1578),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1579] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3870),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1579),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1580] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3710),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1580),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1581] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3512),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1581),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1582] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3510),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1582),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1583] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3513),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1583),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1584] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3532),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1584),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1585] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3538),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1585),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1586] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3540),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1586),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1587] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3546),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1587),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1588] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3544),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1588),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1589] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3535),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1589),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1590] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3505),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1590),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1591] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3504),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1591),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1592] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3498),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1592),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1593] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4304),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1593),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1594] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3506),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1594),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1595] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3486),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1595),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1596] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3519),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1596),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1597] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3887),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1597),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1598] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3771),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1598),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1599] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3831),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1599),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1600] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3821),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1600),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1601] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3807),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1601),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1602] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3805),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1602),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1603] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3804),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1603),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1604] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3801),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1604),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1605] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3768),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1605),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1606] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3770),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1606),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1607] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3830),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1607),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1608] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3842),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1608),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1609] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3843),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1609),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1610] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3860),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1610),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1611] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3020),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1611),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1612] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3826),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1612),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1613] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3828),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1613),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1614] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3813),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1614),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1615] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4071),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1615),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1616] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4070),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1616),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1617] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3009),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1617),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1618] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2788),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1618),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1619] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4211),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1619),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1620] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3874),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1620),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1621] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2787),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1621),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1622] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3881),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1622),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1623] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4192),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1623),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1624] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2762),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1624),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1625] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3283),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5970),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2181),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1625),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_defined_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1626] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2754),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1626),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1627] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2753),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1627),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1628] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2751),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1628),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1629] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2750),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1629),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1630] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2749),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1630),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1631] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4363),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5875),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2538),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1631),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1632] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2746),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1632),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1633] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2765),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1633),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1634] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2761),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1634),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1635] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3793),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1635),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1636] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4183),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1636),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1637] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4191),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1637),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1638] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2759),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1638),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1639] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4188),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1639),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1640] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2537),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1640),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1641] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2758),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1641),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1642] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2752),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1642),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1643] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4115),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5665),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2447),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1643),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2020),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_defined_QMARK] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1644] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2416),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1644),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1645] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2887),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1645),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1646] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2886),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1646),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1647] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2768),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1647),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1648] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3688),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1648),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1649] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3750),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1649),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1650] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3749),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1650),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1651] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3472),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1651),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1652] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2673),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1652),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1653] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4147),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1653),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1654] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4145),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1654),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1655] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4140),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1655),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1656] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4163),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1656),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1657] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3893),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1657),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_defined_QMARK] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_TILDE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1786),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1786),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1658] = {
    [sym_heredoc_body] = STATE(1658),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2614),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_when] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_ensure] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1659] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4166),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1659),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1660] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4184),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1660),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1661] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4197),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1661),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1662] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4189),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1662),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1663] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3682),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1663),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1664] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3613),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1664),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1665] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4198),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1665),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1666] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4200),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1666),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1667] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3696),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1667),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1668] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3636),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1668),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1669] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3637),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1669),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1670] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3638),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1670),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1671] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3639),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1671),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1672] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3697),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1672),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1673] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3640),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1673),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1674] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3677),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1674),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1675] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3641),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1675),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1676] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1676),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1677] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3647),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1677),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1678] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3648),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1678),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1679] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3698),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1679),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1680] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4204),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1680),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1681] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3702),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1681),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1682] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3703),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1682),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1683] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4213),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1683),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1684] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4152),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1684),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1685] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3704),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1685),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1686] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3705),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1686),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1687] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3708),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1687),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1688] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3711),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1688),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1689] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3714),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1689),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1690] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3715),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1690),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1691] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3472),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1691),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1692] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3668),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1692),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1693] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3670),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1693),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1694] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3746),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1694),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1695] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3492),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1695),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1696] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3654),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1696),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1697] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3586),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1697),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1698] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3556),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1698),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1699] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3558),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1699),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1700] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3564),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1700),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1701] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3565),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1701),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1702] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3566),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1702),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1703] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3567),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1703),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1704] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3568),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1704),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1705] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3959),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1705),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1706] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3574),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1706),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1707] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3577),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1707),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1708] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3602),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1708),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1709] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3597),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1709),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1710] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3553),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1710),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1711] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3615),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1711),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1712] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3713),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1712),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1713] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2416),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1713),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1714] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3573),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1714),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1715] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3592),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1715),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1716] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3581),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5719),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1716),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_defined_QMARK] = ACTIONS(1860),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1868),
    [sym__unary_minus_num] = ACTIONS(1870),
    [sym__binary_minus] = ACTIONS(1868),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1717] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3383),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5949),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2439),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1717),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1718] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4252),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1718),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1719] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4256),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1719),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1720] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4257),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1720),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1721] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4259),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1721),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1722] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4263),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1722),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1723] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3679),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1723),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1724] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3020),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1724),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1725] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3657),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1725),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1726] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3672),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1726),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1727] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4265),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1727),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1728] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4227),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1728),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1729] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4225),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1729),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1730] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4230),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1730),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1731] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4234),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1731),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1732] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4237),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1732),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1733] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4238),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1733),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1734] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3472),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1734),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1735] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4250),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1735),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1736] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4251),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1736),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1737] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4220),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5940),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2639),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1737),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_defined_QMARK] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2354),
    [sym__unary_minus_num] = ACTIONS(2356),
    [sym__binary_minus] = ACTIONS(2354),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1738] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3685),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1738),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1739] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3688),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1739),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1740] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3508),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1740),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1741] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3172),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1741),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1742] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2901),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1742),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1743] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3989),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5926),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1743),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_defined_QMARK] = ACTIONS(1754),
    [anon_sym_not] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1768),
    [sym__unary_minus_num] = ACTIONS(361),
    [sym__binary_minus] = ACTIONS(1768),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1744] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2956),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1744),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1745] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3691),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1745),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1746] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3609),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1746),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1747] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2951),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1747),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1748] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2949),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1748),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1749] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2948),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1749),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1750] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3760),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1750),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1751] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2944),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1751),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1752] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2943),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1752),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1753] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2941),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1753),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1754] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2934),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1754),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1755] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2933),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1755),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1756] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3753),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1756),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1757] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2932),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1757),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1758] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3653),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1758),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1759] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4103),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1759),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1760] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3726),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1760),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1761] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2997),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1761),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1762] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4160),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1762),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1763] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2537),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1763),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1764] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2915),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1764),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1765] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2916),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1765),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1766] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2856),
    [sym__unary_minus_pow] = STATE(2347),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2337),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1766),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_defined_QMARK] = ACTIONS(1397),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1405),
    [sym__unary_minus_num] = ACTIONS(1407),
    [sym__binary_minus] = ACTIONS(1405),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1767] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2748),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5798),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2144),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1767),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1087),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1087),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1768] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3997),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5658),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1768),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1769] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3850),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1769),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1770] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3769),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1770),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1771] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3686),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1771),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1772] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3858),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1772),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1773] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3854),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1773),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1774] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3853),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1774),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1775] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3851),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1775),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1776] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3848),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1776),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1777] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3845),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1777),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1778] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3844),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1778),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1779] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3840),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1779),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1780] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3839),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1780),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1781] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3761),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1781),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1782] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3837),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1782),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1783] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3020),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1783),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1784] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3791),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1784),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1785] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3806),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1785),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1786] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3817),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5979),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1786),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1787] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3320),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1787),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1788] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3278),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1788),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1789] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3694),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1789),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1790] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3701),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1790),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1791] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3364),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1791),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1792] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3365),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1792),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1793] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3366),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1793),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1794] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3367),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1794),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1795] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3368),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1795),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1796] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3370),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1796),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1797] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3371),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1797),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1798] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3373),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1798),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1799] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3374),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1799),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1800] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3375),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1800),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1801] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3759),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1801),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1802] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3643),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1802),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1803] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3236),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1803),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1804] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3020),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1804),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1805] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3273),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1805),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1806] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3272),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1806),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1807] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3612),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1807),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1808] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3342),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1808),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1453),
    [sym__unary_minus_num] = ACTIONS(1455),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1809] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(4196),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5765),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2525),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1809),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1810] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3717),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1810),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1811] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3733),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1811),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1812] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3734),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1812),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1813] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3735),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1813),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1814] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3736),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1814),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1815] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3737),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1815),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1816] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3739),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1816),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1817] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3740),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1817),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1818] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4139),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1818),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1819] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4157),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1819),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1820] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4194),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1820),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1821] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3472),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1821),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1822] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3742),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1822),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1823] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3662),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1823),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1824] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3743),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1824),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1825] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4164),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1825),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1826] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4142),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1826),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1827] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4254),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5889),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2512),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1827),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_defined_QMARK] = ACTIONS(2216),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2224),
    [sym__unary_minus_num] = ACTIONS(2226),
    [sym__binary_minus] = ACTIONS(2224),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1828] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3706),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5680),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2500),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1828),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1928),
    [sym__unary_minus_num] = ACTIONS(1930),
    [sym__binary_minus] = ACTIONS(1928),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1829] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3927),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1829),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1830] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3744),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1830),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1831] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3745),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1831),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1832] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3962),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1832),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1833] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3896),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1833),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1834] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3020),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1834),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1835] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2537),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1835),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1836] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4187),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1836),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1837] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4186),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1837),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1838] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4185),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1838),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1839] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4176),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1839),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1840] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3723),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1840),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1841] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4175),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1841),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1842] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4174),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1842),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1843] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4173),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1843),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1844] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4168),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1844),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1845] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4167),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1845),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1846] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4162),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1846),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1847] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3724),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1847),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1848] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3604),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2313),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1848),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1882),
    [anon_sym_defined_QMARK] = ACTIONS(1884),
    [anon_sym_not] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(257),
    [sym_float] = ACTIONS(257),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1890),
    [sym__unary_minus_num] = ACTIONS(265),
    [sym__binary_minus] = ACTIONS(1890),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1849] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4113),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5947),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2532),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1849),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1998),
    [anon_sym_defined_QMARK] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2008),
    [sym__unary_minus_num] = ACTIONS(2010),
    [sym__binary_minus] = ACTIONS(2008),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1850] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4299),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1850),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1851] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2726),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1851),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1277),
    [anon_sym_not] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1852] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4291),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1852),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1853] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3946),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1853),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1854] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4290),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1854),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1855] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4289),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1855),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1856] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4288),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1856),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1857] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4287),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1857),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1858] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4286),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1858),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1859] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4285),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1859),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1860] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1860),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1861] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4281),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1861),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1862] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4156),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5876),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2556),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1862),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1863] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4279),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1863),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1864] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4278),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1864),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1865] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4272),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1865),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1866] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3472),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1866),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1867] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3767),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1867),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1868] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3766),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(3097),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1868),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1869] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3777),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3073),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1869),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1870] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4372),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1870),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1871] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4379),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5878),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2643),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1871),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_defined_QMARK] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2390),
    [sym__unary_minus_num] = ACTIONS(2392),
    [sym__binary_minus] = ACTIONS(2390),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1872] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3191),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2465),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5951),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2191),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2044),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1872),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_defined_QMARK] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1640),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1640),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1873] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3731),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1873),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1874] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3545),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1874),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1875] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4123),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5974),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2376),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1875),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1876] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3518),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1876),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1877] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3525),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1877),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1878] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3526),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1878),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1879] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3527),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1879),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1880] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3530),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1880),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1881] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3534),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1881),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1882] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3536),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1882),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1883] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3537),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1883),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1884] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3539),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1884),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1885] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3541),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1885),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1886] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3936),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1886),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1887] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3543),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1887),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1888] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(4149),
    [sym__unary_minus_pow] = STATE(3391),
    [sym__primary] = STATE(3266),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2219),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5690),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2874),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(2199),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(2852),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1888),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_defined_QMARK] = ACTIONS(1834),
    [anon_sym_not] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(1447),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1449),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(343),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(1840),
    [sym__unary_minus_num] = ACTIONS(405),
    [sym__binary_minus] = ACTIONS(1840),
    [sym__identifier_suffix] = ACTIONS(1457),
    [sym__constant_suffix] = ACTIONS(1447),
  },
  [1889] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2537),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1889),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1890] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3516),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1890),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1891] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(3481),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(3069),
    [sym_parenthesized_statements] = STATE(2306),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5950),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2210),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1891),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1892] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2968),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2315),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1892),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1893] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2996),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1893),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1894] = {
    [sym_method] = STATE(2359),
    [sym_singleton_method] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_singleton_class] = STATE(2359),
    [sym_module] = STATE(2359),
    [sym_return] = STATE(2359),
    [sym_yield] = STATE(2359),
    [sym_break] = STATE(2359),
    [sym_next] = STATE(2359),
    [sym_redo] = STATE(2359),
    [sym_retry] = STATE(2359),
    [sym_while] = STATE(2359),
    [sym_until] = STATE(2359),
    [sym_for] = STATE(2359),
    [sym_case] = STATE(2359),
    [sym_case_match] = STATE(2359),
    [sym_if] = STATE(2359),
    [sym_unless] = STATE(2359),
    [sym_begin] = STATE(2359),
    [sym__arg] = STATE(2968),
    [sym__unary_minus_pow] = STATE(2528),
    [sym__primary] = STATE(2344),
    [sym_parenthesized_statements] = STATE(2359),
    [sym_element_reference] = STATE(2091),
    [sym_scope_resolution] = STATE(2091),
    [sym__call] = STATE(2040),
    [sym_call] = STATE(2359),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_parenthesized_unary] = STATE(2359),
    [sym_unary_literal] = STATE(2302),
    [sym__literal] = STATE(2359),
    [sym__numeric] = STATE(2358),
    [sym__simple_numeric] = STATE(2302),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2187),
    [sym__function_identifier_call] = STATE(2289),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2043),
    [sym__nonlocal_variable] = STATE(2069),
    [sym__int_or_float] = STATE(5562),
    [sym_complex] = STATE(2285),
    [sym_rational] = STATE(2285),
    [sym_nil] = STATE(2091),
    [sym_constant_suffix] = STATE(2266),
    [sym_identifier_suffix] = STATE(2264),
    [sym_chained_string] = STATE(2359),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2359),
    [sym_string_array] = STATE(2359),
    [sym_symbol_array] = STATE(2359),
    [sym_delimited_symbol] = STATE(2358),
    [sym_regex] = STATE(2359),
    [sym_heredoc_body] = STATE(1894),
    [sym_array] = STATE(2359),
    [sym_hash] = STATE(2359),
    [sym_lambda] = STATE(2359),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_defined_QMARK] = ACTIONS(1650),
    [anon_sym_not] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1895] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3947),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1895),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1896] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3961),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1896),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1897] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3955),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1897),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1898] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3964),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1898),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1899] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3913),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1899),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1900] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3917),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1900),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1901] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3919),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1901),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1902] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3920),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1902),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1903] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3930),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1903),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1904] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3931),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1904),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1905] = {
    [sym_method] = STATE(2972),
    [sym_singleton_method] = STATE(2972),
    [sym_class] = STATE(2972),
    [sym_singleton_class] = STATE(2972),
    [sym_module] = STATE(2972),
    [sym_return] = STATE(2972),
    [sym_yield] = STATE(2972),
    [sym_break] = STATE(2972),
    [sym_next] = STATE(2972),
    [sym_redo] = STATE(2972),
    [sym_retry] = STATE(2972),
    [sym_while] = STATE(2972),
    [sym_until] = STATE(2972),
    [sym_for] = STATE(2972),
    [sym_case] = STATE(2972),
    [sym_case_match] = STATE(2972),
    [sym_if] = STATE(2972),
    [sym_unless] = STATE(2972),
    [sym_begin] = STATE(2972),
    [sym__arg] = STATE(3932),
    [sym__unary_minus_pow] = STATE(3041),
    [sym__primary] = STATE(3168),
    [sym_parenthesized_statements] = STATE(2972),
    [sym_element_reference] = STATE(2234),
    [sym_scope_resolution] = STATE(2234),
    [sym__call] = STATE(2173),
    [sym_call] = STATE(2972),
    [sym_assignment] = STATE(3037),
    [sym_operator_assignment] = STATE(3037),
    [sym_conditional] = STATE(3037),
    [sym_range] = STATE(3037),
    [sym_binary] = STATE(3037),
    [sym_unary] = STATE(3037),
    [sym_parenthesized_unary] = STATE(2972),
    [sym_unary_literal] = STATE(3048),
    [sym__literal] = STATE(2972),
    [sym__numeric] = STATE(2974),
    [sym__simple_numeric] = STATE(3048),
    [sym_left_assignment_list] = STATE(5932),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(2704),
    [sym__function_identifier_call] = STATE(3013),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2172),
    [sym__nonlocal_variable] = STATE(2218),
    [sym__int_or_float] = STATE(5577),
    [sym_complex] = STATE(3032),
    [sym_rational] = STATE(3032),
    [sym_nil] = STATE(2234),
    [sym_constant_suffix] = STATE(2862),
    [sym_identifier_suffix] = STATE(2869),
    [sym_chained_string] = STATE(2972),
    [sym_string] = STATE(3501),
    [sym_subshell] = STATE(2972),
    [sym_string_array] = STATE(2972),
    [sym_symbol_array] = STATE(2972),
    [sym_delimited_symbol] = STATE(2974),
    [sym_regex] = STATE(2972),
    [sym_heredoc_body] = STATE(1905),
    [sym_array] = STATE(2972),
    [sym_hash] = STATE(2972),
    [sym_lambda] = STATE(2972),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(281),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_next] = ACTIONS(1433),
    [anon_sym_redo] = ACTIONS(295),
    [anon_sym_retry] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(303),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(325),
    [sym_float] = ACTIONS(325),
    [sym_super] = ACTIONS(1421),
    [sym_self] = ACTIONS(1421),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_constant] = ACTIONS(1421),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1451),
    [sym_class_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_character] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [sym_simple_symbol] = ACTIONS(341),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(345),
    [sym__subshell_start] = ACTIONS(347),
    [sym__regex_start] = ACTIONS(349),
    [sym__string_array_start] = ACTIONS(351),
    [sym__symbol_array_start] = ACTIONS(353),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(337),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1906] = {
    [sym_heredoc_body] = STATE(1906),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2618),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_end] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2616),
    [anon_sym_EQ] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2616),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_when] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2616),
    [anon_sym_CARET] = ACTIONS(2616),
    [anon_sym_elsif] = ACTIONS(2616),
    [anon_sym_else] = ACTIONS(2616),
    [anon_sym_then] = ACTIONS(2616),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_ensure] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2618),
    [anon_sym_AMP_DOT] = ACTIONS(2618),
    [anon_sym_PLUS_EQ] = ACTIONS(2618),
    [anon_sym_DASH_EQ] = ACTIONS(2618),
    [anon_sym_STAR_EQ] = ACTIONS(2618),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2618),
    [anon_sym_SLASH_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2618),
    [anon_sym_AMP_EQ] = ACTIONS(2618),
    [anon_sym_PERCENT_EQ] = ACTIONS(2618),
    [anon_sym_GT_GT_EQ] = ACTIONS(2618),
    [anon_sym_LT_LT_EQ] = ACTIONS(2618),
    [anon_sym_CARET_EQ] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(2616),
    [anon_sym_and] = ACTIONS(2616),
    [anon_sym_or] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2616),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_EQ] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_EQ] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_SLASH] = ACTIONS(2616),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_EQ_EQ] = ACTIONS(2616),
    [anon_sym_BANG_EQ] = ACTIONS(2618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT_EQ_GT] = ACTIONS(2618),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_BANG_TILDE] = ACTIONS(2618),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym__line_break] = ACTIONS(2618),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2618),
    [sym__binary_star] = ACTIONS(2618),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2618),
    [sym__element_reference_bracket] = ACTIONS(2618),
  },
  [1907] = {
    [sym_heredoc_body] = STATE(1907),
    [sym_identifier] = ACTIONS(2620),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_RBRACE] = ACTIONS(2622),
    [anon_sym_def] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2620),
    [anon_sym_RPAREN] = ACTIONS(2622),
    [anon_sym_DOT] = ACTIONS(2620),
    [anon_sym_COLON_COLON] = ACTIONS(2620),
    [anon_sym_end] = ACTIONS(2620),
    [anon_sym_rescue] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(2620),
    [anon_sym_COMMA] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2622),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_nil] = ACTIONS(2620),
    [anon_sym_AMP] = ACTIONS(2620),
    [anon_sym_class] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_yield] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2620),
    [anon_sym_redo] = ACTIONS(2620),
    [anon_sym_retry] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_unless] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [anon_sym_until] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_do] = ACTIONS(2620),
    [anon_sym_case] = ACTIONS(2620),
    [anon_sym_when] = ACTIONS(2620),
    [anon_sym_EQ_GT] = ACTIONS(2622),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_LPAREN2] = ACTIONS(2622),
    [anon_sym_DOT_DOT] = ACTIONS(2620),
    [anon_sym_CARET] = ACTIONS(2620),
    [anon_sym_elsif] = ACTIONS(2620),
    [anon_sym_else] = ACTIONS(2620),
    [anon_sym_then] = ACTIONS(2620),
    [anon_sym_begin] = ACTIONS(2620),
    [anon_sym_ensure] = ACTIONS(2620),
    [anon_sym_COLON_COLON2] = ACTIONS(2622),
    [anon_sym_AMP_DOT] = ACTIONS(2622),
    [anon_sym_PLUS_EQ] = ACTIONS(2622),
    [anon_sym_DASH_EQ] = ACTIONS(2622),
    [anon_sym_STAR_EQ] = ACTIONS(2622),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2622),
    [anon_sym_SLASH_EQ] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2622),
    [anon_sym_PIPE_EQ] = ACTIONS(2622),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2622),
    [anon_sym_AMP_EQ] = ACTIONS(2622),
    [anon_sym_PERCENT_EQ] = ACTIONS(2622),
    [anon_sym_GT_GT_EQ] = ACTIONS(2622),
    [anon_sym_LT_LT_EQ] = ACTIONS(2622),
    [anon_sym_CARET_EQ] = ACTIONS(2622),
    [anon_sym_QMARK] = ACTIONS(2620),
    [anon_sym_and] = ACTIONS(2620),
    [anon_sym_or] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE] = ACTIONS(2620),
    [anon_sym_AMP_AMP] = ACTIONS(2620),
    [anon_sym_LT_LT] = ACTIONS(2620),
    [anon_sym_GT_GT] = ACTIONS(2620),
    [anon_sym_LT_EQ] = ACTIONS(2620),
    [anon_sym_GT] = ACTIONS(2620),
    [anon_sym_GT_EQ] = ACTIONS(2622),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_SLASH] = ACTIONS(2620),
    [anon_sym_PERCENT] = ACTIONS(2620),
    [anon_sym_EQ_EQ] = ACTIONS(2620),
    [anon_sym_BANG_EQ] = ACTIONS(2622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2622),
    [anon_sym_LT_EQ_GT] = ACTIONS(2622),
    [anon_sym_EQ_TILDE] = ACTIONS(2622),
    [anon_sym_BANG_TILDE] = ACTIONS(2622),
    [anon_sym_defined_QMARK] = ACTIONS(2622),
    [anon_sym_not] = ACTIONS(2620),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_TILDE] = ACTIONS(2622),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2620),
    [sym_float] = ACTIONS(2620),
    [sym_super] = ACTIONS(2620),
    [sym_self] = ACTIONS(2620),
    [sym_true] = ACTIONS(2620),
    [sym_false] = ACTIONS(2620),
    [sym_constant] = ACTIONS(2620),
    [aux_sym_constant_suffix_token1] = ACTIONS(2622),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2620),
    [sym_instance_variable] = ACTIONS(2622),
    [sym_class_variable] = ACTIONS(2622),
    [sym_global_variable] = ACTIONS(2622),
    [sym_character] = ACTIONS(2622),
    [anon_sym_DASH_GT] = ACTIONS(2622),
    [sym__line_break] = ACTIONS(2622),
    [sym_simple_symbol] = ACTIONS(2622),
    [sym__string_start] = ACTIONS(2622),
    [sym__symbol_start] = ACTIONS(2622),
    [sym__subshell_start] = ACTIONS(2622),
    [sym__regex_start] = ACTIONS(2622),
    [sym__string_array_start] = ACTIONS(2622),
    [sym__symbol_array_start] = ACTIONS(2622),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2622),
    [sym__block_ampersand] = ACTIONS(2622),
    [sym__splat_star] = ACTIONS(2622),
    [sym__unary_minus] = ACTIONS(2622),
    [sym__unary_minus_num] = ACTIONS(2622),
    [sym__binary_minus] = ACTIONS(2622),
    [sym__binary_star] = ACTIONS(2622),
    [sym_hash_key_symbol] = ACTIONS(2622),
    [sym__identifier_suffix] = ACTIONS(2622),
    [sym__constant_suffix] = ACTIONS(2622),
    [sym__hash_splat_star_star] = ACTIONS(2622),
    [sym__binary_star_star] = ACTIONS(2622),
    [sym__element_reference_bracket] = ACTIONS(2622),
  },
  [1908] = {
    [sym_heredoc_body] = STATE(1908),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_end] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_EQ] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_when] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2624),
    [anon_sym_elsif] = ACTIONS(2624),
    [anon_sym_else] = ACTIONS(2624),
    [anon_sym_then] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_ensure] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_PLUS_EQ] = ACTIONS(2626),
    [anon_sym_DASH_EQ] = ACTIONS(2626),
    [anon_sym_STAR_EQ] = ACTIONS(2626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2626),
    [anon_sym_SLASH_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2626),
    [anon_sym_AMP_EQ] = ACTIONS(2626),
    [anon_sym_PERCENT_EQ] = ACTIONS(2626),
    [anon_sym_GT_GT_EQ] = ACTIONS(2626),
    [anon_sym_LT_LT_EQ] = ACTIONS(2626),
    [anon_sym_CARET_EQ] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2624),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_LT_LT] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2624),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2624),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1909] = {
    [sym_heredoc_body] = STATE(1909),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_end] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_EQ] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2628),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_when] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2628),
    [anon_sym_elsif] = ACTIONS(2628),
    [anon_sym_else] = ACTIONS(2628),
    [anon_sym_then] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_ensure] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_PLUS_EQ] = ACTIONS(2630),
    [anon_sym_DASH_EQ] = ACTIONS(2630),
    [anon_sym_STAR_EQ] = ACTIONS(2630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2630),
    [anon_sym_SLASH_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2630),
    [anon_sym_AMP_EQ] = ACTIONS(2630),
    [anon_sym_PERCENT_EQ] = ACTIONS(2630),
    [anon_sym_GT_GT_EQ] = ACTIONS(2630),
    [anon_sym_LT_LT_EQ] = ACTIONS(2630),
    [anon_sym_CARET_EQ] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2628),
    [anon_sym_AMP_AMP] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2628),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_SLASH] = ACTIONS(2628),
    [anon_sym_PERCENT] = ACTIONS(2628),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1910] = {
    [sym_heredoc_body] = STATE(1910),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_end] = ACTIONS(2638),
    [anon_sym_rescue] = ACTIONS(2638),
    [anon_sym_EQ] = ACTIONS(2638),
    [anon_sym_COMMA] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2638),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2638),
    [anon_sym_unless] = ACTIONS(2638),
    [anon_sym_while] = ACTIONS(2638),
    [anon_sym_until] = ACTIONS(2638),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2638),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_when] = ACTIONS(2638),
    [anon_sym_EQ_GT] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2638),
    [anon_sym_CARET] = ACTIONS(2638),
    [anon_sym_elsif] = ACTIONS(2638),
    [anon_sym_else] = ACTIONS(2638),
    [anon_sym_then] = ACTIONS(2638),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_ensure] = ACTIONS(2638),
    [anon_sym_COLON_COLON2] = ACTIONS(2636),
    [anon_sym_AMP_DOT] = ACTIONS(2636),
    [anon_sym_PLUS_EQ] = ACTIONS(2636),
    [anon_sym_DASH_EQ] = ACTIONS(2636),
    [anon_sym_STAR_EQ] = ACTIONS(2636),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2636),
    [anon_sym_SLASH_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2636),
    [anon_sym_AMP_EQ] = ACTIONS(2636),
    [anon_sym_PERCENT_EQ] = ACTIONS(2636),
    [anon_sym_GT_GT_EQ] = ACTIONS(2636),
    [anon_sym_LT_LT_EQ] = ACTIONS(2636),
    [anon_sym_CARET_EQ] = ACTIONS(2636),
    [anon_sym_QMARK] = ACTIONS(2638),
    [anon_sym_and] = ACTIONS(2638),
    [anon_sym_or] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2638),
    [anon_sym_LT_EQ] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_EQ] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_SLASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_BANG_EQ] = ACTIONS(2636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2636),
    [anon_sym_LT_EQ_GT] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2636),
    [anon_sym_BANG_TILDE] = ACTIONS(2636),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2636),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2636),
    [sym__binary_star] = ACTIONS(2636),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2636),
    [sym__element_reference_bracket] = ACTIONS(2636),
  },
  [1911] = {
    [sym_heredoc_body] = STATE(1911),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_end] = ACTIONS(2638),
    [anon_sym_rescue] = ACTIONS(2638),
    [anon_sym_EQ] = ACTIONS(2638),
    [anon_sym_COMMA] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2638),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2638),
    [anon_sym_unless] = ACTIONS(2638),
    [anon_sym_while] = ACTIONS(2638),
    [anon_sym_until] = ACTIONS(2638),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2638),
    [anon_sym_do] = ACTIONS(2638),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_when] = ACTIONS(2638),
    [anon_sym_EQ_GT] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2638),
    [anon_sym_CARET] = ACTIONS(2638),
    [anon_sym_elsif] = ACTIONS(2638),
    [anon_sym_else] = ACTIONS(2638),
    [anon_sym_then] = ACTIONS(2638),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_ensure] = ACTIONS(2638),
    [anon_sym_COLON_COLON2] = ACTIONS(2636),
    [anon_sym_AMP_DOT] = ACTIONS(2636),
    [anon_sym_PLUS_EQ] = ACTIONS(2636),
    [anon_sym_DASH_EQ] = ACTIONS(2636),
    [anon_sym_STAR_EQ] = ACTIONS(2636),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2636),
    [anon_sym_SLASH_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2636),
    [anon_sym_AMP_EQ] = ACTIONS(2636),
    [anon_sym_PERCENT_EQ] = ACTIONS(2636),
    [anon_sym_GT_GT_EQ] = ACTIONS(2636),
    [anon_sym_LT_LT_EQ] = ACTIONS(2636),
    [anon_sym_CARET_EQ] = ACTIONS(2636),
    [anon_sym_QMARK] = ACTIONS(2638),
    [anon_sym_and] = ACTIONS(2638),
    [anon_sym_or] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2638),
    [anon_sym_LT_EQ] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_EQ] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_SLASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_BANG_EQ] = ACTIONS(2636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2636),
    [anon_sym_LT_EQ_GT] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2636),
    [anon_sym_BANG_TILDE] = ACTIONS(2636),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2636),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2636),
    [sym__binary_star] = ACTIONS(2636),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2636),
    [sym__element_reference_bracket] = ACTIONS(2636),
  },
  [1912] = {
    [sym_heredoc_body] = STATE(1912),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_end] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_EQ] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_when] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2632),
    [anon_sym_elsif] = ACTIONS(2632),
    [anon_sym_else] = ACTIONS(2632),
    [anon_sym_then] = ACTIONS(2632),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_ensure] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_PLUS_EQ] = ACTIONS(2634),
    [anon_sym_DASH_EQ] = ACTIONS(2634),
    [anon_sym_STAR_EQ] = ACTIONS(2634),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2634),
    [anon_sym_SLASH_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2634),
    [anon_sym_AMP_EQ] = ACTIONS(2634),
    [anon_sym_PERCENT_EQ] = ACTIONS(2634),
    [anon_sym_GT_GT_EQ] = ACTIONS(2634),
    [anon_sym_LT_LT_EQ] = ACTIONS(2634),
    [anon_sym_CARET_EQ] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2632),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_SLASH] = ACTIONS(2632),
    [anon_sym_PERCENT] = ACTIONS(2632),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1913] = {
    [sym_heredoc_body] = STATE(1913),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_when] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_ensure] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1914] = {
    [sym_heredoc_body] = STATE(1914),
    [sym_identifier] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_RBRACE] = ACTIONS(2642),
    [anon_sym_def] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_RPAREN] = ACTIONS(2642),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_COLON_COLON] = ACTIONS(2640),
    [anon_sym_end] = ACTIONS(2640),
    [anon_sym_rescue] = ACTIONS(2640),
    [anon_sym_EQ] = ACTIONS(2640),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_PIPE] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2642),
    [anon_sym_STAR] = ACTIONS(2640),
    [anon_sym_nil] = ACTIONS(2640),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_yield] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_retry] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_unless] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_until] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_in] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_when] = ACTIONS(2640),
    [anon_sym_EQ_GT] = ACTIONS(2642),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_LPAREN2] = ACTIONS(2642),
    [anon_sym_DOT_DOT] = ACTIONS(2640),
    [anon_sym_CARET] = ACTIONS(2640),
    [anon_sym_elsif] = ACTIONS(2640),
    [anon_sym_else] = ACTIONS(2640),
    [anon_sym_then] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2640),
    [anon_sym_ensure] = ACTIONS(2640),
    [anon_sym_COLON_COLON2] = ACTIONS(2642),
    [anon_sym_AMP_DOT] = ACTIONS(2642),
    [anon_sym_PLUS_EQ] = ACTIONS(2642),
    [anon_sym_DASH_EQ] = ACTIONS(2642),
    [anon_sym_STAR_EQ] = ACTIONS(2642),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2642),
    [anon_sym_SLASH_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2642),
    [anon_sym_AMP_EQ] = ACTIONS(2642),
    [anon_sym_PERCENT_EQ] = ACTIONS(2642),
    [anon_sym_GT_GT_EQ] = ACTIONS(2642),
    [anon_sym_LT_LT_EQ] = ACTIONS(2642),
    [anon_sym_CARET_EQ] = ACTIONS(2642),
    [anon_sym_QMARK] = ACTIONS(2640),
    [anon_sym_and] = ACTIONS(2640),
    [anon_sym_or] = ACTIONS(2640),
    [anon_sym_PIPE_PIPE] = ACTIONS(2640),
    [anon_sym_AMP_AMP] = ACTIONS(2640),
    [anon_sym_LT_LT] = ACTIONS(2640),
    [anon_sym_GT_GT] = ACTIONS(2640),
    [anon_sym_LT_EQ] = ACTIONS(2640),
    [anon_sym_GT] = ACTIONS(2640),
    [anon_sym_GT_EQ] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2640),
    [anon_sym_SLASH] = ACTIONS(2640),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_EQ_EQ] = ACTIONS(2640),
    [anon_sym_BANG_EQ] = ACTIONS(2642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2642),
    [anon_sym_LT_EQ_GT] = ACTIONS(2642),
    [anon_sym_EQ_TILDE] = ACTIONS(2642),
    [anon_sym_BANG_TILDE] = ACTIONS(2642),
    [anon_sym_defined_QMARK] = ACTIONS(2642),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2640),
    [sym_float] = ACTIONS(2640),
    [sym_super] = ACTIONS(2640),
    [sym_self] = ACTIONS(2640),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [sym_constant] = ACTIONS(2640),
    [aux_sym_constant_suffix_token1] = ACTIONS(2642),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2640),
    [sym_instance_variable] = ACTIONS(2642),
    [sym_class_variable] = ACTIONS(2642),
    [sym_global_variable] = ACTIONS(2642),
    [sym_character] = ACTIONS(2642),
    [anon_sym_DASH_GT] = ACTIONS(2642),
    [sym__line_break] = ACTIONS(2642),
    [sym_simple_symbol] = ACTIONS(2642),
    [sym__string_start] = ACTIONS(2642),
    [sym__symbol_start] = ACTIONS(2642),
    [sym__subshell_start] = ACTIONS(2642),
    [sym__regex_start] = ACTIONS(2642),
    [sym__string_array_start] = ACTIONS(2642),
    [sym__symbol_array_start] = ACTIONS(2642),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2642),
    [sym__block_ampersand] = ACTIONS(2642),
    [sym__splat_star] = ACTIONS(2642),
    [sym__unary_minus] = ACTIONS(2642),
    [sym__unary_minus_num] = ACTIONS(2642),
    [sym__binary_minus] = ACTIONS(2642),
    [sym__binary_star] = ACTIONS(2642),
    [sym_hash_key_symbol] = ACTIONS(2642),
    [sym__identifier_suffix] = ACTIONS(2642),
    [sym__constant_suffix] = ACTIONS(2642),
    [sym__hash_splat_star_star] = ACTIONS(2642),
    [sym__binary_star_star] = ACTIONS(2642),
    [sym__element_reference_bracket] = ACTIONS(2642),
  },
  [1915] = {
    [sym_heredoc_body] = STATE(1915),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_end] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_EQ] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2644),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_when] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2644),
    [anon_sym_elsif] = ACTIONS(2644),
    [anon_sym_else] = ACTIONS(2644),
    [anon_sym_then] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_ensure] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_PLUS_EQ] = ACTIONS(2646),
    [anon_sym_DASH_EQ] = ACTIONS(2646),
    [anon_sym_STAR_EQ] = ACTIONS(2646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2646),
    [anon_sym_SLASH_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2646),
    [anon_sym_AMP_EQ] = ACTIONS(2646),
    [anon_sym_PERCENT_EQ] = ACTIONS(2646),
    [anon_sym_GT_GT_EQ] = ACTIONS(2646),
    [anon_sym_LT_LT_EQ] = ACTIONS(2646),
    [anon_sym_CARET_EQ] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_SLASH] = ACTIONS(2644),
    [anon_sym_PERCENT] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1916] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5362),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(4986),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(4940),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1916),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2652),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2652),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_end] = ACTIONS(2660),
    [anon_sym_rescue] = ACTIONS(2660),
    [anon_sym_EQ] = ACTIONS(2662),
    [anon_sym_COMMA] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2652),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_in] = ACTIONS(2660),
    [anon_sym_do] = ACTIONS(2660),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_when] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_elsif] = ACTIONS(2660),
    [anon_sym_else] = ACTIONS(2660),
    [anon_sym_then] = ACTIONS(2660),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_ensure] = ACTIONS(2660),
    [anon_sym_and] = ACTIONS(2660),
    [anon_sym_or] = ACTIONS(2660),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym__line_break] = ACTIONS(2652),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1917] = {
    [sym_heredoc_body] = STATE(1917),
    [ts_builtin_sym_end] = ACTIONS(745),
    [sym_identifier] = ACTIONS(733),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2736),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1918] = {
    [sym_heredoc_body] = STATE(1918),
    [ts_builtin_sym_end] = ACTIONS(745),
    [sym_identifier] = ACTIONS(733),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1919] = {
    [sym_heredoc_body] = STATE(1919),
    [ts_builtin_sym_end] = ACTIONS(2622),
    [sym_identifier] = ACTIONS(2620),
    [aux_sym_program_token1] = ACTIONS(2622),
    [anon_sym___END__] = ACTIONS(2620),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_def] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2620),
    [anon_sym_DOT] = ACTIONS(2620),
    [anon_sym_COLON_COLON] = ACTIONS(2620),
    [anon_sym_rescue] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(2620),
    [anon_sym_COMMA] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2622),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_nil] = ACTIONS(2620),
    [anon_sym_AMP] = ACTIONS(2620),
    [anon_sym_class] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_yield] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2620),
    [anon_sym_redo] = ACTIONS(2620),
    [anon_sym_retry] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_unless] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [anon_sym_until] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_do] = ACTIONS(2620),
    [anon_sym_case] = ACTIONS(2620),
    [anon_sym_EQ_GT] = ACTIONS(2622),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_LPAREN2] = ACTIONS(2622),
    [anon_sym_DOT_DOT] = ACTIONS(2620),
    [anon_sym_CARET] = ACTIONS(2620),
    [anon_sym_begin] = ACTIONS(2620),
    [anon_sym_COLON_COLON2] = ACTIONS(2622),
    [anon_sym_AMP_DOT] = ACTIONS(2622),
    [anon_sym_PLUS_EQ] = ACTIONS(2622),
    [anon_sym_DASH_EQ] = ACTIONS(2622),
    [anon_sym_STAR_EQ] = ACTIONS(2622),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2622),
    [anon_sym_SLASH_EQ] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2622),
    [anon_sym_PIPE_EQ] = ACTIONS(2622),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2622),
    [anon_sym_AMP_EQ] = ACTIONS(2622),
    [anon_sym_PERCENT_EQ] = ACTIONS(2622),
    [anon_sym_GT_GT_EQ] = ACTIONS(2622),
    [anon_sym_LT_LT_EQ] = ACTIONS(2622),
    [anon_sym_CARET_EQ] = ACTIONS(2622),
    [anon_sym_QMARK] = ACTIONS(2620),
    [anon_sym_and] = ACTIONS(2620),
    [anon_sym_or] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE] = ACTIONS(2620),
    [anon_sym_AMP_AMP] = ACTIONS(2620),
    [anon_sym_LT_LT] = ACTIONS(2620),
    [anon_sym_GT_GT] = ACTIONS(2620),
    [anon_sym_LT_EQ] = ACTIONS(2620),
    [anon_sym_GT] = ACTIONS(2620),
    [anon_sym_GT_EQ] = ACTIONS(2622),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_SLASH] = ACTIONS(2620),
    [anon_sym_PERCENT] = ACTIONS(2620),
    [anon_sym_EQ_EQ] = ACTIONS(2620),
    [anon_sym_BANG_EQ] = ACTIONS(2622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2622),
    [anon_sym_LT_EQ_GT] = ACTIONS(2622),
    [anon_sym_EQ_TILDE] = ACTIONS(2622),
    [anon_sym_BANG_TILDE] = ACTIONS(2622),
    [anon_sym_defined_QMARK] = ACTIONS(2622),
    [anon_sym_not] = ACTIONS(2620),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_TILDE] = ACTIONS(2622),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2620),
    [sym_float] = ACTIONS(2620),
    [sym_super] = ACTIONS(2620),
    [sym_self] = ACTIONS(2620),
    [sym_true] = ACTIONS(2620),
    [sym_false] = ACTIONS(2620),
    [sym_constant] = ACTIONS(2620),
    [aux_sym_constant_suffix_token1] = ACTIONS(2622),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2620),
    [sym_instance_variable] = ACTIONS(2622),
    [sym_class_variable] = ACTIONS(2622),
    [sym_global_variable] = ACTIONS(2622),
    [sym_character] = ACTIONS(2622),
    [anon_sym_DASH_GT] = ACTIONS(2622),
    [sym__line_break] = ACTIONS(2622),
    [sym_simple_symbol] = ACTIONS(2622),
    [sym__string_start] = ACTIONS(2622),
    [sym__symbol_start] = ACTIONS(2622),
    [sym__subshell_start] = ACTIONS(2622),
    [sym__regex_start] = ACTIONS(2622),
    [sym__string_array_start] = ACTIONS(2622),
    [sym__symbol_array_start] = ACTIONS(2622),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2622),
    [sym__block_ampersand] = ACTIONS(2622),
    [sym__splat_star] = ACTIONS(2622),
    [sym__unary_minus] = ACTIONS(2622),
    [sym__unary_minus_num] = ACTIONS(2622),
    [sym__binary_minus] = ACTIONS(2622),
    [sym__binary_star] = ACTIONS(2622),
    [sym_hash_key_symbol] = ACTIONS(2622),
    [sym__identifier_suffix] = ACTIONS(2622),
    [sym__constant_suffix] = ACTIONS(2622),
    [sym__hash_splat_star_star] = ACTIONS(2622),
    [sym__binary_star_star] = ACTIONS(2622),
    [sym__element_reference_bracket] = ACTIONS(2622),
  },
  [1920] = {
    [sym_heredoc_body] = STATE(1920),
    [ts_builtin_sym_end] = ACTIONS(2642),
    [sym_identifier] = ACTIONS(2640),
    [aux_sym_program_token1] = ACTIONS(2642),
    [anon_sym___END__] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_def] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_COLON_COLON] = ACTIONS(2640),
    [anon_sym_rescue] = ACTIONS(2640),
    [anon_sym_EQ] = ACTIONS(2640),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_PIPE] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2642),
    [anon_sym_STAR] = ACTIONS(2640),
    [anon_sym_nil] = ACTIONS(2640),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_yield] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_retry] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_unless] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_until] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_in] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_EQ_GT] = ACTIONS(2642),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_LPAREN2] = ACTIONS(2642),
    [anon_sym_DOT_DOT] = ACTIONS(2640),
    [anon_sym_CARET] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2640),
    [anon_sym_COLON_COLON2] = ACTIONS(2642),
    [anon_sym_AMP_DOT] = ACTIONS(2642),
    [anon_sym_PLUS_EQ] = ACTIONS(2642),
    [anon_sym_DASH_EQ] = ACTIONS(2642),
    [anon_sym_STAR_EQ] = ACTIONS(2642),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2642),
    [anon_sym_SLASH_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2642),
    [anon_sym_AMP_EQ] = ACTIONS(2642),
    [anon_sym_PERCENT_EQ] = ACTIONS(2642),
    [anon_sym_GT_GT_EQ] = ACTIONS(2642),
    [anon_sym_LT_LT_EQ] = ACTIONS(2642),
    [anon_sym_CARET_EQ] = ACTIONS(2642),
    [anon_sym_QMARK] = ACTIONS(2640),
    [anon_sym_and] = ACTIONS(2640),
    [anon_sym_or] = ACTIONS(2640),
    [anon_sym_PIPE_PIPE] = ACTIONS(2640),
    [anon_sym_AMP_AMP] = ACTIONS(2640),
    [anon_sym_LT_LT] = ACTIONS(2640),
    [anon_sym_GT_GT] = ACTIONS(2640),
    [anon_sym_LT_EQ] = ACTIONS(2640),
    [anon_sym_GT] = ACTIONS(2640),
    [anon_sym_GT_EQ] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2640),
    [anon_sym_SLASH] = ACTIONS(2640),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_EQ_EQ] = ACTIONS(2640),
    [anon_sym_BANG_EQ] = ACTIONS(2642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2642),
    [anon_sym_LT_EQ_GT] = ACTIONS(2642),
    [anon_sym_EQ_TILDE] = ACTIONS(2642),
    [anon_sym_BANG_TILDE] = ACTIONS(2642),
    [anon_sym_defined_QMARK] = ACTIONS(2642),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2640),
    [sym_float] = ACTIONS(2640),
    [sym_super] = ACTIONS(2640),
    [sym_self] = ACTIONS(2640),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [sym_constant] = ACTIONS(2640),
    [aux_sym_constant_suffix_token1] = ACTIONS(2642),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2640),
    [sym_instance_variable] = ACTIONS(2642),
    [sym_class_variable] = ACTIONS(2642),
    [sym_global_variable] = ACTIONS(2642),
    [sym_character] = ACTIONS(2642),
    [anon_sym_DASH_GT] = ACTIONS(2642),
    [sym__line_break] = ACTIONS(2642),
    [sym_simple_symbol] = ACTIONS(2642),
    [sym__string_start] = ACTIONS(2642),
    [sym__symbol_start] = ACTIONS(2642),
    [sym__subshell_start] = ACTIONS(2642),
    [sym__regex_start] = ACTIONS(2642),
    [sym__string_array_start] = ACTIONS(2642),
    [sym__symbol_array_start] = ACTIONS(2642),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2642),
    [sym__block_ampersand] = ACTIONS(2642),
    [sym__splat_star] = ACTIONS(2642),
    [sym__unary_minus] = ACTIONS(2642),
    [sym__unary_minus_num] = ACTIONS(2642),
    [sym__binary_minus] = ACTIONS(2642),
    [sym__binary_star] = ACTIONS(2642),
    [sym_hash_key_symbol] = ACTIONS(2642),
    [sym__identifier_suffix] = ACTIONS(2642),
    [sym__constant_suffix] = ACTIONS(2642),
    [sym__hash_splat_star_star] = ACTIONS(2642),
    [sym__binary_star_star] = ACTIONS(2642),
    [sym__element_reference_bracket] = ACTIONS(2642),
  },
  [1921] = {
    [sym_heredoc_body] = STATE(1921),
    [ts_builtin_sym_end] = ACTIONS(2618),
    [sym_identifier] = ACTIONS(2616),
    [aux_sym_program_token1] = ACTIONS(2618),
    [anon_sym___END__] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2616),
    [anon_sym_EQ] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2616),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2616),
    [anon_sym_CARET] = ACTIONS(2616),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2618),
    [anon_sym_AMP_DOT] = ACTIONS(2618),
    [anon_sym_PLUS_EQ] = ACTIONS(2618),
    [anon_sym_DASH_EQ] = ACTIONS(2618),
    [anon_sym_STAR_EQ] = ACTIONS(2618),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2618),
    [anon_sym_SLASH_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2618),
    [anon_sym_AMP_EQ] = ACTIONS(2618),
    [anon_sym_PERCENT_EQ] = ACTIONS(2618),
    [anon_sym_GT_GT_EQ] = ACTIONS(2618),
    [anon_sym_LT_LT_EQ] = ACTIONS(2618),
    [anon_sym_CARET_EQ] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(2616),
    [anon_sym_and] = ACTIONS(2616),
    [anon_sym_or] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2616),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_EQ] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_EQ] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_SLASH] = ACTIONS(2616),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_EQ_EQ] = ACTIONS(2616),
    [anon_sym_BANG_EQ] = ACTIONS(2618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT_EQ_GT] = ACTIONS(2618),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_BANG_TILDE] = ACTIONS(2618),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym__line_break] = ACTIONS(2618),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2618),
    [sym__binary_star] = ACTIONS(2618),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2618),
    [sym__element_reference_bracket] = ACTIONS(2618),
  },
  [1922] = {
    [sym_heredoc_body] = STATE(1922),
    [ts_builtin_sym_end] = ACTIONS(2626),
    [sym_identifier] = ACTIONS(2624),
    [aux_sym_program_token1] = ACTIONS(2626),
    [anon_sym___END__] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_EQ] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_PLUS_EQ] = ACTIONS(2626),
    [anon_sym_DASH_EQ] = ACTIONS(2626),
    [anon_sym_STAR_EQ] = ACTIONS(2626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2626),
    [anon_sym_SLASH_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2626),
    [anon_sym_AMP_EQ] = ACTIONS(2626),
    [anon_sym_PERCENT_EQ] = ACTIONS(2626),
    [anon_sym_GT_GT_EQ] = ACTIONS(2626),
    [anon_sym_LT_LT_EQ] = ACTIONS(2626),
    [anon_sym_CARET_EQ] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2624),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_LT_LT] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2624),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2624),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1923] = {
    [sym_heredoc_body] = STATE(1923),
    [ts_builtin_sym_end] = ACTIONS(2636),
    [sym_identifier] = ACTIONS(2632),
    [aux_sym_program_token1] = ACTIONS(2636),
    [anon_sym___END__] = ACTIONS(2638),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2638),
    [anon_sym_EQ] = ACTIONS(2638),
    [anon_sym_COMMA] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2638),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2638),
    [anon_sym_unless] = ACTIONS(2638),
    [anon_sym_while] = ACTIONS(2638),
    [anon_sym_until] = ACTIONS(2638),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2638),
    [anon_sym_do] = ACTIONS(2638),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2638),
    [anon_sym_CARET] = ACTIONS(2638),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2636),
    [anon_sym_AMP_DOT] = ACTIONS(2636),
    [anon_sym_PLUS_EQ] = ACTIONS(2636),
    [anon_sym_DASH_EQ] = ACTIONS(2636),
    [anon_sym_STAR_EQ] = ACTIONS(2636),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2636),
    [anon_sym_SLASH_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2636),
    [anon_sym_AMP_EQ] = ACTIONS(2636),
    [anon_sym_PERCENT_EQ] = ACTIONS(2636),
    [anon_sym_GT_GT_EQ] = ACTIONS(2636),
    [anon_sym_LT_LT_EQ] = ACTIONS(2636),
    [anon_sym_CARET_EQ] = ACTIONS(2636),
    [anon_sym_QMARK] = ACTIONS(2638),
    [anon_sym_and] = ACTIONS(2638),
    [anon_sym_or] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2638),
    [anon_sym_LT_EQ] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_EQ] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_SLASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_BANG_EQ] = ACTIONS(2636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2636),
    [anon_sym_LT_EQ_GT] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2636),
    [anon_sym_BANG_TILDE] = ACTIONS(2636),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2636),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2636),
    [sym__binary_star] = ACTIONS(2636),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2636),
    [sym__element_reference_bracket] = ACTIONS(2636),
  },
  [1924] = {
    [sym_heredoc_body] = STATE(1924),
    [ts_builtin_sym_end] = ACTIONS(2630),
    [sym_identifier] = ACTIONS(2628),
    [aux_sym_program_token1] = ACTIONS(2630),
    [anon_sym___END__] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_EQ] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2628),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_PLUS_EQ] = ACTIONS(2630),
    [anon_sym_DASH_EQ] = ACTIONS(2630),
    [anon_sym_STAR_EQ] = ACTIONS(2630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2630),
    [anon_sym_SLASH_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2630),
    [anon_sym_AMP_EQ] = ACTIONS(2630),
    [anon_sym_PERCENT_EQ] = ACTIONS(2630),
    [anon_sym_GT_GT_EQ] = ACTIONS(2630),
    [anon_sym_LT_LT_EQ] = ACTIONS(2630),
    [anon_sym_CARET_EQ] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2628),
    [anon_sym_AMP_AMP] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2628),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_SLASH] = ACTIONS(2628),
    [anon_sym_PERCENT] = ACTIONS(2628),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1925] = {
    [sym_heredoc_body] = STATE(1925),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [sym_identifier] = ACTIONS(2644),
    [aux_sym_program_token1] = ACTIONS(2646),
    [anon_sym___END__] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_EQ] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2644),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_PLUS_EQ] = ACTIONS(2646),
    [anon_sym_DASH_EQ] = ACTIONS(2646),
    [anon_sym_STAR_EQ] = ACTIONS(2646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2646),
    [anon_sym_SLASH_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2646),
    [anon_sym_AMP_EQ] = ACTIONS(2646),
    [anon_sym_PERCENT_EQ] = ACTIONS(2646),
    [anon_sym_GT_GT_EQ] = ACTIONS(2646),
    [anon_sym_LT_LT_EQ] = ACTIONS(2646),
    [anon_sym_CARET_EQ] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_SLASH] = ACTIONS(2644),
    [anon_sym_PERCENT] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1926] = {
    [sym_heredoc_body] = STATE(1926),
    [ts_builtin_sym_end] = ACTIONS(2634),
    [sym_identifier] = ACTIONS(2632),
    [aux_sym_program_token1] = ACTIONS(2634),
    [anon_sym___END__] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_EQ] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2632),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_PLUS_EQ] = ACTIONS(2634),
    [anon_sym_DASH_EQ] = ACTIONS(2634),
    [anon_sym_STAR_EQ] = ACTIONS(2634),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2634),
    [anon_sym_SLASH_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2634),
    [anon_sym_AMP_EQ] = ACTIONS(2634),
    [anon_sym_PERCENT_EQ] = ACTIONS(2634),
    [anon_sym_GT_GT_EQ] = ACTIONS(2634),
    [anon_sym_LT_LT_EQ] = ACTIONS(2634),
    [anon_sym_CARET_EQ] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2632),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_SLASH] = ACTIONS(2632),
    [anon_sym_PERCENT] = ACTIONS(2632),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1927] = {
    [sym_heredoc_body] = STATE(1927),
    [ts_builtin_sym_end] = ACTIONS(2636),
    [sym_identifier] = ACTIONS(2632),
    [aux_sym_program_token1] = ACTIONS(2636),
    [anon_sym___END__] = ACTIONS(2638),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2638),
    [anon_sym_EQ] = ACTIONS(2638),
    [anon_sym_COMMA] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2638),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2638),
    [anon_sym_unless] = ACTIONS(2638),
    [anon_sym_while] = ACTIONS(2638),
    [anon_sym_until] = ACTIONS(2638),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2638),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2638),
    [anon_sym_CARET] = ACTIONS(2638),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2636),
    [anon_sym_AMP_DOT] = ACTIONS(2636),
    [anon_sym_PLUS_EQ] = ACTIONS(2636),
    [anon_sym_DASH_EQ] = ACTIONS(2636),
    [anon_sym_STAR_EQ] = ACTIONS(2636),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2636),
    [anon_sym_SLASH_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2636),
    [anon_sym_AMP_EQ] = ACTIONS(2636),
    [anon_sym_PERCENT_EQ] = ACTIONS(2636),
    [anon_sym_GT_GT_EQ] = ACTIONS(2636),
    [anon_sym_LT_LT_EQ] = ACTIONS(2636),
    [anon_sym_CARET_EQ] = ACTIONS(2636),
    [anon_sym_QMARK] = ACTIONS(2638),
    [anon_sym_and] = ACTIONS(2638),
    [anon_sym_or] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2638),
    [anon_sym_LT_EQ] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_EQ] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_SLASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_BANG_EQ] = ACTIONS(2636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2636),
    [anon_sym_LT_EQ_GT] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2636),
    [anon_sym_BANG_TILDE] = ACTIONS(2636),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2636),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2636),
    [sym__binary_star] = ACTIONS(2636),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2636),
    [sym__element_reference_bracket] = ACTIONS(2636),
  },
  [1928] = {
    [sym_heredoc_body] = STATE(1928),
    [ts_builtin_sym_end] = ACTIONS(745),
    [sym_identifier] = ACTIONS(733),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1929] = {
    [sym_heredoc_body] = STATE(1929),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2740),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1930] = {
    [sym_heredoc_body] = STATE(1930),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LBRACK2] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1931] = {
    [sym_heredoc_body] = STATE(1931),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1932] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5362),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(4986),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(4940),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1932),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [ts_builtin_sym_end] = ACTIONS(2652),
    [sym_identifier] = ACTIONS(2648),
    [aux_sym_program_token1] = ACTIONS(2652),
    [anon_sym___END__] = ACTIONS(2660),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_rescue] = ACTIONS(2660),
    [anon_sym_EQ] = ACTIONS(2662),
    [anon_sym_COMMA] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2652),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_do] = ACTIONS(2660),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_and] = ACTIONS(2660),
    [anon_sym_or] = ACTIONS(2660),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym__line_break] = ACTIONS(2652),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1933] = {
    [sym_heredoc_body] = STATE(1933),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1934] = {
    [sym_heredoc_body] = STATE(1934),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2746),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1935] = {
    [sym_heredoc_body] = STATE(1935),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2638),
    [anon_sym_EQ] = ACTIONS(2638),
    [anon_sym_COMMA] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2638),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2638),
    [anon_sym_do] = ACTIONS(2638),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2638),
    [anon_sym_CARET] = ACTIONS(2638),
    [anon_sym_then] = ACTIONS(2638),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2636),
    [anon_sym_AMP_DOT] = ACTIONS(2636),
    [anon_sym_PLUS_EQ] = ACTIONS(2636),
    [anon_sym_DASH_EQ] = ACTIONS(2636),
    [anon_sym_STAR_EQ] = ACTIONS(2636),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2636),
    [anon_sym_SLASH_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2636),
    [anon_sym_AMP_EQ] = ACTIONS(2636),
    [anon_sym_PERCENT_EQ] = ACTIONS(2636),
    [anon_sym_GT_GT_EQ] = ACTIONS(2636),
    [anon_sym_LT_LT_EQ] = ACTIONS(2636),
    [anon_sym_CARET_EQ] = ACTIONS(2636),
    [anon_sym_QMARK] = ACTIONS(2638),
    [anon_sym_and] = ACTIONS(2638),
    [anon_sym_or] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2638),
    [anon_sym_LT_EQ] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_EQ] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_SLASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_BANG_EQ] = ACTIONS(2636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2636),
    [anon_sym_LT_EQ_GT] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2636),
    [anon_sym_BANG_TILDE] = ACTIONS(2636),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2636),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2636),
    [sym__binary_star] = ACTIONS(2636),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2636),
    [sym__element_reference_bracket] = ACTIONS(2636),
  },
  [1936] = {
    [sym_heredoc_body] = STATE(1936),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1937] = {
    [sym_heredoc_body] = STATE(1937),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2750),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1938] = {
    [sym_heredoc_body] = STATE(1938),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2638),
    [anon_sym_EQ] = ACTIONS(2638),
    [anon_sym_COMMA] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2638),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2638),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2638),
    [anon_sym_CARET] = ACTIONS(2638),
    [anon_sym_then] = ACTIONS(2638),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2636),
    [anon_sym_AMP_DOT] = ACTIONS(2636),
    [anon_sym_PLUS_EQ] = ACTIONS(2636),
    [anon_sym_DASH_EQ] = ACTIONS(2636),
    [anon_sym_STAR_EQ] = ACTIONS(2636),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2636),
    [anon_sym_SLASH_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2636),
    [anon_sym_AMP_EQ] = ACTIONS(2636),
    [anon_sym_PERCENT_EQ] = ACTIONS(2636),
    [anon_sym_GT_GT_EQ] = ACTIONS(2636),
    [anon_sym_LT_LT_EQ] = ACTIONS(2636),
    [anon_sym_CARET_EQ] = ACTIONS(2636),
    [anon_sym_QMARK] = ACTIONS(2638),
    [anon_sym_and] = ACTIONS(2638),
    [anon_sym_or] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2638),
    [anon_sym_LT_EQ] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_EQ] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_SLASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_BANG_EQ] = ACTIONS(2636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2636),
    [anon_sym_LT_EQ_GT] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2636),
    [anon_sym_BANG_TILDE] = ACTIONS(2636),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2636),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2636),
    [sym__binary_star] = ACTIONS(2636),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2636),
    [sym__element_reference_bracket] = ACTIONS(2636),
  },
  [1939] = {
    [sym_heredoc_body] = STATE(1939),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1940] = {
    [sym_heredoc_body] = STATE(1940),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2752),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1941] = {
    [sym_heredoc_body] = STATE(1941),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2754),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1942] = {
    [sym_heredoc_body] = STATE(1942),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1943] = {
    [sym_heredoc_body] = STATE(1943),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_EQ] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2644),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_RBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_PLUS_EQ] = ACTIONS(2646),
    [anon_sym_DASH_EQ] = ACTIONS(2646),
    [anon_sym_STAR_EQ] = ACTIONS(2646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2646),
    [anon_sym_SLASH_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2646),
    [anon_sym_AMP_EQ] = ACTIONS(2646),
    [anon_sym_PERCENT_EQ] = ACTIONS(2646),
    [anon_sym_GT_GT_EQ] = ACTIONS(2646),
    [anon_sym_LT_LT_EQ] = ACTIONS(2646),
    [anon_sym_CARET_EQ] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_SLASH] = ACTIONS(2644),
    [anon_sym_PERCENT] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1944] = {
    [sym_heredoc_body] = STATE(1944),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2638),
    [anon_sym_EQ] = ACTIONS(2638),
    [anon_sym_COMMA] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2638),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2638),
    [anon_sym_unless] = ACTIONS(2638),
    [anon_sym_while] = ACTIONS(2638),
    [anon_sym_until] = ACTIONS(2638),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2638),
    [anon_sym_do] = ACTIONS(2638),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2638),
    [anon_sym_CARET] = ACTIONS(2638),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2636),
    [anon_sym_AMP_DOT] = ACTIONS(2636),
    [anon_sym_PLUS_EQ] = ACTIONS(2636),
    [anon_sym_DASH_EQ] = ACTIONS(2636),
    [anon_sym_STAR_EQ] = ACTIONS(2636),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2636),
    [anon_sym_SLASH_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2636),
    [anon_sym_AMP_EQ] = ACTIONS(2636),
    [anon_sym_PERCENT_EQ] = ACTIONS(2636),
    [anon_sym_GT_GT_EQ] = ACTIONS(2636),
    [anon_sym_LT_LT_EQ] = ACTIONS(2636),
    [anon_sym_CARET_EQ] = ACTIONS(2636),
    [anon_sym_QMARK] = ACTIONS(2638),
    [anon_sym_and] = ACTIONS(2638),
    [anon_sym_or] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2638),
    [anon_sym_LT_EQ] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_EQ] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_SLASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_BANG_EQ] = ACTIONS(2636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2636),
    [anon_sym_LT_EQ_GT] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2636),
    [anon_sym_BANG_TILDE] = ACTIONS(2636),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2636),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2636),
    [sym__binary_star] = ACTIONS(2636),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2636),
    [sym__element_reference_bracket] = ACTIONS(2636),
  },
  [1945] = {
    [sym_heredoc_body] = STATE(1945),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2740),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LBRACK2] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1946] = {
    [sym_heredoc_body] = STATE(1946),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2618),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2616),
    [anon_sym_EQ] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2616),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_RBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2616),
    [anon_sym_CARET] = ACTIONS(2616),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2618),
    [anon_sym_AMP_DOT] = ACTIONS(2618),
    [anon_sym_PLUS_EQ] = ACTIONS(2618),
    [anon_sym_DASH_EQ] = ACTIONS(2618),
    [anon_sym_STAR_EQ] = ACTIONS(2618),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2618),
    [anon_sym_SLASH_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2618),
    [anon_sym_AMP_EQ] = ACTIONS(2618),
    [anon_sym_PERCENT_EQ] = ACTIONS(2618),
    [anon_sym_GT_GT_EQ] = ACTIONS(2618),
    [anon_sym_LT_LT_EQ] = ACTIONS(2618),
    [anon_sym_CARET_EQ] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(2616),
    [anon_sym_and] = ACTIONS(2616),
    [anon_sym_or] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2616),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_EQ] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_EQ] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_SLASH] = ACTIONS(2616),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_EQ_EQ] = ACTIONS(2616),
    [anon_sym_BANG_EQ] = ACTIONS(2618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT_EQ_GT] = ACTIONS(2618),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_BANG_TILDE] = ACTIONS(2618),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2618),
    [sym__binary_star] = ACTIONS(2618),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2618),
    [sym__element_reference_bracket] = ACTIONS(2618),
  },
  [1947] = {
    [sym_heredoc_body] = STATE(1947),
    [sym_identifier] = ACTIONS(2620),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_def] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2620),
    [anon_sym_RPAREN] = ACTIONS(2622),
    [anon_sym_DOT] = ACTIONS(2620),
    [anon_sym_COLON_COLON] = ACTIONS(2620),
    [anon_sym_rescue] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(2620),
    [anon_sym_COMMA] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(2620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2622),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_nil] = ACTIONS(2620),
    [anon_sym_AMP] = ACTIONS(2620),
    [anon_sym_class] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_yield] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2620),
    [anon_sym_redo] = ACTIONS(2620),
    [anon_sym_retry] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_unless] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [anon_sym_until] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_do] = ACTIONS(2620),
    [anon_sym_case] = ACTIONS(2620),
    [anon_sym_EQ_GT] = ACTIONS(2622),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_RBRACK] = ACTIONS(2622),
    [anon_sym_LPAREN2] = ACTIONS(2622),
    [anon_sym_DOT_DOT] = ACTIONS(2620),
    [anon_sym_CARET] = ACTIONS(2620),
    [anon_sym_begin] = ACTIONS(2620),
    [anon_sym_COLON_COLON2] = ACTIONS(2622),
    [anon_sym_AMP_DOT] = ACTIONS(2622),
    [anon_sym_PLUS_EQ] = ACTIONS(2622),
    [anon_sym_DASH_EQ] = ACTIONS(2622),
    [anon_sym_STAR_EQ] = ACTIONS(2622),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2622),
    [anon_sym_SLASH_EQ] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2622),
    [anon_sym_PIPE_EQ] = ACTIONS(2622),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2622),
    [anon_sym_AMP_EQ] = ACTIONS(2622),
    [anon_sym_PERCENT_EQ] = ACTIONS(2622),
    [anon_sym_GT_GT_EQ] = ACTIONS(2622),
    [anon_sym_LT_LT_EQ] = ACTIONS(2622),
    [anon_sym_CARET_EQ] = ACTIONS(2622),
    [anon_sym_QMARK] = ACTIONS(2620),
    [anon_sym_and] = ACTIONS(2620),
    [anon_sym_or] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE] = ACTIONS(2620),
    [anon_sym_AMP_AMP] = ACTIONS(2620),
    [anon_sym_LT_LT] = ACTIONS(2620),
    [anon_sym_GT_GT] = ACTIONS(2620),
    [anon_sym_LT_EQ] = ACTIONS(2620),
    [anon_sym_GT] = ACTIONS(2620),
    [anon_sym_GT_EQ] = ACTIONS(2622),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_SLASH] = ACTIONS(2620),
    [anon_sym_PERCENT] = ACTIONS(2620),
    [anon_sym_EQ_EQ] = ACTIONS(2620),
    [anon_sym_BANG_EQ] = ACTIONS(2622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2622),
    [anon_sym_LT_EQ_GT] = ACTIONS(2622),
    [anon_sym_EQ_TILDE] = ACTIONS(2622),
    [anon_sym_BANG_TILDE] = ACTIONS(2622),
    [anon_sym_defined_QMARK] = ACTIONS(2622),
    [anon_sym_not] = ACTIONS(2620),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_TILDE] = ACTIONS(2622),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2620),
    [sym_float] = ACTIONS(2620),
    [sym_super] = ACTIONS(2620),
    [sym_self] = ACTIONS(2620),
    [sym_true] = ACTIONS(2620),
    [sym_false] = ACTIONS(2620),
    [sym_constant] = ACTIONS(2620),
    [aux_sym_constant_suffix_token1] = ACTIONS(2622),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2620),
    [sym_instance_variable] = ACTIONS(2622),
    [sym_class_variable] = ACTIONS(2622),
    [sym_global_variable] = ACTIONS(2622),
    [sym_character] = ACTIONS(2622),
    [anon_sym_DASH_GT] = ACTIONS(2622),
    [sym_simple_symbol] = ACTIONS(2622),
    [sym__string_start] = ACTIONS(2622),
    [sym__symbol_start] = ACTIONS(2622),
    [sym__subshell_start] = ACTIONS(2622),
    [sym__regex_start] = ACTIONS(2622),
    [sym__string_array_start] = ACTIONS(2622),
    [sym__symbol_array_start] = ACTIONS(2622),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2622),
    [sym__block_ampersand] = ACTIONS(2622),
    [sym__splat_star] = ACTIONS(2622),
    [sym__unary_minus] = ACTIONS(2622),
    [sym__unary_minus_num] = ACTIONS(2622),
    [sym__binary_minus] = ACTIONS(2622),
    [sym__binary_star] = ACTIONS(2622),
    [sym_hash_key_symbol] = ACTIONS(2622),
    [sym__identifier_suffix] = ACTIONS(2622),
    [sym__constant_suffix] = ACTIONS(2622),
    [sym__hash_splat_star_star] = ACTIONS(2622),
    [sym__binary_star_star] = ACTIONS(2622),
    [sym__element_reference_bracket] = ACTIONS(2622),
  },
  [1948] = {
    [sym_heredoc_body] = STATE(1948),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_EQ] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_RBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2632),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_PLUS_EQ] = ACTIONS(2634),
    [anon_sym_DASH_EQ] = ACTIONS(2634),
    [anon_sym_STAR_EQ] = ACTIONS(2634),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2634),
    [anon_sym_SLASH_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2634),
    [anon_sym_AMP_EQ] = ACTIONS(2634),
    [anon_sym_PERCENT_EQ] = ACTIONS(2634),
    [anon_sym_GT_GT_EQ] = ACTIONS(2634),
    [anon_sym_LT_LT_EQ] = ACTIONS(2634),
    [anon_sym_CARET_EQ] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2632),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_SLASH] = ACTIONS(2632),
    [anon_sym_PERCENT] = ACTIONS(2632),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1949] = {
    [sym_heredoc_body] = STATE(1949),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_EQ] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_RBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_PLUS_EQ] = ACTIONS(2626),
    [anon_sym_DASH_EQ] = ACTIONS(2626),
    [anon_sym_STAR_EQ] = ACTIONS(2626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2626),
    [anon_sym_SLASH_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2626),
    [anon_sym_AMP_EQ] = ACTIONS(2626),
    [anon_sym_PERCENT_EQ] = ACTIONS(2626),
    [anon_sym_GT_GT_EQ] = ACTIONS(2626),
    [anon_sym_LT_LT_EQ] = ACTIONS(2626),
    [anon_sym_CARET_EQ] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2624),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_LT_LT] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2624),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2624),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1950] = {
    [sym_heredoc_body] = STATE(1950),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2638),
    [anon_sym_EQ] = ACTIONS(2638),
    [anon_sym_COMMA] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2638),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2638),
    [anon_sym_do] = ACTIONS(2638),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_RBRACK] = ACTIONS(2636),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2638),
    [anon_sym_CARET] = ACTIONS(2638),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2636),
    [anon_sym_AMP_DOT] = ACTIONS(2636),
    [anon_sym_PLUS_EQ] = ACTIONS(2636),
    [anon_sym_DASH_EQ] = ACTIONS(2636),
    [anon_sym_STAR_EQ] = ACTIONS(2636),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2636),
    [anon_sym_SLASH_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2636),
    [anon_sym_AMP_EQ] = ACTIONS(2636),
    [anon_sym_PERCENT_EQ] = ACTIONS(2636),
    [anon_sym_GT_GT_EQ] = ACTIONS(2636),
    [anon_sym_LT_LT_EQ] = ACTIONS(2636),
    [anon_sym_CARET_EQ] = ACTIONS(2636),
    [anon_sym_QMARK] = ACTIONS(2638),
    [anon_sym_and] = ACTIONS(2638),
    [anon_sym_or] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2638),
    [anon_sym_LT_EQ] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_EQ] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_SLASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_BANG_EQ] = ACTIONS(2636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2636),
    [anon_sym_LT_EQ_GT] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2636),
    [anon_sym_BANG_TILDE] = ACTIONS(2636),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2636),
    [sym__binary_star] = ACTIONS(2636),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2636),
    [sym__element_reference_bracket] = ACTIONS(2636),
  },
  [1951] = {
    [sym_heredoc_body] = STATE(1951),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_EQ] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2628),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_RBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_PLUS_EQ] = ACTIONS(2630),
    [anon_sym_DASH_EQ] = ACTIONS(2630),
    [anon_sym_STAR_EQ] = ACTIONS(2630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2630),
    [anon_sym_SLASH_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2630),
    [anon_sym_AMP_EQ] = ACTIONS(2630),
    [anon_sym_PERCENT_EQ] = ACTIONS(2630),
    [anon_sym_GT_GT_EQ] = ACTIONS(2630),
    [anon_sym_LT_LT_EQ] = ACTIONS(2630),
    [anon_sym_CARET_EQ] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2628),
    [anon_sym_AMP_AMP] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2628),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_SLASH] = ACTIONS(2628),
    [anon_sym_PERCENT] = ACTIONS(2628),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1952] = {
    [sym_heredoc_body] = STATE(1952),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2638),
    [anon_sym_EQ] = ACTIONS(2638),
    [anon_sym_COMMA] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2638),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2638),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_RBRACK] = ACTIONS(2636),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2638),
    [anon_sym_CARET] = ACTIONS(2638),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2636),
    [anon_sym_AMP_DOT] = ACTIONS(2636),
    [anon_sym_PLUS_EQ] = ACTIONS(2636),
    [anon_sym_DASH_EQ] = ACTIONS(2636),
    [anon_sym_STAR_EQ] = ACTIONS(2636),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2636),
    [anon_sym_SLASH_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2636),
    [anon_sym_AMP_EQ] = ACTIONS(2636),
    [anon_sym_PERCENT_EQ] = ACTIONS(2636),
    [anon_sym_GT_GT_EQ] = ACTIONS(2636),
    [anon_sym_LT_LT_EQ] = ACTIONS(2636),
    [anon_sym_CARET_EQ] = ACTIONS(2636),
    [anon_sym_QMARK] = ACTIONS(2638),
    [anon_sym_and] = ACTIONS(2638),
    [anon_sym_or] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2638),
    [anon_sym_LT_EQ] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_EQ] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_SLASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_BANG_EQ] = ACTIONS(2636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2636),
    [anon_sym_LT_EQ_GT] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2636),
    [anon_sym_BANG_TILDE] = ACTIONS(2636),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2636),
    [sym__binary_star] = ACTIONS(2636),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2636),
    [sym__element_reference_bracket] = ACTIONS(2636),
  },
  [1953] = {
    [sym_heredoc_body] = STATE(1953),
    [sym_identifier] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_def] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_RPAREN] = ACTIONS(2642),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_COLON_COLON] = ACTIONS(2640),
    [anon_sym_rescue] = ACTIONS(2640),
    [anon_sym_EQ] = ACTIONS(2640),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_PIPE] = ACTIONS(2640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2642),
    [anon_sym_STAR] = ACTIONS(2640),
    [anon_sym_nil] = ACTIONS(2640),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_yield] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_retry] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_unless] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_until] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_in] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_EQ_GT] = ACTIONS(2642),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_RBRACK] = ACTIONS(2642),
    [anon_sym_LPAREN2] = ACTIONS(2642),
    [anon_sym_DOT_DOT] = ACTIONS(2640),
    [anon_sym_CARET] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2640),
    [anon_sym_COLON_COLON2] = ACTIONS(2642),
    [anon_sym_AMP_DOT] = ACTIONS(2642),
    [anon_sym_PLUS_EQ] = ACTIONS(2642),
    [anon_sym_DASH_EQ] = ACTIONS(2642),
    [anon_sym_STAR_EQ] = ACTIONS(2642),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2642),
    [anon_sym_SLASH_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2642),
    [anon_sym_AMP_EQ] = ACTIONS(2642),
    [anon_sym_PERCENT_EQ] = ACTIONS(2642),
    [anon_sym_GT_GT_EQ] = ACTIONS(2642),
    [anon_sym_LT_LT_EQ] = ACTIONS(2642),
    [anon_sym_CARET_EQ] = ACTIONS(2642),
    [anon_sym_QMARK] = ACTIONS(2640),
    [anon_sym_and] = ACTIONS(2640),
    [anon_sym_or] = ACTIONS(2640),
    [anon_sym_PIPE_PIPE] = ACTIONS(2640),
    [anon_sym_AMP_AMP] = ACTIONS(2640),
    [anon_sym_LT_LT] = ACTIONS(2640),
    [anon_sym_GT_GT] = ACTIONS(2640),
    [anon_sym_LT_EQ] = ACTIONS(2640),
    [anon_sym_GT] = ACTIONS(2640),
    [anon_sym_GT_EQ] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2640),
    [anon_sym_SLASH] = ACTIONS(2640),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_EQ_EQ] = ACTIONS(2640),
    [anon_sym_BANG_EQ] = ACTIONS(2642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2642),
    [anon_sym_LT_EQ_GT] = ACTIONS(2642),
    [anon_sym_EQ_TILDE] = ACTIONS(2642),
    [anon_sym_BANG_TILDE] = ACTIONS(2642),
    [anon_sym_defined_QMARK] = ACTIONS(2642),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2640),
    [sym_float] = ACTIONS(2640),
    [sym_super] = ACTIONS(2640),
    [sym_self] = ACTIONS(2640),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [sym_constant] = ACTIONS(2640),
    [aux_sym_constant_suffix_token1] = ACTIONS(2642),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2640),
    [sym_instance_variable] = ACTIONS(2642),
    [sym_class_variable] = ACTIONS(2642),
    [sym_global_variable] = ACTIONS(2642),
    [sym_character] = ACTIONS(2642),
    [anon_sym_DASH_GT] = ACTIONS(2642),
    [sym_simple_symbol] = ACTIONS(2642),
    [sym__string_start] = ACTIONS(2642),
    [sym__symbol_start] = ACTIONS(2642),
    [sym__subshell_start] = ACTIONS(2642),
    [sym__regex_start] = ACTIONS(2642),
    [sym__string_array_start] = ACTIONS(2642),
    [sym__symbol_array_start] = ACTIONS(2642),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2642),
    [sym__block_ampersand] = ACTIONS(2642),
    [sym__splat_star] = ACTIONS(2642),
    [sym__unary_minus] = ACTIONS(2642),
    [sym__unary_minus_num] = ACTIONS(2642),
    [sym__binary_minus] = ACTIONS(2642),
    [sym__binary_star] = ACTIONS(2642),
    [sym_hash_key_symbol] = ACTIONS(2642),
    [sym__identifier_suffix] = ACTIONS(2642),
    [sym__constant_suffix] = ACTIONS(2642),
    [sym__hash_splat_star_star] = ACTIONS(2642),
    [sym__binary_star_star] = ACTIONS(2642),
    [sym__element_reference_bracket] = ACTIONS(2642),
  },
  [1954] = {
    [sym_heredoc_body] = STATE(1954),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1955] = {
    [sym_heredoc_body] = STATE(1955),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2740),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1956] = {
    [sym_heredoc_body] = STATE(1956),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2740),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1957] = {
    [sym_heredoc_body] = STATE(1957),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1958] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5362),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(4986),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(4940),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1958),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2652),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_rescue] = ACTIONS(2660),
    [anon_sym_EQ] = ACTIONS(2662),
    [anon_sym_COMMA] = ACTIONS(2662),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_do] = ACTIONS(2660),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_RBRACK] = ACTIONS(2652),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_and] = ACTIONS(2660),
    [anon_sym_or] = ACTIONS(2660),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1959] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5362),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(4986),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym_destructured_left_assignment] = STATE(5368),
    [sym_rest_assignment] = STATE(5368),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(4974),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1959),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_RPAREN] = ACTIONS(2762),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_in] = ACTIONS(2764),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1960] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5362),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(4986),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym_destructured_left_assignment] = STATE(5368),
    [sym_rest_assignment] = STATE(5368),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(4974),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1960),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_RPAREN] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_EQ] = ACTIONS(2766),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_in] = ACTIONS(2768),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1961] = {
    [sym_heredoc_body] = STATE(1961),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_end] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2614),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_when] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_elsif] = ACTIONS(2628),
    [anon_sym_else] = ACTIONS(2628),
    [anon_sym_then] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_ensure] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1962] = {
    [sym_heredoc_body] = STATE(1962),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_end] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_COLON] = ACTIONS(2614),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_when] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_elsif] = ACTIONS(2624),
    [anon_sym_else] = ACTIONS(2624),
    [anon_sym_then] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_ensure] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1963] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5362),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(4986),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym_left_assignment_list] = STATE(5610),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(5024),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1963),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1964] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5362),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(4986),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym_left_assignment_list] = STATE(5585),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(4962),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1964),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1965] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5362),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(4986),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym_left_assignment_list] = STATE(5599),
    [sym__mlhs] = STATE(5594),
    [sym_destructured_left_assignment] = STATE(5304),
    [sym_rest_assignment] = STATE(5304),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(5013),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1965),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1966] = {
    [sym_heredoc_body] = STATE(1966),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_end] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_COLON] = ACTIONS(2612),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_when] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_elsif] = ACTIONS(2624),
    [anon_sym_else] = ACTIONS(2624),
    [anon_sym_then] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_ensure] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1967] = {
    [sym_heredoc_body] = STATE(1967),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_end] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2612),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_when] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_elsif] = ACTIONS(2628),
    [anon_sym_else] = ACTIONS(2628),
    [anon_sym_then] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_ensure] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1968] = {
    [sym_heredoc_body] = STATE(1968),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2618),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_end] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_COLON] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_when] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2616),
    [anon_sym_CARET] = ACTIONS(2618),
    [anon_sym_elsif] = ACTIONS(2616),
    [anon_sym_else] = ACTIONS(2616),
    [anon_sym_then] = ACTIONS(2616),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_ensure] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2618),
    [anon_sym_AMP_DOT] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(2616),
    [anon_sym_and] = ACTIONS(2616),
    [anon_sym_or] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2618),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_LT_LT] = ACTIONS(2618),
    [anon_sym_GT_GT] = ACTIONS(2618),
    [anon_sym_LT_EQ] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_EQ] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2618),
    [anon_sym_SLASH] = ACTIONS(2618),
    [anon_sym_PERCENT] = ACTIONS(2618),
    [anon_sym_EQ_EQ] = ACTIONS(2616),
    [anon_sym_BANG_EQ] = ACTIONS(2618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT_EQ_GT] = ACTIONS(2618),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_BANG_TILDE] = ACTIONS(2618),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym__line_break] = ACTIONS(2618),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2618),
    [sym__binary_star] = ACTIONS(2618),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2618),
    [sym__element_reference_bracket] = ACTIONS(2618),
  },
  [1969] = {
    [sym_heredoc_body] = STATE(1969),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_end] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_when] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_elsif] = ACTIONS(2644),
    [anon_sym_else] = ACTIONS(2644),
    [anon_sym_then] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_ensure] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1970] = {
    [sym_heredoc_body] = STATE(1970),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_end] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_when] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_elsif] = ACTIONS(2624),
    [anon_sym_else] = ACTIONS(2624),
    [anon_sym_then] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_ensure] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1971] = {
    [sym_heredoc_body] = STATE(1971),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_end] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_when] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_elsif] = ACTIONS(2628),
    [anon_sym_else] = ACTIONS(2628),
    [anon_sym_then] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_ensure] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1972] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5362),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(4986),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(4940),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1972),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2662),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_EQ] = ACTIONS(2662),
    [anon_sym_COMMA] = ACTIONS(2662),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_in] = ACTIONS(2770),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1973] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5362),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(4986),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym_destructured_left_assignment] = STATE(5368),
    [sym_rest_assignment] = STATE(5368),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(4974),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1973),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1974] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5331),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(126),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(5401),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1974),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2774),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(2776),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1975] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5331),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(128),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(5401),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1975),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2778),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(2780),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1976] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5331),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(131),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(5401),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1976),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2782),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(2784),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1977] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5385),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(5155),
    [sym_scope_resolution] = STATE(5155),
    [sym__call] = STATE(4684),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(5081),
    [sym__variable] = STATE(4682),
    [sym__nonlocal_variable] = STATE(4871),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(5155),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1977),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2786),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2788),
    [anon_sym_nil] = ACTIONS(2790),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2786),
    [sym_self] = ACTIONS(2786),
    [sym_true] = ACTIONS(2792),
    [sym_false] = ACTIONS(2792),
    [sym_constant] = ACTIONS(2786),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2794),
    [sym_class_variable] = ACTIONS(2794),
    [sym_global_variable] = ACTIONS(2794),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1978] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5331),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(132),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(5401),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1978),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2796),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1979] = {
    [sym_heredoc_body] = STATE(1979),
    [ts_builtin_sym_end] = ACTIONS(2630),
    [sym_identifier] = ACTIONS(2628),
    [aux_sym_program_token1] = ACTIONS(2630),
    [anon_sym___END__] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1980] = {
    [sym_heredoc_body] = STATE(1980),
    [ts_builtin_sym_end] = ACTIONS(2626),
    [sym_identifier] = ACTIONS(2624),
    [aux_sym_program_token1] = ACTIONS(2626),
    [anon_sym___END__] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_COLON] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1981] = {
    [sym_heredoc_body] = STATE(1981),
    [ts_builtin_sym_end] = ACTIONS(2626),
    [sym_identifier] = ACTIONS(2624),
    [aux_sym_program_token1] = ACTIONS(2626),
    [anon_sym___END__] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_COLON] = ACTIONS(2736),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1982] = {
    [sym_heredoc_body] = STATE(1982),
    [ts_builtin_sym_end] = ACTIONS(2618),
    [sym_identifier] = ACTIONS(2616),
    [aux_sym_program_token1] = ACTIONS(2618),
    [anon_sym___END__] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_COLON] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2616),
    [anon_sym_CARET] = ACTIONS(2618),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2618),
    [anon_sym_AMP_DOT] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(2616),
    [anon_sym_and] = ACTIONS(2616),
    [anon_sym_or] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2618),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_LT_LT] = ACTIONS(2618),
    [anon_sym_GT_GT] = ACTIONS(2618),
    [anon_sym_LT_EQ] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_EQ] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2618),
    [anon_sym_SLASH] = ACTIONS(2618),
    [anon_sym_PERCENT] = ACTIONS(2618),
    [anon_sym_EQ_EQ] = ACTIONS(2616),
    [anon_sym_BANG_EQ] = ACTIONS(2618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT_EQ_GT] = ACTIONS(2618),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_BANG_TILDE] = ACTIONS(2618),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym__line_break] = ACTIONS(2618),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2618),
    [sym__binary_star] = ACTIONS(2618),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2618),
    [sym__element_reference_bracket] = ACTIONS(2618),
  },
  [1983] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5331),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(134),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(5401),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1983),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2798),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1984] = {
    [sym_heredoc_body] = STATE(1984),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [sym_identifier] = ACTIONS(2644),
    [aux_sym_program_token1] = ACTIONS(2646),
    [anon_sym___END__] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1985] = {
    [sym_method] = STATE(5401),
    [sym_singleton_method] = STATE(5401),
    [sym_class] = STATE(5401),
    [sym_singleton_class] = STATE(5401),
    [sym_module] = STATE(5401),
    [sym_return] = STATE(5401),
    [sym_yield] = STATE(5401),
    [sym_break] = STATE(5401),
    [sym_next] = STATE(5401),
    [sym_redo] = STATE(5401),
    [sym_retry] = STATE(5401),
    [sym_while] = STATE(5401),
    [sym_until] = STATE(5401),
    [sym_for] = STATE(5401),
    [sym_case] = STATE(5401),
    [sym_case_match] = STATE(5401),
    [sym_if] = STATE(5401),
    [sym_unless] = STATE(5401),
    [sym_begin] = STATE(5401),
    [sym__primary] = STATE(5331),
    [sym_parenthesized_statements] = STATE(5401),
    [sym_element_reference] = STATE(4986),
    [sym_scope_resolution] = STATE(133),
    [sym__call] = STATE(4665),
    [sym_call] = STATE(5401),
    [sym_parenthesized_unary] = STATE(5401),
    [sym_unary_literal] = STATE(5405),
    [sym__literal] = STATE(5401),
    [sym__numeric] = STATE(5389),
    [sym__simple_numeric] = STATE(5405),
    [sym__function_identifier] = STATE(4852),
    [sym__function_identifier_call] = STATE(5406),
    [sym__lhs] = STATE(5401),
    [sym__variable] = STATE(4668),
    [sym__nonlocal_variable] = STATE(4785),
    [sym__int_or_float] = STATE(5528),
    [sym_complex] = STATE(5470),
    [sym_rational] = STATE(5470),
    [sym_nil] = STATE(4986),
    [sym_constant_suffix] = STATE(4791),
    [sym_identifier_suffix] = STATE(4812),
    [sym_chained_string] = STATE(5401),
    [sym_string] = STATE(5146),
    [sym_subshell] = STATE(5401),
    [sym_string_array] = STATE(5401),
    [sym_symbol_array] = STATE(5401),
    [sym_delimited_symbol] = STATE(5389),
    [sym_regex] = STATE(5401),
    [sym_heredoc_body] = STATE(1985),
    [sym_array] = STATE(5401),
    [sym_hash] = STATE(5401),
    [sym_lambda] = STATE(5401),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2800),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1986] = {
    [sym_heredoc_body] = STATE(1986),
    [ts_builtin_sym_end] = ACTIONS(2630),
    [sym_identifier] = ACTIONS(2628),
    [aux_sym_program_token1] = ACTIONS(2630),
    [anon_sym___END__] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2736),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1987] = {
    [sym_heredoc_body] = STATE(1987),
    [ts_builtin_sym_end] = ACTIONS(2630),
    [sym_identifier] = ACTIONS(2628),
    [aux_sym_program_token1] = ACTIONS(2630),
    [anon_sym___END__] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1988] = {
    [sym_heredoc_body] = STATE(1988),
    [ts_builtin_sym_end] = ACTIONS(2626),
    [sym_identifier] = ACTIONS(2624),
    [aux_sym_program_token1] = ACTIONS(2626),
    [anon_sym___END__] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1989] = {
    [sym_heredoc_body] = STATE(1989),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_COLON] = ACTIONS(2750),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_then] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1990] = {
    [sym_heredoc_body] = STATE(1990),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_COLON] = ACTIONS(2746),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_then] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1991] = {
    [sym_heredoc_body] = STATE(1991),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_COLON] = ACTIONS(2740),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1992] = {
    [sym_heredoc_body] = STATE(1992),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2750),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_then] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1993] = {
    [sym_heredoc_body] = STATE(1993),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_COLON] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_RBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1994] = {
    [sym_heredoc_body] = STATE(1994),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1995] = {
    [sym_heredoc_body] = STATE(1995),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1996] = {
    [sym_heredoc_body] = STATE(1996),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2618),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_COLON] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_RBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2616),
    [anon_sym_CARET] = ACTIONS(2618),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2618),
    [anon_sym_AMP_DOT] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(2616),
    [anon_sym_and] = ACTIONS(2616),
    [anon_sym_or] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2618),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_LT_LT] = ACTIONS(2618),
    [anon_sym_GT_GT] = ACTIONS(2618),
    [anon_sym_LT_EQ] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_EQ] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2618),
    [anon_sym_SLASH] = ACTIONS(2618),
    [anon_sym_PERCENT] = ACTIONS(2618),
    [anon_sym_EQ_EQ] = ACTIONS(2616),
    [anon_sym_BANG_EQ] = ACTIONS(2618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT_EQ_GT] = ACTIONS(2618),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_BANG_TILDE] = ACTIONS(2618),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2618),
    [sym__binary_star] = ACTIONS(2618),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2618),
    [sym__element_reference_bracket] = ACTIONS(2618),
  },
  [1997] = {
    [sym_heredoc_body] = STATE(1997),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2746),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_then] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1998] = {
    [sym_heredoc_body] = STATE(1998),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_RBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1999] = {
    [sym_heredoc_body] = STATE(1999),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_COLON] = ACTIONS(2752),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_RBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [2000] = {
    [sym_heredoc_body] = STATE(2000),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2740),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [2001] = {
    [sym_heredoc_body] = STATE(2001),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_RBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [2002] = {
    [sym_heredoc_body] = STATE(2002),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2752),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_RBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [2003] = {
    [sym_heredoc_body] = STATE(2003),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_RBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [2004] = {
    [sym_heredoc_body] = STATE(2004),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_COLON] = ACTIONS(2754),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_RBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [2005] = {
    [sym_heredoc_body] = STATE(2005),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_RBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [2006] = {
    [sym_heredoc_body] = STATE(2006),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_RBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [2007] = {
    [sym_heredoc_body] = STATE(2007),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_COLON] = ACTIONS(2740),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_RBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2626),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [2008] = {
    [sym_heredoc_body] = STATE(2008),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2740),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_RBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [2009] = {
    [sym_heredoc_body] = STATE(2009),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2754),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_RBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [2010] = {
    [sym_heredoc_body] = STATE(2010),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_RBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [2011] = {
    [sym_splat_parameter] = STATE(4531),
    [sym__array_pattern_n] = STATE(4492),
    [sym__pattern_expr] = STATE(4532),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym_find_pattern] = STATE(4459),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4505),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4471),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2011),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_RBRACE] = ACTIONS(2806),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_RPAREN] = ACTIONS(2806),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_end] = ACTIONS(2812),
    [anon_sym_rescue] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_SEMI] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2814),
    [anon_sym_STAR] = ACTIONS(2816),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_unless] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_until] = ACTIONS(2812),
    [anon_sym_in] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_when] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2822),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_elsif] = ACTIONS(2812),
    [anon_sym_else] = ACTIONS(2812),
    [anon_sym_then] = ACTIONS(2812),
    [anon_sym_ensure] = ACTIONS(2812),
    [anon_sym_and] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2806),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2012] = {
    [sym__pattern_expr] = STATE(4464),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym_find_pattern] = STATE(4459),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4505),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4471),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2012),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_RBRACE] = ACTIONS(2848),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_RPAREN] = ACTIONS(2848),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_end] = ACTIONS(2850),
    [anon_sym_rescue] = ACTIONS(2850),
    [anon_sym_COMMA] = ACTIONS(2848),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2814),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_unless] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_until] = ACTIONS(2850),
    [anon_sym_in] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2822),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_elsif] = ACTIONS(2850),
    [anon_sym_else] = ACTIONS(2850),
    [anon_sym_then] = ACTIONS(2850),
    [anon_sym_ensure] = ACTIONS(2850),
    [anon_sym_and] = ACTIONS(2850),
    [anon_sym_or] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2848),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2013] = {
    [sym__pattern_expr] = STATE(4463),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym_find_pattern] = STATE(4459),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4505),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4471),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2013),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_RPAREN] = ACTIONS(2394),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_end] = ACTIONS(2852),
    [anon_sym_rescue] = ACTIONS(2852),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2814),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2852),
    [anon_sym_unless] = ACTIONS(2852),
    [anon_sym_while] = ACTIONS(2852),
    [anon_sym_until] = ACTIONS(2852),
    [anon_sym_in] = ACTIONS(2852),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_when] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2822),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_elsif] = ACTIONS(2852),
    [anon_sym_else] = ACTIONS(2852),
    [anon_sym_then] = ACTIONS(2852),
    [anon_sym_ensure] = ACTIONS(2852),
    [anon_sym_and] = ACTIONS(2852),
    [anon_sym_or] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2394),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2014] = {
    [sym_splat_parameter] = STATE(4989),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5460),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym__array_pattern_body] = STATE(5661),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(5660),
    [sym_find_pattern] = STATE(4790),
    [sym__hash_pattern_body] = STATE(5659),
    [sym_keyword_pattern] = STATE(4925),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_constant_suffix] = STATE(5898),
    [sym_identifier_suffix] = STATE(5898),
    [sym_string] = STATE(4761),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2014),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2860),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2866),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2878),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2015] = {
    [sym_splat_parameter] = STATE(4989),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5460),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym__array_pattern_body] = STATE(5664),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(5663),
    [sym_find_pattern] = STATE(4790),
    [sym__hash_pattern_body] = STATE(5827),
    [sym_keyword_pattern] = STATE(4925),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_constant_suffix] = STATE(5898),
    [sym_identifier_suffix] = STATE(5898),
    [sym_string] = STATE(4761),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2015),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2866),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_RBRACK] = ACTIONS(2860),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2878),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2016] = {
    [sym_splat_parameter] = STATE(4989),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5460),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym__array_pattern_body] = STATE(5728),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(5727),
    [sym_find_pattern] = STATE(4790),
    [sym__hash_pattern_body] = STATE(5726),
    [sym_keyword_pattern] = STATE(4925),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_constant_suffix] = STATE(5898),
    [sym_identifier_suffix] = STATE(5898),
    [sym_string] = STATE(4761),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2016),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2866),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2878),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2017] = {
    [sym_splat_parameter] = STATE(4989),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5460),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym__array_pattern_body] = STATE(5731),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(5730),
    [sym_find_pattern] = STATE(4790),
    [sym__hash_pattern_body] = STATE(5729),
    [sym_keyword_pattern] = STATE(4925),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_constant_suffix] = STATE(5898),
    [sym_identifier_suffix] = STATE(5898),
    [sym_string] = STATE(4761),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2017),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2866),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_RBRACK] = ACTIONS(2902),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2878),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2018] = {
    [sym_splat_parameter] = STATE(4936),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym__pattern_top_expr_body] = STATE(4985),
    [sym__array_pattern_n] = STATE(4984),
    [sym__pattern_expr] = STATE(4937),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(4979),
    [sym_find_pattern] = STATE(4790),
    [sym__hash_pattern_body] = STATE(4977),
    [sym_keyword_pattern] = STATE(4931),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4811),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4754),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_constant_suffix] = STATE(5681),
    [sym_identifier_suffix] = STATE(5681),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2018),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_STAR] = ACTIONS(2866),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DOT_DOT] = ACTIONS(2908),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2910),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2912),
    [sym_float] = ACTIONS(2912),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2914),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2910),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2019] = {
    [sym_splat_parameter] = STATE(4520),
    [sym_hash_splat_parameter] = STATE(4507),
    [sym_hash_splat_nil] = STATE(4507),
    [sym__pattern_top_expr_body] = STATE(4483),
    [sym__array_pattern_n] = STATE(4509),
    [sym__pattern_expr] = STATE(4526),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym__find_pattern_body] = STATE(4486),
    [sym_find_pattern] = STATE(4459),
    [sym__hash_pattern_body] = STATE(4476),
    [sym_keyword_pattern] = STATE(4525),
    [sym__hash_pattern_any_rest] = STATE(4514),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4505),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4471),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_constant_suffix] = STATE(5806),
    [sym_identifier_suffix] = STATE(5806),
    [sym_string] = STATE(4437),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2019),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2814),
    [anon_sym_STAR] = ACTIONS(2918),
    [anon_sym_STAR_STAR] = ACTIONS(1672),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2822),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2920),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2020] = {
    [sym_splat_parameter] = STATE(4936),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym__pattern_top_expr_body] = STATE(4952),
    [sym__array_pattern_n] = STATE(4984),
    [sym__pattern_expr] = STATE(4937),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(4979),
    [sym_find_pattern] = STATE(4790),
    [sym__hash_pattern_body] = STATE(4977),
    [sym_keyword_pattern] = STATE(4931),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4811),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4754),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_constant_suffix] = STATE(5681),
    [sym_identifier_suffix] = STATE(5681),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2020),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_STAR] = ACTIONS(2866),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DOT_DOT] = ACTIONS(2908),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2910),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2912),
    [sym_float] = ACTIONS(2912),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2914),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2910),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2021] = {
    [sym_splat_parameter] = STATE(4810),
    [sym_hash_splat_parameter] = STATE(4507),
    [sym_hash_splat_nil] = STATE(4507),
    [sym__pattern_top_expr_body] = STATE(4483),
    [sym__array_pattern_n] = STATE(4509),
    [sym__pattern_expr] = STATE(4789),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym__find_pattern_body] = STATE(4486),
    [sym_find_pattern] = STATE(4459),
    [sym__hash_pattern_body] = STATE(4476),
    [sym_keyword_pattern] = STATE(4768),
    [sym__hash_pattern_any_rest] = STATE(4514),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4698),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4675),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_constant_suffix] = STATE(5723),
    [sym_identifier_suffix] = STATE(5723),
    [sym_string] = STATE(4642),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2021),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2918),
    [anon_sym_STAR_STAR] = ACTIONS(1672),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2932),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2022] = {
    [sym_splat_parameter] = STATE(4641),
    [sym_hash_splat_parameter] = STATE(4507),
    [sym_hash_splat_nil] = STATE(4507),
    [sym__pattern_top_expr_body] = STATE(4508),
    [sym__array_pattern_n] = STATE(4509),
    [sym__pattern_expr] = STATE(4639),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym__find_pattern_body] = STATE(4486),
    [sym_find_pattern] = STATE(4459),
    [sym__hash_pattern_body] = STATE(4476),
    [sym_keyword_pattern] = STATE(4640),
    [sym__hash_pattern_any_rest] = STATE(4514),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4590),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4585),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_constant_suffix] = STATE(5714),
    [sym_identifier_suffix] = STATE(5714),
    [sym_string] = STATE(4563),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2022),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_STAR_STAR] = ACTIONS(1712),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2940),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1718),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2942),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2944),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2023] = {
    [sym_splat_parameter] = STATE(4520),
    [sym_hash_splat_parameter] = STATE(4507),
    [sym_hash_splat_nil] = STATE(4507),
    [sym__pattern_top_expr_body] = STATE(4508),
    [sym__array_pattern_n] = STATE(4509),
    [sym__pattern_expr] = STATE(4526),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym__find_pattern_body] = STATE(4486),
    [sym_find_pattern] = STATE(4459),
    [sym__hash_pattern_body] = STATE(4476),
    [sym_keyword_pattern] = STATE(4525),
    [sym__hash_pattern_any_rest] = STATE(4514),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4505),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4471),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_constant_suffix] = STATE(5806),
    [sym_identifier_suffix] = STATE(5806),
    [sym_string] = STATE(4437),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2023),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2814),
    [anon_sym_STAR] = ACTIONS(2918),
    [anon_sym_STAR_STAR] = ACTIONS(1672),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2822),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2920),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2024] = {
    [sym_splat_parameter] = STATE(4810),
    [sym_hash_splat_parameter] = STATE(4507),
    [sym_hash_splat_nil] = STATE(4507),
    [sym__pattern_top_expr_body] = STATE(4850),
    [sym__array_pattern_n] = STATE(4509),
    [sym__pattern_expr] = STATE(4789),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym__find_pattern_body] = STATE(4486),
    [sym_find_pattern] = STATE(4459),
    [sym__hash_pattern_body] = STATE(4476),
    [sym_keyword_pattern] = STATE(4768),
    [sym__hash_pattern_any_rest] = STATE(4514),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4698),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4675),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_constant_suffix] = STATE(5723),
    [sym_identifier_suffix] = STATE(5723),
    [sym_string] = STATE(4642),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2024),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2918),
    [anon_sym_STAR_STAR] = ACTIONS(1672),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2932),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2025] = {
    [sym_splat_parameter] = STATE(4989),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym__pattern_top_expr_body] = STATE(4952),
    [sym__array_pattern_n] = STATE(4984),
    [sym__pattern_expr] = STATE(4983),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(4979),
    [sym_find_pattern] = STATE(4790),
    [sym__hash_pattern_body] = STATE(4977),
    [sym_keyword_pattern] = STATE(4925),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_constant_suffix] = STATE(5898),
    [sym_identifier_suffix] = STATE(5898),
    [sym_string] = STATE(4761),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2025),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2866),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2878),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2026] = {
    [sym_splat_parameter] = STATE(4624),
    [sym__array_pattern_n] = STATE(4492),
    [sym__pattern_expr] = STATE(4626),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym_find_pattern] = STATE(4459),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4590),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4585),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2026),
    [sym_lambda] = STATE(4407),
    [ts_builtin_sym_end] = ACTIONS(2806),
    [sym_identifier] = ACTIONS(2802),
    [aux_sym_program_token1] = ACTIONS(2806),
    [anon_sym___END__] = ACTIONS(2812),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_rescue] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_SEMI] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_unless] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_until] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2940),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1718),
    [anon_sym_and] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2806),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2944),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2027] = {
    [sym_splat_parameter] = STATE(4810),
    [sym_hash_splat_parameter] = STATE(4507),
    [sym_hash_splat_nil] = STATE(4507),
    [sym__pattern_top_expr_body] = STATE(4508),
    [sym__array_pattern_n] = STATE(4509),
    [sym__pattern_expr] = STATE(4789),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym__find_pattern_body] = STATE(4486),
    [sym_find_pattern] = STATE(4459),
    [sym__hash_pattern_body] = STATE(4476),
    [sym_keyword_pattern] = STATE(4768),
    [sym__hash_pattern_any_rest] = STATE(4514),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4698),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4675),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_constant_suffix] = STATE(5723),
    [sym_identifier_suffix] = STATE(5723),
    [sym_string] = STATE(4642),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2027),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2918),
    [anon_sym_STAR_STAR] = ACTIONS(1672),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2932),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2028] = {
    [sym_splat_parameter] = STATE(4989),
    [sym_hash_splat_parameter] = STATE(4914),
    [sym_hash_splat_nil] = STATE(4914),
    [sym__pattern_top_expr_body] = STATE(4985),
    [sym__array_pattern_n] = STATE(4984),
    [sym__pattern_expr] = STATE(4983),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(4979),
    [sym_find_pattern] = STATE(4790),
    [sym__hash_pattern_body] = STATE(4977),
    [sym_keyword_pattern] = STATE(4925),
    [sym__hash_pattern_any_rest] = STATE(4920),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_constant_suffix] = STATE(5898),
    [sym_identifier_suffix] = STATE(5898),
    [sym_string] = STATE(4761),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2028),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2866),
    [anon_sym_STAR_STAR] = ACTIONS(1746),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2878),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2029] = {
    [sym_splat_parameter] = STATE(4641),
    [sym_hash_splat_parameter] = STATE(4507),
    [sym_hash_splat_nil] = STATE(4507),
    [sym__pattern_top_expr_body] = STATE(4483),
    [sym__array_pattern_n] = STATE(4509),
    [sym__pattern_expr] = STATE(4639),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym__find_pattern_body] = STATE(4486),
    [sym_find_pattern] = STATE(4459),
    [sym__hash_pattern_body] = STATE(4476),
    [sym_keyword_pattern] = STATE(4640),
    [sym__hash_pattern_any_rest] = STATE(4514),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4590),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4585),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_constant_suffix] = STATE(5714),
    [sym_identifier_suffix] = STATE(5714),
    [sym_string] = STATE(4563),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2029),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_STAR_STAR] = ACTIONS(1712),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2940),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1718),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2942),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2944),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2030] = {
    [sym_heredoc_body] = STATE(2030),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2646),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_COLON_COLON] = ACTIONS(2646),
    [anon_sym_end] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_when] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_elsif] = ACTIONS(2644),
    [anon_sym_else] = ACTIONS(2644),
    [anon_sym_then] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_ensure] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
  },
  [2031] = {
    [sym__pattern_expr] = STATE(4464),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym_find_pattern] = STATE(4459),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4590),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4585),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2031),
    [sym_lambda] = STATE(4407),
    [ts_builtin_sym_end] = ACTIONS(2848),
    [sym_identifier] = ACTIONS(2802),
    [aux_sym_program_token1] = ACTIONS(2848),
    [anon_sym___END__] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_rescue] = ACTIONS(2850),
    [anon_sym_COMMA] = ACTIONS(2848),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_unless] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_until] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2940),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1718),
    [anon_sym_and] = ACTIONS(2850),
    [anon_sym_or] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2848),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2944),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2032] = {
    [sym_heredoc_body] = STATE(2032),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2626),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_end] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_when] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_elsif] = ACTIONS(2624),
    [anon_sym_else] = ACTIONS(2624),
    [anon_sym_then] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_ensure] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2626),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
  },
  [2033] = {
    [sym_heredoc_body] = STATE(2033),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2618),
    [anon_sym_RPAREN] = ACTIONS(2618),
    [anon_sym_COLON_COLON] = ACTIONS(2618),
    [anon_sym_end] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_when] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2616),
    [anon_sym_elsif] = ACTIONS(2616),
    [anon_sym_else] = ACTIONS(2616),
    [anon_sym_then] = ACTIONS(2616),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_ensure] = ACTIONS(2616),
    [anon_sym_and] = ACTIONS(2616),
    [anon_sym_or] = ACTIONS(2616),
    [anon_sym_PLUS] = ACTIONS(2618),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2618),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym__line_break] = ACTIONS(2618),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2618),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
  },
  [2034] = {
    [sym_heredoc_body] = STATE(2034),
    [sym_identifier] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_def] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2950),
    [anon_sym_end] = ACTIONS(2948),
    [anon_sym_rescue] = ACTIONS(2948),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_nil] = ACTIONS(2948),
    [anon_sym_class] = ACTIONS(2948),
    [anon_sym_module] = ACTIONS(2948),
    [anon_sym_return] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2948),
    [anon_sym_break] = ACTIONS(2948),
    [anon_sym_next] = ACTIONS(2948),
    [anon_sym_redo] = ACTIONS(2948),
    [anon_sym_retry] = ACTIONS(2948),
    [anon_sym_if] = ACTIONS(2948),
    [anon_sym_unless] = ACTIONS(2948),
    [anon_sym_while] = ACTIONS(2948),
    [anon_sym_until] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2948),
    [anon_sym_in] = ACTIONS(2948),
    [anon_sym_do] = ACTIONS(2948),
    [anon_sym_case] = ACTIONS(2948),
    [anon_sym_when] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_DOT_DOT] = ACTIONS(2948),
    [anon_sym_elsif] = ACTIONS(2948),
    [anon_sym_else] = ACTIONS(2948),
    [anon_sym_then] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2948),
    [anon_sym_ensure] = ACTIONS(2948),
    [anon_sym_and] = ACTIONS(2948),
    [anon_sym_or] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_defined_QMARK] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2948),
    [sym_float] = ACTIONS(2948),
    [sym_super] = ACTIONS(2948),
    [sym_self] = ACTIONS(2948),
    [sym_true] = ACTIONS(2948),
    [sym_false] = ACTIONS(2948),
    [sym_constant] = ACTIONS(2948),
    [aux_sym_constant_suffix_token1] = ACTIONS(2950),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2948),
    [sym_instance_variable] = ACTIONS(2950),
    [sym_class_variable] = ACTIONS(2950),
    [sym_global_variable] = ACTIONS(2950),
    [sym_character] = ACTIONS(2950),
    [anon_sym_DASH_GT] = ACTIONS(2950),
    [sym__line_break] = ACTIONS(2950),
    [sym_simple_symbol] = ACTIONS(2950),
    [sym__string_start] = ACTIONS(2950),
    [sym__symbol_start] = ACTIONS(2950),
    [sym__subshell_start] = ACTIONS(2950),
    [sym__regex_start] = ACTIONS(2950),
    [sym__string_array_start] = ACTIONS(2950),
    [sym__symbol_array_start] = ACTIONS(2950),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2950),
    [sym__block_ampersand] = ACTIONS(2950),
    [sym__splat_star] = ACTIONS(2950),
    [sym__unary_minus] = ACTIONS(2950),
    [sym__unary_minus_num] = ACTIONS(2950),
    [sym__binary_minus] = ACTIONS(2950),
    [sym_hash_key_symbol] = ACTIONS(2950),
    [sym__identifier_suffix] = ACTIONS(2950),
    [sym__constant_suffix] = ACTIONS(2950),
    [sym__hash_splat_star_star] = ACTIONS(2950),
  },
  [2035] = {
    [sym_heredoc_body] = STATE(2035),
    [sym_identifier] = ACTIONS(2620),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_RBRACE] = ACTIONS(2622),
    [anon_sym_def] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2622),
    [anon_sym_RPAREN] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2622),
    [anon_sym_end] = ACTIONS(2620),
    [anon_sym_rescue] = ACTIONS(2620),
    [anon_sym_COMMA] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2622),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_nil] = ACTIONS(2620),
    [anon_sym_class] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_yield] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2620),
    [anon_sym_redo] = ACTIONS(2620),
    [anon_sym_retry] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_unless] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [anon_sym_until] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_do] = ACTIONS(2620),
    [anon_sym_case] = ACTIONS(2620),
    [anon_sym_when] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_DOT_DOT] = ACTIONS(2620),
    [anon_sym_elsif] = ACTIONS(2620),
    [anon_sym_else] = ACTIONS(2620),
    [anon_sym_then] = ACTIONS(2620),
    [anon_sym_begin] = ACTIONS(2620),
    [anon_sym_ensure] = ACTIONS(2620),
    [anon_sym_and] = ACTIONS(2620),
    [anon_sym_or] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_defined_QMARK] = ACTIONS(2622),
    [anon_sym_not] = ACTIONS(2620),
    [anon_sym_BANG] = ACTIONS(2622),
    [anon_sym_TILDE] = ACTIONS(2622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2620),
    [sym_float] = ACTIONS(2620),
    [sym_super] = ACTIONS(2620),
    [sym_self] = ACTIONS(2620),
    [sym_true] = ACTIONS(2620),
    [sym_false] = ACTIONS(2620),
    [sym_constant] = ACTIONS(2620),
    [aux_sym_constant_suffix_token1] = ACTIONS(2622),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2620),
    [sym_instance_variable] = ACTIONS(2622),
    [sym_class_variable] = ACTIONS(2622),
    [sym_global_variable] = ACTIONS(2622),
    [sym_character] = ACTIONS(2622),
    [anon_sym_DASH_GT] = ACTIONS(2622),
    [sym__line_break] = ACTIONS(2622),
    [sym_simple_symbol] = ACTIONS(2622),
    [sym__string_start] = ACTIONS(2622),
    [sym__symbol_start] = ACTIONS(2622),
    [sym__subshell_start] = ACTIONS(2622),
    [sym__regex_start] = ACTIONS(2622),
    [sym__string_array_start] = ACTIONS(2622),
    [sym__symbol_array_start] = ACTIONS(2622),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2622),
    [sym__block_ampersand] = ACTIONS(2622),
    [sym__splat_star] = ACTIONS(2622),
    [sym__unary_minus] = ACTIONS(2622),
    [sym__unary_minus_num] = ACTIONS(2622),
    [sym__binary_minus] = ACTIONS(2622),
    [sym_hash_key_symbol] = ACTIONS(2622),
    [sym__identifier_suffix] = ACTIONS(2622),
    [sym__constant_suffix] = ACTIONS(2622),
    [sym__hash_splat_star_star] = ACTIONS(2622),
  },
  [2036] = {
    [sym_heredoc_body] = STATE(2036),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_end] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_when] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_elsif] = ACTIONS(2628),
    [anon_sym_else] = ACTIONS(2628),
    [anon_sym_then] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_ensure] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
  },
  [2037] = {
    [sym__pattern_expr] = STATE(4463),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym_find_pattern] = STATE(4459),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4590),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4585),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2037),
    [sym_lambda] = STATE(4407),
    [ts_builtin_sym_end] = ACTIONS(2394),
    [sym_identifier] = ACTIONS(2802),
    [aux_sym_program_token1] = ACTIONS(2394),
    [anon_sym___END__] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_rescue] = ACTIONS(2852),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2852),
    [anon_sym_unless] = ACTIONS(2852),
    [anon_sym_while] = ACTIONS(2852),
    [anon_sym_until] = ACTIONS(2852),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2940),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1718),
    [anon_sym_and] = ACTIONS(2852),
    [anon_sym_or] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2394),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2944),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2038] = {
    [sym_splat_parameter] = STATE(4765),
    [sym__array_pattern_n] = STATE(4492),
    [sym__pattern_expr] = STATE(4776),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym_find_pattern] = STATE(4459),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4698),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4675),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2038),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_SEMI] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2816),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_unless] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_then] = ACTIONS(2812),
    [anon_sym_and] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2806),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
  },
  [2039] = {
    [sym_heredoc_body] = STATE(2039),
    [sym_identifier] = ACTIONS(2638),
    [anon_sym_BEGIN] = ACTIONS(2638),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_END] = ACTIONS(2638),
    [anon_sym_def] = ACTIONS(2638),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_DOT] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2638),
    [anon_sym_end] = ACTIONS(2638),
    [anon_sym_rescue] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2636),
    [anon_sym_nil] = ACTIONS(2638),
    [anon_sym_class] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2636),
    [anon_sym_module] = ACTIONS(2638),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_yield] = ACTIONS(2638),
    [anon_sym_break] = ACTIONS(2638),
    [anon_sym_next] = ACTIONS(2638),
    [anon_sym_redo] = ACTIONS(2638),
    [anon_sym_retry] = ACTIONS(2638),
    [anon_sym_if] = ACTIONS(2638),
    [anon_sym_unless] = ACTIONS(2638),
    [anon_sym_while] = ACTIONS(2638),
    [anon_sym_until] = ACTIONS(2638),
    [anon_sym_for] = ACTIONS(2638),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2638),
    [anon_sym_else] = ACTIONS(2638),
    [anon_sym_begin] = ACTIONS(2638),
    [anon_sym_ensure] = ACTIONS(2638),
    [anon_sym_COLON_COLON2] = ACTIONS(2636),
    [anon_sym_AMP_DOT] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_defined_QMARK] = ACTIONS(2636),
    [anon_sym_not] = ACTIONS(2638),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_TILDE] = ACTIONS(2636),
    [anon_sym_undef] = ACTIONS(2638),
    [anon_sym_alias] = ACTIONS(2638),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2638),
    [sym_float] = ACTIONS(2638),
    [sym_super] = ACTIONS(2638),
    [sym_self] = ACTIONS(2638),
    [sym_true] = ACTIONS(2638),
    [sym_false] = ACTIONS(2638),
    [sym_constant] = ACTIONS(2638),
    [aux_sym_constant_suffix_token1] = ACTIONS(2636),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2638),
    [sym_instance_variable] = ACTIONS(2636),
    [sym_class_variable] = ACTIONS(2636),
    [sym_global_variable] = ACTIONS(2636),
    [sym_character] = ACTIONS(2636),
    [anon_sym_DASH_GT] = ACTIONS(2636),
    [sym__line_break] = ACTIONS(2636),
    [sym_simple_symbol] = ACTIONS(2636),
    [sym__string_start] = ACTIONS(2636),
    [sym__symbol_start] = ACTIONS(2636),
    [sym__subshell_start] = ACTIONS(2636),
    [sym__regex_start] = ACTIONS(2636),
    [sym__string_array_start] = ACTIONS(2636),
    [sym__symbol_array_start] = ACTIONS(2636),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2636),
    [sym__unary_minus] = ACTIONS(2636),
    [sym__unary_minus_num] = ACTIONS(2636),
    [sym__binary_minus] = ACTIONS(2636),
    [sym__identifier_suffix] = ACTIONS(2636),
    [sym__constant_suffix] = ACTIONS(2636),
    [sym__element_reference_bracket] = ACTIONS(2636),
  },
  [2040] = {
    [sym_argument_list] = STATE(2255),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_heredoc_body] = STATE(2040),
    [ts_builtin_sym_end] = ACTIONS(179),
    [aux_sym_program_token1] = ACTIONS(179),
    [anon_sym___END__] = ACTIONS(181),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(179),
    [anon_sym_RPAREN] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_when] = ACTIONS(179),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_elsif] = ACTIONS(179),
    [anon_sym_else] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_ensure] = ACTIONS(179),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(179),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [2041] = {
    [sym_heredoc_body] = STATE(2041),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_BEGIN] = ACTIONS(1990),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(2954),
    [anon_sym_END] = ACTIONS(1990),
    [anon_sym_def] = ACTIONS(1990),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_RPAREN] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2954),
    [anon_sym_end] = ACTIONS(1990),
    [anon_sym_rescue] = ACTIONS(1990),
    [anon_sym_PIPE] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2954),
    [anon_sym_nil] = ACTIONS(1990),
    [anon_sym_class] = ACTIONS(1990),
    [anon_sym_module] = ACTIONS(1990),
    [anon_sym_return] = ACTIONS(1990),
    [anon_sym_yield] = ACTIONS(1990),
    [anon_sym_break] = ACTIONS(1990),
    [anon_sym_next] = ACTIONS(1990),
    [anon_sym_redo] = ACTIONS(1990),
    [anon_sym_retry] = ACTIONS(1990),
    [anon_sym_if] = ACTIONS(1990),
    [anon_sym_unless] = ACTIONS(1990),
    [anon_sym_while] = ACTIONS(1990),
    [anon_sym_until] = ACTIONS(1990),
    [anon_sym_for] = ACTIONS(1990),
    [anon_sym_in] = ACTIONS(1990),
    [anon_sym_case] = ACTIONS(1990),
    [anon_sym_when] = ACTIONS(1990),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_DOT_DOT] = ACTIONS(1990),
    [anon_sym_elsif] = ACTIONS(1990),
    [anon_sym_else] = ACTIONS(1990),
    [anon_sym_then] = ACTIONS(1990),
    [anon_sym_begin] = ACTIONS(1990),
    [anon_sym_ensure] = ACTIONS(1990),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_defined_QMARK] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(1990),
    [anon_sym_BANG] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2954),
    [anon_sym_undef] = ACTIONS(1990),
    [anon_sym_alias] = ACTIONS(1990),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(1990),
    [sym_float] = ACTIONS(1990),
    [sym_super] = ACTIONS(1990),
    [sym_self] = ACTIONS(1990),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_constant] = ACTIONS(1990),
    [aux_sym_constant_suffix_token1] = ACTIONS(2954),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1990),
    [sym_instance_variable] = ACTIONS(2954),
    [sym_class_variable] = ACTIONS(2954),
    [sym_global_variable] = ACTIONS(2954),
    [sym_character] = ACTIONS(2954),
    [anon_sym_DASH_GT] = ACTIONS(2954),
    [sym_simple_symbol] = ACTIONS(2954),
    [sym__string_start] = ACTIONS(2954),
    [sym__symbol_start] = ACTIONS(2954),
    [sym__subshell_start] = ACTIONS(2954),
    [sym__regex_start] = ACTIONS(2954),
    [sym__string_array_start] = ACTIONS(2954),
    [sym__symbol_array_start] = ACTIONS(2954),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2954),
    [sym__unary_minus] = ACTIONS(2954),
    [sym__unary_minus_num] = ACTIONS(2954),
    [sym__binary_minus] = ACTIONS(2954),
    [sym__identifier_suffix] = ACTIONS(2954),
    [sym__constant_suffix] = ACTIONS(2954),
  },
  [2042] = {
    [sym_argument_list] = STATE(2235),
    [sym_do_block] = STATE(2295),
    [sym_block] = STATE(2279),
    [sym_heredoc_body] = STATE(2042),
    [ts_builtin_sym_end] = ACTIONS(179),
    [aux_sym_program_token1] = ACTIONS(179),
    [anon_sym___END__] = ACTIONS(181),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(179),
    [anon_sym_RPAREN] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(179),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(2956),
    [anon_sym_when] = ACTIONS(179),
    [anon_sym_EQ_GT] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_CARET] = ACTIONS(181),
    [anon_sym_elsif] = ACTIONS(179),
    [anon_sym_else] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_ensure] = ACTIONS(179),
    [anon_sym_COLON_COLON2] = ACTIONS(179),
    [anon_sym_AMP_DOT] = ACTIONS(179),
    [anon_sym_PLUS_EQ] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(179),
    [anon_sym_STAR_EQ] = ACTIONS(179),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(179),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(179),
    [anon_sym_AMP_EQ] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(179),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(179),
    [anon_sym_LT_EQ_GT] = ACTIONS(179),
    [anon_sym_EQ_TILDE] = ACTIONS(179),
    [anon_sym_BANG_TILDE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(179),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(179),
    [sym__binary_star] = ACTIONS(179),
    [sym__binary_star_star] = ACTIONS(179),
    [sym__element_reference_bracket] = ACTIONS(179),
  },
  [2043] = {
    [sym_argument_list] = STATE(2256),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_heredoc_body] = STATE(2043),
    [ts_builtin_sym_end] = ACTIONS(123),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_end] = ACTIONS(123),
    [anon_sym_rescue] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_unless] = ACTIONS(123),
    [anon_sym_while] = ACTIONS(123),
    [anon_sym_until] = ACTIONS(123),
    [anon_sym_in] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_when] = ACTIONS(123),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(123),
    [anon_sym_else] = ACTIONS(123),
    [anon_sym_then] = ACTIONS(123),
    [anon_sym_ensure] = ACTIONS(123),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(123),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(123),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(123),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [2044] = {
    [sym_argument_list] = STATE(2246),
    [sym_do_block] = STATE(2299),
    [sym_block] = STATE(2334),
    [sym_heredoc_body] = STATE(2044),
    [ts_builtin_sym_end] = ACTIONS(123),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_end] = ACTIONS(123),
    [anon_sym_rescue] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_unless] = ACTIONS(123),
    [anon_sym_while] = ACTIONS(123),
    [anon_sym_until] = ACTIONS(123),
    [anon_sym_in] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(2956),
    [anon_sym_when] = ACTIONS(123),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(123),
    [anon_sym_else] = ACTIONS(123),
    [anon_sym_then] = ACTIONS(123),
    [anon_sym_ensure] = ACTIONS(123),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(123),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(123),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(123),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [2045] = {
    [sym_splat_parameter] = STATE(4899),
    [sym__array_pattern_n] = STATE(4956),
    [sym__pattern_expr] = STATE(4901),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4811),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4754),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_string] = STATE(4702),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2045),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2806),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_rescue] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_RBRACK] = ACTIONS(2806),
    [anon_sym_DOT_DOT] = ACTIONS(2908),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2910),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2912),
    [sym_float] = ACTIONS(2912),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2910),
  },
  [2046] = {
    [sym_splat_parameter] = STATE(4955),
    [sym__array_pattern_n] = STATE(4956),
    [sym__pattern_expr] = STATE(4963),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_string] = STATE(4702),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2046),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2806),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_RBRACK] = ACTIONS(2806),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2047] = {
    [sym__pattern_expr] = STATE(4463),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym_find_pattern] = STATE(4459),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4698),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4675),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2047),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2852),
    [anon_sym_unless] = ACTIONS(2852),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_then] = ACTIONS(2852),
    [anon_sym_and] = ACTIONS(2852),
    [anon_sym_or] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2394),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
  },
  [2048] = {
    [sym__pattern_expr] = STATE(4464),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym_find_pattern] = STATE(4459),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4698),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4675),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2048),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_COMMA] = ACTIONS(2848),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_unless] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_then] = ACTIONS(2850),
    [anon_sym_and] = ACTIONS(2850),
    [anon_sym_or] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2848),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
  },
  [2049] = {
    [sym_heredoc_body] = STATE(2049),
    [sym_identifier] = ACTIONS(2964),
    [anon_sym_BEGIN] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_END] = ACTIONS(2964),
    [anon_sym_def] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_end] = ACTIONS(2964),
    [anon_sym_rescue] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2966),
    [anon_sym_STAR] = ACTIONS(2966),
    [anon_sym_nil] = ACTIONS(2964),
    [anon_sym_class] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2966),
    [anon_sym_module] = ACTIONS(2964),
    [anon_sym_return] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2964),
    [anon_sym_break] = ACTIONS(2964),
    [anon_sym_next] = ACTIONS(2964),
    [anon_sym_redo] = ACTIONS(2964),
    [anon_sym_retry] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2964),
    [anon_sym_unless] = ACTIONS(2964),
    [anon_sym_while] = ACTIONS(2964),
    [anon_sym_until] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2964),
    [anon_sym_case] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_else] = ACTIONS(2964),
    [anon_sym_begin] = ACTIONS(2964),
    [anon_sym_ensure] = ACTIONS(2964),
    [anon_sym_COLON_COLON2] = ACTIONS(2966),
    [anon_sym_AMP_DOT] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_defined_QMARK] = ACTIONS(2966),
    [anon_sym_not] = ACTIONS(2964),
    [anon_sym_BANG] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2966),
    [anon_sym_undef] = ACTIONS(2964),
    [anon_sym_alias] = ACTIONS(2964),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2964),
    [sym_float] = ACTIONS(2964),
    [sym_super] = ACTIONS(2964),
    [sym_self] = ACTIONS(2964),
    [sym_true] = ACTIONS(2964),
    [sym_false] = ACTIONS(2964),
    [sym_constant] = ACTIONS(2964),
    [aux_sym_constant_suffix_token1] = ACTIONS(2966),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2964),
    [sym_instance_variable] = ACTIONS(2966),
    [sym_class_variable] = ACTIONS(2966),
    [sym_global_variable] = ACTIONS(2966),
    [sym_character] = ACTIONS(2966),
    [anon_sym_DASH_GT] = ACTIONS(2966),
    [sym__line_break] = ACTIONS(2966),
    [sym_simple_symbol] = ACTIONS(2966),
    [sym__string_start] = ACTIONS(2966),
    [sym__symbol_start] = ACTIONS(2966),
    [sym__subshell_start] = ACTIONS(2966),
    [sym__regex_start] = ACTIONS(2966),
    [sym__string_array_start] = ACTIONS(2966),
    [sym__symbol_array_start] = ACTIONS(2966),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2966),
    [sym__unary_minus] = ACTIONS(2966),
    [sym__unary_minus_num] = ACTIONS(2966),
    [sym__binary_minus] = ACTIONS(2966),
    [sym__identifier_suffix] = ACTIONS(2966),
    [sym__constant_suffix] = ACTIONS(2966),
    [sym__element_reference_bracket] = ACTIONS(2966),
  },
  [2050] = {
    [sym_heredoc_body] = STATE(2050),
    [ts_builtin_sym_end] = ACTIONS(2966),
    [aux_sym_program_token1] = ACTIONS(2966),
    [anon_sym___END__] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_RBRACE] = ACTIONS(2966),
    [anon_sym_RPAREN] = ACTIONS(2966),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_end] = ACTIONS(2966),
    [anon_sym_rescue] = ACTIONS(2966),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_COMMA] = ACTIONS(2966),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2966),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_unless] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_until] = ACTIONS(2966),
    [anon_sym_in] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_when] = ACTIONS(2966),
    [anon_sym_EQ_GT] = ACTIONS(2970),
    [anon_sym_LBRACK2] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_elsif] = ACTIONS(2966),
    [anon_sym_else] = ACTIONS(2966),
    [anon_sym_then] = ACTIONS(2966),
    [anon_sym_ensure] = ACTIONS(2966),
    [anon_sym_COLON_COLON2] = ACTIONS(2966),
    [anon_sym_AMP_DOT] = ACTIONS(2966),
    [anon_sym_PLUS_EQ] = ACTIONS(2966),
    [anon_sym_DASH_EQ] = ACTIONS(2966),
    [anon_sym_STAR_EQ] = ACTIONS(2966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2966),
    [anon_sym_SLASH_EQ] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2966),
    [anon_sym_PIPE_EQ] = ACTIONS(2966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2966),
    [anon_sym_AMP_EQ] = ACTIONS(2966),
    [anon_sym_PERCENT_EQ] = ACTIONS(2966),
    [anon_sym_GT_GT_EQ] = ACTIONS(2966),
    [anon_sym_LT_LT_EQ] = ACTIONS(2966),
    [anon_sym_CARET_EQ] = ACTIONS(2966),
    [anon_sym_QMARK] = ACTIONS(2966),
    [anon_sym_and] = ACTIONS(2966),
    [anon_sym_or] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2966),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2966),
    [anon_sym_LT_EQ_GT] = ACTIONS(2966),
    [anon_sym_EQ_TILDE] = ACTIONS(2966),
    [anon_sym_BANG_TILDE] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2966),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2966),
    [sym__binary_star] = ACTIONS(2966),
    [sym__binary_star_star] = ACTIONS(2966),
    [sym__element_reference_bracket] = ACTIONS(2966),
  },
  [2051] = {
    [sym_heredoc_body] = STATE(2051),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [sym_identifier] = ACTIONS(2644),
    [aux_sym_program_token1] = ACTIONS(2646),
    [anon_sym___END__] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2646),
    [anon_sym_COLON_COLON] = ACTIONS(2646),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
  },
  [2052] = {
    [sym_heredoc_body] = STATE(2052),
    [ts_builtin_sym_end] = ACTIONS(2618),
    [sym_identifier] = ACTIONS(2616),
    [aux_sym_program_token1] = ACTIONS(2618),
    [anon_sym___END__] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2618),
    [anon_sym_COLON_COLON] = ACTIONS(2618),
    [anon_sym_rescue] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2616),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_and] = ACTIONS(2616),
    [anon_sym_or] = ACTIONS(2616),
    [anon_sym_PLUS] = ACTIONS(2618),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2618),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym__line_break] = ACTIONS(2618),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2618),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
  },
  [2053] = {
    [sym_do_block] = STATE(2086),
    [sym_block] = STATE(2086),
    [sym_heredoc_body] = STATE(2053),
    [ts_builtin_sym_end] = ACTIONS(2972),
    [aux_sym_program_token1] = ACTIONS(2972),
    [anon_sym___END__] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_end] = ACTIONS(2972),
    [anon_sym_rescue] = ACTIONS(2972),
    [anon_sym_EQ] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_PIPE] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LT] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2972),
    [anon_sym_unless] = ACTIONS(2972),
    [anon_sym_while] = ACTIONS(2972),
    [anon_sym_until] = ACTIONS(2972),
    [anon_sym_in] = ACTIONS(2972),
    [anon_sym_do] = ACTIONS(2972),
    [anon_sym_when] = ACTIONS(2972),
    [anon_sym_EQ_GT] = ACTIONS(2972),
    [anon_sym_DOT_DOT] = ACTIONS(2974),
    [anon_sym_CARET] = ACTIONS(2974),
    [anon_sym_elsif] = ACTIONS(2972),
    [anon_sym_else] = ACTIONS(2972),
    [anon_sym_then] = ACTIONS(2972),
    [anon_sym_ensure] = ACTIONS(2972),
    [anon_sym_COLON_COLON2] = ACTIONS(2972),
    [anon_sym_AMP_DOT] = ACTIONS(2972),
    [anon_sym_PLUS_EQ] = ACTIONS(2972),
    [anon_sym_DASH_EQ] = ACTIONS(2972),
    [anon_sym_STAR_EQ] = ACTIONS(2972),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2972),
    [anon_sym_SLASH_EQ] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2972),
    [anon_sym_PIPE_EQ] = ACTIONS(2972),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2972),
    [anon_sym_AMP_EQ] = ACTIONS(2972),
    [anon_sym_PERCENT_EQ] = ACTIONS(2972),
    [anon_sym_GT_GT_EQ] = ACTIONS(2972),
    [anon_sym_LT_LT_EQ] = ACTIONS(2972),
    [anon_sym_CARET_EQ] = ACTIONS(2972),
    [anon_sym_QMARK] = ACTIONS(2972),
    [anon_sym_and] = ACTIONS(2972),
    [anon_sym_or] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_LT_LT] = ACTIONS(2974),
    [anon_sym_GT_GT] = ACTIONS(2974),
    [anon_sym_LT_EQ] = ACTIONS(2974),
    [anon_sym_GT] = ACTIONS(2974),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_SLASH] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2972),
    [anon_sym_LT_EQ_GT] = ACTIONS(2972),
    [anon_sym_EQ_TILDE] = ACTIONS(2972),
    [anon_sym_BANG_TILDE] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2972),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2972),
    [sym__binary_star] = ACTIONS(2972),
    [sym__binary_star_star] = ACTIONS(2972),
    [sym__element_reference_bracket] = ACTIONS(2972),
  },
  [2054] = {
    [sym_heredoc_body] = STATE(2054),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_BEGIN] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_RBRACE] = ACTIONS(1102),
    [anon_sym_END] = ACTIONS(1116),
    [anon_sym_def] = ACTIONS(1116),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [anon_sym_RPAREN] = ACTIONS(1102),
    [anon_sym_COLON_COLON] = ACTIONS(1102),
    [anon_sym_end] = ACTIONS(1116),
    [anon_sym_rescue] = ACTIONS(1116),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1102),
    [anon_sym_STAR] = ACTIONS(1102),
    [anon_sym_nil] = ACTIONS(1116),
    [anon_sym_class] = ACTIONS(1116),
    [anon_sym_module] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1116),
    [anon_sym_yield] = ACTIONS(1116),
    [anon_sym_break] = ACTIONS(1116),
    [anon_sym_next] = ACTIONS(1116),
    [anon_sym_redo] = ACTIONS(1116),
    [anon_sym_retry] = ACTIONS(1116),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_unless] = ACTIONS(1116),
    [anon_sym_while] = ACTIONS(1116),
    [anon_sym_until] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_in] = ACTIONS(1116),
    [anon_sym_case] = ACTIONS(1116),
    [anon_sym_when] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_DOT_DOT] = ACTIONS(1116),
    [anon_sym_elsif] = ACTIONS(1116),
    [anon_sym_else] = ACTIONS(1116),
    [anon_sym_begin] = ACTIONS(1116),
    [anon_sym_ensure] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1102),
    [anon_sym_defined_QMARK] = ACTIONS(1102),
    [anon_sym_not] = ACTIONS(1116),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_undef] = ACTIONS(1116),
    [anon_sym_alias] = ACTIONS(1116),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(1116),
    [sym_float] = ACTIONS(1116),
    [sym_super] = ACTIONS(1116),
    [sym_self] = ACTIONS(1116),
    [sym_true] = ACTIONS(1116),
    [sym_false] = ACTIONS(1116),
    [sym_constant] = ACTIONS(1116),
    [aux_sym_constant_suffix_token1] = ACTIONS(1102),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1116),
    [sym_instance_variable] = ACTIONS(1102),
    [sym_class_variable] = ACTIONS(1102),
    [sym_global_variable] = ACTIONS(1102),
    [sym_character] = ACTIONS(1102),
    [anon_sym_DASH_GT] = ACTIONS(1102),
    [sym_simple_symbol] = ACTIONS(1102),
    [sym__string_start] = ACTIONS(1102),
    [sym__symbol_start] = ACTIONS(1102),
    [sym__subshell_start] = ACTIONS(1102),
    [sym__regex_start] = ACTIONS(1102),
    [sym__string_array_start] = ACTIONS(1102),
    [sym__symbol_array_start] = ACTIONS(1102),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1102),
    [sym__unary_minus] = ACTIONS(1102),
    [sym__unary_minus_num] = ACTIONS(1102),
    [sym__binary_minus] = ACTIONS(1102),
    [sym__identifier_suffix] = ACTIONS(1102),
    [sym__constant_suffix] = ACTIONS(1102),
  },
  [2055] = {
    [sym_do_block] = STATE(2085),
    [sym_block] = STATE(2085),
    [sym_heredoc_body] = STATE(2055),
    [ts_builtin_sym_end] = ACTIONS(2976),
    [aux_sym_program_token1] = ACTIONS(2976),
    [anon_sym___END__] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2976),
    [anon_sym_RBRACE] = ACTIONS(2976),
    [anon_sym_RPAREN] = ACTIONS(2976),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_end] = ACTIONS(2976),
    [anon_sym_rescue] = ACTIONS(2976),
    [anon_sym_EQ] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_PIPE] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_LT] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2976),
    [anon_sym_unless] = ACTIONS(2976),
    [anon_sym_while] = ACTIONS(2976),
    [anon_sym_until] = ACTIONS(2976),
    [anon_sym_in] = ACTIONS(2976),
    [anon_sym_do] = ACTIONS(2976),
    [anon_sym_when] = ACTIONS(2976),
    [anon_sym_EQ_GT] = ACTIONS(2976),
    [anon_sym_DOT_DOT] = ACTIONS(2978),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_elsif] = ACTIONS(2976),
    [anon_sym_else] = ACTIONS(2976),
    [anon_sym_then] = ACTIONS(2976),
    [anon_sym_ensure] = ACTIONS(2976),
    [anon_sym_COLON_COLON2] = ACTIONS(2976),
    [anon_sym_AMP_DOT] = ACTIONS(2976),
    [anon_sym_PLUS_EQ] = ACTIONS(2976),
    [anon_sym_DASH_EQ] = ACTIONS(2976),
    [anon_sym_STAR_EQ] = ACTIONS(2976),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2976),
    [anon_sym_SLASH_EQ] = ACTIONS(2976),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2976),
    [anon_sym_PIPE_EQ] = ACTIONS(2976),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2976),
    [anon_sym_AMP_EQ] = ACTIONS(2976),
    [anon_sym_PERCENT_EQ] = ACTIONS(2976),
    [anon_sym_GT_GT_EQ] = ACTIONS(2976),
    [anon_sym_LT_LT_EQ] = ACTIONS(2976),
    [anon_sym_CARET_EQ] = ACTIONS(2976),
    [anon_sym_QMARK] = ACTIONS(2976),
    [anon_sym_and] = ACTIONS(2976),
    [anon_sym_or] = ACTIONS(2976),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_LT_LT] = ACTIONS(2978),
    [anon_sym_GT_GT] = ACTIONS(2978),
    [anon_sym_LT_EQ] = ACTIONS(2978),
    [anon_sym_GT] = ACTIONS(2978),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_SLASH] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_EQ_EQ] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2976),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2976),
    [anon_sym_LT_EQ_GT] = ACTIONS(2976),
    [anon_sym_EQ_TILDE] = ACTIONS(2976),
    [anon_sym_BANG_TILDE] = ACTIONS(2976),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2976),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2976),
    [sym__binary_star] = ACTIONS(2976),
    [sym__binary_star_star] = ACTIONS(2976),
    [sym__element_reference_bracket] = ACTIONS(2976),
  },
  [2056] = {
    [sym_heredoc_body] = STATE(2056),
    [ts_builtin_sym_end] = ACTIONS(2622),
    [sym_identifier] = ACTIONS(2620),
    [aux_sym_program_token1] = ACTIONS(2622),
    [anon_sym___END__] = ACTIONS(2620),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_def] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2622),
    [anon_sym_rescue] = ACTIONS(2620),
    [anon_sym_COMMA] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2622),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_nil] = ACTIONS(2620),
    [anon_sym_class] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_yield] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2620),
    [anon_sym_redo] = ACTIONS(2620),
    [anon_sym_retry] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_unless] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [anon_sym_until] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_do] = ACTIONS(2620),
    [anon_sym_case] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_DOT_DOT] = ACTIONS(2620),
    [anon_sym_begin] = ACTIONS(2620),
    [anon_sym_and] = ACTIONS(2620),
    [anon_sym_or] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_defined_QMARK] = ACTIONS(2622),
    [anon_sym_not] = ACTIONS(2620),
    [anon_sym_BANG] = ACTIONS(2622),
    [anon_sym_TILDE] = ACTIONS(2622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2620),
    [sym_float] = ACTIONS(2620),
    [sym_super] = ACTIONS(2620),
    [sym_self] = ACTIONS(2620),
    [sym_true] = ACTIONS(2620),
    [sym_false] = ACTIONS(2620),
    [sym_constant] = ACTIONS(2620),
    [aux_sym_constant_suffix_token1] = ACTIONS(2622),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2620),
    [sym_instance_variable] = ACTIONS(2622),
    [sym_class_variable] = ACTIONS(2622),
    [sym_global_variable] = ACTIONS(2622),
    [sym_character] = ACTIONS(2622),
    [anon_sym_DASH_GT] = ACTIONS(2622),
    [sym__line_break] = ACTIONS(2622),
    [sym_simple_symbol] = ACTIONS(2622),
    [sym__string_start] = ACTIONS(2622),
    [sym__symbol_start] = ACTIONS(2622),
    [sym__subshell_start] = ACTIONS(2622),
    [sym__regex_start] = ACTIONS(2622),
    [sym__string_array_start] = ACTIONS(2622),
    [sym__symbol_array_start] = ACTIONS(2622),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2622),
    [sym__block_ampersand] = ACTIONS(2622),
    [sym__splat_star] = ACTIONS(2622),
    [sym__unary_minus] = ACTIONS(2622),
    [sym__unary_minus_num] = ACTIONS(2622),
    [sym__binary_minus] = ACTIONS(2622),
    [sym_hash_key_symbol] = ACTIONS(2622),
    [sym__identifier_suffix] = ACTIONS(2622),
    [sym__constant_suffix] = ACTIONS(2622),
    [sym__hash_splat_star_star] = ACTIONS(2622),
  },
  [2057] = {
    [sym_heredoc_body] = STATE(2057),
    [sym_identifier] = ACTIONS(2980),
    [anon_sym_BEGIN] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2982),
    [anon_sym_RBRACE] = ACTIONS(2982),
    [anon_sym_END] = ACTIONS(2980),
    [anon_sym_def] = ACTIONS(2980),
    [anon_sym_LPAREN] = ACTIONS(2982),
    [anon_sym_RPAREN] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2982),
    [anon_sym_end] = ACTIONS(2980),
    [anon_sym_rescue] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_nil] = ACTIONS(2980),
    [anon_sym_class] = ACTIONS(2980),
    [anon_sym_module] = ACTIONS(2980),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2980),
    [anon_sym_break] = ACTIONS(2980),
    [anon_sym_next] = ACTIONS(2980),
    [anon_sym_redo] = ACTIONS(2980),
    [anon_sym_retry] = ACTIONS(2980),
    [anon_sym_if] = ACTIONS(2980),
    [anon_sym_unless] = ACTIONS(2980),
    [anon_sym_while] = ACTIONS(2980),
    [anon_sym_until] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2980),
    [anon_sym_in] = ACTIONS(2980),
    [anon_sym_case] = ACTIONS(2980),
    [anon_sym_when] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_DOT_DOT] = ACTIONS(2980),
    [anon_sym_elsif] = ACTIONS(2980),
    [anon_sym_else] = ACTIONS(2980),
    [anon_sym_begin] = ACTIONS(2980),
    [anon_sym_ensure] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_defined_QMARK] = ACTIONS(2982),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_BANG] = ACTIONS(2982),
    [anon_sym_TILDE] = ACTIONS(2982),
    [anon_sym_undef] = ACTIONS(2980),
    [anon_sym_alias] = ACTIONS(2980),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2980),
    [sym_float] = ACTIONS(2980),
    [sym_super] = ACTIONS(2980),
    [sym_self] = ACTIONS(2980),
    [sym_true] = ACTIONS(2980),
    [sym_false] = ACTIONS(2980),
    [sym_constant] = ACTIONS(2980),
    [aux_sym_constant_suffix_token1] = ACTIONS(2982),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2980),
    [sym_instance_variable] = ACTIONS(2982),
    [sym_class_variable] = ACTIONS(2982),
    [sym_global_variable] = ACTIONS(2982),
    [sym_character] = ACTIONS(2982),
    [anon_sym_DASH_GT] = ACTIONS(2982),
    [sym_simple_symbol] = ACTIONS(2982),
    [sym__string_start] = ACTIONS(2982),
    [sym__symbol_start] = ACTIONS(2982),
    [sym__subshell_start] = ACTIONS(2982),
    [sym__regex_start] = ACTIONS(2982),
    [sym__string_array_start] = ACTIONS(2982),
    [sym__symbol_array_start] = ACTIONS(2982),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2982),
    [sym__unary_minus] = ACTIONS(2982),
    [sym__unary_minus_num] = ACTIONS(2982),
    [sym__binary_minus] = ACTIONS(2982),
    [sym__identifier_suffix] = ACTIONS(2982),
    [sym__constant_suffix] = ACTIONS(2982),
  },
  [2058] = {
    [sym_heredoc_body] = STATE(2058),
    [ts_builtin_sym_end] = ACTIONS(2630),
    [sym_identifier] = ACTIONS(2628),
    [aux_sym_program_token1] = ACTIONS(2630),
    [anon_sym___END__] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
  },
  [2059] = {
    [sym_do_block] = STATE(2086),
    [sym_block] = STATE(2086),
    [sym_heredoc_body] = STATE(2059),
    [ts_builtin_sym_end] = ACTIONS(2972),
    [aux_sym_program_token1] = ACTIONS(2972),
    [anon_sym___END__] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_end] = ACTIONS(2972),
    [anon_sym_rescue] = ACTIONS(2972),
    [anon_sym_EQ] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_PIPE] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LT] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2972),
    [anon_sym_unless] = ACTIONS(2972),
    [anon_sym_while] = ACTIONS(2972),
    [anon_sym_until] = ACTIONS(2972),
    [anon_sym_in] = ACTIONS(2972),
    [anon_sym_do] = ACTIONS(2986),
    [anon_sym_when] = ACTIONS(2972),
    [anon_sym_EQ_GT] = ACTIONS(2972),
    [anon_sym_DOT_DOT] = ACTIONS(2974),
    [anon_sym_CARET] = ACTIONS(2974),
    [anon_sym_elsif] = ACTIONS(2972),
    [anon_sym_else] = ACTIONS(2972),
    [anon_sym_then] = ACTIONS(2972),
    [anon_sym_ensure] = ACTIONS(2972),
    [anon_sym_COLON_COLON2] = ACTIONS(2972),
    [anon_sym_AMP_DOT] = ACTIONS(2972),
    [anon_sym_PLUS_EQ] = ACTIONS(2972),
    [anon_sym_DASH_EQ] = ACTIONS(2972),
    [anon_sym_STAR_EQ] = ACTIONS(2972),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2972),
    [anon_sym_SLASH_EQ] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2972),
    [anon_sym_PIPE_EQ] = ACTIONS(2972),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2972),
    [anon_sym_AMP_EQ] = ACTIONS(2972),
    [anon_sym_PERCENT_EQ] = ACTIONS(2972),
    [anon_sym_GT_GT_EQ] = ACTIONS(2972),
    [anon_sym_LT_LT_EQ] = ACTIONS(2972),
    [anon_sym_CARET_EQ] = ACTIONS(2972),
    [anon_sym_QMARK] = ACTIONS(2972),
    [anon_sym_and] = ACTIONS(2972),
    [anon_sym_or] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_LT_LT] = ACTIONS(2974),
    [anon_sym_GT_GT] = ACTIONS(2974),
    [anon_sym_LT_EQ] = ACTIONS(2974),
    [anon_sym_GT] = ACTIONS(2974),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_SLASH] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2972),
    [anon_sym_LT_EQ_GT] = ACTIONS(2972),
    [anon_sym_EQ_TILDE] = ACTIONS(2972),
    [anon_sym_BANG_TILDE] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2972),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2972),
    [sym__binary_star] = ACTIONS(2972),
    [sym__binary_star_star] = ACTIONS(2972),
    [sym__element_reference_bracket] = ACTIONS(2972),
  },
  [2060] = {
    [sym_do_block] = STATE(2085),
    [sym_block] = STATE(2085),
    [sym_heredoc_body] = STATE(2060),
    [ts_builtin_sym_end] = ACTIONS(2976),
    [aux_sym_program_token1] = ACTIONS(2976),
    [anon_sym___END__] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_RBRACE] = ACTIONS(2976),
    [anon_sym_RPAREN] = ACTIONS(2976),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_end] = ACTIONS(2976),
    [anon_sym_rescue] = ACTIONS(2976),
    [anon_sym_EQ] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_PIPE] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_LT] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2976),
    [anon_sym_unless] = ACTIONS(2976),
    [anon_sym_while] = ACTIONS(2976),
    [anon_sym_until] = ACTIONS(2976),
    [anon_sym_in] = ACTIONS(2976),
    [anon_sym_do] = ACTIONS(2986),
    [anon_sym_when] = ACTIONS(2976),
    [anon_sym_EQ_GT] = ACTIONS(2976),
    [anon_sym_DOT_DOT] = ACTIONS(2978),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_elsif] = ACTIONS(2976),
    [anon_sym_else] = ACTIONS(2976),
    [anon_sym_then] = ACTIONS(2976),
    [anon_sym_ensure] = ACTIONS(2976),
    [anon_sym_COLON_COLON2] = ACTIONS(2976),
    [anon_sym_AMP_DOT] = ACTIONS(2976),
    [anon_sym_PLUS_EQ] = ACTIONS(2976),
    [anon_sym_DASH_EQ] = ACTIONS(2976),
    [anon_sym_STAR_EQ] = ACTIONS(2976),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2976),
    [anon_sym_SLASH_EQ] = ACTIONS(2976),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2976),
    [anon_sym_PIPE_EQ] = ACTIONS(2976),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2976),
    [anon_sym_AMP_EQ] = ACTIONS(2976),
    [anon_sym_PERCENT_EQ] = ACTIONS(2976),
    [anon_sym_GT_GT_EQ] = ACTIONS(2976),
    [anon_sym_LT_LT_EQ] = ACTIONS(2976),
    [anon_sym_CARET_EQ] = ACTIONS(2976),
    [anon_sym_QMARK] = ACTIONS(2976),
    [anon_sym_and] = ACTIONS(2976),
    [anon_sym_or] = ACTIONS(2976),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_LT_LT] = ACTIONS(2978),
    [anon_sym_GT_GT] = ACTIONS(2978),
    [anon_sym_LT_EQ] = ACTIONS(2978),
    [anon_sym_GT] = ACTIONS(2978),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_SLASH] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_EQ_EQ] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2976),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2976),
    [anon_sym_LT_EQ_GT] = ACTIONS(2976),
    [anon_sym_EQ_TILDE] = ACTIONS(2976),
    [anon_sym_BANG_TILDE] = ACTIONS(2976),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2976),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2976),
    [sym__binary_star] = ACTIONS(2976),
    [sym__binary_star_star] = ACTIONS(2976),
    [sym__element_reference_bracket] = ACTIONS(2976),
  },
  [2061] = {
    [sym_heredoc_body] = STATE(2061),
    [ts_builtin_sym_end] = ACTIONS(2950),
    [sym_identifier] = ACTIONS(2948),
    [aux_sym_program_token1] = ACTIONS(2950),
    [anon_sym___END__] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_def] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2950),
    [anon_sym_rescue] = ACTIONS(2948),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_nil] = ACTIONS(2948),
    [anon_sym_class] = ACTIONS(2948),
    [anon_sym_module] = ACTIONS(2948),
    [anon_sym_return] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2948),
    [anon_sym_break] = ACTIONS(2948),
    [anon_sym_next] = ACTIONS(2948),
    [anon_sym_redo] = ACTIONS(2948),
    [anon_sym_retry] = ACTIONS(2948),
    [anon_sym_if] = ACTIONS(2948),
    [anon_sym_unless] = ACTIONS(2948),
    [anon_sym_while] = ACTIONS(2948),
    [anon_sym_until] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2948),
    [anon_sym_do] = ACTIONS(2948),
    [anon_sym_case] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_DOT_DOT] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2948),
    [anon_sym_and] = ACTIONS(2948),
    [anon_sym_or] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_defined_QMARK] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2948),
    [sym_float] = ACTIONS(2948),
    [sym_super] = ACTIONS(2948),
    [sym_self] = ACTIONS(2948),
    [sym_true] = ACTIONS(2948),
    [sym_false] = ACTIONS(2948),
    [sym_constant] = ACTIONS(2948),
    [aux_sym_constant_suffix_token1] = ACTIONS(2950),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2948),
    [sym_instance_variable] = ACTIONS(2950),
    [sym_class_variable] = ACTIONS(2950),
    [sym_global_variable] = ACTIONS(2950),
    [sym_character] = ACTIONS(2950),
    [anon_sym_DASH_GT] = ACTIONS(2950),
    [sym__line_break] = ACTIONS(2950),
    [sym_simple_symbol] = ACTIONS(2950),
    [sym__string_start] = ACTIONS(2950),
    [sym__symbol_start] = ACTIONS(2950),
    [sym__subshell_start] = ACTIONS(2950),
    [sym__regex_start] = ACTIONS(2950),
    [sym__string_array_start] = ACTIONS(2950),
    [sym__symbol_array_start] = ACTIONS(2950),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2950),
    [sym__block_ampersand] = ACTIONS(2950),
    [sym__splat_star] = ACTIONS(2950),
    [sym__unary_minus] = ACTIONS(2950),
    [sym__unary_minus_num] = ACTIONS(2950),
    [sym__binary_minus] = ACTIONS(2950),
    [sym_hash_key_symbol] = ACTIONS(2950),
    [sym__identifier_suffix] = ACTIONS(2950),
    [sym__constant_suffix] = ACTIONS(2950),
    [sym__hash_splat_star_star] = ACTIONS(2950),
  },
  [2062] = {
    [sym_heredoc_body] = STATE(2062),
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_BEGIN] = ACTIONS(2988),
    [anon_sym_LBRACE] = ACTIONS(2990),
    [anon_sym_RBRACE] = ACTIONS(2990),
    [anon_sym_END] = ACTIONS(2988),
    [anon_sym_def] = ACTIONS(2988),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_RPAREN] = ACTIONS(2990),
    [anon_sym_COLON_COLON] = ACTIONS(2990),
    [anon_sym_end] = ACTIONS(2988),
    [anon_sym_rescue] = ACTIONS(2988),
    [anon_sym_SEMI] = ACTIONS(2990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2990),
    [anon_sym_STAR] = ACTIONS(2990),
    [anon_sym_nil] = ACTIONS(2988),
    [anon_sym_class] = ACTIONS(2988),
    [anon_sym_module] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_break] = ACTIONS(2988),
    [anon_sym_next] = ACTIONS(2988),
    [anon_sym_redo] = ACTIONS(2988),
    [anon_sym_retry] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_unless] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_until] = ACTIONS(2988),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_in] = ACTIONS(2988),
    [anon_sym_case] = ACTIONS(2988),
    [anon_sym_when] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_DOT_DOT] = ACTIONS(2988),
    [anon_sym_elsif] = ACTIONS(2988),
    [anon_sym_else] = ACTIONS(2988),
    [anon_sym_begin] = ACTIONS(2988),
    [anon_sym_ensure] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2990),
    [anon_sym_defined_QMARK] = ACTIONS(2990),
    [anon_sym_not] = ACTIONS(2988),
    [anon_sym_BANG] = ACTIONS(2990),
    [anon_sym_TILDE] = ACTIONS(2990),
    [anon_sym_undef] = ACTIONS(2988),
    [anon_sym_alias] = ACTIONS(2988),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2988),
    [sym_float] = ACTIONS(2988),
    [sym_super] = ACTIONS(2988),
    [sym_self] = ACTIONS(2988),
    [sym_true] = ACTIONS(2988),
    [sym_false] = ACTIONS(2988),
    [sym_constant] = ACTIONS(2988),
    [aux_sym_constant_suffix_token1] = ACTIONS(2990),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2988),
    [sym_instance_variable] = ACTIONS(2990),
    [sym_class_variable] = ACTIONS(2990),
    [sym_global_variable] = ACTIONS(2990),
    [sym_character] = ACTIONS(2990),
    [anon_sym_DASH_GT] = ACTIONS(2990),
    [sym_simple_symbol] = ACTIONS(2990),
    [sym__string_start] = ACTIONS(2990),
    [sym__symbol_start] = ACTIONS(2990),
    [sym__subshell_start] = ACTIONS(2990),
    [sym__regex_start] = ACTIONS(2990),
    [sym__string_array_start] = ACTIONS(2990),
    [sym__symbol_array_start] = ACTIONS(2990),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2990),
    [sym__unary_minus] = ACTIONS(2990),
    [sym__unary_minus_num] = ACTIONS(2990),
    [sym__binary_minus] = ACTIONS(2990),
    [sym__identifier_suffix] = ACTIONS(2990),
    [sym__constant_suffix] = ACTIONS(2990),
  },
  [2063] = {
    [sym_heredoc_body] = STATE(2063),
    [ts_builtin_sym_end] = ACTIONS(2626),
    [sym_identifier] = ACTIONS(2624),
    [aux_sym_program_token1] = ACTIONS(2626),
    [anon_sym___END__] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2626),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2626),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
  },
  [2064] = {
    [sym__pattern_expr] = STATE(4851),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4811),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4754),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_string] = STATE(4702),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2064),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2394),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_rescue] = ACTIONS(2852),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_RBRACK] = ACTIONS(2394),
    [anon_sym_DOT_DOT] = ACTIONS(2908),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2852),
    [anon_sym_or] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2910),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2912),
    [sym_float] = ACTIONS(2912),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2910),
  },
  [2065] = {
    [sym_heredoc_body] = STATE(2065),
    [ts_builtin_sym_end] = ACTIONS(2636),
    [aux_sym_program_token1] = ACTIONS(2636),
    [anon_sym___END__] = ACTIONS(2638),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_RPAREN] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2638),
    [anon_sym_end] = ACTIONS(2636),
    [anon_sym_rescue] = ACTIONS(2636),
    [anon_sym_EQ] = ACTIONS(2638),
    [anon_sym_COMMA] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_unless] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [anon_sym_until] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2634),
    [anon_sym_when] = ACTIONS(2636),
    [anon_sym_EQ_GT] = ACTIONS(2636),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2638),
    [anon_sym_CARET] = ACTIONS(2638),
    [anon_sym_elsif] = ACTIONS(2636),
    [anon_sym_else] = ACTIONS(2636),
    [anon_sym_then] = ACTIONS(2636),
    [anon_sym_ensure] = ACTIONS(2636),
    [anon_sym_COLON_COLON2] = ACTIONS(2636),
    [anon_sym_AMP_DOT] = ACTIONS(2636),
    [anon_sym_PLUS_EQ] = ACTIONS(2636),
    [anon_sym_DASH_EQ] = ACTIONS(2636),
    [anon_sym_STAR_EQ] = ACTIONS(2636),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2636),
    [anon_sym_SLASH_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2636),
    [anon_sym_AMP_EQ] = ACTIONS(2636),
    [anon_sym_PERCENT_EQ] = ACTIONS(2636),
    [anon_sym_GT_GT_EQ] = ACTIONS(2636),
    [anon_sym_LT_LT_EQ] = ACTIONS(2636),
    [anon_sym_CARET_EQ] = ACTIONS(2636),
    [anon_sym_QMARK] = ACTIONS(2636),
    [anon_sym_and] = ACTIONS(2636),
    [anon_sym_or] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2638),
    [anon_sym_LT_EQ] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_EQ] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_SLASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_BANG_EQ] = ACTIONS(2636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2636),
    [anon_sym_LT_EQ_GT] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2636),
    [anon_sym_BANG_TILDE] = ACTIONS(2636),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2636),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2636),
    [sym__binary_star] = ACTIONS(2636),
    [sym__binary_star_star] = ACTIONS(2636),
    [sym__element_reference_bracket] = ACTIONS(2636),
  },
  [2066] = {
    [sym__pattern_expr] = STATE(4851),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_string] = STATE(4702),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2066),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2394),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_RBRACK] = ACTIONS(2394),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2852),
    [anon_sym_or] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2067] = {
    [sym__pattern_expr] = STATE(4844),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_string] = STATE(4702),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2067),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_RBRACE] = ACTIONS(2848),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2848),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_COMMA] = ACTIONS(2848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_RBRACK] = ACTIONS(2848),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2850),
    [anon_sym_or] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2068] = {
    [sym_heredoc_body] = STATE(2068),
    [ts_builtin_sym_end] = ACTIONS(2622),
    [aux_sym_program_token1] = ACTIONS(2622),
    [anon_sym___END__] = ACTIONS(2620),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_RBRACE] = ACTIONS(2622),
    [anon_sym_RPAREN] = ACTIONS(2622),
    [anon_sym_DOT] = ACTIONS(2620),
    [anon_sym_end] = ACTIONS(2622),
    [anon_sym_rescue] = ACTIONS(2622),
    [anon_sym_EQ] = ACTIONS(2620),
    [anon_sym_COMMA] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2622),
    [anon_sym_unless] = ACTIONS(2622),
    [anon_sym_while] = ACTIONS(2622),
    [anon_sym_until] = ACTIONS(2622),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_do] = ACTIONS(2622),
    [anon_sym_when] = ACTIONS(2622),
    [anon_sym_EQ_GT] = ACTIONS(2622),
    [anon_sym_LPAREN2] = ACTIONS(2622),
    [anon_sym_DOT_DOT] = ACTIONS(2620),
    [anon_sym_CARET] = ACTIONS(2620),
    [anon_sym_elsif] = ACTIONS(2622),
    [anon_sym_else] = ACTIONS(2622),
    [anon_sym_then] = ACTIONS(2622),
    [anon_sym_ensure] = ACTIONS(2622),
    [anon_sym_COLON_COLON2] = ACTIONS(2622),
    [anon_sym_AMP_DOT] = ACTIONS(2622),
    [anon_sym_PLUS_EQ] = ACTIONS(2622),
    [anon_sym_DASH_EQ] = ACTIONS(2622),
    [anon_sym_STAR_EQ] = ACTIONS(2622),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2622),
    [anon_sym_SLASH_EQ] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2622),
    [anon_sym_PIPE_EQ] = ACTIONS(2622),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2622),
    [anon_sym_AMP_EQ] = ACTIONS(2622),
    [anon_sym_PERCENT_EQ] = ACTIONS(2622),
    [anon_sym_GT_GT_EQ] = ACTIONS(2622),
    [anon_sym_LT_LT_EQ] = ACTIONS(2622),
    [anon_sym_CARET_EQ] = ACTIONS(2622),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_and] = ACTIONS(2622),
    [anon_sym_or] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE] = ACTIONS(2620),
    [anon_sym_AMP_AMP] = ACTIONS(2620),
    [anon_sym_LT_LT] = ACTIONS(2620),
    [anon_sym_GT_GT] = ACTIONS(2620),
    [anon_sym_LT_EQ] = ACTIONS(2620),
    [anon_sym_GT] = ACTIONS(2620),
    [anon_sym_GT_EQ] = ACTIONS(2622),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_SLASH] = ACTIONS(2620),
    [anon_sym_PERCENT] = ACTIONS(2620),
    [anon_sym_EQ_EQ] = ACTIONS(2620),
    [anon_sym_BANG_EQ] = ACTIONS(2622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2622),
    [anon_sym_LT_EQ_GT] = ACTIONS(2622),
    [anon_sym_EQ_TILDE] = ACTIONS(2622),
    [anon_sym_BANG_TILDE] = ACTIONS(2622),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2622),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2622),
    [sym__binary_star] = ACTIONS(2622),
    [sym__binary_star_star] = ACTIONS(2622),
    [sym__element_reference_bracket] = ACTIONS(2622),
  },
  [2069] = {
    [sym_heredoc_body] = STATE(2069),
    [ts_builtin_sym_end] = ACTIONS(745),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(745),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_in] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_when] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(745),
    [anon_sym_then] = ACTIONS(745),
    [anon_sym_ensure] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2070] = {
    [sym_heredoc_body] = STATE(2070),
    [ts_builtin_sym_end] = ACTIONS(2642),
    [aux_sym_program_token1] = ACTIONS(2642),
    [anon_sym___END__] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_RBRACE] = ACTIONS(2642),
    [anon_sym_RPAREN] = ACTIONS(2642),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_end] = ACTIONS(2642),
    [anon_sym_rescue] = ACTIONS(2642),
    [anon_sym_EQ] = ACTIONS(2640),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_PIPE] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2642),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2642),
    [anon_sym_unless] = ACTIONS(2642),
    [anon_sym_while] = ACTIONS(2642),
    [anon_sym_until] = ACTIONS(2642),
    [anon_sym_in] = ACTIONS(2642),
    [anon_sym_do] = ACTIONS(2642),
    [anon_sym_when] = ACTIONS(2642),
    [anon_sym_EQ_GT] = ACTIONS(2642),
    [anon_sym_LPAREN2] = ACTIONS(2642),
    [anon_sym_DOT_DOT] = ACTIONS(2640),
    [anon_sym_CARET] = ACTIONS(2640),
    [anon_sym_elsif] = ACTIONS(2642),
    [anon_sym_else] = ACTIONS(2642),
    [anon_sym_then] = ACTIONS(2642),
    [anon_sym_ensure] = ACTIONS(2642),
    [anon_sym_COLON_COLON2] = ACTIONS(2642),
    [anon_sym_AMP_DOT] = ACTIONS(2642),
    [anon_sym_PLUS_EQ] = ACTIONS(2642),
    [anon_sym_DASH_EQ] = ACTIONS(2642),
    [anon_sym_STAR_EQ] = ACTIONS(2642),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2642),
    [anon_sym_SLASH_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2642),
    [anon_sym_AMP_EQ] = ACTIONS(2642),
    [anon_sym_PERCENT_EQ] = ACTIONS(2642),
    [anon_sym_GT_GT_EQ] = ACTIONS(2642),
    [anon_sym_LT_LT_EQ] = ACTIONS(2642),
    [anon_sym_CARET_EQ] = ACTIONS(2642),
    [anon_sym_QMARK] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(2642),
    [anon_sym_or] = ACTIONS(2642),
    [anon_sym_PIPE_PIPE] = ACTIONS(2640),
    [anon_sym_AMP_AMP] = ACTIONS(2640),
    [anon_sym_LT_LT] = ACTIONS(2640),
    [anon_sym_GT_GT] = ACTIONS(2640),
    [anon_sym_LT_EQ] = ACTIONS(2640),
    [anon_sym_GT] = ACTIONS(2640),
    [anon_sym_GT_EQ] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2640),
    [anon_sym_SLASH] = ACTIONS(2640),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_EQ_EQ] = ACTIONS(2640),
    [anon_sym_BANG_EQ] = ACTIONS(2642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2642),
    [anon_sym_LT_EQ_GT] = ACTIONS(2642),
    [anon_sym_EQ_TILDE] = ACTIONS(2642),
    [anon_sym_BANG_TILDE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2642),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2642),
    [sym__binary_star] = ACTIONS(2642),
    [sym__binary_star_star] = ACTIONS(2642),
    [sym__element_reference_bracket] = ACTIONS(2642),
  },
  [2071] = {
    [sym_heredoc_body] = STATE(2071),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(2992),
    [anon_sym_end] = ACTIONS(745),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_in] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_when] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(2742),
    [anon_sym_LBRACK2] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(745),
    [anon_sym_then] = ACTIONS(745),
    [anon_sym_ensure] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2072] = {
    [sym_heredoc_body] = STATE(2072),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [aux_sym_program_token1] = ACTIONS(2646),
    [anon_sym___END__] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_end] = ACTIONS(2646),
    [anon_sym_rescue] = ACTIONS(2646),
    [anon_sym_EQ] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2646),
    [anon_sym_unless] = ACTIONS(2646),
    [anon_sym_while] = ACTIONS(2646),
    [anon_sym_until] = ACTIONS(2646),
    [anon_sym_in] = ACTIONS(2646),
    [anon_sym_do] = ACTIONS(2646),
    [anon_sym_when] = ACTIONS(2646),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2644),
    [anon_sym_elsif] = ACTIONS(2646),
    [anon_sym_else] = ACTIONS(2646),
    [anon_sym_then] = ACTIONS(2646),
    [anon_sym_ensure] = ACTIONS(2646),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_PLUS_EQ] = ACTIONS(2646),
    [anon_sym_DASH_EQ] = ACTIONS(2646),
    [anon_sym_STAR_EQ] = ACTIONS(2646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2646),
    [anon_sym_SLASH_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2646),
    [anon_sym_AMP_EQ] = ACTIONS(2646),
    [anon_sym_PERCENT_EQ] = ACTIONS(2646),
    [anon_sym_GT_GT_EQ] = ACTIONS(2646),
    [anon_sym_LT_LT_EQ] = ACTIONS(2646),
    [anon_sym_CARET_EQ] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2646),
    [anon_sym_and] = ACTIONS(2646),
    [anon_sym_or] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_SLASH] = ACTIONS(2644),
    [anon_sym_PERCENT] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [2073] = {
    [sym_heredoc_body] = STATE(2073),
    [ts_builtin_sym_end] = ACTIONS(745),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(745),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_in] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_when] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(745),
    [anon_sym_then] = ACTIONS(745),
    [anon_sym_ensure] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2074] = {
    [sym_heredoc_body] = STATE(2074),
    [ts_builtin_sym_end] = ACTIONS(2618),
    [aux_sym_program_token1] = ACTIONS(2618),
    [anon_sym___END__] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_RPAREN] = ACTIONS(2618),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_end] = ACTIONS(2618),
    [anon_sym_rescue] = ACTIONS(2618),
    [anon_sym_EQ] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2618),
    [anon_sym_unless] = ACTIONS(2618),
    [anon_sym_while] = ACTIONS(2618),
    [anon_sym_until] = ACTIONS(2618),
    [anon_sym_in] = ACTIONS(2618),
    [anon_sym_do] = ACTIONS(2618),
    [anon_sym_when] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2616),
    [anon_sym_CARET] = ACTIONS(2616),
    [anon_sym_elsif] = ACTIONS(2618),
    [anon_sym_else] = ACTIONS(2618),
    [anon_sym_then] = ACTIONS(2618),
    [anon_sym_ensure] = ACTIONS(2618),
    [anon_sym_COLON_COLON2] = ACTIONS(2618),
    [anon_sym_AMP_DOT] = ACTIONS(2618),
    [anon_sym_PLUS_EQ] = ACTIONS(2618),
    [anon_sym_DASH_EQ] = ACTIONS(2618),
    [anon_sym_STAR_EQ] = ACTIONS(2618),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2618),
    [anon_sym_SLASH_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2618),
    [anon_sym_AMP_EQ] = ACTIONS(2618),
    [anon_sym_PERCENT_EQ] = ACTIONS(2618),
    [anon_sym_GT_GT_EQ] = ACTIONS(2618),
    [anon_sym_LT_LT_EQ] = ACTIONS(2618),
    [anon_sym_CARET_EQ] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(2618),
    [anon_sym_and] = ACTIONS(2618),
    [anon_sym_or] = ACTIONS(2618),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2616),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_EQ] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_EQ] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_SLASH] = ACTIONS(2616),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_EQ_EQ] = ACTIONS(2616),
    [anon_sym_BANG_EQ] = ACTIONS(2618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT_EQ_GT] = ACTIONS(2618),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_BANG_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2618),
    [sym__binary_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2618),
    [sym__element_reference_bracket] = ACTIONS(2618),
  },
  [2075] = {
    [sym_heredoc_body] = STATE(2075),
    [ts_builtin_sym_end] = ACTIONS(2636),
    [aux_sym_program_token1] = ACTIONS(2636),
    [anon_sym___END__] = ACTIONS(2638),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_RPAREN] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2638),
    [anon_sym_end] = ACTIONS(2636),
    [anon_sym_rescue] = ACTIONS(2636),
    [anon_sym_EQ] = ACTIONS(2638),
    [anon_sym_COMMA] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_unless] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [anon_sym_until] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_when] = ACTIONS(2636),
    [anon_sym_EQ_GT] = ACTIONS(2636),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2638),
    [anon_sym_CARET] = ACTIONS(2638),
    [anon_sym_elsif] = ACTIONS(2636),
    [anon_sym_else] = ACTIONS(2636),
    [anon_sym_then] = ACTIONS(2636),
    [anon_sym_ensure] = ACTIONS(2636),
    [anon_sym_COLON_COLON2] = ACTIONS(2636),
    [anon_sym_AMP_DOT] = ACTIONS(2636),
    [anon_sym_PLUS_EQ] = ACTIONS(2636),
    [anon_sym_DASH_EQ] = ACTIONS(2636),
    [anon_sym_STAR_EQ] = ACTIONS(2636),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2636),
    [anon_sym_SLASH_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_PIPE_EQ] = ACTIONS(2636),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2636),
    [anon_sym_AMP_EQ] = ACTIONS(2636),
    [anon_sym_PERCENT_EQ] = ACTIONS(2636),
    [anon_sym_GT_GT_EQ] = ACTIONS(2636),
    [anon_sym_LT_LT_EQ] = ACTIONS(2636),
    [anon_sym_CARET_EQ] = ACTIONS(2636),
    [anon_sym_QMARK] = ACTIONS(2636),
    [anon_sym_and] = ACTIONS(2636),
    [anon_sym_or] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2638),
    [anon_sym_LT_EQ] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_EQ] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_SLASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_BANG_EQ] = ACTIONS(2636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2636),
    [anon_sym_LT_EQ_GT] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2636),
    [anon_sym_BANG_TILDE] = ACTIONS(2636),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2636),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2636),
    [sym__binary_star] = ACTIONS(2636),
    [sym__binary_star_star] = ACTIONS(2636),
    [sym__element_reference_bracket] = ACTIONS(2636),
  },
  [2076] = {
    [sym_heredoc_body] = STATE(2076),
    [ts_builtin_sym_end] = ACTIONS(2626),
    [aux_sym_program_token1] = ACTIONS(2626),
    [anon_sym___END__] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_end] = ACTIONS(2626),
    [anon_sym_rescue] = ACTIONS(2626),
    [anon_sym_EQ] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2626),
    [anon_sym_unless] = ACTIONS(2626),
    [anon_sym_while] = ACTIONS(2626),
    [anon_sym_until] = ACTIONS(2626),
    [anon_sym_in] = ACTIONS(2626),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_when] = ACTIONS(2626),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2624),
    [anon_sym_elsif] = ACTIONS(2626),
    [anon_sym_else] = ACTIONS(2626),
    [anon_sym_then] = ACTIONS(2626),
    [anon_sym_ensure] = ACTIONS(2626),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_PLUS_EQ] = ACTIONS(2626),
    [anon_sym_DASH_EQ] = ACTIONS(2626),
    [anon_sym_STAR_EQ] = ACTIONS(2626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2626),
    [anon_sym_SLASH_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2626),
    [anon_sym_AMP_EQ] = ACTIONS(2626),
    [anon_sym_PERCENT_EQ] = ACTIONS(2626),
    [anon_sym_GT_GT_EQ] = ACTIONS(2626),
    [anon_sym_LT_LT_EQ] = ACTIONS(2626),
    [anon_sym_CARET_EQ] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2626),
    [anon_sym_and] = ACTIONS(2626),
    [anon_sym_or] = ACTIONS(2626),
    [anon_sym_PIPE_PIPE] = ACTIONS(2624),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_LT_LT] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2624),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2624),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [2077] = {
    [sym_heredoc_body] = STATE(2077),
    [ts_builtin_sym_end] = ACTIONS(2630),
    [aux_sym_program_token1] = ACTIONS(2630),
    [anon_sym___END__] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_end] = ACTIONS(2630),
    [anon_sym_rescue] = ACTIONS(2630),
    [anon_sym_EQ] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2630),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2630),
    [anon_sym_until] = ACTIONS(2630),
    [anon_sym_in] = ACTIONS(2630),
    [anon_sym_do] = ACTIONS(2630),
    [anon_sym_when] = ACTIONS(2630),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2628),
    [anon_sym_elsif] = ACTIONS(2630),
    [anon_sym_else] = ACTIONS(2630),
    [anon_sym_then] = ACTIONS(2630),
    [anon_sym_ensure] = ACTIONS(2630),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_PLUS_EQ] = ACTIONS(2630),
    [anon_sym_DASH_EQ] = ACTIONS(2630),
    [anon_sym_STAR_EQ] = ACTIONS(2630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2630),
    [anon_sym_SLASH_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2630),
    [anon_sym_AMP_EQ] = ACTIONS(2630),
    [anon_sym_PERCENT_EQ] = ACTIONS(2630),
    [anon_sym_GT_GT_EQ] = ACTIONS(2630),
    [anon_sym_LT_LT_EQ] = ACTIONS(2630),
    [anon_sym_CARET_EQ] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2630),
    [anon_sym_and] = ACTIONS(2630),
    [anon_sym_or] = ACTIONS(2630),
    [anon_sym_PIPE_PIPE] = ACTIONS(2628),
    [anon_sym_AMP_AMP] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2628),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_SLASH] = ACTIONS(2628),
    [anon_sym_PERCENT] = ACTIONS(2628),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [2078] = {
    [sym_heredoc_body] = STATE(2078),
    [ts_builtin_sym_end] = ACTIONS(2634),
    [aux_sym_program_token1] = ACTIONS(2634),
    [anon_sym___END__] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_end] = ACTIONS(2634),
    [anon_sym_rescue] = ACTIONS(2634),
    [anon_sym_EQ] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2634),
    [anon_sym_unless] = ACTIONS(2634),
    [anon_sym_while] = ACTIONS(2634),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_in] = ACTIONS(2634),
    [anon_sym_do] = ACTIONS(2634),
    [anon_sym_when] = ACTIONS(2634),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2632),
    [anon_sym_elsif] = ACTIONS(2634),
    [anon_sym_else] = ACTIONS(2634),
    [anon_sym_then] = ACTIONS(2634),
    [anon_sym_ensure] = ACTIONS(2634),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_PLUS_EQ] = ACTIONS(2634),
    [anon_sym_DASH_EQ] = ACTIONS(2634),
    [anon_sym_STAR_EQ] = ACTIONS(2634),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2634),
    [anon_sym_SLASH_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2634),
    [anon_sym_AMP_EQ] = ACTIONS(2634),
    [anon_sym_PERCENT_EQ] = ACTIONS(2634),
    [anon_sym_GT_GT_EQ] = ACTIONS(2634),
    [anon_sym_LT_LT_EQ] = ACTIONS(2634),
    [anon_sym_CARET_EQ] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2634),
    [anon_sym_and] = ACTIONS(2634),
    [anon_sym_or] = ACTIONS(2634),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2632),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_SLASH] = ACTIONS(2632),
    [anon_sym_PERCENT] = ACTIONS(2632),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [2079] = {
    [sym__pattern_expr] = STATE(4844),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4811),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4754),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_string] = STATE(4702),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2079),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2848),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_rescue] = ACTIONS(2850),
    [anon_sym_COMMA] = ACTIONS(2848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_RBRACK] = ACTIONS(2848),
    [anon_sym_DOT_DOT] = ACTIONS(2908),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2850),
    [anon_sym_or] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2910),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2912),
    [sym_float] = ACTIONS(2912),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2910),
  },
  [2080] = {
    [sym_heredoc_body] = STATE(2080),
    [ts_builtin_sym_end] = ACTIONS(2998),
    [aux_sym_program_token1] = ACTIONS(2998),
    [anon_sym___END__] = ACTIONS(3000),
    [anon_sym_LBRACE] = ACTIONS(2998),
    [anon_sym_RBRACE] = ACTIONS(2998),
    [anon_sym_RPAREN] = ACTIONS(2998),
    [anon_sym_DOT] = ACTIONS(3000),
    [anon_sym_end] = ACTIONS(2998),
    [anon_sym_rescue] = ACTIONS(2998),
    [anon_sym_EQ] = ACTIONS(3000),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_PIPE] = ACTIONS(3000),
    [anon_sym_SEMI] = ACTIONS(2998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(3000),
    [anon_sym_LT] = ACTIONS(3000),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_unless] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_until] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_when] = ACTIONS(2998),
    [anon_sym_EQ_GT] = ACTIONS(2998),
    [anon_sym_DOT_DOT] = ACTIONS(3000),
    [anon_sym_CARET] = ACTIONS(3000),
    [anon_sym_elsif] = ACTIONS(2998),
    [anon_sym_else] = ACTIONS(2998),
    [anon_sym_then] = ACTIONS(2998),
    [anon_sym_ensure] = ACTIONS(2998),
    [anon_sym_COLON_COLON2] = ACTIONS(2998),
    [anon_sym_AMP_DOT] = ACTIONS(2998),
    [anon_sym_PLUS_EQ] = ACTIONS(2998),
    [anon_sym_DASH_EQ] = ACTIONS(2998),
    [anon_sym_STAR_EQ] = ACTIONS(2998),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2998),
    [anon_sym_SLASH_EQ] = ACTIONS(2998),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2998),
    [anon_sym_PIPE_EQ] = ACTIONS(2998),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2998),
    [anon_sym_AMP_EQ] = ACTIONS(2998),
    [anon_sym_PERCENT_EQ] = ACTIONS(2998),
    [anon_sym_GT_GT_EQ] = ACTIONS(2998),
    [anon_sym_LT_LT_EQ] = ACTIONS(2998),
    [anon_sym_CARET_EQ] = ACTIONS(2998),
    [anon_sym_QMARK] = ACTIONS(2998),
    [anon_sym_and] = ACTIONS(2998),
    [anon_sym_or] = ACTIONS(2998),
    [anon_sym_PIPE_PIPE] = ACTIONS(3000),
    [anon_sym_AMP_AMP] = ACTIONS(3000),
    [anon_sym_LT_LT] = ACTIONS(3000),
    [anon_sym_GT_GT] = ACTIONS(3000),
    [anon_sym_LT_EQ] = ACTIONS(3000),
    [anon_sym_GT] = ACTIONS(3000),
    [anon_sym_GT_EQ] = ACTIONS(2998),
    [anon_sym_PLUS] = ACTIONS(3000),
    [anon_sym_SLASH] = ACTIONS(3000),
    [anon_sym_PERCENT] = ACTIONS(3000),
    [anon_sym_EQ_EQ] = ACTIONS(3000),
    [anon_sym_BANG_EQ] = ACTIONS(2998),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2998),
    [anon_sym_LT_EQ_GT] = ACTIONS(2998),
    [anon_sym_EQ_TILDE] = ACTIONS(2998),
    [anon_sym_BANG_TILDE] = ACTIONS(2998),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2998),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2998),
    [sym__binary_star] = ACTIONS(2998),
    [sym__binary_star_star] = ACTIONS(2998),
    [sym__element_reference_bracket] = ACTIONS(2998),
  },
  [2081] = {
    [sym_heredoc_body] = STATE(2081),
    [ts_builtin_sym_end] = ACTIONS(3002),
    [aux_sym_program_token1] = ACTIONS(3002),
    [anon_sym___END__] = ACTIONS(3004),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_RPAREN] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3004),
    [anon_sym_end] = ACTIONS(3002),
    [anon_sym_rescue] = ACTIONS(3002),
    [anon_sym_EQ] = ACTIONS(3004),
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_PIPE] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3002),
    [anon_sym_AMP] = ACTIONS(3004),
    [anon_sym_LT] = ACTIONS(3004),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_unless] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_until] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_when] = ACTIONS(3002),
    [anon_sym_EQ_GT] = ACTIONS(3002),
    [anon_sym_DOT_DOT] = ACTIONS(3004),
    [anon_sym_CARET] = ACTIONS(3004),
    [anon_sym_elsif] = ACTIONS(3002),
    [anon_sym_else] = ACTIONS(3002),
    [anon_sym_then] = ACTIONS(3002),
    [anon_sym_ensure] = ACTIONS(3002),
    [anon_sym_COLON_COLON2] = ACTIONS(3002),
    [anon_sym_AMP_DOT] = ACTIONS(3002),
    [anon_sym_PLUS_EQ] = ACTIONS(3002),
    [anon_sym_DASH_EQ] = ACTIONS(3002),
    [anon_sym_STAR_EQ] = ACTIONS(3002),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3002),
    [anon_sym_SLASH_EQ] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3002),
    [anon_sym_PIPE_EQ] = ACTIONS(3002),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3002),
    [anon_sym_AMP_EQ] = ACTIONS(3002),
    [anon_sym_PERCENT_EQ] = ACTIONS(3002),
    [anon_sym_GT_GT_EQ] = ACTIONS(3002),
    [anon_sym_LT_LT_EQ] = ACTIONS(3002),
    [anon_sym_CARET_EQ] = ACTIONS(3002),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_and] = ACTIONS(3002),
    [anon_sym_or] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_LT_LT] = ACTIONS(3004),
    [anon_sym_GT_GT] = ACTIONS(3004),
    [anon_sym_LT_EQ] = ACTIONS(3004),
    [anon_sym_GT] = ACTIONS(3004),
    [anon_sym_GT_EQ] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3004),
    [anon_sym_SLASH] = ACTIONS(3004),
    [anon_sym_PERCENT] = ACTIONS(3004),
    [anon_sym_EQ_EQ] = ACTIONS(3004),
    [anon_sym_BANG_EQ] = ACTIONS(3002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3002),
    [anon_sym_LT_EQ_GT] = ACTIONS(3002),
    [anon_sym_EQ_TILDE] = ACTIONS(3002),
    [anon_sym_BANG_TILDE] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3002),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3002),
    [sym__binary_star] = ACTIONS(3002),
    [sym__binary_star_star] = ACTIONS(3002),
    [sym__element_reference_bracket] = ACTIONS(3002),
  },
  [2082] = {
    [sym_heredoc_body] = STATE(2082),
    [ts_builtin_sym_end] = ACTIONS(3006),
    [aux_sym_program_token1] = ACTIONS(3006),
    [anon_sym___END__] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(3006),
    [anon_sym_RPAREN] = ACTIONS(3006),
    [anon_sym_DOT] = ACTIONS(3008),
    [anon_sym_end] = ACTIONS(3006),
    [anon_sym_rescue] = ACTIONS(3006),
    [anon_sym_EQ] = ACTIONS(3008),
    [anon_sym_COMMA] = ACTIONS(3006),
    [anon_sym_PIPE] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3006),
    [anon_sym_AMP] = ACTIONS(3008),
    [anon_sym_LT] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3006),
    [anon_sym_unless] = ACTIONS(3006),
    [anon_sym_while] = ACTIONS(3006),
    [anon_sym_until] = ACTIONS(3006),
    [anon_sym_in] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_when] = ACTIONS(3006),
    [anon_sym_EQ_GT] = ACTIONS(3006),
    [anon_sym_DOT_DOT] = ACTIONS(3008),
    [anon_sym_CARET] = ACTIONS(3008),
    [anon_sym_elsif] = ACTIONS(3006),
    [anon_sym_else] = ACTIONS(3006),
    [anon_sym_then] = ACTIONS(3006),
    [anon_sym_ensure] = ACTIONS(3006),
    [anon_sym_COLON_COLON2] = ACTIONS(3006),
    [anon_sym_AMP_DOT] = ACTIONS(3006),
    [anon_sym_PLUS_EQ] = ACTIONS(3006),
    [anon_sym_DASH_EQ] = ACTIONS(3006),
    [anon_sym_STAR_EQ] = ACTIONS(3006),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3006),
    [anon_sym_SLASH_EQ] = ACTIONS(3006),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3006),
    [anon_sym_PIPE_EQ] = ACTIONS(3006),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3006),
    [anon_sym_AMP_EQ] = ACTIONS(3006),
    [anon_sym_PERCENT_EQ] = ACTIONS(3006),
    [anon_sym_GT_GT_EQ] = ACTIONS(3006),
    [anon_sym_LT_LT_EQ] = ACTIONS(3006),
    [anon_sym_CARET_EQ] = ACTIONS(3006),
    [anon_sym_QMARK] = ACTIONS(3006),
    [anon_sym_and] = ACTIONS(3006),
    [anon_sym_or] = ACTIONS(3006),
    [anon_sym_PIPE_PIPE] = ACTIONS(3008),
    [anon_sym_AMP_AMP] = ACTIONS(3008),
    [anon_sym_LT_LT] = ACTIONS(3008),
    [anon_sym_GT_GT] = ACTIONS(3008),
    [anon_sym_LT_EQ] = ACTIONS(3008),
    [anon_sym_GT] = ACTIONS(3008),
    [anon_sym_GT_EQ] = ACTIONS(3006),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_SLASH] = ACTIONS(3008),
    [anon_sym_PERCENT] = ACTIONS(3008),
    [anon_sym_EQ_EQ] = ACTIONS(3008),
    [anon_sym_BANG_EQ] = ACTIONS(3006),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3006),
    [anon_sym_LT_EQ_GT] = ACTIONS(3006),
    [anon_sym_EQ_TILDE] = ACTIONS(3006),
    [anon_sym_BANG_TILDE] = ACTIONS(3006),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3006),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3006),
    [sym__binary_star] = ACTIONS(3006),
    [sym__binary_star_star] = ACTIONS(3006),
    [sym__element_reference_bracket] = ACTIONS(3006),
  },
  [2083] = {
    [sym_heredoc_body] = STATE(2083),
    [ts_builtin_sym_end] = ACTIONS(3010),
    [aux_sym_program_token1] = ACTIONS(3010),
    [anon_sym___END__] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_RBRACE] = ACTIONS(3010),
    [anon_sym_RPAREN] = ACTIONS(3010),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_end] = ACTIONS(3010),
    [anon_sym_rescue] = ACTIONS(3010),
    [anon_sym_EQ] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_PIPE] = ACTIONS(3012),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3010),
    [anon_sym_unless] = ACTIONS(3010),
    [anon_sym_while] = ACTIONS(3010),
    [anon_sym_until] = ACTIONS(3010),
    [anon_sym_in] = ACTIONS(3010),
    [anon_sym_do] = ACTIONS(3010),
    [anon_sym_when] = ACTIONS(3010),
    [anon_sym_EQ_GT] = ACTIONS(3010),
    [anon_sym_DOT_DOT] = ACTIONS(3012),
    [anon_sym_CARET] = ACTIONS(3012),
    [anon_sym_elsif] = ACTIONS(3010),
    [anon_sym_else] = ACTIONS(3010),
    [anon_sym_then] = ACTIONS(3010),
    [anon_sym_ensure] = ACTIONS(3010),
    [anon_sym_COLON_COLON2] = ACTIONS(3010),
    [anon_sym_AMP_DOT] = ACTIONS(3010),
    [anon_sym_PLUS_EQ] = ACTIONS(3010),
    [anon_sym_DASH_EQ] = ACTIONS(3010),
    [anon_sym_STAR_EQ] = ACTIONS(3010),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3010),
    [anon_sym_SLASH_EQ] = ACTIONS(3010),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3010),
    [anon_sym_PIPE_EQ] = ACTIONS(3010),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3010),
    [anon_sym_AMP_EQ] = ACTIONS(3010),
    [anon_sym_PERCENT_EQ] = ACTIONS(3010),
    [anon_sym_GT_GT_EQ] = ACTIONS(3010),
    [anon_sym_LT_LT_EQ] = ACTIONS(3010),
    [anon_sym_CARET_EQ] = ACTIONS(3010),
    [anon_sym_QMARK] = ACTIONS(3010),
    [anon_sym_and] = ACTIONS(3010),
    [anon_sym_or] = ACTIONS(3010),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [anon_sym_LT_EQ] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_GT_EQ] = ACTIONS(3010),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_SLASH] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_EQ_EQ] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3010),
    [anon_sym_LT_EQ_GT] = ACTIONS(3010),
    [anon_sym_EQ_TILDE] = ACTIONS(3010),
    [anon_sym_BANG_TILDE] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3010),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3010),
    [sym__binary_star] = ACTIONS(3010),
    [sym__binary_star_star] = ACTIONS(3010),
    [sym__element_reference_bracket] = ACTIONS(3010),
  },
  [2084] = {
    [sym_heredoc_body] = STATE(2084),
    [ts_builtin_sym_end] = ACTIONS(2966),
    [aux_sym_program_token1] = ACTIONS(2966),
    [anon_sym___END__] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_RBRACE] = ACTIONS(2966),
    [anon_sym_RPAREN] = ACTIONS(2966),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_end] = ACTIONS(2966),
    [anon_sym_rescue] = ACTIONS(2966),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_COMMA] = ACTIONS(2966),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2966),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_unless] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_until] = ACTIONS(2966),
    [anon_sym_in] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_when] = ACTIONS(2966),
    [anon_sym_EQ_GT] = ACTIONS(2966),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_elsif] = ACTIONS(2966),
    [anon_sym_else] = ACTIONS(2966),
    [anon_sym_then] = ACTIONS(2966),
    [anon_sym_ensure] = ACTIONS(2966),
    [anon_sym_COLON_COLON2] = ACTIONS(2966),
    [anon_sym_AMP_DOT] = ACTIONS(2966),
    [anon_sym_PLUS_EQ] = ACTIONS(2966),
    [anon_sym_DASH_EQ] = ACTIONS(2966),
    [anon_sym_STAR_EQ] = ACTIONS(2966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2966),
    [anon_sym_SLASH_EQ] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2966),
    [anon_sym_PIPE_EQ] = ACTIONS(2966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2966),
    [anon_sym_AMP_EQ] = ACTIONS(2966),
    [anon_sym_PERCENT_EQ] = ACTIONS(2966),
    [anon_sym_GT_GT_EQ] = ACTIONS(2966),
    [anon_sym_LT_LT_EQ] = ACTIONS(2966),
    [anon_sym_CARET_EQ] = ACTIONS(2966),
    [anon_sym_QMARK] = ACTIONS(2966),
    [anon_sym_and] = ACTIONS(2966),
    [anon_sym_or] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2966),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2966),
    [anon_sym_LT_EQ_GT] = ACTIONS(2966),
    [anon_sym_EQ_TILDE] = ACTIONS(2966),
    [anon_sym_BANG_TILDE] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2966),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2966),
    [sym__binary_star] = ACTIONS(2966),
    [sym__binary_star_star] = ACTIONS(2966),
    [sym__element_reference_bracket] = ACTIONS(2966),
  },
  [2085] = {
    [sym_heredoc_body] = STATE(2085),
    [ts_builtin_sym_end] = ACTIONS(3014),
    [aux_sym_program_token1] = ACTIONS(3014),
    [anon_sym___END__] = ACTIONS(3016),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_RPAREN] = ACTIONS(3014),
    [anon_sym_DOT] = ACTIONS(3016),
    [anon_sym_end] = ACTIONS(3014),
    [anon_sym_rescue] = ACTIONS(3014),
    [anon_sym_EQ] = ACTIONS(3016),
    [anon_sym_COMMA] = ACTIONS(3014),
    [anon_sym_PIPE] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3016),
    [anon_sym_LT] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3014),
    [anon_sym_unless] = ACTIONS(3014),
    [anon_sym_while] = ACTIONS(3014),
    [anon_sym_until] = ACTIONS(3014),
    [anon_sym_in] = ACTIONS(3014),
    [anon_sym_do] = ACTIONS(3014),
    [anon_sym_when] = ACTIONS(3014),
    [anon_sym_EQ_GT] = ACTIONS(3014),
    [anon_sym_DOT_DOT] = ACTIONS(3016),
    [anon_sym_CARET] = ACTIONS(3016),
    [anon_sym_elsif] = ACTIONS(3014),
    [anon_sym_else] = ACTIONS(3014),
    [anon_sym_then] = ACTIONS(3014),
    [anon_sym_ensure] = ACTIONS(3014),
    [anon_sym_COLON_COLON2] = ACTIONS(3014),
    [anon_sym_AMP_DOT] = ACTIONS(3014),
    [anon_sym_PLUS_EQ] = ACTIONS(3014),
    [anon_sym_DASH_EQ] = ACTIONS(3014),
    [anon_sym_STAR_EQ] = ACTIONS(3014),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3014),
    [anon_sym_SLASH_EQ] = ACTIONS(3014),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3014),
    [anon_sym_PIPE_EQ] = ACTIONS(3014),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3014),
    [anon_sym_AMP_EQ] = ACTIONS(3014),
    [anon_sym_PERCENT_EQ] = ACTIONS(3014),
    [anon_sym_GT_GT_EQ] = ACTIONS(3014),
    [anon_sym_LT_LT_EQ] = ACTIONS(3014),
    [anon_sym_CARET_EQ] = ACTIONS(3014),
    [anon_sym_QMARK] = ACTIONS(3014),
    [anon_sym_and] = ACTIONS(3014),
    [anon_sym_or] = ACTIONS(3014),
    [anon_sym_PIPE_PIPE] = ACTIONS(3016),
    [anon_sym_AMP_AMP] = ACTIONS(3016),
    [anon_sym_LT_LT] = ACTIONS(3016),
    [anon_sym_GT_GT] = ACTIONS(3016),
    [anon_sym_LT_EQ] = ACTIONS(3016),
    [anon_sym_GT] = ACTIONS(3016),
    [anon_sym_GT_EQ] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [anon_sym_EQ_EQ] = ACTIONS(3016),
    [anon_sym_BANG_EQ] = ACTIONS(3014),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3014),
    [anon_sym_LT_EQ_GT] = ACTIONS(3014),
    [anon_sym_EQ_TILDE] = ACTIONS(3014),
    [anon_sym_BANG_TILDE] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3014),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3014),
    [sym__binary_star_star] = ACTIONS(3014),
    [sym__element_reference_bracket] = ACTIONS(3014),
  },
  [2086] = {
    [sym_heredoc_body] = STATE(2086),
    [ts_builtin_sym_end] = ACTIONS(3018),
    [aux_sym_program_token1] = ACTIONS(3018),
    [anon_sym___END__] = ACTIONS(3020),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_RPAREN] = ACTIONS(3018),
    [anon_sym_DOT] = ACTIONS(3020),
    [anon_sym_end] = ACTIONS(3018),
    [anon_sym_rescue] = ACTIONS(3018),
    [anon_sym_EQ] = ACTIONS(3020),
    [anon_sym_COMMA] = ACTIONS(3018),
    [anon_sym_PIPE] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3018),
    [anon_sym_unless] = ACTIONS(3018),
    [anon_sym_while] = ACTIONS(3018),
    [anon_sym_until] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3018),
    [anon_sym_do] = ACTIONS(3018),
    [anon_sym_when] = ACTIONS(3018),
    [anon_sym_EQ_GT] = ACTIONS(3018),
    [anon_sym_DOT_DOT] = ACTIONS(3020),
    [anon_sym_CARET] = ACTIONS(3020),
    [anon_sym_elsif] = ACTIONS(3018),
    [anon_sym_else] = ACTIONS(3018),
    [anon_sym_then] = ACTIONS(3018),
    [anon_sym_ensure] = ACTIONS(3018),
    [anon_sym_COLON_COLON2] = ACTIONS(3018),
    [anon_sym_AMP_DOT] = ACTIONS(3018),
    [anon_sym_PLUS_EQ] = ACTIONS(3018),
    [anon_sym_DASH_EQ] = ACTIONS(3018),
    [anon_sym_STAR_EQ] = ACTIONS(3018),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3018),
    [anon_sym_SLASH_EQ] = ACTIONS(3018),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3018),
    [anon_sym_PIPE_EQ] = ACTIONS(3018),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3018),
    [anon_sym_AMP_EQ] = ACTIONS(3018),
    [anon_sym_PERCENT_EQ] = ACTIONS(3018),
    [anon_sym_GT_GT_EQ] = ACTIONS(3018),
    [anon_sym_LT_LT_EQ] = ACTIONS(3018),
    [anon_sym_CARET_EQ] = ACTIONS(3018),
    [anon_sym_QMARK] = ACTIONS(3018),
    [anon_sym_and] = ACTIONS(3018),
    [anon_sym_or] = ACTIONS(3018),
    [anon_sym_PIPE_PIPE] = ACTIONS(3020),
    [anon_sym_AMP_AMP] = ACTIONS(3020),
    [anon_sym_LT_LT] = ACTIONS(3020),
    [anon_sym_GT_GT] = ACTIONS(3020),
    [anon_sym_LT_EQ] = ACTIONS(3020),
    [anon_sym_GT] = ACTIONS(3020),
    [anon_sym_GT_EQ] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_SLASH] = ACTIONS(3020),
    [anon_sym_PERCENT] = ACTIONS(3020),
    [anon_sym_EQ_EQ] = ACTIONS(3020),
    [anon_sym_BANG_EQ] = ACTIONS(3018),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3018),
    [anon_sym_LT_EQ_GT] = ACTIONS(3018),
    [anon_sym_EQ_TILDE] = ACTIONS(3018),
    [anon_sym_BANG_TILDE] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3018),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3018),
    [sym__binary_star] = ACTIONS(3018),
    [sym__binary_star_star] = ACTIONS(3018),
    [sym__element_reference_bracket] = ACTIONS(3018),
  },
  [2087] = {
    [sym_heredoc_body] = STATE(2087),
    [ts_builtin_sym_end] = ACTIONS(123),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_end] = ACTIONS(123),
    [anon_sym_rescue] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_unless] = ACTIONS(123),
    [anon_sym_while] = ACTIONS(123),
    [anon_sym_until] = ACTIONS(123),
    [anon_sym_in] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_when] = ACTIONS(123),
    [anon_sym_EQ_GT] = ACTIONS(2996),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(123),
    [anon_sym_else] = ACTIONS(123),
    [anon_sym_then] = ACTIONS(123),
    [anon_sym_ensure] = ACTIONS(123),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(123),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(123),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(123),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [2088] = {
    [sym_heredoc_body] = STATE(2088),
    [ts_builtin_sym_end] = ACTIONS(3022),
    [aux_sym_program_token1] = ACTIONS(3022),
    [anon_sym___END__] = ACTIONS(3024),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_RPAREN] = ACTIONS(3022),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_end] = ACTIONS(3022),
    [anon_sym_rescue] = ACTIONS(3022),
    [anon_sym_EQ] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_PIPE] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3022),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LT] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3022),
    [anon_sym_unless] = ACTIONS(3022),
    [anon_sym_while] = ACTIONS(3022),
    [anon_sym_until] = ACTIONS(3022),
    [anon_sym_in] = ACTIONS(3022),
    [anon_sym_do] = ACTIONS(3022),
    [anon_sym_when] = ACTIONS(3022),
    [anon_sym_EQ_GT] = ACTIONS(3022),
    [anon_sym_DOT_DOT] = ACTIONS(3024),
    [anon_sym_CARET] = ACTIONS(3024),
    [anon_sym_elsif] = ACTIONS(3022),
    [anon_sym_else] = ACTIONS(3022),
    [anon_sym_then] = ACTIONS(3022),
    [anon_sym_ensure] = ACTIONS(3022),
    [anon_sym_COLON_COLON2] = ACTIONS(3022),
    [anon_sym_AMP_DOT] = ACTIONS(3022),
    [anon_sym_PLUS_EQ] = ACTIONS(3022),
    [anon_sym_DASH_EQ] = ACTIONS(3022),
    [anon_sym_STAR_EQ] = ACTIONS(3022),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3022),
    [anon_sym_SLASH_EQ] = ACTIONS(3022),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3022),
    [anon_sym_PIPE_EQ] = ACTIONS(3022),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3022),
    [anon_sym_AMP_EQ] = ACTIONS(3022),
    [anon_sym_PERCENT_EQ] = ACTIONS(3022),
    [anon_sym_GT_GT_EQ] = ACTIONS(3022),
    [anon_sym_LT_LT_EQ] = ACTIONS(3022),
    [anon_sym_CARET_EQ] = ACTIONS(3022),
    [anon_sym_QMARK] = ACTIONS(3022),
    [anon_sym_and] = ACTIONS(3022),
    [anon_sym_or] = ACTIONS(3022),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_LT_LT] = ACTIONS(3024),
    [anon_sym_GT_GT] = ACTIONS(3024),
    [anon_sym_LT_EQ] = ACTIONS(3024),
    [anon_sym_GT] = ACTIONS(3024),
    [anon_sym_GT_EQ] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_SLASH] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_EQ_EQ] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3022),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3022),
    [anon_sym_LT_EQ_GT] = ACTIONS(3022),
    [anon_sym_EQ_TILDE] = ACTIONS(3022),
    [anon_sym_BANG_TILDE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3022),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3022),
    [sym__binary_star] = ACTIONS(3022),
    [sym__binary_star_star] = ACTIONS(3022),
    [sym__element_reference_bracket] = ACTIONS(3022),
  },
  [2089] = {
    [sym_heredoc_body] = STATE(2089),
    [ts_builtin_sym_end] = ACTIONS(3026),
    [aux_sym_program_token1] = ACTIONS(3026),
    [anon_sym___END__] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(3026),
    [anon_sym_RBRACE] = ACTIONS(3026),
    [anon_sym_RPAREN] = ACTIONS(3026),
    [anon_sym_DOT] = ACTIONS(3028),
    [anon_sym_end] = ACTIONS(3026),
    [anon_sym_rescue] = ACTIONS(3026),
    [anon_sym_EQ] = ACTIONS(3028),
    [anon_sym_COMMA] = ACTIONS(3026),
    [anon_sym_PIPE] = ACTIONS(3028),
    [anon_sym_SEMI] = ACTIONS(3026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3028),
    [anon_sym_LT] = ACTIONS(3028),
    [anon_sym_if] = ACTIONS(3026),
    [anon_sym_unless] = ACTIONS(3026),
    [anon_sym_while] = ACTIONS(3026),
    [anon_sym_until] = ACTIONS(3026),
    [anon_sym_in] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3026),
    [anon_sym_when] = ACTIONS(3026),
    [anon_sym_EQ_GT] = ACTIONS(3026),
    [anon_sym_DOT_DOT] = ACTIONS(3028),
    [anon_sym_CARET] = ACTIONS(3028),
    [anon_sym_elsif] = ACTIONS(3026),
    [anon_sym_else] = ACTIONS(3026),
    [anon_sym_then] = ACTIONS(3026),
    [anon_sym_ensure] = ACTIONS(3026),
    [anon_sym_COLON_COLON2] = ACTIONS(3026),
    [anon_sym_AMP_DOT] = ACTIONS(3026),
    [anon_sym_PLUS_EQ] = ACTIONS(3026),
    [anon_sym_DASH_EQ] = ACTIONS(3026),
    [anon_sym_STAR_EQ] = ACTIONS(3026),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3026),
    [anon_sym_SLASH_EQ] = ACTIONS(3026),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3026),
    [anon_sym_PIPE_EQ] = ACTIONS(3026),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3026),
    [anon_sym_AMP_EQ] = ACTIONS(3026),
    [anon_sym_PERCENT_EQ] = ACTIONS(3026),
    [anon_sym_GT_GT_EQ] = ACTIONS(3026),
    [anon_sym_LT_LT_EQ] = ACTIONS(3026),
    [anon_sym_CARET_EQ] = ACTIONS(3026),
    [anon_sym_QMARK] = ACTIONS(3026),
    [anon_sym_and] = ACTIONS(3026),
    [anon_sym_or] = ACTIONS(3026),
    [anon_sym_PIPE_PIPE] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_LT_LT] = ACTIONS(3028),
    [anon_sym_GT_GT] = ACTIONS(3028),
    [anon_sym_LT_EQ] = ACTIONS(3028),
    [anon_sym_GT] = ACTIONS(3028),
    [anon_sym_GT_EQ] = ACTIONS(3026),
    [anon_sym_PLUS] = ACTIONS(3028),
    [anon_sym_SLASH] = ACTIONS(3028),
    [anon_sym_PERCENT] = ACTIONS(3028),
    [anon_sym_EQ_EQ] = ACTIONS(3028),
    [anon_sym_BANG_EQ] = ACTIONS(3026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3026),
    [anon_sym_LT_EQ_GT] = ACTIONS(3026),
    [anon_sym_EQ_TILDE] = ACTIONS(3026),
    [anon_sym_BANG_TILDE] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3026),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3026),
    [sym__binary_star] = ACTIONS(3026),
    [sym__binary_star_star] = ACTIONS(3026),
    [sym__element_reference_bracket] = ACTIONS(3026),
  },
  [2090] = {
    [sym_heredoc_body] = STATE(2090),
    [ts_builtin_sym_end] = ACTIONS(3030),
    [aux_sym_program_token1] = ACTIONS(3030),
    [anon_sym___END__] = ACTIONS(3032),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_end] = ACTIONS(3030),
    [anon_sym_rescue] = ACTIONS(3030),
    [anon_sym_EQ] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_unless] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_until] = ACTIONS(3030),
    [anon_sym_in] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_when] = ACTIONS(3030),
    [anon_sym_EQ_GT] = ACTIONS(3030),
    [anon_sym_DOT_DOT] = ACTIONS(3032),
    [anon_sym_CARET] = ACTIONS(3032),
    [anon_sym_elsif] = ACTIONS(3030),
    [anon_sym_else] = ACTIONS(3030),
    [anon_sym_then] = ACTIONS(3030),
    [anon_sym_ensure] = ACTIONS(3030),
    [anon_sym_COLON_COLON2] = ACTIONS(3030),
    [anon_sym_AMP_DOT] = ACTIONS(3030),
    [anon_sym_PLUS_EQ] = ACTIONS(3030),
    [anon_sym_DASH_EQ] = ACTIONS(3030),
    [anon_sym_STAR_EQ] = ACTIONS(3030),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3030),
    [anon_sym_SLASH_EQ] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3030),
    [anon_sym_PIPE_EQ] = ACTIONS(3030),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3030),
    [anon_sym_AMP_EQ] = ACTIONS(3030),
    [anon_sym_PERCENT_EQ] = ACTIONS(3030),
    [anon_sym_GT_GT_EQ] = ACTIONS(3030),
    [anon_sym_LT_LT_EQ] = ACTIONS(3030),
    [anon_sym_CARET_EQ] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3030),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3032),
    [anon_sym_GT_GT] = ACTIONS(3032),
    [anon_sym_LT_EQ] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_GT_EQ] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_SLASH] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3030),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3030),
    [anon_sym_LT_EQ_GT] = ACTIONS(3030),
    [anon_sym_EQ_TILDE] = ACTIONS(3030),
    [anon_sym_BANG_TILDE] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3030),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3030),
    [sym__binary_star] = ACTIONS(3030),
    [sym__binary_star_star] = ACTIONS(3030),
    [sym__element_reference_bracket] = ACTIONS(3030),
  },
  [2091] = {
    [sym_heredoc_body] = STATE(2091),
    [ts_builtin_sym_end] = ACTIONS(123),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_end] = ACTIONS(123),
    [anon_sym_rescue] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_unless] = ACTIONS(123),
    [anon_sym_while] = ACTIONS(123),
    [anon_sym_until] = ACTIONS(123),
    [anon_sym_in] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_when] = ACTIONS(123),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(123),
    [anon_sym_else] = ACTIONS(123),
    [anon_sym_then] = ACTIONS(123),
    [anon_sym_ensure] = ACTIONS(123),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(123),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(123),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(123),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [2092] = {
    [sym_heredoc_body] = STATE(2092),
    [ts_builtin_sym_end] = ACTIONS(3034),
    [aux_sym_program_token1] = ACTIONS(3034),
    [anon_sym___END__] = ACTIONS(3036),
    [anon_sym_LBRACE] = ACTIONS(3034),
    [anon_sym_RBRACE] = ACTIONS(3034),
    [anon_sym_RPAREN] = ACTIONS(3034),
    [anon_sym_DOT] = ACTIONS(3036),
    [anon_sym_end] = ACTIONS(3034),
    [anon_sym_rescue] = ACTIONS(3034),
    [anon_sym_EQ] = ACTIONS(3036),
    [anon_sym_COMMA] = ACTIONS(3034),
    [anon_sym_PIPE] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3034),
    [anon_sym_AMP] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3036),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_unless] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_until] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_when] = ACTIONS(3034),
    [anon_sym_EQ_GT] = ACTIONS(3034),
    [anon_sym_DOT_DOT] = ACTIONS(3036),
    [anon_sym_CARET] = ACTIONS(3036),
    [anon_sym_elsif] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_then] = ACTIONS(3034),
    [anon_sym_ensure] = ACTIONS(3034),
    [anon_sym_COLON_COLON2] = ACTIONS(3034),
    [anon_sym_AMP_DOT] = ACTIONS(3034),
    [anon_sym_PLUS_EQ] = ACTIONS(3034),
    [anon_sym_DASH_EQ] = ACTIONS(3034),
    [anon_sym_STAR_EQ] = ACTIONS(3034),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3034),
    [anon_sym_SLASH_EQ] = ACTIONS(3034),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3034),
    [anon_sym_PIPE_EQ] = ACTIONS(3034),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3034),
    [anon_sym_AMP_EQ] = ACTIONS(3034),
    [anon_sym_PERCENT_EQ] = ACTIONS(3034),
    [anon_sym_GT_GT_EQ] = ACTIONS(3034),
    [anon_sym_LT_LT_EQ] = ACTIONS(3034),
    [anon_sym_CARET_EQ] = ACTIONS(3034),
    [anon_sym_QMARK] = ACTIONS(3034),
    [anon_sym_and] = ACTIONS(3034),
    [anon_sym_or] = ACTIONS(3034),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_LT_LT] = ACTIONS(3036),
    [anon_sym_GT_GT] = ACTIONS(3036),
    [anon_sym_LT_EQ] = ACTIONS(3036),
    [anon_sym_GT] = ACTIONS(3036),
    [anon_sym_GT_EQ] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3036),
    [anon_sym_SLASH] = ACTIONS(3036),
    [anon_sym_PERCENT] = ACTIONS(3036),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_BANG_EQ] = ACTIONS(3034),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3034),
    [anon_sym_LT_EQ_GT] = ACTIONS(3034),
    [anon_sym_EQ_TILDE] = ACTIONS(3034),
    [anon_sym_BANG_TILDE] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3034),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3034),
    [sym__binary_star] = ACTIONS(3034),
    [sym__binary_star_star] = ACTIONS(3034),
    [sym__element_reference_bracket] = ACTIONS(3034),
  },
  [2093] = {
    [sym_splat_parameter] = STATE(4989),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5460),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym__array_pattern_body] = STATE(5831),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(5832),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_string] = STATE(4702),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2093),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_RBRACK] = ACTIONS(3038),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2094] = {
    [sym_splat_parameter] = STATE(4989),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5460),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym__array_pattern_body] = STATE(5754),
    [sym_array_pattern] = STATE(4790),
    [sym__find_pattern_body] = STATE(5753),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_string] = STATE(4702),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2094),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_RBRACK] = ACTIONS(3040),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2095] = {
    [sym_heredoc_body] = STATE(2095),
    [ts_builtin_sym_end] = ACTIONS(3042),
    [aux_sym_program_token1] = ACTIONS(3042),
    [anon_sym___END__] = ACTIONS(3044),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3044),
    [anon_sym_end] = ACTIONS(3042),
    [anon_sym_rescue] = ACTIONS(3042),
    [anon_sym_EQ] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_LT] = ACTIONS(3044),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_unless] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_until] = ACTIONS(3042),
    [anon_sym_in] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_when] = ACTIONS(3042),
    [anon_sym_EQ_GT] = ACTIONS(3042),
    [anon_sym_DOT_DOT] = ACTIONS(3044),
    [anon_sym_CARET] = ACTIONS(3044),
    [anon_sym_elsif] = ACTIONS(3042),
    [anon_sym_else] = ACTIONS(3042),
    [anon_sym_then] = ACTIONS(3042),
    [anon_sym_ensure] = ACTIONS(3042),
    [anon_sym_COLON_COLON2] = ACTIONS(3042),
    [anon_sym_AMP_DOT] = ACTIONS(3042),
    [anon_sym_PLUS_EQ] = ACTIONS(3042),
    [anon_sym_DASH_EQ] = ACTIONS(3042),
    [anon_sym_STAR_EQ] = ACTIONS(3042),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3042),
    [anon_sym_SLASH_EQ] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3042),
    [anon_sym_PIPE_EQ] = ACTIONS(3042),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3042),
    [anon_sym_AMP_EQ] = ACTIONS(3042),
    [anon_sym_PERCENT_EQ] = ACTIONS(3042),
    [anon_sym_GT_GT_EQ] = ACTIONS(3042),
    [anon_sym_LT_LT_EQ] = ACTIONS(3042),
    [anon_sym_CARET_EQ] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_LT_LT] = ACTIONS(3044),
    [anon_sym_GT_GT] = ACTIONS(3044),
    [anon_sym_LT_EQ] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(3044),
    [anon_sym_GT_EQ] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3044),
    [anon_sym_SLASH] = ACTIONS(3044),
    [anon_sym_PERCENT] = ACTIONS(3044),
    [anon_sym_EQ_EQ] = ACTIONS(3044),
    [anon_sym_BANG_EQ] = ACTIONS(3042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3042),
    [anon_sym_LT_EQ_GT] = ACTIONS(3042),
    [anon_sym_EQ_TILDE] = ACTIONS(3042),
    [anon_sym_BANG_TILDE] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3042),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3042),
    [sym__binary_star] = ACTIONS(3042),
    [sym__binary_star_star] = ACTIONS(3042),
    [sym__element_reference_bracket] = ACTIONS(3042),
  },
  [2096] = {
    [sym_heredoc_body] = STATE(2096),
    [ts_builtin_sym_end] = ACTIONS(3046),
    [aux_sym_program_token1] = ACTIONS(3046),
    [anon_sym___END__] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_RBRACE] = ACTIONS(3046),
    [anon_sym_RPAREN] = ACTIONS(3046),
    [anon_sym_DOT] = ACTIONS(3048),
    [anon_sym_end] = ACTIONS(3046),
    [anon_sym_rescue] = ACTIONS(3046),
    [anon_sym_EQ] = ACTIONS(3048),
    [anon_sym_COMMA] = ACTIONS(3046),
    [anon_sym_PIPE] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_LT] = ACTIONS(3048),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_unless] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_until] = ACTIONS(3046),
    [anon_sym_in] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_when] = ACTIONS(3046),
    [anon_sym_EQ_GT] = ACTIONS(3046),
    [anon_sym_DOT_DOT] = ACTIONS(3048),
    [anon_sym_CARET] = ACTIONS(3048),
    [anon_sym_elsif] = ACTIONS(3046),
    [anon_sym_else] = ACTIONS(3046),
    [anon_sym_then] = ACTIONS(3046),
    [anon_sym_ensure] = ACTIONS(3046),
    [anon_sym_COLON_COLON2] = ACTIONS(3046),
    [anon_sym_AMP_DOT] = ACTIONS(3046),
    [anon_sym_PLUS_EQ] = ACTIONS(3046),
    [anon_sym_DASH_EQ] = ACTIONS(3046),
    [anon_sym_STAR_EQ] = ACTIONS(3046),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3046),
    [anon_sym_SLASH_EQ] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3046),
    [anon_sym_PIPE_EQ] = ACTIONS(3046),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3046),
    [anon_sym_AMP_EQ] = ACTIONS(3046),
    [anon_sym_PERCENT_EQ] = ACTIONS(3046),
    [anon_sym_GT_GT_EQ] = ACTIONS(3046),
    [anon_sym_LT_LT_EQ] = ACTIONS(3046),
    [anon_sym_CARET_EQ] = ACTIONS(3046),
    [anon_sym_QMARK] = ACTIONS(3046),
    [anon_sym_and] = ACTIONS(3046),
    [anon_sym_or] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_LT_LT] = ACTIONS(3048),
    [anon_sym_GT_GT] = ACTIONS(3048),
    [anon_sym_LT_EQ] = ACTIONS(3048),
    [anon_sym_GT] = ACTIONS(3048),
    [anon_sym_GT_EQ] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_SLASH] = ACTIONS(3048),
    [anon_sym_PERCENT] = ACTIONS(3048),
    [anon_sym_EQ_EQ] = ACTIONS(3048),
    [anon_sym_BANG_EQ] = ACTIONS(3046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3046),
    [anon_sym_LT_EQ_GT] = ACTIONS(3046),
    [anon_sym_EQ_TILDE] = ACTIONS(3046),
    [anon_sym_BANG_TILDE] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3046),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3046),
    [sym__binary_star] = ACTIONS(3046),
    [sym__binary_star_star] = ACTIONS(3046),
    [sym__element_reference_bracket] = ACTIONS(3046),
  },
  [2097] = {
    [sym_heredoc_body] = STATE(2097),
    [ts_builtin_sym_end] = ACTIONS(3050),
    [aux_sym_program_token1] = ACTIONS(3050),
    [anon_sym___END__] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3050),
    [anon_sym_RBRACE] = ACTIONS(3050),
    [anon_sym_RPAREN] = ACTIONS(3050),
    [anon_sym_DOT] = ACTIONS(3052),
    [anon_sym_end] = ACTIONS(3050),
    [anon_sym_rescue] = ACTIONS(3050),
    [anon_sym_EQ] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3050),
    [anon_sym_PIPE] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3050),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_unless] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_until] = ACTIONS(3050),
    [anon_sym_in] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_when] = ACTIONS(3050),
    [anon_sym_EQ_GT] = ACTIONS(3050),
    [anon_sym_DOT_DOT] = ACTIONS(3052),
    [anon_sym_CARET] = ACTIONS(3052),
    [anon_sym_elsif] = ACTIONS(3050),
    [anon_sym_else] = ACTIONS(3050),
    [anon_sym_then] = ACTIONS(3050),
    [anon_sym_ensure] = ACTIONS(3050),
    [anon_sym_COLON_COLON2] = ACTIONS(3050),
    [anon_sym_AMP_DOT] = ACTIONS(3050),
    [anon_sym_PLUS_EQ] = ACTIONS(3050),
    [anon_sym_DASH_EQ] = ACTIONS(3050),
    [anon_sym_STAR_EQ] = ACTIONS(3050),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3050),
    [anon_sym_SLASH_EQ] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3050),
    [anon_sym_PIPE_EQ] = ACTIONS(3050),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3050),
    [anon_sym_AMP_EQ] = ACTIONS(3050),
    [anon_sym_PERCENT_EQ] = ACTIONS(3050),
    [anon_sym_GT_GT_EQ] = ACTIONS(3050),
    [anon_sym_LT_LT_EQ] = ACTIONS(3050),
    [anon_sym_CARET_EQ] = ACTIONS(3050),
    [anon_sym_QMARK] = ACTIONS(3050),
    [anon_sym_and] = ACTIONS(3050),
    [anon_sym_or] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_LT_LT] = ACTIONS(3052),
    [anon_sym_GT_GT] = ACTIONS(3052),
    [anon_sym_LT_EQ] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3052),
    [anon_sym_GT_EQ] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3052),
    [anon_sym_PERCENT] = ACTIONS(3052),
    [anon_sym_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3050),
    [anon_sym_LT_EQ_GT] = ACTIONS(3050),
    [anon_sym_EQ_TILDE] = ACTIONS(3050),
    [anon_sym_BANG_TILDE] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3050),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3050),
    [sym__binary_star] = ACTIONS(3050),
    [sym__binary_star_star] = ACTIONS(3050),
    [sym__element_reference_bracket] = ACTIONS(3050),
  },
  [2098] = {
    [sym_heredoc_body] = STATE(2098),
    [ts_builtin_sym_end] = ACTIONS(3054),
    [aux_sym_program_token1] = ACTIONS(3054),
    [anon_sym___END__] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3054),
    [anon_sym_RBRACE] = ACTIONS(3054),
    [anon_sym_RPAREN] = ACTIONS(3054),
    [anon_sym_DOT] = ACTIONS(3056),
    [anon_sym_end] = ACTIONS(3054),
    [anon_sym_rescue] = ACTIONS(3054),
    [anon_sym_EQ] = ACTIONS(3056),
    [anon_sym_COMMA] = ACTIONS(3054),
    [anon_sym_PIPE] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3054),
    [anon_sym_unless] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_until] = ACTIONS(3054),
    [anon_sym_in] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_when] = ACTIONS(3054),
    [anon_sym_EQ_GT] = ACTIONS(3054),
    [anon_sym_DOT_DOT] = ACTIONS(3056),
    [anon_sym_CARET] = ACTIONS(3056),
    [anon_sym_elsif] = ACTIONS(3054),
    [anon_sym_else] = ACTIONS(3054),
    [anon_sym_then] = ACTIONS(3054),
    [anon_sym_ensure] = ACTIONS(3054),
    [anon_sym_COLON_COLON2] = ACTIONS(3054),
    [anon_sym_AMP_DOT] = ACTIONS(3054),
    [anon_sym_PLUS_EQ] = ACTIONS(3054),
    [anon_sym_DASH_EQ] = ACTIONS(3054),
    [anon_sym_STAR_EQ] = ACTIONS(3054),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3054),
    [anon_sym_SLASH_EQ] = ACTIONS(3054),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3054),
    [anon_sym_PIPE_EQ] = ACTIONS(3054),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3054),
    [anon_sym_AMP_EQ] = ACTIONS(3054),
    [anon_sym_PERCENT_EQ] = ACTIONS(3054),
    [anon_sym_GT_GT_EQ] = ACTIONS(3054),
    [anon_sym_LT_LT_EQ] = ACTIONS(3054),
    [anon_sym_CARET_EQ] = ACTIONS(3054),
    [anon_sym_QMARK] = ACTIONS(3054),
    [anon_sym_and] = ACTIONS(3054),
    [anon_sym_or] = ACTIONS(3054),
    [anon_sym_PIPE_PIPE] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_LT_LT] = ACTIONS(3056),
    [anon_sym_GT_GT] = ACTIONS(3056),
    [anon_sym_LT_EQ] = ACTIONS(3056),
    [anon_sym_GT] = ACTIONS(3056),
    [anon_sym_GT_EQ] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3056),
    [anon_sym_SLASH] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(3056),
    [anon_sym_EQ_EQ] = ACTIONS(3056),
    [anon_sym_BANG_EQ] = ACTIONS(3054),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3054),
    [anon_sym_LT_EQ_GT] = ACTIONS(3054),
    [anon_sym_EQ_TILDE] = ACTIONS(3054),
    [anon_sym_BANG_TILDE] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3054),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3054),
    [sym__binary_star] = ACTIONS(3054),
    [sym__binary_star_star] = ACTIONS(3054),
    [sym__element_reference_bracket] = ACTIONS(3054),
  },
  [2099] = {
    [sym_heredoc_body] = STATE(2099),
    [ts_builtin_sym_end] = ACTIONS(3058),
    [aux_sym_program_token1] = ACTIONS(3058),
    [anon_sym___END__] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3058),
    [anon_sym_RBRACE] = ACTIONS(3058),
    [anon_sym_RPAREN] = ACTIONS(3058),
    [anon_sym_DOT] = ACTIONS(3060),
    [anon_sym_end] = ACTIONS(3058),
    [anon_sym_rescue] = ACTIONS(3058),
    [anon_sym_EQ] = ACTIONS(3060),
    [anon_sym_COMMA] = ACTIONS(3058),
    [anon_sym_PIPE] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_LT] = ACTIONS(3060),
    [anon_sym_if] = ACTIONS(3058),
    [anon_sym_unless] = ACTIONS(3058),
    [anon_sym_while] = ACTIONS(3058),
    [anon_sym_until] = ACTIONS(3058),
    [anon_sym_in] = ACTIONS(3058),
    [anon_sym_do] = ACTIONS(3058),
    [anon_sym_when] = ACTIONS(3058),
    [anon_sym_EQ_GT] = ACTIONS(3058),
    [anon_sym_DOT_DOT] = ACTIONS(3060),
    [anon_sym_CARET] = ACTIONS(3060),
    [anon_sym_elsif] = ACTIONS(3058),
    [anon_sym_else] = ACTIONS(3058),
    [anon_sym_then] = ACTIONS(3058),
    [anon_sym_ensure] = ACTIONS(3058),
    [anon_sym_COLON_COLON2] = ACTIONS(3058),
    [anon_sym_AMP_DOT] = ACTIONS(3058),
    [anon_sym_PLUS_EQ] = ACTIONS(3058),
    [anon_sym_DASH_EQ] = ACTIONS(3058),
    [anon_sym_STAR_EQ] = ACTIONS(3058),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3058),
    [anon_sym_SLASH_EQ] = ACTIONS(3058),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3058),
    [anon_sym_PIPE_EQ] = ACTIONS(3058),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3058),
    [anon_sym_AMP_EQ] = ACTIONS(3058),
    [anon_sym_PERCENT_EQ] = ACTIONS(3058),
    [anon_sym_GT_GT_EQ] = ACTIONS(3058),
    [anon_sym_LT_LT_EQ] = ACTIONS(3058),
    [anon_sym_CARET_EQ] = ACTIONS(3058),
    [anon_sym_QMARK] = ACTIONS(3058),
    [anon_sym_and] = ACTIONS(3058),
    [anon_sym_or] = ACTIONS(3058),
    [anon_sym_PIPE_PIPE] = ACTIONS(3060),
    [anon_sym_AMP_AMP] = ACTIONS(3060),
    [anon_sym_LT_LT] = ACTIONS(3060),
    [anon_sym_GT_GT] = ACTIONS(3060),
    [anon_sym_LT_EQ] = ACTIONS(3060),
    [anon_sym_GT] = ACTIONS(3060),
    [anon_sym_GT_EQ] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_SLASH] = ACTIONS(3060),
    [anon_sym_PERCENT] = ACTIONS(3060),
    [anon_sym_EQ_EQ] = ACTIONS(3060),
    [anon_sym_BANG_EQ] = ACTIONS(3058),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3058),
    [anon_sym_LT_EQ_GT] = ACTIONS(3058),
    [anon_sym_EQ_TILDE] = ACTIONS(3058),
    [anon_sym_BANG_TILDE] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3058),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3058),
    [sym__binary_star] = ACTIONS(3058),
    [sym__binary_star_star] = ACTIONS(3058),
    [sym__element_reference_bracket] = ACTIONS(3058),
  },
  [2100] = {
    [sym_heredoc_body] = STATE(2100),
    [ts_builtin_sym_end] = ACTIONS(3062),
    [aux_sym_program_token1] = ACTIONS(3062),
    [anon_sym___END__] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3062),
    [anon_sym_RBRACE] = ACTIONS(3062),
    [anon_sym_RPAREN] = ACTIONS(3062),
    [anon_sym_DOT] = ACTIONS(3064),
    [anon_sym_end] = ACTIONS(3062),
    [anon_sym_rescue] = ACTIONS(3062),
    [anon_sym_EQ] = ACTIONS(3064),
    [anon_sym_COMMA] = ACTIONS(3062),
    [anon_sym_PIPE] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3062),
    [anon_sym_unless] = ACTIONS(3062),
    [anon_sym_while] = ACTIONS(3062),
    [anon_sym_until] = ACTIONS(3062),
    [anon_sym_in] = ACTIONS(3062),
    [anon_sym_do] = ACTIONS(3062),
    [anon_sym_when] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(3062),
    [anon_sym_DOT_DOT] = ACTIONS(3064),
    [anon_sym_CARET] = ACTIONS(3064),
    [anon_sym_elsif] = ACTIONS(3062),
    [anon_sym_else] = ACTIONS(3062),
    [anon_sym_then] = ACTIONS(3062),
    [anon_sym_ensure] = ACTIONS(3062),
    [anon_sym_COLON_COLON2] = ACTIONS(3062),
    [anon_sym_AMP_DOT] = ACTIONS(3062),
    [anon_sym_PLUS_EQ] = ACTIONS(3062),
    [anon_sym_DASH_EQ] = ACTIONS(3062),
    [anon_sym_STAR_EQ] = ACTIONS(3062),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3062),
    [anon_sym_SLASH_EQ] = ACTIONS(3062),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3062),
    [anon_sym_PIPE_EQ] = ACTIONS(3062),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3062),
    [anon_sym_AMP_EQ] = ACTIONS(3062),
    [anon_sym_PERCENT_EQ] = ACTIONS(3062),
    [anon_sym_GT_GT_EQ] = ACTIONS(3062),
    [anon_sym_LT_LT_EQ] = ACTIONS(3062),
    [anon_sym_CARET_EQ] = ACTIONS(3062),
    [anon_sym_QMARK] = ACTIONS(3062),
    [anon_sym_and] = ACTIONS(3062),
    [anon_sym_or] = ACTIONS(3062),
    [anon_sym_PIPE_PIPE] = ACTIONS(3064),
    [anon_sym_AMP_AMP] = ACTIONS(3064),
    [anon_sym_LT_LT] = ACTIONS(3064),
    [anon_sym_GT_GT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(3064),
    [anon_sym_GT] = ACTIONS(3064),
    [anon_sym_GT_EQ] = ACTIONS(3062),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_SLASH] = ACTIONS(3064),
    [anon_sym_PERCENT] = ACTIONS(3064),
    [anon_sym_EQ_EQ] = ACTIONS(3064),
    [anon_sym_BANG_EQ] = ACTIONS(3062),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3062),
    [anon_sym_LT_EQ_GT] = ACTIONS(3062),
    [anon_sym_EQ_TILDE] = ACTIONS(3062),
    [anon_sym_BANG_TILDE] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3062),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3062),
    [sym__binary_star] = ACTIONS(3062),
    [sym__binary_star_star] = ACTIONS(3062),
    [sym__element_reference_bracket] = ACTIONS(3062),
  },
  [2101] = {
    [sym_heredoc_body] = STATE(2101),
    [ts_builtin_sym_end] = ACTIONS(3066),
    [aux_sym_program_token1] = ACTIONS(3066),
    [anon_sym___END__] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3066),
    [anon_sym_RPAREN] = ACTIONS(3066),
    [anon_sym_DOT] = ACTIONS(3068),
    [anon_sym_end] = ACTIONS(3066),
    [anon_sym_rescue] = ACTIONS(3066),
    [anon_sym_EQ] = ACTIONS(3068),
    [anon_sym_COMMA] = ACTIONS(3066),
    [anon_sym_PIPE] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_LT] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3066),
    [anon_sym_unless] = ACTIONS(3066),
    [anon_sym_while] = ACTIONS(3066),
    [anon_sym_until] = ACTIONS(3066),
    [anon_sym_in] = ACTIONS(3066),
    [anon_sym_do] = ACTIONS(3066),
    [anon_sym_when] = ACTIONS(3066),
    [anon_sym_EQ_GT] = ACTIONS(3066),
    [anon_sym_DOT_DOT] = ACTIONS(3068),
    [anon_sym_CARET] = ACTIONS(3068),
    [anon_sym_elsif] = ACTIONS(3066),
    [anon_sym_else] = ACTIONS(3066),
    [anon_sym_then] = ACTIONS(3066),
    [anon_sym_ensure] = ACTIONS(3066),
    [anon_sym_COLON_COLON2] = ACTIONS(3066),
    [anon_sym_AMP_DOT] = ACTIONS(3066),
    [anon_sym_PLUS_EQ] = ACTIONS(3066),
    [anon_sym_DASH_EQ] = ACTIONS(3066),
    [anon_sym_STAR_EQ] = ACTIONS(3066),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3066),
    [anon_sym_SLASH_EQ] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3066),
    [anon_sym_PIPE_EQ] = ACTIONS(3066),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3066),
    [anon_sym_AMP_EQ] = ACTIONS(3066),
    [anon_sym_PERCENT_EQ] = ACTIONS(3066),
    [anon_sym_GT_GT_EQ] = ACTIONS(3066),
    [anon_sym_LT_LT_EQ] = ACTIONS(3066),
    [anon_sym_CARET_EQ] = ACTIONS(3066),
    [anon_sym_QMARK] = ACTIONS(3066),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE] = ACTIONS(3068),
    [anon_sym_AMP_AMP] = ACTIONS(3068),
    [anon_sym_LT_LT] = ACTIONS(3068),
    [anon_sym_GT_GT] = ACTIONS(3068),
    [anon_sym_LT_EQ] = ACTIONS(3068),
    [anon_sym_GT] = ACTIONS(3068),
    [anon_sym_GT_EQ] = ACTIONS(3066),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_SLASH] = ACTIONS(3068),
    [anon_sym_PERCENT] = ACTIONS(3068),
    [anon_sym_EQ_EQ] = ACTIONS(3068),
    [anon_sym_BANG_EQ] = ACTIONS(3066),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3066),
    [anon_sym_LT_EQ_GT] = ACTIONS(3066),
    [anon_sym_EQ_TILDE] = ACTIONS(3066),
    [anon_sym_BANG_TILDE] = ACTIONS(3066),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3066),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3066),
    [sym__binary_star] = ACTIONS(3066),
    [sym__binary_star_star] = ACTIONS(3066),
    [sym__element_reference_bracket] = ACTIONS(3066),
  },
  [2102] = {
    [sym_heredoc_body] = STATE(2102),
    [ts_builtin_sym_end] = ACTIONS(3070),
    [aux_sym_program_token1] = ACTIONS(3070),
    [anon_sym___END__] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_RPAREN] = ACTIONS(3070),
    [anon_sym_DOT] = ACTIONS(3072),
    [anon_sym_end] = ACTIONS(3070),
    [anon_sym_rescue] = ACTIONS(3070),
    [anon_sym_EQ] = ACTIONS(3072),
    [anon_sym_COMMA] = ACTIONS(3070),
    [anon_sym_PIPE] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_LT] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3070),
    [anon_sym_unless] = ACTIONS(3070),
    [anon_sym_while] = ACTIONS(3070),
    [anon_sym_until] = ACTIONS(3070),
    [anon_sym_in] = ACTIONS(3070),
    [anon_sym_do] = ACTIONS(3070),
    [anon_sym_when] = ACTIONS(3070),
    [anon_sym_EQ_GT] = ACTIONS(3070),
    [anon_sym_DOT_DOT] = ACTIONS(3072),
    [anon_sym_CARET] = ACTIONS(3072),
    [anon_sym_elsif] = ACTIONS(3070),
    [anon_sym_else] = ACTIONS(3070),
    [anon_sym_then] = ACTIONS(3070),
    [anon_sym_ensure] = ACTIONS(3070),
    [anon_sym_COLON_COLON2] = ACTIONS(3070),
    [anon_sym_AMP_DOT] = ACTIONS(3070),
    [anon_sym_PLUS_EQ] = ACTIONS(3070),
    [anon_sym_DASH_EQ] = ACTIONS(3070),
    [anon_sym_STAR_EQ] = ACTIONS(3070),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3070),
    [anon_sym_SLASH_EQ] = ACTIONS(3070),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3070),
    [anon_sym_PIPE_EQ] = ACTIONS(3070),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3070),
    [anon_sym_AMP_EQ] = ACTIONS(3070),
    [anon_sym_PERCENT_EQ] = ACTIONS(3070),
    [anon_sym_GT_GT_EQ] = ACTIONS(3070),
    [anon_sym_LT_LT_EQ] = ACTIONS(3070),
    [anon_sym_CARET_EQ] = ACTIONS(3070),
    [anon_sym_QMARK] = ACTIONS(3070),
    [anon_sym_and] = ACTIONS(3070),
    [anon_sym_or] = ACTIONS(3070),
    [anon_sym_PIPE_PIPE] = ACTIONS(3072),
    [anon_sym_AMP_AMP] = ACTIONS(3072),
    [anon_sym_LT_LT] = ACTIONS(3072),
    [anon_sym_GT_GT] = ACTIONS(3072),
    [anon_sym_LT_EQ] = ACTIONS(3072),
    [anon_sym_GT] = ACTIONS(3072),
    [anon_sym_GT_EQ] = ACTIONS(3070),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [anon_sym_EQ_EQ] = ACTIONS(3072),
    [anon_sym_BANG_EQ] = ACTIONS(3070),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3070),
    [anon_sym_LT_EQ_GT] = ACTIONS(3070),
    [anon_sym_EQ_TILDE] = ACTIONS(3070),
    [anon_sym_BANG_TILDE] = ACTIONS(3070),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3070),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3070),
    [sym__binary_star] = ACTIONS(3070),
    [sym__binary_star_star] = ACTIONS(3070),
    [sym__element_reference_bracket] = ACTIONS(3070),
  },
  [2103] = {
    [sym_heredoc_body] = STATE(2103),
    [ts_builtin_sym_end] = ACTIONS(3074),
    [aux_sym_program_token1] = ACTIONS(3074),
    [anon_sym___END__] = ACTIONS(3076),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_RPAREN] = ACTIONS(3074),
    [anon_sym_DOT] = ACTIONS(3076),
    [anon_sym_end] = ACTIONS(3074),
    [anon_sym_rescue] = ACTIONS(3074),
    [anon_sym_EQ] = ACTIONS(3076),
    [anon_sym_COMMA] = ACTIONS(3074),
    [anon_sym_PIPE] = ACTIONS(3076),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3076),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(3074),
    [anon_sym_unless] = ACTIONS(3074),
    [anon_sym_while] = ACTIONS(3074),
    [anon_sym_until] = ACTIONS(3074),
    [anon_sym_in] = ACTIONS(3074),
    [anon_sym_do] = ACTIONS(3074),
    [anon_sym_when] = ACTIONS(3074),
    [anon_sym_EQ_GT] = ACTIONS(3074),
    [anon_sym_DOT_DOT] = ACTIONS(3076),
    [anon_sym_CARET] = ACTIONS(3076),
    [anon_sym_elsif] = ACTIONS(3074),
    [anon_sym_else] = ACTIONS(3074),
    [anon_sym_then] = ACTIONS(3074),
    [anon_sym_ensure] = ACTIONS(3074),
    [anon_sym_COLON_COLON2] = ACTIONS(3074),
    [anon_sym_AMP_DOT] = ACTIONS(3074),
    [anon_sym_PLUS_EQ] = ACTIONS(3074),
    [anon_sym_DASH_EQ] = ACTIONS(3074),
    [anon_sym_STAR_EQ] = ACTIONS(3074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3074),
    [anon_sym_SLASH_EQ] = ACTIONS(3074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3074),
    [anon_sym_PIPE_EQ] = ACTIONS(3074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3074),
    [anon_sym_AMP_EQ] = ACTIONS(3074),
    [anon_sym_PERCENT_EQ] = ACTIONS(3074),
    [anon_sym_GT_GT_EQ] = ACTIONS(3074),
    [anon_sym_LT_LT_EQ] = ACTIONS(3074),
    [anon_sym_CARET_EQ] = ACTIONS(3074),
    [anon_sym_QMARK] = ACTIONS(3074),
    [anon_sym_and] = ACTIONS(3074),
    [anon_sym_or] = ACTIONS(3074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3076),
    [anon_sym_AMP_AMP] = ACTIONS(3076),
    [anon_sym_LT_LT] = ACTIONS(3076),
    [anon_sym_GT_GT] = ACTIONS(3076),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_EQ] = ACTIONS(3074),
    [anon_sym_PLUS] = ACTIONS(3076),
    [anon_sym_SLASH] = ACTIONS(3076),
    [anon_sym_PERCENT] = ACTIONS(3076),
    [anon_sym_EQ_EQ] = ACTIONS(3076),
    [anon_sym_BANG_EQ] = ACTIONS(3074),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3074),
    [anon_sym_LT_EQ_GT] = ACTIONS(3074),
    [anon_sym_EQ_TILDE] = ACTIONS(3074),
    [anon_sym_BANG_TILDE] = ACTIONS(3074),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3074),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3074),
    [sym__binary_star] = ACTIONS(3074),
    [sym__binary_star_star] = ACTIONS(3074),
    [sym__element_reference_bracket] = ACTIONS(3074),
  },
  [2104] = {
    [sym_heredoc_body] = STATE(2104),
    [sym_identifier] = ACTIONS(3078),
    [anon_sym_BEGIN] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_END] = ACTIONS(3078),
    [anon_sym_def] = ACTIONS(3078),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_end] = ACTIONS(3078),
    [anon_sym_rescue] = ACTIONS(3078),
    [anon_sym_EQ] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_nil] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_module] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_yield] = ACTIONS(3078),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_next] = ACTIONS(3078),
    [anon_sym_redo] = ACTIONS(3078),
    [anon_sym_retry] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_unless] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_until] = ACTIONS(3078),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_case] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3080),
    [anon_sym_DOT_DOT] = ACTIONS(3078),
    [anon_sym_else] = ACTIONS(3078),
    [anon_sym_begin] = ACTIONS(3078),
    [anon_sym_ensure] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_defined_QMARK] = ACTIONS(3080),
    [anon_sym_not] = ACTIONS(3078),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_undef] = ACTIONS(3078),
    [anon_sym_alias] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(3078),
    [sym_float] = ACTIONS(3078),
    [sym_super] = ACTIONS(3078),
    [sym_self] = ACTIONS(3078),
    [sym_true] = ACTIONS(3078),
    [sym_false] = ACTIONS(3078),
    [sym_constant] = ACTIONS(3078),
    [aux_sym_constant_suffix_token1] = ACTIONS(3080),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3078),
    [sym_instance_variable] = ACTIONS(3080),
    [sym_class_variable] = ACTIONS(3080),
    [sym_global_variable] = ACTIONS(3080),
    [sym_character] = ACTIONS(3080),
    [anon_sym_DASH_GT] = ACTIONS(3080),
    [sym__line_break] = ACTIONS(3080),
    [sym_simple_symbol] = ACTIONS(3080),
    [sym__string_start] = ACTIONS(3080),
    [sym__symbol_start] = ACTIONS(3080),
    [sym__subshell_start] = ACTIONS(3080),
    [sym__regex_start] = ACTIONS(3080),
    [sym__string_array_start] = ACTIONS(3080),
    [sym__symbol_array_start] = ACTIONS(3080),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3080),
    [sym__unary_minus] = ACTIONS(3080),
    [sym__unary_minus_num] = ACTIONS(3080),
    [sym__binary_minus] = ACTIONS(3080),
    [sym__identifier_suffix] = ACTIONS(3080),
    [sym__constant_suffix] = ACTIONS(3080),
  },
  [2105] = {
    [sym_heredoc_body] = STATE(2105),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2618),
    [anon_sym_RPAREN] = ACTIONS(2618),
    [anon_sym_COLON_COLON] = ACTIONS(2618),
    [anon_sym_rescue] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_RBRACK] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2616),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_and] = ACTIONS(2616),
    [anon_sym_or] = ACTIONS(2616),
    [anon_sym_PLUS] = ACTIONS(2618),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2618),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2618),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
  },
  [2106] = {
    [sym_heredoc_body] = STATE(2106),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2646),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_COLON_COLON] = ACTIONS(2646),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_RBRACK] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
  },
  [2107] = {
    [sym_heredoc_body] = STATE(2107),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2626),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_RBRACK] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2626),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
  },
  [2108] = {
    [sym_heredoc_body] = STATE(2108),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(745),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_in] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_when] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(745),
    [anon_sym_then] = ACTIONS(745),
    [anon_sym_ensure] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2109] = {
    [sym_heredoc_body] = STATE(2109),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_RBRACK] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
  },
  [2110] = {
    [sym_heredoc_body] = STATE(2110),
    [sym_identifier] = ACTIONS(3084),
    [anon_sym_BEGIN] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3086),
    [anon_sym_END] = ACTIONS(3084),
    [anon_sym_def] = ACTIONS(3084),
    [anon_sym_LPAREN] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [anon_sym_end] = ACTIONS(3084),
    [anon_sym_rescue] = ACTIONS(3084),
    [anon_sym_EQ] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3086),
    [anon_sym_nil] = ACTIONS(3084),
    [anon_sym_class] = ACTIONS(3084),
    [anon_sym_module] = ACTIONS(3084),
    [anon_sym_return] = ACTIONS(3084),
    [anon_sym_yield] = ACTIONS(3084),
    [anon_sym_break] = ACTIONS(3084),
    [anon_sym_next] = ACTIONS(3084),
    [anon_sym_redo] = ACTIONS(3084),
    [anon_sym_retry] = ACTIONS(3084),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_unless] = ACTIONS(3084),
    [anon_sym_while] = ACTIONS(3084),
    [anon_sym_until] = ACTIONS(3084),
    [anon_sym_for] = ACTIONS(3084),
    [anon_sym_case] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_DOT_DOT] = ACTIONS(3084),
    [anon_sym_else] = ACTIONS(3084),
    [anon_sym_begin] = ACTIONS(3084),
    [anon_sym_ensure] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_defined_QMARK] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3086),
    [anon_sym_TILDE] = ACTIONS(3086),
    [anon_sym_undef] = ACTIONS(3084),
    [anon_sym_alias] = ACTIONS(3084),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(3084),
    [sym_float] = ACTIONS(3084),
    [sym_super] = ACTIONS(3084),
    [sym_self] = ACTIONS(3084),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [sym_constant] = ACTIONS(3084),
    [aux_sym_constant_suffix_token1] = ACTIONS(3086),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3084),
    [sym_instance_variable] = ACTIONS(3086),
    [sym_class_variable] = ACTIONS(3086),
    [sym_global_variable] = ACTIONS(3086),
    [sym_character] = ACTIONS(3086),
    [anon_sym_DASH_GT] = ACTIONS(3086),
    [sym__line_break] = ACTIONS(3086),
    [sym_simple_symbol] = ACTIONS(3086),
    [sym__string_start] = ACTIONS(3086),
    [sym__symbol_start] = ACTIONS(3086),
    [sym__subshell_start] = ACTIONS(3086),
    [sym__regex_start] = ACTIONS(3086),
    [sym__string_array_start] = ACTIONS(3086),
    [sym__symbol_array_start] = ACTIONS(3086),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3086),
    [sym__unary_minus] = ACTIONS(3086),
    [sym__unary_minus_num] = ACTIONS(3086),
    [sym__binary_minus] = ACTIONS(3086),
    [sym__identifier_suffix] = ACTIONS(3086),
    [sym__constant_suffix] = ACTIONS(3086),
  },
  [2111] = {
    [sym_heredoc_body] = STATE(2111),
    [sym_identifier] = ACTIONS(3088),
    [anon_sym_BEGIN] = ACTIONS(3088),
    [anon_sym_LBRACE] = ACTIONS(3090),
    [anon_sym_END] = ACTIONS(3088),
    [anon_sym_def] = ACTIONS(3088),
    [anon_sym_LPAREN] = ACTIONS(3090),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_end] = ACTIONS(3088),
    [anon_sym_rescue] = ACTIONS(3088),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_SEMI] = ACTIONS(3090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3090),
    [anon_sym_nil] = ACTIONS(3088),
    [anon_sym_class] = ACTIONS(3088),
    [anon_sym_module] = ACTIONS(3088),
    [anon_sym_return] = ACTIONS(3088),
    [anon_sym_yield] = ACTIONS(3088),
    [anon_sym_break] = ACTIONS(3088),
    [anon_sym_next] = ACTIONS(3088),
    [anon_sym_redo] = ACTIONS(3088),
    [anon_sym_retry] = ACTIONS(3088),
    [anon_sym_if] = ACTIONS(3088),
    [anon_sym_unless] = ACTIONS(3088),
    [anon_sym_while] = ACTIONS(3088),
    [anon_sym_until] = ACTIONS(3088),
    [anon_sym_for] = ACTIONS(3088),
    [anon_sym_case] = ACTIONS(3088),
    [anon_sym_LBRACK] = ACTIONS(3090),
    [anon_sym_DOT_DOT] = ACTIONS(3088),
    [anon_sym_else] = ACTIONS(3088),
    [anon_sym_begin] = ACTIONS(3088),
    [anon_sym_ensure] = ACTIONS(3088),
    [anon_sym_PLUS] = ACTIONS(3090),
    [anon_sym_defined_QMARK] = ACTIONS(3090),
    [anon_sym_not] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3090),
    [anon_sym_TILDE] = ACTIONS(3090),
    [anon_sym_undef] = ACTIONS(3088),
    [anon_sym_alias] = ACTIONS(3088),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(3088),
    [sym_float] = ACTIONS(3088),
    [sym_super] = ACTIONS(3088),
    [sym_self] = ACTIONS(3088),
    [sym_true] = ACTIONS(3088),
    [sym_false] = ACTIONS(3088),
    [sym_constant] = ACTIONS(3088),
    [aux_sym_constant_suffix_token1] = ACTIONS(3090),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3088),
    [sym_instance_variable] = ACTIONS(3090),
    [sym_class_variable] = ACTIONS(3090),
    [sym_global_variable] = ACTIONS(3090),
    [sym_character] = ACTIONS(3090),
    [anon_sym_DASH_GT] = ACTIONS(3090),
    [sym__line_break] = ACTIONS(3090),
    [sym_simple_symbol] = ACTIONS(3090),
    [sym__string_start] = ACTIONS(3090),
    [sym__symbol_start] = ACTIONS(3090),
    [sym__subshell_start] = ACTIONS(3090),
    [sym__regex_start] = ACTIONS(3090),
    [sym__string_array_start] = ACTIONS(3090),
    [sym__symbol_array_start] = ACTIONS(3090),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3090),
    [sym__unary_minus] = ACTIONS(3090),
    [sym__unary_minus_num] = ACTIONS(3090),
    [sym__binary_minus] = ACTIONS(3090),
    [sym__identifier_suffix] = ACTIONS(3090),
    [sym__constant_suffix] = ACTIONS(3090),
  },
  [2112] = {
    [sym_heredoc_body] = STATE(2112),
    [sym_identifier] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_def] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2950),
    [anon_sym_rescue] = ACTIONS(2948),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_nil] = ACTIONS(2948),
    [anon_sym_class] = ACTIONS(2948),
    [anon_sym_module] = ACTIONS(2948),
    [anon_sym_return] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2948),
    [anon_sym_break] = ACTIONS(2948),
    [anon_sym_next] = ACTIONS(2948),
    [anon_sym_redo] = ACTIONS(2948),
    [anon_sym_retry] = ACTIONS(2948),
    [anon_sym_if] = ACTIONS(2948),
    [anon_sym_unless] = ACTIONS(2948),
    [anon_sym_while] = ACTIONS(2948),
    [anon_sym_until] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2948),
    [anon_sym_do] = ACTIONS(2948),
    [anon_sym_case] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_RBRACK] = ACTIONS(2950),
    [anon_sym_DOT_DOT] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2948),
    [anon_sym_and] = ACTIONS(2948),
    [anon_sym_or] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_defined_QMARK] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2948),
    [sym_float] = ACTIONS(2948),
    [sym_super] = ACTIONS(2948),
    [sym_self] = ACTIONS(2948),
    [sym_true] = ACTIONS(2948),
    [sym_false] = ACTIONS(2948),
    [sym_constant] = ACTIONS(2948),
    [aux_sym_constant_suffix_token1] = ACTIONS(2950),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2948),
    [sym_instance_variable] = ACTIONS(2950),
    [sym_class_variable] = ACTIONS(2950),
    [sym_global_variable] = ACTIONS(2950),
    [sym_character] = ACTIONS(2950),
    [anon_sym_DASH_GT] = ACTIONS(2950),
    [sym_simple_symbol] = ACTIONS(2950),
    [sym__string_start] = ACTIONS(2950),
    [sym__symbol_start] = ACTIONS(2950),
    [sym__subshell_start] = ACTIONS(2950),
    [sym__regex_start] = ACTIONS(2950),
    [sym__string_array_start] = ACTIONS(2950),
    [sym__symbol_array_start] = ACTIONS(2950),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2950),
    [sym__block_ampersand] = ACTIONS(2950),
    [sym__splat_star] = ACTIONS(2950),
    [sym__unary_minus] = ACTIONS(2950),
    [sym__unary_minus_num] = ACTIONS(2950),
    [sym__binary_minus] = ACTIONS(2950),
    [sym_hash_key_symbol] = ACTIONS(2950),
    [sym__identifier_suffix] = ACTIONS(2950),
    [sym__constant_suffix] = ACTIONS(2950),
    [sym__hash_splat_star_star] = ACTIONS(2950),
  },
  [2113] = {
    [sym_heredoc_body] = STATE(2113),
    [sym_identifier] = ACTIONS(2620),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_def] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2622),
    [anon_sym_RPAREN] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2622),
    [anon_sym_rescue] = ACTIONS(2620),
    [anon_sym_COMMA] = ACTIONS(2622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2622),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_nil] = ACTIONS(2620),
    [anon_sym_class] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_yield] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2620),
    [anon_sym_redo] = ACTIONS(2620),
    [anon_sym_retry] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_unless] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [anon_sym_until] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_do] = ACTIONS(2620),
    [anon_sym_case] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_RBRACK] = ACTIONS(2622),
    [anon_sym_DOT_DOT] = ACTIONS(2620),
    [anon_sym_begin] = ACTIONS(2620),
    [anon_sym_and] = ACTIONS(2620),
    [anon_sym_or] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_defined_QMARK] = ACTIONS(2622),
    [anon_sym_not] = ACTIONS(2620),
    [anon_sym_BANG] = ACTIONS(2622),
    [anon_sym_TILDE] = ACTIONS(2622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2620),
    [sym_float] = ACTIONS(2620),
    [sym_super] = ACTIONS(2620),
    [sym_self] = ACTIONS(2620),
    [sym_true] = ACTIONS(2620),
    [sym_false] = ACTIONS(2620),
    [sym_constant] = ACTIONS(2620),
    [aux_sym_constant_suffix_token1] = ACTIONS(2622),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2620),
    [sym_instance_variable] = ACTIONS(2622),
    [sym_class_variable] = ACTIONS(2622),
    [sym_global_variable] = ACTIONS(2622),
    [sym_character] = ACTIONS(2622),
    [anon_sym_DASH_GT] = ACTIONS(2622),
    [sym_simple_symbol] = ACTIONS(2622),
    [sym__string_start] = ACTIONS(2622),
    [sym__symbol_start] = ACTIONS(2622),
    [sym__subshell_start] = ACTIONS(2622),
    [sym__regex_start] = ACTIONS(2622),
    [sym__string_array_start] = ACTIONS(2622),
    [sym__symbol_array_start] = ACTIONS(2622),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2622),
    [sym__block_ampersand] = ACTIONS(2622),
    [sym__splat_star] = ACTIONS(2622),
    [sym__unary_minus] = ACTIONS(2622),
    [sym__unary_minus_num] = ACTIONS(2622),
    [sym__binary_minus] = ACTIONS(2622),
    [sym_hash_key_symbol] = ACTIONS(2622),
    [sym__identifier_suffix] = ACTIONS(2622),
    [sym__constant_suffix] = ACTIONS(2622),
    [sym__hash_splat_star_star] = ACTIONS(2622),
  },
  [2114] = {
    [sym_heredoc_body] = STATE(2114),
    [sym_identifier] = ACTIONS(3092),
    [anon_sym_BEGIN] = ACTIONS(3092),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_END] = ACTIONS(3092),
    [anon_sym_def] = ACTIONS(3092),
    [anon_sym_LPAREN] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_end] = ACTIONS(3092),
    [anon_sym_rescue] = ACTIONS(3092),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3094),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_nil] = ACTIONS(3092),
    [anon_sym_class] = ACTIONS(3092),
    [anon_sym_module] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_break] = ACTIONS(3092),
    [anon_sym_next] = ACTIONS(3092),
    [anon_sym_redo] = ACTIONS(3092),
    [anon_sym_retry] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_unless] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_until] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_case] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_DOT_DOT] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_ensure] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_defined_QMARK] = ACTIONS(3094),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_undef] = ACTIONS(3092),
    [anon_sym_alias] = ACTIONS(3092),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3092),
    [sym_float] = ACTIONS(3092),
    [sym_super] = ACTIONS(3092),
    [sym_self] = ACTIONS(3092),
    [sym_true] = ACTIONS(3092),
    [sym_false] = ACTIONS(3092),
    [sym_constant] = ACTIONS(3092),
    [aux_sym_constant_suffix_token1] = ACTIONS(3094),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3092),
    [sym_instance_variable] = ACTIONS(3094),
    [sym_class_variable] = ACTIONS(3094),
    [sym_global_variable] = ACTIONS(3094),
    [sym_character] = ACTIONS(3094),
    [anon_sym_DASH_GT] = ACTIONS(3094),
    [sym__line_break] = ACTIONS(3094),
    [sym_simple_symbol] = ACTIONS(3094),
    [sym__string_start] = ACTIONS(3094),
    [sym__symbol_start] = ACTIONS(3094),
    [sym__subshell_start] = ACTIONS(3094),
    [sym__regex_start] = ACTIONS(3094),
    [sym__string_array_start] = ACTIONS(3094),
    [sym__symbol_array_start] = ACTIONS(3094),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3094),
    [sym__unary_minus] = ACTIONS(3094),
    [sym__unary_minus_num] = ACTIONS(3094),
    [sym__binary_minus] = ACTIONS(3094),
    [sym__identifier_suffix] = ACTIONS(3094),
    [sym__constant_suffix] = ACTIONS(3094),
  },
  [2115] = {
    [sym_heredoc_body] = STATE(2115),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_BEGIN] = ACTIONS(1990),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_END] = ACTIONS(1990),
    [anon_sym_def] = ACTIONS(1990),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2954),
    [anon_sym_end] = ACTIONS(1990),
    [anon_sym_rescue] = ACTIONS(1990),
    [anon_sym_PIPE] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2954),
    [anon_sym_nil] = ACTIONS(1990),
    [anon_sym_class] = ACTIONS(1990),
    [anon_sym_module] = ACTIONS(1990),
    [anon_sym_return] = ACTIONS(1990),
    [anon_sym_yield] = ACTIONS(1990),
    [anon_sym_break] = ACTIONS(1990),
    [anon_sym_next] = ACTIONS(1990),
    [anon_sym_redo] = ACTIONS(1990),
    [anon_sym_retry] = ACTIONS(1990),
    [anon_sym_if] = ACTIONS(1990),
    [anon_sym_unless] = ACTIONS(1990),
    [anon_sym_while] = ACTIONS(1990),
    [anon_sym_until] = ACTIONS(1990),
    [anon_sym_for] = ACTIONS(1990),
    [anon_sym_case] = ACTIONS(1990),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_DOT_DOT] = ACTIONS(1990),
    [anon_sym_else] = ACTIONS(1990),
    [anon_sym_begin] = ACTIONS(1990),
    [anon_sym_ensure] = ACTIONS(1990),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_defined_QMARK] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(1990),
    [anon_sym_BANG] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2954),
    [anon_sym_undef] = ACTIONS(1990),
    [anon_sym_alias] = ACTIONS(1990),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(1990),
    [sym_float] = ACTIONS(1990),
    [sym_super] = ACTIONS(1990),
    [sym_self] = ACTIONS(1990),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_constant] = ACTIONS(1990),
    [aux_sym_constant_suffix_token1] = ACTIONS(2954),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1990),
    [sym_instance_variable] = ACTIONS(2954),
    [sym_class_variable] = ACTIONS(2954),
    [sym_global_variable] = ACTIONS(2954),
    [sym_character] = ACTIONS(2954),
    [anon_sym_DASH_GT] = ACTIONS(2954),
    [sym_simple_symbol] = ACTIONS(2954),
    [sym__string_start] = ACTIONS(2954),
    [sym__symbol_start] = ACTIONS(2954),
    [sym__subshell_start] = ACTIONS(2954),
    [sym__regex_start] = ACTIONS(2954),
    [sym__string_array_start] = ACTIONS(2954),
    [sym__symbol_array_start] = ACTIONS(2954),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2954),
    [sym__unary_minus] = ACTIONS(2954),
    [sym__unary_minus_num] = ACTIONS(2954),
    [sym__binary_minus] = ACTIONS(2954),
    [sym__identifier_suffix] = ACTIONS(2954),
    [sym__constant_suffix] = ACTIONS(2954),
  },
  [2116] = {
    [sym_heredoc_body] = STATE(2116),
    [sym_identifier] = ACTIONS(3096),
    [anon_sym_BEGIN] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3098),
    [anon_sym_END] = ACTIONS(3096),
    [anon_sym_def] = ACTIONS(3096),
    [anon_sym_LPAREN] = ACTIONS(3098),
    [anon_sym_COLON_COLON] = ACTIONS(3098),
    [anon_sym_end] = ACTIONS(3096),
    [anon_sym_rescue] = ACTIONS(3096),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_nil] = ACTIONS(3096),
    [anon_sym_class] = ACTIONS(3096),
    [anon_sym_module] = ACTIONS(3096),
    [anon_sym_return] = ACTIONS(3096),
    [anon_sym_yield] = ACTIONS(3096),
    [anon_sym_break] = ACTIONS(3096),
    [anon_sym_next] = ACTIONS(3096),
    [anon_sym_redo] = ACTIONS(3096),
    [anon_sym_retry] = ACTIONS(3096),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_unless] = ACTIONS(3096),
    [anon_sym_while] = ACTIONS(3096),
    [anon_sym_until] = ACTIONS(3096),
    [anon_sym_for] = ACTIONS(3096),
    [anon_sym_case] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_DOT_DOT] = ACTIONS(3096),
    [anon_sym_else] = ACTIONS(3096),
    [anon_sym_begin] = ACTIONS(3096),
    [anon_sym_ensure] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3098),
    [anon_sym_defined_QMARK] = ACTIONS(3098),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_BANG] = ACTIONS(3098),
    [anon_sym_TILDE] = ACTIONS(3098),
    [anon_sym_undef] = ACTIONS(3096),
    [anon_sym_alias] = ACTIONS(3096),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3096),
    [sym_float] = ACTIONS(3096),
    [sym_super] = ACTIONS(3096),
    [sym_self] = ACTIONS(3096),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [sym_constant] = ACTIONS(3096),
    [aux_sym_constant_suffix_token1] = ACTIONS(3098),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3096),
    [sym_instance_variable] = ACTIONS(3098),
    [sym_class_variable] = ACTIONS(3098),
    [sym_global_variable] = ACTIONS(3098),
    [sym_character] = ACTIONS(3098),
    [anon_sym_DASH_GT] = ACTIONS(3098),
    [sym__line_break] = ACTIONS(3098),
    [sym_simple_symbol] = ACTIONS(3098),
    [sym__string_start] = ACTIONS(3098),
    [sym__symbol_start] = ACTIONS(3098),
    [sym__subshell_start] = ACTIONS(3098),
    [sym__regex_start] = ACTIONS(3098),
    [sym__string_array_start] = ACTIONS(3098),
    [sym__symbol_array_start] = ACTIONS(3098),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3098),
    [sym__unary_minus] = ACTIONS(3098),
    [sym__unary_minus_num] = ACTIONS(3098),
    [sym__binary_minus] = ACTIONS(3098),
    [sym__identifier_suffix] = ACTIONS(3098),
    [sym__constant_suffix] = ACTIONS(3098),
  },
  [2117] = {
    [sym_heredoc_body] = STATE(2117),
    [sym_identifier] = ACTIONS(3100),
    [anon_sym_BEGIN] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_END] = ACTIONS(3100),
    [anon_sym_def] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_end] = ACTIONS(3100),
    [anon_sym_rescue] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_nil] = ACTIONS(3100),
    [anon_sym_class] = ACTIONS(3100),
    [anon_sym_module] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_yield] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_next] = ACTIONS(3100),
    [anon_sym_redo] = ACTIONS(3100),
    [anon_sym_retry] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_unless] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_until] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_DOT_DOT] = ACTIONS(3100),
    [anon_sym_else] = ACTIONS(3100),
    [anon_sym_begin] = ACTIONS(3100),
    [anon_sym_ensure] = ACTIONS(3100),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_defined_QMARK] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(3100),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_undef] = ACTIONS(3100),
    [anon_sym_alias] = ACTIONS(3100),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3100),
    [sym_float] = ACTIONS(3100),
    [sym_super] = ACTIONS(3100),
    [sym_self] = ACTIONS(3100),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [sym_constant] = ACTIONS(3100),
    [aux_sym_constant_suffix_token1] = ACTIONS(3102),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3100),
    [sym_instance_variable] = ACTIONS(3102),
    [sym_class_variable] = ACTIONS(3102),
    [sym_global_variable] = ACTIONS(3102),
    [sym_character] = ACTIONS(3102),
    [anon_sym_DASH_GT] = ACTIONS(3102),
    [sym__line_break] = ACTIONS(3102),
    [sym_simple_symbol] = ACTIONS(3102),
    [sym__string_start] = ACTIONS(3102),
    [sym__symbol_start] = ACTIONS(3102),
    [sym__subshell_start] = ACTIONS(3102),
    [sym__regex_start] = ACTIONS(3102),
    [sym__string_array_start] = ACTIONS(3102),
    [sym__symbol_array_start] = ACTIONS(3102),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3102),
    [sym__unary_minus] = ACTIONS(3102),
    [sym__unary_minus_num] = ACTIONS(3102),
    [sym__binary_minus] = ACTIONS(3102),
    [sym__identifier_suffix] = ACTIONS(3102),
    [sym__constant_suffix] = ACTIONS(3102),
  },
  [2118] = {
    [sym_heredoc_body] = STATE(2118),
    [aux_sym__mlhs_repeat1] = STATE(5296),
    [anon_sym_LBRACE] = ACTIONS(3104),
    [anon_sym_RBRACE] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(3104),
    [anon_sym_DOT] = ACTIONS(3106),
    [anon_sym_end] = ACTIONS(3104),
    [anon_sym_rescue] = ACTIONS(3104),
    [anon_sym_EQ] = ACTIONS(3108),
    [anon_sym_COMMA] = ACTIONS(3104),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3106),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_unless] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_until] = ACTIONS(3104),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_when] = ACTIONS(3104),
    [anon_sym_EQ_GT] = ACTIONS(3104),
    [anon_sym_DOT_DOT] = ACTIONS(3106),
    [anon_sym_CARET] = ACTIONS(3106),
    [anon_sym_elsif] = ACTIONS(3104),
    [anon_sym_else] = ACTIONS(3104),
    [anon_sym_then] = ACTIONS(3104),
    [anon_sym_ensure] = ACTIONS(3104),
    [anon_sym_COLON_COLON2] = ACTIONS(3104),
    [anon_sym_AMP_DOT] = ACTIONS(3104),
    [anon_sym_PLUS_EQ] = ACTIONS(3110),
    [anon_sym_DASH_EQ] = ACTIONS(3110),
    [anon_sym_STAR_EQ] = ACTIONS(3110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3110),
    [anon_sym_SLASH_EQ] = ACTIONS(3110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3110),
    [anon_sym_PIPE_EQ] = ACTIONS(3110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3110),
    [anon_sym_AMP_EQ] = ACTIONS(3110),
    [anon_sym_PERCENT_EQ] = ACTIONS(3110),
    [anon_sym_GT_GT_EQ] = ACTIONS(3110),
    [anon_sym_LT_LT_EQ] = ACTIONS(3110),
    [anon_sym_CARET_EQ] = ACTIONS(3110),
    [anon_sym_QMARK] = ACTIONS(3104),
    [anon_sym_and] = ACTIONS(3104),
    [anon_sym_or] = ACTIONS(3104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(3106),
    [anon_sym_LT_EQ] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_EQ] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_SLASH] = ACTIONS(3106),
    [anon_sym_PERCENT] = ACTIONS(3106),
    [anon_sym_EQ_EQ] = ACTIONS(3106),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3104),
    [anon_sym_LT_EQ_GT] = ACTIONS(3104),
    [anon_sym_EQ_TILDE] = ACTIONS(3104),
    [anon_sym_BANG_TILDE] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3104),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3104),
    [sym__binary_star] = ACTIONS(3104),
    [sym__binary_star_star] = ACTIONS(3104),
    [sym__element_reference_bracket] = ACTIONS(3104),
  },
  [2119] = {
    [sym_heredoc_body] = STATE(2119),
    [aux_sym__mlhs_repeat1] = STATE(5296),
    [anon_sym_LBRACE] = ACTIONS(3104),
    [anon_sym_RBRACE] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(3104),
    [anon_sym_DOT] = ACTIONS(3106),
    [anon_sym_end] = ACTIONS(3104),
    [anon_sym_rescue] = ACTIONS(3104),
    [anon_sym_EQ] = ACTIONS(3112),
    [anon_sym_COMMA] = ACTIONS(3104),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3106),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_unless] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_until] = ACTIONS(3104),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_when] = ACTIONS(3104),
    [anon_sym_EQ_GT] = ACTIONS(3104),
    [anon_sym_DOT_DOT] = ACTIONS(3106),
    [anon_sym_CARET] = ACTIONS(3106),
    [anon_sym_elsif] = ACTIONS(3104),
    [anon_sym_else] = ACTIONS(3104),
    [anon_sym_then] = ACTIONS(3104),
    [anon_sym_ensure] = ACTIONS(3104),
    [anon_sym_COLON_COLON2] = ACTIONS(3104),
    [anon_sym_AMP_DOT] = ACTIONS(3104),
    [anon_sym_PLUS_EQ] = ACTIONS(3114),
    [anon_sym_DASH_EQ] = ACTIONS(3114),
    [anon_sym_STAR_EQ] = ACTIONS(3114),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3114),
    [anon_sym_SLASH_EQ] = ACTIONS(3114),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3114),
    [anon_sym_PIPE_EQ] = ACTIONS(3114),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3114),
    [anon_sym_AMP_EQ] = ACTIONS(3114),
    [anon_sym_PERCENT_EQ] = ACTIONS(3114),
    [anon_sym_GT_GT_EQ] = ACTIONS(3114),
    [anon_sym_LT_LT_EQ] = ACTIONS(3114),
    [anon_sym_CARET_EQ] = ACTIONS(3114),
    [anon_sym_QMARK] = ACTIONS(3104),
    [anon_sym_and] = ACTIONS(3104),
    [anon_sym_or] = ACTIONS(3104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(3106),
    [anon_sym_LT_EQ] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_EQ] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_SLASH] = ACTIONS(3106),
    [anon_sym_PERCENT] = ACTIONS(3106),
    [anon_sym_EQ_EQ] = ACTIONS(3106),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3104),
    [anon_sym_LT_EQ_GT] = ACTIONS(3104),
    [anon_sym_EQ_TILDE] = ACTIONS(3104),
    [anon_sym_BANG_TILDE] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3104),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3104),
    [sym__binary_star] = ACTIONS(3104),
    [sym__binary_star_star] = ACTIONS(3104),
    [sym__element_reference_bracket] = ACTIONS(3104),
  },
  [2120] = {
    [sym_heredoc_body] = STATE(2120),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_BEGIN] = ACTIONS(3116),
    [anon_sym_LBRACE] = ACTIONS(3118),
    [anon_sym_END] = ACTIONS(3116),
    [anon_sym_def] = ACTIONS(3116),
    [anon_sym_LPAREN] = ACTIONS(3118),
    [anon_sym_COLON_COLON] = ACTIONS(3118),
    [anon_sym_end] = ACTIONS(3116),
    [anon_sym_rescue] = ACTIONS(3116),
    [anon_sym_SEMI] = ACTIONS(3118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3118),
    [anon_sym_STAR] = ACTIONS(3118),
    [anon_sym_nil] = ACTIONS(3116),
    [anon_sym_class] = ACTIONS(3116),
    [anon_sym_module] = ACTIONS(3116),
    [anon_sym_return] = ACTIONS(3116),
    [anon_sym_yield] = ACTIONS(3116),
    [anon_sym_break] = ACTIONS(3116),
    [anon_sym_next] = ACTIONS(3116),
    [anon_sym_redo] = ACTIONS(3116),
    [anon_sym_retry] = ACTIONS(3116),
    [anon_sym_if] = ACTIONS(3116),
    [anon_sym_unless] = ACTIONS(3116),
    [anon_sym_while] = ACTIONS(3116),
    [anon_sym_until] = ACTIONS(3116),
    [anon_sym_for] = ACTIONS(3116),
    [anon_sym_case] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(3118),
    [anon_sym_DOT_DOT] = ACTIONS(3116),
    [anon_sym_else] = ACTIONS(3116),
    [anon_sym_begin] = ACTIONS(3116),
    [anon_sym_ensure] = ACTIONS(3116),
    [anon_sym_PLUS] = ACTIONS(3118),
    [anon_sym_defined_QMARK] = ACTIONS(3118),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3118),
    [anon_sym_undef] = ACTIONS(3116),
    [anon_sym_alias] = ACTIONS(3116),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3116),
    [sym_float] = ACTIONS(3116),
    [sym_super] = ACTIONS(3116),
    [sym_self] = ACTIONS(3116),
    [sym_true] = ACTIONS(3116),
    [sym_false] = ACTIONS(3116),
    [sym_constant] = ACTIONS(3116),
    [aux_sym_constant_suffix_token1] = ACTIONS(3118),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3116),
    [sym_instance_variable] = ACTIONS(3118),
    [sym_class_variable] = ACTIONS(3118),
    [sym_global_variable] = ACTIONS(3118),
    [sym_character] = ACTIONS(3118),
    [anon_sym_DASH_GT] = ACTIONS(3118),
    [sym__line_break] = ACTIONS(3118),
    [sym_simple_symbol] = ACTIONS(3118),
    [sym__string_start] = ACTIONS(3118),
    [sym__symbol_start] = ACTIONS(3118),
    [sym__subshell_start] = ACTIONS(3118),
    [sym__regex_start] = ACTIONS(3118),
    [sym__string_array_start] = ACTIONS(3118),
    [sym__symbol_array_start] = ACTIONS(3118),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3118),
    [sym__unary_minus] = ACTIONS(3118),
    [sym__unary_minus_num] = ACTIONS(3118),
    [sym__binary_minus] = ACTIONS(3118),
    [sym__identifier_suffix] = ACTIONS(3118),
    [sym__constant_suffix] = ACTIONS(3118),
  },
  [2121] = {
    [sym_heredoc_body] = STATE(2121),
    [sym_identifier] = ACTIONS(3120),
    [anon_sym_BEGIN] = ACTIONS(3120),
    [anon_sym_LBRACE] = ACTIONS(3122),
    [anon_sym_END] = ACTIONS(3120),
    [anon_sym_def] = ACTIONS(3120),
    [anon_sym_LPAREN] = ACTIONS(3122),
    [anon_sym_COLON_COLON] = ACTIONS(3122),
    [anon_sym_end] = ACTIONS(3120),
    [anon_sym_rescue] = ACTIONS(3120),
    [anon_sym_SEMI] = ACTIONS(3122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3122),
    [anon_sym_nil] = ACTIONS(3120),
    [anon_sym_class] = ACTIONS(3120),
    [anon_sym_module] = ACTIONS(3120),
    [anon_sym_return] = ACTIONS(3120),
    [anon_sym_yield] = ACTIONS(3120),
    [anon_sym_break] = ACTIONS(3120),
    [anon_sym_next] = ACTIONS(3120),
    [anon_sym_redo] = ACTIONS(3120),
    [anon_sym_retry] = ACTIONS(3120),
    [anon_sym_if] = ACTIONS(3120),
    [anon_sym_unless] = ACTIONS(3120),
    [anon_sym_while] = ACTIONS(3120),
    [anon_sym_until] = ACTIONS(3120),
    [anon_sym_for] = ACTIONS(3120),
    [anon_sym_case] = ACTIONS(3120),
    [anon_sym_LBRACK] = ACTIONS(3122),
    [anon_sym_DOT_DOT] = ACTIONS(3120),
    [anon_sym_else] = ACTIONS(3120),
    [anon_sym_begin] = ACTIONS(3120),
    [anon_sym_ensure] = ACTIONS(3120),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_defined_QMARK] = ACTIONS(3122),
    [anon_sym_not] = ACTIONS(3120),
    [anon_sym_BANG] = ACTIONS(3122),
    [anon_sym_TILDE] = ACTIONS(3122),
    [anon_sym_undef] = ACTIONS(3120),
    [anon_sym_alias] = ACTIONS(3120),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3120),
    [sym_float] = ACTIONS(3120),
    [sym_super] = ACTIONS(3120),
    [sym_self] = ACTIONS(3120),
    [sym_true] = ACTIONS(3120),
    [sym_false] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3120),
    [aux_sym_constant_suffix_token1] = ACTIONS(3122),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3120),
    [sym_instance_variable] = ACTIONS(3122),
    [sym_class_variable] = ACTIONS(3122),
    [sym_global_variable] = ACTIONS(3122),
    [sym_character] = ACTIONS(3122),
    [anon_sym_DASH_GT] = ACTIONS(3122),
    [sym__line_break] = ACTIONS(3122),
    [sym_simple_symbol] = ACTIONS(3122),
    [sym__string_start] = ACTIONS(3122),
    [sym__symbol_start] = ACTIONS(3122),
    [sym__subshell_start] = ACTIONS(3122),
    [sym__regex_start] = ACTIONS(3122),
    [sym__string_array_start] = ACTIONS(3122),
    [sym__symbol_array_start] = ACTIONS(3122),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3122),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__unary_minus_num] = ACTIONS(3122),
    [sym__binary_minus] = ACTIONS(3122),
    [sym__identifier_suffix] = ACTIONS(3122),
    [sym__constant_suffix] = ACTIONS(3122),
  },
  [2122] = {
    [sym_heredoc_body] = STATE(2122),
    [sym_identifier] = ACTIONS(3124),
    [anon_sym_BEGIN] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(3126),
    [anon_sym_END] = ACTIONS(3124),
    [anon_sym_def] = ACTIONS(3124),
    [anon_sym_LPAREN] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3126),
    [anon_sym_end] = ACTIONS(3124),
    [anon_sym_rescue] = ACTIONS(3124),
    [anon_sym_SEMI] = ACTIONS(3126),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(3124),
    [anon_sym_class] = ACTIONS(3124),
    [anon_sym_module] = ACTIONS(3124),
    [anon_sym_return] = ACTIONS(3124),
    [anon_sym_yield] = ACTIONS(3124),
    [anon_sym_break] = ACTIONS(3124),
    [anon_sym_next] = ACTIONS(3124),
    [anon_sym_redo] = ACTIONS(3124),
    [anon_sym_retry] = ACTIONS(3124),
    [anon_sym_if] = ACTIONS(3124),
    [anon_sym_unless] = ACTIONS(3124),
    [anon_sym_while] = ACTIONS(3124),
    [anon_sym_until] = ACTIONS(3124),
    [anon_sym_for] = ACTIONS(3124),
    [anon_sym_case] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_DOT_DOT] = ACTIONS(3124),
    [anon_sym_else] = ACTIONS(3124),
    [anon_sym_begin] = ACTIONS(3124),
    [anon_sym_ensure] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3126),
    [anon_sym_defined_QMARK] = ACTIONS(3126),
    [anon_sym_not] = ACTIONS(3124),
    [anon_sym_BANG] = ACTIONS(3126),
    [anon_sym_TILDE] = ACTIONS(3126),
    [anon_sym_undef] = ACTIONS(3124),
    [anon_sym_alias] = ACTIONS(3124),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3124),
    [sym_float] = ACTIONS(3124),
    [sym_super] = ACTIONS(3124),
    [sym_self] = ACTIONS(3124),
    [sym_true] = ACTIONS(3124),
    [sym_false] = ACTIONS(3124),
    [sym_constant] = ACTIONS(3124),
    [aux_sym_constant_suffix_token1] = ACTIONS(3126),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3124),
    [sym_instance_variable] = ACTIONS(3126),
    [sym_class_variable] = ACTIONS(3126),
    [sym_global_variable] = ACTIONS(3126),
    [sym_character] = ACTIONS(3126),
    [anon_sym_DASH_GT] = ACTIONS(3126),
    [sym__line_break] = ACTIONS(3126),
    [sym_simple_symbol] = ACTIONS(3126),
    [sym__string_start] = ACTIONS(3126),
    [sym__symbol_start] = ACTIONS(3126),
    [sym__subshell_start] = ACTIONS(3126),
    [sym__regex_start] = ACTIONS(3126),
    [sym__string_array_start] = ACTIONS(3126),
    [sym__symbol_array_start] = ACTIONS(3126),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3126),
    [sym__unary_minus] = ACTIONS(3126),
    [sym__unary_minus_num] = ACTIONS(3126),
    [sym__binary_minus] = ACTIONS(3126),
    [sym__identifier_suffix] = ACTIONS(3126),
    [sym__constant_suffix] = ACTIONS(3126),
  },
  [2123] = {
    [sym_heredoc_body] = STATE(2123),
    [sym_identifier] = ACTIONS(3128),
    [anon_sym_BEGIN] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_END] = ACTIONS(3128),
    [anon_sym_def] = ACTIONS(3128),
    [anon_sym_LPAREN] = ACTIONS(3130),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_end] = ACTIONS(3128),
    [anon_sym_rescue] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3130),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_nil] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_module] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_next] = ACTIONS(3128),
    [anon_sym_redo] = ACTIONS(3128),
    [anon_sym_retry] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_unless] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_until] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3130),
    [anon_sym_DOT_DOT] = ACTIONS(3128),
    [anon_sym_else] = ACTIONS(3128),
    [anon_sym_begin] = ACTIONS(3128),
    [anon_sym_ensure] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3130),
    [anon_sym_defined_QMARK] = ACTIONS(3130),
    [anon_sym_not] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_undef] = ACTIONS(3128),
    [anon_sym_alias] = ACTIONS(3128),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3128),
    [sym_float] = ACTIONS(3128),
    [sym_super] = ACTIONS(3128),
    [sym_self] = ACTIONS(3128),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [sym_constant] = ACTIONS(3128),
    [aux_sym_constant_suffix_token1] = ACTIONS(3130),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3128),
    [sym_instance_variable] = ACTIONS(3130),
    [sym_class_variable] = ACTIONS(3130),
    [sym_global_variable] = ACTIONS(3130),
    [sym_character] = ACTIONS(3130),
    [anon_sym_DASH_GT] = ACTIONS(3130),
    [sym__line_break] = ACTIONS(3130),
    [sym_simple_symbol] = ACTIONS(3130),
    [sym__string_start] = ACTIONS(3130),
    [sym__symbol_start] = ACTIONS(3130),
    [sym__subshell_start] = ACTIONS(3130),
    [sym__regex_start] = ACTIONS(3130),
    [sym__string_array_start] = ACTIONS(3130),
    [sym__symbol_array_start] = ACTIONS(3130),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3130),
    [sym__unary_minus] = ACTIONS(3130),
    [sym__unary_minus_num] = ACTIONS(3130),
    [sym__binary_minus] = ACTIONS(3130),
    [sym__identifier_suffix] = ACTIONS(3130),
    [sym__constant_suffix] = ACTIONS(3130),
  },
  [2124] = {
    [sym_heredoc_body] = STATE(2124),
    [sym_identifier] = ACTIONS(3132),
    [anon_sym_BEGIN] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3134),
    [anon_sym_END] = ACTIONS(3132),
    [anon_sym_def] = ACTIONS(3132),
    [anon_sym_LPAREN] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3134),
    [anon_sym_end] = ACTIONS(3132),
    [anon_sym_rescue] = ACTIONS(3132),
    [anon_sym_SEMI] = ACTIONS(3134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_nil] = ACTIONS(3132),
    [anon_sym_class] = ACTIONS(3132),
    [anon_sym_module] = ACTIONS(3132),
    [anon_sym_return] = ACTIONS(3132),
    [anon_sym_yield] = ACTIONS(3132),
    [anon_sym_break] = ACTIONS(3132),
    [anon_sym_next] = ACTIONS(3132),
    [anon_sym_redo] = ACTIONS(3132),
    [anon_sym_retry] = ACTIONS(3132),
    [anon_sym_if] = ACTIONS(3132),
    [anon_sym_unless] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3132),
    [anon_sym_until] = ACTIONS(3132),
    [anon_sym_for] = ACTIONS(3132),
    [anon_sym_case] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_DOT_DOT] = ACTIONS(3132),
    [anon_sym_else] = ACTIONS(3132),
    [anon_sym_begin] = ACTIONS(3132),
    [anon_sym_ensure] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3134),
    [anon_sym_undef] = ACTIONS(3132),
    [anon_sym_alias] = ACTIONS(3132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3132),
    [sym_float] = ACTIONS(3132),
    [sym_super] = ACTIONS(3132),
    [sym_self] = ACTIONS(3132),
    [sym_true] = ACTIONS(3132),
    [sym_false] = ACTIONS(3132),
    [sym_constant] = ACTIONS(3132),
    [aux_sym_constant_suffix_token1] = ACTIONS(3134),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3132),
    [sym_instance_variable] = ACTIONS(3134),
    [sym_class_variable] = ACTIONS(3134),
    [sym_global_variable] = ACTIONS(3134),
    [sym_character] = ACTIONS(3134),
    [anon_sym_DASH_GT] = ACTIONS(3134),
    [sym__line_break] = ACTIONS(3134),
    [sym_simple_symbol] = ACTIONS(3134),
    [sym__string_start] = ACTIONS(3134),
    [sym__symbol_start] = ACTIONS(3134),
    [sym__subshell_start] = ACTIONS(3134),
    [sym__regex_start] = ACTIONS(3134),
    [sym__string_array_start] = ACTIONS(3134),
    [sym__symbol_array_start] = ACTIONS(3134),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3134),
    [sym__unary_minus] = ACTIONS(3134),
    [sym__unary_minus_num] = ACTIONS(3134),
    [sym__binary_minus] = ACTIONS(3134),
    [sym__identifier_suffix] = ACTIONS(3134),
    [sym__constant_suffix] = ACTIONS(3134),
  },
  [2125] = {
    [sym_heredoc_body] = STATE(2125),
    [sym_identifier] = ACTIONS(3136),
    [anon_sym_BEGIN] = ACTIONS(3136),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_END] = ACTIONS(3136),
    [anon_sym_def] = ACTIONS(3136),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_COLON_COLON] = ACTIONS(3138),
    [anon_sym_end] = ACTIONS(3136),
    [anon_sym_rescue] = ACTIONS(3136),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3138),
    [anon_sym_STAR] = ACTIONS(3138),
    [anon_sym_nil] = ACTIONS(3136),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_module] = ACTIONS(3136),
    [anon_sym_return] = ACTIONS(3136),
    [anon_sym_yield] = ACTIONS(3136),
    [anon_sym_break] = ACTIONS(3136),
    [anon_sym_next] = ACTIONS(3136),
    [anon_sym_redo] = ACTIONS(3136),
    [anon_sym_retry] = ACTIONS(3136),
    [anon_sym_if] = ACTIONS(3136),
    [anon_sym_unless] = ACTIONS(3136),
    [anon_sym_while] = ACTIONS(3136),
    [anon_sym_until] = ACTIONS(3136),
    [anon_sym_for] = ACTIONS(3136),
    [anon_sym_case] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_DOT_DOT] = ACTIONS(3136),
    [anon_sym_else] = ACTIONS(3136),
    [anon_sym_begin] = ACTIONS(3136),
    [anon_sym_ensure] = ACTIONS(3136),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_defined_QMARK] = ACTIONS(3138),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_undef] = ACTIONS(3136),
    [anon_sym_alias] = ACTIONS(3136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3136),
    [sym_float] = ACTIONS(3136),
    [sym_super] = ACTIONS(3136),
    [sym_self] = ACTIONS(3136),
    [sym_true] = ACTIONS(3136),
    [sym_false] = ACTIONS(3136),
    [sym_constant] = ACTIONS(3136),
    [aux_sym_constant_suffix_token1] = ACTIONS(3138),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3136),
    [sym_instance_variable] = ACTIONS(3138),
    [sym_class_variable] = ACTIONS(3138),
    [sym_global_variable] = ACTIONS(3138),
    [sym_character] = ACTIONS(3138),
    [anon_sym_DASH_GT] = ACTIONS(3138),
    [sym__line_break] = ACTIONS(3138),
    [sym_simple_symbol] = ACTIONS(3138),
    [sym__string_start] = ACTIONS(3138),
    [sym__symbol_start] = ACTIONS(3138),
    [sym__subshell_start] = ACTIONS(3138),
    [sym__regex_start] = ACTIONS(3138),
    [sym__string_array_start] = ACTIONS(3138),
    [sym__symbol_array_start] = ACTIONS(3138),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3138),
    [sym__unary_minus] = ACTIONS(3138),
    [sym__unary_minus_num] = ACTIONS(3138),
    [sym__binary_minus] = ACTIONS(3138),
    [sym__identifier_suffix] = ACTIONS(3138),
    [sym__constant_suffix] = ACTIONS(3138),
  },
  [2126] = {
    [sym_heredoc_body] = STATE(2126),
    [sym_identifier] = ACTIONS(3140),
    [anon_sym_BEGIN] = ACTIONS(3140),
    [anon_sym_LBRACE] = ACTIONS(3142),
    [anon_sym_END] = ACTIONS(3140),
    [anon_sym_def] = ACTIONS(3140),
    [anon_sym_LPAREN] = ACTIONS(3142),
    [anon_sym_COLON_COLON] = ACTIONS(3142),
    [anon_sym_end] = ACTIONS(3140),
    [anon_sym_rescue] = ACTIONS(3140),
    [anon_sym_SEMI] = ACTIONS(3142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3142),
    [anon_sym_STAR] = ACTIONS(3142),
    [anon_sym_nil] = ACTIONS(3140),
    [anon_sym_class] = ACTIONS(3140),
    [anon_sym_module] = ACTIONS(3140),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_yield] = ACTIONS(3140),
    [anon_sym_break] = ACTIONS(3140),
    [anon_sym_next] = ACTIONS(3140),
    [anon_sym_redo] = ACTIONS(3140),
    [anon_sym_retry] = ACTIONS(3140),
    [anon_sym_if] = ACTIONS(3140),
    [anon_sym_unless] = ACTIONS(3140),
    [anon_sym_while] = ACTIONS(3140),
    [anon_sym_until] = ACTIONS(3140),
    [anon_sym_for] = ACTIONS(3140),
    [anon_sym_case] = ACTIONS(3140),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_DOT_DOT] = ACTIONS(3140),
    [anon_sym_else] = ACTIONS(3140),
    [anon_sym_begin] = ACTIONS(3140),
    [anon_sym_ensure] = ACTIONS(3140),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_defined_QMARK] = ACTIONS(3142),
    [anon_sym_not] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3142),
    [anon_sym_TILDE] = ACTIONS(3142),
    [anon_sym_undef] = ACTIONS(3140),
    [anon_sym_alias] = ACTIONS(3140),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3140),
    [sym_float] = ACTIONS(3140),
    [sym_super] = ACTIONS(3140),
    [sym_self] = ACTIONS(3140),
    [sym_true] = ACTIONS(3140),
    [sym_false] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3140),
    [aux_sym_constant_suffix_token1] = ACTIONS(3142),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3140),
    [sym_instance_variable] = ACTIONS(3142),
    [sym_class_variable] = ACTIONS(3142),
    [sym_global_variable] = ACTIONS(3142),
    [sym_character] = ACTIONS(3142),
    [anon_sym_DASH_GT] = ACTIONS(3142),
    [sym__line_break] = ACTIONS(3142),
    [sym_simple_symbol] = ACTIONS(3142),
    [sym__string_start] = ACTIONS(3142),
    [sym__symbol_start] = ACTIONS(3142),
    [sym__subshell_start] = ACTIONS(3142),
    [sym__regex_start] = ACTIONS(3142),
    [sym__string_array_start] = ACTIONS(3142),
    [sym__symbol_array_start] = ACTIONS(3142),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3142),
    [sym__unary_minus] = ACTIONS(3142),
    [sym__unary_minus_num] = ACTIONS(3142),
    [sym__binary_minus] = ACTIONS(3142),
    [sym__identifier_suffix] = ACTIONS(3142),
    [sym__constant_suffix] = ACTIONS(3142),
  },
  [2127] = {
    [sym_heredoc_body] = STATE(2127),
    [sym_identifier] = ACTIONS(3144),
    [anon_sym_BEGIN] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_END] = ACTIONS(3144),
    [anon_sym_def] = ACTIONS(3144),
    [anon_sym_LPAREN] = ACTIONS(3146),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_end] = ACTIONS(3144),
    [anon_sym_rescue] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3146),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_module] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_yield] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_next] = ACTIONS(3144),
    [anon_sym_redo] = ACTIONS(3144),
    [anon_sym_retry] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_unless] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_until] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_DOT_DOT] = ACTIONS(3144),
    [anon_sym_else] = ACTIONS(3144),
    [anon_sym_begin] = ACTIONS(3144),
    [anon_sym_ensure] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3146),
    [anon_sym_defined_QMARK] = ACTIONS(3146),
    [anon_sym_not] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_undef] = ACTIONS(3144),
    [anon_sym_alias] = ACTIONS(3144),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3144),
    [sym_float] = ACTIONS(3144),
    [sym_super] = ACTIONS(3144),
    [sym_self] = ACTIONS(3144),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [sym_constant] = ACTIONS(3144),
    [aux_sym_constant_suffix_token1] = ACTIONS(3146),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3144),
    [sym_instance_variable] = ACTIONS(3146),
    [sym_class_variable] = ACTIONS(3146),
    [sym_global_variable] = ACTIONS(3146),
    [sym_character] = ACTIONS(3146),
    [anon_sym_DASH_GT] = ACTIONS(3146),
    [sym__line_break] = ACTIONS(3146),
    [sym_simple_symbol] = ACTIONS(3146),
    [sym__string_start] = ACTIONS(3146),
    [sym__symbol_start] = ACTIONS(3146),
    [sym__subshell_start] = ACTIONS(3146),
    [sym__regex_start] = ACTIONS(3146),
    [sym__string_array_start] = ACTIONS(3146),
    [sym__symbol_array_start] = ACTIONS(3146),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3146),
    [sym__unary_minus] = ACTIONS(3146),
    [sym__unary_minus_num] = ACTIONS(3146),
    [sym__binary_minus] = ACTIONS(3146),
    [sym__identifier_suffix] = ACTIONS(3146),
    [sym__constant_suffix] = ACTIONS(3146),
  },
  [2128] = {
    [sym_heredoc_body] = STATE(2128),
    [aux_sym__mlhs_repeat1] = STATE(5296),
    [anon_sym_LBRACE] = ACTIONS(3104),
    [anon_sym_RBRACE] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(3104),
    [anon_sym_DOT] = ACTIONS(3106),
    [anon_sym_end] = ACTIONS(3104),
    [anon_sym_rescue] = ACTIONS(3104),
    [anon_sym_EQ] = ACTIONS(3148),
    [anon_sym_COMMA] = ACTIONS(3104),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3106),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_unless] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_until] = ACTIONS(3104),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_when] = ACTIONS(3104),
    [anon_sym_EQ_GT] = ACTIONS(3104),
    [anon_sym_DOT_DOT] = ACTIONS(3106),
    [anon_sym_CARET] = ACTIONS(3106),
    [anon_sym_elsif] = ACTIONS(3104),
    [anon_sym_else] = ACTIONS(3104),
    [anon_sym_then] = ACTIONS(3104),
    [anon_sym_ensure] = ACTIONS(3104),
    [anon_sym_COLON_COLON2] = ACTIONS(3104),
    [anon_sym_AMP_DOT] = ACTIONS(3104),
    [anon_sym_PLUS_EQ] = ACTIONS(3150),
    [anon_sym_DASH_EQ] = ACTIONS(3150),
    [anon_sym_STAR_EQ] = ACTIONS(3150),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3150),
    [anon_sym_SLASH_EQ] = ACTIONS(3150),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3150),
    [anon_sym_PIPE_EQ] = ACTIONS(3150),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3150),
    [anon_sym_AMP_EQ] = ACTIONS(3150),
    [anon_sym_PERCENT_EQ] = ACTIONS(3150),
    [anon_sym_GT_GT_EQ] = ACTIONS(3150),
    [anon_sym_LT_LT_EQ] = ACTIONS(3150),
    [anon_sym_CARET_EQ] = ACTIONS(3150),
    [anon_sym_QMARK] = ACTIONS(3104),
    [anon_sym_and] = ACTIONS(3104),
    [anon_sym_or] = ACTIONS(3104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(3106),
    [anon_sym_LT_EQ] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_EQ] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_SLASH] = ACTIONS(3106),
    [anon_sym_PERCENT] = ACTIONS(3106),
    [anon_sym_EQ_EQ] = ACTIONS(3106),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3104),
    [anon_sym_LT_EQ_GT] = ACTIONS(3104),
    [anon_sym_EQ_TILDE] = ACTIONS(3104),
    [anon_sym_BANG_TILDE] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3104),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3104),
    [sym__binary_star] = ACTIONS(3104),
    [sym__binary_star_star] = ACTIONS(3104),
    [sym__element_reference_bracket] = ACTIONS(3104),
  },
  [2129] = {
    [sym_heredoc_body] = STATE(2129),
    [sym_identifier] = ACTIONS(3152),
    [anon_sym_BEGIN] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_END] = ACTIONS(3152),
    [anon_sym_def] = ACTIONS(3152),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_end] = ACTIONS(3152),
    [anon_sym_rescue] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3154),
    [anon_sym_nil] = ACTIONS(3152),
    [anon_sym_class] = ACTIONS(3152),
    [anon_sym_module] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3152),
    [anon_sym_yield] = ACTIONS(3152),
    [anon_sym_break] = ACTIONS(3152),
    [anon_sym_next] = ACTIONS(3152),
    [anon_sym_redo] = ACTIONS(3152),
    [anon_sym_retry] = ACTIONS(3152),
    [anon_sym_if] = ACTIONS(3152),
    [anon_sym_unless] = ACTIONS(3152),
    [anon_sym_while] = ACTIONS(3152),
    [anon_sym_until] = ACTIONS(3152),
    [anon_sym_for] = ACTIONS(3152),
    [anon_sym_case] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_DOT_DOT] = ACTIONS(3152),
    [anon_sym_else] = ACTIONS(3152),
    [anon_sym_begin] = ACTIONS(3152),
    [anon_sym_ensure] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_defined_QMARK] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_undef] = ACTIONS(3152),
    [anon_sym_alias] = ACTIONS(3152),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3152),
    [sym_float] = ACTIONS(3152),
    [sym_super] = ACTIONS(3152),
    [sym_self] = ACTIONS(3152),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [sym_constant] = ACTIONS(3152),
    [aux_sym_constant_suffix_token1] = ACTIONS(3154),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3152),
    [sym_instance_variable] = ACTIONS(3154),
    [sym_class_variable] = ACTIONS(3154),
    [sym_global_variable] = ACTIONS(3154),
    [sym_character] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3154),
    [sym__line_break] = ACTIONS(3154),
    [sym_simple_symbol] = ACTIONS(3154),
    [sym__string_start] = ACTIONS(3154),
    [sym__symbol_start] = ACTIONS(3154),
    [sym__subshell_start] = ACTIONS(3154),
    [sym__regex_start] = ACTIONS(3154),
    [sym__string_array_start] = ACTIONS(3154),
    [sym__symbol_array_start] = ACTIONS(3154),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3154),
    [sym__unary_minus] = ACTIONS(3154),
    [sym__unary_minus_num] = ACTIONS(3154),
    [sym__binary_minus] = ACTIONS(3154),
    [sym__identifier_suffix] = ACTIONS(3154),
    [sym__constant_suffix] = ACTIONS(3154),
  },
  [2130] = {
    [sym_heredoc_body] = STATE(2130),
    [ts_builtin_sym_end] = ACTIONS(2954),
    [sym_identifier] = ACTIONS(1990),
    [aux_sym_program_token1] = ACTIONS(2954),
    [anon_sym___END__] = ACTIONS(1990),
    [anon_sym_BEGIN] = ACTIONS(1990),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_END] = ACTIONS(1990),
    [anon_sym_def] = ACTIONS(1990),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2954),
    [anon_sym_nil] = ACTIONS(1990),
    [anon_sym_class] = ACTIONS(1990),
    [anon_sym_module] = ACTIONS(1990),
    [anon_sym_return] = ACTIONS(1990),
    [anon_sym_yield] = ACTIONS(1990),
    [anon_sym_break] = ACTIONS(1990),
    [anon_sym_next] = ACTIONS(1990),
    [anon_sym_redo] = ACTIONS(1990),
    [anon_sym_retry] = ACTIONS(1990),
    [anon_sym_if] = ACTIONS(1990),
    [anon_sym_unless] = ACTIONS(1990),
    [anon_sym_while] = ACTIONS(1990),
    [anon_sym_until] = ACTIONS(1990),
    [anon_sym_for] = ACTIONS(1990),
    [anon_sym_case] = ACTIONS(1990),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_DOT_DOT] = ACTIONS(1990),
    [anon_sym_begin] = ACTIONS(1990),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_defined_QMARK] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(1990),
    [anon_sym_BANG] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2954),
    [anon_sym_undef] = ACTIONS(1990),
    [anon_sym_alias] = ACTIONS(1990),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(1990),
    [sym_float] = ACTIONS(1990),
    [sym_super] = ACTIONS(1990),
    [sym_self] = ACTIONS(1990),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_constant] = ACTIONS(1990),
    [aux_sym_constant_suffix_token1] = ACTIONS(2954),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1990),
    [sym_instance_variable] = ACTIONS(2954),
    [sym_class_variable] = ACTIONS(2954),
    [sym_global_variable] = ACTIONS(2954),
    [sym_character] = ACTIONS(2954),
    [anon_sym_DASH_GT] = ACTIONS(2954),
    [sym_simple_symbol] = ACTIONS(2954),
    [sym__string_start] = ACTIONS(2954),
    [sym__symbol_start] = ACTIONS(2954),
    [sym__subshell_start] = ACTIONS(2954),
    [sym__regex_start] = ACTIONS(2954),
    [sym__string_array_start] = ACTIONS(2954),
    [sym__symbol_array_start] = ACTIONS(2954),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2954),
    [sym__unary_minus] = ACTIONS(2954),
    [sym__unary_minus_num] = ACTIONS(2954),
    [sym__binary_minus] = ACTIONS(2954),
    [sym__identifier_suffix] = ACTIONS(2954),
    [sym__constant_suffix] = ACTIONS(2954),
  },
  [2131] = {
    [sym_heredoc_body] = STATE(2131),
    [aux_sym__mlhs_repeat1] = STATE(5296),
    [anon_sym_RBRACE] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(3104),
    [anon_sym_DOT] = ACTIONS(3106),
    [anon_sym_end] = ACTIONS(3104),
    [anon_sym_rescue] = ACTIONS(3104),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_COMMA] = ACTIONS(3104),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3106),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_unless] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_until] = ACTIONS(3104),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_when] = ACTIONS(3104),
    [anon_sym_EQ_GT] = ACTIONS(3104),
    [anon_sym_DOT_DOT] = ACTIONS(3106),
    [anon_sym_CARET] = ACTIONS(3106),
    [anon_sym_elsif] = ACTIONS(3104),
    [anon_sym_else] = ACTIONS(3104),
    [anon_sym_then] = ACTIONS(3104),
    [anon_sym_ensure] = ACTIONS(3104),
    [anon_sym_COLON_COLON2] = ACTIONS(3104),
    [anon_sym_AMP_DOT] = ACTIONS(3104),
    [anon_sym_PLUS_EQ] = ACTIONS(3158),
    [anon_sym_DASH_EQ] = ACTIONS(3158),
    [anon_sym_STAR_EQ] = ACTIONS(3158),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3158),
    [anon_sym_SLASH_EQ] = ACTIONS(3158),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3158),
    [anon_sym_PIPE_EQ] = ACTIONS(3158),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3158),
    [anon_sym_AMP_EQ] = ACTIONS(3158),
    [anon_sym_PERCENT_EQ] = ACTIONS(3158),
    [anon_sym_GT_GT_EQ] = ACTIONS(3158),
    [anon_sym_LT_LT_EQ] = ACTIONS(3158),
    [anon_sym_CARET_EQ] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3104),
    [anon_sym_and] = ACTIONS(3104),
    [anon_sym_or] = ACTIONS(3104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(3106),
    [anon_sym_LT_EQ] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_EQ] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_SLASH] = ACTIONS(3106),
    [anon_sym_PERCENT] = ACTIONS(3106),
    [anon_sym_EQ_EQ] = ACTIONS(3106),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3104),
    [anon_sym_LT_EQ_GT] = ACTIONS(3104),
    [anon_sym_EQ_TILDE] = ACTIONS(3104),
    [anon_sym_BANG_TILDE] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3104),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3104),
    [sym__binary_star] = ACTIONS(3104),
    [sym__binary_star_star] = ACTIONS(3104),
    [sym__element_reference_bracket] = ACTIONS(3104),
  },
  [2132] = {
    [sym_splat_parameter] = STATE(4949),
    [sym__pattern_expr] = STATE(4933),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4811),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4754),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_string] = STATE(4702),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2132),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DOT_DOT] = ACTIONS(2908),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2910),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2912),
    [sym_float] = ACTIONS(2912),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2910),
  },
  [2133] = {
    [sym_heredoc_body] = STATE(2133),
    [ts_builtin_sym_end] = ACTIONS(2982),
    [sym_identifier] = ACTIONS(2980),
    [aux_sym_program_token1] = ACTIONS(2982),
    [anon_sym___END__] = ACTIONS(2980),
    [anon_sym_BEGIN] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2982),
    [anon_sym_END] = ACTIONS(2980),
    [anon_sym_def] = ACTIONS(2980),
    [anon_sym_LPAREN] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2982),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_nil] = ACTIONS(2980),
    [anon_sym_class] = ACTIONS(2980),
    [anon_sym_module] = ACTIONS(2980),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2980),
    [anon_sym_break] = ACTIONS(2980),
    [anon_sym_next] = ACTIONS(2980),
    [anon_sym_redo] = ACTIONS(2980),
    [anon_sym_retry] = ACTIONS(2980),
    [anon_sym_if] = ACTIONS(2980),
    [anon_sym_unless] = ACTIONS(2980),
    [anon_sym_while] = ACTIONS(2980),
    [anon_sym_until] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2980),
    [anon_sym_case] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_DOT_DOT] = ACTIONS(2980),
    [anon_sym_begin] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_defined_QMARK] = ACTIONS(2982),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_BANG] = ACTIONS(2982),
    [anon_sym_TILDE] = ACTIONS(2982),
    [anon_sym_undef] = ACTIONS(2980),
    [anon_sym_alias] = ACTIONS(2980),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2980),
    [sym_float] = ACTIONS(2980),
    [sym_super] = ACTIONS(2980),
    [sym_self] = ACTIONS(2980),
    [sym_true] = ACTIONS(2980),
    [sym_false] = ACTIONS(2980),
    [sym_constant] = ACTIONS(2980),
    [aux_sym_constant_suffix_token1] = ACTIONS(2982),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2980),
    [sym_instance_variable] = ACTIONS(2982),
    [sym_class_variable] = ACTIONS(2982),
    [sym_global_variable] = ACTIONS(2982),
    [sym_character] = ACTIONS(2982),
    [anon_sym_DASH_GT] = ACTIONS(2982),
    [sym_simple_symbol] = ACTIONS(2982),
    [sym__string_start] = ACTIONS(2982),
    [sym__symbol_start] = ACTIONS(2982),
    [sym__subshell_start] = ACTIONS(2982),
    [sym__regex_start] = ACTIONS(2982),
    [sym__string_array_start] = ACTIONS(2982),
    [sym__symbol_array_start] = ACTIONS(2982),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2982),
    [sym__unary_minus] = ACTIONS(2982),
    [sym__unary_minus_num] = ACTIONS(2982),
    [sym__binary_minus] = ACTIONS(2982),
    [sym__identifier_suffix] = ACTIONS(2982),
    [sym__constant_suffix] = ACTIONS(2982),
  },
  [2134] = {
    [sym_heredoc_body] = STATE(2134),
    [aux_sym__mlhs_repeat1] = STATE(5296),
    [anon_sym_RBRACE] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(3104),
    [anon_sym_DOT] = ACTIONS(3106),
    [anon_sym_end] = ACTIONS(3104),
    [anon_sym_rescue] = ACTIONS(3104),
    [anon_sym_EQ] = ACTIONS(3160),
    [anon_sym_COMMA] = ACTIONS(3162),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3106),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_unless] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_until] = ACTIONS(3104),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_when] = ACTIONS(3104),
    [anon_sym_EQ_GT] = ACTIONS(3104),
    [anon_sym_DOT_DOT] = ACTIONS(3106),
    [anon_sym_CARET] = ACTIONS(3106),
    [anon_sym_elsif] = ACTIONS(3104),
    [anon_sym_else] = ACTIONS(3104),
    [anon_sym_then] = ACTIONS(3104),
    [anon_sym_ensure] = ACTIONS(3104),
    [anon_sym_COLON_COLON2] = ACTIONS(3104),
    [anon_sym_AMP_DOT] = ACTIONS(3104),
    [anon_sym_PLUS_EQ] = ACTIONS(3164),
    [anon_sym_DASH_EQ] = ACTIONS(3164),
    [anon_sym_STAR_EQ] = ACTIONS(3164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3164),
    [anon_sym_SLASH_EQ] = ACTIONS(3164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3164),
    [anon_sym_PIPE_EQ] = ACTIONS(3164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3164),
    [anon_sym_AMP_EQ] = ACTIONS(3164),
    [anon_sym_PERCENT_EQ] = ACTIONS(3164),
    [anon_sym_GT_GT_EQ] = ACTIONS(3164),
    [anon_sym_LT_LT_EQ] = ACTIONS(3164),
    [anon_sym_CARET_EQ] = ACTIONS(3164),
    [anon_sym_QMARK] = ACTIONS(3104),
    [anon_sym_and] = ACTIONS(3104),
    [anon_sym_or] = ACTIONS(3104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(3106),
    [anon_sym_LT_EQ] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_EQ] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_SLASH] = ACTIONS(3106),
    [anon_sym_PERCENT] = ACTIONS(3106),
    [anon_sym_EQ_EQ] = ACTIONS(3106),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3104),
    [anon_sym_LT_EQ_GT] = ACTIONS(3104),
    [anon_sym_EQ_TILDE] = ACTIONS(3104),
    [anon_sym_BANG_TILDE] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3104),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3104),
    [sym__binary_star] = ACTIONS(3104),
    [sym__binary_star_star] = ACTIONS(3104),
    [sym__element_reference_bracket] = ACTIONS(3104),
  },
  [2135] = {
    [sym_splat_parameter] = STATE(4949),
    [sym__pattern_expr] = STATE(4933),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_string] = STATE(4702),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2135),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2136] = {
    [sym_splat_parameter] = STATE(4501),
    [sym__pattern_expr] = STATE(4465),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym_find_pattern] = STATE(4459),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4505),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4471),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2136),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2814),
    [anon_sym_STAR] = ACTIONS(2816),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2822),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2137] = {
    [sym_splat_parameter] = STATE(4501),
    [sym__pattern_expr] = STATE(4465),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym_find_pattern] = STATE(4459),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4590),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4585),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2137),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2940),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1718),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2944),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2138] = {
    [sym_splat_parameter] = STATE(4501),
    [sym__pattern_expr] = STATE(4465),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym_find_pattern] = STATE(4459),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4698),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4675),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2138),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2816),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
  },
  [2139] = {
    [sym_heredoc_body] = STATE(2139),
    [aux_sym__mlhs_repeat1] = STATE(5296),
    [anon_sym_RBRACE] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(3104),
    [anon_sym_DOT] = ACTIONS(3106),
    [anon_sym_end] = ACTIONS(3104),
    [anon_sym_rescue] = ACTIONS(3104),
    [anon_sym_EQ] = ACTIONS(3166),
    [anon_sym_COMMA] = ACTIONS(3104),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3106),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_unless] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_until] = ACTIONS(3104),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_when] = ACTIONS(3104),
    [anon_sym_EQ_GT] = ACTIONS(3104),
    [anon_sym_DOT_DOT] = ACTIONS(3106),
    [anon_sym_CARET] = ACTIONS(3106),
    [anon_sym_elsif] = ACTIONS(3104),
    [anon_sym_else] = ACTIONS(3104),
    [anon_sym_then] = ACTIONS(3104),
    [anon_sym_ensure] = ACTIONS(3104),
    [anon_sym_COLON_COLON2] = ACTIONS(3104),
    [anon_sym_AMP_DOT] = ACTIONS(3104),
    [anon_sym_PLUS_EQ] = ACTIONS(3168),
    [anon_sym_DASH_EQ] = ACTIONS(3168),
    [anon_sym_STAR_EQ] = ACTIONS(3168),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3168),
    [anon_sym_SLASH_EQ] = ACTIONS(3168),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3168),
    [anon_sym_PIPE_EQ] = ACTIONS(3168),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3168),
    [anon_sym_AMP_EQ] = ACTIONS(3168),
    [anon_sym_PERCENT_EQ] = ACTIONS(3168),
    [anon_sym_GT_GT_EQ] = ACTIONS(3168),
    [anon_sym_LT_LT_EQ] = ACTIONS(3168),
    [anon_sym_CARET_EQ] = ACTIONS(3168),
    [anon_sym_QMARK] = ACTIONS(3104),
    [anon_sym_and] = ACTIONS(3104),
    [anon_sym_or] = ACTIONS(3104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(3106),
    [anon_sym_LT_EQ] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_EQ] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_SLASH] = ACTIONS(3106),
    [anon_sym_PERCENT] = ACTIONS(3106),
    [anon_sym_EQ_EQ] = ACTIONS(3106),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3104),
    [anon_sym_LT_EQ_GT] = ACTIONS(3104),
    [anon_sym_EQ_TILDE] = ACTIONS(3104),
    [anon_sym_BANG_TILDE] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3104),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3104),
    [sym__binary_star] = ACTIONS(3104),
    [sym__binary_star_star] = ACTIONS(3104),
    [sym__element_reference_bracket] = ACTIONS(3104),
  },
  [2140] = {
    [sym_heredoc_body] = STATE(2140),
    [ts_builtin_sym_end] = ACTIONS(2990),
    [sym_identifier] = ACTIONS(2988),
    [aux_sym_program_token1] = ACTIONS(2990),
    [anon_sym___END__] = ACTIONS(2988),
    [anon_sym_BEGIN] = ACTIONS(2988),
    [anon_sym_LBRACE] = ACTIONS(2990),
    [anon_sym_END] = ACTIONS(2988),
    [anon_sym_def] = ACTIONS(2988),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_COLON_COLON] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2990),
    [anon_sym_STAR] = ACTIONS(2990),
    [anon_sym_nil] = ACTIONS(2988),
    [anon_sym_class] = ACTIONS(2988),
    [anon_sym_module] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_break] = ACTIONS(2988),
    [anon_sym_next] = ACTIONS(2988),
    [anon_sym_redo] = ACTIONS(2988),
    [anon_sym_retry] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_unless] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_until] = ACTIONS(2988),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_case] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_DOT_DOT] = ACTIONS(2988),
    [anon_sym_begin] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2990),
    [anon_sym_defined_QMARK] = ACTIONS(2990),
    [anon_sym_not] = ACTIONS(2988),
    [anon_sym_BANG] = ACTIONS(2990),
    [anon_sym_TILDE] = ACTIONS(2990),
    [anon_sym_undef] = ACTIONS(2988),
    [anon_sym_alias] = ACTIONS(2988),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2988),
    [sym_float] = ACTIONS(2988),
    [sym_super] = ACTIONS(2988),
    [sym_self] = ACTIONS(2988),
    [sym_true] = ACTIONS(2988),
    [sym_false] = ACTIONS(2988),
    [sym_constant] = ACTIONS(2988),
    [aux_sym_constant_suffix_token1] = ACTIONS(2990),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2988),
    [sym_instance_variable] = ACTIONS(2990),
    [sym_class_variable] = ACTIONS(2990),
    [sym_global_variable] = ACTIONS(2990),
    [sym_character] = ACTIONS(2990),
    [anon_sym_DASH_GT] = ACTIONS(2990),
    [sym_simple_symbol] = ACTIONS(2990),
    [sym__string_start] = ACTIONS(2990),
    [sym__symbol_start] = ACTIONS(2990),
    [sym__subshell_start] = ACTIONS(2990),
    [sym__regex_start] = ACTIONS(2990),
    [sym__string_array_start] = ACTIONS(2990),
    [sym__symbol_array_start] = ACTIONS(2990),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2990),
    [sym__unary_minus] = ACTIONS(2990),
    [sym__unary_minus_num] = ACTIONS(2990),
    [sym__binary_minus] = ACTIONS(2990),
    [sym__identifier_suffix] = ACTIONS(2990),
    [sym__constant_suffix] = ACTIONS(2990),
  },
  [2141] = {
    [sym_heredoc_body] = STATE(2141),
    [aux_sym__mlhs_repeat1] = STATE(5296),
    [anon_sym_RBRACE] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(3104),
    [anon_sym_DOT] = ACTIONS(3106),
    [anon_sym_end] = ACTIONS(3104),
    [anon_sym_rescue] = ACTIONS(3104),
    [anon_sym_EQ] = ACTIONS(3170),
    [anon_sym_COMMA] = ACTIONS(3162),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3106),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_unless] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_until] = ACTIONS(3104),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_when] = ACTIONS(3104),
    [anon_sym_EQ_GT] = ACTIONS(3104),
    [anon_sym_DOT_DOT] = ACTIONS(3106),
    [anon_sym_CARET] = ACTIONS(3106),
    [anon_sym_elsif] = ACTIONS(3104),
    [anon_sym_else] = ACTIONS(3104),
    [anon_sym_then] = ACTIONS(3104),
    [anon_sym_ensure] = ACTIONS(3104),
    [anon_sym_COLON_COLON2] = ACTIONS(3104),
    [anon_sym_AMP_DOT] = ACTIONS(3104),
    [anon_sym_PLUS_EQ] = ACTIONS(3172),
    [anon_sym_DASH_EQ] = ACTIONS(3172),
    [anon_sym_STAR_EQ] = ACTIONS(3172),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3172),
    [anon_sym_SLASH_EQ] = ACTIONS(3172),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3172),
    [anon_sym_PIPE_EQ] = ACTIONS(3172),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3172),
    [anon_sym_AMP_EQ] = ACTIONS(3172),
    [anon_sym_PERCENT_EQ] = ACTIONS(3172),
    [anon_sym_GT_GT_EQ] = ACTIONS(3172),
    [anon_sym_LT_LT_EQ] = ACTIONS(3172),
    [anon_sym_CARET_EQ] = ACTIONS(3172),
    [anon_sym_QMARK] = ACTIONS(3104),
    [anon_sym_and] = ACTIONS(3104),
    [anon_sym_or] = ACTIONS(3104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(3106),
    [anon_sym_LT_EQ] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_EQ] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_SLASH] = ACTIONS(3106),
    [anon_sym_PERCENT] = ACTIONS(3106),
    [anon_sym_EQ_EQ] = ACTIONS(3106),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3104),
    [anon_sym_LT_EQ_GT] = ACTIONS(3104),
    [anon_sym_EQ_TILDE] = ACTIONS(3104),
    [anon_sym_BANG_TILDE] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3104),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3104),
    [sym__binary_star] = ACTIONS(3104),
    [sym__binary_star_star] = ACTIONS(3104),
    [sym__element_reference_bracket] = ACTIONS(3104),
  },
  [2142] = {
    [sym_heredoc_body] = STATE(2142),
    [aux_sym__mlhs_repeat1] = STATE(5296),
    [anon_sym_RBRACE] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(3104),
    [anon_sym_DOT] = ACTIONS(3106),
    [anon_sym_end] = ACTIONS(3104),
    [anon_sym_rescue] = ACTIONS(3104),
    [anon_sym_EQ] = ACTIONS(3174),
    [anon_sym_COMMA] = ACTIONS(3162),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3106),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_unless] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_until] = ACTIONS(3104),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_when] = ACTIONS(3104),
    [anon_sym_EQ_GT] = ACTIONS(3104),
    [anon_sym_DOT_DOT] = ACTIONS(3106),
    [anon_sym_CARET] = ACTIONS(3106),
    [anon_sym_elsif] = ACTIONS(3104),
    [anon_sym_else] = ACTIONS(3104),
    [anon_sym_then] = ACTIONS(3104),
    [anon_sym_ensure] = ACTIONS(3104),
    [anon_sym_COLON_COLON2] = ACTIONS(3104),
    [anon_sym_AMP_DOT] = ACTIONS(3104),
    [anon_sym_PLUS_EQ] = ACTIONS(3176),
    [anon_sym_DASH_EQ] = ACTIONS(3176),
    [anon_sym_STAR_EQ] = ACTIONS(3176),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3176),
    [anon_sym_SLASH_EQ] = ACTIONS(3176),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3176),
    [anon_sym_PIPE_EQ] = ACTIONS(3176),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3176),
    [anon_sym_AMP_EQ] = ACTIONS(3176),
    [anon_sym_PERCENT_EQ] = ACTIONS(3176),
    [anon_sym_GT_GT_EQ] = ACTIONS(3176),
    [anon_sym_LT_LT_EQ] = ACTIONS(3176),
    [anon_sym_CARET_EQ] = ACTIONS(3176),
    [anon_sym_QMARK] = ACTIONS(3104),
    [anon_sym_and] = ACTIONS(3104),
    [anon_sym_or] = ACTIONS(3104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(3106),
    [anon_sym_LT_EQ] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_EQ] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_SLASH] = ACTIONS(3106),
    [anon_sym_PERCENT] = ACTIONS(3106),
    [anon_sym_EQ_EQ] = ACTIONS(3106),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3104),
    [anon_sym_LT_EQ_GT] = ACTIONS(3104),
    [anon_sym_EQ_TILDE] = ACTIONS(3104),
    [anon_sym_BANG_TILDE] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3104),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3104),
    [sym__binary_star] = ACTIONS(3104),
    [sym__binary_star_star] = ACTIONS(3104),
    [sym__element_reference_bracket] = ACTIONS(3104),
  },
  [2143] = {
    [sym_heredoc_body] = STATE(2143),
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1116),
    [aux_sym_program_token1] = ACTIONS(1102),
    [anon_sym___END__] = ACTIONS(1116),
    [anon_sym_BEGIN] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_END] = ACTIONS(1116),
    [anon_sym_def] = ACTIONS(1116),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [anon_sym_COLON_COLON] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1102),
    [anon_sym_STAR] = ACTIONS(1102),
    [anon_sym_nil] = ACTIONS(1116),
    [anon_sym_class] = ACTIONS(1116),
    [anon_sym_module] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1116),
    [anon_sym_yield] = ACTIONS(1116),
    [anon_sym_break] = ACTIONS(1116),
    [anon_sym_next] = ACTIONS(1116),
    [anon_sym_redo] = ACTIONS(1116),
    [anon_sym_retry] = ACTIONS(1116),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_unless] = ACTIONS(1116),
    [anon_sym_while] = ACTIONS(1116),
    [anon_sym_until] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_case] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_DOT_DOT] = ACTIONS(1116),
    [anon_sym_begin] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1102),
    [anon_sym_defined_QMARK] = ACTIONS(1102),
    [anon_sym_not] = ACTIONS(1116),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_undef] = ACTIONS(1116),
    [anon_sym_alias] = ACTIONS(1116),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(1116),
    [sym_float] = ACTIONS(1116),
    [sym_super] = ACTIONS(1116),
    [sym_self] = ACTIONS(1116),
    [sym_true] = ACTIONS(1116),
    [sym_false] = ACTIONS(1116),
    [sym_constant] = ACTIONS(1116),
    [aux_sym_constant_suffix_token1] = ACTIONS(1102),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1116),
    [sym_instance_variable] = ACTIONS(1102),
    [sym_class_variable] = ACTIONS(1102),
    [sym_global_variable] = ACTIONS(1102),
    [sym_character] = ACTIONS(1102),
    [anon_sym_DASH_GT] = ACTIONS(1102),
    [sym_simple_symbol] = ACTIONS(1102),
    [sym__string_start] = ACTIONS(1102),
    [sym__symbol_start] = ACTIONS(1102),
    [sym__subshell_start] = ACTIONS(1102),
    [sym__regex_start] = ACTIONS(1102),
    [sym__string_array_start] = ACTIONS(1102),
    [sym__symbol_array_start] = ACTIONS(1102),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1102),
    [sym__unary_minus] = ACTIONS(1102),
    [sym__unary_minus_num] = ACTIONS(1102),
    [sym__binary_minus] = ACTIONS(1102),
    [sym__identifier_suffix] = ACTIONS(1102),
    [sym__constant_suffix] = ACTIONS(1102),
  },
  [2144] = {
    [sym_heredoc_body] = STATE(2144),
    [aux_sym__mlhs_repeat1] = STATE(5296),
    [anon_sym_RBRACE] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(3104),
    [anon_sym_DOT] = ACTIONS(3106),
    [anon_sym_end] = ACTIONS(3104),
    [anon_sym_rescue] = ACTIONS(3104),
    [anon_sym_EQ] = ACTIONS(3178),
    [anon_sym_COMMA] = ACTIONS(3104),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3106),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_unless] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_until] = ACTIONS(3104),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_when] = ACTIONS(3104),
    [anon_sym_EQ_GT] = ACTIONS(3104),
    [anon_sym_DOT_DOT] = ACTIONS(3106),
    [anon_sym_CARET] = ACTIONS(3106),
    [anon_sym_elsif] = ACTIONS(3104),
    [anon_sym_else] = ACTIONS(3104),
    [anon_sym_then] = ACTIONS(3104),
    [anon_sym_ensure] = ACTIONS(3104),
    [anon_sym_COLON_COLON2] = ACTIONS(3104),
    [anon_sym_AMP_DOT] = ACTIONS(3104),
    [anon_sym_PLUS_EQ] = ACTIONS(3180),
    [anon_sym_DASH_EQ] = ACTIONS(3180),
    [anon_sym_STAR_EQ] = ACTIONS(3180),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3180),
    [anon_sym_SLASH_EQ] = ACTIONS(3180),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3180),
    [anon_sym_PIPE_EQ] = ACTIONS(3180),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3180),
    [anon_sym_AMP_EQ] = ACTIONS(3180),
    [anon_sym_PERCENT_EQ] = ACTIONS(3180),
    [anon_sym_GT_GT_EQ] = ACTIONS(3180),
    [anon_sym_LT_LT_EQ] = ACTIONS(3180),
    [anon_sym_CARET_EQ] = ACTIONS(3180),
    [anon_sym_QMARK] = ACTIONS(3104),
    [anon_sym_and] = ACTIONS(3104),
    [anon_sym_or] = ACTIONS(3104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(3106),
    [anon_sym_LT_EQ] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_EQ] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_SLASH] = ACTIONS(3106),
    [anon_sym_PERCENT] = ACTIONS(3106),
    [anon_sym_EQ_EQ] = ACTIONS(3106),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3104),
    [anon_sym_LT_EQ_GT] = ACTIONS(3104),
    [anon_sym_EQ_TILDE] = ACTIONS(3104),
    [anon_sym_BANG_TILDE] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3104),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3104),
    [sym__binary_star] = ACTIONS(3104),
    [sym__binary_star_star] = ACTIONS(3104),
    [sym__element_reference_bracket] = ACTIONS(3104),
  },
  [2145] = {
    [sym_heredoc_body] = STATE(2145),
    [aux_sym__mlhs_repeat1] = STATE(5296),
    [anon_sym_RBRACE] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(3104),
    [anon_sym_DOT] = ACTIONS(3106),
    [anon_sym_end] = ACTIONS(3104),
    [anon_sym_rescue] = ACTIONS(3104),
    [anon_sym_EQ] = ACTIONS(3182),
    [anon_sym_COMMA] = ACTIONS(3104),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3106),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_unless] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_until] = ACTIONS(3104),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_when] = ACTIONS(3104),
    [anon_sym_EQ_GT] = ACTIONS(3104),
    [anon_sym_DOT_DOT] = ACTIONS(3106),
    [anon_sym_CARET] = ACTIONS(3106),
    [anon_sym_elsif] = ACTIONS(3104),
    [anon_sym_else] = ACTIONS(3104),
    [anon_sym_then] = ACTIONS(3104),
    [anon_sym_ensure] = ACTIONS(3104),
    [anon_sym_COLON_COLON2] = ACTIONS(3104),
    [anon_sym_AMP_DOT] = ACTIONS(3104),
    [anon_sym_PLUS_EQ] = ACTIONS(3184),
    [anon_sym_DASH_EQ] = ACTIONS(3184),
    [anon_sym_STAR_EQ] = ACTIONS(3184),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3184),
    [anon_sym_SLASH_EQ] = ACTIONS(3184),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3184),
    [anon_sym_PIPE_EQ] = ACTIONS(3184),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3184),
    [anon_sym_AMP_EQ] = ACTIONS(3184),
    [anon_sym_PERCENT_EQ] = ACTIONS(3184),
    [anon_sym_GT_GT_EQ] = ACTIONS(3184),
    [anon_sym_LT_LT_EQ] = ACTIONS(3184),
    [anon_sym_CARET_EQ] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3104),
    [anon_sym_and] = ACTIONS(3104),
    [anon_sym_or] = ACTIONS(3104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(3106),
    [anon_sym_LT_EQ] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_EQ] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_SLASH] = ACTIONS(3106),
    [anon_sym_PERCENT] = ACTIONS(3106),
    [anon_sym_EQ_EQ] = ACTIONS(3106),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3104),
    [anon_sym_LT_EQ_GT] = ACTIONS(3104),
    [anon_sym_EQ_TILDE] = ACTIONS(3104),
    [anon_sym_BANG_TILDE] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3104),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3104),
    [sym__binary_star] = ACTIONS(3104),
    [sym__binary_star_star] = ACTIONS(3104),
    [sym__element_reference_bracket] = ACTIONS(3104),
  },
  [2146] = {
    [sym_heredoc_body] = STATE(2146),
    [ts_builtin_sym_end] = ACTIONS(745),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(2992),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(3186),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(2742),
    [anon_sym_LBRACK2] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2147] = {
    [sym_heredoc_body] = STATE(2147),
    [sym_identifier] = ACTIONS(3128),
    [anon_sym_BEGIN] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_END] = ACTIONS(3128),
    [anon_sym_def] = ACTIONS(3128),
    [anon_sym_LPAREN] = ACTIONS(3130),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3130),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_nil] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_module] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_next] = ACTIONS(3128),
    [anon_sym_redo] = ACTIONS(3128),
    [anon_sym_retry] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_unless] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_until] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3130),
    [anon_sym_DOT_DOT] = ACTIONS(3128),
    [anon_sym_begin] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3130),
    [anon_sym_defined_QMARK] = ACTIONS(3130),
    [anon_sym_not] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_undef] = ACTIONS(3128),
    [anon_sym_alias] = ACTIONS(3128),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3128),
    [sym_float] = ACTIONS(3128),
    [sym_super] = ACTIONS(3128),
    [sym_self] = ACTIONS(3128),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [sym_constant] = ACTIONS(3128),
    [aux_sym_constant_suffix_token1] = ACTIONS(3130),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3128),
    [sym_instance_variable] = ACTIONS(3130),
    [sym_class_variable] = ACTIONS(3130),
    [sym_global_variable] = ACTIONS(3130),
    [sym_character] = ACTIONS(3130),
    [anon_sym_DASH_GT] = ACTIONS(3130),
    [sym_simple_symbol] = ACTIONS(3130),
    [sym__string_start] = ACTIONS(3130),
    [sym__symbol_start] = ACTIONS(3130),
    [sym__subshell_start] = ACTIONS(3130),
    [sym__regex_start] = ACTIONS(3130),
    [sym__string_array_start] = ACTIONS(3130),
    [sym__symbol_array_start] = ACTIONS(3130),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3130),
    [sym__unary_minus] = ACTIONS(3130),
    [sym__unary_minus_num] = ACTIONS(3130),
    [sym__binary_minus] = ACTIONS(3130),
    [sym__identifier_suffix] = ACTIONS(3130),
    [sym__constant_suffix] = ACTIONS(3130),
  },
  [2148] = {
    [sym_heredoc_body] = STATE(2148),
    [sym_identifier] = ACTIONS(3096),
    [anon_sym_BEGIN] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3098),
    [anon_sym_RBRACE] = ACTIONS(3098),
    [anon_sym_END] = ACTIONS(3096),
    [anon_sym_def] = ACTIONS(3096),
    [anon_sym_LPAREN] = ACTIONS(3098),
    [anon_sym_COLON_COLON] = ACTIONS(3098),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_nil] = ACTIONS(3096),
    [anon_sym_class] = ACTIONS(3096),
    [anon_sym_module] = ACTIONS(3096),
    [anon_sym_return] = ACTIONS(3096),
    [anon_sym_yield] = ACTIONS(3096),
    [anon_sym_break] = ACTIONS(3096),
    [anon_sym_next] = ACTIONS(3096),
    [anon_sym_redo] = ACTIONS(3096),
    [anon_sym_retry] = ACTIONS(3096),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_unless] = ACTIONS(3096),
    [anon_sym_while] = ACTIONS(3096),
    [anon_sym_until] = ACTIONS(3096),
    [anon_sym_for] = ACTIONS(3096),
    [anon_sym_case] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_DOT_DOT] = ACTIONS(3096),
    [anon_sym_begin] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3098),
    [anon_sym_defined_QMARK] = ACTIONS(3098),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_BANG] = ACTIONS(3098),
    [anon_sym_TILDE] = ACTIONS(3098),
    [anon_sym_undef] = ACTIONS(3096),
    [anon_sym_alias] = ACTIONS(3096),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3096),
    [sym_float] = ACTIONS(3096),
    [sym_super] = ACTIONS(3096),
    [sym_self] = ACTIONS(3096),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [sym_constant] = ACTIONS(3096),
    [aux_sym_constant_suffix_token1] = ACTIONS(3098),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3096),
    [sym_instance_variable] = ACTIONS(3098),
    [sym_class_variable] = ACTIONS(3098),
    [sym_global_variable] = ACTIONS(3098),
    [sym_character] = ACTIONS(3098),
    [anon_sym_DASH_GT] = ACTIONS(3098),
    [sym_simple_symbol] = ACTIONS(3098),
    [sym__string_start] = ACTIONS(3098),
    [sym__symbol_start] = ACTIONS(3098),
    [sym__subshell_start] = ACTIONS(3098),
    [sym__regex_start] = ACTIONS(3098),
    [sym__string_array_start] = ACTIONS(3098),
    [sym__symbol_array_start] = ACTIONS(3098),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3098),
    [sym__unary_minus] = ACTIONS(3098),
    [sym__unary_minus_num] = ACTIONS(3098),
    [sym__binary_minus] = ACTIONS(3098),
    [sym__identifier_suffix] = ACTIONS(3098),
    [sym__constant_suffix] = ACTIONS(3098),
  },
  [2149] = {
    [sym__pattern_expr] = STATE(4933),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4811),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4754),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_string] = STATE(4702),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2149),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DOT_DOT] = ACTIONS(2908),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2910),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2912),
    [sym_float] = ACTIONS(2912),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2910),
  },
  [2150] = {
    [sym_heredoc_body] = STATE(2150),
    [sym_identifier] = ACTIONS(3100),
    [anon_sym_BEGIN] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_END] = ACTIONS(3100),
    [anon_sym_def] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_nil] = ACTIONS(3100),
    [anon_sym_class] = ACTIONS(3100),
    [anon_sym_module] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_yield] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_next] = ACTIONS(3100),
    [anon_sym_redo] = ACTIONS(3100),
    [anon_sym_retry] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_unless] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_until] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_DOT_DOT] = ACTIONS(3100),
    [anon_sym_begin] = ACTIONS(3100),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_defined_QMARK] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(3100),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_undef] = ACTIONS(3100),
    [anon_sym_alias] = ACTIONS(3100),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3100),
    [sym_float] = ACTIONS(3100),
    [sym_super] = ACTIONS(3100),
    [sym_self] = ACTIONS(3100),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [sym_constant] = ACTIONS(3100),
    [aux_sym_constant_suffix_token1] = ACTIONS(3102),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3100),
    [sym_instance_variable] = ACTIONS(3102),
    [sym_class_variable] = ACTIONS(3102),
    [sym_global_variable] = ACTIONS(3102),
    [sym_character] = ACTIONS(3102),
    [anon_sym_DASH_GT] = ACTIONS(3102),
    [sym_simple_symbol] = ACTIONS(3102),
    [sym__string_start] = ACTIONS(3102),
    [sym__symbol_start] = ACTIONS(3102),
    [sym__subshell_start] = ACTIONS(3102),
    [sym__regex_start] = ACTIONS(3102),
    [sym__string_array_start] = ACTIONS(3102),
    [sym__symbol_array_start] = ACTIONS(3102),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3102),
    [sym__unary_minus] = ACTIONS(3102),
    [sym__unary_minus_num] = ACTIONS(3102),
    [sym__binary_minus] = ACTIONS(3102),
    [sym__identifier_suffix] = ACTIONS(3102),
    [sym__constant_suffix] = ACTIONS(3102),
  },
  [2151] = {
    [sym_heredoc_body] = STATE(2151),
    [sym_identifier] = ACTIONS(3124),
    [anon_sym_BEGIN] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(3126),
    [anon_sym_RBRACE] = ACTIONS(3126),
    [anon_sym_END] = ACTIONS(3124),
    [anon_sym_def] = ACTIONS(3124),
    [anon_sym_LPAREN] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3126),
    [anon_sym_SEMI] = ACTIONS(3126),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(3124),
    [anon_sym_class] = ACTIONS(3124),
    [anon_sym_module] = ACTIONS(3124),
    [anon_sym_return] = ACTIONS(3124),
    [anon_sym_yield] = ACTIONS(3124),
    [anon_sym_break] = ACTIONS(3124),
    [anon_sym_next] = ACTIONS(3124),
    [anon_sym_redo] = ACTIONS(3124),
    [anon_sym_retry] = ACTIONS(3124),
    [anon_sym_if] = ACTIONS(3124),
    [anon_sym_unless] = ACTIONS(3124),
    [anon_sym_while] = ACTIONS(3124),
    [anon_sym_until] = ACTIONS(3124),
    [anon_sym_for] = ACTIONS(3124),
    [anon_sym_case] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_DOT_DOT] = ACTIONS(3124),
    [anon_sym_begin] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3126),
    [anon_sym_defined_QMARK] = ACTIONS(3126),
    [anon_sym_not] = ACTIONS(3124),
    [anon_sym_BANG] = ACTIONS(3126),
    [anon_sym_TILDE] = ACTIONS(3126),
    [anon_sym_undef] = ACTIONS(3124),
    [anon_sym_alias] = ACTIONS(3124),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3124),
    [sym_float] = ACTIONS(3124),
    [sym_super] = ACTIONS(3124),
    [sym_self] = ACTIONS(3124),
    [sym_true] = ACTIONS(3124),
    [sym_false] = ACTIONS(3124),
    [sym_constant] = ACTIONS(3124),
    [aux_sym_constant_suffix_token1] = ACTIONS(3126),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3124),
    [sym_instance_variable] = ACTIONS(3126),
    [sym_class_variable] = ACTIONS(3126),
    [sym_global_variable] = ACTIONS(3126),
    [sym_character] = ACTIONS(3126),
    [anon_sym_DASH_GT] = ACTIONS(3126),
    [sym_simple_symbol] = ACTIONS(3126),
    [sym__string_start] = ACTIONS(3126),
    [sym__symbol_start] = ACTIONS(3126),
    [sym__subshell_start] = ACTIONS(3126),
    [sym__regex_start] = ACTIONS(3126),
    [sym__string_array_start] = ACTIONS(3126),
    [sym__symbol_array_start] = ACTIONS(3126),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3126),
    [sym__unary_minus] = ACTIONS(3126),
    [sym__unary_minus_num] = ACTIONS(3126),
    [sym__binary_minus] = ACTIONS(3126),
    [sym__identifier_suffix] = ACTIONS(3126),
    [sym__constant_suffix] = ACTIONS(3126),
  },
  [2152] = {
    [sym_heredoc_body] = STATE(2152),
    [sym_identifier] = ACTIONS(3136),
    [anon_sym_BEGIN] = ACTIONS(3136),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_END] = ACTIONS(3136),
    [anon_sym_def] = ACTIONS(3136),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_COLON_COLON] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3138),
    [anon_sym_STAR] = ACTIONS(3138),
    [anon_sym_nil] = ACTIONS(3136),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_module] = ACTIONS(3136),
    [anon_sym_return] = ACTIONS(3136),
    [anon_sym_yield] = ACTIONS(3136),
    [anon_sym_break] = ACTIONS(3136),
    [anon_sym_next] = ACTIONS(3136),
    [anon_sym_redo] = ACTIONS(3136),
    [anon_sym_retry] = ACTIONS(3136),
    [anon_sym_if] = ACTIONS(3136),
    [anon_sym_unless] = ACTIONS(3136),
    [anon_sym_while] = ACTIONS(3136),
    [anon_sym_until] = ACTIONS(3136),
    [anon_sym_for] = ACTIONS(3136),
    [anon_sym_case] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_DOT_DOT] = ACTIONS(3136),
    [anon_sym_begin] = ACTIONS(3136),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_defined_QMARK] = ACTIONS(3138),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_undef] = ACTIONS(3136),
    [anon_sym_alias] = ACTIONS(3136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3136),
    [sym_float] = ACTIONS(3136),
    [sym_super] = ACTIONS(3136),
    [sym_self] = ACTIONS(3136),
    [sym_true] = ACTIONS(3136),
    [sym_false] = ACTIONS(3136),
    [sym_constant] = ACTIONS(3136),
    [aux_sym_constant_suffix_token1] = ACTIONS(3138),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3136),
    [sym_instance_variable] = ACTIONS(3138),
    [sym_class_variable] = ACTIONS(3138),
    [sym_global_variable] = ACTIONS(3138),
    [sym_character] = ACTIONS(3138),
    [anon_sym_DASH_GT] = ACTIONS(3138),
    [sym_simple_symbol] = ACTIONS(3138),
    [sym__string_start] = ACTIONS(3138),
    [sym__symbol_start] = ACTIONS(3138),
    [sym__subshell_start] = ACTIONS(3138),
    [sym__regex_start] = ACTIONS(3138),
    [sym__string_array_start] = ACTIONS(3138),
    [sym__symbol_array_start] = ACTIONS(3138),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3138),
    [sym__unary_minus] = ACTIONS(3138),
    [sym__unary_minus_num] = ACTIONS(3138),
    [sym__binary_minus] = ACTIONS(3138),
    [sym__identifier_suffix] = ACTIONS(3138),
    [sym__constant_suffix] = ACTIONS(3138),
  },
  [2153] = {
    [sym__pattern_expr] = STATE(4465),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym_find_pattern] = STATE(4459),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4590),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4585),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2153),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2940),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1718),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2944),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2154] = {
    [sym__pattern_expr] = STATE(4465),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym_find_pattern] = STATE(4459),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4698),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4675),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2154),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
  },
  [2155] = {
    [sym__pattern_expr] = STATE(5630),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_string] = STATE(4702),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2155),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2156] = {
    [sym_heredoc_body] = STATE(2156),
    [sym_identifier] = ACTIONS(3132),
    [anon_sym_BEGIN] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3134),
    [anon_sym_RBRACE] = ACTIONS(3134),
    [anon_sym_END] = ACTIONS(3132),
    [anon_sym_def] = ACTIONS(3132),
    [anon_sym_LPAREN] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_nil] = ACTIONS(3132),
    [anon_sym_class] = ACTIONS(3132),
    [anon_sym_module] = ACTIONS(3132),
    [anon_sym_return] = ACTIONS(3132),
    [anon_sym_yield] = ACTIONS(3132),
    [anon_sym_break] = ACTIONS(3132),
    [anon_sym_next] = ACTIONS(3132),
    [anon_sym_redo] = ACTIONS(3132),
    [anon_sym_retry] = ACTIONS(3132),
    [anon_sym_if] = ACTIONS(3132),
    [anon_sym_unless] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3132),
    [anon_sym_until] = ACTIONS(3132),
    [anon_sym_for] = ACTIONS(3132),
    [anon_sym_case] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_DOT_DOT] = ACTIONS(3132),
    [anon_sym_begin] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3134),
    [anon_sym_undef] = ACTIONS(3132),
    [anon_sym_alias] = ACTIONS(3132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3132),
    [sym_float] = ACTIONS(3132),
    [sym_super] = ACTIONS(3132),
    [sym_self] = ACTIONS(3132),
    [sym_true] = ACTIONS(3132),
    [sym_false] = ACTIONS(3132),
    [sym_constant] = ACTIONS(3132),
    [aux_sym_constant_suffix_token1] = ACTIONS(3134),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3132),
    [sym_instance_variable] = ACTIONS(3134),
    [sym_class_variable] = ACTIONS(3134),
    [sym_global_variable] = ACTIONS(3134),
    [sym_character] = ACTIONS(3134),
    [anon_sym_DASH_GT] = ACTIONS(3134),
    [sym_simple_symbol] = ACTIONS(3134),
    [sym__string_start] = ACTIONS(3134),
    [sym__symbol_start] = ACTIONS(3134),
    [sym__subshell_start] = ACTIONS(3134),
    [sym__regex_start] = ACTIONS(3134),
    [sym__string_array_start] = ACTIONS(3134),
    [sym__symbol_array_start] = ACTIONS(3134),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3134),
    [sym__unary_minus] = ACTIONS(3134),
    [sym__unary_minus_num] = ACTIONS(3134),
    [sym__binary_minus] = ACTIONS(3134),
    [sym__identifier_suffix] = ACTIONS(3134),
    [sym__constant_suffix] = ACTIONS(3134),
  },
  [2157] = {
    [sym_heredoc_body] = STATE(2157),
    [sym_identifier] = ACTIONS(3152),
    [anon_sym_BEGIN] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_END] = ACTIONS(3152),
    [anon_sym_def] = ACTIONS(3152),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3154),
    [anon_sym_nil] = ACTIONS(3152),
    [anon_sym_class] = ACTIONS(3152),
    [anon_sym_module] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3152),
    [anon_sym_yield] = ACTIONS(3152),
    [anon_sym_break] = ACTIONS(3152),
    [anon_sym_next] = ACTIONS(3152),
    [anon_sym_redo] = ACTIONS(3152),
    [anon_sym_retry] = ACTIONS(3152),
    [anon_sym_if] = ACTIONS(3152),
    [anon_sym_unless] = ACTIONS(3152),
    [anon_sym_while] = ACTIONS(3152),
    [anon_sym_until] = ACTIONS(3152),
    [anon_sym_for] = ACTIONS(3152),
    [anon_sym_case] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_DOT_DOT] = ACTIONS(3152),
    [anon_sym_begin] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_defined_QMARK] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_undef] = ACTIONS(3152),
    [anon_sym_alias] = ACTIONS(3152),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3152),
    [sym_float] = ACTIONS(3152),
    [sym_super] = ACTIONS(3152),
    [sym_self] = ACTIONS(3152),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [sym_constant] = ACTIONS(3152),
    [aux_sym_constant_suffix_token1] = ACTIONS(3154),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3152),
    [sym_instance_variable] = ACTIONS(3154),
    [sym_class_variable] = ACTIONS(3154),
    [sym_global_variable] = ACTIONS(3154),
    [sym_character] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3154),
    [sym_simple_symbol] = ACTIONS(3154),
    [sym__string_start] = ACTIONS(3154),
    [sym__symbol_start] = ACTIONS(3154),
    [sym__subshell_start] = ACTIONS(3154),
    [sym__regex_start] = ACTIONS(3154),
    [sym__string_array_start] = ACTIONS(3154),
    [sym__symbol_array_start] = ACTIONS(3154),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3154),
    [sym__unary_minus] = ACTIONS(3154),
    [sym__unary_minus_num] = ACTIONS(3154),
    [sym__binary_minus] = ACTIONS(3154),
    [sym__identifier_suffix] = ACTIONS(3154),
    [sym__constant_suffix] = ACTIONS(3154),
  },
  [2158] = {
    [sym_heredoc_body] = STATE(2158),
    [sym_identifier] = ACTIONS(3140),
    [anon_sym_BEGIN] = ACTIONS(3140),
    [anon_sym_LBRACE] = ACTIONS(3142),
    [anon_sym_RBRACE] = ACTIONS(3142),
    [anon_sym_END] = ACTIONS(3140),
    [anon_sym_def] = ACTIONS(3140),
    [anon_sym_LPAREN] = ACTIONS(3142),
    [anon_sym_COLON_COLON] = ACTIONS(3142),
    [anon_sym_SEMI] = ACTIONS(3142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3142),
    [anon_sym_STAR] = ACTIONS(3142),
    [anon_sym_nil] = ACTIONS(3140),
    [anon_sym_class] = ACTIONS(3140),
    [anon_sym_module] = ACTIONS(3140),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_yield] = ACTIONS(3140),
    [anon_sym_break] = ACTIONS(3140),
    [anon_sym_next] = ACTIONS(3140),
    [anon_sym_redo] = ACTIONS(3140),
    [anon_sym_retry] = ACTIONS(3140),
    [anon_sym_if] = ACTIONS(3140),
    [anon_sym_unless] = ACTIONS(3140),
    [anon_sym_while] = ACTIONS(3140),
    [anon_sym_until] = ACTIONS(3140),
    [anon_sym_for] = ACTIONS(3140),
    [anon_sym_case] = ACTIONS(3140),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_DOT_DOT] = ACTIONS(3140),
    [anon_sym_begin] = ACTIONS(3140),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_defined_QMARK] = ACTIONS(3142),
    [anon_sym_not] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3142),
    [anon_sym_TILDE] = ACTIONS(3142),
    [anon_sym_undef] = ACTIONS(3140),
    [anon_sym_alias] = ACTIONS(3140),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3140),
    [sym_float] = ACTIONS(3140),
    [sym_super] = ACTIONS(3140),
    [sym_self] = ACTIONS(3140),
    [sym_true] = ACTIONS(3140),
    [sym_false] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3140),
    [aux_sym_constant_suffix_token1] = ACTIONS(3142),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3140),
    [sym_instance_variable] = ACTIONS(3142),
    [sym_class_variable] = ACTIONS(3142),
    [sym_global_variable] = ACTIONS(3142),
    [sym_character] = ACTIONS(3142),
    [anon_sym_DASH_GT] = ACTIONS(3142),
    [sym_simple_symbol] = ACTIONS(3142),
    [sym__string_start] = ACTIONS(3142),
    [sym__symbol_start] = ACTIONS(3142),
    [sym__subshell_start] = ACTIONS(3142),
    [sym__regex_start] = ACTIONS(3142),
    [sym__string_array_start] = ACTIONS(3142),
    [sym__symbol_array_start] = ACTIONS(3142),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3142),
    [sym__unary_minus] = ACTIONS(3142),
    [sym__unary_minus_num] = ACTIONS(3142),
    [sym__binary_minus] = ACTIONS(3142),
    [sym__identifier_suffix] = ACTIONS(3142),
    [sym__constant_suffix] = ACTIONS(3142),
  },
  [2159] = {
    [sym_heredoc_body] = STATE(2159),
    [sym_identifier] = ACTIONS(3144),
    [anon_sym_BEGIN] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_RBRACE] = ACTIONS(3146),
    [anon_sym_END] = ACTIONS(3144),
    [anon_sym_def] = ACTIONS(3144),
    [anon_sym_LPAREN] = ACTIONS(3146),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3146),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_module] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_yield] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_next] = ACTIONS(3144),
    [anon_sym_redo] = ACTIONS(3144),
    [anon_sym_retry] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_unless] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_until] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_DOT_DOT] = ACTIONS(3144),
    [anon_sym_begin] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3146),
    [anon_sym_defined_QMARK] = ACTIONS(3146),
    [anon_sym_not] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_undef] = ACTIONS(3144),
    [anon_sym_alias] = ACTIONS(3144),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3144),
    [sym_float] = ACTIONS(3144),
    [sym_super] = ACTIONS(3144),
    [sym_self] = ACTIONS(3144),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [sym_constant] = ACTIONS(3144),
    [aux_sym_constant_suffix_token1] = ACTIONS(3146),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3144),
    [sym_instance_variable] = ACTIONS(3146),
    [sym_class_variable] = ACTIONS(3146),
    [sym_global_variable] = ACTIONS(3146),
    [sym_character] = ACTIONS(3146),
    [anon_sym_DASH_GT] = ACTIONS(3146),
    [sym_simple_symbol] = ACTIONS(3146),
    [sym__string_start] = ACTIONS(3146),
    [sym__symbol_start] = ACTIONS(3146),
    [sym__subshell_start] = ACTIONS(3146),
    [sym__regex_start] = ACTIONS(3146),
    [sym__string_array_start] = ACTIONS(3146),
    [sym__symbol_array_start] = ACTIONS(3146),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3146),
    [sym__unary_minus] = ACTIONS(3146),
    [sym__unary_minus_num] = ACTIONS(3146),
    [sym__binary_minus] = ACTIONS(3146),
    [sym__identifier_suffix] = ACTIONS(3146),
    [sym__constant_suffix] = ACTIONS(3146),
  },
  [2160] = {
    [sym_heredoc_body] = STATE(2160),
    [sym_identifier] = ACTIONS(3092),
    [anon_sym_BEGIN] = ACTIONS(3092),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_RBRACE] = ACTIONS(3094),
    [anon_sym_END] = ACTIONS(3092),
    [anon_sym_def] = ACTIONS(3092),
    [anon_sym_LPAREN] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3094),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_nil] = ACTIONS(3092),
    [anon_sym_class] = ACTIONS(3092),
    [anon_sym_module] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_break] = ACTIONS(3092),
    [anon_sym_next] = ACTIONS(3092),
    [anon_sym_redo] = ACTIONS(3092),
    [anon_sym_retry] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_unless] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_until] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_case] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_DOT_DOT] = ACTIONS(3092),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_defined_QMARK] = ACTIONS(3094),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_undef] = ACTIONS(3092),
    [anon_sym_alias] = ACTIONS(3092),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3092),
    [sym_float] = ACTIONS(3092),
    [sym_super] = ACTIONS(3092),
    [sym_self] = ACTIONS(3092),
    [sym_true] = ACTIONS(3092),
    [sym_false] = ACTIONS(3092),
    [sym_constant] = ACTIONS(3092),
    [aux_sym_constant_suffix_token1] = ACTIONS(3094),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3092),
    [sym_instance_variable] = ACTIONS(3094),
    [sym_class_variable] = ACTIONS(3094),
    [sym_global_variable] = ACTIONS(3094),
    [sym_character] = ACTIONS(3094),
    [anon_sym_DASH_GT] = ACTIONS(3094),
    [sym_simple_symbol] = ACTIONS(3094),
    [sym__string_start] = ACTIONS(3094),
    [sym__symbol_start] = ACTIONS(3094),
    [sym__subshell_start] = ACTIONS(3094),
    [sym__regex_start] = ACTIONS(3094),
    [sym__string_array_start] = ACTIONS(3094),
    [sym__symbol_array_start] = ACTIONS(3094),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3094),
    [sym__unary_minus] = ACTIONS(3094),
    [sym__unary_minus_num] = ACTIONS(3094),
    [sym__binary_minus] = ACTIONS(3094),
    [sym__identifier_suffix] = ACTIONS(3094),
    [sym__constant_suffix] = ACTIONS(3094),
  },
  [2161] = {
    [sym__pattern_expr] = STATE(5578),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_string] = STATE(4702),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2161),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2162] = {
    [sym__pattern_expr] = STATE(4933),
    [sym_as_pattern] = STATE(4861),
    [sym__pattern_expr_alt] = STATE(4861),
    [sym_alternative_pattern] = STATE(4863),
    [sym_array_pattern] = STATE(4790),
    [sym_find_pattern] = STATE(4790),
    [sym_hash_pattern] = STATE(4790),
    [sym__pattern_expr_basic] = STATE(4824),
    [sym_parenthesized_pattern] = STATE(4790),
    [sym__pattern_value] = STATE(4790),
    [sym__pattern_range] = STATE(4809),
    [sym__pattern_primitive] = STATE(4763),
    [sym__pattern_lambda] = STATE(4719),
    [sym__pattern_literal] = STATE(4719),
    [sym__keyword_variable] = STATE(4702),
    [sym_variable_reference_pattern] = STATE(4786),
    [sym_expression_reference_pattern] = STATE(4786),
    [sym__pattern_constant] = STATE(4674),
    [sym__pattern_constant_resolution] = STATE(4677),
    [sym_unary_literal] = STATE(4681),
    [sym__literal] = STATE(4702),
    [sym__numeric] = STATE(4678),
    [sym__simple_numeric] = STATE(4681),
    [sym__int_or_float] = STATE(5517),
    [sym_complex] = STATE(4680),
    [sym_rational] = STATE(4680),
    [sym_nil] = STATE(4710),
    [sym_string] = STATE(4702),
    [sym_subshell] = STATE(4702),
    [sym_string_array] = STATE(4702),
    [sym_symbol_array] = STATE(4702),
    [sym_delimited_symbol] = STATE(4678),
    [sym_regex] = STATE(4702),
    [sym_heredoc_body] = STATE(2162),
    [sym_lambda] = STATE(4741),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2163] = {
    [sym_heredoc_body] = STATE(2163),
    [sym_identifier] = ACTIONS(3120),
    [anon_sym_BEGIN] = ACTIONS(3120),
    [anon_sym_LBRACE] = ACTIONS(3122),
    [anon_sym_RBRACE] = ACTIONS(3122),
    [anon_sym_END] = ACTIONS(3120),
    [anon_sym_def] = ACTIONS(3120),
    [anon_sym_LPAREN] = ACTIONS(3122),
    [anon_sym_COLON_COLON] = ACTIONS(3122),
    [anon_sym_SEMI] = ACTIONS(3122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3122),
    [anon_sym_nil] = ACTIONS(3120),
    [anon_sym_class] = ACTIONS(3120),
    [anon_sym_module] = ACTIONS(3120),
    [anon_sym_return] = ACTIONS(3120),
    [anon_sym_yield] = ACTIONS(3120),
    [anon_sym_break] = ACTIONS(3120),
    [anon_sym_next] = ACTIONS(3120),
    [anon_sym_redo] = ACTIONS(3120),
    [anon_sym_retry] = ACTIONS(3120),
    [anon_sym_if] = ACTIONS(3120),
    [anon_sym_unless] = ACTIONS(3120),
    [anon_sym_while] = ACTIONS(3120),
    [anon_sym_until] = ACTIONS(3120),
    [anon_sym_for] = ACTIONS(3120),
    [anon_sym_case] = ACTIONS(3120),
    [anon_sym_LBRACK] = ACTIONS(3122),
    [anon_sym_DOT_DOT] = ACTIONS(3120),
    [anon_sym_begin] = ACTIONS(3120),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_defined_QMARK] = ACTIONS(3122),
    [anon_sym_not] = ACTIONS(3120),
    [anon_sym_BANG] = ACTIONS(3122),
    [anon_sym_TILDE] = ACTIONS(3122),
    [anon_sym_undef] = ACTIONS(3120),
    [anon_sym_alias] = ACTIONS(3120),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3120),
    [sym_float] = ACTIONS(3120),
    [sym_super] = ACTIONS(3120),
    [sym_self] = ACTIONS(3120),
    [sym_true] = ACTIONS(3120),
    [sym_false] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3120),
    [aux_sym_constant_suffix_token1] = ACTIONS(3122),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3120),
    [sym_instance_variable] = ACTIONS(3122),
    [sym_class_variable] = ACTIONS(3122),
    [sym_global_variable] = ACTIONS(3122),
    [sym_character] = ACTIONS(3122),
    [anon_sym_DASH_GT] = ACTIONS(3122),
    [sym_simple_symbol] = ACTIONS(3122),
    [sym__string_start] = ACTIONS(3122),
    [sym__symbol_start] = ACTIONS(3122),
    [sym__subshell_start] = ACTIONS(3122),
    [sym__regex_start] = ACTIONS(3122),
    [sym__string_array_start] = ACTIONS(3122),
    [sym__symbol_array_start] = ACTIONS(3122),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3122),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__unary_minus_num] = ACTIONS(3122),
    [sym__binary_minus] = ACTIONS(3122),
    [sym__identifier_suffix] = ACTIONS(3122),
    [sym__constant_suffix] = ACTIONS(3122),
  },
  [2164] = {
    [sym_heredoc_body] = STATE(2164),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_BEGIN] = ACTIONS(3116),
    [anon_sym_LBRACE] = ACTIONS(3118),
    [anon_sym_RBRACE] = ACTIONS(3118),
    [anon_sym_END] = ACTIONS(3116),
    [anon_sym_def] = ACTIONS(3116),
    [anon_sym_LPAREN] = ACTIONS(3118),
    [anon_sym_COLON_COLON] = ACTIONS(3118),
    [anon_sym_SEMI] = ACTIONS(3118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3118),
    [anon_sym_STAR] = ACTIONS(3118),
    [anon_sym_nil] = ACTIONS(3116),
    [anon_sym_class] = ACTIONS(3116),
    [anon_sym_module] = ACTIONS(3116),
    [anon_sym_return] = ACTIONS(3116),
    [anon_sym_yield] = ACTIONS(3116),
    [anon_sym_break] = ACTIONS(3116),
    [anon_sym_next] = ACTIONS(3116),
    [anon_sym_redo] = ACTIONS(3116),
    [anon_sym_retry] = ACTIONS(3116),
    [anon_sym_if] = ACTIONS(3116),
    [anon_sym_unless] = ACTIONS(3116),
    [anon_sym_while] = ACTIONS(3116),
    [anon_sym_until] = ACTIONS(3116),
    [anon_sym_for] = ACTIONS(3116),
    [anon_sym_case] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(3118),
    [anon_sym_DOT_DOT] = ACTIONS(3116),
    [anon_sym_begin] = ACTIONS(3116),
    [anon_sym_PLUS] = ACTIONS(3118),
    [anon_sym_defined_QMARK] = ACTIONS(3118),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3118),
    [anon_sym_undef] = ACTIONS(3116),
    [anon_sym_alias] = ACTIONS(3116),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3116),
    [sym_float] = ACTIONS(3116),
    [sym_super] = ACTIONS(3116),
    [sym_self] = ACTIONS(3116),
    [sym_true] = ACTIONS(3116),
    [sym_false] = ACTIONS(3116),
    [sym_constant] = ACTIONS(3116),
    [aux_sym_constant_suffix_token1] = ACTIONS(3118),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3116),
    [sym_instance_variable] = ACTIONS(3118),
    [sym_class_variable] = ACTIONS(3118),
    [sym_global_variable] = ACTIONS(3118),
    [sym_character] = ACTIONS(3118),
    [anon_sym_DASH_GT] = ACTIONS(3118),
    [sym_simple_symbol] = ACTIONS(3118),
    [sym__string_start] = ACTIONS(3118),
    [sym__symbol_start] = ACTIONS(3118),
    [sym__subshell_start] = ACTIONS(3118),
    [sym__regex_start] = ACTIONS(3118),
    [sym__string_array_start] = ACTIONS(3118),
    [sym__symbol_array_start] = ACTIONS(3118),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3118),
    [sym__unary_minus] = ACTIONS(3118),
    [sym__unary_minus_num] = ACTIONS(3118),
    [sym__binary_minus] = ACTIONS(3118),
    [sym__identifier_suffix] = ACTIONS(3118),
    [sym__constant_suffix] = ACTIONS(3118),
  },
  [2165] = {
    [sym__pattern_expr] = STATE(4465),
    [sym_as_pattern] = STATE(4472),
    [sym__pattern_expr_alt] = STATE(4472),
    [sym_alternative_pattern] = STATE(4460),
    [sym_array_pattern] = STATE(4459),
    [sym_find_pattern] = STATE(4459),
    [sym_hash_pattern] = STATE(4459),
    [sym__pattern_expr_basic] = STATE(4505),
    [sym_parenthesized_pattern] = STATE(4459),
    [sym__pattern_value] = STATE(4459),
    [sym__pattern_range] = STATE(4441),
    [sym__pattern_primitive] = STATE(4471),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_variable_reference_pattern] = STATE(4445),
    [sym_expression_reference_pattern] = STATE(4445),
    [sym__pattern_constant] = STATE(4371),
    [sym__pattern_constant_resolution] = STATE(4362),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2165),
    [sym_lambda] = STATE(4407),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2814),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2822),
    [sym_line] = ACTIONS(1678),
    [sym_file] = ACTIONS(1678),
    [sym_encoding] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2166] = {
    [sym_heredoc_body] = STATE(2166),
    [aux_sym__mlhs_repeat1] = STATE(5296),
    [ts_builtin_sym_end] = ACTIONS(3104),
    [aux_sym_program_token1] = ACTIONS(3104),
    [anon_sym___END__] = ACTIONS(3106),
    [anon_sym_LBRACE] = ACTIONS(3104),
    [anon_sym_DOT] = ACTIONS(3106),
    [anon_sym_rescue] = ACTIONS(3104),
    [anon_sym_EQ] = ACTIONS(3188),
    [anon_sym_COMMA] = ACTIONS(3104),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3106),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_unless] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_until] = ACTIONS(3104),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_EQ_GT] = ACTIONS(3104),
    [anon_sym_DOT_DOT] = ACTIONS(3106),
    [anon_sym_CARET] = ACTIONS(3106),
    [anon_sym_COLON_COLON2] = ACTIONS(3104),
    [anon_sym_AMP_DOT] = ACTIONS(3104),
    [anon_sym_PLUS_EQ] = ACTIONS(3190),
    [anon_sym_DASH_EQ] = ACTIONS(3190),
    [anon_sym_STAR_EQ] = ACTIONS(3190),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3190),
    [anon_sym_SLASH_EQ] = ACTIONS(3190),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3190),
    [anon_sym_PIPE_EQ] = ACTIONS(3190),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3190),
    [anon_sym_AMP_EQ] = ACTIONS(3190),
    [anon_sym_PERCENT_EQ] = ACTIONS(3190),
    [anon_sym_GT_GT_EQ] = ACTIONS(3190),
    [anon_sym_LT_LT_EQ] = ACTIONS(3190),
    [anon_sym_CARET_EQ] = ACTIONS(3190),
    [anon_sym_QMARK] = ACTIONS(3104),
    [anon_sym_and] = ACTIONS(3104),
    [anon_sym_or] = ACTIONS(3104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(3106),
    [anon_sym_LT_EQ] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_EQ] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_SLASH] = ACTIONS(3106),
    [anon_sym_PERCENT] = ACTIONS(3106),
    [anon_sym_EQ_EQ] = ACTIONS(3106),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3104),
    [anon_sym_LT_EQ_GT] = ACTIONS(3104),
    [anon_sym_EQ_TILDE] = ACTIONS(3104),
    [anon_sym_BANG_TILDE] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3104),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3104),
    [sym__binary_star] = ACTIONS(3104),
    [sym__binary_star_star] = ACTIONS(3104),
    [sym__element_reference_bracket] = ACTIONS(3104),
  },
  [2167] = {
    [sym_heredoc_body] = STATE(2167),
    [aux_sym__mlhs_repeat1] = STATE(5296),
    [ts_builtin_sym_end] = ACTIONS(3104),
    [aux_sym_program_token1] = ACTIONS(3104),
    [anon_sym___END__] = ACTIONS(3106),
    [anon_sym_LBRACE] = ACTIONS(3104),
    [anon_sym_DOT] = ACTIONS(3106),
    [anon_sym_rescue] = ACTIONS(3104),
    [anon_sym_EQ] = ACTIONS(3192),
    [anon_sym_COMMA] = ACTIONS(3104),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3106),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_unless] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_until] = ACTIONS(3104),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_EQ_GT] = ACTIONS(3104),
    [anon_sym_DOT_DOT] = ACTIONS(3106),
    [anon_sym_CARET] = ACTIONS(3106),
    [anon_sym_COLON_COLON2] = ACTIONS(3104),
    [anon_sym_AMP_DOT] = ACTIONS(3104),
    [anon_sym_PLUS_EQ] = ACTIONS(3194),
    [anon_sym_DASH_EQ] = ACTIONS(3194),
    [anon_sym_STAR_EQ] = ACTIONS(3194),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3194),
    [anon_sym_SLASH_EQ] = ACTIONS(3194),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3194),
    [anon_sym_PIPE_EQ] = ACTIONS(3194),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3194),
    [anon_sym_AMP_EQ] = ACTIONS(3194),
    [anon_sym_PERCENT_EQ] = ACTIONS(3194),
    [anon_sym_GT_GT_EQ] = ACTIONS(3194),
    [anon_sym_LT_LT_EQ] = ACTIONS(3194),
    [anon_sym_CARET_EQ] = ACTIONS(3194),
    [anon_sym_QMARK] = ACTIONS(3104),
    [anon_sym_and] = ACTIONS(3104),
    [anon_sym_or] = ACTIONS(3104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(3106),
    [anon_sym_LT_EQ] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_EQ] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_SLASH] = ACTIONS(3106),
    [anon_sym_PERCENT] = ACTIONS(3106),
    [anon_sym_EQ_EQ] = ACTIONS(3106),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3104),
    [anon_sym_LT_EQ_GT] = ACTIONS(3104),
    [anon_sym_EQ_TILDE] = ACTIONS(3104),
    [anon_sym_BANG_TILDE] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3104),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3104),
    [sym__binary_star] = ACTIONS(3104),
    [sym__binary_star_star] = ACTIONS(3104),
    [sym__element_reference_bracket] = ACTIONS(3104),
  },
  [2168] = {
    [sym_heredoc_body] = STATE(2168),
    [aux_sym__mlhs_repeat1] = STATE(5296),
    [ts_builtin_sym_end] = ACTIONS(3104),
    [aux_sym_program_token1] = ACTIONS(3104),
    [anon_sym___END__] = ACTIONS(3106),
    [anon_sym_LBRACE] = ACTIONS(3104),
    [anon_sym_DOT] = ACTIONS(3106),
    [anon_sym_rescue] = ACTIONS(3104),
    [anon_sym_EQ] = ACTIONS(3196),
    [anon_sym_COMMA] = ACTIONS(3104),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3106),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_unless] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_until] = ACTIONS(3104),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_EQ_GT] = ACTIONS(3104),
    [anon_sym_DOT_DOT] = ACTIONS(3106),
    [anon_sym_CARET] = ACTIONS(3106),
    [anon_sym_COLON_COLON2] = ACTIONS(3104),
    [anon_sym_AMP_DOT] = ACTIONS(3104),
    [anon_sym_PLUS_EQ] = ACTIONS(3198),
    [anon_sym_DASH_EQ] = ACTIONS(3198),
    [anon_sym_STAR_EQ] = ACTIONS(3198),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3198),
    [anon_sym_SLASH_EQ] = ACTIONS(3198),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3198),
    [anon_sym_PIPE_EQ] = ACTIONS(3198),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3198),
    [anon_sym_AMP_EQ] = ACTIONS(3198),
    [anon_sym_PERCENT_EQ] = ACTIONS(3198),
    [anon_sym_GT_GT_EQ] = ACTIONS(3198),
    [anon_sym_LT_LT_EQ] = ACTIONS(3198),
    [anon_sym_CARET_EQ] = ACTIONS(3198),
    [anon_sym_QMARK] = ACTIONS(3104),
    [anon_sym_and] = ACTIONS(3104),
    [anon_sym_or] = ACTIONS(3104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(3106),
    [anon_sym_LT_EQ] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_EQ] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_SLASH] = ACTIONS(3106),
    [anon_sym_PERCENT] = ACTIONS(3106),
    [anon_sym_EQ_EQ] = ACTIONS(3106),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3104),
    [anon_sym_LT_EQ_GT] = ACTIONS(3104),
    [anon_sym_EQ_TILDE] = ACTIONS(3104),
    [anon_sym_BANG_TILDE] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3104),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3104),
    [sym__binary_star] = ACTIONS(3104),
    [sym__binary_star_star] = ACTIONS(3104),
    [sym__element_reference_bracket] = ACTIONS(3104),
  },
  [2169] = {
    [sym__pattern_primitive] = STATE(4448),
    [sym__pattern_lambda] = STATE(4382),
    [sym__pattern_literal] = STATE(4382),
    [sym__keyword_variable] = STATE(4430),
    [sym_unary_literal] = STATE(4408),
    [sym__literal] = STATE(4430),
    [sym__numeric] = STATE(4383),
    [sym__simple_numeric] = STATE(4408),
    [sym__int_or_float] = STATE(5529),
    [sym_complex] = STATE(4413),
    [sym_rational] = STATE(4413),
    [sym_nil] = STATE(4396),
    [sym_string] = STATE(4430),
    [sym_subshell] = STATE(4430),
    [sym_string_array] = STATE(4430),
    [sym_symbol_array] = STATE(4430),
    [sym_delimited_symbol] = STATE(4383),
    [sym_regex] = STATE(4430),
    [sym_heredoc_body] = STATE(2169),
    [sym_lambda] = STATE(4407),
    [anon_sym_LBRACE] = ACTIONS(3200),
    [anon_sym_RBRACE] = ACTIONS(3200),
    [anon_sym_RPAREN] = ACTIONS(3200),
    [anon_sym_end] = ACTIONS(3200),
    [anon_sym_rescue] = ACTIONS(3200),
    [anon_sym_COMMA] = ACTIONS(3200),
    [anon_sym_PIPE] = ACTIONS(3200),
    [anon_sym_SEMI] = ACTIONS(3200),
    [anon_sym_nil] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3200),
    [anon_sym_unless] = ACTIONS(3200),
    [anon_sym_while] = ACTIONS(3200),
    [anon_sym_until] = ACTIONS(3200),
    [anon_sym_in] = ACTIONS(3200),
    [anon_sym_do] = ACTIONS(3200),
    [anon_sym_when] = ACTIONS(3200),
    [anon_sym_EQ_GT] = ACTIONS(3200),
    [sym_line] = ACTIONS(3204),
    [sym_file] = ACTIONS(3204),
    [sym_encoding] = ACTIONS(3204),
    [anon_sym_elsif] = ACTIONS(3200),
    [anon_sym_else] = ACTIONS(3200),
    [anon_sym_then] = ACTIONS(3200),
    [anon_sym_ensure] = ACTIONS(3200),
    [anon_sym_and] = ACTIONS(3200),
    [anon_sym_or] = ACTIONS(3200),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(3204),
    [sym_true] = ACTIONS(3204),
    [sym_false] = ACTIONS(3204),
    [anon_sym_DASH_GT] = ACTIONS(3206),
    [sym__line_break] = ACTIONS(3200),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2170] = {
    [sym_heredoc_body] = STATE(2170),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(2992),
    [anon_sym_rescue] = ACTIONS(2742),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(2742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_unless] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_until] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(2742),
    [anon_sym_LBRACK2] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2742),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2171] = {
    [sym_heredoc_body] = STATE(2171),
    [ts_builtin_sym_end] = ACTIONS(745),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(3186),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(3210), 1,
      anon_sym_do,
    STATE(2172), 1,
      sym_heredoc_body,
    STATE(2834), 1,
      sym_argument_list,
    STATE(2906), 1,
      sym_block,
    STATE(2907), 1,
      sym_do_block,
    ACTIONS(129), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(3210), 1,
      anon_sym_do,
    STATE(2173), 1,
      sym_heredoc_body,
    STATE(2848), 1,
      sym_argument_list,
    STATE(3005), 1,
      sym_block,
    STATE(3007), 1,
      sym_do_block,
    ACTIONS(181), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(179), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [174] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2174), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [248] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    STATE(2175), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3214), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [328] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2994), 1,
      anon_sym_COLON,
    STATE(2176), 1,
      sym_heredoc_body,
    ACTIONS(3082), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [406] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3216), 1,
      anon_sym_EQ,
    STATE(2177), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3218), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [486] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(3220), 1,
      anon_sym_EQ,
    STATE(2178), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3222), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [568] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3224), 1,
      anon_sym_EQ,
    STATE(2179), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3226), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [648] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2984), 1,
      anon_sym_LBRACE,
    STATE(2180), 1,
      sym_heredoc_body,
    STATE(2085), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2978), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2976), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [726] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(3228), 1,
      anon_sym_EQ,
    STATE(2181), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3230), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [808] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2984), 1,
      anon_sym_LBRACE,
    STATE(2182), 1,
      sym_heredoc_body,
    STATE(2086), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2974), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2972), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [886] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3232), 1,
      anon_sym_EQ,
    STATE(2183), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3234), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [966] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(3236), 1,
      anon_sym_EQ,
    STATE(2184), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3238), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1048] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2968), 1,
      anon_sym_COLON_COLON,
    STATE(2185), 1,
      sym_heredoc_body,
    ACTIONS(2970), 2,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
    ACTIONS(2964), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2966), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1126] = 40,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1680), 1,
      anon_sym_CARET,
    ACTIONS(2802), 1,
      sym_identifier,
    ACTIONS(2804), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    ACTIONS(2810), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2814), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2818), 1,
      anon_sym_nil,
    ACTIONS(2820), 1,
      anon_sym_LBRACK,
    ACTIONS(2822), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2828), 1,
      sym_constant,
    ACTIONS(2830), 1,
      anon_sym_DASH_GT,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    STATE(2186), 1,
      sym_heredoc_body,
    STATE(4362), 1,
      sym__pattern_constant_resolution,
    STATE(4371), 1,
      sym__pattern_constant,
    STATE(4396), 1,
      sym_nil,
    STATE(4407), 1,
      sym_lambda,
    STATE(4438), 1,
      sym__pattern_expr_basic,
    STATE(4441), 1,
      sym__pattern_range,
    STATE(4471), 1,
      sym__pattern_primitive,
    STATE(5529), 1,
      sym__int_or_float,
    ACTIONS(2824), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2826), 2,
      sym_integer,
      sym_float,
    STATE(4382), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4383), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4408), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4413), 2,
      sym_complex,
      sym_rational,
    STATE(4445), 2,
      sym_variable_reference_pattern,
      sym_expression_reference_pattern,
    STATE(4459), 5,
      sym_array_pattern,
      sym_find_pattern,
      sym_hash_pattern,
      sym_parenthesized_pattern,
      sym__pattern_value,
    ACTIONS(1678), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4430), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [1269] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    STATE(2187), 1,
      sym_heredoc_body,
    STATE(2256), 1,
      sym_argument_list,
    STATE(2299), 1,
      sym_do_block,
    STATE(2334), 1,
      sym_block,
    ACTIONS(413), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(411), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1352] = 40,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_CARET,
    ACTIONS(2802), 1,
      sym_identifier,
    ACTIONS(2804), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    ACTIONS(2810), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2818), 1,
      anon_sym_nil,
    ACTIONS(2820), 1,
      anon_sym_LBRACK,
    ACTIONS(2828), 1,
      sym_constant,
    ACTIONS(2830), 1,
      anon_sym_DASH_GT,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(2936), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2940), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2944), 1,
      sym__symbol_start,
    STATE(2188), 1,
      sym_heredoc_body,
    STATE(4362), 1,
      sym__pattern_constant_resolution,
    STATE(4371), 1,
      sym__pattern_constant,
    STATE(4396), 1,
      sym_nil,
    STATE(4407), 1,
      sym_lambda,
    STATE(4438), 1,
      sym__pattern_expr_basic,
    STATE(4441), 1,
      sym__pattern_range,
    STATE(4585), 1,
      sym__pattern_primitive,
    STATE(5529), 1,
      sym__int_or_float,
    ACTIONS(2824), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2826), 2,
      sym_integer,
      sym_float,
    STATE(4382), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4383), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4408), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4413), 2,
      sym_complex,
      sym_rational,
    STATE(4445), 2,
      sym_variable_reference_pattern,
      sym_expression_reference_pattern,
    STATE(4459), 5,
      sym_array_pattern,
      sym_find_pattern,
      sym_hash_pattern,
      sym_parenthesized_pattern,
      sym__pattern_value,
    ACTIONS(1678), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4430), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [1495] = 40,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_CARET,
    ACTIONS(2856), 1,
      anon_sym_LBRACE,
    ACTIONS(2858), 1,
      anon_sym_LPAREN,
    ACTIONS(2862), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2864), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2868), 1,
      anon_sym_nil,
    ACTIONS(2870), 1,
      anon_sym_LBRACK,
    ACTIONS(2872), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2884), 1,
      anon_sym_DASH_GT,
    ACTIONS(2886), 1,
      sym_simple_symbol,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(2890), 1,
      sym__symbol_start,
    ACTIONS(2892), 1,
      sym__subshell_start,
    ACTIONS(2894), 1,
      sym__regex_start,
    ACTIONS(2896), 1,
      sym__string_array_start,
    ACTIONS(2898), 1,
      sym__symbol_array_start,
    ACTIONS(2900), 1,
      sym_heredoc_beginning,
    ACTIONS(2958), 1,
      sym_identifier,
    ACTIONS(2962), 1,
      sym_constant,
    STATE(2189), 1,
      sym_heredoc_body,
    STATE(4674), 1,
      sym__pattern_constant,
    STATE(4677), 1,
      sym__pattern_constant_resolution,
    STATE(4710), 1,
      sym_nil,
    STATE(4741), 1,
      sym_lambda,
    STATE(4763), 1,
      sym__pattern_primitive,
    STATE(4809), 1,
      sym__pattern_range,
    STATE(4828), 1,
      sym__pattern_expr_basic,
    STATE(5517), 1,
      sym__int_or_float,
    ACTIONS(2874), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2876), 2,
      sym_integer,
      sym_float,
    STATE(4678), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4680), 2,
      sym_complex,
      sym_rational,
    STATE(4681), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4719), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4786), 2,
      sym_variable_reference_pattern,
      sym_expression_reference_pattern,
    STATE(4790), 5,
      sym_array_pattern,
      sym_find_pattern,
      sym_hash_pattern,
      sym_parenthesized_pattern,
      sym__pattern_value,
    ACTIONS(655), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4702), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [1638] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2968), 1,
      anon_sym_COLON_COLON,
    STATE(2190), 1,
      sym_heredoc_body,
    ACTIONS(2970), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
    ACTIONS(2964), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2966), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1715] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    ACTIONS(2956), 1,
      anon_sym_do,
    STATE(2191), 1,
      sym_heredoc_body,
    STATE(2246), 1,
      sym_argument_list,
    STATE(2299), 1,
      sym_do_block,
    STATE(2334), 1,
      sym_block,
    ACTIONS(413), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(411), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1800] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2192), 1,
      sym_heredoc_body,
    ACTIONS(2634), 2,
      anon_sym_LBRACE,
      anon_sym_LPAREN2,
    ACTIONS(2638), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2636), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1875] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3240), 1,
      anon_sym_LBRACE,
    ACTIONS(3242), 1,
      anon_sym_do,
    STATE(2193), 1,
      sym_heredoc_body,
    STATE(2261), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2978), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2976), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1954] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2194), 1,
      sym_heredoc_body,
    ACTIONS(2996), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2029] = 40,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1680), 1,
      anon_sym_CARET,
    ACTIONS(2802), 1,
      sym_identifier,
    ACTIONS(2804), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    ACTIONS(2810), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2818), 1,
      anon_sym_nil,
    ACTIONS(2820), 1,
      anon_sym_LBRACK,
    ACTIONS(2828), 1,
      sym_constant,
    ACTIONS(2830), 1,
      anon_sym_DASH_GT,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(2924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2926), 1,
      anon_sym_DOT_DOT,
    STATE(2195), 1,
      sym_heredoc_body,
    STATE(4362), 1,
      sym__pattern_constant_resolution,
    STATE(4371), 1,
      sym__pattern_constant,
    STATE(4396), 1,
      sym_nil,
    STATE(4407), 1,
      sym_lambda,
    STATE(4438), 1,
      sym__pattern_expr_basic,
    STATE(4441), 1,
      sym__pattern_range,
    STATE(4675), 1,
      sym__pattern_primitive,
    STATE(5529), 1,
      sym__int_or_float,
    ACTIONS(2928), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2930), 2,
      sym_integer,
      sym_float,
    STATE(4382), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4383), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4408), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4413), 2,
      sym_complex,
      sym_rational,
    STATE(4445), 2,
      sym_variable_reference_pattern,
      sym_expression_reference_pattern,
    STATE(4459), 5,
      sym_array_pattern,
      sym_find_pattern,
      sym_hash_pattern,
      sym_parenthesized_pattern,
      sym__pattern_value,
    ACTIONS(1678), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4430), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [2172] = 40,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_CARET,
    ACTIONS(2856), 1,
      anon_sym_LBRACE,
    ACTIONS(2858), 1,
      anon_sym_LPAREN,
    ACTIONS(2862), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2868), 1,
      anon_sym_nil,
    ACTIONS(2870), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_DASH_GT,
    ACTIONS(2886), 1,
      sym_simple_symbol,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(2890), 1,
      sym__symbol_start,
    ACTIONS(2892), 1,
      sym__subshell_start,
    ACTIONS(2894), 1,
      sym__regex_start,
    ACTIONS(2896), 1,
      sym__string_array_start,
    ACTIONS(2898), 1,
      sym__symbol_array_start,
    ACTIONS(2900), 1,
      sym_heredoc_beginning,
    ACTIONS(2906), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2908), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2958), 1,
      sym_identifier,
    ACTIONS(2962), 1,
      sym_constant,
    STATE(2196), 1,
      sym_heredoc_body,
    STATE(4674), 1,
      sym__pattern_constant,
    STATE(4677), 1,
      sym__pattern_constant_resolution,
    STATE(4710), 1,
      sym_nil,
    STATE(4741), 1,
      sym_lambda,
    STATE(4754), 1,
      sym__pattern_primitive,
    STATE(4809), 1,
      sym__pattern_range,
    STATE(4828), 1,
      sym__pattern_expr_basic,
    STATE(5517), 1,
      sym__int_or_float,
    ACTIONS(2910), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2912), 2,
      sym_integer,
      sym_float,
    STATE(4678), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4680), 2,
      sym_complex,
      sym_rational,
    STATE(4681), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4719), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4786), 2,
      sym_variable_reference_pattern,
      sym_expression_reference_pattern,
    STATE(4790), 5,
      sym_array_pattern,
      sym_find_pattern,
      sym_hash_pattern,
      sym_parenthesized_pattern,
      sym__pattern_value,
    ACTIONS(655), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4702), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [2315] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3240), 1,
      anon_sym_LBRACE,
    ACTIONS(3242), 1,
      anon_sym_do,
    STATE(2197), 1,
      sym_heredoc_body,
    STATE(2224), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2974), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2972), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2394] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3244), 1,
      anon_sym_EQ,
    STATE(2198), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3246), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2472] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    STATE(2199), 1,
      sym_heredoc_body,
    STATE(2906), 1,
      sym_block,
    STATE(2907), 1,
      sym_do_block,
    STATE(3106), 1,
      sym_argument_list,
    ACTIONS(129), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2554] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2200), 1,
      sym_heredoc_body,
    ACTIONS(2634), 3,
      anon_sym_LBRACE,
      anon_sym_do,
      anon_sym_LPAREN2,
    ACTIONS(2638), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2636), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2628] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3254), 1,
      anon_sym_ri,
    STATE(2201), 1,
      sym_heredoc_body,
    ACTIONS(3252), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3250), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3248), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2704] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    STATE(2202), 1,
      sym_heredoc_body,
    STATE(2205), 1,
      aux_sym_chained_string_repeat1,
    STATE(2270), 1,
      sym_string,
    ACTIONS(3106), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2782] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2203), 1,
      sym_heredoc_body,
    ACTIONS(2632), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2634), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2854] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2204), 1,
      sym_heredoc_body,
    ACTIONS(2620), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2622), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2926] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    STATE(2205), 1,
      sym_heredoc_body,
    STATE(2207), 1,
      aux_sym_chained_string_repeat1,
    STATE(2270), 1,
      sym_string,
    ACTIONS(3258), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3256), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3004] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(3260), 1,
      anon_sym_EQ,
    STATE(2206), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3262), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3084] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3268), 1,
      sym__string_start,
    STATE(2270), 1,
      sym_string,
    STATE(2207), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(3266), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3264), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3160] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3271), 1,
      anon_sym_EQ_GT,
    STATE(2205), 1,
      aux_sym_chained_string_repeat1,
    STATE(2208), 1,
      sym_heredoc_body,
    STATE(2270), 1,
      sym_string,
    ACTIONS(3106), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3240] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2209), 1,
      sym_heredoc_body,
    ACTIONS(2616), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2618), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3312] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(3273), 1,
      anon_sym_EQ,
    STATE(2210), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3275), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3392] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2211), 1,
      sym_heredoc_body,
    ACTIONS(2644), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2646), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3464] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3277), 1,
      anon_sym_EQ,
    STATE(2212), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3279), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3542] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3281), 1,
      anon_sym_EQ,
    STATE(2213), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3283), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3620] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(3285), 1,
      anon_sym_EQ,
    STATE(2214), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3287), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3700] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3289), 1,
      anon_sym_EQ,
    STATE(2215), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3291), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3778] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2216), 1,
      sym_heredoc_body,
    ACTIONS(2624), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2626), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3850] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2217), 1,
      sym_heredoc_body,
    ACTIONS(2628), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2630), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3922] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2218), 1,
      sym_heredoc_body,
    ACTIONS(733), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3994] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    STATE(2219), 1,
      sym_heredoc_body,
    STATE(3005), 1,
      sym_block,
    STATE(3007), 1,
      sym_do_block,
    STATE(3150), 1,
      sym_argument_list,
    ACTIONS(181), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(179), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4076] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2220), 1,
      sym_heredoc_body,
    ACTIONS(2640), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2642), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4148] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2221), 1,
      sym_heredoc_body,
    STATE(2273), 1,
      sym_argument_list,
    ACTIONS(3295), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3293), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4223] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2222), 1,
      sym_heredoc_body,
    ACTIONS(3072), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3070), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4294] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2992), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3297), 1,
      anon_sym_COLON,
    STATE(2223), 1,
      sym_heredoc_body,
    ACTIONS(2742), 2,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4371] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2224), 1,
      sym_heredoc_body,
    ACTIONS(3020), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3018), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4442] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2225), 1,
      sym_heredoc_body,
    STATE(2385), 1,
      sym_argument_list,
    ACTIONS(429), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(427), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4517] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2226), 1,
      sym_heredoc_body,
    ACTIONS(3068), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3066), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4588] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2227), 1,
      sym_heredoc_body,
    ACTIONS(3036), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3034), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4659] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2228), 1,
      sym_heredoc_body,
    ACTIONS(3004), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3002), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4730] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2229), 1,
      sym_heredoc_body,
    ACTIONS(3032), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3030), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2230), 1,
      sym_heredoc_body,
    ACTIONS(3024), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3022), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4872] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2231), 1,
      sym_heredoc_body,
    ACTIONS(3301), 10,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3299), 47,
      sym__line_break,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4943] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2232), 1,
      sym_heredoc_body,
    ACTIONS(3044), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3042), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5014] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2233), 1,
      sym_heredoc_body,
    STATE(2362), 1,
      sym_argument_list,
    ACTIONS(425), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(423), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2234), 1,
      sym_heredoc_body,
    ACTIONS(129), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5160] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    ACTIONS(2956), 1,
      anon_sym_do,
    STATE(2235), 1,
      sym_heredoc_body,
    STATE(2287), 1,
      sym_do_block,
    STATE(2292), 1,
      sym_block,
    ACTIONS(3305), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3303), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5239] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2236), 1,
      sym_heredoc_body,
    STATE(2349), 1,
      sym_argument_list,
    ACTIONS(417), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(415), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5314] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2237), 1,
      sym_heredoc_body,
    ACTIONS(2644), 10,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2646), 47,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2238), 1,
      sym_heredoc_body,
    ACTIONS(3028), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3026), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5456] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2239), 1,
      sym_heredoc_body,
    ACTIONS(2616), 10,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2618), 47,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2240), 1,
      sym_heredoc_body,
    ACTIONS(129), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5598] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    ACTIONS(2956), 1,
      anon_sym_do,
    STATE(2241), 1,
      sym_heredoc_body,
    STATE(2346), 1,
      sym_block,
    STATE(2380), 1,
      sym_do_block,
    ACTIONS(3309), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3307), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5677] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2242), 1,
      sym_heredoc_body,
    STATE(2340), 1,
      sym_argument_list,
    ACTIONS(421), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(419), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2243), 1,
      sym_heredoc_body,
    ACTIONS(2964), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2966), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5823] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2992), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3311), 1,
      anon_sym_COLON,
    STATE(2244), 1,
      sym_heredoc_body,
    ACTIONS(2742), 2,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5900] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2968), 1,
      anon_sym_COLON_COLON,
    STATE(2245), 1,
      sym_heredoc_body,
    ACTIONS(2970), 3,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
    ACTIONS(2964), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2966), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5975] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    ACTIONS(2956), 1,
      anon_sym_do,
    STATE(2246), 1,
      sym_heredoc_body,
    STATE(2352), 1,
      sym_block,
    STATE(2353), 1,
      sym_do_block,
    ACTIONS(3315), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3313), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6054] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2247), 1,
      sym_heredoc_body,
    ACTIONS(3000), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2998), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2248), 1,
      sym_heredoc_body,
    ACTIONS(3076), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3074), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6196] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2249), 1,
      sym_heredoc_body,
    STATE(2386), 1,
      sym_argument_list,
    ACTIONS(3319), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3317), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6271] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2250), 1,
      sym_heredoc_body,
    ACTIONS(3064), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3062), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2251), 1,
      sym_heredoc_body,
    ACTIONS(3060), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3058), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6413] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2252), 1,
      sym_heredoc_body,
    ACTIONS(3056), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3054), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6484] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2253), 1,
      sym_heredoc_body,
    ACTIONS(3052), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3050), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6555] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2254), 1,
      sym_heredoc_body,
    ACTIONS(3048), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3046), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6626] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    STATE(2255), 1,
      sym_heredoc_body,
    STATE(2287), 1,
      sym_do_block,
    STATE(2292), 1,
      sym_block,
    ACTIONS(3305), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3303), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6703] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    STATE(2256), 1,
      sym_heredoc_body,
    STATE(2352), 1,
      sym_block,
    STATE(2353), 1,
      sym_do_block,
    ACTIONS(3315), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3313), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6780] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2257), 1,
      sym_heredoc_body,
    ACTIONS(3323), 10,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3321), 47,
      sym__line_break,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6851] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    STATE(2258), 1,
      sym_heredoc_body,
    STATE(2346), 1,
      sym_block,
    STATE(2380), 1,
      sym_do_block,
    ACTIONS(3309), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3307), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6928] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2259), 1,
      sym_heredoc_body,
    ACTIONS(3008), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3006), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2260), 1,
      sym_heredoc_body,
    ACTIONS(3012), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3010), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7070] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2261), 1,
      sym_heredoc_body,
    ACTIONS(3016), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3014), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7141] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3325), 1,
      anon_sym_COLON,
    STATE(2205), 1,
      aux_sym_chained_string_repeat1,
    STATE(2262), 1,
      sym_heredoc_body,
    STATE(2270), 1,
      sym_string,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7219] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2263), 1,
      sym_heredoc_body,
    STATE(2261), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2978), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2976), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7291] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2264), 1,
      sym_heredoc_body,
    ACTIONS(2624), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2626), 47,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2265), 1,
      sym_heredoc_body,
    STATE(2224), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2974), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2972), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7433] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2266), 1,
      sym_heredoc_body,
    ACTIONS(2628), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2630), 47,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7503] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3327), 1,
      anon_sym_EQ,
    STATE(2267), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3329), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7579] = 27,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(2944), 1,
      sym__symbol_start,
    ACTIONS(3202), 1,
      anon_sym_nil,
    ACTIONS(3206), 1,
      anon_sym_DASH_GT,
    ACTIONS(3331), 1,
      anon_sym___END__,
    STATE(2268), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_nil,
    STATE(4407), 1,
      sym_lambda,
    STATE(4448), 1,
      sym__pattern_primitive,
    STATE(5529), 1,
      sym__int_or_float,
    ACTIONS(2824), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2826), 2,
      sym_integer,
      sym_float,
    STATE(4382), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4383), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4408), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4413), 2,
      sym_complex,
      sym_rational,
    ACTIONS(3204), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4430), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
    ACTIONS(3200), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [7693] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3271), 1,
      anon_sym_EQ_GT,
    ACTIONS(3333), 1,
      anon_sym_COLON,
    STATE(2205), 1,
      aux_sym_chained_string_repeat1,
    STATE(2269), 1,
      sym_heredoc_body,
    STATE(2270), 1,
      sym_string,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7773] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2270), 1,
      sym_heredoc_body,
    ACTIONS(3337), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3335), 47,
      sym__line_break,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7843] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2992), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3339), 1,
      anon_sym_COLON,
    STATE(2271), 1,
      sym_heredoc_body,
    ACTIONS(2742), 2,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7919] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2272), 1,
      sym_heredoc_body,
    ACTIONS(2996), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(129), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7991] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2273), 1,
      sym_heredoc_body,
    ACTIONS(3343), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3341), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8060] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2274), 1,
      sym_heredoc_body,
    ACTIONS(3347), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3345), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8129] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2275), 1,
      sym_heredoc_body,
    ACTIONS(3349), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3012), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3010), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8200] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2276), 1,
      sym_heredoc_body,
    ACTIONS(3353), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3351), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8269] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2277), 1,
      sym_heredoc_body,
    ACTIONS(3357), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3355), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8338] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2278), 1,
      sym_heredoc_body,
    ACTIONS(3361), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3359), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8407] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2279), 1,
      sym_heredoc_body,
    ACTIONS(3365), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3363), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8476] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3367), 1,
      anon_sym_EQ,
    STATE(2280), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3369), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8551] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2281), 1,
      sym_heredoc_body,
    ACTIONS(3349), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(3012), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3010), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8622] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2282), 1,
      sym_heredoc_body,
    ACTIONS(3373), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3371), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8691] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2283), 1,
      sym_heredoc_body,
    ACTIONS(3377), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3375), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8760] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2284), 1,
      sym_heredoc_body,
    ACTIONS(3381), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3379), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8829] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2285), 1,
      sym_heredoc_body,
    ACTIONS(3250), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3248), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8898] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3383), 1,
      anon_sym_EQ,
    STATE(2286), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3385), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8973] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2287), 1,
      sym_heredoc_body,
    ACTIONS(3389), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3387), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9042] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2288), 1,
      sym_heredoc_body,
    ACTIONS(3393), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3391), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9111] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2289), 1,
      sym_heredoc_body,
    ACTIONS(3397), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3395), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9180] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2290), 1,
      sym_heredoc_body,
    ACTIONS(3401), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3399), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9249] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2291), 1,
      sym_heredoc_body,
    ACTIONS(3405), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3403), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9318] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2292), 1,
      sym_heredoc_body,
    ACTIONS(3389), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3387), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9387] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2293), 1,
      sym_heredoc_body,
    ACTIONS(3409), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3407), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9456] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2294), 1,
      sym_heredoc_body,
    ACTIONS(3413), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3411), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9525] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2295), 1,
      sym_heredoc_body,
    ACTIONS(3365), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3363), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9594] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3415), 1,
      anon_sym_EQ,
    STATE(2296), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3417), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9669] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2297), 1,
      sym_heredoc_body,
    ACTIONS(3419), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3349), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9738] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2298), 1,
      sym_heredoc_body,
    ACTIONS(3044), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3042), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9807] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2299), 1,
      sym_heredoc_body,
    ACTIONS(3423), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3421), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9876] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2300), 1,
      sym_heredoc_body,
    ACTIONS(3427), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3425), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9945] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2301), 1,
      sym_heredoc_body,
    ACTIONS(3024), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3022), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10014] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2302), 1,
      sym_heredoc_body,
    ACTIONS(3431), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10083] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2303), 1,
      sym_heredoc_body,
    ACTIONS(3435), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3433), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10152] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym_heredoc_body,
    ACTIONS(3439), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3437), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10221] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2305), 1,
      sym_heredoc_body,
    ACTIONS(3443), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3441), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10290] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2306), 1,
      sym_heredoc_body,
    ACTIONS(3447), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3445), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10359] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2307), 1,
      sym_heredoc_body,
    ACTIONS(3451), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3449), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10428] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2308), 1,
      sym_heredoc_body,
    ACTIONS(3076), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3074), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10497] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3082), 1,
      anon_sym_EQ_GT,
    ACTIONS(3311), 1,
      anon_sym_COLON,
    STATE(2309), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10570] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2310), 1,
      sym_heredoc_body,
    ACTIONS(3455), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3453), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10639] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2311), 1,
      sym_heredoc_body,
    ACTIONS(3068), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3066), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10708] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2312), 1,
      sym_heredoc_body,
    ACTIONS(3459), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3457), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10777] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3461), 1,
      anon_sym_EQ,
    STATE(2313), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3463), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10852] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2314), 1,
      sym_heredoc_body,
    ACTIONS(3467), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3465), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10921] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2315), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10990] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2316), 1,
      sym_heredoc_body,
    ACTIONS(3475), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3473), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11059] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2317), 1,
      sym_heredoc_body,
    ACTIONS(3479), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3477), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11128] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2318), 1,
      sym_heredoc_body,
    ACTIONS(3483), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3481), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11197] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2319), 1,
      sym_heredoc_body,
    ACTIONS(3487), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3485), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11266] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2320), 1,
      sym_heredoc_body,
    ACTIONS(3491), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3489), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11335] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2321), 1,
      sym_heredoc_body,
    ACTIONS(3495), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3493), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11404] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2322), 1,
      sym_heredoc_body,
    ACTIONS(3499), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3497), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11473] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2323), 1,
      sym_heredoc_body,
    ACTIONS(3503), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3501), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11542] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2324), 1,
      sym_heredoc_body,
    ACTIONS(3507), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3505), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11611] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2325), 1,
      sym_heredoc_body,
    ACTIONS(3511), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3509), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11680] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2326), 1,
      sym_heredoc_body,
    ACTIONS(3060), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3058), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11749] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2327), 1,
      sym_heredoc_body,
    ACTIONS(3064), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3062), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11818] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2328), 1,
      sym_heredoc_body,
    ACTIONS(3515), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3513), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11887] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2329), 1,
      sym_heredoc_body,
    ACTIONS(3519), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3517), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11956] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2330), 1,
      sym_heredoc_body,
    ACTIONS(3523), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12025] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2331), 1,
      sym_heredoc_body,
    ACTIONS(3012), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3010), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12094] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2332), 1,
      sym_heredoc_body,
    ACTIONS(3527), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3525), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12163] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2333), 1,
      sym_heredoc_body,
    ACTIONS(3531), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3529), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12232] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2334), 1,
      sym_heredoc_body,
    ACTIONS(3423), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3421), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12301] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2335), 1,
      sym_heredoc_body,
    ACTIONS(3535), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3533), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12370] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2336), 1,
      sym_heredoc_body,
    ACTIONS(3539), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3537), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12439] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2337), 1,
      sym_heredoc_body,
    ACTIONS(3543), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12508] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2338), 1,
      sym_heredoc_body,
    ACTIONS(3547), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3545), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12577] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2339), 1,
      sym_heredoc_body,
    ACTIONS(3551), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3549), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12646] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2340), 1,
      sym_heredoc_body,
    ACTIONS(3555), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3553), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12715] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2341), 1,
      sym_heredoc_body,
    ACTIONS(3559), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12784] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2342), 1,
      sym_heredoc_body,
    ACTIONS(3056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3054), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12853] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3561), 1,
      anon_sym_EQ_GT,
    STATE(2343), 1,
      sym_heredoc_body,
    ACTIONS(3106), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12924] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3563), 1,
      anon_sym_DOT,
    ACTIONS(3565), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(3567), 1,
      anon_sym_AMP_DOT,
    ACTIONS(3569), 1,
      sym__element_reference_bracket,
    STATE(2344), 1,
      sym_heredoc_body,
    ACTIONS(3543), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13001] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ_GT,
    STATE(2345), 1,
      sym_heredoc_body,
    ACTIONS(3573), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3571), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13072] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2346), 1,
      sym_heredoc_body,
    ACTIONS(3579), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3577), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13141] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2347), 1,
      sym_heredoc_body,
    ACTIONS(3583), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3581), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13210] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2348), 1,
      sym_heredoc_body,
    ACTIONS(3587), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13279] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2349), 1,
      sym_heredoc_body,
    ACTIONS(3591), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3589), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13348] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2350), 1,
      sym_heredoc_body,
    ACTIONS(3595), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3593), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13417] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2351), 1,
      sym_heredoc_body,
    ACTIONS(3599), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3597), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13486] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2352), 1,
      sym_heredoc_body,
    ACTIONS(3603), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3601), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13555] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2353), 1,
      sym_heredoc_body,
    ACTIONS(3603), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3601), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13624] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2354), 1,
      sym_heredoc_body,
    ACTIONS(3607), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3605), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13693] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym_heredoc_body,
    ACTIONS(3008), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3006), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13762] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3609), 1,
      anon_sym_EQ_GT,
    STATE(2356), 1,
      sym_heredoc_body,
    ACTIONS(3419), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3349), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13833] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2357), 1,
      sym_heredoc_body,
    ACTIONS(3613), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3611), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13902] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2358), 1,
      sym_heredoc_body,
    ACTIONS(3617), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3615), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13971] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2359), 1,
      sym_heredoc_body,
    ACTIONS(3106), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14040] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2360), 1,
      sym_heredoc_body,
    ACTIONS(3621), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3619), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14109] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2361), 1,
      sym_heredoc_body,
    ACTIONS(3625), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3623), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14178] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2362), 1,
      sym_heredoc_body,
    ACTIONS(3629), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3627), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14247] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2363), 1,
      sym_heredoc_body,
    ACTIONS(3633), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3631), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14316] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2364), 1,
      sym_heredoc_body,
    ACTIONS(3637), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3635), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14385] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2365), 1,
      sym_heredoc_body,
    ACTIONS(3641), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3639), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14454] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2366), 1,
      sym_heredoc_body,
    ACTIONS(3645), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3643), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14523] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2367), 1,
      sym_heredoc_body,
    ACTIONS(3649), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3647), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14592] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2368), 1,
      sym_heredoc_body,
    ACTIONS(3653), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3651), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14661] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2369), 1,
      sym_heredoc_body,
    ACTIONS(3036), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3034), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14730] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2370), 1,
      sym_heredoc_body,
    ACTIONS(3657), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3655), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14799] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3659), 1,
      anon_sym_EQ,
    STATE(2371), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3661), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14874] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2372), 1,
      sym_heredoc_body,
    ACTIONS(3004), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3002), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14943] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2373), 1,
      sym_heredoc_body,
    ACTIONS(3012), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3010), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15012] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2374), 1,
      sym_heredoc_body,
    ACTIONS(3665), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3663), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15081] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2375), 1,
      sym_heredoc_body,
    ACTIONS(3669), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3667), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15150] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3671), 1,
      anon_sym_EQ,
    STATE(2376), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3673), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15225] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2377), 1,
      sym_heredoc_body,
    ACTIONS(3677), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3675), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15294] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2378), 1,
      sym_heredoc_body,
    ACTIONS(3573), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3571), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15363] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2379), 1,
      sym_heredoc_body,
    ACTIONS(3681), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3679), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15432] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2380), 1,
      sym_heredoc_body,
    ACTIONS(3579), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3577), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15501] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2381), 1,
      sym_heredoc_body,
    ACTIONS(3685), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3683), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15570] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3687), 1,
      anon_sym_EQ,
    STATE(2382), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3689), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15645] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2383), 1,
      sym_heredoc_body,
    ACTIONS(3693), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3691), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15714] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2384), 1,
      sym_heredoc_body,
    ACTIONS(3697), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3695), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15783] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2385), 1,
      sym_heredoc_body,
    ACTIONS(3701), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3699), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15852] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2386), 1,
      sym_heredoc_body,
    ACTIONS(3705), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3703), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15921] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2387), 1,
      sym_heredoc_body,
    ACTIONS(3709), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3707), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15990] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2388), 1,
      sym_heredoc_body,
    ACTIONS(3713), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3711), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16059] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2389), 1,
      sym_heredoc_body,
    ACTIONS(3000), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2998), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16128] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2390), 1,
      sym_heredoc_body,
    ACTIONS(3717), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3715), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16197] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2391), 1,
      sym_heredoc_body,
    ACTIONS(3032), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3030), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16266] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2392), 1,
      sym_heredoc_body,
    ACTIONS(3721), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3719), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16335] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2393), 1,
      sym_heredoc_body,
    ACTIONS(3725), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3723), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16404] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2394), 1,
      sym_heredoc_body,
    ACTIONS(3052), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3050), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16473] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2395), 1,
      sym_heredoc_body,
    ACTIONS(3729), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3727), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16542] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2396), 1,
      sym_heredoc_body,
    ACTIONS(3048), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3046), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16611] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2397), 1,
      sym_heredoc_body,
    ACTIONS(3733), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3731), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16680] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2398), 1,
      sym_heredoc_body,
    ACTIONS(3737), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3735), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16749] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2399), 1,
      sym_heredoc_body,
    ACTIONS(3741), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3739), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16818] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2400), 1,
      sym_heredoc_body,
    ACTIONS(3745), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3743), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16887] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2401), 1,
      sym_heredoc_body,
    ACTIONS(3749), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3747), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16956] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2402), 1,
      sym_heredoc_body,
    ACTIONS(3753), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3751), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17025] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2403), 1,
      sym_heredoc_body,
    ACTIONS(3757), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3755), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17094] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2404), 1,
      sym_heredoc_body,
    ACTIONS(3761), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3759), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17163] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2996), 1,
      anon_sym_EQ_GT,
    STATE(2405), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17234] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2406), 1,
      sym_heredoc_body,
    ACTIONS(3765), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3763), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17303] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2407), 1,
      sym_heredoc_body,
    ACTIONS(3769), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3767), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17372] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2634), 1,
      anon_sym_LPAREN2,
    STATE(2408), 1,
      sym_heredoc_body,
    ACTIONS(2638), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2636), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17443] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2409), 1,
      sym_heredoc_body,
    ACTIONS(3773), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3771), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17512] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2410), 1,
      sym_heredoc_body,
    ACTIONS(3777), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3775), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17581] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2411), 1,
      sym_heredoc_body,
    ACTIONS(3781), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3779), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17650] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2412), 1,
      sym_heredoc_body,
    ACTIONS(3785), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3783), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17719] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2413), 1,
      sym_heredoc_body,
    ACTIONS(3789), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3787), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17788] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2414), 1,
      sym_heredoc_body,
    ACTIONS(3793), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3791), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17857] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2415), 1,
      sym_heredoc_body,
    ACTIONS(3797), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3795), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17926] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2416), 1,
      sym_heredoc_body,
    ACTIONS(3801), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17995] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2417), 1,
      sym_heredoc_body,
    ACTIONS(3805), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3803), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18064] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2418), 1,
      sym_heredoc_body,
    ACTIONS(3809), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3807), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18133] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3082), 1,
      anon_sym_EQ_GT,
    ACTIONS(3297), 1,
      anon_sym_COLON,
    STATE(2419), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18206] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2420), 1,
      sym_heredoc_body,
    ACTIONS(3813), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3811), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18275] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3271), 1,
      anon_sym_EQ_GT,
    STATE(2421), 1,
      sym_heredoc_body,
    ACTIONS(3106), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18346] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2422), 1,
      sym_heredoc_body,
    ACTIONS(3072), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3070), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18415] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2423), 1,
      sym_heredoc_body,
    ACTIONS(3817), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3815), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18484] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2424), 1,
      sym_heredoc_body,
    ACTIONS(3821), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3819), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18553] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2425), 1,
      sym_heredoc_body,
    ACTIONS(3825), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3823), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18622] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2426), 1,
      sym_heredoc_body,
    ACTIONS(3829), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3827), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18691] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2427), 1,
      sym_heredoc_body,
    ACTIONS(3833), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3831), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18760] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2428), 1,
      sym_heredoc_body,
    ACTIONS(3837), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3835), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18829] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2429), 1,
      sym_heredoc_body,
    ACTIONS(3841), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18898] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2430), 1,
      sym_heredoc_body,
    ACTIONS(3845), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3843), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18967] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2431), 1,
      sym_heredoc_body,
    ACTIONS(3849), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3847), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19036] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2432), 1,
      sym_heredoc_body,
    ACTIONS(3853), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3851), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19105] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2433), 1,
      sym_heredoc_body,
    ACTIONS(3857), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3855), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19174] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3859), 1,
      anon_sym_EQ,
    STATE(2434), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3861), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19249] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2435), 1,
      sym_heredoc_body,
    ACTIONS(3865), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3863), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19318] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2436), 1,
      sym_heredoc_body,
    ACTIONS(3869), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3867), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19387] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2437), 1,
      sym_heredoc_body,
    ACTIONS(3873), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19456] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3082), 1,
      anon_sym_EQ_GT,
    ACTIONS(3339), 1,
      anon_sym_COLON,
    STATE(2438), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19528] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3875), 1,
      anon_sym_EQ,
    STATE(2439), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3877), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19602] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3879), 1,
      anon_sym_EQ,
    STATE(2440), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3881), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19676] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2992), 1,
      anon_sym_COLON_COLON,
    STATE(2441), 1,
      sym_heredoc_body,
    ACTIONS(2742), 2,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19748] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2996), 1,
      anon_sym_EQ_GT,
    STATE(2442), 1,
      sym_heredoc_body,
    ACTIONS(129), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19818] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3883), 1,
      anon_sym_COLON,
    STATE(2205), 1,
      aux_sym_chained_string_repeat1,
    STATE(2270), 1,
      sym_string,
    STATE(2443), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19894] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3885), 1,
      anon_sym_EQ,
    STATE(2444), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3887), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19968] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3889), 1,
      anon_sym_EQ,
    STATE(2445), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3891), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20042] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(3893), 1,
      anon_sym_EQ,
    STATE(2446), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3895), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20118] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3897), 1,
      anon_sym_EQ,
    STATE(2447), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3899), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20192] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3901), 1,
      anon_sym_EQ,
    STATE(2448), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3903), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20266] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3905), 1,
      anon_sym_EQ,
    STATE(2449), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3907), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20340] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3911), 1,
      anon_sym_LPAREN,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    STATE(2450), 1,
      sym_heredoc_body,
    STATE(2925), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4552), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5629), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20439] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(3929), 1,
      anon_sym_EQ,
    STATE(2451), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3931), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 21,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20514] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3933), 1,
      anon_sym_EQ,
    STATE(2452), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3935), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 22,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20587] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(3937), 1,
      anon_sym_LPAREN,
    STATE(2453), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4548), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5433), 1,
      sym__method_rest,
    STATE(5593), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20686] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(3939), 1,
      anon_sym_LPAREN,
    STATE(2454), 1,
      sym_heredoc_body,
    STATE(2925), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4549), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5613), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20785] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(3941), 1,
      anon_sym_LPAREN,
    STATE(2322), 1,
      sym__method_rest,
    STATE(2455), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4554), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5582), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20884] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(3943), 1,
      anon_sym_LPAREN,
    STATE(2456), 1,
      sym_heredoc_body,
    STATE(2925), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4540), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5631), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20983] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3945), 1,
      anon_sym_EQ,
    STATE(2457), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3947), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21056] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2968), 1,
      anon_sym_COLON_COLON,
    STATE(2458), 1,
      sym_heredoc_body,
    ACTIONS(2970), 2,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
    ACTIONS(2964), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2966), 33,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21127] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_COLON,
    STATE(2459), 1,
      sym_heredoc_body,
    ACTIONS(2624), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2626), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21196] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(3949), 1,
      anon_sym_LPAREN,
    STATE(2322), 1,
      sym__method_rest,
    STATE(2460), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4543), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5580), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2461), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21362] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(3951), 1,
      anon_sym_LPAREN,
    STATE(2322), 1,
      sym__method_rest,
    STATE(2462), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4538), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5601), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21461] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(3953), 1,
      anon_sym_LPAREN,
    STATE(2463), 1,
      sym_heredoc_body,
    STATE(2925), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4546), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5633), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21560] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(3955), 1,
      anon_sym_rescue,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3969), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2464), 1,
      sym_heredoc_body,
    STATE(2480), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [21663] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_DOT,
    ACTIONS(3991), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(3993), 1,
      anon_sym_AMP_DOT,
    ACTIONS(3995), 1,
      sym__element_reference_bracket,
    STATE(2465), 1,
      sym_heredoc_body,
    ACTIONS(3543), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21738] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(3997), 1,
      anon_sym_EQ,
    STATE(2466), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3999), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 21,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21813] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4001), 1,
      anon_sym_LPAREN,
    STATE(2467), 1,
      sym_heredoc_body,
    STATE(2925), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4550), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5602), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21912] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4003), 1,
      anon_sym_LPAREN,
    STATE(2468), 1,
      sym_heredoc_body,
    STATE(2925), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4544), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5596), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22011] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4005), 1,
      anon_sym_LPAREN,
    STATE(2322), 1,
      sym__method_rest,
    STATE(2469), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4561), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5591), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22110] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    STATE(2470), 1,
      sym_heredoc_body,
    STATE(2925), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4535), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5619), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22209] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4009), 1,
      anon_sym_LPAREN,
    STATE(2322), 1,
      sym__method_rest,
    STATE(2471), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4539), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5584), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22308] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4011), 1,
      anon_sym_LPAREN,
    STATE(2322), 1,
      sym__method_rest,
    STATE(2472), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4557), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5598), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22407] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4013), 1,
      anon_sym_COMMA,
    STATE(2473), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22476] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4016), 1,
      anon_sym_LPAREN,
    STATE(2322), 1,
      sym__method_rest,
    STATE(2474), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4558), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5587), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22575] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4018), 1,
      anon_sym_EQ,
    STATE(2475), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4020), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22648] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4022), 1,
      anon_sym_LPAREN,
    STATE(2322), 1,
      sym__method_rest,
    STATE(2476), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4545), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5589), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22747] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_COLON,
    STATE(2477), 1,
      sym_heredoc_body,
    ACTIONS(2628), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2630), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22816] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    STATE(2322), 1,
      sym__method_rest,
    STATE(2478), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4559), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5611), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22915] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4026), 1,
      anon_sym_LPAREN,
    STATE(2322), 1,
      sym__method_rest,
    STATE(2479), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4556), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5623), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [23014] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_COMMA,
    STATE(2473), 1,
      aux_sym_exceptions_repeat1,
    STATE(2480), 1,
      sym_heredoc_body,
    ACTIONS(4030), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23085] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4034), 1,
      anon_sym_EQ,
    STATE(2481), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4036), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23158] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4038), 1,
      anon_sym_LPAREN,
    STATE(2482), 1,
      sym_heredoc_body,
    STATE(2925), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4542), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5617), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [23257] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4040), 1,
      anon_sym_LPAREN,
    STATE(2322), 1,
      sym__method_rest,
    STATE(2483), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4541), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5615), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [23356] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    STATE(2322), 1,
      sym__method_rest,
    STATE(2484), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4536), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5639), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [23455] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(4044), 1,
      anon_sym_EQ,
    STATE(2485), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4046), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 21,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23530] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2480), 1,
      aux_sym_exceptions_repeat1,
    STATE(2486), 1,
      sym_heredoc_body,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23599] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4048), 1,
      anon_sym_LPAREN,
    STATE(2487), 1,
      sym_heredoc_body,
    STATE(2925), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4560), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5621), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [23698] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4050), 1,
      anon_sym_LPAREN,
    STATE(2488), 1,
      sym_heredoc_body,
    STATE(2925), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4537), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5627), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [23797] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3919), 1,
      sym_constant,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4052), 1,
      anon_sym_LPAREN,
    STATE(2322), 1,
      sym__method_rest,
    STATE(2489), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4551), 1,
      sym__method_name,
    STATE(4826), 1,
      sym__nonlocal_variable,
    STATE(5579), 1,
      sym__variable,
    ACTIONS(3917), 2,
      sym_super,
      sym_self,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [23896] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2490), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 28,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [23986] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2491), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 36,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24062] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(3955), 1,
      anon_sym_rescue,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3969), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2492), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [24162] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2493), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 29,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [24250] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2494), 1,
      sym_heredoc_body,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 38,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24322] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2495), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 29,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [24410] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3969), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2496), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [24508] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2497), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24576] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4062), 1,
      sym__binary_star_star,
    STATE(2498), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24644] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3969), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    ACTIONS(4066), 1,
      anon_sym_DOT,
    STATE(2499), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [24742] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(4068), 1,
      anon_sym_EQ,
    STATE(2500), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4070), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 20,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24816] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3969), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2501), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [24914] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3841), 1,
      anon_sym_DOT,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3969), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2502), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [25012] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(4072), 1,
      anon_sym_EQ,
    STATE(2503), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4074), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 20,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25086] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2504), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 35,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25166] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4076), 1,
      anon_sym_EQ,
    STATE(2505), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4078), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 21,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25238] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    STATE(2506), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [25334] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3969), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    STATE(2507), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [25432] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3969), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    STATE(2508), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [25530] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4088), 1,
      sym__binary_star_star,
    STATE(2509), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25598] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2740), 1,
      anon_sym_COLON,
    STATE(2510), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25666] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2511), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 36,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25740] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(4090), 1,
      anon_sym_EQ,
    STATE(2512), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4092), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 20,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25814] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    STATE(2513), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [25910] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3969), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    STATE(2514), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [26008] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2515), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26076] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4102), 1,
      anon_sym_EQ,
    STATE(2516), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4104), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 21,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26148] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4106), 1,
      anon_sym_COLON,
    STATE(2517), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26216] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(3955), 1,
      anon_sym_rescue,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3969), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2518), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [26316] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2519), 1,
      sym_heredoc_body,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 40,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3082), 1,
      anon_sym_EQ_GT,
    STATE(2520), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26454] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2521), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26522] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    STATE(2522), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26590] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3569), 1,
      sym__element_reference_bracket,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(4110), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4112), 1,
      anon_sym_AMP_DOT,
    STATE(2523), 1,
      sym_heredoc_body,
    ACTIONS(3543), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26664] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4114), 1,
      anon_sym_COMMA,
    STATE(2524), 1,
      sym_heredoc_body,
    STATE(2534), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26733] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(4116), 1,
      anon_sym_EQ,
    STATE(2525), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4118), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 19,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26806] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(4120), 1,
      anon_sym_EQ,
    STATE(2526), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4122), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 19,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26879] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4124), 1,
      anon_sym_EQ,
    STATE(2527), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4126), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 20,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26950] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2528), 1,
      sym_heredoc_body,
    ACTIONS(3583), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3581), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27015] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2529), 1,
      sym_heredoc_body,
    ACTIONS(3543), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27080] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2530), 1,
      sym_heredoc_body,
    ACTIONS(3559), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27145] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(4128), 1,
      anon_sym_EQ,
    STATE(2531), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4130), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 19,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27218] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(4132), 1,
      anon_sym_EQ,
    STATE(2532), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4134), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 19,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27291] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2533), 1,
      sym_heredoc_body,
    ACTIONS(3439), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3437), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27356] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4114), 1,
      anon_sym_COMMA,
    STATE(2534), 1,
      sym_heredoc_body,
    STATE(2543), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4030), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27425] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4136), 1,
      anon_sym_EQ,
    STATE(2535), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4138), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 20,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27496] = 26,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(3202), 1,
      anon_sym_nil,
    ACTIONS(3206), 1,
      anon_sym_DASH_GT,
    STATE(2536), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_nil,
    STATE(4407), 1,
      sym_lambda,
    STATE(4448), 1,
      sym__pattern_primitive,
    STATE(5529), 1,
      sym__int_or_float,
    ACTIONS(2928), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2930), 2,
      sym_integer,
      sym_float,
    STATE(4382), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4383), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4408), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4413), 2,
      sym_complex,
      sym_rational,
    ACTIONS(3204), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4430), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
    ACTIONS(3200), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [27603] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2537), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27668] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(4140), 1,
      anon_sym_EQ,
    STATE(2538), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4142), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 19,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27741] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2539), 1,
      sym_heredoc_body,
    ACTIONS(3841), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27806] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(4114), 1,
      anon_sym_COMMA,
    ACTIONS(4144), 1,
      anon_sym_rescue,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4158), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2534), 1,
      aux_sym_exceptions_repeat1,
    STATE(2540), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [27909] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2541), 1,
      sym_heredoc_body,
    ACTIONS(3527), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3525), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27974] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4158), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    ACTIONS(4178), 1,
      anon_sym_rescue,
    STATE(2534), 1,
      aux_sym_exceptions_repeat1,
    STATE(2542), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [28075] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4180), 1,
      anon_sym_COMMA,
    STATE(2543), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28142] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4183), 1,
      anon_sym_COLON,
    STATE(2205), 1,
      aux_sym_chained_string_repeat1,
    STATE(2270), 1,
      sym_string,
    STATE(2544), 1,
      sym_heredoc_body,
    ACTIONS(3106), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28215] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2534), 1,
      aux_sym_exceptions_repeat1,
    STATE(2545), 1,
      sym_heredoc_body,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28282] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2546), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28348] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2547), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28414] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4158), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    ACTIONS(4178), 1,
      anon_sym_rescue,
    STATE(2548), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [28512] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      sym__binary_star_star,
    STATE(2549), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28578] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4187), 1,
      anon_sym_EQ,
    STATE(2550), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4189), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 18,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28648] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4066), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4158), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2551), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [28744] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3271), 1,
      anon_sym_EQ_GT,
    ACTIONS(4191), 1,
      anon_sym_COLON,
    STATE(2205), 1,
      aux_sym_chained_string_repeat1,
    STATE(2270), 1,
      sym_string,
    STATE(2552), 1,
      sym_heredoc_body,
    ACTIONS(3106), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28818] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3841), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4158), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2553), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [28914] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4158), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2554), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [29010] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4158), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2555), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [29106] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4193), 1,
      anon_sym_EQ,
    STATE(2556), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4195), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3106), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 18,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29176] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2557), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [29270] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4158), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    ACTIONS(4178), 1,
      anon_sym_rescue,
    STATE(2558), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [29368] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4158), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2559), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [29464] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4158), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2560), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [29560] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3995), 1,
      sym__element_reference_bracket,
    ACTIONS(4197), 1,
      anon_sym_DOT,
    ACTIONS(4199), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4201), 1,
      anon_sym_AMP_DOT,
    STATE(2561), 1,
      sym_heredoc_body,
    ACTIONS(3543), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29632] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4158), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2562), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [29728] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2563), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29794] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2564), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 27,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [29880] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2565), 1,
      sym_heredoc_body,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 36,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29950] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2566), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 27,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [30036] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2567), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [30124] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2568), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 33,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30202] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2569), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 34,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30274] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2570), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 34,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30348] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2571), 1,
      sym_heredoc_body,
    ACTIONS(129), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 33,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30412] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4203), 1,
      sym__binary_star_star,
    STATE(2572), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30478] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2573), 1,
      sym_heredoc_body,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 38,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30546] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(4205), 1,
      anon_sym_EQ,
    STATE(2574), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4207), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3104), 17,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3106), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [30618] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(4209), 1,
      anon_sym_EQ,
    STATE(2575), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4211), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3104), 17,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3106), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [30690] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2576), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [30784] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    STATE(2577), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30850] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2578), 1,
      sym_heredoc_body,
    STATE(3087), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4552), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [30937] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4217), 1,
      anon_sym_COMMA,
    STATE(2579), 1,
      sym_heredoc_body,
    STATE(2648), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4030), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31004] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2580), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31069] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2364), 1,
      sym__method_rest,
    STATE(2581), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4545), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31156] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2582), 1,
      sym_heredoc_body,
    STATE(2947), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4560), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31243] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2583), 1,
      sym_heredoc_body,
    STATE(2947), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4537), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31330] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2348), 1,
      sym__method_rest,
    STATE(2584), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4558), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31417] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2348), 1,
      sym__method_rest,
    STATE(2585), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4545), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31504] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2586), 1,
      sym_heredoc_body,
    STATE(3087), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4560), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31591] = 26,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2886), 1,
      sym_simple_symbol,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(2890), 1,
      sym__symbol_start,
    ACTIONS(2892), 1,
      sym__subshell_start,
    ACTIONS(2894), 1,
      sym__regex_start,
    ACTIONS(2896), 1,
      sym__string_array_start,
    ACTIONS(2898), 1,
      sym__symbol_array_start,
    ACTIONS(2900), 1,
      sym_heredoc_beginning,
    ACTIONS(4221), 1,
      anon_sym_nil,
    ACTIONS(4225), 1,
      anon_sym_DASH_GT,
    STATE(2587), 1,
      sym_heredoc_body,
    STATE(4710), 1,
      sym_nil,
    STATE(4741), 1,
      sym_lambda,
    STATE(4817), 1,
      sym__pattern_primitive,
    STATE(5517), 1,
      sym__int_or_float,
    ACTIONS(2910), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2912), 2,
      sym_integer,
      sym_float,
    STATE(4678), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4680), 2,
      sym_complex,
      sym_rational,
    STATE(4681), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4719), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    ACTIONS(4223), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4702), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
    ACTIONS(3200), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [31696] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2588), 1,
      sym_heredoc_body,
    STATE(3087), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4540), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31783] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2364), 1,
      sym__method_rest,
    STATE(2589), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4558), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31870] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2590), 1,
      sym_heredoc_body,
    STATE(2947), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4540), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31957] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2348), 1,
      sym__method_rest,
    STATE(2591), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4551), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32044] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2364), 1,
      sym__method_rest,
    STATE(2592), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4551), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32131] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2593), 1,
      sym_heredoc_body,
    STATE(3087), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4550), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32218] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4227), 1,
      anon_sym_PIPE,
    ACTIONS(4229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4237), 1,
      anon_sym_CARET,
    ACTIONS(4239), 1,
      anon_sym_QMARK,
    ACTIONS(4241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4247), 1,
      anon_sym_GT_EQ,
    ACTIONS(4253), 1,
      anon_sym_EQ_EQ,
    STATE(2594), 1,
      sym_heredoc_body,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [32313] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4227), 1,
      anon_sym_PIPE,
    ACTIONS(4229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4237), 1,
      anon_sym_CARET,
    ACTIONS(4239), 1,
      anon_sym_QMARK,
    ACTIONS(4241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4247), 1,
      anon_sym_GT_EQ,
    ACTIONS(4253), 1,
      anon_sym_EQ_EQ,
    STATE(2595), 1,
      sym_heredoc_body,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [32408] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2596), 1,
      sym_heredoc_body,
    STATE(2947), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4544), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32495] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2597), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32560] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2598), 1,
      sym_heredoc_body,
    STATE(2947), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4535), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32647] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4227), 1,
      anon_sym_PIPE,
    ACTIONS(4229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4237), 1,
      anon_sym_CARET,
    ACTIONS(4241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4247), 1,
      anon_sym_GT_EQ,
    ACTIONS(4253), 1,
      anon_sym_EQ_EQ,
    STATE(2599), 1,
      sym_heredoc_body,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [32740] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2348), 1,
      sym__method_rest,
    STATE(2600), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4557), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32827] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4257), 1,
      anon_sym_rescue,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2579), 1,
      aux_sym_exceptions_repeat1,
    STATE(2601), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 19,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [32928] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2602), 1,
      sym_heredoc_body,
    STATE(3087), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4537), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33015] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2348), 1,
      sym__method_rest,
    STATE(2603), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4539), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33102] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2364), 1,
      sym__method_rest,
    STATE(2604), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4539), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33189] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4227), 1,
      anon_sym_PIPE,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    ACTIONS(4237), 1,
      anon_sym_CARET,
    ACTIONS(4247), 1,
      anon_sym_GT_EQ,
    ACTIONS(4253), 1,
      anon_sym_EQ_EQ,
    STATE(2605), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [33274] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2364), 1,
      sym__method_rest,
    STATE(2606), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4556), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33361] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4144), 1,
      anon_sym_rescue,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4227), 1,
      anon_sym_PIPE,
    ACTIONS(4229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4237), 1,
      anon_sym_CARET,
    ACTIONS(4239), 1,
      anon_sym_QMARK,
    ACTIONS(4241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4247), 1,
      anon_sym_GT_EQ,
    ACTIONS(4253), 1,
      anon_sym_EQ_EQ,
    STATE(2607), 1,
      sym_heredoc_body,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [33458] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2608), 1,
      sym_heredoc_body,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 35,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33527] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4227), 1,
      anon_sym_PIPE,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    ACTIONS(4237), 1,
      anon_sym_CARET,
    ACTIONS(4247), 1,
      anon_sym_GT_EQ,
    ACTIONS(4253), 1,
      anon_sym_EQ_EQ,
    STATE(2609), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [33612] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4227), 1,
      anon_sym_PIPE,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    ACTIONS(4237), 1,
      anon_sym_CARET,
    ACTIONS(4243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4247), 1,
      anon_sym_GT_EQ,
    ACTIONS(4253), 1,
      anon_sym_EQ_EQ,
    STATE(2610), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [33699] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2611), 1,
      sym_heredoc_body,
    STATE(2947), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4552), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33786] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2612), 1,
      sym_heredoc_body,
    STATE(2947), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4542), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33873] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2613), 1,
      sym_heredoc_body,
    STATE(3087), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4546), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33960] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4227), 1,
      anon_sym_PIPE,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    ACTIONS(4237), 1,
      anon_sym_CARET,
    STATE(2614), 1,
      sym_heredoc_body,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 32,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34037] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2615), 1,
      sym_heredoc_body,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 33,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34108] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2348), 1,
      sym__method_rest,
    STATE(2616), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4559), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34195] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2617), 1,
      sym_heredoc_body,
    STATE(2947), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4549), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34282] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2618), 1,
      sym_heredoc_body,
    STATE(3087), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4542), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34369] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2619), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34434] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2364), 1,
      sym__method_rest,
    STATE(2620), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4559), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34521] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    STATE(2621), 1,
      sym_heredoc_body,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 33,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34594] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2622), 1,
      sym_heredoc_body,
    STATE(2947), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4546), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34681] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2364), 1,
      sym__method_rest,
    STATE(2623), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4557), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34768] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2624), 1,
      sym_heredoc_body,
    STATE(3087), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4549), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34855] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2625), 1,
      sym_heredoc_body,
    STATE(3087), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4535), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34942] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2626), 1,
      sym_heredoc_body,
    STATE(3087), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4544), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35029] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2348), 1,
      sym__method_rest,
    STATE(2627), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4543), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35116] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4227), 1,
      anon_sym_PIPE,
    ACTIONS(4229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4237), 1,
      anon_sym_CARET,
    ACTIONS(4239), 1,
      anon_sym_QMARK,
    ACTIONS(4241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4247), 1,
      anon_sym_GT_EQ,
    ACTIONS(4253), 1,
      anon_sym_EQ_EQ,
    STATE(2628), 1,
      sym_heredoc_body,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [35211] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2348), 1,
      sym__method_rest,
    STATE(2629), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4538), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35298] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2364), 1,
      sym__method_rest,
    STATE(2630), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4541), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35385] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2364), 1,
      sym__method_rest,
    STATE(2631), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4543), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35472] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2348), 1,
      sym__method_rest,
    STATE(2632), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4541), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35559] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4227), 1,
      anon_sym_PIPE,
    ACTIONS(4229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4237), 1,
      anon_sym_CARET,
    ACTIONS(4239), 1,
      anon_sym_QMARK,
    ACTIONS(4241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4247), 1,
      anon_sym_GT_EQ,
    ACTIONS(4253), 1,
      anon_sym_EQ_EQ,
    STATE(2633), 1,
      sym_heredoc_body,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [35654] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(4144), 1,
      anon_sym_rescue,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4227), 1,
      anon_sym_PIPE,
    ACTIONS(4229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4237), 1,
      anon_sym_CARET,
    ACTIONS(4239), 1,
      anon_sym_QMARK,
    ACTIONS(4241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4247), 1,
      anon_sym_GT_EQ,
    ACTIONS(4253), 1,
      anon_sym_EQ_EQ,
    STATE(2634), 1,
      sym_heredoc_body,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [35751] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2348), 1,
      sym__method_rest,
    STATE(2635), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4554), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35838] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2364), 1,
      sym__method_rest,
    STATE(2636), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4554), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35925] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(4295), 1,
      anon_sym_EQ,
    STATE(2637), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4297), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3104), 16,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3106), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [35996] = 26,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2886), 1,
      sym_simple_symbol,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(2890), 1,
      sym__symbol_start,
    ACTIONS(2892), 1,
      sym__subshell_start,
    ACTIONS(2894), 1,
      sym__regex_start,
    ACTIONS(2896), 1,
      sym__string_array_start,
    ACTIONS(2898), 1,
      sym__symbol_array_start,
    ACTIONS(2900), 1,
      sym_heredoc_beginning,
    ACTIONS(4221), 1,
      anon_sym_nil,
    ACTIONS(4225), 1,
      anon_sym_DASH_GT,
    STATE(2638), 1,
      sym_heredoc_body,
    STATE(4710), 1,
      sym_nil,
    STATE(4741), 1,
      sym_lambda,
    STATE(4817), 1,
      sym__pattern_primitive,
    STATE(5517), 1,
      sym__int_or_float,
    ACTIONS(2874), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2876), 2,
      sym_integer,
      sym_float,
    STATE(4678), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4680), 2,
      sym_complex,
      sym_rational,
    STATE(4681), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4719), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    ACTIONS(4223), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4702), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
    ACTIONS(3200), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [36101] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4299), 1,
      anon_sym_EQ,
    STATE(2639), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4301), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3104), 17,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3106), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [36170] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2640), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4548), 1,
      sym__method_name,
    STATE(5476), 1,
      sym__method_rest,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [36257] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2641), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36322] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4303), 1,
      sym__binary_star_star,
    STATE(2642), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36387] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(4305), 1,
      anon_sym_EQ,
    STATE(2643), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4307), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3104), 16,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3106), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [36458] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2364), 1,
      sym__method_rest,
    STATE(2644), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4536), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [36545] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2348), 1,
      sym__method_rest,
    STATE(2645), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4561), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [36632] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4257), 1,
      anon_sym_rescue,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2579), 1,
      aux_sym_exceptions_repeat1,
    STATE(2646), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [36729] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2364), 1,
      sym__method_rest,
    STATE(2647), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4561), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [36816] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4309), 1,
      anon_sym_COMMA,
    STATE(2648), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36881] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2649), 1,
      sym_heredoc_body,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 37,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36948] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4312), 1,
      anon_sym_EQ,
    STATE(2650), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4314), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3104), 17,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3106), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [37017] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2348), 1,
      sym__method_rest,
    STATE(2651), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4556), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [37104] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2652), 1,
      sym_heredoc_body,
    STATE(2947), 1,
      sym__method_rest,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4550), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [37191] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4316), 1,
      sym__binary_star_star,
    STATE(2653), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37256] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4227), 1,
      anon_sym_PIPE,
    ACTIONS(4229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4237), 1,
      anon_sym_CARET,
    ACTIONS(4241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4247), 1,
      anon_sym_GT_EQ,
    ACTIONS(4253), 1,
      anon_sym_EQ_EQ,
    STATE(2654), 1,
      sym_heredoc_body,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [37349] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4318), 1,
      anon_sym_COLON,
    STATE(2205), 1,
      aux_sym_chained_string_repeat1,
    STATE(2270), 1,
      sym_string,
    STATE(2655), 1,
      sym_heredoc_body,
    ACTIONS(3106), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37420] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2579), 1,
      aux_sym_exceptions_repeat1,
    STATE(2656), 1,
      sym_heredoc_body,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37485] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4227), 1,
      anon_sym_PIPE,
    ACTIONS(4229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4237), 1,
      anon_sym_CARET,
    ACTIONS(4239), 1,
      anon_sym_QMARK,
    ACTIONS(4241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4247), 1,
      anon_sym_GT_EQ,
    ACTIONS(4253), 1,
      anon_sym_EQ_EQ,
    STATE(2657), 1,
      sym_heredoc_body,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [37580] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2348), 1,
      sym__method_rest,
    STATE(2658), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4536), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [37667] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2364), 1,
      sym__method_rest,
    STATE(2659), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4538), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [37754] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4213), 1,
      sym_identifier,
    ACTIONS(4215), 1,
      sym_constant,
    STATE(2660), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4548), 1,
      sym__method_name,
    STATE(5330), 1,
      sym__method_rest,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [37841] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2661), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [37933] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2662), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37997] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4320), 1,
      anon_sym_COMMA,
    STATE(2663), 1,
      sym_heredoc_body,
    STATE(2674), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4030), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38063] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4322), 1,
      anon_sym_rescue,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4326), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4332), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4336), 1,
      anon_sym_QMARK,
    ACTIONS(4338), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4340), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_GT_EQ,
    ACTIONS(4350), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2663), 1,
      aux_sym_exceptions_repeat1,
    STATE(2664), 1,
      sym_heredoc_body,
    ACTIONS(3559), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4330), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4352), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 18,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [38161] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4257), 1,
      anon_sym_rescue,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2665), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 19,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [38259] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2944), 1,
      sym__symbol_start,
    ACTIONS(4356), 1,
      sym_identifier,
    ACTIONS(4362), 1,
      sym_constant,
    ACTIONS(4370), 1,
      sym_simple_symbol,
    STATE(2666), 1,
      sym_heredoc_body,
    STATE(4553), 1,
      sym__method_name,
    STATE(4815), 1,
      sym_constant_suffix,
    STATE(4816), 1,
      sym_identifier_suffix,
    ACTIONS(4364), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4366), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4368), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4794), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(4360), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4358), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [38343] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    STATE(2667), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38409] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2944), 1,
      sym__symbol_start,
    ACTIONS(4356), 1,
      sym_identifier,
    ACTIONS(4362), 1,
      sym_constant,
    ACTIONS(4370), 1,
      sym_simple_symbol,
    STATE(2668), 1,
      sym_heredoc_body,
    STATE(4751), 1,
      sym__method_name,
    STATE(4815), 1,
      sym_constant_suffix,
    STATE(4816), 1,
      sym_identifier_suffix,
    ACTIONS(4364), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4366), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4368), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4794), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(4360), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4358), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [38493] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2669), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38557] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2670), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38625] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2671), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [38721] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2672), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [38817] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2673), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 23,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [38907] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4372), 1,
      anon_sym_COMMA,
    STATE(2674), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38971] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4215), 1,
      sym_constant,
    ACTIONS(4375), 1,
      sym_identifier,
    STATE(2675), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4577), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [39055] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4215), 1,
      sym_constant,
    ACTIONS(4375), 1,
      sym_identifier,
    STATE(2676), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4587), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [39139] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4377), 1,
      sym_identifier,
    ACTIONS(4383), 1,
      sym_constant,
    ACTIONS(4391), 1,
      sym_simple_symbol,
    ACTIONS(4393), 1,
      sym__symbol_start,
    STATE(2675), 1,
      sym__method_name,
    STATE(2677), 1,
      sym_heredoc_body,
    STATE(3243), 1,
      sym_identifier_suffix,
    STATE(3245), 1,
      sym_constant_suffix,
    ACTIONS(4385), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4387), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4389), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(3361), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(4381), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4379), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [39223] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2678), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39315] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3927), 1,
      sym_simple_symbol,
    ACTIONS(4215), 1,
      sym_constant,
    ACTIONS(4375), 1,
      sym_identifier,
    STATE(2679), 1,
      sym_heredoc_body,
    STATE(4461), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym_constant_suffix,
    STATE(4553), 1,
      sym__method_name,
    ACTIONS(3921), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3923), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4462), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3915), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3913), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [39399] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2680), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39491] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4257), 1,
      anon_sym_rescue,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2681), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39585] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4377), 1,
      sym_identifier,
    ACTIONS(4383), 1,
      sym_constant,
    ACTIONS(4391), 1,
      sym_simple_symbol,
    ACTIONS(4393), 1,
      sym__symbol_start,
    STATE(2682), 1,
      sym_heredoc_body,
    STATE(2695), 1,
      sym__method_name,
    STATE(3243), 1,
      sym_identifier_suffix,
    STATE(3245), 1,
      sym_constant_suffix,
    ACTIONS(4385), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4387), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4389), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(3361), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(4381), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4379), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [39669] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2683), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39761] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2684), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39853] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2685), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 23,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [39943] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2686), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [40035] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    ACTIONS(4397), 1,
      anon_sym_EQ_GT,
    STATE(2687), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [40131] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2688), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [40223] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2689), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [40319] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2690), 1,
      sym_heredoc_body,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 37,
      sym__line_break,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40385] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2691), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40449] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2663), 1,
      aux_sym_exceptions_repeat1,
    STATE(2692), 1,
      sym_heredoc_body,
    ACTIONS(3559), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40513] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2693), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40577] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2694), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 33,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40649] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2944), 1,
      sym__symbol_start,
    ACTIONS(4356), 1,
      sym_identifier,
    ACTIONS(4362), 1,
      sym_constant,
    ACTIONS(4370), 1,
      sym_simple_symbol,
    STATE(2695), 1,
      sym_heredoc_body,
    STATE(4577), 1,
      sym__method_name,
    STATE(4815), 1,
      sym_constant_suffix,
    STATE(4816), 1,
      sym_identifier_suffix,
    ACTIONS(4364), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4366), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4368), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4794), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(4360), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4358), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40733] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2696), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 33,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40803] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2697), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 32,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40879] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2698), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 25,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [40965] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2699), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 26,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [41049] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2700), 1,
      sym_heredoc_body,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 35,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41117] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2701), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 26,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [41201] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2702), 1,
      sym_heredoc_body,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 29,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41276] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4326), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4332), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4336), 1,
      anon_sym_QMARK,
    ACTIONS(4338), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4340), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_GT_EQ,
    ACTIONS(4350), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2703), 1,
      sym_heredoc_body,
    ACTIONS(4100), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4330), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4352), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [41369] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(3210), 1,
      anon_sym_do,
    STATE(2704), 1,
      sym_heredoc_body,
    STATE(2834), 1,
      sym_argument_list,
    STATE(2906), 1,
      sym_block,
    STATE(2907), 1,
      sym_do_block,
    ACTIONS(413), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(411), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41442] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2705), 1,
      sym_heredoc_body,
    STATE(2728), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41505] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3186), 1,
      anon_sym_COLON,
    STATE(2706), 1,
      sym_heredoc_body,
    ACTIONS(2628), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2630), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41568] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4322), 1,
      anon_sym_rescue,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4326), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4332), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4336), 1,
      anon_sym_QMARK,
    ACTIONS(4338), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4340), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_GT_EQ,
    ACTIONS(4350), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2707), 1,
      sym_heredoc_body,
    ACTIONS(3551), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4330), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4352), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 18,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [41663] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4344), 1,
      anon_sym_GT_EQ,
    ACTIONS(4350), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2708), 1,
      sym_heredoc_body,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4330), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4352), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 23,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [41746] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2709), 1,
      sym_heredoc_body,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41815] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2710), 1,
      sym_heredoc_body,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41886] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2711), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41949] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2712), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42012] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2713), 1,
      sym_heredoc_body,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 34,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42077] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2714), 1,
      sym_heredoc_body,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 32,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42144] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4344), 1,
      anon_sym_GT_EQ,
    ACTIONS(4350), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2715), 1,
      sym_heredoc_body,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4330), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4352), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 23,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [42227] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2716), 1,
      sym_heredoc_body,
    ACTIONS(3801), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42290] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4399), 1,
      anon_sym_rescue,
    ACTIONS(4401), 1,
      anon_sym_COMMA,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2717), 1,
      sym_heredoc_body,
    STATE(2728), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [42387] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2718), 1,
      sym_heredoc_body,
    ACTIONS(4060), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42450] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4435), 1,
      sym__binary_star_star,
    STATE(2719), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42513] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4437), 1,
      anon_sym_COMMA,
    STATE(2720), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42576] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4326), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4332), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4336), 1,
      anon_sym_QMARK,
    ACTIONS(4338), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4340), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_GT_EQ,
    ACTIONS(4350), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2721), 1,
      sym_heredoc_body,
    ACTIONS(3841), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4330), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4352), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [42669] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2722), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [42760] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4340), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_GT_EQ,
    ACTIONS(4350), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2723), 1,
      sym_heredoc_body,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4330), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4352), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 22,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [42845] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3569), 1,
      sym__element_reference_bracket,
    ACTIONS(4442), 1,
      anon_sym_DOT,
    ACTIONS(4444), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4446), 1,
      anon_sym_AMP_DOT,
    STATE(2724), 1,
      sym_heredoc_body,
    ACTIONS(3543), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42914] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2725), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4448), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [43005] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2726), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4450), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [43096] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4326), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4332), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4336), 1,
      anon_sym_QMARK,
    ACTIONS(4338), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4340), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_GT_EQ,
    ACTIONS(4350), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2727), 1,
      sym_heredoc_body,
    ACTIONS(4066), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4330), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4352), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [43189] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4401), 1,
      anon_sym_COMMA,
    STATE(2720), 1,
      aux_sym_exceptions_repeat1,
    STATE(2728), 1,
      sym_heredoc_body,
    ACTIONS(4030), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43254] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2729), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [43345] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4454), 1,
      anon_sym_COLON,
    STATE(2205), 1,
      aux_sym_chained_string_repeat1,
    STATE(2270), 1,
      sym_string,
    STATE(2730), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43414] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    STATE(2731), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4456), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [43505] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(4458), 1,
      anon_sym_rescue,
    STATE(2728), 1,
      aux_sym_exceptions_repeat1,
    STATE(2732), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [43604] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4401), 1,
      anon_sym_COMMA,
    STATE(2728), 1,
      aux_sym_exceptions_repeat1,
    STATE(2733), 1,
      sym_heredoc_body,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43669] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4460), 1,
      sym__binary_star_star,
    STATE(2734), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43732] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(4458), 1,
      anon_sym_rescue,
    STATE(2728), 1,
      aux_sym_exceptions_repeat1,
    STATE(2735), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [43827] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4399), 1,
      anon_sym_rescue,
    ACTIONS(4401), 1,
      anon_sym_COMMA,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2728), 1,
      aux_sym_exceptions_repeat1,
    STATE(2736), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [43928] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3186), 1,
      anon_sym_COLON,
    STATE(2737), 1,
      sym_heredoc_body,
    ACTIONS(2624), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2626), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43991] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4322), 1,
      anon_sym_rescue,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4326), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4332), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4336), 1,
      anon_sym_QMARK,
    ACTIONS(4338), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4340), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_GT_EQ,
    ACTIONS(4350), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2738), 1,
      sym_heredoc_body,
    ACTIONS(3527), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4330), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4352), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 18,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [44086] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4326), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4332), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4336), 1,
      anon_sym_QMARK,
    ACTIONS(4338), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4340), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_GT_EQ,
    ACTIONS(4350), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2739), 1,
      sym_heredoc_body,
    ACTIONS(4086), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4330), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4352), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [44179] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4326), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4332), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4336), 1,
      anon_sym_QMARK,
    ACTIONS(4338), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4340), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_GT_EQ,
    ACTIONS(4350), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2740), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4330), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4352), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [44272] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4326), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4332), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4338), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4340), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_GT_EQ,
    ACTIONS(4350), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2741), 1,
      sym_heredoc_body,
    ACTIONS(4082), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4330), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4352), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 20,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [44363] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4326), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4332), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4336), 1,
      anon_sym_QMARK,
    ACTIONS(4338), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4340), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_GT_EQ,
    ACTIONS(4350), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2742), 1,
      sym_heredoc_body,
    ACTIONS(3801), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4330), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4352), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [44456] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4326), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4332), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4336), 1,
      anon_sym_QMARK,
    ACTIONS(4338), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4340), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_GT_EQ,
    ACTIONS(4350), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2743), 1,
      sym_heredoc_body,
    ACTIONS(3801), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4330), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4352), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [44549] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4324), 1,
      anon_sym_PIPE,
    ACTIONS(4326), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4328), 1,
      anon_sym_AMP,
    ACTIONS(4332), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4334), 1,
      anon_sym_CARET,
    ACTIONS(4338), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4340), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_GT_EQ,
    ACTIONS(4350), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4354), 1,
      sym__binary_star_star,
    STATE(2744), 1,
      sym_heredoc_body,
    ACTIONS(4096), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4342), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4346), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4330), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4348), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4352), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 20,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [44640] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2745), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44706] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2746), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44780] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2747), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [44874] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2748), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 21,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [44962] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2749), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 23,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [45046] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2750), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 24,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [45128] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2751), 1,
      sym_heredoc_body,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 33,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45194] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2752), 1,
      sym_heredoc_body,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 35,
      sym__line_break,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45258] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2753), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 24,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [45340] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2754), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45402] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_rescue,
    ACTIONS(4464), 1,
      anon_sym_COMMA,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4468), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4478), 1,
      anon_sym_QMARK,
    ACTIONS(4480), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2755), 1,
      sym_heredoc_body,
    STATE(2781), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 15,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [45500] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4464), 1,
      anon_sym_COMMA,
    STATE(2756), 1,
      sym_heredoc_body,
    STATE(2781), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45564] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2757), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [45658] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2758), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45720] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2759), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45782] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(4498), 1,
      anon_sym_EQ_GT,
    STATE(2760), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [45876] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2761), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45946] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2762), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [46036] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(4458), 1,
      anon_sym_rescue,
    STATE(2763), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [46128] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2764), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [46218] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2765), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46286] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2766), 1,
      sym_heredoc_body,
    STATE(2781), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46348] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2767), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 21,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [46436] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2768), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46498] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2769), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [46588] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2770), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [46678] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2771), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [46768] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4468), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4478), 1,
      anon_sym_QMARK,
    ACTIONS(4480), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    ACTIONS(4500), 1,
      anon_sym_rescue,
    STATE(2772), 1,
      sym_heredoc_body,
    STATE(2781), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [46864] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3254), 1,
      anon_sym_ri,
    STATE(2773), 1,
      sym_heredoc_body,
    ACTIONS(3252), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3250), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3248), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46928] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4502), 1,
      anon_sym_COLON,
    STATE(2205), 1,
      aux_sym_chained_string_repeat1,
    STATE(2270), 1,
      sym_string,
    STATE(2774), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46996] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(4458), 1,
      anon_sym_rescue,
    STATE(2775), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [47092] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(343), 1,
      sym__string_start,
    ACTIONS(3333), 1,
      anon_sym_COLON,
    STATE(2776), 1,
      sym_heredoc_body,
    STATE(2790), 1,
      aux_sym_chained_string_repeat1,
    STATE(2896), 1,
      sym_string,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3271), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(3104), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47162] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2777), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [47252] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2778), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [47342] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4504), 1,
      anon_sym_COMMA,
    STATE(2779), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47404] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2780), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [47498] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4464), 1,
      anon_sym_COMMA,
    STATE(2779), 1,
      aux_sym_exceptions_repeat1,
    STATE(2781), 1,
      sym_heredoc_body,
    ACTIONS(4030), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47562] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2782), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [47655] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2783), 1,
      sym_heredoc_body,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 34,
      sym__line_break,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47718] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2784), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [47807] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4399), 1,
      anon_sym_rescue,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2785), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [47898] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2786), 1,
      sym_heredoc_body,
    ACTIONS(3801), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47959] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2787), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4450), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [48048] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2788), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [48137] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(3210), 1,
      anon_sym_do,
    STATE(2789), 1,
      sym_heredoc_body,
    STATE(2976), 1,
      sym_do_block,
    STATE(2977), 1,
      sym_block,
    ACTIONS(3309), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3307), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48204] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(343), 1,
      sym__string_start,
    STATE(2790), 1,
      sym_heredoc_body,
    STATE(2838), 1,
      aux_sym_chained_string_repeat1,
    STATE(2896), 1,
      sym_string,
    ACTIONS(3258), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3256), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48269] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2791), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4448), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [48358] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2792), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48419] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2793), 1,
      sym_heredoc_body,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 32,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48482] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2794), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48543] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2795), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48604] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2796), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48665] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2797), 1,
      sym_heredoc_body,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48734] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2798), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48799] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2799), 1,
      sym_heredoc_body,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48866] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2800), 1,
      sym_heredoc_body,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48939] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3995), 1,
      sym__element_reference_bracket,
    ACTIONS(4539), 1,
      anon_sym_DOT,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4543), 1,
      anon_sym_AMP_DOT,
    STATE(2801), 1,
      sym_heredoc_body,
    ACTIONS(3543), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49006] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2802), 1,
      sym_heredoc_body,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 20,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [49089] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2803), 1,
      sym_heredoc_body,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 21,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [49170] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4545), 1,
      sym__binary_star_star,
    STATE(2804), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49231] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2805), 1,
      sym_heredoc_body,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49296] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2806), 1,
      sym_heredoc_body,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 21,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [49377] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4468), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4478), 1,
      anon_sym_QMARK,
    ACTIONS(4480), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    ACTIONS(4500), 1,
      anon_sym_rescue,
    STATE(2807), 1,
      sym_heredoc_body,
    ACTIONS(3551), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [49470] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2808), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [49559] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4399), 1,
      anon_sym_rescue,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2809), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [49654] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2810), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [49741] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2811), 1,
      sym_heredoc_body,
    ACTIONS(4060), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49802] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    STATE(2205), 1,
      aux_sym_chained_string_repeat1,
    STATE(2270), 1,
      sym_string,
    STATE(2812), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49867] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2813), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 23,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [49948] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2814), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [50037] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2815), 1,
      sym_heredoc_body,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 32,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50102] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(343), 1,
      sym__string_start,
    STATE(2790), 1,
      aux_sym_chained_string_repeat1,
    STATE(2816), 1,
      sym_heredoc_body,
    STATE(2896), 1,
      sym_string,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3271), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(3104), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50169] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4547), 1,
      sym__binary_star_star,
    STATE(2817), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50230] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2818), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 23,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [50311] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2819), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 22,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [50394] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3254), 1,
      anon_sym_ri,
    STATE(2820), 1,
      sym_heredoc_body,
    ACTIONS(3252), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3250), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3248), 33,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50457] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2821), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [50546] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2822), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [50639] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(2823), 1,
      sym_heredoc_body,
    STATE(2928), 1,
      sym_argument_list,
    ACTIONS(421), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(419), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50702] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4468), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4480), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2824), 1,
      sym_heredoc_body,
    ACTIONS(4096), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 18,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [50791] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2825), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4456), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [50880] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4468), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4478), 1,
      anon_sym_QMARK,
    ACTIONS(4480), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2826), 1,
      sym_heredoc_body,
    ACTIONS(3841), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [50971] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2827), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 29,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51044] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2828), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51111] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2829), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51180] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2830), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [51267] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4468), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4478), 1,
      anon_sym_QMARK,
    ACTIONS(4480), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2831), 1,
      sym_heredoc_body,
    ACTIONS(4066), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [51358] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2832), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51419] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2833), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51480] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(3210), 1,
      anon_sym_do,
    STATE(2834), 1,
      sym_heredoc_body,
    STATE(2931), 1,
      sym_do_block,
    STATE(2954), 1,
      sym_block,
    ACTIONS(3315), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3313), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51547] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4468), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4478), 1,
      anon_sym_QMARK,
    ACTIONS(4480), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2835), 1,
      sym_heredoc_body,
    ACTIONS(4086), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [51638] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2836), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [51727] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2837), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [51816] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4549), 1,
      sym__string_start,
    STATE(2896), 1,
      sym_string,
    STATE(2838), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(3266), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3264), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51879] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(2839), 1,
      sym_heredoc_body,
    STATE(2971), 1,
      sym_argument_list,
    ACTIONS(429), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(427), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51942] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4468), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4478), 1,
      anon_sym_QMARK,
    ACTIONS(4480), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    ACTIONS(4500), 1,
      anon_sym_rescue,
    STATE(2840), 1,
      sym_heredoc_body,
    ACTIONS(3527), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [52035] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(2841), 1,
      sym_heredoc_body,
    STATE(2959), 1,
      sym_argument_list,
    ACTIONS(425), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(423), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52098] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4468), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4478), 1,
      anon_sym_QMARK,
    ACTIONS(4480), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2842), 1,
      sym_heredoc_body,
    ACTIONS(4100), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [52189] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4468), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4478), 1,
      anon_sym_QMARK,
    ACTIONS(4480), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2843), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [52280] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4468), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4480), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2844), 1,
      sym_heredoc_body,
    ACTIONS(4082), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 18,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [52369] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4468), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4478), 1,
      anon_sym_QMARK,
    ACTIONS(4480), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2845), 1,
      sym_heredoc_body,
    ACTIONS(3801), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [52460] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_PIPE,
    ACTIONS(4468), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_AMP,
    ACTIONS(4474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4476), 1,
      anon_sym_CARET,
    ACTIONS(4478), 1,
      anon_sym_QMARK,
    ACTIONS(4480), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4486), 1,
      anon_sym_GT_EQ,
    ACTIONS(4492), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4496), 1,
      sym__binary_star_star,
    STATE(2846), 1,
      sym_heredoc_body,
    ACTIONS(3801), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4488), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4472), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4490), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4494), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [52551] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(2847), 1,
      sym_heredoc_body,
    STATE(2985), 1,
      sym_argument_list,
    ACTIONS(3295), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3293), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52614] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(3210), 1,
      anon_sym_do,
    STATE(2848), 1,
      sym_heredoc_body,
    STATE(2902), 1,
      sym_block,
    STATE(2908), 1,
      sym_do_block,
    ACTIONS(3305), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3303), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52681] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2849), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [52774] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(2850), 1,
      sym_heredoc_body,
    STATE(2973), 1,
      sym_argument_list,
    ACTIONS(3319), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3317), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52837] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(2851), 1,
      sym_heredoc_body,
    STATE(2937), 1,
      sym_argument_list,
    ACTIONS(417), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(415), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52900] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(343), 1,
      sym__string_start,
    STATE(2790), 1,
      aux_sym_chained_string_repeat1,
    STATE(2852), 1,
      sym_heredoc_body,
    STATE(2896), 1,
      sym_string,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52965] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    STATE(2853), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53025] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    ACTIONS(4554), 1,
      anon_sym_PIPE,
    ACTIONS(4556), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4562), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4564), 1,
      anon_sym_CARET,
    ACTIONS(4566), 1,
      anon_sym_QMARK,
    ACTIONS(4568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4574), 1,
      anon_sym_GT_EQ,
    ACTIONS(4580), 1,
      anon_sym_EQ_EQ,
    STATE(2854), 1,
      sym_heredoc_body,
    ACTIONS(4086), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4560), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [53115] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    STATE(2855), 1,
      sym_heredoc_body,
    ACTIONS(4572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53183] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    STATE(2856), 1,
      sym_heredoc_body,
    ACTIONS(3801), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53243] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_rescue,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    ACTIONS(4554), 1,
      anon_sym_PIPE,
    ACTIONS(4556), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4562), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4564), 1,
      anon_sym_CARET,
    ACTIONS(4566), 1,
      anon_sym_QMARK,
    ACTIONS(4568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4574), 1,
      anon_sym_GT_EQ,
    ACTIONS(4580), 1,
      anon_sym_EQ_EQ,
    STATE(2857), 1,
      sym_heredoc_body,
    ACTIONS(3551), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4560), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 15,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [53335] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    STATE(2858), 1,
      sym_heredoc_body,
    ACTIONS(4572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53401] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    STATE(2859), 1,
      sym_heredoc_body,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53463] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    ACTIONS(4554), 1,
      anon_sym_PIPE,
    ACTIONS(4556), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4562), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4564), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4574), 1,
      anon_sym_GT_EQ,
    ACTIONS(4580), 1,
      anon_sym_EQ_EQ,
    STATE(2860), 1,
      sym_heredoc_body,
    ACTIONS(4096), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4560), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [53551] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    ACTIONS(4554), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_CARET,
    STATE(2861), 1,
      sym_heredoc_body,
    ACTIONS(4572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53623] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2862), 1,
      sym_heredoc_body,
    ACTIONS(2628), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2630), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53681] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym___END__,
    ACTIONS(4584), 1,
      anon_sym_rescue,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2863), 1,
      sym_heredoc_body,
    STATE(2877), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [53775] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(343), 1,
      sym__string_start,
    ACTIONS(4618), 1,
      anon_sym_COLON,
    STATE(2790), 1,
      aux_sym_chained_string_repeat1,
    STATE(2864), 1,
      sym_heredoc_body,
    STATE(2896), 1,
      sym_string,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53841] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    ACTIONS(4554), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_CARET,
    ACTIONS(4570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4574), 1,
      anon_sym_GT_EQ,
    ACTIONS(4580), 1,
      anon_sym_EQ_EQ,
    STATE(2865), 1,
      sym_heredoc_body,
    ACTIONS(4572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4560), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [53923] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4620), 1,
      sym__binary_star_star,
    STATE(2866), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53983] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4622), 1,
      anon_sym_COMMA,
    STATE(2867), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54043] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_COMMA,
    STATE(2868), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54103] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2869), 1,
      sym_heredoc_body,
    ACTIONS(2624), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2626), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54161] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    ACTIONS(4554), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_CARET,
    ACTIONS(4574), 1,
      anon_sym_GT_EQ,
    ACTIONS(4580), 1,
      anon_sym_EQ_EQ,
    STATE(2870), 1,
      sym_heredoc_body,
    ACTIONS(4572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4560), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 20,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [54241] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    STATE(2871), 1,
      sym_heredoc_body,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 29,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54305] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    ACTIONS(4554), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_CARET,
    ACTIONS(4574), 1,
      anon_sym_GT_EQ,
    ACTIONS(4580), 1,
      anon_sym_EQ_EQ,
    STATE(2872), 1,
      sym_heredoc_body,
    ACTIONS(4572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4560), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 20,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [54385] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2873), 1,
      sym_heredoc_body,
    STATE(2877), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54445] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    STATE(2874), 1,
      sym_heredoc_body,
    STATE(2906), 1,
      sym_block,
    STATE(2907), 1,
      sym_do_block,
    STATE(3106), 1,
      sym_argument_list,
    ACTIONS(413), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(411), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54513] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym___END__,
    ACTIONS(4584), 1,
      anon_sym_rescue,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    STATE(2875), 1,
      sym_heredoc_body,
    STATE(2877), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [54611] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2876), 1,
      sym_heredoc_body,
    ACTIONS(3323), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3321), 35,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54669] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4632), 1,
      anon_sym_COMMA,
    STATE(2867), 1,
      aux_sym_exceptions_repeat1,
    STATE(2877), 1,
      sym_heredoc_body,
    ACTIONS(4030), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54731] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2878), 1,
      sym_heredoc_body,
    ACTIONS(2644), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2646), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54789] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2879), 1,
      sym_heredoc_body,
    ACTIONS(2616), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2618), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54847] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2880), 1,
      sym_heredoc_body,
    STATE(2893), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54907] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2881), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [54995] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    STATE(2882), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55055] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    STATE(2883), 1,
      sym_heredoc_body,
    ACTIONS(4060), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55115] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_rescue,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    ACTIONS(4554), 1,
      anon_sym_PIPE,
    ACTIONS(4556), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4562), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4564), 1,
      anon_sym_CARET,
    ACTIONS(4566), 1,
      anon_sym_QMARK,
    ACTIONS(4568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4574), 1,
      anon_sym_GT_EQ,
    ACTIONS(4580), 1,
      anon_sym_EQ_EQ,
    STATE(2884), 1,
      sym_heredoc_body,
    ACTIONS(3527), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4560), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 15,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [55207] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4634), 1,
      anon_sym_COLON,
    STATE(2205), 1,
      aux_sym_chained_string_repeat1,
    STATE(2270), 1,
      sym_string,
    STATE(2885), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55273] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    ACTIONS(4554), 1,
      anon_sym_PIPE,
    ACTIONS(4556), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4562), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4564), 1,
      anon_sym_CARET,
    ACTIONS(4566), 1,
      anon_sym_QMARK,
    ACTIONS(4568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4574), 1,
      anon_sym_GT_EQ,
    ACTIONS(4580), 1,
      anon_sym_EQ_EQ,
    STATE(2886), 1,
      sym_heredoc_body,
    ACTIONS(3801), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4560), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [55363] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    ACTIONS(4554), 1,
      anon_sym_PIPE,
    ACTIONS(4556), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4562), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4564), 1,
      anon_sym_CARET,
    ACTIONS(4566), 1,
      anon_sym_QMARK,
    ACTIONS(4568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4574), 1,
      anon_sym_GT_EQ,
    ACTIONS(4580), 1,
      anon_sym_EQ_EQ,
    STATE(2887), 1,
      sym_heredoc_body,
    ACTIONS(3801), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4560), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [55453] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2888), 1,
      sym_heredoc_body,
    ACTIONS(3301), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3299), 35,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55511] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4636), 1,
      sym__binary_star_star,
    STATE(2889), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55571] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4638), 1,
      anon_sym_COMMA,
    STATE(2890), 1,
      sym_heredoc_body,
    STATE(2893), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55633] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2891), 1,
      sym_heredoc_body,
    ACTIONS(3349), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    ACTIONS(3012), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3010), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55693] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(4640), 1,
      anon_sym_rescue,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      anon_sym_QMARK,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2892), 1,
      sym_heredoc_body,
    STATE(2893), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [55787] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4638), 1,
      anon_sym_COMMA,
    STATE(2868), 1,
      aux_sym_exceptions_repeat1,
    STATE(2893), 1,
      sym_heredoc_body,
    ACTIONS(4030), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55849] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3349), 1,
      anon_sym_LBRACE,
    STATE(2894), 1,
      sym_heredoc_body,
    ACTIONS(3012), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3010), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55909] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    ACTIONS(4554), 1,
      anon_sym_PIPE,
    ACTIONS(4556), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4562), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4564), 1,
      anon_sym_CARET,
    ACTIONS(4566), 1,
      anon_sym_QMARK,
    ACTIONS(4568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4574), 1,
      anon_sym_GT_EQ,
    ACTIONS(4580), 1,
      anon_sym_EQ_EQ,
    STATE(2895), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4560), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [55999] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2896), 1,
      sym_heredoc_body,
    ACTIONS(3337), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3335), 35,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56057] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(4638), 1,
      anon_sym_COMMA,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      anon_sym_QMARK,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    ACTIONS(4674), 1,
      anon_sym_rescue,
    STATE(2893), 1,
      aux_sym_exceptions_repeat1,
    STATE(2897), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [56153] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    ACTIONS(4554), 1,
      anon_sym_PIPE,
    ACTIONS(4556), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4562), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4564), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4574), 1,
      anon_sym_GT_EQ,
    ACTIONS(4580), 1,
      anon_sym_EQ_EQ,
    STATE(2898), 1,
      sym_heredoc_body,
    ACTIONS(4082), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4560), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [56241] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    ACTIONS(4554), 1,
      anon_sym_PIPE,
    ACTIONS(4556), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4562), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4564), 1,
      anon_sym_CARET,
    ACTIONS(4566), 1,
      anon_sym_QMARK,
    ACTIONS(4568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4574), 1,
      anon_sym_GT_EQ,
    ACTIONS(4580), 1,
      anon_sym_EQ_EQ,
    STATE(2899), 1,
      sym_heredoc_body,
    ACTIONS(4100), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4560), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [56331] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      anon_sym_QMARK,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2900), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [56420] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym___END__,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2901), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [56509] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2902), 1,
      sym_heredoc_body,
    ACTIONS(3389), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3387), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56566] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2903), 1,
      sym_heredoc_body,
    ACTIONS(3669), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3667), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56623] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2904), 1,
      sym_heredoc_body,
    ACTIONS(3645), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3643), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56680] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2905), 1,
      sym_heredoc_body,
    ACTIONS(3607), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3605), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56737] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2906), 1,
      sym_heredoc_body,
    ACTIONS(3423), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3421), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56794] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2907), 1,
      sym_heredoc_body,
    ACTIONS(3423), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3421), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56851] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2908), 1,
      sym_heredoc_body,
    ACTIONS(3389), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3387), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56908] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4066), 1,
      anon_sym___END__,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2909), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [56997] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2910), 1,
      sym_heredoc_body,
    ACTIONS(3008), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3006), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57054] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2911), 1,
      sym_heredoc_body,
    ACTIONS(3725), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3723), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57111] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2912), 1,
      sym_heredoc_body,
    ACTIONS(3451), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3449), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57168] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2913), 1,
      sym_heredoc_body,
    ACTIONS(3373), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3371), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57225] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(343), 1,
      sym__string_start,
    ACTIONS(3271), 1,
      anon_sym_EQ_GT,
    STATE(2790), 1,
      aux_sym_chained_string_repeat1,
    STATE(2896), 1,
      sym_string,
    STATE(2914), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57290] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym___END__,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2915), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [57379] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym___END__,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2916), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [57468] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4676), 1,
      anon_sym___END__,
    ACTIONS(4678), 1,
      anon_sym_EQ_GT,
    STATE(2917), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [57561] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym___END__,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2918), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [57648] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2919), 1,
      sym_heredoc_body,
    ACTIONS(3873), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57705] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym___END__,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2920), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [57794] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2921), 1,
      sym_heredoc_body,
    ACTIONS(3401), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3399), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57851] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2922), 1,
      sym_heredoc_body,
    ACTIONS(3657), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3655), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57908] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2923), 1,
      sym_heredoc_body,
    ACTIONS(3419), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3349), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57965] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym___END__,
    ACTIONS(4584), 1,
      anon_sym_rescue,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    STATE(2924), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [58060] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2925), 1,
      sym_heredoc_body,
    ACTIONS(3499), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3497), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58117] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2926), 1,
      sym_heredoc_body,
    ACTIONS(3515), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3513), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58174] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2927), 1,
      sym_heredoc_body,
    ACTIONS(3805), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3803), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58231] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2928), 1,
      sym_heredoc_body,
    ACTIONS(3555), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3553), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58288] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2929), 1,
      sym_heredoc_body,
    ACTIONS(3713), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3711), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58345] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym___END__,
    ACTIONS(4584), 1,
      anon_sym_rescue,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2930), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [58436] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2931), 1,
      sym_heredoc_body,
    ACTIONS(3603), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3601), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58493] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2932), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58552] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2933), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58611] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2934), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58678] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2935), 1,
      sym_heredoc_body,
    ACTIONS(3745), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3743), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58735] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2936), 1,
      sym_heredoc_body,
    ACTIONS(3381), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3379), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58792] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2937), 1,
      sym_heredoc_body,
    ACTIONS(3591), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3589), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58849] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2938), 1,
      sym_heredoc_body,
    ACTIONS(3869), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3867), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58906] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4066), 1,
      anon_sym_DOT,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      anon_sym_QMARK,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2939), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [58995] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3841), 1,
      anon_sym_DOT,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      anon_sym_QMARK,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2940), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [59084] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2941), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59149] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2942), 1,
      sym_heredoc_body,
    ACTIONS(3749), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3747), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59206] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2943), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym___END__,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59277] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2944), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [59358] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2945), 1,
      sym_heredoc_body,
    ACTIONS(3523), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59415] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3271), 1,
      anon_sym_EQ_GT,
    ACTIONS(4680), 1,
      anon_sym_COLON,
    STATE(2205), 1,
      aux_sym_chained_string_repeat1,
    STATE(2270), 1,
      sym_string,
    STATE(2946), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59482] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2947), 1,
      sym_heredoc_body,
    ACTIONS(3587), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59539] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2948), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 20,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [59618] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2949), 1,
      sym_heredoc_body,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 29,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59681] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2950), 1,
      sym_heredoc_body,
    ACTIONS(3048), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3046), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59738] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2951), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 20,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [59817] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2952), 1,
      sym_heredoc_body,
    ACTIONS(3467), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3465), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59874] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2953), 1,
      sym_heredoc_body,
    ACTIONS(3443), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3441), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59931] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2954), 1,
      sym_heredoc_body,
    ACTIONS(3603), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3601), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59988] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2955), 1,
      sym_heredoc_body,
    ACTIONS(3741), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3739), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60045] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2956), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60104] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(4640), 1,
      anon_sym_rescue,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      anon_sym_QMARK,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2957), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [60195] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2958), 1,
      sym_heredoc_body,
    ACTIONS(3052), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3050), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60252] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2959), 1,
      sym_heredoc_body,
    ACTIONS(3629), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3627), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60309] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2960), 1,
      sym_heredoc_body,
    ACTIONS(3813), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3811), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60366] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2961), 1,
      sym_heredoc_body,
    ACTIONS(3056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3054), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60423] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2962), 1,
      sym_heredoc_body,
    ACTIONS(3060), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3058), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60480] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym___END__,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    STATE(2963), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [60573] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(4112), 1,
      anon_sym_AMP_DOT,
    ACTIONS(4682), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4684), 1,
      sym__element_reference_bracket,
    STATE(2964), 1,
      sym_heredoc_body,
    ACTIONS(3543), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60638] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2965), 1,
      sym_heredoc_body,
    ACTIONS(3697), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3695), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60695] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    STATE(2966), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60758] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2967), 1,
      sym_heredoc_body,
    ACTIONS(3427), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3425), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60815] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2968), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60874] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2969), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 17,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [60961] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2970), 1,
      sym_heredoc_body,
    ACTIONS(3064), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3062), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61018] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2971), 1,
      sym_heredoc_body,
    ACTIONS(3701), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3699), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61075] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2972), 1,
      sym_heredoc_body,
    ACTIONS(3106), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61132] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2973), 1,
      sym_heredoc_body,
    ACTIONS(3705), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3703), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61189] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2974), 1,
      sym_heredoc_body,
    ACTIONS(3617), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3615), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61246] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    STATE(2975), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61307] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2976), 1,
      sym_heredoc_body,
    ACTIONS(3579), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3577), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61364] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2977), 1,
      sym_heredoc_body,
    ACTIONS(3579), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3577), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61421] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4686), 1,
      sym__binary_star_star,
    STATE(2978), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61480] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym___END__,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    STATE(2979), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [61573] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2980), 1,
      sym_heredoc_body,
    ACTIONS(3849), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3847), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61630] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2981), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61689] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2982), 1,
      sym_heredoc_body,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61750] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2983), 1,
      sym_heredoc_body,
    ACTIONS(3527), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3525), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61807] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2984), 1,
      sym_heredoc_body,
    ACTIONS(3737), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3735), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61864] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2985), 1,
      sym_heredoc_body,
    ACTIONS(3343), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3341), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61921] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2986), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61980] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2987), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62039] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2988), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62106] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2989), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62171] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      anon_sym_QMARK,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2990), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [62260] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2991), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62331] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2992), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [62412] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2993), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 20,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [62491] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2994), 1,
      sym_heredoc_body,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 29,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62554] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2995), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 20,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [62633] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym___END__,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2996), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [62720] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(2997), 1,
      sym_heredoc_body,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62781] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2998), 1,
      sym_heredoc_body,
    ACTIONS(3559), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62838] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(2999), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62897] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3000), 1,
      sym_heredoc_body,
    ACTIONS(3068), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3066), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62954] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      anon_sym_QMARK,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(3001), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [63043] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(3002), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 17,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [63130] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3003), 1,
      sym_heredoc_body,
    ACTIONS(3491), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3489), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63187] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3004), 1,
      sym_heredoc_body,
    ACTIONS(3539), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3537), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63244] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3005), 1,
      sym_heredoc_body,
    ACTIONS(3365), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3363), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63301] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      anon_sym_QMARK,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(3006), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [63390] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3007), 1,
      sym_heredoc_body,
    ACTIONS(3365), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3363), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63447] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3008), 1,
      sym_heredoc_body,
    ACTIONS(3595), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3593), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63504] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym___END__,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(3009), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [63593] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3010), 1,
      sym_heredoc_body,
    ACTIONS(3357), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3355), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63650] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4640), 1,
      anon_sym_rescue,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      anon_sym_QMARK,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(3011), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [63741] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3012), 1,
      sym_heredoc_body,
    ACTIONS(3757), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3755), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63798] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3013), 1,
      sym_heredoc_body,
    ACTIONS(3397), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3395), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63855] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3014), 1,
      sym_heredoc_body,
    ACTIONS(3377), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3375), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63912] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3015), 1,
      sym_heredoc_body,
    ACTIONS(3777), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3775), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63969] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3016), 1,
      sym_heredoc_body,
    ACTIONS(3769), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3767), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64026] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3017), 1,
      sym_heredoc_body,
    ACTIONS(3789), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3787), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64083] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      anon_sym_QMARK,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    STATE(3018), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [64172] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4688), 1,
      sym__binary_star_star,
    STATE(3019), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64231] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3020), 1,
      sym_heredoc_body,
    ACTIONS(3801), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64288] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3021), 1,
      sym_heredoc_body,
    ACTIONS(3865), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3863), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64345] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3022), 1,
      sym_heredoc_body,
    ACTIONS(3821), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3819), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64402] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3023), 1,
      sym_heredoc_body,
    ACTIONS(3531), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3529), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64459] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3024), 1,
      sym_heredoc_body,
    ACTIONS(3781), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3779), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64516] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3025), 1,
      sym_heredoc_body,
    ACTIONS(3797), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3795), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64573] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(343), 1,
      sym__string_start,
    ACTIONS(4690), 1,
      anon_sym_COLON,
    STATE(2790), 1,
      aux_sym_chained_string_repeat1,
    STATE(2896), 1,
      sym_string,
    STATE(3026), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64638] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3027), 1,
      sym_heredoc_body,
    ACTIONS(3547), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3545), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64695] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3028), 1,
      sym_heredoc_body,
    ACTIONS(3809), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3807), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64752] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3029), 1,
      sym_heredoc_body,
    ACTIONS(3825), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3823), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64809] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3030), 1,
      sym_heredoc_body,
    ACTIONS(3455), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3453), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64866] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3031), 1,
      sym_heredoc_body,
    ACTIONS(3409), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3407), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64923] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3032), 1,
      sym_heredoc_body,
    ACTIONS(3250), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3248), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64980] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3033), 1,
      sym_heredoc_body,
    ACTIONS(3853), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3851), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65037] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3034), 1,
      sym_heredoc_body,
    ACTIONS(3439), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3437), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65094] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3035), 1,
      sym_heredoc_body,
    ACTIONS(3413), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3411), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65151] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3036), 1,
      sym_heredoc_body,
    ACTIONS(3833), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3831), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65208] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3037), 1,
      sym_heredoc_body,
    ACTIONS(3543), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65265] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3038), 1,
      sym_heredoc_body,
    ACTIONS(3507), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3505), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65322] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3039), 1,
      sym_heredoc_body,
    ACTIONS(3837), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3835), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65379] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3040), 1,
      sym_heredoc_body,
    ACTIONS(3435), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3433), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65436] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3041), 1,
      sym_heredoc_body,
    ACTIONS(3583), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3581), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65493] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3042), 1,
      sym_heredoc_body,
    ACTIONS(3613), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3611), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65550] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3043), 1,
      sym_heredoc_body,
    ACTIONS(3793), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3791), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65607] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3044), 1,
      sym_heredoc_body,
    ACTIONS(3573), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3571), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65664] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3045), 1,
      sym_heredoc_body,
    ACTIONS(3765), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3763), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65721] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3046), 1,
      sym_heredoc_body,
    ACTIONS(3761), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3759), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65778] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3047), 1,
      sym_heredoc_body,
    ACTIONS(3817), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3815), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65835] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3048), 1,
      sym_heredoc_body,
    ACTIONS(3431), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65892] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3049), 1,
      sym_heredoc_body,
    ACTIONS(3599), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3597), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65949] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3050), 1,
      sym_heredoc_body,
    ACTIONS(3361), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3359), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66006] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3051), 1,
      sym_heredoc_body,
    ACTIONS(3012), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3010), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66063] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3254), 1,
      anon_sym_ri,
    STATE(3052), 1,
      sym_heredoc_body,
    ACTIONS(3252), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3250), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3248), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66124] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3053), 1,
      sym_heredoc_body,
    ACTIONS(3785), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3783), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66181] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3054), 1,
      sym_heredoc_body,
    ACTIONS(3024), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3022), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66238] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3055), 1,
      sym_heredoc_body,
    ACTIONS(3633), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3631), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66295] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3056), 1,
      sym_heredoc_body,
    ACTIONS(3511), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3509), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66352] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3057), 1,
      sym_heredoc_body,
    ACTIONS(3845), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3843), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66409] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3058), 1,
      sym_heredoc_body,
    ACTIONS(3857), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3855), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66466] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3059), 1,
      sym_heredoc_body,
    ACTIONS(3000), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2998), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66523] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3060), 1,
      sym_heredoc_body,
    ACTIONS(3353), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3351), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66580] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3841), 1,
      anon_sym___END__,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    STATE(3061), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [66669] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3062), 1,
      sym_heredoc_body,
    ACTIONS(3032), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3030), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66726] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3063), 1,
      sym_heredoc_body,
    ACTIONS(3004), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3002), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66783] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3064), 1,
      sym_heredoc_body,
    ACTIONS(3685), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3683), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66840] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3065), 1,
      sym_heredoc_body,
    ACTIONS(3036), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3034), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66897] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3066), 1,
      sym_heredoc_body,
    ACTIONS(3733), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3731), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66954] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3067), 1,
      sym_heredoc_body,
    ACTIONS(3625), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3623), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67011] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3068), 1,
      sym_heredoc_body,
    ACTIONS(3729), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3727), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67068] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3563), 1,
      anon_sym_DOT,
    ACTIONS(3567), 1,
      anon_sym_AMP_DOT,
    ACTIONS(4684), 1,
      sym__element_reference_bracket,
    ACTIONS(4692), 1,
      anon_sym_COLON_COLON2,
    STATE(3069), 1,
      sym_heredoc_body,
    ACTIONS(3543), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67133] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3070), 1,
      sym_heredoc_body,
    ACTIONS(3717), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3715), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67190] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3071), 1,
      sym_heredoc_body,
    ACTIONS(3621), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3619), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67247] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3072), 1,
      sym_heredoc_body,
    ACTIONS(3535), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3533), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67304] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3073), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67361] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3074), 1,
      sym_heredoc_body,
    ACTIONS(3503), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3501), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67418] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3075), 1,
      sym_heredoc_body,
    ACTIONS(3753), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3751), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67475] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3076), 1,
      sym_heredoc_body,
    ACTIONS(3495), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3493), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67532] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3077), 1,
      sym_heredoc_body,
    ACTIONS(3347), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3345), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67589] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3078), 1,
      sym_heredoc_body,
    ACTIONS(3693), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3691), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67646] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3079), 1,
      sym_heredoc_body,
    ACTIONS(3487), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3485), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67703] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3080), 1,
      sym_heredoc_body,
    ACTIONS(3681), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3679), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67760] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3081), 1,
      sym_heredoc_body,
    ACTIONS(3483), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3481), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67817] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3082), 1,
      sym_heredoc_body,
    ACTIONS(3653), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3651), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67874] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3083), 1,
      sym_heredoc_body,
    ACTIONS(3649), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3647), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67931] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3084), 1,
      sym_heredoc_body,
    ACTIONS(3641), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3639), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67988] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3085), 1,
      sym_heredoc_body,
    ACTIONS(3773), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3771), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68045] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(343), 1,
      sym__string_start,
    ACTIONS(3271), 1,
      anon_sym_EQ_GT,
    ACTIONS(4694), 1,
      anon_sym_COLON,
    STATE(2790), 1,
      aux_sym_chained_string_repeat1,
    STATE(2896), 1,
      sym_string,
    STATE(3086), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68112] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3087), 1,
      sym_heredoc_body,
    ACTIONS(3637), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3635), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68169] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3088), 1,
      sym_heredoc_body,
    ACTIONS(3519), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3517), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68226] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3089), 1,
      sym_heredoc_body,
    ACTIONS(3393), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3391), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68283] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3090), 1,
      sym_heredoc_body,
    ACTIONS(3551), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3549), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68340] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3091), 1,
      sym_heredoc_body,
    ACTIONS(3479), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3477), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68397] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3092), 1,
      sym_heredoc_body,
    ACTIONS(3475), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3473), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68454] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3093), 1,
      sym_heredoc_body,
    ACTIONS(3459), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3457), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68511] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    ACTIONS(4676), 1,
      anon_sym___END__,
    STATE(3094), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [68604] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3095), 1,
      sym_heredoc_body,
    ACTIONS(3665), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3663), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68661] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3096), 1,
      sym_heredoc_body,
    ACTIONS(3677), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3675), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68718] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3097), 1,
      sym_heredoc_body,
    ACTIONS(3447), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3445), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68775] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3098), 1,
      sym_heredoc_body,
    ACTIONS(3709), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3707), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68832] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3099), 1,
      sym_heredoc_body,
    ACTIONS(3721), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3719), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68889] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3100), 1,
      sym_heredoc_body,
    ACTIONS(3829), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3827), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68946] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3101), 1,
      sym_heredoc_body,
    ACTIONS(3076), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3074), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69003] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3102), 1,
      sym_heredoc_body,
    ACTIONS(3044), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3042), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69060] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3103), 1,
      sym_heredoc_body,
    ACTIONS(3405), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3403), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69117] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3104), 1,
      sym_heredoc_body,
    ACTIONS(3072), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3070), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69174] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3105), 1,
      sym_heredoc_body,
    ACTIONS(3841), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69231] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    STATE(2931), 1,
      sym_do_block,
    STATE(2954), 1,
      sym_block,
    STATE(3106), 1,
      sym_heredoc_body,
    ACTIONS(3315), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3313), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69293] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4696), 1,
      anon_sym_COMMA,
    STATE(3107), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69351] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3108), 1,
      sym_heredoc_body,
    ACTIONS(3573), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3571), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69407] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(4699), 1,
      anon_sym_PIPE,
    ACTIONS(4701), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4707), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4709), 1,
      anon_sym_CARET,
    ACTIONS(4711), 1,
      anon_sym_QMARK,
    ACTIONS(4713), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4719), 1,
      anon_sym_GT_EQ,
    ACTIONS(4725), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3109), 1,
      sym_heredoc_body,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4705), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4727), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [69495] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3110), 1,
      sym_heredoc_body,
    ACTIONS(3419), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3609), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(3349), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69553] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3111), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69611] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3112), 1,
      sym_heredoc_body,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69671] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3113), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69729] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3114), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3561), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(3104), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69787] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3115), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69845] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3116), 1,
      sym_heredoc_body,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69911] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3117), 1,
      sym_heredoc_body,
    STATE(3136), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69969] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym___END__,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    ACTIONS(4731), 1,
      anon_sym_rescue,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3118), 1,
      sym_heredoc_body,
    STATE(3136), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [70065] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3119), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3271), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(3104), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70123] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(4699), 1,
      anon_sym_PIPE,
    ACTIONS(4701), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4707), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4709), 1,
      anon_sym_CARET,
    ACTIONS(4713), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4719), 1,
      anon_sym_GT_EQ,
    ACTIONS(4725), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3120), 1,
      sym_heredoc_body,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4705), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4727), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [70209] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym___END__,
    ACTIONS(4731), 1,
      anon_sym_rescue,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3121), 1,
      sym_heredoc_body,
    STATE(3136), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [70301] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3122), 1,
      sym_heredoc_body,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70365] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4674), 1,
      anon_sym_rescue,
    ACTIONS(4699), 1,
      anon_sym_PIPE,
    ACTIONS(4701), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4707), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4709), 1,
      anon_sym_CARET,
    ACTIONS(4711), 1,
      anon_sym_QMARK,
    ACTIONS(4713), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4719), 1,
      anon_sym_GT_EQ,
    ACTIONS(4725), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3123), 1,
      sym_heredoc_body,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4705), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4727), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [70455] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3124), 1,
      sym_heredoc_body,
    ACTIONS(3419), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3349), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70511] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4699), 1,
      anon_sym_PIPE,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4709), 1,
      anon_sym_CARET,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3125), 1,
      sym_heredoc_body,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70581] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    ACTIONS(4699), 1,
      anon_sym_PIPE,
    ACTIONS(4701), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4707), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4709), 1,
      anon_sym_CARET,
    ACTIONS(4711), 1,
      anon_sym_QMARK,
    ACTIONS(4713), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4719), 1,
      anon_sym_GT_EQ,
    ACTIONS(4725), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3126), 1,
      sym_heredoc_body,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4705), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4727), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [70669] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4765), 1,
      anon_sym_COLON,
    STATE(2205), 1,
      aux_sym_chained_string_repeat1,
    STATE(2270), 1,
      sym_string,
    STATE(3127), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70733] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    ACTIONS(4699), 1,
      anon_sym_PIPE,
    ACTIONS(4701), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4707), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4709), 1,
      anon_sym_CARET,
    ACTIONS(4711), 1,
      anon_sym_QMARK,
    ACTIONS(4713), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4719), 1,
      anon_sym_GT_EQ,
    ACTIONS(4725), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3128), 1,
      sym_heredoc_body,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4705), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4727), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [70821] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    ACTIONS(4699), 1,
      anon_sym_PIPE,
    ACTIONS(4701), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4707), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4709), 1,
      anon_sym_CARET,
    ACTIONS(4713), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4719), 1,
      anon_sym_GT_EQ,
    ACTIONS(4725), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3129), 1,
      sym_heredoc_body,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4705), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4727), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [70907] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(4699), 1,
      anon_sym_PIPE,
    ACTIONS(4701), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4707), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4709), 1,
      anon_sym_CARET,
    ACTIONS(4711), 1,
      anon_sym_QMARK,
    ACTIONS(4713), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4719), 1,
      anon_sym_GT_EQ,
    ACTIONS(4725), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3130), 1,
      sym_heredoc_body,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4705), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4727), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [70995] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(4699), 1,
      anon_sym_PIPE,
    ACTIONS(4701), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4707), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4709), 1,
      anon_sym_CARET,
    ACTIONS(4711), 1,
      anon_sym_QMARK,
    ACTIONS(4713), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4719), 1,
      anon_sym_GT_EQ,
    ACTIONS(4725), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3131), 1,
      sym_heredoc_body,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4705), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4727), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [71083] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4699), 1,
      anon_sym_PIPE,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4709), 1,
      anon_sym_CARET,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4719), 1,
      anon_sym_GT_EQ,
    ACTIONS(4725), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3132), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4705), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4727), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 18,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [71163] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym___END__,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    ACTIONS(4767), 1,
      anon_sym_rescue,
    ACTIONS(4769), 1,
      anon_sym_COMMA,
    STATE(3133), 1,
      sym_heredoc_body,
    STATE(3136), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [71257] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4699), 1,
      anon_sym_PIPE,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4709), 1,
      anon_sym_CARET,
    ACTIONS(4719), 1,
      anon_sym_GT_EQ,
    ACTIONS(4725), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3134), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4705), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4727), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [71335] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3135), 1,
      sym_heredoc_body,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71397] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4769), 1,
      anon_sym_COMMA,
    STATE(3107), 1,
      aux_sym_exceptions_repeat1,
    STATE(3136), 1,
      sym_heredoc_body,
    ACTIONS(4030), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71457] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3137), 1,
      sym_heredoc_body,
    ACTIONS(3573), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3575), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(3571), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71515] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    STATE(2976), 1,
      sym_do_block,
    STATE(2977), 1,
      sym_block,
    STATE(3138), 1,
      sym_heredoc_body,
    ACTIONS(3309), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3307), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71577] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4699), 1,
      anon_sym_PIPE,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4709), 1,
      anon_sym_CARET,
    ACTIONS(4719), 1,
      anon_sym_GT_EQ,
    ACTIONS(4725), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3139), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4705), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4727), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [71655] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4771), 1,
      sym__binary_star_star,
    STATE(3140), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71713] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3141), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71771] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(4674), 1,
      anon_sym_rescue,
    ACTIONS(4699), 1,
      anon_sym_PIPE,
    ACTIONS(4701), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4707), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4709), 1,
      anon_sym_CARET,
    ACTIONS(4711), 1,
      anon_sym_QMARK,
    ACTIONS(4713), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4719), 1,
      anon_sym_GT_EQ,
    ACTIONS(4725), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    STATE(3142), 1,
      sym_heredoc_body,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4705), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4727), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [71861] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3969), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    ACTIONS(4773), 1,
      anon_sym_rescue,
    STATE(3143), 1,
      sym_heredoc_body,
    STATE(3222), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [71953] = 26,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym___END__,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    ACTIONS(4767), 1,
      anon_sym_rescue,
    ACTIONS(4769), 1,
      anon_sym_COMMA,
    STATE(3136), 1,
      aux_sym_exceptions_repeat1,
    STATE(3144), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [72051] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4769), 1,
      anon_sym_COMMA,
    STATE(3136), 1,
      aux_sym_exceptions_repeat1,
    STATE(3145), 1,
      sym_heredoc_body,
    ACTIONS(3559), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72111] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(343), 1,
      sym__string_start,
    ACTIONS(4775), 1,
      anon_sym_COLON,
    STATE(2790), 1,
      aux_sym_chained_string_repeat1,
    STATE(2896), 1,
      sym_string,
    STATE(3146), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72175] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4777), 1,
      sym__binary_star_star,
    STATE(3147), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72233] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4779), 1,
      sym__binary_star_star,
    STATE(3148), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72291] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3149), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72347] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    STATE(2902), 1,
      sym_block,
    STATE(2908), 1,
      sym_do_block,
    STATE(3150), 1,
      sym_heredoc_body,
    ACTIONS(3305), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3303), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72409] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(343), 1,
      sym__string_start,
    ACTIONS(3271), 1,
      anon_sym_EQ_GT,
    ACTIONS(4781), 1,
      anon_sym_COLON,
    STATE(2790), 1,
      aux_sym_chained_string_repeat1,
    STATE(2896), 1,
      sym_string,
    STATE(3151), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72475] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3152), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72531] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(1908), 1,
      sym_identifier_suffix,
    STATE(1909), 1,
      sym_constant_suffix,
    STATE(2258), 1,
      sym_argument_list,
    STATE(3153), 1,
      sym_heredoc_body,
    ACTIONS(4783), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4789), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4791), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1912), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4787), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4785), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [72602] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    ACTIONS(4676), 1,
      anon_sym___END__,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3154), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [72693] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4793), 1,
      sym_identifier,
    ACTIONS(4799), 1,
      sym_constant,
    STATE(2076), 1,
      sym_identifier_suffix,
    STATE(2077), 1,
      sym_constant_suffix,
    STATE(2241), 1,
      sym_argument_list,
    STATE(3155), 1,
      sym_heredoc_body,
    ACTIONS(4801), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4803), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2078), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4797), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4795), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [72766] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym___END__,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3156), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [72853] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym___END__,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3157), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [72940] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3158), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72997] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    ACTIONS(4805), 1,
      anon_sym___END__,
    STATE(3159), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4456), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [73084] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    ACTIONS(4807), 1,
      sym_identifier,
    ACTIONS(4813), 1,
      sym_constant,
    STATE(2216), 1,
      sym_identifier_suffix,
    STATE(2217), 1,
      sym_constant_suffix,
    STATE(3138), 1,
      sym_argument_list,
    STATE(3160), 1,
      sym_heredoc_body,
    ACTIONS(4815), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4817), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2203), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4811), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4809), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [73157] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3161), 1,
      sym_heredoc_body,
    STATE(3222), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [73214] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3969), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    ACTIONS(4773), 1,
      anon_sym_rescue,
    STATE(3162), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [73303] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4819), 1,
      sym_identifier,
    ACTIONS(4825), 1,
      sym_constant,
    STATE(1922), 1,
      sym_identifier_suffix,
    STATE(1924), 1,
      sym_constant_suffix,
    STATE(2258), 1,
      sym_argument_list,
    STATE(3163), 1,
      sym_heredoc_body,
    ACTIONS(4827), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4829), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1926), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4823), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4821), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [73376] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4831), 1,
      sym_identifier,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    ACTIONS(4839), 1,
      sym_constant,
    STATE(3164), 1,
      sym_heredoc_body,
    STATE(4862), 1,
      sym_constant_suffix,
    STATE(4864), 1,
      sym_identifier_suffix,
    STATE(5015), 1,
      sym_argument_list,
    ACTIONS(4841), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4843), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(4882), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4835), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4833), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [73449] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4676), 1,
      anon_sym___END__,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    ACTIONS(4845), 1,
      anon_sym_EQ_GT,
    STATE(3165), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [73540] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4783), 1,
      sym_identifier,
    ACTIONS(4847), 1,
      sym_constant,
    STATE(1908), 1,
      sym_identifier_suffix,
    STATE(1909), 1,
      sym_constant_suffix,
    STATE(2258), 1,
      sym_argument_list,
    STATE(3166), 1,
      sym_heredoc_body,
    ACTIONS(4789), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4791), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1912), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4787), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4785), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [73613] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2076), 1,
      sym_identifier_suffix,
    STATE(2077), 1,
      sym_constant_suffix,
    STATE(2258), 1,
      sym_argument_list,
    STATE(3167), 1,
      sym_heredoc_body,
    ACTIONS(4793), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4801), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4803), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2078), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4797), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4795), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [73684] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4849), 1,
      anon_sym_DOT,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4853), 1,
      anon_sym_AMP_DOT,
    ACTIONS(4855), 1,
      sym__element_reference_bracket,
    STATE(3168), 1,
      sym_heredoc_body,
    ACTIONS(3543), 8,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [73747] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4857), 1,
      anon_sym_COMMA,
    STATE(3169), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [73804] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3569), 1,
      sym__element_reference_bracket,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(4112), 1,
      anon_sym_AMP_DOT,
    ACTIONS(4860), 1,
      anon_sym_COLON_COLON2,
    STATE(3170), 1,
      sym_heredoc_body,
    ACTIONS(3543), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [73867] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3171), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [73928] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    ACTIONS(4862), 1,
      anon_sym___END__,
    STATE(3172), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [74015] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(1949), 1,
      sym_identifier_suffix,
    STATE(1951), 1,
      sym_constant_suffix,
    STATE(3138), 1,
      sym_argument_list,
    STATE(3173), 1,
      sym_heredoc_body,
    ACTIONS(4864), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4870), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4872), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1948), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4868), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4866), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [74086] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4783), 1,
      sym_identifier,
    ACTIONS(4874), 1,
      sym_constant,
    STATE(1908), 1,
      sym_identifier_suffix,
    STATE(1909), 1,
      sym_constant_suffix,
    STATE(2258), 1,
      sym_argument_list,
    STATE(3174), 1,
      sym_heredoc_body,
    ACTIONS(4789), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4791), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1912), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4787), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4785), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [74159] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3175), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [74216] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym___END__,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3176), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [74301] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3177), 1,
      sym_heredoc_body,
    STATE(3229), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [74358] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4876), 1,
      anon_sym_COMMA,
    STATE(3178), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [74415] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(4879), 1,
      anon_sym_rescue,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4883), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4889), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4893), 1,
      anon_sym_QMARK,
    ACTIONS(4895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3179), 1,
      sym_heredoc_body,
    STATE(3229), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [74506] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4783), 1,
      sym_identifier,
    ACTIONS(4913), 1,
      sym_constant,
    STATE(1908), 1,
      sym_identifier_suffix,
    STATE(1909), 1,
      sym_constant_suffix,
    STATE(2241), 1,
      sym_argument_list,
    STATE(3180), 1,
      sym_heredoc_body,
    ACTIONS(4789), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4791), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1912), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4787), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4785), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [74579] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym___END__,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3181), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [74666] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym___END__,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    ACTIONS(4731), 1,
      anon_sym_rescue,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3182), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [74759] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3183), 1,
      sym_heredoc_body,
    STATE(3233), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [74816] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(343), 1,
      sym__string_start,
    ACTIONS(4502), 1,
      anon_sym_COLON,
    STATE(2790), 1,
      aux_sym_chained_string_repeat1,
    STATE(2896), 1,
      sym_string,
    STATE(3184), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [74879] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    ACTIONS(4864), 1,
      sym_identifier,
    ACTIONS(4915), 1,
      sym_constant,
    STATE(1949), 1,
      sym_identifier_suffix,
    STATE(1951), 1,
      sym_constant_suffix,
    STATE(2789), 1,
      sym_argument_list,
    STATE(3185), 1,
      sym_heredoc_body,
    ACTIONS(4870), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4872), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1948), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4868), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4866), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [74952] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(1922), 1,
      sym_identifier_suffix,
    STATE(1924), 1,
      sym_constant_suffix,
    STATE(2258), 1,
      sym_argument_list,
    STATE(3186), 1,
      sym_heredoc_body,
    ACTIONS(4819), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4827), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4829), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1926), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4823), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4821), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [75023] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(1922), 1,
      sym_identifier_suffix,
    STATE(1924), 1,
      sym_constant_suffix,
    STATE(2241), 1,
      sym_argument_list,
    STATE(3187), 1,
      sym_heredoc_body,
    ACTIONS(4819), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4827), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4829), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1926), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4823), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4821), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [75094] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym___END__,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3188), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [75181] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3967), 1,
      anon_sym_CARET,
    ACTIONS(3969), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3977), 1,
      anon_sym_GT_EQ,
    ACTIONS(3983), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3987), 1,
      sym__binary_star_star,
    ACTIONS(4773), 1,
      anon_sym_rescue,
    STATE(3189), 1,
      sym_heredoc_body,
    ACTIONS(3975), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3979), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3963), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3981), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3985), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [75270] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym___END__,
    ACTIONS(4731), 1,
      anon_sym_rescue,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3190), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [75359] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym___END__,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3191), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [75446] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3192), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [75503] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(1908), 1,
      sym_identifier_suffix,
    STATE(1909), 1,
      sym_constant_suffix,
    STATE(2241), 1,
      sym_argument_list,
    STATE(3193), 1,
      sym_heredoc_body,
    ACTIONS(4783), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4789), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4791), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1912), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4787), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4785), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [75574] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2076), 1,
      sym_identifier_suffix,
    STATE(2077), 1,
      sym_constant_suffix,
    STATE(2241), 1,
      sym_argument_list,
    STATE(3194), 1,
      sym_heredoc_body,
    ACTIONS(4793), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4801), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4803), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2078), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4797), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4795), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [75645] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4783), 1,
      sym_identifier,
    ACTIONS(4917), 1,
      sym_constant,
    STATE(1908), 1,
      sym_identifier_suffix,
    STATE(1909), 1,
      sym_constant_suffix,
    STATE(2241), 1,
      sym_argument_list,
    STATE(3195), 1,
      sym_heredoc_body,
    ACTIONS(4789), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4791), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1912), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4787), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4785), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [75718] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    ACTIONS(4919), 1,
      sym_identifier,
    ACTIONS(4925), 1,
      sym_constant,
    STATE(3196), 1,
      sym_heredoc_body,
    STATE(4791), 1,
      sym_constant_suffix,
    STATE(4812), 1,
      sym_identifier_suffix,
    STATE(5015), 1,
      sym_argument_list,
    ACTIONS(2710), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2734), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(4788), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4923), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4921), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [75791] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4931), 1,
      anon_sym_EQ2,
    STATE(3197), 1,
      sym_heredoc_body,
    ACTIONS(4927), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(4929), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [75848] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(2216), 1,
      sym_identifier_suffix,
    STATE(2217), 1,
      sym_constant_suffix,
    STATE(3138), 1,
      sym_argument_list,
    STATE(3198), 1,
      sym_heredoc_body,
    ACTIONS(4807), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4815), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4817), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2203), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4811), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4809), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [75919] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4793), 1,
      sym_identifier,
    ACTIONS(4933), 1,
      sym_constant,
    STATE(2076), 1,
      sym_identifier_suffix,
    STATE(2077), 1,
      sym_constant_suffix,
    STATE(2258), 1,
      sym_argument_list,
    STATE(3199), 1,
      sym_heredoc_body,
    ACTIONS(4801), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4803), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2078), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4797), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4795), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [75992] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3200), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 18,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [76069] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4819), 1,
      sym_identifier,
    ACTIONS(4935), 1,
      sym_constant,
    STATE(1922), 1,
      sym_identifier_suffix,
    STATE(1924), 1,
      sym_constant_suffix,
    STATE(2241), 1,
      sym_argument_list,
    STATE(3201), 1,
      sym_heredoc_body,
    ACTIONS(4827), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4829), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1926), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4823), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4821), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [76142] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_rescue,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4951), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3202), 1,
      sym_heredoc_body,
    STATE(3267), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [76233] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3203), 1,
      sym_heredoc_body,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [76294] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4783), 1,
      sym_identifier,
    ACTIONS(4971), 1,
      sym_constant,
    STATE(1908), 1,
      sym_identifier_suffix,
    STATE(1909), 1,
      sym_constant_suffix,
    STATE(2258), 1,
      sym_argument_list,
    STATE(3204), 1,
      sym_heredoc_body,
    ACTIONS(4789), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4791), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1912), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4787), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4785), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [76367] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3205), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 18,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [76444] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3206), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [76523] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(1949), 1,
      sym_identifier_suffix,
    STATE(1951), 1,
      sym_constant_suffix,
    STATE(2789), 1,
      sym_argument_list,
    STATE(3207), 1,
      sym_heredoc_body,
    ACTIONS(4864), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4870), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4872), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1948), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4868), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4866), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [76594] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4973), 1,
      anon_sym_COMMA,
    STATE(3208), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [76651] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(343), 1,
      sym__string_start,
    ACTIONS(4976), 1,
      anon_sym_COLON,
    STATE(2790), 1,
      aux_sym_chained_string_repeat1,
    STATE(2896), 1,
      sym_string,
    STATE(3209), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [76714] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3210), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym___END__,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [76783] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    ACTIONS(4978), 1,
      anon_sym___END__,
    STATE(3211), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4448), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [76870] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3212), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [76933] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    STATE(3213), 1,
      sym_heredoc_body,
    STATE(4862), 1,
      sym_constant_suffix,
    STATE(4864), 1,
      sym_identifier_suffix,
    STATE(5015), 1,
      sym_argument_list,
    ACTIONS(4831), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4841), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4843), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(4882), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4835), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4833), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [77004] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(2216), 1,
      sym_identifier_suffix,
    STATE(2217), 1,
      sym_constant_suffix,
    STATE(2789), 1,
      sym_argument_list,
    STATE(3214), 1,
      sym_heredoc_body,
    ACTIONS(4807), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4815), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4817), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2203), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4811), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4809), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [77075] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    ACTIONS(4807), 1,
      sym_identifier,
    ACTIONS(4980), 1,
      sym_constant,
    STATE(2216), 1,
      sym_identifier_suffix,
    STATE(2217), 1,
      sym_constant_suffix,
    STATE(2789), 1,
      sym_argument_list,
    STATE(3215), 1,
      sym_heredoc_body,
    ACTIONS(4815), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4817), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2203), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4811), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4809), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [77148] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3216), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [77213] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3217), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [77270] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym___END__,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3218), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [77355] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4793), 1,
      sym_identifier,
    ACTIONS(4982), 1,
      sym_constant,
    STATE(2076), 1,
      sym_identifier_suffix,
    STATE(2077), 1,
      sym_constant_suffix,
    STATE(2258), 1,
      sym_argument_list,
    STATE(3219), 1,
      sym_heredoc_body,
    ACTIONS(4801), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4803), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2078), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4797), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4795), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [77428] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym___END__,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3220), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [77519] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    ACTIONS(4864), 1,
      sym_identifier,
    ACTIONS(4984), 1,
      sym_constant,
    STATE(1949), 1,
      sym_identifier_suffix,
    STATE(1951), 1,
      sym_constant_suffix,
    STATE(3138), 1,
      sym_argument_list,
    STATE(3221), 1,
      sym_heredoc_body,
    ACTIONS(4870), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4872), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1948), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4868), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4866), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [77592] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4986), 1,
      anon_sym_COMMA,
    STATE(3208), 1,
      aux_sym_exceptions_repeat1,
    STATE(3222), 1,
      sym_heredoc_body,
    ACTIONS(4030), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [77651] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym___END__,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3223), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [77742] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4951), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    ACTIONS(4988), 1,
      anon_sym_rescue,
    STATE(3224), 1,
      sym_heredoc_body,
    STATE(3233), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [77833] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    STATE(3225), 1,
      sym_heredoc_body,
    STATE(4791), 1,
      sym_constant_suffix,
    STATE(4812), 1,
      sym_identifier_suffix,
    STATE(5015), 1,
      sym_argument_list,
    ACTIONS(2710), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2734), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4919), 2,
      sym_constant,
      sym_identifier,
    STATE(4788), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4923), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4921), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [77904] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    ACTIONS(4919), 1,
      sym_identifier,
    ACTIONS(4990), 1,
      sym_constant,
    STATE(3226), 1,
      sym_heredoc_body,
    STATE(4791), 1,
      sym_constant_suffix,
    STATE(4812), 1,
      sym_identifier_suffix,
    STATE(5015), 1,
      sym_argument_list,
    ACTIONS(2710), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2734), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(4788), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4923), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4921), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [77977] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3841), 1,
      anon_sym___END__,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3227), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [78064] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    ACTIONS(4992), 1,
      anon_sym___END__,
    STATE(3228), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [78151] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4994), 1,
      anon_sym_COMMA,
    STATE(3178), 1,
      aux_sym_exceptions_repeat1,
    STATE(3229), 1,
      sym_heredoc_body,
    ACTIONS(4030), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78210] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    ACTIONS(4588), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4590), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_QMARK,
    ACTIONS(4600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4602), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4606), 1,
      anon_sym_GT_EQ,
    ACTIONS(4612), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4616), 1,
      sym__binary_star_star,
    ACTIONS(4996), 1,
      anon_sym___END__,
    STATE(3230), 1,
      sym_heredoc_body,
    ACTIONS(4604), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4608), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4592), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4610), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4614), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4450), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [78297] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4883), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4889), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4893), 1,
      anon_sym_QMARK,
    ACTIONS(4895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    ACTIONS(4998), 1,
      anon_sym_rescue,
    STATE(3231), 1,
      sym_heredoc_body,
    STATE(3358), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [78388] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4066), 1,
      anon_sym___END__,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3232), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [78475] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5000), 1,
      anon_sym_COMMA,
    STATE(3169), 1,
      aux_sym_exceptions_repeat1,
    STATE(3233), 1,
      sym_heredoc_body,
    ACTIONS(4030), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78534] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    STATE(3234), 1,
      sym_heredoc_body,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 29,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78593] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4883), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4889), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4893), 1,
      anon_sym_QMARK,
    ACTIONS(4895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3235), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [78679] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3236), 1,
      sym_heredoc_body,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78737] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    STATE(3237), 1,
      sym_heredoc_body,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78797] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    ACTIONS(5008), 1,
      anon_sym_PIPE,
    ACTIONS(5010), 1,
      anon_sym_AMP,
    ACTIONS(5014), 1,
      anon_sym_CARET,
    ACTIONS(5018), 1,
      anon_sym_GT_EQ,
    ACTIONS(5020), 1,
      anon_sym_EQ_EQ,
    STATE(3238), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5016), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5012), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5022), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 17,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [78873] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    STATE(3239), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [78949] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    STATE(3240), 1,
      sym_heredoc_body,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79009] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    STATE(3241), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79065] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    STATE(3242), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [79141] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3243), 1,
      sym_heredoc_body,
    ACTIONS(2624), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2626), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [79195] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    ACTIONS(5046), 1,
      anon_sym_AMP_AMP,
    STATE(3244), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [79273] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3245), 1,
      sym_heredoc_body,
    ACTIONS(2628), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2630), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [79327] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym___END__,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    ACTIONS(5046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5048), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5050), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5052), 1,
      anon_sym_QMARK,
    ACTIONS(5054), 1,
      anon_sym_PIPE_PIPE,
    STATE(3246), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [79413] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    ACTIONS(5008), 1,
      anon_sym_PIPE,
    ACTIONS(5010), 1,
      anon_sym_AMP,
    ACTIONS(5014), 1,
      anon_sym_CARET,
    ACTIONS(5018), 1,
      anon_sym_GT_EQ,
    ACTIONS(5020), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5056), 1,
      anon_sym_AMP_AMP,
    STATE(3247), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5016), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5012), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5022), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [79491] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    ACTIONS(5008), 1,
      anon_sym_PIPE,
    ACTIONS(5010), 1,
      anon_sym_AMP,
    ACTIONS(5014), 1,
      anon_sym_CARET,
    STATE(3248), 1,
      sym_heredoc_body,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5016), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79559] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    STATE(3249), 1,
      sym_heredoc_body,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5016), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79621] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    ACTIONS(5010), 1,
      anon_sym_AMP,
    STATE(3250), 1,
      sym_heredoc_body,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5016), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79685] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3251), 1,
      sym_heredoc_body,
    ACTIONS(3012), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3010), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79739] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym___END__,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    ACTIONS(5046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5048), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5050), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5052), 1,
      anon_sym_QMARK,
    ACTIONS(5054), 1,
      anon_sym_PIPE_PIPE,
    STATE(3252), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [79825] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    STATE(3253), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79881] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    STATE(3254), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79937] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    STATE(3255), 1,
      sym_heredoc_body,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79995] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    ACTIONS(5008), 1,
      anon_sym_PIPE,
    ACTIONS(5010), 1,
      anon_sym_AMP,
    ACTIONS(5014), 1,
      anon_sym_CARET,
    ACTIONS(5018), 1,
      anon_sym_GT_EQ,
    ACTIONS(5020), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5058), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5060), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5062), 1,
      anon_sym_QMARK,
    ACTIONS(5064), 1,
      anon_sym_PIPE_PIPE,
    STATE(3256), 1,
      sym_heredoc_body,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5016), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5012), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5022), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [80081] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    ACTIONS(5008), 1,
      anon_sym_PIPE,
    ACTIONS(5010), 1,
      anon_sym_AMP,
    ACTIONS(5014), 1,
      anon_sym_CARET,
    ACTIONS(5018), 1,
      anon_sym_GT_EQ,
    ACTIONS(5020), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5058), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5060), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5062), 1,
      anon_sym_QMARK,
    ACTIONS(5064), 1,
      anon_sym_PIPE_PIPE,
    STATE(3257), 1,
      sym_heredoc_body,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5016), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5012), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5022), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [80167] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    ACTIONS(5008), 1,
      anon_sym_PIPE,
    ACTIONS(5010), 1,
      anon_sym_AMP,
    ACTIONS(5014), 1,
      anon_sym_CARET,
    ACTIONS(5018), 1,
      anon_sym_GT_EQ,
    ACTIONS(5020), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5058), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5060), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5064), 1,
      anon_sym_PIPE_PIPE,
    STATE(3258), 1,
      sym_heredoc_body,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5016), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5012), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5022), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [80251] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    ACTIONS(5008), 1,
      anon_sym_PIPE,
    ACTIONS(5010), 1,
      anon_sym_AMP,
    ACTIONS(5014), 1,
      anon_sym_CARET,
    ACTIONS(5018), 1,
      anon_sym_GT_EQ,
    ACTIONS(5020), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5058), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5060), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5062), 1,
      anon_sym_QMARK,
    ACTIONS(5064), 1,
      anon_sym_PIPE_PIPE,
    STATE(3259), 1,
      sym_heredoc_body,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5016), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5012), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5022), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [80337] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    ACTIONS(5008), 1,
      anon_sym_PIPE,
    ACTIONS(5010), 1,
      anon_sym_AMP,
    ACTIONS(5014), 1,
      anon_sym_CARET,
    ACTIONS(5018), 1,
      anon_sym_GT_EQ,
    ACTIONS(5020), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5058), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5060), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5062), 1,
      anon_sym_QMARK,
    ACTIONS(5064), 1,
      anon_sym_PIPE_PIPE,
    STATE(3260), 1,
      sym_heredoc_body,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5016), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5012), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5022), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [80423] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    ACTIONS(5008), 1,
      anon_sym_PIPE,
    ACTIONS(5010), 1,
      anon_sym_AMP,
    ACTIONS(5014), 1,
      anon_sym_CARET,
    ACTIONS(5018), 1,
      anon_sym_GT_EQ,
    ACTIONS(5020), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5058), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5060), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5062), 1,
      anon_sym_QMARK,
    ACTIONS(5064), 1,
      anon_sym_PIPE_PIPE,
    STATE(3261), 1,
      sym_heredoc_body,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5016), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5012), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5022), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [80509] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(343), 1,
      sym__string_start,
    ACTIONS(4502), 1,
      anon_sym_COLON,
    STATE(2790), 1,
      aux_sym_chained_string_repeat1,
    STATE(2896), 1,
      sym_string,
    STATE(3262), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80571] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    ACTIONS(5008), 1,
      anon_sym_PIPE,
    ACTIONS(5010), 1,
      anon_sym_AMP,
    ACTIONS(5014), 1,
      anon_sym_CARET,
    ACTIONS(5018), 1,
      anon_sym_GT_EQ,
    ACTIONS(5020), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5058), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5060), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5064), 1,
      anon_sym_PIPE_PIPE,
    STATE(3263), 1,
      sym_heredoc_body,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5016), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5012), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5022), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [80655] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    STATE(3264), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80711] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5066), 1,
      sym__binary_star_star,
    STATE(3265), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80767] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5068), 1,
      anon_sym_DOT,
    ACTIONS(5070), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(5072), 1,
      anon_sym_AMP_DOT,
    ACTIONS(5074), 1,
      sym__element_reference_bracket,
    STATE(3266), 1,
      sym_heredoc_body,
    ACTIONS(3543), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80829] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5076), 1,
      anon_sym_COMMA,
    STATE(3267), 1,
      sym_heredoc_body,
    STATE(3279), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4030), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80887] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5078), 1,
      sym__binary_star_star,
    STATE(3268), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80943] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3269), 1,
      sym_heredoc_body,
    ACTIONS(3349), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3012), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3010), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80999] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym___END__,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    ACTIONS(5046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5048), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5050), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5054), 1,
      anon_sym_PIPE_PIPE,
    STATE(3270), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [81083] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3561), 1,
      anon_sym_EQ_GT,
    STATE(3271), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81139] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4951), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3272), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [81225] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4951), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3273), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [81311] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(4879), 1,
      anon_sym_rescue,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4883), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4889), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4893), 1,
      anon_sym_QMARK,
    ACTIONS(4895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3274), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [81399] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3275), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 14,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [81483] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    ACTIONS(5008), 1,
      anon_sym_PIPE,
    ACTIONS(5010), 1,
      anon_sym_AMP,
    ACTIONS(5014), 1,
      anon_sym_CARET,
    ACTIONS(5018), 1,
      anon_sym_GT_EQ,
    ACTIONS(5020), 1,
      anon_sym_EQ_EQ,
    STATE(3276), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5016), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5012), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5022), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 17,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [81559] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4951), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3277), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [81645] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4951), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3278), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [81731] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5080), 1,
      anon_sym_COMMA,
    STATE(3279), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81787] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4879), 1,
      anon_sym_rescue,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4883), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4889), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4893), 1,
      anon_sym_QMARK,
    ACTIONS(4895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3280), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [81875] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym___END__,
    ACTIONS(4767), 1,
      anon_sym_rescue,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    ACTIONS(5046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5048), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5050), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5052), 1,
      anon_sym_QMARK,
    ACTIONS(5054), 1,
      anon_sym_PIPE_PIPE,
    STATE(3281), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [81963] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    STATE(3282), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82023] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    STATE(3283), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82079] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3284), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82135] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3285), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 17,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [82211] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3286), 1,
      sym_heredoc_body,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82271] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    STATE(3287), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82327] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3267), 1,
      aux_sym_exceptions_repeat1,
    STATE(3288), 1,
      sym_heredoc_body,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82383] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3289), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 17,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [82459] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym___END__,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    ACTIONS(5046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5048), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5050), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5052), 1,
      anon_sym_QMARK,
    ACTIONS(5054), 1,
      anon_sym_PIPE_PIPE,
    STATE(3290), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [82545] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3291), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 16,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [82623] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3292), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82691] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym___END__,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    ACTIONS(5046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5048), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5050), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5052), 1,
      anon_sym_QMARK,
    ACTIONS(5054), 1,
      anon_sym_PIPE_PIPE,
    STATE(3293), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [82777] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym___END__,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    ACTIONS(5046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5048), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5050), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5052), 1,
      anon_sym_QMARK,
    ACTIONS(5054), 1,
      anon_sym_PIPE_PIPE,
    STATE(3294), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [82863] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3295), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82925] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4883), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4889), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4893), 1,
      anon_sym_QMARK,
    ACTIONS(4895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3296), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [83011] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3297), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83075] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4883), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4889), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4893), 1,
      anon_sym_QMARK,
    ACTIONS(4895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    ACTIONS(4998), 1,
      anon_sym_rescue,
    STATE(3298), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [83163] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3299), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83219] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3300), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83275] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3301), 1,
      sym_heredoc_body,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83333] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3609), 1,
      anon_sym_EQ_GT,
    STATE(3302), 1,
      sym_heredoc_body,
    ACTIONS(3419), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3349), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83389] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4883), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4889), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4893), 1,
      anon_sym_QMARK,
    ACTIONS(4895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3303), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [83475] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ_GT,
    STATE(3304), 1,
      sym_heredoc_body,
    ACTIONS(3573), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3571), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83531] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4883), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4889), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4893), 1,
      anon_sym_QMARK,
    ACTIONS(4895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3305), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [83617] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4883), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4889), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3306), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 14,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [83701] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5083), 1,
      sym__binary_star_star,
    STATE(3307), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83757] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4883), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4889), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4893), 1,
      anon_sym_QMARK,
    ACTIONS(4895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3308), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [83843] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(5085), 1,
      anon_sym_rescue,
    ACTIONS(5087), 1,
      anon_sym_COMMA,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3309), 1,
      sym_heredoc_body,
    STATE(3317), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [83937] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4883), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4889), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3310), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 14,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [84021] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3311), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84077] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4883), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4889), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4893), 1,
      anon_sym_QMARK,
    ACTIONS(4895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    ACTIONS(4998), 1,
      anon_sym_rescue,
    STATE(3312), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [84165] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_rescue,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4951), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3313), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [84253] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5074), 1,
      sym__element_reference_bracket,
    ACTIONS(5121), 1,
      anon_sym_DOT,
    ACTIONS(5123), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(5125), 1,
      anon_sym_AMP_DOT,
    STATE(3314), 1,
      sym_heredoc_body,
    ACTIONS(3543), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84315] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3311), 1,
      anon_sym_COLON,
    STATE(3315), 1,
      sym_heredoc_body,
    ACTIONS(2628), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2630), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84371] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3311), 1,
      anon_sym_COLON,
    STATE(3316), 1,
      sym_heredoc_body,
    ACTIONS(2624), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2626), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84427] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_COMMA,
    STATE(3317), 1,
      sym_heredoc_body,
    STATE(3346), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4030), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84485] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3297), 1,
      anon_sym_COLON,
    STATE(3318), 1,
      sym_heredoc_body,
    ACTIONS(2628), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2630), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84541] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_COMMA,
    STATE(3317), 1,
      aux_sym_exceptions_repeat1,
    STATE(3319), 1,
      sym_heredoc_body,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84599] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4951), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3320), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [84685] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    ACTIONS(4676), 1,
      anon_sym___END__,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    ACTIONS(5046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5048), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5050), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5052), 1,
      anon_sym_QMARK,
    ACTIONS(5054), 1,
      anon_sym_PIPE_PIPE,
    STATE(3321), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [84775] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3297), 1,
      anon_sym_COLON,
    STATE(3322), 1,
      sym_heredoc_body,
    ACTIONS(2624), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2626), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84831] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5127), 1,
      sym__binary_star_star,
    STATE(3323), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84887] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3324), 1,
      sym_heredoc_body,
    STATE(3358), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84943] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4158), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    ACTIONS(5129), 1,
      anon_sym_rescue,
    ACTIONS(5131), 1,
      anon_sym_COMMA,
    STATE(3325), 1,
      sym_heredoc_body,
    STATE(3469), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [85035] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    STATE(3326), 1,
      sym_heredoc_body,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85093] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4158), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    ACTIONS(5133), 1,
      anon_sym_rescue,
    STATE(3327), 1,
      sym_heredoc_body,
    STATE(3469), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [85183] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3841), 1,
      anon_sym_DOT,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4951), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3328), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [85269] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3329), 1,
      sym_heredoc_body,
    ACTIONS(2616), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2618), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [85323] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    STATE(3330), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85379] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3331), 1,
      sym_heredoc_body,
    ACTIONS(2644), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2646), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [85433] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    STATE(3332), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85489] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    STATE(3333), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85553] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5135), 1,
      anon_sym_COMMA,
    STATE(3334), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85609] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_rescue,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4951), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3335), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [85697] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    ACTIONS(5138), 1,
      anon_sym_rescue,
    STATE(3317), 1,
      aux_sym_exceptions_repeat1,
    STATE(3336), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [85789] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym___END__,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    ACTIONS(5046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5048), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5050), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5054), 1,
      anon_sym_PIPE_PIPE,
    STATE(3337), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [85873] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3271), 1,
      anon_sym_EQ_GT,
    STATE(3338), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85929] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    STATE(3339), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85991] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    STATE(3340), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym___END__,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [86059] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    ACTIONS(5138), 1,
      anon_sym_rescue,
    STATE(3317), 1,
      aux_sym_exceptions_repeat1,
    STATE(3341), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 12,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [86147] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3342), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [86203] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3841), 1,
      anon_sym_DOT,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    ACTIONS(5008), 1,
      anon_sym_PIPE,
    ACTIONS(5010), 1,
      anon_sym_AMP,
    ACTIONS(5014), 1,
      anon_sym_CARET,
    ACTIONS(5018), 1,
      anon_sym_GT_EQ,
    ACTIONS(5020), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5058), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5060), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5062), 1,
      anon_sym_QMARK,
    ACTIONS(5064), 1,
      anon_sym_PIPE_PIPE,
    STATE(3343), 1,
      sym_heredoc_body,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5016), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5012), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5022), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [86289] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3344), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 14,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [86373] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4066), 1,
      anon_sym_DOT,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    ACTIONS(5008), 1,
      anon_sym_PIPE,
    ACTIONS(5010), 1,
      anon_sym_AMP,
    ACTIONS(5014), 1,
      anon_sym_CARET,
    ACTIONS(5018), 1,
      anon_sym_GT_EQ,
    ACTIONS(5020), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5058), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5060), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5062), 1,
      anon_sym_QMARK,
    ACTIONS(5064), 1,
      anon_sym_PIPE_PIPE,
    STATE(3345), 1,
      sym_heredoc_body,
    ACTIONS(5002), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5016), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5004), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5012), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5022), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [86459] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5140), 1,
      anon_sym_COMMA,
    STATE(3346), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [86515] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym___END__,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    ACTIONS(4767), 1,
      anon_sym_rescue,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    ACTIONS(5046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5048), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5050), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5052), 1,
      anon_sym_QMARK,
    ACTIONS(5054), 1,
      anon_sym_PIPE_PIPE,
    STATE(3347), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [86607] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5085), 1,
      anon_sym_rescue,
    ACTIONS(5087), 1,
      anon_sym_COMMA,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3317), 1,
      aux_sym_exceptions_repeat1,
    STATE(3348), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 11,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [86697] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym___END__,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    ACTIONS(5046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5048), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5050), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5052), 1,
      anon_sym_QMARK,
    ACTIONS(5054), 1,
      anon_sym_PIPE_PIPE,
    STATE(3349), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [86787] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4066), 1,
      anon_sym_DOT,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4951), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3350), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [86873] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4951), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    ACTIONS(4988), 1,
      anon_sym_rescue,
    STATE(3351), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [86961] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4066), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4883), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4889), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4893), 1,
      anon_sym_QMARK,
    ACTIONS(4895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3352), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [87047] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5143), 1,
      sym__binary_star_star,
    STATE(3353), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87103] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3841), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(4883), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4885), 1,
      anon_sym_AMP,
    ACTIONS(4889), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4891), 1,
      anon_sym_CARET,
    ACTIONS(4893), 1,
      anon_sym_QMARK,
    ACTIONS(4895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4901), 1,
      anon_sym_GT_EQ,
    ACTIONS(4907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4911), 1,
      sym__binary_star_star,
    STATE(3354), 1,
      sym_heredoc_body,
    ACTIONS(4899), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4903), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4887), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4905), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4909), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [87189] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3355), 1,
      sym_heredoc_body,
    ACTIONS(5145), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(5147), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [87243] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3317), 1,
      aux_sym_exceptions_repeat1,
    STATE(3356), 1,
      sym_heredoc_body,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87299] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym___END__,
    ACTIONS(4628), 1,
      anon_sym_in,
    ACTIONS(4630), 1,
      anon_sym_EQ_GT,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    ACTIONS(5046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5048), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5050), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5052), 1,
      anon_sym_QMARK,
    ACTIONS(5054), 1,
      anon_sym_PIPE_PIPE,
    STATE(3357), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [87389] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5149), 1,
      anon_sym_COMMA,
    STATE(3334), 1,
      aux_sym_exceptions_repeat1,
    STATE(3358), 1,
      sym_heredoc_body,
    ACTIONS(4030), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87447] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4951), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    ACTIONS(4988), 1,
      anon_sym_rescue,
    STATE(3359), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [87535] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3360), 1,
      sym_heredoc_body,
    ACTIONS(3761), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(3759), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [87589] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3361), 1,
      sym_heredoc_body,
    ACTIONS(4927), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(4929), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [87643] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3362), 1,
      sym_heredoc_body,
    ACTIONS(2620), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2622), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [87697] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3363), 1,
      sym_heredoc_body,
    ACTIONS(2640), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2642), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [87751] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3364), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87807] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3365), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 17,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [87883] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3366), 1,
      sym_heredoc_body,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87943] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3367), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 17,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [88019] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3368), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 16,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [88097] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5151), 1,
      sym__binary_star_star,
    STATE(3369), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88153] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3370), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88221] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3371), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88283] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3372), 1,
      sym_heredoc_body,
    ACTIONS(3749), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(3747), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [88337] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3373), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88401] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3374), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88457] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    STATE(3375), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88513] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5153), 1,
      anon_sym_PIPE,
    ACTIONS(5155), 1,
      anon_sym_AMP,
    ACTIONS(5159), 1,
      anon_sym_CARET,
    ACTIONS(5163), 1,
      anon_sym_GT_EQ,
    ACTIONS(5169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    STATE(3376), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 16,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [88588] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3841), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_PIPE,
    ACTIONS(5155), 1,
      anon_sym_AMP,
    ACTIONS(5159), 1,
      anon_sym_CARET,
    ACTIONS(5163), 1,
      anon_sym_GT_EQ,
    ACTIONS(5169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    ACTIONS(5175), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5177), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5179), 1,
      anon_sym_QMARK,
    ACTIONS(5181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5183), 1,
      anon_sym_AMP_AMP,
    STATE(3377), 1,
      sym_heredoc_body,
    ACTIONS(5161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [88673] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3378), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 14,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [88754] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3379), 1,
      sym_heredoc_body,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88807] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(343), 1,
      sym__string_start,
    STATE(2790), 1,
      aux_sym_chained_string_repeat1,
    STATE(2896), 1,
      sym_string,
    STATE(3380), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88866] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3381), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [88953] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    ACTIONS(4992), 1,
      anon_sym___END__,
    STATE(3382), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [89038] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_PIPE,
    ACTIONS(5187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5189), 1,
      anon_sym_AMP,
    ACTIONS(5193), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5195), 1,
      anon_sym_CARET,
    ACTIONS(5197), 1,
      anon_sym_QMARK,
    ACTIONS(5199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5201), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5205), 1,
      anon_sym_GT_EQ,
    ACTIONS(5211), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3383), 1,
      sym_heredoc_body,
    ACTIONS(5203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5213), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [89123] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3384), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [89210] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4771), 1,
      sym__binary_star_star,
    STATE(3385), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89265] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    ACTIONS(4996), 1,
      anon_sym___END__,
    STATE(3386), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4450), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [89350] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3387), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [89433] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3388), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [89516] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2107), 1,
      sym_identifier_suffix,
    STATE(2109), 1,
      sym_constant_suffix,
    STATE(3389), 1,
      sym_heredoc_body,
    ACTIONS(5217), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(5223), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(5225), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2112), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(5221), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5219), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [89581] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5131), 1,
      anon_sym_COMMA,
    STATE(3390), 1,
      sym_heredoc_body,
    STATE(3469), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89638] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3391), 1,
      sym_heredoc_body,
    ACTIONS(3583), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3581), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89691] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3339), 1,
      anon_sym_COLON,
    STATE(3392), 1,
      sym_heredoc_body,
    ACTIONS(2624), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2626), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89746] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    STATE(3393), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89801] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(3202), 1,
      anon_sym_nil,
    ACTIONS(3206), 1,
      anon_sym_DASH_GT,
    STATE(3394), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_nil,
    STATE(4407), 1,
      sym_lambda,
    STATE(4443), 1,
      sym__pattern_primitive,
    STATE(5529), 1,
      sym__int_or_float,
    ACTIONS(2824), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2826), 2,
      sym_integer,
      sym_float,
    STATE(4382), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4383), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4408), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4413), 2,
      sym_complex,
      sym_rational,
    ACTIONS(3204), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4430), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [89894] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5153), 1,
      anon_sym_PIPE,
    ACTIONS(5155), 1,
      anon_sym_AMP,
    ACTIONS(5159), 1,
      anon_sym_CARET,
    ACTIONS(5163), 1,
      anon_sym_GT_EQ,
    ACTIONS(5169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    STATE(3395), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 16,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [89969] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    STATE(3396), 1,
      sym_heredoc_body,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90028] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3397), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [90115] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5153), 1,
      anon_sym_PIPE,
    ACTIONS(5155), 1,
      anon_sym_AMP,
    ACTIONS(5159), 1,
      anon_sym_CARET,
    ACTIONS(5163), 1,
      anon_sym_GT_EQ,
    ACTIONS(5169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    ACTIONS(5183), 1,
      anon_sym_AMP_AMP,
    STATE(3398), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 15,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [90192] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3399), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90251] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3400), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90306] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5153), 1,
      anon_sym_PIPE,
    ACTIONS(5155), 1,
      anon_sym_AMP,
    ACTIONS(5159), 1,
      anon_sym_CARET,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    STATE(3401), 1,
      sym_heredoc_body,
    ACTIONS(5161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90373] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3402), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [90456] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3403), 1,
      sym_heredoc_body,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__line_break,
      sym__binary_minus,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90513] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    STATE(3404), 1,
      sym_heredoc_body,
    ACTIONS(5161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90574] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3405), 1,
      sym_heredoc_body,
    STATE(3469), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90629] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5155), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    STATE(3406), 1,
      sym_heredoc_body,
    ACTIONS(5161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90692] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3407), 1,
      sym_heredoc_body,
    ACTIONS(3543), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90745] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3408), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 14,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [90826] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    STATE(3409), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90881] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    STATE(3410), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90936] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2032), 1,
      sym_identifier_suffix,
    STATE(2036), 1,
      sym_constant_suffix,
    STATE(3411), 1,
      sym_heredoc_body,
    ACTIONS(5227), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(5233), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(5235), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2034), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(5231), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5229), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [91001] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    STATE(3412), 1,
      sym_heredoc_body,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [91058] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_PIPE,
    ACTIONS(5155), 1,
      anon_sym_AMP,
    ACTIONS(5159), 1,
      anon_sym_CARET,
    ACTIONS(5163), 1,
      anon_sym_GT_EQ,
    ACTIONS(5169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    ACTIONS(5175), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5177), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5179), 1,
      anon_sym_QMARK,
    ACTIONS(5181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5183), 1,
      anon_sym_AMP_AMP,
    STATE(3413), 1,
      sym_heredoc_body,
    ACTIONS(5161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [91143] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(2944), 1,
      sym__symbol_start,
    ACTIONS(3202), 1,
      anon_sym_nil,
    ACTIONS(3206), 1,
      anon_sym_DASH_GT,
    STATE(3414), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_nil,
    STATE(4407), 1,
      sym_lambda,
    STATE(4443), 1,
      sym__pattern_primitive,
    STATE(5529), 1,
      sym__int_or_float,
    ACTIONS(2824), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2826), 2,
      sym_integer,
      sym_float,
    STATE(4382), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4383), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4408), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4413), 2,
      sym_complex,
      sym_rational,
    ACTIONS(3204), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4430), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [91236] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_PIPE,
    ACTIONS(5155), 1,
      anon_sym_AMP,
    ACTIONS(5159), 1,
      anon_sym_CARET,
    ACTIONS(5163), 1,
      anon_sym_GT_EQ,
    ACTIONS(5169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    ACTIONS(5175), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5177), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5179), 1,
      anon_sym_QMARK,
    ACTIONS(5181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5183), 1,
      anon_sym_AMP_AMP,
    STATE(3415), 1,
      sym_heredoc_body,
    ACTIONS(5161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [91321] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_PIPE,
    ACTIONS(5155), 1,
      anon_sym_AMP,
    ACTIONS(5159), 1,
      anon_sym_CARET,
    ACTIONS(5163), 1,
      anon_sym_GT_EQ,
    ACTIONS(5169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    ACTIONS(5175), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5177), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5183), 1,
      anon_sym_AMP_AMP,
    STATE(3416), 1,
      sym_heredoc_body,
    ACTIONS(5161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [91404] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_PIPE,
    ACTIONS(5155), 1,
      anon_sym_AMP,
    ACTIONS(5159), 1,
      anon_sym_CARET,
    ACTIONS(5163), 1,
      anon_sym_GT_EQ,
    ACTIONS(5169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    ACTIONS(5175), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5177), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5179), 1,
      anon_sym_QMARK,
    ACTIONS(5181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5183), 1,
      anon_sym_AMP_AMP,
    STATE(3417), 1,
      sym_heredoc_body,
    ACTIONS(5161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [91489] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_PIPE,
    ACTIONS(5155), 1,
      anon_sym_AMP,
    ACTIONS(5159), 1,
      anon_sym_CARET,
    ACTIONS(5163), 1,
      anon_sym_GT_EQ,
    ACTIONS(5169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    ACTIONS(5175), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5177), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5179), 1,
      anon_sym_QMARK,
    ACTIONS(5181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5183), 1,
      anon_sym_AMP_AMP,
    STATE(3418), 1,
      sym_heredoc_body,
    ACTIONS(5161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [91574] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    ACTIONS(5138), 1,
      anon_sym_rescue,
    STATE(3419), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [91663] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(3202), 1,
      anon_sym_nil,
    ACTIONS(3206), 1,
      anon_sym_DASH_GT,
    STATE(3420), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_nil,
    STATE(4407), 1,
      sym_lambda,
    STATE(4443), 1,
      sym__pattern_primitive,
    STATE(5529), 1,
      sym__int_or_float,
    ACTIONS(2928), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2930), 2,
      sym_integer,
      sym_float,
    STATE(4382), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4383), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4408), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4413), 2,
      sym_complex,
      sym_rational,
    ACTIONS(3204), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4430), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [91756] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2886), 1,
      sym_simple_symbol,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(2890), 1,
      sym__symbol_start,
    ACTIONS(2892), 1,
      sym__subshell_start,
    ACTIONS(2894), 1,
      sym__regex_start,
    ACTIONS(2896), 1,
      sym__string_array_start,
    ACTIONS(2898), 1,
      sym__symbol_array_start,
    ACTIONS(2900), 1,
      sym_heredoc_beginning,
    ACTIONS(4221), 1,
      anon_sym_nil,
    ACTIONS(4225), 1,
      anon_sym_DASH_GT,
    STATE(3421), 1,
      sym_heredoc_body,
    STATE(4710), 1,
      sym_nil,
    STATE(4741), 1,
      sym_lambda,
    STATE(4798), 1,
      sym__pattern_primitive,
    STATE(5517), 1,
      sym__int_or_float,
    ACTIONS(2874), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2876), 2,
      sym_integer,
      sym_float,
    STATE(4678), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4680), 2,
      sym_complex,
      sym_rational,
    STATE(4681), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4719), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    ACTIONS(4223), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4702), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [91849] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3841), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_PIPE,
    ACTIONS(5187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5189), 1,
      anon_sym_AMP,
    ACTIONS(5193), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5195), 1,
      anon_sym_CARET,
    ACTIONS(5197), 1,
      anon_sym_QMARK,
    ACTIONS(5199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5201), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5205), 1,
      anon_sym_GT_EQ,
    ACTIONS(5211), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3422), 1,
      sym_heredoc_body,
    ACTIONS(5203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5213), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [91934] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_COMMA,
    STATE(3423), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [91989] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_PIPE,
    ACTIONS(5187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5189), 1,
      anon_sym_AMP,
    ACTIONS(5193), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5195), 1,
      anon_sym_CARET,
    ACTIONS(5199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5201), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5205), 1,
      anon_sym_GT_EQ,
    ACTIONS(5211), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3424), 1,
      sym_heredoc_body,
    ACTIONS(5203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5213), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [92072] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3425), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92127] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3426), 1,
      sym_heredoc_body,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92184] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3427), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92239] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3428), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92294] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5189), 1,
      anon_sym_AMP,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3429), 1,
      sym_heredoc_body,
    ACTIONS(5203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92357] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3430), 1,
      sym_heredoc_body,
    ACTIONS(5203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92418] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3431), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [92501] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5185), 1,
      anon_sym_PIPE,
    ACTIONS(5189), 1,
      anon_sym_AMP,
    ACTIONS(5195), 1,
      anon_sym_CARET,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3432), 1,
      sym_heredoc_body,
    ACTIONS(5203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92568] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5185), 1,
      anon_sym_PIPE,
    ACTIONS(5189), 1,
      anon_sym_AMP,
    ACTIONS(5195), 1,
      anon_sym_CARET,
    ACTIONS(5201), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5205), 1,
      anon_sym_GT_EQ,
    ACTIONS(5211), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3433), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5213), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 15,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [92645] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5185), 1,
      anon_sym_PIPE,
    ACTIONS(5189), 1,
      anon_sym_AMP,
    ACTIONS(5195), 1,
      anon_sym_CARET,
    ACTIONS(5205), 1,
      anon_sym_GT_EQ,
    ACTIONS(5211), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3434), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5213), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 16,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [92720] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3435), 1,
      sym_heredoc_body,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92779] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3339), 1,
      anon_sym_COLON,
    STATE(3436), 1,
      sym_heredoc_body,
    ACTIONS(2628), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2630), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92834] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5240), 1,
      sym__binary_star_star,
    STATE(3437), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92889] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5185), 1,
      anon_sym_PIPE,
    ACTIONS(5189), 1,
      anon_sym_AMP,
    ACTIONS(5195), 1,
      anon_sym_CARET,
    ACTIONS(5205), 1,
      anon_sym_GT_EQ,
    ACTIONS(5211), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3438), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5213), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 16,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [92964] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3439), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93019] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2886), 1,
      sym_simple_symbol,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(2890), 1,
      sym__symbol_start,
    ACTIONS(2892), 1,
      sym__subshell_start,
    ACTIONS(2894), 1,
      sym__regex_start,
    ACTIONS(2896), 1,
      sym__string_array_start,
    ACTIONS(2898), 1,
      sym__symbol_array_start,
    ACTIONS(2900), 1,
      sym_heredoc_beginning,
    ACTIONS(4221), 1,
      anon_sym_nil,
    ACTIONS(4225), 1,
      anon_sym_DASH_GT,
    STATE(3440), 1,
      sym_heredoc_body,
    STATE(4710), 1,
      sym_nil,
    STATE(4741), 1,
      sym_lambda,
    STATE(4798), 1,
      sym__pattern_primitive,
    STATE(5517), 1,
      sym__int_or_float,
    ACTIONS(2910), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2912), 2,
      sym_integer,
      sym_float,
    STATE(4678), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4680), 2,
      sym_complex,
      sym_rational,
    STATE(4681), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4719), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    ACTIONS(4223), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4702), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [93112] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_PIPE,
    ACTIONS(5155), 1,
      anon_sym_AMP,
    ACTIONS(5159), 1,
      anon_sym_CARET,
    ACTIONS(5163), 1,
      anon_sym_GT_EQ,
    ACTIONS(5169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    ACTIONS(5175), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5177), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5179), 1,
      anon_sym_QMARK,
    ACTIONS(5181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5183), 1,
      anon_sym_AMP_AMP,
    STATE(3441), 1,
      sym_heredoc_body,
    ACTIONS(5161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [93197] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3442), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [93280] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4066), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_PIPE,
    ACTIONS(5187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5189), 1,
      anon_sym_AMP,
    ACTIONS(5193), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5195), 1,
      anon_sym_CARET,
    ACTIONS(5197), 1,
      anon_sym_QMARK,
    ACTIONS(5199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5201), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5205), 1,
      anon_sym_GT_EQ,
    ACTIONS(5211), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3443), 1,
      sym_heredoc_body,
    ACTIONS(5203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5213), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [93365] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_PIPE,
    ACTIONS(5155), 1,
      anon_sym_AMP,
    ACTIONS(5159), 1,
      anon_sym_CARET,
    ACTIONS(5163), 1,
      anon_sym_GT_EQ,
    ACTIONS(5169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    ACTIONS(5175), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5177), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5183), 1,
      anon_sym_AMP_AMP,
    STATE(3444), 1,
      sym_heredoc_body,
    ACTIONS(5161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [93448] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4158), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    ACTIONS(5133), 1,
      anon_sym_rescue,
    STATE(3445), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [93535] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    STATE(3446), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93590] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    ACTIONS(5242), 1,
      anon_sym_EQ_GT,
    STATE(3447), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [93677] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3448), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93732] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3449), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93787] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3995), 1,
      sym__element_reference_bracket,
    ACTIONS(4197), 1,
      anon_sym_DOT,
    ACTIONS(4201), 1,
      anon_sym_AMP_DOT,
    ACTIONS(5244), 1,
      anon_sym_COLON_COLON2,
    STATE(3450), 1,
      sym_heredoc_body,
    ACTIONS(3543), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93848] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3451), 1,
      sym_heredoc_body,
    ACTIONS(3841), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93901] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3452), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [93984] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3453), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94047] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5246), 1,
      sym__binary_star_star,
    STATE(3454), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94102] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5248), 1,
      sym__binary_star_star,
    STATE(3455), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94157] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3456), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94218] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3457), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94285] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3458), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 16,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [94362] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3459), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 17,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [94437] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3460), 1,
      sym_heredoc_body,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94496] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3461), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [94579] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3462), 1,
      sym_heredoc_body,
    ACTIONS(3349), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(3012), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3010), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94634] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3463), 1,
      sym_heredoc_body,
    ACTIONS(3527), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3525), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94687] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3464), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 17,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [94762] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3465), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94817] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    ACTIONS(5138), 1,
      anon_sym_rescue,
    STATE(3466), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 12,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [94902] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3467), 1,
      sym_heredoc_body,
    ACTIONS(3439), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3437), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94955] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    ACTIONS(4862), 1,
      anon_sym___END__,
    STATE(3468), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [95040] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5131), 1,
      anon_sym_COMMA,
    STATE(3423), 1,
      aux_sym_exceptions_repeat1,
    STATE(3469), 1,
      sym_heredoc_body,
    ACTIONS(4030), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95097] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_PIPE,
    ACTIONS(4148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4150), 1,
      anon_sym_AMP,
    ACTIONS(4154), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4156), 1,
      anon_sym_CARET,
    ACTIONS(4158), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4166), 1,
      anon_sym_GT_EQ,
    ACTIONS(4172), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4176), 1,
      sym__binary_star_star,
    ACTIONS(5133), 1,
      anon_sym_rescue,
    STATE(3470), 1,
      sym_heredoc_body,
    ACTIONS(4164), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [95184] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    ACTIONS(4805), 1,
      anon_sym___END__,
    STATE(3471), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4456), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [95269] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3472), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95322] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_PIPE,
    ACTIONS(5187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5189), 1,
      anon_sym_AMP,
    ACTIONS(5193), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5195), 1,
      anon_sym_CARET,
    ACTIONS(5197), 1,
      anon_sym_QMARK,
    ACTIONS(5199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5201), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5205), 1,
      anon_sym_GT_EQ,
    ACTIONS(5211), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3473), 1,
      sym_heredoc_body,
    ACTIONS(5203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5213), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [95407] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_PIPE,
    ACTIONS(5187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5189), 1,
      anon_sym_AMP,
    ACTIONS(5193), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5195), 1,
      anon_sym_CARET,
    ACTIONS(5197), 1,
      anon_sym_QMARK,
    ACTIONS(5199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5201), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5205), 1,
      anon_sym_GT_EQ,
    ACTIONS(5211), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3474), 1,
      sym_heredoc_body,
    ACTIONS(5203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5213), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [95492] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4066), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_PIPE,
    ACTIONS(5155), 1,
      anon_sym_AMP,
    ACTIONS(5159), 1,
      anon_sym_CARET,
    ACTIONS(5163), 1,
      anon_sym_GT_EQ,
    ACTIONS(5169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5173), 1,
      sym__binary_star_star,
    ACTIONS(5175), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5177), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5179), 1,
      anon_sym_QMARK,
    ACTIONS(5181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5183), 1,
      anon_sym_AMP_AMP,
    STATE(3475), 1,
      sym_heredoc_body,
    ACTIONS(5161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [95577] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_PIPE,
    ACTIONS(5187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5189), 1,
      anon_sym_AMP,
    ACTIONS(5193), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5195), 1,
      anon_sym_CARET,
    ACTIONS(5199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5201), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5205), 1,
      anon_sym_GT_EQ,
    ACTIONS(5211), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3476), 1,
      sym_heredoc_body,
    ACTIONS(5203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5213), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [95660] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4733), 1,
      anon_sym_PIPE,
    ACTIONS(4735), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4741), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4743), 1,
      anon_sym_CARET,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    ACTIONS(4747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4749), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4753), 1,
      anon_sym_GT_EQ,
    ACTIONS(4759), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4763), 1,
      sym__binary_star_star,
    ACTIONS(4978), 1,
      anon_sym___END__,
    STATE(3477), 1,
      sym_heredoc_body,
    ACTIONS(4751), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4755), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4757), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4761), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4448), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [95745] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_PIPE,
    ACTIONS(5187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5189), 1,
      anon_sym_AMP,
    ACTIONS(5193), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5195), 1,
      anon_sym_CARET,
    ACTIONS(5197), 1,
      anon_sym_QMARK,
    ACTIONS(5199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5201), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5205), 1,
      anon_sym_GT_EQ,
    ACTIONS(5211), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3478), 1,
      sym_heredoc_body,
    ACTIONS(5203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5213), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [95830] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_PIPE,
    ACTIONS(5187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5189), 1,
      anon_sym_AMP,
    ACTIONS(5193), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5195), 1,
      anon_sym_CARET,
    ACTIONS(5197), 1,
      anon_sym_QMARK,
    ACTIONS(5199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5201), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5205), 1,
      anon_sym_GT_EQ,
    ACTIONS(5211), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3479), 1,
      sym_heredoc_body,
    ACTIONS(5203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5207), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5209), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5213), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [95915] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2058), 1,
      sym_constant_suffix,
    STATE(2063), 1,
      sym_identifier_suffix,
    STATE(3480), 1,
      sym_heredoc_body,
    ACTIONS(5250), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(5256), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(5258), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2061), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(5254), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5252), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [95980] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5262), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5272), 1,
      anon_sym_QMARK,
    ACTIONS(5274), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3481), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 12,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [96062] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5292), 1,
      sym__string_start,
    STATE(2896), 1,
      sym_string,
    STATE(3482), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(3266), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3264), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96118] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_COLON,
    STATE(3483), 1,
      sym_heredoc_body,
    ACTIONS(2628), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2630), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96172] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    ACTIONS(5295), 1,
      anon_sym_rescue,
    STATE(3484), 1,
      sym_heredoc_body,
    STATE(3587), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [96262] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5262), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5272), 1,
      anon_sym_QMARK,
    ACTIONS(5274), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3485), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [96348] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5297), 1,
      anon_sym_PIPE,
    ACTIONS(5299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5301), 1,
      anon_sym_AMP,
    ACTIONS(5305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5307), 1,
      anon_sym_CARET,
    ACTIONS(5309), 1,
      anon_sym_QMARK,
    ACTIONS(5311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5317), 1,
      anon_sym_GT_EQ,
    ACTIONS(5323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3486), 1,
      sym_heredoc_body,
    ACTIONS(5315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [96432] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_COLON,
    STATE(3487), 1,
      sym_heredoc_body,
    ACTIONS(2624), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2626), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96486] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5262), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5272), 1,
      anon_sym_QMARK,
    ACTIONS(5274), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3488), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [96572] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5000), 1,
      anon_sym_COMMA,
    STATE(3233), 1,
      aux_sym_exceptions_repeat1,
    STATE(3489), 1,
      sym_heredoc_body,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96628] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2054), 1,
      sym__string_start,
    STATE(2896), 1,
      sym_string,
    STATE(3482), 1,
      aux_sym_chained_string_repeat1,
    STATE(3490), 1,
      sym_heredoc_body,
    ACTIONS(3258), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3256), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96686] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    ACTIONS(5295), 1,
      anon_sym_rescue,
    STATE(3491), 1,
      sym_heredoc_body,
    STATE(3587), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [96772] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(5297), 1,
      anon_sym_PIPE,
    ACTIONS(5299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5301), 1,
      anon_sym_AMP,
    ACTIONS(5305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5307), 1,
      anon_sym_CARET,
    ACTIONS(5309), 1,
      anon_sym_QMARK,
    ACTIONS(5311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5317), 1,
      anon_sym_GT_EQ,
    ACTIONS(5323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3492), 1,
      sym_heredoc_body,
    ACTIONS(5315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [96856] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4227), 1,
      anon_sym_PIPE,
    ACTIONS(4229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4237), 1,
      anon_sym_CARET,
    ACTIONS(4239), 1,
      anon_sym_QMARK,
    ACTIONS(4241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4247), 1,
      anon_sym_GT_EQ,
    ACTIONS(4253), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5129), 1,
      anon_sym_rescue,
    STATE(3493), 1,
      sym_heredoc_body,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [96942] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3841), 1,
      anon_sym_DOT,
    ACTIONS(5297), 1,
      anon_sym_PIPE,
    ACTIONS(5299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5301), 1,
      anon_sym_AMP,
    ACTIONS(5305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5307), 1,
      anon_sym_CARET,
    ACTIONS(5309), 1,
      anon_sym_QMARK,
    ACTIONS(5311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5317), 1,
      anon_sym_GT_EQ,
    ACTIONS(5323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3494), 1,
      sym_heredoc_body,
    ACTIONS(5315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [97026] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4066), 1,
      anon_sym_DOT,
    ACTIONS(5297), 1,
      anon_sym_PIPE,
    ACTIONS(5299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5301), 1,
      anon_sym_AMP,
    ACTIONS(5305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5307), 1,
      anon_sym_CARET,
    ACTIONS(5309), 1,
      anon_sym_QMARK,
    ACTIONS(5311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5317), 1,
      anon_sym_GT_EQ,
    ACTIONS(5323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3495), 1,
      sym_heredoc_body,
    ACTIONS(5315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [97110] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(5085), 1,
      anon_sym_rescue,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5262), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5272), 1,
      anon_sym_QMARK,
    ACTIONS(5274), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3496), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [97198] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      anon_sym_QMARK,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    ACTIONS(5329), 1,
      anon_sym_rescue,
    STATE(3497), 1,
      sym_heredoc_body,
    STATE(3589), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [97286] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3498), 1,
      sym_heredoc_body,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [97342] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    ACTIONS(5331), 1,
      anon_sym_EQ_GT,
    STATE(3499), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [97428] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5262), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5272), 1,
      anon_sym_QMARK,
    ACTIONS(5274), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3500), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [97514] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2054), 1,
      sym__string_start,
    STATE(2896), 1,
      sym_string,
    STATE(3490), 1,
      aux_sym_chained_string_repeat1,
    STATE(3501), 1,
      sym_heredoc_body,
    ACTIONS(3106), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [97572] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      anon_sym_QMARK,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    ACTIONS(5333), 1,
      anon_sym_rescue,
    ACTIONS(5335), 1,
      anon_sym_COMMA,
    STATE(3502), 1,
      sym_heredoc_body,
    STATE(3589), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [97662] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4227), 1,
      anon_sym_PIPE,
    ACTIONS(4229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4231), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4237), 1,
      anon_sym_CARET,
    ACTIONS(4239), 1,
      anon_sym_QMARK,
    ACTIONS(4241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4247), 1,
      anon_sym_GT_EQ,
    ACTIONS(4253), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5129), 1,
      anon_sym_rescue,
    STATE(3503), 1,
      sym_heredoc_body,
    ACTIONS(4245), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [97748] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3504), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [97802] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3505), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [97856] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5297), 1,
      anon_sym_PIPE,
    ACTIONS(5299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5301), 1,
      anon_sym_AMP,
    ACTIONS(5305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5307), 1,
      anon_sym_CARET,
    ACTIONS(5309), 1,
      anon_sym_QMARK,
    ACTIONS(5311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5317), 1,
      anon_sym_GT_EQ,
    ACTIONS(5323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3506), 1,
      sym_heredoc_body,
    ACTIONS(5315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [97940] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4951), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    ACTIONS(5000), 1,
      anon_sym_COMMA,
    ACTIONS(5337), 1,
      anon_sym_rescue,
    STATE(3233), 1,
      aux_sym_exceptions_repeat1,
    STATE(3507), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [98030] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5262), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5272), 1,
      anon_sym_QMARK,
    ACTIONS(5274), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3508), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 12,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [98112] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3509), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98170] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3510), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98224] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3511), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98278] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    ACTIONS(5297), 1,
      anon_sym_PIPE,
    ACTIONS(5299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5301), 1,
      anon_sym_AMP,
    ACTIONS(5305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5307), 1,
      anon_sym_CARET,
    ACTIONS(5309), 1,
      anon_sym_QMARK,
    ACTIONS(5311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5317), 1,
      anon_sym_GT_EQ,
    ACTIONS(5323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3512), 1,
      sym_heredoc_body,
    ACTIONS(5315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [98362] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5297), 1,
      anon_sym_PIPE,
    ACTIONS(5301), 1,
      anon_sym_AMP,
    ACTIONS(5307), 1,
      anon_sym_CARET,
    ACTIONS(5317), 1,
      anon_sym_GT_EQ,
    ACTIONS(5323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3513), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [98436] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5297), 1,
      anon_sym_PIPE,
    ACTIONS(5299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5301), 1,
      anon_sym_AMP,
    ACTIONS(5305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5307), 1,
      anon_sym_CARET,
    ACTIONS(5311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5317), 1,
      anon_sym_GT_EQ,
    ACTIONS(5323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3514), 1,
      sym_heredoc_body,
    ACTIONS(5315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 12,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [98518] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4862), 1,
      anon_sym___END__,
    ACTIONS(5024), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5040), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5044), 1,
      sym__binary_star_star,
    ACTIONS(5046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5048), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5050), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5052), 1,
      anon_sym_QMARK,
    ACTIONS(5054), 1,
      anon_sym_PIPE_PIPE,
    STATE(3515), 1,
      sym_heredoc_body,
    ACTIONS(5032), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5036), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5028), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5042), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [98602] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5262), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5272), 1,
      anon_sym_QMARK,
    ACTIONS(5274), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3516), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 12,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [98684] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4855), 1,
      sym__element_reference_bracket,
    ACTIONS(5339), 1,
      anon_sym_DOT,
    ACTIONS(5341), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(5343), 1,
      anon_sym_AMP_DOT,
    STATE(3517), 1,
      sym_heredoc_body,
    ACTIONS(3543), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98744] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3518), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98798] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3519), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98852] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5262), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5274), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3520), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [98932] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3521), 1,
      sym_heredoc_body,
    ACTIONS(2616), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2618), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98984] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3522), 1,
      sym_heredoc_body,
    ACTIONS(2644), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2646), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99036] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5262), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5274), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3523), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [99116] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5262), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5272), 1,
      anon_sym_QMARK,
    ACTIONS(5274), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3524), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 12,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [99198] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3525), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 16,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [99272] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3526), 1,
      sym_heredoc_body,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99330] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3527), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 16,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [99404] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    ACTIONS(5297), 1,
      anon_sym_PIPE,
    ACTIONS(5299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5301), 1,
      anon_sym_AMP,
    ACTIONS(5305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5307), 1,
      anon_sym_CARET,
    ACTIONS(5311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5317), 1,
      anon_sym_GT_EQ,
    ACTIONS(5323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3528), 1,
      sym_heredoc_body,
    ACTIONS(5315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 12,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [99486] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5085), 1,
      anon_sym_rescue,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5262), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5272), 1,
      anon_sym_QMARK,
    ACTIONS(5274), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3529), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 11,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [99570] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3530), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 15,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [99646] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    ACTIONS(5297), 1,
      anon_sym_PIPE,
    ACTIONS(5299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5301), 1,
      anon_sym_AMP,
    ACTIONS(5305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5307), 1,
      anon_sym_CARET,
    ACTIONS(5309), 1,
      anon_sym_QMARK,
    ACTIONS(5311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5317), 1,
      anon_sym_GT_EQ,
    ACTIONS(5323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3531), 1,
      sym_heredoc_body,
    ACTIONS(5315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [99730] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3532), 1,
      sym_heredoc_body,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99788] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5345), 1,
      sym__binary_star_star,
    STATE(3533), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99842] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3534), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99908] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5301), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3535), 1,
      sym_heredoc_body,
    ACTIONS(5315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99970] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3536), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100030] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3537), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100092] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5297), 1,
      anon_sym_PIPE,
    ACTIONS(5301), 1,
      anon_sym_AMP,
    ACTIONS(5307), 1,
      anon_sym_CARET,
    ACTIONS(5317), 1,
      anon_sym_GT_EQ,
    ACTIONS(5323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3538), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [100166] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3539), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100220] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5297), 1,
      anon_sym_PIPE,
    ACTIONS(5301), 1,
      anon_sym_AMP,
    ACTIONS(5307), 1,
      anon_sym_CARET,
    ACTIONS(5313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5317), 1,
      anon_sym_GT_EQ,
    ACTIONS(5323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3540), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [100296] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3541), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100350] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5347), 1,
      sym__binary_star_star,
    STATE(3542), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100404] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3543), 1,
      sym_heredoc_body,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__line_break,
      sym__binary_minus,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100460] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3544), 1,
      sym_heredoc_body,
    ACTIONS(5315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100520] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5262), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5272), 1,
      anon_sym_QMARK,
    ACTIONS(5274), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3545), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 12,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [100602] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5297), 1,
      anon_sym_PIPE,
    ACTIONS(5301), 1,
      anon_sym_AMP,
    ACTIONS(5307), 1,
      anon_sym_CARET,
    ACTIONS(5327), 1,
      sym__binary_star_star,
    STATE(3546), 1,
      sym_heredoc_body,
    ACTIONS(5315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100668] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_DOT,
    ACTIONS(4939), 1,
      anon_sym_PIPE,
    ACTIONS(4941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4943), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4949), 1,
      anon_sym_CARET,
    ACTIONS(4951), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4959), 1,
      anon_sym_GT_EQ,
    ACTIONS(4965), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4969), 1,
      sym__binary_star_star,
    ACTIONS(5076), 1,
      anon_sym_COMMA,
    ACTIONS(5349), 1,
      anon_sym_rescue,
    STATE(3267), 1,
      aux_sym_exceptions_repeat1,
    STATE(3547), 1,
      sym_heredoc_body,
    ACTIONS(4957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4961), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4945), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4963), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4967), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [100758] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5351), 1,
      sym__binary_star_star,
    STATE(3548), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100811] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2740), 1,
      anon_sym_COLON,
    STATE(3549), 1,
      sym_heredoc_body,
    ACTIONS(2628), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2630), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100864] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5353), 1,
      anon_sym_rescue,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3550), 1,
      sym_heredoc_body,
    STATE(3582), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [100949] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5387), 1,
      anon_sym_rescue,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3551), 1,
      sym_heredoc_body,
    STATE(3716), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [101034] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    ACTIONS(5295), 1,
      anon_sym_rescue,
    STATE(3552), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [101121] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5425), 1,
      anon_sym_AMP,
    ACTIONS(5429), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5431), 1,
      anon_sym_CARET,
    ACTIONS(5433), 1,
      anon_sym_QMARK,
    ACTIONS(5435), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5437), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5441), 1,
      anon_sym_GT_EQ,
    ACTIONS(5447), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3553), 1,
      sym_heredoc_body,
    ACTIONS(5439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5443), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5427), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5445), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5449), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [101204] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      anon_sym_QMARK,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    ACTIONS(5329), 1,
      anon_sym_rescue,
    STATE(3554), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [101289] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2740), 1,
      anon_sym_COLON,
    STATE(3555), 1,
      sym_heredoc_body,
    ACTIONS(2624), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2626), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101342] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3556), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101395] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5076), 1,
      anon_sym_COMMA,
    STATE(3267), 1,
      aux_sym_exceptions_repeat1,
    STATE(3557), 1,
      sym_heredoc_body,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101450] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5425), 1,
      anon_sym_AMP,
    ACTIONS(5431), 1,
      anon_sym_CARET,
    ACTIONS(5441), 1,
      anon_sym_GT_EQ,
    ACTIONS(5447), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3558), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5443), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5427), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5445), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5449), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [101523] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3559), 1,
      sym_heredoc_body,
    STATE(3594), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101576] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym_COMMA,
    STATE(3560), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101629] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3561), 1,
      sym_heredoc_body,
    STATE(3587), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101682] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_COMMA,
    STATE(3562), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101735] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_CARET,
    ACTIONS(4275), 1,
      anon_sym_QMARK,
    ACTIONS(4277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 1,
      anon_sym_GT_EQ,
    ACTIONS(4289), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4293), 1,
      sym__binary_star_star,
    ACTIONS(5295), 1,
      anon_sym_rescue,
    STATE(3563), 1,
      sym_heredoc_body,
    ACTIONS(4281), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4285), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4265), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4287), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4291), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [101818] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3564), 1,
      sym_heredoc_body,
    ACTIONS(5443), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5445), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101875] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5425), 1,
      anon_sym_AMP,
    ACTIONS(5431), 1,
      anon_sym_CARET,
    ACTIONS(5441), 1,
      anon_sym_GT_EQ,
    ACTIONS(5447), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3565), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5443), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5427), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5445), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5449), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [101948] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5425), 1,
      anon_sym_AMP,
    ACTIONS(5431), 1,
      anon_sym_CARET,
    ACTIONS(5437), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5441), 1,
      anon_sym_GT_EQ,
    ACTIONS(5447), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3566), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5443), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5427), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5445), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5449), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [102023] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5425), 1,
      anon_sym_AMP,
    ACTIONS(5431), 1,
      anon_sym_CARET,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3567), 1,
      sym_heredoc_body,
    ACTIONS(5439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5443), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5445), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102088] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3568), 1,
      sym_heredoc_body,
    ACTIONS(5439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5443), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5445), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102147] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5425), 1,
      anon_sym_AMP,
    ACTIONS(5429), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5431), 1,
      anon_sym_CARET,
    ACTIONS(5435), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5437), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5441), 1,
      anon_sym_GT_EQ,
    ACTIONS(5447), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3569), 1,
      sym_heredoc_body,
    ACTIONS(5439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5443), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5427), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5445), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5449), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [102228] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3570), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4456), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [102309] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3571), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [102390] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    ACTIONS(5459), 1,
      anon_sym_rescue,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    STATE(3572), 1,
      sym_heredoc_body,
    STATE(3594), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [102479] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5425), 1,
      anon_sym_AMP,
    ACTIONS(5429), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5431), 1,
      anon_sym_CARET,
    ACTIONS(5433), 1,
      anon_sym_QMARK,
    ACTIONS(5435), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5437), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5441), 1,
      anon_sym_GT_EQ,
    ACTIONS(5447), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3573), 1,
      sym_heredoc_body,
    ACTIONS(5439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5443), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5427), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5445), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5449), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [102562] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5425), 1,
      anon_sym_AMP,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3574), 1,
      sym_heredoc_body,
    ACTIONS(5439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5443), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5445), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102623] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3575), 1,
      sym_heredoc_body,
    STATE(3589), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102676] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4642), 1,
      anon_sym_PIPE,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4646), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4652), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      anon_sym_QMARK,
    ACTIONS(4656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4662), 1,
      anon_sym_GT_EQ,
    ACTIONS(4668), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4672), 1,
      sym__binary_star_star,
    ACTIONS(5329), 1,
      anon_sym_rescue,
    STATE(3576), 1,
      sym_heredoc_body,
    ACTIONS(4660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4664), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4666), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4670), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [102761] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3577), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102814] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4106), 1,
      anon_sym_COLON,
    STATE(3578), 1,
      sym_heredoc_body,
    ACTIONS(2628), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2630), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102867] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3579), 1,
      sym_heredoc_body,
    STATE(3582), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102920] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3580), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4448), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [103001] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3581), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103054] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5465), 1,
      anon_sym_COMMA,
    STATE(3560), 1,
      aux_sym_exceptions_repeat1,
    STATE(3582), 1,
      sym_heredoc_body,
    ACTIONS(4030), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103109] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3583), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4450), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [103190] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5467), 1,
      sym__binary_star_star,
    STATE(3584), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103243] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5387), 1,
      anon_sym_rescue,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    STATE(3585), 1,
      sym_heredoc_body,
    STATE(3716), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [103332] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5425), 1,
      anon_sym_AMP,
    ACTIONS(5429), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5431), 1,
      anon_sym_CARET,
    ACTIONS(5433), 1,
      anon_sym_QMARK,
    ACTIONS(5435), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5437), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5441), 1,
      anon_sym_GT_EQ,
    ACTIONS(5447), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3586), 1,
      sym_heredoc_body,
    ACTIONS(5439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5443), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5427), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5445), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5449), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [103415] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5469), 1,
      anon_sym_COMMA,
    STATE(3587), 1,
      sym_heredoc_body,
    STATE(3591), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4030), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103470] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    ACTIONS(5471), 1,
      anon_sym_rescue,
    STATE(3588), 1,
      sym_heredoc_body,
    STATE(3610), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [103555] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5335), 1,
      anon_sym_COMMA,
    STATE(3589), 1,
      sym_heredoc_body,
    STATE(3590), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4030), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103610] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5473), 1,
      anon_sym_COMMA,
    STATE(3590), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103663] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5476), 1,
      anon_sym_COMMA,
    STATE(3591), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103716] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5425), 1,
      anon_sym_AMP,
    ACTIONS(5429), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5431), 1,
      anon_sym_CARET,
    ACTIONS(5433), 1,
      anon_sym_QMARK,
    ACTIONS(5435), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5437), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5441), 1,
      anon_sym_GT_EQ,
    ACTIONS(5447), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3592), 1,
      sym_heredoc_body,
    ACTIONS(5439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5443), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5427), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5445), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5449), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [103799] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5425), 1,
      anon_sym_AMP,
    ACTIONS(5429), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5431), 1,
      anon_sym_CARET,
    ACTIONS(5433), 1,
      anon_sym_QMARK,
    ACTIONS(5435), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5437), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5441), 1,
      anon_sym_GT_EQ,
    ACTIONS(5447), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3593), 1,
      sym_heredoc_body,
    ACTIONS(5439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5443), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5427), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5445), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5449), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [103882] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5479), 1,
      anon_sym_COMMA,
    STATE(3562), 1,
      aux_sym_exceptions_repeat1,
    STATE(3594), 1,
      sym_heredoc_body,
    ACTIONS(4030), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103937] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5335), 1,
      anon_sym_COMMA,
    STATE(3589), 1,
      aux_sym_exceptions_repeat1,
    STATE(3595), 1,
      sym_heredoc_body,
    ACTIONS(3559), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103992] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    STATE(3596), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [104073] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3597), 1,
      sym_heredoc_body,
    ACTIONS(5445), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104128] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    ACTIONS(5459), 1,
      anon_sym_rescue,
    STATE(3594), 1,
      aux_sym_exceptions_repeat1,
    STATE(3598), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [104213] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4106), 1,
      anon_sym_COLON,
    STATE(3599), 1,
      sym_heredoc_body,
    ACTIONS(2624), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2626), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104266] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(343), 1,
      sym__string_start,
    ACTIONS(5481), 1,
      anon_sym_COLON,
    STATE(2790), 1,
      aux_sym_chained_string_repeat1,
    STATE(2896), 1,
      sym_string,
    STATE(3600), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104325] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5425), 1,
      anon_sym_AMP,
    ACTIONS(5429), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5431), 1,
      anon_sym_CARET,
    ACTIONS(5435), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5437), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5441), 1,
      anon_sym_GT_EQ,
    ACTIONS(5447), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3601), 1,
      sym_heredoc_body,
    ACTIONS(5439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5443), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5427), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5445), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5449), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [104406] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3602), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104459] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(5483), 1,
      anon_sym_rescue,
    ACTIONS(5485), 1,
      anon_sym_COMMA,
    STATE(3603), 1,
      sym_heredoc_body,
    STATE(3835), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [104545] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    STATE(3604), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104597] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4699), 1,
      anon_sym_PIPE,
    ACTIONS(4701), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4707), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4709), 1,
      anon_sym_CARET,
    ACTIONS(4711), 1,
      anon_sym_QMARK,
    ACTIONS(4713), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4719), 1,
      anon_sym_GT_EQ,
    ACTIONS(4725), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    ACTIONS(5333), 1,
      anon_sym_rescue,
    STATE(3605), 1,
      sym_heredoc_body,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4705), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4727), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [104681] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    STATE(3606), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104733] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    ACTIONS(5491), 1,
      anon_sym_PIPE,
    ACTIONS(5493), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5495), 1,
      anon_sym_AMP,
    ACTIONS(5499), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5509), 1,
      anon_sym_GT_EQ,
    ACTIONS(5515), 1,
      anon_sym_EQ_EQ,
    STATE(3607), 1,
      sym_heredoc_body,
    ACTIONS(5507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5497), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5517), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [104813] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    ACTIONS(5491), 1,
      anon_sym_PIPE,
    ACTIONS(5493), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5495), 1,
      anon_sym_AMP,
    ACTIONS(5499), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5509), 1,
      anon_sym_GT_EQ,
    ACTIONS(5515), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5519), 1,
      anon_sym_QMARK,
    STATE(3608), 1,
      sym_heredoc_body,
    ACTIONS(5507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5497), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5517), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [104895] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    STATE(3609), 1,
      sym_heredoc_body,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104955] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5531), 1,
      anon_sym_COMMA,
    STATE(3610), 1,
      sym_heredoc_body,
    STATE(3629), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4030), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105009] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(5337), 1,
      anon_sym_rescue,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5539), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    ACTIONS(5543), 1,
      anon_sym_QMARK,
    ACTIONS(5545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5549), 1,
      anon_sym_GT_EQ,
    ACTIONS(5551), 1,
      anon_sym_EQ_EQ,
    STATE(3611), 1,
      sym_heredoc_body,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5537), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5553), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [105093] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    STATE(3612), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105145] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3613), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [105225] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3614), 1,
      sym_heredoc_body,
    STATE(3616), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105277] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    STATE(3615), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105329] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5555), 1,
      anon_sym_COMMA,
    STATE(3616), 1,
      sym_heredoc_body,
    STATE(3709), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4030), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105383] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5353), 1,
      anon_sym_rescue,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3617), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [105465] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    STATE(3618), 1,
      sym_heredoc_body,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105519] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    STATE(3619), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105573] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    STATE(3620), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105625] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5539), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    ACTIONS(5545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5549), 1,
      anon_sym_GT_EQ,
    ACTIONS(5551), 1,
      anon_sym_EQ_EQ,
    STATE(3621), 1,
      sym_heredoc_body,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5537), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5553), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 10,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [105705] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(4699), 1,
      anon_sym_PIPE,
    ACTIONS(4701), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4703), 1,
      anon_sym_AMP,
    ACTIONS(4707), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4709), 1,
      anon_sym_CARET,
    ACTIONS(4711), 1,
      anon_sym_QMARK,
    ACTIONS(4713), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4719), 1,
      anon_sym_GT_EQ,
    ACTIONS(4725), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4729), 1,
      sym__binary_star_star,
    ACTIONS(5333), 1,
      anon_sym_rescue,
    STATE(3622), 1,
      sym_heredoc_body,
    ACTIONS(4717), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4721), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4705), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4723), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4727), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [105789] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    ACTIONS(5491), 1,
      anon_sym_PIPE,
    ACTIONS(5495), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    STATE(3623), 1,
      sym_heredoc_body,
    ACTIONS(5507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105853] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5557), 1,
      anon_sym_rescue,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5571), 1,
      anon_sym_QMARK,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3624), 1,
      sym_heredoc_body,
    STATE(3797), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [105939] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3625), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [106019] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    ACTIONS(5471), 1,
      anon_sym_rescue,
    STATE(3626), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [106101] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5387), 1,
      anon_sym_rescue,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3627), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [106183] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(3628), 1,
      sym_heredoc_body,
    STATE(4490), 1,
      sym_keyword_pattern,
    STATE(4496), 1,
      sym__hash_pattern_any_rest,
    STATE(5640), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(5591), 2,
      sym_constant,
      sym_identifier,
    STATE(4507), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5806), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5593), 6,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5595), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [106253] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5597), 1,
      anon_sym_COMMA,
    STATE(3629), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [106305] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5600), 1,
      anon_sym_in,
    ACTIONS(5602), 1,
      anon_sym_EQ_GT,
    STATE(3630), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [106361] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    STATE(3631), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 11,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [106439] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    STATE(3632), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [106491] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    ACTIONS(5491), 1,
      anon_sym_PIPE,
    ACTIONS(5495), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5509), 1,
      anon_sym_GT_EQ,
    ACTIONS(5515), 1,
      anon_sym_EQ_EQ,
    STATE(3633), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5497), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5517), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [106563] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    STATE(3634), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [106647] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    STATE(3635), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [106731] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3636), 1,
      sym_heredoc_body,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [106785] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3637), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [106837] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3638), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [106889] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3639), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [106949] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3640), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [107007] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3641), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [107081] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3642), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [107161] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_GT_EQ,
    ACTIONS(5551), 1,
      anon_sym_EQ_EQ,
    STATE(3643), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5537), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5553), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [107233] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3644), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 14,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [107305] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    STATE(3645), 1,
      sym_heredoc_body,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [107361] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5632), 1,
      anon_sym_EQ_GT,
    STATE(3646), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [107445] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3647), 1,
      sym_heredoc_body,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [107501] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3648), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 14,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [107573] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5387), 1,
      anon_sym_rescue,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    STATE(3649), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [107659] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    ACTIONS(5491), 1,
      anon_sym_PIPE,
    ACTIONS(5495), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5509), 1,
      anon_sym_GT_EQ,
    ACTIONS(5515), 1,
      anon_sym_EQ_EQ,
    STATE(3650), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5497), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5517), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [107731] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3610), 1,
      aux_sym_exceptions_repeat1,
    STATE(3651), 1,
      sym_heredoc_body,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [107783] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    ACTIONS(5491), 1,
      anon_sym_PIPE,
    ACTIONS(5495), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5509), 1,
      anon_sym_GT_EQ,
    ACTIONS(5515), 1,
      anon_sym_EQ_EQ,
    STATE(3652), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5497), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5517), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 12,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [107857] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    STATE(3653), 1,
      sym_heredoc_body,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [107921] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3654), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [107973] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3655), 1,
      sym_heredoc_body,
    STATE(3716), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108025] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3656), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [108105] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    STATE(3657), 1,
      sym_heredoc_body,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108159] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3658), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [108239] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3659), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 11,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [108317] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5600), 1,
      anon_sym_in,
    ACTIONS(5602), 1,
      anon_sym_EQ_GT,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(3660), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [108401] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(3661), 1,
      sym_heredoc_body,
    STATE(4490), 1,
      sym_keyword_pattern,
    STATE(4504), 1,
      sym__hash_pattern_any_rest,
    STATE(5640), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(5591), 2,
      sym_constant,
      sym_identifier,
    STATE(4507), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5806), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5636), 6,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5638), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [108471] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5539), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    ACTIONS(5543), 1,
      anon_sym_QMARK,
    ACTIONS(5545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5549), 1,
      anon_sym_GT_EQ,
    ACTIONS(5551), 1,
      anon_sym_EQ_EQ,
    STATE(3662), 1,
      sym_heredoc_body,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5537), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5553), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [108553] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(3663), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [108633] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5600), 1,
      anon_sym_in,
    ACTIONS(5602), 1,
      anon_sym_EQ_GT,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(3664), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [108717] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    ACTIONS(5495), 1,
      anon_sym_AMP,
    STATE(3665), 1,
      sym_heredoc_body,
    ACTIONS(5507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108777] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3666), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [108857] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3667), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [108935] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3668), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [109015] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    STATE(3669), 1,
      sym_heredoc_body,
    ACTIONS(5507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [109073] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3670), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [109153] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3671), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [109203] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    STATE(3672), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [109255] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(5640), 1,
      anon_sym_rescue,
    STATE(3673), 1,
      sym_heredoc_body,
    STATE(3835), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [109339] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3674), 1,
      sym_heredoc_body,
    ACTIONS(3106), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3104), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [109389] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5642), 1,
      anon_sym_COMMA,
    STATE(3675), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [109441] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5645), 1,
      sym__binary_star_star,
    STATE(3676), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [109493] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3677), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [109557] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5555), 1,
      anon_sym_COMMA,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5571), 1,
      anon_sym_QMARK,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    ACTIONS(5647), 1,
      anon_sym_rescue,
    STATE(3616), 1,
      aux_sym_exceptions_repeat1,
    STATE(3678), 1,
      sym_heredoc_body,
    ACTIONS(3559), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3557), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [109645] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5539), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    ACTIONS(5543), 1,
      anon_sym_QMARK,
    ACTIONS(5545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5549), 1,
      anon_sym_GT_EQ,
    ACTIONS(5551), 1,
      anon_sym_EQ_EQ,
    STATE(3679), 1,
      sym_heredoc_body,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5537), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5553), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [109727] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    ACTIONS(5459), 1,
      anon_sym_rescue,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    STATE(3680), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [109813] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5600), 1,
      anon_sym_in,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    ACTIONS(5649), 1,
      anon_sym_EQ_GT,
    STATE(3681), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [109897] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3682), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [109977] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3683), 1,
      sym_heredoc_body,
    ACTIONS(3419), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3349), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110027] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 26,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110083] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3685), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 11,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [110161] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5539), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    ACTIONS(5543), 1,
      anon_sym_QMARK,
    ACTIONS(5545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5549), 1,
      anon_sym_GT_EQ,
    ACTIONS(5551), 1,
      anon_sym_EQ_EQ,
    STATE(3686), 1,
      sym_heredoc_body,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5537), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5553), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [110243] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_in,
    ACTIONS(5602), 1,
      anon_sym_EQ_GT,
    STATE(3687), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110297] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3688), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110349] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(5640), 1,
      anon_sym_rescue,
    STATE(3689), 1,
      sym_heredoc_body,
    STATE(3835), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [110437] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5600), 1,
      anon_sym_in,
    ACTIONS(5602), 1,
      anon_sym_EQ_GT,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(3690), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [110521] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    STATE(3691), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110573] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(5349), 1,
      anon_sym_rescue,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5539), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    ACTIONS(5543), 1,
      anon_sym_QMARK,
    ACTIONS(5545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5549), 1,
      anon_sym_GT_EQ,
    ACTIONS(5551), 1,
      anon_sym_EQ_EQ,
    STATE(3692), 1,
      sym_heredoc_body,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5537), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5553), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [110657] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    STATE(3693), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [110741] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    ACTIONS(5547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5549), 1,
      anon_sym_GT_EQ,
    ACTIONS(5551), 1,
      anon_sym_EQ_EQ,
    STATE(3694), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5537), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5553), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 12,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [110815] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(5349), 1,
      anon_sym_rescue,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5539), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    ACTIONS(5543), 1,
      anon_sym_QMARK,
    ACTIONS(5545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5549), 1,
      anon_sym_GT_EQ,
    ACTIONS(5551), 1,
      anon_sym_EQ_EQ,
    STATE(3695), 1,
      sym_heredoc_body,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5537), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5553), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [110899] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3696), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110951] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3697), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 14,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [111023] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3698), 1,
      sym_heredoc_body,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111079] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5539), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    ACTIONS(5545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5549), 1,
      anon_sym_GT_EQ,
    ACTIONS(5551), 1,
      anon_sym_EQ_EQ,
    STATE(3699), 1,
      sym_heredoc_body,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5537), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5553), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 10,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [111159] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3700), 1,
      sym_heredoc_body,
    ACTIONS(3573), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3571), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111209] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_GT_EQ,
    ACTIONS(5551), 1,
      anon_sym_EQ_EQ,
    STATE(3701), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5537), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5553), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [111281] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3702), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 14,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [111353] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3703), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [111427] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3704), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111491] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3705), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111549] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5539), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    ACTIONS(5543), 1,
      anon_sym_QMARK,
    ACTIONS(5545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5549), 1,
      anon_sym_GT_EQ,
    ACTIONS(5551), 1,
      anon_sym_EQ_EQ,
    STATE(3706), 1,
      sym_heredoc_body,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5537), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5553), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [111631] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5651), 1,
      sym__binary_star_star,
    STATE(3707), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111683] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3708), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111743] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5653), 1,
      anon_sym_COMMA,
    STATE(3709), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111795] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(3710), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [111875] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3711), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111927] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3712), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [112007] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5539), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    ACTIONS(5543), 1,
      anon_sym_QMARK,
    ACTIONS(5545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5549), 1,
      anon_sym_GT_EQ,
    ACTIONS(5551), 1,
      anon_sym_EQ_EQ,
    STATE(3713), 1,
      sym_heredoc_body,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5537), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5553), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [112089] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3714), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112141] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3715), 1,
      sym_heredoc_body,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112195] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5656), 1,
      anon_sym_COMMA,
    STATE(3675), 1,
      aux_sym_exceptions_repeat1,
    STATE(3716), 1,
      sym_heredoc_body,
    ACTIONS(4030), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112249] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(3717), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [112329] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5571), 1,
      anon_sym_QMARK,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    ACTIONS(5658), 1,
      anon_sym_rescue,
    ACTIONS(5660), 1,
      anon_sym_COMMA,
    STATE(3718), 1,
      sym_heredoc_body,
    STATE(3797), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3557), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112417] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    ACTIONS(5491), 1,
      anon_sym_PIPE,
    ACTIONS(5493), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5495), 1,
      anon_sym_AMP,
    ACTIONS(5499), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5509), 1,
      anon_sym_GT_EQ,
    ACTIONS(5515), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5519), 1,
      anon_sym_QMARK,
    STATE(3719), 1,
      sym_heredoc_body,
    ACTIONS(5507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5497), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5517), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [112499] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(3720), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [112579] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    STATE(3721), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 11,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [112657] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    ACTIONS(5491), 1,
      anon_sym_PIPE,
    ACTIONS(5493), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5495), 1,
      anon_sym_AMP,
    ACTIONS(5499), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5509), 1,
      anon_sym_GT_EQ,
    ACTIONS(5515), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5519), 1,
      anon_sym_QMARK,
    STATE(3722), 1,
      sym_heredoc_body,
    ACTIONS(5507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5497), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5517), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [112739] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(3723), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [112819] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(3724), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [112899] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5571), 1,
      anon_sym_QMARK,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    ACTIONS(5662), 1,
      anon_sym_rescue,
    STATE(3616), 1,
      aux_sym_exceptions_repeat1,
    STATE(3725), 1,
      sym_heredoc_body,
    ACTIONS(3559), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [112985] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3726), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [113065] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    ACTIONS(5491), 1,
      anon_sym_PIPE,
    ACTIONS(5493), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5495), 1,
      anon_sym_AMP,
    ACTIONS(5499), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5509), 1,
      anon_sym_GT_EQ,
    ACTIONS(5515), 1,
      anon_sym_EQ_EQ,
    STATE(3727), 1,
      sym_heredoc_body,
    ACTIONS(5507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5497), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5517), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [113145] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    ACTIONS(5491), 1,
      anon_sym_PIPE,
    ACTIONS(5493), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5495), 1,
      anon_sym_AMP,
    ACTIONS(5499), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5509), 1,
      anon_sym_GT_EQ,
    ACTIONS(5515), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5519), 1,
      anon_sym_QMARK,
    STATE(3728), 1,
      sym_heredoc_body,
    ACTIONS(5507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5497), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5517), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [113227] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(3729), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [113307] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(5483), 1,
      anon_sym_rescue,
    ACTIONS(5485), 1,
      anon_sym_COMMA,
    STATE(3730), 1,
      sym_heredoc_body,
    STATE(3835), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3557), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113397] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5262), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5272), 1,
      anon_sym_QMARK,
    ACTIONS(5274), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    STATE(3731), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [113477] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5664), 1,
      sym__binary_star_star,
    STATE(3732), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113529] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    STATE(3733), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113581] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    STATE(3734), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 14,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [113653] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    STATE(3735), 1,
      sym_heredoc_body,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113709] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    STATE(3736), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 14,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [113781] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    STATE(3737), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [113855] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    ACTIONS(5491), 1,
      anon_sym_PIPE,
    ACTIONS(5493), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5495), 1,
      anon_sym_AMP,
    ACTIONS(5499), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5509), 1,
      anon_sym_GT_EQ,
    ACTIONS(5515), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5519), 1,
      anon_sym_QMARK,
    STATE(3738), 1,
      sym_heredoc_body,
    ACTIONS(5507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5497), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5517), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [113937] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    STATE(3739), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114001] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    STATE(3740), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114059] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5666), 1,
      sym__binary_star_star,
    STATE(3741), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114111] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    STATE(3742), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114171] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    STATE(3743), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114223] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    STATE(3744), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114275] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    STATE(3745), 1,
      sym_heredoc_body,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__line_break,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114329] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3746), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114381] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3747), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [114459] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3748), 1,
      sym_heredoc_body,
    ACTIONS(3323), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3321), 27,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114509] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3749), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [114589] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3750), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [114669] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3751), 1,
      sym_heredoc_body,
    ACTIONS(3301), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3299), 27,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114719] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    ACTIONS(5459), 1,
      anon_sym_rescue,
    STATE(3752), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [114801] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(3753), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [114881] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(5337), 1,
      anon_sym_rescue,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5539), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    ACTIONS(5543), 1,
      anon_sym_QMARK,
    ACTIONS(5545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5549), 1,
      anon_sym_GT_EQ,
    ACTIONS(5551), 1,
      anon_sym_EQ_EQ,
    STATE(3754), 1,
      sym_heredoc_body,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5537), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5553), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [114965] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4066), 1,
      anon_sym_DOT,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    ACTIONS(5491), 1,
      anon_sym_PIPE,
    ACTIONS(5493), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5495), 1,
      anon_sym_AMP,
    ACTIONS(5499), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5509), 1,
      anon_sym_GT_EQ,
    ACTIONS(5515), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5519), 1,
      anon_sym_QMARK,
    STATE(3755), 1,
      sym_heredoc_body,
    ACTIONS(5507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5497), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5517), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [115047] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3841), 1,
      anon_sym_DOT,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    ACTIONS(5491), 1,
      anon_sym_PIPE,
    ACTIONS(5493), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5495), 1,
      anon_sym_AMP,
    ACTIONS(5499), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5509), 1,
      anon_sym_GT_EQ,
    ACTIONS(5515), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5519), 1,
      anon_sym_QMARK,
    STATE(3756), 1,
      sym_heredoc_body,
    ACTIONS(5507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5511), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5497), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5513), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5517), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [115129] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5489), 1,
      sym__binary_star_star,
    STATE(3757), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115181] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5555), 1,
      anon_sym_COMMA,
    STATE(3616), 1,
      aux_sym_exceptions_repeat1,
    STATE(3758), 1,
      sym_heredoc_body,
    ACTIONS(3559), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115235] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    STATE(3759), 1,
      sym_heredoc_body,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115291] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    STATE(3760), 1,
      sym_heredoc_body,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115349] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3761), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115400] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    STATE(3762), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115451] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    STATE(3763), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115502] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    ACTIONS(5672), 1,
      anon_sym_AMP,
    STATE(3764), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5676), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5678), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115561] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(3765), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [115640] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3766), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [115719] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3767), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [115798] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5742), 1,
      anon_sym_PIPE,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_CARET,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    STATE(3768), 1,
      sym_heredoc_body,
    ACTIONS(5748), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5750), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 18,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115861] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5571), 1,
      anon_sym_QMARK,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3769), 1,
      sym_heredoc_body,
    ACTIONS(4086), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [115942] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    STATE(3770), 1,
      sym_heredoc_body,
    ACTIONS(5748), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5750), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115999] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    ACTIONS(5742), 1,
      anon_sym_PIPE,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_CARET,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5760), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5762), 1,
      anon_sym_QMARK,
    ACTIONS(5764), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5768), 1,
      anon_sym_GT_EQ,
    ACTIONS(5770), 1,
      anon_sym_EQ_EQ,
    STATE(3771), 1,
      sym_heredoc_body,
    ACTIONS(5748), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5750), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5758), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5772), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [116080] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(5776), 1,
      anon_sym_EQ_GT,
    STATE(3772), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [116163] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    STATE(3773), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5676), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5678), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116220] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5571), 1,
      anon_sym_QMARK,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3774), 1,
      sym_heredoc_body,
    ACTIONS(3841), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [116301] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5571), 1,
      anon_sym_QMARK,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3775), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [116382] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3776), 1,
      sym_heredoc_body,
    ACTIONS(4082), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 8,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [116461] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3777), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116512] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    STATE(3778), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116563] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    ACTIONS(5471), 1,
      anon_sym_rescue,
    STATE(3610), 1,
      aux_sym_exceptions_repeat1,
    STATE(3779), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3557), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116650] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3780), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [116727] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(5780), 1,
      anon_sym_EQ_GT,
    STATE(3781), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [116810] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(3782), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [116889] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(5776), 1,
      anon_sym_EQ_GT,
    STATE(3783), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [116972] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5782), 1,
      sym__binary_star_star,
    STATE(3784), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117023] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(5640), 1,
      anon_sym_rescue,
    STATE(3785), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [117104] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    ACTIONS(5672), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(5786), 1,
      anon_sym_CARET,
    STATE(3786), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5676), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5678), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 18,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117167] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3787), 1,
      sym_heredoc_body,
    ACTIONS(4096), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 8,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [117246] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3788), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [117325] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(3789), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [117402] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    ACTIONS(5672), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(5786), 1,
      anon_sym_CARET,
    ACTIONS(5790), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5794), 1,
      anon_sym_EQ_EQ,
    STATE(3790), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5676), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5678), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5788), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [117475] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5571), 1,
      anon_sym_QMARK,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3791), 1,
      sym_heredoc_body,
    ACTIONS(3801), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [117556] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(5640), 1,
      anon_sym_rescue,
    STATE(3792), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [117641] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(5742), 1,
      anon_sym_PIPE,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_CARET,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5760), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5762), 1,
      anon_sym_QMARK,
    ACTIONS(5764), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5768), 1,
      anon_sym_GT_EQ,
    ACTIONS(5770), 1,
      anon_sym_EQ_EQ,
    STATE(3793), 1,
      sym_heredoc_body,
    ACTIONS(5748), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5750), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5758), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5772), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [117722] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    ACTIONS(5672), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(5786), 1,
      anon_sym_CARET,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5794), 1,
      anon_sym_EQ_EQ,
    STATE(3794), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5676), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5678), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5788), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 12,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [117793] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3795), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [117872] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    STATE(3796), 1,
      sym_heredoc_body,
    ACTIONS(5676), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5678), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117927] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5660), 1,
      anon_sym_COMMA,
    STATE(3797), 1,
      sym_heredoc_body,
    STATE(3814), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4030), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117980] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5571), 1,
      anon_sym_QMARK,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    ACTIONS(5662), 1,
      anon_sym_rescue,
    STATE(3798), 1,
      sym_heredoc_body,
    ACTIONS(3527), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [118063] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    ACTIONS(5672), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(5786), 1,
      anon_sym_CARET,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5794), 1,
      anon_sym_EQ_EQ,
    STATE(3799), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5676), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5678), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5788), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 12,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [118134] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    STATE(3800), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118185] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    ACTIONS(5742), 1,
      anon_sym_PIPE,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_CARET,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5760), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5762), 1,
      anon_sym_QMARK,
    ACTIONS(5764), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5768), 1,
      anon_sym_GT_EQ,
    ACTIONS(5770), 1,
      anon_sym_EQ_EQ,
    STATE(3801), 1,
      sym_heredoc_body,
    ACTIONS(5748), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5750), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5758), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5772), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [118266] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    STATE(3802), 1,
      sym_heredoc_body,
    ACTIONS(5678), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118319] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(3803), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [118398] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5742), 1,
      anon_sym_PIPE,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_CARET,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    ACTIONS(5766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5768), 1,
      anon_sym_GT_EQ,
    ACTIONS(5770), 1,
      anon_sym_EQ_EQ,
    STATE(3804), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5748), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5750), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5758), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5772), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 11,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [118471] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5742), 1,
      anon_sym_PIPE,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_CARET,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    ACTIONS(5768), 1,
      anon_sym_GT_EQ,
    ACTIONS(5770), 1,
      anon_sym_EQ_EQ,
    STATE(3805), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5748), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5750), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5758), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5772), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 12,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [118542] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5571), 1,
      anon_sym_QMARK,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3806), 1,
      sym_heredoc_body,
    ACTIONS(3801), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [118623] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    STATE(3807), 1,
      sym_heredoc_body,
    ACTIONS(5750), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118678] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    ACTIONS(5742), 1,
      anon_sym_PIPE,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_CARET,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5760), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5764), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5768), 1,
      anon_sym_GT_EQ,
    ACTIONS(5770), 1,
      anon_sym_EQ_EQ,
    STATE(3808), 1,
      sym_heredoc_body,
    ACTIONS(5748), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5750), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5758), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5772), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [118757] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5742), 1,
      anon_sym_PIPE,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_CARET,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5760), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5764), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5768), 1,
      anon_sym_GT_EQ,
    ACTIONS(5770), 1,
      anon_sym_EQ_EQ,
    STATE(3809), 1,
      sym_heredoc_body,
    ACTIONS(5748), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5750), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5758), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5772), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [118836] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5798), 1,
      sym__binary_star_star,
    STATE(3810), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118887] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5571), 1,
      anon_sym_QMARK,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    ACTIONS(5662), 1,
      anon_sym_rescue,
    STATE(3811), 1,
      sym_heredoc_body,
    ACTIONS(3551), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [118970] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    STATE(3812), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119021] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    STATE(3813), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119072] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5800), 1,
      anon_sym_COMMA,
    STATE(3814), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119123] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    ACTIONS(5672), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(5786), 1,
      anon_sym_CARET,
    ACTIONS(5790), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5794), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5803), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5805), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_PIPE_PIPE,
    STATE(3815), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5676), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5678), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5788), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [119204] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(3816), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [119283] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3817), 1,
      sym_heredoc_body,
    ACTIONS(3801), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119334] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(3818), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [119413] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(5776), 1,
      anon_sym_EQ_GT,
    STATE(3819), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119468] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(5776), 1,
      anon_sym_EQ_GT,
    STATE(3820), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [119551] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5742), 1,
      anon_sym_PIPE,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_CARET,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    ACTIONS(5768), 1,
      anon_sym_GT_EQ,
    ACTIONS(5770), 1,
      anon_sym_EQ_EQ,
    STATE(3821), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5748), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5750), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5758), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5772), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 12,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [119622] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5811), 1,
      sym__binary_star_star,
    STATE(3822), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119673] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5813), 1,
      sym__binary_star_star,
    STATE(3823), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119724] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3824), 1,
      sym_heredoc_body,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119777] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(3825), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [119856] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5742), 1,
      anon_sym_PIPE,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_CARET,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5760), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5762), 1,
      anon_sym_QMARK,
    ACTIONS(5764), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5768), 1,
      anon_sym_GT_EQ,
    ACTIONS(5770), 1,
      anon_sym_EQ_EQ,
    STATE(3826), 1,
      sym_heredoc_body,
    ACTIONS(5748), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5750), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5758), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5772), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [119937] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3827), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119988] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5742), 1,
      anon_sym_PIPE,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_CARET,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5760), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5762), 1,
      anon_sym_QMARK,
    ACTIONS(5764), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5768), 1,
      anon_sym_GT_EQ,
    ACTIONS(5770), 1,
      anon_sym_EQ_EQ,
    STATE(3828), 1,
      sym_heredoc_body,
    ACTIONS(5748), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5750), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5758), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5772), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [120069] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    STATE(3829), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120120] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    STATE(3830), 1,
      sym_heredoc_body,
    ACTIONS(5748), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5750), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120179] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    STATE(3831), 1,
      sym_heredoc_body,
    ACTIONS(4060), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120230] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3832), 1,
      sym_heredoc_body,
    STATE(3835), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120281] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5557), 1,
      anon_sym_rescue,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5571), 1,
      anon_sym_QMARK,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3833), 1,
      sym_heredoc_body,
    ACTIONS(3527), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [120364] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5815), 1,
      sym__binary_star_star,
    STATE(3834), 1,
      sym_heredoc_body,
    ACTIONS(3471), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120415] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COMMA,
    STATE(3835), 1,
      sym_heredoc_body,
    STATE(3885), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4030), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120468] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_DOT,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    ACTIONS(5672), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(5786), 1,
      anon_sym_CARET,
    ACTIONS(5790), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5794), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5803), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5805), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_PIPE_PIPE,
    STATE(3836), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5676), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5678), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5788), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [120549] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3837), 1,
      sym_heredoc_body,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120602] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5353), 1,
      anon_sym_rescue,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    STATE(3582), 1,
      aux_sym_exceptions_repeat1,
    STATE(3838), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3557), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120689] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3839), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120740] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3840), 1,
      sym_heredoc_body,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 18,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120799] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    ACTIONS(5672), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(5786), 1,
      anon_sym_CARET,
    ACTIONS(5790), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5794), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5803), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5805), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_PIPE_PIPE,
    STATE(3841), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5676), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5678), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5788), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [120880] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    STATE(3842), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120931] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    STATE(3843), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120982] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3844), 1,
      sym_heredoc_body,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 18,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121039] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3845), 1,
      sym_heredoc_body,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 17,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121102] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5557), 1,
      anon_sym_rescue,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5571), 1,
      anon_sym_QMARK,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3846), 1,
      sym_heredoc_body,
    ACTIONS(3551), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3549), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [121185] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_DOT,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    ACTIONS(5672), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(5786), 1,
      anon_sym_CARET,
    ACTIONS(5790), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5794), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5803), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5805), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5809), 1,
      anon_sym_PIPE_PIPE,
    STATE(3847), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5676), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5678), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5788), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [121264] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3848), 1,
      sym_heredoc_body,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 10,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [121337] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3849), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121388] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5571), 1,
      anon_sym_QMARK,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3850), 1,
      sym_heredoc_body,
    ACTIONS(4100), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [121469] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3851), 1,
      sym_heredoc_body,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 11,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [121540] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3852), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121599] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3853), 1,
      sym_heredoc_body,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121654] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3854), 1,
      sym_heredoc_body,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 11,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [121725] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    ACTIONS(5672), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(5786), 1,
      anon_sym_CARET,
    ACTIONS(5790), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5794), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5803), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5805), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_PIPE_PIPE,
    STATE(3855), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5676), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5678), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5788), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [121806] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3856), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [121883] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    ACTIONS(5672), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(5786), 1,
      anon_sym_CARET,
    ACTIONS(5790), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5794), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5803), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5805), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_PIPE_PIPE,
    STATE(3857), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5676), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5678), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5788), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [121964] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3858), 1,
      sym_heredoc_body,
    ACTIONS(4060), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122015] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(5776), 1,
      anon_sym_EQ_GT,
    STATE(3859), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122068] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    STATE(3860), 1,
      sym_heredoc_body,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122121] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    STATE(3861), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122172] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3862), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122229] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3863), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122292] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_PIPE,
    ACTIONS(5561), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_AMP,
    ACTIONS(5567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5569), 1,
      anon_sym_CARET,
    ACTIONS(5571), 1,
      anon_sym_QMARK,
    ACTIONS(5573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5579), 1,
      anon_sym_GT_EQ,
    ACTIONS(5585), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5589), 1,
      sym__binary_star_star,
    STATE(3864), 1,
      sym_heredoc_body,
    ACTIONS(4066), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5581), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5565), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5583), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5587), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [122373] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3865), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [122452] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3866), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 12,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [122525] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(3867), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [122596] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3868), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [122667] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3869), 1,
      sym_heredoc_body,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122722] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3870), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [122793] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    STATE(3871), 1,
      sym_heredoc_body,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122848] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(3872), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 13,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [122919] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5660), 1,
      anon_sym_COMMA,
    STATE(3797), 1,
      aux_sym_exceptions_repeat1,
    STATE(3873), 1,
      sym_heredoc_body,
    ACTIONS(3559), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122972] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3874), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123023] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(3875), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 12,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [123096] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    STATE(3876), 1,
      sym_heredoc_body,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123149] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    STATE(3877), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123200] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(3878), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [123279] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    ACTIONS(5672), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(5786), 1,
      anon_sym_CARET,
    ACTIONS(5790), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5794), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5803), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5805), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5809), 1,
      anon_sym_PIPE_PIPE,
    STATE(3879), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5676), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5678), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5788), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [123358] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COMMA,
    STATE(3835), 1,
      aux_sym_exceptions_repeat1,
    STATE(3880), 1,
      sym_heredoc_body,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123411] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3881), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [123490] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym__binary_star_star,
    STATE(3882), 1,
      sym_heredoc_body,
    ACTIONS(3801), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123541] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    STATE(3883), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123604] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    STATE(3884), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123661] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5817), 1,
      anon_sym_COMMA,
    STATE(3885), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123712] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3797), 1,
      aux_sym_exceptions_repeat1,
    STATE(3886), 1,
      sym_heredoc_body,
    ACTIONS(3559), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123763] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3887), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [123842] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(3888), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [123919] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    STATE(3889), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123978] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3890), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [124056] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3891), 1,
      sym_heredoc_body,
    ACTIONS(3801), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [124136] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5884), 1,
      sym__binary_star_star,
    STATE(3892), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124186] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3893), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124236] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3894), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [124314] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3895), 1,
      sym_heredoc_body,
    ACTIONS(4086), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [124394] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5886), 1,
      anon_sym_PIPE,
    ACTIONS(5888), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5894), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5896), 1,
      anon_sym_CARET,
    ACTIONS(5898), 1,
      anon_sym_QMARK,
    ACTIONS(5900), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5906), 1,
      anon_sym_GT_EQ,
    ACTIONS(5912), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3896), 1,
      sym_heredoc_body,
    ACTIONS(3801), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5892), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5914), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 6,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [124474] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5918), 1,
      sym__binary_star_star,
    STATE(3897), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124524] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3898), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [124602] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5920), 1,
      anon_sym_EQ_GT,
    STATE(3899), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [124684] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(3900), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4450), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [124762] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_in,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    ACTIONS(5922), 1,
      anon_sym_EQ_GT,
    STATE(3901), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [124844] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3902), 1,
      sym_heredoc_body,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124896] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3903), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124946] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3904), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124996] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    STATE(3905), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [125078] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5886), 1,
      anon_sym_PIPE,
    ACTIONS(5888), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5894), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5896), 1,
      anon_sym_CARET,
    ACTIONS(5900), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5906), 1,
      anon_sym_GT_EQ,
    ACTIONS(5912), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3906), 1,
      sym_heredoc_body,
    ACTIONS(4082), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5892), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5914), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [125156] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(3907), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4448), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [125234] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    STATE(3908), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [125316] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3909), 1,
      sym_heredoc_body,
    ACTIONS(4066), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [125396] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3910), 1,
      sym_heredoc_body,
    ACTIONS(3841), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [125476] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3911), 1,
      sym_heredoc_body,
    ACTIONS(4100), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [125556] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3912), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 17,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125614] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3913), 1,
      sym_heredoc_body,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125668] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_in,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    ACTIONS(5483), 1,
      anon_sym_rescue,
    STATE(3914), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125752] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5647), 1,
      anon_sym_rescue,
    ACTIONS(5886), 1,
      anon_sym_PIPE,
    ACTIONS(5888), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5894), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5896), 1,
      anon_sym_CARET,
    ACTIONS(5898), 1,
      anon_sym_QMARK,
    ACTIONS(5900), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5906), 1,
      anon_sym_GT_EQ,
    ACTIONS(5912), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3915), 1,
      sym_heredoc_body,
    ACTIONS(3551), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5892), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3549), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5914), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125834] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3916), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 17,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125890] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5886), 1,
      anon_sym_PIPE,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5896), 1,
      anon_sym_CARET,
    ACTIONS(5906), 1,
      anon_sym_GT_EQ,
    ACTIONS(5912), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3917), 1,
      sym_heredoc_body,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5892), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5914), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 10,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [125960] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5886), 1,
      anon_sym_PIPE,
    ACTIONS(5888), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5894), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5896), 1,
      anon_sym_CARET,
    ACTIONS(5900), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5906), 1,
      anon_sym_GT_EQ,
    ACTIONS(5912), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3918), 1,
      sym_heredoc_body,
    ACTIONS(4096), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5892), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5914), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [126038] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5886), 1,
      anon_sym_PIPE,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5896), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5906), 1,
      anon_sym_GT_EQ,
    ACTIONS(5912), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3919), 1,
      sym_heredoc_body,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5892), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5914), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [126110] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5886), 1,
      anon_sym_PIPE,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5896), 1,
      anon_sym_CARET,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3920), 1,
      sym_heredoc_body,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 16,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126172] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    ACTIONS(5465), 1,
      anon_sym_COMMA,
    ACTIONS(5924), 1,
      anon_sym_rescue,
    STATE(3582), 1,
      aux_sym_exceptions_repeat1,
    STATE(3921), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3557), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126256] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3922), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 16,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126318] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5886), 1,
      anon_sym_PIPE,
    ACTIONS(5888), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5894), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5896), 1,
      anon_sym_CARET,
    ACTIONS(5898), 1,
      anon_sym_QMARK,
    ACTIONS(5900), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5906), 1,
      anon_sym_GT_EQ,
    ACTIONS(5912), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3923), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5892), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5914), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 6,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [126398] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5465), 1,
      anon_sym_COMMA,
    STATE(3582), 1,
      aux_sym_exceptions_repeat1,
    STATE(3924), 1,
      sym_heredoc_body,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126450] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3925), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [126522] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(3926), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [126600] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3927), 1,
      sym_heredoc_body,
    ACTIONS(3801), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126650] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_in,
    ACTIONS(5602), 1,
      anon_sym_EQ_GT,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3928), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [126732] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3929), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 10,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [126802] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3930), 1,
      sym_heredoc_body,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 17,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126858] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3931), 1,
      sym_heredoc_body,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 17,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126916] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3932), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126966] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3933), 1,
      sym_heredoc_body,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127020] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5926), 1,
      sym__binary_star_star,
    STATE(3934), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127070] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    STATE(3935), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [127152] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3936), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127202] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3937), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [127282] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3938), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4456), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [127360] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3939), 1,
      sym_heredoc_body,
    ACTIONS(4082), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 7,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [127438] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3940), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 10,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [127508] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3941), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 9,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [127584] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3942), 1,
      sym_heredoc_body,
    ACTIONS(4060), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127634] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3943), 1,
      sym_heredoc_body,
    ACTIONS(3801), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [127714] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    ACTIONS(5928), 1,
      anon_sym_rescue,
    ACTIONS(5930), 1,
      anon_sym_COMMA,
    STATE(3944), 1,
      sym_heredoc_body,
    STATE(4036), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3557), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127798] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_rescue,
    ACTIONS(5886), 1,
      anon_sym_PIPE,
    ACTIONS(5888), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5894), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5896), 1,
      anon_sym_CARET,
    ACTIONS(5898), 1,
      anon_sym_QMARK,
    ACTIONS(5900), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5906), 1,
      anon_sym_GT_EQ,
    ACTIONS(5912), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3945), 1,
      sym_heredoc_body,
    ACTIONS(3551), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5892), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3549), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5914), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127880] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3946), 1,
      sym_heredoc_body,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127932] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5886), 1,
      anon_sym_PIPE,
    ACTIONS(5888), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5894), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5896), 1,
      anon_sym_CARET,
    ACTIONS(5898), 1,
      anon_sym_QMARK,
    ACTIONS(5900), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5906), 1,
      anon_sym_GT_EQ,
    ACTIONS(5912), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3947), 1,
      sym_heredoc_body,
    ACTIONS(4100), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5892), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5914), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 6,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [128012] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3948), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [128090] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3949), 1,
      sym_heredoc_body,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__line_break,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128142] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(3950), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4456), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [128220] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    STATE(3951), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128274] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3952), 1,
      sym_heredoc_body,
    ACTIONS(4096), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 7,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [128352] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3953), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [128430] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3954), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [128508] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3955), 1,
      sym_heredoc_body,
    ACTIONS(4060), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128558] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    ACTIONS(5483), 1,
      anon_sym_rescue,
    STATE(3956), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [128638] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_in,
    ACTIONS(5602), 1,
      anon_sym_EQ_GT,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3957), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128692] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_in,
    ACTIONS(5602), 1,
      anon_sym_EQ_GT,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3958), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [128774] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym__binary_star_star,
    ACTIONS(5604), 1,
      anon_sym_PIPE,
    ACTIONS(5606), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5608), 1,
      anon_sym_AMP,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_CARET,
    ACTIONS(5616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5622), 1,
      anon_sym_GT_EQ,
    ACTIONS(5628), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(3959), 1,
      sym_heredoc_body,
    ACTIONS(5620), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5624), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5610), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5626), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5630), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [128852] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5647), 1,
      anon_sym_rescue,
    ACTIONS(5886), 1,
      anon_sym_PIPE,
    ACTIONS(5888), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5894), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5896), 1,
      anon_sym_CARET,
    ACTIONS(5898), 1,
      anon_sym_QMARK,
    ACTIONS(5900), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5906), 1,
      anon_sym_GT_EQ,
    ACTIONS(5912), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3960), 1,
      sym_heredoc_body,
    ACTIONS(3527), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5892), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5914), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128934] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5886), 1,
      anon_sym_PIPE,
    ACTIONS(5888), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5894), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5896), 1,
      anon_sym_CARET,
    ACTIONS(5898), 1,
      anon_sym_QMARK,
    ACTIONS(5900), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5906), 1,
      anon_sym_GT_EQ,
    ACTIONS(5912), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3961), 1,
      sym_heredoc_body,
    ACTIONS(4086), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5892), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5914), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 6,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [129014] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5886), 1,
      anon_sym_PIPE,
    ACTIONS(5888), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5894), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5896), 1,
      anon_sym_CARET,
    ACTIONS(5898), 1,
      anon_sym_QMARK,
    ACTIONS(5900), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5906), 1,
      anon_sym_GT_EQ,
    ACTIONS(5912), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3962), 1,
      sym_heredoc_body,
    ACTIONS(3801), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5892), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5914), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 6,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [129094] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3963), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [129172] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5886), 1,
      anon_sym_PIPE,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5896), 1,
      anon_sym_CARET,
    ACTIONS(5906), 1,
      anon_sym_GT_EQ,
    ACTIONS(5912), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3964), 1,
      sym_heredoc_body,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5892), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5914), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 10,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [129242] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3965), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129292] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    ACTIONS(5932), 1,
      anon_sym_COMMA,
    STATE(3966), 1,
      sym_heredoc_body,
    STATE(5280), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5936), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5934), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129376] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_in,
    ACTIONS(5602), 1,
      anon_sym_EQ_GT,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3967), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [129458] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3968), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 12,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [129528] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3969), 1,
      sym_heredoc_body,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129582] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3970), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 12,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [129652] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5938), 1,
      sym__binary_star_star,
    STATE(3971), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129702] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3972), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4448), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [129780] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    ACTIONS(5940), 1,
      anon_sym_rescue,
    STATE(3973), 1,
      sym_heredoc_body,
    STATE(4036), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3557), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [129862] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3974), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 11,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [129934] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3975), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 18,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129996] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3976), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130052] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3977), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [130130] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3978), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130188] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3979), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130238] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3980), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130288] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    ACTIONS(5471), 1,
      anon_sym_rescue,
    STATE(3981), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130372] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3982), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 9,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [130448] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    ACTIONS(5531), 1,
      anon_sym_COMMA,
    ACTIONS(5942), 1,
      anon_sym_rescue,
    STATE(3610), 1,
      aux_sym_exceptions_repeat1,
    STATE(3983), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3557), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130536] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3984), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [130614] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5353), 1,
      anon_sym_rescue,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    STATE(3985), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130698] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3986), 1,
      sym_heredoc_body,
    ACTIONS(3801), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130748] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    ACTIONS(5531), 1,
      anon_sym_COMMA,
    ACTIONS(5942), 1,
      anon_sym_rescue,
    STATE(3610), 1,
      aux_sym_exceptions_repeat1,
    STATE(3987), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3557), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130832] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_rescue,
    ACTIONS(5886), 1,
      anon_sym_PIPE,
    ACTIONS(5888), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5890), 1,
      anon_sym_AMP,
    ACTIONS(5894), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5896), 1,
      anon_sym_CARET,
    ACTIONS(5898), 1,
      anon_sym_QMARK,
    ACTIONS(5900), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5906), 1,
      anon_sym_GT_EQ,
    ACTIONS(5912), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5916), 1,
      sym__binary_star_star,
    STATE(3988), 1,
      sym_heredoc_body,
    ACTIONS(3527), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5904), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5908), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5892), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5910), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5914), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130914] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_PIPE,
    ACTIONS(5391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5393), 1,
      anon_sym_AMP,
    ACTIONS(5397), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5399), 1,
      anon_sym_CARET,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    ACTIONS(5403), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5405), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5409), 1,
      anon_sym_GT_EQ,
    ACTIONS(5415), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5419), 1,
      sym__binary_star_star,
    STATE(3989), 1,
      sym_heredoc_body,
    ACTIONS(5407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5411), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5395), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5413), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5417), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4450), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [130992] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    ACTIONS(5465), 1,
      anon_sym_COMMA,
    ACTIONS(5924), 1,
      anon_sym_rescue,
    STATE(3582), 1,
      aux_sym_exceptions_repeat1,
    STATE(3990), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3557), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131080] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_in,
    ACTIONS(5602), 1,
      anon_sym_EQ_GT,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(3991), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131161] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_in,
    ACTIONS(5602), 1,
      anon_sym_EQ_GT,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(3992), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4395), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131242] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5980), 1,
      anon_sym_AMP,
    ACTIONS(5984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5986), 1,
      anon_sym_CARET,
    ACTIONS(5988), 1,
      anon_sym_QMARK,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(3993), 1,
      sym_heredoc_body,
    ACTIONS(3801), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5982), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131321] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(5776), 1,
      anon_sym_EQ_GT,
    STATE(3994), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131374] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6008), 1,
      sym__binary_star_star,
    STATE(3995), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131423] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(6010), 1,
      anon_sym_EQ_GT,
    STATE(3996), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4395), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131504] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(3997), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131553] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5980), 1,
      anon_sym_AMP,
    ACTIONS(5984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5986), 1,
      anon_sym_CARET,
    ACTIONS(5988), 1,
      anon_sym_QMARK,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(3998), 1,
      sym_heredoc_body,
    ACTIONS(4056), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5982), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4054), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131632] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3999), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4456), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [131709] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4000), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 8,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [131784] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5980), 1,
      anon_sym_AMP,
    ACTIONS(5984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5986), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4001), 1,
      sym_heredoc_body,
    ACTIONS(4082), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5982), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 6,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [131861] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4002), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [131938] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5980), 1,
      anon_sym_AMP,
    ACTIONS(5984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5986), 1,
      anon_sym_CARET,
    ACTIONS(5988), 1,
      anon_sym_QMARK,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4003), 1,
      sym_heredoc_body,
    ACTIONS(4086), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5982), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132017] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5980), 1,
      anon_sym_AMP,
    ACTIONS(5984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5986), 1,
      anon_sym_CARET,
    ACTIONS(5988), 1,
      anon_sym_QMARK,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4004), 1,
      sym_heredoc_body,
    ACTIONS(3801), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5982), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132096] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_in,
    ACTIONS(5602), 1,
      anon_sym_EQ_GT,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4005), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132177] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5930), 1,
      anon_sym_COMMA,
    STATE(4006), 1,
      sym_heredoc_body,
    STATE(4036), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132228] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4007), 1,
      sym_heredoc_body,
    STATE(4036), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132277] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(4008), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5936), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3839), 5,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132356] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4009), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 17,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132417] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4010), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132466] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_in,
    ACTIONS(5602), 1,
      anon_sym_EQ_GT,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4011), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132519] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5089), 1,
      anon_sym_PIPE,
    ACTIONS(5091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5093), 1,
      anon_sym_AMP,
    ACTIONS(5097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5099), 1,
      anon_sym_CARET,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    ACTIONS(5103), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5105), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5109), 1,
      anon_sym_GT_EQ,
    ACTIONS(5115), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5119), 1,
      sym__binary_star_star,
    ACTIONS(5940), 1,
      anon_sym_rescue,
    STATE(4012), 1,
      sym_heredoc_body,
    ACTIONS(5107), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5111), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5095), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5113), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5117), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [132598] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4013), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [132675] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4014), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [132752] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4015), 1,
      sym_heredoc_body,
    ACTIONS(3801), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132801] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5980), 1,
      anon_sym_AMP,
    ACTIONS(5984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5986), 1,
      anon_sym_CARET,
    ACTIONS(5988), 1,
      anon_sym_QMARK,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4016), 1,
      sym_heredoc_body,
    ACTIONS(4100), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5982), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4098), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132880] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6012), 1,
      anon_sym_COMMA,
    STATE(4017), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132929] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5980), 1,
      anon_sym_AMP,
    ACTIONS(5984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5986), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4018), 1,
      sym_heredoc_body,
    ACTIONS(4096), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5982), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 6,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [133006] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4019), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 11,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [133075] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4020), 1,
      sym_heredoc_body,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133128] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4021), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 11,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [133197] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4022), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133246] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4023), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 10,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [133317] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4024), 1,
      sym_heredoc_body,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133368] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4025), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133417] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_DOT,
    ACTIONS(5521), 1,
      anon_sym_AMP,
    ACTIONS(5529), 1,
      sym__binary_star_star,
    ACTIONS(5533), 1,
      anon_sym_PIPE,
    ACTIONS(5535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5539), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5541), 1,
      anon_sym_CARET,
    ACTIONS(5543), 1,
      anon_sym_QMARK,
    ACTIONS(5545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5549), 1,
      anon_sym_GT_EQ,
    ACTIONS(5551), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6017), 1,
      anon_sym_rescue,
    STATE(4026), 1,
      sym_heredoc_body,
    ACTIONS(5523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5525), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6019), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3549), 3,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(5527), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5537), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5553), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133500] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(4027), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [133577] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(5776), 1,
      anon_sym_EQ_GT,
    STATE(4028), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133658] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(5776), 1,
      anon_sym_EQ_GT,
    STATE(4029), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4395), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133739] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4030), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133788] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(4031), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [133865] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(6021), 1,
      anon_sym_EQ_GT,
    STATE(4032), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4395), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133946] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4033), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [134023] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(5776), 1,
      anon_sym_EQ_GT,
    STATE(4034), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134104] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_AMP,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4035), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 16,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134161] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5930), 1,
      anon_sym_COMMA,
    STATE(4017), 1,
      aux_sym_exceptions_repeat1,
    STATE(4036), 1,
      sym_heredoc_body,
    ACTIONS(4030), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134212] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4037), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 16,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134267] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_CARET,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4038), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 15,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134328] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_CARET,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4039), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5982), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 8,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [134399] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5531), 1,
      anon_sym_COMMA,
    STATE(3610), 1,
      aux_sym_exceptions_repeat1,
    STATE(4040), 1,
      sym_heredoc_body,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134450] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_CARET,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4041), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5982), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [134519] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4042), 1,
      sym_heredoc_body,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 18,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134572] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_CARET,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4043), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4056), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5982), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [134641] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4044), 1,
      sym_heredoc_body,
    ACTIONS(4060), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134690] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4045), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [134767] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(4046), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4448), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [134844] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4047), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 8,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [134919] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4048), 1,
      sym_heredoc_body,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      sym__line_break,
      sym__binary_minus,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134970] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4049), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135019] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4050), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135068] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(4051), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4450), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [135145] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4052), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 18,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135202] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(4053), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5936), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4064), 5,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135281] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4054), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 18,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135336] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(4055), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6023), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4456), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135414] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6043), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    STATE(4056), 1,
      sym_heredoc_body,
    ACTIONS(6041), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [135488] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(4057), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4456), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [135564] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6057), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6067), 1,
      anon_sym_QMARK,
    ACTIONS(6069), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4058), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 4,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135644] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6087), 1,
      anon_sym_COMMA,
    STATE(4059), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135692] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(4060), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4450), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [135768] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    ACTIONS(5924), 1,
      anon_sym_rescue,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6057), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6067), 1,
      anon_sym_QMARK,
    ACTIONS(6069), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4061), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3525), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135850] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6043), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    ACTIONS(6090), 1,
      anon_sym_QMARK,
    STATE(4062), 1,
      sym_heredoc_body,
    ACTIONS(6041), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3839), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [135926] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(4063), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [136002] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(4064), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4456), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [136078] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(4065), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6023), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4448), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136156] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6043), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    ACTIONS(6090), 1,
      anon_sym_QMARK,
    STATE(4066), 1,
      sym_heredoc_body,
    ACTIONS(6041), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [136232] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(4067), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4448), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [136308] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6092), 1,
      anon_sym_COMMA,
    STATE(4059), 1,
      aux_sym_exceptions_repeat1,
    STATE(4068), 1,
      sym_heredoc_body,
    ACTIONS(4030), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136358] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6094), 1,
      anon_sym_rescue,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6098), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6108), 1,
      anon_sym_QMARK,
    ACTIONS(6110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4068), 1,
      aux_sym_exceptions_repeat1,
    STATE(4069), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136438] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4070), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136486] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6057), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6069), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4071), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 7,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [136560] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    STATE(4072), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136608] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6043), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    ACTIONS(6090), 1,
      anon_sym_QMARK,
    STATE(4073), 1,
      sym_heredoc_body,
    ACTIONS(6041), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [136684] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    STATE(4074), 1,
      sym_heredoc_body,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      sym__line_break,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136734] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    STATE(4075), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136782] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    STATE(4076), 1,
      sym_heredoc_body,
    ACTIONS(6041), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136838] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6092), 1,
      anon_sym_COMMA,
    STATE(4068), 1,
      aux_sym_exceptions_repeat1,
    STATE(4077), 1,
      sym_heredoc_body,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136888] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4078), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136936] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6092), 1,
      anon_sym_COMMA,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6098), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6108), 1,
      anon_sym_QMARK,
    ACTIONS(6110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    ACTIONS(6128), 1,
      anon_sym_rescue,
    STATE(4068), 1,
      aux_sym_exceptions_repeat1,
    STATE(4079), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3557), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137018] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    STATE(4080), 1,
      sym_heredoc_body,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137070] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5924), 1,
      anon_sym_rescue,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6057), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6067), 1,
      anon_sym_QMARK,
    ACTIONS(6069), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4081), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137148] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6057), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6067), 1,
      anon_sym_QMARK,
    ACTIONS(6069), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4082), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 4,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137228] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4083), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 10,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [137296] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4084), 1,
      sym_heredoc_body,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137348] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    STATE(4085), 1,
      sym_heredoc_body,
    ACTIONS(6041), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137402] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4086), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 10,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [137470] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4087), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [137540] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4088), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 16,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137600] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6043), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    STATE(4089), 1,
      sym_heredoc_body,
    ACTIONS(6041), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [137668] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4090), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 17,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137722] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4091), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 17,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137778] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4068), 1,
      aux_sym_exceptions_repeat1,
    STATE(4092), 1,
      sym_heredoc_body,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137826] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6043), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    ACTIONS(6090), 1,
      anon_sym_QMARK,
    STATE(4093), 1,
      sym_heredoc_body,
    ACTIONS(6041), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [137902] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    STATE(4094), 1,
      sym_heredoc_body,
    ACTIONS(6041), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 16,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137962] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4095), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138010] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4096), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138058] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4097), 1,
      sym_heredoc_body,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      sym__binary_minus,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138108] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4098), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138160] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6057), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6067), 1,
      anon_sym_QMARK,
    ACTIONS(6069), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4099), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4395), 4,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138240] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(4100), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [138316] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    STATE(4101), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138364] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6043), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    STATE(4102), 1,
      sym_heredoc_body,
    ACTIONS(6041), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [138434] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(4103), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [138510] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(4104), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [138586] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(4105), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5936), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6130), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138664] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6057), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6067), 1,
      anon_sym_QMARK,
    ACTIONS(6069), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4106), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [138740] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6057), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6067), 1,
      anon_sym_QMARK,
    ACTIONS(6069), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4107), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [138816] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6057), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6069), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4108), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 7,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [138890] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6057), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6067), 1,
      anon_sym_QMARK,
    ACTIONS(6069), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4109), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [138966] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6098), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6108), 1,
      anon_sym_QMARK,
    ACTIONS(6110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    ACTIONS(6132), 1,
      anon_sym_rescue,
    ACTIONS(6134), 1,
      anon_sym_COMMA,
    STATE(4110), 1,
      sym_heredoc_body,
    STATE(4137), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3557), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139048] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6043), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    ACTIONS(6090), 1,
      anon_sym_QMARK,
    STATE(4111), 1,
      sym_heredoc_body,
    ACTIONS(6041), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3799), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [139124] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6057), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6067), 1,
      anon_sym_QMARK,
    ACTIONS(6069), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4112), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [139200] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(5742), 1,
      anon_sym_PIPE,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_CARET,
    ACTIONS(5754), 1,
      sym__binary_star_star,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5760), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5762), 1,
      anon_sym_QMARK,
    ACTIONS(5764), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5768), 1,
      anon_sym_GT_EQ,
    ACTIONS(5770), 1,
      anon_sym_EQ_EQ,
    STATE(4113), 1,
      sym_heredoc_body,
    ACTIONS(5748), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5750), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6136), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4098), 3,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(5752), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5758), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5772), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139280] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_rescue,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6057), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6067), 1,
      anon_sym_QMARK,
    ACTIONS(6069), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4114), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139358] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(4115), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6023), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4450), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139436] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6098), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6108), 1,
      anon_sym_QMARK,
    ACTIONS(6110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    ACTIONS(6138), 1,
      anon_sym_rescue,
    STATE(4116), 1,
      sym_heredoc_body,
    STATE(4137), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139516] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    ACTIONS(5262), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5264), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5270), 1,
      anon_sym_CARET,
    ACTIONS(5272), 1,
      anon_sym_QMARK,
    ACTIONS(5274), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5280), 1,
      anon_sym_GT_EQ,
    ACTIONS(5286), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5290), 1,
      sym__binary_star_star,
    ACTIONS(5928), 1,
      anon_sym_rescue,
    STATE(4117), 1,
      sym_heredoc_body,
    ACTIONS(5278), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5282), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5284), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5288), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139594] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6043), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    STATE(4118), 1,
      sym_heredoc_body,
    ACTIONS(6041), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [139668] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    STATE(4119), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139716] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6057), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6067), 1,
      anon_sym_QMARK,
    ACTIONS(6069), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4120), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4084), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [139792] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6043), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    ACTIONS(6090), 1,
      anon_sym_QMARK,
    STATE(4121), 1,
      sym_heredoc_body,
    ACTIONS(6041), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [139868] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6043), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    ACTIONS(6090), 1,
      anon_sym_QMARK,
    STATE(4122), 1,
      sym_heredoc_body,
    ACTIONS(6041), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4064), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [139944] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(4123), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4450), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [140020] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6043), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      sym__binary_star_star,
    STATE(4124), 1,
      sym_heredoc_body,
    ACTIONS(6041), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6045), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6047), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [140088] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4125), 1,
      sym_heredoc_body,
    ACTIONS(2642), 13,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ_GT,
    ACTIONS(2640), 19,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
      sym_identifier,
  [140134] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5461), 1,
      anon_sym_in,
    ACTIONS(5463), 1,
      anon_sym_EQ_GT,
    ACTIONS(5942), 1,
      anon_sym_rescue,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6057), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6067), 1,
      anon_sym_QMARK,
    ACTIONS(6069), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4126), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3525), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140216] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5359), 1,
      anon_sym_AMP,
    ACTIONS(5363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5365), 1,
      anon_sym_CARET,
    ACTIONS(5367), 1,
      anon_sym_QMARK,
    ACTIONS(5369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 1,
      anon_sym_GT_EQ,
    ACTIONS(5381), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5385), 1,
      sym__binary_star_star,
    STATE(4127), 1,
      sym_heredoc_body,
    ACTIONS(5373), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5377), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5361), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5379), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5383), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4448), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [140292] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6158), 1,
      anon_sym_GT_EQ,
    ACTIONS(6164), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    STATE(4128), 1,
      sym_heredoc_body,
    ACTIONS(6156), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6160), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6166), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 6,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [140365] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6098), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6108), 1,
      anon_sym_QMARK,
    ACTIONS(6110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    ACTIONS(6138), 1,
      anon_sym_rescue,
    STATE(4129), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140442] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(238), 1,
      sym__terminator,
    STATE(4130), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140521] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4131), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4098), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140596] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4132), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140671] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4133), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140718] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(212), 1,
      sym__terminator,
    STATE(4134), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140797] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6094), 1,
      anon_sym_rescue,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6098), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6108), 1,
      anon_sym_QMARK,
    ACTIONS(6110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4135), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140874] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6098), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4136), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 6,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
  [140947] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6134), 1,
      anon_sym_COMMA,
    STATE(4137), 1,
      sym_heredoc_body,
    STATE(4165), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4030), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4028), 22,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140996] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6098), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6108), 1,
      anon_sym_QMARK,
    ACTIONS(6110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4138), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4064), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141071] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4139), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141118] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    STATE(4140), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141165] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4141), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141212] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6098), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6108), 1,
      anon_sym_QMARK,
    ACTIONS(6110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4142), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141287] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(5776), 1,
      anon_sym_EQ_GT,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4143), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4395), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141366] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4137), 1,
      aux_sym_exceptions_repeat1,
    STATE(4144), 1,
      sym_heredoc_body,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141413] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    STATE(4145), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141460] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(5776), 1,
      anon_sym_EQ_GT,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4146), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141511] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    STATE(4147), 1,
      sym_heredoc_body,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      sym__line_break,
      sym__binary_minus,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141560] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4148), 1,
      sym_heredoc_body,
    ACTIONS(3759), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ_GT,
    ACTIONS(3761), 19,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
      sym_identifier,
  [141605] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(4149), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6206), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6204), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141682] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(4150), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6023), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4452), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141759] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(4151), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6023), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4064), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141836] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6158), 1,
      anon_sym_GT_EQ,
    ACTIONS(6164), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    ACTIONS(6208), 1,
      anon_sym_QMARK,
    STATE(4152), 1,
      sym_heredoc_body,
    ACTIONS(6156), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6160), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6166), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141911] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(4153), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5936), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6204), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141988] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4154), 1,
      sym_heredoc_body,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      sym__binary_minus,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142037] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6098), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4155), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 6,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
  [142110] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4156), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142157] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6098), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6108), 1,
      anon_sym_QMARK,
    ACTIONS(6110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4157), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142232] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_PIPE,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_AMP,
    ACTIONS(5718), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5720), 1,
      anon_sym_CARET,
    ACTIONS(5722), 1,
      anon_sym_QMARK,
    ACTIONS(5724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5730), 1,
      anon_sym_GT_EQ,
    ACTIONS(5736), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(4158), 1,
      sym_heredoc_body,
    ACTIONS(5728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5732), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6206), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5716), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5734), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6210), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(5738), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142309] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6158), 1,
      anon_sym_GT_EQ,
    ACTIONS(6164), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    STATE(4159), 1,
      sym_heredoc_body,
    ACTIONS(6156), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6160), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6166), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 6,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [142382] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6158), 1,
      anon_sym_GT_EQ,
    ACTIONS(6164), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    ACTIONS(6208), 1,
      anon_sym_QMARK,
    STATE(4160), 1,
      sym_heredoc_body,
    ACTIONS(6156), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6160), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6214), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6212), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
    ACTIONS(6166), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142459] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6098), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6108), 1,
      anon_sym_QMARK,
    ACTIONS(6110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4161), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4054), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142534] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4162), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [142601] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    STATE(4163), 1,
      sym_heredoc_body,
    ACTIONS(6156), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6160), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 16,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142656] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6098), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6108), 1,
      anon_sym_QMARK,
    ACTIONS(6110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4164), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4098), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142731] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6216), 1,
      anon_sym_COMMA,
    STATE(4165), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3841), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3839), 22,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142778] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    STATE(4166), 1,
      sym_heredoc_body,
    ACTIONS(6156), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6160), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 16,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142831] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4167), 1,
      sym_heredoc_body,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 18,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142882] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4168), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [142949] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6134), 1,
      anon_sym_COMMA,
    STATE(4137), 1,
      aux_sym_exceptions_repeat1,
    STATE(4169), 1,
      sym_heredoc_body,
    ACTIONS(3559), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 22,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142998] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(5776), 1,
      anon_sym_EQ_GT,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4170), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3799), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143077] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4171), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143124] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_in,
    ACTIONS(5776), 1,
      anon_sym_EQ_GT,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4172), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3799), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143203] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4173), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 8,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [143272] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4174), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 15,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143331] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4175), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 16,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143384] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4176), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 16,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143439] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4177), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 15,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143498] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4178), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4054), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143573] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(4179), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4452), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143648] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(4180), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4456), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143723] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(4181), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4440), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143798] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4182), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 8,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [143867] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    STATE(4183), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143914] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    STATE(4184), 1,
      sym_heredoc_body,
    ACTIONS(6156), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6160), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 15,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143973] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4185), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144020] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4186), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144067] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4187), 1,
      sym_heredoc_body,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 20,
      sym__binary_minus,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144116] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6158), 1,
      anon_sym_GT_EQ,
    ACTIONS(6164), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    ACTIONS(6208), 1,
      anon_sym_QMARK,
    STATE(4188), 1,
      sym_heredoc_body,
    ACTIONS(6156), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6160), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6166), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144191] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6158), 1,
      anon_sym_GT_EQ,
    ACTIONS(6164), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    STATE(4189), 1,
      sym_heredoc_body,
    ACTIONS(6156), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6160), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6166), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 8,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [144260] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4190), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4440), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144335] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6158), 1,
      anon_sym_GT_EQ,
    ACTIONS(6164), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    ACTIONS(6208), 1,
      anon_sym_QMARK,
    STATE(4191), 1,
      sym_heredoc_body,
    ACTIONS(6156), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6160), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6166), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144410] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4192), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144457] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4193), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4080), 6,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [144530] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6098), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6108), 1,
      anon_sym_QMARK,
    ACTIONS(6110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4194), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144605] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3254), 1,
      anon_sym_ri,
    STATE(4195), 1,
      sym_heredoc_body,
    ACTIONS(3250), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3252), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3248), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [144654] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6158), 1,
      anon_sym_GT_EQ,
    ACTIONS(6164), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    ACTIONS(6208), 1,
      anon_sym_QMARK,
    STATE(4196), 1,
      sym_heredoc_body,
    ACTIONS(6156), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6160), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4098), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6166), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144729] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6158), 1,
      anon_sym_GT_EQ,
    ACTIONS(6164), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    ACTIONS(6208), 1,
      anon_sym_QMARK,
    STATE(4197), 1,
      sym_heredoc_body,
    ACTIONS(6156), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6160), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4054), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6166), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144804] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6158), 1,
      anon_sym_GT_EQ,
    ACTIONS(6164), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    STATE(4198), 1,
      sym_heredoc_body,
    ACTIONS(6156), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6160), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6166), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [144871] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(4199), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5936), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6210), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144948] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    STATE(4200), 1,
      sym_heredoc_body,
    ACTIONS(6160), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 18,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144999] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4201), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 16,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145054] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(4202), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4450), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145129] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4203), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [145196] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6158), 1,
      anon_sym_GT_EQ,
    ACTIONS(6164), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    STATE(4204), 1,
      sym_heredoc_body,
    ACTIONS(6156), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6160), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6162), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6166), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [145263] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4205), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 16,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145316] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4206), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4207), 1,
      sym_heredoc_body,
    ACTIONS(3747), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ_GT,
    ACTIONS(3749), 19,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
      sym_identifier,
  [145436] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4208), 1,
      sym_heredoc_body,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 18,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145487] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4209), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145562] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(229), 1,
      sym__terminator,
    STATE(4210), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145641] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4211), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 6,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [145714] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6096), 1,
      anon_sym_PIPE,
    ACTIONS(6098), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6100), 1,
      anon_sym_AMP,
    ACTIONS(6104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_CARET,
    ACTIONS(6108), 1,
      anon_sym_QMARK,
    ACTIONS(6110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6112), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6116), 1,
      anon_sym_GT_EQ,
    ACTIONS(6122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6126), 1,
      sym__binary_star_star,
    STATE(4212), 1,
      sym_heredoc_body,
    ACTIONS(6114), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6102), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3839), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145789] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6168), 1,
      sym__binary_star_star,
    STATE(4213), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145836] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(4214), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4448), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145911] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4215), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 9,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [145978] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      anon_sym_PIPE,
    ACTIONS(6221), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6223), 1,
      anon_sym_AMP,
    ACTIONS(6227), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6229), 1,
      anon_sym_CARET,
    ACTIONS(6231), 1,
      anon_sym_QMARK,
    ACTIONS(6233), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6235), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6239), 1,
      anon_sym_GT_EQ,
    ACTIONS(6245), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4216), 1,
      sym_heredoc_body,
    ACTIONS(6237), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6225), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4098), 4,
      anon_sym_rescue,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6247), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146052] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4217), 1,
      sym_heredoc_body,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 17,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146102] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_PIPE,
    ACTIONS(6253), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6259), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6263), 1,
      anon_sym_QMARK,
    ACTIONS(6265), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6267), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6271), 1,
      anon_sym_GT_EQ,
    ACTIONS(6277), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4218), 1,
      sym_heredoc_body,
    ACTIONS(6269), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6257), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4064), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6279), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146176] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_rescue,
    ACTIONS(6219), 1,
      anon_sym_PIPE,
    ACTIONS(6221), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6223), 1,
      anon_sym_AMP,
    ACTIONS(6227), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6229), 1,
      anon_sym_CARET,
    ACTIONS(6231), 1,
      anon_sym_QMARK,
    ACTIONS(6233), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6235), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6239), 1,
      anon_sym_GT_EQ,
    ACTIONS(6245), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4219), 1,
      sym_heredoc_body,
    ACTIONS(6237), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3525), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6225), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6247), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146252] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4220), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146298] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      anon_sym_PIPE,
    ACTIONS(6221), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6223), 1,
      anon_sym_AMP,
    ACTIONS(6227), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6229), 1,
      anon_sym_CARET,
    ACTIONS(6233), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6235), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6239), 1,
      anon_sym_GT_EQ,
    ACTIONS(6245), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4221), 1,
      sym_heredoc_body,
    ACTIONS(6237), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6225), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4094), 5,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6247), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146370] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4222), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146416] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_PIPE,
    ACTIONS(6253), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6259), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6265), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6267), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6271), 1,
      anon_sym_GT_EQ,
    ACTIONS(6277), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4223), 1,
      sym_heredoc_body,
    ACTIONS(6269), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6257), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4094), 5,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6279), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146488] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      anon_sym_PIPE,
    ACTIONS(6221), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6223), 1,
      anon_sym_AMP,
    ACTIONS(6227), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6229), 1,
      anon_sym_CARET,
    ACTIONS(6231), 1,
      anon_sym_QMARK,
    ACTIONS(6233), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6235), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6239), 1,
      anon_sym_GT_EQ,
    ACTIONS(6245), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4224), 1,
      sym_heredoc_body,
    ACTIONS(6237), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6225), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4054), 4,
      anon_sym_rescue,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6247), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146562] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4225), 1,
      sym_heredoc_body,
    ACTIONS(6269), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 15,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146614] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6223), 1,
      anon_sym_AMP,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4226), 1,
      sym_heredoc_body,
    ACTIONS(6237), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 15,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146668] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4227), 1,
      sym_heredoc_body,
    ACTIONS(6269), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 14,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146726] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_PIPE,
    ACTIONS(6253), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6259), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6265), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6267), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6271), 1,
      anon_sym_GT_EQ,
    ACTIONS(6277), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4228), 1,
      sym_heredoc_body,
    ACTIONS(6269), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6257), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4080), 5,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6279), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146798] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      anon_sym_PIPE,
    ACTIONS(6221), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6223), 1,
      anon_sym_AMP,
    ACTIONS(6227), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6229), 1,
      anon_sym_CARET,
    ACTIONS(6233), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6235), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6239), 1,
      anon_sym_GT_EQ,
    ACTIONS(6245), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4229), 1,
      sym_heredoc_body,
    ACTIONS(6237), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6225), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4080), 5,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6247), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146870] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4230), 1,
      sym_heredoc_body,
    ACTIONS(6269), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 15,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146924] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      anon_sym_PIPE,
    ACTIONS(6221), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6223), 1,
      anon_sym_AMP,
    ACTIONS(6227), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6229), 1,
      anon_sym_CARET,
    ACTIONS(6231), 1,
      anon_sym_QMARK,
    ACTIONS(6233), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6235), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6239), 1,
      anon_sym_GT_EQ,
    ACTIONS(6245), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4231), 1,
      sym_heredoc_body,
    ACTIONS(6237), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6225), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 4,
      anon_sym_rescue,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6247), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146998] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4232), 1,
      sym_heredoc_body,
    STATE(4490), 1,
      sym_keyword_pattern,
    STATE(4496), 1,
      sym__hash_pattern_any_rest,
    STATE(5756), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6283), 2,
      sym_constant,
      sym_identifier,
    STATE(4507), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5714), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5593), 6,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5595), 9,
      anon_sym___END__,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [147062] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      anon_sym_PIPE,
    ACTIONS(6221), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6223), 1,
      anon_sym_AMP,
    ACTIONS(6227), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6229), 1,
      anon_sym_CARET,
    ACTIONS(6231), 1,
      anon_sym_QMARK,
    ACTIONS(6233), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6235), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6239), 1,
      anon_sym_GT_EQ,
    ACTIONS(6245), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4233), 1,
      sym_heredoc_body,
    ACTIONS(6237), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6225), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 4,
      anon_sym_rescue,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6247), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147136] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4234), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147182] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6285), 1,
      anon_sym_PIPE,
    STATE(4235), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6023), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6210), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147258] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6287), 1,
      anon_sym_PIPE,
    STATE(4236), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6023), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6204), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147334] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4237), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147380] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4238), 1,
      sym_heredoc_body,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147428] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6132), 1,
      anon_sym_rescue,
    ACTIONS(6219), 1,
      anon_sym_PIPE,
    ACTIONS(6221), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6223), 1,
      anon_sym_AMP,
    ACTIONS(6227), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6229), 1,
      anon_sym_CARET,
    ACTIONS(6231), 1,
      anon_sym_QMARK,
    ACTIONS(6233), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6235), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6239), 1,
      anon_sym_GT_EQ,
    ACTIONS(6245), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4239), 1,
      sym_heredoc_body,
    ACTIONS(6237), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3525), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6225), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6247), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147504] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_PIPE,
    ACTIONS(6253), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6259), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6263), 1,
      anon_sym_QMARK,
    ACTIONS(6265), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6267), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6271), 1,
      anon_sym_GT_EQ,
    ACTIONS(6277), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4240), 1,
      sym_heredoc_body,
    ACTIONS(6269), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6257), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3839), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6279), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147578] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      anon_sym_PIPE,
    ACTIONS(6221), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6223), 1,
      anon_sym_AMP,
    ACTIONS(6227), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6229), 1,
      anon_sym_CARET,
    ACTIONS(6231), 1,
      anon_sym_QMARK,
    ACTIONS(6233), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6235), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6239), 1,
      anon_sym_GT_EQ,
    ACTIONS(6245), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4241), 1,
      sym_heredoc_body,
    ACTIONS(6237), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6225), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 4,
      anon_sym_rescue,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6247), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147652] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4242), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147698] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4243), 1,
      sym_heredoc_body,
    ACTIONS(6237), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 15,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147750] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_PIPE,
    ACTIONS(6253), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6259), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6263), 1,
      anon_sym_QMARK,
    ACTIONS(6265), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6267), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6271), 1,
      anon_sym_GT_EQ,
    ACTIONS(6277), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4244), 1,
      sym_heredoc_body,
    ACTIONS(6269), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6257), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4054), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6279), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147824] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(4245), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6023), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6204), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147900] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4246), 1,
      sym_heredoc_body,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 19,
      sym__binary_minus,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147948] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5684), 1,
      anon_sym_AMP,
    ACTIONS(5688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5690), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_QMARK,
    ACTIONS(5694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 1,
      anon_sym_GT_EQ,
    ACTIONS(5706), 1,
      anon_sym_EQ_EQ,
    STATE(4247), 1,
      sym_heredoc_body,
    ACTIONS(5698), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5702), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6023), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6210), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(5686), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5704), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5708), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148024] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4248), 1,
      sym_heredoc_body,
    STATE(4490), 1,
      sym_keyword_pattern,
    STATE(4504), 1,
      sym__hash_pattern_any_rest,
    STATE(5756), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6283), 2,
      sym_constant,
      sym_identifier,
    STATE(4507), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5714), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5636), 6,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5638), 9,
      anon_sym___END__,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [148088] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_PIPE,
    ACTIONS(6253), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6259), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6263), 1,
      anon_sym_QMARK,
    ACTIONS(6265), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6267), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6271), 1,
      anon_sym_GT_EQ,
    ACTIONS(6277), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4249), 1,
      sym_heredoc_body,
    ACTIONS(6269), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6257), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4098), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6279), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148162] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_PIPE,
    ACTIONS(6253), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6259), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6263), 1,
      anon_sym_QMARK,
    ACTIONS(6265), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6267), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6271), 1,
      anon_sym_GT_EQ,
    ACTIONS(6277), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4250), 1,
      sym_heredoc_body,
    ACTIONS(6269), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6257), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6279), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148236] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_PIPE,
    ACTIONS(6253), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6259), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6263), 1,
      anon_sym_QMARK,
    ACTIONS(6265), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6267), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6271), 1,
      anon_sym_GT_EQ,
    ACTIONS(6277), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4251), 1,
      sym_heredoc_body,
    ACTIONS(6269), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6257), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3799), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6279), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148310] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_PIPE,
    ACTIONS(6253), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6259), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6263), 1,
      anon_sym_QMARK,
    ACTIONS(6265), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6267), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6271), 1,
      anon_sym_GT_EQ,
    ACTIONS(6277), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4252), 1,
      sym_heredoc_body,
    ACTIONS(6269), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6257), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6279), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148384] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(6291), 1,
      anon_sym___END__,
    STATE(4253), 1,
      sym_heredoc_body,
    ACTIONS(745), 9,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(6289), 20,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [148430] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      anon_sym_PIPE,
    ACTIONS(6057), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_AMP,
    ACTIONS(6063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6065), 1,
      anon_sym_CARET,
    ACTIONS(6067), 1,
      anon_sym_QMARK,
    ACTIONS(6069), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6071), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6081), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6085), 1,
      sym__binary_star_star,
    STATE(4254), 1,
      sym_heredoc_body,
    ACTIONS(6073), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6077), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6061), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4440), 4,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6083), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148504] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6219), 1,
      anon_sym_PIPE,
    ACTIONS(6223), 1,
      anon_sym_AMP,
    ACTIONS(6229), 1,
      anon_sym_CARET,
    ACTIONS(6239), 1,
      anon_sym_GT_EQ,
    ACTIONS(6245), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4255), 1,
      sym_heredoc_body,
    ACTIONS(6237), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6225), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6247), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 8,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [148570] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4256), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148616] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6251), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6271), 1,
      anon_sym_GT_EQ,
    ACTIONS(6277), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4257), 1,
      sym_heredoc_body,
    ACTIONS(6269), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6257), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6279), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 8,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [148682] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4258), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148728] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4259), 1,
      sym_heredoc_body,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 17,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148778] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6219), 1,
      anon_sym_PIPE,
    ACTIONS(6223), 1,
      anon_sym_AMP,
    ACTIONS(6229), 1,
      anon_sym_CARET,
    ACTIONS(6239), 1,
      anon_sym_GT_EQ,
    ACTIONS(6245), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4260), 1,
      sym_heredoc_body,
    ACTIONS(6237), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6225), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6247), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 8,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [148844] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6219), 1,
      anon_sym_PIPE,
    ACTIONS(6223), 1,
      anon_sym_AMP,
    ACTIONS(6229), 1,
      anon_sym_CARET,
    ACTIONS(6235), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6239), 1,
      anon_sym_GT_EQ,
    ACTIONS(6245), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4261), 1,
      sym_heredoc_body,
    ACTIONS(6237), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6225), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6247), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 7,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [148912] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      anon_sym_PIPE,
    ACTIONS(6223), 1,
      anon_sym_AMP,
    ACTIONS(6229), 1,
      anon_sym_CARET,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4262), 1,
      sym_heredoc_body,
    ACTIONS(6237), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6241), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6243), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 14,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148970] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6251), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6271), 1,
      anon_sym_GT_EQ,
    ACTIONS(6277), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4263), 1,
      sym_heredoc_body,
    ACTIONS(6269), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6257), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6279), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 8,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [149036] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6249), 1,
      sym__binary_star_star,
    STATE(4264), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149082] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6251), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6267), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6271), 1,
      anon_sym_GT_EQ,
    ACTIONS(6277), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6281), 1,
      sym__binary_star_star,
    STATE(4265), 1,
      sym_heredoc_body,
    ACTIONS(6269), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6273), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6257), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6275), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6279), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 7,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [149150] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3064), 1,
      anon_sym___END__,
    STATE(4266), 1,
      sym_heredoc_body,
    ACTIONS(3062), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [149193] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym___END__,
    STATE(4267), 1,
      sym_heredoc_body,
    ACTIONS(2742), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [149236] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6307), 1,
      anon_sym_COLON2,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4268), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149311] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6329), 1,
      anon_sym_COLON2,
    STATE(4269), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149386] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6331), 1,
      anon_sym_COLON2,
    STATE(4270), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149461] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6333), 1,
      anon_sym_COLON2,
    STATE(4271), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149536] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4272), 1,
      sym_heredoc_body,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 18,
      sym__binary_minus,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149583] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6335), 1,
      anon_sym_COLON2,
    STATE(4273), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149658] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6337), 1,
      anon_sym_COLON2,
    STATE(4274), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149733] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6339), 1,
      anon_sym_COLON2,
    STATE(4275), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149808] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6341), 1,
      anon_sym_RPAREN,
    STATE(4276), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149883] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6345), 1,
      anon_sym_COLON2,
    STATE(4277), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149958] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4278), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150003] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4279), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150048] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6347), 1,
      anon_sym_COLON2,
    STATE(4280), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150123] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4281), 1,
      sym_heredoc_body,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150176] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4282), 1,
      sym_heredoc_body,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4080), 4,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150247] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6349), 1,
      anon_sym_COLON2,
    STATE(4283), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150322] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4284), 1,
      sym_heredoc_body,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150373] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4285), 1,
      sym_heredoc_body,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150430] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4286), 1,
      sym_heredoc_body,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4054), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150503] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4287), 1,
      sym_heredoc_body,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [150570] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4288), 1,
      sym_heredoc_body,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [150635] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4289), 1,
      sym_heredoc_body,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150684] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4290), 1,
      sym_heredoc_body,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4054), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [150749] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4291), 1,
      sym_heredoc_body,
    ACTIONS(4060), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4058), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150794] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6351), 1,
      anon_sym_COLON2,
    STATE(4292), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150869] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6353), 1,
      anon_sym_COLON2,
    STATE(4293), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150944] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6355), 1,
      anon_sym_COLON2,
    STATE(4294), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151019] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6357), 1,
      anon_sym_COLON2,
    STATE(4295), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151094] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4296), 1,
      sym_heredoc_body,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3799), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151167] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4297), 1,
      sym_heredoc_body,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3799), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151240] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6359), 1,
      anon_sym_RPAREN,
    STATE(4298), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151315] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4299), 1,
      sym_heredoc_body,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151388] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6361), 1,
      anon_sym_COLON2,
    STATE(4300), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151463] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6363), 1,
      anon_sym_RPAREN,
    STATE(4301), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151538] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6365), 1,
      anon_sym_RPAREN,
    STATE(4302), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151613] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4303), 1,
      sym_heredoc_body,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4098), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151686] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6367), 1,
      anon_sym_RPAREN,
    STATE(4304), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151761] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym___END__,
    STATE(4305), 1,
      sym_heredoc_body,
    ACTIONS(6369), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [151804] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6373), 1,
      anon_sym_EQ_GT,
    STATE(4306), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151879] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6375), 1,
      anon_sym_RPAREN,
    STATE(4307), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151954] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6377), 1,
      anon_sym_RPAREN,
    STATE(4308), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152029] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6379), 1,
      anon_sym_RPAREN,
    STATE(4309), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152104] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6381), 1,
      anon_sym_COLON2,
    STATE(4310), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152179] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6383), 1,
      anon_sym_RPAREN,
    STATE(4311), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152254] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6385), 1,
      anon_sym_RPAREN,
    STATE(4312), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152329] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6387), 1,
      anon_sym_COLON2,
    STATE(4313), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152404] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6389), 1,
      anon_sym_COLON2,
    STATE(4314), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152479] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4315), 1,
      sym_heredoc_body,
    ACTIONS(3323), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3321), 27,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [152522] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6391), 1,
      anon_sym_COLON2,
    STATE(4316), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152597] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6393), 1,
      anon_sym_COLON2,
    STATE(4317), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152672] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6395), 1,
      anon_sym_RPAREN,
    STATE(4318), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152747] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6397), 1,
      anon_sym_RPAREN,
    STATE(4319), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152822] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6399), 1,
      anon_sym_COLON2,
    STATE(4320), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152897] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6401), 1,
      anon_sym_COLON2,
    STATE(4321), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152972] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6403), 1,
      anon_sym_RPAREN,
    STATE(4322), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153047] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6405), 1,
      anon_sym_COLON2,
    STATE(4323), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153122] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6407), 1,
      anon_sym_COLON2,
    STATE(4324), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153197] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6409), 1,
      anon_sym_COLON2,
    STATE(4325), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153272] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6411), 1,
      anon_sym_COLON2,
    STATE(4326), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153347] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6413), 1,
      anon_sym_COLON2,
    STATE(4327), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153422] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6415), 1,
      anon_sym_RPAREN,
    STATE(4328), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153497] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6417), 1,
      anon_sym_COLON2,
    STATE(4329), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153572] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6419), 1,
      anon_sym_COLON2,
    STATE(4330), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153647] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym___END__,
    STATE(4331), 1,
      sym_heredoc_body,
    ACTIONS(3022), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [153690] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6421), 1,
      anon_sym_RPAREN,
    STATE(4332), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153765] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6423), 1,
      anon_sym_COLON2,
    STATE(4333), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153840] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym___END__,
    STATE(4334), 1,
      sym_heredoc_body,
    ACTIONS(3030), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [153883] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3004), 1,
      anon_sym___END__,
    STATE(4335), 1,
      sym_heredoc_body,
    ACTIONS(3002), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [153926] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3036), 1,
      anon_sym___END__,
    STATE(4336), 1,
      sym_heredoc_body,
    ACTIONS(3034), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [153969] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym___END__,
    STATE(4337), 1,
      sym_heredoc_body,
    ACTIONS(3042), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [154012] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym___END__,
    STATE(4338), 1,
      sym_heredoc_body,
    ACTIONS(3066), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [154055] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6425), 1,
      anon_sym_COLON2,
    STATE(4339), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154130] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4340), 1,
      sym_heredoc_body,
    ACTIONS(3301), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3299), 27,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [154173] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6427), 1,
      anon_sym_RPAREN,
    STATE(4341), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154248] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3072), 1,
      anon_sym___END__,
    STATE(4342), 1,
      sym_heredoc_body,
    ACTIONS(3070), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [154291] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym___END__,
    STATE(4343), 1,
      sym_heredoc_body,
    ACTIONS(2998), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [154334] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym___END__,
    STATE(4344), 1,
      sym_heredoc_body,
    ACTIONS(3074), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [154377] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6429), 1,
      anon_sym_COLON2,
    STATE(4345), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154452] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6431), 1,
      anon_sym_RPAREN,
    STATE(4346), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154527] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6433), 1,
      anon_sym_RPAREN,
    STATE(4347), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154602] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6435), 1,
      anon_sym_COLON2,
    STATE(4348), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154677] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6437), 1,
      anon_sym_RPAREN,
    STATE(4349), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154752] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6439), 1,
      anon_sym_COLON2,
    STATE(4350), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154827] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6441), 1,
      anon_sym_COLON2,
    STATE(4351), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154902] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6443), 1,
      anon_sym_RPAREN,
    STATE(4352), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154977] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3012), 1,
      anon_sym___END__,
    STATE(4353), 1,
      sym_heredoc_body,
    ACTIONS(3010), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [155020] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym___END__,
    STATE(4354), 1,
      sym_heredoc_body,
    ACTIONS(3006), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [155063] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6445), 1,
      anon_sym_RPAREN,
    STATE(4355), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155138] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6447), 1,
      anon_sym_RPAREN,
    STATE(4356), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155213] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6449), 1,
      anon_sym_COLON2,
    STATE(4357), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155288] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6451), 1,
      anon_sym_COLON2,
    STATE(4358), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155363] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6453), 1,
      anon_sym_RPAREN,
    STATE(4359), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155438] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6455), 1,
      anon_sym_COLON2,
    STATE(4360), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155513] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6457), 1,
      anon_sym_COLON2,
    STATE(4361), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155588] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6461), 1,
      anon_sym___END__,
    STATE(4362), 1,
      sym_heredoc_body,
    ACTIONS(6459), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155631] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4363), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4440), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155704] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2968), 1,
      anon_sym___END__,
    STATE(4364), 1,
      sym_heredoc_body,
    ACTIONS(2970), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155747] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3060), 1,
      anon_sym___END__,
    STATE(4365), 1,
      sym_heredoc_body,
    ACTIONS(3058), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [155790] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym___END__,
    STATE(4366), 1,
      sym_heredoc_body,
    ACTIONS(3054), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [155833] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3052), 1,
      anon_sym___END__,
    STATE(4367), 1,
      sym_heredoc_body,
    ACTIONS(3050), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [155876] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3048), 1,
      anon_sym___END__,
    STATE(4368), 1,
      sym_heredoc_body,
    ACTIONS(3046), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [155919] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6463), 1,
      anon_sym_COLON2,
    STATE(4369), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155994] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6465), 1,
      anon_sym_COLON2,
    STATE(4370), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156069] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6469), 1,
      anon_sym___END__,
    ACTIONS(6471), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6473), 1,
      anon_sym_LBRACK2,
    ACTIONS(6475), 1,
      anon_sym_LPAREN2,
    STATE(4371), 1,
      sym_heredoc_body,
    ACTIONS(6467), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156118] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4372), 1,
      sym_heredoc_body,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4094), 4,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156189] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    ACTIONS(6477), 1,
      anon_sym_RPAREN,
    STATE(4373), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6343), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156264] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6479), 1,
      anon_sym_COLON2,
    STATE(4374), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156339] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6481), 1,
      anon_sym_COLON2,
    STATE(4375), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156414] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6483), 1,
      anon_sym_COLON2,
    STATE(4376), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156489] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6485), 1,
      anon_sym_COLON2,
    STATE(4377), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156564] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_PIPE,
    ACTIONS(6295), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_AMP,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_CARET,
    ACTIONS(6305), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6317), 1,
      anon_sym_GT_EQ,
    ACTIONS(6323), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    ACTIONS(6487), 1,
      anon_sym_COLON2,
    STATE(4378), 1,
      sym_heredoc_body,
    ACTIONS(6309), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6315), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6319), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6299), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6321), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6325), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156639] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6327), 1,
      sym__binary_star_star,
    STATE(4379), 1,
      sym_heredoc_body,
    ACTIONS(3801), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3799), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156684] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4380), 1,
      sym_heredoc_body,
    ACTIONS(3044), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3042), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156726] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4381), 1,
      sym_heredoc_body,
    ACTIONS(3769), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3767), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156768] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4382), 1,
      sym_heredoc_body,
    ACTIONS(6491), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(6489), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156810] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4383), 1,
      sym_heredoc_body,
    ACTIONS(3617), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3615), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156852] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4384), 1,
      sym_heredoc_body,
    ACTIONS(3008), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3006), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156894] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4385), 1,
      sym_heredoc_body,
    ACTIONS(3036), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3034), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156936] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4386), 1,
      sym_heredoc_body,
    ACTIONS(3012), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3010), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156978] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4387), 1,
      sym_heredoc_body,
    ACTIONS(3068), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3066), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157020] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4388), 1,
      sym_heredoc_body,
    ACTIONS(3607), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3605), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157062] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4389), 1,
      sym_heredoc_body,
    ACTIONS(3519), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3517), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157104] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4390), 1,
      sym_heredoc_body,
    ACTIONS(3393), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3391), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157146] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4391), 1,
      sym_heredoc_body,
    ACTIONS(3028), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3026), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157188] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4392), 1,
      sym_heredoc_body,
    ACTIONS(3052), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3050), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157230] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4393), 1,
      sym_heredoc_body,
    ACTIONS(3076), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3074), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157272] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4394), 1,
      sym_heredoc_body,
    ACTIONS(3056), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3054), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157314] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4395), 1,
      sym_heredoc_body,
    ACTIONS(3072), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3070), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157356] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4396), 1,
      sym_heredoc_body,
    ACTIONS(6493), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(2996), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157398] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4397), 1,
      sym_heredoc_body,
    ACTIONS(3849), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3847), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157440] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4398), 1,
      sym_heredoc_body,
    ACTIONS(3060), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3058), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157482] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4399), 1,
      sym_heredoc_body,
    ACTIONS(3633), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3631), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157524] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4400), 1,
      sym_heredoc_body,
    ACTIONS(3789), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157566] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4401), 1,
      sym_heredoc_body,
    ACTIONS(3785), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3783), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157608] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4402), 1,
      sym_heredoc_body,
    ACTIONS(3048), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3046), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157650] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4403), 1,
      sym_heredoc_body,
    ACTIONS(3737), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3735), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157692] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4404), 1,
      sym_heredoc_body,
    ACTIONS(3347), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3345), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157734] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4405), 1,
      sym_heredoc_body,
    ACTIONS(3773), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3771), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157776] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4406), 1,
      sym_heredoc_body,
    ACTIONS(3753), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3751), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157818] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4407), 1,
      sym_heredoc_body,
    ACTIONS(6495), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3561), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157860] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4408), 1,
      sym_heredoc_body,
    ACTIONS(3431), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3429), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157902] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4409), 1,
      sym_heredoc_body,
    ACTIONS(3613), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3611), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157944] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4410), 1,
      sym_heredoc_body,
    ACTIONS(3797), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3795), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157986] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4411), 1,
      sym_heredoc_body,
    ACTIONS(3757), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3755), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158028] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4412), 1,
      sym_heredoc_body,
    ACTIONS(3873), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3871), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158070] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4413), 1,
      sym_heredoc_body,
    ACTIONS(3250), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3248), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158112] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4414), 1,
      sym_heredoc_body,
    ACTIONS(3817), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3815), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158154] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4415), 1,
      sym_heredoc_body,
    ACTIONS(3697), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3695), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158196] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4416), 1,
      sym_heredoc_body,
    ACTIONS(3813), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3811), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158238] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4417), 1,
      sym_heredoc_body,
    ACTIONS(3004), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3002), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158280] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4418), 1,
      sym_heredoc_body,
    ACTIONS(3064), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3062), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158322] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4419), 1,
      sym_heredoc_body,
    ACTIONS(3032), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3030), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158364] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4420), 1,
      sym_heredoc_body,
    ACTIONS(3000), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(2998), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158406] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4421), 1,
      sym_heredoc_body,
    ACTIONS(3024), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3022), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158448] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4422), 1,
      sym_heredoc_body,
    ACTIONS(3471), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3469), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158490] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4423), 1,
      sym_heredoc_body,
    ACTIONS(3741), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3739), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158532] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4424), 1,
      sym_heredoc_body,
    ACTIONS(3443), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3441), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158574] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4425), 1,
      sym_heredoc_body,
    ACTIONS(3405), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3403), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158616] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4426), 1,
      sym_heredoc_body,
    ACTIONS(3467), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3465), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158658] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4427), 1,
      sym_heredoc_body,
    ACTIONS(3523), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3521), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158700] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4428), 1,
      sym_heredoc_body,
    ACTIONS(3669), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3667), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158742] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4429), 1,
      sym_heredoc_body,
    ACTIONS(3645), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3643), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158784] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4430), 1,
      sym_heredoc_body,
    ACTIONS(6497), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3271), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158826] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4431), 1,
      sym_heredoc_body,
    ACTIONS(3825), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3823), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158868] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_COLON,
    STATE(4432), 1,
      sym_heredoc_body,
    ACTIONS(2742), 26,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158909] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6501), 1,
      anon_sym___END__,
    STATE(4433), 1,
      sym_heredoc_body,
    ACTIONS(6499), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [158950] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym___END__,
    STATE(4434), 1,
      sym_heredoc_body,
    ACTIONS(6503), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [158991] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym___END__,
    STATE(4435), 1,
      sym_heredoc_body,
    ACTIONS(6503), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [159032] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6501), 1,
      anon_sym___END__,
    STATE(4436), 1,
      sym_heredoc_body,
    ACTIONS(6499), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [159073] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6497), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_COLON,
    STATE(4437), 1,
      sym_heredoc_body,
    ACTIONS(3271), 24,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159115] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6511), 1,
      anon_sym___END__,
    STATE(4438), 1,
      sym_heredoc_body,
    ACTIONS(6509), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159155] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6515), 1,
      anon_sym___END__,
    ACTIONS(6517), 1,
      anon_sym_LBRACE,
    ACTIONS(6519), 1,
      anon_sym_do,
    STATE(4434), 1,
      sym_block,
    STATE(4435), 1,
      sym_do_block,
    STATE(4439), 1,
      sym_heredoc_body,
    ACTIONS(6513), 21,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159203] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6523), 1,
      anon_sym___END__,
    STATE(4440), 1,
      sym_heredoc_body,
    ACTIONS(6521), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159243] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6527), 1,
      anon_sym___END__,
    STATE(4441), 1,
      sym_heredoc_body,
    ACTIONS(6525), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159283] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6517), 1,
      anon_sym_LBRACE,
    ACTIONS(6519), 1,
      anon_sym_do,
    ACTIONS(6531), 1,
      anon_sym___END__,
    STATE(4433), 1,
      sym_block,
    STATE(4436), 1,
      sym_do_block,
    STATE(4442), 1,
      sym_heredoc_body,
    ACTIONS(6529), 21,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159331] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6535), 1,
      anon_sym___END__,
    STATE(4443), 1,
      sym_heredoc_body,
    ACTIONS(6533), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159371] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6537), 1,
      anon_sym___END__,
    STATE(4444), 1,
      sym_heredoc_body,
    ACTIONS(3575), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159411] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6469), 1,
      anon_sym___END__,
    STATE(4445), 1,
      sym_heredoc_body,
    ACTIONS(6467), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159451] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6541), 1,
      anon_sym___END__,
    STATE(4446), 1,
      sym_heredoc_body,
    ACTIONS(6539), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159491] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6545), 1,
      anon_sym___END__,
    STATE(4447), 1,
      sym_heredoc_body,
    ACTIONS(6543), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159531] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym___END__,
    STATE(4448), 1,
      sym_heredoc_body,
    ACTIONS(6547), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159571] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6517), 1,
      anon_sym_LBRACE,
    ACTIONS(6531), 1,
      anon_sym___END__,
    STATE(4433), 1,
      sym_block,
    STATE(4436), 1,
      sym_do_block,
    STATE(4449), 1,
      sym_heredoc_body,
    ACTIONS(6529), 22,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159617] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6553), 1,
      anon_sym___END__,
    STATE(4450), 1,
      sym_heredoc_body,
    ACTIONS(6551), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159657] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6555), 1,
      anon_sym___END__,
    STATE(4451), 1,
      sym_heredoc_body,
    ACTIONS(3609), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159697] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6559), 1,
      anon_sym___END__,
    STATE(4452), 1,
      sym_heredoc_body,
    ACTIONS(6557), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159737] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym___END__,
    STATE(4453), 1,
      sym_heredoc_body,
    ACTIONS(6561), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159777] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6567), 1,
      anon_sym___END__,
    STATE(4454), 1,
      sym_heredoc_body,
    ACTIONS(6565), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159817] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6571), 1,
      anon_sym___END__,
    STATE(4455), 1,
      sym_heredoc_body,
    ACTIONS(6569), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159857] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6575), 1,
      anon_sym___END__,
    STATE(4456), 1,
      sym_heredoc_body,
    ACTIONS(6573), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159897] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6515), 1,
      anon_sym___END__,
    ACTIONS(6517), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_block,
    STATE(4435), 1,
      sym_do_block,
    STATE(4457), 1,
      sym_heredoc_body,
    ACTIONS(6513), 22,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159943] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6579), 1,
      anon_sym___END__,
    STATE(4458), 1,
      sym_heredoc_body,
    ACTIONS(6577), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159983] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6581), 1,
      anon_sym___END__,
    STATE(4459), 1,
      sym_heredoc_body,
    ACTIONS(3082), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160023] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6585), 1,
      anon_sym___END__,
    STATE(4460), 1,
      sym_heredoc_body,
    ACTIONS(6583), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160062] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4461), 1,
      sym_heredoc_body,
    ACTIONS(2626), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2624), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [160101] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4462), 1,
      sym_heredoc_body,
    ACTIONS(4929), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(4927), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [160140] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6589), 1,
      anon_sym___END__,
    ACTIONS(6591), 1,
      anon_sym_EQ_GT,
    STATE(4463), 1,
      sym_heredoc_body,
    ACTIONS(6587), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160181] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6591), 1,
      anon_sym_EQ_GT,
    ACTIONS(6595), 1,
      anon_sym___END__,
    STATE(4464), 1,
      sym_heredoc_body,
    ACTIONS(6593), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160222] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6591), 1,
      anon_sym_EQ_GT,
    ACTIONS(6599), 1,
      anon_sym___END__,
    STATE(4465), 1,
      sym_heredoc_body,
    ACTIONS(6597), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160263] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4466), 1,
      sym_heredoc_body,
    ACTIONS(2618), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2616), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [160302] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4467), 1,
      sym_heredoc_body,
    STATE(4490), 1,
      sym_keyword_pattern,
    STATE(4496), 1,
      sym__hash_pattern_any_rest,
    STATE(5916), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6601), 2,
      sym_constant,
      sym_identifier,
    STATE(4507), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5723), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5593), 4,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5595), 6,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [160361] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4468), 1,
      sym_heredoc_body,
    ACTIONS(2646), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2644), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [160400] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6605), 1,
      anon_sym___END__,
    STATE(4469), 1,
      sym_heredoc_body,
    ACTIONS(6603), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160439] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4470), 1,
      sym_heredoc_body,
    ACTIONS(2622), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2620), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [160478] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6607), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6609), 1,
      anon_sym_DOT_DOT,
    STATE(4471), 1,
      sym_heredoc_body,
    ACTIONS(6467), 23,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160519] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6613), 1,
      anon_sym___END__,
    STATE(4472), 1,
      sym_heredoc_body,
    ACTIONS(6611), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4473), 1,
      sym_heredoc_body,
    ACTIONS(2630), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2628), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [160597] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4474), 1,
      sym_heredoc_body,
    ACTIONS(5147), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(5145), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [160636] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4475), 1,
      sym_heredoc_body,
    STATE(4490), 1,
      sym_keyword_pattern,
    STATE(4504), 1,
      sym__hash_pattern_any_rest,
    STATE(5916), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6601), 2,
      sym_constant,
      sym_identifier,
    STATE(4507), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5723), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5636), 4,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5638), 6,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [160695] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6617), 1,
      anon_sym___END__,
    STATE(4476), 1,
      sym_heredoc_body,
    ACTIONS(6615), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160733] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym___END__,
    STATE(4477), 1,
      sym_heredoc_body,
    ACTIONS(6619), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160771] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6625), 1,
      anon_sym___END__,
    STATE(4478), 1,
      sym_heredoc_body,
    ACTIONS(6623), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160809] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6629), 1,
      anon_sym___END__,
    STATE(4479), 1,
      sym_heredoc_body,
    ACTIONS(6627), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160847] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4480), 1,
      sym_heredoc_body,
    ACTIONS(6633), 3,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(6631), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160885] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6625), 1,
      anon_sym___END__,
    STATE(4481), 1,
      sym_heredoc_body,
    ACTIONS(6623), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160923] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6291), 1,
      anon_sym___END__,
    STATE(4482), 1,
      sym_heredoc_body,
    ACTIONS(6289), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160961] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6637), 1,
      anon_sym___END__,
    STATE(4483), 1,
      sym_heredoc_body,
    ACTIONS(6635), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160999] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6641), 1,
      anon_sym___END__,
    STATE(4484), 1,
      sym_heredoc_body,
    ACTIONS(6639), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161037] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6645), 1,
      anon_sym___END__,
    STATE(4485), 1,
      sym_heredoc_body,
    ACTIONS(6643), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161075] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6649), 1,
      anon_sym___END__,
    STATE(4486), 1,
      sym_heredoc_body,
    ACTIONS(6647), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161113] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6531), 1,
      anon_sym___END__,
    STATE(4487), 1,
      sym_heredoc_body,
    ACTIONS(6529), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161151] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6653), 1,
      anon_sym___END__,
    STATE(4488), 1,
      sym_heredoc_body,
    ACTIONS(6651), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161189] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6657), 1,
      anon_sym___END__,
    STATE(4489), 1,
      sym_heredoc_body,
    ACTIONS(6655), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161227] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6661), 1,
      anon_sym___END__,
    STATE(4490), 1,
      sym_heredoc_body,
    ACTIONS(6659), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161265] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6665), 1,
      anon_sym___END__,
    STATE(4491), 1,
      sym_heredoc_body,
    ACTIONS(6663), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161303] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6669), 1,
      anon_sym___END__,
    STATE(4492), 1,
      sym_heredoc_body,
    ACTIONS(6667), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161341] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6671), 1,
      anon_sym___END__,
    STATE(4493), 1,
      sym_heredoc_body,
    ACTIONS(6631), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161379] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6673), 1,
      anon_sym_COLON,
    STATE(4494), 1,
      sym_heredoc_body,
    ACTIONS(3082), 23,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161417] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6629), 1,
      anon_sym___END__,
    STATE(4495), 1,
      sym_heredoc_body,
    ACTIONS(6627), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161455] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym___END__,
    STATE(4496), 1,
      sym_heredoc_body,
    ACTIONS(5636), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161493] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6677), 1,
      anon_sym___END__,
    STATE(4497), 1,
      sym_heredoc_body,
    ACTIONS(6675), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161531] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6681), 1,
      anon_sym___END__,
    STATE(4498), 1,
      sym_heredoc_body,
    ACTIONS(6679), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161569] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6685), 1,
      anon_sym___END__,
    STATE(4499), 1,
      sym_heredoc_body,
    ACTIONS(6683), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161607] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6689), 1,
      anon_sym_PIPE,
    STATE(4500), 1,
      sym_heredoc_body,
    STATE(4502), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6687), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161647] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6693), 1,
      anon_sym___END__,
    STATE(4501), 1,
      sym_heredoc_body,
    ACTIONS(6691), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161685] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6697), 1,
      anon_sym_PIPE,
    STATE(4502), 2,
      sym_heredoc_body,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6695), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161723] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6629), 1,
      anon_sym___END__,
    STATE(4503), 1,
      sym_heredoc_body,
    ACTIONS(6627), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161761] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6702), 1,
      anon_sym___END__,
    STATE(4504), 1,
      sym_heredoc_body,
    ACTIONS(6700), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161799] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6689), 1,
      anon_sym_PIPE,
    STATE(4500), 1,
      aux_sym_alternative_pattern_repeat1,
    STATE(4505), 1,
      sym_heredoc_body,
    ACTIONS(6583), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161839] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4676), 1,
      anon_sym___END__,
    STATE(4506), 1,
      sym_heredoc_body,
    ACTIONS(4395), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161877] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6706), 1,
      anon_sym___END__,
    STATE(4507), 1,
      sym_heredoc_body,
    ACTIONS(6704), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161915] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym___END__,
    STATE(4508), 1,
      sym_heredoc_body,
    ACTIONS(6708), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161953] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6714), 1,
      anon_sym___END__,
    STATE(4509), 1,
      sym_heredoc_body,
    ACTIONS(6712), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161991] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6629), 1,
      anon_sym___END__,
    STATE(4510), 1,
      sym_heredoc_body,
    ACTIONS(6627), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162029] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym___END__,
    STATE(4511), 1,
      sym_heredoc_body,
    ACTIONS(6716), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162067] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6722), 1,
      anon_sym___END__,
    STATE(4512), 1,
      sym_heredoc_body,
    ACTIONS(6720), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162105] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6726), 1,
      anon_sym___END__,
    STATE(4513), 1,
      sym_heredoc_body,
    ACTIONS(6724), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162143] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym___END__,
    STATE(4514), 1,
      sym_heredoc_body,
    ACTIONS(6728), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162181] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4515), 1,
      sym_heredoc_body,
    STATE(4884), 1,
      sym_keyword_pattern,
    STATE(4917), 1,
      sym__hash_pattern_any_rest,
    STATE(5971), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6732), 2,
      sym_constant,
      sym_identifier,
    STATE(4914), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5681), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5636), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5638), 4,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [162238] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6734), 1,
      sym_identifier,
    ACTIONS(6740), 1,
      anon_sym_nil,
    STATE(4516), 1,
      sym_heredoc_body,
    ACTIONS(6736), 6,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(6738), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162279] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4517), 1,
      sym_heredoc_body,
    STATE(4884), 1,
      sym_keyword_pattern,
    STATE(4917), 1,
      sym__hash_pattern_any_rest,
    STATE(5811), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6742), 2,
      sym_constant,
      sym_identifier,
    STATE(4914), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5898), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5638), 3,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5636), 5,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [162336] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4518), 1,
      sym_heredoc_body,
    STATE(4884), 1,
      sym_keyword_pattern,
    STATE(4930), 1,
      sym__hash_pattern_any_rest,
    STATE(5811), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6742), 2,
      sym_constant,
      sym_identifier,
    STATE(4914), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5898), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5595), 3,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5593), 5,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [162393] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4519), 1,
      sym_heredoc_body,
    STATE(4884), 1,
      sym_keyword_pattern,
    STATE(4930), 1,
      sym__hash_pattern_any_rest,
    STATE(5971), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6732), 2,
      sym_constant,
      sym_identifier,
    STATE(4914), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5681), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5593), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5595), 4,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [162450] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6746), 1,
      anon_sym_COMMA,
    STATE(4520), 1,
      sym_heredoc_body,
    STATE(4530), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6744), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162488] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6748), 1,
      anon_sym_COMMA,
    STATE(4521), 1,
      sym_heredoc_body,
    STATE(4527), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(5593), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162526] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6746), 1,
      anon_sym_COMMA,
    STATE(4522), 1,
      sym_heredoc_body,
    STATE(4533), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6750), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162564] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6754), 1,
      anon_sym_COMMA,
    STATE(4523), 1,
      sym_heredoc_body,
    STATE(4529), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6752), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162602] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6754), 1,
      anon_sym_COMMA,
    STATE(4523), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4524), 1,
      sym_heredoc_body,
    ACTIONS(6756), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162640] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6758), 1,
      anon_sym_COMMA,
    STATE(4521), 1,
      aux_sym__hash_pattern_body_repeat1,
    STATE(4525), 1,
      sym_heredoc_body,
    ACTIONS(6728), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162678] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6591), 1,
      anon_sym_EQ_GT,
    ACTIONS(6762), 1,
      anon_sym_COMMA,
    STATE(4526), 1,
      sym_heredoc_body,
    ACTIONS(6760), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162716] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6764), 1,
      anon_sym_COMMA,
    STATE(4527), 2,
      sym_heredoc_body,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6659), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162752] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6767), 1,
      sym_identifier,
    STATE(4528), 1,
      sym_heredoc_body,
    ACTIONS(2652), 6,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2660), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162790] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6769), 1,
      anon_sym_COMMA,
    STATE(4529), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6724), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162826] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6772), 1,
      anon_sym_COMMA,
    STATE(4530), 1,
      sym_heredoc_body,
    STATE(4533), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6750), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162864] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6746), 1,
      anon_sym_COMMA,
    STATE(4522), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4531), 1,
      sym_heredoc_body,
    ACTIONS(6744), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162902] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6591), 1,
      anon_sym_EQ_GT,
    ACTIONS(6762), 1,
      anon_sym_COMMA,
    STATE(4532), 1,
      sym_heredoc_body,
    ACTIONS(6667), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162940] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6774), 1,
      anon_sym_COMMA,
    STATE(4533), 2,
      sym_heredoc_body,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6597), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162976] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6777), 1,
      anon_sym_rescue,
    STATE(4534), 1,
      sym_heredoc_body,
    ACTIONS(6720), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [163011] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(819), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(158), 1,
      sym_parameters,
    STATE(217), 1,
      sym__terminator,
    STATE(3010), 1,
      sym__body_expr,
    STATE(4535), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5501), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163070] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(791), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(145), 1,
      sym_parameters,
    STATE(223), 1,
      sym__terminator,
    STATE(2277), 1,
      sym__body_expr,
    STATE(4536), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5563), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163129] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(779), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(139), 1,
      sym_parameters,
    STATE(217), 1,
      sym__terminator,
    STATE(3010), 1,
      sym__body_expr,
    STATE(4537), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5501), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163188] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(767), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(135), 1,
      sym_parameters,
    STATE(223), 1,
      sym__terminator,
    STATE(2277), 1,
      sym__body_expr,
    STATE(4538), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5563), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163247] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(835), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(166), 1,
      sym_parameters,
    STATE(223), 1,
      sym__terminator,
    STATE(2277), 1,
      sym__body_expr,
    STATE(4539), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5563), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163306] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(785), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(142), 1,
      sym_parameters,
    STATE(217), 1,
      sym__terminator,
    STATE(3010), 1,
      sym__body_expr,
    STATE(4540), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5501), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163365] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(795), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(147), 1,
      sym_parameters,
    STATE(223), 1,
      sym__terminator,
    STATE(2277), 1,
      sym__body_expr,
    STATE(4541), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5563), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163424] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(797), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(148), 1,
      sym_parameters,
    STATE(217), 1,
      sym__terminator,
    STATE(3010), 1,
      sym__body_expr,
    STATE(4542), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5501), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163483] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(813), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(155), 1,
      sym_parameters,
    STATE(223), 1,
      sym__terminator,
    STATE(2277), 1,
      sym__body_expr,
    STATE(4543), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5563), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163542] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(829), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(163), 1,
      sym_parameters,
    STATE(217), 1,
      sym__terminator,
    STATE(3010), 1,
      sym__body_expr,
    STATE(4544), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5501), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163601] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(839), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(168), 1,
      sym_parameters,
    STATE(223), 1,
      sym__terminator,
    STATE(2277), 1,
      sym__body_expr,
    STATE(4545), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5563), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163660] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(783), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(141), 1,
      sym_parameters,
    STATE(217), 1,
      sym__terminator,
    STATE(3010), 1,
      sym__body_expr,
    STATE(4546), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5501), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163719] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6777), 1,
      anon_sym_rescue,
    STATE(4547), 1,
      sym_heredoc_body,
    ACTIONS(6683), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [163754] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(801), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(149), 1,
      sym_parameters,
    STATE(231), 1,
      sym__terminator,
    STATE(4548), 1,
      sym_heredoc_body,
    STATE(5358), 1,
      sym__body_expr,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5521), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163813] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(807), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(152), 1,
      sym_parameters,
    STATE(217), 1,
      sym__terminator,
    STATE(3010), 1,
      sym__body_expr,
    STATE(4549), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5501), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163872] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(833), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(165), 1,
      sym_parameters,
    STATE(217), 1,
      sym__terminator,
    STATE(3010), 1,
      sym__body_expr,
    STATE(4550), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5501), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163931] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(815), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(156), 1,
      sym_parameters,
    STATE(223), 1,
      sym__terminator,
    STATE(2277), 1,
      sym__body_expr,
    STATE(4551), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5563), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163990] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(787), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(143), 1,
      sym_parameters,
    STATE(217), 1,
      sym__terminator,
    STATE(3010), 1,
      sym__body_expr,
    STATE(4552), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5501), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164049] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___END__,
    STATE(4553), 1,
      sym_heredoc_body,
    ACTIONS(6787), 20,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [164084] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(811), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(154), 1,
      sym_parameters,
    STATE(223), 1,
      sym__terminator,
    STATE(2277), 1,
      sym__body_expr,
    STATE(4554), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5563), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164143] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym___END__,
    ACTIONS(3186), 1,
      anon_sym_COLON,
    STATE(4555), 1,
      sym_heredoc_body,
    ACTIONS(2742), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [164180] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(831), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(164), 1,
      sym_parameters,
    STATE(223), 1,
      sym__terminator,
    STATE(2277), 1,
      sym__body_expr,
    STATE(4556), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5563), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164239] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(773), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(137), 1,
      sym_parameters,
    STATE(223), 1,
      sym__terminator,
    STATE(2277), 1,
      sym__body_expr,
    STATE(4557), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5563), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164298] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(825), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(161), 1,
      sym_parameters,
    STATE(223), 1,
      sym__terminator,
    STATE(2277), 1,
      sym__body_expr,
    STATE(4558), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5563), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164357] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(823), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(160), 1,
      sym_parameters,
    STATE(223), 1,
      sym__terminator,
    STATE(2277), 1,
      sym__body_expr,
    STATE(4559), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5563), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164416] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(771), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(136), 1,
      sym_parameters,
    STATE(217), 1,
      sym__terminator,
    STATE(3010), 1,
      sym__body_expr,
    STATE(4560), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5501), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164475] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(781), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    STATE(140), 1,
      sym_parameters,
    STATE(223), 1,
      sym__terminator,
    STATE(2277), 1,
      sym__body_expr,
    STATE(4561), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym__simple_formal_parameter,
    STATE(5563), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164534] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6791), 1,
      sym_identifier,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6801), 1,
      anon_sym_do,
    STATE(4562), 1,
      sym_heredoc_body,
    STATE(5480), 1,
      sym__simple_formal_parameter,
    STATE(4733), 2,
      sym_do_block,
      sym_block,
    STATE(5341), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164588] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6803), 1,
      anon_sym_COLON,
    STATE(4563), 1,
      sym_heredoc_body,
    ACTIONS(6497), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3271), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [164624] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6807), 1,
      anon_sym___END__,
    STATE(4564), 1,
      sym_heredoc_body,
    ACTIONS(6805), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [164658] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(371), 1,
      anon_sym_do,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(6791), 1,
      sym_identifier,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    STATE(4565), 1,
      sym_heredoc_body,
    STATE(5480), 1,
      sym__simple_formal_parameter,
    STATE(3042), 2,
      sym_do_block,
      sym_block,
    STATE(5440), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164712] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6791), 1,
      sym_identifier,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6809), 1,
      anon_sym_LBRACE,
    ACTIONS(6811), 1,
      anon_sym_do,
    STATE(4566), 1,
      sym_heredoc_body,
    STATE(5480), 1,
      sym__simple_formal_parameter,
    STATE(4733), 2,
      sym_do_block,
      sym_block,
    STATE(5379), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164766] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6791), 1,
      sym_identifier,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(6815), 1,
      anon_sym_do,
    STATE(4567), 1,
      sym_heredoc_body,
    STATE(5480), 1,
      sym__simple_formal_parameter,
    STATE(5381), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5475), 2,
      sym_do_block,
      sym_block,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164820] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6791), 1,
      sym_identifier,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6817), 1,
      anon_sym_LBRACE,
    ACTIONS(6819), 1,
      anon_sym_do,
    STATE(4568), 1,
      sym_heredoc_body,
    STATE(5480), 1,
      sym__simple_formal_parameter,
    STATE(4409), 2,
      sym_do_block,
      sym_block,
    STATE(5424), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164874] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6517), 1,
      anon_sym_LBRACE,
    ACTIONS(6791), 1,
      sym_identifier,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6821), 1,
      anon_sym_do,
    STATE(4569), 1,
      sym_heredoc_body,
    STATE(5480), 1,
      sym__simple_formal_parameter,
    STATE(4409), 2,
      sym_do_block,
      sym_block,
    STATE(5417), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164928] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6825), 1,
      anon_sym___END__,
    STATE(4570), 1,
      sym_heredoc_body,
    ACTIONS(6823), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [164962] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6829), 1,
      anon_sym___END__,
    STATE(4571), 1,
      sym_heredoc_body,
    ACTIONS(6827), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [164996] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6833), 1,
      anon_sym___END__,
    STATE(4572), 1,
      sym_heredoc_body,
    ACTIONS(6831), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165030] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6837), 1,
      anon_sym___END__,
    STATE(4573), 1,
      sym_heredoc_body,
    ACTIONS(6835), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165064] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6839), 1,
      anon_sym_COMMA,
    STATE(4574), 1,
      sym_heredoc_body,
    STATE(4578), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6752), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [165100] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6839), 1,
      anon_sym_COMMA,
    STATE(4574), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4575), 1,
      sym_heredoc_body,
    ACTIONS(6756), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [165136] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_do,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    ACTIONS(6791), 1,
      sym_identifier,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    STATE(4576), 1,
      sym_heredoc_body,
    STATE(5480), 1,
      sym__simple_formal_parameter,
    STATE(2357), 2,
      sym_do_block,
      sym_block,
    STATE(5478), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165190] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6843), 1,
      anon_sym___END__,
    STATE(4577), 1,
      sym_heredoc_body,
    ACTIONS(6841), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165224] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6845), 1,
      anon_sym_COMMA,
    STATE(4578), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6724), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [165258] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6848), 1,
      sym_identifier,
    ACTIONS(6850), 1,
      anon_sym_COMMA,
    ACTIONS(6852), 1,
      anon_sym_PIPE,
    ACTIONS(6854), 1,
      anon_sym_SEMI,
    STATE(4579), 1,
      sym_heredoc_body,
    STATE(5261), 1,
      sym__simple_formal_parameter,
    STATE(5262), 1,
      sym_parameters,
    STATE(5418), 1,
      sym__formal_parameter,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165313] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6856), 1,
      anon_sym_COMMA,
    STATE(4580), 2,
      sym_heredoc_body,
      aux_sym_undef_repeat1,
    ACTIONS(6787), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165346] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6861), 1,
      anon_sym_COMMA,
    STATE(4580), 1,
      aux_sym_undef_repeat1,
    STATE(4581), 1,
      sym_heredoc_body,
    ACTIONS(6859), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165381] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6848), 1,
      sym_identifier,
    ACTIONS(6863), 1,
      anon_sym_COMMA,
    ACTIONS(6865), 1,
      anon_sym_PIPE,
    ACTIONS(6867), 1,
      anon_sym_SEMI,
    STATE(4582), 1,
      sym_heredoc_body,
    STATE(5261), 1,
      sym__simple_formal_parameter,
    STATE(5262), 1,
      sym_parameters,
    STATE(5455), 1,
      sym__formal_parameter,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165436] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6869), 1,
      anon_sym_rescue,
    STATE(4583), 1,
      sym_heredoc_body,
    ACTIONS(6683), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [165469] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6869), 1,
      anon_sym_rescue,
    STATE(4584), 1,
      sym_heredoc_body,
    ACTIONS(6720), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [165502] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6469), 1,
      anon_sym___END__,
    ACTIONS(6871), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6873), 1,
      anon_sym_DOT_DOT,
    STATE(4585), 1,
      sym_heredoc_body,
    ACTIONS(6467), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [165539] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4586), 1,
      sym_heredoc_body,
    ACTIONS(3761), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3759), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [165572] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6861), 1,
      anon_sym_COMMA,
    STATE(4581), 1,
      aux_sym_undef_repeat1,
    STATE(4587), 1,
      sym_heredoc_body,
    ACTIONS(6875), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165607] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(6877), 1,
      anon_sym_EQ2,
    STATE(4588), 1,
      sym_heredoc_body,
    ACTIONS(4929), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165640] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4589), 1,
      sym_heredoc_body,
    ACTIONS(3749), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3747), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [165673] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6585), 1,
      anon_sym___END__,
    ACTIONS(6879), 1,
      anon_sym_PIPE,
    STATE(4590), 1,
      sym_heredoc_body,
    STATE(4604), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6583), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [165709] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6848), 1,
      sym_identifier,
    ACTIONS(6881), 1,
      anon_sym_PIPE,
    ACTIONS(6883), 1,
      anon_sym_SEMI,
    STATE(4591), 1,
      sym_heredoc_body,
    STATE(5240), 1,
      sym__formal_parameter,
    STATE(5261), 1,
      sym__simple_formal_parameter,
    STATE(5262), 1,
      sym_parameters,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165761] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6848), 1,
      sym_identifier,
    ACTIONS(6885), 1,
      anon_sym_PIPE,
    ACTIONS(6887), 1,
      anon_sym_SEMI,
    STATE(4592), 1,
      sym_heredoc_body,
    STATE(5240), 1,
      sym__formal_parameter,
    STATE(5261), 1,
      sym__simple_formal_parameter,
    STATE(5262), 1,
      sym_parameters,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165813] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6581), 1,
      anon_sym___END__,
    ACTIONS(6889), 1,
      anon_sym_COLON,
    STATE(4593), 1,
      sym_heredoc_body,
    ACTIONS(3082), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [165847] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4594), 1,
      sym_heredoc_body,
    ACTIONS(6893), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6891), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165879] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4595), 1,
      sym_heredoc_body,
    ACTIONS(6893), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6895), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165911] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6671), 1,
      anon_sym___END__,
    STATE(4596), 1,
      sym_heredoc_body,
    ACTIONS(6897), 3,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(6631), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [165945] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6848), 1,
      sym_identifier,
    ACTIONS(6899), 1,
      anon_sym_PIPE,
    ACTIONS(6901), 1,
      anon_sym_SEMI,
    STATE(4597), 1,
      sym_heredoc_body,
    STATE(5240), 1,
      sym__formal_parameter,
    STATE(5261), 1,
      sym__simple_formal_parameter,
    STATE(5262), 1,
      sym_parameters,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165997] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4598), 1,
      sym_heredoc_body,
    ACTIONS(6893), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6903), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [166029] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6905), 1,
      anon_sym___END__,
    ACTIONS(6907), 1,
      anon_sym_PIPE,
    STATE(4599), 2,
      sym_heredoc_body,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6695), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [166063] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6848), 1,
      sym_identifier,
    ACTIONS(6910), 1,
      anon_sym_PIPE,
    ACTIONS(6912), 1,
      anon_sym_SEMI,
    STATE(4600), 1,
      sym_heredoc_body,
    STATE(5240), 1,
      sym__formal_parameter,
    STATE(5261), 1,
      sym__simple_formal_parameter,
    STATE(5262), 1,
      sym_parameters,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [166115] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4601), 1,
      sym_heredoc_body,
    ACTIONS(6893), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6914), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [166147] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4602), 1,
      sym_heredoc_body,
    ACTIONS(6893), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6916), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [166179] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4603), 1,
      sym_heredoc_body,
    ACTIONS(6893), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6823), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [166211] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6879), 1,
      anon_sym_PIPE,
    ACTIONS(6918), 1,
      anon_sym___END__,
    STATE(4599), 1,
      aux_sym_alternative_pattern_repeat1,
    STATE(4604), 1,
      sym_heredoc_body,
    ACTIONS(6687), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [166247] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6920), 1,
      anon_sym_rescue,
    STATE(4605), 1,
      sym_heredoc_body,
    ACTIONS(6683), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [166279] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6920), 1,
      anon_sym_rescue,
    STATE(4606), 1,
      sym_heredoc_body,
    ACTIONS(6720), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [166311] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2640), 1,
      anon_sym___END__,
    STATE(4607), 1,
      sym_heredoc_body,
    ACTIONS(2642), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [166342] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(6922), 1,
      anon_sym_RBRACE,
    STATE(4608), 1,
      sym_heredoc_body,
    STATE(4920), 1,
      sym__hash_pattern_any_rest,
    STATE(4925), 1,
      sym_keyword_pattern,
    STATE(5758), 1,
      sym__hash_pattern_body,
    STATE(5811), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6742), 2,
      sym_constant,
      sym_identifier,
    STATE(4914), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5898), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [166393] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6924), 1,
      sym_identifier,
    ACTIONS(6926), 1,
      anon_sym_RPAREN,
    STATE(4609), 1,
      sym_heredoc_body,
    STATE(5261), 1,
      sym__simple_formal_parameter,
    STATE(5262), 1,
      sym_parameters,
    STATE(5554), 1,
      sym__formal_parameter,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [166442] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_end,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    STATE(4610), 1,
      sym_heredoc_body,
    STATE(4885), 1,
      sym__terminator,
    STATE(5241), 1,
      aux_sym_case_repeat1,
    STATE(5243), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5557), 1,
      sym_when,
    STATE(5780), 1,
      sym_else,
    ACTIONS(1351), 2,
      sym__line_break,
      anon_sym_SEMI,
  [166501] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(6946), 1,
      anon_sym_end,
    STATE(4611), 1,
      sym_heredoc_body,
    STATE(4932), 1,
      sym__terminator,
    STATE(5238), 1,
      aux_sym_case_match_repeat1,
    STATE(5239), 1,
      aux_sym_case_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5557), 1,
      sym_when,
    STATE(5706), 1,
      sym_else,
    ACTIONS(1351), 2,
      sym__line_break,
      anon_sym_SEMI,
  [166560] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6734), 1,
      sym_identifier,
    ACTIONS(6740), 1,
      anon_sym_nil,
    STATE(4612), 1,
      sym_heredoc_body,
    ACTIONS(6736), 6,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(6738), 9,
      anon_sym___END__,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [166595] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(6948), 1,
      anon_sym_end,
    STATE(4613), 1,
      sym_heredoc_body,
    STATE(4895), 1,
      sym__terminator,
    STATE(5269), 1,
      aux_sym_case_repeat1,
    STATE(5271), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5557), 1,
      sym_when,
    STATE(5961), 1,
      sym_else,
    ACTIONS(1351), 2,
      sym__line_break,
      anon_sym_SEMI,
  [166654] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6924), 1,
      sym_identifier,
    ACTIONS(6950), 1,
      anon_sym_RPAREN,
    STATE(4614), 1,
      sym_heredoc_body,
    STATE(5261), 1,
      sym__simple_formal_parameter,
    STATE(5262), 1,
      sym_parameters,
    STATE(5496), 1,
      sym__formal_parameter,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [166703] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6924), 1,
      sym_identifier,
    ACTIONS(6952), 1,
      anon_sym_RPAREN,
    STATE(4615), 1,
      sym_heredoc_body,
    STATE(5261), 1,
      sym__simple_formal_parameter,
    STATE(5262), 1,
      sym_parameters,
    STATE(5559), 1,
      sym__formal_parameter,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [166752] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(6954), 1,
      anon_sym_end,
    STATE(4616), 1,
      sym_heredoc_body,
    STATE(4928), 1,
      sym__terminator,
    STATE(5218), 1,
      aux_sym_case_repeat1,
    STATE(5221), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5557), 1,
      sym_when,
    STATE(5820), 1,
      sym_else,
    ACTIONS(1351), 2,
      sym__line_break,
      anon_sym_SEMI,
  [166811] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(6956), 1,
      anon_sym_end,
    STATE(4617), 1,
      sym_heredoc_body,
    STATE(4935), 1,
      sym__terminator,
    STATE(5223), 1,
      aux_sym_case_repeat1,
    STATE(5225), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5557), 1,
      sym_when,
    STATE(5775), 1,
      sym_else,
    ACTIONS(1351), 2,
      sym__line_break,
      anon_sym_SEMI,
  [166870] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3250), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3254), 1,
      anon_sym_ri,
    STATE(4618), 1,
      sym_heredoc_body,
    ACTIONS(3252), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3248), 13,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [166905] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(6958), 1,
      anon_sym_end,
    STATE(4619), 1,
      sym_heredoc_body,
    STATE(4893), 1,
      sym__terminator,
    STATE(5283), 1,
      aux_sym_case_repeat1,
    STATE(5286), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5557), 1,
      sym_when,
    STATE(5688), 1,
      sym_else,
    ACTIONS(1351), 2,
      sym__line_break,
      anon_sym_SEMI,
  [166964] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(6960), 1,
      anon_sym_RBRACE,
    STATE(4620), 1,
      sym_heredoc_body,
    STATE(4920), 1,
      sym__hash_pattern_any_rest,
    STATE(4925), 1,
      sym_keyword_pattern,
    STATE(5809), 1,
      sym__hash_pattern_body,
    STATE(5811), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6742), 2,
      sym_constant,
      sym_identifier,
    STATE(4914), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5898), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [167015] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6924), 1,
      sym_identifier,
    STATE(4621), 1,
      sym_heredoc_body,
    STATE(5240), 1,
      sym__formal_parameter,
    STATE(5261), 1,
      sym__simple_formal_parameter,
    STATE(5262), 1,
      sym_parameters,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [167061] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    STATE(2054), 1,
      sym__terminator,
    STATE(4622), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(6962), 8,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [167103] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6599), 1,
      anon_sym___END__,
    ACTIONS(6964), 1,
      anon_sym_COMMA,
    STATE(4623), 2,
      sym_heredoc_body,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6597), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167135] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6967), 1,
      anon_sym___END__,
    ACTIONS(6969), 1,
      anon_sym_COMMA,
    STATE(4624), 1,
      sym_heredoc_body,
    STATE(4636), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6744), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167169] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3311), 1,
      anon_sym_COLON,
    STATE(4625), 1,
      sym_heredoc_body,
    ACTIONS(2742), 15,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [167199] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6591), 1,
      anon_sym_EQ_GT,
    ACTIONS(6669), 1,
      anon_sym___END__,
    ACTIONS(6971), 1,
      anon_sym_COMMA,
    STATE(4626), 1,
      sym_heredoc_body,
    ACTIONS(6667), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167233] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6848), 1,
      sym_identifier,
    STATE(4627), 1,
      sym_heredoc_body,
    STATE(5240), 1,
      sym__formal_parameter,
    STATE(5261), 1,
      sym__simple_formal_parameter,
    STATE(5262), 1,
      sym_parameters,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [167279] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5595), 1,
      anon_sym___END__,
    ACTIONS(6973), 1,
      anon_sym_COMMA,
    STATE(4628), 1,
      sym_heredoc_body,
    STATE(4632), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(5593), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167313] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6975), 1,
      anon_sym___END__,
    ACTIONS(6977), 1,
      anon_sym_COMMA,
    STATE(4629), 1,
      sym_heredoc_body,
    STATE(4633), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6756), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167347] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym___END__,
    ACTIONS(6981), 1,
      anon_sym_COMMA,
    STATE(4623), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4630), 1,
      sym_heredoc_body,
    ACTIONS(6750), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167381] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1672), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6785), 1,
      anon_sym_AMP,
    ACTIONS(6983), 1,
      anon_sym_LPAREN,
    STATE(4631), 1,
      sym_heredoc_body,
    STATE(5520), 1,
      sym__formal_parameter,
    STATE(5544), 1,
      sym_parameters,
    STATE(5552), 1,
      sym__simple_formal_parameter,
    STATE(5532), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [167427] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6661), 1,
      anon_sym___END__,
    ACTIONS(6985), 1,
      anon_sym_COMMA,
    STATE(4632), 2,
      sym_heredoc_body,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6659), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167459] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_COMMA,
    ACTIONS(6988), 1,
      anon_sym___END__,
    STATE(4633), 1,
      sym_heredoc_body,
    STATE(4634), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6752), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167493] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6726), 1,
      anon_sym___END__,
    ACTIONS(6990), 1,
      anon_sym_COMMA,
    STATE(4634), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6724), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167525] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    STATE(2054), 1,
      sym__terminator,
    STATE(4635), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(1089), 8,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [167567] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6969), 1,
      anon_sym_COMMA,
    ACTIONS(6979), 1,
      anon_sym___END__,
    STATE(4623), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4636), 1,
      sym_heredoc_body,
    ACTIONS(6750), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167601] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6767), 1,
      sym_identifier,
    STATE(4637), 1,
      sym_heredoc_body,
    ACTIONS(2652), 6,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2660), 9,
      anon_sym___END__,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167633] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2866), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6993), 1,
      sym_identifier,
    STATE(4638), 1,
      sym_heredoc_body,
    STATE(5240), 1,
      sym__formal_parameter,
    STATE(5261), 1,
      sym__simple_formal_parameter,
    STATE(5262), 1,
      sym_parameters,
    STATE(5236), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [167679] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6591), 1,
      anon_sym_EQ_GT,
    ACTIONS(6971), 1,
      anon_sym_COMMA,
    ACTIONS(6995), 1,
      anon_sym___END__,
    STATE(4639), 1,
      sym_heredoc_body,
    ACTIONS(6760), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167713] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym___END__,
    ACTIONS(6997), 1,
      anon_sym_COMMA,
    STATE(4628), 1,
      aux_sym__hash_pattern_body_repeat1,
    STATE(4640), 1,
      sym_heredoc_body,
    ACTIONS(6728), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167747] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6967), 1,
      anon_sym___END__,
    ACTIONS(6969), 1,
      anon_sym_COMMA,
    STATE(4630), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4641), 1,
      sym_heredoc_body,
    ACTIONS(6744), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167781] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6497), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6999), 1,
      anon_sym_COLON,
    STATE(4642), 1,
      sym_heredoc_body,
    ACTIONS(3271), 13,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [167812] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6685), 1,
      anon_sym___END__,
    ACTIONS(7001), 1,
      anon_sym_rescue,
    STATE(4643), 1,
      sym_heredoc_body,
    ACTIONS(6683), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167843] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6722), 1,
      anon_sym___END__,
    ACTIONS(7001), 1,
      anon_sym_rescue,
    STATE(4644), 1,
      sym_heredoc_body,
    ACTIONS(6720), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167874] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3250), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3252), 1,
      anon_sym_r,
    STATE(4645), 1,
      sym_heredoc_body,
    ACTIONS(3254), 2,
      anon_sym_i,
      anon_sym_ri,
    ACTIONS(3248), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167907] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3250), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3252), 1,
      anon_sym_r,
    STATE(4646), 1,
      sym_heredoc_body,
    ACTIONS(3254), 2,
      anon_sym_i,
      anon_sym_ri,
    ACTIONS(3248), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167940] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4647), 1,
      sym_heredoc_body,
    ACTIONS(3070), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [167966] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4648), 1,
      sym_heredoc_body,
    ACTIONS(3030), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [167992] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4649), 1,
      sym_heredoc_body,
    ACTIONS(3066), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168018] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4650), 1,
      sym_heredoc_body,
    ACTIONS(3034), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168044] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4651), 1,
      sym_heredoc_body,
    ACTIONS(6289), 5,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(745), 9,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [168072] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3301), 1,
      anon_sym_DOT_DOT,
    STATE(4652), 1,
      sym_heredoc_body,
    ACTIONS(3299), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168100] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4653), 1,
      sym_heredoc_body,
    ACTIONS(3054), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168126] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4654), 1,
      sym_heredoc_body,
    ACTIONS(2998), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168152] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4655), 1,
      sym_heredoc_body,
    ACTIONS(3074), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168178] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4656), 1,
      sym_heredoc_body,
    ACTIONS(3050), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168204] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4657), 1,
      sym_heredoc_body,
    ACTIONS(3046), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168230] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3297), 1,
      anon_sym_COLON,
    STATE(4658), 1,
      sym_heredoc_body,
    ACTIONS(2742), 13,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [168258] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4659), 1,
      sym_heredoc_body,
    ACTIONS(3002), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168284] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4660), 1,
      sym_heredoc_body,
    ACTIONS(3022), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168310] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4661), 1,
      sym_heredoc_body,
    ACTIONS(3042), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168336] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6975), 1,
      anon_sym___END__,
    ACTIONS(7003), 1,
      anon_sym_COMMA,
    STATE(4662), 1,
      sym_heredoc_body,
    STATE(4667), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6756), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [168368] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4663), 1,
      sym_heredoc_body,
    ACTIONS(2970), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [168394] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6726), 1,
      anon_sym___END__,
    ACTIONS(7005), 1,
      anon_sym_COMMA,
    STATE(4664), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6724), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [168424] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(7008), 1,
      anon_sym_do,
    STATE(4665), 1,
      sym_heredoc_body,
    STATE(5036), 1,
      sym_argument_list,
    STATE(5328), 1,
      sym_block,
    STATE(5481), 1,
      sym_do_block,
    ACTIONS(179), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [168462] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4666), 1,
      sym_heredoc_body,
    ACTIONS(2742), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [168488] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6988), 1,
      anon_sym___END__,
    ACTIONS(7003), 1,
      anon_sym_COMMA,
    STATE(4664), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4667), 1,
      sym_heredoc_body,
    ACTIONS(6752), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [168520] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(7008), 1,
      anon_sym_do,
    STATE(4668), 1,
      sym_heredoc_body,
    STATE(5035), 1,
      sym_argument_list,
    STATE(5487), 1,
      sym_do_block,
    STATE(5488), 1,
      sym_block,
    ACTIONS(123), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [168558] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4669), 1,
      sym_heredoc_body,
    ACTIONS(3058), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168584] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3323), 1,
      anon_sym_DOT_DOT,
    STATE(4670), 1,
      sym_heredoc_body,
    ACTIONS(3321), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168612] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4671), 1,
      sym_heredoc_body,
    ACTIONS(3010), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168638] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4672), 1,
      sym_heredoc_body,
    ACTIONS(3062), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168664] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4673), 1,
      sym_heredoc_body,
    ACTIONS(3006), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168690] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7010), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7012), 1,
      anon_sym_LBRACK2,
    ACTIONS(7014), 1,
      anon_sym_LPAREN2,
    STATE(4674), 1,
      sym_heredoc_body,
    ACTIONS(6467), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168722] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7016), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7018), 1,
      anon_sym_DOT_DOT,
    STATE(4675), 1,
      sym_heredoc_body,
    ACTIONS(6467), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [168752] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4676), 1,
      sym_heredoc_body,
    ACTIONS(6369), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [168778] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4677), 1,
      sym_heredoc_body,
    ACTIONS(6459), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [168804] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3617), 1,
      anon_sym_DOT_DOT,
    STATE(4678), 1,
      sym_heredoc_body,
    ACTIONS(3615), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168831] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3339), 1,
      anon_sym_COLON,
    STATE(4679), 1,
      sym_heredoc_body,
    ACTIONS(2742), 12,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [168858] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3250), 1,
      anon_sym_DOT_DOT,
    STATE(4680), 1,
      sym_heredoc_body,
    ACTIONS(3248), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168885] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT_DOT,
    STATE(4681), 1,
      sym_heredoc_body,
    ACTIONS(3429), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168912] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(7008), 1,
      anon_sym_do,
    STATE(4682), 1,
      sym_heredoc_body,
    STATE(5035), 1,
      sym_argument_list,
    STATE(5487), 1,
      sym_do_block,
    STATE(5488), 1,
      sym_block,
    ACTIONS(123), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [168949] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3761), 1,
      anon_sym_DOT_DOT,
    STATE(4683), 1,
      sym_heredoc_body,
    ACTIONS(3759), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168976] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(7008), 1,
      anon_sym_do,
    STATE(4684), 1,
      sym_heredoc_body,
    STATE(5036), 1,
      sym_argument_list,
    STATE(5328), 1,
      sym_block,
    STATE(5481), 1,
      sym_do_block,
    ACTIONS(179), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [169013] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_DOT_DOT,
    STATE(4685), 1,
      sym_heredoc_body,
    ACTIONS(3074), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169040] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT,
    STATE(4686), 1,
      sym_heredoc_body,
    ACTIONS(3871), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169067] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3849), 1,
      anon_sym_DOT_DOT,
    STATE(4687), 1,
      sym_heredoc_body,
    ACTIONS(3847), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169094] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_DOT_DOT,
    STATE(4688), 1,
      sym_heredoc_body,
    ACTIONS(2998), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169121] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3072), 1,
      anon_sym_DOT_DOT,
    STATE(4689), 1,
      sym_heredoc_body,
    ACTIONS(3070), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169148] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3405), 1,
      anon_sym_DOT_DOT,
    STATE(4690), 1,
      sym_heredoc_body,
    ACTIONS(3403), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169175] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3028), 1,
      anon_sym_DOT_DOT,
    STATE(4691), 1,
      sym_heredoc_body,
    ACTIONS(3026), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169202] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT,
    STATE(4692), 1,
      sym_heredoc_body,
    ACTIONS(3066), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169229] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6722), 1,
      anon_sym___END__,
    ACTIONS(7020), 1,
      anon_sym_rescue,
    STATE(4693), 1,
      sym_heredoc_body,
    ACTIONS(6720), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [169258] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_DOT_DOT,
    STATE(4694), 1,
      sym_heredoc_body,
    ACTIONS(3030), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169285] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3789), 1,
      anon_sym_DOT_DOT,
    STATE(4695), 1,
      sym_heredoc_body,
    ACTIONS(3787), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169312] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3749), 1,
      anon_sym_DOT_DOT,
    STATE(4696), 1,
      sym_heredoc_body,
    ACTIONS(3747), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169339] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3645), 1,
      anon_sym_DOT_DOT,
    STATE(4697), 1,
      sym_heredoc_body,
    ACTIONS(3643), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169366] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7022), 1,
      anon_sym_PIPE,
    STATE(4698), 1,
      sym_heredoc_body,
    STATE(4742), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6583), 11,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [169395] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3669), 1,
      anon_sym_DOT_DOT,
    STATE(4699), 1,
      sym_heredoc_body,
    ACTIONS(3667), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169422] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6497), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7024), 1,
      anon_sym_COLON,
    STATE(4700), 1,
      sym_heredoc_body,
    ACTIONS(3271), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169451] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7026), 1,
      anon_sym_PIPE,
    STATE(4701), 2,
      sym_heredoc_body,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6695), 11,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [169478] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6497), 1,
      anon_sym_DOT_DOT,
    STATE(4702), 1,
      sym_heredoc_body,
    ACTIONS(3271), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169505] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT_DOT,
    STATE(4703), 1,
      sym_heredoc_body,
    ACTIONS(3521), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169532] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3467), 1,
      anon_sym_DOT_DOT,
    STATE(4704), 1,
      sym_heredoc_body,
    ACTIONS(3465), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169559] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3064), 1,
      anon_sym_DOT_DOT,
    STATE(4705), 1,
      sym_heredoc_body,
    ACTIONS(3062), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169586] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3817), 1,
      anon_sym_DOT_DOT,
    STATE(4706), 1,
      sym_heredoc_body,
    ACTIONS(3815), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169613] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3825), 1,
      anon_sym_DOT_DOT,
    STATE(4707), 1,
      sym_heredoc_body,
    ACTIONS(3823), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169640] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_DOT_DOT,
    STATE(4708), 1,
      sym_heredoc_body,
    ACTIONS(3042), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169667] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3048), 1,
      anon_sym_DOT_DOT,
    STATE(4709), 1,
      sym_heredoc_body,
    ACTIONS(3046), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169694] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6493), 1,
      anon_sym_DOT_DOT,
    STATE(4710), 1,
      sym_heredoc_body,
    ACTIONS(2996), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169721] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6685), 1,
      anon_sym___END__,
    ACTIONS(7020), 1,
      anon_sym_rescue,
    STATE(4711), 1,
      sym_heredoc_body,
    ACTIONS(6683), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [169750] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3471), 1,
      anon_sym_DOT_DOT,
    STATE(4712), 1,
      sym_heredoc_body,
    ACTIONS(3469), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169777] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3036), 1,
      anon_sym_DOT_DOT,
    STATE(4713), 1,
      sym_heredoc_body,
    ACTIONS(3034), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169804] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3004), 1,
      anon_sym_DOT_DOT,
    STATE(4714), 1,
      sym_heredoc_body,
    ACTIONS(3002), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169831] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3757), 1,
      anon_sym_DOT_DOT,
    STATE(4715), 1,
      sym_heredoc_body,
    ACTIONS(3755), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169858] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_DOT_DOT,
    STATE(4716), 1,
      sym_heredoc_body,
    ACTIONS(3022), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169885] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3347), 1,
      anon_sym_DOT_DOT,
    STATE(4717), 1,
      sym_heredoc_body,
    ACTIONS(3345), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169912] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT,
    STATE(4718), 1,
      sym_heredoc_body,
    ACTIONS(3783), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169939] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6491), 1,
      anon_sym_DOT_DOT,
    STATE(4719), 1,
      sym_heredoc_body,
    ACTIONS(6489), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169966] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3633), 1,
      anon_sym_DOT_DOT,
    STATE(4720), 1,
      sym_heredoc_body,
    ACTIONS(3631), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169993] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3012), 1,
      anon_sym_DOT_DOT,
    STATE(4721), 1,
      sym_heredoc_body,
    ACTIONS(3010), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170020] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_DOT_DOT,
    STATE(4722), 1,
      sym_heredoc_body,
    ACTIONS(3006), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170047] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7029), 1,
      anon_sym_COLON,
    STATE(4723), 1,
      sym_heredoc_body,
    ACTIONS(3082), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [170074] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3737), 1,
      anon_sym_DOT_DOT,
    STATE(4724), 1,
      sym_heredoc_body,
    ACTIONS(3735), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170101] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3443), 1,
      anon_sym_DOT_DOT,
    STATE(4725), 1,
      sym_heredoc_body,
    ACTIONS(3441), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170128] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3060), 1,
      anon_sym_DOT_DOT,
    STATE(4726), 1,
      sym_heredoc_body,
    ACTIONS(3058), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170155] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7031), 1,
      sym_identifier,
    ACTIONS(7033), 1,
      anon_sym_nil,
    STATE(4727), 1,
      sym_heredoc_body,
    ACTIONS(6738), 4,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6736), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [170186] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_DOT_DOT,
    STATE(4728), 1,
      sym_heredoc_body,
    ACTIONS(3054), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170213] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3753), 1,
      anon_sym_DOT_DOT,
    STATE(4729), 1,
      sym_heredoc_body,
    ACTIONS(3751), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170240] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3741), 1,
      anon_sym_DOT_DOT,
    STATE(4730), 1,
      sym_heredoc_body,
    ACTIONS(3739), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170267] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_DOT_DOT,
    STATE(4731), 1,
      sym_heredoc_body,
    ACTIONS(3391), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170294] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3769), 1,
      anon_sym_DOT_DOT,
    STATE(4732), 1,
      sym_heredoc_body,
    ACTIONS(3767), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170321] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3613), 1,
      anon_sym_DOT_DOT,
    STATE(4733), 1,
      sym_heredoc_body,
    ACTIONS(3611), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170348] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_DOT_DOT,
    STATE(4734), 1,
      sym_heredoc_body,
    ACTIONS(3795), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170375] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3813), 1,
      anon_sym_DOT_DOT,
    STATE(4735), 1,
      sym_heredoc_body,
    ACTIONS(3811), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170402] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3697), 1,
      anon_sym_DOT_DOT,
    STATE(4736), 1,
      sym_heredoc_body,
    ACTIONS(3695), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170429] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3607), 1,
      anon_sym_DOT_DOT,
    STATE(4737), 1,
      sym_heredoc_body,
    ACTIONS(3605), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170456] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3519), 1,
      anon_sym_DOT_DOT,
    STATE(4738), 1,
      sym_heredoc_body,
    ACTIONS(3517), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170483] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3773), 1,
      anon_sym_DOT_DOT,
    STATE(4739), 1,
      sym_heredoc_body,
    ACTIONS(3771), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170510] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3052), 1,
      anon_sym_DOT_DOT,
    STATE(4740), 1,
      sym_heredoc_body,
    ACTIONS(3050), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170537] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym_DOT_DOT,
    STATE(4741), 1,
      sym_heredoc_body,
    ACTIONS(3561), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170564] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7022), 1,
      anon_sym_PIPE,
    STATE(4701), 1,
      aux_sym_alternative_pattern_repeat1,
    STATE(4742), 1,
      sym_heredoc_body,
    ACTIONS(6687), 11,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [170593] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(733), 1,
      anon_sym_DOT,
    ACTIONS(745), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6877), 1,
      anon_sym_EQ2,
    STATE(4743), 1,
      sym_heredoc_body,
    ACTIONS(4927), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(4929), 7,
      sym__line_break,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      sym_identifier,
  [170625] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6722), 1,
      anon_sym___END__,
    ACTIONS(7035), 1,
      anon_sym_rescue,
    STATE(4744), 1,
      sym_heredoc_body,
    ACTIONS(6720), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [170653] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___END__,
    ACTIONS(7037), 1,
      anon_sym_COMMA,
    STATE(4745), 2,
      sym_heredoc_body,
      aux_sym_undef_repeat1,
    ACTIONS(6787), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [170681] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(7008), 1,
      anon_sym_do,
    STATE(4746), 1,
      sym_heredoc_body,
    STATE(4964), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2976), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [170711] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7040), 1,
      anon_sym___END__,
    STATE(4747), 1,
      sym_heredoc_body,
    ACTIONS(7042), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6916), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [170739] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7044), 1,
      anon_sym_COMMA,
    STATE(4748), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6724), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [170765] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(7008), 1,
      anon_sym_do,
    STATE(4749), 1,
      sym_heredoc_body,
    STATE(4972), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2972), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [170795] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6825), 1,
      anon_sym___END__,
    STATE(4750), 1,
      sym_heredoc_body,
    ACTIONS(7042), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6823), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [170823] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7047), 1,
      anon_sym___END__,
    ACTIONS(7049), 1,
      anon_sym_COMMA,
    STATE(4751), 1,
      sym_heredoc_body,
    STATE(4753), 1,
      aux_sym_undef_repeat1,
    ACTIONS(6875), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [170853] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6685), 1,
      anon_sym___END__,
    ACTIONS(7035), 1,
      anon_sym_rescue,
    STATE(4752), 1,
      sym_heredoc_body,
    ACTIONS(6683), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [170881] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7049), 1,
      anon_sym_COMMA,
    ACTIONS(7051), 1,
      anon_sym___END__,
    STATE(4745), 1,
      aux_sym_undef_repeat1,
    STATE(4753), 1,
      sym_heredoc_body,
    ACTIONS(6859), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [170911] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7055), 1,
      anon_sym_DOT_DOT,
    STATE(4754), 1,
      sym_heredoc_body,
    ACTIONS(6467), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170939] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7057), 1,
      anon_sym_COMMA,
    STATE(4755), 1,
      sym_heredoc_body,
    STATE(4762), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6756), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [170967] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4927), 1,
      anon_sym___END__,
    ACTIONS(7059), 1,
      anon_sym_EQ2,
    STATE(4756), 1,
      sym_heredoc_body,
    ACTIONS(4929), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [170995] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7061), 1,
      anon_sym___END__,
    STATE(4757), 1,
      sym_heredoc_body,
    ACTIONS(7042), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6891), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171023] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7063), 1,
      anon_sym___END__,
    STATE(4758), 1,
      sym_heredoc_body,
    ACTIONS(7042), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6895), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171051] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___END__,
    STATE(4759), 1,
      sym_heredoc_body,
    ACTIONS(7042), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6903), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171079] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7067), 1,
      anon_sym___END__,
    STATE(4760), 1,
      sym_heredoc_body,
    ACTIONS(7042), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6914), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171107] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6497), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7069), 1,
      anon_sym_COLON,
    STATE(4761), 1,
      sym_heredoc_body,
    ACTIONS(3271), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171135] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7057), 1,
      anon_sym_COMMA,
    STATE(4748), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4762), 1,
      sym_heredoc_body,
    ACTIONS(6752), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [171163] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7073), 1,
      anon_sym_DOT_DOT,
    STATE(4763), 1,
      sym_heredoc_body,
    ACTIONS(6467), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171191] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4764), 1,
      sym_heredoc_body,
    ACTIONS(6521), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171214] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7075), 1,
      anon_sym_COMMA,
    STATE(4765), 1,
      sym_heredoc_body,
    STATE(4808), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6744), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [171241] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7077), 1,
      anon_sym_COLON,
    STATE(4766), 1,
      sym_heredoc_body,
    ACTIONS(3082), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171266] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7079), 1,
      sym_identifier,
    STATE(4767), 1,
      sym_heredoc_body,
    ACTIONS(2660), 4,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2652), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [171293] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7081), 1,
      anon_sym_COMMA,
    STATE(4768), 1,
      sym_heredoc_body,
    STATE(4784), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6728), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [171320] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4769), 1,
      sym_heredoc_body,
    ACTIONS(6503), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [171343] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4770), 1,
      sym_heredoc_body,
    ACTIONS(6503), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [171366] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4771), 1,
      sym_heredoc_body,
    STATE(4884), 1,
      sym_keyword_pattern,
    STATE(5971), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6732), 2,
      sym_constant,
      sym_identifier,
    STATE(5681), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [171401] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4772), 1,
      sym_heredoc_body,
    ACTIONS(2622), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171424] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym_PIPE,
    STATE(4773), 1,
      sym_heredoc_body,
    STATE(4777), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6687), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171451] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7085), 1,
      anon_sym___END__,
    ACTIONS(7087), 1,
      anon_sym_rescue,
    ACTIONS(7091), 1,
      anon_sym_if,
    ACTIONS(7093), 1,
      anon_sym_unless,
    ACTIONS(7095), 1,
      anon_sym_while,
    ACTIONS(7097), 1,
      anon_sym_until,
    STATE(2143), 1,
      sym__terminator,
    STATE(4774), 1,
      sym_heredoc_body,
    ACTIONS(6962), 2,
      ts_builtin_sym_end,
      aux_sym_program_token1,
    ACTIONS(7089), 2,
      sym__line_break,
      anon_sym_SEMI,
  [171490] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1091), 1,
      anon_sym___END__,
    ACTIONS(7087), 1,
      anon_sym_rescue,
    ACTIONS(7091), 1,
      anon_sym_if,
    ACTIONS(7093), 1,
      anon_sym_unless,
    ACTIONS(7095), 1,
      anon_sym_while,
    ACTIONS(7097), 1,
      anon_sym_until,
    STATE(2143), 1,
      sym__terminator,
    STATE(4775), 1,
      sym_heredoc_body,
    ACTIONS(1089), 2,
      ts_builtin_sym_end,
      aux_sym_program_token1,
    ACTIONS(7089), 2,
      sym__line_break,
      anon_sym_SEMI,
  [171529] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6591), 1,
      anon_sym_EQ_GT,
    ACTIONS(7099), 1,
      anon_sym_COMMA,
    STATE(4776), 1,
      sym_heredoc_body,
    ACTIONS(6667), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [171556] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7101), 1,
      anon_sym_PIPE,
    STATE(4777), 2,
      sym_heredoc_body,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6695), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171581] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4778), 1,
      sym_heredoc_body,
    ACTIONS(2618), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171604] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4779), 1,
      sym_heredoc_body,
    ACTIONS(2634), 3,
      anon_sym_LBRACE,
      anon_sym_do,
      anon_sym_LPAREN2,
    ACTIONS(2636), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4780), 1,
      sym_heredoc_body,
    ACTIONS(2646), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171652] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4781), 1,
      sym_heredoc_body,
    ACTIONS(6561), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171675] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7104), 1,
      anon_sym_PIPE,
    STATE(4782), 1,
      sym_heredoc_body,
    STATE(4820), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6687), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171702] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4783), 1,
      sym_heredoc_body,
    ACTIONS(6569), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171725] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7106), 1,
      anon_sym_COMMA,
    STATE(4784), 1,
      sym_heredoc_body,
    STATE(4807), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(5593), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [171752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4785), 1,
      sym_heredoc_body,
    ACTIONS(745), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171775] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4786), 1,
      sym_heredoc_body,
    ACTIONS(6467), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4787), 1,
      sym_heredoc_body,
    ACTIONS(2642), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4788), 1,
      sym_heredoc_body,
    ACTIONS(2634), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171844] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6591), 1,
      anon_sym_EQ_GT,
    ACTIONS(7099), 1,
      anon_sym_COMMA,
    STATE(4789), 1,
      sym_heredoc_body,
    ACTIONS(6760), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [171871] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4790), 1,
      sym_heredoc_body,
    ACTIONS(3082), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4791), 1,
      sym_heredoc_body,
    ACTIONS(2630), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171917] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4792), 1,
      sym_heredoc_body,
    ACTIONS(6543), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171940] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4793), 1,
      sym_heredoc_body,
    ACTIONS(3575), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171963] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4927), 1,
      anon_sym___END__,
    STATE(4794), 1,
      sym_heredoc_body,
    ACTIONS(4929), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171988] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4795), 1,
      sym_heredoc_body,
    ACTIONS(2642), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172011] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2644), 1,
      anon_sym___END__,
    STATE(4796), 1,
      sym_heredoc_body,
    ACTIONS(2646), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [172036] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2620), 1,
      anon_sym___END__,
    STATE(4797), 1,
      sym_heredoc_body,
    ACTIONS(2622), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [172061] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4798), 1,
      sym_heredoc_body,
    ACTIONS(6533), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172084] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2616), 1,
      anon_sym___END__,
    STATE(4799), 1,
      sym_heredoc_body,
    ACTIONS(2618), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [172109] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4800), 1,
      sym_heredoc_body,
    ACTIONS(6655), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172132] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4490), 1,
      sym_keyword_pattern,
    STATE(4801), 1,
      sym_heredoc_body,
    STATE(5640), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(5591), 2,
      sym_constant,
      sym_identifier,
    STATE(5806), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [172167] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4490), 1,
      sym_keyword_pattern,
    STATE(4802), 1,
      sym_heredoc_body,
    STATE(5916), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6601), 2,
      sym_constant,
      sym_identifier,
    STATE(5723), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [172202] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4803), 1,
      sym_heredoc_body,
    ACTIONS(3609), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172225] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4804), 1,
      sym_heredoc_body,
    ACTIONS(6573), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172248] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4805), 1,
      sym_heredoc_body,
    ACTIONS(6565), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172271] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7108), 1,
      anon_sym_LBRACE,
    ACTIONS(7110), 1,
      anon_sym_do,
    STATE(4806), 1,
      sym_heredoc_body,
    STATE(5043), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2976), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [172300] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7112), 1,
      anon_sym_COMMA,
    STATE(4807), 2,
      sym_heredoc_body,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6659), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [172325] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7075), 1,
      anon_sym_COMMA,
    STATE(4808), 1,
      sym_heredoc_body,
    STATE(4823), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6750), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [172352] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4809), 1,
      sym_heredoc_body,
    ACTIONS(6525), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172375] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7075), 1,
      anon_sym_COMMA,
    STATE(4810), 1,
      sym_heredoc_body,
    STATE(4832), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6744), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [172402] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym_PIPE,
    STATE(4773), 1,
      aux_sym_alternative_pattern_repeat1,
    STATE(4811), 1,
      sym_heredoc_body,
    ACTIONS(6583), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172429] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4812), 1,
      sym_heredoc_body,
    ACTIONS(2626), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [172452] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4813), 1,
      sym_heredoc_body,
    ACTIONS(6639), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172475] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4814), 1,
      sym_heredoc_body,
    ACTIONS(6557), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172498] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym___END__,
    STATE(4815), 1,
      sym_heredoc_body,
    ACTIONS(2630), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [172523] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2624), 1,
      anon_sym___END__,
    STATE(4816), 1,
      sym_heredoc_body,
    ACTIONS(2626), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [172548] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4817), 1,
      sym_heredoc_body,
    ACTIONS(6547), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172571] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7108), 1,
      anon_sym_LBRACE,
    ACTIONS(7110), 1,
      anon_sym_do,
    STATE(4818), 1,
      sym_heredoc_body,
    STATE(5042), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2972), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [172600] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4819), 1,
      sym_heredoc_body,
    ACTIONS(6551), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172623] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7115), 1,
      anon_sym_PIPE,
    STATE(4820), 2,
      sym_heredoc_body,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6695), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172648] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4821), 1,
      sym_heredoc_body,
    ACTIONS(6577), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172671] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4490), 1,
      sym_keyword_pattern,
    STATE(4822), 1,
      sym_heredoc_body,
    STATE(5756), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6283), 2,
      sym_constant,
      sym_identifier,
    STATE(5714), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [172706] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7118), 1,
      anon_sym_COMMA,
    STATE(4823), 2,
      sym_heredoc_body,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6597), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [172731] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7104), 1,
      anon_sym_PIPE,
    STATE(4782), 1,
      aux_sym_alternative_pattern_repeat1,
    STATE(4824), 1,
      sym_heredoc_body,
    ACTIONS(6583), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172758] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4825), 1,
      sym_heredoc_body,
    STATE(4884), 1,
      sym_keyword_pattern,
    STATE(5811), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6742), 2,
      sym_constant,
      sym_identifier,
    STATE(5898), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [172793] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(733), 1,
      anon_sym_DOT,
    ACTIONS(745), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4927), 1,
      anon_sym_STAR,
    STATE(4826), 1,
      sym_heredoc_body,
    ACTIONS(4929), 8,
      sym__line_break,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      sym_identifier,
  [172822] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4827), 1,
      sym_heredoc_body,
    ACTIONS(6539), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172845] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4828), 1,
      sym_heredoc_body,
    ACTIONS(6509), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172868] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5145), 1,
      anon_sym___END__,
    STATE(4829), 1,
      sym_heredoc_body,
    ACTIONS(5147), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [172893] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4830), 1,
      sym_heredoc_body,
    ACTIONS(7121), 3,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(6631), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172918] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7123), 1,
      anon_sym_rescue,
    STATE(4831), 1,
      sym_heredoc_body,
    ACTIONS(6720), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [172943] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7125), 1,
      anon_sym_COMMA,
    STATE(4823), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4832), 1,
      sym_heredoc_body,
    ACTIONS(6750), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [172970] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4833), 1,
      sym_heredoc_body,
    ACTIONS(6499), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [172993] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7123), 1,
      anon_sym_rescue,
    STATE(4834), 1,
      sym_heredoc_body,
    ACTIONS(6683), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [173018] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4835), 1,
      sym_heredoc_body,
    ACTIONS(6499), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [173041] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7127), 1,
      anon_sym_rescue,
    STATE(4836), 1,
      sym_heredoc_body,
    ACTIONS(6683), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [173065] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7129), 1,
      anon_sym_rescue,
    ACTIONS(7131), 1,
      anon_sym_if,
    ACTIONS(7133), 1,
      anon_sym_unless,
    ACTIONS(7135), 1,
      anon_sym_while,
    ACTIONS(7137), 1,
      anon_sym_until,
    ACTIONS(7139), 1,
      anon_sym_do,
    STATE(349), 1,
      sym__terminator,
    STATE(4837), 1,
      sym_heredoc_body,
    STATE(5426), 1,
      sym_do,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173103] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4838), 1,
      sym_heredoc_body,
    ACTIONS(7141), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6903), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [173127] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    ACTIONS(7143), 1,
      anon_sym_then,
    STATE(275), 1,
      sym__terminator,
    STATE(4839), 1,
      sym_heredoc_body,
    STATE(5313), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173165] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    ACTIONS(7143), 1,
      anon_sym_then,
    STATE(267), 1,
      sym__terminator,
    STATE(4840), 1,
      sym_heredoc_body,
    STATE(5310), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173203] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4841), 1,
      sym_heredoc_body,
    ACTIONS(6603), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173225] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4842), 1,
      sym_heredoc_body,
    ACTIONS(2634), 3,
      anon_sym_LBRACE,
      anon_sym_do,
      anon_sym_LPAREN2,
    ACTIONS(2636), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [173249] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4843), 1,
      sym_heredoc_body,
    ACTIONS(7141), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6914), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [173273] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7145), 1,
      anon_sym_EQ_GT,
    STATE(4844), 1,
      sym_heredoc_body,
    ACTIONS(6593), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173297] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6809), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      anon_sym_do,
    STATE(4769), 1,
      sym_block,
    STATE(4770), 1,
      sym_do_block,
    STATE(4845), 1,
      sym_heredoc_body,
    ACTIONS(6513), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173327] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4846), 1,
      sym_heredoc_body,
    ACTIONS(7141), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6895), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [173351] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    ACTIONS(7143), 1,
      anon_sym_then,
    STATE(274), 1,
      sym__terminator,
    STATE(4847), 1,
      sym_heredoc_body,
    STATE(5318), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173389] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    ACTIONS(7143), 1,
      anon_sym_then,
    STATE(270), 1,
      sym__terminator,
    STATE(4848), 1,
      sym_heredoc_body,
    STATE(5312), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173427] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4849), 1,
      sym_heredoc_body,
    ACTIONS(6289), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173449] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7143), 1,
      anon_sym_then,
    ACTIONS(7149), 1,
      anon_sym_if,
    ACTIONS(7151), 1,
      anon_sym_unless,
    STATE(294), 1,
      sym__terminator,
    STATE(4850), 1,
      sym_heredoc_body,
    STATE(5315), 1,
      sym__guard,
    STATE(5539), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5536), 2,
      sym_if_guard,
      sym_unless_guard,
  [173485] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7145), 1,
      anon_sym_EQ_GT,
    STATE(4851), 1,
      sym_heredoc_body,
    ACTIONS(6587), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173509] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(7008), 1,
      anon_sym_do,
    STATE(4852), 1,
      sym_heredoc_body,
    STATE(5035), 1,
      sym_argument_list,
    STATE(5487), 1,
      sym_do_block,
    STATE(5488), 1,
      sym_block,
    ACTIONS(411), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [173543] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7153), 1,
      anon_sym_COMMA,
    STATE(4853), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6724), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [173567] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7156), 1,
      anon_sym_COMMA,
    STATE(4853), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4854), 1,
      sym_heredoc_body,
    ACTIONS(6752), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [173593] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4855), 1,
      sym_heredoc_body,
    ACTIONS(7141), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6916), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [173617] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7129), 1,
      anon_sym_rescue,
    ACTIONS(7131), 1,
      anon_sym_if,
    ACTIONS(7133), 1,
      anon_sym_unless,
    ACTIONS(7135), 1,
      anon_sym_while,
    ACTIONS(7137), 1,
      anon_sym_until,
    ACTIONS(7139), 1,
      anon_sym_do,
    STATE(349), 1,
      sym__terminator,
    STATE(4856), 1,
      sym_heredoc_body,
    STATE(5357), 1,
      sym_do,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173655] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7127), 1,
      anon_sym_rescue,
    STATE(4857), 1,
      sym_heredoc_body,
    ACTIONS(6720), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [173679] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7129), 1,
      anon_sym_rescue,
    ACTIONS(7131), 1,
      anon_sym_if,
    ACTIONS(7133), 1,
      anon_sym_unless,
    ACTIONS(7135), 1,
      anon_sym_while,
    ACTIONS(7137), 1,
      anon_sym_until,
    ACTIONS(7158), 1,
      anon_sym_do,
    STATE(343), 1,
      sym__terminator,
    STATE(2293), 1,
      sym_do,
    STATE(4858), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173717] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7129), 1,
      anon_sym_rescue,
    ACTIONS(7131), 1,
      anon_sym_if,
    ACTIONS(7133), 1,
      anon_sym_unless,
    ACTIONS(7135), 1,
      anon_sym_while,
    ACTIONS(7137), 1,
      anon_sym_until,
    ACTIONS(7158), 1,
      anon_sym_do,
    STATE(343), 1,
      sym__terminator,
    STATE(2294), 1,
      sym_do,
    STATE(4859), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173755] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4860), 1,
      sym_heredoc_body,
    ACTIONS(2642), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [173777] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4861), 1,
      sym_heredoc_body,
    ACTIONS(6611), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173799] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4862), 1,
      sym_heredoc_body,
    ACTIONS(2630), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [173821] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4863), 1,
      sym_heredoc_body,
    ACTIONS(6583), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173843] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4864), 1,
      sym_heredoc_body,
    ACTIONS(2626), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [173865] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6809), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      anon_sym_do,
    STATE(4833), 1,
      sym_block,
    STATE(4835), 1,
      sym_do_block,
    STATE(4865), 1,
      sym_heredoc_body,
    ACTIONS(6529), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173895] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    ACTIONS(7143), 1,
      anon_sym_then,
    STATE(273), 1,
      sym__terminator,
    STATE(4866), 1,
      sym_heredoc_body,
    STATE(5308), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173933] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7160), 1,
      anon_sym_COLON,
    STATE(4867), 1,
      sym_heredoc_body,
    ACTIONS(3082), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173957] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    ACTIONS(7143), 1,
      anon_sym_then,
    STATE(269), 1,
      sym__terminator,
    STATE(4868), 1,
      sym_heredoc_body,
    STATE(5326), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173995] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    ACTIONS(7143), 1,
      anon_sym_then,
    STATE(271), 1,
      sym__terminator,
    STATE(4869), 1,
      sym_heredoc_body,
    STATE(5322), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [174033] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7156), 1,
      anon_sym_COMMA,
    STATE(4854), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4870), 1,
      sym_heredoc_body,
    ACTIONS(6756), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [174059] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4871), 1,
      sym_heredoc_body,
    ACTIONS(745), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [174081] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4872), 1,
      sym_heredoc_body,
    ACTIONS(2618), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [174103] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4873), 1,
      sym_heredoc_body,
    ACTIONS(2622), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [174125] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4874), 1,
      sym_heredoc_body,
    ACTIONS(2646), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [174147] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6809), 1,
      anon_sym_LBRACE,
    STATE(4769), 1,
      sym_block,
    STATE(4770), 1,
      sym_do_block,
    STATE(4875), 1,
      sym_heredoc_body,
    ACTIONS(6513), 7,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174175] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6809), 1,
      anon_sym_LBRACE,
    STATE(4833), 1,
      sym_block,
    STATE(4835), 1,
      sym_do_block,
    STATE(4876), 1,
      sym_heredoc_body,
    ACTIONS(6529), 7,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174203] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7129), 1,
      anon_sym_rescue,
    ACTIONS(7131), 1,
      anon_sym_if,
    ACTIONS(7133), 1,
      anon_sym_unless,
    ACTIONS(7135), 1,
      anon_sym_while,
    ACTIONS(7137), 1,
      anon_sym_until,
    ACTIONS(7162), 1,
      anon_sym_do,
    STATE(354), 1,
      sym__terminator,
    STATE(3035), 1,
      sym_do,
    STATE(4877), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [174241] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4878), 1,
      sym_heredoc_body,
    ACTIONS(7141), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6823), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [174265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(6877), 1,
      anon_sym_EQ2,
    STATE(4879), 1,
      sym_heredoc_body,
    ACTIONS(4927), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(4929), 7,
      sym__line_break,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      sym_identifier,
  [174291] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7129), 1,
      anon_sym_rescue,
    ACTIONS(7131), 1,
      anon_sym_if,
    ACTIONS(7133), 1,
      anon_sym_unless,
    ACTIONS(7135), 1,
      anon_sym_while,
    ACTIONS(7137), 1,
      anon_sym_until,
    ACTIONS(7162), 1,
      anon_sym_do,
    STATE(354), 1,
      sym__terminator,
    STATE(3031), 1,
      sym_do,
    STATE(4880), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [174329] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4881), 1,
      sym_heredoc_body,
    ACTIONS(7141), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6891), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [174353] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4882), 1,
      sym_heredoc_body,
    ACTIONS(2634), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [174375] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7166), 1,
      aux_sym_string_array_token1,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7172), 1,
      sym__string_end,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    STATE(4883), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5535), 1,
      aux_sym_symbol_array_repeat1,
  [174412] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4884), 1,
      sym_heredoc_body,
    ACTIONS(6659), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174433] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7176), 1,
      anon_sym_end,
    STATE(4885), 1,
      sym_heredoc_body,
    STATE(5215), 1,
      aux_sym_case_match_repeat1,
    STATE(5258), 1,
      aux_sym_case_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5557), 1,
      sym_when,
    STATE(5744), 1,
      sym_else,
  [174470] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7178), 1,
      aux_sym_string_array_token1,
    ACTIONS(7180), 1,
      sym__string_end,
    STATE(4886), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5499), 1,
      aux_sym_symbol_array_repeat1,
  [174507] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7182), 1,
      aux_sym_string_array_token1,
    ACTIONS(7184), 1,
      sym__string_end,
    STATE(4887), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5498), 1,
      aux_sym_string_array_repeat1,
  [174544] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7186), 1,
      aux_sym_string_array_token1,
    ACTIONS(7188), 1,
      sym__string_end,
    STATE(4888), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5568), 1,
      aux_sym_symbol_array_repeat1,
  [174581] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7190), 1,
      anon_sym_COMMA,
    STATE(4889), 1,
      sym_heredoc_body,
    STATE(4908), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6752), 7,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [174606] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7192), 1,
      aux_sym_string_array_token1,
    ACTIONS(7194), 1,
      sym__string_end,
    STATE(4890), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5513), 1,
      aux_sym_string_array_repeat1,
  [174643] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7196), 1,
      aux_sym_string_array_token1,
    ACTIONS(7198), 1,
      sym__string_end,
    STATE(4891), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5500), 1,
      aux_sym_string_array_repeat1,
  [174680] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7200), 1,
      aux_sym_string_array_token1,
    ACTIONS(7202), 1,
      sym__string_end,
    STATE(4892), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5511), 1,
      aux_sym_symbol_array_repeat1,
  [174717] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7204), 1,
      anon_sym_end,
    STATE(4893), 1,
      sym_heredoc_body,
    STATE(5251), 1,
      aux_sym_case_repeat1,
    STATE(5252), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5557), 1,
      sym_when,
    STATE(5969), 1,
      sym_else,
  [174754] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7206), 1,
      anon_sym_rescue,
    STATE(4894), 1,
      sym_heredoc_body,
    ACTIONS(6683), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [174777] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7208), 1,
      anon_sym_end,
    STATE(4895), 1,
      sym_heredoc_body,
    STATE(5282), 1,
      aux_sym_case_match_repeat1,
    STATE(5288), 1,
      aux_sym_case_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5557), 1,
      sym_when,
    STATE(5698), 1,
      sym_else,
  [174814] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7210), 1,
      anon_sym_COMMA,
    STATE(4896), 2,
      sym_heredoc_body,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6597), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174837] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7213), 1,
      anon_sym_COMMA,
    STATE(4897), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6724), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174860] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7216), 1,
      anon_sym_COMMA,
    STATE(4898), 1,
      sym_heredoc_body,
    STATE(4918), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6756), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174885] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    STATE(4899), 1,
      sym_heredoc_body,
    STATE(4900), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6744), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174910] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    STATE(4896), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4900), 1,
      sym_heredoc_body,
    ACTIONS(6750), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174935] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7145), 1,
      anon_sym_EQ_GT,
    ACTIONS(7220), 1,
      anon_sym_COMMA,
    STATE(4901), 1,
      sym_heredoc_body,
    ACTIONS(6667), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174960] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7206), 1,
      anon_sym_rescue,
    STATE(4902), 1,
      sym_heredoc_body,
    ACTIONS(6720), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [174983] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7222), 1,
      aux_sym_string_array_token1,
    ACTIONS(7224), 1,
      sym__string_end,
    STATE(4903), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5570), 1,
      aux_sym_symbol_array_repeat1,
  [175020] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4904), 1,
      sym_heredoc_body,
    ACTIONS(6663), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175041] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7226), 1,
      aux_sym_string_array_token1,
    ACTIONS(7228), 1,
      sym__string_end,
    STATE(4905), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5495), 1,
      aux_sym_string_array_repeat1,
  [175078] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7230), 1,
      aux_sym_string_array_token1,
    ACTIONS(7232), 1,
      sym__string_end,
    STATE(4906), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5556), 1,
      aux_sym_symbol_array_repeat1,
  [175115] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7234), 1,
      aux_sym_string_array_token1,
    ACTIONS(7236), 1,
      sym__string_end,
    STATE(4907), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5519), 1,
      aux_sym_symbol_array_repeat1,
  [175152] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7238), 1,
      anon_sym_COMMA,
    STATE(4908), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6724), 7,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [175175] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7241), 1,
      aux_sym_string_array_token1,
    ACTIONS(7243), 1,
      sym__string_end,
    STATE(4909), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5548), 1,
      aux_sym_string_array_repeat1,
  [175212] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7245), 1,
      aux_sym_string_array_token1,
    ACTIONS(7247), 1,
      sym__string_end,
    STATE(4910), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5523), 1,
      aux_sym_string_array_repeat1,
  [175249] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4911), 1,
      sym_heredoc_body,
    ACTIONS(6679), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175270] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7249), 1,
      aux_sym_string_array_token1,
    ACTIONS(7251), 1,
      sym__string_end,
    STATE(4912), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5504), 1,
      aux_sym_symbol_array_repeat1,
  [175307] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7253), 1,
      aux_sym_string_array_token1,
    ACTIONS(7255), 1,
      sym__string_end,
    STATE(4913), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5569), 1,
      aux_sym_string_array_repeat1,
  [175344] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4914), 1,
      sym_heredoc_body,
    ACTIONS(6704), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175365] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7257), 1,
      aux_sym_string_array_token1,
    ACTIONS(7259), 1,
      sym__string_end,
    STATE(4915), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5565), 1,
      aux_sym_string_array_repeat1,
  [175402] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7261), 1,
      aux_sym_string_array_token1,
    ACTIONS(7263), 1,
      sym__string_end,
    STATE(4916), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5574), 1,
      aux_sym_symbol_array_repeat1,
  [175439] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4917), 1,
      sym_heredoc_body,
    ACTIONS(6700), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175460] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7216), 1,
      anon_sym_COMMA,
    STATE(4897), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4918), 1,
      sym_heredoc_body,
    ACTIONS(6752), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175485] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7265), 1,
      anon_sym_COMMA,
    STATE(4919), 2,
      sym_heredoc_body,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6659), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175508] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4920), 1,
      sym_heredoc_body,
    ACTIONS(6728), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175529] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7268), 1,
      aux_sym_string_array_token1,
    ACTIONS(7270), 1,
      sym__string_end,
    STATE(4921), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5534), 1,
      aux_sym_string_array_repeat1,
  [175566] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7190), 1,
      anon_sym_COMMA,
    STATE(4889), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4922), 1,
      sym_heredoc_body,
    ACTIONS(6756), 7,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [175591] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7272), 1,
      aux_sym_string_array_token1,
    ACTIONS(7274), 1,
      sym__string_end,
    STATE(4923), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5508), 1,
      aux_sym_string_array_repeat1,
  [175628] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7276), 1,
      aux_sym_string_array_token1,
    ACTIONS(7278), 1,
      sym__string_end,
    STATE(4924), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5530), 1,
      aux_sym_symbol_array_repeat1,
  [175665] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7280), 1,
      anon_sym_COMMA,
    STATE(4925), 1,
      sym_heredoc_body,
    STATE(4934), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6728), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175690] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7282), 1,
      anon_sym_COMMA,
    STATE(4896), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4926), 1,
      sym_heredoc_body,
    ACTIONS(6750), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175715] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7284), 1,
      anon_sym_COMMA,
    STATE(4919), 1,
      aux_sym__hash_pattern_body_repeat1,
    STATE(4927), 1,
      sym_heredoc_body,
    ACTIONS(5593), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175740] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7286), 1,
      anon_sym_end,
    STATE(4928), 1,
      sym_heredoc_body,
    STATE(5245), 1,
      aux_sym_case_repeat1,
    STATE(5248), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5557), 1,
      sym_when,
    STATE(5776), 1,
      sym_else,
  [175777] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7288), 1,
      anon_sym_COMMA,
    STATE(4929), 2,
      sym_heredoc_body,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6659), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175800] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4930), 1,
      sym_heredoc_body,
    ACTIONS(5636), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175821] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7291), 1,
      anon_sym_COMMA,
    STATE(4927), 1,
      aux_sym__hash_pattern_body_repeat1,
    STATE(4931), 1,
      sym_heredoc_body,
    ACTIONS(6728), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175846] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7293), 1,
      anon_sym_end,
    STATE(4932), 1,
      sym_heredoc_body,
    STATE(5216), 1,
      aux_sym_case_match_repeat1,
    STATE(5264), 1,
      aux_sym_case_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5557), 1,
      sym_when,
    STATE(5778), 1,
      sym_else,
  [175883] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7145), 1,
      anon_sym_EQ_GT,
    STATE(4933), 1,
      sym_heredoc_body,
    ACTIONS(6597), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175906] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7295), 1,
      anon_sym_COMMA,
    STATE(4929), 1,
      aux_sym__hash_pattern_body_repeat1,
    STATE(4934), 1,
      sym_heredoc_body,
    ACTIONS(5593), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175931] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7297), 1,
      anon_sym_end,
    STATE(4935), 1,
      sym_heredoc_body,
    STATE(5219), 1,
      aux_sym_case_repeat1,
    STATE(5222), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5557), 1,
      sym_when,
    STATE(5803), 1,
      sym_else,
  [175968] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    STATE(4926), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4936), 1,
      sym_heredoc_body,
    ACTIONS(6744), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175993] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7145), 1,
      anon_sym_EQ_GT,
    ACTIONS(7220), 1,
      anon_sym_COMMA,
    STATE(4937), 1,
      sym_heredoc_body,
    ACTIONS(6760), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176018] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7299), 1,
      aux_sym_string_array_token1,
    ACTIONS(7301), 1,
      sym__string_end,
    STATE(4910), 1,
      aux_sym__literal_contents,
    STATE(4938), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [176052] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4939), 1,
      sym_heredoc_body,
    ACTIONS(6716), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176072] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4940), 1,
      sym_heredoc_body,
    ACTIONS(3104), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(7303), 4,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
  [176094] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7305), 1,
      anon_sym_COMMA,
    STATE(4941), 1,
      sym_heredoc_body,
    STATE(4954), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6750), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4942), 1,
      sym_heredoc_body,
    ACTIONS(3070), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176138] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4943), 1,
      sym_heredoc_body,
    ACTIONS(6627), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4944), 1,
      sym_heredoc_body,
    ACTIONS(2998), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176178] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4945), 1,
      sym_heredoc_body,
    ACTIONS(6627), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4946), 1,
      sym_heredoc_body,
    ACTIONS(3074), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176218] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4947), 1,
      sym_heredoc_body,
    ACTIONS(6720), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176238] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4948), 1,
      sym_heredoc_body,
    ACTIONS(6627), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176258] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4949), 1,
      sym_heredoc_body,
    ACTIONS(6691), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176278] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4950), 1,
      sym_heredoc_body,
    ACTIONS(6683), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176298] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_rescue,
    STATE(4951), 1,
      sym_heredoc_body,
    ACTIONS(6683), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176320] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4952), 1,
      sym_heredoc_body,
    ACTIONS(6635), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176340] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_rescue,
    STATE(4953), 1,
      sym_heredoc_body,
    ACTIONS(6720), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176362] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7309), 1,
      anon_sym_COMMA,
    STATE(4954), 2,
      sym_heredoc_body,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6597), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176384] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7312), 1,
      anon_sym_COMMA,
    STATE(4955), 1,
      sym_heredoc_body,
    STATE(4969), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6744), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176408] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4956), 1,
      sym_heredoc_body,
    ACTIONS(6667), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176428] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7314), 1,
      aux_sym_string_array_token1,
    ACTIONS(7316), 1,
      sym__string_end,
    STATE(4890), 1,
      aux_sym__literal_contents,
    STATE(4957), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [176462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4958), 1,
      sym_heredoc_body,
    ACTIONS(3042), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176482] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7318), 1,
      aux_sym_string_array_token1,
    ACTIONS(7320), 1,
      sym__string_end,
    STATE(4883), 1,
      aux_sym__literal_contents,
    STATE(4959), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [176516] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7322), 1,
      aux_sym_string_array_token1,
    ACTIONS(7324), 1,
      sym__string_end,
    STATE(4907), 1,
      aux_sym__literal_contents,
    STATE(4960), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [176550] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7326), 1,
      aux_sym_string_array_token1,
    ACTIONS(7328), 1,
      sym__string_end,
    STATE(4913), 1,
      aux_sym__literal_contents,
    STATE(4961), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [176584] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(7330), 1,
      anon_sym_in,
    STATE(4962), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    STATE(5311), 1,
      sym_in,
    ACTIONS(3104), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176612] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7145), 1,
      anon_sym_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_COMMA,
    STATE(4963), 1,
      sym_heredoc_body,
    ACTIONS(6667), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4964), 1,
      sym_heredoc_body,
    ACTIONS(3014), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176656] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7334), 1,
      anon_sym_COMMA,
    STATE(4965), 1,
      sym_heredoc_body,
    STATE(5020), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6752), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176680] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7336), 1,
      anon_sym_rescue,
    STATE(4966), 1,
      sym_heredoc_body,
    ACTIONS(6683), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176702] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7336), 1,
      anon_sym_rescue,
    STATE(4967), 1,
      sym_heredoc_body,
    ACTIONS(6720), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4968), 1,
      sym_heredoc_body,
    ACTIONS(3034), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176744] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7312), 1,
      anon_sym_COMMA,
    STATE(4954), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4969), 1,
      sym_heredoc_body,
    ACTIONS(6750), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176768] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4970), 1,
      sym_heredoc_body,
    ACTIONS(3002), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4971), 1,
      sym_heredoc_body,
    ACTIONS(3046), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4972), 1,
      sym_heredoc_body,
    ACTIONS(3018), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176828] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4973), 1,
      sym_heredoc_body,
    ACTIONS(3062), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176848] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4974), 1,
      sym_heredoc_body,
    ACTIONS(3104), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(7338), 4,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
  [176870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4975), 1,
      sym_heredoc_body,
    ACTIONS(3058), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4976), 1,
      sym_heredoc_body,
    ACTIONS(3054), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176910] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4977), 1,
      sym_heredoc_body,
    ACTIONS(6615), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4978), 1,
      sym_heredoc_body,
    ACTIONS(3050), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176950] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4979), 1,
      sym_heredoc_body,
    ACTIONS(6647), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176970] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4980), 1,
      sym_heredoc_body,
    ACTIONS(3026), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4981), 1,
      sym_heredoc_body,
    ACTIONS(3030), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177010] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7340), 1,
      aux_sym_string_array_token1,
    ACTIONS(7342), 1,
      sym__string_end,
    STATE(4924), 1,
      aux_sym__literal_contents,
    STATE(4982), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [177044] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7145), 1,
      anon_sym_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_COMMA,
    STATE(4983), 1,
      sym_heredoc_body,
    ACTIONS(6760), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177068] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4984), 1,
      sym_heredoc_body,
    ACTIONS(6712), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177088] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4985), 1,
      sym_heredoc_body,
    ACTIONS(6708), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4986), 1,
      sym_heredoc_body,
    ACTIONS(123), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4987), 1,
      sym_heredoc_body,
    ACTIONS(3066), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177148] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7344), 1,
      aux_sym_string_array_token1,
    ACTIONS(7346), 1,
      sym__string_end,
    STATE(4909), 1,
      aux_sym__literal_contents,
    STATE(4988), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [177182] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7312), 1,
      anon_sym_COMMA,
    STATE(4941), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4989), 1,
      sym_heredoc_body,
    ACTIONS(6744), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177206] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7348), 1,
      aux_sym_string_array_token1,
    ACTIONS(7350), 1,
      sym__string_end,
    STATE(4923), 1,
      aux_sym__literal_contents,
    STATE(4990), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [177240] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7352), 1,
      aux_sym_string_array_token1,
    ACTIONS(7354), 1,
      sym__string_end,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(4991), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [177274] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7356), 1,
      aux_sym_string_array_token1,
    ACTIONS(7358), 1,
      sym__string_end,
    STATE(4916), 1,
      aux_sym__literal_contents,
    STATE(4992), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [177308] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7360), 1,
      anon_sym_end,
    ACTIONS(7362), 1,
      anon_sym_rescue,
    ACTIONS(7364), 1,
      anon_sym_ensure,
    STATE(4993), 1,
      sym_heredoc_body,
    STATE(5014), 1,
      aux_sym__body_statement_repeat1,
    STATE(5412), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [177338] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7366), 1,
      aux_sym_string_array_token1,
    ACTIONS(7368), 1,
      sym__string_end,
    STATE(4915), 1,
      aux_sym__literal_contents,
    STATE(4994), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [177372] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4995), 1,
      sym_heredoc_body,
    ACTIONS(6724), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177392] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7370), 1,
      aux_sym_string_array_token1,
    ACTIONS(7372), 1,
      sym__string_end,
    STATE(4891), 1,
      aux_sym__literal_contents,
    STATE(4996), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [177426] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    STATE(2143), 1,
      sym__terminator,
    STATE(4997), 1,
      sym_heredoc_body,
    ACTIONS(7089), 2,
      sym__line_break,
      anon_sym_SEMI,
  [177458] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7374), 1,
      aux_sym_string_array_token1,
    ACTIONS(7376), 1,
      sym__string_end,
    STATE(4998), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
  [177492] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7360), 1,
      anon_sym_end,
    ACTIONS(7362), 1,
      anon_sym_rescue,
    ACTIONS(7364), 1,
      anon_sym_ensure,
    STATE(4999), 1,
      sym_heredoc_body,
    STATE(5011), 1,
      aux_sym__body_statement_repeat1,
    STATE(5412), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [177522] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7378), 1,
      aux_sym_string_array_token1,
    ACTIONS(7380), 1,
      sym__string_end,
    STATE(5000), 1,
      sym_heredoc_body,
    STATE(5034), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_interpolation,
  [177556] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7382), 1,
      aux_sym_string_array_token1,
    ACTIONS(7384), 1,
      sym__string_end,
    STATE(4906), 1,
      aux_sym__literal_contents,
    STATE(5001), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [177590] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5002), 1,
      sym_heredoc_body,
    ACTIONS(6643), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177610] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7386), 1,
      aux_sym_string_array_token1,
    ACTIONS(7388), 1,
      sym__string_end,
    STATE(4886), 1,
      aux_sym__literal_contents,
    STATE(5003), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [177644] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7390), 1,
      aux_sym_string_array_token1,
    ACTIONS(7392), 1,
      sym__string_end,
    STATE(4905), 1,
      aux_sym__literal_contents,
    STATE(5004), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [177678] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7394), 1,
      aux_sym_string_array_token1,
    ACTIONS(7396), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(5005), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [177712] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5006), 1,
      sym_heredoc_body,
    ACTIONS(6651), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177732] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7398), 1,
      anon_sym_COMMA,
    STATE(5007), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6724), 6,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [177754] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7401), 1,
      anon_sym_COMMA,
    STATE(5007), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(5008), 1,
      sym_heredoc_body,
    ACTIONS(6752), 6,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [177778] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5009), 1,
      sym_heredoc_body,
    ACTIONS(6623), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5010), 1,
      sym_heredoc_body,
    ACTIONS(3022), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177818] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7403), 1,
      anon_sym_end,
    ACTIONS(7405), 1,
      anon_sym_rescue,
    ACTIONS(7408), 1,
      anon_sym_else,
    ACTIONS(7411), 1,
      anon_sym_ensure,
    STATE(5011), 2,
      sym_heredoc_body,
      aux_sym__body_statement_repeat1,
    STATE(5412), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [177846] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7401), 1,
      anon_sym_COMMA,
    STATE(5008), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(5012), 1,
      sym_heredoc_body,
    ACTIONS(6756), 6,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [177870] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(7330), 1,
      anon_sym_in,
    STATE(5013), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    STATE(5324), 1,
      sym_in,
    ACTIONS(3104), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177898] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7362), 1,
      anon_sym_rescue,
    ACTIONS(7364), 1,
      anon_sym_ensure,
    ACTIONS(7414), 1,
      anon_sym_end,
    STATE(5011), 1,
      aux_sym__body_statement_repeat1,
    STATE(5014), 1,
      sym_heredoc_body,
    STATE(5412), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [177928] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(7008), 1,
      anon_sym_do,
    STATE(5015), 1,
      sym_heredoc_body,
    STATE(5327), 1,
      sym_block,
    STATE(5361), 1,
      sym_do_block,
    ACTIONS(3307), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177956] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5016), 1,
      sym_heredoc_body,
    ACTIONS(6619), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177976] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5017), 1,
      sym_heredoc_body,
    ACTIONS(2966), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177996] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5018), 1,
      sym_heredoc_body,
    ACTIONS(6631), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178016] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5019), 1,
      sym_heredoc_body,
    ACTIONS(6623), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178036] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7416), 1,
      anon_sym_COMMA,
    STATE(5020), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6724), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178058] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5021), 1,
      sym_heredoc_body,
    ACTIONS(6675), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5022), 1,
      sym_heredoc_body,
    ACTIONS(3006), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5023), 1,
      sym_heredoc_body,
    ACTIONS(3010), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178118] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    ACTIONS(7330), 1,
      anon_sym_in,
    STATE(5024), 1,
      sym_heredoc_body,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    STATE(5321), 1,
      sym_in,
    ACTIONS(3104), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178146] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7419), 1,
      aux_sym_string_array_token1,
    ACTIONS(7421), 1,
      sym__string_end,
    STATE(4888), 1,
      aux_sym__literal_contents,
    STATE(5025), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [178180] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7334), 1,
      anon_sym_COMMA,
    STATE(4965), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(5026), 1,
      sym_heredoc_body,
    ACTIONS(6756), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178204] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7423), 1,
      aux_sym_string_array_token1,
    ACTIONS(7425), 1,
      sym__string_end,
    STATE(4887), 1,
      aux_sym__literal_contents,
    STATE(5027), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [178238] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5028), 1,
      sym_heredoc_body,
    ACTIONS(6627), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178258] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7427), 1,
      aux_sym_string_array_token1,
    ACTIONS(7429), 1,
      sym__string_end,
    STATE(4892), 1,
      aux_sym__literal_contents,
    STATE(5029), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [178292] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_rescue,
    ACTIONS(6932), 1,
      anon_sym_if,
    ACTIONS(6934), 1,
      anon_sym_unless,
    ACTIONS(6936), 1,
      anon_sym_while,
    ACTIONS(6938), 1,
      anon_sym_until,
    STATE(2054), 1,
      sym__terminator,
    STATE(5030), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [178324] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7168), 1,
      sym_escape_sequence,
    ACTIONS(7170), 1,
      sym_string_content,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7431), 1,
      aux_sym_string_array_token1,
    ACTIONS(7433), 1,
      sym__string_end,
    STATE(4912), 1,
      aux_sym__literal_contents,
    STATE(5031), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
  [178358] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5032), 1,
      sym_heredoc_body,
    ACTIONS(6529), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178378] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5033), 1,
      sym_heredoc_body,
    ACTIONS(4395), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178398] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7435), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7438), 1,
      aux_sym_string_array_token1,
    ACTIONS(7440), 1,
      sym_escape_sequence,
    ACTIONS(7443), 1,
      sym_string_content,
    ACTIONS(7446), 1,
      sym__string_end,
    ACTIONS(7448), 1,
      sym__short_interpolation,
    STATE(5263), 1,
      sym_interpolation,
    STATE(5034), 2,
      sym_heredoc_body,
      aux_sym__literal_contents,
  [178430] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(7008), 1,
      anon_sym_do,
    STATE(5035), 1,
      sym_heredoc_body,
    STATE(5376), 1,
      sym_block,
    STATE(5383), 1,
      sym_do_block,
    ACTIONS(3313), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178458] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(7008), 1,
      anon_sym_do,
    STATE(5036), 1,
      sym_heredoc_body,
    STATE(5384), 1,
      sym_block,
    STATE(5386), 1,
      sym_do_block,
    ACTIONS(3303), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178486] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7455), 1,
      sym__string_end,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    STATE(5037), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [178515] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7459), 1,
      sym__string_end,
    STATE(5038), 1,
      sym_heredoc_body,
    STATE(5135), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [178544] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5039), 1,
      sym_heredoc_body,
    ACTIONS(3054), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178563] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5040), 1,
      sym_heredoc_body,
    ACTIONS(3058), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178582] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7461), 1,
      sym_identifier,
    ACTIONS(7465), 1,
      anon_sym_do,
    STATE(5041), 1,
      sym_heredoc_body,
    ACTIONS(7463), 5,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
  [178605] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5042), 1,
      sym_heredoc_body,
    ACTIONS(3018), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178624] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5043), 1,
      sym_heredoc_body,
    ACTIONS(3014), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178643] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym__pow,
    STATE(3353), 1,
      sym__simple_numeric,
    STATE(5044), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(257), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [178670] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7467), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5045), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [178699] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3323), 1,
      sym__simple_numeric,
    STATE(3467), 1,
      sym__pow,
    STATE(5046), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(325), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [178726] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7469), 1,
      sym__string_end,
    STATE(5047), 1,
      sym_heredoc_body,
    STATE(5057), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [178755] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5048), 1,
      sym_heredoc_body,
    ACTIONS(3062), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178774] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7471), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5049), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [178803] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7473), 1,
      sym__string_end,
    STATE(5050), 1,
      sym_heredoc_body,
    STATE(5058), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [178832] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7475), 1,
      sym__string_end,
    STATE(5051), 1,
      sym_heredoc_body,
    STATE(5059), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [178861] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7477), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5052), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [178890] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7479), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5053), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [178919] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3034), 1,
      sym__pow,
    STATE(3741), 1,
      sym__simple_numeric,
    STATE(5054), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(325), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [178946] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7481), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5055), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [178975] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7483), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5056), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [179004] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7485), 1,
      sym__string_end,
    STATE(5057), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [179033] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7487), 1,
      sym__string_end,
    STATE(5058), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [179062] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7489), 1,
      sym__string_end,
    STATE(5059), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [179091] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2722), 1,
      sym__string_start,
    STATE(5060), 1,
      sym_heredoc_body,
    STATE(5105), 1,
      aux_sym_chained_string_repeat1,
    STATE(5309), 1,
      sym_string,
    ACTIONS(3256), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [179116] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7491), 1,
      sym__string_end,
    STATE(5061), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [179145] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7493), 1,
      sym__string_end,
    STATE(5062), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [179174] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5063), 1,
      sym_heredoc_body,
    ACTIONS(3006), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [179193] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5064), 1,
      sym_heredoc_body,
    ACTIONS(3074), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [179212] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7495), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5065), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [179241] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5066), 1,
      sym_heredoc_body,
    ACTIONS(2998), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [179260] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5067), 1,
      sym_heredoc_body,
    ACTIONS(3070), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [179279] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym__pow,
    STATE(3707), 1,
      sym__simple_numeric,
    STATE(5068), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(257), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [179306] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3034), 1,
      sym__pow,
    STATE(3455), 1,
      sym__simple_numeric,
    STATE(5069), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(397), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [179333] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7497), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5070), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [179362] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7499), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5071), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [179391] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7501), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5072), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [179420] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7503), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5073), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [179449] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7505), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5074), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [179478] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5075), 1,
      sym_heredoc_body,
    ACTIONS(3066), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [179497] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2533), 1,
      sym__pow,
    STATE(3732), 1,
      sym__simple_numeric,
    STATE(5076), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(257), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [179524] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5077), 1,
      sym_heredoc_body,
    ACTIONS(3042), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [179543] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3467), 1,
      sym__pow,
    STATE(3995), 1,
      sym__simple_numeric,
    STATE(5078), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(397), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [179570] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5079), 1,
      sym_heredoc_body,
    ACTIONS(2966), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [179589] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7143), 1,
      anon_sym_then,
    ACTIONS(7507), 1,
      anon_sym_COMMA,
    STATE(304), 1,
      sym__terminator,
    STATE(5080), 1,
      sym_heredoc_body,
    STATE(5088), 1,
      aux_sym_when_repeat1,
    STATE(5573), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [179618] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5081), 1,
      sym_heredoc_body,
    ACTIONS(7509), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
    ACTIONS(3104), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [179639] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7511), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5082), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [179668] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3467), 1,
      sym__pow,
    STATE(3934), 1,
      sym__simple_numeric,
    STATE(5083), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(325), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [179695] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7513), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5084), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [179724] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7515), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5085), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [179753] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym__pow,
    STATE(3784), 1,
      sym__simple_numeric,
    STATE(5086), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(257), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [179780] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7517), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5087), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [179809] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7143), 1,
      anon_sym_then,
    ACTIONS(7507), 1,
      anon_sym_COMMA,
    STATE(296), 1,
      sym__terminator,
    STATE(5088), 1,
      sym_heredoc_body,
    STATE(5314), 1,
      aux_sym_when_repeat1,
    STATE(5522), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [179838] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3454), 1,
      sym__simple_numeric,
    STATE(3467), 1,
      sym__pow,
    STATE(5089), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(397), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [179865] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_EQ_GT,
    ACTIONS(7143), 1,
      anon_sym_then,
    STATE(279), 1,
      sym__terminator,
    STATE(5090), 1,
      sym_heredoc_body,
    STATE(5293), 1,
      sym_exception_variable,
    STATE(5492), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [179894] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7519), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5091), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [179923] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5092), 1,
      sym_heredoc_body,
    ACTIONS(3034), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [179942] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7521), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5093), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [179971] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7523), 1,
      anon_sym_COMMA,
    STATE(5094), 1,
      sym_heredoc_body,
    STATE(5190), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6752), 5,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [179994] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2533), 1,
      sym__pow,
    STATE(2817), 1,
      sym__simple_numeric,
    STATE(5095), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [180021] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7525), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5096), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [180050] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym__pow,
    STATE(2642), 1,
      sym__simple_numeric,
    STATE(5097), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [180077] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7527), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7531), 1,
      sym_heredoc_end,
    ACTIONS(7533), 1,
      sym__short_interpolation,
    STATE(5098), 1,
      sym_heredoc_body,
    STATE(5208), 1,
      aux_sym_heredoc_body_repeat1,
    STATE(5305), 1,
      sym_interpolation,
    ACTIONS(7529), 2,
      sym_heredoc_content,
      sym_escape_sequence,
  [180106] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7535), 1,
      sym__string_end,
    STATE(5099), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [180135] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2533), 1,
      sym__pow,
    STATE(3265), 1,
      sym__simple_numeric,
    STATE(5100), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(257), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [180162] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3034), 1,
      sym__pow,
    STATE(3822), 1,
      sym__simple_numeric,
    STATE(5101), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(325), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [180189] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5102), 1,
      sym_heredoc_body,
    ACTIONS(7537), 7,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [180208] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym__pow,
    STATE(2804), 1,
      sym__simple_numeric,
    STATE(5103), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [180235] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2533), 1,
      sym__pow,
    STATE(3823), 1,
      sym__simple_numeric,
    STATE(5104), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(257), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [180262] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7539), 1,
      sym__string_start,
    STATE(5309), 1,
      sym_string,
    STATE(5105), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(3264), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [180285] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7542), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5106), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [180314] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7544), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5107), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [180343] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5108), 1,
      sym_heredoc_body,
    ACTIONS(3002), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [180362] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7546), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5109), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [180391] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7548), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5110), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [180420] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3034), 1,
      sym__pow,
    STATE(3437), 1,
      sym__simple_numeric,
    STATE(5111), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(397), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [180447] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2533), 1,
      sym__pow,
    STATE(3148), 1,
      sym__simple_numeric,
    STATE(5112), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [180474] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7550), 1,
      anon_sym_COMMA,
    STATE(5113), 1,
      sym_heredoc_body,
    STATE(5165), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6752), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [180497] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7552), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5114), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [180526] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7554), 1,
      sym__string_end,
    STATE(5115), 1,
      sym_heredoc_body,
    STATE(5130), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [180555] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7556), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5116), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [180584] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7558), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5117), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [180613] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym__pow,
    STATE(3147), 1,
      sym__simple_numeric,
    STATE(5118), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [180640] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7560), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5119), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [180669] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7562), 1,
      sym__string_end,
    STATE(5120), 1,
      sym_heredoc_body,
    STATE(5133), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [180698] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3385), 1,
      sym__simple_numeric,
    STATE(3467), 1,
      sym__pow,
    STATE(5121), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(397), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [180725] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3467), 1,
      sym__pow,
    STATE(3676), 1,
      sym__simple_numeric,
    STATE(5122), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(325), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [180752] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3034), 1,
      sym__pow,
    STATE(4022), 1,
      sym__simple_numeric,
    STATE(5123), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(397), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [180779] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7564), 1,
      sym__string_end,
    STATE(5124), 1,
      sym_heredoc_body,
    STATE(5134), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [180808] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3467), 1,
      sym__pow,
    STATE(3971), 1,
      sym__simple_numeric,
    STATE(5125), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(397), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [180835] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7566), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5126), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [180864] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2533), 1,
      sym__pow,
    STATE(2719), 1,
      sym__simple_numeric,
    STATE(5127), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [180891] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7568), 1,
      sym__string_end,
    STATE(5128), 1,
      sym_heredoc_body,
    STATE(5136), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [180920] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7570), 1,
      sym__string_end,
    STATE(5129), 1,
      sym_heredoc_body,
    STATE(5137), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [180949] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7572), 1,
      sym__string_end,
    STATE(5130), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [180978] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7574), 1,
      sym__string_end,
    STATE(5062), 1,
      aux_sym__literal_contents,
    STATE(5131), 1,
      sym_heredoc_body,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [181007] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2533), 1,
      sym__pow,
    STATE(3584), 1,
      sym__simple_numeric,
    STATE(5132), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(257), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [181034] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7576), 1,
      sym__string_end,
    STATE(5133), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [181063] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7578), 1,
      sym__string_end,
    STATE(5134), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [181092] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7580), 1,
      sym__string_end,
    STATE(5135), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [181121] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7582), 1,
      sym__string_end,
    STATE(5136), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [181150] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7584), 1,
      sym__string_end,
    STATE(5137), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [181179] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym__pow,
    STATE(2734), 1,
      sym__simple_numeric,
    STATE(5138), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [181206] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3034), 1,
      sym__pow,
    STATE(3892), 1,
      sym__simple_numeric,
    STATE(5139), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(397), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [181233] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2533), 1,
      sym__pow,
    STATE(2572), 1,
      sym__simple_numeric,
    STATE(5140), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [181260] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7586), 1,
      sym__string_end,
    STATE(5141), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [181289] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7588), 1,
      sym__string_end,
    STATE(5142), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [181318] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7590), 1,
      sym__string_end,
    STATE(5143), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [181347] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym__pow,
    STATE(2549), 1,
      sym__simple_numeric,
    STATE(5144), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [181374] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3252), 1,
      anon_sym_r,
    STATE(5145), 1,
      sym_heredoc_body,
    ACTIONS(3254), 2,
      anon_sym_i,
      anon_sym_ri,
    ACTIONS(3248), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181397] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2722), 1,
      sym__string_start,
    STATE(5060), 1,
      aux_sym_chained_string_repeat1,
    STATE(5146), 1,
      sym_heredoc_body,
    STATE(5309), 1,
      sym_string,
    ACTIONS(3104), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181422] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7550), 1,
      anon_sym_COMMA,
    STATE(5113), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(5147), 1,
      sym_heredoc_body,
    ACTIONS(6756), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [181445] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7592), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5148), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [181474] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym__pow,
    STATE(3542), 1,
      sym__simple_numeric,
    STATE(5149), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(257), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [181501] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2498), 1,
      sym__simple_numeric,
    STATE(2533), 1,
      sym__pow,
    STATE(5150), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [181528] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7594), 1,
      sym__string_end,
    STATE(5151), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [181557] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym__pow,
    STATE(2509), 1,
      sym__simple_numeric,
    STATE(5152), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [181584] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7596), 1,
      sym__string_end,
    STATE(5153), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [181613] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7598), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5154), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [181642] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5155), 1,
      sym_heredoc_body,
    ACTIONS(123), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181661] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2533), 1,
      sym__pow,
    STATE(2978), 1,
      sym__simple_numeric,
    STATE(5156), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [181688] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5157), 1,
      sym_heredoc_body,
    ACTIONS(3030), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181707] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3034), 1,
      sym__pow,
    STATE(3268), 1,
      sym__simple_numeric,
    STATE(5158), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(325), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [181734] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5159), 1,
      sym_heredoc_body,
    ACTIONS(3022), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181753] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7600), 1,
      sym__string_end,
    STATE(5160), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [181782] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7602), 1,
      sym__string_end,
    STATE(5161), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [181811] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7604), 1,
      sym__string_end,
    STATE(5162), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [181840] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7606), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5163), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [181869] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5164), 1,
      sym_heredoc_body,
    ACTIONS(7608), 7,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [181888] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7610), 1,
      anon_sym_COMMA,
    STATE(5165), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6724), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [181909] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym__pow,
    STATE(3019), 1,
      sym__simple_numeric,
    STATE(5166), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [181936] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7613), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5167), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [181965] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7615), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7621), 1,
      sym_heredoc_end,
    ACTIONS(7623), 1,
      sym__short_interpolation,
    STATE(5305), 1,
      sym_interpolation,
    ACTIONS(7618), 2,
      sym_heredoc_content,
      sym_escape_sequence,
    STATE(5168), 2,
      sym_heredoc_body,
      aux_sym_heredoc_body_repeat1,
  [181992] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7626), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5169), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [182021] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7628), 1,
      sym__string_end,
    STATE(5170), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [182050] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3467), 1,
      sym__pow,
    STATE(3834), 1,
      sym__simple_numeric,
    STATE(5171), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(397), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [182077] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2533), 1,
      sym__pow,
    STATE(3533), 1,
      sym__simple_numeric,
    STATE(5172), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(257), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [182104] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7630), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5173), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [182133] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym__pow,
    STATE(3548), 1,
      sym__simple_numeric,
    STATE(5174), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(257), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [182160] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3307), 1,
      sym__simple_numeric,
    STATE(3467), 1,
      sym__pow,
    STATE(5175), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(325), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [182187] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5176), 1,
      sym_heredoc_body,
    ACTIONS(3010), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [182206] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7632), 1,
      sym__string_end,
    STATE(5160), 1,
      aux_sym__literal_contents,
    STATE(5177), 1,
      sym_heredoc_body,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [182235] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7634), 1,
      sym__string_end,
    STATE(5037), 1,
      aux_sym__literal_contents,
    STATE(5178), 1,
      sym_heredoc_body,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [182264] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7636), 1,
      sym__string_end,
    STATE(5179), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [182293] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7638), 1,
      sym__string_end,
    STATE(5180), 1,
      sym_heredoc_body,
    STATE(5189), 1,
      aux_sym__literal_contents,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [182322] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7640), 1,
      sym__string_end,
    STATE(5161), 1,
      aux_sym__literal_contents,
    STATE(5181), 1,
      sym_heredoc_body,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [182351] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7642), 1,
      sym__string_end,
    STATE(5162), 1,
      aux_sym__literal_contents,
    STATE(5182), 1,
      sym_heredoc_body,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [182380] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2533), 1,
      sym__pow,
    STATE(2653), 1,
      sym__simple_numeric,
    STATE(5183), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [182407] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3467), 1,
      sym__pow,
    STATE(3810), 1,
      sym__simple_numeric,
    STATE(5184), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(325), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [182434] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7644), 1,
      sym__string_end,
    STATE(5170), 1,
      aux_sym__literal_contents,
    STATE(5185), 1,
      sym_heredoc_body,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [182463] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym__pow,
    STATE(2889), 1,
      sym__simple_numeric,
    STATE(5186), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [182490] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5187), 1,
      sym_heredoc_body,
    ACTIONS(3026), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [182509] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7646), 1,
      sym__string_end,
    STATE(5180), 1,
      aux_sym__literal_contents,
    STATE(5188), 1,
      sym_heredoc_body,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [182538] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7446), 1,
      sym__string_end,
    ACTIONS(7648), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7654), 1,
      sym__short_interpolation,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7651), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(5189), 2,
      sym_heredoc_body,
      aux_sym__literal_contents,
  [182565] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7657), 1,
      anon_sym_COMMA,
    STATE(5190), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6724), 5,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [182586] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7660), 1,
      sym__string_end,
    STATE(5061), 1,
      aux_sym__literal_contents,
    STATE(5191), 1,
      sym_heredoc_body,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [182615] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7662), 1,
      sym__string_end,
    STATE(5142), 1,
      aux_sym__literal_contents,
    STATE(5192), 1,
      sym_heredoc_body,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [182644] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7664), 1,
      sym__string_end,
    STATE(5179), 1,
      aux_sym__literal_contents,
    STATE(5193), 1,
      sym_heredoc_body,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [182673] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7666), 1,
      anon_sym_rescue,
    STATE(5194), 1,
      sym_heredoc_body,
    ACTIONS(6683), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [182694] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7666), 1,
      anon_sym_rescue,
    STATE(5195), 1,
      sym_heredoc_body,
    ACTIONS(6720), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [182715] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7668), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5196), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [182744] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7670), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5197), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [182773] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7672), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5198), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [182802] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7674), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5199), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [182831] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5200), 1,
      sym_heredoc_body,
    ACTIONS(3050), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [182850] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7676), 1,
      sym__string_end,
    STATE(5151), 1,
      aux_sym__literal_contents,
    STATE(5201), 1,
      sym_heredoc_body,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [182879] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7678), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5202), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [182908] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3140), 1,
      sym__simple_numeric,
    STATE(3467), 1,
      sym__pow,
    STATE(5203), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [182935] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    ACTIONS(7680), 1,
      sym__string_end,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5204), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [182964] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5205), 1,
      sym_heredoc_body,
    ACTIONS(3046), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [182983] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3034), 1,
      sym__pow,
    STATE(3369), 1,
      sym__simple_numeric,
    STATE(5206), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(325), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [183010] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2533), 1,
      sym__pow,
    STATE(2866), 1,
      sym__simple_numeric,
    STATE(5207), 1,
      sym_heredoc_body,
    STATE(5562), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2285), 2,
      sym_complex,
      sym_rational,
  [183037] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7527), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7533), 1,
      sym__short_interpolation,
    ACTIONS(7682), 1,
      sym_heredoc_end,
    STATE(5168), 1,
      aux_sym_heredoc_body_repeat1,
    STATE(5208), 1,
      sym_heredoc_body,
    STATE(5305), 1,
      sym_interpolation,
    ACTIONS(7529), 2,
      sym_heredoc_content,
      sym_escape_sequence,
  [183066] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3034), 1,
      sym__pow,
    STATE(3897), 1,
      sym__simple_numeric,
    STATE(5209), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(325), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [183093] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7684), 1,
      sym__string_end,
    STATE(5141), 1,
      aux_sym__literal_contents,
    STATE(5210), 1,
      sym_heredoc_body,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [183122] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3034), 1,
      sym__pow,
    STATE(3778), 1,
      sym__simple_numeric,
    STATE(5211), 1,
      sym_heredoc_body,
    STATE(5577), 1,
      sym__int_or_float,
    ACTIONS(397), 2,
      sym_integer,
      sym_float,
    STATE(3032), 2,
      sym_complex,
      sym_rational,
  [183149] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7523), 1,
      anon_sym_COMMA,
    STATE(5094), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(5212), 1,
      sym_heredoc_body,
    ACTIONS(6756), 5,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [183172] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7451), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7457), 1,
      sym__short_interpolation,
    ACTIONS(7686), 1,
      sym__string_end,
    STATE(5153), 1,
      aux_sym__literal_contents,
    STATE(5213), 1,
      sym_heredoc_body,
    STATE(5320), 1,
      sym_interpolation,
    ACTIONS(7453), 2,
      sym_string_content,
      sym_escape_sequence,
  [183201] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    STATE(5214), 1,
      sym_heredoc_body,
    STATE(5439), 1,
      sym_argument_list,
    ACTIONS(415), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183223] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7688), 1,
      anon_sym_end,
    STATE(5215), 1,
      sym_heredoc_body,
    STATE(5292), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5724), 1,
      sym_else,
  [183251] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7690), 1,
      anon_sym_end,
    STATE(5216), 1,
      sym_heredoc_body,
    STATE(5292), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5817), 1,
      sym_else,
  [183279] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4712), 1,
      sym__simple_numeric,
    STATE(5217), 1,
      sym_heredoc_body,
    STATE(5517), 1,
      sym__int_or_float,
    ACTIONS(2912), 2,
      sym_integer,
      sym_float,
    STATE(4680), 2,
      sym_complex,
      sym_rational,
  [183303] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7286), 1,
      anon_sym_end,
    STATE(5218), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5776), 1,
      sym_else,
  [183331] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7692), 1,
      anon_sym_end,
    STATE(5219), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5822), 1,
      sym_else,
  [183359] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5220), 1,
      sym_heredoc_body,
    STATE(5382), 1,
      sym__simple_numeric,
    STATE(5528), 1,
      sym__int_or_float,
    ACTIONS(2704), 2,
      sym_integer,
      sym_float,
    STATE(5470), 2,
      sym_complex,
      sym_rational,
  [183383] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7694), 1,
      anon_sym_end,
    STATE(5221), 1,
      sym_heredoc_body,
    STATE(5292), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5773), 1,
      sym_else,
  [183411] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7696), 1,
      anon_sym_end,
    STATE(5222), 1,
      sym_heredoc_body,
    STATE(5292), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5823), 1,
      sym_else,
  [183439] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7297), 1,
      anon_sym_end,
    STATE(5223), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5803), 1,
      sym_else,
  [183467] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7698), 1,
      anon_sym_rescue,
    STATE(5224), 1,
      sym_heredoc_body,
    ACTIONS(6720), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [183487] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7700), 1,
      anon_sym_end,
    STATE(5225), 1,
      sym_heredoc_body,
    STATE(5292), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5807), 1,
      sym_else,
  [183515] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7702), 1,
      sym_identifier,
    ACTIONS(7704), 1,
      anon_sym_LPAREN,
    STATE(4447), 1,
      sym__nonlocal_variable,
    STATE(5226), 1,
      sym_heredoc_body,
    ACTIONS(4368), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [183539] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7706), 1,
      anon_sym_end,
    STATE(5227), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5771), 1,
      sym_else,
  [183567] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    STATE(5000), 1,
      aux_sym__literal_contents,
    STATE(5228), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [183593] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7698), 1,
      anon_sym_rescue,
    STATE(5229), 1,
      sym_heredoc_body,
    ACTIONS(6683), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [183613] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7708), 1,
      sym_identifier,
    ACTIONS(7710), 1,
      anon_sym_LPAREN,
    STATE(4792), 1,
      sym__nonlocal_variable,
    STATE(5230), 1,
      sym_heredoc_body,
    ACTIONS(7712), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [183637] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7702), 1,
      sym_identifier,
    ACTIONS(7704), 1,
      anon_sym_LPAREN,
    STATE(4447), 1,
      sym__nonlocal_variable,
    STATE(5231), 1,
      sym_heredoc_body,
    ACTIONS(3925), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [183661] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7714), 1,
      anon_sym_rescue,
    STATE(5232), 1,
      sym_heredoc_body,
    ACTIONS(6683), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [183681] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7716), 1,
      anon_sym_end,
    STATE(5233), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5793), 1,
      sym_else,
  [183709] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7714), 1,
      anon_sym_rescue,
    STATE(5234), 1,
      sym_heredoc_body,
    ACTIONS(6720), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [183729] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5235), 1,
      sym_heredoc_body,
    ACTIONS(2640), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
    ACTIONS(2642), 3,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
  [183749] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5236), 1,
      sym_heredoc_body,
    ACTIONS(7718), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [183767] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5237), 1,
      sym_heredoc_body,
    ACTIONS(7720), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [183785] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7722), 1,
      anon_sym_end,
    STATE(5238), 1,
      sym_heredoc_body,
    STATE(5292), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5779), 1,
      sym_else,
  [183813] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7293), 1,
      anon_sym_end,
    STATE(5239), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5778), 1,
      sym_else,
  [183841] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5240), 1,
      sym_heredoc_body,
    ACTIONS(7724), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [183859] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7176), 1,
      anon_sym_end,
    STATE(5241), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5744), 1,
      sym_else,
  [183887] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5242), 1,
      sym_heredoc_body,
    ACTIONS(7726), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
    ACTIONS(7728), 3,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
  [183907] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7730), 1,
      anon_sym_end,
    STATE(5243), 1,
      sym_heredoc_body,
    STATE(5292), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5741), 1,
      sym_else,
  [183935] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7732), 1,
      anon_sym_COMMA,
    STATE(5244), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6724), 4,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [183955] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7735), 1,
      anon_sym_end,
    STATE(5245), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5740), 1,
      sym_else,
  [183983] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5246), 1,
      sym_heredoc_body,
    ACTIONS(7737), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [184001] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7164), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7174), 1,
      sym__short_interpolation,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5247), 1,
      sym_heredoc_body,
    STATE(5263), 1,
      sym_interpolation,
    ACTIONS(7170), 2,
      sym_string_content,
      sym_escape_sequence,
  [184027] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7739), 1,
      anon_sym_end,
    STATE(5248), 1,
      sym_heredoc_body,
    STATE(5292), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5739), 1,
      sym_else,
  [184055] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7741), 1,
      anon_sym_end,
    STATE(5249), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5707), 1,
      sym_else,
  [184083] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4422), 1,
      sym__simple_numeric,
    STATE(5250), 1,
      sym_heredoc_body,
    STATE(5529), 1,
      sym__int_or_float,
    ACTIONS(2826), 2,
      sym_integer,
      sym_float,
    STATE(4413), 2,
      sym_complex,
      sym_rational,
  [184107] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7743), 1,
      anon_sym_end,
    STATE(5251), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5833), 1,
      sym_else,
  [184135] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7745), 1,
      anon_sym_end,
    STATE(5252), 1,
      sym_heredoc_body,
    STATE(5292), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5841), 1,
      sym_else,
  [184163] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7741), 1,
      anon_sym_end,
    STATE(5233), 1,
      aux_sym_case_repeat1,
    STATE(5253), 1,
      sym_heredoc_body,
    STATE(5557), 1,
      sym_when,
    STATE(5707), 1,
      sym_else,
  [184191] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4712), 1,
      sym__simple_numeric,
    STATE(5254), 1,
      sym_heredoc_body,
    STATE(5517), 1,
      sym__int_or_float,
    ACTIONS(2876), 2,
      sym_integer,
      sym_float,
    STATE(4680), 2,
      sym_complex,
      sym_rational,
  [184215] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4422), 1,
      sym__simple_numeric,
    STATE(5255), 1,
      sym_heredoc_body,
    STATE(5529), 1,
      sym__int_or_float,
    ACTIONS(2930), 2,
      sym_integer,
      sym_float,
    STATE(4413), 2,
      sym_complex,
      sym_rational,
  [184239] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7747), 1,
      anon_sym_end,
    STATE(5256), 1,
      sym_heredoc_body,
    STATE(5289), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5939), 1,
      sym_else,
  [184267] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7747), 1,
      anon_sym_end,
    STATE(5257), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5939), 1,
      sym_else,
  [184295] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7749), 1,
      anon_sym_end,
    STATE(5258), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5725), 1,
      sym_else,
  [184323] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    STATE(5259), 1,
      sym_heredoc_body,
    STATE(5468), 1,
      sym_argument_list,
    ACTIONS(3317), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184345] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    STATE(5260), 1,
      sym_heredoc_body,
    STATE(5469), 1,
      sym_argument_list,
    ACTIONS(3293), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184367] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5261), 1,
      sym_heredoc_body,
    ACTIONS(7751), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [184385] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5262), 1,
      sym_heredoc_body,
    ACTIONS(7753), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [184403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5263), 1,
      sym_heredoc_body,
    ACTIONS(7755), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
    ACTIONS(7757), 3,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
  [184423] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7759), 1,
      anon_sym_end,
    STATE(5264), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5735), 1,
      sym_else,
  [184451] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5265), 1,
      sym_heredoc_body,
    ACTIONS(3086), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [184469] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5266), 1,
      sym_heredoc_body,
    ACTIONS(3529), 6,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184487] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5267), 1,
      sym_heredoc_body,
    ACTIONS(3779), 6,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184505] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5268), 1,
      sym_heredoc_body,
    ACTIONS(3080), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [184523] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7208), 1,
      anon_sym_end,
    STATE(5269), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5698), 1,
      sym_else,
  [184551] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7761), 1,
      anon_sym_COMMA,
    STATE(5270), 1,
      sym_heredoc_body,
    STATE(5284), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6756), 4,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [184573] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7763), 1,
      anon_sym_end,
    STATE(5271), 1,
      sym_heredoc_body,
    STATE(5292), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5701), 1,
      sym_else,
  [184601] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    STATE(5272), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym_argument_list,
    ACTIONS(419), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184623] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5273), 1,
      sym_heredoc_body,
    ACTIONS(3090), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [184641] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    STATE(5274), 1,
      sym_heredoc_body,
    STATE(5444), 1,
      sym_argument_list,
    ACTIONS(423), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184663] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7765), 1,
      anon_sym_rescue,
    STATE(5275), 1,
      sym_heredoc_body,
    ACTIONS(6683), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [184683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5276), 1,
      sym_heredoc_body,
    ACTIONS(7767), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
    ACTIONS(7769), 3,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
  [184703] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4837), 1,
      anon_sym_LPAREN2,
    STATE(5277), 1,
      sym_heredoc_body,
    STATE(5445), 1,
      sym_argument_list,
    ACTIONS(427), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184725] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7771), 1,
      anon_sym_end,
    STATE(5278), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5816), 1,
      sym_else,
  [184753] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7765), 1,
      anon_sym_rescue,
    STATE(5279), 1,
      sym_heredoc_body,
    ACTIONS(6720), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [184773] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5932), 1,
      anon_sym_COMMA,
    STATE(5280), 1,
      sym_heredoc_body,
    STATE(5285), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(7773), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
  [184795] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5932), 1,
      anon_sym_COMMA,
    STATE(5280), 1,
      aux_sym_exceptions_repeat1,
    STATE(5281), 1,
      sym_heredoc_body,
    ACTIONS(5934), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
  [184817] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7775), 1,
      anon_sym_end,
    STATE(5282), 1,
      sym_heredoc_body,
    STATE(5292), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5944), 1,
      sym_else,
  [184845] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7204), 1,
      anon_sym_end,
    STATE(5283), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5969), 1,
      sym_else,
  [184873] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7761), 1,
      anon_sym_COMMA,
    STATE(5244), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(5284), 1,
      sym_heredoc_body,
    ACTIONS(6752), 4,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [184895] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7777), 1,
      anon_sym_COMMA,
    STATE(5285), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3839), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
  [184915] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_in,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7780), 1,
      anon_sym_end,
    STATE(5286), 1,
      sym_heredoc_body,
    STATE(5292), 1,
      aux_sym_case_match_repeat1,
    STATE(5525), 1,
      sym_in_clause,
    STATE(5963), 1,
      sym_else,
  [184943] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7771), 1,
      anon_sym_end,
    STATE(5227), 1,
      aux_sym_case_repeat1,
    STATE(5287), 1,
      sym_heredoc_body,
    STATE(5557), 1,
      sym_when,
    STATE(5816), 1,
      sym_else,
  [184971] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7782), 1,
      anon_sym_end,
    STATE(5288), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5945), 1,
      sym_else,
  [184999] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_when,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7784), 1,
      anon_sym_end,
    STATE(5289), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      aux_sym_case_repeat1,
    STATE(5557), 1,
      sym_when,
    STATE(5704), 1,
      sym_else,
  [185027] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7788), 1,
      anon_sym_when,
    STATE(5557), 1,
      sym_when,
    ACTIONS(7786), 2,
      anon_sym_end,
      anon_sym_else,
    STATE(5290), 2,
      sym_heredoc_body,
      aux_sym_case_repeat1,
  [185048] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7143), 1,
      anon_sym_then,
    STATE(282), 1,
      sym__terminator,
    STATE(5291), 1,
      sym_heredoc_body,
    STATE(5414), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [185071] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7793), 1,
      anon_sym_in,
    STATE(5525), 1,
      sym_in_clause,
    ACTIONS(7791), 2,
      anon_sym_end,
      anon_sym_else,
    STATE(5292), 2,
      sym_heredoc_body,
      aux_sym_case_match_repeat1,
  [185092] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7143), 1,
      anon_sym_then,
    STATE(278), 1,
      sym__terminator,
    STATE(5293), 1,
      sym_heredoc_body,
    STATE(5363), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [185115] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5294), 1,
      sym_heredoc_body,
    ACTIONS(3839), 5,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
  [185132] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5295), 1,
      sym_heredoc_body,
    ACTIONS(3321), 5,
      sym__string_start,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7796), 1,
      anon_sym_COMMA,
    STATE(5296), 1,
      sym_heredoc_body,
    STATE(5299), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2762), 3,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_in,
  [185170] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7767), 1,
      anon_sym_POUND_LBRACE,
    STATE(5297), 1,
      sym_heredoc_body,
    ACTIONS(7769), 4,
      sym_heredoc_content,
      sym_heredoc_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185189] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7798), 1,
      anon_sym_EQ,
    ACTIONS(7800), 1,
      anon_sym_COLON,
    STATE(5298), 1,
      sym_heredoc_body,
    ACTIONS(7718), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185210] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7802), 1,
      anon_sym_COMMA,
    STATE(5299), 2,
      sym_heredoc_body,
      aux_sym__mlhs_repeat1,
    ACTIONS(7338), 3,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_in,
  [185229] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5300), 1,
      sym_heredoc_body,
    ACTIONS(7805), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6623), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [185248] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7726), 1,
      anon_sym_POUND_LBRACE,
    STATE(5301), 1,
      sym_heredoc_body,
    ACTIONS(7728), 4,
      sym_heredoc_content,
      sym_heredoc_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2640), 1,
      anon_sym_POUND_LBRACE,
    STATE(5302), 1,
      sym_heredoc_body,
    ACTIONS(2642), 4,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185286] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7726), 1,
      anon_sym_POUND_LBRACE,
    STATE(5303), 1,
      sym_heredoc_body,
    ACTIONS(7728), 4,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185305] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3162), 1,
      anon_sym_COMMA,
    STATE(5296), 1,
      aux_sym__mlhs_repeat1,
    STATE(5304), 1,
      sym_heredoc_body,
    ACTIONS(7807), 3,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_in,
  [185326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7809), 1,
      anon_sym_POUND_LBRACE,
    STATE(5305), 1,
      sym_heredoc_body,
    ACTIONS(7811), 4,
      sym_heredoc_content,
      sym_heredoc_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185345] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7813), 1,
      anon_sym_EQ,
    ACTIONS(7815), 1,
      anon_sym_COLON,
    STATE(5306), 1,
      sym_heredoc_body,
    ACTIONS(7718), 3,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
  [185366] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5307), 1,
      sym_heredoc_body,
    ACTIONS(3299), 5,
      sym__string_start,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185383] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7817), 1,
      anon_sym_end,
    ACTIONS(7819), 1,
      anon_sym_elsif,
    STATE(5308), 1,
      sym_heredoc_body,
    STATE(5812), 2,
      sym_elsif,
      sym_else,
  [185406] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5309), 1,
      sym_heredoc_body,
    ACTIONS(3335), 5,
      sym__string_start,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185423] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7819), 1,
      anon_sym_elsif,
    ACTIONS(7821), 1,
      anon_sym_end,
    STATE(5310), 1,
      sym_heredoc_body,
    STATE(5767), 2,
      sym_elsif,
      sym_else,
  [185446] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7139), 1,
      anon_sym_do,
    STATE(349), 1,
      sym__terminator,
    STATE(5311), 1,
      sym_heredoc_body,
    STATE(5351), 1,
      sym_do,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [185469] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7819), 1,
      anon_sym_elsif,
    ACTIONS(7823), 1,
      anon_sym_end,
    STATE(5312), 1,
      sym_heredoc_body,
    STATE(5673), 2,
      sym_elsif,
      sym_else,
  [185492] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7819), 1,
      anon_sym_elsif,
    ACTIONS(7825), 1,
      anon_sym_end,
    STATE(5313), 1,
      sym_heredoc_body,
    STATE(5675), 2,
      sym_elsif,
      sym_else,
  [185515] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7827), 1,
      anon_sym_COMMA,
    STATE(5314), 2,
      sym_heredoc_body,
      aux_sym_when_repeat1,
    ACTIONS(7830), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
  [185534] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7143), 1,
      anon_sym_then,
    STATE(290), 1,
      sym__terminator,
    STATE(5315), 1,
      sym_heredoc_body,
    STATE(5512), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [185557] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5316), 1,
      sym_heredoc_body,
    ACTIONS(7834), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(7832), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
  [185576] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5317), 1,
      sym_heredoc_body,
    ACTIONS(7834), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(7836), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
  [185595] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7819), 1,
      anon_sym_elsif,
    ACTIONS(7838), 1,
      anon_sym_end,
    STATE(5318), 1,
      sym_heredoc_body,
    STATE(5977), 2,
      sym_elsif,
      sym_else,
  [185618] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7767), 1,
      anon_sym_POUND_LBRACE,
    STATE(5319), 1,
      sym_heredoc_body,
    ACTIONS(7769), 4,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185637] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7755), 1,
      anon_sym_POUND_LBRACE,
    STATE(5320), 1,
      sym_heredoc_body,
    ACTIONS(7757), 4,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185656] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_do,
    STATE(354), 1,
      sym__terminator,
    STATE(2922), 1,
      sym_do,
    STATE(5321), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [185679] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7819), 1,
      anon_sym_elsif,
    ACTIONS(7840), 1,
      anon_sym_end,
    STATE(5322), 1,
      sym_heredoc_body,
    STATE(5783), 2,
      sym_elsif,
      sym_else,
  [185702] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7842), 1,
      anon_sym_EQ,
    ACTIONS(7844), 1,
      anon_sym_COLON,
    STATE(5323), 1,
      sym_heredoc_body,
    ACTIONS(7718), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
  [185723] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7158), 1,
      anon_sym_do,
    STATE(343), 1,
      sym__terminator,
    STATE(2370), 1,
      sym_do,
    STATE(5324), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [185746] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2640), 1,
      anon_sym_POUND_LBRACE,
    STATE(5325), 1,
      sym_heredoc_body,
    ACTIONS(2642), 4,
      sym_heredoc_content,
      sym_heredoc_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185765] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_else,
    ACTIONS(7819), 1,
      anon_sym_elsif,
    ACTIONS(7846), 1,
      anon_sym_end,
    STATE(5326), 1,
      sym_heredoc_body,
    STATE(5785), 2,
      sym_elsif,
      sym_else,
  [185788] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5327), 1,
      sym_heredoc_body,
    ACTIONS(3577), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185804] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5328), 1,
      sym_heredoc_body,
    ACTIONS(3363), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185820] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5329), 1,
      sym_heredoc_body,
    ACTIONS(3593), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185836] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5330), 1,
      sym_heredoc_body,
    ACTIONS(3585), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185852] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7850), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(7852), 1,
      sym__element_reference_bracket,
    STATE(5331), 1,
      sym_heredoc_body,
    ACTIONS(7848), 2,
      anon_sym_DOT,
      anon_sym_AMP_DOT,
  [185872] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5332), 1,
      sym_heredoc_body,
    ACTIONS(3549), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185888] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5333), 1,
      sym_heredoc_body,
    ACTIONS(3509), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185904] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5334), 1,
      sym_heredoc_body,
    ACTIONS(3505), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185920] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5335), 1,
      sym_heredoc_body,
    ACTIONS(3453), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185936] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5336), 1,
      sym_heredoc_body,
    ACTIONS(3375), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185952] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5337), 1,
      sym_heredoc_body,
    ACTIONS(3351), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185968] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5338), 1,
      sym_heredoc_body,
    ACTIONS(3425), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185984] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5339), 1,
      sym_heredoc_body,
    ACTIONS(3537), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186000] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7854), 1,
      anon_sym_COMMA,
    ACTIONS(6724), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(5340), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
  [186018] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    ACTIONS(7857), 1,
      anon_sym_do,
    STATE(5341), 1,
      sym_heredoc_body,
    STATE(4686), 2,
      sym_do_block,
      sym_block,
  [186038] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5342), 1,
      sym_heredoc_body,
    ACTIONS(3827), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186054] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5343), 1,
      sym_heredoc_body,
    ACTIONS(3723), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186070] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5344), 1,
      sym_heredoc_body,
    ACTIONS(3449), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186086] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5345), 1,
      sym_heredoc_body,
    ACTIONS(3371), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186102] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5346), 1,
      sym_heredoc_body,
    ACTIONS(7859), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
  [186118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5347), 1,
      sym_heredoc_body,
    ACTIONS(7861), 4,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
  [186134] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5348), 1,
      sym_heredoc_body,
    ACTIONS(6130), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
  [186150] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5349), 1,
      sym_heredoc_body,
    ACTIONS(7863), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [186166] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5350), 1,
      sym_heredoc_body,
    ACTIONS(3399), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186182] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5351), 1,
      sym_heredoc_body,
    ACTIONS(3655), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186198] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5352), 1,
      sym_heredoc_body,
    ACTIONS(3379), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186214] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5242), 1,
      sym__nonlocal_variable,
    STATE(5353), 1,
      sym_heredoc_body,
    ACTIONS(7865), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [186232] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7867), 1,
      anon_sym_COMMA,
    ACTIONS(7724), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5354), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [186250] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5355), 1,
      sym_heredoc_body,
    ACTIONS(3711), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186266] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5356), 1,
      sym_heredoc_body,
    ACTIONS(3743), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186282] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5357), 1,
      sym_heredoc_body,
    ACTIONS(3407), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186298] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5358), 1,
      sym_heredoc_body,
    ACTIONS(3355), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186314] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5359), 1,
      sym_heredoc_body,
    ACTIONS(3867), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186330] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5360), 1,
      sym_heredoc_body,
    ACTIONS(3847), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186346] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5361), 1,
      sym_heredoc_body,
    ACTIONS(3577), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186362] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7852), 1,
      sym__element_reference_bracket,
    ACTIONS(7870), 1,
      anon_sym_COLON_COLON2,
    STATE(5362), 1,
      sym_heredoc_body,
    ACTIONS(7848), 2,
      anon_sym_DOT,
      anon_sym_AMP_DOT,
  [186382] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5363), 1,
      sym_heredoc_body,
    ACTIONS(7872), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [186398] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7874), 1,
      anon_sym_rescue,
    STATE(5364), 1,
      sym_heredoc_body,
    ACTIONS(6720), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [186416] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5365), 1,
      sym_heredoc_body,
    ACTIONS(3787), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186432] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7874), 1,
      anon_sym_rescue,
    STATE(5366), 1,
      sym_heredoc_body,
    ACTIONS(6683), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [186450] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5367), 1,
      sym_heredoc_body,
    ACTIONS(3783), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5368), 1,
      sym_heredoc_body,
    ACTIONS(7338), 4,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
  [186482] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5369), 1,
      sym_heredoc_body,
    ACTIONS(7834), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(7876), 2,
      sym__line_break,
      anon_sym_SEMI,
  [186500] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7878), 1,
      anon_sym_EQ,
    ACTIONS(7880), 1,
      anon_sym_COLON,
    STATE(5370), 1,
      sym_heredoc_body,
    ACTIONS(7718), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [186520] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7882), 1,
      anon_sym_COMMA,
    STATE(5340), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(5371), 1,
      sym_heredoc_body,
    ACTIONS(2334), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [186540] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5372), 1,
      sym_heredoc_body,
    ACTIONS(7884), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [186556] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5373), 1,
      sym_heredoc_body,
    ACTIONS(3345), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186572] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5374), 1,
      sym_heredoc_body,
    ACTIONS(3771), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186588] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5375), 1,
      sym_heredoc_body,
    ACTIONS(3751), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186604] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5376), 1,
      sym_heredoc_body,
    ACTIONS(3601), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186620] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5377), 1,
      sym_heredoc_body,
    ACTIONS(2954), 4,
      anon_sym_end,
      anon_sym_in,
      anon_sym_when,
      anon_sym_else,
  [186636] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5378), 1,
      sym_heredoc_body,
    ACTIONS(3445), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186652] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6809), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      anon_sym_do,
    STATE(5379), 1,
      sym_heredoc_body,
    STATE(4686), 2,
      sym_do_block,
      sym_block,
  [186672] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5380), 1,
      sym_heredoc_body,
    ACTIONS(7886), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [186688] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_LBRACE,
    ACTIONS(7008), 1,
      anon_sym_do,
    STATE(5381), 1,
      sym_heredoc_body,
    STATE(5388), 2,
      sym_do_block,
      sym_block,
  [186708] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5382), 1,
      sym_heredoc_body,
    ACTIONS(3469), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186724] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5383), 1,
      sym_heredoc_body,
    ACTIONS(3601), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186740] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5384), 1,
      sym_heredoc_body,
    ACTIONS(3387), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186756] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7890), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(7892), 1,
      sym__element_reference_bracket,
    STATE(5385), 1,
      sym_heredoc_body,
    ACTIONS(7888), 2,
      anon_sym_DOT,
      anon_sym_AMP_DOT,
  [186776] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5386), 1,
      sym_heredoc_body,
    ACTIONS(3387), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186792] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5387), 1,
      sym_heredoc_body,
    ACTIONS(3803), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186808] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5388), 1,
      sym_heredoc_body,
    ACTIONS(3871), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186824] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5389), 1,
      sym_heredoc_body,
    ACTIONS(3615), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186840] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5390), 1,
      sym_heredoc_body,
    ACTIONS(3735), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186856] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7896), 1,
      anon_sym_COMMA,
    STATE(5371), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(5391), 1,
      sym_heredoc_body,
    ACTIONS(7894), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [186876] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5392), 1,
      sym_heredoc_body,
    ACTIONS(3755), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186892] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5393), 1,
      sym_heredoc_body,
    ACTIONS(3767), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186908] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7898), 1,
      anon_sym_COMMA,
    STATE(5354), 1,
      aux_sym_parameters_repeat1,
    STATE(5394), 1,
      sym_heredoc_body,
    ACTIONS(7900), 2,
      sym__line_break,
      anon_sym_SEMI,
  [186928] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5395), 1,
      sym_heredoc_body,
    ACTIONS(3795), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186944] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5303), 1,
      sym__nonlocal_variable,
    STATE(5396), 1,
      sym_heredoc_body,
    ACTIONS(7902), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [186962] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5397), 1,
      sym_heredoc_body,
    ACTIONS(3747), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186978] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5398), 1,
      sym_heredoc_body,
    ACTIONS(7904), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [186994] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5301), 1,
      sym__nonlocal_variable,
    STATE(5399), 1,
      sym_heredoc_body,
    ACTIONS(7906), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [187012] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5400), 1,
      sym_heredoc_body,
    ACTIONS(3359), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187028] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5401), 1,
      sym_heredoc_body,
    ACTIONS(3104), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187044] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5402), 1,
      sym_heredoc_body,
    ACTIONS(3597), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187060] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7908), 1,
      sym_identifier,
    STATE(5403), 1,
      sym_heredoc_body,
    ACTIONS(7463), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187078] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5404), 1,
      sym_heredoc_body,
    ACTIONS(3807), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187094] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5405), 1,
      sym_heredoc_body,
    ACTIONS(3429), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187110] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5406), 1,
      sym_heredoc_body,
    ACTIONS(3395), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187126] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5407), 1,
      sym_heredoc_body,
    ACTIONS(3517), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187142] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5408), 1,
      sym_heredoc_body,
    ACTIONS(3851), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187158] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5409), 1,
      sym_heredoc_body,
    ACTIONS(3835), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187174] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5410), 1,
      sym_heredoc_body,
    ACTIONS(3739), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187190] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5411), 1,
      sym_heredoc_body,
    ACTIONS(3791), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187206] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5412), 1,
      sym_heredoc_body,
    ACTIONS(7910), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [187222] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5413), 1,
      sym_heredoc_body,
    ACTIONS(3433), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187238] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5414), 1,
      sym_heredoc_body,
    ACTIONS(7912), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [187254] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5415), 1,
      sym_heredoc_body,
    ACTIONS(3831), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187270] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5416), 1,
      sym_heredoc_body,
    ACTIONS(3815), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187286] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6517), 1,
      anon_sym_LBRACE,
    ACTIONS(6519), 1,
      anon_sym_do,
    STATE(5417), 1,
      sym_heredoc_body,
    STATE(4412), 2,
      sym_do_block,
      sym_block,
  [187306] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7914), 1,
      anon_sym_COMMA,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7918), 1,
      anon_sym_SEMI,
    STATE(5418), 1,
      sym_heredoc_body,
    STATE(5443), 1,
      aux_sym_parameters_repeat1,
  [187328] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5419), 1,
      sym_heredoc_body,
    ACTIONS(3763), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187344] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5420), 1,
      sym_heredoc_body,
    ACTIONS(3759), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187360] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7920), 1,
      anon_sym_COMMA,
    ACTIONS(7724), 2,
      anon_sym_PIPE,
      anon_sym_SEMI,
    STATE(5421), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [187378] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5422), 1,
      sym_heredoc_body,
    ACTIONS(3683), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187394] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5423), 1,
      sym_heredoc_body,
    ACTIONS(3823), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187410] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6817), 1,
      anon_sym_LBRACE,
    ACTIONS(7923), 1,
      anon_sym_do,
    STATE(5424), 1,
      sym_heredoc_body,
    STATE(4412), 2,
      sym_do_block,
      sym_block,
  [187430] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7898), 1,
      anon_sym_COMMA,
    STATE(5394), 1,
      aux_sym_parameters_repeat1,
    STATE(5425), 1,
      sym_heredoc_body,
    ACTIONS(7925), 2,
      sym__line_break,
      anon_sym_SEMI,
  [187450] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5426), 1,
      sym_heredoc_body,
    ACTIONS(3411), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187466] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5427), 1,
      sym_heredoc_body,
    ACTIONS(3403), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187482] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5428), 1,
      sym_heredoc_body,
    ACTIONS(3631), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187498] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5429), 1,
      sym_heredoc_body,
    ACTIONS(3623), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187514] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5430), 1,
      sym_heredoc_body,
    ACTIONS(3619), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187530] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5431), 1,
      sym_heredoc_body,
    ACTIONS(3501), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187546] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5432), 1,
      sym_heredoc_body,
    ACTIONS(3493), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187562] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5433), 1,
      sym_heredoc_body,
    ACTIONS(3497), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187578] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5434), 1,
      sym_heredoc_body,
    ACTIONS(3349), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187594] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5435), 1,
      sym_heredoc_body,
    ACTIONS(3485), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187610] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5436), 1,
      sym_heredoc_body,
    ACTIONS(3513), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187626] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5437), 1,
      sym_heredoc_body,
    ACTIONS(3481), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187642] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5438), 1,
      sym_heredoc_body,
    ACTIONS(3553), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187658] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5439), 1,
      sym_heredoc_body,
    ACTIONS(3589), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187674] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(3210), 1,
      anon_sym_do,
    STATE(5440), 1,
      sym_heredoc_body,
    STATE(2919), 2,
      sym_do_block,
      sym_block,
  [187694] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6881), 1,
      anon_sym_PIPE,
    ACTIONS(6883), 1,
      anon_sym_SEMI,
    ACTIONS(7927), 1,
      anon_sym_COMMA,
    STATE(5421), 1,
      aux_sym_parameters_repeat1,
    STATE(5441), 1,
      sym_heredoc_body,
  [187716] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5442), 1,
      sym_heredoc_body,
    ACTIONS(3545), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187732] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6910), 1,
      anon_sym_PIPE,
    ACTIONS(6912), 1,
      anon_sym_SEMI,
    ACTIONS(7929), 1,
      anon_sym_COMMA,
    STATE(5421), 1,
      aux_sym_parameters_repeat1,
    STATE(5443), 1,
      sym_heredoc_body,
  [187754] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5444), 1,
      sym_heredoc_body,
    ACTIONS(3627), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187770] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5445), 1,
      sym_heredoc_body,
    ACTIONS(3699), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187786] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5446), 1,
      sym_heredoc_body,
    ACTIONS(3863), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187802] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5447), 1,
      sym_heredoc_body,
    ACTIONS(3775), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187818] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5448), 1,
      sym_heredoc_body,
    ACTIONS(3441), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187834] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7931), 1,
      anon_sym_COMMA,
    STATE(5449), 1,
      sym_heredoc_body,
    STATE(5452), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(7900), 2,
      anon_sym_LBRACE,
      anon_sym_do,
  [187854] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5450), 1,
      sym_heredoc_body,
    ACTIONS(3489), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187870] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5451), 1,
      sym_heredoc_body,
    ACTIONS(3843), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187886] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7933), 1,
      anon_sym_COMMA,
    ACTIONS(7724), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    STATE(5452), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [187904] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5453), 1,
      sym_heredoc_body,
    ACTIONS(3855), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187920] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5454), 1,
      sym_heredoc_body,
    ACTIONS(3695), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187936] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7936), 1,
      anon_sym_COMMA,
    ACTIONS(7938), 1,
      anon_sym_PIPE,
    ACTIONS(7940), 1,
      anon_sym_SEMI,
    STATE(5441), 1,
      aux_sym_parameters_repeat1,
    STATE(5455), 1,
      sym_heredoc_body,
  [187958] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5456), 1,
      sym_heredoc_body,
    ACTIONS(3811), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187974] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5457), 1,
      sym_heredoc_body,
    ACTIONS(3731), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187990] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5458), 1,
      sym_heredoc_body,
    ACTIONS(3727), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188006] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5459), 1,
      sym_heredoc_body,
    ACTIONS(3477), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188022] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7145), 1,
      anon_sym_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_COMMA,
    STATE(5460), 1,
      sym_heredoc_body,
    ACTIONS(7942), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [188042] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5461), 1,
      sym_heredoc_body,
    ACTIONS(3715), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188058] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5462), 1,
      sym_heredoc_body,
    ACTIONS(3691), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188074] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5463), 1,
      sym_heredoc_body,
    ACTIONS(3679), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188090] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5464), 1,
      sym_heredoc_body,
    ACTIONS(3473), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188106] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5465), 1,
      sym_heredoc_body,
    ACTIONS(3457), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188122] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5466), 1,
      sym_heredoc_body,
    ACTIONS(3647), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188138] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5467), 1,
      sym_heredoc_body,
    ACTIONS(3639), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188154] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5468), 1,
      sym_heredoc_body,
    ACTIONS(3703), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188170] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5469), 1,
      sym_heredoc_body,
    ACTIONS(3341), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188186] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5470), 1,
      sym_heredoc_body,
    ACTIONS(3248), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188202] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5471), 1,
      sym_heredoc_body,
    ACTIONS(3819), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188218] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5472), 1,
      sym_heredoc_body,
    ACTIONS(3651), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188234] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5473), 1,
      sym_heredoc_body,
    ACTIONS(3571), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188250] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5474), 1,
      sym_heredoc_body,
    ACTIONS(3533), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188266] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5475), 1,
      sym_heredoc_body,
    ACTIONS(3611), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188282] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5476), 1,
      sym_heredoc_body,
    ACTIONS(3635), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188298] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5477), 1,
      sym_heredoc_body,
    ACTIONS(3465), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188314] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    ACTIONS(2956), 1,
      anon_sym_do,
    STATE(5478), 1,
      sym_heredoc_body,
    STATE(2437), 2,
      sym_do_block,
      sym_block,
  [188334] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5479), 1,
      sym_heredoc_body,
    ACTIONS(3663), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188350] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7931), 1,
      anon_sym_COMMA,
    STATE(5449), 1,
      aux_sym_parameters_repeat1,
    STATE(5480), 1,
      sym_heredoc_body,
    ACTIONS(7925), 2,
      anon_sym_LBRACE,
      anon_sym_do,
  [188370] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5481), 1,
      sym_heredoc_body,
    ACTIONS(3363), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188386] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5482), 1,
      sym_heredoc_body,
    ACTIONS(3675), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188402] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5483), 1,
      sym_heredoc_body,
    ACTIONS(3391), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188418] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5484), 1,
      sym_heredoc_body,
    ACTIONS(3707), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188434] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5485), 1,
      sym_heredoc_body,
    ACTIONS(3521), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188450] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5486), 1,
      sym_heredoc_body,
    ACTIONS(3667), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188466] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5487), 1,
      sym_heredoc_body,
    ACTIONS(3421), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188482] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5488), 1,
      sym_heredoc_body,
    ACTIONS(3421), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188498] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7944), 1,
      anon_sym_rescue,
    STATE(5489), 1,
      sym_heredoc_body,
    ACTIONS(6720), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [188516] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7944), 1,
      anon_sym_rescue,
    STATE(5490), 1,
      sym_heredoc_body,
    ACTIONS(6683), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [188534] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5491), 1,
      sym_heredoc_body,
    ACTIONS(3643), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188550] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5492), 1,
      sym_heredoc_body,
    ACTIONS(7946), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [188566] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5493), 1,
      sym_heredoc_body,
    ACTIONS(3719), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188582] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5494), 1,
      sym_heredoc_body,
    ACTIONS(3605), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188598] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7548), 1,
      sym__string_end,
    ACTIONS(7948), 1,
      aux_sym_string_array_token1,
    STATE(5495), 1,
      sym_heredoc_body,
    STATE(5505), 1,
      aux_sym_string_array_repeat1,
  [188617] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7950), 1,
      anon_sym_RPAREN,
    ACTIONS(7952), 1,
      anon_sym_COMMA,
    STATE(5496), 1,
      sym_heredoc_body,
    STATE(5516), 1,
      aux_sym_parameters_repeat1,
  [188636] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7954), 1,
      anon_sym_RBRACE,
    ACTIONS(7956), 1,
      anon_sym_COMMA,
    STATE(5497), 2,
      sym_heredoc_body,
      aux_sym_hash_repeat1,
  [188653] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7495), 1,
      sym__string_end,
    ACTIONS(7959), 1,
      aux_sym_string_array_token1,
    STATE(5498), 1,
      sym_heredoc_body,
    STATE(5505), 1,
      aux_sym_string_array_repeat1,
  [188672] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7481), 1,
      sym__string_end,
    ACTIONS(7961), 1,
      aux_sym_string_array_token1,
    STATE(5499), 1,
      sym_heredoc_body,
    STATE(5537), 1,
      aux_sym_symbol_array_repeat1,
  [188691] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7477), 1,
      sym__string_end,
    ACTIONS(7963), 1,
      aux_sym_string_array_token1,
    STATE(5500), 1,
      sym_heredoc_body,
    STATE(5505), 1,
      aux_sym_string_array_repeat1,
  [188710] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(214), 1,
      sym__terminator,
    STATE(5501), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [188727] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5502), 1,
      sym_heredoc_body,
    ACTIONS(3090), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188742] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(210), 1,
      sym__terminator,
    STATE(5503), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [188759] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7556), 1,
      sym__string_end,
    ACTIONS(7965), 1,
      aux_sym_string_array_token1,
    STATE(5504), 1,
      sym_heredoc_body,
    STATE(5537), 1,
      aux_sym_symbol_array_repeat1,
  [188778] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7967), 1,
      aux_sym_string_array_token1,
    ACTIONS(7970), 1,
      sym__string_end,
    STATE(5505), 2,
      sym_heredoc_body,
      aux_sym_string_array_repeat1,
  [188795] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7972), 1,
      ts_builtin_sym_end,
    ACTIONS(7974), 1,
      aux_sym_program_token1,
    ACTIONS(7976), 1,
      anon_sym___END__,
    STATE(5506), 1,
      sym_heredoc_body,
  [188814] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7978), 1,
      anon_sym_RBRACE,
    ACTIONS(7980), 1,
      anon_sym_COMMA,
    STATE(5507), 1,
      sym_heredoc_body,
    STATE(5531), 1,
      aux_sym_hash_repeat1,
  [188833] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7560), 1,
      sym__string_end,
    ACTIONS(7982), 1,
      aux_sym_string_array_token1,
    STATE(5505), 1,
      aux_sym_string_array_repeat1,
    STATE(5508), 1,
      sym_heredoc_body,
  [188852] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7984), 1,
      anon_sym_COMMA,
    ACTIONS(7987), 1,
      anon_sym_PIPE,
    STATE(5509), 2,
      sym_heredoc_body,
      aux_sym_block_parameters_repeat1,
  [188869] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_RBRACE,
    ACTIONS(7989), 1,
      anon_sym_COMMA,
    STATE(5497), 1,
      aux_sym_hash_repeat1,
    STATE(5510), 1,
      sym_heredoc_body,
  [188888] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7471), 1,
      sym__string_end,
    ACTIONS(7991), 1,
      aux_sym_string_array_token1,
    STATE(5511), 1,
      sym_heredoc_body,
    STATE(5537), 1,
      aux_sym_symbol_array_repeat1,
  [188907] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5512), 1,
      sym_heredoc_body,
    ACTIONS(7993), 3,
      anon_sym_end,
      anon_sym_in,
      anon_sym_else,
  [188922] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7467), 1,
      sym__string_end,
    ACTIONS(7995), 1,
      aux_sym_string_array_token1,
    STATE(5505), 1,
      aux_sym_string_array_repeat1,
    STATE(5513), 1,
      sym_heredoc_body,
  [188941] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(7999), 1,
      anon_sym_PIPE,
    STATE(5514), 1,
      sym_heredoc_body,
    STATE(5524), 1,
      aux_sym_block_parameters_repeat1,
  [188960] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7724), 1,
      anon_sym_RPAREN,
    ACTIONS(8001), 1,
      anon_sym_COMMA,
    STATE(5515), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [188977] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7952), 1,
      anon_sym_COMMA,
    ACTIONS(8004), 1,
      anon_sym_RPAREN,
    STATE(5515), 1,
      aux_sym_parameters_repeat1,
    STATE(5516), 1,
      sym_heredoc_body,
  [188996] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8006), 1,
      anon_sym_i,
    ACTIONS(8008), 1,
      anon_sym_ri,
    ACTIONS(8010), 1,
      anon_sym_r,
    STATE(5517), 1,
      sym_heredoc_body,
  [189015] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7952), 1,
      anon_sym_COMMA,
    ACTIONS(8012), 1,
      anon_sym_RPAREN,
    STATE(5515), 1,
      aux_sym_parameters_repeat1,
    STATE(5518), 1,
      sym_heredoc_body,
  [189034] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7511), 1,
      sym__string_end,
    ACTIONS(8014), 1,
      aux_sym_string_array_token1,
    STATE(5519), 1,
      sym_heredoc_body,
    STATE(5537), 1,
      aux_sym_symbol_array_repeat1,
  [189053] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5520), 1,
      sym_heredoc_body,
    ACTIONS(7724), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189068] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(236), 1,
      sym__terminator,
    STATE(5521), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [189085] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5522), 1,
      sym_heredoc_body,
    ACTIONS(8016), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [189100] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7517), 1,
      sym__string_end,
    ACTIONS(8018), 1,
      aux_sym_string_array_token1,
    STATE(5505), 1,
      aux_sym_string_array_repeat1,
    STATE(5523), 1,
      sym_heredoc_body,
  [189119] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(8020), 1,
      anon_sym_PIPE,
    STATE(5509), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5524), 1,
      sym_heredoc_body,
  [189138] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5525), 1,
      sym_heredoc_body,
    ACTIONS(8022), 3,
      anon_sym_end,
      anon_sym_in,
      anon_sym_else,
  [189153] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(8024), 1,
      anon_sym_PIPE,
    STATE(5526), 1,
      sym_heredoc_body,
    STATE(5542), 1,
      aux_sym_block_parameters_repeat1,
  [189172] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(8026), 1,
      anon_sym_PIPE,
    STATE(5527), 1,
      sym_heredoc_body,
    STATE(5555), 1,
      aux_sym_block_parameters_repeat1,
  [189191] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8028), 1,
      anon_sym_i,
    ACTIONS(8030), 1,
      anon_sym_ri,
    ACTIONS(8032), 1,
      anon_sym_r,
    STATE(5528), 1,
      sym_heredoc_body,
  [189210] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8034), 1,
      anon_sym_i,
    ACTIONS(8036), 1,
      anon_sym_ri,
    ACTIONS(8038), 1,
      anon_sym_r,
    STATE(5529), 1,
      sym_heredoc_body,
  [189229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7672), 1,
      sym__string_end,
    ACTIONS(8040), 1,
      aux_sym_string_array_token1,
    STATE(5530), 1,
      sym_heredoc_body,
    STATE(5537), 1,
      aux_sym_symbol_array_repeat1,
  [189248] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2560), 1,
      anon_sym_RBRACE,
    ACTIONS(8042), 1,
      anon_sym_COMMA,
    STATE(5497), 1,
      aux_sym_hash_repeat1,
    STATE(5531), 1,
      sym_heredoc_body,
  [189267] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5532), 1,
      sym_heredoc_body,
    ACTIONS(7718), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189282] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8044), 1,
      anon_sym_RBRACE,
    ACTIONS(8046), 1,
      anon_sym_COMMA,
    STATE(5510), 1,
      aux_sym_hash_repeat1,
    STATE(5533), 1,
      sym_heredoc_body,
  [189301] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7668), 1,
      sym__string_end,
    ACTIONS(8048), 1,
      aux_sym_string_array_token1,
    STATE(5505), 1,
      aux_sym_string_array_repeat1,
    STATE(5534), 1,
      sym_heredoc_body,
  [189320] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7519), 1,
      sym__string_end,
    ACTIONS(8050), 1,
      aux_sym_string_array_token1,
    STATE(5535), 1,
      sym_heredoc_body,
    STATE(5537), 1,
      aux_sym_symbol_array_repeat1,
  [189339] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5536), 1,
      sym_heredoc_body,
    ACTIONS(8052), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
  [189354] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8054), 1,
      aux_sym_string_array_token1,
    ACTIONS(8057), 1,
      sym__string_end,
    STATE(5537), 2,
      sym_heredoc_body,
      aux_sym_symbol_array_repeat1,
  [189371] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5538), 1,
      sym_heredoc_body,
    ACTIONS(3080), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189386] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5539), 1,
      sym_heredoc_body,
    ACTIONS(8059), 3,
      anon_sym_end,
      anon_sym_in,
      anon_sym_else,
  [189401] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8061), 1,
      anon_sym_RPAREN,
    STATE(5540), 1,
      sym_heredoc_body,
    ACTIONS(8063), 2,
      anon_sym_and,
      anon_sym_or,
  [189418] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(8065), 1,
      anon_sym_PIPE,
    STATE(5541), 1,
      sym_heredoc_body,
    STATE(5543), 1,
      aux_sym_block_parameters_repeat1,
  [189437] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(8067), 1,
      anon_sym_PIPE,
    STATE(5509), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5542), 1,
      sym_heredoc_body,
  [189456] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(8069), 1,
      anon_sym_PIPE,
    STATE(5509), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5543), 1,
      sym_heredoc_body,
  [189475] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5544), 1,
      sym_heredoc_body,
    ACTIONS(7753), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189490] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(8071), 1,
      anon_sym_PIPE,
    STATE(5545), 1,
      sym_heredoc_body,
    STATE(5547), 1,
      aux_sym_block_parameters_repeat1,
  [189509] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(8073), 1,
      anon_sym_PIPE,
    STATE(5509), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5546), 1,
      sym_heredoc_body,
  [189528] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(8075), 1,
      anon_sym_PIPE,
    STATE(5509), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5547), 1,
      sym_heredoc_body,
  [189547] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7598), 1,
      sym__string_end,
    ACTIONS(8077), 1,
      aux_sym_string_array_token1,
    STATE(5505), 1,
      aux_sym_string_array_repeat1,
    STATE(5548), 1,
      sym_heredoc_body,
  [189566] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(8079), 1,
      anon_sym_PIPE,
    STATE(5549), 1,
      sym_heredoc_body,
    STATE(5550), 1,
      aux_sym_block_parameters_repeat1,
  [189585] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    STATE(5509), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5550), 1,
      sym_heredoc_body,
  [189604] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(228), 1,
      sym__terminator,
    STATE(5551), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [189621] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5552), 1,
      sym_heredoc_body,
    ACTIONS(7751), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189636] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8083), 1,
      anon_sym_RBRACE,
    ACTIONS(8085), 1,
      anon_sym_COMMA,
    STATE(5553), 1,
      sym_heredoc_body,
    STATE(5575), 1,
      aux_sym_hash_repeat1,
  [189655] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7952), 1,
      anon_sym_COMMA,
    ACTIONS(8087), 1,
      anon_sym_RPAREN,
    STATE(5554), 1,
      sym_heredoc_body,
    STATE(5567), 1,
      aux_sym_parameters_repeat1,
  [189674] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(8089), 1,
      anon_sym_PIPE,
    STATE(5509), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5555), 1,
      sym_heredoc_body,
  [189693] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7592), 1,
      sym__string_end,
    ACTIONS(8091), 1,
      aux_sym_string_array_token1,
    STATE(5537), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5556), 1,
      sym_heredoc_body,
  [189712] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5557), 1,
      sym_heredoc_body,
    ACTIONS(8093), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [189727] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8095), 1,
      anon_sym_RPAREN,
    STATE(5558), 1,
      sym_heredoc_body,
    ACTIONS(8063), 2,
      anon_sym_and,
      anon_sym_or,
  [189744] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7952), 1,
      anon_sym_COMMA,
    ACTIONS(8097), 1,
      anon_sym_RPAREN,
    STATE(5518), 1,
      aux_sym_parameters_repeat1,
    STATE(5559), 1,
      sym_heredoc_body,
  [189763] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(8099), 1,
      anon_sym_PIPE,
    STATE(5546), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5560), 1,
      sym_heredoc_body,
  [189782] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5561), 1,
      sym_heredoc_body,
    ACTIONS(7737), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189797] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8101), 1,
      anon_sym_i,
    ACTIONS(8103), 1,
      anon_sym_ri,
    ACTIONS(8105), 1,
      anon_sym_r,
    STATE(5562), 1,
      sym_heredoc_body,
  [189816] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(234), 1,
      sym__terminator,
    STATE(5563), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [189833] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(8107), 1,
      anon_sym_PIPE,
    STATE(5509), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5564), 1,
      sym_heredoc_body,
  [189852] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7613), 1,
      sym__string_end,
    ACTIONS(8109), 1,
      aux_sym_string_array_token1,
    STATE(5505), 1,
      aux_sym_string_array_repeat1,
    STATE(5565), 1,
      sym_heredoc_body,
  [189871] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(240), 1,
      sym__terminator,
    STATE(5566), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [189888] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7952), 1,
      anon_sym_COMMA,
    ACTIONS(8111), 1,
      anon_sym_RPAREN,
    STATE(5515), 1,
      aux_sym_parameters_repeat1,
    STATE(5567), 1,
      sym_heredoc_body,
  [189907] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7503), 1,
      sym__string_end,
    ACTIONS(8113), 1,
      aux_sym_string_array_token1,
    STATE(5537), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5568), 1,
      sym_heredoc_body,
  [189926] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7566), 1,
      sym__string_end,
    ACTIONS(8115), 1,
      aux_sym_string_array_token1,
    STATE(5505), 1,
      aux_sym_string_array_repeat1,
    STATE(5569), 1,
      sym_heredoc_body,
  [189945] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7544), 1,
      sym__string_end,
    ACTIONS(8117), 1,
      aux_sym_string_array_token1,
    STATE(5537), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5570), 1,
      sym_heredoc_body,
  [189964] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5571), 1,
      sym_heredoc_body,
    ACTIONS(7720), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189979] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5572), 1,
      sym_heredoc_body,
    ACTIONS(3086), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189994] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5573), 1,
      sym_heredoc_body,
    ACTIONS(8119), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [190009] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7630), 1,
      sym__string_end,
    ACTIONS(8121), 1,
      aux_sym_string_array_token1,
    STATE(5537), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5574), 1,
      sym_heredoc_body,
  [190028] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2556), 1,
      anon_sym_RBRACE,
    ACTIONS(8123), 1,
      anon_sym_COMMA,
    STATE(5497), 1,
      aux_sym_hash_repeat1,
    STATE(5575), 1,
      sym_heredoc_body,
  [190047] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    ACTIONS(8125), 1,
      anon_sym_PIPE,
    STATE(5564), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5576), 1,
      sym_heredoc_body,
  [190066] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym_i,
    ACTIONS(8129), 1,
      anon_sym_ri,
    ACTIONS(8131), 1,
      anon_sym_r,
    STATE(5577), 1,
      sym_heredoc_body,
  [190085] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7145), 1,
      anon_sym_EQ_GT,
    ACTIONS(8133), 1,
      anon_sym_RPAREN,
    STATE(5578), 1,
      sym_heredoc_body,
  [190101] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5579), 1,
      sym_heredoc_body,
    ACTIONS(8135), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190115] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5580), 1,
      sym_heredoc_body,
    ACTIONS(8137), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190129] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5581), 1,
      sym_heredoc_body,
    ACTIONS(8139), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190143] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5582), 1,
      sym_heredoc_body,
    ACTIONS(8141), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190157] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5583), 1,
      sym_heredoc_body,
    ACTIONS(8143), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [190171] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5584), 1,
      sym_heredoc_body,
    ACTIONS(8145), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190185] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_in,
    STATE(5311), 1,
      sym_in,
    STATE(5585), 1,
      sym_heredoc_body,
  [190201] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5586), 1,
      sym_heredoc_body,
    ACTIONS(8147), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190215] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5587), 1,
      sym_heredoc_body,
    ACTIONS(8149), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190229] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5588), 1,
      sym_heredoc_body,
    ACTIONS(8151), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190243] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5589), 1,
      sym_heredoc_body,
    ACTIONS(8153), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190257] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5590), 1,
      sym_heredoc_body,
    ACTIONS(8155), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190271] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5591), 1,
      sym_heredoc_body,
    ACTIONS(8157), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190285] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5592), 1,
      sym_heredoc_body,
    ACTIONS(745), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190299] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5593), 1,
      sym_heredoc_body,
    ACTIONS(8159), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5594), 1,
      sym_heredoc_body,
    ACTIONS(8161), 2,
      anon_sym_EQ,
      anon_sym_in,
  [190327] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5595), 1,
      sym_heredoc_body,
    ACTIONS(8163), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190341] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5596), 1,
      sym_heredoc_body,
    ACTIONS(8165), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190355] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5597), 1,
      sym_heredoc_body,
    ACTIONS(8167), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190369] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5598), 1,
      sym_heredoc_body,
    ACTIONS(8169), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190383] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_in,
    STATE(5324), 1,
      sym_in,
    STATE(5599), 1,
      sym_heredoc_body,
  [190399] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5600), 1,
      sym_heredoc_body,
    ACTIONS(8171), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190413] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5601), 1,
      sym_heredoc_body,
    ACTIONS(8173), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190427] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5602), 1,
      sym_heredoc_body,
    ACTIONS(8175), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190441] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5603), 1,
      sym_heredoc_body,
    ACTIONS(8177), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190455] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7918), 1,
      anon_sym_SEMI,
    STATE(5604), 1,
      sym_heredoc_body,
  [190471] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5605), 1,
      sym_heredoc_body,
    ACTIONS(8179), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190485] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LPAREN,
    STATE(5378), 1,
      sym_parenthesized_statements,
    STATE(5606), 1,
      sym_heredoc_body,
  [190501] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5607), 1,
      sym_heredoc_body,
    ACTIONS(8181), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190515] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5608), 1,
      sym_heredoc_body,
    ACTIONS(8183), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190529] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5609), 1,
      sym_heredoc_body,
    ACTIONS(8185), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190543] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_in,
    STATE(5321), 1,
      sym_in,
    STATE(5610), 1,
      sym_heredoc_body,
  [190559] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5611), 1,
      sym_heredoc_body,
    ACTIONS(8187), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190573] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8161), 1,
      anon_sym_EQ,
    ACTIONS(8189), 1,
      anon_sym_RPAREN,
    STATE(5612), 1,
      sym_heredoc_body,
  [190589] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5613), 1,
      sym_heredoc_body,
    ACTIONS(8191), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190603] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5614), 1,
      sym_heredoc_body,
    ACTIONS(8193), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190617] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5615), 1,
      sym_heredoc_body,
    ACTIONS(8195), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190631] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5616), 1,
      sym_heredoc_body,
    ACTIONS(8197), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190645] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5617), 1,
      sym_heredoc_body,
    ACTIONS(8199), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190659] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5618), 1,
      sym_heredoc_body,
    ACTIONS(8201), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190673] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5619), 1,
      sym_heredoc_body,
    ACTIONS(8203), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190687] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5620), 1,
      sym_heredoc_body,
    ACTIONS(8205), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190701] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5621), 1,
      sym_heredoc_body,
    ACTIONS(8207), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190715] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5622), 1,
      sym_heredoc_body,
    ACTIONS(8209), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190729] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5623), 1,
      sym_heredoc_body,
    ACTIONS(8211), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190743] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7938), 1,
      anon_sym_PIPE,
    ACTIONS(7940), 1,
      anon_sym_SEMI,
    STATE(5624), 1,
      sym_heredoc_body,
  [190759] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5625), 1,
      sym_heredoc_body,
    ACTIONS(8213), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190773] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5626), 1,
      sym_heredoc_body,
    ACTIONS(8215), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190787] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5627), 1,
      sym_heredoc_body,
    ACTIONS(8217), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190801] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5628), 1,
      sym_heredoc_body,
    ACTIONS(7942), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [190815] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5629), 1,
      sym_heredoc_body,
    ACTIONS(8219), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190829] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7145), 1,
      anon_sym_EQ_GT,
    ACTIONS(8221), 1,
      anon_sym_RPAREN,
    STATE(5630), 1,
      sym_heredoc_body,
  [190845] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5631), 1,
      sym_heredoc_body,
    ACTIONS(8223), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190859] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5632), 1,
      sym_heredoc_body,
    ACTIONS(8225), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190873] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5633), 1,
      sym_heredoc_body,
    ACTIONS(8227), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190887] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5634), 1,
      sym_heredoc_body,
    ACTIONS(8229), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190901] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5635), 1,
      sym_heredoc_body,
    ACTIONS(8231), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190915] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5636), 1,
      sym_heredoc_body,
    ACTIONS(8233), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190929] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5637), 1,
      sym_heredoc_body,
    ACTIONS(8235), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190943] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5638), 1,
      sym_heredoc_body,
    ACTIONS(7954), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [190957] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5639), 1,
      sym_heredoc_body,
    ACTIONS(8237), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190971] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6507), 1,
      anon_sym_COLON,
    STATE(5640), 1,
      sym_heredoc_body,
  [190984] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8239), 1,
      anon_sym_EQ,
    STATE(5641), 1,
      sym_heredoc_body,
  [190997] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8241), 1,
      anon_sym_end,
    STATE(5642), 1,
      sym_heredoc_body,
  [191010] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8243), 1,
      anon_sym_RBRACK,
    STATE(5643), 1,
      sym_heredoc_body,
  [191023] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8245), 1,
      anon_sym_end,
    STATE(5644), 1,
      sym_heredoc_body,
  [191036] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8247), 1,
      anon_sym_end,
    STATE(5645), 1,
      sym_heredoc_body,
  [191049] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8249), 1,
      anon_sym_end,
    STATE(5646), 1,
      sym_heredoc_body,
  [191062] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8251), 1,
      anon_sym_RBRACE,
    STATE(5647), 1,
      sym_heredoc_body,
  [191075] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8253), 1,
      anon_sym_end,
    STATE(5648), 1,
      sym_heredoc_body,
  [191088] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8255), 1,
      anon_sym_RBRACE,
    STATE(5649), 1,
      sym_heredoc_body,
  [191101] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8257), 1,
      ts_builtin_sym_end,
    STATE(5650), 1,
      sym_heredoc_body,
  [191114] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8259), 1,
      anon_sym_EQ,
    STATE(5651), 1,
      sym_heredoc_body,
  [191127] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8261), 1,
      anon_sym_end,
    STATE(5652), 1,
      sym_heredoc_body,
  [191140] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8263), 1,
      sym_constant,
    STATE(5653), 1,
      sym_heredoc_body,
  [191153] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8265), 1,
      sym__string_end,
    STATE(5654), 1,
      sym_heredoc_body,
  [191166] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8267), 1,
      anon_sym_COLON,
    STATE(5655), 1,
      sym_heredoc_body,
  [191179] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8269), 1,
      anon_sym_RPAREN,
    STATE(5656), 1,
      sym_heredoc_body,
  [191192] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8271), 1,
      anon_sym_end,
    STATE(5657), 1,
      sym_heredoc_body,
  [191205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8273), 1,
      anon_sym_EQ,
    STATE(5658), 1,
      sym_heredoc_body,
  [191218] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8275), 1,
      anon_sym_RPAREN,
    STATE(5659), 1,
      sym_heredoc_body,
  [191231] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8277), 1,
      anon_sym_RPAREN,
    STATE(5660), 1,
      sym_heredoc_body,
  [191244] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8279), 1,
      anon_sym_RPAREN,
    STATE(5661), 1,
      sym_heredoc_body,
  [191257] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8281), 1,
      anon_sym_end,
    STATE(5662), 1,
      sym_heredoc_body,
  [191270] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8277), 1,
      anon_sym_RBRACK,
    STATE(5663), 1,
      sym_heredoc_body,
  [191283] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8279), 1,
      anon_sym_RBRACK,
    STATE(5664), 1,
      sym_heredoc_body,
  [191296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8283), 1,
      anon_sym_EQ,
    STATE(5665), 1,
      sym_heredoc_body,
  [191309] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8285), 1,
      anon_sym_end,
    STATE(5666), 1,
      sym_heredoc_body,
  [191322] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8287), 1,
      anon_sym_COLON,
    STATE(5667), 1,
      sym_heredoc_body,
  [191335] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8289), 1,
      sym_constant,
    STATE(5668), 1,
      sym_heredoc_body,
  [191348] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8291), 1,
      anon_sym_COLON,
    STATE(5669), 1,
      sym_heredoc_body,
  [191361] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8293), 1,
      anon_sym_RBRACK,
    STATE(5670), 1,
      sym_heredoc_body,
  [191374] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8295), 1,
      anon_sym_end,
    STATE(5671), 1,
      sym_heredoc_body,
  [191387] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_end,
    STATE(5672), 1,
      sym_heredoc_body,
  [191400] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8299), 1,
      anon_sym_end,
    STATE(5673), 1,
      sym_heredoc_body,
  [191413] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8301), 1,
      anon_sym_end,
    STATE(5674), 1,
      sym_heredoc_body,
  [191426] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8303), 1,
      anon_sym_end,
    STATE(5675), 1,
      sym_heredoc_body,
  [191439] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8305), 1,
      anon_sym_end,
    STATE(5676), 1,
      sym_heredoc_body,
  [191452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8307), 1,
      anon_sym_EQ,
    STATE(5677), 1,
      sym_heredoc_body,
  [191465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8309), 1,
      anon_sym_EQ,
    STATE(5678), 1,
      sym_heredoc_body,
  [191478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8311), 1,
      anon_sym_EQ,
    STATE(5679), 1,
      sym_heredoc_body,
  [191491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8313), 1,
      anon_sym_EQ,
    STATE(5680), 1,
      sym_heredoc_body,
  [191504] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7077), 1,
      anon_sym_COLON,
    STATE(5681), 1,
      sym_heredoc_body,
  [191517] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8315), 1,
      anon_sym_end,
    STATE(5682), 1,
      sym_heredoc_body,
  [191530] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8317), 1,
      anon_sym_RBRACE,
    STATE(5683), 1,
      sym_heredoc_body,
  [191543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8319), 1,
      anon_sym_EQ,
    STATE(5684), 1,
      sym_heredoc_body,
  [191556] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8321), 1,
      sym__string_end,
    STATE(5685), 1,
      sym_heredoc_body,
  [191569] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8323), 1,
      anon_sym_end,
    STATE(5686), 1,
      sym_heredoc_body,
  [191582] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8325), 1,
      anon_sym_end,
    STATE(5687), 1,
      sym_heredoc_body,
  [191595] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7204), 1,
      anon_sym_end,
    STATE(5688), 1,
      sym_heredoc_body,
  [191608] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8327), 1,
      anon_sym_COLON,
    STATE(5689), 1,
      sym_heredoc_body,
  [191621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8329), 1,
      anon_sym_EQ,
    STATE(5690), 1,
      sym_heredoc_body,
  [191634] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8331), 1,
      anon_sym_RBRACE,
    STATE(5691), 1,
      sym_heredoc_body,
  [191647] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8333), 1,
      anon_sym_end,
    STATE(5692), 1,
      sym_heredoc_body,
  [191660] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8335), 1,
      anon_sym_RBRACK,
    STATE(5693), 1,
      sym_heredoc_body,
  [191673] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8337), 1,
      anon_sym_end,
    STATE(5694), 1,
      sym_heredoc_body,
  [191686] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8339), 1,
      anon_sym_end,
    STATE(5695), 1,
      sym_heredoc_body,
  [191699] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8341), 1,
      anon_sym_RPAREN,
    STATE(5696), 1,
      sym_heredoc_body,
  [191712] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8343), 1,
      anon_sym_end,
    STATE(5697), 1,
      sym_heredoc_body,
  [191725] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7782), 1,
      anon_sym_end,
    STATE(5698), 1,
      sym_heredoc_body,
  [191738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8345), 1,
      anon_sym_EQ,
    STATE(5699), 1,
      sym_heredoc_body,
  [191751] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8347), 1,
      anon_sym_end,
    STATE(5700), 1,
      sym_heredoc_body,
  [191764] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8349), 1,
      anon_sym_end,
    STATE(5701), 1,
      sym_heredoc_body,
  [191777] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8351), 1,
      anon_sym_end,
    STATE(5702), 1,
      sym_heredoc_body,
  [191790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8353), 1,
      anon_sym_EQ,
    STATE(5703), 1,
      sym_heredoc_body,
  [191803] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8355), 1,
      anon_sym_end,
    STATE(5704), 1,
      sym_heredoc_body,
  [191816] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8357), 1,
      anon_sym_end,
    STATE(5705), 1,
      sym_heredoc_body,
  [191829] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7293), 1,
      anon_sym_end,
    STATE(5706), 1,
      sym_heredoc_body,
  [191842] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7716), 1,
      anon_sym_end,
    STATE(5707), 1,
      sym_heredoc_body,
  [191855] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8359), 1,
      anon_sym_end,
    STATE(5708), 1,
      sym_heredoc_body,
  [191868] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8361), 1,
      anon_sym_LBRACE,
    STATE(5709), 1,
      sym_heredoc_body,
  [191881] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8363), 1,
      anon_sym_EQ,
    STATE(5710), 1,
      sym_heredoc_body,
  [191894] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8365), 1,
      anon_sym_RBRACE,
    STATE(5711), 1,
      sym_heredoc_body,
  [191907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8367), 1,
      anon_sym_EQ,
    STATE(5712), 1,
      sym_heredoc_body,
  [191920] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8369), 1,
      sym_identifier,
    STATE(5713), 1,
      sym_heredoc_body,
  [191933] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6889), 1,
      anon_sym_COLON,
    STATE(5714), 1,
      sym_heredoc_body,
  [191946] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8371), 1,
      anon_sym_RBRACE,
    STATE(5715), 1,
      sym_heredoc_body,
  [191959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8373), 1,
      anon_sym_EQ,
    STATE(5716), 1,
      sym_heredoc_body,
  [191972] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8375), 1,
      anon_sym_end,
    STATE(5717), 1,
      sym_heredoc_body,
  [191985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8377), 1,
      anon_sym_EQ,
    STATE(5718), 1,
      sym_heredoc_body,
  [191998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8379), 1,
      anon_sym_EQ,
    STATE(5719), 1,
      sym_heredoc_body,
  [192011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8381), 1,
      anon_sym_EQ,
    STATE(5720), 1,
      sym_heredoc_body,
  [192024] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_end,
    STATE(5721), 1,
      sym_heredoc_body,
  [192037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8385), 1,
      anon_sym_EQ,
    STATE(5722), 1,
      sym_heredoc_body,
  [192050] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7029), 1,
      anon_sym_COLON,
    STATE(5723), 1,
      sym_heredoc_body,
  [192063] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8387), 1,
      anon_sym_end,
    STATE(5724), 1,
      sym_heredoc_body,
  [192076] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8389), 1,
      anon_sym_end,
    STATE(5725), 1,
      sym_heredoc_body,
  [192089] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8391), 1,
      anon_sym_RPAREN,
    STATE(5726), 1,
      sym_heredoc_body,
  [192102] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8393), 1,
      anon_sym_RPAREN,
    STATE(5727), 1,
      sym_heredoc_body,
  [192115] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8395), 1,
      anon_sym_RPAREN,
    STATE(5728), 1,
      sym_heredoc_body,
  [192128] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8391), 1,
      anon_sym_RBRACK,
    STATE(5729), 1,
      sym_heredoc_body,
  [192141] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8393), 1,
      anon_sym_RBRACK,
    STATE(5730), 1,
      sym_heredoc_body,
  [192154] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8395), 1,
      anon_sym_RBRACK,
    STATE(5731), 1,
      sym_heredoc_body,
  [192167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8397), 1,
      anon_sym_EQ,
    STATE(5732), 1,
      sym_heredoc_body,
  [192180] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8399), 1,
      anon_sym_RBRACK,
    STATE(5733), 1,
      sym_heredoc_body,
  [192193] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8401), 1,
      anon_sym_end,
    STATE(5734), 1,
      sym_heredoc_body,
  [192206] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8403), 1,
      anon_sym_end,
    STATE(5735), 1,
      sym_heredoc_body,
  [192219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8405), 1,
      anon_sym_EQ,
    STATE(5736), 1,
      sym_heredoc_body,
  [192232] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8407), 1,
      anon_sym_EQ,
    STATE(5737), 1,
      sym_heredoc_body,
  [192245] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8409), 1,
      anon_sym_end,
    STATE(5738), 1,
      sym_heredoc_body,
  [192258] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8411), 1,
      anon_sym_end,
    STATE(5739), 1,
      sym_heredoc_body,
  [192271] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8413), 1,
      anon_sym_end,
    STATE(5740), 1,
      sym_heredoc_body,
  [192284] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8415), 1,
      anon_sym_end,
    STATE(5741), 1,
      sym_heredoc_body,
  [192297] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8417), 1,
      anon_sym_end,
    STATE(5742), 1,
      sym_heredoc_body,
  [192310] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8419), 1,
      anon_sym_EQ,
    STATE(5743), 1,
      sym_heredoc_body,
  [192323] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_end,
    STATE(5744), 1,
      sym_heredoc_body,
  [192336] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8421), 1,
      anon_sym_end,
    STATE(5745), 1,
      sym_heredoc_body,
  [192349] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8423), 1,
      anon_sym_end,
    STATE(5746), 1,
      sym_heredoc_body,
  [192362] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8425), 1,
      anon_sym_end,
    STATE(5747), 1,
      sym_heredoc_body,
  [192375] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8427), 1,
      anon_sym_end,
    STATE(5748), 1,
      sym_heredoc_body,
  [192388] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8429), 1,
      anon_sym_end,
    STATE(5749), 1,
      sym_heredoc_body,
  [192401] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8431), 1,
      sym_constant,
    STATE(5750), 1,
      sym_heredoc_body,
  [192414] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8433), 1,
      sym_constant,
    STATE(5751), 1,
      sym_heredoc_body,
  [192427] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8435), 1,
      sym_identifier,
    STATE(5752), 1,
      sym_heredoc_body,
  [192440] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8437), 1,
      anon_sym_RBRACK,
    STATE(5753), 1,
      sym_heredoc_body,
  [192453] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8439), 1,
      anon_sym_RBRACK,
    STATE(5754), 1,
      sym_heredoc_body,
  [192466] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8441), 1,
      sym__string_end,
    STATE(5755), 1,
      sym_heredoc_body,
  [192479] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6803), 1,
      anon_sym_COLON,
    STATE(5756), 1,
      sym_heredoc_body,
  [192492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8443), 1,
      anon_sym_,
    STATE(5757), 1,
      sym_heredoc_body,
  [192505] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8445), 1,
      anon_sym_RBRACE,
    STATE(5758), 1,
      sym_heredoc_body,
  [192518] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8443), 1,
      sym_uninterpreted,
    STATE(5759), 1,
      sym_heredoc_body,
  [192531] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8447), 1,
      anon_sym_end,
    STATE(5760), 1,
      sym_heredoc_body,
  [192544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8449), 1,
      anon_sym_EQ,
    STATE(5761), 1,
      sym_heredoc_body,
  [192557] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7741), 1,
      anon_sym_end,
    STATE(5762), 1,
      sym_heredoc_body,
  [192570] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8451), 1,
      anon_sym_end,
    STATE(5763), 1,
      sym_heredoc_body,
  [192583] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8453), 1,
      anon_sym_end,
    STATE(5764), 1,
      sym_heredoc_body,
  [192596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8455), 1,
      anon_sym_EQ,
    STATE(5765), 1,
      sym_heredoc_body,
  [192609] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8457), 1,
      anon_sym_RBRACE,
    STATE(5766), 1,
      sym_heredoc_body,
  [192622] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8459), 1,
      anon_sym_end,
    STATE(5767), 1,
      sym_heredoc_body,
  [192635] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8461), 1,
      anon_sym_end,
    STATE(5768), 1,
      sym_heredoc_body,
  [192648] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8463), 1,
      anon_sym_end,
    STATE(5769), 1,
      sym_heredoc_body,
  [192661] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8465), 1,
      sym_constant,
    STATE(5770), 1,
      sym_heredoc_body,
  [192674] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8467), 1,
      anon_sym_end,
    STATE(5771), 1,
      sym_heredoc_body,
  [192687] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8469), 1,
      anon_sym_end,
    STATE(5772), 1,
      sym_heredoc_body,
  [192700] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8471), 1,
      anon_sym_end,
    STATE(5773), 1,
      sym_heredoc_body,
  [192713] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8473), 1,
      anon_sym_RBRACE,
    STATE(5774), 1,
      sym_heredoc_body,
  [192726] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7297), 1,
      anon_sym_end,
    STATE(5775), 1,
      sym_heredoc_body,
  [192739] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7735), 1,
      anon_sym_end,
    STATE(5776), 1,
      sym_heredoc_body,
  [192752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8475), 1,
      anon_sym_EQ,
    STATE(5777), 1,
      sym_heredoc_body,
  [192765] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7759), 1,
      anon_sym_end,
    STATE(5778), 1,
      sym_heredoc_body,
  [192778] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8477), 1,
      anon_sym_end,
    STATE(5779), 1,
      sym_heredoc_body,
  [192791] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7176), 1,
      anon_sym_end,
    STATE(5780), 1,
      sym_heredoc_body,
  [192804] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8479), 1,
      anon_sym_end,
    STATE(5781), 1,
      sym_heredoc_body,
  [192817] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym_end,
    STATE(5782), 1,
      sym_heredoc_body,
  [192830] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8483), 1,
      anon_sym_end,
    STATE(5783), 1,
      sym_heredoc_body,
  [192843] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8485), 1,
      anon_sym_end,
    STATE(5784), 1,
      sym_heredoc_body,
  [192856] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8487), 1,
      anon_sym_end,
    STATE(5785), 1,
      sym_heredoc_body,
  [192869] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8489), 1,
      anon_sym_end,
    STATE(5786), 1,
      sym_heredoc_body,
  [192882] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8491), 1,
      anon_sym_end,
    STATE(5787), 1,
      sym_heredoc_body,
  [192895] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8493), 1,
      sym_constant,
    STATE(5788), 1,
      sym_heredoc_body,
  [192908] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8495), 1,
      anon_sym_end,
    STATE(5789), 1,
      sym_heredoc_body,
  [192921] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8497), 1,
      anon_sym_end,
    STATE(5790), 1,
      sym_heredoc_body,
  [192934] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8499), 1,
      anon_sym_end,
    STATE(5791), 1,
      sym_heredoc_body,
  [192947] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8501), 1,
      anon_sym_end,
    STATE(5792), 1,
      sym_heredoc_body,
  [192960] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8503), 1,
      anon_sym_end,
    STATE(5793), 1,
      sym_heredoc_body,
  [192973] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8505), 1,
      anon_sym_end,
    STATE(5794), 1,
      sym_heredoc_body,
  [192986] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8507), 1,
      anon_sym_RBRACE,
    STATE(5795), 1,
      sym_heredoc_body,
  [192999] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8509), 1,
      anon_sym_end,
    STATE(5796), 1,
      sym_heredoc_body,
  [193012] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8511), 1,
      anon_sym_end,
    STATE(5797), 1,
      sym_heredoc_body,
  [193025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8513), 1,
      anon_sym_EQ,
    STATE(5798), 1,
      sym_heredoc_body,
  [193038] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8515), 1,
      anon_sym_end,
    STATE(5799), 1,
      sym_heredoc_body,
  [193051] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8517), 1,
      anon_sym_end,
    STATE(5800), 1,
      sym_heredoc_body,
  [193064] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8519), 1,
      anon_sym_end,
    STATE(5801), 1,
      sym_heredoc_body,
  [193077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8521), 1,
      anon_sym_EQ,
    STATE(5802), 1,
      sym_heredoc_body,
  [193090] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7692), 1,
      anon_sym_end,
    STATE(5803), 1,
      sym_heredoc_body,
  [193103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8523), 1,
      anon_sym_EQ,
    STATE(5804), 1,
      sym_heredoc_body,
  [193116] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8525), 1,
      anon_sym_RBRACK,
    STATE(5805), 1,
      sym_heredoc_body,
  [193129] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6673), 1,
      anon_sym_COLON,
    STATE(5806), 1,
      sym_heredoc_body,
  [193142] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8527), 1,
      anon_sym_end,
    STATE(5807), 1,
      sym_heredoc_body,
  [193155] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8529), 1,
      sym_constant,
    STATE(5808), 1,
      sym_heredoc_body,
  [193168] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8531), 1,
      anon_sym_RBRACE,
    STATE(5809), 1,
      sym_heredoc_body,
  [193181] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8533), 1,
      anon_sym_end,
    STATE(5810), 1,
      sym_heredoc_body,
  [193194] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7069), 1,
      anon_sym_COLON,
    STATE(5811), 1,
      sym_heredoc_body,
  [193207] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8535), 1,
      anon_sym_end,
    STATE(5812), 1,
      sym_heredoc_body,
  [193220] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8537), 1,
      anon_sym_RBRACE,
    STATE(5813), 1,
      sym_heredoc_body,
  [193233] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8539), 1,
      anon_sym_end,
    STATE(5814), 1,
      sym_heredoc_body,
  [193246] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8541), 1,
      sym__string_end,
    STATE(5815), 1,
      sym_heredoc_body,
  [193259] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7706), 1,
      anon_sym_end,
    STATE(5816), 1,
      sym_heredoc_body,
  [193272] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8543), 1,
      anon_sym_end,
    STATE(5817), 1,
      sym_heredoc_body,
  [193285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8545), 1,
      anon_sym_EQ,
    STATE(5818), 1,
      sym_heredoc_body,
  [193298] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8547), 1,
      anon_sym_end,
    STATE(5819), 1,
      sym_heredoc_body,
  [193311] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7286), 1,
      anon_sym_end,
    STATE(5820), 1,
      sym_heredoc_body,
  [193324] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8549), 1,
      anon_sym_end,
    STATE(5821), 1,
      sym_heredoc_body,
  [193337] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8551), 1,
      anon_sym_end,
    STATE(5822), 1,
      sym_heredoc_body,
  [193350] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8553), 1,
      anon_sym_end,
    STATE(5823), 1,
      sym_heredoc_body,
  [193363] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8555), 1,
      anon_sym_end,
    STATE(5824), 1,
      sym_heredoc_body,
  [193376] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8557), 1,
      anon_sym_RBRACE,
    STATE(5825), 1,
      sym_heredoc_body,
  [193389] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8559), 1,
      anon_sym_RPAREN,
    STATE(5826), 1,
      sym_heredoc_body,
  [193402] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8275), 1,
      anon_sym_RBRACK,
    STATE(5827), 1,
      sym_heredoc_body,
  [193415] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8561), 1,
      anon_sym_end,
    STATE(5828), 1,
      sym_heredoc_body,
  [193428] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8563), 1,
      sym_constant,
    STATE(5829), 1,
      sym_heredoc_body,
  [193441] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8565), 1,
      anon_sym_end,
    STATE(5830), 1,
      sym_heredoc_body,
  [193454] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8567), 1,
      anon_sym_RBRACK,
    STATE(5831), 1,
      sym_heredoc_body,
  [193467] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8569), 1,
      anon_sym_RBRACK,
    STATE(5832), 1,
      sym_heredoc_body,
  [193480] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8571), 1,
      anon_sym_end,
    STATE(5833), 1,
      sym_heredoc_body,
  [193493] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8573), 1,
      anon_sym_end,
    STATE(5834), 1,
      sym_heredoc_body,
  [193506] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8575), 1,
      anon_sym_end,
    STATE(5835), 1,
      sym_heredoc_body,
  [193519] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8577), 1,
      sym_identifier,
    STATE(5836), 1,
      sym_heredoc_body,
  [193532] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8579), 1,
      sym_identifier,
    STATE(5837), 1,
      sym_heredoc_body,
  [193545] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8581), 1,
      anon_sym_RBRACE,
    STATE(5838), 1,
      sym_heredoc_body,
  [193558] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8583), 1,
      anon_sym_end,
    STATE(5839), 1,
      sym_heredoc_body,
  [193571] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8585), 1,
      anon_sym_end,
    STATE(5840), 1,
      sym_heredoc_body,
  [193584] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8587), 1,
      anon_sym_end,
    STATE(5841), 1,
      sym_heredoc_body,
  [193597] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8589), 1,
      anon_sym_end,
    STATE(5842), 1,
      sym_heredoc_body,
  [193610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8591), 1,
      anon_sym_EQ,
    STATE(5843), 1,
      sym_heredoc_body,
  [193623] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8593), 1,
      sym__string_end,
    STATE(5844), 1,
      sym_heredoc_body,
  [193636] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8595), 1,
      anon_sym_RBRACE,
    STATE(5845), 1,
      sym_heredoc_body,
  [193649] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8597), 1,
      anon_sym_end,
    STATE(5846), 1,
      sym_heredoc_body,
  [193662] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8599), 1,
      anon_sym_end,
    STATE(5847), 1,
      sym_heredoc_body,
  [193675] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8601), 1,
      sym_identifier,
    STATE(5848), 1,
      sym_heredoc_body,
  [193688] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8603), 1,
      anon_sym_end,
    STATE(5849), 1,
      sym_heredoc_body,
  [193701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8605), 1,
      anon_sym_EQ,
    STATE(5850), 1,
      sym_heredoc_body,
  [193714] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8607), 1,
      anon_sym_end,
    STATE(5851), 1,
      sym_heredoc_body,
  [193727] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8609), 1,
      anon_sym_end,
    STATE(5852), 1,
      sym_heredoc_body,
  [193740] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8611), 1,
      anon_sym_end,
    STATE(5853), 1,
      sym_heredoc_body,
  [193753] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8613), 1,
      sym_constant,
    STATE(5854), 1,
      sym_heredoc_body,
  [193766] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8615), 1,
      anon_sym_end,
    STATE(5855), 1,
      sym_heredoc_body,
  [193779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8617), 1,
      anon_sym_EQ,
    STATE(5856), 1,
      sym_heredoc_body,
  [193792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8619), 1,
      anon_sym_EQ,
    STATE(5857), 1,
      sym_heredoc_body,
  [193805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8621), 1,
      anon_sym_EQ,
    STATE(5858), 1,
      sym_heredoc_body,
  [193818] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8623), 1,
      anon_sym_RBRACK,
    STATE(5859), 1,
      sym_heredoc_body,
  [193831] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8625), 1,
      sym__string_end,
    STATE(5860), 1,
      sym_heredoc_body,
  [193844] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8627), 1,
      sym_constant,
    STATE(5861), 1,
      sym_heredoc_body,
  [193857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8629), 1,
      anon_sym_EQ,
    STATE(5862), 1,
      sym_heredoc_body,
  [193870] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8631), 1,
      anon_sym_LBRACE,
    STATE(5863), 1,
      sym_heredoc_body,
  [193883] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8633), 1,
      anon_sym_end,
    STATE(5864), 1,
      sym_heredoc_body,
  [193896] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8635), 1,
      anon_sym_RBRACK,
    STATE(5865), 1,
      sym_heredoc_body,
  [193909] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7771), 1,
      anon_sym_end,
    STATE(5866), 1,
      sym_heredoc_body,
  [193922] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8637), 1,
      anon_sym_RBRACE,
    STATE(5867), 1,
      sym_heredoc_body,
  [193935] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8639), 1,
      anon_sym_RBRACK,
    STATE(5868), 1,
      sym_heredoc_body,
  [193948] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8641), 1,
      anon_sym_RPAREN,
    STATE(5869), 1,
      sym_heredoc_body,
  [193961] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8643), 1,
      anon_sym_end,
    STATE(5870), 1,
      sym_heredoc_body,
  [193974] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8645), 1,
      anon_sym_RBRACE,
    STATE(5871), 1,
      sym_heredoc_body,
  [193987] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8647), 1,
      anon_sym_COLON,
    STATE(5872), 1,
      sym_heredoc_body,
  [194000] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8649), 1,
      anon_sym_COLON,
    STATE(5873), 1,
      sym_heredoc_body,
  [194013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8651), 1,
      anon_sym_EQ,
    STATE(5874), 1,
      sym_heredoc_body,
  [194026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8653), 1,
      anon_sym_EQ,
    STATE(5875), 1,
      sym_heredoc_body,
  [194039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8655), 1,
      anon_sym_EQ,
    STATE(5876), 1,
      sym_heredoc_body,
  [194052] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8657), 1,
      anon_sym_RBRACE,
    STATE(5877), 1,
      sym_heredoc_body,
  [194065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8659), 1,
      anon_sym_EQ,
    STATE(5878), 1,
      sym_heredoc_body,
  [194078] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8661), 1,
      anon_sym_COLON,
    STATE(5879), 1,
      sym_heredoc_body,
  [194091] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8663), 1,
      anon_sym_RBRACE,
    STATE(5880), 1,
      sym_heredoc_body,
  [194104] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8665), 1,
      anon_sym_end,
    STATE(5881), 1,
      sym_heredoc_body,
  [194117] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8667), 1,
      sym__string_end,
    STATE(5882), 1,
      sym_heredoc_body,
  [194130] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8669), 1,
      sym__string_end,
    STATE(5883), 1,
      sym_heredoc_body,
  [194143] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8671), 1,
      anon_sym_RBRACE,
    STATE(5884), 1,
      sym_heredoc_body,
  [194156] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8673), 1,
      anon_sym_end,
    STATE(5885), 1,
      sym_heredoc_body,
  [194169] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8675), 1,
      anon_sym_end,
    STATE(5886), 1,
      sym_heredoc_body,
  [194182] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8677), 1,
      anon_sym_COLON,
    STATE(5887), 1,
      sym_heredoc_body,
  [194195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8679), 1,
      anon_sym_EQ,
    STATE(5888), 1,
      sym_heredoc_body,
  [194208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8681), 1,
      anon_sym_EQ,
    STATE(5889), 1,
      sym_heredoc_body,
  [194221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8683), 1,
      anon_sym_EQ,
    STATE(5890), 1,
      sym_heredoc_body,
  [194234] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8685), 1,
      anon_sym_end,
    STATE(5891), 1,
      sym_heredoc_body,
  [194247] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8687), 1,
      anon_sym_end,
    STATE(5892), 1,
      sym_heredoc_body,
  [194260] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8689), 1,
      anon_sym_RBRACE,
    STATE(5893), 1,
      sym_heredoc_body,
  [194273] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8691), 1,
      anon_sym_RBRACE,
    STATE(5894), 1,
      sym_heredoc_body,
  [194286] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8693), 1,
      anon_sym_RBRACE,
    STATE(5895), 1,
      sym_heredoc_body,
  [194299] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8695), 1,
      anon_sym_end,
    STATE(5896), 1,
      sym_heredoc_body,
  [194312] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8697), 1,
      anon_sym_end,
    STATE(5897), 1,
      sym_heredoc_body,
  [194325] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7160), 1,
      anon_sym_COLON,
    STATE(5898), 1,
      sym_heredoc_body,
  [194338] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8699), 1,
      anon_sym_end,
    STATE(5899), 1,
      sym_heredoc_body,
  [194351] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8701), 1,
      anon_sym_end,
    STATE(5900), 1,
      sym_heredoc_body,
  [194364] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8703), 1,
      anon_sym_RBRACK,
    STATE(5901), 1,
      sym_heredoc_body,
  [194377] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8705), 1,
      ts_builtin_sym_end,
    STATE(5902), 1,
      sym_heredoc_body,
  [194390] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8707), 1,
      sym_identifier,
    STATE(5903), 1,
      sym_heredoc_body,
  [194403] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8709), 1,
      anon_sym_RBRACE,
    STATE(5904), 1,
      sym_heredoc_body,
  [194416] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8711), 1,
      sym_constant,
    STATE(5905), 1,
      sym_heredoc_body,
  [194429] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8713), 1,
      sym__string_end,
    STATE(5906), 1,
      sym_heredoc_body,
  [194442] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8715), 1,
      anon_sym_RBRACK,
    STATE(5907), 1,
      sym_heredoc_body,
  [194455] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8717), 1,
      anon_sym_EQ,
    STATE(5908), 1,
      sym_heredoc_body,
  [194468] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8719), 1,
      anon_sym_RBRACE,
    STATE(5909), 1,
      sym_heredoc_body,
  [194481] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8721), 1,
      anon_sym_end,
    STATE(5910), 1,
      sym_heredoc_body,
  [194494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8723), 1,
      anon_sym_EQ,
    STATE(5911), 1,
      sym_heredoc_body,
  [194507] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8725), 1,
      anon_sym_end,
    STATE(5912), 1,
      sym_heredoc_body,
  [194520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8727), 1,
      anon_sym_EQ,
    STATE(5913), 1,
      sym_heredoc_body,
  [194533] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8729), 1,
      anon_sym_RBRACE,
    STATE(5914), 1,
      sym_heredoc_body,
  [194546] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8731), 1,
      anon_sym_end,
    STATE(5915), 1,
      sym_heredoc_body,
  [194559] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6999), 1,
      anon_sym_COLON,
    STATE(5916), 1,
      sym_heredoc_body,
  [194572] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8733), 1,
      sym_constant,
    STATE(5917), 1,
      sym_heredoc_body,
  [194585] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8735), 1,
      anon_sym_end,
    STATE(5918), 1,
      sym_heredoc_body,
  [194598] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_end,
    STATE(5919), 1,
      sym_heredoc_body,
  [194611] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8737), 1,
      anon_sym_end,
    STATE(5920), 1,
      sym_heredoc_body,
  [194624] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8739), 1,
      anon_sym_end,
    STATE(5921), 1,
      sym_heredoc_body,
  [194637] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8741), 1,
      anon_sym_end,
    STATE(5922), 1,
      sym_heredoc_body,
  [194650] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8743), 1,
      anon_sym_end,
    STATE(5923), 1,
      sym_heredoc_body,
  [194663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8745), 1,
      anon_sym_EQ,
    STATE(5924), 1,
      sym_heredoc_body,
  [194676] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8747), 1,
      anon_sym_end,
    STATE(5925), 1,
      sym_heredoc_body,
  [194689] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8749), 1,
      anon_sym_EQ,
    STATE(5926), 1,
      sym_heredoc_body,
  [194702] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_end,
    STATE(5927), 1,
      sym_heredoc_body,
  [194715] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8753), 1,
      anon_sym_end,
    STATE(5928), 1,
      sym_heredoc_body,
  [194728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8755), 1,
      anon_sym_EQ,
    STATE(5929), 1,
      sym_heredoc_body,
  [194741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8757), 1,
      anon_sym_EQ,
    STATE(5930), 1,
      sym_heredoc_body,
  [194754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8759), 1,
      anon_sym_EQ,
    STATE(5931), 1,
      sym_heredoc_body,
  [194767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8761), 1,
      anon_sym_EQ,
    STATE(5932), 1,
      sym_heredoc_body,
  [194780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8763), 1,
      anon_sym_EQ,
    STATE(5933), 1,
      sym_heredoc_body,
  [194793] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2618), 1,
      anon_sym_COLON,
    STATE(5934), 1,
      sym_heredoc_body,
  [194806] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8765), 1,
      anon_sym_end,
    STATE(5935), 1,
      sym_heredoc_body,
  [194819] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2646), 1,
      anon_sym_COLON,
    STATE(5936), 1,
      sym_heredoc_body,
  [194832] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8767), 1,
      anon_sym_RBRACE,
    STATE(5937), 1,
      sym_heredoc_body,
  [194845] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8769), 1,
      anon_sym_end,
    STATE(5938), 1,
      sym_heredoc_body,
  [194858] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7784), 1,
      anon_sym_end,
    STATE(5939), 1,
      sym_heredoc_body,
  [194871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8771), 1,
      anon_sym_EQ,
    STATE(5940), 1,
      sym_heredoc_body,
  [194884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8773), 1,
      anon_sym_,
    STATE(5941), 1,
      sym_heredoc_body,
  [194897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8773), 1,
      sym_uninterpreted,
    STATE(5942), 1,
      sym_heredoc_body,
  [194910] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8775), 1,
      anon_sym_COLON,
    STATE(5943), 1,
      sym_heredoc_body,
  [194923] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8777), 1,
      anon_sym_end,
    STATE(5944), 1,
      sym_heredoc_body,
  [194936] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8779), 1,
      anon_sym_end,
    STATE(5945), 1,
      sym_heredoc_body,
  [194949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8781), 1,
      anon_sym_EQ,
    STATE(5946), 1,
      sym_heredoc_body,
  [194962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8783), 1,
      anon_sym_EQ,
    STATE(5947), 1,
      sym_heredoc_body,
  [194975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8785), 1,
      anon_sym_EQ,
    STATE(5948), 1,
      sym_heredoc_body,
  [194988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8787), 1,
      anon_sym_EQ,
    STATE(5949), 1,
      sym_heredoc_body,
  [195001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8789), 1,
      anon_sym_EQ,
    STATE(5950), 1,
      sym_heredoc_body,
  [195014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8791), 1,
      anon_sym_EQ,
    STATE(5951), 1,
      sym_heredoc_body,
  [195027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8793), 1,
      anon_sym_EQ,
    STATE(5952), 1,
      sym_heredoc_body,
  [195040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8795), 1,
      anon_sym_EQ,
    STATE(5953), 1,
      sym_heredoc_body,
  [195053] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8797), 1,
      sym_identifier,
    STATE(5954), 1,
      sym_heredoc_body,
  [195066] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8799), 1,
      anon_sym_end,
    STATE(5955), 1,
      sym_heredoc_body,
  [195079] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8801), 1,
      anon_sym_COLON,
    STATE(5956), 1,
      sym_heredoc_body,
  [195092] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8803), 1,
      anon_sym_end,
    STATE(5957), 1,
      sym_heredoc_body,
  [195105] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8805), 1,
      sym_constant,
    STATE(5958), 1,
      sym_heredoc_body,
  [195118] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8807), 1,
      anon_sym_end,
    STATE(5959), 1,
      sym_heredoc_body,
  [195131] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8809), 1,
      sym_identifier,
    STATE(5960), 1,
      sym_heredoc_body,
  [195144] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7208), 1,
      anon_sym_end,
    STATE(5961), 1,
      sym_heredoc_body,
  [195157] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8811), 1,
      anon_sym_end,
    STATE(5962), 1,
      sym_heredoc_body,
  [195170] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8813), 1,
      anon_sym_end,
    STATE(5963), 1,
      sym_heredoc_body,
  [195183] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8815), 1,
      sym_identifier,
    STATE(5964), 1,
      sym_heredoc_body,
  [195196] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8817), 1,
      sym_constant,
    STATE(5965), 1,
      sym_heredoc_body,
  [195209] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8819), 1,
      sym_identifier,
    STATE(5966), 1,
      sym_heredoc_body,
  [195222] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8821), 1,
      anon_sym_RPAREN,
    STATE(5967), 1,
      sym_heredoc_body,
  [195235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8823), 1,
      anon_sym_EQ,
    STATE(5968), 1,
      sym_heredoc_body,
  [195248] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7743), 1,
      anon_sym_end,
    STATE(5969), 1,
      sym_heredoc_body,
  [195261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8825), 1,
      anon_sym_EQ,
    STATE(5970), 1,
      sym_heredoc_body,
  [195274] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7024), 1,
      anon_sym_COLON,
    STATE(5971), 1,
      sym_heredoc_body,
  [195287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8827), 1,
      anon_sym_EQ,
    STATE(5972), 1,
      sym_heredoc_body,
  [195300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8829), 1,
      anon_sym_EQ,
    STATE(5973), 1,
      sym_heredoc_body,
  [195313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8831), 1,
      anon_sym_EQ,
    STATE(5974), 1,
      sym_heredoc_body,
  [195326] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8833), 1,
      sym_identifier,
    STATE(5975), 1,
      sym_heredoc_body,
  [195339] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8835), 1,
      anon_sym_COLON,
    STATE(5976), 1,
      sym_heredoc_body,
  [195352] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8837), 1,
      anon_sym_end,
    STATE(5977), 1,
      sym_heredoc_body,
  [195365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8839), 1,
      anon_sym_EQ,
    STATE(5978), 1,
      sym_heredoc_body,
  [195378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8841), 1,
      anon_sym_EQ,
    STATE(5979), 1,
      sym_heredoc_body,
  [195391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8843), 1,
      anon_sym_EQ,
    STATE(5980), 1,
      sym_heredoc_body,
  [195404] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8845), 1,
      sym__string_end,
    STATE(5981), 1,
      sym_heredoc_body,
  [195417] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8847), 1,
      anon_sym_RPAREN,
    STATE(5982), 1,
      sym_heredoc_body,
  [195430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8849), 1,
      anon_sym_EQ,
    STATE(5983), 1,
      sym_heredoc_body,
  [195443] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8851), 1,
      ts_builtin_sym_end,
    STATE(5984), 1,
      sym_heredoc_body,
  [195456] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8853), 1,
      anon_sym_RBRACE,
    STATE(5985), 1,
      sym_heredoc_body,
  [195469] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8855), 1,
      anon_sym_end,
    STATE(5986), 1,
      sym_heredoc_body,
  [195482] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8857), 1,
      anon_sym_COLON,
    STATE(5987), 1,
      sym_heredoc_body,
  [195495] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8859), 1,
      anon_sym_end,
    STATE(5988), 1,
      sym_heredoc_body,
  [195508] = 1,
    ACTIONS(8861), 1,
      ts_builtin_sym_end,
  [195512] = 1,
    ACTIONS(8863), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2172)] = 0,
  [SMALL_STATE(2173)] = 87,
  [SMALL_STATE(2174)] = 174,
  [SMALL_STATE(2175)] = 248,
  [SMALL_STATE(2176)] = 328,
  [SMALL_STATE(2177)] = 406,
  [SMALL_STATE(2178)] = 486,
  [SMALL_STATE(2179)] = 568,
  [SMALL_STATE(2180)] = 648,
  [SMALL_STATE(2181)] = 726,
  [SMALL_STATE(2182)] = 808,
  [SMALL_STATE(2183)] = 886,
  [SMALL_STATE(2184)] = 966,
  [SMALL_STATE(2185)] = 1048,
  [SMALL_STATE(2186)] = 1126,
  [SMALL_STATE(2187)] = 1269,
  [SMALL_STATE(2188)] = 1352,
  [SMALL_STATE(2189)] = 1495,
  [SMALL_STATE(2190)] = 1638,
  [SMALL_STATE(2191)] = 1715,
  [SMALL_STATE(2192)] = 1800,
  [SMALL_STATE(2193)] = 1875,
  [SMALL_STATE(2194)] = 1954,
  [SMALL_STATE(2195)] = 2029,
  [SMALL_STATE(2196)] = 2172,
  [SMALL_STATE(2197)] = 2315,
  [SMALL_STATE(2198)] = 2394,
  [SMALL_STATE(2199)] = 2472,
  [SMALL_STATE(2200)] = 2554,
  [SMALL_STATE(2201)] = 2628,
  [SMALL_STATE(2202)] = 2704,
  [SMALL_STATE(2203)] = 2782,
  [SMALL_STATE(2204)] = 2854,
  [SMALL_STATE(2205)] = 2926,
  [SMALL_STATE(2206)] = 3004,
  [SMALL_STATE(2207)] = 3084,
  [SMALL_STATE(2208)] = 3160,
  [SMALL_STATE(2209)] = 3240,
  [SMALL_STATE(2210)] = 3312,
  [SMALL_STATE(2211)] = 3392,
  [SMALL_STATE(2212)] = 3464,
  [SMALL_STATE(2213)] = 3542,
  [SMALL_STATE(2214)] = 3620,
  [SMALL_STATE(2215)] = 3700,
  [SMALL_STATE(2216)] = 3778,
  [SMALL_STATE(2217)] = 3850,
  [SMALL_STATE(2218)] = 3922,
  [SMALL_STATE(2219)] = 3994,
  [SMALL_STATE(2220)] = 4076,
  [SMALL_STATE(2221)] = 4148,
  [SMALL_STATE(2222)] = 4223,
  [SMALL_STATE(2223)] = 4294,
  [SMALL_STATE(2224)] = 4371,
  [SMALL_STATE(2225)] = 4442,
  [SMALL_STATE(2226)] = 4517,
  [SMALL_STATE(2227)] = 4588,
  [SMALL_STATE(2228)] = 4659,
  [SMALL_STATE(2229)] = 4730,
  [SMALL_STATE(2230)] = 4801,
  [SMALL_STATE(2231)] = 4872,
  [SMALL_STATE(2232)] = 4943,
  [SMALL_STATE(2233)] = 5014,
  [SMALL_STATE(2234)] = 5089,
  [SMALL_STATE(2235)] = 5160,
  [SMALL_STATE(2236)] = 5239,
  [SMALL_STATE(2237)] = 5314,
  [SMALL_STATE(2238)] = 5385,
  [SMALL_STATE(2239)] = 5456,
  [SMALL_STATE(2240)] = 5527,
  [SMALL_STATE(2241)] = 5598,
  [SMALL_STATE(2242)] = 5677,
  [SMALL_STATE(2243)] = 5752,
  [SMALL_STATE(2244)] = 5823,
  [SMALL_STATE(2245)] = 5900,
  [SMALL_STATE(2246)] = 5975,
  [SMALL_STATE(2247)] = 6054,
  [SMALL_STATE(2248)] = 6125,
  [SMALL_STATE(2249)] = 6196,
  [SMALL_STATE(2250)] = 6271,
  [SMALL_STATE(2251)] = 6342,
  [SMALL_STATE(2252)] = 6413,
  [SMALL_STATE(2253)] = 6484,
  [SMALL_STATE(2254)] = 6555,
  [SMALL_STATE(2255)] = 6626,
  [SMALL_STATE(2256)] = 6703,
  [SMALL_STATE(2257)] = 6780,
  [SMALL_STATE(2258)] = 6851,
  [SMALL_STATE(2259)] = 6928,
  [SMALL_STATE(2260)] = 6999,
  [SMALL_STATE(2261)] = 7070,
  [SMALL_STATE(2262)] = 7141,
  [SMALL_STATE(2263)] = 7219,
  [SMALL_STATE(2264)] = 7291,
  [SMALL_STATE(2265)] = 7361,
  [SMALL_STATE(2266)] = 7433,
  [SMALL_STATE(2267)] = 7503,
  [SMALL_STATE(2268)] = 7579,
  [SMALL_STATE(2269)] = 7693,
  [SMALL_STATE(2270)] = 7773,
  [SMALL_STATE(2271)] = 7843,
  [SMALL_STATE(2272)] = 7919,
  [SMALL_STATE(2273)] = 7991,
  [SMALL_STATE(2274)] = 8060,
  [SMALL_STATE(2275)] = 8129,
  [SMALL_STATE(2276)] = 8200,
  [SMALL_STATE(2277)] = 8269,
  [SMALL_STATE(2278)] = 8338,
  [SMALL_STATE(2279)] = 8407,
  [SMALL_STATE(2280)] = 8476,
  [SMALL_STATE(2281)] = 8551,
  [SMALL_STATE(2282)] = 8622,
  [SMALL_STATE(2283)] = 8691,
  [SMALL_STATE(2284)] = 8760,
  [SMALL_STATE(2285)] = 8829,
  [SMALL_STATE(2286)] = 8898,
  [SMALL_STATE(2287)] = 8973,
  [SMALL_STATE(2288)] = 9042,
  [SMALL_STATE(2289)] = 9111,
  [SMALL_STATE(2290)] = 9180,
  [SMALL_STATE(2291)] = 9249,
  [SMALL_STATE(2292)] = 9318,
  [SMALL_STATE(2293)] = 9387,
  [SMALL_STATE(2294)] = 9456,
  [SMALL_STATE(2295)] = 9525,
  [SMALL_STATE(2296)] = 9594,
  [SMALL_STATE(2297)] = 9669,
  [SMALL_STATE(2298)] = 9738,
  [SMALL_STATE(2299)] = 9807,
  [SMALL_STATE(2300)] = 9876,
  [SMALL_STATE(2301)] = 9945,
  [SMALL_STATE(2302)] = 10014,
  [SMALL_STATE(2303)] = 10083,
  [SMALL_STATE(2304)] = 10152,
  [SMALL_STATE(2305)] = 10221,
  [SMALL_STATE(2306)] = 10290,
  [SMALL_STATE(2307)] = 10359,
  [SMALL_STATE(2308)] = 10428,
  [SMALL_STATE(2309)] = 10497,
  [SMALL_STATE(2310)] = 10570,
  [SMALL_STATE(2311)] = 10639,
  [SMALL_STATE(2312)] = 10708,
  [SMALL_STATE(2313)] = 10777,
  [SMALL_STATE(2314)] = 10852,
  [SMALL_STATE(2315)] = 10921,
  [SMALL_STATE(2316)] = 10990,
  [SMALL_STATE(2317)] = 11059,
  [SMALL_STATE(2318)] = 11128,
  [SMALL_STATE(2319)] = 11197,
  [SMALL_STATE(2320)] = 11266,
  [SMALL_STATE(2321)] = 11335,
  [SMALL_STATE(2322)] = 11404,
  [SMALL_STATE(2323)] = 11473,
  [SMALL_STATE(2324)] = 11542,
  [SMALL_STATE(2325)] = 11611,
  [SMALL_STATE(2326)] = 11680,
  [SMALL_STATE(2327)] = 11749,
  [SMALL_STATE(2328)] = 11818,
  [SMALL_STATE(2329)] = 11887,
  [SMALL_STATE(2330)] = 11956,
  [SMALL_STATE(2331)] = 12025,
  [SMALL_STATE(2332)] = 12094,
  [SMALL_STATE(2333)] = 12163,
  [SMALL_STATE(2334)] = 12232,
  [SMALL_STATE(2335)] = 12301,
  [SMALL_STATE(2336)] = 12370,
  [SMALL_STATE(2337)] = 12439,
  [SMALL_STATE(2338)] = 12508,
  [SMALL_STATE(2339)] = 12577,
  [SMALL_STATE(2340)] = 12646,
  [SMALL_STATE(2341)] = 12715,
  [SMALL_STATE(2342)] = 12784,
  [SMALL_STATE(2343)] = 12853,
  [SMALL_STATE(2344)] = 12924,
  [SMALL_STATE(2345)] = 13001,
  [SMALL_STATE(2346)] = 13072,
  [SMALL_STATE(2347)] = 13141,
  [SMALL_STATE(2348)] = 13210,
  [SMALL_STATE(2349)] = 13279,
  [SMALL_STATE(2350)] = 13348,
  [SMALL_STATE(2351)] = 13417,
  [SMALL_STATE(2352)] = 13486,
  [SMALL_STATE(2353)] = 13555,
  [SMALL_STATE(2354)] = 13624,
  [SMALL_STATE(2355)] = 13693,
  [SMALL_STATE(2356)] = 13762,
  [SMALL_STATE(2357)] = 13833,
  [SMALL_STATE(2358)] = 13902,
  [SMALL_STATE(2359)] = 13971,
  [SMALL_STATE(2360)] = 14040,
  [SMALL_STATE(2361)] = 14109,
  [SMALL_STATE(2362)] = 14178,
  [SMALL_STATE(2363)] = 14247,
  [SMALL_STATE(2364)] = 14316,
  [SMALL_STATE(2365)] = 14385,
  [SMALL_STATE(2366)] = 14454,
  [SMALL_STATE(2367)] = 14523,
  [SMALL_STATE(2368)] = 14592,
  [SMALL_STATE(2369)] = 14661,
  [SMALL_STATE(2370)] = 14730,
  [SMALL_STATE(2371)] = 14799,
  [SMALL_STATE(2372)] = 14874,
  [SMALL_STATE(2373)] = 14943,
  [SMALL_STATE(2374)] = 15012,
  [SMALL_STATE(2375)] = 15081,
  [SMALL_STATE(2376)] = 15150,
  [SMALL_STATE(2377)] = 15225,
  [SMALL_STATE(2378)] = 15294,
  [SMALL_STATE(2379)] = 15363,
  [SMALL_STATE(2380)] = 15432,
  [SMALL_STATE(2381)] = 15501,
  [SMALL_STATE(2382)] = 15570,
  [SMALL_STATE(2383)] = 15645,
  [SMALL_STATE(2384)] = 15714,
  [SMALL_STATE(2385)] = 15783,
  [SMALL_STATE(2386)] = 15852,
  [SMALL_STATE(2387)] = 15921,
  [SMALL_STATE(2388)] = 15990,
  [SMALL_STATE(2389)] = 16059,
  [SMALL_STATE(2390)] = 16128,
  [SMALL_STATE(2391)] = 16197,
  [SMALL_STATE(2392)] = 16266,
  [SMALL_STATE(2393)] = 16335,
  [SMALL_STATE(2394)] = 16404,
  [SMALL_STATE(2395)] = 16473,
  [SMALL_STATE(2396)] = 16542,
  [SMALL_STATE(2397)] = 16611,
  [SMALL_STATE(2398)] = 16680,
  [SMALL_STATE(2399)] = 16749,
  [SMALL_STATE(2400)] = 16818,
  [SMALL_STATE(2401)] = 16887,
  [SMALL_STATE(2402)] = 16956,
  [SMALL_STATE(2403)] = 17025,
  [SMALL_STATE(2404)] = 17094,
  [SMALL_STATE(2405)] = 17163,
  [SMALL_STATE(2406)] = 17234,
  [SMALL_STATE(2407)] = 17303,
  [SMALL_STATE(2408)] = 17372,
  [SMALL_STATE(2409)] = 17443,
  [SMALL_STATE(2410)] = 17512,
  [SMALL_STATE(2411)] = 17581,
  [SMALL_STATE(2412)] = 17650,
  [SMALL_STATE(2413)] = 17719,
  [SMALL_STATE(2414)] = 17788,
  [SMALL_STATE(2415)] = 17857,
  [SMALL_STATE(2416)] = 17926,
  [SMALL_STATE(2417)] = 17995,
  [SMALL_STATE(2418)] = 18064,
  [SMALL_STATE(2419)] = 18133,
  [SMALL_STATE(2420)] = 18206,
  [SMALL_STATE(2421)] = 18275,
  [SMALL_STATE(2422)] = 18346,
  [SMALL_STATE(2423)] = 18415,
  [SMALL_STATE(2424)] = 18484,
  [SMALL_STATE(2425)] = 18553,
  [SMALL_STATE(2426)] = 18622,
  [SMALL_STATE(2427)] = 18691,
  [SMALL_STATE(2428)] = 18760,
  [SMALL_STATE(2429)] = 18829,
  [SMALL_STATE(2430)] = 18898,
  [SMALL_STATE(2431)] = 18967,
  [SMALL_STATE(2432)] = 19036,
  [SMALL_STATE(2433)] = 19105,
  [SMALL_STATE(2434)] = 19174,
  [SMALL_STATE(2435)] = 19249,
  [SMALL_STATE(2436)] = 19318,
  [SMALL_STATE(2437)] = 19387,
  [SMALL_STATE(2438)] = 19456,
  [SMALL_STATE(2439)] = 19528,
  [SMALL_STATE(2440)] = 19602,
  [SMALL_STATE(2441)] = 19676,
  [SMALL_STATE(2442)] = 19748,
  [SMALL_STATE(2443)] = 19818,
  [SMALL_STATE(2444)] = 19894,
  [SMALL_STATE(2445)] = 19968,
  [SMALL_STATE(2446)] = 20042,
  [SMALL_STATE(2447)] = 20118,
  [SMALL_STATE(2448)] = 20192,
  [SMALL_STATE(2449)] = 20266,
  [SMALL_STATE(2450)] = 20340,
  [SMALL_STATE(2451)] = 20439,
  [SMALL_STATE(2452)] = 20514,
  [SMALL_STATE(2453)] = 20587,
  [SMALL_STATE(2454)] = 20686,
  [SMALL_STATE(2455)] = 20785,
  [SMALL_STATE(2456)] = 20884,
  [SMALL_STATE(2457)] = 20983,
  [SMALL_STATE(2458)] = 21056,
  [SMALL_STATE(2459)] = 21127,
  [SMALL_STATE(2460)] = 21196,
  [SMALL_STATE(2461)] = 21295,
  [SMALL_STATE(2462)] = 21362,
  [SMALL_STATE(2463)] = 21461,
  [SMALL_STATE(2464)] = 21560,
  [SMALL_STATE(2465)] = 21663,
  [SMALL_STATE(2466)] = 21738,
  [SMALL_STATE(2467)] = 21813,
  [SMALL_STATE(2468)] = 21912,
  [SMALL_STATE(2469)] = 22011,
  [SMALL_STATE(2470)] = 22110,
  [SMALL_STATE(2471)] = 22209,
  [SMALL_STATE(2472)] = 22308,
  [SMALL_STATE(2473)] = 22407,
  [SMALL_STATE(2474)] = 22476,
  [SMALL_STATE(2475)] = 22575,
  [SMALL_STATE(2476)] = 22648,
  [SMALL_STATE(2477)] = 22747,
  [SMALL_STATE(2478)] = 22816,
  [SMALL_STATE(2479)] = 22915,
  [SMALL_STATE(2480)] = 23014,
  [SMALL_STATE(2481)] = 23085,
  [SMALL_STATE(2482)] = 23158,
  [SMALL_STATE(2483)] = 23257,
  [SMALL_STATE(2484)] = 23356,
  [SMALL_STATE(2485)] = 23455,
  [SMALL_STATE(2486)] = 23530,
  [SMALL_STATE(2487)] = 23599,
  [SMALL_STATE(2488)] = 23698,
  [SMALL_STATE(2489)] = 23797,
  [SMALL_STATE(2490)] = 23896,
  [SMALL_STATE(2491)] = 23986,
  [SMALL_STATE(2492)] = 24062,
  [SMALL_STATE(2493)] = 24162,
  [SMALL_STATE(2494)] = 24250,
  [SMALL_STATE(2495)] = 24322,
  [SMALL_STATE(2496)] = 24410,
  [SMALL_STATE(2497)] = 24508,
  [SMALL_STATE(2498)] = 24576,
  [SMALL_STATE(2499)] = 24644,
  [SMALL_STATE(2500)] = 24742,
  [SMALL_STATE(2501)] = 24816,
  [SMALL_STATE(2502)] = 24914,
  [SMALL_STATE(2503)] = 25012,
  [SMALL_STATE(2504)] = 25086,
  [SMALL_STATE(2505)] = 25166,
  [SMALL_STATE(2506)] = 25238,
  [SMALL_STATE(2507)] = 25334,
  [SMALL_STATE(2508)] = 25432,
  [SMALL_STATE(2509)] = 25530,
  [SMALL_STATE(2510)] = 25598,
  [SMALL_STATE(2511)] = 25666,
  [SMALL_STATE(2512)] = 25740,
  [SMALL_STATE(2513)] = 25814,
  [SMALL_STATE(2514)] = 25910,
  [SMALL_STATE(2515)] = 26008,
  [SMALL_STATE(2516)] = 26076,
  [SMALL_STATE(2517)] = 26148,
  [SMALL_STATE(2518)] = 26216,
  [SMALL_STATE(2519)] = 26316,
  [SMALL_STATE(2520)] = 26386,
  [SMALL_STATE(2521)] = 26454,
  [SMALL_STATE(2522)] = 26522,
  [SMALL_STATE(2523)] = 26590,
  [SMALL_STATE(2524)] = 26664,
  [SMALL_STATE(2525)] = 26733,
  [SMALL_STATE(2526)] = 26806,
  [SMALL_STATE(2527)] = 26879,
  [SMALL_STATE(2528)] = 26950,
  [SMALL_STATE(2529)] = 27015,
  [SMALL_STATE(2530)] = 27080,
  [SMALL_STATE(2531)] = 27145,
  [SMALL_STATE(2532)] = 27218,
  [SMALL_STATE(2533)] = 27291,
  [SMALL_STATE(2534)] = 27356,
  [SMALL_STATE(2535)] = 27425,
  [SMALL_STATE(2536)] = 27496,
  [SMALL_STATE(2537)] = 27603,
  [SMALL_STATE(2538)] = 27668,
  [SMALL_STATE(2539)] = 27741,
  [SMALL_STATE(2540)] = 27806,
  [SMALL_STATE(2541)] = 27909,
  [SMALL_STATE(2542)] = 27974,
  [SMALL_STATE(2543)] = 28075,
  [SMALL_STATE(2544)] = 28142,
  [SMALL_STATE(2545)] = 28215,
  [SMALL_STATE(2546)] = 28282,
  [SMALL_STATE(2547)] = 28348,
  [SMALL_STATE(2548)] = 28414,
  [SMALL_STATE(2549)] = 28512,
  [SMALL_STATE(2550)] = 28578,
  [SMALL_STATE(2551)] = 28648,
  [SMALL_STATE(2552)] = 28744,
  [SMALL_STATE(2553)] = 28818,
  [SMALL_STATE(2554)] = 28914,
  [SMALL_STATE(2555)] = 29010,
  [SMALL_STATE(2556)] = 29106,
  [SMALL_STATE(2557)] = 29176,
  [SMALL_STATE(2558)] = 29270,
  [SMALL_STATE(2559)] = 29368,
  [SMALL_STATE(2560)] = 29464,
  [SMALL_STATE(2561)] = 29560,
  [SMALL_STATE(2562)] = 29632,
  [SMALL_STATE(2563)] = 29728,
  [SMALL_STATE(2564)] = 29794,
  [SMALL_STATE(2565)] = 29880,
  [SMALL_STATE(2566)] = 29950,
  [SMALL_STATE(2567)] = 30036,
  [SMALL_STATE(2568)] = 30124,
  [SMALL_STATE(2569)] = 30202,
  [SMALL_STATE(2570)] = 30274,
  [SMALL_STATE(2571)] = 30348,
  [SMALL_STATE(2572)] = 30412,
  [SMALL_STATE(2573)] = 30478,
  [SMALL_STATE(2574)] = 30546,
  [SMALL_STATE(2575)] = 30618,
  [SMALL_STATE(2576)] = 30690,
  [SMALL_STATE(2577)] = 30784,
  [SMALL_STATE(2578)] = 30850,
  [SMALL_STATE(2579)] = 30937,
  [SMALL_STATE(2580)] = 31004,
  [SMALL_STATE(2581)] = 31069,
  [SMALL_STATE(2582)] = 31156,
  [SMALL_STATE(2583)] = 31243,
  [SMALL_STATE(2584)] = 31330,
  [SMALL_STATE(2585)] = 31417,
  [SMALL_STATE(2586)] = 31504,
  [SMALL_STATE(2587)] = 31591,
  [SMALL_STATE(2588)] = 31696,
  [SMALL_STATE(2589)] = 31783,
  [SMALL_STATE(2590)] = 31870,
  [SMALL_STATE(2591)] = 31957,
  [SMALL_STATE(2592)] = 32044,
  [SMALL_STATE(2593)] = 32131,
  [SMALL_STATE(2594)] = 32218,
  [SMALL_STATE(2595)] = 32313,
  [SMALL_STATE(2596)] = 32408,
  [SMALL_STATE(2597)] = 32495,
  [SMALL_STATE(2598)] = 32560,
  [SMALL_STATE(2599)] = 32647,
  [SMALL_STATE(2600)] = 32740,
  [SMALL_STATE(2601)] = 32827,
  [SMALL_STATE(2602)] = 32928,
  [SMALL_STATE(2603)] = 33015,
  [SMALL_STATE(2604)] = 33102,
  [SMALL_STATE(2605)] = 33189,
  [SMALL_STATE(2606)] = 33274,
  [SMALL_STATE(2607)] = 33361,
  [SMALL_STATE(2608)] = 33458,
  [SMALL_STATE(2609)] = 33527,
  [SMALL_STATE(2610)] = 33612,
  [SMALL_STATE(2611)] = 33699,
  [SMALL_STATE(2612)] = 33786,
  [SMALL_STATE(2613)] = 33873,
  [SMALL_STATE(2614)] = 33960,
  [SMALL_STATE(2615)] = 34037,
  [SMALL_STATE(2616)] = 34108,
  [SMALL_STATE(2617)] = 34195,
  [SMALL_STATE(2618)] = 34282,
  [SMALL_STATE(2619)] = 34369,
  [SMALL_STATE(2620)] = 34434,
  [SMALL_STATE(2621)] = 34521,
  [SMALL_STATE(2622)] = 34594,
  [SMALL_STATE(2623)] = 34681,
  [SMALL_STATE(2624)] = 34768,
  [SMALL_STATE(2625)] = 34855,
  [SMALL_STATE(2626)] = 34942,
  [SMALL_STATE(2627)] = 35029,
  [SMALL_STATE(2628)] = 35116,
  [SMALL_STATE(2629)] = 35211,
  [SMALL_STATE(2630)] = 35298,
  [SMALL_STATE(2631)] = 35385,
  [SMALL_STATE(2632)] = 35472,
  [SMALL_STATE(2633)] = 35559,
  [SMALL_STATE(2634)] = 35654,
  [SMALL_STATE(2635)] = 35751,
  [SMALL_STATE(2636)] = 35838,
  [SMALL_STATE(2637)] = 35925,
  [SMALL_STATE(2638)] = 35996,
  [SMALL_STATE(2639)] = 36101,
  [SMALL_STATE(2640)] = 36170,
  [SMALL_STATE(2641)] = 36257,
  [SMALL_STATE(2642)] = 36322,
  [SMALL_STATE(2643)] = 36387,
  [SMALL_STATE(2644)] = 36458,
  [SMALL_STATE(2645)] = 36545,
  [SMALL_STATE(2646)] = 36632,
  [SMALL_STATE(2647)] = 36729,
  [SMALL_STATE(2648)] = 36816,
  [SMALL_STATE(2649)] = 36881,
  [SMALL_STATE(2650)] = 36948,
  [SMALL_STATE(2651)] = 37017,
  [SMALL_STATE(2652)] = 37104,
  [SMALL_STATE(2653)] = 37191,
  [SMALL_STATE(2654)] = 37256,
  [SMALL_STATE(2655)] = 37349,
  [SMALL_STATE(2656)] = 37420,
  [SMALL_STATE(2657)] = 37485,
  [SMALL_STATE(2658)] = 37580,
  [SMALL_STATE(2659)] = 37667,
  [SMALL_STATE(2660)] = 37754,
  [SMALL_STATE(2661)] = 37841,
  [SMALL_STATE(2662)] = 37933,
  [SMALL_STATE(2663)] = 37997,
  [SMALL_STATE(2664)] = 38063,
  [SMALL_STATE(2665)] = 38161,
  [SMALL_STATE(2666)] = 38259,
  [SMALL_STATE(2667)] = 38343,
  [SMALL_STATE(2668)] = 38409,
  [SMALL_STATE(2669)] = 38493,
  [SMALL_STATE(2670)] = 38557,
  [SMALL_STATE(2671)] = 38625,
  [SMALL_STATE(2672)] = 38721,
  [SMALL_STATE(2673)] = 38817,
  [SMALL_STATE(2674)] = 38907,
  [SMALL_STATE(2675)] = 38971,
  [SMALL_STATE(2676)] = 39055,
  [SMALL_STATE(2677)] = 39139,
  [SMALL_STATE(2678)] = 39223,
  [SMALL_STATE(2679)] = 39315,
  [SMALL_STATE(2680)] = 39399,
  [SMALL_STATE(2681)] = 39491,
  [SMALL_STATE(2682)] = 39585,
  [SMALL_STATE(2683)] = 39669,
  [SMALL_STATE(2684)] = 39761,
  [SMALL_STATE(2685)] = 39853,
  [SMALL_STATE(2686)] = 39943,
  [SMALL_STATE(2687)] = 40035,
  [SMALL_STATE(2688)] = 40131,
  [SMALL_STATE(2689)] = 40223,
  [SMALL_STATE(2690)] = 40319,
  [SMALL_STATE(2691)] = 40385,
  [SMALL_STATE(2692)] = 40449,
  [SMALL_STATE(2693)] = 40513,
  [SMALL_STATE(2694)] = 40577,
  [SMALL_STATE(2695)] = 40649,
  [SMALL_STATE(2696)] = 40733,
  [SMALL_STATE(2697)] = 40803,
  [SMALL_STATE(2698)] = 40879,
  [SMALL_STATE(2699)] = 40965,
  [SMALL_STATE(2700)] = 41049,
  [SMALL_STATE(2701)] = 41117,
  [SMALL_STATE(2702)] = 41201,
  [SMALL_STATE(2703)] = 41276,
  [SMALL_STATE(2704)] = 41369,
  [SMALL_STATE(2705)] = 41442,
  [SMALL_STATE(2706)] = 41505,
  [SMALL_STATE(2707)] = 41568,
  [SMALL_STATE(2708)] = 41663,
  [SMALL_STATE(2709)] = 41746,
  [SMALL_STATE(2710)] = 41815,
  [SMALL_STATE(2711)] = 41886,
  [SMALL_STATE(2712)] = 41949,
  [SMALL_STATE(2713)] = 42012,
  [SMALL_STATE(2714)] = 42077,
  [SMALL_STATE(2715)] = 42144,
  [SMALL_STATE(2716)] = 42227,
  [SMALL_STATE(2717)] = 42290,
  [SMALL_STATE(2718)] = 42387,
  [SMALL_STATE(2719)] = 42450,
  [SMALL_STATE(2720)] = 42513,
  [SMALL_STATE(2721)] = 42576,
  [SMALL_STATE(2722)] = 42669,
  [SMALL_STATE(2723)] = 42760,
  [SMALL_STATE(2724)] = 42845,
  [SMALL_STATE(2725)] = 42914,
  [SMALL_STATE(2726)] = 43005,
  [SMALL_STATE(2727)] = 43096,
  [SMALL_STATE(2728)] = 43189,
  [SMALL_STATE(2729)] = 43254,
  [SMALL_STATE(2730)] = 43345,
  [SMALL_STATE(2731)] = 43414,
  [SMALL_STATE(2732)] = 43505,
  [SMALL_STATE(2733)] = 43604,
  [SMALL_STATE(2734)] = 43669,
  [SMALL_STATE(2735)] = 43732,
  [SMALL_STATE(2736)] = 43827,
  [SMALL_STATE(2737)] = 43928,
  [SMALL_STATE(2738)] = 43991,
  [SMALL_STATE(2739)] = 44086,
  [SMALL_STATE(2740)] = 44179,
  [SMALL_STATE(2741)] = 44272,
  [SMALL_STATE(2742)] = 44363,
  [SMALL_STATE(2743)] = 44456,
  [SMALL_STATE(2744)] = 44549,
  [SMALL_STATE(2745)] = 44640,
  [SMALL_STATE(2746)] = 44706,
  [SMALL_STATE(2747)] = 44780,
  [SMALL_STATE(2748)] = 44874,
  [SMALL_STATE(2749)] = 44962,
  [SMALL_STATE(2750)] = 45046,
  [SMALL_STATE(2751)] = 45128,
  [SMALL_STATE(2752)] = 45194,
  [SMALL_STATE(2753)] = 45258,
  [SMALL_STATE(2754)] = 45340,
  [SMALL_STATE(2755)] = 45402,
  [SMALL_STATE(2756)] = 45500,
  [SMALL_STATE(2757)] = 45564,
  [SMALL_STATE(2758)] = 45658,
  [SMALL_STATE(2759)] = 45720,
  [SMALL_STATE(2760)] = 45782,
  [SMALL_STATE(2761)] = 45876,
  [SMALL_STATE(2762)] = 45946,
  [SMALL_STATE(2763)] = 46036,
  [SMALL_STATE(2764)] = 46128,
  [SMALL_STATE(2765)] = 46218,
  [SMALL_STATE(2766)] = 46286,
  [SMALL_STATE(2767)] = 46348,
  [SMALL_STATE(2768)] = 46436,
  [SMALL_STATE(2769)] = 46498,
  [SMALL_STATE(2770)] = 46588,
  [SMALL_STATE(2771)] = 46678,
  [SMALL_STATE(2772)] = 46768,
  [SMALL_STATE(2773)] = 46864,
  [SMALL_STATE(2774)] = 46928,
  [SMALL_STATE(2775)] = 46996,
  [SMALL_STATE(2776)] = 47092,
  [SMALL_STATE(2777)] = 47162,
  [SMALL_STATE(2778)] = 47252,
  [SMALL_STATE(2779)] = 47342,
  [SMALL_STATE(2780)] = 47404,
  [SMALL_STATE(2781)] = 47498,
  [SMALL_STATE(2782)] = 47562,
  [SMALL_STATE(2783)] = 47655,
  [SMALL_STATE(2784)] = 47718,
  [SMALL_STATE(2785)] = 47807,
  [SMALL_STATE(2786)] = 47898,
  [SMALL_STATE(2787)] = 47959,
  [SMALL_STATE(2788)] = 48048,
  [SMALL_STATE(2789)] = 48137,
  [SMALL_STATE(2790)] = 48204,
  [SMALL_STATE(2791)] = 48269,
  [SMALL_STATE(2792)] = 48358,
  [SMALL_STATE(2793)] = 48419,
  [SMALL_STATE(2794)] = 48482,
  [SMALL_STATE(2795)] = 48543,
  [SMALL_STATE(2796)] = 48604,
  [SMALL_STATE(2797)] = 48665,
  [SMALL_STATE(2798)] = 48734,
  [SMALL_STATE(2799)] = 48799,
  [SMALL_STATE(2800)] = 48866,
  [SMALL_STATE(2801)] = 48939,
  [SMALL_STATE(2802)] = 49006,
  [SMALL_STATE(2803)] = 49089,
  [SMALL_STATE(2804)] = 49170,
  [SMALL_STATE(2805)] = 49231,
  [SMALL_STATE(2806)] = 49296,
  [SMALL_STATE(2807)] = 49377,
  [SMALL_STATE(2808)] = 49470,
  [SMALL_STATE(2809)] = 49559,
  [SMALL_STATE(2810)] = 49654,
  [SMALL_STATE(2811)] = 49741,
  [SMALL_STATE(2812)] = 49802,
  [SMALL_STATE(2813)] = 49867,
  [SMALL_STATE(2814)] = 49948,
  [SMALL_STATE(2815)] = 50037,
  [SMALL_STATE(2816)] = 50102,
  [SMALL_STATE(2817)] = 50169,
  [SMALL_STATE(2818)] = 50230,
  [SMALL_STATE(2819)] = 50311,
  [SMALL_STATE(2820)] = 50394,
  [SMALL_STATE(2821)] = 50457,
  [SMALL_STATE(2822)] = 50546,
  [SMALL_STATE(2823)] = 50639,
  [SMALL_STATE(2824)] = 50702,
  [SMALL_STATE(2825)] = 50791,
  [SMALL_STATE(2826)] = 50880,
  [SMALL_STATE(2827)] = 50971,
  [SMALL_STATE(2828)] = 51044,
  [SMALL_STATE(2829)] = 51111,
  [SMALL_STATE(2830)] = 51180,
  [SMALL_STATE(2831)] = 51267,
  [SMALL_STATE(2832)] = 51358,
  [SMALL_STATE(2833)] = 51419,
  [SMALL_STATE(2834)] = 51480,
  [SMALL_STATE(2835)] = 51547,
  [SMALL_STATE(2836)] = 51638,
  [SMALL_STATE(2837)] = 51727,
  [SMALL_STATE(2838)] = 51816,
  [SMALL_STATE(2839)] = 51879,
  [SMALL_STATE(2840)] = 51942,
  [SMALL_STATE(2841)] = 52035,
  [SMALL_STATE(2842)] = 52098,
  [SMALL_STATE(2843)] = 52189,
  [SMALL_STATE(2844)] = 52280,
  [SMALL_STATE(2845)] = 52369,
  [SMALL_STATE(2846)] = 52460,
  [SMALL_STATE(2847)] = 52551,
  [SMALL_STATE(2848)] = 52614,
  [SMALL_STATE(2849)] = 52681,
  [SMALL_STATE(2850)] = 52774,
  [SMALL_STATE(2851)] = 52837,
  [SMALL_STATE(2852)] = 52900,
  [SMALL_STATE(2853)] = 52965,
  [SMALL_STATE(2854)] = 53025,
  [SMALL_STATE(2855)] = 53115,
  [SMALL_STATE(2856)] = 53183,
  [SMALL_STATE(2857)] = 53243,
  [SMALL_STATE(2858)] = 53335,
  [SMALL_STATE(2859)] = 53401,
  [SMALL_STATE(2860)] = 53463,
  [SMALL_STATE(2861)] = 53551,
  [SMALL_STATE(2862)] = 53623,
  [SMALL_STATE(2863)] = 53681,
  [SMALL_STATE(2864)] = 53775,
  [SMALL_STATE(2865)] = 53841,
  [SMALL_STATE(2866)] = 53923,
  [SMALL_STATE(2867)] = 53983,
  [SMALL_STATE(2868)] = 54043,
  [SMALL_STATE(2869)] = 54103,
  [SMALL_STATE(2870)] = 54161,
  [SMALL_STATE(2871)] = 54241,
  [SMALL_STATE(2872)] = 54305,
  [SMALL_STATE(2873)] = 54385,
  [SMALL_STATE(2874)] = 54445,
  [SMALL_STATE(2875)] = 54513,
  [SMALL_STATE(2876)] = 54611,
  [SMALL_STATE(2877)] = 54669,
  [SMALL_STATE(2878)] = 54731,
  [SMALL_STATE(2879)] = 54789,
  [SMALL_STATE(2880)] = 54847,
  [SMALL_STATE(2881)] = 54907,
  [SMALL_STATE(2882)] = 54995,
  [SMALL_STATE(2883)] = 55055,
  [SMALL_STATE(2884)] = 55115,
  [SMALL_STATE(2885)] = 55207,
  [SMALL_STATE(2886)] = 55273,
  [SMALL_STATE(2887)] = 55363,
  [SMALL_STATE(2888)] = 55453,
  [SMALL_STATE(2889)] = 55511,
  [SMALL_STATE(2890)] = 55571,
  [SMALL_STATE(2891)] = 55633,
  [SMALL_STATE(2892)] = 55693,
  [SMALL_STATE(2893)] = 55787,
  [SMALL_STATE(2894)] = 55849,
  [SMALL_STATE(2895)] = 55909,
  [SMALL_STATE(2896)] = 55999,
  [SMALL_STATE(2897)] = 56057,
  [SMALL_STATE(2898)] = 56153,
  [SMALL_STATE(2899)] = 56241,
  [SMALL_STATE(2900)] = 56331,
  [SMALL_STATE(2901)] = 56420,
  [SMALL_STATE(2902)] = 56509,
  [SMALL_STATE(2903)] = 56566,
  [SMALL_STATE(2904)] = 56623,
  [SMALL_STATE(2905)] = 56680,
  [SMALL_STATE(2906)] = 56737,
  [SMALL_STATE(2907)] = 56794,
  [SMALL_STATE(2908)] = 56851,
  [SMALL_STATE(2909)] = 56908,
  [SMALL_STATE(2910)] = 56997,
  [SMALL_STATE(2911)] = 57054,
  [SMALL_STATE(2912)] = 57111,
  [SMALL_STATE(2913)] = 57168,
  [SMALL_STATE(2914)] = 57225,
  [SMALL_STATE(2915)] = 57290,
  [SMALL_STATE(2916)] = 57379,
  [SMALL_STATE(2917)] = 57468,
  [SMALL_STATE(2918)] = 57561,
  [SMALL_STATE(2919)] = 57648,
  [SMALL_STATE(2920)] = 57705,
  [SMALL_STATE(2921)] = 57794,
  [SMALL_STATE(2922)] = 57851,
  [SMALL_STATE(2923)] = 57908,
  [SMALL_STATE(2924)] = 57965,
  [SMALL_STATE(2925)] = 58060,
  [SMALL_STATE(2926)] = 58117,
  [SMALL_STATE(2927)] = 58174,
  [SMALL_STATE(2928)] = 58231,
  [SMALL_STATE(2929)] = 58288,
  [SMALL_STATE(2930)] = 58345,
  [SMALL_STATE(2931)] = 58436,
  [SMALL_STATE(2932)] = 58493,
  [SMALL_STATE(2933)] = 58552,
  [SMALL_STATE(2934)] = 58611,
  [SMALL_STATE(2935)] = 58678,
  [SMALL_STATE(2936)] = 58735,
  [SMALL_STATE(2937)] = 58792,
  [SMALL_STATE(2938)] = 58849,
  [SMALL_STATE(2939)] = 58906,
  [SMALL_STATE(2940)] = 58995,
  [SMALL_STATE(2941)] = 59084,
  [SMALL_STATE(2942)] = 59149,
  [SMALL_STATE(2943)] = 59206,
  [SMALL_STATE(2944)] = 59277,
  [SMALL_STATE(2945)] = 59358,
  [SMALL_STATE(2946)] = 59415,
  [SMALL_STATE(2947)] = 59482,
  [SMALL_STATE(2948)] = 59539,
  [SMALL_STATE(2949)] = 59618,
  [SMALL_STATE(2950)] = 59681,
  [SMALL_STATE(2951)] = 59738,
  [SMALL_STATE(2952)] = 59817,
  [SMALL_STATE(2953)] = 59874,
  [SMALL_STATE(2954)] = 59931,
  [SMALL_STATE(2955)] = 59988,
  [SMALL_STATE(2956)] = 60045,
  [SMALL_STATE(2957)] = 60104,
  [SMALL_STATE(2958)] = 60195,
  [SMALL_STATE(2959)] = 60252,
  [SMALL_STATE(2960)] = 60309,
  [SMALL_STATE(2961)] = 60366,
  [SMALL_STATE(2962)] = 60423,
  [SMALL_STATE(2963)] = 60480,
  [SMALL_STATE(2964)] = 60573,
  [SMALL_STATE(2965)] = 60638,
  [SMALL_STATE(2966)] = 60695,
  [SMALL_STATE(2967)] = 60758,
  [SMALL_STATE(2968)] = 60815,
  [SMALL_STATE(2969)] = 60874,
  [SMALL_STATE(2970)] = 60961,
  [SMALL_STATE(2971)] = 61018,
  [SMALL_STATE(2972)] = 61075,
  [SMALL_STATE(2973)] = 61132,
  [SMALL_STATE(2974)] = 61189,
  [SMALL_STATE(2975)] = 61246,
  [SMALL_STATE(2976)] = 61307,
  [SMALL_STATE(2977)] = 61364,
  [SMALL_STATE(2978)] = 61421,
  [SMALL_STATE(2979)] = 61480,
  [SMALL_STATE(2980)] = 61573,
  [SMALL_STATE(2981)] = 61630,
  [SMALL_STATE(2982)] = 61689,
  [SMALL_STATE(2983)] = 61750,
  [SMALL_STATE(2984)] = 61807,
  [SMALL_STATE(2985)] = 61864,
  [SMALL_STATE(2986)] = 61921,
  [SMALL_STATE(2987)] = 61980,
  [SMALL_STATE(2988)] = 62039,
  [SMALL_STATE(2989)] = 62106,
  [SMALL_STATE(2990)] = 62171,
  [SMALL_STATE(2991)] = 62260,
  [SMALL_STATE(2992)] = 62331,
  [SMALL_STATE(2993)] = 62412,
  [SMALL_STATE(2994)] = 62491,
  [SMALL_STATE(2995)] = 62554,
  [SMALL_STATE(2996)] = 62633,
  [SMALL_STATE(2997)] = 62720,
  [SMALL_STATE(2998)] = 62781,
  [SMALL_STATE(2999)] = 62838,
  [SMALL_STATE(3000)] = 62897,
  [SMALL_STATE(3001)] = 62954,
  [SMALL_STATE(3002)] = 63043,
  [SMALL_STATE(3003)] = 63130,
  [SMALL_STATE(3004)] = 63187,
  [SMALL_STATE(3005)] = 63244,
  [SMALL_STATE(3006)] = 63301,
  [SMALL_STATE(3007)] = 63390,
  [SMALL_STATE(3008)] = 63447,
  [SMALL_STATE(3009)] = 63504,
  [SMALL_STATE(3010)] = 63593,
  [SMALL_STATE(3011)] = 63650,
  [SMALL_STATE(3012)] = 63741,
  [SMALL_STATE(3013)] = 63798,
  [SMALL_STATE(3014)] = 63855,
  [SMALL_STATE(3015)] = 63912,
  [SMALL_STATE(3016)] = 63969,
  [SMALL_STATE(3017)] = 64026,
  [SMALL_STATE(3018)] = 64083,
  [SMALL_STATE(3019)] = 64172,
  [SMALL_STATE(3020)] = 64231,
  [SMALL_STATE(3021)] = 64288,
  [SMALL_STATE(3022)] = 64345,
  [SMALL_STATE(3023)] = 64402,
  [SMALL_STATE(3024)] = 64459,
  [SMALL_STATE(3025)] = 64516,
  [SMALL_STATE(3026)] = 64573,
  [SMALL_STATE(3027)] = 64638,
  [SMALL_STATE(3028)] = 64695,
  [SMALL_STATE(3029)] = 64752,
  [SMALL_STATE(3030)] = 64809,
  [SMALL_STATE(3031)] = 64866,
  [SMALL_STATE(3032)] = 64923,
  [SMALL_STATE(3033)] = 64980,
  [SMALL_STATE(3034)] = 65037,
  [SMALL_STATE(3035)] = 65094,
  [SMALL_STATE(3036)] = 65151,
  [SMALL_STATE(3037)] = 65208,
  [SMALL_STATE(3038)] = 65265,
  [SMALL_STATE(3039)] = 65322,
  [SMALL_STATE(3040)] = 65379,
  [SMALL_STATE(3041)] = 65436,
  [SMALL_STATE(3042)] = 65493,
  [SMALL_STATE(3043)] = 65550,
  [SMALL_STATE(3044)] = 65607,
  [SMALL_STATE(3045)] = 65664,
  [SMALL_STATE(3046)] = 65721,
  [SMALL_STATE(3047)] = 65778,
  [SMALL_STATE(3048)] = 65835,
  [SMALL_STATE(3049)] = 65892,
  [SMALL_STATE(3050)] = 65949,
  [SMALL_STATE(3051)] = 66006,
  [SMALL_STATE(3052)] = 66063,
  [SMALL_STATE(3053)] = 66124,
  [SMALL_STATE(3054)] = 66181,
  [SMALL_STATE(3055)] = 66238,
  [SMALL_STATE(3056)] = 66295,
  [SMALL_STATE(3057)] = 66352,
  [SMALL_STATE(3058)] = 66409,
  [SMALL_STATE(3059)] = 66466,
  [SMALL_STATE(3060)] = 66523,
  [SMALL_STATE(3061)] = 66580,
  [SMALL_STATE(3062)] = 66669,
  [SMALL_STATE(3063)] = 66726,
  [SMALL_STATE(3064)] = 66783,
  [SMALL_STATE(3065)] = 66840,
  [SMALL_STATE(3066)] = 66897,
  [SMALL_STATE(3067)] = 66954,
  [SMALL_STATE(3068)] = 67011,
  [SMALL_STATE(3069)] = 67068,
  [SMALL_STATE(3070)] = 67133,
  [SMALL_STATE(3071)] = 67190,
  [SMALL_STATE(3072)] = 67247,
  [SMALL_STATE(3073)] = 67304,
  [SMALL_STATE(3074)] = 67361,
  [SMALL_STATE(3075)] = 67418,
  [SMALL_STATE(3076)] = 67475,
  [SMALL_STATE(3077)] = 67532,
  [SMALL_STATE(3078)] = 67589,
  [SMALL_STATE(3079)] = 67646,
  [SMALL_STATE(3080)] = 67703,
  [SMALL_STATE(3081)] = 67760,
  [SMALL_STATE(3082)] = 67817,
  [SMALL_STATE(3083)] = 67874,
  [SMALL_STATE(3084)] = 67931,
  [SMALL_STATE(3085)] = 67988,
  [SMALL_STATE(3086)] = 68045,
  [SMALL_STATE(3087)] = 68112,
  [SMALL_STATE(3088)] = 68169,
  [SMALL_STATE(3089)] = 68226,
  [SMALL_STATE(3090)] = 68283,
  [SMALL_STATE(3091)] = 68340,
  [SMALL_STATE(3092)] = 68397,
  [SMALL_STATE(3093)] = 68454,
  [SMALL_STATE(3094)] = 68511,
  [SMALL_STATE(3095)] = 68604,
  [SMALL_STATE(3096)] = 68661,
  [SMALL_STATE(3097)] = 68718,
  [SMALL_STATE(3098)] = 68775,
  [SMALL_STATE(3099)] = 68832,
  [SMALL_STATE(3100)] = 68889,
  [SMALL_STATE(3101)] = 68946,
  [SMALL_STATE(3102)] = 69003,
  [SMALL_STATE(3103)] = 69060,
  [SMALL_STATE(3104)] = 69117,
  [SMALL_STATE(3105)] = 69174,
  [SMALL_STATE(3106)] = 69231,
  [SMALL_STATE(3107)] = 69293,
  [SMALL_STATE(3108)] = 69351,
  [SMALL_STATE(3109)] = 69407,
  [SMALL_STATE(3110)] = 69495,
  [SMALL_STATE(3111)] = 69553,
  [SMALL_STATE(3112)] = 69611,
  [SMALL_STATE(3113)] = 69671,
  [SMALL_STATE(3114)] = 69729,
  [SMALL_STATE(3115)] = 69787,
  [SMALL_STATE(3116)] = 69845,
  [SMALL_STATE(3117)] = 69911,
  [SMALL_STATE(3118)] = 69969,
  [SMALL_STATE(3119)] = 70065,
  [SMALL_STATE(3120)] = 70123,
  [SMALL_STATE(3121)] = 70209,
  [SMALL_STATE(3122)] = 70301,
  [SMALL_STATE(3123)] = 70365,
  [SMALL_STATE(3124)] = 70455,
  [SMALL_STATE(3125)] = 70511,
  [SMALL_STATE(3126)] = 70581,
  [SMALL_STATE(3127)] = 70669,
  [SMALL_STATE(3128)] = 70733,
  [SMALL_STATE(3129)] = 70821,
  [SMALL_STATE(3130)] = 70907,
  [SMALL_STATE(3131)] = 70995,
  [SMALL_STATE(3132)] = 71083,
  [SMALL_STATE(3133)] = 71163,
  [SMALL_STATE(3134)] = 71257,
  [SMALL_STATE(3135)] = 71335,
  [SMALL_STATE(3136)] = 71397,
  [SMALL_STATE(3137)] = 71457,
  [SMALL_STATE(3138)] = 71515,
  [SMALL_STATE(3139)] = 71577,
  [SMALL_STATE(3140)] = 71655,
  [SMALL_STATE(3141)] = 71713,
  [SMALL_STATE(3142)] = 71771,
  [SMALL_STATE(3143)] = 71861,
  [SMALL_STATE(3144)] = 71953,
  [SMALL_STATE(3145)] = 72051,
  [SMALL_STATE(3146)] = 72111,
  [SMALL_STATE(3147)] = 72175,
  [SMALL_STATE(3148)] = 72233,
  [SMALL_STATE(3149)] = 72291,
  [SMALL_STATE(3150)] = 72347,
  [SMALL_STATE(3151)] = 72409,
  [SMALL_STATE(3152)] = 72475,
  [SMALL_STATE(3153)] = 72531,
  [SMALL_STATE(3154)] = 72602,
  [SMALL_STATE(3155)] = 72693,
  [SMALL_STATE(3156)] = 72766,
  [SMALL_STATE(3157)] = 72853,
  [SMALL_STATE(3158)] = 72940,
  [SMALL_STATE(3159)] = 72997,
  [SMALL_STATE(3160)] = 73084,
  [SMALL_STATE(3161)] = 73157,
  [SMALL_STATE(3162)] = 73214,
  [SMALL_STATE(3163)] = 73303,
  [SMALL_STATE(3164)] = 73376,
  [SMALL_STATE(3165)] = 73449,
  [SMALL_STATE(3166)] = 73540,
  [SMALL_STATE(3167)] = 73613,
  [SMALL_STATE(3168)] = 73684,
  [SMALL_STATE(3169)] = 73747,
  [SMALL_STATE(3170)] = 73804,
  [SMALL_STATE(3171)] = 73867,
  [SMALL_STATE(3172)] = 73928,
  [SMALL_STATE(3173)] = 74015,
  [SMALL_STATE(3174)] = 74086,
  [SMALL_STATE(3175)] = 74159,
  [SMALL_STATE(3176)] = 74216,
  [SMALL_STATE(3177)] = 74301,
  [SMALL_STATE(3178)] = 74358,
  [SMALL_STATE(3179)] = 74415,
  [SMALL_STATE(3180)] = 74506,
  [SMALL_STATE(3181)] = 74579,
  [SMALL_STATE(3182)] = 74666,
  [SMALL_STATE(3183)] = 74759,
  [SMALL_STATE(3184)] = 74816,
  [SMALL_STATE(3185)] = 74879,
  [SMALL_STATE(3186)] = 74952,
  [SMALL_STATE(3187)] = 75023,
  [SMALL_STATE(3188)] = 75094,
  [SMALL_STATE(3189)] = 75181,
  [SMALL_STATE(3190)] = 75270,
  [SMALL_STATE(3191)] = 75359,
  [SMALL_STATE(3192)] = 75446,
  [SMALL_STATE(3193)] = 75503,
  [SMALL_STATE(3194)] = 75574,
  [SMALL_STATE(3195)] = 75645,
  [SMALL_STATE(3196)] = 75718,
  [SMALL_STATE(3197)] = 75791,
  [SMALL_STATE(3198)] = 75848,
  [SMALL_STATE(3199)] = 75919,
  [SMALL_STATE(3200)] = 75992,
  [SMALL_STATE(3201)] = 76069,
  [SMALL_STATE(3202)] = 76142,
  [SMALL_STATE(3203)] = 76233,
  [SMALL_STATE(3204)] = 76294,
  [SMALL_STATE(3205)] = 76367,
  [SMALL_STATE(3206)] = 76444,
  [SMALL_STATE(3207)] = 76523,
  [SMALL_STATE(3208)] = 76594,
  [SMALL_STATE(3209)] = 76651,
  [SMALL_STATE(3210)] = 76714,
  [SMALL_STATE(3211)] = 76783,
  [SMALL_STATE(3212)] = 76870,
  [SMALL_STATE(3213)] = 76933,
  [SMALL_STATE(3214)] = 77004,
  [SMALL_STATE(3215)] = 77075,
  [SMALL_STATE(3216)] = 77148,
  [SMALL_STATE(3217)] = 77213,
  [SMALL_STATE(3218)] = 77270,
  [SMALL_STATE(3219)] = 77355,
  [SMALL_STATE(3220)] = 77428,
  [SMALL_STATE(3221)] = 77519,
  [SMALL_STATE(3222)] = 77592,
  [SMALL_STATE(3223)] = 77651,
  [SMALL_STATE(3224)] = 77742,
  [SMALL_STATE(3225)] = 77833,
  [SMALL_STATE(3226)] = 77904,
  [SMALL_STATE(3227)] = 77977,
  [SMALL_STATE(3228)] = 78064,
  [SMALL_STATE(3229)] = 78151,
  [SMALL_STATE(3230)] = 78210,
  [SMALL_STATE(3231)] = 78297,
  [SMALL_STATE(3232)] = 78388,
  [SMALL_STATE(3233)] = 78475,
  [SMALL_STATE(3234)] = 78534,
  [SMALL_STATE(3235)] = 78593,
  [SMALL_STATE(3236)] = 78679,
  [SMALL_STATE(3237)] = 78737,
  [SMALL_STATE(3238)] = 78797,
  [SMALL_STATE(3239)] = 78873,
  [SMALL_STATE(3240)] = 78949,
  [SMALL_STATE(3241)] = 79009,
  [SMALL_STATE(3242)] = 79065,
  [SMALL_STATE(3243)] = 79141,
  [SMALL_STATE(3244)] = 79195,
  [SMALL_STATE(3245)] = 79273,
  [SMALL_STATE(3246)] = 79327,
  [SMALL_STATE(3247)] = 79413,
  [SMALL_STATE(3248)] = 79491,
  [SMALL_STATE(3249)] = 79559,
  [SMALL_STATE(3250)] = 79621,
  [SMALL_STATE(3251)] = 79685,
  [SMALL_STATE(3252)] = 79739,
  [SMALL_STATE(3253)] = 79825,
  [SMALL_STATE(3254)] = 79881,
  [SMALL_STATE(3255)] = 79937,
  [SMALL_STATE(3256)] = 79995,
  [SMALL_STATE(3257)] = 80081,
  [SMALL_STATE(3258)] = 80167,
  [SMALL_STATE(3259)] = 80251,
  [SMALL_STATE(3260)] = 80337,
  [SMALL_STATE(3261)] = 80423,
  [SMALL_STATE(3262)] = 80509,
  [SMALL_STATE(3263)] = 80571,
  [SMALL_STATE(3264)] = 80655,
  [SMALL_STATE(3265)] = 80711,
  [SMALL_STATE(3266)] = 80767,
  [SMALL_STATE(3267)] = 80829,
  [SMALL_STATE(3268)] = 80887,
  [SMALL_STATE(3269)] = 80943,
  [SMALL_STATE(3270)] = 80999,
  [SMALL_STATE(3271)] = 81083,
  [SMALL_STATE(3272)] = 81139,
  [SMALL_STATE(3273)] = 81225,
  [SMALL_STATE(3274)] = 81311,
  [SMALL_STATE(3275)] = 81399,
  [SMALL_STATE(3276)] = 81483,
  [SMALL_STATE(3277)] = 81559,
  [SMALL_STATE(3278)] = 81645,
  [SMALL_STATE(3279)] = 81731,
  [SMALL_STATE(3280)] = 81787,
  [SMALL_STATE(3281)] = 81875,
  [SMALL_STATE(3282)] = 81963,
  [SMALL_STATE(3283)] = 82023,
  [SMALL_STATE(3284)] = 82079,
  [SMALL_STATE(3285)] = 82135,
  [SMALL_STATE(3286)] = 82211,
  [SMALL_STATE(3287)] = 82271,
  [SMALL_STATE(3288)] = 82327,
  [SMALL_STATE(3289)] = 82383,
  [SMALL_STATE(3290)] = 82459,
  [SMALL_STATE(3291)] = 82545,
  [SMALL_STATE(3292)] = 82623,
  [SMALL_STATE(3293)] = 82691,
  [SMALL_STATE(3294)] = 82777,
  [SMALL_STATE(3295)] = 82863,
  [SMALL_STATE(3296)] = 82925,
  [SMALL_STATE(3297)] = 83011,
  [SMALL_STATE(3298)] = 83075,
  [SMALL_STATE(3299)] = 83163,
  [SMALL_STATE(3300)] = 83219,
  [SMALL_STATE(3301)] = 83275,
  [SMALL_STATE(3302)] = 83333,
  [SMALL_STATE(3303)] = 83389,
  [SMALL_STATE(3304)] = 83475,
  [SMALL_STATE(3305)] = 83531,
  [SMALL_STATE(3306)] = 83617,
  [SMALL_STATE(3307)] = 83701,
  [SMALL_STATE(3308)] = 83757,
  [SMALL_STATE(3309)] = 83843,
  [SMALL_STATE(3310)] = 83937,
  [SMALL_STATE(3311)] = 84021,
  [SMALL_STATE(3312)] = 84077,
  [SMALL_STATE(3313)] = 84165,
  [SMALL_STATE(3314)] = 84253,
  [SMALL_STATE(3315)] = 84315,
  [SMALL_STATE(3316)] = 84371,
  [SMALL_STATE(3317)] = 84427,
  [SMALL_STATE(3318)] = 84485,
  [SMALL_STATE(3319)] = 84541,
  [SMALL_STATE(3320)] = 84599,
  [SMALL_STATE(3321)] = 84685,
  [SMALL_STATE(3322)] = 84775,
  [SMALL_STATE(3323)] = 84831,
  [SMALL_STATE(3324)] = 84887,
  [SMALL_STATE(3325)] = 84943,
  [SMALL_STATE(3326)] = 85035,
  [SMALL_STATE(3327)] = 85093,
  [SMALL_STATE(3328)] = 85183,
  [SMALL_STATE(3329)] = 85269,
  [SMALL_STATE(3330)] = 85323,
  [SMALL_STATE(3331)] = 85379,
  [SMALL_STATE(3332)] = 85433,
  [SMALL_STATE(3333)] = 85489,
  [SMALL_STATE(3334)] = 85553,
  [SMALL_STATE(3335)] = 85609,
  [SMALL_STATE(3336)] = 85697,
  [SMALL_STATE(3337)] = 85789,
  [SMALL_STATE(3338)] = 85873,
  [SMALL_STATE(3339)] = 85929,
  [SMALL_STATE(3340)] = 85991,
  [SMALL_STATE(3341)] = 86059,
  [SMALL_STATE(3342)] = 86147,
  [SMALL_STATE(3343)] = 86203,
  [SMALL_STATE(3344)] = 86289,
  [SMALL_STATE(3345)] = 86373,
  [SMALL_STATE(3346)] = 86459,
  [SMALL_STATE(3347)] = 86515,
  [SMALL_STATE(3348)] = 86607,
  [SMALL_STATE(3349)] = 86697,
  [SMALL_STATE(3350)] = 86787,
  [SMALL_STATE(3351)] = 86873,
  [SMALL_STATE(3352)] = 86961,
  [SMALL_STATE(3353)] = 87047,
  [SMALL_STATE(3354)] = 87103,
  [SMALL_STATE(3355)] = 87189,
  [SMALL_STATE(3356)] = 87243,
  [SMALL_STATE(3357)] = 87299,
  [SMALL_STATE(3358)] = 87389,
  [SMALL_STATE(3359)] = 87447,
  [SMALL_STATE(3360)] = 87535,
  [SMALL_STATE(3361)] = 87589,
  [SMALL_STATE(3362)] = 87643,
  [SMALL_STATE(3363)] = 87697,
  [SMALL_STATE(3364)] = 87751,
  [SMALL_STATE(3365)] = 87807,
  [SMALL_STATE(3366)] = 87883,
  [SMALL_STATE(3367)] = 87943,
  [SMALL_STATE(3368)] = 88019,
  [SMALL_STATE(3369)] = 88097,
  [SMALL_STATE(3370)] = 88153,
  [SMALL_STATE(3371)] = 88221,
  [SMALL_STATE(3372)] = 88283,
  [SMALL_STATE(3373)] = 88337,
  [SMALL_STATE(3374)] = 88401,
  [SMALL_STATE(3375)] = 88457,
  [SMALL_STATE(3376)] = 88513,
  [SMALL_STATE(3377)] = 88588,
  [SMALL_STATE(3378)] = 88673,
  [SMALL_STATE(3379)] = 88754,
  [SMALL_STATE(3380)] = 88807,
  [SMALL_STATE(3381)] = 88866,
  [SMALL_STATE(3382)] = 88953,
  [SMALL_STATE(3383)] = 89038,
  [SMALL_STATE(3384)] = 89123,
  [SMALL_STATE(3385)] = 89210,
  [SMALL_STATE(3386)] = 89265,
  [SMALL_STATE(3387)] = 89350,
  [SMALL_STATE(3388)] = 89433,
  [SMALL_STATE(3389)] = 89516,
  [SMALL_STATE(3390)] = 89581,
  [SMALL_STATE(3391)] = 89638,
  [SMALL_STATE(3392)] = 89691,
  [SMALL_STATE(3393)] = 89746,
  [SMALL_STATE(3394)] = 89801,
  [SMALL_STATE(3395)] = 89894,
  [SMALL_STATE(3396)] = 89969,
  [SMALL_STATE(3397)] = 90028,
  [SMALL_STATE(3398)] = 90115,
  [SMALL_STATE(3399)] = 90192,
  [SMALL_STATE(3400)] = 90251,
  [SMALL_STATE(3401)] = 90306,
  [SMALL_STATE(3402)] = 90373,
  [SMALL_STATE(3403)] = 90456,
  [SMALL_STATE(3404)] = 90513,
  [SMALL_STATE(3405)] = 90574,
  [SMALL_STATE(3406)] = 90629,
  [SMALL_STATE(3407)] = 90692,
  [SMALL_STATE(3408)] = 90745,
  [SMALL_STATE(3409)] = 90826,
  [SMALL_STATE(3410)] = 90881,
  [SMALL_STATE(3411)] = 90936,
  [SMALL_STATE(3412)] = 91001,
  [SMALL_STATE(3413)] = 91058,
  [SMALL_STATE(3414)] = 91143,
  [SMALL_STATE(3415)] = 91236,
  [SMALL_STATE(3416)] = 91321,
  [SMALL_STATE(3417)] = 91404,
  [SMALL_STATE(3418)] = 91489,
  [SMALL_STATE(3419)] = 91574,
  [SMALL_STATE(3420)] = 91663,
  [SMALL_STATE(3421)] = 91756,
  [SMALL_STATE(3422)] = 91849,
  [SMALL_STATE(3423)] = 91934,
  [SMALL_STATE(3424)] = 91989,
  [SMALL_STATE(3425)] = 92072,
  [SMALL_STATE(3426)] = 92127,
  [SMALL_STATE(3427)] = 92184,
  [SMALL_STATE(3428)] = 92239,
  [SMALL_STATE(3429)] = 92294,
  [SMALL_STATE(3430)] = 92357,
  [SMALL_STATE(3431)] = 92418,
  [SMALL_STATE(3432)] = 92501,
  [SMALL_STATE(3433)] = 92568,
  [SMALL_STATE(3434)] = 92645,
  [SMALL_STATE(3435)] = 92720,
  [SMALL_STATE(3436)] = 92779,
  [SMALL_STATE(3437)] = 92834,
  [SMALL_STATE(3438)] = 92889,
  [SMALL_STATE(3439)] = 92964,
  [SMALL_STATE(3440)] = 93019,
  [SMALL_STATE(3441)] = 93112,
  [SMALL_STATE(3442)] = 93197,
  [SMALL_STATE(3443)] = 93280,
  [SMALL_STATE(3444)] = 93365,
  [SMALL_STATE(3445)] = 93448,
  [SMALL_STATE(3446)] = 93535,
  [SMALL_STATE(3447)] = 93590,
  [SMALL_STATE(3448)] = 93677,
  [SMALL_STATE(3449)] = 93732,
  [SMALL_STATE(3450)] = 93787,
  [SMALL_STATE(3451)] = 93848,
  [SMALL_STATE(3452)] = 93901,
  [SMALL_STATE(3453)] = 93984,
  [SMALL_STATE(3454)] = 94047,
  [SMALL_STATE(3455)] = 94102,
  [SMALL_STATE(3456)] = 94157,
  [SMALL_STATE(3457)] = 94218,
  [SMALL_STATE(3458)] = 94285,
  [SMALL_STATE(3459)] = 94362,
  [SMALL_STATE(3460)] = 94437,
  [SMALL_STATE(3461)] = 94496,
  [SMALL_STATE(3462)] = 94579,
  [SMALL_STATE(3463)] = 94634,
  [SMALL_STATE(3464)] = 94687,
  [SMALL_STATE(3465)] = 94762,
  [SMALL_STATE(3466)] = 94817,
  [SMALL_STATE(3467)] = 94902,
  [SMALL_STATE(3468)] = 94955,
  [SMALL_STATE(3469)] = 95040,
  [SMALL_STATE(3470)] = 95097,
  [SMALL_STATE(3471)] = 95184,
  [SMALL_STATE(3472)] = 95269,
  [SMALL_STATE(3473)] = 95322,
  [SMALL_STATE(3474)] = 95407,
  [SMALL_STATE(3475)] = 95492,
  [SMALL_STATE(3476)] = 95577,
  [SMALL_STATE(3477)] = 95660,
  [SMALL_STATE(3478)] = 95745,
  [SMALL_STATE(3479)] = 95830,
  [SMALL_STATE(3480)] = 95915,
  [SMALL_STATE(3481)] = 95980,
  [SMALL_STATE(3482)] = 96062,
  [SMALL_STATE(3483)] = 96118,
  [SMALL_STATE(3484)] = 96172,
  [SMALL_STATE(3485)] = 96262,
  [SMALL_STATE(3486)] = 96348,
  [SMALL_STATE(3487)] = 96432,
  [SMALL_STATE(3488)] = 96486,
  [SMALL_STATE(3489)] = 96572,
  [SMALL_STATE(3490)] = 96628,
  [SMALL_STATE(3491)] = 96686,
  [SMALL_STATE(3492)] = 96772,
  [SMALL_STATE(3493)] = 96856,
  [SMALL_STATE(3494)] = 96942,
  [SMALL_STATE(3495)] = 97026,
  [SMALL_STATE(3496)] = 97110,
  [SMALL_STATE(3497)] = 97198,
  [SMALL_STATE(3498)] = 97286,
  [SMALL_STATE(3499)] = 97342,
  [SMALL_STATE(3500)] = 97428,
  [SMALL_STATE(3501)] = 97514,
  [SMALL_STATE(3502)] = 97572,
  [SMALL_STATE(3503)] = 97662,
  [SMALL_STATE(3504)] = 97748,
  [SMALL_STATE(3505)] = 97802,
  [SMALL_STATE(3506)] = 97856,
  [SMALL_STATE(3507)] = 97940,
  [SMALL_STATE(3508)] = 98030,
  [SMALL_STATE(3509)] = 98112,
  [SMALL_STATE(3510)] = 98170,
  [SMALL_STATE(3511)] = 98224,
  [SMALL_STATE(3512)] = 98278,
  [SMALL_STATE(3513)] = 98362,
  [SMALL_STATE(3514)] = 98436,
  [SMALL_STATE(3515)] = 98518,
  [SMALL_STATE(3516)] = 98602,
  [SMALL_STATE(3517)] = 98684,
  [SMALL_STATE(3518)] = 98744,
  [SMALL_STATE(3519)] = 98798,
  [SMALL_STATE(3520)] = 98852,
  [SMALL_STATE(3521)] = 98932,
  [SMALL_STATE(3522)] = 98984,
  [SMALL_STATE(3523)] = 99036,
  [SMALL_STATE(3524)] = 99116,
  [SMALL_STATE(3525)] = 99198,
  [SMALL_STATE(3526)] = 99272,
  [SMALL_STATE(3527)] = 99330,
  [SMALL_STATE(3528)] = 99404,
  [SMALL_STATE(3529)] = 99486,
  [SMALL_STATE(3530)] = 99570,
  [SMALL_STATE(3531)] = 99646,
  [SMALL_STATE(3532)] = 99730,
  [SMALL_STATE(3533)] = 99788,
  [SMALL_STATE(3534)] = 99842,
  [SMALL_STATE(3535)] = 99908,
  [SMALL_STATE(3536)] = 99970,
  [SMALL_STATE(3537)] = 100030,
  [SMALL_STATE(3538)] = 100092,
  [SMALL_STATE(3539)] = 100166,
  [SMALL_STATE(3540)] = 100220,
  [SMALL_STATE(3541)] = 100296,
  [SMALL_STATE(3542)] = 100350,
  [SMALL_STATE(3543)] = 100404,
  [SMALL_STATE(3544)] = 100460,
  [SMALL_STATE(3545)] = 100520,
  [SMALL_STATE(3546)] = 100602,
  [SMALL_STATE(3547)] = 100668,
  [SMALL_STATE(3548)] = 100758,
  [SMALL_STATE(3549)] = 100811,
  [SMALL_STATE(3550)] = 100864,
  [SMALL_STATE(3551)] = 100949,
  [SMALL_STATE(3552)] = 101034,
  [SMALL_STATE(3553)] = 101121,
  [SMALL_STATE(3554)] = 101204,
  [SMALL_STATE(3555)] = 101289,
  [SMALL_STATE(3556)] = 101342,
  [SMALL_STATE(3557)] = 101395,
  [SMALL_STATE(3558)] = 101450,
  [SMALL_STATE(3559)] = 101523,
  [SMALL_STATE(3560)] = 101576,
  [SMALL_STATE(3561)] = 101629,
  [SMALL_STATE(3562)] = 101682,
  [SMALL_STATE(3563)] = 101735,
  [SMALL_STATE(3564)] = 101818,
  [SMALL_STATE(3565)] = 101875,
  [SMALL_STATE(3566)] = 101948,
  [SMALL_STATE(3567)] = 102023,
  [SMALL_STATE(3568)] = 102088,
  [SMALL_STATE(3569)] = 102147,
  [SMALL_STATE(3570)] = 102228,
  [SMALL_STATE(3571)] = 102309,
  [SMALL_STATE(3572)] = 102390,
  [SMALL_STATE(3573)] = 102479,
  [SMALL_STATE(3574)] = 102562,
  [SMALL_STATE(3575)] = 102623,
  [SMALL_STATE(3576)] = 102676,
  [SMALL_STATE(3577)] = 102761,
  [SMALL_STATE(3578)] = 102814,
  [SMALL_STATE(3579)] = 102867,
  [SMALL_STATE(3580)] = 102920,
  [SMALL_STATE(3581)] = 103001,
  [SMALL_STATE(3582)] = 103054,
  [SMALL_STATE(3583)] = 103109,
  [SMALL_STATE(3584)] = 103190,
  [SMALL_STATE(3585)] = 103243,
  [SMALL_STATE(3586)] = 103332,
  [SMALL_STATE(3587)] = 103415,
  [SMALL_STATE(3588)] = 103470,
  [SMALL_STATE(3589)] = 103555,
  [SMALL_STATE(3590)] = 103610,
  [SMALL_STATE(3591)] = 103663,
  [SMALL_STATE(3592)] = 103716,
  [SMALL_STATE(3593)] = 103799,
  [SMALL_STATE(3594)] = 103882,
  [SMALL_STATE(3595)] = 103937,
  [SMALL_STATE(3596)] = 103992,
  [SMALL_STATE(3597)] = 104073,
  [SMALL_STATE(3598)] = 104128,
  [SMALL_STATE(3599)] = 104213,
  [SMALL_STATE(3600)] = 104266,
  [SMALL_STATE(3601)] = 104325,
  [SMALL_STATE(3602)] = 104406,
  [SMALL_STATE(3603)] = 104459,
  [SMALL_STATE(3604)] = 104545,
  [SMALL_STATE(3605)] = 104597,
  [SMALL_STATE(3606)] = 104681,
  [SMALL_STATE(3607)] = 104733,
  [SMALL_STATE(3608)] = 104813,
  [SMALL_STATE(3609)] = 104895,
  [SMALL_STATE(3610)] = 104955,
  [SMALL_STATE(3611)] = 105009,
  [SMALL_STATE(3612)] = 105093,
  [SMALL_STATE(3613)] = 105145,
  [SMALL_STATE(3614)] = 105225,
  [SMALL_STATE(3615)] = 105277,
  [SMALL_STATE(3616)] = 105329,
  [SMALL_STATE(3617)] = 105383,
  [SMALL_STATE(3618)] = 105465,
  [SMALL_STATE(3619)] = 105519,
  [SMALL_STATE(3620)] = 105573,
  [SMALL_STATE(3621)] = 105625,
  [SMALL_STATE(3622)] = 105705,
  [SMALL_STATE(3623)] = 105789,
  [SMALL_STATE(3624)] = 105853,
  [SMALL_STATE(3625)] = 105939,
  [SMALL_STATE(3626)] = 106019,
  [SMALL_STATE(3627)] = 106101,
  [SMALL_STATE(3628)] = 106183,
  [SMALL_STATE(3629)] = 106253,
  [SMALL_STATE(3630)] = 106305,
  [SMALL_STATE(3631)] = 106361,
  [SMALL_STATE(3632)] = 106439,
  [SMALL_STATE(3633)] = 106491,
  [SMALL_STATE(3634)] = 106563,
  [SMALL_STATE(3635)] = 106647,
  [SMALL_STATE(3636)] = 106731,
  [SMALL_STATE(3637)] = 106785,
  [SMALL_STATE(3638)] = 106837,
  [SMALL_STATE(3639)] = 106889,
  [SMALL_STATE(3640)] = 106949,
  [SMALL_STATE(3641)] = 107007,
  [SMALL_STATE(3642)] = 107081,
  [SMALL_STATE(3643)] = 107161,
  [SMALL_STATE(3644)] = 107233,
  [SMALL_STATE(3645)] = 107305,
  [SMALL_STATE(3646)] = 107361,
  [SMALL_STATE(3647)] = 107445,
  [SMALL_STATE(3648)] = 107501,
  [SMALL_STATE(3649)] = 107573,
  [SMALL_STATE(3650)] = 107659,
  [SMALL_STATE(3651)] = 107731,
  [SMALL_STATE(3652)] = 107783,
  [SMALL_STATE(3653)] = 107857,
  [SMALL_STATE(3654)] = 107921,
  [SMALL_STATE(3655)] = 107973,
  [SMALL_STATE(3656)] = 108025,
  [SMALL_STATE(3657)] = 108105,
  [SMALL_STATE(3658)] = 108159,
  [SMALL_STATE(3659)] = 108239,
  [SMALL_STATE(3660)] = 108317,
  [SMALL_STATE(3661)] = 108401,
  [SMALL_STATE(3662)] = 108471,
  [SMALL_STATE(3663)] = 108553,
  [SMALL_STATE(3664)] = 108633,
  [SMALL_STATE(3665)] = 108717,
  [SMALL_STATE(3666)] = 108777,
  [SMALL_STATE(3667)] = 108857,
  [SMALL_STATE(3668)] = 108935,
  [SMALL_STATE(3669)] = 109015,
  [SMALL_STATE(3670)] = 109073,
  [SMALL_STATE(3671)] = 109153,
  [SMALL_STATE(3672)] = 109203,
  [SMALL_STATE(3673)] = 109255,
  [SMALL_STATE(3674)] = 109339,
  [SMALL_STATE(3675)] = 109389,
  [SMALL_STATE(3676)] = 109441,
  [SMALL_STATE(3677)] = 109493,
  [SMALL_STATE(3678)] = 109557,
  [SMALL_STATE(3679)] = 109645,
  [SMALL_STATE(3680)] = 109727,
  [SMALL_STATE(3681)] = 109813,
  [SMALL_STATE(3682)] = 109897,
  [SMALL_STATE(3683)] = 109977,
  [SMALL_STATE(3684)] = 110027,
  [SMALL_STATE(3685)] = 110083,
  [SMALL_STATE(3686)] = 110161,
  [SMALL_STATE(3687)] = 110243,
  [SMALL_STATE(3688)] = 110297,
  [SMALL_STATE(3689)] = 110349,
  [SMALL_STATE(3690)] = 110437,
  [SMALL_STATE(3691)] = 110521,
  [SMALL_STATE(3692)] = 110573,
  [SMALL_STATE(3693)] = 110657,
  [SMALL_STATE(3694)] = 110741,
  [SMALL_STATE(3695)] = 110815,
  [SMALL_STATE(3696)] = 110899,
  [SMALL_STATE(3697)] = 110951,
  [SMALL_STATE(3698)] = 111023,
  [SMALL_STATE(3699)] = 111079,
  [SMALL_STATE(3700)] = 111159,
  [SMALL_STATE(3701)] = 111209,
  [SMALL_STATE(3702)] = 111281,
  [SMALL_STATE(3703)] = 111353,
  [SMALL_STATE(3704)] = 111427,
  [SMALL_STATE(3705)] = 111491,
  [SMALL_STATE(3706)] = 111549,
  [SMALL_STATE(3707)] = 111631,
  [SMALL_STATE(3708)] = 111683,
  [SMALL_STATE(3709)] = 111743,
  [SMALL_STATE(3710)] = 111795,
  [SMALL_STATE(3711)] = 111875,
  [SMALL_STATE(3712)] = 111927,
  [SMALL_STATE(3713)] = 112007,
  [SMALL_STATE(3714)] = 112089,
  [SMALL_STATE(3715)] = 112141,
  [SMALL_STATE(3716)] = 112195,
  [SMALL_STATE(3717)] = 112249,
  [SMALL_STATE(3718)] = 112329,
  [SMALL_STATE(3719)] = 112417,
  [SMALL_STATE(3720)] = 112499,
  [SMALL_STATE(3721)] = 112579,
  [SMALL_STATE(3722)] = 112657,
  [SMALL_STATE(3723)] = 112739,
  [SMALL_STATE(3724)] = 112819,
  [SMALL_STATE(3725)] = 112899,
  [SMALL_STATE(3726)] = 112985,
  [SMALL_STATE(3727)] = 113065,
  [SMALL_STATE(3728)] = 113145,
  [SMALL_STATE(3729)] = 113227,
  [SMALL_STATE(3730)] = 113307,
  [SMALL_STATE(3731)] = 113397,
  [SMALL_STATE(3732)] = 113477,
  [SMALL_STATE(3733)] = 113529,
  [SMALL_STATE(3734)] = 113581,
  [SMALL_STATE(3735)] = 113653,
  [SMALL_STATE(3736)] = 113709,
  [SMALL_STATE(3737)] = 113781,
  [SMALL_STATE(3738)] = 113855,
  [SMALL_STATE(3739)] = 113937,
  [SMALL_STATE(3740)] = 114001,
  [SMALL_STATE(3741)] = 114059,
  [SMALL_STATE(3742)] = 114111,
  [SMALL_STATE(3743)] = 114171,
  [SMALL_STATE(3744)] = 114223,
  [SMALL_STATE(3745)] = 114275,
  [SMALL_STATE(3746)] = 114329,
  [SMALL_STATE(3747)] = 114381,
  [SMALL_STATE(3748)] = 114459,
  [SMALL_STATE(3749)] = 114509,
  [SMALL_STATE(3750)] = 114589,
  [SMALL_STATE(3751)] = 114669,
  [SMALL_STATE(3752)] = 114719,
  [SMALL_STATE(3753)] = 114801,
  [SMALL_STATE(3754)] = 114881,
  [SMALL_STATE(3755)] = 114965,
  [SMALL_STATE(3756)] = 115047,
  [SMALL_STATE(3757)] = 115129,
  [SMALL_STATE(3758)] = 115181,
  [SMALL_STATE(3759)] = 115235,
  [SMALL_STATE(3760)] = 115291,
  [SMALL_STATE(3761)] = 115349,
  [SMALL_STATE(3762)] = 115400,
  [SMALL_STATE(3763)] = 115451,
  [SMALL_STATE(3764)] = 115502,
  [SMALL_STATE(3765)] = 115561,
  [SMALL_STATE(3766)] = 115640,
  [SMALL_STATE(3767)] = 115719,
  [SMALL_STATE(3768)] = 115798,
  [SMALL_STATE(3769)] = 115861,
  [SMALL_STATE(3770)] = 115942,
  [SMALL_STATE(3771)] = 115999,
  [SMALL_STATE(3772)] = 116080,
  [SMALL_STATE(3773)] = 116163,
  [SMALL_STATE(3774)] = 116220,
  [SMALL_STATE(3775)] = 116301,
  [SMALL_STATE(3776)] = 116382,
  [SMALL_STATE(3777)] = 116461,
  [SMALL_STATE(3778)] = 116512,
  [SMALL_STATE(3779)] = 116563,
  [SMALL_STATE(3780)] = 116650,
  [SMALL_STATE(3781)] = 116727,
  [SMALL_STATE(3782)] = 116810,
  [SMALL_STATE(3783)] = 116889,
  [SMALL_STATE(3784)] = 116972,
  [SMALL_STATE(3785)] = 117023,
  [SMALL_STATE(3786)] = 117104,
  [SMALL_STATE(3787)] = 117167,
  [SMALL_STATE(3788)] = 117246,
  [SMALL_STATE(3789)] = 117325,
  [SMALL_STATE(3790)] = 117402,
  [SMALL_STATE(3791)] = 117475,
  [SMALL_STATE(3792)] = 117556,
  [SMALL_STATE(3793)] = 117641,
  [SMALL_STATE(3794)] = 117722,
  [SMALL_STATE(3795)] = 117793,
  [SMALL_STATE(3796)] = 117872,
  [SMALL_STATE(3797)] = 117927,
  [SMALL_STATE(3798)] = 117980,
  [SMALL_STATE(3799)] = 118063,
  [SMALL_STATE(3800)] = 118134,
  [SMALL_STATE(3801)] = 118185,
  [SMALL_STATE(3802)] = 118266,
  [SMALL_STATE(3803)] = 118319,
  [SMALL_STATE(3804)] = 118398,
  [SMALL_STATE(3805)] = 118471,
  [SMALL_STATE(3806)] = 118542,
  [SMALL_STATE(3807)] = 118623,
  [SMALL_STATE(3808)] = 118678,
  [SMALL_STATE(3809)] = 118757,
  [SMALL_STATE(3810)] = 118836,
  [SMALL_STATE(3811)] = 118887,
  [SMALL_STATE(3812)] = 118970,
  [SMALL_STATE(3813)] = 119021,
  [SMALL_STATE(3814)] = 119072,
  [SMALL_STATE(3815)] = 119123,
  [SMALL_STATE(3816)] = 119204,
  [SMALL_STATE(3817)] = 119283,
  [SMALL_STATE(3818)] = 119334,
  [SMALL_STATE(3819)] = 119413,
  [SMALL_STATE(3820)] = 119468,
  [SMALL_STATE(3821)] = 119551,
  [SMALL_STATE(3822)] = 119622,
  [SMALL_STATE(3823)] = 119673,
  [SMALL_STATE(3824)] = 119724,
  [SMALL_STATE(3825)] = 119777,
  [SMALL_STATE(3826)] = 119856,
  [SMALL_STATE(3827)] = 119937,
  [SMALL_STATE(3828)] = 119988,
  [SMALL_STATE(3829)] = 120069,
  [SMALL_STATE(3830)] = 120120,
  [SMALL_STATE(3831)] = 120179,
  [SMALL_STATE(3832)] = 120230,
  [SMALL_STATE(3833)] = 120281,
  [SMALL_STATE(3834)] = 120364,
  [SMALL_STATE(3835)] = 120415,
  [SMALL_STATE(3836)] = 120468,
  [SMALL_STATE(3837)] = 120549,
  [SMALL_STATE(3838)] = 120602,
  [SMALL_STATE(3839)] = 120689,
  [SMALL_STATE(3840)] = 120740,
  [SMALL_STATE(3841)] = 120799,
  [SMALL_STATE(3842)] = 120880,
  [SMALL_STATE(3843)] = 120931,
  [SMALL_STATE(3844)] = 120982,
  [SMALL_STATE(3845)] = 121039,
  [SMALL_STATE(3846)] = 121102,
  [SMALL_STATE(3847)] = 121185,
  [SMALL_STATE(3848)] = 121264,
  [SMALL_STATE(3849)] = 121337,
  [SMALL_STATE(3850)] = 121388,
  [SMALL_STATE(3851)] = 121469,
  [SMALL_STATE(3852)] = 121540,
  [SMALL_STATE(3853)] = 121599,
  [SMALL_STATE(3854)] = 121654,
  [SMALL_STATE(3855)] = 121725,
  [SMALL_STATE(3856)] = 121806,
  [SMALL_STATE(3857)] = 121883,
  [SMALL_STATE(3858)] = 121964,
  [SMALL_STATE(3859)] = 122015,
  [SMALL_STATE(3860)] = 122068,
  [SMALL_STATE(3861)] = 122121,
  [SMALL_STATE(3862)] = 122172,
  [SMALL_STATE(3863)] = 122229,
  [SMALL_STATE(3864)] = 122292,
  [SMALL_STATE(3865)] = 122373,
  [SMALL_STATE(3866)] = 122452,
  [SMALL_STATE(3867)] = 122525,
  [SMALL_STATE(3868)] = 122596,
  [SMALL_STATE(3869)] = 122667,
  [SMALL_STATE(3870)] = 122722,
  [SMALL_STATE(3871)] = 122793,
  [SMALL_STATE(3872)] = 122848,
  [SMALL_STATE(3873)] = 122919,
  [SMALL_STATE(3874)] = 122972,
  [SMALL_STATE(3875)] = 123023,
  [SMALL_STATE(3876)] = 123096,
  [SMALL_STATE(3877)] = 123149,
  [SMALL_STATE(3878)] = 123200,
  [SMALL_STATE(3879)] = 123279,
  [SMALL_STATE(3880)] = 123358,
  [SMALL_STATE(3881)] = 123411,
  [SMALL_STATE(3882)] = 123490,
  [SMALL_STATE(3883)] = 123541,
  [SMALL_STATE(3884)] = 123604,
  [SMALL_STATE(3885)] = 123661,
  [SMALL_STATE(3886)] = 123712,
  [SMALL_STATE(3887)] = 123763,
  [SMALL_STATE(3888)] = 123842,
  [SMALL_STATE(3889)] = 123919,
  [SMALL_STATE(3890)] = 123978,
  [SMALL_STATE(3891)] = 124056,
  [SMALL_STATE(3892)] = 124136,
  [SMALL_STATE(3893)] = 124186,
  [SMALL_STATE(3894)] = 124236,
  [SMALL_STATE(3895)] = 124314,
  [SMALL_STATE(3896)] = 124394,
  [SMALL_STATE(3897)] = 124474,
  [SMALL_STATE(3898)] = 124524,
  [SMALL_STATE(3899)] = 124602,
  [SMALL_STATE(3900)] = 124684,
  [SMALL_STATE(3901)] = 124762,
  [SMALL_STATE(3902)] = 124844,
  [SMALL_STATE(3903)] = 124896,
  [SMALL_STATE(3904)] = 124946,
  [SMALL_STATE(3905)] = 124996,
  [SMALL_STATE(3906)] = 125078,
  [SMALL_STATE(3907)] = 125156,
  [SMALL_STATE(3908)] = 125234,
  [SMALL_STATE(3909)] = 125316,
  [SMALL_STATE(3910)] = 125396,
  [SMALL_STATE(3911)] = 125476,
  [SMALL_STATE(3912)] = 125556,
  [SMALL_STATE(3913)] = 125614,
  [SMALL_STATE(3914)] = 125668,
  [SMALL_STATE(3915)] = 125752,
  [SMALL_STATE(3916)] = 125834,
  [SMALL_STATE(3917)] = 125890,
  [SMALL_STATE(3918)] = 125960,
  [SMALL_STATE(3919)] = 126038,
  [SMALL_STATE(3920)] = 126110,
  [SMALL_STATE(3921)] = 126172,
  [SMALL_STATE(3922)] = 126256,
  [SMALL_STATE(3923)] = 126318,
  [SMALL_STATE(3924)] = 126398,
  [SMALL_STATE(3925)] = 126450,
  [SMALL_STATE(3926)] = 126522,
  [SMALL_STATE(3927)] = 126600,
  [SMALL_STATE(3928)] = 126650,
  [SMALL_STATE(3929)] = 126732,
  [SMALL_STATE(3930)] = 126802,
  [SMALL_STATE(3931)] = 126858,
  [SMALL_STATE(3932)] = 126916,
  [SMALL_STATE(3933)] = 126966,
  [SMALL_STATE(3934)] = 127020,
  [SMALL_STATE(3935)] = 127070,
  [SMALL_STATE(3936)] = 127152,
  [SMALL_STATE(3937)] = 127202,
  [SMALL_STATE(3938)] = 127282,
  [SMALL_STATE(3939)] = 127360,
  [SMALL_STATE(3940)] = 127438,
  [SMALL_STATE(3941)] = 127508,
  [SMALL_STATE(3942)] = 127584,
  [SMALL_STATE(3943)] = 127634,
  [SMALL_STATE(3944)] = 127714,
  [SMALL_STATE(3945)] = 127798,
  [SMALL_STATE(3946)] = 127880,
  [SMALL_STATE(3947)] = 127932,
  [SMALL_STATE(3948)] = 128012,
  [SMALL_STATE(3949)] = 128090,
  [SMALL_STATE(3950)] = 128142,
  [SMALL_STATE(3951)] = 128220,
  [SMALL_STATE(3952)] = 128274,
  [SMALL_STATE(3953)] = 128352,
  [SMALL_STATE(3954)] = 128430,
  [SMALL_STATE(3955)] = 128508,
  [SMALL_STATE(3956)] = 128558,
  [SMALL_STATE(3957)] = 128638,
  [SMALL_STATE(3958)] = 128692,
  [SMALL_STATE(3959)] = 128774,
  [SMALL_STATE(3960)] = 128852,
  [SMALL_STATE(3961)] = 128934,
  [SMALL_STATE(3962)] = 129014,
  [SMALL_STATE(3963)] = 129094,
  [SMALL_STATE(3964)] = 129172,
  [SMALL_STATE(3965)] = 129242,
  [SMALL_STATE(3966)] = 129292,
  [SMALL_STATE(3967)] = 129376,
  [SMALL_STATE(3968)] = 129458,
  [SMALL_STATE(3969)] = 129528,
  [SMALL_STATE(3970)] = 129582,
  [SMALL_STATE(3971)] = 129652,
  [SMALL_STATE(3972)] = 129702,
  [SMALL_STATE(3973)] = 129780,
  [SMALL_STATE(3974)] = 129862,
  [SMALL_STATE(3975)] = 129934,
  [SMALL_STATE(3976)] = 129996,
  [SMALL_STATE(3977)] = 130052,
  [SMALL_STATE(3978)] = 130130,
  [SMALL_STATE(3979)] = 130188,
  [SMALL_STATE(3980)] = 130238,
  [SMALL_STATE(3981)] = 130288,
  [SMALL_STATE(3982)] = 130372,
  [SMALL_STATE(3983)] = 130448,
  [SMALL_STATE(3984)] = 130536,
  [SMALL_STATE(3985)] = 130614,
  [SMALL_STATE(3986)] = 130698,
  [SMALL_STATE(3987)] = 130748,
  [SMALL_STATE(3988)] = 130832,
  [SMALL_STATE(3989)] = 130914,
  [SMALL_STATE(3990)] = 130992,
  [SMALL_STATE(3991)] = 131080,
  [SMALL_STATE(3992)] = 131161,
  [SMALL_STATE(3993)] = 131242,
  [SMALL_STATE(3994)] = 131321,
  [SMALL_STATE(3995)] = 131374,
  [SMALL_STATE(3996)] = 131423,
  [SMALL_STATE(3997)] = 131504,
  [SMALL_STATE(3998)] = 131553,
  [SMALL_STATE(3999)] = 131632,
  [SMALL_STATE(4000)] = 131709,
  [SMALL_STATE(4001)] = 131784,
  [SMALL_STATE(4002)] = 131861,
  [SMALL_STATE(4003)] = 131938,
  [SMALL_STATE(4004)] = 132017,
  [SMALL_STATE(4005)] = 132096,
  [SMALL_STATE(4006)] = 132177,
  [SMALL_STATE(4007)] = 132228,
  [SMALL_STATE(4008)] = 132277,
  [SMALL_STATE(4009)] = 132356,
  [SMALL_STATE(4010)] = 132417,
  [SMALL_STATE(4011)] = 132466,
  [SMALL_STATE(4012)] = 132519,
  [SMALL_STATE(4013)] = 132598,
  [SMALL_STATE(4014)] = 132675,
  [SMALL_STATE(4015)] = 132752,
  [SMALL_STATE(4016)] = 132801,
  [SMALL_STATE(4017)] = 132880,
  [SMALL_STATE(4018)] = 132929,
  [SMALL_STATE(4019)] = 133006,
  [SMALL_STATE(4020)] = 133075,
  [SMALL_STATE(4021)] = 133128,
  [SMALL_STATE(4022)] = 133197,
  [SMALL_STATE(4023)] = 133246,
  [SMALL_STATE(4024)] = 133317,
  [SMALL_STATE(4025)] = 133368,
  [SMALL_STATE(4026)] = 133417,
  [SMALL_STATE(4027)] = 133500,
  [SMALL_STATE(4028)] = 133577,
  [SMALL_STATE(4029)] = 133658,
  [SMALL_STATE(4030)] = 133739,
  [SMALL_STATE(4031)] = 133788,
  [SMALL_STATE(4032)] = 133865,
  [SMALL_STATE(4033)] = 133946,
  [SMALL_STATE(4034)] = 134023,
  [SMALL_STATE(4035)] = 134104,
  [SMALL_STATE(4036)] = 134161,
  [SMALL_STATE(4037)] = 134212,
  [SMALL_STATE(4038)] = 134267,
  [SMALL_STATE(4039)] = 134328,
  [SMALL_STATE(4040)] = 134399,
  [SMALL_STATE(4041)] = 134450,
  [SMALL_STATE(4042)] = 134519,
  [SMALL_STATE(4043)] = 134572,
  [SMALL_STATE(4044)] = 134641,
  [SMALL_STATE(4045)] = 134690,
  [SMALL_STATE(4046)] = 134767,
  [SMALL_STATE(4047)] = 134844,
  [SMALL_STATE(4048)] = 134919,
  [SMALL_STATE(4049)] = 134970,
  [SMALL_STATE(4050)] = 135019,
  [SMALL_STATE(4051)] = 135068,
  [SMALL_STATE(4052)] = 135145,
  [SMALL_STATE(4053)] = 135202,
  [SMALL_STATE(4054)] = 135281,
  [SMALL_STATE(4055)] = 135336,
  [SMALL_STATE(4056)] = 135414,
  [SMALL_STATE(4057)] = 135488,
  [SMALL_STATE(4058)] = 135564,
  [SMALL_STATE(4059)] = 135644,
  [SMALL_STATE(4060)] = 135692,
  [SMALL_STATE(4061)] = 135768,
  [SMALL_STATE(4062)] = 135850,
  [SMALL_STATE(4063)] = 135926,
  [SMALL_STATE(4064)] = 136002,
  [SMALL_STATE(4065)] = 136078,
  [SMALL_STATE(4066)] = 136156,
  [SMALL_STATE(4067)] = 136232,
  [SMALL_STATE(4068)] = 136308,
  [SMALL_STATE(4069)] = 136358,
  [SMALL_STATE(4070)] = 136438,
  [SMALL_STATE(4071)] = 136486,
  [SMALL_STATE(4072)] = 136560,
  [SMALL_STATE(4073)] = 136608,
  [SMALL_STATE(4074)] = 136684,
  [SMALL_STATE(4075)] = 136734,
  [SMALL_STATE(4076)] = 136782,
  [SMALL_STATE(4077)] = 136838,
  [SMALL_STATE(4078)] = 136888,
  [SMALL_STATE(4079)] = 136936,
  [SMALL_STATE(4080)] = 137018,
  [SMALL_STATE(4081)] = 137070,
  [SMALL_STATE(4082)] = 137148,
  [SMALL_STATE(4083)] = 137228,
  [SMALL_STATE(4084)] = 137296,
  [SMALL_STATE(4085)] = 137348,
  [SMALL_STATE(4086)] = 137402,
  [SMALL_STATE(4087)] = 137470,
  [SMALL_STATE(4088)] = 137540,
  [SMALL_STATE(4089)] = 137600,
  [SMALL_STATE(4090)] = 137668,
  [SMALL_STATE(4091)] = 137722,
  [SMALL_STATE(4092)] = 137778,
  [SMALL_STATE(4093)] = 137826,
  [SMALL_STATE(4094)] = 137902,
  [SMALL_STATE(4095)] = 137962,
  [SMALL_STATE(4096)] = 138010,
  [SMALL_STATE(4097)] = 138058,
  [SMALL_STATE(4098)] = 138108,
  [SMALL_STATE(4099)] = 138160,
  [SMALL_STATE(4100)] = 138240,
  [SMALL_STATE(4101)] = 138316,
  [SMALL_STATE(4102)] = 138364,
  [SMALL_STATE(4103)] = 138434,
  [SMALL_STATE(4104)] = 138510,
  [SMALL_STATE(4105)] = 138586,
  [SMALL_STATE(4106)] = 138664,
  [SMALL_STATE(4107)] = 138740,
  [SMALL_STATE(4108)] = 138816,
  [SMALL_STATE(4109)] = 138890,
  [SMALL_STATE(4110)] = 138966,
  [SMALL_STATE(4111)] = 139048,
  [SMALL_STATE(4112)] = 139124,
  [SMALL_STATE(4113)] = 139200,
  [SMALL_STATE(4114)] = 139280,
  [SMALL_STATE(4115)] = 139358,
  [SMALL_STATE(4116)] = 139436,
  [SMALL_STATE(4117)] = 139516,
  [SMALL_STATE(4118)] = 139594,
  [SMALL_STATE(4119)] = 139668,
  [SMALL_STATE(4120)] = 139716,
  [SMALL_STATE(4121)] = 139792,
  [SMALL_STATE(4122)] = 139868,
  [SMALL_STATE(4123)] = 139944,
  [SMALL_STATE(4124)] = 140020,
  [SMALL_STATE(4125)] = 140088,
  [SMALL_STATE(4126)] = 140134,
  [SMALL_STATE(4127)] = 140216,
  [SMALL_STATE(4128)] = 140292,
  [SMALL_STATE(4129)] = 140365,
  [SMALL_STATE(4130)] = 140442,
  [SMALL_STATE(4131)] = 140521,
  [SMALL_STATE(4132)] = 140596,
  [SMALL_STATE(4133)] = 140671,
  [SMALL_STATE(4134)] = 140718,
  [SMALL_STATE(4135)] = 140797,
  [SMALL_STATE(4136)] = 140874,
  [SMALL_STATE(4137)] = 140947,
  [SMALL_STATE(4138)] = 140996,
  [SMALL_STATE(4139)] = 141071,
  [SMALL_STATE(4140)] = 141118,
  [SMALL_STATE(4141)] = 141165,
  [SMALL_STATE(4142)] = 141212,
  [SMALL_STATE(4143)] = 141287,
  [SMALL_STATE(4144)] = 141366,
  [SMALL_STATE(4145)] = 141413,
  [SMALL_STATE(4146)] = 141460,
  [SMALL_STATE(4147)] = 141511,
  [SMALL_STATE(4148)] = 141560,
  [SMALL_STATE(4149)] = 141605,
  [SMALL_STATE(4150)] = 141682,
  [SMALL_STATE(4151)] = 141759,
  [SMALL_STATE(4152)] = 141836,
  [SMALL_STATE(4153)] = 141911,
  [SMALL_STATE(4154)] = 141988,
  [SMALL_STATE(4155)] = 142037,
  [SMALL_STATE(4156)] = 142110,
  [SMALL_STATE(4157)] = 142157,
  [SMALL_STATE(4158)] = 142232,
  [SMALL_STATE(4159)] = 142309,
  [SMALL_STATE(4160)] = 142382,
  [SMALL_STATE(4161)] = 142459,
  [SMALL_STATE(4162)] = 142534,
  [SMALL_STATE(4163)] = 142601,
  [SMALL_STATE(4164)] = 142656,
  [SMALL_STATE(4165)] = 142731,
  [SMALL_STATE(4166)] = 142778,
  [SMALL_STATE(4167)] = 142831,
  [SMALL_STATE(4168)] = 142882,
  [SMALL_STATE(4169)] = 142949,
  [SMALL_STATE(4170)] = 142998,
  [SMALL_STATE(4171)] = 143077,
  [SMALL_STATE(4172)] = 143124,
  [SMALL_STATE(4173)] = 143203,
  [SMALL_STATE(4174)] = 143272,
  [SMALL_STATE(4175)] = 143331,
  [SMALL_STATE(4176)] = 143384,
  [SMALL_STATE(4177)] = 143439,
  [SMALL_STATE(4178)] = 143498,
  [SMALL_STATE(4179)] = 143573,
  [SMALL_STATE(4180)] = 143648,
  [SMALL_STATE(4181)] = 143723,
  [SMALL_STATE(4182)] = 143798,
  [SMALL_STATE(4183)] = 143867,
  [SMALL_STATE(4184)] = 143914,
  [SMALL_STATE(4185)] = 143973,
  [SMALL_STATE(4186)] = 144020,
  [SMALL_STATE(4187)] = 144067,
  [SMALL_STATE(4188)] = 144116,
  [SMALL_STATE(4189)] = 144191,
  [SMALL_STATE(4190)] = 144260,
  [SMALL_STATE(4191)] = 144335,
  [SMALL_STATE(4192)] = 144410,
  [SMALL_STATE(4193)] = 144457,
  [SMALL_STATE(4194)] = 144530,
  [SMALL_STATE(4195)] = 144605,
  [SMALL_STATE(4196)] = 144654,
  [SMALL_STATE(4197)] = 144729,
  [SMALL_STATE(4198)] = 144804,
  [SMALL_STATE(4199)] = 144871,
  [SMALL_STATE(4200)] = 144948,
  [SMALL_STATE(4201)] = 144999,
  [SMALL_STATE(4202)] = 145054,
  [SMALL_STATE(4203)] = 145129,
  [SMALL_STATE(4204)] = 145196,
  [SMALL_STATE(4205)] = 145263,
  [SMALL_STATE(4206)] = 145316,
  [SMALL_STATE(4207)] = 145391,
  [SMALL_STATE(4208)] = 145436,
  [SMALL_STATE(4209)] = 145487,
  [SMALL_STATE(4210)] = 145562,
  [SMALL_STATE(4211)] = 145641,
  [SMALL_STATE(4212)] = 145714,
  [SMALL_STATE(4213)] = 145789,
  [SMALL_STATE(4214)] = 145836,
  [SMALL_STATE(4215)] = 145911,
  [SMALL_STATE(4216)] = 145978,
  [SMALL_STATE(4217)] = 146052,
  [SMALL_STATE(4218)] = 146102,
  [SMALL_STATE(4219)] = 146176,
  [SMALL_STATE(4220)] = 146252,
  [SMALL_STATE(4221)] = 146298,
  [SMALL_STATE(4222)] = 146370,
  [SMALL_STATE(4223)] = 146416,
  [SMALL_STATE(4224)] = 146488,
  [SMALL_STATE(4225)] = 146562,
  [SMALL_STATE(4226)] = 146614,
  [SMALL_STATE(4227)] = 146668,
  [SMALL_STATE(4228)] = 146726,
  [SMALL_STATE(4229)] = 146798,
  [SMALL_STATE(4230)] = 146870,
  [SMALL_STATE(4231)] = 146924,
  [SMALL_STATE(4232)] = 146998,
  [SMALL_STATE(4233)] = 147062,
  [SMALL_STATE(4234)] = 147136,
  [SMALL_STATE(4235)] = 147182,
  [SMALL_STATE(4236)] = 147258,
  [SMALL_STATE(4237)] = 147334,
  [SMALL_STATE(4238)] = 147380,
  [SMALL_STATE(4239)] = 147428,
  [SMALL_STATE(4240)] = 147504,
  [SMALL_STATE(4241)] = 147578,
  [SMALL_STATE(4242)] = 147652,
  [SMALL_STATE(4243)] = 147698,
  [SMALL_STATE(4244)] = 147750,
  [SMALL_STATE(4245)] = 147824,
  [SMALL_STATE(4246)] = 147900,
  [SMALL_STATE(4247)] = 147948,
  [SMALL_STATE(4248)] = 148024,
  [SMALL_STATE(4249)] = 148088,
  [SMALL_STATE(4250)] = 148162,
  [SMALL_STATE(4251)] = 148236,
  [SMALL_STATE(4252)] = 148310,
  [SMALL_STATE(4253)] = 148384,
  [SMALL_STATE(4254)] = 148430,
  [SMALL_STATE(4255)] = 148504,
  [SMALL_STATE(4256)] = 148570,
  [SMALL_STATE(4257)] = 148616,
  [SMALL_STATE(4258)] = 148682,
  [SMALL_STATE(4259)] = 148728,
  [SMALL_STATE(4260)] = 148778,
  [SMALL_STATE(4261)] = 148844,
  [SMALL_STATE(4262)] = 148912,
  [SMALL_STATE(4263)] = 148970,
  [SMALL_STATE(4264)] = 149036,
  [SMALL_STATE(4265)] = 149082,
  [SMALL_STATE(4266)] = 149150,
  [SMALL_STATE(4267)] = 149193,
  [SMALL_STATE(4268)] = 149236,
  [SMALL_STATE(4269)] = 149311,
  [SMALL_STATE(4270)] = 149386,
  [SMALL_STATE(4271)] = 149461,
  [SMALL_STATE(4272)] = 149536,
  [SMALL_STATE(4273)] = 149583,
  [SMALL_STATE(4274)] = 149658,
  [SMALL_STATE(4275)] = 149733,
  [SMALL_STATE(4276)] = 149808,
  [SMALL_STATE(4277)] = 149883,
  [SMALL_STATE(4278)] = 149958,
  [SMALL_STATE(4279)] = 150003,
  [SMALL_STATE(4280)] = 150048,
  [SMALL_STATE(4281)] = 150123,
  [SMALL_STATE(4282)] = 150176,
  [SMALL_STATE(4283)] = 150247,
  [SMALL_STATE(4284)] = 150322,
  [SMALL_STATE(4285)] = 150373,
  [SMALL_STATE(4286)] = 150430,
  [SMALL_STATE(4287)] = 150503,
  [SMALL_STATE(4288)] = 150570,
  [SMALL_STATE(4289)] = 150635,
  [SMALL_STATE(4290)] = 150684,
  [SMALL_STATE(4291)] = 150749,
  [SMALL_STATE(4292)] = 150794,
  [SMALL_STATE(4293)] = 150869,
  [SMALL_STATE(4294)] = 150944,
  [SMALL_STATE(4295)] = 151019,
  [SMALL_STATE(4296)] = 151094,
  [SMALL_STATE(4297)] = 151167,
  [SMALL_STATE(4298)] = 151240,
  [SMALL_STATE(4299)] = 151315,
  [SMALL_STATE(4300)] = 151388,
  [SMALL_STATE(4301)] = 151463,
  [SMALL_STATE(4302)] = 151538,
  [SMALL_STATE(4303)] = 151613,
  [SMALL_STATE(4304)] = 151686,
  [SMALL_STATE(4305)] = 151761,
  [SMALL_STATE(4306)] = 151804,
  [SMALL_STATE(4307)] = 151879,
  [SMALL_STATE(4308)] = 151954,
  [SMALL_STATE(4309)] = 152029,
  [SMALL_STATE(4310)] = 152104,
  [SMALL_STATE(4311)] = 152179,
  [SMALL_STATE(4312)] = 152254,
  [SMALL_STATE(4313)] = 152329,
  [SMALL_STATE(4314)] = 152404,
  [SMALL_STATE(4315)] = 152479,
  [SMALL_STATE(4316)] = 152522,
  [SMALL_STATE(4317)] = 152597,
  [SMALL_STATE(4318)] = 152672,
  [SMALL_STATE(4319)] = 152747,
  [SMALL_STATE(4320)] = 152822,
  [SMALL_STATE(4321)] = 152897,
  [SMALL_STATE(4322)] = 152972,
  [SMALL_STATE(4323)] = 153047,
  [SMALL_STATE(4324)] = 153122,
  [SMALL_STATE(4325)] = 153197,
  [SMALL_STATE(4326)] = 153272,
  [SMALL_STATE(4327)] = 153347,
  [SMALL_STATE(4328)] = 153422,
  [SMALL_STATE(4329)] = 153497,
  [SMALL_STATE(4330)] = 153572,
  [SMALL_STATE(4331)] = 153647,
  [SMALL_STATE(4332)] = 153690,
  [SMALL_STATE(4333)] = 153765,
  [SMALL_STATE(4334)] = 153840,
  [SMALL_STATE(4335)] = 153883,
  [SMALL_STATE(4336)] = 153926,
  [SMALL_STATE(4337)] = 153969,
  [SMALL_STATE(4338)] = 154012,
  [SMALL_STATE(4339)] = 154055,
  [SMALL_STATE(4340)] = 154130,
  [SMALL_STATE(4341)] = 154173,
  [SMALL_STATE(4342)] = 154248,
  [SMALL_STATE(4343)] = 154291,
  [SMALL_STATE(4344)] = 154334,
  [SMALL_STATE(4345)] = 154377,
  [SMALL_STATE(4346)] = 154452,
  [SMALL_STATE(4347)] = 154527,
  [SMALL_STATE(4348)] = 154602,
  [SMALL_STATE(4349)] = 154677,
  [SMALL_STATE(4350)] = 154752,
  [SMALL_STATE(4351)] = 154827,
  [SMALL_STATE(4352)] = 154902,
  [SMALL_STATE(4353)] = 154977,
  [SMALL_STATE(4354)] = 155020,
  [SMALL_STATE(4355)] = 155063,
  [SMALL_STATE(4356)] = 155138,
  [SMALL_STATE(4357)] = 155213,
  [SMALL_STATE(4358)] = 155288,
  [SMALL_STATE(4359)] = 155363,
  [SMALL_STATE(4360)] = 155438,
  [SMALL_STATE(4361)] = 155513,
  [SMALL_STATE(4362)] = 155588,
  [SMALL_STATE(4363)] = 155631,
  [SMALL_STATE(4364)] = 155704,
  [SMALL_STATE(4365)] = 155747,
  [SMALL_STATE(4366)] = 155790,
  [SMALL_STATE(4367)] = 155833,
  [SMALL_STATE(4368)] = 155876,
  [SMALL_STATE(4369)] = 155919,
  [SMALL_STATE(4370)] = 155994,
  [SMALL_STATE(4371)] = 156069,
  [SMALL_STATE(4372)] = 156118,
  [SMALL_STATE(4373)] = 156189,
  [SMALL_STATE(4374)] = 156264,
  [SMALL_STATE(4375)] = 156339,
  [SMALL_STATE(4376)] = 156414,
  [SMALL_STATE(4377)] = 156489,
  [SMALL_STATE(4378)] = 156564,
  [SMALL_STATE(4379)] = 156639,
  [SMALL_STATE(4380)] = 156684,
  [SMALL_STATE(4381)] = 156726,
  [SMALL_STATE(4382)] = 156768,
  [SMALL_STATE(4383)] = 156810,
  [SMALL_STATE(4384)] = 156852,
  [SMALL_STATE(4385)] = 156894,
  [SMALL_STATE(4386)] = 156936,
  [SMALL_STATE(4387)] = 156978,
  [SMALL_STATE(4388)] = 157020,
  [SMALL_STATE(4389)] = 157062,
  [SMALL_STATE(4390)] = 157104,
  [SMALL_STATE(4391)] = 157146,
  [SMALL_STATE(4392)] = 157188,
  [SMALL_STATE(4393)] = 157230,
  [SMALL_STATE(4394)] = 157272,
  [SMALL_STATE(4395)] = 157314,
  [SMALL_STATE(4396)] = 157356,
  [SMALL_STATE(4397)] = 157398,
  [SMALL_STATE(4398)] = 157440,
  [SMALL_STATE(4399)] = 157482,
  [SMALL_STATE(4400)] = 157524,
  [SMALL_STATE(4401)] = 157566,
  [SMALL_STATE(4402)] = 157608,
  [SMALL_STATE(4403)] = 157650,
  [SMALL_STATE(4404)] = 157692,
  [SMALL_STATE(4405)] = 157734,
  [SMALL_STATE(4406)] = 157776,
  [SMALL_STATE(4407)] = 157818,
  [SMALL_STATE(4408)] = 157860,
  [SMALL_STATE(4409)] = 157902,
  [SMALL_STATE(4410)] = 157944,
  [SMALL_STATE(4411)] = 157986,
  [SMALL_STATE(4412)] = 158028,
  [SMALL_STATE(4413)] = 158070,
  [SMALL_STATE(4414)] = 158112,
  [SMALL_STATE(4415)] = 158154,
  [SMALL_STATE(4416)] = 158196,
  [SMALL_STATE(4417)] = 158238,
  [SMALL_STATE(4418)] = 158280,
  [SMALL_STATE(4419)] = 158322,
  [SMALL_STATE(4420)] = 158364,
  [SMALL_STATE(4421)] = 158406,
  [SMALL_STATE(4422)] = 158448,
  [SMALL_STATE(4423)] = 158490,
  [SMALL_STATE(4424)] = 158532,
  [SMALL_STATE(4425)] = 158574,
  [SMALL_STATE(4426)] = 158616,
  [SMALL_STATE(4427)] = 158658,
  [SMALL_STATE(4428)] = 158700,
  [SMALL_STATE(4429)] = 158742,
  [SMALL_STATE(4430)] = 158784,
  [SMALL_STATE(4431)] = 158826,
  [SMALL_STATE(4432)] = 158868,
  [SMALL_STATE(4433)] = 158909,
  [SMALL_STATE(4434)] = 158950,
  [SMALL_STATE(4435)] = 158991,
  [SMALL_STATE(4436)] = 159032,
  [SMALL_STATE(4437)] = 159073,
  [SMALL_STATE(4438)] = 159115,
  [SMALL_STATE(4439)] = 159155,
  [SMALL_STATE(4440)] = 159203,
  [SMALL_STATE(4441)] = 159243,
  [SMALL_STATE(4442)] = 159283,
  [SMALL_STATE(4443)] = 159331,
  [SMALL_STATE(4444)] = 159371,
  [SMALL_STATE(4445)] = 159411,
  [SMALL_STATE(4446)] = 159451,
  [SMALL_STATE(4447)] = 159491,
  [SMALL_STATE(4448)] = 159531,
  [SMALL_STATE(4449)] = 159571,
  [SMALL_STATE(4450)] = 159617,
  [SMALL_STATE(4451)] = 159657,
  [SMALL_STATE(4452)] = 159697,
  [SMALL_STATE(4453)] = 159737,
  [SMALL_STATE(4454)] = 159777,
  [SMALL_STATE(4455)] = 159817,
  [SMALL_STATE(4456)] = 159857,
  [SMALL_STATE(4457)] = 159897,
  [SMALL_STATE(4458)] = 159943,
  [SMALL_STATE(4459)] = 159983,
  [SMALL_STATE(4460)] = 160023,
  [SMALL_STATE(4461)] = 160062,
  [SMALL_STATE(4462)] = 160101,
  [SMALL_STATE(4463)] = 160140,
  [SMALL_STATE(4464)] = 160181,
  [SMALL_STATE(4465)] = 160222,
  [SMALL_STATE(4466)] = 160263,
  [SMALL_STATE(4467)] = 160302,
  [SMALL_STATE(4468)] = 160361,
  [SMALL_STATE(4469)] = 160400,
  [SMALL_STATE(4470)] = 160439,
  [SMALL_STATE(4471)] = 160478,
  [SMALL_STATE(4472)] = 160519,
  [SMALL_STATE(4473)] = 160558,
  [SMALL_STATE(4474)] = 160597,
  [SMALL_STATE(4475)] = 160636,
  [SMALL_STATE(4476)] = 160695,
  [SMALL_STATE(4477)] = 160733,
  [SMALL_STATE(4478)] = 160771,
  [SMALL_STATE(4479)] = 160809,
  [SMALL_STATE(4480)] = 160847,
  [SMALL_STATE(4481)] = 160885,
  [SMALL_STATE(4482)] = 160923,
  [SMALL_STATE(4483)] = 160961,
  [SMALL_STATE(4484)] = 160999,
  [SMALL_STATE(4485)] = 161037,
  [SMALL_STATE(4486)] = 161075,
  [SMALL_STATE(4487)] = 161113,
  [SMALL_STATE(4488)] = 161151,
  [SMALL_STATE(4489)] = 161189,
  [SMALL_STATE(4490)] = 161227,
  [SMALL_STATE(4491)] = 161265,
  [SMALL_STATE(4492)] = 161303,
  [SMALL_STATE(4493)] = 161341,
  [SMALL_STATE(4494)] = 161379,
  [SMALL_STATE(4495)] = 161417,
  [SMALL_STATE(4496)] = 161455,
  [SMALL_STATE(4497)] = 161493,
  [SMALL_STATE(4498)] = 161531,
  [SMALL_STATE(4499)] = 161569,
  [SMALL_STATE(4500)] = 161607,
  [SMALL_STATE(4501)] = 161647,
  [SMALL_STATE(4502)] = 161685,
  [SMALL_STATE(4503)] = 161723,
  [SMALL_STATE(4504)] = 161761,
  [SMALL_STATE(4505)] = 161799,
  [SMALL_STATE(4506)] = 161839,
  [SMALL_STATE(4507)] = 161877,
  [SMALL_STATE(4508)] = 161915,
  [SMALL_STATE(4509)] = 161953,
  [SMALL_STATE(4510)] = 161991,
  [SMALL_STATE(4511)] = 162029,
  [SMALL_STATE(4512)] = 162067,
  [SMALL_STATE(4513)] = 162105,
  [SMALL_STATE(4514)] = 162143,
  [SMALL_STATE(4515)] = 162181,
  [SMALL_STATE(4516)] = 162238,
  [SMALL_STATE(4517)] = 162279,
  [SMALL_STATE(4518)] = 162336,
  [SMALL_STATE(4519)] = 162393,
  [SMALL_STATE(4520)] = 162450,
  [SMALL_STATE(4521)] = 162488,
  [SMALL_STATE(4522)] = 162526,
  [SMALL_STATE(4523)] = 162564,
  [SMALL_STATE(4524)] = 162602,
  [SMALL_STATE(4525)] = 162640,
  [SMALL_STATE(4526)] = 162678,
  [SMALL_STATE(4527)] = 162716,
  [SMALL_STATE(4528)] = 162752,
  [SMALL_STATE(4529)] = 162790,
  [SMALL_STATE(4530)] = 162826,
  [SMALL_STATE(4531)] = 162864,
  [SMALL_STATE(4532)] = 162902,
  [SMALL_STATE(4533)] = 162940,
  [SMALL_STATE(4534)] = 162976,
  [SMALL_STATE(4535)] = 163011,
  [SMALL_STATE(4536)] = 163070,
  [SMALL_STATE(4537)] = 163129,
  [SMALL_STATE(4538)] = 163188,
  [SMALL_STATE(4539)] = 163247,
  [SMALL_STATE(4540)] = 163306,
  [SMALL_STATE(4541)] = 163365,
  [SMALL_STATE(4542)] = 163424,
  [SMALL_STATE(4543)] = 163483,
  [SMALL_STATE(4544)] = 163542,
  [SMALL_STATE(4545)] = 163601,
  [SMALL_STATE(4546)] = 163660,
  [SMALL_STATE(4547)] = 163719,
  [SMALL_STATE(4548)] = 163754,
  [SMALL_STATE(4549)] = 163813,
  [SMALL_STATE(4550)] = 163872,
  [SMALL_STATE(4551)] = 163931,
  [SMALL_STATE(4552)] = 163990,
  [SMALL_STATE(4553)] = 164049,
  [SMALL_STATE(4554)] = 164084,
  [SMALL_STATE(4555)] = 164143,
  [SMALL_STATE(4556)] = 164180,
  [SMALL_STATE(4557)] = 164239,
  [SMALL_STATE(4558)] = 164298,
  [SMALL_STATE(4559)] = 164357,
  [SMALL_STATE(4560)] = 164416,
  [SMALL_STATE(4561)] = 164475,
  [SMALL_STATE(4562)] = 164534,
  [SMALL_STATE(4563)] = 164588,
  [SMALL_STATE(4564)] = 164624,
  [SMALL_STATE(4565)] = 164658,
  [SMALL_STATE(4566)] = 164712,
  [SMALL_STATE(4567)] = 164766,
  [SMALL_STATE(4568)] = 164820,
  [SMALL_STATE(4569)] = 164874,
  [SMALL_STATE(4570)] = 164928,
  [SMALL_STATE(4571)] = 164962,
  [SMALL_STATE(4572)] = 164996,
  [SMALL_STATE(4573)] = 165030,
  [SMALL_STATE(4574)] = 165064,
  [SMALL_STATE(4575)] = 165100,
  [SMALL_STATE(4576)] = 165136,
  [SMALL_STATE(4577)] = 165190,
  [SMALL_STATE(4578)] = 165224,
  [SMALL_STATE(4579)] = 165258,
  [SMALL_STATE(4580)] = 165313,
  [SMALL_STATE(4581)] = 165346,
  [SMALL_STATE(4582)] = 165381,
  [SMALL_STATE(4583)] = 165436,
  [SMALL_STATE(4584)] = 165469,
  [SMALL_STATE(4585)] = 165502,
  [SMALL_STATE(4586)] = 165539,
  [SMALL_STATE(4587)] = 165572,
  [SMALL_STATE(4588)] = 165607,
  [SMALL_STATE(4589)] = 165640,
  [SMALL_STATE(4590)] = 165673,
  [SMALL_STATE(4591)] = 165709,
  [SMALL_STATE(4592)] = 165761,
  [SMALL_STATE(4593)] = 165813,
  [SMALL_STATE(4594)] = 165847,
  [SMALL_STATE(4595)] = 165879,
  [SMALL_STATE(4596)] = 165911,
  [SMALL_STATE(4597)] = 165945,
  [SMALL_STATE(4598)] = 165997,
  [SMALL_STATE(4599)] = 166029,
  [SMALL_STATE(4600)] = 166063,
  [SMALL_STATE(4601)] = 166115,
  [SMALL_STATE(4602)] = 166147,
  [SMALL_STATE(4603)] = 166179,
  [SMALL_STATE(4604)] = 166211,
  [SMALL_STATE(4605)] = 166247,
  [SMALL_STATE(4606)] = 166279,
  [SMALL_STATE(4607)] = 166311,
  [SMALL_STATE(4608)] = 166342,
  [SMALL_STATE(4609)] = 166393,
  [SMALL_STATE(4610)] = 166442,
  [SMALL_STATE(4611)] = 166501,
  [SMALL_STATE(4612)] = 166560,
  [SMALL_STATE(4613)] = 166595,
  [SMALL_STATE(4614)] = 166654,
  [SMALL_STATE(4615)] = 166703,
  [SMALL_STATE(4616)] = 166752,
  [SMALL_STATE(4617)] = 166811,
  [SMALL_STATE(4618)] = 166870,
  [SMALL_STATE(4619)] = 166905,
  [SMALL_STATE(4620)] = 166964,
  [SMALL_STATE(4621)] = 167015,
  [SMALL_STATE(4622)] = 167061,
  [SMALL_STATE(4623)] = 167103,
  [SMALL_STATE(4624)] = 167135,
  [SMALL_STATE(4625)] = 167169,
  [SMALL_STATE(4626)] = 167199,
  [SMALL_STATE(4627)] = 167233,
  [SMALL_STATE(4628)] = 167279,
  [SMALL_STATE(4629)] = 167313,
  [SMALL_STATE(4630)] = 167347,
  [SMALL_STATE(4631)] = 167381,
  [SMALL_STATE(4632)] = 167427,
  [SMALL_STATE(4633)] = 167459,
  [SMALL_STATE(4634)] = 167493,
  [SMALL_STATE(4635)] = 167525,
  [SMALL_STATE(4636)] = 167567,
  [SMALL_STATE(4637)] = 167601,
  [SMALL_STATE(4638)] = 167633,
  [SMALL_STATE(4639)] = 167679,
  [SMALL_STATE(4640)] = 167713,
  [SMALL_STATE(4641)] = 167747,
  [SMALL_STATE(4642)] = 167781,
  [SMALL_STATE(4643)] = 167812,
  [SMALL_STATE(4644)] = 167843,
  [SMALL_STATE(4645)] = 167874,
  [SMALL_STATE(4646)] = 167907,
  [SMALL_STATE(4647)] = 167940,
  [SMALL_STATE(4648)] = 167966,
  [SMALL_STATE(4649)] = 167992,
  [SMALL_STATE(4650)] = 168018,
  [SMALL_STATE(4651)] = 168044,
  [SMALL_STATE(4652)] = 168072,
  [SMALL_STATE(4653)] = 168100,
  [SMALL_STATE(4654)] = 168126,
  [SMALL_STATE(4655)] = 168152,
  [SMALL_STATE(4656)] = 168178,
  [SMALL_STATE(4657)] = 168204,
  [SMALL_STATE(4658)] = 168230,
  [SMALL_STATE(4659)] = 168258,
  [SMALL_STATE(4660)] = 168284,
  [SMALL_STATE(4661)] = 168310,
  [SMALL_STATE(4662)] = 168336,
  [SMALL_STATE(4663)] = 168368,
  [SMALL_STATE(4664)] = 168394,
  [SMALL_STATE(4665)] = 168424,
  [SMALL_STATE(4666)] = 168462,
  [SMALL_STATE(4667)] = 168488,
  [SMALL_STATE(4668)] = 168520,
  [SMALL_STATE(4669)] = 168558,
  [SMALL_STATE(4670)] = 168584,
  [SMALL_STATE(4671)] = 168612,
  [SMALL_STATE(4672)] = 168638,
  [SMALL_STATE(4673)] = 168664,
  [SMALL_STATE(4674)] = 168690,
  [SMALL_STATE(4675)] = 168722,
  [SMALL_STATE(4676)] = 168752,
  [SMALL_STATE(4677)] = 168778,
  [SMALL_STATE(4678)] = 168804,
  [SMALL_STATE(4679)] = 168831,
  [SMALL_STATE(4680)] = 168858,
  [SMALL_STATE(4681)] = 168885,
  [SMALL_STATE(4682)] = 168912,
  [SMALL_STATE(4683)] = 168949,
  [SMALL_STATE(4684)] = 168976,
  [SMALL_STATE(4685)] = 169013,
  [SMALL_STATE(4686)] = 169040,
  [SMALL_STATE(4687)] = 169067,
  [SMALL_STATE(4688)] = 169094,
  [SMALL_STATE(4689)] = 169121,
  [SMALL_STATE(4690)] = 169148,
  [SMALL_STATE(4691)] = 169175,
  [SMALL_STATE(4692)] = 169202,
  [SMALL_STATE(4693)] = 169229,
  [SMALL_STATE(4694)] = 169258,
  [SMALL_STATE(4695)] = 169285,
  [SMALL_STATE(4696)] = 169312,
  [SMALL_STATE(4697)] = 169339,
  [SMALL_STATE(4698)] = 169366,
  [SMALL_STATE(4699)] = 169395,
  [SMALL_STATE(4700)] = 169422,
  [SMALL_STATE(4701)] = 169451,
  [SMALL_STATE(4702)] = 169478,
  [SMALL_STATE(4703)] = 169505,
  [SMALL_STATE(4704)] = 169532,
  [SMALL_STATE(4705)] = 169559,
  [SMALL_STATE(4706)] = 169586,
  [SMALL_STATE(4707)] = 169613,
  [SMALL_STATE(4708)] = 169640,
  [SMALL_STATE(4709)] = 169667,
  [SMALL_STATE(4710)] = 169694,
  [SMALL_STATE(4711)] = 169721,
  [SMALL_STATE(4712)] = 169750,
  [SMALL_STATE(4713)] = 169777,
  [SMALL_STATE(4714)] = 169804,
  [SMALL_STATE(4715)] = 169831,
  [SMALL_STATE(4716)] = 169858,
  [SMALL_STATE(4717)] = 169885,
  [SMALL_STATE(4718)] = 169912,
  [SMALL_STATE(4719)] = 169939,
  [SMALL_STATE(4720)] = 169966,
  [SMALL_STATE(4721)] = 169993,
  [SMALL_STATE(4722)] = 170020,
  [SMALL_STATE(4723)] = 170047,
  [SMALL_STATE(4724)] = 170074,
  [SMALL_STATE(4725)] = 170101,
  [SMALL_STATE(4726)] = 170128,
  [SMALL_STATE(4727)] = 170155,
  [SMALL_STATE(4728)] = 170186,
  [SMALL_STATE(4729)] = 170213,
  [SMALL_STATE(4730)] = 170240,
  [SMALL_STATE(4731)] = 170267,
  [SMALL_STATE(4732)] = 170294,
  [SMALL_STATE(4733)] = 170321,
  [SMALL_STATE(4734)] = 170348,
  [SMALL_STATE(4735)] = 170375,
  [SMALL_STATE(4736)] = 170402,
  [SMALL_STATE(4737)] = 170429,
  [SMALL_STATE(4738)] = 170456,
  [SMALL_STATE(4739)] = 170483,
  [SMALL_STATE(4740)] = 170510,
  [SMALL_STATE(4741)] = 170537,
  [SMALL_STATE(4742)] = 170564,
  [SMALL_STATE(4743)] = 170593,
  [SMALL_STATE(4744)] = 170625,
  [SMALL_STATE(4745)] = 170653,
  [SMALL_STATE(4746)] = 170681,
  [SMALL_STATE(4747)] = 170711,
  [SMALL_STATE(4748)] = 170739,
  [SMALL_STATE(4749)] = 170765,
  [SMALL_STATE(4750)] = 170795,
  [SMALL_STATE(4751)] = 170823,
  [SMALL_STATE(4752)] = 170853,
  [SMALL_STATE(4753)] = 170881,
  [SMALL_STATE(4754)] = 170911,
  [SMALL_STATE(4755)] = 170939,
  [SMALL_STATE(4756)] = 170967,
  [SMALL_STATE(4757)] = 170995,
  [SMALL_STATE(4758)] = 171023,
  [SMALL_STATE(4759)] = 171051,
  [SMALL_STATE(4760)] = 171079,
  [SMALL_STATE(4761)] = 171107,
  [SMALL_STATE(4762)] = 171135,
  [SMALL_STATE(4763)] = 171163,
  [SMALL_STATE(4764)] = 171191,
  [SMALL_STATE(4765)] = 171214,
  [SMALL_STATE(4766)] = 171241,
  [SMALL_STATE(4767)] = 171266,
  [SMALL_STATE(4768)] = 171293,
  [SMALL_STATE(4769)] = 171320,
  [SMALL_STATE(4770)] = 171343,
  [SMALL_STATE(4771)] = 171366,
  [SMALL_STATE(4772)] = 171401,
  [SMALL_STATE(4773)] = 171424,
  [SMALL_STATE(4774)] = 171451,
  [SMALL_STATE(4775)] = 171490,
  [SMALL_STATE(4776)] = 171529,
  [SMALL_STATE(4777)] = 171556,
  [SMALL_STATE(4778)] = 171581,
  [SMALL_STATE(4779)] = 171604,
  [SMALL_STATE(4780)] = 171629,
  [SMALL_STATE(4781)] = 171652,
  [SMALL_STATE(4782)] = 171675,
  [SMALL_STATE(4783)] = 171702,
  [SMALL_STATE(4784)] = 171725,
  [SMALL_STATE(4785)] = 171752,
  [SMALL_STATE(4786)] = 171775,
  [SMALL_STATE(4787)] = 171798,
  [SMALL_STATE(4788)] = 171821,
  [SMALL_STATE(4789)] = 171844,
  [SMALL_STATE(4790)] = 171871,
  [SMALL_STATE(4791)] = 171894,
  [SMALL_STATE(4792)] = 171917,
  [SMALL_STATE(4793)] = 171940,
  [SMALL_STATE(4794)] = 171963,
  [SMALL_STATE(4795)] = 171988,
  [SMALL_STATE(4796)] = 172011,
  [SMALL_STATE(4797)] = 172036,
  [SMALL_STATE(4798)] = 172061,
  [SMALL_STATE(4799)] = 172084,
  [SMALL_STATE(4800)] = 172109,
  [SMALL_STATE(4801)] = 172132,
  [SMALL_STATE(4802)] = 172167,
  [SMALL_STATE(4803)] = 172202,
  [SMALL_STATE(4804)] = 172225,
  [SMALL_STATE(4805)] = 172248,
  [SMALL_STATE(4806)] = 172271,
  [SMALL_STATE(4807)] = 172300,
  [SMALL_STATE(4808)] = 172325,
  [SMALL_STATE(4809)] = 172352,
  [SMALL_STATE(4810)] = 172375,
  [SMALL_STATE(4811)] = 172402,
  [SMALL_STATE(4812)] = 172429,
  [SMALL_STATE(4813)] = 172452,
  [SMALL_STATE(4814)] = 172475,
  [SMALL_STATE(4815)] = 172498,
  [SMALL_STATE(4816)] = 172523,
  [SMALL_STATE(4817)] = 172548,
  [SMALL_STATE(4818)] = 172571,
  [SMALL_STATE(4819)] = 172600,
  [SMALL_STATE(4820)] = 172623,
  [SMALL_STATE(4821)] = 172648,
  [SMALL_STATE(4822)] = 172671,
  [SMALL_STATE(4823)] = 172706,
  [SMALL_STATE(4824)] = 172731,
  [SMALL_STATE(4825)] = 172758,
  [SMALL_STATE(4826)] = 172793,
  [SMALL_STATE(4827)] = 172822,
  [SMALL_STATE(4828)] = 172845,
  [SMALL_STATE(4829)] = 172868,
  [SMALL_STATE(4830)] = 172893,
  [SMALL_STATE(4831)] = 172918,
  [SMALL_STATE(4832)] = 172943,
  [SMALL_STATE(4833)] = 172970,
  [SMALL_STATE(4834)] = 172993,
  [SMALL_STATE(4835)] = 173018,
  [SMALL_STATE(4836)] = 173041,
  [SMALL_STATE(4837)] = 173065,
  [SMALL_STATE(4838)] = 173103,
  [SMALL_STATE(4839)] = 173127,
  [SMALL_STATE(4840)] = 173165,
  [SMALL_STATE(4841)] = 173203,
  [SMALL_STATE(4842)] = 173225,
  [SMALL_STATE(4843)] = 173249,
  [SMALL_STATE(4844)] = 173273,
  [SMALL_STATE(4845)] = 173297,
  [SMALL_STATE(4846)] = 173327,
  [SMALL_STATE(4847)] = 173351,
  [SMALL_STATE(4848)] = 173389,
  [SMALL_STATE(4849)] = 173427,
  [SMALL_STATE(4850)] = 173449,
  [SMALL_STATE(4851)] = 173485,
  [SMALL_STATE(4852)] = 173509,
  [SMALL_STATE(4853)] = 173543,
  [SMALL_STATE(4854)] = 173567,
  [SMALL_STATE(4855)] = 173593,
  [SMALL_STATE(4856)] = 173617,
  [SMALL_STATE(4857)] = 173655,
  [SMALL_STATE(4858)] = 173679,
  [SMALL_STATE(4859)] = 173717,
  [SMALL_STATE(4860)] = 173755,
  [SMALL_STATE(4861)] = 173777,
  [SMALL_STATE(4862)] = 173799,
  [SMALL_STATE(4863)] = 173821,
  [SMALL_STATE(4864)] = 173843,
  [SMALL_STATE(4865)] = 173865,
  [SMALL_STATE(4866)] = 173895,
  [SMALL_STATE(4867)] = 173933,
  [SMALL_STATE(4868)] = 173957,
  [SMALL_STATE(4869)] = 173995,
  [SMALL_STATE(4870)] = 174033,
  [SMALL_STATE(4871)] = 174059,
  [SMALL_STATE(4872)] = 174081,
  [SMALL_STATE(4873)] = 174103,
  [SMALL_STATE(4874)] = 174125,
  [SMALL_STATE(4875)] = 174147,
  [SMALL_STATE(4876)] = 174175,
  [SMALL_STATE(4877)] = 174203,
  [SMALL_STATE(4878)] = 174241,
  [SMALL_STATE(4879)] = 174265,
  [SMALL_STATE(4880)] = 174291,
  [SMALL_STATE(4881)] = 174329,
  [SMALL_STATE(4882)] = 174353,
  [SMALL_STATE(4883)] = 174375,
  [SMALL_STATE(4884)] = 174412,
  [SMALL_STATE(4885)] = 174433,
  [SMALL_STATE(4886)] = 174470,
  [SMALL_STATE(4887)] = 174507,
  [SMALL_STATE(4888)] = 174544,
  [SMALL_STATE(4889)] = 174581,
  [SMALL_STATE(4890)] = 174606,
  [SMALL_STATE(4891)] = 174643,
  [SMALL_STATE(4892)] = 174680,
  [SMALL_STATE(4893)] = 174717,
  [SMALL_STATE(4894)] = 174754,
  [SMALL_STATE(4895)] = 174777,
  [SMALL_STATE(4896)] = 174814,
  [SMALL_STATE(4897)] = 174837,
  [SMALL_STATE(4898)] = 174860,
  [SMALL_STATE(4899)] = 174885,
  [SMALL_STATE(4900)] = 174910,
  [SMALL_STATE(4901)] = 174935,
  [SMALL_STATE(4902)] = 174960,
  [SMALL_STATE(4903)] = 174983,
  [SMALL_STATE(4904)] = 175020,
  [SMALL_STATE(4905)] = 175041,
  [SMALL_STATE(4906)] = 175078,
  [SMALL_STATE(4907)] = 175115,
  [SMALL_STATE(4908)] = 175152,
  [SMALL_STATE(4909)] = 175175,
  [SMALL_STATE(4910)] = 175212,
  [SMALL_STATE(4911)] = 175249,
  [SMALL_STATE(4912)] = 175270,
  [SMALL_STATE(4913)] = 175307,
  [SMALL_STATE(4914)] = 175344,
  [SMALL_STATE(4915)] = 175365,
  [SMALL_STATE(4916)] = 175402,
  [SMALL_STATE(4917)] = 175439,
  [SMALL_STATE(4918)] = 175460,
  [SMALL_STATE(4919)] = 175485,
  [SMALL_STATE(4920)] = 175508,
  [SMALL_STATE(4921)] = 175529,
  [SMALL_STATE(4922)] = 175566,
  [SMALL_STATE(4923)] = 175591,
  [SMALL_STATE(4924)] = 175628,
  [SMALL_STATE(4925)] = 175665,
  [SMALL_STATE(4926)] = 175690,
  [SMALL_STATE(4927)] = 175715,
  [SMALL_STATE(4928)] = 175740,
  [SMALL_STATE(4929)] = 175777,
  [SMALL_STATE(4930)] = 175800,
  [SMALL_STATE(4931)] = 175821,
  [SMALL_STATE(4932)] = 175846,
  [SMALL_STATE(4933)] = 175883,
  [SMALL_STATE(4934)] = 175906,
  [SMALL_STATE(4935)] = 175931,
  [SMALL_STATE(4936)] = 175968,
  [SMALL_STATE(4937)] = 175993,
  [SMALL_STATE(4938)] = 176018,
  [SMALL_STATE(4939)] = 176052,
  [SMALL_STATE(4940)] = 176072,
  [SMALL_STATE(4941)] = 176094,
  [SMALL_STATE(4942)] = 176118,
  [SMALL_STATE(4943)] = 176138,
  [SMALL_STATE(4944)] = 176158,
  [SMALL_STATE(4945)] = 176178,
  [SMALL_STATE(4946)] = 176198,
  [SMALL_STATE(4947)] = 176218,
  [SMALL_STATE(4948)] = 176238,
  [SMALL_STATE(4949)] = 176258,
  [SMALL_STATE(4950)] = 176278,
  [SMALL_STATE(4951)] = 176298,
  [SMALL_STATE(4952)] = 176320,
  [SMALL_STATE(4953)] = 176340,
  [SMALL_STATE(4954)] = 176362,
  [SMALL_STATE(4955)] = 176384,
  [SMALL_STATE(4956)] = 176408,
  [SMALL_STATE(4957)] = 176428,
  [SMALL_STATE(4958)] = 176462,
  [SMALL_STATE(4959)] = 176482,
  [SMALL_STATE(4960)] = 176516,
  [SMALL_STATE(4961)] = 176550,
  [SMALL_STATE(4962)] = 176584,
  [SMALL_STATE(4963)] = 176612,
  [SMALL_STATE(4964)] = 176636,
  [SMALL_STATE(4965)] = 176656,
  [SMALL_STATE(4966)] = 176680,
  [SMALL_STATE(4967)] = 176702,
  [SMALL_STATE(4968)] = 176724,
  [SMALL_STATE(4969)] = 176744,
  [SMALL_STATE(4970)] = 176768,
  [SMALL_STATE(4971)] = 176788,
  [SMALL_STATE(4972)] = 176808,
  [SMALL_STATE(4973)] = 176828,
  [SMALL_STATE(4974)] = 176848,
  [SMALL_STATE(4975)] = 176870,
  [SMALL_STATE(4976)] = 176890,
  [SMALL_STATE(4977)] = 176910,
  [SMALL_STATE(4978)] = 176930,
  [SMALL_STATE(4979)] = 176950,
  [SMALL_STATE(4980)] = 176970,
  [SMALL_STATE(4981)] = 176990,
  [SMALL_STATE(4982)] = 177010,
  [SMALL_STATE(4983)] = 177044,
  [SMALL_STATE(4984)] = 177068,
  [SMALL_STATE(4985)] = 177088,
  [SMALL_STATE(4986)] = 177108,
  [SMALL_STATE(4987)] = 177128,
  [SMALL_STATE(4988)] = 177148,
  [SMALL_STATE(4989)] = 177182,
  [SMALL_STATE(4990)] = 177206,
  [SMALL_STATE(4991)] = 177240,
  [SMALL_STATE(4992)] = 177274,
  [SMALL_STATE(4993)] = 177308,
  [SMALL_STATE(4994)] = 177338,
  [SMALL_STATE(4995)] = 177372,
  [SMALL_STATE(4996)] = 177392,
  [SMALL_STATE(4997)] = 177426,
  [SMALL_STATE(4998)] = 177458,
  [SMALL_STATE(4999)] = 177492,
  [SMALL_STATE(5000)] = 177522,
  [SMALL_STATE(5001)] = 177556,
  [SMALL_STATE(5002)] = 177590,
  [SMALL_STATE(5003)] = 177610,
  [SMALL_STATE(5004)] = 177644,
  [SMALL_STATE(5005)] = 177678,
  [SMALL_STATE(5006)] = 177712,
  [SMALL_STATE(5007)] = 177732,
  [SMALL_STATE(5008)] = 177754,
  [SMALL_STATE(5009)] = 177778,
  [SMALL_STATE(5010)] = 177798,
  [SMALL_STATE(5011)] = 177818,
  [SMALL_STATE(5012)] = 177846,
  [SMALL_STATE(5013)] = 177870,
  [SMALL_STATE(5014)] = 177898,
  [SMALL_STATE(5015)] = 177928,
  [SMALL_STATE(5016)] = 177956,
  [SMALL_STATE(5017)] = 177976,
  [SMALL_STATE(5018)] = 177996,
  [SMALL_STATE(5019)] = 178016,
  [SMALL_STATE(5020)] = 178036,
  [SMALL_STATE(5021)] = 178058,
  [SMALL_STATE(5022)] = 178078,
  [SMALL_STATE(5023)] = 178098,
  [SMALL_STATE(5024)] = 178118,
  [SMALL_STATE(5025)] = 178146,
  [SMALL_STATE(5026)] = 178180,
  [SMALL_STATE(5027)] = 178204,
  [SMALL_STATE(5028)] = 178238,
  [SMALL_STATE(5029)] = 178258,
  [SMALL_STATE(5030)] = 178292,
  [SMALL_STATE(5031)] = 178324,
  [SMALL_STATE(5032)] = 178358,
  [SMALL_STATE(5033)] = 178378,
  [SMALL_STATE(5034)] = 178398,
  [SMALL_STATE(5035)] = 178430,
  [SMALL_STATE(5036)] = 178458,
  [SMALL_STATE(5037)] = 178486,
  [SMALL_STATE(5038)] = 178515,
  [SMALL_STATE(5039)] = 178544,
  [SMALL_STATE(5040)] = 178563,
  [SMALL_STATE(5041)] = 178582,
  [SMALL_STATE(5042)] = 178605,
  [SMALL_STATE(5043)] = 178624,
  [SMALL_STATE(5044)] = 178643,
  [SMALL_STATE(5045)] = 178670,
  [SMALL_STATE(5046)] = 178699,
  [SMALL_STATE(5047)] = 178726,
  [SMALL_STATE(5048)] = 178755,
  [SMALL_STATE(5049)] = 178774,
  [SMALL_STATE(5050)] = 178803,
  [SMALL_STATE(5051)] = 178832,
  [SMALL_STATE(5052)] = 178861,
  [SMALL_STATE(5053)] = 178890,
  [SMALL_STATE(5054)] = 178919,
  [SMALL_STATE(5055)] = 178946,
  [SMALL_STATE(5056)] = 178975,
  [SMALL_STATE(5057)] = 179004,
  [SMALL_STATE(5058)] = 179033,
  [SMALL_STATE(5059)] = 179062,
  [SMALL_STATE(5060)] = 179091,
  [SMALL_STATE(5061)] = 179116,
  [SMALL_STATE(5062)] = 179145,
  [SMALL_STATE(5063)] = 179174,
  [SMALL_STATE(5064)] = 179193,
  [SMALL_STATE(5065)] = 179212,
  [SMALL_STATE(5066)] = 179241,
  [SMALL_STATE(5067)] = 179260,
  [SMALL_STATE(5068)] = 179279,
  [SMALL_STATE(5069)] = 179306,
  [SMALL_STATE(5070)] = 179333,
  [SMALL_STATE(5071)] = 179362,
  [SMALL_STATE(5072)] = 179391,
  [SMALL_STATE(5073)] = 179420,
  [SMALL_STATE(5074)] = 179449,
  [SMALL_STATE(5075)] = 179478,
  [SMALL_STATE(5076)] = 179497,
  [SMALL_STATE(5077)] = 179524,
  [SMALL_STATE(5078)] = 179543,
  [SMALL_STATE(5079)] = 179570,
  [SMALL_STATE(5080)] = 179589,
  [SMALL_STATE(5081)] = 179618,
  [SMALL_STATE(5082)] = 179639,
  [SMALL_STATE(5083)] = 179668,
  [SMALL_STATE(5084)] = 179695,
  [SMALL_STATE(5085)] = 179724,
  [SMALL_STATE(5086)] = 179753,
  [SMALL_STATE(5087)] = 179780,
  [SMALL_STATE(5088)] = 179809,
  [SMALL_STATE(5089)] = 179838,
  [SMALL_STATE(5090)] = 179865,
  [SMALL_STATE(5091)] = 179894,
  [SMALL_STATE(5092)] = 179923,
  [SMALL_STATE(5093)] = 179942,
  [SMALL_STATE(5094)] = 179971,
  [SMALL_STATE(5095)] = 179994,
  [SMALL_STATE(5096)] = 180021,
  [SMALL_STATE(5097)] = 180050,
  [SMALL_STATE(5098)] = 180077,
  [SMALL_STATE(5099)] = 180106,
  [SMALL_STATE(5100)] = 180135,
  [SMALL_STATE(5101)] = 180162,
  [SMALL_STATE(5102)] = 180189,
  [SMALL_STATE(5103)] = 180208,
  [SMALL_STATE(5104)] = 180235,
  [SMALL_STATE(5105)] = 180262,
  [SMALL_STATE(5106)] = 180285,
  [SMALL_STATE(5107)] = 180314,
  [SMALL_STATE(5108)] = 180343,
  [SMALL_STATE(5109)] = 180362,
  [SMALL_STATE(5110)] = 180391,
  [SMALL_STATE(5111)] = 180420,
  [SMALL_STATE(5112)] = 180447,
  [SMALL_STATE(5113)] = 180474,
  [SMALL_STATE(5114)] = 180497,
  [SMALL_STATE(5115)] = 180526,
  [SMALL_STATE(5116)] = 180555,
  [SMALL_STATE(5117)] = 180584,
  [SMALL_STATE(5118)] = 180613,
  [SMALL_STATE(5119)] = 180640,
  [SMALL_STATE(5120)] = 180669,
  [SMALL_STATE(5121)] = 180698,
  [SMALL_STATE(5122)] = 180725,
  [SMALL_STATE(5123)] = 180752,
  [SMALL_STATE(5124)] = 180779,
  [SMALL_STATE(5125)] = 180808,
  [SMALL_STATE(5126)] = 180835,
  [SMALL_STATE(5127)] = 180864,
  [SMALL_STATE(5128)] = 180891,
  [SMALL_STATE(5129)] = 180920,
  [SMALL_STATE(5130)] = 180949,
  [SMALL_STATE(5131)] = 180978,
  [SMALL_STATE(5132)] = 181007,
  [SMALL_STATE(5133)] = 181034,
  [SMALL_STATE(5134)] = 181063,
  [SMALL_STATE(5135)] = 181092,
  [SMALL_STATE(5136)] = 181121,
  [SMALL_STATE(5137)] = 181150,
  [SMALL_STATE(5138)] = 181179,
  [SMALL_STATE(5139)] = 181206,
  [SMALL_STATE(5140)] = 181233,
  [SMALL_STATE(5141)] = 181260,
  [SMALL_STATE(5142)] = 181289,
  [SMALL_STATE(5143)] = 181318,
  [SMALL_STATE(5144)] = 181347,
  [SMALL_STATE(5145)] = 181374,
  [SMALL_STATE(5146)] = 181397,
  [SMALL_STATE(5147)] = 181422,
  [SMALL_STATE(5148)] = 181445,
  [SMALL_STATE(5149)] = 181474,
  [SMALL_STATE(5150)] = 181501,
  [SMALL_STATE(5151)] = 181528,
  [SMALL_STATE(5152)] = 181557,
  [SMALL_STATE(5153)] = 181584,
  [SMALL_STATE(5154)] = 181613,
  [SMALL_STATE(5155)] = 181642,
  [SMALL_STATE(5156)] = 181661,
  [SMALL_STATE(5157)] = 181688,
  [SMALL_STATE(5158)] = 181707,
  [SMALL_STATE(5159)] = 181734,
  [SMALL_STATE(5160)] = 181753,
  [SMALL_STATE(5161)] = 181782,
  [SMALL_STATE(5162)] = 181811,
  [SMALL_STATE(5163)] = 181840,
  [SMALL_STATE(5164)] = 181869,
  [SMALL_STATE(5165)] = 181888,
  [SMALL_STATE(5166)] = 181909,
  [SMALL_STATE(5167)] = 181936,
  [SMALL_STATE(5168)] = 181965,
  [SMALL_STATE(5169)] = 181992,
  [SMALL_STATE(5170)] = 182021,
  [SMALL_STATE(5171)] = 182050,
  [SMALL_STATE(5172)] = 182077,
  [SMALL_STATE(5173)] = 182104,
  [SMALL_STATE(5174)] = 182133,
  [SMALL_STATE(5175)] = 182160,
  [SMALL_STATE(5176)] = 182187,
  [SMALL_STATE(5177)] = 182206,
  [SMALL_STATE(5178)] = 182235,
  [SMALL_STATE(5179)] = 182264,
  [SMALL_STATE(5180)] = 182293,
  [SMALL_STATE(5181)] = 182322,
  [SMALL_STATE(5182)] = 182351,
  [SMALL_STATE(5183)] = 182380,
  [SMALL_STATE(5184)] = 182407,
  [SMALL_STATE(5185)] = 182434,
  [SMALL_STATE(5186)] = 182463,
  [SMALL_STATE(5187)] = 182490,
  [SMALL_STATE(5188)] = 182509,
  [SMALL_STATE(5189)] = 182538,
  [SMALL_STATE(5190)] = 182565,
  [SMALL_STATE(5191)] = 182586,
  [SMALL_STATE(5192)] = 182615,
  [SMALL_STATE(5193)] = 182644,
  [SMALL_STATE(5194)] = 182673,
  [SMALL_STATE(5195)] = 182694,
  [SMALL_STATE(5196)] = 182715,
  [SMALL_STATE(5197)] = 182744,
  [SMALL_STATE(5198)] = 182773,
  [SMALL_STATE(5199)] = 182802,
  [SMALL_STATE(5200)] = 182831,
  [SMALL_STATE(5201)] = 182850,
  [SMALL_STATE(5202)] = 182879,
  [SMALL_STATE(5203)] = 182908,
  [SMALL_STATE(5204)] = 182935,
  [SMALL_STATE(5205)] = 182964,
  [SMALL_STATE(5206)] = 182983,
  [SMALL_STATE(5207)] = 183010,
  [SMALL_STATE(5208)] = 183037,
  [SMALL_STATE(5209)] = 183066,
  [SMALL_STATE(5210)] = 183093,
  [SMALL_STATE(5211)] = 183122,
  [SMALL_STATE(5212)] = 183149,
  [SMALL_STATE(5213)] = 183172,
  [SMALL_STATE(5214)] = 183201,
  [SMALL_STATE(5215)] = 183223,
  [SMALL_STATE(5216)] = 183251,
  [SMALL_STATE(5217)] = 183279,
  [SMALL_STATE(5218)] = 183303,
  [SMALL_STATE(5219)] = 183331,
  [SMALL_STATE(5220)] = 183359,
  [SMALL_STATE(5221)] = 183383,
  [SMALL_STATE(5222)] = 183411,
  [SMALL_STATE(5223)] = 183439,
  [SMALL_STATE(5224)] = 183467,
  [SMALL_STATE(5225)] = 183487,
  [SMALL_STATE(5226)] = 183515,
  [SMALL_STATE(5227)] = 183539,
  [SMALL_STATE(5228)] = 183567,
  [SMALL_STATE(5229)] = 183593,
  [SMALL_STATE(5230)] = 183613,
  [SMALL_STATE(5231)] = 183637,
  [SMALL_STATE(5232)] = 183661,
  [SMALL_STATE(5233)] = 183681,
  [SMALL_STATE(5234)] = 183709,
  [SMALL_STATE(5235)] = 183729,
  [SMALL_STATE(5236)] = 183749,
  [SMALL_STATE(5237)] = 183767,
  [SMALL_STATE(5238)] = 183785,
  [SMALL_STATE(5239)] = 183813,
  [SMALL_STATE(5240)] = 183841,
  [SMALL_STATE(5241)] = 183859,
  [SMALL_STATE(5242)] = 183887,
  [SMALL_STATE(5243)] = 183907,
  [SMALL_STATE(5244)] = 183935,
  [SMALL_STATE(5245)] = 183955,
  [SMALL_STATE(5246)] = 183983,
  [SMALL_STATE(5247)] = 184001,
  [SMALL_STATE(5248)] = 184027,
  [SMALL_STATE(5249)] = 184055,
  [SMALL_STATE(5250)] = 184083,
  [SMALL_STATE(5251)] = 184107,
  [SMALL_STATE(5252)] = 184135,
  [SMALL_STATE(5253)] = 184163,
  [SMALL_STATE(5254)] = 184191,
  [SMALL_STATE(5255)] = 184215,
  [SMALL_STATE(5256)] = 184239,
  [SMALL_STATE(5257)] = 184267,
  [SMALL_STATE(5258)] = 184295,
  [SMALL_STATE(5259)] = 184323,
  [SMALL_STATE(5260)] = 184345,
  [SMALL_STATE(5261)] = 184367,
  [SMALL_STATE(5262)] = 184385,
  [SMALL_STATE(5263)] = 184403,
  [SMALL_STATE(5264)] = 184423,
  [SMALL_STATE(5265)] = 184451,
  [SMALL_STATE(5266)] = 184469,
  [SMALL_STATE(5267)] = 184487,
  [SMALL_STATE(5268)] = 184505,
  [SMALL_STATE(5269)] = 184523,
  [SMALL_STATE(5270)] = 184551,
  [SMALL_STATE(5271)] = 184573,
  [SMALL_STATE(5272)] = 184601,
  [SMALL_STATE(5273)] = 184623,
  [SMALL_STATE(5274)] = 184641,
  [SMALL_STATE(5275)] = 184663,
  [SMALL_STATE(5276)] = 184683,
  [SMALL_STATE(5277)] = 184703,
  [SMALL_STATE(5278)] = 184725,
  [SMALL_STATE(5279)] = 184753,
  [SMALL_STATE(5280)] = 184773,
  [SMALL_STATE(5281)] = 184795,
  [SMALL_STATE(5282)] = 184817,
  [SMALL_STATE(5283)] = 184845,
  [SMALL_STATE(5284)] = 184873,
  [SMALL_STATE(5285)] = 184895,
  [SMALL_STATE(5286)] = 184915,
  [SMALL_STATE(5287)] = 184943,
  [SMALL_STATE(5288)] = 184971,
  [SMALL_STATE(5289)] = 184999,
  [SMALL_STATE(5290)] = 185027,
  [SMALL_STATE(5291)] = 185048,
  [SMALL_STATE(5292)] = 185071,
  [SMALL_STATE(5293)] = 185092,
  [SMALL_STATE(5294)] = 185115,
  [SMALL_STATE(5295)] = 185132,
  [SMALL_STATE(5296)] = 185149,
  [SMALL_STATE(5297)] = 185170,
  [SMALL_STATE(5298)] = 185189,
  [SMALL_STATE(5299)] = 185210,
  [SMALL_STATE(5300)] = 185229,
  [SMALL_STATE(5301)] = 185248,
  [SMALL_STATE(5302)] = 185267,
  [SMALL_STATE(5303)] = 185286,
  [SMALL_STATE(5304)] = 185305,
  [SMALL_STATE(5305)] = 185326,
  [SMALL_STATE(5306)] = 185345,
  [SMALL_STATE(5307)] = 185366,
  [SMALL_STATE(5308)] = 185383,
  [SMALL_STATE(5309)] = 185406,
  [SMALL_STATE(5310)] = 185423,
  [SMALL_STATE(5311)] = 185446,
  [SMALL_STATE(5312)] = 185469,
  [SMALL_STATE(5313)] = 185492,
  [SMALL_STATE(5314)] = 185515,
  [SMALL_STATE(5315)] = 185534,
  [SMALL_STATE(5316)] = 185557,
  [SMALL_STATE(5317)] = 185576,
  [SMALL_STATE(5318)] = 185595,
  [SMALL_STATE(5319)] = 185618,
  [SMALL_STATE(5320)] = 185637,
  [SMALL_STATE(5321)] = 185656,
  [SMALL_STATE(5322)] = 185679,
  [SMALL_STATE(5323)] = 185702,
  [SMALL_STATE(5324)] = 185723,
  [SMALL_STATE(5325)] = 185746,
  [SMALL_STATE(5326)] = 185765,
  [SMALL_STATE(5327)] = 185788,
  [SMALL_STATE(5328)] = 185804,
  [SMALL_STATE(5329)] = 185820,
  [SMALL_STATE(5330)] = 185836,
  [SMALL_STATE(5331)] = 185852,
  [SMALL_STATE(5332)] = 185872,
  [SMALL_STATE(5333)] = 185888,
  [SMALL_STATE(5334)] = 185904,
  [SMALL_STATE(5335)] = 185920,
  [SMALL_STATE(5336)] = 185936,
  [SMALL_STATE(5337)] = 185952,
  [SMALL_STATE(5338)] = 185968,
  [SMALL_STATE(5339)] = 185984,
  [SMALL_STATE(5340)] = 186000,
  [SMALL_STATE(5341)] = 186018,
  [SMALL_STATE(5342)] = 186038,
  [SMALL_STATE(5343)] = 186054,
  [SMALL_STATE(5344)] = 186070,
  [SMALL_STATE(5345)] = 186086,
  [SMALL_STATE(5346)] = 186102,
  [SMALL_STATE(5347)] = 186118,
  [SMALL_STATE(5348)] = 186134,
  [SMALL_STATE(5349)] = 186150,
  [SMALL_STATE(5350)] = 186166,
  [SMALL_STATE(5351)] = 186182,
  [SMALL_STATE(5352)] = 186198,
  [SMALL_STATE(5353)] = 186214,
  [SMALL_STATE(5354)] = 186232,
  [SMALL_STATE(5355)] = 186250,
  [SMALL_STATE(5356)] = 186266,
  [SMALL_STATE(5357)] = 186282,
  [SMALL_STATE(5358)] = 186298,
  [SMALL_STATE(5359)] = 186314,
  [SMALL_STATE(5360)] = 186330,
  [SMALL_STATE(5361)] = 186346,
  [SMALL_STATE(5362)] = 186362,
  [SMALL_STATE(5363)] = 186382,
  [SMALL_STATE(5364)] = 186398,
  [SMALL_STATE(5365)] = 186416,
  [SMALL_STATE(5366)] = 186432,
  [SMALL_STATE(5367)] = 186450,
  [SMALL_STATE(5368)] = 186466,
  [SMALL_STATE(5369)] = 186482,
  [SMALL_STATE(5370)] = 186500,
  [SMALL_STATE(5371)] = 186520,
  [SMALL_STATE(5372)] = 186540,
  [SMALL_STATE(5373)] = 186556,
  [SMALL_STATE(5374)] = 186572,
  [SMALL_STATE(5375)] = 186588,
  [SMALL_STATE(5376)] = 186604,
  [SMALL_STATE(5377)] = 186620,
  [SMALL_STATE(5378)] = 186636,
  [SMALL_STATE(5379)] = 186652,
  [SMALL_STATE(5380)] = 186672,
  [SMALL_STATE(5381)] = 186688,
  [SMALL_STATE(5382)] = 186708,
  [SMALL_STATE(5383)] = 186724,
  [SMALL_STATE(5384)] = 186740,
  [SMALL_STATE(5385)] = 186756,
  [SMALL_STATE(5386)] = 186776,
  [SMALL_STATE(5387)] = 186792,
  [SMALL_STATE(5388)] = 186808,
  [SMALL_STATE(5389)] = 186824,
  [SMALL_STATE(5390)] = 186840,
  [SMALL_STATE(5391)] = 186856,
  [SMALL_STATE(5392)] = 186876,
  [SMALL_STATE(5393)] = 186892,
  [SMALL_STATE(5394)] = 186908,
  [SMALL_STATE(5395)] = 186928,
  [SMALL_STATE(5396)] = 186944,
  [SMALL_STATE(5397)] = 186962,
  [SMALL_STATE(5398)] = 186978,
  [SMALL_STATE(5399)] = 186994,
  [SMALL_STATE(5400)] = 187012,
  [SMALL_STATE(5401)] = 187028,
  [SMALL_STATE(5402)] = 187044,
  [SMALL_STATE(5403)] = 187060,
  [SMALL_STATE(5404)] = 187078,
  [SMALL_STATE(5405)] = 187094,
  [SMALL_STATE(5406)] = 187110,
  [SMALL_STATE(5407)] = 187126,
  [SMALL_STATE(5408)] = 187142,
  [SMALL_STATE(5409)] = 187158,
  [SMALL_STATE(5410)] = 187174,
  [SMALL_STATE(5411)] = 187190,
  [SMALL_STATE(5412)] = 187206,
  [SMALL_STATE(5413)] = 187222,
  [SMALL_STATE(5414)] = 187238,
  [SMALL_STATE(5415)] = 187254,
  [SMALL_STATE(5416)] = 187270,
  [SMALL_STATE(5417)] = 187286,
  [SMALL_STATE(5418)] = 187306,
  [SMALL_STATE(5419)] = 187328,
  [SMALL_STATE(5420)] = 187344,
  [SMALL_STATE(5421)] = 187360,
  [SMALL_STATE(5422)] = 187378,
  [SMALL_STATE(5423)] = 187394,
  [SMALL_STATE(5424)] = 187410,
  [SMALL_STATE(5425)] = 187430,
  [SMALL_STATE(5426)] = 187450,
  [SMALL_STATE(5427)] = 187466,
  [SMALL_STATE(5428)] = 187482,
  [SMALL_STATE(5429)] = 187498,
  [SMALL_STATE(5430)] = 187514,
  [SMALL_STATE(5431)] = 187530,
  [SMALL_STATE(5432)] = 187546,
  [SMALL_STATE(5433)] = 187562,
  [SMALL_STATE(5434)] = 187578,
  [SMALL_STATE(5435)] = 187594,
  [SMALL_STATE(5436)] = 187610,
  [SMALL_STATE(5437)] = 187626,
  [SMALL_STATE(5438)] = 187642,
  [SMALL_STATE(5439)] = 187658,
  [SMALL_STATE(5440)] = 187674,
  [SMALL_STATE(5441)] = 187694,
  [SMALL_STATE(5442)] = 187716,
  [SMALL_STATE(5443)] = 187732,
  [SMALL_STATE(5444)] = 187754,
  [SMALL_STATE(5445)] = 187770,
  [SMALL_STATE(5446)] = 187786,
  [SMALL_STATE(5447)] = 187802,
  [SMALL_STATE(5448)] = 187818,
  [SMALL_STATE(5449)] = 187834,
  [SMALL_STATE(5450)] = 187854,
  [SMALL_STATE(5451)] = 187870,
  [SMALL_STATE(5452)] = 187886,
  [SMALL_STATE(5453)] = 187904,
  [SMALL_STATE(5454)] = 187920,
  [SMALL_STATE(5455)] = 187936,
  [SMALL_STATE(5456)] = 187958,
  [SMALL_STATE(5457)] = 187974,
  [SMALL_STATE(5458)] = 187990,
  [SMALL_STATE(5459)] = 188006,
  [SMALL_STATE(5460)] = 188022,
  [SMALL_STATE(5461)] = 188042,
  [SMALL_STATE(5462)] = 188058,
  [SMALL_STATE(5463)] = 188074,
  [SMALL_STATE(5464)] = 188090,
  [SMALL_STATE(5465)] = 188106,
  [SMALL_STATE(5466)] = 188122,
  [SMALL_STATE(5467)] = 188138,
  [SMALL_STATE(5468)] = 188154,
  [SMALL_STATE(5469)] = 188170,
  [SMALL_STATE(5470)] = 188186,
  [SMALL_STATE(5471)] = 188202,
  [SMALL_STATE(5472)] = 188218,
  [SMALL_STATE(5473)] = 188234,
  [SMALL_STATE(5474)] = 188250,
  [SMALL_STATE(5475)] = 188266,
  [SMALL_STATE(5476)] = 188282,
  [SMALL_STATE(5477)] = 188298,
  [SMALL_STATE(5478)] = 188314,
  [SMALL_STATE(5479)] = 188334,
  [SMALL_STATE(5480)] = 188350,
  [SMALL_STATE(5481)] = 188370,
  [SMALL_STATE(5482)] = 188386,
  [SMALL_STATE(5483)] = 188402,
  [SMALL_STATE(5484)] = 188418,
  [SMALL_STATE(5485)] = 188434,
  [SMALL_STATE(5486)] = 188450,
  [SMALL_STATE(5487)] = 188466,
  [SMALL_STATE(5488)] = 188482,
  [SMALL_STATE(5489)] = 188498,
  [SMALL_STATE(5490)] = 188516,
  [SMALL_STATE(5491)] = 188534,
  [SMALL_STATE(5492)] = 188550,
  [SMALL_STATE(5493)] = 188566,
  [SMALL_STATE(5494)] = 188582,
  [SMALL_STATE(5495)] = 188598,
  [SMALL_STATE(5496)] = 188617,
  [SMALL_STATE(5497)] = 188636,
  [SMALL_STATE(5498)] = 188653,
  [SMALL_STATE(5499)] = 188672,
  [SMALL_STATE(5500)] = 188691,
  [SMALL_STATE(5501)] = 188710,
  [SMALL_STATE(5502)] = 188727,
  [SMALL_STATE(5503)] = 188742,
  [SMALL_STATE(5504)] = 188759,
  [SMALL_STATE(5505)] = 188778,
  [SMALL_STATE(5506)] = 188795,
  [SMALL_STATE(5507)] = 188814,
  [SMALL_STATE(5508)] = 188833,
  [SMALL_STATE(5509)] = 188852,
  [SMALL_STATE(5510)] = 188869,
  [SMALL_STATE(5511)] = 188888,
  [SMALL_STATE(5512)] = 188907,
  [SMALL_STATE(5513)] = 188922,
  [SMALL_STATE(5514)] = 188941,
  [SMALL_STATE(5515)] = 188960,
  [SMALL_STATE(5516)] = 188977,
  [SMALL_STATE(5517)] = 188996,
  [SMALL_STATE(5518)] = 189015,
  [SMALL_STATE(5519)] = 189034,
  [SMALL_STATE(5520)] = 189053,
  [SMALL_STATE(5521)] = 189068,
  [SMALL_STATE(5522)] = 189085,
  [SMALL_STATE(5523)] = 189100,
  [SMALL_STATE(5524)] = 189119,
  [SMALL_STATE(5525)] = 189138,
  [SMALL_STATE(5526)] = 189153,
  [SMALL_STATE(5527)] = 189172,
  [SMALL_STATE(5528)] = 189191,
  [SMALL_STATE(5529)] = 189210,
  [SMALL_STATE(5530)] = 189229,
  [SMALL_STATE(5531)] = 189248,
  [SMALL_STATE(5532)] = 189267,
  [SMALL_STATE(5533)] = 189282,
  [SMALL_STATE(5534)] = 189301,
  [SMALL_STATE(5535)] = 189320,
  [SMALL_STATE(5536)] = 189339,
  [SMALL_STATE(5537)] = 189354,
  [SMALL_STATE(5538)] = 189371,
  [SMALL_STATE(5539)] = 189386,
  [SMALL_STATE(5540)] = 189401,
  [SMALL_STATE(5541)] = 189418,
  [SMALL_STATE(5542)] = 189437,
  [SMALL_STATE(5543)] = 189456,
  [SMALL_STATE(5544)] = 189475,
  [SMALL_STATE(5545)] = 189490,
  [SMALL_STATE(5546)] = 189509,
  [SMALL_STATE(5547)] = 189528,
  [SMALL_STATE(5548)] = 189547,
  [SMALL_STATE(5549)] = 189566,
  [SMALL_STATE(5550)] = 189585,
  [SMALL_STATE(5551)] = 189604,
  [SMALL_STATE(5552)] = 189621,
  [SMALL_STATE(5553)] = 189636,
  [SMALL_STATE(5554)] = 189655,
  [SMALL_STATE(5555)] = 189674,
  [SMALL_STATE(5556)] = 189693,
  [SMALL_STATE(5557)] = 189712,
  [SMALL_STATE(5558)] = 189727,
  [SMALL_STATE(5559)] = 189744,
  [SMALL_STATE(5560)] = 189763,
  [SMALL_STATE(5561)] = 189782,
  [SMALL_STATE(5562)] = 189797,
  [SMALL_STATE(5563)] = 189816,
  [SMALL_STATE(5564)] = 189833,
  [SMALL_STATE(5565)] = 189852,
  [SMALL_STATE(5566)] = 189871,
  [SMALL_STATE(5567)] = 189888,
  [SMALL_STATE(5568)] = 189907,
  [SMALL_STATE(5569)] = 189926,
  [SMALL_STATE(5570)] = 189945,
  [SMALL_STATE(5571)] = 189964,
  [SMALL_STATE(5572)] = 189979,
  [SMALL_STATE(5573)] = 189994,
  [SMALL_STATE(5574)] = 190009,
  [SMALL_STATE(5575)] = 190028,
  [SMALL_STATE(5576)] = 190047,
  [SMALL_STATE(5577)] = 190066,
  [SMALL_STATE(5578)] = 190085,
  [SMALL_STATE(5579)] = 190101,
  [SMALL_STATE(5580)] = 190115,
  [SMALL_STATE(5581)] = 190129,
  [SMALL_STATE(5582)] = 190143,
  [SMALL_STATE(5583)] = 190157,
  [SMALL_STATE(5584)] = 190171,
  [SMALL_STATE(5585)] = 190185,
  [SMALL_STATE(5586)] = 190201,
  [SMALL_STATE(5587)] = 190215,
  [SMALL_STATE(5588)] = 190229,
  [SMALL_STATE(5589)] = 190243,
  [SMALL_STATE(5590)] = 190257,
  [SMALL_STATE(5591)] = 190271,
  [SMALL_STATE(5592)] = 190285,
  [SMALL_STATE(5593)] = 190299,
  [SMALL_STATE(5594)] = 190313,
  [SMALL_STATE(5595)] = 190327,
  [SMALL_STATE(5596)] = 190341,
  [SMALL_STATE(5597)] = 190355,
  [SMALL_STATE(5598)] = 190369,
  [SMALL_STATE(5599)] = 190383,
  [SMALL_STATE(5600)] = 190399,
  [SMALL_STATE(5601)] = 190413,
  [SMALL_STATE(5602)] = 190427,
  [SMALL_STATE(5603)] = 190441,
  [SMALL_STATE(5604)] = 190455,
  [SMALL_STATE(5605)] = 190471,
  [SMALL_STATE(5606)] = 190485,
  [SMALL_STATE(5607)] = 190501,
  [SMALL_STATE(5608)] = 190515,
  [SMALL_STATE(5609)] = 190529,
  [SMALL_STATE(5610)] = 190543,
  [SMALL_STATE(5611)] = 190559,
  [SMALL_STATE(5612)] = 190573,
  [SMALL_STATE(5613)] = 190589,
  [SMALL_STATE(5614)] = 190603,
  [SMALL_STATE(5615)] = 190617,
  [SMALL_STATE(5616)] = 190631,
  [SMALL_STATE(5617)] = 190645,
  [SMALL_STATE(5618)] = 190659,
  [SMALL_STATE(5619)] = 190673,
  [SMALL_STATE(5620)] = 190687,
  [SMALL_STATE(5621)] = 190701,
  [SMALL_STATE(5622)] = 190715,
  [SMALL_STATE(5623)] = 190729,
  [SMALL_STATE(5624)] = 190743,
  [SMALL_STATE(5625)] = 190759,
  [SMALL_STATE(5626)] = 190773,
  [SMALL_STATE(5627)] = 190787,
  [SMALL_STATE(5628)] = 190801,
  [SMALL_STATE(5629)] = 190815,
  [SMALL_STATE(5630)] = 190829,
  [SMALL_STATE(5631)] = 190845,
  [SMALL_STATE(5632)] = 190859,
  [SMALL_STATE(5633)] = 190873,
  [SMALL_STATE(5634)] = 190887,
  [SMALL_STATE(5635)] = 190901,
  [SMALL_STATE(5636)] = 190915,
  [SMALL_STATE(5637)] = 190929,
  [SMALL_STATE(5638)] = 190943,
  [SMALL_STATE(5639)] = 190957,
  [SMALL_STATE(5640)] = 190971,
  [SMALL_STATE(5641)] = 190984,
  [SMALL_STATE(5642)] = 190997,
  [SMALL_STATE(5643)] = 191010,
  [SMALL_STATE(5644)] = 191023,
  [SMALL_STATE(5645)] = 191036,
  [SMALL_STATE(5646)] = 191049,
  [SMALL_STATE(5647)] = 191062,
  [SMALL_STATE(5648)] = 191075,
  [SMALL_STATE(5649)] = 191088,
  [SMALL_STATE(5650)] = 191101,
  [SMALL_STATE(5651)] = 191114,
  [SMALL_STATE(5652)] = 191127,
  [SMALL_STATE(5653)] = 191140,
  [SMALL_STATE(5654)] = 191153,
  [SMALL_STATE(5655)] = 191166,
  [SMALL_STATE(5656)] = 191179,
  [SMALL_STATE(5657)] = 191192,
  [SMALL_STATE(5658)] = 191205,
  [SMALL_STATE(5659)] = 191218,
  [SMALL_STATE(5660)] = 191231,
  [SMALL_STATE(5661)] = 191244,
  [SMALL_STATE(5662)] = 191257,
  [SMALL_STATE(5663)] = 191270,
  [SMALL_STATE(5664)] = 191283,
  [SMALL_STATE(5665)] = 191296,
  [SMALL_STATE(5666)] = 191309,
  [SMALL_STATE(5667)] = 191322,
  [SMALL_STATE(5668)] = 191335,
  [SMALL_STATE(5669)] = 191348,
  [SMALL_STATE(5670)] = 191361,
  [SMALL_STATE(5671)] = 191374,
  [SMALL_STATE(5672)] = 191387,
  [SMALL_STATE(5673)] = 191400,
  [SMALL_STATE(5674)] = 191413,
  [SMALL_STATE(5675)] = 191426,
  [SMALL_STATE(5676)] = 191439,
  [SMALL_STATE(5677)] = 191452,
  [SMALL_STATE(5678)] = 191465,
  [SMALL_STATE(5679)] = 191478,
  [SMALL_STATE(5680)] = 191491,
  [SMALL_STATE(5681)] = 191504,
  [SMALL_STATE(5682)] = 191517,
  [SMALL_STATE(5683)] = 191530,
  [SMALL_STATE(5684)] = 191543,
  [SMALL_STATE(5685)] = 191556,
  [SMALL_STATE(5686)] = 191569,
  [SMALL_STATE(5687)] = 191582,
  [SMALL_STATE(5688)] = 191595,
  [SMALL_STATE(5689)] = 191608,
  [SMALL_STATE(5690)] = 191621,
  [SMALL_STATE(5691)] = 191634,
  [SMALL_STATE(5692)] = 191647,
  [SMALL_STATE(5693)] = 191660,
  [SMALL_STATE(5694)] = 191673,
  [SMALL_STATE(5695)] = 191686,
  [SMALL_STATE(5696)] = 191699,
  [SMALL_STATE(5697)] = 191712,
  [SMALL_STATE(5698)] = 191725,
  [SMALL_STATE(5699)] = 191738,
  [SMALL_STATE(5700)] = 191751,
  [SMALL_STATE(5701)] = 191764,
  [SMALL_STATE(5702)] = 191777,
  [SMALL_STATE(5703)] = 191790,
  [SMALL_STATE(5704)] = 191803,
  [SMALL_STATE(5705)] = 191816,
  [SMALL_STATE(5706)] = 191829,
  [SMALL_STATE(5707)] = 191842,
  [SMALL_STATE(5708)] = 191855,
  [SMALL_STATE(5709)] = 191868,
  [SMALL_STATE(5710)] = 191881,
  [SMALL_STATE(5711)] = 191894,
  [SMALL_STATE(5712)] = 191907,
  [SMALL_STATE(5713)] = 191920,
  [SMALL_STATE(5714)] = 191933,
  [SMALL_STATE(5715)] = 191946,
  [SMALL_STATE(5716)] = 191959,
  [SMALL_STATE(5717)] = 191972,
  [SMALL_STATE(5718)] = 191985,
  [SMALL_STATE(5719)] = 191998,
  [SMALL_STATE(5720)] = 192011,
  [SMALL_STATE(5721)] = 192024,
  [SMALL_STATE(5722)] = 192037,
  [SMALL_STATE(5723)] = 192050,
  [SMALL_STATE(5724)] = 192063,
  [SMALL_STATE(5725)] = 192076,
  [SMALL_STATE(5726)] = 192089,
  [SMALL_STATE(5727)] = 192102,
  [SMALL_STATE(5728)] = 192115,
  [SMALL_STATE(5729)] = 192128,
  [SMALL_STATE(5730)] = 192141,
  [SMALL_STATE(5731)] = 192154,
  [SMALL_STATE(5732)] = 192167,
  [SMALL_STATE(5733)] = 192180,
  [SMALL_STATE(5734)] = 192193,
  [SMALL_STATE(5735)] = 192206,
  [SMALL_STATE(5736)] = 192219,
  [SMALL_STATE(5737)] = 192232,
  [SMALL_STATE(5738)] = 192245,
  [SMALL_STATE(5739)] = 192258,
  [SMALL_STATE(5740)] = 192271,
  [SMALL_STATE(5741)] = 192284,
  [SMALL_STATE(5742)] = 192297,
  [SMALL_STATE(5743)] = 192310,
  [SMALL_STATE(5744)] = 192323,
  [SMALL_STATE(5745)] = 192336,
  [SMALL_STATE(5746)] = 192349,
  [SMALL_STATE(5747)] = 192362,
  [SMALL_STATE(5748)] = 192375,
  [SMALL_STATE(5749)] = 192388,
  [SMALL_STATE(5750)] = 192401,
  [SMALL_STATE(5751)] = 192414,
  [SMALL_STATE(5752)] = 192427,
  [SMALL_STATE(5753)] = 192440,
  [SMALL_STATE(5754)] = 192453,
  [SMALL_STATE(5755)] = 192466,
  [SMALL_STATE(5756)] = 192479,
  [SMALL_STATE(5757)] = 192492,
  [SMALL_STATE(5758)] = 192505,
  [SMALL_STATE(5759)] = 192518,
  [SMALL_STATE(5760)] = 192531,
  [SMALL_STATE(5761)] = 192544,
  [SMALL_STATE(5762)] = 192557,
  [SMALL_STATE(5763)] = 192570,
  [SMALL_STATE(5764)] = 192583,
  [SMALL_STATE(5765)] = 192596,
  [SMALL_STATE(5766)] = 192609,
  [SMALL_STATE(5767)] = 192622,
  [SMALL_STATE(5768)] = 192635,
  [SMALL_STATE(5769)] = 192648,
  [SMALL_STATE(5770)] = 192661,
  [SMALL_STATE(5771)] = 192674,
  [SMALL_STATE(5772)] = 192687,
  [SMALL_STATE(5773)] = 192700,
  [SMALL_STATE(5774)] = 192713,
  [SMALL_STATE(5775)] = 192726,
  [SMALL_STATE(5776)] = 192739,
  [SMALL_STATE(5777)] = 192752,
  [SMALL_STATE(5778)] = 192765,
  [SMALL_STATE(5779)] = 192778,
  [SMALL_STATE(5780)] = 192791,
  [SMALL_STATE(5781)] = 192804,
  [SMALL_STATE(5782)] = 192817,
  [SMALL_STATE(5783)] = 192830,
  [SMALL_STATE(5784)] = 192843,
  [SMALL_STATE(5785)] = 192856,
  [SMALL_STATE(5786)] = 192869,
  [SMALL_STATE(5787)] = 192882,
  [SMALL_STATE(5788)] = 192895,
  [SMALL_STATE(5789)] = 192908,
  [SMALL_STATE(5790)] = 192921,
  [SMALL_STATE(5791)] = 192934,
  [SMALL_STATE(5792)] = 192947,
  [SMALL_STATE(5793)] = 192960,
  [SMALL_STATE(5794)] = 192973,
  [SMALL_STATE(5795)] = 192986,
  [SMALL_STATE(5796)] = 192999,
  [SMALL_STATE(5797)] = 193012,
  [SMALL_STATE(5798)] = 193025,
  [SMALL_STATE(5799)] = 193038,
  [SMALL_STATE(5800)] = 193051,
  [SMALL_STATE(5801)] = 193064,
  [SMALL_STATE(5802)] = 193077,
  [SMALL_STATE(5803)] = 193090,
  [SMALL_STATE(5804)] = 193103,
  [SMALL_STATE(5805)] = 193116,
  [SMALL_STATE(5806)] = 193129,
  [SMALL_STATE(5807)] = 193142,
  [SMALL_STATE(5808)] = 193155,
  [SMALL_STATE(5809)] = 193168,
  [SMALL_STATE(5810)] = 193181,
  [SMALL_STATE(5811)] = 193194,
  [SMALL_STATE(5812)] = 193207,
  [SMALL_STATE(5813)] = 193220,
  [SMALL_STATE(5814)] = 193233,
  [SMALL_STATE(5815)] = 193246,
  [SMALL_STATE(5816)] = 193259,
  [SMALL_STATE(5817)] = 193272,
  [SMALL_STATE(5818)] = 193285,
  [SMALL_STATE(5819)] = 193298,
  [SMALL_STATE(5820)] = 193311,
  [SMALL_STATE(5821)] = 193324,
  [SMALL_STATE(5822)] = 193337,
  [SMALL_STATE(5823)] = 193350,
  [SMALL_STATE(5824)] = 193363,
  [SMALL_STATE(5825)] = 193376,
  [SMALL_STATE(5826)] = 193389,
  [SMALL_STATE(5827)] = 193402,
  [SMALL_STATE(5828)] = 193415,
  [SMALL_STATE(5829)] = 193428,
  [SMALL_STATE(5830)] = 193441,
  [SMALL_STATE(5831)] = 193454,
  [SMALL_STATE(5832)] = 193467,
  [SMALL_STATE(5833)] = 193480,
  [SMALL_STATE(5834)] = 193493,
  [SMALL_STATE(5835)] = 193506,
  [SMALL_STATE(5836)] = 193519,
  [SMALL_STATE(5837)] = 193532,
  [SMALL_STATE(5838)] = 193545,
  [SMALL_STATE(5839)] = 193558,
  [SMALL_STATE(5840)] = 193571,
  [SMALL_STATE(5841)] = 193584,
  [SMALL_STATE(5842)] = 193597,
  [SMALL_STATE(5843)] = 193610,
  [SMALL_STATE(5844)] = 193623,
  [SMALL_STATE(5845)] = 193636,
  [SMALL_STATE(5846)] = 193649,
  [SMALL_STATE(5847)] = 193662,
  [SMALL_STATE(5848)] = 193675,
  [SMALL_STATE(5849)] = 193688,
  [SMALL_STATE(5850)] = 193701,
  [SMALL_STATE(5851)] = 193714,
  [SMALL_STATE(5852)] = 193727,
  [SMALL_STATE(5853)] = 193740,
  [SMALL_STATE(5854)] = 193753,
  [SMALL_STATE(5855)] = 193766,
  [SMALL_STATE(5856)] = 193779,
  [SMALL_STATE(5857)] = 193792,
  [SMALL_STATE(5858)] = 193805,
  [SMALL_STATE(5859)] = 193818,
  [SMALL_STATE(5860)] = 193831,
  [SMALL_STATE(5861)] = 193844,
  [SMALL_STATE(5862)] = 193857,
  [SMALL_STATE(5863)] = 193870,
  [SMALL_STATE(5864)] = 193883,
  [SMALL_STATE(5865)] = 193896,
  [SMALL_STATE(5866)] = 193909,
  [SMALL_STATE(5867)] = 193922,
  [SMALL_STATE(5868)] = 193935,
  [SMALL_STATE(5869)] = 193948,
  [SMALL_STATE(5870)] = 193961,
  [SMALL_STATE(5871)] = 193974,
  [SMALL_STATE(5872)] = 193987,
  [SMALL_STATE(5873)] = 194000,
  [SMALL_STATE(5874)] = 194013,
  [SMALL_STATE(5875)] = 194026,
  [SMALL_STATE(5876)] = 194039,
  [SMALL_STATE(5877)] = 194052,
  [SMALL_STATE(5878)] = 194065,
  [SMALL_STATE(5879)] = 194078,
  [SMALL_STATE(5880)] = 194091,
  [SMALL_STATE(5881)] = 194104,
  [SMALL_STATE(5882)] = 194117,
  [SMALL_STATE(5883)] = 194130,
  [SMALL_STATE(5884)] = 194143,
  [SMALL_STATE(5885)] = 194156,
  [SMALL_STATE(5886)] = 194169,
  [SMALL_STATE(5887)] = 194182,
  [SMALL_STATE(5888)] = 194195,
  [SMALL_STATE(5889)] = 194208,
  [SMALL_STATE(5890)] = 194221,
  [SMALL_STATE(5891)] = 194234,
  [SMALL_STATE(5892)] = 194247,
  [SMALL_STATE(5893)] = 194260,
  [SMALL_STATE(5894)] = 194273,
  [SMALL_STATE(5895)] = 194286,
  [SMALL_STATE(5896)] = 194299,
  [SMALL_STATE(5897)] = 194312,
  [SMALL_STATE(5898)] = 194325,
  [SMALL_STATE(5899)] = 194338,
  [SMALL_STATE(5900)] = 194351,
  [SMALL_STATE(5901)] = 194364,
  [SMALL_STATE(5902)] = 194377,
  [SMALL_STATE(5903)] = 194390,
  [SMALL_STATE(5904)] = 194403,
  [SMALL_STATE(5905)] = 194416,
  [SMALL_STATE(5906)] = 194429,
  [SMALL_STATE(5907)] = 194442,
  [SMALL_STATE(5908)] = 194455,
  [SMALL_STATE(5909)] = 194468,
  [SMALL_STATE(5910)] = 194481,
  [SMALL_STATE(5911)] = 194494,
  [SMALL_STATE(5912)] = 194507,
  [SMALL_STATE(5913)] = 194520,
  [SMALL_STATE(5914)] = 194533,
  [SMALL_STATE(5915)] = 194546,
  [SMALL_STATE(5916)] = 194559,
  [SMALL_STATE(5917)] = 194572,
  [SMALL_STATE(5918)] = 194585,
  [SMALL_STATE(5919)] = 194598,
  [SMALL_STATE(5920)] = 194611,
  [SMALL_STATE(5921)] = 194624,
  [SMALL_STATE(5922)] = 194637,
  [SMALL_STATE(5923)] = 194650,
  [SMALL_STATE(5924)] = 194663,
  [SMALL_STATE(5925)] = 194676,
  [SMALL_STATE(5926)] = 194689,
  [SMALL_STATE(5927)] = 194702,
  [SMALL_STATE(5928)] = 194715,
  [SMALL_STATE(5929)] = 194728,
  [SMALL_STATE(5930)] = 194741,
  [SMALL_STATE(5931)] = 194754,
  [SMALL_STATE(5932)] = 194767,
  [SMALL_STATE(5933)] = 194780,
  [SMALL_STATE(5934)] = 194793,
  [SMALL_STATE(5935)] = 194806,
  [SMALL_STATE(5936)] = 194819,
  [SMALL_STATE(5937)] = 194832,
  [SMALL_STATE(5938)] = 194845,
  [SMALL_STATE(5939)] = 194858,
  [SMALL_STATE(5940)] = 194871,
  [SMALL_STATE(5941)] = 194884,
  [SMALL_STATE(5942)] = 194897,
  [SMALL_STATE(5943)] = 194910,
  [SMALL_STATE(5944)] = 194923,
  [SMALL_STATE(5945)] = 194936,
  [SMALL_STATE(5946)] = 194949,
  [SMALL_STATE(5947)] = 194962,
  [SMALL_STATE(5948)] = 194975,
  [SMALL_STATE(5949)] = 194988,
  [SMALL_STATE(5950)] = 195001,
  [SMALL_STATE(5951)] = 195014,
  [SMALL_STATE(5952)] = 195027,
  [SMALL_STATE(5953)] = 195040,
  [SMALL_STATE(5954)] = 195053,
  [SMALL_STATE(5955)] = 195066,
  [SMALL_STATE(5956)] = 195079,
  [SMALL_STATE(5957)] = 195092,
  [SMALL_STATE(5958)] = 195105,
  [SMALL_STATE(5959)] = 195118,
  [SMALL_STATE(5960)] = 195131,
  [SMALL_STATE(5961)] = 195144,
  [SMALL_STATE(5962)] = 195157,
  [SMALL_STATE(5963)] = 195170,
  [SMALL_STATE(5964)] = 195183,
  [SMALL_STATE(5965)] = 195196,
  [SMALL_STATE(5966)] = 195209,
  [SMALL_STATE(5967)] = 195222,
  [SMALL_STATE(5968)] = 195235,
  [SMALL_STATE(5969)] = 195248,
  [SMALL_STATE(5970)] = 195261,
  [SMALL_STATE(5971)] = 195274,
  [SMALL_STATE(5972)] = 195287,
  [SMALL_STATE(5973)] = 195300,
  [SMALL_STATE(5974)] = 195313,
  [SMALL_STATE(5975)] = 195326,
  [SMALL_STATE(5976)] = 195339,
  [SMALL_STATE(5977)] = 195352,
  [SMALL_STATE(5978)] = 195365,
  [SMALL_STATE(5979)] = 195378,
  [SMALL_STATE(5980)] = 195391,
  [SMALL_STATE(5981)] = 195404,
  [SMALL_STATE(5982)] = 195417,
  [SMALL_STATE(5983)] = 195430,
  [SMALL_STATE(5984)] = 195443,
  [SMALL_STATE(5985)] = 195456,
  [SMALL_STATE(5986)] = 195469,
  [SMALL_STATE(5987)] = 195482,
  [SMALL_STATE(5988)] = 195495,
  [SMALL_STATE(5989)] = 195508,
  [SMALL_STATE(5990)] = 195512,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5098),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5942),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5941),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5863),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5709),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2479),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5770),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2249),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2221),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2668),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2682),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1982),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4576),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5191),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5193),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5213),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5210),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4961),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4959),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5207),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lhs, 1, 0, 0),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2474),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lhs, 1, 0, 0),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5770),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5976),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lhs, 1, 0, 2),
  [181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lhs, 1, 0, 2),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2478),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5127),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5655),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2469),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3052),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5100),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5689),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2463),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5917),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1985),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2850),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2847),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(613),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2773),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4565),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5099),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5192),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4938),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4960),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5175),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5943),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2467),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2820),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5089),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5669),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_identifier_call, 1, 0, 4),
  [413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_identifier_call, 1, 0, 4),
  [415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 1, 0, 0),
  [417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield, 1, 0, 0),
  [419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return, 1, 0, 0),
  [421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return, 1, 0, 0),
  [423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break, 1, 0, 0),
  [425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break, 1, 0, 0),
  [427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_next, 1, 0, 0),
  [429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_next, 1, 0, 0),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2476),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5140),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5879),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2484),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5872),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2471),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5156),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5667),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2460),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5172),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5887),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5046),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5956),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2454),
  [607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5121),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5987),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2462),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5750),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4710),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5230),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2676),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2677),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5183),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5905),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2571),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5873),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable, 1, 0, 0),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable, 1, 0, 0),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5446),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3021),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5442),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2338),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2325),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3056),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2259),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4582),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4722),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5022),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5333),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2355),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5063),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4354),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4384),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4673),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2252),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4649),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4338),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3000),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4266),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4366),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4394),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4418),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4387),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2327),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4728),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4672),
  [875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4653),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4987),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4973),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4976),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2961),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4705),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5039),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2226),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5075),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4692),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2970),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5048),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5474),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3072),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_argument, 1, 0, 0),
  [911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_argument, 1, 0, 0),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2242),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2236),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2239),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5152),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 2, 0, 17),
  [949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range, 2, 0, 17),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5337),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4942),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5339),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3062),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3104),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2422),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3064),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5157),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3045),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5067),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3039),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3004),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3060),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3030),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2336),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2276),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4647),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4648),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4334),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2310),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4694),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4689),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5144),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4342),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2406),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4395),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5335),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4419),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2428),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4981),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5409),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2090),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5419),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2391),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5422),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2229),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2222),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5400),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2278),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5097),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3050),
  [1069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 2),
  [1071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 2),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [1089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 1, 0, 0),
  [1091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 1, 0, 0),
  [1093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1913),
  [1096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5863),
  [1099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(748),
  [1102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0),
  [1104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5709),
  [1107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2462),
  [1110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(357),
  [1113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5770),
  [1116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0),
  [1118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2057),
  [1121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1170),
  [1124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1972),
  [1127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2089),
  [1130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1975),
  [1133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1983),
  [1136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(51),
  [1139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(50),
  [1142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(52),
  [1145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(49),
  [1148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2249),
  [1151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2221),
  [1154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(411),
  [1157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(403),
  [1160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(405),
  [1163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(402),
  [1166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1965),
  [1169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(284),
  [1172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(423),
  [1175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1170),
  [1178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(199),
  [1181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(665),
  [1184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(660),
  [1187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(649),
  [1190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(641),
  [1193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2676),
  [1196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2677),
  [1199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2201),
  [1202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2091),
  [1205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1969),
  [1208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1968),
  [1211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1914),
  [1214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2359),
  [1217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(4576),
  [1220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2358),
  [1223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5191),
  [1226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5193),
  [1229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5213),
  [1232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5210),
  [1235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(4961),
  [1238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(4959),
  [1241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(669),
  [1244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5183),
  [1247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1171),
  [1250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1968),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [1285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then, 1, 0, 0),
  [1287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then, 2, 0, 0),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1555),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [1301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else, 1, 0, 0),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5345),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5138),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2911),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2393),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2913),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5343),
  [1335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elsif, 3, 0, 64),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5471),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5377),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [1357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue, 4, 0, 94),
  [1359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue, 3, 0, 72),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [1379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue, 2, 0, 0),
  [1381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue, 3, 0, 74),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2424),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3022),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5186),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5176),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5023),
  [1413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ensure, 1, 0, 0),
  [1415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_in_clause, 4, 0, 111),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2218),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [1427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2823),
  [1429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2851),
  [1431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2841),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2839),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [1449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2879),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [1459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_in_clause, 3, 0, 68),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [1463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_when, 4, 0, 89),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [1469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else, 2, 0, 0),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [1477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_when, 3, 0, 68),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5206),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5166),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [1517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [1523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5044),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [1535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [1553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4367),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5200),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4740),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4978),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1594),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2483),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [1613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [1617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [1629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2133),
  [1632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [1634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [1642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [1652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [1654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [1658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5303),
  [1660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5958),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [1670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [1674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4396),
  [1680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [1684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [1686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [1688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2272),
  [1694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [1696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [1698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5203),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5668),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4612),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5226),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [1728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2087),
  [1732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [1736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2419),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5788),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [1752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [1756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2405),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2442),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2223),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [1778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [1784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [1790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2438),
  [1820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [1836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5436),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [1846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5350),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [1856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [1862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [1864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5174),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5242),
  [1874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2921),
  [1876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5301),
  [1878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [1880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [1886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [1888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [1890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4564),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [1896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [1898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [1900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [1902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [1904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [1910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [1912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2456),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [1916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [1922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [1924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5054),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5917),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [1938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [1940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [1948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [1950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [1952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2472),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [1960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [1962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [1966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [1974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [1980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [1986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [1990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__terminator, 1, 0, 0),
  [1992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2450),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [1996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [2002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [2004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1611),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [2008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5211),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [2020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [2022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [2026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [2032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1691),
  [2034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2488),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [2038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [2044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1784),
  [2046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [2052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3521),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5047),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5101),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [2064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [2072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [2074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2455),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [2080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [2086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5086),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [2096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2487),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [2102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [2108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [2110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5209),
  [2118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [2122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [2126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [2128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [2130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5139),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [2142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [2146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [2152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [2154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5112),
  [2162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2468),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [2166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [2174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5123),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [2184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [2190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [2192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5132),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [2204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [2212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5122),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [2238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5076),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [2248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [2254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [2274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5104),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [2284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [2300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [2314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5083),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4818),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list_with_trailing_comma, 3, 0, 0),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [2334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list_with_trailing_comma, 2, 0, 0),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4749),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [2342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [2348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [2350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5125),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [2360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2520),
  [2362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 2, 0, 29),
  [2364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2441),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5473),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5266),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [2378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [2384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [2386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5078),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 2, 0, 28),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [2408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [2420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [2432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [2444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [2468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 2, 0, 29),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4491),
  [2472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 2, 0, 28),
  [2474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 2, 0, 28),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4498),
  [2478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_forward_argument, 1, 0, 0),
  [2480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_forward_argument, 1, 0, 0),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [2486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_splat_argument, 1, 0, 0),
  [2504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_splat_argument, 1, 0, 0),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_argument, 1, 0, 0),
  [2508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_argument, 1, 0, 0),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [2514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [2524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [2544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [2548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2461),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4911),
  [2552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [2554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5329),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5434),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5404),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [2608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_parameter, 2, 0, 30),
  [2610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_parameter, 2, 0, 30),
  [2612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [2614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [2616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_suffix, 1, 0, 0),
  [2618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_suffix, 1, 0, 0),
  [2620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 1, 0, 0),
  [2622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 1, 0, 0),
  [2624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_identifier, 1, 0, 7),
  [2626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_identifier, 1, 0, 7),
  [2628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_identifier, 1, 0, 6),
  [2630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_identifier, 1, 0, 6),
  [2632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call, 3, 0, 49),
  [2634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call, 3, 0, 49),
  [2636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scope_resolution, 3, 0, 51),
  [2638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scope_resolution, 3, 0, 51),
  [2640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__nonlocal_variable, 1, 0, 0),
  [2642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nonlocal_variable, 1, 0, 0),
  [2644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_suffix, 1, 0, 0),
  [2646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_suffix, 1, 0, 0),
  [2648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4253),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [2652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_parameter, 1, 0, 0),
  [2654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2453),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5653),
  [2660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_parameter, 1, 0, 0),
  [2662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_assignment, 1, 0, 0),
  [2664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4980),
  [2666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [2668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [2670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5272),
  [2672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5214),
  [2674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5274),
  [2676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5277),
  [2678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5259),
  [2680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5260),
  [2682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [2684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [2686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [2692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [2696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5220),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5606),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5606),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5145),
  [2706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4785),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4986),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4780),
  [2712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4778),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4787),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5401),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5124),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5182),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5128),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5129),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4994),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4992),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [2738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [2740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [2742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_constant, 1, 0, 0),
  [2744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [2746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [2748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [2750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [2752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [2754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [2756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [2758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4651),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [2762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mlhs, 2, 0, 0),
  [2764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mlhs, 2, 0, 0),
  [2766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mlhs, 3, 0, 0),
  [2768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mlhs, 3, 0, 0),
  [2770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_assignment, 1, 0, 0),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5861),
  [2774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [2782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [2786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4871),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5965),
  [2790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5187),
  [2792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5155),
  [2794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4860),
  [2796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [2798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [2800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4459),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [2806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_pattern_n, 2, 0, 77),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5829),
  [2812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_pattern_n, 2, 0, 77),
  [2814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [2818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4391),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [2822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3394),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5250),
  [2826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4195),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [2830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [2832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [2834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5185),
  [2836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5038),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5181),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5177),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4988),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5001),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4430),
  [2848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 2, 0, 29),
  [2850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_pattern, 2, 0, 29),
  [2852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_pattern, 2, 0, 28),
  [2854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4867),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4608),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5808),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [2866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4767),
  [2868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4691),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [2872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3421),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5254),
  [2876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4645),
  [2878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4679),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5936),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5934),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4562),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4678),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5188),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5051),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5131),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4957),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5029),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4814),
  [2904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4766),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [2908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3440),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5217),
  [2912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4646),
  [2914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4658),
  [2916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4494),
  [2918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4528),
  [2920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4432),
  [2922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4723),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [2926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3420),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5255),
  [2930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4618),
  [2932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4625),
  [2934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4593),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [2938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4637),
  [2940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3414),
  [2942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4555),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5050),
  [2946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [2948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__chained_command_call, 3, 0, 49),
  [2950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__chained_command_call, 3, 0, 49),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [2954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__terminator, 1, 0, 0),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [2958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4790),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4767),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4666),
  [2964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scope_resolution, 2, 0, 14),
  [2966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scope_resolution, 2, 0, 14),
  [2968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_constant_resolution, 2, 0, 14),
  [2970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_constant_resolution, 2, 0, 14),
  [2972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_reference, 3, 0, 48),
  [2974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_reference, 3, 0, 48),
  [2976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_reference, 4, 0, 48),
  [2978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_reference, 4, 0, 48),
  [2980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [2982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [2984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [2986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [2988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 1, 0, 0),
  [2990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 1, 0, 0),
  [2992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_constant, 1, 0, 0),
  [2994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [2996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__keyword_variable, 1, 0, 0),
  [2998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 4, 0, 95),
  [3000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 4, 0, 95),
  [3002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 5, 0, 115),
  [3004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 5, 0, 115),
  [3006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 2, 0, 0),
  [3008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 2, 0, 0),
  [3010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [3012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [3014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_reference, 5, 0, 103),
  [3016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_reference, 5, 0, 103),
  [3018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_reference, 4, 0, 79),
  [3020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_reference, 4, 0, 79),
  [3022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 6, 0, 121),
  [3024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 6, 0, 121),
  [3026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nil, 1, 0, 0),
  [3028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nil, 1, 0, 0),
  [3030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 5, 0, 96),
  [3032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 5, 0, 96),
  [3034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 5, 0, 114),
  [3036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 5, 0, 114),
  [3038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [3040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4793),
  [3042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 4, 0, 97),
  [3044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 4, 0, 97),
  [3046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 16),
  [3048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 16),
  [3050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 75),
  [3052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 75),
  [3054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 3, 0, 75),
  [3056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 3, 0, 75),
  [3058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 3, 0, 16),
  [3060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 3, 0, 16),
  [3062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 3, 0, 0),
  [3064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 3, 0, 0),
  [3066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 4, 0, 96),
  [3068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 4, 0, 96),
  [3070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 4, 0, 75),
  [3072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 4, 0, 75),
  [3074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4, 0, 95),
  [3076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 4, 0, 95),
  [3078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, 0, 0),
  [3080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0),
  [3082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_expr_basic, 1, 0, 0),
  [3084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2, 0, 0),
  [3086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0),
  [3088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, 0, 0),
  [3090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, 0, 0),
  [3092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 5, 0, 117),
  [3094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 5, 0, 117),
  [3096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 4, 0, 0),
  [3098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 4, 0, 0),
  [3100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 5, 0, 0),
  [3102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 5, 0, 0),
  [3104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary, 1, 0, 0),
  [3106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary, 1, 0, 0),
  [3108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [3110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [3112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [3116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 6, 0, 123),
  [3118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 6, 0, 123),
  [3120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 5, 0, 119),
  [3122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 5, 0, 119),
  [3124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 7, 0, 125),
  [3126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 7, 0, 125),
  [3128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 3, 0, 0),
  [3130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 3, 0, 0),
  [3132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 6, 0, 122),
  [3134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 6, 0, 122),
  [3136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 8, 0, 126),
  [3138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 8, 0, 126),
  [3140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 7, 0, 124),
  [3142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 7, 0, 124),
  [3144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 4, 0, 113),
  [3146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 4, 0, 113),
  [3148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [3150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [3152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 2, 0, 0),
  [3154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 2, 0, 0),
  [3156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [3158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [3160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [3162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [3166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [3170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [3174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [3178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [3182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [3186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [3188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [3192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [3196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [3200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_range, 2, 0, 17),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [3212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [3216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [3220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [3224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [3228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [3232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [3236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [3244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [3248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_numeric, 1, 0, 0),
  [3250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_numeric, 1, 0, 0),
  [3252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__int_or_float, 1, 0, 0),
  [3254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__int_or_float, 1, 0, 0),
  [3256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chained_string, 2, 0, 0),
  [3258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_chained_string, 2, 0, 0),
  [3260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [3264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0),
  [3266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0),
  [3268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5191),
  [3271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_literal, 1, 0, 0),
  [3273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [3277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [3279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [3281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [3283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [3285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [3287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [3289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [3291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [3293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_retry, 1, 0, 0),
  [3295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_retry, 1, 0, 0),
  [3297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [3299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 23),
  [3301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 23),
  [3303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 18),
  [3305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 18),
  [3307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 3, 0, 50),
  [3309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 3, 0, 50),
  [3311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [3313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 20),
  [3315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 20),
  [3317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redo, 1, 0, 0),
  [3319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_redo, 1, 0, 0),
  [3321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 8),
  [3323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 8),
  [3325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [3327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [3331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_range, 2, 0, 17),
  [3333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [3335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 1, 0, 0),
  [3337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chained_string_repeat1, 1, 0, 0),
  [3339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [3341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_retry, 2, 0, 0),
  [3343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_retry, 2, 0, 0),
  [3345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 4, 0, 26),
  [3347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 4, 0, 26),
  [3349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 2, 0, 0),
  [3351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 14),
  [3353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 14),
  [3355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 2, 0, 31),
  [3357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 2, 0, 31),
  [3359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin, 3, 0, 0),
  [3361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin, 3, 0, 0),
  [3363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 19),
  [3365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 19),
  [3367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [3369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [3371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless, 4, 0, 64),
  [3373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless, 4, 0, 64),
  [3375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 62),
  [3377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 62),
  [3379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 4, 0, 33),
  [3381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 4, 0, 33),
  [3383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [3385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [3387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 3, 0, 52),
  [3389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 3, 0, 52),
  [3391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 6, 0, 55),
  [3393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 6, 0, 55),
  [3395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary, 1, 0, 5),
  [3397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary, 1, 0, 5),
  [3399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 2, 0, 0),
  [3401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 2, 0, 0),
  [3403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 2, 0, 0),
  [3405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 2, 0, 0),
  [3407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 3, 0, 32),
  [3409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 3, 0, 32),
  [3411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_until, 3, 0, 32),
  [3413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_until, 3, 0, 32),
  [3415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [3417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [3419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 2, 0, 0),
  [3421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 21),
  [3423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 21),
  [3425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 4, 0, 62),
  [3427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 4, 0, 62),
  [3429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__numeric, 1, 0, 0),
  [3431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__numeric, 1, 0, 0),
  [3433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 3, 0, 0),
  [3435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 3, 0, 0),
  [3437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_minus_pow, 2, 0, 12),
  [3439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unary_minus_pow, 2, 0, 12),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 3, 0, 0),
  [3443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 3, 0, 0),
  [3445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_unary, 2, 0, 11),
  [3447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_unary, 2, 0, 11),
  [3449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless, 4, 0, 63),
  [3451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless, 4, 0, 63),
  [3453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 3, 0, 30),
  [3455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 3, 0, 30),
  [3457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 5, 0, 87),
  [3459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 5, 0, 87),
  [3461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [3465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, 0, 25),
  [3467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, 0, 25),
  [3469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_literal, 2, 0, 11),
  [3471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_literal, 2, 0, 11),
  [3473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 5, 0, 66),
  [3475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 5, 0, 66),
  [3477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 3, 0, 0),
  [3479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 3, 0, 0),
  [3481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless, 5, 0, 86),
  [3483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless, 5, 0, 86),
  [3485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless, 5, 0, 85),
  [3487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless, 5, 0, 85),
  [3489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 3, 0, 0),
  [3491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 3, 0, 0),
  [3493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 5, 0, 86),
  [3495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 5, 0, 86),
  [3497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 2, 0, 13),
  [3499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 2, 0, 13),
  [3501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 5, 0, 85),
  [3503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 5, 0, 85),
  [3505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 3, 0, 61),
  [3507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 3, 0, 61),
  [3509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 3, 0, 60),
  [3511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 3, 0, 60),
  [3513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_statements, 2, 0, 0),
  [3515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_statements, 2, 0, 0),
  [3517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 6, 0, 56),
  [3519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 6, 0, 56),
  [3521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subshell, 3, 0, 24),
  [3523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subshell, 3, 0, 24),
  [3525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_assignment, 3, 0, 40),
  [3527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_assignment, 3, 0, 40),
  [3529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [3531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [3533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin, 2, 0, 0),
  [3535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin, 2, 0, 0),
  [3537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 4, 0, 14),
  [3539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 4, 0, 14),
  [3541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg, 1, 0, 0),
  [3543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg, 1, 0, 0),
  [3545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 3, 0, 14),
  [3547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 3, 0, 14),
  [3549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body_expr, 2, 0, 16),
  [3551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__body_expr, 2, 0, 16),
  [3553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return, 2, 0, 0),
  [3555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return, 2, 0, 0),
  [3557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, 0, 53),
  [3559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment, 3, 0, 53),
  [3561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_lambda, 1, 0, 0),
  [3563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3167),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [3571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2, 0, 0),
  [3573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2, 0, 0),
  [3575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [3577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 4, 0, 80),
  [3579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 4, 0, 80),
  [3581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg, 1, 0, 1),
  [3583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg, 1, 0, 1),
  [3585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_singleton_method, 4, 0, 59),
  [3587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_singleton_method, 4, 0, 59),
  [3589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 2, 0, 0),
  [3591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield, 2, 0, 0),
  [3593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 4, 0, 0),
  [3595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 4, 0, 0),
  [3597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3, 0, 0),
  [3599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3, 0, 0),
  [3601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 3, 0, 54),
  [3603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 3, 0, 54),
  [3605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex, 2, 0, 0),
  [3607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex, 2, 0, 0),
  [3609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_pattern, 2, 0, 0),
  [3611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 2, 0, 16),
  [3613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 2, 0, 16),
  [3615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1, 0, 0),
  [3617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1, 0, 0),
  [3619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 5, 0, 84),
  [3621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 5, 0, 84),
  [3623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 84),
  [3625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 84),
  [3627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break, 2, 0, 0),
  [3629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break, 2, 0, 0),
  [3631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 2, 0, 0),
  [3633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 2, 0, 0),
  [3635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_singleton_method, 6, 0, 104),
  [3637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_singleton_method, 6, 0, 104),
  [3639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 5, 0, 105),
  [3641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 5, 0, 105),
  [3643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex, 2, 0, 22),
  [3645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex, 2, 0, 22),
  [3647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_singleton_class, 6, 0, 106),
  [3649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_singleton_class, 6, 0, 106),
  [3651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, 0, 107),
  [3653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, 0, 107),
  [3655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for, 4, 0, 65),
  [3657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for, 4, 0, 65),
  [3659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [3663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 5, 0, 33),
  [3665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 5, 0, 33),
  [3667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rational, 2, 0, 0),
  [3669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rational, 2, 0, 0),
  [3671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [3675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 5, 0, 91),
  [3677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 5, 0, 91),
  [3679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 6, 0, 66),
  [3681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 6, 0, 66),
  [3683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 83),
  [3685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 83),
  [3687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [3689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [3691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 6, 0, 108),
  [3693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 6, 0, 108),
  [3695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 3, 0, 27),
  [3697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 3, 0, 27),
  [3699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_next, 2, 0, 0),
  [3701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_next, 2, 0, 0),
  [3703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redo, 2, 0, 0),
  [3705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_redo, 2, 0, 0),
  [3707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 5, 0, 92),
  [3709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 5, 0, 92),
  [3711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 4, 0, 69),
  [3713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 4, 0, 69),
  [3715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 6, 0, 109),
  [3717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 6, 0, 109),
  [3719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 5, 0, 0),
  [3721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 5, 0, 0),
  [3723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 4, 0, 64),
  [3725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 4, 0, 64),
  [3727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 6, 0, 33),
  [3729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 6, 0, 33),
  [3731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 6, 0, 112),
  [3733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 6, 0, 112),
  [3735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 5, 0, 55),
  [3737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 5, 0, 55),
  [3739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 3, 0, 26),
  [3741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 3, 0, 26),
  [3743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 4, 0, 0),
  [3745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 4, 0, 0),
  [3747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delimited_symbol, 3, 0, 23),
  [3749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delimited_symbol, 3, 0, 23),
  [3751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 4, 0, 0),
  [3753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 4, 0, 0),
  [3755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 5, 0, 26),
  [3757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 5, 0, 26),
  [3759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delimited_symbol, 2, 0, 8),
  [3761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delimited_symbol, 2, 0, 8),
  [3763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_singleton_class, 5, 0, 66),
  [3765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_singleton_class, 5, 0, 66),
  [3767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 5, 0, 56),
  [3769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 5, 0, 56),
  [3771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 4, 0, 55),
  [3773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 4, 0, 55),
  [3775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_statements, 3, 0, 0),
  [3777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_statements, 3, 0, 0),
  [3779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [3781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [3783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 4, 0, 0),
  [3785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 4, 0, 0),
  [3787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 4, 0, 56),
  [3789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 4, 0, 56),
  [3791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 4, 0, 82),
  [3793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 4, 0, 82),
  [3795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 5, 0, 27),
  [3797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 5, 0, 27),
  [3799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary, 2, 0, 11),
  [3801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary, 2, 0, 11),
  [3803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 4, 0, 66),
  [3805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 4, 0, 66),
  [3807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 5, 0, 0),
  [3809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 5, 0, 0),
  [3811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 3, 0, 0),
  [3813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 3, 0, 0),
  [3815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subshell, 2, 0, 9),
  [3817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subshell, 2, 0, 9),
  [3819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 2, 0, 0),
  [3821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 2, 0, 0),
  [3823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 2, 0, 10),
  [3825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 2, 0, 10),
  [3827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 4, 0, 63),
  [3829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 4, 0, 63),
  [3831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 3, 0, 33),
  [3833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 3, 0, 33),
  [3835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 4, 0, 60),
  [3837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 4, 0, 60),
  [3839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0),
  [3841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0),
  [3843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 7, 0, 116),
  [3845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 7, 0, 116),
  [3847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 4, 0, 27),
  [3849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 4, 0, 27),
  [3851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 4, 0, 81),
  [3853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 4, 0, 81),
  [3855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 7, 0, 66),
  [3857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 7, 0, 66),
  [3859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [3863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 14),
  [3865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 14),
  [3867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin, 4, 0, 0),
  [3869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin, 4, 0, 0),
  [3871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, 0, 37),
  [3873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 3, 0, 37),
  [3875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [3879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [3883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [3885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [3889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [3893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [3897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [3901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [3905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [3909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4743),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4470),
  [3915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4470),
  [3917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5592),
  [3919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4826),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4468),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4125),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [3929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [3931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [3933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [3945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [3957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [3961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [3963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [3965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [3983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [3989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3194),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [3997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [4013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(821),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [4018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [4028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_right_assignment_list, 2, 0, 0),
  [4030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_right_assignment_list, 2, 0, 0),
  [4032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [4044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [4054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary, 3, 0, 40),
  [4056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary, 3, 0, 40),
  [4058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pow, 3, 0, 40),
  [4060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pow, 3, 0, 40),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [4064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_argument, 2, 0, 0),
  [4066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_argument, 2, 0, 0),
  [4068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [4072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [4076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [4080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 3, 0, 41),
  [4082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range, 3, 0, 41),
  [4084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional, 5, 0, 102),
  [4086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional, 5, 0, 102),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [4090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [4094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 2, 0, 15),
  [4096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range, 2, 0, 15),
  [4098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue_modifier_arg, 3, 0, 38),
  [4100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue_modifier_arg, 3, 0, 38),
  [4102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [4106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [4108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3153),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [4114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [4116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [4120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [4124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [4128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [4132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [4134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [4136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [4140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [4142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [4144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [4146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [4148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [4150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [4152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [4154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [4172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [4178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [4180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(832),
  [4183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [4187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [4191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [4193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [4195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [4197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3193),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [4205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [4209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [4213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4879),
  [4215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4462),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4710),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [4227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [4231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [4233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [4235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [4253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [4263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [4265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [4271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [4289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [4295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [4299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [4305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [4309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(833),
  [4312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [4318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [4324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [4328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [4330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [4332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [4336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [4340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [4350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [4356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4756),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4797),
  [4360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4797),
  [4362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4794),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4796),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4799),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4607),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4794),
  [4372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(830),
  [4375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4588),
  [4377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3197),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [4381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3362),
  [4383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3361),
  [4385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [4391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [4393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5120),
  [4395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [4397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [4403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1634),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [4407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [4409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [4411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [4429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [4437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(828),
  [4440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue_modifier_expression, 3, 0, 38),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3186),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [4448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 58),
  [4450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 57),
  [4452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_argument, 2, 0, 0),
  [4454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [4456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_splat_argument, 2, 0, 0),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [4466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [4470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [4472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [4474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [4492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [4502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [4504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(811),
  [4507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [4509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [4511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [4513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [4515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [4533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [4539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3187),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [4547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [4549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5201),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [4554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [4558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [4560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [4562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [4580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [4586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [4590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [4592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [4594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [4596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [4598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [4600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [4612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [4618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [4622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(837),
  [4625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(818),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [4634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [4642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [4646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [4648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [4650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [4662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [4668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [4676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [4680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [4690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [4694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [4696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(825),
  [4699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [4701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [4703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [4705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [4707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [4709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [4715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [4725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [4733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [4739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [4741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [4749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [4759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [4765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [4775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [4781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [4783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [4787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [4793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [4797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [4799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [4805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_splat_argument, 2, 0, 0),
  [4807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2203),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [4811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [4813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2408),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [4819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1926),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [4823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [4825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [4831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4882),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [4835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4873),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [4839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4842),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4874),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [4847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [4849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3214),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [4857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(819),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [4862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue_modifier_expression, 3, 0, 38),
  [4864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [4866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [4868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [4874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [4876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(839),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [4881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1571),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [4885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [4887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [4889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [4907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [4913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [4915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [4917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [4919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4788),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4772),
  [4923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4772),
  [4925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [4927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_name, 1, 0, 0),
  [4929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_name, 1, 0, 0),
  [4931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3355),
  [4933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [4935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [4939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [4943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [4945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [4947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [4965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [4971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [4973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(827),
  [4976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [4978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 3, 0, 58),
  [4980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2200),
  [4982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [4984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [4990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4779),
  [4992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_argument, 2, 0, 0),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [4996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 3, 0, 57),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [5000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [5006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [5008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [5010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [5012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [5020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [5022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [5024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [5026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [5028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [5034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [5040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [5048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [5050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [5054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [5056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [5058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [5060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [5064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [5066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [5068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3198),
  [5070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [5072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [5076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [5078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [5080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(813),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [5089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [5093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [5095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [5097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [5107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [5115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [5121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3173),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [5127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [5131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [5133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [5135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(838),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [5140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(815),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [5145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_setter, 2, 0, 30),
  [5147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setter, 2, 0, 30),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [5153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [5155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [5157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [5161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [5165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [5167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [5169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [5177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [5185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [5189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [5191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [5193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [5211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [5215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [5217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [5219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [5221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [5227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2034),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [5231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [5237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(829),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [5246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [5250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [5254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [5260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [5264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [5266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [5268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [5270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [5286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [5292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5047),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [5297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [5299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [5301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [5303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [5305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [5323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [5339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3207),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [5351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [5353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [5355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [5359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [5361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [5363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [5381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [5389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [5393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [5395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [5397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [5403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [5411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [5415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [5421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [5423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [5425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1704),
  [5427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1703),
  [5429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [5431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [5439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [5441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [5443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [5445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [5447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1699),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [5451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [5453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(817),
  [5456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(820),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [5469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [5473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(840),
  [5476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(834),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [5481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [5483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [5491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [5495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [5497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [5499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [5503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [5505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [5507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [5513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [5515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [5521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [5523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [5527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [5529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [5531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [5533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [5535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [5537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [5539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [5541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [5543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [5545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [5547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [5549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [5551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [5553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [5555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [5557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [5559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [5561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [5563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [5565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [5567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [5569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [5571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [5573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [5575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [5577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [5579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [5581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [5585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [5587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [5589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [5591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5806),
  [5593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_pattern_body, 2, 0, 0),
  [5595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_pattern_body, 2, 0, 0),
  [5597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(841),
  [5600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [5604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [5606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [5608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [5610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1816),
  [5612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [5624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [5628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1812),
  [5630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [5634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [5636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_pattern_body, 3, 0, 0),
  [5638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_pattern_body, 3, 0, 0),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [5642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(826),
  [5645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [5647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [5649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [5651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [5653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(816),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [5672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [5680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [5684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [5686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [5688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [5706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [5710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [5714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1535),
  [5716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [5718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [5736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [5742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [5744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [5758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [5760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [5770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [5784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [5788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [5794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [5800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(812),
  [5803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [5805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [5817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(835),
  [5820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [5822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [5824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [5826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [5828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [5846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [5852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [5856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [5858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [5860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [5878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [5886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [5890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [5892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [5894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [5912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [5934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exceptions, 1, 0, 0),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [5944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [5948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [5950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [5952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [5970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [5976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [5980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [5982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [5984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [5988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [5998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [6000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [6002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [6012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(814),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [6025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [6029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [6031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [6033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [6037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [6049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [6055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [6059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [6061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [6063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [6065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [6067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [6069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [6071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [6075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [6077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [6081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [6083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [6087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(824),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [6092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [6094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [6096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1839),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [6100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [6102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [6104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [6122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [6130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0),
  [6132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [6134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [6140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [6144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [6146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [6148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [6158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [6164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [6170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [6172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [6176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [6178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [6180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [6198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [6204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, 0, 76),
  [6206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [6210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_parameter, 3, 0, 76),
  [6212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_in, 2, 0, 0),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [6216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(822),
  [6219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [6221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [6223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [6225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [6227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [6231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [6235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [6237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [6239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [6241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [6245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [6247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [6249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [6251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [6255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [6257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [6259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [6261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [6263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [6265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [6267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [6269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [6271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [6273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [6277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [6279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [6281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [6283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5714),
  [6285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_parameter, 3, 0, 76),
  [6287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional_parameter, 3, 0, 76),
  [6289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_parameter, 2, 0, 14),
  [6291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_parameter, 2, 0, 14),
  [6293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [6295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [6297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [6299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [6301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [6303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [6305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [6307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [6309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [6315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [6317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [6319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [6321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [6323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [6327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [6329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [6331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [6335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5608),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [6345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [6351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [6353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [6355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [6357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [6359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5620),
  [6361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [6363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5626),
  [6365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5636),
  [6367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5618),
  [6369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_constant_resolution, 3, 0, 51),
  [6371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_constant_resolution, 3, 0, 51),
  [6373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [6375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5603),
  [6377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5634),
  [6379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5622),
  [6381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [6383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5609),
  [6385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5600),
  [6387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [6389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [6391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [6393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [6395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [6397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5637),
  [6399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [6401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [6403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5632),
  [6405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [6407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [6409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [6413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [6415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5595),
  [6417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [6419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [6421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5605),
  [6423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [6425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [6427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5614),
  [6429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [6431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [6433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5581),
  [6435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [6437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5625),
  [6439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [6441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [6443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5635),
  [6445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5607),
  [6447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5586),
  [6449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [6451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [6453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5588),
  [6455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [6457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [6459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_constant, 1, 0, 47),
  [6461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_constant, 1, 0, 47),
  [6463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [6465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [6467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_value, 1, 0, 0),
  [6469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_value, 1, 0, 0),
  [6471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5854),
  [6473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [6475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [6477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [6479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [6481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [6483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [6485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [6487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [6489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_primitive, 1, 0, 0),
  [6491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_primitive, 1, 0, 0),
  [6493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__keyword_variable, 1, 0, 0),
  [6495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_lambda, 1, 0, 0),
  [6497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_literal, 1, 0, 0),
  [6499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_call_with_block, 3, 0, 52),
  [6501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_call_with_block, 3, 0, 52),
  [6503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_call_with_block, 3, 0, 54),
  [6505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_call_with_block, 3, 0, 54),
  [6507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [6509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 99),
  [6511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 99),
  [6513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_call, 2, 0, 20),
  [6515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_call, 2, 0, 20),
  [6517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [6519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [6521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_pattern, 3, 0, 0),
  [6523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_pattern, 3, 0, 0),
  [6525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_value, 1, 0, 46),
  [6527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_value, 1, 0, 46),
  [6529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_call, 2, 0, 18),
  [6531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_call, 2, 0, 18),
  [6533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_range, 2, 0, 15),
  [6535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_range, 2, 0, 15),
  [6537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [6539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_find_pattern, 3, 0, 0),
  [6541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_find_pattern, 3, 0, 0),
  [6543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_reference_pattern, 2, 0, 14),
  [6545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_reference_pattern, 2, 0, 14),
  [6547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_range, 3, 0, 41),
  [6549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_range, 3, 0, 41),
  [6551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_pattern, 3, 0, 0),
  [6553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_pattern, 3, 0, 0),
  [6555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_pattern, 2, 0, 0),
  [6557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3, 0, 101),
  [6559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 3, 0, 101),
  [6561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_reference_pattern, 4, 0, 66),
  [6563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_reference_pattern, 4, 0, 66),
  [6565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_pattern, 4, 0, 101),
  [6567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_pattern, 4, 0, 101),
  [6569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_find_pattern, 4, 0, 101),
  [6571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_find_pattern, 4, 0, 101),
  [6573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4, 0, 101),
  [6575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 4, 0, 101),
  [6577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3, 0, 0),
  [6579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 3, 0, 0),
  [6581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_expr_basic, 1, 0, 0),
  [6583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_expr_alt, 1, 0, 0),
  [6585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_expr_alt, 1, 0, 0),
  [6587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 3, 0, 57),
  [6589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_pattern, 3, 0, 57),
  [6591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5836),
  [6593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 3, 0, 58),
  [6595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_pattern, 3, 0, 58),
  [6597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0),
  [6599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0),
  [6601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5723),
  [6603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_pattern, 3, 0, 98),
  [6605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_pattern, 3, 0, 98),
  [6607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [6609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [6611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_expr, 1, 0, 0),
  [6613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_expr, 1, 0, 0),
  [6615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 45),
  [6617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 45),
  [6619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_binary, 3, 0, 40),
  [6621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_binary, 3, 0, 40),
  [6623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument, 1, 0, 0),
  [6625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument, 1, 0, 0),
  [6627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_unary, 2, 0, 11),
  [6629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_unary, 2, 0, 11),
  [6631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 3),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [6635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 3, 0, 42),
  [6637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_pattern, 3, 0, 42),
  [6639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_splat_nil, 2, 0, 0),
  [6641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_splat_nil, 2, 0, 0),
  [6643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_command, 2, 0, 0),
  [6645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_command, 2, 0, 0),
  [6647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 44),
  [6649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 44),
  [6651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_command, 2, 0, 0),
  [6653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_command, 2, 0, 0),
  [6655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_splat_parameter, 2, 0, 14),
  [6657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_splat_parameter, 2, 0, 14),
  [6659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0),
  [6661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0),
  [6663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 29),
  [6665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 3, 0, 29),
  [6667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_pattern_n, 3, 0, 0),
  [6669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_pattern_n, 3, 0, 0),
  [6671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 3),
  [6673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [6675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_command, 2, 0, 0),
  [6677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_command, 2, 0, 0),
  [6679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 28),
  [6681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 3, 0, 28),
  [6683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_assignment, 3, 0, 53),
  [6685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_assignment, 3, 0, 53),
  [6687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternative_pattern, 2, 0, 78),
  [6689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [6691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__find_pattern_body, 4, 0, 0),
  [6693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__find_pattern_body, 4, 0, 0),
  [6695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 100),
  [6697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 100), SHIFT_REPEAT(2186),
  [6700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_pattern_body, 4, 0, 0),
  [6702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_pattern_body, 4, 0, 0),
  [6704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_pattern_any_rest, 1, 0, 0),
  [6706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_pattern_any_rest, 1, 0, 0),
  [6708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_test_pattern, 3, 0, 42),
  [6710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_test_pattern, 3, 0, 42),
  [6712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 43),
  [6714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 43),
  [6716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_next_command, 2, 0, 0),
  [6718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_next_command, 2, 0, 0),
  [6720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_operator_assignment, 3, 0, 40),
  [6722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_operator_assignment, 3, 0, 40),
  [6724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0),
  [6726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0),
  [6728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_pattern_body, 1, 0, 0),
  [6730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_pattern_body, 1, 0, 0),
  [6732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5681),
  [6734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4489),
  [6736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_splat_parameter, 1, 0, 0),
  [6738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_splat_parameter, 1, 0, 0),
  [6740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4484),
  [6742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5898),
  [6744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_pattern_n, 1, 0, 0),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [6750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_pattern_n, 2, 0, 0),
  [6752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_argument_list, 2, 0, 0),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [6756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_argument_list, 1, 0, 0),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [6760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 0),
  [6762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [6764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4801),
  [6767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4482),
  [6769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(450),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [6774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0), SHIFT_REPEAT(2165),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [6779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5298),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5561),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5403),
  [6787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_undef_repeat1, 2, 0, 0),
  [6789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_undef_repeat1, 2, 0, 0),
  [6791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5323),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [6795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5246),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5041),
  [6801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [6805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin_block, 3, 0, 0),
  [6807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin_block, 3, 0, 0),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [6811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [6813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [6815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [6817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [6819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [6821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [6823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, 0, 0),
  [6825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, 0, 0),
  [6827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin_block, 4, 0, 0),
  [6829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin_block, 4, 0, 0),
  [6831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_block, 4, 0, 0),
  [6833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_block, 4, 0, 0),
  [6835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_block, 3, 0, 0),
  [6837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_block, 3, 0, 0),
  [6839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [6841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias, 3, 0, 35),
  [6843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias, 3, 0, 35),
  [6845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(454),
  [6848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5306),
  [6850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5604),
  [6852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [6854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5713),
  [6856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_undef_repeat1, 2, 0, 0), SHIFT_REPEAT(2679),
  [6859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_undef, 3, 0, 0),
  [6861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [6863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5624),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [6867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5975),
  [6869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [6871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [6873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2268),
  [6875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_undef, 2, 0, 0),
  [6877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [6879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [6881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [6883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5964),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [6887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5903),
  [6889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [6891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_until_modifier, 3, 0, 39),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [6895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_modifier, 3, 0, 39),
  [6897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [6901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5960),
  [6903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless_modifier, 3, 0, 39),
  [6905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 100),
  [6907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 100), SHIFT_REPEAT(2188),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5954),
  [6914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_modifier, 3, 0, 39),
  [6916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue_modifier, 3, 0, 38),
  [6918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alternative_pattern, 2, 0, 78),
  [6920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [6922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4803),
  [6924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5370),
  [6926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5572),
  [6928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [6932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [6934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [6936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [6938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [6940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5415),
  [6948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [6950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [6952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [6954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [6956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5387),
  [6958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [6960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4451),
  [6962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 2, 0, 0),
  [6964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0), SHIFT_REPEAT(2153),
  [6967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_pattern_n, 1, 0, 0),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4248),
  [6975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_argument_list, 1, 0, 0),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [6979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_pattern_n, 2, 0, 0),
  [6981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [6985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4822),
  [6988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_argument_list, 2, 0, 0),
  [6990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(456),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5323),
  [6995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 0),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [7005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(445),
  [7008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [7010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5751),
  [7012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [7014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [7016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [7018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2536),
  [7020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [7022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [7024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [7026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 100), SHIFT_REPEAT(2195),
  [7029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [7031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4800),
  [7033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4813),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [7037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_undef_repeat1, 2, 0, 0), SHIFT_REPEAT(2666),
  [7040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue_modifier, 3, 0, 38),
  [7042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [7044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(455),
  [7047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_undef, 2, 0, 0),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [7051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_undef, 3, 0, 0),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [7055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2587),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4829),
  [7061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_until_modifier, 3, 0, 39),
  [7063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_modifier, 3, 0, 39),
  [7065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless_modifier, 3, 0, 39),
  [7067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_modifier, 3, 0, 39),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [7073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2638),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [7079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4849),
  [7081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4467),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [7085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 2, 0, 0),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [7089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [7095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [7097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [7101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 100), SHIFT_REPEAT(2196),
  [7104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [7106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [7108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [7110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [7112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4802),
  [7115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 100), SHIFT_REPEAT(2189),
  [7118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0), SHIFT_REPEAT(2154),
  [7121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [7123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [7125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [7129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [7131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [7133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [7137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [7139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [7143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5752),
  [7147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [7151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [7153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(448),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [7160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [7164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [7166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5091),
  [7168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5263),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5263),
  [7172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5353),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [7178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5055),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [7182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5065),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4739),
  [7186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5073),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4695),
  [7190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [7192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5045),
  [7194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4730),
  [7196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5052),
  [7198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [7200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5049),
  [7202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4736),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [7206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [7210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0), SHIFT_REPEAT(2149),
  [7213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(449),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [7222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5107),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4400),
  [7226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5110),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4405),
  [7230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5148),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [7234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5082),
  [7236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [7238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(451),
  [7241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5154),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4423),
  [7245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5087),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [7249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5116),
  [7251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [7253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5126),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [7257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5167),
  [7259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5410),
  [7261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5173),
  [7263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5454),
  [7265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4771),
  [7268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5196),
  [7270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5374),
  [7272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5119),
  [7274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [7276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5198),
  [7278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5365),
  [7280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [7282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [7286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [7288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4825),
  [7291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [7293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5352),
  [7295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [7297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5464),
  [7299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4996),
  [7301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [7303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_assignment, 2, 0, 0),
  [7305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [7307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [7309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0), SHIFT_REPEAT(2162),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [7314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5027),
  [7316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [7318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5031),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [7322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5003),
  [7324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [7326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4990),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [7336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [7338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__mlhs_repeat1, 2, 0, 0),
  [7340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5685),
  [7342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5456),
  [7344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5004),
  [7346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4425),
  [7348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5815),
  [7350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [7352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5654),
  [7354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5448),
  [7356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4982),
  [7358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5428),
  [7360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body_statement, 1, 0, 0),
  [7362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [7366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4991),
  [7368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5427),
  [7370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5844),
  [7372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [7374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_array_repeat1, 2, 0, 26),
  [7376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_array_repeat1, 2, 0, 26),
  [7378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_symbol_array_repeat1, 2, 0, 27),
  [7380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_symbol_array_repeat1, 2, 0, 27),
  [7382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5005),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4399),
  [7386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5755),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [7390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5882),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4424),
  [7394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5883),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [7398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(453),
  [7401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [7403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__body_statement_repeat1, 2, 0, 0),
  [7405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__body_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(677),
  [7408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__body_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(266),
  [7411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__body_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(289),
  [7414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body_statement, 2, 0, 0),
  [7416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(447),
  [7419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5981),
  [7421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [7423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5906),
  [7425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4725),
  [7427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5025),
  [7429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4720),
  [7431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5860),
  [7433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [7435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(353),
  [7438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__literal_contents, 2, 0, 0),
  [7440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(5263),
  [7443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(5263),
  [7446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__literal_contents, 2, 0, 0),
  [7448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(5353),
  [7451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [7453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5320),
  [7455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [7457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [7459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4148),
  [7461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5237),
  [7463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameter, 1, 0, 0),
  [7465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameter, 1, 0, 0),
  [7467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [7469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [7471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [7473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4586),
  [7475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4706),
  [7477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [7479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [7481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [7483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [7485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [7487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [7489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4703),
  [7491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [7493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4704),
  [7495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [7497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4715),
  [7499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [7501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [7503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4732),
  [7505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4734),
  [7507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [7509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exception_variable, 2, 0, 0),
  [7511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [7513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4731),
  [7515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4738),
  [7517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [7519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [7521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4389),
  [7523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [7525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [7527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [7529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [7531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5989),
  [7533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5399),
  [7535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [7537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then, 2, 0, 0),
  [7539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5124),
  [7542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [7544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [7546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [7548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4403),
  [7550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [7552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [7554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [7562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [7564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5295),
  [7566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [7568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5416),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5423),
  [7572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4652),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5307),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [7582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5485),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5477),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [7590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [7594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2888),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [7598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5397),
  [7606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [7608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then, 3, 0, 0),
  [7610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(452),
  [7613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5373),
  [7615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 2, 0, 0), SHIFT_REPEAT(355),
  [7618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2, 0, 0), SHIFT_REPEAT(5305),
  [7621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2, 0, 0),
  [7623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2, 0, 0), SHIFT_REPEAT(5399),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [7636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [7640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [7642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5420),
  [7644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4315),
  [7646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [7648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(334),
  [7651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(5320),
  [7654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(5396),
  [7657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(444),
  [7660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [7662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [7664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [7666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [7668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5390),
  [7670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [7672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5393),
  [7674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5395),
  [7676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [7678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5483),
  [7680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5407),
  [7682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5990),
  [7684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [7686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [7688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [7690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5482),
  [7692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5463),
  [7694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [7696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5462),
  [7698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [7700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5465),
  [7702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [7704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [7706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [7708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4792),
  [7710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [7712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4795),
  [7714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [7716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5356),
  [7718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_formal_parameter, 1, 0, 0),
  [7720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameter, 2, 0, 14),
  [7722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5355),
  [7724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0),
  [7726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 2, 0, 0),
  [7728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 2, 0, 0),
  [7730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [7732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [7735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [7737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_forward_parameter, 1, 0, 0),
  [7739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [7741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5413),
  [7743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [7745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [7747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [7749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [7751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter, 1, 0, 0),
  [7753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter, 1, 0, 36),
  [7755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__literal_contents, 1, 0, 0),
  [7757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__literal_contents, 1, 0, 0),
  [7759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5479),
  [7761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [7763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [7765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [7767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3, 0, 0),
  [7769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, 0, 0),
  [7771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [7773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exceptions, 2, 0, 0),
  [7775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [7777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(831),
  [7780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [7782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [7784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [7786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, 0, 0),
  [7788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, 0, 0), SHIFT_REPEAT(809),
  [7791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_match_repeat1, 2, 0, 70),
  [7793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_match_repeat1, 2, 0, 70), SHIFT_REPEAT(2024),
  [7796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [7798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [7800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [7802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__mlhs_repeat1, 2, 0, 0), SHIFT_REPEAT(1973),
  [7805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [7807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mlhs, 1, 0, 0),
  [7809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 1, 0, 0),
  [7811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 1, 0, 0),
  [7813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [7815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [7817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5342),
  [7819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [7821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [7823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [7825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [7827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_when_repeat1, 2, 0, 90), SHIFT_REPEAT(808),
  [7830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_when_repeat1, 2, 0, 90),
  [7832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless_guard, 2, 0, 64),
  [7834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [7836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_guard, 2, 0, 64),
  [7838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elsif, 3, 0, 63),
  [7840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [7842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [7844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [7846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [7848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [7850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [7852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [7854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(443),
  [7857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [7859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_when_repeat1, 2, 0, 68),
  [7861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructured_left_assignment, 3, 0, 0),
  [7863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else, 2, 0, 0),
  [7865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5235),
  [7867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(4631),
  [7870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [7872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue, 4, 0, 93),
  [7874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [7876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_superclass, 2, 0, 0),
  [7878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [7880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [7882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [7884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue, 2, 0, 16),
  [7886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ensure, 2, 0, 0),
  [7888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [7890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [7894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list_with_trailing_comma, 1, 0, 0),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [7900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bare_parameters, 2, 0, 0),
  [7902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5302),
  [7904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else, 3, 0, 0),
  [7906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5325),
  [7908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5571),
  [7910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__body_statement_repeat1, 1, 0, 0),
  [7912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue, 3, 0, 73),
  [7914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [7916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [7918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5848),
  [7920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(4627),
  [7923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [7925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bare_parameters, 1, 0, 0),
  [7927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [7929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [7931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [7933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(4638),
  [7936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4591),
  [7938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5966),
  [7942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_pattern_body, 1, 0, 0),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [7946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue, 3, 0, 71),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5096),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [7952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4621),
  [7954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hash_repeat1, 2, 0, 0),
  [7956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_repeat1, 2, 0, 0), SHIFT_REPEAT(777),
  [7959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5084),
  [7961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5072),
  [7963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5071),
  [7965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [7967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_array_repeat1, 2, 0, 0), SHIFT_REPEAT(5247),
  [7970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_array_repeat1, 2, 0, 0),
  [7972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, 0, 0),
  [7974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5759),
  [7976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5757),
  [7978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [7980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5163),
  [7984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_parameters_repeat1, 2, 0, 120), SHIFT_REPEAT(5837),
  [7987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_parameters_repeat1, 2, 0, 120),
  [7989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [7991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5074),
  [7993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_in_clause, 4, 0, 110),
  [7995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5070),
  [7997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5837),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [8001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(4621),
  [8004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [8006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4737),
  [8008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [8010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4699),
  [8012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5273),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5056),
  [8016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when, 4, 0, 88),
  [8018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [8020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [8022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_match_repeat1, 1, 0, 34),
  [8024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [8026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [8028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5494),
  [8030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5491),
  [8032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5486),
  [8034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4388),
  [8036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [8038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4428),
  [8040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5204),
  [8042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [8044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [8046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [8048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5202),
  [8050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5114),
  [8052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__guard, 1, 0, 0),
  [8054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_symbol_array_repeat1, 2, 0, 0), SHIFT_REPEAT(5228),
  [8057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_symbol_array_repeat1, 2, 0, 0),
  [8059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_in_clause, 3, 0, 67),
  [8061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4781),
  [8063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [8071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [8073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [8077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5109),
  [8079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [8081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5450),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5538),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [8091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5106),
  [8093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 1, 0, 0),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5268),
  [8099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [8101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [8105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2375),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5197),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5502),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5117),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [8119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when, 3, 0, 67),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5199),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [8131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4819),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [8143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_parameters_repeat1, 2, 0, 118),
  [8145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [8153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [8161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_left_assignment_list, 1, 0, 0),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [8167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [8171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [8179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [8191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [8193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [8195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [8197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [8199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [8205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [8207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [8209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [8211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [8213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [8215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [8217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [8219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [8221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [8223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [8225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [8227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [8229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [8231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [8235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [8239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [8241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [8243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4806),
  [8245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [8247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [8249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [8251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [8253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [8255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [8257] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [8259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [8261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [8263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5017),
  [8265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5375),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [8269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5447),
  [8271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [8275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [8277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [8279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [8281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [8283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [8285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [8287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [8289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [8291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [8293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5402),
  [8295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [8297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [8299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [8301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [8303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [8305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [8309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [8311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [8313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [8315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [8317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [8319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [8321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5367),
  [8323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [8325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [8327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [8331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [8333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [8335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [8337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5336),
  [8339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [8341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5267),
  [8343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [8345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [8347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [8349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [8351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [8353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [8355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [8357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [8359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5359),
  [8361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [8363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [8365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4971),
  [8367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [8369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5527),
  [8371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [8373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [8375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4975),
  [8377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [8379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [8381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [8383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [8385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [8387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [8389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [8393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [8395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4804),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [8399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4746),
  [8401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [8403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5458),
  [8405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [8409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5408),
  [8411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [8413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [8415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5411),
  [8419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [8421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [8423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5429),
  [8425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [8427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [8429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5430),
  [8431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [8433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4676),
  [8435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4841),
  [8437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [8439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4821),
  [8441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [8443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5902),
  [8445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4764),
  [8447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [8449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [8451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [8453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5432),
  [8455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [8457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [8459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5435),
  [8461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5437),
  [8463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [8465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [8467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [8469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5459),
  [8471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [8473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [8475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [8477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5484),
  [8479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [8481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [8483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [8485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [8487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [8489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [8491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [8493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [8495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [8497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [8499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [8501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [8503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5493),
  [8505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [8507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4946),
  [8509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [8511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4958),
  [8513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [8515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5467),
  [8517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5466),
  [8519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5472),
  [8521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [8523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [8525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [8527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5461),
  [8529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4663),
  [8531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [8533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [8535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5431),
  [8537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [8539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [8541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [8543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5457),
  [8545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [8547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4968),
  [8549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4970),
  [8551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5453),
  [8553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5451),
  [8555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5010),
  [8557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4709),
  [8559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [8561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [8563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [8565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [8567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4458),
  [8569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [8571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [8573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [8575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [8577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4469),
  [8579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5583),
  [8581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4685),
  [8583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [8585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [8587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [8589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4421),
  [8591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [8593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [8595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5319),
  [8597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [8599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [8601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5514),
  [8603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4713),
  [8605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [8607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4714),
  [8609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4716),
  [8611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [8613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [8615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [8617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [8619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [8621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [8623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [8625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [8627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [8629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [8631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [8633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [8635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [8637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [8639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [8641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [8643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4398),
  [8645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5297),
  [8647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [8649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [8651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [8653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [8655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [8657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [8659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [8661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [8663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [8665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [8667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4406),
  [8669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [8671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [8673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [8675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5040),
  [8677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [8679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [8681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [8683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [8685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5066),
  [8687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [8689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_body, 1, 0, 0),
  [8691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [8693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4365),
  [8697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [8699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5108),
  [8701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5159),
  [8703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [8705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 3, 0, 0),
  [8707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5560),
  [8709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4572),
  [8711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [8713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [8715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [8719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4344),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4343),
  [8723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [8725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [8727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [8729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5064),
  [8731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [8733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [8735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [8737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [8739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [8741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4660),
  [8743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [8745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [8747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4650),
  [8749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [8751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4661),
  [8753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4654),
  [8755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [8757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [8759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [8761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [8763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [8765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [8767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [8769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [8771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [8773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5984),
  [8775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [8779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [8781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [8783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [8785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [8787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [8789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [8791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [8793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [8795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [8797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5576),
  [8799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [8801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [8803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [8805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [8807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body_statement, 1, 0, 0),
  [8809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5549),
  [8811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elsif, 4, 0, 86),
  [8813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [8815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5545),
  [8817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5079),
  [8819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5541),
  [8821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [8827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [8829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [8831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [8833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5526),
  [8835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [8837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elsif, 4, 0, 85),
  [8839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [8841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [8843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [8845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4718),
  [8847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [8849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [8851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2, 0, 0),
  [8853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [8855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [8857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [8859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [8861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc_body, 2, 0, 0),
  [8863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc_body, 3, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__line_break = 0,
  ts_external_token__no_line_break = 1,
  ts_external_token_simple_symbol = 2,
  ts_external_token__string_start = 3,
  ts_external_token__symbol_start = 4,
  ts_external_token__subshell_start = 5,
  ts_external_token__regex_start = 6,
  ts_external_token__string_array_start = 7,
  ts_external_token__symbol_array_start = 8,
  ts_external_token__heredoc_body_start = 9,
  ts_external_token_string_content = 10,
  ts_external_token_heredoc_content = 11,
  ts_external_token__string_end = 12,
  ts_external_token_heredoc_end = 13,
  ts_external_token_heredoc_beginning = 14,
  ts_external_token_SLASH = 15,
  ts_external_token__block_ampersand = 16,
  ts_external_token__splat_star = 17,
  ts_external_token__unary_minus = 18,
  ts_external_token__unary_minus_num = 19,
  ts_external_token__binary_minus = 20,
  ts_external_token__binary_star = 21,
  ts_external_token__singleton_class_left_angle_left_langle = 22,
  ts_external_token_hash_key_symbol = 23,
  ts_external_token__identifier_suffix = 24,
  ts_external_token__constant_suffix = 25,
  ts_external_token__hash_splat_star_star = 26,
  ts_external_token__binary_star_star = 27,
  ts_external_token__element_reference_bracket = 28,
  ts_external_token__short_interpolation = 29,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__line_break] = sym__line_break,
  [ts_external_token__no_line_break] = sym__no_line_break,
  [ts_external_token_simple_symbol] = sym_simple_symbol,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__symbol_start] = sym__symbol_start,
  [ts_external_token__subshell_start] = sym__subshell_start,
  [ts_external_token__regex_start] = sym__regex_start,
  [ts_external_token__string_array_start] = sym__string_array_start,
  [ts_external_token__symbol_array_start] = sym__symbol_array_start,
  [ts_external_token__heredoc_body_start] = sym__heredoc_body_start,
  [ts_external_token_string_content] = sym_string_content,
  [ts_external_token_heredoc_content] = sym_heredoc_content,
  [ts_external_token__string_end] = sym__string_end,
  [ts_external_token_heredoc_end] = sym_heredoc_end,
  [ts_external_token_heredoc_beginning] = sym_heredoc_beginning,
  [ts_external_token_SLASH] = anon_sym_SLASH,
  [ts_external_token__block_ampersand] = sym__block_ampersand,
  [ts_external_token__splat_star] = sym__splat_star,
  [ts_external_token__unary_minus] = sym__unary_minus,
  [ts_external_token__unary_minus_num] = sym__unary_minus_num,
  [ts_external_token__binary_minus] = sym__binary_minus,
  [ts_external_token__binary_star] = sym__binary_star,
  [ts_external_token__singleton_class_left_angle_left_langle] = sym__singleton_class_left_angle_left_langle,
  [ts_external_token_hash_key_symbol] = sym_hash_key_symbol,
  [ts_external_token__identifier_suffix] = sym__identifier_suffix,
  [ts_external_token__constant_suffix] = sym__constant_suffix,
  [ts_external_token__hash_splat_star_star] = sym__hash_splat_star_star,
  [ts_external_token__binary_star_star] = sym__binary_star_star,
  [ts_external_token__element_reference_bracket] = sym__element_reference_bracket,
  [ts_external_token__short_interpolation] = sym__short_interpolation,
};

static const bool ts_external_scanner_states[42][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__no_line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_string_content] = true,
    [ts_external_token_heredoc_content] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
    [ts_external_token__short_interpolation] = true,
  },
  [2] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [3] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [4] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [5] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
  },
  [6] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [7] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [8] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [9] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
  },
  [10] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
  },
  [11] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__binary_star_star] = true,
  },
  [12] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [13] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__binary_star_star] = true,
  },
  [14] = {
    [ts_external_token__no_line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [15] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [16] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__no_line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [17] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [18] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [19] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [20] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [21] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus_num] = true,
  },
  [22] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [23] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus_num] = true,
  },
  [24] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [25] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [26] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [27] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
  },
  [28] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [29] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [30] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
  },
  [31] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [32] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
  },
  [33] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [34] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [35] = {
    [ts_external_token__heredoc_body_start] = true,
  },
  [36] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [37] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_string_content] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token__short_interpolation] = true,
  },
  [38] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [39] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_content] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token__short_interpolation] = true,
  },
  [40] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_string_content] = true,
    [ts_external_token__short_interpolation] = true,
  },
  [41] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_end] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_ruby_external_scanner_create(void);
void tree_sitter_ruby_external_scanner_destroy(void *);
bool tree_sitter_ruby_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_ruby_external_scanner_serialize(void *, char *);
void tree_sitter_ruby_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_ruby(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_ruby_external_scanner_create,
      tree_sitter_ruby_external_scanner_destroy,
      tree_sitter_ruby_external_scanner_scan,
      tree_sitter_ruby_external_scanner_serialize,
      tree_sitter_ruby_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
